;============================================================================          
;
;         P A P E R   T A P E   /   C A R D   R E A D E R
;
;============================================================================          
;       This module was originally M18 
;============================================================================          
	  .XLIST
	  INCLUDE PREAMBLE
	  .LIST

PUBLIC    DATALD
PUBLIC    DATALDBT
PUBLIC    DATASVBT
PUBLIC    READPTL

EXTRN     AVARD:NEAR
EXTRN     ALPHA:NEAR
EXTRN     ARGUMNTR:NEAR
EXTRN     BREAKPTT:NEAR
EXTRN     CHARCTR:NEAR
EXTRN     CPBASE :DWORD
EXTRN     DELAY10:NEAR
EXTRN     DEVICET:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     ERROR_48:NEAR
EXTRN     ERROR_52:NEAR
EXTRN     EXPR:NEAR
EXTRN     ENDSTIOZ:NEAR
EXTRN     FLTBINB:NEAR
EXTRN     OBSTROBE:NEAR
EXTRN     OBSBLK:NEAR
EXTRN     REMCO:NEAR
EXTRN     RCVASCII:NEAR
EXTRN     WAITRDYB:NEAR
EXTRN     WAITIBSF:NEAR

;-----------------------------------------------------------------------------;
;        FILE = BPMVP18 ,09/09/1986
;        MODULE    MOD-18 PAPER-TAPE
;
;     *************************************
;     *                                   *
;     *  MOD18:  PAPER-TAPE, CARD READER  *
;     *                                   *
;     *************************************
;
;     REFERENCED MODULES:
;
;        SYMBL     BPMVP00$  SYSTEM EQUATES
;        SYMBL     BPMVP02$  SYNTAX CHECKING
;        SYMBL     BPMVP01$  CONTROL
;        SYMBL     BPMVP06$  SUBROUTINES
;        SYMBL     BPMVP05$  I/O SUBROUTINES
;        SYMBL     BPMVP07$  EXPRESSION ANALYSIS
;        SYMBL     BPMVP10$  ALPHANUMERICS
;        SYMBL     BPMVP08$  STATEMENTS
;        SYMBL     BPMVP16$  SUBROUTINES
;        SYMBL     BPMVP04$  STATEMENTS
;        SYMBL     DAMVP35$  EDIT
;        SYMBL     BPMVP17$  STATEMENTS
;        SYMBL     JLMVP32$  MVP SUBROUTINES
;        TITLE     DATALDBT
;     DATALDBT: PROCESS A 'DATALOAD BT' STATEMENT
;
;          FORMAT:
;
;     DATALOAD BT[R] [([N=expr][,][L=char][,][S=char])]
;
;          [/xyy,] alpha-variable
;           #n,
;
;          where: char = hexdigit hexdigit
;                        literal
;                        alpha-variable
;
;                 device type = 5 or 6
;
;          NOTE:  THIS STATEMENT WAS DESIGNED FOR 2203
;               PAPER TAPE READER. THE 2200 LOGIC WAS
;               COPIED EVEN THOUGH CERTAIN BUGS EXIST
;               IN THAT LOGIC.
;
;               1. THE 17MS DELAY IS MISPLACED (SHOULD BE
;                  AFTER DIRECTION STROBE).
;               2. WITH TYPE 5, DIRECTION STROBE & 17MS
;                  DELAY SHOULD HAVE BEEN SKIPPED.
;               3. DELAY AFTER CBS STROBES DOES NOTHING.
;               4. WHY WERE CBS STROBES USED AT ALL?
;
;          ENTRY: TEXTPTR POINTS AFTER 'BT'
;
;          MODIFIED REGISTERS: ALL,AUX0-5
;               IN EXECUTION PHASE, AUX6
;-----------------------------------------------------------------------------;
DATALDBT: MOV       DL,1
	  CMP       BYTE PTR [TEXTPTR],'R' ;LOOK FOR 'R'
	  JNE       DATALDBT1X
	  INC       TEXTPTR
	  MOV       DL,0
DATALDBT1X:
	  MOV       AUX04,EDX   ;SAVE PARAMETER FLAG
	  CMP       BYTE PTR [TEXTPTR],'('
	  JNE       DTLDBT1     ;BRANCH IF NF
	  INC       TEXTPTR

;%PROCESS 'N' PARAMETER
	  MOV       DX,0FFFFH   ;SCX,0     F1F0,F1F0,PHPL ; To be checked.
	  MOV       AUX05,EDX   ;It seems DX should be 0. DEFAULT 'N' VALUE = FFFF
	  CMP       BYTE PTR [TEXTPTR],'N'
	  JNE       DTLDBT2
	  INC       TEXTPTR
	  CMP       BYTE PTR [TEXTPTR],'='
	  JNE       ERROR_12    ;BRANCH IF NOT MATCH
	  INC       TEXTPTR
	  CALL      EXPR        ;SCAN &EVALUATE EXPRESSION
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DTLDBT3
	  CALL      FLTBINB     ;CONVERT VALUE TO BINARY
	  TEST      R2,0FH      ;ERROR IF VALUE = 0
	  JZ        ERR_34P
	  MOV       DX,WORD PTR R0
	  MOV       AUX05,EDX   ;SAVE 'N' VALUE
DTLDBT3:
	  CMP       BYTE PTR [TEXTPTR],','
	  JNE       DTLDBT6
	  INC       TEXTPTR

;%PROCESS 'L' PARAMETER
DTLDBT2:  CMP       BYTE PTR [TEXTPTR],'L'
	  JNE       DTLDBT5
	  INC       TEXTPTR
	  CMP       BYTE PTR [TEXTPTR],'='
	  JNE       ERROR_12    ;BRANCH IF NOT MATCH
	  INC       TEXTPTR
	  CALL      CHARCTR     ;GET LEADER CODE CHAR.
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DTLDBT4
	  MOV       DL,R0
	  MOV       AUX06,EDX   ;SAVE LEADER CODE CHAR
	  OR        AUX04,02H   ;FLAG = 'L' FOUND

DTLDBT4:  CMP       BYTE PTR [TEXTPTR],','
	  JNE       DTLDBT6
	  INC       TEXTPTR

;%PROCESS 'S' PARAMETER
DTLDBT5:
	  CMP       BYTE PTR [TEXTPTR],'S'
	  JNE       DTLDBT5X
	  INC       TEXTPTR
DTLDBT5X:
	  CMP       BYTE PTR [TEXTPTR],'='
	  JNE       ERROR_12    ;BRANCH IF NOT MATCH
	  INC       TEXTPTR
	  CALL      CHARCTR     ;GET STOP CODE
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DTLDBT6
	  MOV       EDX,AUX06
	  MOV       DH,R0       ;SAVE STOP CODE
	  MOV       AUX06,EDX
	  OR        AUX04,04    ;FLAG = 'S' FOUND
;%SCAN REST OF STATEMENT
DTLDBT6:                        ;LOOK FOR ')'
	  CMP       BYTE PTR [TEXTPTR],')'
	  JNE       ERROR_11    ;BRANCH IF NOT MATCH
	  INC       TEXTPTR

DTLDBT1:  CALL      DEVICET     ;SCAN & PROCESS #n, OR /xyy,
	  CALL      AVARD       ;SCAN & PROCESS ALPHA VAR.
	  TEST      R0,0FH      ;NF, ERROR
	  JNZ       ERR_29P
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DTLDBT7
;%SETUP FOR EXECUTION
	  MOV       EDX,ACTDEV
	  MOV       AL,DH       ;ERROR IF DEVICE TYPE NOT 5 OR 6
	  AND       AL,0FH
	  CMP       AL,6
	  JE        _M1801
	  CMP       AL,5
	  JNE       ERR_48P
_M1801:   mov       edx,vsptr   ;GET LENGTH & ADDR OF ALPHA VAR.
	  mov       ax,word ptr [edx]
	  mov       word ptr [r0],ax
	  mov       edx,dword ptr [edx+2]
	  add       vsptr,6
	  XCHG      EDX,AUX05   ;SAVE ADDR
	  CMP       DX,WORD PTR R0  ;R1,0 = MINIMUN OF LENGTH & N-VALUE
	  JG        _M1802
	  MOV       WORD PTR R0,DX
_M1802:   MOV       EDX,AUX04
	  MOV       R2,DL       ;R2 = PARAMETER FLAG
	  MOV       EDX,AUX06
	  MOV       WORD PTR R3,DX
	  MOV       K,2
	  CALL      OBSTROBE    ;START OF OPERATION (MVP FLAG FOR CARD READER)
;%EXECUTE STATEMENT
;     ENTRY:
;          AUX5 = ADDRESS OF RECEIVER VARIABLE
;          F1,0 = MAXIMUM NO. OF CHARACTERS TO RECEIVE
;          F2,BIT01 = 0 IF BTR, 1 IF BT
;            ,BIT02 = 1 IFF 'L' PARAMETER FOUND
;            ,BIT04 = 1 IFF 'S' PARAMETER FOUND
;          F3 = LEADER CODE CHARACTER (IF ANY)
;          F4 = STOP CODE CHARACTER (IF ANY)
;
;     NOTE, 2200T SEQUENCE IS:
;               ENABLE
;               DELAY 17MS.
;               OBS DIRECTION (NO WAIT FOR READY)
;
;           2600 SEQUENCE IS:
;               ENABLE
;               WAIT FOR READY
;               OBS DIRECTION
;               DELAY 17MS.
;
	  MOV       AL,R2       ;K = DIRECTION (00 IF FORWARD, 01 IF REVERSE)
	  AND       AL,1
	  XOR       AL,1
	  MOV       K,AL
;-----------------------------;
; Delay of 17 ms. Checkpoint. ;
;-----------------------------;
;         CALL      DELAY10     ;CHECKPOINT
;         CALL      DELAY10
	  CALL      OBSTROBE    ;STROBE (OBS) DIRECTION
	  MOV       EDX,AUX05   ;POINT TO RECEIVER
	  ADD       WORD PTR R0,DX  ;R1,0 = ADDR OF END OF RECEIVER +1
;     PROCESS LEADER CODE
;
	  TEST      R2,2        ;BRANCH IF NO LEADER CODE SPECIFIED
	  JZ        DTLDBT8
_M1803:   CALL      DCTCREAD    ;INPUT NEXT CHAR.
	  MOV       AL,R3       ;BRANCH IF LEADER CODE CHAR.
	  CMP       AL,K
	  JE        _M1803
	  JMP       DTLDBT9
;     PROCESS DATA CHARACTERS
;
DTLDBT10: CMP       WORD PTR R0,DX  ;BRANCH IF RECEIVER FULL
	  JLE       DTLDBT7
DTLDBT8:  CALL      DCTCREAD    ;INPUT NEXT DATA CHAR

;_   ADVANCE BEFORE DISABLING -- DISABLING CHANGES
;_   DIRECTION TO FORWARD)
DTLDBT9:  MOV       AL,K        ;CHAR ==> RECEIVER
	  MOV       [EDX],AL
	  INC       DX
	  CMP       AL,R4       ;BRANCH IF NOT STOP CODE
	  JNE       DTLDBT10
	  TEST      R2,4        ;BRANCH IF NO STOP CODE SPECIFIED
	  JZ        DTLDBT10
DTLDBT7:  CALL      WAITRDYB    ;WAIT FOR RECEIVER READY (GIVES TAPE TIME TO
				; ADVANCED BEFORE DISABLING -- DISABLING CHANGES
				; DIRECTION TO FORWARD)
	  JMP       ENDSTIOZ    ;ENABLE CONSOLE OUTPUT, EXIT

ERR_29P:  JMP       ERROR_29    ;MISSING ALPHA VAR.
ERR_48P:  JMP       ERROR_48    ;ILLEGAL DEVICE ADDR

;-----------------------------------------------------------------------------;
;         TITLE     DCTCREAD
;     DCTCREAD: GET NEXT CHARACTER FROM INPUT DEVICE
;          USING PAPER TAPE READER LOGIC, AS SCREWY AS
;          IT MAY BE.
;
;          ENTRY: DEVICE ENABLED
;
;          RETURN: K = CHARACTER INPUT
;
;          MODIFIED REGISTERS: K
;-----------------------------------------------------------------------------;
DCTCREAD: TEST      BYTE PTR FS:[CPUST],10H
	  JZ        _M1804
	  CALL      BREAKPTT    ;BREAKPOINT IF 30MS TIMESLICE UP
_M1804: ; PUSH      EDX         ;SAVE PC'S
	  CALL      WAITRDYB    ;WAIT FOR DEVICE READY
	; POP       EDX
	  MOV       BYTE PTR FS:[CPURDY],AL  ;ALLOW INPUT (CPU READY)
	  MOV       AL,K
	  MOV       BYTE PTR FS:[CBS],AL
	  CALL      WAITIBSF    ;WAIT FOR CHAR. (UP TO 8MS)
	  MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF (IGNORE IT)
;%NEXT DELAY NOT NEEDED ON 2600
	  RET                   ;DELAY 10 USEC
;-----------------------------------------------------------------------------;
;         TITLE     DATASVBT
;     DATASVBT: PROCESS A 'DATASAVE BT' STATEMENT
;
;          FORMAT: DATASAVE BT [/xyy,] alpha #n
;
;               WHERE: device type must = 4
;
;          ENTRY: TEXTPTR POINTS AFTER 'BT'
;
;          MODIFIED REGISTERS: ALL,AUX0-2
;-----------------------------------------------------------------------------;
DATASVBT: CALL      DEVICET     ;LOOK FOR #n, OR /xyy,
	  CALL      ALPHA       ;SCAN & PROCESS ALPHA-VAR. OR LITERAL
	  TEST      R0,0FH      ;NF, ERROR
	  JNZ       ERR_29P
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DTSVBT1
	  MOV       EDX,ACTDEV
	  MOV       AL,DH       ;ERROR IF NOT DEVICE TYPE 4
	  AND       AL,0FH
	  CMP       AL,4
	  JNE       ERR_48P
	  mov       edx,vsptr   ;GET ADDR & LENGTH OF ALPHA VALUE
	  mov       ax,word ptr [edx]
	  mov       word ptr [r0],ax
	  mov       edx,dword ptr [edx+2]
	  add       vsptr,6
	  CALL      OBSBLK      ;OUTPUT VALUE WITH OBS STROBES
DTSVBT1:  JMP       ENDSTIOZ    ;ENABLE CONSOLE OUTPUT, EXIT

;-----------------------------------------------------------------------------;
;         TITLE     DATALDX
;     DATALDX: PROCESS A 'DATALOAD' STATEMENT FOR DEVICE TYPES 5 & 6.
;
;          FORMAT:  DATALOAD [#n,]variable [,variable]...
;                             /xyy, array      array
;
;          ENTRY: TEXTPTR POINTS AFTER 'DATALOAD'
;                 DEVICE TYPE = 5 OR 6
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;                    IN EXECUTION PHASE, AUX3,B
;-----------------------------------------------------------------------------;
DATALD:   CALL      DEVICET     ;PROCESS /XYY OR #N
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DATALDX
	  MOV       EDX,ACTDEV
	  MOV       AL,DH
	  AND       AL,0FH
	  CMP       AL,05
	  JE        DATALDX
	  CMP       AL,06       ;ERROR IF DEVICE TYPE NOT 5 OR 6
	  JNE       ERR_48P
	  MOV       K,2
	  CALL      OBSTROBE    ;START OF OPERATION (MVP FLAG FOR CARD READER)
DATALDX:  CALL      ARGUMNTR    ;SCAN NEXT ARGUMENT
	  TEST      SL,2        ;BRANCH IF NOT EXEC. PHASE
	  JZ        DATALDX1
DATALDX3: CALL      READPTL     ;INPUT NEXT VALUE
	  DEC       EDX
	  MOV       R0,DL
	  MOV       R1,0        ;R1,0 = LENGTH OF VALUE
	  MOV       EDX,MODE    ;EOF OFF
	  AND       DL,07FH
	  MOV       AL,K        ;BRANCH IF X-OFF NOT FOUND
	  AND       AL,0FH
	  CMP       AL,03
	  JNE       DATALDX2
	  OR        DL,80H
	  MOV       MODE,EDX    ;EOF ON
	  JMP       REMCO       ;SKIP OVER OF STMT
DATALDX2: MOV       MODE,EDX    ;CHECKPOINT
	  MOV       EDX,DWORD PTR [CPBASE]
	  LEA       EDX,[EDX].@IOBUFFR
	  MOV       AUX0B,EDX   ;AUXB = ADDR OF VALUE
	  CALL      RCVASCII    ;VALUE ==> RECEIVER
	  DEC       WORD PTR R6 ;DECREMENT ELEMENT COUNT
	  CMP       WORD PTR R6,0   ;BRANCH IF MORE ELEMENTS IN RECEIVER
	  JA        DATALDX3

DATALDX1: CMP       BYTE PTR [TEXTPTR],','
	  JNE       ENDSTIOZ    ;ENABLE CONSOLE OUTPUT, EXIT
	  INC       TEXTPTR
	  JMP       DATALDX

;-----------------------------------------------------------------------------;
;         TITLE     READPTL
;     READPTL: INPUT A LINE FROM PAPER TAPE READER;
;          CHARACTERS ARE READ & STORED IN I/O BUFFER
;          UNTIL A 'CR' OR 'X-OFF' IS FOUND. IF 'CR' IS
;          FOUND, NEXT CHARACTER IS READ BUT IGNORED.
;          80-BIT IS STRIPPED OFF ALL CHARACTERS READ.
;          NULLS & RUBOUTS ARE IGNORED.
;
;          ENTRY: DEVICE ENABLED
;
;          RETURN: INPUT DATA IN I/O BUFFER
;               PC'S POINT AFTER DATA
;               K = 00 IF 'CR' FOUND
;                   13 IF 'X-OFF' FOUND
;
;          MODIFIED REGISTERS: PC'S,K,CH,CL
;-----------------------------------------------------------------------------;
READPTL:  MOV       EDX,ACTDEV
	  MOV       AL,DH       ;BRANCH IF DEVICETYPE NOT 6
	  AND       AL,0FH
	  CMP       AL,6
	  JNE       _M1805
	  MOV       K,0         ;DIRECTION = FORWARD
	  CALL      OBSTROBE    ;STROBE DIRECTION
_M1805:                         ;POINT TO IOBUFFER
	  MOV       EDX,DWORD PTR [CPBASE]
	  LEA       EDX,[EDX].@IOBUFFR
	  JMP       READPTL5

READPTL1: OR        DL,DL       ;ERROR IF I/O BUFFER FULL
	  JE        ERR_52P
READPTL5: CALL      DCTCREAD    ;INPUT NEXT CHAR.
	  AND       K,7FH       ;STRIP OFF 80-BIT
	  TEST      K,0F0H      ;BRANCH IF NOT '0-'
	  JNZ       READPTL2
	  CMP       K,0         ;BRANCH IF NULL (IGNORE)
	  JE        READPTL5
	  MOV       AL,K
	  MOV       [EDX],AL    ;CHAR ==> BUFFER
	  INC       EDX
	  CMP       K,0DH       ;BRANCH IF NOT 'CR'
	  JNE       READPTL1
	  CALL      DCTCREAD    ;INPUT CHAR AFTER 'CR'
	  MOV       K,0         ;FLAG = 'CR' FOUND
	  RET

READPTL2: CMP       K,7FH       ;BRANCH IF NOT '7-, AND IF RUBOUT (IGNORE)
	  JE        READPTL5

READPTL4: CMP       K,13H       ;BRANCH IF NOT 'X-OFF'
	  JNE       READPTL3
	  RET

READPTL3: MOV       AL,K        ;CHAR ==> BUFFER
	  MOV       [EDX],AL
	  INC       EDX
	  JMP       READPTL1

ERR_52P:  JMP       ERROR_52    ;BUFFER FULL
ERR_34P:  JMP       ERROR_34    ;ILLEGAL VALUE

ENDMOD18:

CODE      ENDS
	  END

