;============================================================================
;       
;    D A T A L O A D / D A T A S A V E   A C   ( D O S   F O R M A T ) 
;
;============================================================================           
;       This module was originally M_DOS
;============================================================================
	   .XLIST
	   INCLUDE PREAMBLE
	   .LIST
PUBLIC  DTLDAC
PUBLIC  DTSVAC

EXTRN   ALPHA           :NEAR
EXTRN   ALPHA1          :NEAR
EXTRN   ALPHARAY        :NEAR
EXTRN   BINVAL          :NEAR
EXTRN   CCL             :NEAR
extrn   cpbase          :dword
EXTRN   DISKSELC        :NEAR
EXTRN   DISKSL_P        :NEAR
EXTRN   DISKSL_C        :NEAR
EXTRN   DISKSEL         :NEAR
EXTRN   DREAD           :NEAR
EXTRN   DWRITE          :NEAR
EXTRN   ERROR           :NEAR
EXTRN   ERROR_11        :NEAR
EXTRN   ERROR_29        :NEAR
EXTRN   ERROR_34        :NEAR
EXTRN   ERROR_51        :NEAR
EXTRN   ERROR_86        :NEAR
EXTRN   ERROR_82        :NEAR
EXTRN   ERROR_83        :NEAR
EXTRN   ERROR_52        :NEAR
EXTRN   ENDSDISK        :NEAR
EXTRN   EXPR            :NEAR
EXTRN   FLTBIN          :NEAR
EXTRN   FILE_PTR        :NEAR
EXTRN   FILE_A          :NEAR
EXTRN   gettime         :NEAR
EXTRN   PLATTER         :NEAR
EXTRN   PUTPLTTR        :NEAR
extrn   scratch         :near
EXTRN   ZEROFIL_        :NEAR

;************************  LOW  LEVEL  **********************************
;*
;*  (1) PHYSICAL( SIDE,TRACK,SECTOR) --- THE 2200 DISK CONTROLLER PROCESS
;*
;*  (2) LOGICAL (LINEAR SECTOR ADDRESS) DIFFERS
;*
;*          --- 2200 ---(256B)             --- DOS ---(512B)
;*              0,1                             0
;*              2,3                             1
;*              4,5                             2
;*               .                              .
;*               .                              .
;*           (2N),(2N+1)                        N
;*******************************************************************************

DOSREAD:
;*****************************************************************
; ENTRY: PHASE = EXECUTION
;        DISK ENABLED
;        AUX0F = ADDRESS OF WHERE TO STORE DATA
;        EDX = ADDRESS OF SECTOR TO READ
;        AUX0E,LOW BYTE = PLATTER
; RETURN:
;        AUX0F = ADDRESS OF SECTOR ACCESSED + 1
;*****************************************************************
	MOV     EBX,AUX0F
	MOV     AUX03,EBX       ;TEMPORARY STORAGE
	SHL     EDX,1
	CALL    DREAD
	MOV     EDX,AUX0F
	MOV     EBX,AUX03
	MOV     AUX0F,EBX       ;RESTORAGE
	ADD     AUX0F,100H
	CALL    DREAD
	SHR     AUX0F,1
	RET
DOSWRITE:
;*****************************************************************
; ENTRY: PHASE = EXECUTION
;        DISK ENABLED
;        AUX0F = ADDRESS OF DATA TO WRITE
;        EDX = ADDRESS OF SECTOR TO WRITE
;        AUX0E,LOW BYTE = PLATTER
; RETURN:
;        AUX0F = ADDRESS OF SECTOR ACCESSED + 1
;*****************************************************************
	MOV     EBX,AUX0F
	MOV     AUX03,EBX       ;TEMPORARY STORAGE
	SHL     EDX,1
	CALL    DWRITE
	MOV     EDX,AUX0F
	MOV     EBX,AUX03
	MOV     AUX0F,EBX       ;RESTORAGE
	ADD     AUX0F,100H
	CALL    DWRITE
	SHR     AUX0F,1
	RET
;**************    MIDDLE LEVEL    *******************************
;* (1) THIS LEVEL IS ABOUT THE FAT & FILE DIRECTORY MANIPULATION
;* (2) REFERENCE BOOK
;*          IBM Disk Operation System
;*          MS-DOS Developer's Guide
;*****************************************************************
;
DELETED_MARK    EQU 0E5H        ;DELETE FILE MARK IN DIRECTORY
UNUSED_MARK     EQU 00H         ;UNUSED FILE MARK IN DIRECTORY
;
NONE            EQU     -1
FAT             EQU     1
;
DIR_PER_SEC     EQU     16      ;DIR ENTRY PER DIR SECTOR
;
READ            EQU     0
WRITE           EQU     1       ; RW_FLG
;
START_FAT       EQU     2       ;FIRST FAT #
;
BASED           EQU [EBP]       ;POINTER TO STACK ADDRESSING STRUC.
FAT_STACK       STRUC
		DD   ?          ;EBP
		DD   ?          ;RETURN ADDRESS
FAT_TABLE       DD   ?          ;POINTER TO FAT TABLE
FAT_INDEX       DW   ?          ;FAT (CLUSTER) # TO GET / PUT
				;REPLACED BY FAT CONTENTS DURING GET
FAT_VALUE       DW   ?          ;FAT CONTENTS DURING ENCODE (PUT) ONLY
FAT_STACK       ENDS
;
DFMT            EQU  [ESI]      ;POINTER TO DISK FORMAT PARAMETER BLOCK
FORMAT          STRUC
MEDIA           DW   ?          ;DISK MEDIA WORD
BYTES_SECTOR    DW   ?          ; ? BYTES PER SECTOR
CLUSTER_SIZE    DW   ?          ; ? SECTORS PER CLUSTER
FAT_SECTORS     DW   ?          ; ? SECTORS PER FAT
FAT_ENTRIES     DW   ?          ; ? ENTRIES PER FAT
DIR_SECTORS     DW   ?          ; ? SECTORS PER DIRECTORY
DIR_ENTRIES     DW   ?          ; ? ENTRIES PER DIRECTORY
DATA_BEGIN      DW   ?          ; LOGICAL SECTOR # THAT DATA STORE
FORMAT          ENDS
;
FILES           EQU  [EDI]      ;POINTER TO DIRECTORY FILE ENTRIES
FILE_ENTRY      STRUC
FILE_NAME       DB      8 DUP(?)        ;FILE NAME
FILE_EXT        DB      3 DUP(?)        ;FILE EXTENSION
ATTRIBUTE       DB      ?               ;FILE ATTRIBUTE
		DB      10 DUP(?)       ;RESERVED
D_TIME          DW      ?               ;TIME
D_DATE          DW      ?               ;DATE
FILE_START      DW      ?               ;START CLUSTER OF FILE
FILE_LENGTH     DD      ?               ;FILE LENGTH IN BYTES
FILE_ENTRY      ENDS
;
;**** VARIBALE STROAGE ******
TEMP_DATA       DB      1024 DUP(?)     ;SPACE FOR DATA STORAGE
FAT_DATA        DB      7*512 DUP(?)    ;SPACE FOR FAT
DIR_DATA        DB      512 DUP(?)      ;SPACE FOR DIRECTORY
;
FORMAT_TABLE    EQU     $
	FORMAT<0FFEH,512,1,1,314,4,64,7>      ;SS SD: 8  SEC/TRACK 1 SIDED
	FORMAT<0FFFH,512,2,1,316,7,112,10>    ;DS SD: 8  SEC/TRACK 2 SIDED
	FORMAT<0FFCH,512,1,2,352,5,64,9>      ;SS DD: 9  SEC/TRACK 1 SIDED
	FORMAT<0FFDH,512,2,2,355,7,112,12>    ;DS DD: 9  SEC/TRACK 2 SIDED
	FORMAT<0FF9H,512,1,7,2373,14,224,29>  ;DS ED: 15 SEC/TRACK 2 SIDED
FORMAT_ENTRIES  EQU     ($-FORMAT_TABLE)/SIZE FORMAT    ; SELF_ADJUSTING FOR FLEXIBLE
;
DISK_FORMAT     DD      ?       ; DISK FORMAT POINTER
CLUSTER_BYTES   DW      ?       ; # BYTES IN A CLUSTER
;
;
;  THE ABOVE DATA STRUCTURE ARE GLOBAL FOR ALL PARTITION
;
;START_CLUSTER   DW      ?       ; BEGINNING CLUSTER OF FILE    (R5R4)
;FILE_BYTES      DD      ?       ; FILE SIZE IN BYTE            (A5A4)
;
;FILE_CLUSTERS   DW      ?       ; FILE SIZE IN CLUSTER         (A6)
PREVIOUS_INDEX  DW      ?       ; BACK -LINK IN CHAINED FAT     LOCAL USE ONLY
;
GET_DISK_FORMAT:
;***************************************************************
; FUNCTION:
;   CHECK THE DISKETTE IS MS-DOS FORMAT OR NOT ?
; ENRTY:
;       PHASE=EXECUTION
;       DISK ENABLED
;       PLATTER[FILE#,] SPECIFIED DISK
; RERTURN:
;       IF NOT DOS DISKETTE OR NOT SUPPORTED DOS DISKETTE, ERROR xx
;       IF DOS DISKETEE, SET RELATED INFORMATION
;***************************************************************
	MOV     CX,1            ;SPECIFY READ 1 SECTOR
	MOV     DX,1            ;SPECIFY LOGICAL SECTOR 1 (S0,T0,S2)
	LEA     EDI,TEMP_DATA   ;DATA_AREA
	MOV     BX,NONE
				;SET DIR/FAT FLAG TO NONE
	MOV     AX,READ
				;SET FOR READ OPERATION
	CALL    ABS_DISK_IO     ;READ A SECTOR
	XOR     AX,AX
	PUSH    AX              ;WANT FAT ENTRY # 0
	LEA     EDI,TEMP_DATA   ;DATA_AREA
	PUSH    EDI             ;ADDRESS OF FAT TABLE (ASSUME NOT CHANGE)
	CALL    DECODE_FAT      ;EXTRACT FAT ENTRY
	POP     AX              ;AX= VALE OF FAT # 0 = MEDIA WORD
;
; ESTABLISH DISK FORMAT PARAMETER
;
	LEA     ESI,FORMAT_TABLE        ;START OF DISK FORMAT TABLE
	XOR     ECX,ECX
	MOV     CX,FORMAT_ENTRIES       ;NUMBER OF FORMAT SUPPORTED
CHK_FMT:
	CMP     DFMT.MEDIA,AX           ;MEDIA WORD MATCH?
	JZ      SET_CLUSTER_LEN         ;YES, USE THIS FORMAT
	ADD     ESI,SIZE FORMAT
	LOOP    CHK_FMT                 ;NEXT ENTRY
;
	MOV     R0,93H                  ; ERROR CODE = 93  DISK FORMAT ERROR
	JMP     ERROR
;
SET_CLUSTER_LEN:
	MOV     DISK_FORMAT,ESI         ;SAVE POINTER FOR DISK PARAMETER
	MOV     AX,DFMT.BYTES_SECTOR
	MUL     DFMT.CLUSTER_SIZE
	MOV     CLUSTER_BYTES,AX        ; # OF BYTE PER CLUSTER
;
	MOV     BX,FAT
	MOV     AX,READ
	CALL    ABS_DISK_IO             ;READ ALL FAT OUT
;
	RET
;
DOSFINDNAMH:
;*************************************************************
; FUNCTION:
;       READ IN THE DIRECTORY & SEARCH FOR MATCHED FILE NAME
; ENTRY:
;       PHASE = EXECUTION
;       DISK ENABLED
;       I/O BUF + 450T = FILENAME (8 BYTE ) & EXTENSION (3 BYTE)
;       AUX0E = PLATTER SPEC.
;  RETURN:
;       R3=0FF          NOT FOUND
;          0            FOUND & SET RELATED INFORMATION
;
;                       WORD PTR R4 = START CLUSTER OF FILE
;                       A6 = FILE LENGTH IN CLUSTER
;                       A1 = ADDRESS OF LOGICAL SECTOR( FIRST DIRECTORY ENTRY THAT WE CAN USE
;                       A0 = ENTRY NUM. ( 0 -15) OF LOGICAL SECTOR
;  NOTE:
;    DEVDISK TABLE:  REDEFINE(MS-DOS)
;
;    | TYPE | ADDR | START-CLUST| CURR-RECORD| TOTAL-SECTOR|
;       1      1          2            2            2     # BYTES
;
;************************************************************
;PROCESS DIRECTORY (READ FIRST SECTOR OF DIR)
	MOV     ESI,DISK_FORMAT
	XOR     EDX,EDX
	MOV     DX,DFMT.FAT_SECTORS
	MOV     DH,0
	SHL     DX,1               ;FAT TABLE HAS TWO COPYIES
	INC     DX                 ;ADD ONE BOOT SECTOR

	XOR     ECX,ECX
	MOV     CX,DFMT.DIR_SECTORS  ; CX= NUM. OF DIRECTORY SECTOR

	MOV     AUX08,EDX
	ADD     AUX08,ECX            ;AUX08 = END SECTOR ADDRESS OF DIR + 1

	MOV     AX,READ              ; AX= READ
	MOV     CX,1                 ; DX= SECTOR ADRESS
	LEA     EDI,DIR_DATA         ; CX=NUM
	MOV     BX,NONE              ; EDI = ADDRESS TO STORE
	CALL    ABS_DISK_IO

	MOV     R6,0                ;R6 IS A LOCAL FLAG

	MOV     ESI,DISK_FORMAT ;ESI = CORRESPONDING POINTER TO DISK PARAMETERS
READ_DIR_ENTRY:
	LEA     EDI,DIR_DATA    ;POINT TO DIRECTORY INFORMATION
	MOV     BX,0            ;# ENTRIES IN THE DORECTORY
CHECK_N:
	CMP     R6,0
	JNZ     CHECK_K
	MOV     AL,[EDI]
	CMP     AL,UNUSED_MARK
	JZ      CHECK_M
	CMP     AL,DELETED_MARK
	JNZ     CHECK_K
CHECK_M:
	MOV     EAX,AUX0F
	MOV     A1,AX
	DEC     A1              ;SECTOR ADDRESS (A1)
	MOV     A0,BX           ;ENTRY #        (A0)
	MOV     R6,1
	JMP     FIND_N_2
CHECK_K:

	PUSH    EDI
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	ADD     EDX,450
	MOV     ESI,EDX         ;ESI = ADDRESS OF FILENAME(8)&EXTENSION(3)
;       CLD                     ;EDI = ADDRESS OF FILENAME TO BE SEARCHED
	MOV     ECX,11          ;ECX = COUNTER
	REPZ    CMPSB
	POP     EDI
	JNZ     FIND_N_2
;
	MOV     ESI,DISK_FORMAT ;FILE FOUND
	MOV     AX,FILES.FILE_START
	MOV     WORD PTR R4,AX        ;GET START CLUSTER & STORE IT
	MOV     AX,WORD PTR FILES.FILE_LENGTH
	MOV     DX,WORD PTR FILES.FILE_LENGTH+2
				      ;GET FILE LENGTH IN BYTES
;
	DIV     DFMT.BYTES_SECTOR
	CMP     DX,0
	JZ      STORE_FILE_CLUSTER
	INC     AX                              ;AX = FILE LENGTH IN SECTORS
STORE_FILE_CLUSTER:
	MOV     A6,AX
;
	call    dir_adr
	mov     eax,aux0f
	dec     ax
	mov     word ptr [edx],ax               ;put sector address & entry # in dir_ptr table
	mov     word ptr [edx+2],bx
;
	MOV     R3,0
	RET
FIND_N_2:
	ADD     EDI,SIZE FILE_ENTRY     ;NEXT ENTRY
	INC     BX                      ;ONE LESS ENTRY TO GO
	CMP     BX,16
	JNZ     CHECK_N
;
	MOV     EAX,AUX08
	CMP     EAX,AUX0F
	JZ      ERRXX
;
	MOV     EDX,AUX0F
	MOV     CX,1
	MOV     AX,READ
	LEA     EDI,DIR_DATA
	MOV     BX,NONE
	CALL    ABS_DISK_IO
	JMP     READ_DIR_ENTRY
ERRXX:
	MOV     R3,0FFH         ;FILE NOT FOUND
	RET
ABS_DISK_IO:
;**********************************************************************
;  (AX)=RW_FLG = 0 READ
;           1 WRITE
;  (BX)=DFR_FLG
;          = 1  FAT ,DATA ARE COPYED INTO OR OUT OF THE FAT_DATA AREA
;          = -1 ANYTHING, (DX) = FIRST LOGICAL SECTOR
;                         (CX) = NUM. OF SECTORS TO BE READ
;                         (EDI)= ADDRESS OF R/W  DATA
;   MODIFIED REG. : EDX CX R0-R1 K AUX00,01,03,04,05,0C,0F
;**********************************************************************
	MOV     ESI,DISK_FORMAT
	MOV     AUX0F,EDI       ;SET DEFAULT TRANSFER ADDRESS
	CMP     BX,NONE
	JZ      DO_DISK_IO
;PROCESS FAT
PROCESS_FAT:
	XOR     ECX,ECX
	MOV     CX,DFMT.FAT_SECTORS
	MOV     EDX,1
	LEA     EBX,FAT_DATA
	MOV     AUX0F,EBX
;ANYTHING
DO_DISK_IO:
	CMP     AX,WRITE
	JZ      WRITE_SECTOR
READ_SECTOR:
	MOV     EBX,AUX0F
	MOV     AUX04,EBX
	MOV     AUX05,ECX               ;EDX=SECTOR ADDRESS
	CALL    DOSREAD                 ;ECX= # OF SECTOR TO READ (LOGICAL CONTINUE)
	MOV     ECX,AUX05               ;AUX0F= ADDRESS TO STORE DATA
	DEC     ECX                     ;ECX=ECX-1
	JZ      DONE_DISK_IO
	MOV     EDX,AUX0F               ;EDX = NEXT SETOR
	MOV     EBX,AUX04
	ADD     EBX,200H                ;AUX0F= NEXT 521 ADDRESS
	MOV     AUX0F,EBX
	JMP     READ_SECTOR
WRITE_SECTOR:
	MOV     EBX,AUX0F
	MOV     AUX04,EBX
	MOV     AUX05,ECX               ;EDX=SECTOR ADDRESS
	CALL    DOSWRITE                ;ECX= # OF SECTOR TO READ (LOGICAL CONTINUE)
	MOV     ECX,AUX05               ;AUX0F= ADDRESS TO STORE DATA
	DEC     ECX
	JZ      DONE_DISK_IO
	MOV     EDX,AUX0F
	MOV     EBX,AUX04
	ADD     EBX,200H                ;AUX0F= NEXT 521 ADDRESS
	MOV     AUX0F,EBX
	JMP     WRITE_SECTOR
DONE_DISK_IO:
	RET
;
DECODE_FAT:
;*********************************************************************
;* ROUTINE TO DECODE A FAT ENTRY PAIR
;*********************************************************************
	PUSH    EBP
	MOV     EBP,ESP         ;ADDRESS PARAMETER
	PUSH    EAX
	PUSH    ECX
	PUSH    EDI
;
	MOV     EDI,BASED.FAT_TABLE     ;GET TABLE BASE ADDRESS
	MOV     EAX,0
	MOV     AX,BASED.FAT_INDEX      ;GET FAT INDEX #
	ADD     EDI,EAX
	SHR     EAX,1
	ADD     EDI,EAX                 ;EDI=EDI + EAX*1.5 = CONVERT FAT INDEX # TO PHYSICAL ADDRESS
;
	MOV     AX,[EDI]                ;AX= FAT WORD
	TEST    BASED.FAT_INDEX,1       ;EVEN OR ODD INDEX #
	JZ      DECODE_DONE
;
	MOV     CL,4                    ;ODD , HIGHER 12 BITS
	SHR     AX,CL
;
DECODE_DONE:
	AND     AX,0FFFH                ;EVEN , LOWER 12 BITS
	MOV     BASED.FAT_INDEX,AX
	POP     EDI
	POP     ECX
	POP     EAX
	POP     EBP
	RET     4                       ;NOTE : RESULT IS STILL IN THE STACK FOR CALLING ROUTINE TO POP

ENCODE_FAT:
;*********************************************************
;* ROUTINE TO ENCODE A FAT ENTRY
;*********************************************************
	PUSH    EBP
	MOV     EBP,ESP
	PUSH    EAX
	PUSH    ECX
	PUSH    EDI
;
	MOV     EDI,BASED.FAT_TABLE     ;GET TABLE BASE ADDRESS
	MOV     EAX,0
	MOV     AX,BASED.FAT_INDEX      ;GET FAT INDEX #
	ADD     EDI,EAX
	SHR     EAX,1
	ADD     EDI,EAX                 ;EDI=EDI + EAX*1.5 = CONVERT FAT INDEX # TO PHYSICAL ADDRESS
;
	MOV     AX,BASED.FAT_VALUE      ;AX=FAT WORD TO STORE
	AND     AX,0FFFH
	TEST    BASED.FAT_INDEX,1
	JNZ     ENCODE_ODD
;
	AND     BYTE PTR [EDI],0F0H
	OR      AH,BYTE PTR [EDI+1]
	MOV     [EDI],AX
	JMP     ENCODE_DONE
;
ENCODE_ODD:
	MOV     CL,4
	SHL     AX,CL
	AND     BYTE PTR [EDI],0FH
	OR      AL,[EDI]
	MOV     [EDI],AX
ENCODE_DONE:
	POP     EDI
	POP     ECX
	POP     EAX
	POP     EBP
	RET     8                       ;NOTE : RESULT IS STILL IN THE STACK FOR CALLING ROUTINE TO POP

;**************** HIGH LEVEL ********************************
;* BASIC-2 COMMAND
;*  DATALOAD AC ......
;
;*  DATASAVE AC ......
;*************************************************************

;         TITLE     DTLDAC (DATALOAD AC)
;*     DTLDAC: SCAN & PROCESS A 'DATALOAD AC' STATEMENT
;*
;*          STMT FORMAT:
;*        1. DATALOAD AC OPEN platter [file#,] filename
;*
;*        2. DATALOAD AC [ file#, ][(record-num.)] alpha-array
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'AC'
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*          REGISTER USE:
;*               AUXE (DISK CONTROL REG.) = PLATTER,FILE#
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXE,F IN EXECUTION PHASE ONLY
;*
;*

DTLDAC:
	MOV     R0,@OPEN
	CALL    CCL             ;LOOK FOR 'OPEN'
	TEST    R0,0FH
	JZ      DTLDAC1         ;BR IF 'DATALOAD AC OPEN'
;
; FORMAT 2 PROCESS
;
	CALL    DISKSL_P
	CALL    DOSRECORD       ;PROCEES RECORD NUM. IF ANY
	CALL    ALPHARAY
	TEST    SL,2
	JZ      DTLDAC10
	CMP     CX,200H
	JB      ERROR_51
	XCHG    EDX,AUX0F       ;EDX= REORD NUM. TO READ; AUX0F= ADDRESS TO STORE DATA
	CALL    RECMAP
	CALL    DOSREAD
DTLDAC10:
	JMP     ENDSDISK      ;DISABLE DISK ,EXIT

;*     DATALOAD AC OPEN
;* FORMAT 1  PROCESS

DTLDAC1:
	CALL    PLATTER         ;LOOK FOR PLATTER SPEC.
	CALL    DISKSL_C        ;PROCESS #N, SPEC.
	TEST    SL,2
	JZ      BP41AC_04
	CALL    ZEROFIL_        ;IF EXECUTION PHASE , CLEAR DEVICE TABLE SLOT
	CALL    GET_DISK_FORMAT ;
BP41AC_04:
	CALL    DOSFILENAMD     ;SCAN FOR NAME OF FILE OPEN
	TEST    SL,2
	JZ      DTLDAC3         ;BR IF NOT EXECUTION PHASE
	CALL    DOSPUTFLPTR     ;START-CLUSTER & RECORD NUM. & FILE-CLUSTERS ===> # N DEVICE TABLE SLOT
	CALL    PUTPLTTR        ;PLATTER ===> # N DEVICE TABLE SLOT
DTLDAC3:
	JMP     ENDSDISK

;         TITLE     DTSVAC (DATASAVE AC)
;*     DTSVAC: PROCESS 'DATASAVE AC' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               1.  DATASAVE AC OPEN platter [file#,] (expression) filename  ---> CREATE A NEW FILE
;*
;*               1a. DATASAVE AC OPEN platter [file#,] filename ----> REWRITE AN OLD FILE
;*
;*               2.  DATASAVE AC [file#,][(record num.)] alph_var
;*                                                       liter.
;*               3.  DATASAVE AC [file#,]end
;*
;*               4.  DATASAVE AC CLOSE file#
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DATASAVE AC'
;*

DTSVAC:
	MOV     R0,@OPEN
	CALL    CCL             ;LOOK FOR 'OPEN'
	TEST    R0,0FH
	JZ      DTSVACO         ;BR IF FOUND
;
	MOV     R0,@CLOSE
	CALL    CCL             ;LOOK FOR 'CLOSE'
	TEST    R0,0FH
	JZ      DTSVACC         ;BR IF FOUND
;
	CALL    DISKSL_P        ;PROCESS #N,
	CALL    DOSRECORD       ;FROM DEVICE TABLE GET ORIGINAL INFO. & CONVERT ... TO AUX0F
	test    r0,0fh          ;
	jz      dtsvacend       ;br if record num found

; *** process the datasave ac [file#,]end ***
	mov     r0,@end
	call    ccl
	test    r0,0fh
	jnz     dtsvacend
;
	test    sl,2
	jz      dtsvba1

	cmp     aux0f,0
	jz      error_34

;                               ;execution phase
	push    aux0f
	call    dir_adr
	mov     dx,cx
	lea     edi,dir_data
	mov     cx,1
	mov     ax,read
	mov     bx,none
	call    abs_disk_io     ;read the corresponding dir sector out
;
	call    dir_adr
	xor     ebx,ebx
	mov     bx,[edx+2]
	shl     ebx,5
	lea     edi,dir_data
	add     edi,ebx         ;edi point to corresponding entry #
;
	pop     aux0f           ;eax= total record number (0 -9  = total 10)
	mov     eax,aux0f
	mov     edx,eax
	dec     edx
	shl     eax,9
	mov     files.file_length,eax   ;alter file length
;
	mov     ax,dx
	mov     dx,0
	mov     esi,disk_format
	div     dfmt.cluster_size       ; DX:AX \ CLUSTER_SIZE
	inc     ax
	push    ax
	call    file_ptr
	mov     cx,[edx]
	xchg    ch,cl                   ; CX=START CLUSTER
	mov     aux09,ecx
	pop     ax                      ; AX=chain # ( e.g. 10 sectors = 5 clusters = 4 chain between clusters)
xxx1:
	cmp     ax,0
	jz      fat_done1

	mov     aux09,ecx
	push    cx                      ; CURRENT FAT # (AUX09)
	lea     ebx,fat_data
	push    ebx
	call    decode_fat
	pop     cx                      ; NEXT FAT # (ECX)
	dec     ax
	jmp     xxx1

fat_done1:
	mov     bx,0ff8h
	push    bx
	mov     ebx,aux09
	push    bx
	lea     ebx,fat_data
	push    ebx
	call    encode_fat

reallo:
	cmp     cx,0ff8h
	jae     dtsvacdone
	mov     aux09,ecx
	push    cx                      ; CURRENT FAT # (AUX09)
	lea     ebx,fat_data
	push    ebx
	call    decode_fat
	pop     cx                      ; NEXT FAT # (ECX)

	mov     bx,000h
	push    bx
	mov     ebx,aux09
	push    bx
	lea     ebx,fat_data
	push    ebx
	call    encode_fat
	jmp     reallo

dtsvacdone:
	call    dir_adr
	mov     dx,[edx]
	lea     edi,dir_data
	mov     cx,1
	mov     ax,write
	mov     bx,none
	call    abs_disk_io
;
	mov     bx,fat
	mov     ax,write
	call    abs_disk_io     ;WRITE 1ST FAT INTO DISK
;
	mov     esi,disk_format
	mov     cx,dfmt.fat_sectors
	mov     dx,1
	add     dx,cx
	lea     edi,fat_data    ;DX=LOGICAL SECTOR #
	mov     bx,none         ;CX=NUM OF SECTOR FOR R/W
				;EDI= ADDRESS OF DATA
	mov     ax,write
	call    abs_disk_io
	jmp     dtsvba1
dtsvacend:
	CALL    ALPHA           ;PROCESS ALPHA VARIABLE OR LITERAL
	TEST    R0,0FH
	JZ      DTSVACPRO
	JMP     ERROR_29        ;ERROR IF NOT FOUND
DTSVACPRO:
	TEST    SL,2
	JZ      DTSVBA1
;
;*        This patch causes the value to be padded with hex(00)s if the value is
;*        shorter than 512 bytes.  This is done by copying short values to
;*        the IOBUFFER and padding with zeroes.
;
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR  ;POINT TO I/O BUFFER ( I/O BUFFER = 512 BYTE)
	MOV     AUX00,EDX       ;
	MOV     EDI,EDX         ;EDI = I/O BUFFER ADDRESS
;       CALL    POPV4
	MOV     EDX,VSPTR
	MOV     AX,WORD PTR [EDX]
	MOV     WORD PTR [R0],AX
	MOV     ECX,DWORD PTR [EDX+2]
	ADD     VSPTR,6
	MOV     EDX,ECX
	MOV     ESI,EDX         ;ESI = ALPHA VALUE ADDRESS
	MOV     CX,WORD PTR R0  ;R0R1 PAIR = ALPHA LENGTH
	CMP     CX,200H
	JAE     DTSVBA2         ;BR IF LENGTH LONGER THAN 512

;*----------------- value shorter than 512 bytes -------------------------------
;
	AND     ECX,0FFFFH
	MOV     EAX,ECX
;       CLD
	REP     MOVSB           ;MOVE VALUE TO I/O BUFFER
	MOV     ECX,200H
	SUB     ECX,EAX
	MOV     AL,0
	REP     STOSB           ;WRITE ZERO UNTIL END OF I/O BUFFER
	MOV     EDX,AUX00
DTSVBA2:
	XCHG    EDX,AUX0F       ;AFTER, AUX0F=ADDRESS OF WRITE-DATA ; EDX=RECORD NUM.
	CALL    RECMAP          ;EDX=SECTOR ADDRESS;AUX0F=ADDRESS OF WRITE-DATA
	CALL    DOSWRITE        ;WRITE SECTOR
DTSVBA1:
	JMP     ENDSDISK        ;DISABLE DISK ,EXIT

;         TITLE     DATASAVE DC CLOSE

DTSVACC:
	CALL    FILE_A
	TEST    SL,2
	JZ      DTSVACK
	CALL    ZEROFIL_
DTSVACK:
	JMP     ENDSDISK

;         TITLE     DATASAVE AC OPEN

DTSVACO:
	CALL    PLATTER         ;PROCESS PLATTER SPEC.
	CALL    DISKSL_C        ;PROCESS #n, SPEC.
	TEST    SL,2
	JZ      DTSVACO1        ;BR IF NOT EXECUTION PHASE
	CALL    ZEROFIL_        ;CLEAR DEVICE TABLE SLOT
	CALL    GET_DISK_FORMAT
DTSVACO1:
	CALL    DOSFILELOC      ;PROCESS (EXPRESSION) OR FILENAME
	CALL    DOSNEWNAME      ;GET NEW FILENAME FROM TEXT & SCAN IT IN DISK DIRECTORY
	TEST    SL,2
	JZ      DTSVACO2
	CALL    DOSADDFILE      ;ADD FILE TO DISK DIRECTORY
	CALL    PUTPLTTR        ;PLATTER SPEC. ===> # n DEVICE TABLE SLOT
DTSVACO2:
	JMP     ENDSDISK        ;DISABLE DISK ,EXIT

;**************** SUPPORT ROUTINE ********************************
DOSADDFILE:
;******************************************************************
; FUNCTION:
; ENTRY:
;       A1=ADDRESS OF SECTOR
;       A0=ENTRY #
;       WORD PTR R4=START CLUSTER # ALLOCATE
;       AUX07=FILE LENGTH IN BYTES
;       I/O BUF + 450T =FILE NAME( 8 BYTE FILENAME & 3 BYTE EXTENSION)
; RETURN:
;******************************************************************
;
	LEA     EDI,DIR_DATA
	MOV     CX,1
	MOV     DX,A1
	MOV     AX,READ
	MOV     BX,NONE
	CALL    ABS_DISK_IO
	XOR     EBX,EBX
	MOV     BX,A0
	SHL     EBX,5
	lea     edi,dir_data
	ADD     EDI,EBX
;
	MOV     AX,WORD PTR R4
	MOV     FILES.FILE_START,AX     ;MOVE STRAT CLUSTER
;
	MOV     EAX,AUX07               ;FILE LENGTH
	MOV     FILES.FILE_LENGTH,EAX
;
	MOV     AL,0
	MOV     FILES.ATTRIBUTE,AL      ;FILE ATTRIBUTE
;
	call    gettime                 ;fourteen unpacked digits representing the time
	mov     ebx,offset scratch      ; ( two bytes for each unit of time) in scratch area
	mov     dx,0                    ;dx
	mov     eax,0ah                 ;
	call    timeconv                ;  year    ( 00 - 99)   0 - 1
	mov     dl,cl                   ;  month   ( 01 - 12)   2 - 3
	mov     eax,08h                 ;  days    ( 01 - 31)   4 - 5
	call    timeconv                ;  hours   ( 00 - 24)   6 - 7
	shl     cx,5                    ;  minutes ( 00 - 59)   8 - 9
	or      dx,cx                   ;  seconds ( 00 - 59)   a - b
	mov     eax,06h                 ;  centisec( 00     )   c - d
	call    timeconv
	shl     cx,11
	or      dx,cx
	MOV     FILES.D_TIME,dx

	mov     dx,0
	mov     eax,04
	call    timeconv
	mov     dl,cl
	mov     eax,02
	call    timeconv
	shl     cx,5
	or      dx,cx
	mov     eax,0
	call    timeconv
	sub     cl,80
	shl     cx,9
	or      dx,cx
	MOV     FILES.D_DATE,dx         ;FILE DATE/TIME
;
	LEA     EDI,FILES.FILE_NAME
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	ADD     EDX,450
	MOV     ESI,EDX
	MOV     ECX,11
	REP     MOVSB                   ;FILE NAME & EXTENSION
;
	LEA     EDI,DIR_DATA
	MOV     CX,1
	MOV     DX,A1
	MOV     AX,WRITE
	MOV     BX,NONE
	CALL    ABS_DISK_IO
;
	MOV     BX,FAT
	MOV     AX,WRITE
	CALL    ABS_DISK_IO     ;WRITE 1ST FAT INTO DISK
;
	MOV     ESI,DISK_FORMAT
	MOV     CX,DFMT.FAT_SECTORS
	MOV     DX,1
	ADD     DX,CX
	LEA     EDI,FAT_DATA    ;DX=LOGICAL SECTOR #
	MOV     BX,NONE         ;CX=NUM OF SECTOR FOR R/W
				;EDI= ADDRESS OF DATA
	MOV     AX,WRITE

	CALL    ABS_DISK_IO
;
	call    dir_adr
	mov     ax,a1
	mov     word ptr [edx],ax
	mov     ax,a0
	mov     word ptr [edx+2],ax
;
	RET

timeconv:
;***************************************************************
; function:
;       convert two bytes' unpacked digits to binary value
; entry:
;       ebx = point to scratch area
;       eax = offset to scratch area
; return:
;       cl = binary value
;***************************************************************
	mov     ch,[ebx+eax]
	sub     ch,30h
	mov     cl,ch
	shl     cl,3    ;* 8
	shl     ch,1    ;* 2
	add     cl,ch   ;=* 10
	mov     ch,[ebx+eax+1]
	sub     ch,30h
	add     cl,ch
	and     cx,0ffh
	ret

DOSNEWNAME:
;****************************************************************
; FUNCTION:
;       LOOK FOR A DATA FILENAME IN TEXT ; ERROR IF NOT FOUND
;       IN EXECUTION PHASE,SEARCH FOR FILENAME IN DIRECTORY; ERROR IF FOUND
; ENTRY & RETURN : SAME AS ...
;*****************************************************************
	CALL    DOSFILENAMH             ;GET FILENAME FORM TEXT & SEARCH FOR NAME IN DIRECTORY
	TEST    SL,2
	JZ      DOSFILENMXX             ;BR IF NOT EXECUTION PHASE
	TEST    R3,0FH
	JZ      ERROR_83                ;ERROR IF FILE IS FOUND
DOSFILENMXX:
	RET
;
;
DOSFILELOC:
;******************************************************************
; FUNCTION:
;      1. PROCESS THE (expression) & CHECK IF ENOUGH DISK SPACE ? TO CREATE A NEW FILE
;      2. PROCESS THE filename TO REWRITE AN OLD FILE
; ENTRY:
;       TEXTPTR POINTS TO NEXT TEXT CHARACTER
;       IN EXECUTION PHASE, DISK ENABLED ; AUX0E= FILE #/PLATTER
; RETURN:
;       ERROR :         IF NOT ENOUGH DISK SPACE FOR NEW FILE
;                       IF FILE NOT FOUND FOR OLD FILE
;
;       FATS ALLOCATED CHAIN TOGETHER &
;       WORD PTR R4 = FIRST FAT INDEX # (LATER FOR ADD FILE USE)
;       AUX07= FILE LENGTH IN BYTES
;       A6   = FILE LENGTH IN SECTORS
;*****************************************************************
	CMP     BYTE PTR [TEXTPTR],'('
	JNE     DOSFILELOC1
	INC     TEXTPTR
;
; FOR PROCESS THE (expression)
;
	CALL    EXPR            ;PROCESS EXPR
	TEST    SL,2
	JZ      DOSFILELOC5     ;BR IF NOT EXECUTION PHASE
	CALL    FLTBIN          ;CONVERT NO. OF SECTORS TO BINARY (R1R0 PAIR)
	CMP     R2,2
	JNZ     ERROR_34        ;VALULE OUT OF RANGE (0..65535)
	XOR     EAX,EAX
	MOV     AX,WORD PTR R0
	MOV     A6,AX
	SHL     EAX,9
	MOV     AUX07,EAX
	MOV     R2,1            ;PASS # 1
	CALL    FATCHAIN
	MOV     R2,2            ;PASS # 2
	CALL    FATCHAIN
DOSFILELOC5:
	CMP     BYTE PTR [TEXTPTR],')'
	JNE     ERROR_11
	INC     TEXTPTR
	RET
;
; FOR PROCESS THE filename
;
DOSFILELOC1:
	CALL    DOSFILENAMD     ;SCAN FOR NAME OF FILE OPEN
	TEST    SL,2
	JZ      DOSFILELOC2     ;BR IF NOT EXECUTION PHASE
	CALL    DOSPUTFLPTR     ;START-CLUSTER & RECORD NUM. & FILE-CLUSTERS ===> # N DEVICE TABLE SLOT
	CALL    PUTPLTTR        ;PLATTER ===> # N DEVICE TABLE SLOT
DOSFILELOC2:
	POP     EDX             ;POP RETURN ADDRESS FOR STACKK BALANCE
	JMP     ENDSDISK
;
FATCHAIN:
;*******************************************************************
; FUNCTION:
;
; ENTRY:
;       R1R0 PAIR = # OF SECTORS NEEDED
;       R2        = 1 PASS #1 --- CHECK IF ENOUGH DISK SPACE
;                   2 PASS #2 --- REALLY ALLOCATE FAT & CHAIN TOGETHER
; RETURN:
;       IN PASS #2
;       WORD PTR R4 = FIRST FAT INDEX # (LATER FOR ADD FILE USE)
;********************************************************************
	MOV     PREVIOUS_INDEX,NONE
	MOV     ESI,DISK_FORMAT
	MOV     DX,0
	MOV     AX,WORD PTR R0
	DIV     DFMT.CLUSTER_SIZE
	TEST    DX,1
	JZ      CHAIN1
	INC     AX
CHAIN1: MOV     DX,AX                   ;DX= # OF CLUSTERS THAT MAKE UP THE FILE
	MOV     BX,START_FAT            ;BX= FAT # (INDEX)
	MOV     CX,DFMT.FAT_ENTRIES     ;CX= MAX # OF FATS THAT CAN BE CHECK
	SUB     CX,2
	LEA     EDI,FAT_DATA            ;EDI= BASE ADDRESS OF FAT TABLE
SEARCH_FOR_FAT:
	PUSH    BX
	PUSH    EDI
	CALL    DECODE_FAT
	POP     AX                      ;AX=FAT CONTENT
	AND     AX,AX                   ;IS THIS A ZERO FAT
	JNZ     GET_NEXT_FAT
;
;  FAT IS 000 --- USE IT IN THE CHAIN
;
	TEST    R2,1
	JNZ     NO_LINK                 ;BR IF PASS #1
	CMP     PREVIOUS_INDEX,NONE
	JNZ     SAVE_BACK_LINK
	MOV     WORD PTR R4,BX        ;FIRST FAT INDEX
	JMP     SAVE_PREVIOUS_INDEX
SAVE_BACK_LINK:
	PUSH    BX                      ;
	PUSH    PREVIOUS_INDEX          ; WRITE CURRENT FAT INDEX INTO PREVIOUS FAT CONTENT
	PUSH    EDI                     ; THAT MEANS CHAIN TOGETHER
	CALL    ENCODE_FAT
SAVE_PREVIOUS_INDEX:
	MOV     PREVIOUS_INDEX,BX       ;THIS INDEX IS NOW PREVIOUS
NO_LINK:
	DEC     DX              ;1 LESS FAT TO FIND
	JNZ     GET_NEXT_FAT
	TEST    R2,1
	JNZ     RET_LINK        ;BR IF PASS #1
	MOV     AX,0FF8H
	PUSH    AX
	PUSH    BX
	PUSH    EDI
	CALL    ENCODE_FAT      ;SET END OF CLUSTER
	CALL    DOSPUTFLPTR     ;INFOR. ====> # N DEVICE TABLE SLOT
RET_LINK:
	RET
GET_NEXT_FAT:
	INC     BX              ;NEXT FAT INDEX
	DEC     CX              ;DEC MAX. # TO CHECK
	JNZ     SEARCH_FOR_FAT  ;CONTINUE IF MORE LEFT
NO_FREE_FAT:
	JMP     ERROR_86        ;RUN OUT OF FAT
;
;
RECMAP:
;********************************************************************
;FUNCTION: INTERFACE ROUTINE BETWEEN HIGH AND MIDDLE LEVEL
;          RECORD NUM. ======> LOGICAL SECTOR  #
;ENTRY:
;          EDX= REORD NUM. TO READ
;
;                     XXX     YYY            ???   KKK
;   FILE DIR.  xxx    yyy     zzz    ......  kkk   ff8
;
;              0 1    2 3     4 5    ...... 2N 2N+1     (CLUSTER=2SECTORS)
;               0      1       2     ......   N         (CLUSTER=1SECTOR)
;
;                              |
;                              v
;                   REAL LOGICAL SECTOR NUMBER
; RETURN:
;       EDX=LOGICAL SECTOR ADDRESS
;*********************************************************************
	MOV     AX,DX
	MOV     DX,0
	MOV     ESI,DISK_FORMAT
	DIV     DFMT.CLUSTER_SIZE       ; DX:AX \ CLUSTER_SIZE
	PUSH    AX                      ; AX= WHICH CLUSTER TO READ
	PUSH    DX                      ; DX= WHICH SECTOR IN CLUSTER TO READ ;0 EXACT, 1 NEXT
	CALL    FILE_PTR
	MOV     CX,[EDX]
	XCHG    CH,CL                   ; CX=START CLUSTER
	POP     DX                      ; AX=CLUSTER # RELATIVE START CLUSTER
	POP     AX                      ; DX=SECTOR # RELATIVE READ CLUSTER
XXX:
	CMP     AX,0
	JZ      FAT_DONE
	CMP     CX,0FF8H
	JAE     ERROR_89
	PUSH    CX
	LEA     EBX,FAT_DATA
	PUSH    EBX
	CALL    DECODE_FAT
	POP     CX
	DEC     AX
	JMP     XXX
ERROR_89:
	MOV     R0,89H
	JMP     ERROR
FAT_DONE:
	CALL    FATTOSEC
	RET
;
;
FATTOSEC:
;*************************************************
;FUNCTION :
;       FAT VALUE =======> LOGICAL SECTOR(S)
;ENTRY:
;       CX = FAT VALUE
;       DX = EXACT(0) OR NEXT(1)
;RETURN:
;       EDX=SECTOR ADDRESS
;**************************************************
	SUB     CX,2
	MOV     ESI,DISK_FORMAT
	MOV     BX,DFMT.CLUSTER_SIZE
	CMP     BX,1
	JZ      FATTOSEC1
	SHL     CX,1
FATTOSEC1:
	ADD     CX,DFMT.DATA_BEGIN
	TEST    DX,1
	JZ      EXACT
	INC     CX
EXACT:
	XOR     EDX,EDX
	MOV     DX,CX
	RET

;
;
DOSRECORD:

;****************************************************
; FUNCTION: SCAN & PROCESS A RELATIVATE RECORD SPEC.
; FORMAT:
;               [(RECORD_NUM.)]
; ENTRY:
;               TEXTPTR POINT AFTER 'AC'
; RETURN:
;               TEXTPTR POINT TO NEXT NONBLANK CHARACTER
;            1. R0 <> 0 RECORD NUM. NOT FOUND ----SEQUENTIAL &
;               AUX0F = CURRENT REC. NUM. IN DEVICE TABLE SLOT # ; AUTOMATICALLY INCREASE
;            2. R0  = 0 RECORD NUM. FOUND     ----RANDOM  &
;               AUX0F=SECTOR ADDRESS TO READ/WRITE
;*********************************************************
	CMP     BYTE PTR [TEXTPTR],'('
	JNE     RECO2           ;BR IF NOT FOUND
	INC     TEXTPTR
	CALL    BINVAL          ;GET ONE WORD BINARY VALUE
	TEST    SL,2
	JZ      RECO1
	XOR     EDX,EDX
	MOV     DX,WORD PTR R0  ;DX=CURRENT
	PUSH    EDX
	CALL    FILE_PTR
	ADD     EDX,4
	MOV     CX,[EDX]
	XCHG    CH,CL           ;CX=END
	POP     EDX
	DEC     CX
	CMP     CX,DX
	JB      ERROR_34
	JNE     REC99
	OR      MODE,80H
REC99:
	MOV     AUX0F,EDX       ;AUX0F = RECORD # TO READ
RECO1:
	CMP     BYTE PTR [TEXTPTR],')'
	JNE     ERROR_11
	INC     TEXTPTR
	RET
RECO2:
	TEST    SL,2
	JZ      RECO3
	CALL    FILE_PTR
	ADD     EDX,2
	XOR     ECX,ECX
	MOV     CX,[EDX]
	XCHG    CH,CL
	MOV     BX,[EDX+2]      ;BX= END
	XCHG    BH,BL           ;CX= CURRENT
	DEC     BX
	CMP     BX,CX
	JB      ERROR_34
	JNE     REC98
	OR      MODE,80H
REC98:
	MOV     AUX0F,ECX       ;AUX0F = CURRENT RECORD NUMBER IN TABLE SLOT #
	INC     ECX
	XCHG    CH,CL
	MOV     [EDX],CX
RECO3:
	mov     r0,0ffh
	RET
;
;
DOSFILENAMD:
;****************************************************************
; FUNCTION:
;       LOOK FOR A DATA FILENAME IN TEXT ; ERROR IF NOT FOUND
;       IN EXECUTION PHASE,SEARCH FOR FILENAME IN DIRECTORY; ERROR IF NOT FOUND
; ENTRY & RETURN : SAME AS ...
;*****************************************************************
	CALL    DOSFILENAMH             ;GET FILENAME FORM TEXT & SEARCH FOR NAME IN DIRECTORY
	TEST    SL,2
	JZ      DOSFILENMX1             ;BR IF NOT EXECUTION PHASE
	TEST    R3,0FH
	JNZ     ERROR_82                ;ERROR IF FILE IS NOT FOUND
DOSFILENMX1:
	RET
;
;
DOSFILENAMH:
;*******************************************************************
; FUNCTION:
;       LOOK FOR A DATA FILENAME IN TEXT ; ERROR IF NOT FOUND
;       IN EXECUTION PHASE,SEARCH FOR FILENAME IN DIRECTORY; ERROR IF NOT FOUND
; ENTRY:
;       TEXTPTR POINTS TO NEXT TEXT CHARACTER
;       IN EXECUTION PHASE,
;       DISK ENABLED
;       AUX0E = PLATTER SPEC.
; RETURN :
;       IN EXECUTION PHASE,
;       R3 = RETURN VALUE
;          FF           NOT FOUND
;          0            FOUND & SET RELATED INFORMATION
;                       WORD PTR R4 = START CLUSTER OF FILE
;                       A6 = FILE LENGTH IN CLUSTER
;********************************************************************
	CALL    DOSFILENAME     ;LOOK FOR FILENAME IN TEXT
	TEST    R0,0FH
	JZ      DTLDAC_01
	JMP     ERROR_29        ;ERROR IF NOT FOUND FILENAME IN TEXT
DTLDAC_01:
	TEST    SL,2
	JNZ     DOSFINDNAMH     ;BR IF EXECUTION PHASE
	RET
;
;         TITLE     DOSFILENAME
;*  DOSFILENAME: LOOK FOR FILENAME (LITERAL OR ALPHA-VAR)
;*               IN TEXT.  IN EXECUTION PHASE, MOVE NAME
;*               TO  AND PAD WITH TRAILING
;*               SPACES (UP TO 8 CHARACTERS).
;*
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN (EXECUTION PHASE):
;*               F0 <> 0 IF NAME NOT FOUND
;*               F0 = 0 IF NAME FOUND
;*                   NAME (8 BYTES, FILLED WITH TRAILING
;*                       SPACES) & . ==>
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*

DOSFILENAME:
	MOV     K,4
	CALL    ALPHA1
	TEST    R0,0FH
	JNZ     DOSFILENAM1     ; WE WANT  AS FOLLOWS:
	TEST    SL,2            ;   0   -     7  8 - 10
	JZ      DOSFILENAM1     ;    FILENAME    EXTENSION
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	ADD     EDX,450
	MOV     EDI,EDX         ;EDI = ADDRESS OF I/OBUF + 450T
;       CALL    POPV4           ;EDX=ADDRSS OF FILENAME & R1R0 = LENGTH OF FILENAME
	MOV     EDX,VSPTR
	MOV     AX,WORD PTR [EDX]
	MOV     WORD PTR [R0],AX
	MOV     ECX,DWORD PTR [EDX+2]
	ADD     VSPTR,6
	MOV     EDX,ECX
	xor     ebx,ebx
	mov     bx,word ptr r0
	add     ebx,edx         ;ebx = end address of filename
	CMP     WORD PTR R0,0CH
	JA      ERR_52D
;
;   WE LOOK AT NAME & EXTENSION INDIVIDUALLY
;       NAME PART = 8 CHARACTERS , > 8  TRUNCATE, < 8 TRAILING SPACE
;       EXT. PART = 3 CHARACTERS , > 3  TRUNCATE, < 3 TRAILING SPACE

	MOV     ECX,0
NAME1:
	CMP     EDX,EBX
	JZ      NAME2           ; CASE() "ABCD"
	MOV     AL,[EDX]
	CMP     AL,'.'
	JZ      NAME2           ; CASE() "ABCD.???"
	STOSB
	INC     EDX

	INC     ECX
	CMP     ECX,8
	JB      NAME1

	MOV     AUX00,ECX       ; CASE() "ABCDEFGH.???"
	JMP     DOTPRO          ; CASE() "ABCDEFGHI.???"
NAME2:
	MOV     AUX00,ECX       ;TRAILING SPACES OF FILE NAME
	MOV     AL,20H
NAME21:
	STOSB
	INC     ECX
	CMP     ECX,8
	JB      NAME21

;  EXTENSION PART
;
DOTPRO:
	MOV     ECX,AUX00
	SUB     WORD PTR R0,CX          ;R1R0 PAIR = LENGTH IN EXTENSION (INCLUDING DOT)
	JZ      EXT1                    ; CASE() = "ABCD"
	CMP     BYTE PTR [EDX],'.'
	JNZ     EXT1B
	DEC     R0
	INC     EDX
	JMP     EXT1
EXT1B:
	DEC     R0
	JZ      EXT1
	INC     EDX
	CMP     BYTE PTR [EDX],'.'
	JNZ     EXT1B
	DEC     R0
	INC     EDX
EXT1:
	MOV     ECX,3
EXT1A:
	CMP     R0,0                    ; CASE() ="????.ME"
	JZ      EXT2                    ; CASE() ="????.E"
	MOV     AL,[EDX]
	STOSB
	DEC     ECX
	JZ      EXT3
	DEC     R0
	INC     EDX
	JMP     EXT1A
EXT2:
	MOV     AL,20H          ;TRAILING SPACE OF FILE EXTENSION
	STOSB
	DEC     ECX
	JNZ     EXT2
;
EXT3:
	MOV     R0,0
DOSFILENAM1:
	RET
ERR_52D:
	JMP     ERROR_52
;
DOSPUTFLPTR:
;********************************************************************
; FUNCTION:
;       START-CLUSTER & RECORD NUM. & FILE-CLUSTERS ===> # N DEVICE TABLE SLOT
; ENTRY:
;       PHASE= EXECUTION
;       @FILE#,BYTE 2 = FILE #
;     1.  WORD PTR R4 = START_CLUSTER
;     2.  RECORD NUM.=0                   =====> # DEVICE TABLE SLOT
;     3.  A6 = FILE LENGTH IN SECTOR
;  RETURN:
;*********************************************************************
	CALL    FILE_PTR                ;POINT TO #N DEVICE TABLE SLOT
	MOV     AX,WORD PTR R4
	XCHG    AH,AL
	MOV     [EDX],AX                ;START CLUSTER
	ADD     EDX,2
	MOV     WORD PTR [EDX],0        ;RECORD NUM.
	ADD     EDX,2
	MOV     AX,A6
	XCHG    AH,AL
	MOV     [EDX],AX                ;FILE SECTOR
	RET

; DIR#ADR:  point to specified file# entry in the dir_ptr table and return
;           the sector address & entry #
;
;        Entry: @FILE#,byte 2 = file# (0-255)
;               Execution phase
;
;        Return: EDX  = address of file# entry in Dir_ptr Table
;                CH = sector address
;                CL = entry #
;       Modified registers: edx,ecx,eax,ebx
;

DIR_ADR:
	MOV     EDX,DWORD PTR [CPBASE]
	MOV     CX,WORD PTR [EDX].@FILE_
	XCHG    CH,CL                   ;CH = MAX FILE#, CL = FILE#
	CMP     CL,CH
	JA      DIR_AD1                 ;ERROR, IF FILE# > 255
;
	XOR     EAX,EAX
	MOV     AL,CL
	SHL     EAX,2                   ;EACH ENTRY IS 2 WORDS IN BIR_PTR TABLE
	LEA     EDX,[EDX].@DIR_PTR      ;POINT TO # 0
	ADD     EDX,EAX                 ;POINT TO #N IN DEVICE TABLE
	MOV     CX,WORD PTR [EDX]       ;CX= SECTOR ADDRESS
	RET

DIR_AD1:
	JMP     ERROR_34
;
CODE    ENDS
	   END
