;===========================================================================          
;
;       L I S T   S T A T E M E N T
;       
;===========================================================================          
;       This module was originally M27
;===========================================================================          
          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    BUMPREAD
PUBLIC    ERRLIST
PUBLIC    LIST
PUBLIC    LISTVAR
PUBLIC    LISTTA
PUBLIC    LISTDONE
PUBLIC    LISTEND
PUBLIC    LISTLINE
PUBLIC    LISTLINS
PUBLIC    LSTVENDL
PUBLIC    NEXTREF
PUBLIC    NEXTREFS
PUBLIC    NEXTREFA
PUBLIC    NEXTGO?QU
PUBLIC    NEXTGO?QUA
PUBLIC    GETLINE_
PUBLIC    GETNLCH
PUBLIC    GETNLCHS
PUBLIC    PRNTDEF
PUBLIC    PRNTLINE
PUBLIC    PRNTREF
PUBLIC    TXTSETA
PUBLIC    TXTSETB
PUBLIC    UNLISTV

EXTRN     A$TRACE   :NEAR
EXTRN     ALPHA1    :NEAR
EXTRN     ATCOL0E   :NEAR
EXTRN     AVAR      :NEAR
EXTRN     BINDEC    :NEAR
EXTRN     BREAKPTG  :NEAR
EXTRN     BREAKPTT  :NEAR
EXTRN     CCL       :NEAR
EXTRN     CPRNTCR   :NEAR
EXTRN     CPRNTCRX  :NEAR
EXTRN     DRVRDEV   :NEAR
EXTRN     ENBLLIST  :NEAR
EXTRN     ENDSTMT   :NEAR
EXTRN     ERRMSG    :NEAR
EXTRN     ERRORP    :NEAR
EXTRN     ERROR_19  :NEAR
EXTRN     ERROR_29  :NEAR
EXTRN     ERROR_34  :NEAR
EXTRN     ERROR_74  :NEAR
EXTRN     FILE_ADR  :NEAR
EXTRN     FINDDEFC  :NEAR
EXTRN     FINDDEFD  :NEAR
EXTRN     FINDST    :NEAR
EXTRN     INTEGER   :NEAR
EXTRN     LDTMSG1   :NEAR
EXTRN     LDTMSG2   :NEAR
EXTRN     LDTMSG3   :NEAR
EXTRN     LDTMSG4   :NEAR
EXTRN     LDTMSG5   :NEAR
EXTRN     LDTMSG6   :NEAR
EXTRN     LDTMSG17  :NEAR
EXTRN     LISTDC    :NEAR
EXTRN     LISTM     :NEAR
EXTRN     LN_RANGE  :NEAR
EXTRN     MVSCRTCH  :NEAR
EXTRN     NEXTVARL  :NEAR
EXTRN     PRNTCR    :NEAR
EXTRN     PRTCTERR  :NEAR
EXTRN     PTERM     :NEAR
EXTRN     PUTLINF   :NEAR
EXTRN     REM       :NEAR
EXTRN     REMCO     :NEAR
EXTRN     RFILE_    :NEAR
EXTRN     SCANCHA   :NEAR
EXTRN     SCNCHSS   :NEAR
EXTRN     SCRATCH   :NEAR
EXTRN     SRCHDEVP  :NEAR
EXTRN     STACK_BUFFER:NEAR
EXTRN     SWITCH    :NEAR
EXTRN     SWITCHA   :NEAR
EXTRN     TABLNAME  :NEAR
EXTRN     TPDEVTBL  :NEAR
EXTRN     TWRIT2SP  :NEAR
EXTRN     TWRIT3SP  :NEAR
EXTRN     TWRIT4SP  :NEAR
EXTRN     TWRIT6SP  :NEAR
EXTRN     TWRITE    :NEAR
EXTRN     TWRITEP   :NEAR
EXTRN     TWRITESP  :NEAR
EXTRN     TWRITNSP  :NEAR
EXTRN     TWRT30SP  :NEAR
EXTRN     TWRITEMN  :NEAR
EXTRN     VARNAME   :NEAR
EXTRN     VJUMP     :NEAR
EXTRN     VVFMTA    :NEAR
EXTRN     WRT@ORSP  :NEAR
EXTRN     WRTBLK    :NEAR
EXTRN     WRTBLKB   :NEAR
EXTRN     WRTDADDR  :NEAR
EXTRN     WRTDADRF  :NEAR
EXTRN     WRTHEXB   :NEAR
EXTRN     WRTLINE_  :NEAR
EXTRN     WRTLIN_4  :NEAR
EXTRN     WRTNIB    :NEAR
EXTRN     WRTSTRCM  :NEAR
EXTRN     WRTVAL    :NEAR
EXTRN     WRTVAL16  :NEAR
EXTRN     WRTVAL8   :NEAR
EXTRN     WRTVNAMF  :NEAR
EXTRN     WRTWORD   :NEAR
EXTRN     WRTWORDF  :NEAR
EXTRN     _ALERT    :NEAR
EXTRN     _DEFFN    :NEAR
EXTRN     _GOSUB    :NEAR
EXTRN     _OFF      :NEAR
EXTRN     _ON       :NEAR
EXTRN     PLAT      :NEAR

EXTRN     CPBASE    :DWORD
EXTRN     PART_     :BYTE

;     ************************************
;     *                                  *
;     *      MODULE    MOD-27 LIST       *
;     *                                  *
;     ************************************


;     LIST: PROCESS A LIST STATEMENT
;
;        STMT FORMAT:
;      LIST         -- LIST ENTIRE PRGM
;      LIST 100     -- LIST SINGLE LINE
;      LIST 100,200 -- LIST 100 THRU 200
;      LIST 100,    -- LIST 100 TO END
;      LIST  ,200   -- LIST 0 TO 200
;           +D PARAMETER - DECOMPRESSED LIST
;
;      LIST # ...   -- LINE # CROSS REF
;      LIST ' [xxx] -- DEFFN' CROSS REF
;      LIST V ...   -- VARIABLE CROSS REF
;      LIST T ...   -- TEXT CROSS REF
;
;      LIST DC ...  -- DISK INDEX LIST
;      LIST DT      -- LIST DEVICE TABLE
;      LIST I       -- LIST INTERRUPT "
;
;         On all the above, the S parameter in immediate
;            mode allows list-in-steps.  The S parameter
;            is ignored except in immediate mode.
;
;         LIST [S] [title]
;            If the 'title' is included, a top-of-forms
;            followed by the title in expanded print and
;            a blank line are printed before the lising.
;
;          ENTRY: TEXTLPTR POINTS TO CURRENT LINE
;                 TEXTPTR POINTS AFTER WORD 'LIST'
;
;          EXITS: 'ENDSTIO', 'ENTER'(FROM LIST S)
;
;          REGISTER USE (PROGRAM LIST):
;               F3,2 = STARTING LIST NO. (DEFAULT = 0)
;               F7,6 = ENDING LIST NO. (DEFAULT = 9999 OR
;                      STARTING NO. IF ONLY 1 SPECIFIED)
;               AUX7,BIT0020 = HALT STATUS AT ENTRY
;
;          NOTE: LIST IS A STATEMENT. IN 2200 LIST WAS A
;                COMMAND (NON-PROGRAMMABLE)
;
;          ???  BEGIN ROUTINE WITH 'SB CPRNTCR' ???
;
;     HALT/STEP:
;          1. TURN OFF LIST S, LIST D, LIST V
;          2. IF HALT AT BEGIN, LIST AND THEN STOP
;          3. IF HALT DURING LIST, ABORT LIST, THEN STOP.
;
;     LISTSOFF: TURN LIST STEP OFF & EXIT TO 'ENDSTMT'


;
;  LIST [S] D :     DECOMPRESSED LISTING
;     When the D parameter is recognized, the LIST D bit
;     (1000 of MODE) is turned on.  Then, while listing,
;     TWRITE will print 4 spaces after each carriage
;     return.  The exception is that when LISTLINE prints
;     the carriage return at the end of each textline,
;     it temporarily saves and restores the LIST D bit,
;     to suppress the extra spaces.
;     In addition, each statement separator will cause
;     (if not already in column 5) a carriage return
;     and the subsequent spaces before printing out the
;     colon.
;
;     The statement number (but not subsequent statement
;     references) will be printed with leading zeroes.
;
;     A REM % will cause an extra 0E to be printed, which
;     will cause the printer to expand the print.
;     A REM % ^ will cause an 0C to be printed, in
;     addition to the expanded print (0E0A0C).
;
;     Any of the following statements will cause an extra
;     CR/LF at the end of the statement:
;     GOTO, RETURN, END, LOAD.
;
;    LISTFLAG usage:
;       20 - halt/step at entry to LIST
;       03 - Immed/prog mode at entry to LIST
;      LIST D:
;       08 - GOTO flag (for skip line)
;      LIST V:
;       40 - pass 2 flag
;       08 - single variable flag
;       04 - specific type flag
;
;    MODE usage:
;       4000 - LIST S flag (used by PRINTCR)
;       1000 - LIST D flag   "       "
;       0800 - LIST V flag (used by ENDSTMT to fix up the
;              phase and stuff, in case of a syntax err)
;              also set by LIST # and LIST '
;              LISTDONE uses this bit to tell that a
;              SWITCH has been done, and must be reversed

LIST:   MOV     K,4                 ;FLAG CURRENT LENGTH
        CALL    AVAR                ;CHECK FOR POSSIBLE ALPHA VARIABLE
        MOV     AL,R0               ;SAVE THE 'FOUND' FLAG
        MOV     R7,AL
        MOV     R0,1                ;FAKE A 'NF' FLAG FOR NXTCHS
        TEST    R7,0FH              ;SKIP CHECKING FOR S IF VARIABLE ALREADY FOUND
        JZ      LISTA
        CMP     BYTE PTR [TEXTPTR],'S'  ;LOOK FOR 'S'
        JNE     LISTA
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR],'E'
        JNE     LISTAA
        DEC     TEXTPTR
        JMP     LISTA
LISTAA: MOV     R0,0
LISTA:  TEST    SL,2                ;BRANCH IF NOT EXECUTION PHASE
        JZ      LIST9
        CALL    ENBLLIST            ;ENABLE LIST DEVICE
        MOV     EDX,COUNTS
        MOV     DL,1                ;LIST LINE COUNT = 1
        MOV     COUNTS,EDX
        AND     MODE,0A7FFH         ;DEFAULT MODE = NORMAL LIST (NO S, D, OR V)

;------------------ LIST S -----------------------------------------------------

;        Turn on LIST S mode if Immediate mode and
;                  (1) S specified
;               or (2) LIST device is the CRT
;
;        Entry:    PC's = MODE aux
;                  F0,bits 0F = 0 iff S specified
;
        TEST    MODE,0002H          ;branch if not Immediate mode
        JZ      LIST94
        TEST    R0,0FH              ;branch if S specified
        JZ      LIST93

        XCHG    EDX,ACTDEV
        MOV     K,DL                ;K = LIST device
        XCHG    EDX,ACTDEV

        MOV     AL,K
        AND     AL,0FH
        CMP     AL,7
        JNE     LIST94
        TEST    K,10H               ;branch if not CRT
        JNZ     LIST94
        TEST    K,20H
        JNZ     LIST94

LIST93: OR      MODE,4000H          ;turn on LIST S mode

LIST94  EQU     $

;-------------------------------------------------------------------------------

LIST91: MOV     AL,SH
        MOV     R1,AL
        AND     R1,20H
        MOV     EDX,MODE
        MOV     R0,DL
        AND     R0,03H
        AND     SH,0EFH-HALT          ;TURN OFF HALT STEP STATUS BIT
        MOV     EDX,DWORD PTR [CPBASE];POINT TO 'LISTFLAG'
        MOV     AL,R0
        OR      AL,R1                 ;SAVE HALT BIT AND PROG/IMMED MODE BITS
        MOV     BYTE PTR [EDX].@LISTFLG,AL

LIST9:  TEST    R7,0FH                ;SKIP IF ALREADY FOUND ALPHA VARIABLE
        JZ      LIST92
        MOV     K,4                   ;FLAG CURRENT LENGTH
        CALL    ALPHA1                ;CHECK FOR LITERAL OR ALPHA-VARIABLE
        TEST    R0,0FH                ;NF, BRANCH
        JNZ     LIST95
LIST92: CMP     BYTE PTR [TEXTPTR],',';LOOK FOR COMMA (OPTIONAL)
        JNE     LISTB
        INC     TEXTPTR
LISTB:  TEST    SL,2                  ;BRANCH IF NOT EXECUTION PHASE
        JZ      LIST95
        CALL    PRNTCR                ;CR
        MOV     K,0CH
        CALL    TWRITE                ;0C
        MOV     K,0EH
        CALL    TWRITE                ;0E
        XOR     EAX,EAX
        MOV     EBX,VSPTR             ;GET LENGTH & ADDRESS OF TITLE
        MOV     AX,WORD PTR [EBX]
        MOV     EDX,DWORD PTR [EBX+2]
        ADD     VSPTR,6
        MOV     DWORD PTR [A2],EDX
        ADD     DWORD PTR [A2],EAX

        CALL    WRTBLKB               ;WRITE MESSAGE
        CALL    PRNTCR                ;CR
        CALL    PRNTCR                ;CR

LIST95: CMP     BYTE PTR [TEXTPTR],'T';LOOK FOR 'T'
        JNZ     LISTC                 ;BR, IF NOT FOUND
        INC     TEXTPTR
        JMP     LISTT

LISTC:  MOV     R0,@DC
        CALL    CCL                   ;LOOK FOR 'DC'
        TEST    R0,0FH
        JZ      LISTDC                ;FOUND, BRANCH TO DISK INDEX LIST ROUTINE

;  CHECK IF WE ARE REALLY WITHIN A LISTV STATEMENT
;
        TEST    SL,2                  ;SKIP IF X PHASE
        JNZ     LIST6
        TEST    MODE,0800H            ;IGNORE REMAINDER OF LIST STATEMENT IN LISTV MODE
        JNZ     REM

LIST6:  MOV     R0,@DIM
        CALL    CCL                   ;look for DIM
        TEST    R0,0FH
        JZ      LISTDIM               ;branch if found
        MOV     R0,@COM
        CALL    CCL                   ;look for COM
        TEST    R0,0FH
        JZ      LISTCOM               ;branch if found
        MOV     R0,@ERROR
        CALL    CCL                   ;look for ERROR
        TEST    R0,0FH                ;branch if not found
        JZ      LISTM
        MOV     R0,@SELECT
        CALL    CCL                   ;look for SELECT
        TEST    R0,0FH                ;branch if not found
        JZ      LISTSLCT
        CMP     BYTE PTR [TEXTPTR],'I';LOOK FOR 'I'
        JNE     LISTD
        INC     TEXTPTR
        JMP     LISTIT                ;FOUND, BRANCH TO 'LIST I'
LISTD:  CMP     BYTE PTR [TEXTPTR],'#';LOOK FOR '#'
        JNE     LISTE
        INC     TEXTPTR
        JMP     LIST_                 ;FOUND, BRANCH TO LINE NO. CROSS REFERENCE LIST
LISTE:  CMP     BYTE PTR [TEXTPTR],27H;LOOK FOR ' (AS IN  DEFFN')
        JNE     LISTF
        INC     TEXTPTR
        JMP     LIST?QU                ;FOUND, BRANCH TO SPECIAL FUNCTION CROSS REF LIST
LISTF:  CMP     BYTE PTR [TEXTPTR],'V' ;LOOK FOR 'V'
        JNE     LISTG
        INC     TEXTPTR
        JMP     LISTV                  ;FOUND, BRANCH TO VARIABLE CROSS REFERENCE LIST
LISTG:  CMP     BYTE PTR [TEXTPTR],'D' ;LOOK FOR 'D'
        JNE     LIST5                  ;NF, BRANCH
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR],'T' ;LOOK FOR 'T'
        JNE     LISTH
        INC     TEXTPTR
        JMP     LISTDVT                ;BRANCH IF 'DT'

;   LIST  'D' PARAMETER FOUND
;

LISTH:  TEST    SL,2                   ;SKIP IF NOT X PHASE
        JZ      LIST5
        OR      MODE,1000H             ;TURN ON 'LIST D' MODE BIT

;================== program list ===============================================

LIST5   EQU     $

;-------------------------------------------------------------------------------

;  If protected program, display message but don't abort list
;

        TEST    SL,2                  ;branch if not execution phase
        JZ      LIST51
        TEST    MODE,0040H            ;branch if not protected
        JZ      LIST51

        AND     MODE,0EFFFH           ;turn off LIST D if it happens to be on
        MOV     R7,6
        CALL    ERRMSG                ;display protected error message

;-------------------------------------------------------------------------------

LIST51: CALL    LN_RANGE              ;GET LINE NUMBER RANGE (F5F4 TO F7F6)
        MOV     AX,WORD PTR [R6]      ;STARTING NO.
        MOV     WORD PTR [R2],AX
        TEST    R0,0FH                ;SKIP IF ONLY A SINGLE NUMBER SPEC
        JNZ     LIST1
        MOV     AX,WORD PTR [R4]      ;ENDING NO.
        MOV     WORD PTR [R6],AX

LIST1:  TEST    SL,2                  ;EXIT IF NOT EXECUTION PHASE
        JZ      LISTDONE
        CALL    FINDST                ;FIND STARTING OR NEXT HIGHER LINE
        TEST    R0,1                  ;NF, EXIT
        JNZ     LISTDONE
        JMP     LIST3
LIST7:  MOV     AUX0F,EDX             ;SAVE PTR TO CURRENT LINE

;------------------------------------------------------------------------------

;  If protected, list only REM! statements.
;

        TEST    MODE,0040H            ;branch if not protected
        JZ      LIST71
        CALL    LISTREM               ;list REM! statements only
        JMP     LIST72

;-------------------------------------------------------------------------------

LIST71: MOV     EDX,AUX0F
        CALL    LISTLINE              ;LIST CURRENT LINE

LIST72: TEST    SH,20H                ;BRANCH IF HALT STATUS BIT ON
        JNZ     LISTDONE
        MOV     EDX,AUX0F
        MOV     ECX,DWORD PTR [EDX]   ;GET THREAD  OF CURRENT LINE
        CMP     ECX,0
        JE      LISTDONE

        MOV     EDX,ECX
        MOV     AUX0F,EDX             ;SAVE ADDRESS OF NEXT LINE
        ADD     AUX0F,4
        XCHG    EDX,AUX0F
        MOV     CX,WORD PTR [EDX]     ;GET LINE NO. OF LINE; PC'S POINT TO LINE
        XCHG    CH,CL
        MOV     EDX,AUX0F
LIST3:  CMP     CX,WORD PTR [R6]      ;BRANCH IF LINE IN LIST RANGE
        JBE     LIST7

; LISTDONE:  THIS CODE IS EXECUTED FOR EACH OF THE
;    FOLLOWING CONDITIONS:
;       1. ENTRY PHASE END OF ANY LIST STATEMENT
;          EXCEPT LISTDCF, LIST T
;       2. RESOLUTION PHASE SAME AS 1.
;       3. EXECUTION PHASE END OF ALL LIST STATEMENTS
;       4. EXECUTION PHASE HALT STEP PRESSED
;       5. LIST V MODE, (IMITATION ENTRY PHASE) WHEN
;          HALT/STEP PRESSED.
;       6. LIST V MODE, (IMITATION ENTRY PHASE) WHEN
;          DONE WITH LIST.

LISTHALT EQU    $                   ;TEMPORARY EQUIVALENT SYMBOL
LISTEND  EQU    $                   ;TEMPORARY EQUIVALENT SYMBOL

LISTDONE:
        TEST    MODE,0800H
        JZ      LIST27
        CALL    SWITCHA             ;SWITCH TEXTPOINTERS BACK IF LIST V,#,'
LIST25: CALL    UNLISTVA            ;SWITCH MODE BACK TO THE WAY IT WAS
        TEST    CH,20H
        JZ      REMCO
        OR      SH,HALT             ;IF HALT WAS ON AT ENTRY, TURN IT BACK ON
        JMP     REMCO               ;X PHASE EXIT
LIST27: TEST    SL,2                ;SKIP IF X PHASE
        JNZ     LIST25
        JMP     ENDSTMT             ;E/R PHASE EXIT POINT

; UNLISTV:  IF LIST V MODE, GO TO UNLISTVA.
; UNLISTVA:  RESTORE MODE REGISTER TO THE WAY IT WAS
;    AT THE BEGINNING OF LIST.
;
;  ENTRY:  MODE, LISTFLAG WERE SET APPROPRIATELY BY THE
;     LIST LOGIC.
;
;  RETURN (UNLISTVA):  CH=LISTFLG
;
;  MODIFIED REGISTERS:  PC'S, SL, CHCL,F0

UNLISTV:TEST    MODE,0800H          ;EXIT IF NOT LIST V MODE
        JZ      UNLISTVR

UNLISTVA:
        OR      SL,XPHASE           ;X PHASE
        MOV     EDX,DWORD PTR [CPBASE]  ;READ 'LISTFLAG'
        MOV     CH,BYTE PTR [EDX].@LISTFLG
        MOV     R0,CH
        AND     R0,03H
        MOV     EDX,MODE
        OR      DL,R0               ;RESTORE PROG/IMMEDIATE MODE
        AND     DH,0A7H             ;TURN OFF LIST S, D, V BITS
        MOV     MODE,EDX

UNLISTVR:
        RET                         ;EXIT

;     LISTLINE: OUTPUT SPECIFIED TEXT LINE TO ENABLED
;               DEVICE. ASSUMES LINE BEGINS WITH A
;               PACKED LINE NO. ATOMIZED TEXT IS OUTPUT
;               IN UNATOMIZED FORM.
;
;          ENTRY: PC'S POINT TO THREAD OF LINE
;                 DEVICE ENABLED.
;
;          MODIFIED REGISTERS: CH,CL,PC'S,AUX0,2,F0-4,K
;
;     LISTLINS: OUTPUT SPECIFIED TEXT LINE STARTING AT
;               THE SPECIFIED STATEMENT TO THE ENABLED
;               DEVICE.  (CALLED BY HALT/STEP LOGIC TO
;               DISPLAY REMAINER OF PROGRAM LINE).
;
;          ENTRY: AUX0 = ADDRESS OF STATEMENT IN THE LINE
;                        TO BE LISTED.
;
;     PRNTLINE: OUTPUT 'CR' & 'SPACE' & SPECIFIED LINE
;               AS IN 'LISTLINE'.  IF IMMEDIATE EXECUTION
;               OR IF A COMMAND (F6 = 1), OR INPUT MODE,
;               ASSUMES THERE IS NO LINE NUMBER.
;
;          RETURN: AUX2 = CHARCNT (CURSOR POSITION) WHEN
;                  LINE HAS BEEN DISPLAYED UP TO THE
;                  CURRENT VALUE OF TEXTPTR. (FOR ERROR)

;     SPECIAL CASES:
;        1. FOREIGN LANGUAGE CHARACTERS (80-F7):
;             IN 'REM' OR '%' STATEMENTS OR IN LITERAL
;             STRINGS OR IN INPUT MODE, CHARACTERS WITH
;             80-BIT ON ARE NOT TEXT ATOMS (PROBABLY,
;             FOREIGN LANGUAGE CHARACTERS). SUCH CHAR'S
;             ARE OUTPUT AS IS (IE, NOT DE-ATOMIZED).
;        2. NONPRINTABLE CHARACTERS (00-0C,0E,0F):
;             DISPLAYED AS DOTS (.)
;        3. CARRAIGE RETURN (0D)):
;             TERMINATES LISTING OF LINE.
;
;
;     REGISTER USE:
;          F4,BIT01 = 1 IFF STMT IS 'REM' OR '%'
;            ,BIT02 = 1 IFF INPUT MODE
;          AUX0 = PTR TO NEXT CHARACTER OF LIST LINE
;
;    RAM USAGE;  LISTFLAG:
;          08 BIT OF LISTFLAG IS SET ON IF ANY OF THE
;          FOLLOWING VERBS IS ENCOUNTERED:
;           GOTO, RETURN, END, LOAD
; PROGRAM LISTING ENHANCEMENT (LIST D):   (MVP REL 1.9)
;  Program lines referenced by other statements within the
;  program in memory are marked when the program is
;  listed.  For example,
;
;      0010 REM
;     -0020 REM This line is referenced by line 30
;      0030 GOTO 20
;
;  At the beginning of LISTLINE references are searched for.
;  Only exlicit line number references are marked; DEFFN's are
;  not.

PRNTLINE:
        CALL    PRNTCR          ;OUTPUT 'CR' IF NOT AT BEGIN OF LINE
        MOV     EDX,TEXTLPTR
        MOV     ECX,DWORD PTR [EDX] ;AUX0 POINT TO LINE# OF LINE
        MOV     AUX00,EDX
        ADD     AUX00,4
        MOV     R4,2
        MOV     K,20H           ;Leading space if Input mode
        TEST    MODE,1000H      ;skip (f4=2) if INPUT mode
        JNZ     LISTLN4
        TEST    CL,3            ;branch if program line (double word thread)
        JZ      LISTLN17

        MOV     AUX02,0         ;default column for ^ is 00
        CMP     ECX,1           ;return (no display) if thread not 0001
        JNE     LISTLNR
        TEST    MODE,0400H      ;return if immed. mode line not valid
        JZ      LISTLNR
        CALL    TWRITESP        ;leading space
        JMP     LISTLINS        ;go display the immediate mode line

LISTLINE:
        MOV     AUX00,EDX       ;AUX0 POINT TO LINE NO. OF LINE
        ADD     AUX00,4

; If line is referenced and LIST D, precede line with '-'
;
        TEST    MODE,1000H          ;branch if not LIST D
        JZ      LISTLN15
        MOV     K,'-'
        MOV     WORD PTR [R2],CX    ;LINE#
        CALL    SWITCH              ;SAVE TEXTPTRS

; Rel 2.1 correction:  TEXTPTR setup before calling NEXTREF
;

        CALL    NEXTREFS            ;start search at begin of text
        JMP     LISTLN14

LISTLN18:
        TEST    BYTE PTR FS:[CPUST],10H
        JZ      LISTLNA
        CALL    BREAKPTT          ;breakpoint if 30ms up (added Rel 1.9)

LISTLNA:
        CALL    NEXTREF           ;FIND REFERENCE TO LINE

LISTLN14:
        MOV     AX,WORD PTR [R0]
        CMP     AX,WORD PTR [R2]
        JB      LISTLN18
        JE      LISTLN19          ;BRANCH IF FOUND
        INC     WORD PTR [R0]
        JNZ     LISTLN18
        MOV     K,' '

LISTLN19:
        CALL    TWRITE            ;PRINT ' ' IF NO REFERENCE, ELSE '-'
        CALL    SWITCH            ;RESTORE TEXTPTRS

; List line number
;

LISTLN15:
        CALL    LISTLN_A          ;GET AND OUTPUT LINE NO.

LISTLN16:
        CALL    TWRITESP          ;OUTPUT A SPACE

; LIST NEXT STATEMENT
;

LISTLINS:
        CALL    GETNLCHS          ;GET NEXT CHARACTER OF LINE TO LIST
        MOV     R4,1              ;FLAG = DON'T PROCESS TEXT ATOMS (REM OR %)
        CMP     CH,@REM           ;BRANCH IF STMT = 'REM'
        JE      LISTLN22
        CMP     CH,@?PE           ;BRANCH IF STMT = '%'
        JE      LISTLN1
        MOV     R4,0              ;FLAG = PROCESS TEXT ATOMS (NOT REM OR %)
        CMP     CH,0A1H           ;A1 = LOAD
        JE      LISTLN40
        CMP     CH,96H            ;96 = END
        JE      LISTLN40
        CMP     CH,9BH            ;9B = RETURN
        JE      LISTLN40
        CMP     CH,9CH            ;9C = GOTO
        JNE     LISTLN5

LISTLN40:
        MOV     EDX,DWORD PTR [CPBASE]      ;GET 'LISTFLAG'
        OR      BYTE PTR [EDX].@LISTFLG,08H ;TURN ON 'GOTO' FLAG (LISTD SKIP LINE)

LISTLN5:TEST    CH,80H            ;BRANCH IF CHARACTER = ATOM
        JNZ     LISTLN2
        test    r4,1
        jnz     listln555

        CMP     CH,0DH            ;BRANCH IF CHARACTER = CR
        JE      LISTLNCR

        cmp     ch,'"'
        je      listlnzzz
        CMP     CH,7FH              ;BRANCH IF CHARCATRE = VARIABLE ATOM
        JE      LISTLNXXX
        CMP     CH,7DH              ;BRANCH IF CHARCATRE = VARIABLE ATOM
        JE      LISTLNXXX
        CMP     CH,7EH              ;BRANCH IF CHARCATRE = CONSTANT
        JE      LISTLNXXY

;     CHARACTER <> ATOM
;

;       cmp     ch,00h
;       jb      yyy
        cmp     ch,0fh
        ja      yyy
        mov     k,ch
        and     k,0fh
        or      k,30h
        mov     al,k
        mov     edx,aux00
        mov     byte ptr [edx-1],al
        jmp     listln4
yyy:
listln555:
        TEST    CH,0F0H           ;BRANCH IF CHARACTER <> 0x
        JNZ     LISTLN4
        CMP     CH,0DH            ;BRANCH IF CHARACTER = CR
        JE      LISTLNCR
        MOV     K,'.'             ;CHARACTERS 00-0C,0E,0F DISPLAY AS '.'

LISTLN4:CALL    TWRITE            ;OUTPUT CHARACTER

LISTLN13:
        CALL    GETNLCHS          ;GET NEXT CHARACTER OF LINE BEING LISTED
        JMP     LISTLN5

listlnzzz:
        call    twrite
        call    getnlchs
        cmp     ch,0dh
        je      listlncr
        cmp     ch,'"'
        jne     listlnzzz
        call    twrite
        call    getnlchs
        jmp     listln5


;  CHARACTER = VARIABLE ATOM
;

LISTLNXXX:
        MOV     EAX,AUX00
        MOV     CH,BYTE PTR [EAX]
        TEST    CH,08H
        JZ      LISTLNXX5
        MOV     K,'@'
        CALL    TWRITE

LISTLNXX5:
        MOV     EAX,AUX00
        MOV     CH,BYTE PTR [EAX+1]
        MOV     K,CH
        CALL    TWRITE
        MOV     EAX,AUX00
        MOV     CH,BYTE PTR [EAX]
        MOV     BL,CH
        AND     BL,0F0H
        CMP     BL,0F0H
        JE      LISTLNXX1
        SHR     BL,4
        ADD     BL,30H
        CMP     BL,3AH
        JB      LISTLNXX4
        ADD     BL,7

LISTLNXX4:
        MOV     K,BL
        CALL    TWRITE
        MOV     EAX,AUX00
        MOV     CH,BYTE PTR [EAX]

LISTLNXX1:
        TEST    CH,1
        JZ      LISTLNXX2
        MOV     K,'$'
        CALL    TWRITE
        MOV     EAX,AUX00
        MOV     CH,BYTE PTR [EAX]

LISTLNXX2:
        CMP     BYTE PTR [EAX-1],7DH
        JE      LISTLNXX3
        TEST    CH,2
        JZ      LISTLNXX3
        MOV     K,'('
        CALL    TWRITE

LISTLNXX3:
        ADD     AUX00,6
        JMP     LISTLN13


;  CHARACTER = CONSTANT
;

LISTLNXXY:
        MOV     ESI,AUX00
        MOV     EDX,AUX00
        CALL    VVFMTA
        MOV     AUX00,ESI
        CALL    MVSCRTCH
        DEC     R0
        CMP     BYTE PTR [EDX],20H
        JNE     LISTLNXXYA
        INC     EDX
        DEC     R0
LISTLNXXYA:
        MOV     EAX,DWORD PTR [CPBASE]
        MOV     DWORD PTR [EAX].@SPREG,EDX

LISTLNXY2:
        MOV     EAX,DWORD PTR [CPBASE]
        MOV     EDX,DWORD PTR [EAX].@SPREG
        MOV     CH,BYTE PTR [EDX]
        MOV     K,CH
        INC     DWORD PTR [EAX].@SPREG
        CALL    TWRITE
        DEC     R0
        JNE     LISTLNXY2
        ADD     AUX00,8
        JMP     LISTLN13


;  REM STATEMENT
;

LISTLN22:
        CALL    WRTWORD           ;OUTPUT 'REM '
        MOV     EAX,AUX00
LISTLN22Y:
        CMP     BYTE PTR [EAX],20H
        JNE     LISTLN22X
        INC     EAX
        JMP     LISTLN22Y
LISTLN22X:
        CMP     BYTE PTR [EAX],'%'
        JNE     LISTLN22Z
        INC     EAX
LISTLN22B:
        CMP     BYTE PTR [EAX],20H
        JNE     LISTLN22A
        INC     EAX
        JMP     LISTLN22B
LISTLN22A:
        CMP     BYTE PTR [EAX],'%'
        JNE     LISTLN22Z
        CALL    GETNLCHS
        CALL    TWRITE
        CALL    GETNLCHS
        CALL    TWRITE
        MOV     R4,0
        JMP     LISTLN13
LISTLN22Z:
        TEST    MODE,1000H        ;SKIP IF NOT LIST D MODE
        JZ      LISTLN13
        CALL    GETNLCHS
        CMP     CH,25H            ;SKIP IF NOT %
        JNE     LISTLN5
        CALL    TWRITE                       ;WRITE THE %
        MOV     EDX,DWORD PTR [CPBASE]       ;GET 'LISTFLG'
        OR      BYTE PTR [EDX].@LISTFLG,08H  ;TURN ON GOTO FLAG
        MOV     EDX,AUX00
LISTLNB:
        MOV     CH,BYTE PTR [EDX]
        INC     EDX
        CMP     CH,20H            ;(SKIP OVER ANY BLANK CHARACTERS)
        JE      LISTLNB
        MOV     K,5EH             ;SNEAK A PEAK AT NEXT NON-BLANK CHARACTER
        CMP     CH,K              ;SKIP IF '^'
        JE      LISTLN24
        CALL    LISTLND           ;CR,CR,0E
        JMP     LISTLN13

; REM % ^
;

LISTLN24:
        CALL    GETNLCH           ;THROW AWAY '^'
        CALL    TWRITE
        CALL    LISTLND           ;CR,CR,0E
        MOV     K,0CH
        CALL    TWRITE            ;TOP-OF-FORMS
        MOV     K,0AH
        JMP     LISTLN4           ;LINE FEED

LISTLND:CALL    LISTLN0D          ;CR
        CALL    LISTLN0D          ;CR
        MOV     EDX,AUX00
        MOV     CH,BYTE PTR [EDX]
        CMP     CH,0DH            ;SUPPRESS THE 0E IF NEXT CHARACTER IS A CR
        JE      LISTLNR
        MOV     K,0EH
        JMP     TWRITE            ;0E

LISTLNCR:
        TEST    MODE,1000H        ;SKIP IF NOT 'LIST D' MODE
        JZ      LISTLN32
        MOV     EDX,DWORD PTR [CPBASE]         ;READ LISTFLAG
        MOV     CH,BYTE PTR [EDX].@LISTFLG
        MOV     AL,CH
        AND     AL,0F7H
        MOV     BYTE PTR [EDX].@LISTFLG,AL     ;TURN OFF 'GOTO' FLAG
        TEST    CH,08H            ;SKIP IF OFF
        JZ      LISTLN0D
        CALL    LISTLN0D          ;ISSUE AN EXTRA CR IF THE 'GOTO' FLAG IS ON

LISTLN0D:
        AND     MODE,0EFFFH       ;TURN OFF 'LIST D' MODE
        CALL    PRNTCR            ;PRINT CARRIAGE RETURN
        OR      MODE,1000H        ;TURN 'LIST D' MODE BACK ON

LISTLNR:RET                       ;EXIT

LISTLN32:
        JMP     CPRNTCRX          ;OUTPUT 'CR' IF NOT AT BEGIN OF LINE, EXI

;    CHARACTER = ATOM (80-BIT ON)
;

LISTLN2:TEST    R4,2                ;BRANCH IF INPUT MODE
        JNZ     LISTLN4
        TEST    R4,1                ;BRANCH IF STMT <> REM OR %
        JZ      LISTLN6

;     STMT = REM OR % (IGNORE TEXT ATOMS)
;
        CMP     CH,@STMTSEP          ;BRANCH IF CHARACTER <> STMT SEPARATR
        JNE     LISTLN4

;   STATEMENT SEPARATOR -
;

LISTLN8:TEST    MODE,1000H          ;SKIP IF NOT LIST D MODE
        JZ      LISTLN82
        TEST    SH,20H              ;BRANCH IF HALT/STEP ON
        JNZ     LISTHALT
        CALL    LISTLN0D            ;OUTPUT CR
        CALL    TWRIT4SP            ;OUTPUT 4 SPACES
        MOV     EDX,DWORD PTR [CPBASE] ;GET 'LISTFLAG'
        MOV     CH,BYTE PTR [EDX].@LISTFLG
        MOV     AL,CH
        AND     AL,0F7H
        MOV     BYTE PTR [EDX].@LISTFLG,AL
        TEST    CH,8
        JZ      LISTLN82
        CALL    LISTLN0D            ;OUTPUT CR
        CALL    TWRIT4SP            ;OUTPUT 4 SPACES

LISTLN82:
        MOV     K,':'
        CALL    TWRITE              ;OUTPUT ':'
        JMP     LISTLN16            ;BRANCH TO PROCESS NEXT STATEMENT

;     STMT <> REM OR % (PROCESS TEXT ATOMS)
;

LISTLN6:CMP     CH,@STMTSEP
        JE      LISTLN8             ;BR, IF STMT SEPARATOR
        CMP     CH,@LINE_
        JE      LISTLNC             ;BR, IF LINE #
        CMP     CH,@LTRL
        JE      LISTLNE             ;BR, IF LITERAL
        CMP     CH,@HEXLIT
        JE      LISTLNF             ;BR, IF HEX LITERAL
        CMP     CH,7FH              ;BRANCH IF CHARCATRE = VARIABLE ATOM
        JE      LISTLNXXX
        CMP     CH,7DH              ;BRANCH IF CHARCATRE = VARIABLE ATOM
        JE      LISTLNXXX
        CMP     CH,7EH              ;BRANCH IF CHARCATRE = CONSTANT
        JE      LISTLNXXY

;     CHARACTER = TEXT ATOM
;

LISTLN1:CALL    WRTWORD             ;OUTPUT TEXT WORD
        JMP     LISTLN13

;     CHARACTER = LINE# ATOM
;

LISTLNC:
        CALL    LISTLN_             ;GET & OUTPUT LINE# REFERENCE
        ADD     AUX00,4
        JMP     LISTLN13

;     CHARACTER = LITERAL ATOM
;

LISTLNE:
        MOV     K,'"'
        CALL    TWRITE              ;OUTPUT QUOTE
        CALL    GETNLCH             ;GET LENGTH OF LITERAL
        MOV     R3,CH               ;F3 = LENGTH OF LITERAL

LISTLN10:
        CALL    GETNLCH             ;GET NEXT CHARACTER OF LITERAL
        CALL    TWRITEP             ;OUTPUT CHARACTER
        DEC     R3                  ;DECREMENT COUNT
        CMP     R3,0                ;BRANCH IF MORE TO LITERAL
        JNE     LISTLN10
        MOV     K,'"'
        JMP     LISTLN4             ;NEXT CHARACTER TO OUTPUT = QUOTE

;     CHARACTER = HEX LITERAL ATOM
;

LISTLNF:
        CALL    WRTWORD             ;OUTPUT 'HEX('
        CALL    GETNLCH             ;GET LENGTH OF LITERAL
        MOV     R3,CH               ;F3 = LENGTH OF LITERAL
        JMP     LISTLN26

LISTLN25:
        CALL    TWRITESP            ;output a space

LISTLN26:
        CALL    GETNLCH             ;get next byte of hex literal
        MOV     R0,CH
        CALL    WRTHEXB             ;output byte as 2 hex digits
        DEC     R3                  ;decrement byte count
        JNZ     LISTLN25            ;branch if more to literal
        MOV     K,')'               ;next character to output = ')'
        JMP     LISTLN4

;     GETNLCH: GET NEXT CHARACTER OF LINE BEING LISTED &
;              SAVE CHARCNT OF ERROR POSTION (AUX2 = AUX0
;              IFF TEXTPTR >= CURRENT LIST POSTION,AUX0)
;
;          ENTRY: TEXTPTR = POSITION OF ERROR (IF THERE
;                           WAS ONE)
;                 AUX0 = ADDRESS OF NEXT CHARACTER IN LIN
;
;          RETURN: K,CH = NEXT CHARACTER OF LINE
;                  AUX0 = ADDRESS OF CHARACTER +1
;                  F1,0 = TEXTPTR
;                  AUX2 = AUX0 IFF TEXTPTR >= AUX0
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,AUX0,2
;

GETNLCH:MOV     EDX,TEXTPTR
        MOV     DWORD PTR [A0],EDX
        MOV     EDX,AUX00
        MOV     CH,BYTE PTR [EDX]
        MOV     AUX00,EDX           ;GET NEXT CHARACTER OF LINE
        INC     AUX00
        CMP     DWORD PTR [A0],EDX  ;BRANCH IF TEXTPTR < CURRENT LIST POSTION
        JB      GETNLCHA
        MOV     EDX,CHARCNT
        MOV     AUX02,EDX           ;SAVE CHARCNT OF ERROR POSTION

GETNLCHA:
        MOV     K,CH                ;K = NEXT CHARACTER OF LINE
        RET


;     GETNLCHS: GET NEXT NONBLANK CHARACTER OF LINE
;               BEING LISTED & SAVE CHARCNT OF ERROR
;               POSITION (AUX2 = AUX0) IFF TEXTPTR
;               >= CURRENT LIST POSTION,AUX0.
;               IF A SPACE IF FOUND, A SPACE CHARACTER
;               IS OUTPUT & THE NEXT CHARACTER IS GOTTEN.
;

GETNLCH1:
        CALL    TWRITE           ;OUTPUT SPACE CHARACTER

GETNLCHS:
        CALL    GETNLCH          ;GET NEXT CHARACTER FROM LIST LINE
        CMP     CH,20H           ;BRANCH IF CHARACTER = 'SPACE'
        JE      GETNLCH1
        RET

;     LISTLN#: GET LINE NO. (PACKED DECIMAL) FROM LINE
;              BEING LISTED & OUTPUT IT.
;
;          ENTRY: TEXTPTR = POSTION OF ERROR IF THERE WAS
;                           ONE
;                 AUX0 = ADDRESS OF NEXT CHARACTER IN LIN
;
;          RETURN: F3,2 = LINE NUMBER
;                  AUX0 POINTS AFTER LINE NUMBER
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3,K,AUX0,2
;

LISTLN_:CALL    GETNLCH           ;GET 1ST 2 DIGITS OF LINE NO.
        MOV     R3,CH
        CALL    GETNLCH           ;GET 2ND 2 DIGITS OF LINE NO.
        MOV     R2,CH
        JMP     WRTLINE_          ;OUTPUT LINE NUMBER

LISTLN_A:
        TEST    MODE,1000H        ;NO LEADING ZEROES IF NOT LIST D MODE
        JZ      LISTLN_

LISTLN_B:
        CALL    GETNLCH           ;GET 1ST 2 DIGITS OF LINE NO.
        MOV     R3,CH
        CALL    GETNLCH           ;GET 2ND 2 DIGITS OF LINE NO.
        MOV     R2,CH
        JMP     WRTLIN_4          ;OUTPUT LINE NUMBER WITH LEADING ZEROES

;     LISTLINE CONTINUED
;

LISTLN17:
        CALL    WRT@ORSP          ;OUTPUT '@' IF GLOBAL TEXT, ELSE 'SPACE'
        AND     MODE,0DFFFH       ;INPUT MODE OFF
        TEST    MODE,0040H        ;BRANCH IF PROGRAM NOT PROTECTED
        JZ      LISTLN15
        JMP     ERRLIST           ;PROTECT LIST (DON'T DISPLAY STMT TEXT)

;  LISTREM :  list REM  statements on the specified line
;
;        Only the remarks are listed.  Each REM! remark is listed on a separate
;        line.  The word REM! is not listed.
;
;        Entry:    AUXF points at the thread of the line to be listed
;                  LIST device enabled
;
;        Modified registers:  PHPL,CHCL,K,F0-1,AUX0
;

LISTREM:

;------------------ skip past line number --------------------------------------

        MOV     EDX,AUX0F
        MOV     AUX00,EDX
        ADD     AUX00,4
        MOV     EDX,AUX00
        XCHG    EDX,TEXTPTR           ;TEXTPTR points after line number
        ADD     TEXTPTR,2
        MOV     AUX00,EDX             ;save old TEXTPTR

;------------------ look for REM! ----------------------------------------------

LISTRM3:
        CMP     BYTE PTR [TEXTPTR],@REM
        JNE     LISTRM1                ;branch if verb <> REM
        INC     TEXTPTR
LISTRML:CMP     BYTE PTR [TEXTPTR],20H
        JNE     LISTRMK
        INC     TEXTPTR
        JMP     LISTRML
LISTRMK:CMP     BYTE PTR [TEXTPTR],'!'
        JNE     LISTRM1                ;branch if not next char '!'
        INC     TEXTPTR

;------------------ list REM! remark -------------------------------------------

LISTRM5:
        MOV     EDX,TEXTPTR
        MOV     CH,BYTE PTR [EDX]
        MOV     TEXTPTR,EDX          ;get next char of REM
        INC     TEXTPTR
        CMP     CH,0DH               ;branch if not CR
        JNE     LISTRM6
        CALL    LPRNTCR              ;output CR
        JMP     LISTRM4

LISTRM6:
        CMP     CH,@STMTSEP          ;branch if not statement separator
        JNE     LISTRM2
        CALL    LPRNTCR              ;output CR
        JMP     LISTRM3

LISTRM2:
        MOV     K,CH
        CALL    TWRITE               ;output character
        JMP     LISTRM5

;------------------ get to next statement on line ------------------------------

LISTRM1:
        CALL    SCNCHSS              ;scan for statement separator
        TEST    R0,0FH               ;branch if found
        JZ      LISTRM3

;------------------ end of program line ----------------------------------------

LISTRM4:
        MOV     EDX,AUX00
        MOV     TEXTPTR,EDX           ;restore TEXTPTR
        RET


;ERRLIST: LINE DISPLAY FOR ERRORS IN PROTECTED PROGRAMS.
;         THE LINE# AND STATEMENT SEPARATORS ARE DISPLAYED,
;         BUT STATEMENT TEXT IS SUPRESSED.
;
;          E.G,   100:::::
;
;     ENTRY: TEXTPTR POINTS TO ERROR POSITION IN LINE.
;            TEXTLPTR POINTS TO BEGIN OF LINE.
;
;     EXIT: BRANCH BACK TO 'ERROR' ROUTINE (ERRORP).
;

ERRLIST:
        CALL    LISTLN_A               ;DISPLAY LINE#
        MOV     EDX,TEXTPTR
        MOV     DWORD PTR [A2],EDX     ;SAVE TEXTPTR
        MOV     EDX,TEXTLPTR
        INC     EDX
        MOV     TEXTPTR,EDX            ;POINT TO BEGIN OF LINE
        ADD     TEXTPTR,5

ERRLIST1:
        CALL    SCNCHSS                ;SCAN TO NEXT STATEMENT
        TEST    R0,0FH                 ;NF, BRANCH
        JNZ     ERRLIST2
        MOV     EDX,TEXTPTR
        CMP     DWORD PTR [A2],EDX     ;BRANCH IF BEYOND ERROR POINT
        JB      ERRLIST2
        MOV     K,':'
        CALL    TWRITE                 ;DISPLAY COLON
        JMP     ERRLIST1

ERRLIST2:
        CALL    TWRITESP               ;DISPLAY SPACE
        MOV     EDX,DWORD PTR [A2]
        MOV     TEXTPTR,EDX            ;RESTORE TEXTPTR
        JMP     ERRORP


;LIST#:  LIST LINE NUMBER CROSS REFERENCES
;
;   STATEMENT SYNTAX
;      LIST [S][title] #  [ line number range ]
;
;   examples:    LIST #         -  0 TO 9999
;                LIST # 10      -  10 ONLY
;                LIST # 10,     -  10 TO 9999
;                LIST # ,200    -  0 TO 200
;                LIST # 10,200  - 10 TO 200
;

LIST_:  CALL    PRTCTERR            ;ERROR IF PROGRAM PROTECTED
        CALL    LN_RANGE
        TEST    SL,2                ;EXIT IF NOT X PHASE
        JZ      LISTITE
        MOV     AX,WORD PTR [R6]    ;F3F2 = STARTING LINE NUMBER
        MOV     WORD PTR [R2],AX
        MOV     DX,WORD PTR [R6]
        TEST    R0,0FH
        JNZ     LIST_A
        MOV     DX,WORD PTR [R4]    ;PHPL = ENDING LINE NUMBER

LIST_A: MOV     AUX03,EDX           ;AUX 3 = ENDING LINE NUMBER
        INC     AUX03
        CALL    SWITCHA             ;SAVE TEXT POINTERS DURING LIST
        OR      MODE,0800H          ;FLAG THAT THE SWITCH WAS DONE
        JMP     LIST_07

LIST_05:MOV     AX,WORD PTR [R6]    ;INCREMENT THE LINE NUMBER
        MOV     WORD PTR [R2],AX
        INC     WORD PTR [R2]
        CALL    LPRNTCR             ;PRINT A CR  BEFORE FINDING THE NEXT REFERENCES,

;  EXIT IF HALT KEY IS PRESSED
;

LIST_07:MOV     EDX,AUX03
        MOV     WORD PTR [R6],DX    ;F7F6 = UPPER LIMIT
        CALL    NEXTREFS            ;START AT BEGIN OF TEXT
        JMP     LIST_10

LIST_08:MOV     AX,WORD PTR [R0]
        MOV     WORD PTR [R6],AX
        MOV     EDX,TEXTLPTR
        MOV     AUX02,EDX           ;SAVE TEXT LINE POINTER TO THIS REFERENCE

LIST_09:CALL    NEXTREF             ;GET NEXT REFERENCE

LIST_10:MOV     AX,WORD PTR [R0]      ;SKIP IF END OF TEXT
        MOV     CH,AH
        AND     CH,0F0H
        CMP     CH,0F0H
        JE      LIST_11
        CMP     AX,WORD PTR [R2]
        JB      LIST_09
        CMP     WORD PTR [R6],AX      ;LOOP IF NOT WITHIN RANGE
        JBE     LIST_09
        JMP     LIST_08

LIST_11:MOV     EDX,AUX03
        CMP     WORD PTR [R6],DX      ;EXIT IF BEYOND SPECIFIED RANGE OF NUMBERS
        JE      LISTITE

; (OR IF END OF TEXT)
;
        MOV     AX,WORD PTR [R6]
        MOV     WORD PTR [R2],AX
        CALL    FINDST                ;FIND THE SPECIFIED STATEMENT (IF DEFINED)
        CMP     R0,0                  ;SKIP IF FOUND
        JE      LIST_12

;   REFERENCE TO AN UNDEFINED LINE NUMBER
;
        MOV     K,'('
        CALL    TWRITE
        CALL    WRTLIN_4            ;WRITE LINE NUMBER (W/ LEADING ZEROES)
        MOV     K,')'
        CALL    TWRITE              ;ENCLOSE LINE NUMBER IN PARENTHESES
        CALL    TWRITESP            ;WRITE ONE TRAILING SPACE
        JMP     LIST_15

LIST_12:CALL    PRNTREF5            ;WRITE LINE NUMBER (W/ LEADING ZEROES)
        CALL    TWRIT2SP

LIST_15:CALL    PRNTDASH            ;PRINT A DASH
        MOV     EDX,AUX02
        CALL    TXTSETB             ;SET UP TEXTPOINTERS TO THE LINE
        MOV     AX,WORD PTR [R2]    ;F7F6 = LINE NUMBER TO CHECK FOR
        MOV     WORD PTR [R6],AX

LIST_20:CALL    NEXTREF             ;FIND NEXT REFERENCE

LIST_21:MOV     AX,WORD PTR [R0]      ;LOOP BACK IF END OF TEXT
        MOV     CH,AH
        AND     CH,0F0H
        CMP     CH,0F0H
        JE      LIST_05
        CMP     AX,WORD PTR [R6]
        JNE     LIST_20

;  THIS LINE HAS A MATCHED REFERENCE
;
        CALL    GETLINE_           ;GET THE LINE NUMBER
        CALL    PRNTREFC           ;PRINT A SPACE, FOLLOWED BY THE REFERENCE
        CALL    NEXTREFA           ;THREAD TO NEXT LINE (IGNORE MULTIPLE REFS)
        JMP     LIST_21


;     LISTIT: LIST THE INTERRUPT TABLE
;
;          FORMAT:  LIST I
;
;          ENTRY: TEXTPTR POINTS AFTER 'LIST IT'
;
;          MODIFIED REGISTERS:
;

LISTIT:
        TEST    SL,2                  ;BRANCH IF NOT EXECUTION PHASE
        JZ      LISTITE
        CALL    LPRNTCR               ;OUTPUT CR
        MOV     EDX,DWORD PTR [CPBASE];GET INTERRUPT STATUS
        MOV     CH,BYTE PTR [EDX].@ISTATUS
        MOV     R7,CH                 ;F7 = INTERRUPT STATUS
        MOV     EDX,OFFSET _ON+4      ;'ON' IF NOT GENERAL INHIBIT
        MOV     CH,BYTE PTR [EDX]
        TEST    R7,4
        JZ      LISTITA
        MOV     EDX,OFFSET _OFF+4     ;'OFF' IF GENERAL INHIBIT
        MOV     CH,BYTE PTR [EDX]

LISTITA:
        CALL    WRTWORD               ;OUTPUT 'ON' OR 'OFF'
        CALL    LPRNTCR               ;OUTPUT CR
        TEST    R7,2                  ;BRANCH IF NOT IN INTERRUPT SUBROUTINE
        JZ      LISTIT2
        MOV     EDX,OFFSET _GOSUB+7
        MOV     CH,BYTE PTR [EDX]
        CALL    WRTWORD               ;OUTPUT 'GOSUB'
        CALL    LPRNTCR               ;OUTPUT CR

LISTIT2:
        CALL    LPRNTCR               ;OUTPUT CR
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@ITABLE

LISTIT3:
        MOV     AUX03,EDX             ;GET 1ST 2 BYTES OF NEXT ITABLE ENTRY
        ADD     AUX03,2
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        TEST    CH,0FH                ;BRANCH IF NOT DEFINED
        JZ      LISTITE
        MOV     WORD PTR [R6],CX      ;SAVE BYTES
        MOV     EDX,OFFSET _ON+4      ;'ON' IF ENABLED
        MOV     CH,BYTE PTR [EDX]
        TEST    R7,2
        JNZ     LISTITB
        MOV     EDX,OFFSET _OFF+4     ;'OFF' IF DISABLED
        MOV     CH,BYTE PTR [EDX]

LISTITB:
        CALL    WRTWORD               ;OUTPUT 'ON' OR 'OFF'
        CALL    TWRITESP              ;OUTPUT SPACE
        CMP     R6,0                  ;Branch if not ALERT interrupt
        JNE     LISTIT4
        MOV     EDX,OFFSET _ALERT     ;Point at ALERT unatomized word
        MOV     CH,BYTE PTR [EDX]
        MOV     R0,CH                 ;Count
        INC     EDX
        CALL    WRTBLK                ;output ALERT
        JMP     LISTIT5

LISTIT4:
        MOV     AL,R6                 ;K = HIGH DIGIT OF ADDRESS
        SHR     AL,4
        ADD     AL,30H
        CMP     AL,3AH
        JB      LISTITXX1
        ADD     AL,7

LISTITXX1:
        MOV     K,AL
        CALL    TWRITE                ;OUTPUT HEX CHARACTER

        MOV     AL,R6                 ;K = LOW DIGIT OF ADDRESS
        AND     AL,0FH
        ADD     AL,30H
        CMP     AL,3AH
        JB      LISTITXX2
        ADD     AL,7

LISTITXX2:
        MOV     K,AL
        CALL    TWRITE                ;OUTPUT HEX CHARACTER

LISTIT5:
        CALL    TWRITESP            ;OUTPUT SPACE
        MOV     EDX,OFFSET _GOSUB+7
        MOV     CH,BYTE PTR [EDX]
        CALL    WRTWORD             ;OUTPUT 'GOSUB'
        MOV     EDX,AUX03
;       MOV     AUX03,EDX           ;GET TRANSFER ADDRESS
        ADD     AUX03,4
        MOV     EDX,DWORD PTR [EDX]
        ADD     EDX,4
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     EDX,AUX03           ;GET LINE-NUMBER TO TRANSFER TO
        MOV     WORD PTR [R2],CX    ;F3,2 = LINE-NUMBER
        CALL    LNCR                ;OUTPUT LINE NUMBER, CR
        MOV     EAX,DWORD PTR [CPBASE]
        LEA     EAX,[EAX].@ITABLE
        ADD     EAX,96
        CMP     EDX,EAX             ;BRANCH IF MORE TO ITABLE
        JB      LISTIT3

LISTITE:
        JMP     LISTDONE            ;EXIT


;  NEXTGO' - FIND NEXT GOSUB' IN TEXT
;  NEXTGO'A - THREAD TO NEW LINE, AND FIND NEXT GOSUB' IN
;                TEXT.
;
;  ENTRY:  TEXTLPTR POINTS AT CURRENT LINE.  TEXTPTR
;      INDICATES WHERE TO START FOR NEXTGO', DOESN'T
;      MATTER FOR NEXTGO'A.
;
;  RETURN:  TEXTLPTR AND TEXTPTR POINT AFTER NEXT GOSUB'.
;     F0 CONTAINS THE FLAG:
;           00 - FOUND
;           01 - END OF TEXT

NEXTGO?QUA:
          MOV       EDX,TEXTLPTR
          MOV       ECX,DWORD PTR [EDX]
          CMP       ECX,0
          JNE       NEXTGO?QU2
          MOV       R0,01       ;FLAG END OF TEXT
          RET                   ;RETURN

NEXTGO?QU2:
          CALL      TXTSETA     ;SET UP TEXTPTR AND TEXTLPTR TO NEXT LINE

NEXTGO?QU:
          MOV       R0,@GOSUB
          CMP       BYTE PTR [TEXTPTR],@?pe
          JE        NEXTGO?QUA  ;IF AN IMAGE STATEMENT, THREAD TO NEXT

NEXTGO?QU4:
          CALL      SCANCHA     ;LOOK FOR GOSUB ATOM (NOT IN REM)
          TEST      R0,2        ;LOOP IF STATEMENT SEPARATOR
          JNZ       NEXTGO?QU
          TEST      R0,1        ;THREAD TO NEXT STATEMENT IF CR
          JNZ       NEXTGO?QUA

;    FOUND A GOSUB ATOM
;
          CMP       BYTE PTR [TEXTPTR],27H ;CHECK FOR A PRIME
          JNE       NEXTGO?QU
          INC       TEXTPTR
          MOV       R0,0
          RET                   ;F, RETURN WITH F0=00


;  PRNTDEF:  PRINT DEFINING LINE FOR A DEFFN' STATEMENT
;
;   ENTRY:  F3F2 = THE LINE NUMBER.  F7 = THE DEFFN' NO.
;
;   RETURN:  THE SPECIFIED LINE IS PRINTED, WITH CR.
;       THE 02 BIT OF F5 IS TURNED ON.
;
;   MODIFIED REGISTERS:  PC'S, CHCL, F0-F6, K

PRNTDEF:  CALL      WRTLIN_4    ;PRINT THE LINE NUMBER
          CALL      TWRITESP    ;PRINT A SPACE
          MOV       EDX,OFFSET _DEFFN+6
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTWORD     ;PRINT THE WORD 'DEFFN'
          MOV       K,27H
          CALL      TWRITE      ;PRINT A PRIME
          CALL      TWRITESP    ;PRINT A SPACE
          MOV       R1,0
          MOV       AL,R7
          MOV       R0,AL
          MOV       AL,R5
          MOV       R6,AL       ;SAVE FLAG (SO BINDEC DOESN'T CLOBBER IT)
          CALL      BINDEC
          MOV       AL,R6
          OR        AL,02
          MOV       R5,AL       ;FLAG THAT A DEFFN' WAS FOUND
LNCR:     CALL      WRTLINE_    ;PRINT THE DEFFN' NUMBER
LPRNTCR:  CALL      PRNTCR      ;PRINT CARRIAGE RETURN
          TEST      SH,20H      ;RETURN IF NO HALT/STEP
          JZ        NEXTREFR
LIST_91:  JMP       LISTDONE    ;HALT THE LISTING IF HALT STEP WAS PRESSED

;   NEXTREFS: FIND FIRST LINE NUMBER REFERENCE IN TEXT.
;   NEXTREFA: THREAD TO NEXT LINE, THEN GOTO NEXT REF
;   NEXTREF:  FIND NEXT LINE NUMBER REFERENCE IN TEXT.
;      ENTRY:  TEXTPTR AND TEXTLPTR POINT AT SOME TEXT
;         LINE.
;      RETURN:  F1F0 = FIRST LINE NUMBER REFERENCE AFTER
;         SPECIFIED POINT.  TEXTPTR AND TEXTLPTR ARE
;         POINTING TO THE REFERENCE.
;         IF END OF TEXT, F1F0 = FFFF.
;
;      MODIFIED REGISTERS:  F1F0, PC'S, CHCL

NEXTREFS: MOV       EDX,DWORD PTR [CPBASE]  ;SETUP BEGINNING OF TEXT POINTER
          LEA       EDX,[EDX].@TEXTBEG
          MOV       TEXTLPTR,EDX
NEXTREFA: MOV       EDX,TEXTLPTR
          MOV       ECX,DWORD PTR [EDX]
          CMP       ECX,0
          JNE       NEXTREF2
          MOV       WORD PTR [R0],0FFFFH     ;F1F0 = FFFF (END OF TEXT FLAG)
          RET                   ;EXIT IF END OF TEXT

NEXTREF2: CALL      TXTSETA     ;SET UP TEXT POINTERS TO NEXT LINE
NEXTREF:  MOV       R0,@LINE_
          CALL      SCANCHA     ;LOOK FOR STMT #
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,2        ;LOOP IF STMT SEP FOUND
          JE        NEXTREF
          CMP       AL,1        ;LOOP IF CR  FOUND (NEW LINE)
          JE        NEXTREFA
          MOV       EDX,TEXTPTR
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       WORD PTR [R0],CX   ;F1F0= LINE # REFERENCE
          ADD       TEXTPTR,6
NEXTREFR: RET

;   There are 3 entry points involved with the listing
;     of variables.
;
;   The first, LISTV, is branched to from the LIST logic
;      when the V is recognized.  This routine must do the
;      statement syntax checking, and set up the necessary
;      pointers, including the LISTV MODE bit, before
;      branching to VJUMP (entry phase)..
;
;   Next, for each reference to a variable in a text line,
;      if the LISTV bit is on, a branch will be made to
;      LISTVAR.  This logic will decide whether any
;      printing is to be done, and either return or set up
;      pointers to a different line.
;
;   Finally, at the end of each statement, a branch is
;      made to LSTVENDL, which must thread to a new state-
;      ment, and go back to VJUMP, if more scanning is to
;      be done.
;
;
;   REGISTER USAGE - GLOBAL:
;     AUXES 9,A,B - USED BY SWITCH FOR LISTV TEXTPOINTERS
;         AUX C - PASS 1 FOUND VARIABLE NAME
;         AUX D - FIRST VARIABLE NAME TO SEARCH FOR
;         AUX E - LAST NAME +1 (OR +10) TO SEARCH FOR
;       LISTFLG - FLAGS AND MODE STORAGE
;             08 - SINGLE VARIABLE CROSSREF ONLY
;             04 - SPECIFIC TYPE VARIABLE
;             40 - PASS 2 FLAG
;             20 - HALT STEP FLAG AT ENTRY TO LIST
;             03 - IMMED/PROG  MODE BITS, TO BE
;                    RESTORED AFTER LISTING

;     LISTV:
;     ENTRY:  TEXTPOINTER POINTS AFTER THE V.
;     EXIT:  ENDSTMT IN E/R PHASE, ENDSTMTIO IN X PHASE
;     GLOBAL REGISTER USAGE:  ENTRY PHASE OF OTHER STMTS
;        MUST NOT USE THE FOLLOWING AUXES:
;              AUX  9,A,B,C,D,E
;

LISTV:    CALL      PRTCTERR    ;ERROR IF PROGRAM PROTECTED
          MOV       WORD PTR [R6],0  ;DEFAULT FIRST VARIABLE = 0000
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       CH,BYTE PTR [EDX].@LISTFLG
          MOV       R5,CH       ;F5 = FLAG
          CALL      VARNAME     ;LOOK FOR OPTIONAL FIRST VARIABLE
          TEST      R0,0FH      ;NF, SKIP
          JNZ       LISTV05
          OR        R5,0CH      ;FLAG SINGLE VAR, SPECIFIC TYPE
          ADD       R2,10H
          MOV       AX,WORD PTR [R2]
          MOV       WORD PTR [R6],AX   ;F7F6 = FIRST VARIABLE

LISTV05:  CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       LISTV15     ;SKIP IF NF
          INC       TEXTPTR
          AND       R5,0F7H     ;MULTIVARIABLE FLAG
          OR        R5,04H      ;SPECIFIC TYPE FLAG
          CALL      VARNAME     ;LOOK FOR 2ND VARIABLE
          TEST      R0,0FH      ;SKIP IF NF
          JNZ       LISTV15
          CMP       R7,0        ;SKIP IF FIRST VARIABLE WAS FOUND
          JNZ       LISTV10
          MOV       AL,R2
          AND       AL,0FH
          MOV       R6,AL       ;MAKE THE TYPES SEEM TO MATCH
LISTV10:  ADD       R2,10H
          MOV       AL,R2
          XOR       AL,R6
          MOV       R0,AL
          TEST      R0,0FH      ;SKIP IF TYPES MATCH
          JE        LISTV18
          JMP       ERROR_74    ;IMPROPER VARIABLE TYPE

;   2ND VARIABLE NOT FOUND
;

QLISTV90: JMP       LISTV90
LISTV15:  MOV       R3,5EH
          MOV       AH,R3
          MOV       AL,R6
          SHL       AH,4
          AND       AL,0FH
          OR        AH,AL
          MOV       R2,AL       ;DUMMY UP THE 2ND VARIABLE
LISTV18:  TEST      R5,8        ;SKIP IF MULTIVARIABLE WANTED
          JZ        LISTV19
          MOV       AX,WORD PTR [R6]
          MOV       WORD PTR [R2],AX   ;F3F2 END OF RANGE = BEGIN
LISTV19:  TEST      SL,2        ;EXIT IF NOT X PHASE
          JZ        QLISTV90
          MOV       DX,WORD PTR [R6]
          MOV       AUX0D,EDX   ;FIRST NAME TO LOOK FOR
          MOV       DL,R2
          ADD       DL,10H
          MOV       DH,R3       ;INCREMENT BY 10 FOR SPECIFIC TYPE
          TEST      R5,4
          JNZ       LISTV16
          MOV       DL,R2
          INC       DL          ;INCREMENT BY 1 FOR TOTAL LIST V
          TEST      DL,4
          JZ        LISTV16
          ADD       DL,0CH
LISTV16:  MOV       AUX0E,EDX   ;LAST NAME+1(OR +10) TO LOOK FOR
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@LISTFLG
          MOV       AL,R5
          MOV       BYTE PTR [EDX],AL    ;SAVE LISTFLAG
          CALL      SWITCHA     ;SAVE TEXT POINTERS
          OR        MODE,0800H  ;TURN ON LIST V MODE
          AND       MODE,0FFFCH ;TURN OFF IMMEDIATE MODE BITS, RESTORE LATER
          AND       SL,EPHASE   ;PHASE = PSEUDO ENTRY

;    PASS 1 PROCESSING
;

LISTV20:  MOV       EDX,AUX0E
          MOV       AUX0C,EDX   ;INITIALIZE AUX C TO LAST+1 TO LOOK FOR
LISTV25:  MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TEXTBEG
          MOV       TEXTLPTR,EDX   ;POINT AT BEGINNING OF TEXT

;    ENTRY FROM ENDSTMT
;

;   LSTVENDL:  TEXTPTR AND TEXTLPTR POINT AT A LINE WHICH
;      HAS BEEN COMPLETELY SCANNED.  PHASE = PSEUDO ENTRY,
;      LISTV BIT IS ON.  THIS IS ESSENTIALLY ONE OF THE
;      RETURN POINTS FROM VJUMP.

LSTVENDL: MOV       ESP,OFFSET STACK_BUFFER
          MOV       EDX,TEXTLPTR
          MOV       ECX,DWORD PTR [EDX]
          CMP       ECX,0                         ;SKIP IF NOT END OF TEXT
          JNE       LISTV30
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       CH,BYTE PTR [EDX].@LISTFLG
          MOV       AL,CH
          XOR       AL,40H
          MOV       BYTE PTR [EDX].@LISTFLG,AL    ;SWITCH BETWEEEN PASS 1 & 2 (OR VICE VERSA)
          TEST      CH,40H                        ;SKIP IF WAS PASS 2
          JNZ       QLISTV80
          MOV       EDX,AUX0E
          MOV       DWORD PTR [A0],EDX   ;F1F0 = LIMIT VALUE
          MOV       EDX,AUX0C
          CMP       DWORD PTR [A0],EDX
          JBE       QLISTV90             ;EXIT IF NO MORE SYMS FOUND THIS PASS
          MOV       AUX0D,EDX            ;AUX D = SYMBOL NAME THAT WAS FOUND
          MOV       AUX0C,EDX            ;AUX C = UPPER BOUND
          INC       AUX0C

;    PASS 2 NEW VARIABLE
;   (PC'S = AUX D;  VARIABLE TO PRINT REFS TO)
;

          MOV       WORD PTR [R2],DX
          ADD       R2,0F0H     ;CONVERT TO PRINTABLE FORMAT
          TEST      R2,08H
          JZ        LISTVXX
          MOV       K,'@'
          CALL      TWRITE
          JMP       LISTVXX1
LISTVXX:
          CALL      TWRITESP    ;SKIP A LEADING SPACE IF NOT GLOBAL
LISTVXX1:
          MOV       AL,R3       ;PRINT OUT VARIABLE NAME
          MOV       K,AL
          CALL      TWRITE
          MOV       AL,R2
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        LISTXX2
          SHR       AL,4
          ADD       AL,30H
          MOV       K,AL
          CALL      TWRITE

LISTXX2:
          TEST      R2,01H
          JZ        LISTXX4
          MOV       K,'$'
          CALL      TWRITE

LISTXX4:
          TEST      R2,02H
          JZ        LISTXX6
          MOV       K,'('
          CALL      TWRITE

LISTXX6:
          MOV       AL,R2
          AND       AL,0F0H
          CMP       AL,0F0H
          JNE       LISTXX7
          CALL      TWRITESP    ;SKIP A SPACE, IF NO DIGIT

LISTXX7:
          TEST      R2,01H
          JNZ       LISTXX8
          CALL      TWRITESP    ;SKIP A SPACE, IF NOT ALPHA

LISTXX8:
          TEST      R2,02H
          JNZ       LISTXX9
          CALL      TWRITESP    ;SKIP A SPACE, IF NOT ARRAY

LISTXX9:
          CALL      TWRITESP    ;SKIP A SPACE
          CALL      PRNTDA      ;PRINT ' -'
          JMP       LISTV25     ;START SCANNING TEXT, LOOKING FOR REFS TO

;  THIS PARTICULAR VARIABLE
;

;    RETURN TO EITHER LISTVAR OR LSTVENDL DEPENDING
;

QLISTV80: JMP       LISTV80
LISTV30:  CALL      TXTSETA     ;SET UP TEXTPOINTERS TO NEXT LINE
          CALL      BREAKPTG    ;BREAKPOINT IF 30MS. ELAPSED
          JMP       VJUMP       ;SCAN NEXT LINE LOOKING FOR VARIABLE REFERENCES

;    ON WHETHER A REFERENCE IS FOUND OR NOT.
;    LISTVAR- REFERENCE TO A VARIABLE IS FOUND
;

LISTVAR:  MOV       AL,R2
          MOV       R0,AL       ;SAVE F2 FOR LATER
          ADD       R2,10H
          AND       R2,0FBH     ;CONVERT TO SORTABLE FORM
          MOV       EDX,AUX0D
          CMP       WORD PTR R2,DX
          JB        LISTVAR7    ;RETURN IF LESS THAN AUX D
          MOV       EDX,AUX0C
          CMP       WORD PTR R2,DX
          JB        LISTVAR2
          JMP       LISTVAR7    ;RETURN IF VARIABLE IS >= AUX C

LISTVAR2: MOV       EDX,AUX0E
          XOR       DL,R2
          TEST      DL,0FH      ;SKIP IF TYPES MATCH
          JE        LISTVAR5
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@LISTFLG
          MOV       CH,BYTE PTR [EDX]
          TEST      CH,04H      ;RETURN IF TYPES WERE SUPPOSED TO MATCH
          JNZ       LISTVAR7

LISTVAR5:
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@LISTFLG
          MOV       CH,BYTE PTR [EDX]
          TEST      CH,40H      ;SKIP IF PASS 2
          JNZ       LISTV75
          MOV       DX,WORD PTR R2
          MOV       AUX0C,EDX   ;SAVE VARIABLE NAME THAT IS A MATCH
LISTVAR7: MOV       AL,R0       ;RESTORE F2 TO ORIGINAL VALUE
          MOV       R2,AL

LISTVAR8: MOV       R0,0        ;FOUND FLAG
          RET                   ;RETURN TO CALLING ROUTINE

LISTV75:  CALL      GETLINE_
          CALL      PRNTREFC    ;PRINT THE REFERENCE
          JMP       LSTVENDL    ;IGNORE ANY MORE REFERENCES IN THIS LINE,

;  THREAD TO THE NEXT.
;    PASS 2 END OF TEXT
;

;  VARIABLE WAS SPECIFIED
;

LISTV80:  CALL      LPRNTCR     ;PRINT A CARRIAGE RETURN
          MOV       EDX,AUX0D
          MOV       AUX0D,EDX
          INC       AUX0D
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       CH,BYTE PTR [EDX].@LISTFLG
          TEST      CH,80H      ;GO BACK TO PASS 1 IF MORE THAN ONE
          JZ        LISTV20

LISTV90:  JMP       LISTDONE

;   GETLINE#:  READ THE LINE NUMBER CURRENTLY POINTED
;     TO BY TEXTLPTR.
;
;   RETURN:  PC'S POINT AT THE LINE NUMBER, CHCL = LINE #
;   MODIFIED REGS:  PC'S, CHCL
;
;   BUMPREAD:  BUMP THE PC'S BY 2, AND READ
;
;   MODIFIED REGS:  PC'S, CHCL

GETLINE_: MOV       EDX,TEXTLPTR
BUMPREAD: ADD       EDX,4
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET                   ;READ THE VALUE, RETURN

;  PRNTREF:  PRINT ONE LINE NUMBER REFERENCE.
;   (CALLED FROM LIST #, LIST ', LIST V, LIST T)
;
;   ENTRY:  F3F2 = LINE NUMBER TO BE PRINTED.
;
;   MODIFIED REGISTERS: K, PC'S, F1

PRNTREFC: MOV       WORD PTR [R2],CX
PRNTREF:  MOV       EDX,CHARCNT
          MOV       R1,0
          CMP       DH,R1       ;SKIP IF DEFINED LINE WIDTH = 00
          JE        PRNTREF5
          MOV       R1,DL
          ADD       R1,5
          JC        PRNTREF2
          CMP       R1,DH       ;SKIP IF LINE WILL FIT ON CURRENT LINE
          JB        PRNTREF5

PRNTREF2: CALL      LPRNTCR     ;PRINT CARRIAGE RETURN
          MOV       EDX,CHARCNT
          TEST      DH,0F0H     ;SKIP IF DEFINED WIDTH < 16
          JZ        PRNTREF5
          CALL      TWRIT4SP
          CALL      TWRIT4SP    ;SKIP 8 SPACES
PRNTREF5: CALL      TWRITESP    ;OUTPUT ONE SPACE
          JMP       WRTLIN_4    ;OUTPUT THE LINE NUMBER WITH LEADING ZEROES

PRNTDA:   CALL      TWRITESP    ;WRITE 1 SPACE
PRNTDASH: MOV       K,'-'
          JMP       TWRITE      ;WRITE A DASH, RETURN

;   TEXTSETA:  SET UP TEXTPOINTERS TO BEGIN SCAN OF
;      SPECIFIED LINE.
;
;   ENTRY:  CHCL = THREAD POINTING TO LINE.
;
;   RETURN:  TEXTLPTR POINTS TO LINE, TEXTPTR POINTS AFTER
;      THE LINE NUMBER.
;
;  ALTERNATE ENTRY, TEXTSETB:
;       PHPL POINTS TO LINE.

TXTSETA:  MOV       EDX,ECX        ;COPY THREAD TO PC'S
TXTSETB:  MOV       TEXTLPTR,EDX
          MOV       TEXTPTR,EDX    ;PC'S POINT AFTER STMT NUMBER
          ADD       TEXTPTR,6
          RET

;  LIST':  LIST THE SPECIAL FUNCTION REFERENCES.
;
;     GENERAL FORMS:
;           LIST'       - LIST ALL GOSUB' REFERENCES
;           LIST' XXX   - LIST THE REFERENCES TO DEFFN'XXX
;
;     DISPLAY FORM:
;        1234 DEFFN' 123
;               - 0010 0020 0035 0040
;        3456 DEFFN' 135
;               - 0012 0020 0045 2040 3456 3556 4220
;   Scan statement.  Flag = 1,  a=0   if LIST'
;                    Flag = 0,  a=xxx if LIST' XXX
;   1. Scan program looking for all ' characters.  Find
;      the minimum of any integers following them,
;      subject to >= a.  Save value as new a.
;   2. If any are found, search program again, looking
;      for DEFFN' A.  Print all such that are found.
;   3. Now search program for any GOSUB'A.  If none are
;      found, go to 4.  If one or more is found, print
;      a dummy DEFFN' if no DEFFN' was found, then print
;      the GOSUB' references.
;   4. If flag = 0, exit.  Otherwise, a=a+1, goto 1.
;
;    REGISTER USAGE:
;         F6 - a - the particular DEFFN' being looked for
;         F5 - flag - bits defined as follows:
;               01 - all the DEFFN' are desired
;               02 - a DEFFN' has already been found for
;                    the current value of a.
;               04 - a GOSUB' has already been found
;                    (and printed) for current value of a.
;


LIST?qu:  CALL      PRTCTERR    ;CHECK PROTECTED PROGRAM
          CALL      INTEGER     ;SCAN STATEMENT FOR INTEGER
          MOV       AL,R0
          AND       AL,01H
          MOV       R5,AL       ;FLAG = 01 IF ENTIRE RANGE WANTED
          MOV       R6,0        ;RANGE DEFAULT STARTS AT 00
          TEST      R0,0FH      ;SKIP IF ENTIRE RANGE
          JNZ       LIST?qu1
          CMP       R2,0
          JE        M27_22
          JMP       ERROR_34    ;ERROR IF > 255 (ILLEGAL VALUE)
M27_22:
          MOV       AL,R1
          MOV       R7,AL       ;SEARCH ONLY FOR DEFFN' = F7

LIST?qu1: TEST      SL,2        ;EXIT IF NOT X PHASE
          JZ        LIST?qu9
          CALL      SWITCHA     ;SAVE TEXT POINTERS DURING LIST
          OR        MODE,0800H  ;FLAG THAT THE SWITCH WAS DONE
          TEST      R5,1        ;GO DIRECTLY TO PASS 2 IF FLAG=0
          JNZ       LIST?qu13
          JMP       LIST?QU2

;    PASS 1 -
;       SEARCH FOR NEXT HIGHER 'XXX
;

LIST?qu13:
          MOV       R7,0FFH
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TEXTBEG
          MOV       TEXTLPTR,EDX  ;POINT AT FIRST LINE
LIST?qu15:
          MOV       EDX,TEXTLPTR
          MOV       ECX,DWORD PTR [EDX]
          CMP       ECX,0       ;SKIP IF NOT END OF TEXT
          JNE       LIST?qu17

LIST?qu2: MOV       AL,R7       ;K IS THE DEFFN' WE'RE LOOKING FOR
          MOV       K,AL
          AND       R5,0FFH-02  ;FLAG NONE FOUND YET
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TEXTBEG  ;POINT TO 1ST LINE
          CALL      FINDDEFD    ;SEARCH FOR THE DEFFN' (FROM BEGIN OF TEXT)
          JMP       LIST?qu32   ;GO TO PASS 2
LIST?qu17:
          CALL      TXTSETA     ;SET UP TEXTPTRS TO NEXT LINE
JMPBACK1: MOV       R0,27H
          CALL      SCANCHA     ;LOOK FOR '
          TEST      R0,1        ;THREAD IF CR
          JNZ       LIST?qu15
          TEST      R0,2        ;LOOP IF STMT SEP
          JNZ       JMPBACK1
          CALL      INTEGER     ;CHECK FOR INTEGER
          TEST      R0,0FH      ;LOOP IF NOT INTEGER
          JNZ       JMPBACK1
          CMP       R2,0
          JNE       JMPBACK1
          MOV       AL,R1
          CMP       AL,R6       ;IGNORE IF TOO LOW
          JB        JMPBACK1
          CMP       R7,AL       ;IGNORE IF TOO HIGH
          JB        JMPBACK1
          MOV       AL,R1       ;SAVE IT IN F7
          MOV       R7,AL
          JMP       JMPBACK1

;    PASS 2 PROCESSING
;

;  (IN CASE OF MULTIPLE DEFINITION)
;

LIST?qu3: MOV       AL,R7
          MOV       K,AL
          CALL      FINDDEFC    ;SEARCH FOR THE NEXT DEFFN'
LIST?qu32:
          TEST      R0,0FH      ;SKIP IF DEFFN' NOT FOUND
          JNZ       LIST?qu5
          CALL      GETLINE_    ;CHCL = LINE # OF THE DEFFN'
          MOV       WORD PTR R2,CX

;   PRINT DEFFN' LINE
;
          CALL      PRNTDEF     ;PRINT THE DEFINING LINE FOR DEFFN'
          JMP       LIST?qu3    ;LOOP BACK IN CASE OF MULTIPLE DEFFN' LINES
LIST?qu5: MOV       EDX,DWORD PTR [CPBASE]  ;SETUP BEGINNING OF TEXT POINTER
          LEA       EDX,[EDX].@TEXTBEG
          MOV       TEXTLPTR,EDX
          AND       R5,0FFH-04  ;FLAG GOSUB' NOT FOUND YET FOR CURRENT F7
LIST?qu55:
          CALL      NEXTGO?quA  ;THREAD TO NEXT LINE, FIND NEXT REFERENCE
          JMP       LIST?qu62

LIST?qu6: CALL      NEXTGO?qu   ;FIND NEXT GOSUB' IN TEXT
LIST?qu62:
          TEST      R0,0FH      ;SKIP IF END OF TEXT
          JNZ       LIST?qu8
          CALL      INTEGER
          TEST      R0,0FH      ;IGNORE THE GOSUB' IF NOT FOLLOWED BY INTEGER
          JNZ       LIST?qu6
          CMP       R2,0        ;IGNORE IF THE INTEGER IS GREATER THAN 255
          JNE       LIST?qu6
          MOV       AL,R1
          CMP       AL,R7       ;KEEP LOOPING IF IT ISN'T THE ONE WE'RE AFTER
          JNE       LIST?qu6

;   PRINT GOSUB' REFERENCE
;

          TEST      R5,4        ;SKIP IF THIS IS NOT FIRST REFERENCE
          JNZ       LIST?qu67
          TEST      R5,2        ;SKIP IF DEFFN' EXISTED FOR THIS VALUE
          JNZ       LIST?qu65
          MOV       WORD PTR R2,0FFFFH ;INITIALIZE LINE NUMBER TO ????
          CALL      PRNTDEF     ;PRINT DUMMY DEFFN' LINE

LIST?qu65:
          CALL      TWRIT4SP
          CALL      TWRIT3SP    ;TAB 7 SPACES
          CALL      PRNTDASH    ;PRINT A DASH

LIST?qu67:
          CALL      GETLINE_
          CALL      PRNTREFC    ;PRINT THE REFERENCING LINE NUMBER
          OR        R5,04H
          JMP       LIST?qu55   ;THREAD TO THE NEXT LINE, CONTINUE SEARCHING

LIST?qu8: TEST      R5,4
          JZ        M27_23
          CALL      PRNTCR      ;PRINT CR IF ANY REFERENCES
M27_23:
          TEST      R5,1        ;EXIT IF ONLY ONE DEFFN' TO BE LISTED
          JZ        LIST?qu9
          TEST      SH,20H      ;EXIT IF HALT STEP KEY IS PRESSED
          JNZ       LIST?qu9
          MOV       AL,R7
          INC       AL
          MOV       R6,AL       ;NEXT DEFFN' TO LOOK FOR
          CMP       R6,0        ;LOOP FOR ZERO TO 255
          JE        LIST?qu9
          JMP       LIST?qu13   ;PAGING ERROR PREVENTION
LIST?qu9: JMP       LISTDONE    ;EXIT


;    TEXT CROSS REFERENCE
; LIST T:
;    STATEMENT SYNTAX
;      LIST [S][title] T alpha [,alpha ...]
;       where alpha is a literal or alpha variable
;       if a variable, current length is used.
;
;   Note:  Each statement is scanned, beginning after the
;    line number, comparing the deatomized text with the
;    specified character string ("literal").  Blanks in
;    the text or in the string are ignored for comparison
;    purposes.  Operation is undefined for an all blank
;    string.
;
;   F5 USAGE:
;       04 - FLAG FOR PUTLINE, TO INDICATE LIST T MODE
;       02 - PARTIAL MATCH WITHIN LITERAL, CURRENT LINE
;       01 - AT LEAST ONE MATCH IS FOUND FOR LITERAL
;
;   AUX USAGE:
;       A -  LINE # OF CURRENT TEXT LINE SCANNED
;       B -  BYTE COUNT WITHIN LINE, TO BEGIN OF MATCH POINT
;       C -  ADDRESS OF BEGINNING OF LITERAL
;       D -  ADDRESS OF CURRENT BYTE WITHIN LITERAL
;       E -  ADDRESS OF END OF LITERAL
;    NOTE:  2200VP USED SCRATCH AREA INSTEAD OF AUXES A,B,E
;
;   COMPLETE  MATCH

LISTT80:  TEST      R5,1        ;SKIP IF NOT FIRST MATCH
          JNZ       LISTT85
          CALL      TWRIT4SP    ;WRITE 4 SPACES
          CALL      PRNTDA      ;WRITE A SPACE AND A DASH
          CALL      TWRIT2SP    ;WRITE 2 MORE SPACES
          OR        R5,1        ;FLAG A MATCH

LISTT85:  MOV       EDX,AUX0A
          MOV       WORD PTR R2,DX
          CALL      PRNTREF     ;PRINT THE REFERENCING LINE #
LISTT30:  MOV       EDX,AUX0A
          MOV       AL,DL
          INC       AL
          DAA
          MOV       CL,AL
          MOV       AL,DH
          MOV       AH,0
          ADC       AL,AH
          DAA
          MOV       CH,AL
          MOV       WORD PTR [R2],CX ;INCREMENT THE LINE NUMBER
          JNC       LISTT10          ;LOOP IF NOT OVERFLOW (MORE TEXT POSSIBLY)

LISTT90:  TEST      R5,1
          JZ        LISTT9
          CALL      LPRNTCR                 ;PRINT FINAL CR IF ANY MATCHES WERE FOUND
LISTT9:   CMP       BYTE PTR [TEXTPTR],','  ;CHECK FOR COMMA
          JNE       LISTT99                 ;EXIT IF NOT FOUND
          INC       TEXTPTR
LISTT:    CALL      PRTCTERR
          MOV       K,4         ;K=4, FLAG CURRENT LENGTH
          CALL      ALPHA1      ;GET LITERAL OR (CURRENT) ALPHA VARIABLE
          TEST      R0,0FH
          JE        M27_24
          JMP       ERROR_29    ;ERROR 29 IF NOT FOUND
M27_24:
          TEST      SL,2        ;EXIT IF NOT X PHASE
          JZ        LISTT9
          xor       ebx,ebx
          mov       edx,vsptr
          mov       bx,word ptr [edx]
          mov       word ptr [r0],bx
          mov       edx,dword ptr [edx+2]
          add       vsptr,6
          MOV       AUX0C,EDX   ;AUX C = ADDRESS OF LITERAL
          MOV       EAX,EDX
          ADD       EAX,EBX
          MOV       DWORD PTR [A2],EAX
          MOV       K,22H
          CALL      TWRITE      ;QUOTES
          CALL      WRTBLKB     ;WRITE OUT THE LITERAL
          MOV       K,22H
          CALL      TWRITE      ;QUOTES
          CALL      LPRNTCR     ;PRINT A CARRIAGE RETURN
          MOV       EDX,DWORD PTR [A2]
          MOV       AUX0E,EDX   ;LITERAL END ADDRESS
          DEC       AUX0E
          MOV       EDX,AUX0C
          MOV       R0,20H

;   EXIT IF THE LITERAL IS ALL BLANK
;

LISTT05:  MOV       CH,BYTE PTR [EDX]
          MOV       AUX0C,EDX
          INC       EDX
          CMP       CH,R0
          JNE       LISTT06
          CMP       DWORD PTR [A2],EDX
          JNE       LISTT05     ;SKIP OVER ANY LEADING BLANKS

;   EXIT POINT FOR LIST T, ALL PHASES
;

LISTT99:  TEST      SL,2
          JZ        M27_25
          JMP       LISTDONE         ;EXECUTION PHASE
M27_25:
          JMP       ENDSTMT          ;EXIT IF E/R PHASE
LISTT06:  MOV       WORD PTR [R2],0  ;FIRST LINE # = 0000
          MOV       R5,0CH           ;F5 = LIST T FLAGS FOR PUTLINE
LISTT10:  MOV       WORD PTR [R6],0  ;INITIAL COUNT = 0000
          JMP       LISTT20

;  (ENTRY POINT FROM PUTCHAR - ACTION NEEDED)
;

LISTTA:   TEST      R5,2        ;SKIP IF PARTIAL MATCH ALREADY OCCURRED
          JNZ       LISTT15
          INC       WORD PTR [R6] ;INCREMENT COUNT
          MOV       EDX,AUX0B
          CMP       WORD PTR [R6],DX
          JBE       LISTT96     ;SKIP OVER TEXT ALREADY SCANNED
          MOV       EDX,AUX0D
          MOV       R1,20H
          MOV       CH,BYTE PTR [EDX]    ;READ CURRENT BYTE
          CMP       CH,K        ;SKIP IF NOT EQUAL
          JE        LISTT15

;    THIS ENTRY WAS ADDED BECAUSE LISTT96 IS IN NEXT PAGE
;

LISTT96:  JMP       LISTT95
LISTT15:  MOV       EDX,AUX0D
          MOV       R1,20H
          MOV       CH,BYTE PTR [EDX]
          CMP       CH,K        ;SKIP IF NO CHARACTER MATCH
          JNE       M27_26
          JMP       LISTT70

M27_26:
          MOV       AL,R1
          CMP       AL,K        ;RETURN IF EQUAL TO BLANK
          JE        LISTT96
          MOV       EDX,AUX0A
          MOV       WORD PTR [R2],DX  ;F3F2 = LINE NUMBER (RESTART OF CURRENT LINE)

LISTT20:  MOV       DX,WORD PTR [R6]
          MOV       AUX0B,EDX   ;SAVE CURRENT COUNT
          MOV       WORD PTR [R6],0  ;ZERO COUNT
          MOV       EDX,AUX0C
          MOV       AUX0D,EDX
          CALL      FINDST      ;FIND FIRST STMT >= SPEC
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1        ;EXIT IF NO MORE TEXT
          JE        LISTT90
          INC       EDX
          MOV       AUX00,EDX   ;POINT AFTER LINE NUMBER
          ADD       AUX00,5
          MOV       DX,CX
          MOV       AUX0A,EDX   ;NEW LINE #
          AND       R5,0FDH     ;TURN OFF 02 BIT (PARTIAL MATCH FLAG)
          MOV       ESP,OFFSET STACK_BUFFER ;REMOVE REDUNDANT RETURN ADDRESS
          CALL      PUTLINF     ;GO 'RECALL' THE LINE, CHECKING FOR MATCH
          CALL      BREAKPTG    ;IF 30MS. ELAPSED, BREAK
          JMP       LISTT30

;   A CHARACTER MATCH IS FOUND
;

LISTT70:  OR        R5,02H      ;FLAG THE MATCH
          MOV       DL,R0
          PUSH      EDX         ;SAVE F0
          MOV       EDX,AUX0E
          MOV       DWORD PTR [A0],EDX   ;F1F0 = ADDR OF END OF LITERAL
          MOV       EDX,AUX0D   ;PC'S = CURRENT ADDR

LISTT71:  CMP       DWORD PTR [A0],EDX
          JBE       LISTT72     ;EXIT IF END OF LITERAL
          INC       EDX
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX0D,EDX   ;POINT TO NEXT BYTE TO BE MATCHED TO
          CMP       CH,20H
          JE        LISTT71     ;LOOP BACK IF BLANK
          POP       EDX
          MOV       R0,DL       ;RESTORE F0
LISTT95:  MOV       R1,44H      ;FLAG NORMAL RETURN
          RET

LISTT72:  JMP       LISTT80

;   LISTDVT: process a LIST DT statement
;
;         Entry:    TEXTPTR points after DT
;                   TEXTLPTR points to current text line
;
;         NOTE:  new LIST DT routine added in rel 3.0
;

LISTDVT:  TEST      SL,XPHASE   ;branch if not execution phase
          JZ        LISTDT99
          MOV       R0,@CI
          CALL      WRTWORDF    ;'CI'
          CALL      TWRIT4SP    ;'    '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVTBL
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy

;=================== CO /xyy  width xx =======================================

          CALL      TWRT30SP    ;column 40
          MOV       R0,@CO
          CALL      WRTWORDF    ;'CO'
          CALL      TWRIT4SP    ;'    '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVCO
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVCO
          ADD       EDX,2
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      LDTWIDTH    ;'  width xxx' CR
;=================== INPUT /xyy =================================================

          MOV       R0,@INPUT
          CALL      WRTWORDF    ;'INPUT '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVINPT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
;=================== PRINT /xyy  width xx ====================================

          CALL      TWRT30SP    ;column 40
          MOV       R0,@PRINT
          CALL      WRTWORDF    ;'PRINT '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVPRNT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2
          CALL      WRTDADDR    ;/xyy
          MOV       EDX,AUX00
          CALL      LDTWIDTH    ;'  width xxx' CR
;=================== PLOT /xyy =================================================

          MOV       R0,@PLOT
          CALL      WRTWORDF    ;'PLOT'
          CALL      TWRIT2SP    ;' '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVPLOT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
;=================== LIST /xyy  width xx ====================================

          CALL      TWRT30SP    ;column 40
          MOV       R0,@LIST
          CALL      WRTWORDF    ;'LIST '
          CALL      TWRITESP    ;' '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVLIST
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2
          CALL      WRTDADDR    ;/xyy
          MOV       EDX,AUX00
          CALL      LDTWIDTH    ;'  width xxx' CR
;=================== TAPE /xyy =================================================

;=================== #n /xyy [at xxxxx in xxxxx to xxxxx], n = 0-255 ============

          MOV       R0,@TAPE
          CALL      WRTWORDF    ;'TAPE'
          CALL      TWRIT2SP    ;'  '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVTAPE
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          CALL      LPRNTCR     ;CR
          CALL      PRNTCR      ;CR
          MOV       WORD PTR R6,0  ;F7 = 1st file# (#0)
                                   ;F6 = flag (column 0 or 1)
LISTDT1:  CALL      RFILE_
          MOV       AL,R7
          MOV       [EDX+1],AL  ;store file#
          CALL      FILE_ADR    ;get address of file# entry
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2
          XCHG      EDX,AUX00   ;save address

          MOV       R0,CH
          OR        R0,CL
          MOV       CH,BYTE PTR [EDX]
          INC       EDX

          OR        R0,CH
          MOV       CH,BYTE PTR [EDX]
          INC       EDX

          OR        R0,CH
          MOV       CH,BYTE PTR [EDX]
          INC       EDX

          OR        R0,CH
          MOV       CH,BYTE PTR [EDX]
          INC       EDX

          OR        R0,CH
          MOV       CH,BYTE PTR [EDX]
          MOV       CL,BYTE PTR [EDX+1]

          OR        R0,CH
          OR        R0,CL

          CMP       R0,0
          JE        LISTDT11    ;branch if entry all 0 (don't display)

          MOV       K,'#'
          CALL      TWRITE      ;'#'
          MOV       AL,R7
          MOV       R0,AL       ;file#
          MOV       R1,0
          CALL      BINDEC      ;convert file# to packed decimal
          CALL      WRTLINE_    ;display file#
          MOV       R0,63H
          MOV       AL,R0
          CMP       AL,R7       ;branch if 3-digit file#
          JB        LISTDT3
          CALL      TWRITESP    ;' '
          MOV       R0,9
          CMP       R7,9        ;branch if 2-digit file#
          JA        LISTDT3
          CALL      TWRITESP    ;' '

LISTDT3:  CALL      TWRIT2SP    ;'  '
          MOV       EDX,AUX00
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2     ;get device type & address
          MOV       WORD PTR [R2],CX
          MOV       AL,R3
          AND       AL,0F0H
          CMP       AL,10H      ;if data file open with 'F',
          JNE       M27_28
          MOV       R3,13H      ;change device type to 3
M27_28:
          MOV       AL,R3
          AND       AL,0F0H
          CMP       AL,20H      ;if data file open with 'R',
          JNE       M27_29
          MOV       R3,2BH      ;change device type to B
M27_29:
          CALL      WRTDADRF    ;/xyy
          TEST      R3,0F0H     ;branch if data file not open
          JZ        LISTDT4
          MOV       EDX,OFFSET LDTMSG2
          CALL      WRTSTRCM    ;'  at'
          MOV       EDX,AUX00
          ADD       EDX,2
          CALL      LDTSCTR     ;' ' current sector
          MOV       EDX,OFFSET LDTMSG3
          CALL      WRTSTRCM    ;' in'
          MOV       EDX,AUX00
          ADD       AUX00,2
          CALL      LDTSCTR     ;' ' starting sector
          MOV       EDX,OFFSET LDTMSG4
          CALL      WRTSTRCM    ;' to'
          MOV       EDX,AUX00
          ADD       EDX,2
          CALL      LDTSCTR     ;' ' ending sector
          MOV       R0,3        ;3 spaces
          JMP       LISTDT5
LISTDT4:  MOV       R0,1EH      ;30 spaces
LISTDT5:  XOR       R6,1        ;switch columns
          TEST      R6,1
          JZ        LISTDT6
          CALL      TWRITNSP    ;tab to column 40
          JMP       LISTDT11
LISTDT6:  CALL      LCPRNTCR    ;CR
LISTDT11: CALL      RFILE_      ;CH = maximum file#
          CMP       CH,R7       ;branch if no more file#'s
          JE        LISTDT10
          INC       R7          ;next file#
          JMP       LISTDT1

;=================== MDT:  /xyy-ppx ... =========================================

LISTDT10: CALL      LCPRNTCR    ;CR if not at begin of line
          CALL      LPRNTCR     ;CR
          MOV       EDX,OFFSET LDTMSG5
          CALL      WRTSTRCM    ;'MDT:'
          CALL      TWRIT6SP    ;6 spaces
          CALL      SRCHDEVP    ;get terminal printer info.
          DEC       EDX
          CMP       CH,0        ;branch if no terminal
          JE        M27_30      ;branch if no terminal
          CALL      LISTDTX     ;display /004 info
M27_30:
          MOV       EDX,OFFSET MDEVTBL     ;point to MDT
LISTDT7:  MOV       CX,WORD PTR [EDX]      ;get next entry
          XCHG      CH,CL
          MOV       AUX00,EDX   ;get next entry
          ADD       AUX00,2
          CMP       CH,0        ;branch if EOT
          JE        LISTDT80
          CALL      LISTDTX     ;display entry
          MOV       EDX,AUX00   ;get address of next entry
          JMP       LISTDT7

;--------- display MXE TC ports -------------------------------------------------

LISTDT80:
          MOV       EDX,OFFSET TPDEVTBL  ;point to terminal printer/TC table
          MOV       R3,0AH      ;device type
          MOV       R2,1        ;port 1 (1-16)

LISTDT81: MOV       CX,[EDX]
          XCHG      CH,CL       ;get next entry
          MOV       AUX00,EDX
          ADD       AUX00,2
          TEST      CL,80H      ;branch if not TC port (TCPORT = 80H)
          JZ        LISTDT82
          MOV       R6,CL       ;device status
          CALL      LISTDTXX    ;display entry
LISTDT82: MOV       EDX,AUX00   ;address of next entry
          MOV       AL,R2
          INC       AL
          DAA
          MOV       R2,AL       ;increment (decimal) port #
          MOV       R4,17H
          CMP       AL,R4       ;branch if more entries to check
          JB        LISTDT81

;=================== GPT:  /xyy @nnnnnnn onf ... ================================

;=================== done =======================================================

LISTDT8:  CALL      CPRNTCR     ;CR if not at EOL
          CALL      LPRNTCR     ;CR
          MOV       EDX,OFFSET LDTMSG6
          CALL      WRTSTRCM    ;'PDT:'
          CALL      TWRITESP    ;space
          CALL      LISTDRVR    ;ouput printer drivers

;=================== PHT:  /xyy-pp  ... =========================================

LISTDTA0: CALL      LCPRNTCR    ;CR if not at begin of line
          CALL      LPRNTCR     ;CR
          MOV       EDX,OFFSET LDTMSG17
          CALL      WRTSTRCM    ;'PHT:'
          CALL      TWRIT6SP    ;6 spaces

          MOV       BL,11H
          MOV       EDX,OFFSET MDEVTBL     ;point to MDT
LISTDTA7: MOV       CX,WORD PTR [EDX]      ;get next entry
          XCHG      CH,CL
          ADD       EDX,2                  ;get next entry
          CMP       CH,0                   ;branch if EOT
          JE        LISTDTA99
          TEST      CL,80H
          JZ        LISTDTA7
          TEST      CL,10H
          JZ        LISTDTA7
          CMP       CH,10H
          JNZ       LISTDTA8
          OR        BL,22H
LISTDTA8: CMP       CH,20H
          JNZ       LISTDTA9
          OR        BL,44H
LISTDTA9: CMP       CH,30H
          JNZ       LISTDTA7
          OR        BL,88H
          JMP       LISTDTA7

LISTDTA99:
          MOV       EDX,OFFSET PLAT        ;point to PLAT
          MOV       BH,01H
          MOV       CH,00H
LISTDTAA: TEST      BL,BH
          JNZ       LISTDTAB
LISTDTAD: MOV       CL,BYTE PTR [EDX]      ;get next entry
          MOV       AUX00,EDX
          INC       AUX00
          TEST      CL,40H                 ;branch if EOT
          JZ        LISTDTAC
          AND       CL,03FH
          PUSH      BX
          PUSH      CX
          CALL      LISTDTAX               ;display entry
          POP       CX
          POP       BX
LISTDTAC: INC       CH
          MOV       EDX,AUX00              ;get address of next entry
          TEST      CH,0FH
          JNZ       LISTDTAD
          SHL       BH,1
          JC        LISTDTA98
          JMP       LISTDTAA
LISTDTAB: ADD       EDX,16
          ADD       CH,10H
          SHL       BH,1
          JC        LISTDTA98
          JMP       LISTDTAA
LISTDTA98:CALL      LPRNTCR
LISTDT99: JMP       LISTDONE

;   LISTDTX:  display an MDT entry
;
;         Entry:    cursor at location of display
;                   CHCL = MDT entry    (CH=device, CL=status)
;
;         Modified registers:  K,F0-3,F6,CHCL
;
;  LISTDTXX:  same as above, except entry
;
;         Entry:    cursor at location of display
;                   F3F2 = device address (0taa)
;
LISTDTX:  MOV       R6,CL       ;save device status
          MOV       R3,0
          MOV       R2,CH       ;device address
          TEST      R6,80H      ;DEVTDSK = 80H
          JZ        LISTDTXX
          MOV       R3,03       ;device type = 3 if disk, else 0

LISTDTXX: CALL      WRTDADRF    ;'/xyy'
          MOV       R0,6
          TEST      R6,50H      ;DEVUSE= 50H branch if device not open
          JZ        LISTDTX3
          MOV       K,'-'
          CALL      TWRITE      ;'-'
          MOV       AL,R6
          AND       AL,0FH
          MOV       R0,AL
          CALL      WRTNIB      ;'xx'  partition number
          MOV       K,' '
          TEST      R6,10H      ;DEVOPEN = 10H
          JZ        M27_31
          MOV       K,'O'
M27_31:
          TEST      R6,20H      ;DEVEXCLH = 20H
          JZ        M27_32
          MOV       K,'X'
M27_32:
          CALL      TWRITE      ;' ', 'O', or 'X'
          MOV       R0,2
LISTDTX3: JMP       TWRITNSP    ;spaces


LISTDTAX: MOV       R6,CL       ;save device status
          MOV       R2,CH       ;device address
          MOV       R3,0DH      ;device type = D
          CALL      WRTDADRF    ;'/xyy'
          MOV       K,'-'
          CALL      TWRITE      ;'-'
          MOV       AL,R6
          AND       AL,0FH
          MOV       R0,AL
          CALL      WRTNIB      ;'xx'  partition number
          MOV       K,' '
          CALL      TWRITE      ;' '
          MOV       K,' '
          CALL      TWRITE      ;' '
          MOV       K,' '
          CALL      TWRITE      ;' '
          ret


; LISTDRVR         LIST THE PRINTER DRIVER TABLES THAT ARE AVAILABLE FOR THE CURRENT
;         PARTITION AND TERMINAL (DON'T LIST OTHER TERMINAL'S TERMINAL PRINTERS),
;         THEIR ASSOCIATED DEVICE ADDRESSES AND WHETHER OR NOT THEY ARE CURENTLY SELECTED
;
;         ENTRY: NONE
;         EXIT: NO REGISTERS ARE CHANGED EXCEPT CHCL
;         REGISTER USAGE:
;                   F1 - F4 :  GENERAL USAGE
;                   F5 : CONSTANT = 00
;                   F6 : CONSTANT = 04
;                   F7 : TERMINAL ADDRESS OF CURRENT TERMINAL
;                   AUX 1 : COUNT OF DRIVER TABLE ENTRIES PRINTED ON THE CURRENT LINE
;                   AUX 2 : ADDRESS OF CURRENT ENTRY IN DRIVER DEVICE LIST
;                   AUX 3 : DEVICE ADDRESS AND TABLE NUMBER OF CURRENT ENTRY
;                   AUX 4 : STORES ADDRESS OF CURRENT ENTRY IN TABLE NAME LIST
;

LISTDRVR: MOV       AUX01,0     ;SET "PRINTED" COUNT TO 0
          XOR       ECX,ECX
          MOV       CL,BYTE PTR [PART_] ;GET CURRENT PARTITION NUMBER
          MOV       EDX,OFFSET PTERM
          ADD       EDX,ECX
          MOV       CH,BYTE PTR [EDX]
          MOV       R5,0        ;F5 = constant = 0
          MOV       R7,CH       ;F7 = CURRENT TERMINAL ADDRESS
          MOV       R6,04H      ;F6 = CONSTANT = 0
          MOV       EDX,OFFSET DRVRDEV     ;POINT TO DRIVER DEVICE LIST
LSTDRVRL: MOV       AUX02,EDX   ;SAVE ADDRESS OF DRIVER DEVICE LIST ENTRY
;         CALL      RCM         ;READ ENTRY
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          CMP       R5,DH       ;BRANCH IF END OF LIST
          JE        LSTDRVRE
          CMP       R6,DH       ;BRANCH IF ADDRESS <> 04
          JNE       LSTDRVRP
          MOV       AL,K
          AND       AL,0FH
          DEC       AL          ;F4 = TERMINAL NUMBER OF ENTRY
          MOV       R4,AL       ;CONVERT TERMINAL NUMBER TO...

          MOV       AH,AL
          SHL       AH,4
          AND       AL,0FH
          OR        AH,AL
          MOV       R4,AH       ;TERMINAL ADDRESS
          AND       R4,0C3H     ;F4 = TERMINAL ADDRESS OF ENTRY
          MOV       AL,R4
          CMP       AL,R7       ;BRANCH IF not TERMINAL PRINTER OF CURRENT ENTRY
          JNE       LSTDRV3A
LSTDRVRP: MOV       AUX03,EDX   ;SAVE DEVICE ADDRESS & TABLE NUMBER
          MOV       R2,DH       ;F3F2 = device address
          MOV       R3,0
          CALL      WRTDADRF    ;output device address as /0xx
          CALL      TWRITESP    ;PRINT A SPACE
          MOV       R3,0        ;F3 = CHARACTER COUNT
          MOV       EDX,AUX03   ;RECALL TABLE NUMBER
          MOV       R4,DL       ;F4 = TABLE NUMBER
          DEC       R4          ;DECREMENT IT
          MOV       AL,R4
          AND       EAX,0FFH
          SHL       EAX,3
          MOV       EDX,OFFSET TABLNAME    ;POINT TO TABLE NAME LIST
          ADD       EDX,EAX     ;ADD IN DISPLACEMENT
LSTNAMEL: MOV       AUX04,EDX   ;SAVE ADDRESS OF NEXT 2 CHARACTERS
          ADD       AUX04,2
          MOV       AX,[EDX]    ;READ 2 CHARACTERS
          MOV       DX,AX
          MOV       K,DL        ;K = 1ST CHARACTRER
          CALL      TWRITE      ;PRINT IT
          MOV       K,DH        ;K = 2ND CHARACTER
          CALL      TWRITE      ;PRINT IT
          INC       R3          ;INCREMENT CHARACTER COUNT
          MOV       EDX,AUX04
          CMP       R3,4        ;BRANCH IF more to name
          JNE       LSTNAMEL
          CALL      TWRITESP    ;PRINT A SPACE

          MOV       EDX,AUX02   ;RECALL ADDRESS OF ENTRY
          ADD       EDX,3       ;POINT TO BIT MAP FOR THIS ENTRY
;         CALL      RCM         ;READ IT
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       AUX04,EDX   ;SAVE BIT MAP
          MOV       CH,PART_    ;GET CURRENT PARTITION NUMBER
;         AND       CH,07H      ;STRIP OFF F8 BITS
          MOV       WORD PTR [R3],1
LSTNAME1: CMP       CH,0        ;BRANCH IF DONE
          JE        LSTNAME2
          SHL       WORD PTR [R3],1
          DEC       CH          ;DECREMENT PARTITION NUMBER
          JMP       LSTNAME1    ;DO IT AGAIN

LSTNAME2:
          MOV       EDX,AUX04
          AND       WORD PTR R3,DX
          MOV       R0,@ON
          CMP       WORD PTR R3,0
          JNE       LISTDRV1
          MOV       R0,@OFF
LISTDRV1: CALL      WRTWORDF    ;ouput 'ON ' if driver enabled, else 'OFF'
          MOV       EDX,AUX01   ;RECALL COUNT PRINTED THIS LINE
          INC       EDX         ;INCREMENT IT
          MOV       AUX01,EDX   ;SAVE IT
          CMP       R6,DL       ;BRANCH IF NOT AT END OF LINE
          JNE       LISTDRV3
          MOV       DL,0        ;ZERO COUNT
          MOV       AUX01,EDX   ;SAVE IT
          CALL      LPRNTCR     ;PRINT A CR
          MOV       R0,05
          CALL      TWRITNSP    ;output 10 spaces
LISTDRV3: CALL      TWRIT2SP    ;output 2 spaces
LSTDRV3A: ADD       AUX02,6     ;RECALL ADDRESS OF ENTRY IN DRIVER DEVICE LIST
                                ;INCREMENT IT TO NEXT ENTRY
          MOV       EDX,AUX02   ;RECALL NEW ADDRESS
          JMP       LSTDRVRL    ;GO DO NEXT ENTRY
LSTDRVRE: JMP       CPRNTCR     ;PRINT A CR if not at begin of line

;   LDTWIDTH:  display output device width and CR
;   LDTWIDTHX: display output device width
;
;         Entry:  PHPL points at width
;
;         Modified registers:  K,PHPL,CHCL,F0-4
;

LDTWIDTH: MOV       CH,[EDX]    ;get width
          MOV       R1,0        ;get width
          MOV       R0,CH
          CALL      BINDEC      ;F3F2 = packed decimal width
          MOV       AL,R2
          MOV       R4,AL       ;save
          MOV       EDX,OFFSET LDTMSG1
          CALL      WRTSTRCM    ;'  width'
          MOV       AL,R4       ;restore F2
          MOV       R2,AL
          CALL      TWRITESP    ;' '
          CALL      WRTLINE_    ;'xxx' width
          JMP       LPRNTCR     ;CR

LDTWIDTHX:MOV       CH,[EDX]    ;get width
          MOV       R1,0        ;get width
          MOV       R0,CH
          CALL      BINDEC      ;F3F2 = packed decimal width
          CALL      WRTLINE_    ;'xxx' width
          MOV       K,')'
          CALL      TWRITE
          RET

;   LDTSCTR:  display sector number
;
;         Entry:  PHPL points at sector number (2-byte binary)
;
;         Modified registers:  K,CHCL,F0-5,PHPL
;

LDTSCTR:  CALL      TWRITESP    ;' '
          MOV       CX,[EDX]    ;get sector number
          XCHG      CH,CL
          JMP       WRTVAL      ;output sector number

;   LISTCOM:  list common variables in symbol table
;   LISTDIM:  list noncommon variables in symbol table
;   LISTCOM/DIM:  list common variables & non-common variables in stack order
;
;         Entry:  TEXTPTR points after COM or DIM
;

LISTCOM:  cmp       byte ptr [textptr],'/'
          jne       listcomx
          inc       textptr
          jmp       listcd31    ;slash found

listcomx: MOV       R7,1        ;flag = common variables
          JMP       LISTCD1

listcd31: mov       r0,@dim
          call      ccl
          mov       al,r0
          and       al,0fh
          cmp       al,1
          jne       listcd33    ;@dim found
          jmp       error_19

LISTDIM:  MOV       R7,0        ;flag = noncommon variables
LISTCD1:  TEST      SL,XPHASE   ;done if not execution phase
          JZ        LISTCD99

;=================== traverse symbol table link lists (A-Z) =====================

          CALL      PRTCTERR    ;Error if protect flag is on
          MOV       R6,'A'      ;start with A link list
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@VARTHRD
          MOV       AUX04,EDX   ;point to begin of 1st link list

LISTCD2:  MOV       EDX,AUX04
          MOV       ECX,DWORD PTR [EDX]
          MOV       AUX04,EDX   ;point to next link list
          ADD       AUX04,4
          MOV       EDX,ECX
          MOV       AUX01,EDX   ;point to 1st variable in list

LISTCD3:  MOV       EDX,AUX01
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX01,EDX   ;get name and type of variable
          ADD       AUX01,2
          CMP       CH,0        ;branch if not end of link list
          JNE       LISTCD4
          INC       R6          ;increment name letter
          MOV       R0,'Z'
          CMP       R6,'Z'      ;branch if <= 'Z'
          JBE       LISTCD2

LISTCD99: JMP       LISTDONE

;=================== variable found =============================================

LISTCD4:  MOV       WORD PTR [R2],CX   ;save name & type
          MOV       EDX,AUX01
          MOV       ECX,DWORD PTR [EDX]
          MOV       AUX03,EDX   ;aux 3 point after thread in var entry
          ADD       AUX03,4
          MOV       EDX,ECX
          MOV       AUX01,EDX   ;save ptr to next variable in list

;=================== check type ===============================

          MOV       EDX,DWORD PTR [CPBASE]
          MOV       ECX,DWORD PTR [EDX].@COMPTR
          MOV       EDX,AUX03
          CMP       ECX,EDX       ;branch if common variable
          JB        LISTCD5
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,1        ;branch if want commons
          JE        LISTCD3
          JMP       LISTCD6

LISTCD5:  TEST      R7,0FH      ;branch if want noncommons
          JZ        LISTCD3

;=================== correct type -- list variable ==============================

;         Entry:    F3F2 = variable name & type
;                   PHPL = ptr to thread field of variable entry
;

LISTCD6:  CALL      WRTVNAMF          ;ouput variable name
          MOV       EDX,AUX03
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL             ;CHCL = next 2 bytes of entry
          MOV       WORD PTR [R4],1   ;F5F4 = no. of elements (1)

;------------------- DIMS -------------------------------------------------------

          TEST      R2,6        ;branch if scalar variable
          JZ        LISTCD8
          MOV       DL,R2
          MOV       AUX05,EDX   ;save variable type
          TEST      R2,4        ;branch if 2-dimensional
          JNZ       LISTCD7
          MOV       WORD PTR [R0],CX
          CALL      WRTVAL16    ;output dimension
          MOV       EDX,AUX03
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX03,EDX
          ADD       AUX03,2
          MOV       WORD PTR [R4],CX   ;dimension
          JMP       LISTCD9

LISTCD7:  MOV       R0,CH
          CALL      WRTVAL8     ;1st dim
          MOV       K,','
          CALL      TWRITE      ;,
          MOV       EDX,AUX03
          MOV       R0,CL
          CALL      WRTVAL8     ;2nd dim
          MOV       EDX,AUX03
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX03,EDX   ;get dims
          ADD       AUX03,2
          MOV       WORD PTR [R0],CX
          XOR       AX,AX
          MOV       AL,R1       ;dim1 * dim2
          MUL       R0
          MOV       WORD PTR R0,AX
          MOV       WORD PTR R4,AX  ;no. of elements

LISTCD9:  MOV       K,')'
          CALL      TWRITE      ;)
          MOV       EDX,AUX05
          MOV       R2,DL       ;variable type
          MOV       EDX,AUX03

;------------------- alpha length -----------------------------------------------
;         Entry:  PHPL points at length
;                 F5F4 = no. of elements
;

LISTCD8:  TEST      R2,1        ;branch if numeric
          JZ        LISTCD20
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX   ;get length, save address
          INC       AUX00
          TEST      CH,0F0H     ;branch if length > 15
          JNZ       LISTCD11
          CMP       WORD PTR [R4],15       ;branch if no. of elements > 15
          JA        LISTCD11
          MOV       BL,R4
          MOV       AL,CH
          MUL       BL
          MOV       DL,AL
          CMP       DL,10H      ;branch if length < 16
          JB        LISTCDXX

LISTCD11: MOV       DL,10H      ;truncate length to 16

LISTCDXX: MOV       AUX05,EDX   ;save "length"
          MOV       R0,CH
          CALL      WRTVAL8     ;output length
          CALL      ATCOL0E     ;space to column 14

;------------------- alpha value (ascii and hex) --------------------------------

          MOV       EDX,AUX05
          MOV       R0,DL       ;get length
          MOV       R1,0
          MOV       EDX,AUX00   ;get address
          CALL      A$TRACE     ;output value
          JMP       LISTCD90

;------------------- numeric value ----------------------------------------------

;         Entry:  PHPL points at value
;                 F5F4 = no. of elements
;

LISTCD20:
        MOV     AUX03,EDX
        CALL    ATCOL0E            ;space to column 14

LISTCD21:
        MOV     EDX,AUX03
        CALL    VVFMTA             ;format value
        CALL    MVSCRTCH           ;move to output buffer
        XCHG    EDX,CHARCNT
        MOV     R1,DL
        MOV     AL,R0
        ADD     R1,AL
        XCHG    EDX,CHARCNT
        MOV     AL,R1              ;branch if value won't fit on line
        AND     AL,0F0H
        CMP     AL,50H
        JE      LISTCD90
        CALL    WRTBLK             ;output value

        MOV     EDX,AUX03
        ADD     EDX,8              ;point to next value
        MOV     AUX03,EDX
        DEC     WORD PTR [R4]      ;decrement element count
        CMP     WORD PTR [R4],0    ;branch if more
        JNE     LISTCD21

;------------------ end of value -----------------------------------------------

LISTCD90:
        CALL    LCPRNTCR             ;output CR
        MOV     AL,R7
        AND     AL,03H
        CMP     AL,03H
        JE      LISTCD35
        JMP     LISTCD3

LISTCD33:
        MOV     R7,3                 ;SET COM/DIM FLAG
        TEST    SL,XPHASE            ;DONE IF NOT EXECUTION PHASE
        JZ      LISTCD99
        CALL    PRTCTERR             ;ERROR IF PROTECT FLAG IS ON
        MOV     EAX,DWORD PTR [CPBASE]
        MOV     EDX,DWORD PTR [EAX].@VAREND    ;GET END OF SYMBOL TABLE ADDR
        MOV     AUX08,EDX            ;SAVE END OF SYMBOL TABLE
        MOV     EDX,DWORD PTR [EAX].@COMPTR    ;GET CVP ADDRESS
        MOV     AUX07,EDX            ;SAVE CVP ADDRESS
        XCHG    EDX,AUX08            ;RETRIEVE END OF SYMBEL TABLE ADDRESS
        MOV     DWORD PTR [A4],EDX
        XCHG    EDX,AUX08            ;RESTORE PC
        MOV     DWORD PTR [A2],EDX
        CMP     EDX,DWORD PTR [A4]
        JB      LISTCD34             ;TEST READ ADDR AGAINST END OF SYMBOL TABLE
        MOV     EDX,VARPTR           ;RETRIEVE BOTTOM OF SYMBOL TABLE
        MOV     DWORD PTR [A2],EDX
        MOV     AUX07,EDX            ;SAVE NEW LOW END ADDRESS
        CMP     DWORD PTR [A4],EDX
        JBE     LISTCD99             ;TEST LOW END ADDR AGAINST HIGH END ADDR
        CALL    LISTCD40             ;NO COM'S DRAW LINE

;**************** COM/DIM GET NEXT VARIABLE NAME & TYPE **********************

LISTCD34:
        MOV     EDX,DWORD PTR [A2]   ;NEXT VARIABLE ADDRESS
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     AUX06,EDX            ;SAVE CURRENT VARIABLE ADDR & READ
        MOV     AUX05,EDX            ;SAVE NEXT READ LOCATION
        ADD     AUX05,2
        MOV     EDX,ECX
        XCHG    EDX,AUX05            ;SAVE VARIABLE NAME & TYPE
        CALL    NEXTVARL             ;F3F2=NEXT VAR ADDRESS IN VARAIBLE TABLE
        MOV     EDX,AUX08            ;RESTORE END SYMBOL ADDR
        CMP     DWORD PTR [A2],EDX
        JB      LISTCD34             ;MORE VARIABLES - BRANCH

;********************* COM/DIM SET UP & DISPLAY VARIABLE ****************************

        MOV     EDX,AUX05            ;GET VARIABLE NAME & TYPE
        MOV     WORD PTR [R2],DX
        MOV     EDX,AUX06            ;RESTORE LOCATION OF VARIABLE
        MOV     AUX08,EDX            ;SAVE NEW SYMBOL END ADDR
        MOV     AUX03,EDX
        XCHG    EDX,AUX03            ;INCREMENT AUX3 TO POINT
        ADD     AUX03,2
        XCHG    EDX,AUX03            ;AT NO OF ELEMENTS FOR THE
        XCHG    EDX,AUX03
        ADD     AUX03,4              ;CURRENT VARIABLE
        JMP     LISTCD6              ;BRANCH TO OUTPUT ROUTINES

;********************* COM/DIM TEST FOR MORE VARIABLES ***********************

LISTCD35:
        MOV     EDX,AUX07            ;RESTORE CVP ADDRESS
        MOV     DWORD PTR [A2],EDX
        MOV     EDX,AUX08            ;RESTORE SYMBOL TABLE END MEMORY ADDR
        CMP     DWORD PTR [A2],EDX
        JB      LISTCD34             ;TEST CVP AGAINST SYMBOL TABLE ADDR
        MOV     EDX,VARPTR           ;RETRIEVE BOTTOM OF SYMBOL TABLE
        MOV     DWORD PTR [A2],EDX
        MOV     AUX07,EDX            ;SAVE NEW LOW END ADDRESS
        MOV     EDX,AUX08            ;RETRIEVE SYMBOL TABLE END ADDRESS
        CMP     DWORD PTR [A2],EDX
        JB      LISTCD41             ;BRANCH IF MORE VARIABLES
        MOV     EAX,DWORD PTR [CPBASE]
        MOV     ECX,DWORD PTR [EAX].@COMPTR    ;GET CVP - RETURNED IN CHCL
        CMP     DWORD PTR [A2],ECX
        JB      LISTCD99             ;DIM'S PRINTED DON'T DRAW LINE - EXIT
        CALL    LISTCD40             ;NO DIM'S PRINTED DRAW LINE
        JMP     LISTCD99             ;THEN EXIT

LISTCD41:
        CALL    LISTCD40             ;DIM'S PRESENT DRAW LINE
        JMP     LISTCD34             ;MORE VARIABLES

;**************** COM/DIM - END OF COMMON VARIABLES PRINT CR AND DRAW LINE *********

LISTCD40:
        MOV     R0,0                 ;INITIALIZE LOOP COUNTER

LISTCD36:
        CALL    TWRITEMN             ;DISPLAY A "-"
        INC     R0
        CMP     R0,0FH
        JNE     LISTCD36             ;TEST FOR LOOP MAX
        JMP     PRNTCR               ;PRINT CR AND RETURN BACK

;   LISTSLCT: process a LIST SELECT statement
;
;         Entry:    TEXTPTR points after SELECT
;                   TEXTLPTR points to current text line
;
;         Note:     New LIST SELECT added in CS/386 Version
;

LISTSLCT: TEST      SL,XPHASE   ;branch if not execution phase
          JZ        LISTDT99
          MOV       R0,@SELECT
          CALL      WRTWORDF    ;'SELECT'
          CALL      TWRIT4SP    ;'    '
          MOV       K,'R'
          MOV       EDX,MATHMODE
          AND       DL,30H
          CMP       DL,10H
          JNE       LISTSLT0
          MOV       K,'D'
LISTSLT0: CMP       DL,20H
          JNE       LISTSLT1
          MOV       K,'G'
LISTSLT1: CALL      TWRITE      ;'R' OR 'D' OR 'G'
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       R0,@ERROR
          CALL      WRTWORDF    ;'ERROR'
          MOV       K,'>'       ;'>'
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,MATHMODE
          SHR       DH,4
          ADD       DH,30H
          CMP       DH,30H
          JE        LISTSLT2
          MOV       K,DH
          CALL      TWRITE      ;DIGIT
LISTSLT2: MOV       EDX,MATHMODE
          AND       DH,0FH
          ADD       DH,30H
          MOV       K,DH
          CALL      TWRITE      ;DIGIT
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,MATHMODE
          AND       DL,0C0H
          CMP       DL,0C0H
          JNE       LISTSLT3
          MOV       K,'N'       ;'NO'
          CALL      TWRITE
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
LISTSLT3: MOV       R0,@ROUND
          CALL      WRTWORDF    ;'ROUND'
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       K,'P'
          CALL      TWRITE
          MOV       EDX,COUNTS
          AND       DH,0FH
          ADD       DH,30H
          CMP       DH,30H
          JE        LISTSLT5
          MOV       K,DH
          CALL      TWRITE
          JMP       LISTSLT4
LISTSLT5: MOV       K,' '
          CALL      TWRITE
LISTSLT4: MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       K,'L'
          CALL      TWRITE
          MOV       K,'I'
          CALL      TWRITE
          MOV       K,'N'
          CALL      TWRITE
          MOV       K,'E'
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       AL,BYTE PTR [EDX].@LINES
          MOV       R0,AL
          MOV       R1,0
          CALL      BINDEC
          CALL      WRTLINE_
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          TEST      COUNTS,01000H
          JZ        SLCTSLT6
          MOV       K,'N'
          CALL      TWRITE
          MOV       K,'E'
          CALL      TWRITE
          MOV       K,'W'
          CALL      TWRITE
          JMP       SLCTSLT7
SLCTSLT6: MOV       K,'O'
          CALL      TWRITE
          MOV       K,'L'
          CALL      TWRITE
          MOV       K,'D'
          CALL      TWRITE

SLCTSLT7: MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       K,'T'
          CALL      TWRITE
          MOV       K,'I'
          CALL      TWRITE
          MOV       K,'M'
          CALL      TWRITE
          MOV       K,'E'
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@spreg6,1
          JE        SLCTSLTXX
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,'F'
          CALL      TWRITE
          MOV       K,'F'
          CALL      TWRITE
          jmp       slctsltyy
SLCTSLTXX:
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,'N'
          CALL      TWRITE
slctsltyy:
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          MOV       K,'H'
          CALL      TWRITE
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,'G'
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@spreg5,1
          JE        SLCTSLTZZ
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,'F'
          CALL      TWRITE
          MOV       K,'F'
          CALL      TWRITE
          jmp       slctsltaa
SLCTSLTZZ:
          MOV       K,'O'
          CALL      TWRITE
          MOV       K,'N'
          CALL      TWRITE
slctsltaa:
          CALL      PRNTCR      ;CR
          CALL      PRNTCR

          MOV       R0,@SELECT
          CALL      WRTWORDF    ;'SELECT'
          CALL      TWRIT4SP    ;'    '

;=================== CI /xyy    ==============================================

          MOV       R0,@CI
          CALL      WRTWORDF    ;'CI'
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVTBL
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE

;=================== INPUT /xyy =================================================

          MOV       R0,@INPUT
          CALL      WRTWORDF    ;'INPUT '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVINPT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE

;=================== PLOT /xyy =================================================

          MOV       R0,@PLOT
          CALL      WRTWORDF    ;'PLOT'
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVPLOT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE

;=================== TAPE /xyy =================================================

          MOV       R0,@TAPE
          CALL      WRTWORDF    ;'TAPE'
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVTAPE
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          CALL      PRNTCR      ;CR
          CALL      PRNTCR      ;CR

          MOV       R0,@SELECT
          CALL      WRTWORDF    ;'SELECT'
          CALL      TWRIT4SP    ;'    '

;=================== PRINT /xyy  width xx ====================================

          MOV       R0,@PRINT
          CALL      WRTWORDF    ;'PRINT '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVPRNT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2
          CALL      WRTDADDR    ;/xyy
          MOV       K,'('
          CALL      TWRITE
          MOV       EDX,AUX00
          CALL      LDTWIDTHX   ;'  width xxx' CR
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE

;=================== LIST /xyy  width xx ====================================

          MOV       R0,@LIST
          CALL      WRTWORDF    ;'LIST '
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVLIST
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       AUX00,EDX
          ADD       AUX00,2
          CALL      WRTDADDR    ;/xyy
          MOV       K,'('
          CALL      TWRITE
          MOV       EDX,AUX00
          CALL      LDTWIDTHX   ;'  width xxx' CR
          MOV       K,','
          CALL      TWRITE
          MOV       K,' '
          CALL      TWRITE

;=================== CO /xyy  width xx =======================================

          MOV       R0,@CO
          CALL      WRTWORDF    ;'CO'
          MOV       K,' '
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVCO
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy
          MOV       K,'('
          CALL      TWRITE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVCO
          ADD       EDX,2
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      LDTWIDTHX   ;'  width xxx' CR
          CALL      PRNTCR      ;CR
          CALL      PRNTCR      ;CR

          MOV       R0,@SELECT
          CALL      WRTWORDF    ;'SELECT'
          CALL      TWRIT4SP    ;'    '

;=================== DISK /xyy   ============================================

          MOV       R0,@DISK
          CALL      WRTWORDF    ;'DISK'
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVDISK
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CALL      WRTDADDR    ;/xyy

          CALL      LPRNTCR     ;CR
          CALL      PRNTCR      ;CR
          JMP       LISTDONE

;  LCPRNTCR:  print a carriage return if not already at beginning of line.  If
;             HALT pressed, exit to LISTDONE.
;
;        This routine is for use by LIST.
;
;        Modified registers:  CHCL,F1,K
;

LCPRNTCR:
          CALL    CPRNTCR               ;print CR if not at begin of line
          TEST    SH,20H
          JNZ     LISTDONE              ;stop LIST if HALT pressed
          RET                           ;return if no HALT

CODE      ENDS
          END
