          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    DEFFN
PUBLIC    DEFN?QUADD
PUBLIC    DO
PUBLIC    DOCHECK
PUBLIC    ELSE_
PUBLIC    END_
PUBLIC    ENDDO
PUBLIC    ERR_16B
PUBLIC    ERR_29H
PUBLIC    ERR_34C
PUBLIC    ERR_34D
PUBLIC    ERROR_31
PUBLIC    ERRSTMT
PUBLIC    GOSUB
PUBLIC    GOSUBA
PUBLIC    GOSUBPI
PUBLIC    GOTO
PUBLIC    GOTOB
PUBLIC    IF_
PUBLIC    IFB_
PUBLIC    LET
PUBLIC    LETA
PUBLIC    NEXTSTMT
PUBLIC    REM
PUBLIC    REMCO
PUBLIC    REMNULL

EXTRN     $CLOSEA :NEAR
EXTRN     A$TRACE :NEAR
EXTRN     ALPHA   :NEAR
EXTRN     ALPHEXPR:NEAR
EXTRN     ANVARR  :NEAR
EXTRN     ARECEV  :NEAR
EXTRN     AVARD   :NEAR
EXTRN     AVARR   :NEAR
EXTRN     CCL     :NEAR
EXTRN     CCNL    :NEAR
EXTRN     CPRNTCR :NEAR
EXTRN     DEF1STMT:NEAR
EXTRN     DEFFN@  :NEAR
EXTRN     ENBLCO  :NEAR
EXTRN     ENBLNULL:NEAR
EXTRN     ENDMSG  :NEAR
EXTRN     ENDSP   :NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTA:NEAR
EXTRN     ENDSTMTC:NEAR
EXTRN     ENDSTMTF:NEAR
EXTRN     ENDSTMTG:NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ENTERA  :NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_04:NEAR
EXTRN     ERROR_07:NEAR
EXTRN     ERROR_10:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_16:NEAR
EXTRN     ERROR_19:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     EXPR    :NEAR
EXTRN     FINDDEF@:NEAR
EXTRN     IMMEDERR:NEAR
EXTRN     INITSTKS:NEAR
EXTRN     INTEGER :NEAR
EXTRN     LETRDIGT:NEAR
EXTRN     LINE_REF:NEAR
EXTRN     LITERAL :NEAR
EXTRN     MVSCRTCH:NEAR
EXTRN     PRINTVA :NEAR
EXTRN     RECEV   :NEAR
EXTRN     RECNUM  :NEAR
EXTRN     RELEXPR :NEAR
EXTRN     RSTRSTKS:NEAR
EXTRN     SCANCHA :NEAR
EXTRN     SCANCHBX:NEAR
EXTRN     SCNCHSS :NEAR
EXTRN     SLCT@OFF:NEAR
EXTRN     SWITCH  :NEAR
EXTRN     TRACDSBL:NEAR
EXTRN     TRACELIN:NEAR
EXTRN     TRACENBL:NEAR
EXTRN     TRLINE_ :NEAR
EXTRN     TRLINE_A:NEAR
EXTRN     TRLINE_B:NEAR
EXTRN     VAR     :NEAR
EXTRN     VARR    :NEAR
EXTRN     VERBCHK :NEAR
EXTRN     VJUMP   :NEAR
EXTRN     VVFMT   :NEAR
EXTRN     WRTSTRCM:NEAR
EXTRN     _DO     :NEAR

EXTRN     @@OSEND :DWORD
EXTRN     @@VSEND :DWORD
EXTRN     CPBASE  :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;      ***********************************                                     ;
;      *                                 *                                     ;
;      *  MODULE-04: GENERAL STATEMENTS  *                                     ;
;      *                                 *                                     ;
;      ***********************************                                     ;
;                                                                              ;
;                                                                              ;
;      DESCRIPTION: GENERAL BASIC STATEMENTS                                   ;
;                     DEFFN    REM      IF                                     ;
;                     LET      GOTO     GOSUB                                  ;
;                     ELSE                                                     ;
;                                                                              ;
;      ENTRY: BRANCH TO APPROPRIATE STATEMENT ROUTINE.                         ;
;             TEXTPTR POINTS AFTER VERB.                                       ;
;             TEXTLPTR POINTS TO CURRENT LINE.                                 ;
;                                                                              ;
;      EXIT: BRANCH TO 'ENDSTMT','ENDSTIO',OR 'ERROR'                          ;
;                                                                              ;
;------------------------------------------------------------------------------;



;      DEFFN: PROCESS A 'DEFFN' STATEMENT
;
;           FORM 1 (USER DEFINED FUNCTION):
;
;                DEFFN letter (num-scalar) = expression
;                      digit
;
;           FORM 2 (SUBROUTINE MARK):
;
;               DEFFN' integer [(variable [,variable...])]
;           FORM 3 (TEXT ENTRY DEFINITION):
;
;                DEFFN' integer literal [; literal...]
;
;           ENTRY: TEXTPTR POINTS AFTER 'DEFFN'
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2


DEFFN:    CMP     BYTE PTR [TEXTPTR],'@'          ;LOOK FOR '@'
          JNE     DEFFN9
          INC     TEXTPTR
          JMP     DEFFN@                          ;F, BRANCH
DEFFN9:   TEST    SL,2                            ;
          JZ      DEFFN10                         ;
          JMP     REM                             ;SLIDE OVER STMT IF EXECUTION PHASE
DEFFN10:  TEST    MODE,00000002H                  ;ERROR IF IMMEDIATE EXECUTION
          JNZ     ERROR_07
          CALL    LETRDIGT                        ;LOOK FOR LETTER OR DIGIT
          TEST    R0,0FH                          ;
          JNZ     DEFFN1                          ;NF, BRANCH

;      USER DEFINED FUNCTION
;
          TEST    SL,1                            ;BRANCH IF NOT RES PHASE
          JZ      DEFFN5
          MOV     EAX,TEXTLPTR                    ;EAX = ADDRESS CURRENT LINE
          MOV     EDX,DWORD PTR [CPBASE]
          MOV     ECX,DWORD PTR [EDX].@DEFNADR    ;GET PTR TO 1ST DEFFN
          CMP     ECX,0                           ;BRANCH IF CURRENT DEFFN NOT 1ST
          JNE     DEFFN5                          ;
          MOV     DWORD PTR [EDX].@DEFNADR,EAX    ;1ST DEFFN PTR POINT TO CURRENT LINE
DEFFN5:   CMP     BYTE PTR [TEXTPTR],'('          ;LOOK FOR '('
          JNE     ERROR_10
          INC     TEXTPTR
          MOV     K,1                             ;
          CALL    VAR                             ;LOOK FOR NUMERIC SCALAR VARIABLE
          CMP     BYTE PTR [TEXTPTR],')'          ;LOOK FOR ')'
          JNE     ERROR_11
          INC     TEXTPTR
          CMP     BYTE PTR [TEXTPTR],'='          ;LOOK FOR '='
          JNE     ERROR_12
          INC     TEXTPTR
          CALL    EXPR                            ;SCAN EXPRESSION
          JMP     ENDSTMT                         ;EXIT

;      SPECIAL FUNCTION DEFINITION
;

DEFFN1:   CMP     BYTE PTR [TEXTPTR],27H          ;LOOK FOR SINGLE QUOTE
          JNE     ERROR_16
          INC     TEXTPTR
          JMP     DEFFN12                         ;BRANCH IF FOUND
ERR_16B:  JMP     ERROR_16                        ;MISSING LETTER
DEFFN12:  CALL    DEF1STMT                        ;MAKE SURE DEFFN' IS 1ST STMT ON LINE
          CALL    INTEGER                         ;LOOK FOR INTEGER
          TEST    R0,0FH                          ;BRANCH IF NF
          JNZ     ERR_34D                         ;
          CMP     R2,0                            ;ERROR IF INTEGER > 255
          JNE     ERR_34D                         ;
          CALL    DEFN?QUADD                      ;ADD DEFFN' ENTRY TO TABLE (IF NOT FULL)
          CMP     BYTE PTR [TEXTPTR],'('          ;LOOK FOR '('
          JNE     DEFFN3                          ;BR, IF NF
          INC     TEXTPTR

;      SUBROUTINE MARK
;

DEFFN2:   CALL    AVARD                           ;LOOK FOR ALPHA VARIABLE
          TEST    R0,0FH                          ;BRANCH IF FOUND
          JZ      DEFFN11                         ;
          MOV     K,0                             ;
          CALL    VAR                             ;LOOK FOR NUMERIC VARIABLE
DEFFN11:  CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     DEFFNX
          INC     TEXTPTR                         ;BRANCH IF FOUND
          JMP     DEFFN2                          ;
DEFFNX:   CMP     BYTE PTR [TEXTPTR],')'          ;LOOK FOR ')'
          JNE     ERROR_11
          INC     TEXTPTR
          JMP     ENDSTMT                         ;EXIT

;
;      TEXT ENTRY DEFINITION
;

DEFFN3:   CALL    LITERAL                         ;LOOK FOR LITERAL
          TEST    R0,0FH                          ;BRANCH IF NOT FOUND
          JNZ     DEFFN4                          ;
          CMP     BYTE PTR [TEXTPTR],';'          ;LOOK FOR ;
          JNE     DEFFN4
          INC     TEXTPTR                         ;BRANCH IF F
          JMP     DEFFN3                          ;
DEFFN4:   JMP     ENDSTMT                         ;EXIT
ERR_34D:  JMP     ERROR_34                        ;


;      DEFN'ADD: ADD DEFFN' ENTRY TO DEFFN' TABLE (IF NOT
;                ALREADY FULL)
;
;           ENTRY: F1 = DEFFN' integer   (0 - 255)
;
;           DEFN'TBL  (maximum of 6 entries):
;
;                no. of entries
;                a          address of DEFFN'a line
;                b          address of DEFFN'b line
;                c          address of DEFFN'c line
;                d          address of DEFFN'd line
;                e          address of DEFFN'e line
;                f          address of DEFFN'f line
;
;           MODIFIED REGISTERS: F0,6,7,PC'S,CH,CL
;

DEFN?QUADD:
          TEST    SL,1                            ;BRANCH IF NOT RPHASE
          JZ      DEFN?QUAD1                      ;
          MOV     EDX,DWORD PTR [CPBASE]
          LEA     EDX,[EDX].@DFN?QUTBL    ;GET ENTRY COUNT
          MOV     CH,BYTE PTR [EDX]       ;GET ENTRY COUNT
          CMP     CH,6
          JE      DEFN?QUAD1              ;BRANCH IF TABLE FULL
          INC     BYTE PTR [EDX]          ;INCREMENT ENTRY COUNT
          XOR     EAX,EAX
          XOR     EBX,EBX
          MOV     AL,CH
          MOV     BL,CH
          SHL     EAX,2
          ADD     EAX,EBX                          ;AL = 5 * (NO. OF ENTRIES)
          ADD     EDX,EAX
          INC     EDX
          MOV     AL,R1
          MOV     BYTE PTR [EDX],AL               ;'XX ==> TABLE
          MOV     EAX,TEXTLPTR
          MOV     DWORD PTR [EDX+1],EAX           ;ADDRESS OF DEFFN' LINE ==> TABLE
DEFN?QUAD1:
          RET


;      LET: PROCESS A LET STATEMENT
;
;           STMT FORMAT:
;                [LET] numeric-var, num-var,...=expression
;                [LET] alpha-var,alpha-var,...=alpha-expr
;
;           ENTRY: TEXTLPTR POINTS TO CURRENT LINE
;                  TEXTPTR POINTS AFTER WORD 'LET'
;
;           EXIT: ENDST,ERROR
;
;           MODIFIED REGS: ALL,AUX0-5
;                     AUXF (EXECUTION PHASE ONLY)
;

LET:      CALL    TRACENBL                        ;ENABLE TRACE IF TRACE ON
          TEST    SL,2                            ;BRANCH IF XPHASE
          JNZ     LET4                            ;
          CALL    AVARR                           ;LOOK FOR ALPHA RECEIVER
          TEST    R0,0FH                          ;F, BRANCH
          JZ      LETA                            ;
          JMP     LET5                            ;
LET4:     CALL    ANVARR                          ;LOOK FOR ALPHA OR NUMERIC RECEIVER
          MOV     EDX,OSPTR                       ;
          CMP     BYTE PTR [EDX],@NUMREC
          JE      LETN                            ;BRANCH IF NUMERIC
          JMP     LETA                            ;BRANCH IF ALPHA

;
;      NUMERIC LET
;

LET3:     CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     ERROR_13
          INC     TEXTPTR
LET5:     CALL    VARR                            ;LOOK FOR NUMERIC RECEIVER VARIABLE
LETN:     CMP     BYTE PTR [TEXTPTR],'='          ;LOOK FOR '='
          JNE     LET3
          INC     TEXTPTR
          CALL    RECNUM                          ;GET NUMERIC VALUE AND SET RECEIVERS = VALUE
          JMP     LET1

;
;      ALPHA LET
;

LETA1:    CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     ERROR_13
          INC     TEXTPTR
LETA6:    CALL    AVARR                           ;LOOK FOR ALPHA RECEIVER VARIABLE
          TEST    R0,0FH                          ;ERROR IF NOT FOUND
          JNZ     ERR_29H                         ;ERROR

LETA:     CMP     BYTE PTR [TEXTPTR],'='
          JNE     LETA1
          INC     TEXTPTR
LETA2:    MOV     AUX05,TEXTPTR                   ;SAVE TEXTPTR (TO ALPHA EXPRESSION)
LETA3:    MOV     TEXTPTR,AUX05                   ;POINT TO EXPRESSION
          CALL    ALPHEXPR                        ;SCAN & EVALUATE ALPHA EXPRESSION
          TEST    SL,2                            ;BRANCH IF NOT XPHASE
          JZ      LET2                            ;
          MOV     AUX01,EDX                       ;SAVE ADDRESS OF LAST RECEIVER
          MOV     EDX,OSPTR                       ;
          CMP     BYTE PTR [EDX],@ALPHREC
          JE      LETA3                           ;BRANCH IF MORE RECEIVERS
          TEST    MODE,00000004H
          JZ      LET2                            ;BRANCH IF TRACE NOT ON
          MOV     EDX,AUX01                       ;PC'S = ADDRESS OF LAST RECEIVER
          CALL    A$TRACE                         ;OUTPUT ALPHA VALUE IN ASCII AND HEX
LETA5:    CALL    CPRNTCR                         ;OUTPUT CR IF NOT AT BEGIN OF LINE
LET1:     CALL    TRACDSBL                        ;DISABLE TRACE
LET2:     JMP     ENDSTMTZ                        ;EXIT
ERR_29H:  JMP     ERROR_29                        ;MISSING ALPHA VARIABLE


;      REMNULL: ENABLE NULL DEVICE & GOTO REM LOGIC
;      REM: PROCESS A REM STATEMENT
;
;           STMT FORMAT: REM character-string
;
;                CHARACTER STRING MUST NOT CONTAIN COLONS.
;
;           ENTRY: TEXTPTR POINTS AFTER 'REM'
;                  TEXTLPTR POINTS TO CURRENT LINE.
;

REMCO:
REMNULL:  CALL    ENBLNULL                        ;DISABLE ALL DEVICES (IE, ENABLE NULL)
REM:      cmp     byte ptr [textptr],20h          ;
          jne     rema
          inc     textptr
          jmp     rem
rema:     cmp     byte ptr [textptr],'%'
          jne     remz
          inc     textptr
remc:     cmp     byte ptr [textptr],20h
          jne     remb
          inc     textptr
          jmp     remc
remb:     cmp     byte ptr [textptr],'%'
          jne     remz
          inc     textptr
          jmp     vjump
remz:     MOV     R0,':'                          ;
          CALL    SCANCHA                         ;SCAN FOR COLON
          CMP     R0,2
          JE      REM2                            ;SKIP IF STMT SEPARATOR FOUND
          CMP     R0,1
          JE      REM3                            ;SKIP IF CR FOUND
          JMP     ENDSTMTF                        ;CHANGE COLON TO SEPARATOR
REM2:     JMP     ENDSTMTG                        ;BR, IF COLON OR SEPARATOR FOUND
REM3:     JMP     ENDSTMTC                        ;


;      GOTO: PROCESS A GOTO STATEMENT. TRANSFER EXECUTION
;            TO SPECIFIED LINE.
;
;           STMT FORMAT: GOTO line-number
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE.
;
;           EXITS: ENDSTMT (ENTRY, RESOLUTION, IMMEDIATE
;                          EXECUTION)
;                  ENDSTMTA (EXECUTION PHASE & PROGRAM
;                          EXECUTION)
;                  ERROR#11
;
;      GOTOB:  TRANSFER TO SPECIFIED LINE
;
;           ENTRY:  'TRLINE#' ALREADY CALLED
;

GOTO:     TEST    MODE,00000002H                  ;BR, IF NOT IMMEDIATE MODE
          JZ      GOTO9
          MOV     EDX,DWORD PTR [CPBASE]          ;IBASE=CPBASE IF IMMED. MODE
          MOV     DWORD PTR [EDX].@IBASE,EDX
GOTO9:    TEST    SL,2
          JNZ     GOTO_99
          CALL    TRLINE_A                        ;LOOK FOR LINE NO. REFERENCE
          JMP     GOTOB
GOTO_99:  CMP     BYTE PTR [EDX].@SPREG3,0
          JE      GOTO_99X
GOTO_99Z: CALL    TRLINE_A
          JMP     GOTO_99Y
GOTO_99X: TEST    MODE,00000020H
          JZ      GOTO_99Z
          MOV     EDX,DWORD PTR [TEXTPTR+3]
          ADD     TEXTPTR,7
GOTO_99Y: ADD     EDX,4
          TEST    MODE,0002H                      ;BR, IF NOT IMMEDIATE MODE
          JZ      GOTO2                           ;
          JMP     GOTO77                          ;BR TO IMMEDIATE MODE
GOTOB:    TEST    SL,2                            ;BR, IF NOT XPHASE
          JZ      GOTO1                           ;
          ADD     EDX,4                           ;
          TEST    MODE,0002H                      ;BR, IF NOT IMMEDIATE MODE
          JZ      GOTO2                           ;

;
;      IMMEDIATE EXECUTION -- SET CONTINUE INFO. TO
;           REFERENCED LINE.
;
;           >>>>> DATAPTRS NOT ZEROED AS IN 2200 ?? <<<<<
;

GOTO77:   MOV     DX,WORD PTR [TEXTPTR-6]         ;GET LINE NO.
          XCHG    DH,DL
          MOV     CONTLN_,EDX                     ;CONTINUE LINE # = REFERENCE LINE#
          AND     DWORD PTR [STMTCNT],000000FFH   ;CONTINUE STMT COUNT = 0
GOTO1:    JMP     ENDSTMT                         ;

;
;      PROGRAM EXECUTION
;

GOTO2:
GOTOA:    PUSH    EDX                             ;SAVE PC'S
          CALL    TRACENBL                        ;TURN ON TRACE IF TRACE MODE
          POP     EDX                             ;RESTORE PC'S
          MOV     TEXTLPTR,EDX                    ;TEXTLPTR PT TO REFERENCED LINE
          SUB     TEXTLPTR,4
          MOV     TEXTPTR,EDX                     ;TEXTPTR PT TO AFTER LINE# IN REF LINE
          ADD     TEXTPTR,2
          CALL    TRACELIN                        ;PRINT'TRANSFER TO XXXX' MESSAGE IF TRACE MODE
GOTO3:    XOR     EDX,EDX                         ;PC'S =0
          MOV     K,0                             ;
          MOV     STMTCNT,0                       ;STATEMENT COUNT = 0
          JMP     ENDSTMTA                        ;


;      GOSUB: PROCESS A 'GOSUB' STATEMENT
;
;           STMT FORMAT:
;                (1)  GOSUB line-number
;                (2)  GOSUB' integer [(expr [,expr ...])]
;                                      alph   alph
;                     WHERE: alph = alpha argument
;
;           ENTRY: TEXTLPTR POINTS TO CURRENT TEXT LINE
;                  TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;           DESCRIPTION: A SUBROUTINE CALL IS MADE WHEN A
;                GOSUB STATEMENT IS EXECUTED AND A RETURN
;                FROM THE SUBROUTINE IS MADE WHEN A RETURN
;                STATEMENT IS EXECUTED.  WHEN A GOSUB IS
;                ENCOUNTERED, THE FOLLOWING OCCURS:
;                     1. CURRENT STMTCNT --> VS
;                     2. CURRENT TEXTPTR --> VS  (POINTS
;                        TO CHARACTER AFTER GOSUB STMT)
;                     3. CURRENT TEXTLPTR --> VS
;                     4. @SUBR ATOM --> OS
;                THE 12 BYTES IN THE VALUE STACK IS KNOWN
;                AS THE GOSUB GROUP AND REMAINS IN THE VS
;                UNTIL A RETURN IS EXECUTED.
;
;           GOSUB-GROUP: VALUE STACK    12 BYTES
;                -----------------------
;                ! TEXTLPTR  (4 BYTES) !
;                ! TEXTPTR   (4 BYTES) !
;                ! STMTCNT   (4 BYTES) !
;                -----------------------
;
;      GOSUBA: ENTRY POINT FOR ON-GOSUB
;
;           ENTRY: AUX0 = TEXTLPTR +2 OF LINE TO BRANCH TO
;

GOSUB:    CMP     BYTE PTR [TEXTPTR],27H        ;LOOK FOR SINGLE QUOTE
          JNE     GOSUB99
          INC     TEXTPTR          ;INC TEXTPTR
          JMP     GOSUBP           ;BR, IF FOUND (GOSUB')
;
;      GOSUB LOGIC
;

GOSUB99:  TEST    SL,2
          JNZ     GOSUB98
          CALL    TRLINE_                         ;LOOK FOR LINE NO. REFERENCE
          JMP     ENDSTMT                         ;EXIT
GOSUB98:  MOV     EDX,DWORD PTR [CPBASE]
          CMP     BYTE PTR [EDX].@SPREG3,0
          JE      GOSUB98X
GOSUB98Z: CALL    TRLINE_
          JMP     GOSUB98Y
GOSUB98X: TEST    MODE,00000020H
          JZ      GOSUB98Z
          MOV     EDX,DWORD PTR [TEXTPTR+3]
          ADD     TEXTPTR,7
GOSUB98Y: MOV     AUX00,EDX
          ADD     AUX00,4

GOSUBA:
GOSUBC:   MOV     EBX,OSPTR                       ;GET POINTER TO LAST OS ATOM
          INC     EBX                             ;INCREMENT PC'S
          CMP     EBX,DWORD PTR [@@OSEND]         ;STACK FULL
          JE      ERROR_04
          MOV     BYTE PTR [EBX],@SUBR            ;@SUBR ATOM ==> OS
          MOV     OSPTR,EBX
          MOV     ECX,VSPTR
          MOV     EAX,STMTCNT
          MOV     DWORD PTR [ECX-4],EAX           ;CURRENT STMTCNT ==> VS
          MOV     DWORD PTR [ECX-8],TEXTPTR       ;CURRENT TEXTPTR ==> VS
          MOV     EAX,TEXTLPTR
          MOV     DWORD PTR [ECX-12],EAX          ;CURRENT TEXTLPTR ==> VS
          SUB     ECX,12
          MOV     VSPTR,ECX
          CMP     ECX,DWORD PTR [@@VSEND]
          JB      ERROR_02                        ;ERROR IF VS STACK FULL
GOSUBD:   MOV     EAX,DWORD PTR [CPBASE]
          MOV     DWORD PTR [EAX].@SAVEVS,ECX     ;VSPTR ==> SAVEVS
          MOV     DWORD PTR [EAX].@SAVEOS,EBX     ;OSPTR ==> SAVEOS
          MOV     EDX,AUX00
          MOV     CX,WORD PTR [EDX]               ;
          MOV     WORD PTR [R2],CX                ;F3,2 = LINE # OF LINE TO TRANSFER TO
          JMP     GOTOA


;      GOSUBP: PROCESS A GOSUB' STATEMENT
;
;           GENERAL FORM:
;
;                GOSUB' integer [(alpha [,alpha ...])]
;                                 expr    expr
;
;           ENTRY: TEXTPTR POINTS AFTER "GOSUB'"
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;      GOSUBPI: ENTRY FROM INTERRUPT
;
;           ENTRY: AUX0 = Pointer to textline to transfer to
;                  F0   = Operator stack subroutine atom
;
;           MODIFIED REG: ALL,AUX0,1,2
;                AUXA,B IN EXECUTION PHASE ONLY
;

GOSUBP:   CALL    INTEGER                         ;LOOK FOR INTEGER
          TEST    R0,0FH                          ;BR, IF FOUND
          JZ      GOSUBP99                        ;
ERR_34C:  JMP     ERROR_34                        ;
GOSUBP99: CMP     R2,0                            ;ERROR IF INTEGER > 255
          JNE     ERR_34C                         ;
          TEST    SL,2                            ;BR, IF NOT XPHASE
          JZ      GOSUBP2                         ;
          MOV     AL,R1                           ;K = GOSUB' INTEGER
          MOV     K,AL                            ;
GOSUBPX:
          CALL    FINDDEF@                        ;SEARCH FOR DEFFN' IN @IBASE
                                                  ; THEN IN @XBASE
          MOV     DL,R3                           ;
          MOV     AUX0C,EDX                       ;SAVE OS ATOM (@SUBR OR @XSUBR)
          TEST    R0,0FH                          ;BR, IF NF
          JNZ     GOSUBP5                         ;
          CMP     BYTE PTR [TEXTPTR],'('          ;LOOK FOR '('
          JE      GOSUBPK                         ;BR, IF '(' FOUND
          CALL    SWITCH                          ;POINT TO GOSUB STATEMENT
          JMP     GOSUBP1
GOSUBPK:
          INC     TEXTPTR
          CALL    SWITCH                          ;POINT TO GOSUB STATEMENT

;      ARGUMENT PASSING LOGIC
;

          CMP     BYTE PTR [TEXTPTR],'('          ;LOOK FOR '(' IN GOSUB' STMT
          JNE     ERROR_10
          INC     TEXTPTR
          CALL    PASSARG                         ;PASS ARGUMENTS TO DEFFN' VARIABLE
          CALL    SWITCH                          ;POINT TO DEFFN' STMT
          CMP     BYTE PTR [TEXTPTR],')'          ;LOOK FOR ')'
          JNE     ERROR_11
          INC     TEXTPTR

GOSUBP1:
          MOV     EDX,AUX0B                       ;
          ADD     EDX,4
          MOV     AUX00,EDX                       ;SAVE PTR TO LINE TO TRANSFER TO
          MOV     EDX,AUX0C                       ;
          MOV     R0,DL                           ;F0 = SUBR. ATOM
GOSUBPI:
          MOV     AL,R0                           ;
          MOV     R2,AL                           ;F2 = SUBR. ATOM
          MOV     EBX,OSPTR                       ;@SUBR OR @XSUBR ATOM ==> OS
          INC     EBX
          CMP     EBX,DWORD PTR [@@OSEND]
          JE      ERROR_04
          MOV     BYTE PTR [EBX],AL
          MOV     OSPTR,EBX

          MOV     ECX,VSPTR
          MOV     EAX,STMTCNT
          MOV     DWORD PTR [ECX-4],EAX           ;CURRENT STMTCNT ==> VS
          MOV     DWORD PTR [ECX-8],TEXTPTR       ;CURRENT TEXTPTR ==> VS
          MOV     EAX,TEXTLPTR
          MOV     DWORD PTR [ECX-12],EAX          ;CURRENT TEXTLPTR ==> VS
          SUB     ECX,12
          MOV     VSPTR,ECX
          CMP     ECX,DWORD PTR [@@VSEND]
          JB      ERROR_02                        ;ERROR IF VS STACK FULL

          TEST    R2,@XSUBRL                      ;@XSUBRL = 08H
          JZ      GOSUBD                          ;BR, IF NOT GLOBAL SUBR
          MOV     EDX,DWORD PTR [CPBASE]          ;GET CURRENT IBASE & XBASE
          MOV     EAX,DWORD PTR [EDX].@XBASE
          MOV     EBX,DWORD PTR [EDX].@IBASE
          mov     dword ptr [a0],eax
          TEST    R2,@INTRPTL                     ;@INTRPTL = 04H
          JZ      GOSUBP6                         ;BR, IF NOT INTERRUPT
          MOV     EAX,EDX                         ;XBASE = CPBASE IFF INTERRUPT

GOSUBP6:
          MOV     DWORD PTR [EDX].@IBASE,EAX      ;XBASE = IBASE, IFF NOT INTERRUPT
                                                  ; OR XBASE = CPBASE, IFF INTERRUPT
          MOV     ECX,VSPTR
          mov     eax,dword ptr [a0]
          MOV     DWORD PTR [ECX-4],EAX           ;OLD XBASE --> VS
          MOV     DWORD PTR [ECX-8],EBX           ;OLD IBASE --> VS
          SUB     ECX,8
          MOV     VSPTR,ECX
          mov     ebx,osptr
          CMP     ECX,DWORD PTR [@@VSEND]
          JB      ERROR_02                        ;VS STACK FULL
          JMP     GOSUBD                          ;
;
;      ENTRY PHASE LOGIC
;

GOSUBP2:
          CMP     BYTE PTR [TEXTPTR],'('          ;LOOK FOR '('
          JNE     GOSUBP4                         ;NF, EXIT
          INC     TEXTPTR
GOSUBP3:  CALL    ALPHA                           ;LOOK FOR ALPHA VARIABLE OR LITERAL
          TEST    R0,0FH                          ;F, BR
          JZ      GOSUBP33                        ;
          CALL    EXPR                            ;SCAN EXPRESSION
GOSUBP33: CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     GOSUB44                         ;NF, BR
          INC     TEXTPTR
          JMP     GOSUBP3                         ;
GOSUB44:  CMP     BYTE PTR [TEXTPTR],')'          ;LOOK FOR ')'
          JNE     ERROR_11                        ;ERROR ,NF
          INC     TEXTPTR
GOSUBP4:  JMP     ENDSTMT                         ;EXIT
GOSUBP5:  CALL    SWITCH                          ;RESTORE TEXT PTRS TO GOSUB' STMT
ERR0R_37: MOV     R0,37H                          ;UNDEFINED DEFFN' REFERENCE
          JMP     ERROR                           ;


;      PASSARG: PASS ARGUMENTS TO A DEFFN' SUBROUTINE
;               (CALLED BY GOSUB' )
;
;           ENTRY: AUXA POINTS TO 1ST RECEIVER VARIABLE IN
;                     DEFFN' STATEMENT
;                  AUXB POINTS TO DEFFN' LINE
;                  TEXTPTR POINTS TO 1ST ARGUMENT IN ARGU-
;                     MENT LIST (GOSUB' STMT OR KBD BUFFER
;                  TEXTLPTR POINTS TO GOSUB' LINE OR KBD
;                     BUFFER
;
;           RETURN: TEXTPTR POINTS AFTER DEFFN' VARIABLE
;                          LIST
;                   TEXTLPTR POINTS TO DEFFN' LINE
;                   AUXA POINTS AFTER ARGUMENT LIST (IN
;                          IN GOSUB' STMT OR KBD BUFFER)
;                   AUXB POINTS TO GOSUB' STMT OR KBD BUFR
;
;           MODIFIED REGISTERS: ALL, AUX0,1,2,A,B
;
;           >>>>>  NOTE, EXPR CANNOT MODIFY AUXA,B <<<<<<
;
;                  THIS CODE PROBABLY SHOULD BE PART OF
;                  GOSUB' -- NO LONGER CALLED BY KEYFUNC!
;

PASSARG3: CALL    SWITCH                          ;POINT TO ARGUMENT LIST
          CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     ERROR_13                        ;NF, ERROR
          INC     TEXTPTR
PASSARG:  CALL    SWITCH                          ;POINT TO DEFFN' STATEMENT
          CALL    AVARR                           ;LOOK FOR ALPHA RECEIVER VARIABLE
          TEST    R0,0FH                          ;NF, BR
          JNZ     PASSARG2                        ;
          CALL    SWITCH                          ;POINT TO ARGUMENT LIST
          CALL    ALPHA                           ;LOOK FOR ALPHA VARIABLE OR LITERAL
          TEST    R0,0FH                          ;F, BR
          JZ      PASSARG4                        ;
          JMP     ERROR_29                        ;NF, ERROR
PASSARG4: CALL    ARECEV                          ;RECEIVE VALUE
PASSARG1: CALL    SWITCH                          ;POINT TO DEFFN' STMT
          CMP     BYTE PTR [TEXTPTR],','          ;LOOK FOR COMMA
          JNE     PASSARGX                        ;BR, NF
          INC     TEXTPTR
          JMP     PASSARG3                        ;BR, F
PASSARGX: RET
PASSARG2: CALL    VARR                            ;LOOK FOR NUMERIC RECEIVER VARIABLE
          CALL    SWITCH                          ;POINT TO ARGUMENTS
          CALL    EXPR                            ;PROCESS EXPRESSION
          CALL    RECEV                           ;RECEIVE VALUE
          JMP     PASSARG1                        ;


;   IF:  process an IF statement
;
;           STMT FORMAT:
;                (1) IF relation THEN line-no.
;                                     statement
;                                     DO-group
;
;                (2) IF END THEN line-no.
;                                statement
;                                DO-group
;
;           ENTRY: TEXTPTR points to next text character (after IF)
;
;           RELATION-OPERATOR-ATOMS     RELATION-VALUES
;                     < -- 1               X<Y -- 1
;                    <= -- 3               X=Y -- 2
;                     = -- 2               X>Y -- 4
;                    >= -- 6
;                     > -- 4
;                    <> -- 5
;
;

; %----------------- END -------------------------------------------------------
;         This logic allows this condition as only condition in IF.  A generalization
;         allowing this condition anywhere in the relation expression might
;         be nice.
;


IF_:
IFSTMT:   MOV     R0,@END                         ;
          CALL    CCL                             ;LOOK FOR 'END'
          TEST    R0,0FH                          ;BR, NF
          JNZ     IF1_                            ;
          TEST    SL,2                            ;BR, IF NOT XPHASE
          JZ      IF2_                            ;
          mov     edx,mode
          mov     r7,dl
          and     r7,80h                          ;R7 = EOF CONDITION
          and     dl,7fh                          ;EOF OFF
          mov     mode,edx
          JMP     IF2_                            ;BRANCH TO TRUE/FALSE CHECK

;  ----------------- IF relation ------------------------------------------------

IF1_:     CALL    RELEXPR                         ;PROCESS RELATION (EG. X<Y )
IF2_:     MOV     R0,@THEN                        ;
          CALL    CCL                             ;LOOK FOR 'THEN'
          TEST    R0,0FH                          ;
          JZ      IF21                            ;BR, F
          JMP     ERROR_19                        ;ERROR IF NF

;  ----------------- THEN -------------------------------------------------------
IF21:     TEST    SL,2                            ;BR IF NOT XPHASE
          JZ      IF23                            ;
          CMP     R7,0                            ;
          JE      IFF                             ;BR, IF CONDITION FALSE
IF23:     TEST    SL,2
          JNZ     IF40
if23_x:   CALL    LINE_REF                        ;LOOK FOR LINE NUMBER
          TEST    R0,0FH                          ;BR, NF
          JNZ     IF24                            ;
          CALL    TRLINE_B                        ;FIND SPECIFIED LINE
          JMP     GOTOB
IF40:     test    mode,00000020h
          jz      if23_x
          MOV     EDX,TEXTPTR
          CMP     BYTE PTR [EDX],@LINE_
          JNE     IF24
          MOV     EDX,DWORD PTR [EDX+3]
          ADD     TEXTPTR,7
          JMP     GOTOB                           ;TRANSFER IF XPHASE

ELSEER:
IF24:     CALL    DO                              ;LOOK FOR 'DO'
          TEST    R0,0FH                          ;BR, IF NF
          JNZ     IF25
          JMP     ENDSTMT                         ;
IF25:
          TEST    SL,2                            ;BR, IF XPHASE
          JNZ     IF41
          CALL    VERBCHK                         ;CHECK LEGALITY OF NEXT VERB
IF41:     JMP     VJUMP                           ;TRANSFER TO NEXT STMT


;    IFF: IF processing for false condition
;
;         The conditionally executable text is skipped over.  This may be a
;         line number, statement, or DO-group.  Then, the next statement is
;         checked to see if it is ELSE [DO]; if found this is skipped over so
;         that the ELSE statements will be executed.
;
;         Entry:  PC's point after THEN
;                 Phase = execution
;
;    IFB: external entry point for ON (GOSUB,etc) for false condition processing
;
;         The next verb is checked to see if it is ELSE [DO]; if found, this is
;         skipped over so that the ELSE statements will be executed.
;
;         Entry:  PC's points to statement separator or CR after ON statement
;                 Phase = execution
;  ----------------- skip over DO-group -----------------------------------------

IFF:      CALL    SKIPDO                          ;SKIP OVER DO-GROUP (IF ANY)
IFB_:     CALL    NEXTSTMT                        ;SKIP TO BEGINING OF NEXT STMT
          TEST    R0,0FH                          ;BR, IF F
          JZ      IFB1                            ;
          JMP     ENDSTMT                         ;
IFB1:     CMP     BYTE PTR [TEXTPTR],@ELSE        ;LOOK FOR 'ELSE'
          JNE     ENDSTMTA
          INC     TEXTPTR

;  ----------------- skip over ELSE verb (if there is one) ----------------------

IFB2:     CALL    DO                              ;LOOK FOR 'DO'
          CMP     R0,0                            ;BR, IF F
          JE      ENDSTMT                         ;PROCESS STMT AFTER DO
          JMP     VJUMP                           ;PROCESS STMT AFTER ELSE


; ELSE:   process an ELSE statement
;
;         Format:  ELSE [DO:] statement
;
;         Entry:   TEXTPTR points after ELSE
;
;    Processing:
;
;         Entry phase:  Check for legal verb after ELSE [DO]
;                       Branch to VJUMP for verb processing.
;
;         Resolution phase:  same as entry
;
;         Execution phase: skip over ELSE statement or DO-group
;

ELSE_:
ELSESTMT: TEST    SL,2                            ;BR, IF XPHASE
          JNZ     ELSE1                           ;
          JMP     ELSEER                          ;USE IF LOGIC FOR E & R PHASES

;  ----------------- execution phase --------------------------------------------

; CHANGE ELSE LOGIC TO LOOK FOR - ELSE IF DO AND SKIP DO GROUP AS WELL
;

ELSE1:   MOV       R0,@IF
         CALL      CCL                 ;LOOK FOR IF ATOM AFTER ELSE
         TEST      R0,0FH
         JNZ       NOIFDO              ;NO IF ATOM FOUND - BRANCH
         MOV       R0,@THEN
         CALL      SCANCHA

NOIFDO:  CALL      SKIPDO

ELSE3:   CALL      NEXTSTMT            ;skip to beginning of next statement
         TEST      R0,0FH
         JZ        ELSE2               ;branch if there is one
         JMP       ENDSTMT

ELSE2:   TEST      MODE,0002H
         JNZ       ELSE4               ;branch if Immediate mode
         JMP       ENDSTMTA            ;process next statement
ELSE4:   JMP       VJUMP


; DO:     process a 'DO' verb
;
;         Entry:    TEXTPTR points to next text character
;
;         Return:   F0,bits 0F = 0 if found
;                       In resolution phase, DOFLAG turned on (<>0)
;
;                   F0,bits 0F <> 0 if not found
;
;         Modified registers:  PC's,CHCL,F0-1,AUX0,1
;
;  ################# note #######################################################
;         DOFLAG:   the DO flag is used to prevent nested DO-groups.
;                   Flag is set and checked here, and initialized at begin of
;                   resolution phase.
;
;         Adding nested DO-groups seems too hard.  In BASIC-3, skip-text ptrs were
;         inserted after THEN, ELSE, and ERROR.  The pointers were set a resolution
;         time.  This was convenient since DO-groups can be nested; thus, OS and
;         VS were used.  In BASIC-2, I am assuming that we don't want to insert
;         skip text ptrs since users' programs grow and we would have to fixup
;         SAVE to be compatible (ie, strip out skip-text ptrs.  With this assumption
;         DO-group skipping must be done at execution time.  This is hard due to
;         DO-group nesting and DO not atomized.
;  ##############################################################################

DO:       MOV     EDX,OFFSET _DO                   ;
          CALL    CCNL                            ;LOOK FOR 'DO'
          TEST    R0,0FH                          ;BR, IF NF
          JNZ     DO1                             ;
          TEST    SL,RPHASE                       ;BR, IF NOT RPHASE
          JZ      DO1                             ;
          CALL    DOCHECK                         ;MAKE SURE NOT ALREADY IN DO-GROUP
          MOV     BYTE PTR [EDX],1                ;'DO' FOUND (PREVENT NESTING)
          MOV     R0,0                            ;FLAG = 'DO' FOUND
DO1:      RET


;   END:  process an END statement
;
;         Entry:    TEXTPTR points after END
;
;           STMT FORMAT:  END
;
;           DESCRIPTION: STOPS PROGRAM EXECUTION AND
;                DISPLAYS FREE SPACE
;
;
;   ENDDO:  process an ENDDO statement
;
;         Format:   ENDDO
;
;         Processing:
;                   entry: none
;                   resolution:
;                      . check DOFLAG.  Error if not in DO-group.
;                      . clear flag
;                   execution: none
;
;         Entry:    TEXTPTR points after ENDDO
;

END_:
ENDVERB:  MOV     EDX,OFFSET _DO                   ;
          CALL    CCNL                            ;LOOK FOR 'DO'
          TEST    R0,0FH                          ;BR, IF F
          JZ      ENDDO                           ;
          TEST    SL,2                            ;BR, IF NOT XPHASE
          JZ      ENDDO2                          ;
          TEST    MODE,00000002H
          JNZ     END_1                           ;
          CALL    $CLOSEA                         ;CLOASE ALL DEVICE FOR CUR. PARTITION

;  ================= END statement ==============================================
;  (CLOSE BEFORE MSG IN CASE TERMINAL NOT ATTACHED).

END_1:    CALL    ENBLCO                          ;ENABLE CONSOLE OUTPUT
          MOV     EDX,OFFSET ENDMSG               ;OUTPUT 'END PROGRAM'
          CALL    WRTSTRCM                        ;'FREE SPACE ='
          MOV     EDX,VARPTR                      ;
          CALL    ENDSP                           ;FREE SPACE CALCULATION
;
;      PRINT FREE SPACE
;
          CALL    VVFMT                           ;FORMAT VALUE FOR PRINTING
;         CALL    DELETV8                         ;REMOVE VALUE FROM VS
          MOV     EDX,VSPTR
          ADD     EDX,8
          XCHG    EDX,VSPTR                       ;VSPTR = PC'S + 8
          CALL    MVSCRTCH                        ;MOVE VALUE TO 'IOBUFFER'
          CALL    PRINTVA                         ;PRINT VALUE
          CALL    RSTRSTKS                        ;RESTORE STACK PTRS
          TEST    MODE,00000002H                  ;BR, IF IMMEDIATE MODE
          JNZ     END_2                           ;
          CALL    INITSTKS                        ;INIT STACKS, CONTINUE ILLEGAL
END_2:    JMP     ENTERA                          ;PRINT 'CR' AND TERMINATE PRGRM EXECUTION

;  ==============================================================================

ENDDO:
          TEST    SL,RPHASE                       ;BR, IF NOT RPHASE
          JZ      ENDDO2                          ;
          MOV     EDX,DWORD PTR [CPBASE]
          CMP     BYTE PTR [EDX].@DOFLAG,0        ;BR, IF NOT IN DO-GROUP
          JE      ENDDOERR                        ;
          MOV     BYTE PTR [EDX].@DOFLAG,0        ;CLEAR FLAG
ENDDO2:   JMP     ENDSTMT                         ;

;  ----------------- look for DO atom in OS -------------------------------------

ENDDOERR: JMP     DOERR                           ;DO AND ENDDO NOT MATCHED


; ERRSTMT:  process an ERROR statement
;
;         Format:  ERROR statement [:statement]...
;                  ERROR do-group [:statement]...
;
;         Entry:   TEXTPTR points after ERROR
;
;*%----------------- DO processing ----------------------------------------------

ERRSTMT:
ERRORSTM: CALL    DO                              ;LOOK FOR 'DO'
          CMP     R0,0                            ;BR, IF NF
          JNE     ERRSTMT1                        ;
          TEST    SL,2                            ;BR, IF NOT XPHASE
          JZ      ENDSTMT
          CALL    SKIPDOG                         ;SKIP DO-GROUP IF XPHASE
          JMP     ENDSTMT                         ;
;  ----------------- verb check (no DO) -----------------------------------------
;         Certain verbs (eg, DEFFN, %) are not legal after ERROR.

ERRSTMT1: TEST    SL,2                            ;BR, IF XPHASE
          JNZ     ERRSTMT2                        ;
          CALL    VERBCHK                         ;CHECK NEXT VERB FOR LEGALITY
                                                  ; AFTER ELSE
          JMP     VJUMP                           ;
ERRSTMT2: JMP     ENDSTMTC                        ;


; DOCHECK:  check for unmatched DO and ENDDO
;
;         Error if DOFLAG is on. (ie, <>0).
;
;         Return:   PHPL points at DOFLAG
;                   CH = DOFLAG
;         Modified registers: PC's,CHCL
;

DOCHECK:
          MOV     EDX,DWORD PTR [CPBASE]          ;GET DPFLAG
          LEA     EDX,[EDX].@DOFLAG
          CMP     BYTE PTR [EDX],0        ;BR, IF IN DO-GROUP
          JNE     DOERR
          RET

ERROR_31:
DOERR:    MOV     R0,31H                          ;DO NOT MATCHED WITH DOEND
          JMP     ERROR                           ;


;   SKIPDO:  skip over a DO-group (if there is one next in program)
;
;         DO-group:  DO  statement...  ENDDO
;
;         Entry:    execution phase
;                   TEXTPTR points to next text character after DO
;
;         Return:   TEXTPTR points after 'END DO'
;
;         Error:    if no END DO found
;
;         Modified registers: PHPL,CHCL,AUXA,B,F0
;
;   SKIPDOG:  same, except DO already found
;
;  ------------------------------------------------------------------------------

SKIPDO:   CALL    DO                              ;LOOK FOR 'DO'
          TEST    R0,0FH                          ;BR, IF NF
          JNZ     SKIPDO4                         ;
SKIPDOG:  MOV     AUX0A,TEXTPTR
          MOV     EDX,TEXTLPTR                    ;SAVE TEXTLPTR'S IN CASE OF ERROR
          MOV     AUX0B,EDX                       ;
;  ----------------- save text pointers -----------------------------------------

;  ----------------- skip to next statement -----------------------------------

SKIPDO1:  CALL    NEXTSTMT                        ;SKIP TO NEXT STATEMENT
          TEST    R0,0FH                          ;BR, IF F
          JZ      SKIPDO3                         ;
          CALL    SWITCH                          ;RETRIVES TEXTPTR'S TO DO
          JMP     DOERR                           ;ERROR
;  ----------------- check if next statement is END DO --------------------------

SKIPDO3:  CMP     BYTE PTR [TEXTPTR],@END         ;LOOK FOR 'END'
          JNE     SKIPDO1                         ;BR, IF NF
          INC     TEXTPTR
          CALL    DO                              ;LOOK FOR 'DO'
          TEST    R0,0FH                          ;BR, IF NF
          JNZ     SKIPDO1

;  ----------------- END DO found------------------------------------------------

SKIPDO4:  RET


;   NEXTSTMT:  skip to beginning of the next statement
;
;         Entry:    execution phase
;                   TEXTPTR, TEXTLPTR, STMTCNT point to current text position
;
;         Return:   End of program (F0<>0)
;                      TEXTPTR points to end of program
;
;                   More statements (F0=0)
;                      TEXTPTR, TEXTLPTR, STMTCNT updated to next statement
;
;         Modified registers:  CHCL,PHPL,F0
;
;  ----------------- skip to end of current statement ---------------------------

NEXTSTMT: CALL    SCNCHSS                         ;LOOK FOR STMT SEPARATOR (NOT CR)
          TEST    R0,0FH                          ;BR IF NF
          JNZ     NXTSTMT1
          INC     STMTCNT                         ;INCREMENT STMT COUNT
          RET
;  ----------------- get to next line -------------------------------------------

NXTSTMT1: AND     STMTCNT,0FF00H                  ;ZERO STMT COUNT
          TEST    MODE,0002H                      ;BR, IF IMMEDIATE MODE
          JNZ     NXTSTMT3                        ;
          MOV     EDX,TEXTLPTR                    ;
          MOV     R0,0                            ;
          MOV     ECX,DWORD PTR [EDX]             ;GET PTR TO NEXT LINE
          CMP     ECX,0                           ;BR, IF MORE PRGM LINES
          JNE     NXTSTMT2                        ;
NXTSTMT3: MOV     R0,1                            ;FLAG = END OF PROGRAM
          RET

NXTSTMT2: MOV     EDX,ECX
          ADD     EDX,6
          MOV     TEXTLPTR,ECX
          MOV     TEXTPTR,EDX                     ;POINT TO TEXTPTR
          RET

CODE      ENDS
          END
