          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    BNFLTXXX
PUBLIC    ERROR_01
PUBLIC    ERROR_02
PUBLIC    ERROR_04
PUBLIC    ERROR_16
PUBLIC    ERROR_21
PUBLIC    ERROR_50
PUBLIC    ERROR_55
PUBLIC    ERROR_59
PUBLIC    FINDDEFC
PUBLIC    ONBRANCH
PUBLIC    RECEV
PUBLIC    RECEV2
PUBLIC    RECEVPC
PUBLIC    RECEVX
PUBLIC    RECNUM
PUBLIC    TRLINE_
PUBLIC    TRLINE_1
PUBLIC    TRLINE_A
PUBLIC    TRLINE_B
PUBLIC    FLTBNL
PUBLIC    FLTBIN
PUBLIC    FLTBINA
PUBLIC    FLTBINB
PUBLIC    FLTBINSA
PUBLIC    FLTBNCCC
PUBLIC    BINDEC
PUBLIC    BINFLT
PUBLIC    BINFLTA
PUBLIC    DVAR
PUBLIC    FINDDEF@
PUBLIC    FINDDEFD
PUBLIC    FINDDEFX
PUBLIC    FINDDFA@
PUBLIC    RELALPHB
PUBLIC    RELALPHC
PUBLIC    RELA_E
PUBLIC    RELA_B
PUBLIC    RELEXPR
PUBLIC    REL
PUBLIC    CONSOLE
PUBLIC    CONSOLEA
PUBLIC    CONSOLEP
PUBLIC    FINDVAR
PUBLIC    FINDVARL
PUBLIC    ADDVAR
PUBLIC    INITVAR
PUBLIC    CLEARN
PUBLIC    NEXTVAR
PUBLIC    NEXTVARL
PUBLIC    SBPCS

EXTRN     ALPHA     :NEAR
EXTRN     BASE      :NEAR
EXTRN     CCL       :NEAR
EXTRN     ERROR     :NEAR
EXTRN     ERROR_11  :NEAR
EXTRN     ERROR_29  :NEAR
EXTRN     ERROR_34  :NEAR
EXTRN     ERR_01    :NEAR
EXTRN     ERR_02    :NEAR
EXTRN     EXPR      :NEAR
EXTRN     FINDGRTH  :NEAR
EXTRN     FINDST2   :NEAR
EXTRN     FINDSTI   :NEAR
EXTRN     INITSTKA  :NEAR
EXTRN     INITSTKS  :NEAR
EXTRN     INTEGER   :NEAR
EXTRN     IRTEXTBG  :NEAR
EXTRN     LINE_REF  :NEAR
EXTRN     LISTVAR   :NEAR
EXTRN     MATHABS   :NEAR
EXTRN     MATHCMP   :NEAR
EXTRN     MVSCRTCH  :NEAR
EXTRN     NEWTOOLD  :NEAR
EXTRN     PMODE     :NEAR
EXTRN     PRNTCR    :NEAR
EXTRN     RELOP     :NEAR
EXTRN     SWITCH    :NEAR
EXTRN     VARNAME   :NEAR
EXTRN     VVFMT     :NEAR
EXTRN     WRTBLK    :NEAR
EXTRN     _DEVCI    :NEAR
EXTRN     _DEVCO    :NEAR
EXTRN     _DEVPLOT  :NEAR
EXTRN     _DEVTAPE  :NEAR

EXTRN     @@OSEND   :DWORD
EXTRN     @@VSEND   :DWORD
EXTRN     BOOTDEV   :WORD
EXTRN     CPBASE    :DWORD
EXTRN     PART_     :BYTE

;------------------------------------------------------------------------------;
;                                                                              ;
;      ****************************                                            ;
;      *                          *                                            ;
;      *  MODULE-06: SUBROUTINES  *                                            ;
;      *                          *                                            ;
;      ****************************                                            ;
;                                                                              ;
;------------------------------------------------------------------------------;

;      THE OPERATOR STACK (OS) IS A PUSH/POP STACK USED
;      TO STORE ATOMS FOR EXPRESSION ANALYSIS AS WELL AS
;      FOR FOR-LOOPS AND SUBROUTINES. EACH ENTRY IS A
;      SINGLE BYTE. OSPTR POINTS TO THE LAST ENTRY IN THE
;      STACK. AT THE COMPLETION OF THE EXECUTION OF A
;      STATEMENT, THE STACK ONLY CONTAINS FOR-LOOP AND
;      SUBROUTINE ATOMS.
;
;      OPERATOR STACK LOCATION: XXY0-XXZF
;           Z = Y + 3 (STACK IS 64 BYTES LONG)
;      PUSHFO: STORE CONTENTS OF REGISTER F0 IN OS.
;              ERROR IF STACK FULL.
;
;           MODIFIED REGISTERS: PC'S
;

ERROR_04:
         MOV       R0,04        ;STACK OVERFLOW
         JMP       ERROR


;      POPO: GET LAST ATOM FROM OS.
;
;           USE IN-LINE CODE:  TAP      ,OSPTR
;                              TPA-1,R  ,OSPTR
;
;           CAUTION: CARE SHOULD BE TAKEN SINCE NO CHECK
;                    OF OS FLOOR IS MADE.
;
;      THE VALUE STACK (VS) FLOATS ABOVE THE SYMBOL TABLE
;      AND IS USED TO STORE VALUES DURING EXPRESSION
;      ANALYSIS AND SUBROUTINE AND FOR-LOOP INFORMATION.
;      THE STACK MAY ALSO BE USED, WITH CAUTION, TOO AS A
;      TEMPORARY STORAGE AREA. VS IS A PUSH/POP STACK WITH
;      THE LAST VALUE POINTED TO BY VSPTR.  ENTRIES IN THE
;      STACK ARE GENERALLY EITHER 2 BYTES (E.G. ADDRESSES)
;      OR 8 BYTES (E.G. NUMERIC VALUES). THE STACK IS
;      ALIGNED ON AN EVEN BOUNDARY.
;
;
;      PUSHFV2: STORE CONTENTS OF (F1-0) IN VS
;
;           ENTRY: PHASE = EXECUTION OR RESOLUTION
;
;           RETURN: F1,0 = NEW VSPTR
;                   PC'S = VSEND
;
;           MODIFIED REGISTERS: PC'S,F0,F1
;
;      PUSHPV2: STORE CONTENTS OF PC'S IN VS
;
;      CHKVSEND: CHECK FOR STACK OVERFLOW.
;                ERROR IF PC'S < VSEND.
;
;           ENTRY: PC'S = VSPTR
;
;           RETURN: F1,0 = PC'S AT ENTRY
;                   PC'S = VSEND
;
;

ERROR_02:
        JMP     ERR_02                   ;VS OVERFLOW


;      POPV2: GET LAST 2 BYTES FROM VS.
;
;           USE IN-LINE CODE:  TAP      ,VSPTR
;                              TPA+2,R  ,VSPTR
;
;           CAUTION: CARE SHOULD BE TAKEN SINCE NO CHECK
;                    OF VS FLOOR IS MADE.
;
;      PUSHV8: STORE 8 BYTE VALUE IN VS.
;
;           ENTRY: PC'S = ADDRESS OF VALUE IN DATA MEMORY.
;                         ADDRESS MUST BE EVEN.
;                  PHASE = EXECUTION OR RESOLUTION
;
;           RETURN: F1,0 = NEW VSPTR
;                   PC'S = VSEND
;                   CH,CL = 1ST 2 BYTES OF VALUE
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0,F1
;
;
;      PUSH0V8: STORE FLOATING POINT 0 IN VS
;
;           RETURN: F1,0 = NEW VSPTR
;                   PC'S = VSEND
;
;           MODIFIED REGISTERS: PC'S,F0,F1
;
;
;================= PUSH F7-0 ONTO VALUE STACK ===================================
; PUSHVF7:  pushes registers F7-F0 onto the Value Stack.
;
;           F0 is the 1st register stored; F7 is the last register stored and
;           is thus at the top of the stack.
;
;      Modified registers: PC's
;
;
;      PUSHNTXT: STORE CURRENT TEXTPTR, TEXTLPTR, AND
;                STMTCNT IN VS
;
;           RETURN: VALUE STACK
;                ------------
;                ! TEXTLPTR !
;                ! TEXTPTR  !
;                ! STMTCNT  !
;                ------------
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0,F1
;
;
;      POPNTXT: SET TEXTLPTR, TEXTPTR, & STMTCNT TO VALUES
;               IN VALUE STACK.
;
;           ENTRY: VALUE STACK
;                ------------
;                ! TEXTLPTR !
;                ! TEXTPTR  !
;                ! STMTCNT  !
;                ------------
;
;           RETURN: TEXTLPTR,TEXTPTR,STMTCNT= VALUES IN VS
;                   PC'S POINT TO VS AFTER STMTCNT
;                   VSPTR NOT CHANGED
;
;           MODIFIED REGISTERS: PC'S,CH,CL
;
;
;      POPV8: GET THE LAST 8 BYTES FROM VS AND STORE AT
;             THE SPECIFIED ADDRESS.
;
;           ENTRY: PC'S = ADDRESS TO STORE VALUE AT.
;                         ADDRESS MUST BE EVEN.
;
;           RETURN: PC'S POINTS TO 7TH BYTE OF VALUE (NEW)
;                   CH,CL = LAST 2 BYTES OF VALUE
;
;           CAUTION: NO CHECK IS MADE OF VS FLOOR
;
;           MODIFIED REGISTERS: PC'S,CH,CL
;
;
;      DELETV8:
;
;               (VSPTR = VSPTR +8)
;
;           CAUTION: NO CHECK IS MADE OF VS FLOOR
;
;           MODIFIED REGISTERS: NONE
;
;      DELETV8A: VSPTR = PC'S + 8
;
;           RETURN: PC'S = OLD VSPTR
;
;           MODIFIED REGISTERS: PC'S
;
;
;     POPV4: GET THE LAST 4 BYTES FROM THE VS
;
;          RETURN: F1,0 = LAST 2 BYTES IN STACK
;                  PC'S & CH,CL = NEXT 2 BYTES IN STACK
;                  ABOVE 4 BYTES REMOVED FROM STACK
;
;          CAUTION: NO CHECK IS MADE OF VS FLOOR
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1
;
;     POPOV4: REMOVE LAST OS ATOM & GET THE LAST 4 BYTES
;             FROM THE VS
;
;          CAUTION: NO CHECK IS MADE OF OS OR VS FLOORS
;
;     POPVP: GET THE LAST 2 BYTES FROM THE VS AND PUT
;            INTO THE PC'S
;
;          RETURN: PC'S & CH,CL = LAST 2 BYTES IN STACK
;                  ABOVE 2 BYTES REMOVED FROM THE STACK
;
;          MODIFIED REGISTERS:  PC'S,CH,CL
;
;
;      POPRCVR: REMOVE RECEIVER INFORMATION FROM VS & OS.
;               THE LAST OS ATOM IS REMOVED. IF IT IS A
;               NUMERIC-RECEIVER-ATOM, 2 BYTES ARE REMOVED
;               FROM THE VS; IF IT IS AN ALPHA-RECEIVER
;               ATOM, 4 BYTES ARE REMOVED FROM VS.
;
;               (LAST OS ATOM MUST BE ALPHA OR NUMERIC
;                RECEIVER ATOM)
;
;           CAUTION: NO CHECK IS MADE OF OS OR VS FLOOR
;
;           MODIFIED REGISTERS: CH,CL
;
;
;      MPY8X8: MULTIPLY (BINARY) 8 BITS BY 8 BITS
;
;           ENTRY: F0 = MULTIPLIER
;                  F1 = MULTIPLICAND
;
;           RETURN: F1,0 = PRODUCT
;
;           MODIFIED REGISTERS: F0-4
;
;           ALGORITHM: LET MULTIPLIER = AB &
;                          MULTIPLICAND = CD.
;                      THEN, PRODUCT = 256(A*C)
;                                     +16(A*D+B*C)
;                                     +(B*D)
;

;      RECEV: SET THE SPECIFIED NUMERIC RECEIVER VARIABLES
;             = SPECIFIED NUMERIC VALUE. IF TRACE MODE,
;             PRINT THE NUMERIC VALUE.
;
;           ENTRY: VALUE STACK (VS) CONTAINS--
;                   -------------------------------------
;                   ! NUMERIC VALUE (8 BYTES)           !
;                   ! ADDRESS OF 1ST RECEIVER (2 BYTES) !
;                   ! ADDRESS OF 2ND RECEIVER           !
;                   !    .                              !
;                   !    .                              !
;                   !    .                              !
;                   ! ADDRESS OF LAST RECEIVER          !
;                   -------------------------------------
;
;                  OPERATOR STACK (OS) CONTAINS--
;                   -------------------------------------
;                   ! @NUMREC FOR 1ST RECEIVER          !
;                   ! @NUMREC FOR 2ND RECEIVER          !
;                   !    .                              !
;                   !    .                              !
;                   !    .                              !
;                   ! @NUMREC FOR LAST RECEIVER         !
;                   -------------------------------------
;
;                       WHERE: @NUMREC = NUMERIC RECEIVER
;                              ATOM
;
;           RETURN: VS CLEARED OF VALUE AND RECEIVER
;                        ADDRESSES.
;                   OS CLEARED OF @NUMREC ATOMS
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-3,AUX0,1,2
;                               IF TRACE MODE, K
;
;      RECNUM: SCAN AND EVALUATE AN EXPRESSION IN TEXT
;              LINE AND GOTO 'RECEV' TO SET RECEIVER
;              VARIABLES = VALUE.
;
;           ENTRY: VALUE STACK (VS) CONTAINS--
;                   -------------------------------------
;                   ! ADDRESS OF 1ST RECEIVER (2 BYTES) !
;                   ! ADDRESS OF 2ND RECEIVER           !
;                   !    .                              !
;                   !    .                              !
;                   !    .                              !
;                   ! ADDRESS OF LAST RECEIVER          !
;                   -------------------------------------
;
;                  OPERATOR STACK (OS) CONTAINS--
;                   -------------------------------------
;                   ! @NUMREC FOR 1ST RECEIVER          !
;                   ! @NUMREC FOR 2ND RECEIVER          !
;                   !    .                              !
;                   !    .                              !
;                   !    .                              !
;                   ! @NUMREC FOR LAST RECEIVER         !
;                   -------------------------------------
;
;                       WHERE: @NUMREC = NUMERIC RECEIVER
;                              ATOM
;
;           RETURN: VS CLEARED OF VALUE AND RECEIVER
;                        ADDRESSES.
;                   OS CLEARED OF @NUMREC ATOMS
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2
;
;

RECNUM: CALL    EXPR        ;SCAN AND EVALUATE EXPRESSION

RECEV:  TEST    SL,2        ;BRANCH IF NOT EXECUTION PHASE
        JZ      RECEV1
RECEVX:
        TEST    MODE,04H
        JZ      RECEV2      ;BRANCH IF NOT TRACE MODE
        CALL    VVFMT       ;FORMAT VALUE FOR PRINTING
        CALL    MVSCRTCH    ;MOVE VALUE TO 'IOBUFFER'
        CALL    WRTBLK      ;OUTPUT 'VALUE'
        CALL    PRNTCR      ;OUTPUT 'CR'

RECEV2:
        MOV     EAX,VSPTR
        ADD     VSPTR,8
RECEV4:
        MOV     EDX,OSPTR
        DEC     OSPTR
        CMP     BYTE PTR [EDX],@NUMREC
        JNE     RECEV3
        MOV     EDX,VSPTR
        MOV     EBX,DWORD PTR [EDX]
        MOV     ECX,DWORD PTR [EAX]
        MOV     DWORD PTR [EBX],ECX
        MOV     ECX,DWORD PTR [EAX+4]
        MOV     DWORD PTR [EBX+4],ECX
        ADD     VSPTR,4
        JMP     RECEV4

RECEV3:
        MOV     OSPTR,EDX

RECEV1:
        RET


;      RECEVPC: CONVERT 16-BIT BINARY VALUE IN PC'S TO
;               FLOATING POINT, AND SET THE NUMERIC
;               RECEIVER VARIABLES (SET UP IN STACKS) =
;               FL. PT. VALUE.  (IN EXECUTION PHASE)
;
;           ENTRY (EXECUTION PHASE):
;                @NUMREC IN OS
;                ADDRESS OF NUMERIC VARIABLE IN VS
;
;           RETURN (EXECUTION PHASE):
;                VS & OS CLEARED OF RECEIVER INFO.
;
;           MODIFIED REGISTERS (EXECUTION PHASE):
;                PC'S,CH,CL,F0-5,AUX0,1,2,K
;

RECEVPC:
        TEST    SL,2        ;SR IF NOT EXECUTION PHASE
        JZ      RECEV1
        MOV     EAX,VSPTR
        MOV     WORD PTR [EAX-8],0
        MOV     WORD PTR [EAX-6],DX
        MOV     DWORD PTR [EAX-4],0
        SUB     VSPTR,8
        JMP     RECEV       ;FL.PT VALUE ==> NUMERIC RECEIVER


;      TRLINE#: LOOK FOR LINE NUMBER REFERENCE IN TEXT
;               AND FIND THAT LINE.  ERROR IF IMMEDIATE
;               EXECUTION OR LINE NOT FOUND.
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER.
;
;           RETURN: F3,2 & CH,CL = LINE NUMBER REFERENCE
;                   PC'S = ADDRESS OF THREAD OF REFERENCED
;                          LINE.
;
;           NOTE: IN 2200, THIS ROUTINE CALLED 'TRSTMT'
;
;           MODIFIED REGISTERS: CH,CL,PC'S,F0,F2,F3,F6,F7
;                F1,F4,AUX0,1
;
;      TRLINE#A: SAME AS 'TRLINE#' EXCEPT DOES NOT CHECK
;                FOR IMMEDIATE EXECUTION.
;
;      TRLINE#B: IF EXECUTION PHASE, SEARCH FOR REFERENCED
;                LINE.
;
;           ENTRY: F3,2 = LINE NUMBER TO SEARCH FOR
;

TRLINE_:
         TEST   MODE,0002H
         JZ     TRLINE_A        ;BRANCH IF NOT IMMEDIATE MODE
         MOV    R0,07H          ;ILLEGAL IMMEDIATE MODE STATEMENT
         JMP    ERROR

TRLINE_A:
         CALL   LINE_REF        ;LOOK FOR LINE NO. REFERENCE IN TEXT
         TEST   R0,0FH
         JZ     TRLINE_B

ERROR_21:
         MOV    R0,21H          ;MISSING LINE NUMBER
         JMP    ERROR

TRLINE_B:
         TEST   SL,3            ;BRANCH IF ENTRY PHASE
         JZ     TRLINE_1
         TEST   MODE,20h
         JZ     TRLINE_3
         TEST   SL,2
         JZ     TRLINE_4
         MOV    EDX,DWORD PTR [TEXTPTR-4]  ;FOR EXECUTION PHASE
         MOV    R0,0
         RET

TRLINE_4:
         MOV    EDX,TEXTLPTR
         MOV    AUX01,EDX
         MOV    CX,[EDX+4]        ;GET LINE NO. OF CURRENT LINE
         XCHG   CH,CL
         CMP    CX,WORD PTR [R2]
         JE     TRLINE_1          ;BRANCH IF TRANSFER IS TO CURRENT LINE

         MOV    WORD PTR [R6],CX  ;SAVE LINE NUMBER OF CURRENT LINE
         CALL   FINDGRTH          ;FIND BEST GROUP THREAD
         CMP    CX,WORD PTR [R2]  ;branch if group line no. = spec line no
         JE     TRLINE_1

         MOV    AX,WORD PTR [R2]  ;BRANCH IF SPEC. LINE# < CURRENT LINE#
         CMP    AX,WORD PTR [R6]
         JB     TRLINE_2
         CMP    WORD PTR [R6],CX  ;BRANCH IF GROUP LINE NO. >= CURRENT LINE#
         JBE    TRLINE_2
         MOV    EDX,AUX01       ;USE CURRENT LINE AS BEGIN POINT FOR SEARCH

TRLINE_2:
         CALL   FINDST2         ;SEARCH FOR REFERENCED LINE FROM PC'S
         TEST   R0,0FH
         JNZ    ERROR_36        ;NF,BRANCH

TRLINE_1:
         TEST   SL,1
         JZ     TRLINE_X
         MOV    DWORD PTR [TEXTPTR-4],EDX  ;SET LINE ADDRESS TO POINTER BUFFER

TRLINE_X:
         RET

TRLINE_3:
         TEST   SL,2            ;BRANCH IF RESOLUTION PHASE
         JZ     TRLINE_4
         CALL   FINDSTI         ;SEARCH FOR SPECIFIED LINE
         TEST   R0,0FH
         JZ     TRLINE_1        ;BRANCH IF FOUND

ERROR_36:
         MOV    R0,36H          ;UNDEFINED LINE NUMBER
         JMP    ERROR


;      FLTBIN: REMOVE THE LAST VALUE (FLOATING POINT)
;               FROM VS AND CONVERT VALUE (INTEGER PART)
;               TO BINARY.  0 <= VALUE < 65536
;
;           RETURN: F2 = 0 IF VALUE = 0  (F1,0 = 0)
;                      = 1 IF VALUE < 0
;                      = 2 IF 0 < VALUE <65536, F1,0=VALUE
;                      = 4 IF VALUE > 65535
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,F2
;
;      FLTBINA: REMOVE THE LAST VALUE (FLOATING POINT)
;               FROM VS AND CONVERT VALUE (INTEGER PART)
;               TO BINARY.  0 <= VALUE < 256.
;               ERROR IS VALUE < 0 OR > 255.
;
;           RETURN: F2 = 0 IF VALUE = 0
;                      = 2 IF 0 < VALUE < 256
;                   F0 = BINARY VALUE
;                   F1 = 0
;
;      FLTBINSA: SAME AS FLTBINA EXCEPT ABSOLUTE VALUE TAKEN
;
;           RETURN: SAME AS FLTBINA EXCEPT:
;                     F3 = 00 IF POSITIVE OR ZERO
;                          10 IF NEGATIVE
;
;
;      FLTBINB: REMOVE THE LAST VALUE (FLOATING POINT)
;               FROM VS AND CONVERT VALUE (INTEGER PART)
;               TO BINARY. 0 <= VALUE < 65536.
;               ERROR IF VALUE < 0 OR > 65535.
;
;           RETURN: F2 = 0 IF VALUE = 0
;                      = 2 IF 0 < VALUE < 65536
;
;************************************************************************
;       ALIGN_0:Normalize the last entry in VS to a number with exponent
;               equal 0 and remove the value from VS
;
;               Entry: VSPTR
;               Return:EBX = The lower part of the number
;                      EAX = The high part of the number
;                      VSPTR = VSPTR + 8
;************************************************************************

FLTBINSA: MOV       EDX,VSPTR
          MOV       R3,00H
          MOV       AX,WORD PTR [EDX+2]   ;GET 1ST WORD
          MOV       BX,WORD PTR [EDX+4]   ;GET 2ND WORD
          MOV       CX,WORD PTR [EDX+6]   ;GET 3RD WORD
          OR        CX,CX
          JNS       FLTBINQQ
          MOV       R3,10H
          NOT       CX                    ;COMPLEMENT MANTISSA
          NOT       BX
          NEG       AX
          JNZ       FLTBINQQ
          INC       BX
          JNZ       FLTBINQQ
          INC       CX
FLTBINQQ:
          MOV       WORD PTR [EDX+2],AX
          MOV       WORD PTR [EDX+4],BX
          MOV       WORD PTR [EDX+6],CX

FLTBINA:  CALL      FLTBIN                ;CONVERT NUMBER IN VS TO BINARY
          CMP       R2,0
          JE        FLTBINA1              ;BRANCH IF NUMBER = 0
          CMP       R2,2
          JNE       FLTBINA2              ;BRANCH IF VALUE < 0 OR > 65535
          CMP       R1,0
          JNE       FLTBINA2              ;BRANCH IF VALUE > 255
FLTBINA1: RET
FLTBINB:  CALL      FLTBIN                ;CONVERT NUMBER IN VS TO BINARY
          TEST      R2,5
          JNZ       ERROR_34
          JMP       FLTBINA1              ;BRANCH IF 0 <= VALUE < 65536
FLTBINA2: JMP       ERROR_34              ;ILLEGAL VALUE

FLTBIN:   MOV       EDX,VSPTR
          MOV       WORD PTR [R0],0
          MOV       SI,WORD PTR [EDX]
          MOV       AX,WORD PTR [EDX+6]
          MOV       BX,WORD PTR [EDX+4]
          MOV       CX,WORD PTR [EDX+2]
          OR        AX,AX
          JS        FLTBIN3
          JNZ       FLTBINX
          OR        BX,BX
          JNZ       FLTBINX
          OR        CX,CX
          JNZ       FLTBINY
          JMP       FLTBIN2
FLTBINX:  CMP       SI,0
          JGE       FLTBIN4
          JMP       FLTBINZ
FLTBINY:  CMP       SI,0
          JNE       FLTBINZ
          MOV       WORD PTR [R0],CX
          JMP       FLTBIN5

FLTBINZ:  JMP       FLTBINM

FLTBIN5:  MOV       R2,2                  ;0 < VALUE < 65536
          ADD       VSPTR,8               ;REMOVE VALUE FROM VS
          RET
FLTBIN2:  MOV       R2,0                  ;VALUE = 0
          ADD       VSPTR,8               ;REMOVE VALUE FROM VS
          RET
FLTBIN4:  MOV       R2,4                  ;VALUE > 65535
          ADD       VSPTR,8               ;REMOVE VALUE FROM VS
          RET
FLTBIN3:  MOV       R2,1                  ;VALUE < 0
          ADD       VSPTR,8               ;REMOVE VALUE FROM VS
          RET


FLTBINM:
          MOV     ESI,VSPTR
          MOV     AX,WORD PTR [ESI+6]
          OR      AX,AX
          JS      FLT_ERR1        ;IF VALUE < 0
          CALL    ALIGN_0         ;
          CMP     EAX,0           ;BR, IF HIGH MANT = 0
          JNZ     FLT_ERR4        ;ERROR, VALUE > 65535
          CLC
          SHR     EBX,16          ;SHIFT OUT EXP PART
          CMP     EBX,65535       ;BR, IF VALUE > 65534
          JAE     FLT_ERR4
          MOV     R2,2            ;FLAG VALUE NOT 0
          CMP     EBX,0           ;CHECK IF VALUE =0
          JNE     M06_FLT3
          MOV     R2,0            ;FLAG VALUE = 0
M06_FLT3:
          MOV     WORD PTR R0,BX  ;PUT VALUE IN RETURN VARIABLE
          RET

FLT_ERR1:
          ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
          MOV     R2,1            ;FLAG R2 < 0
          RET
FLT_ERR4:
          MOV     R2,4            ;FLAG R2 > 65535
          RET

;
;  FLTBN: Remove the last floating point value from the VS and convert
;          the integer part to binary.  0 <= value < 2^32.
;
;  EXIT: F3F2F1F0 equals value if applicable.
;        K has 01 bit on iff value <> 0,
;        K has 02 bit on iff 0 <= value < 2^16,
;        K has 04 bit on iff 0 <= value < 2^32,
;        K has 08 bit on iff value <= 0.
;
;  MODIFIED REGISTERS: PHPL, CHCL, F0-F5, K.
;                      if value > 2^16 then F7F6 is modified.
;
;  FLTBINA: Same as FLTBIN only error if value < 0 or > 255.
;
;  FLTBINSA: Same as FLTBINA except absolute value is taken.
;
;  EXIT: Same as FLTBIN except K  has 10 on iff negative.
;
;  FLTBINS: Same as FLTBIN only for signed binary values.
;
;  FLTBINB: Same as FLTBIN only error if value < 0 or >= 2^16
;
;  FLTBINC: Same as FLTBIN only error if value < 0 or >= 2^32
;
;  FLTBINR: Same as FLTBIN except F5F4 is not modified.
;
;  FLTBINK: Same as FLTBINR except that K is saved into F4.
;
;=================== NOTE =======================================================

;         This routine was lifted from BASIC-3.  It should replace the FLTBIN
;         routine used throughout BASIC-2.  However, this was NOT done.
;         FLTBIN has many references, many of which would have to be modified
;         slightly since the new FLTBIN uses more registers and has different
;         returns.  To reduce the chance of introducing bugs, I decided to only
;         use the new routine in BIN itself.  The old routine could be replaced
;         when the control memory space is needed.
;
;         Also, note that portions of the BASIC-3 routine not used by BIN have
;         been commented out.  These must be added back in if the old routine
;         is replaced.
;================================================================================

FLTBN_ERR1:
        MOV     K,1             ;OVERFLOW
        ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
        RET

FLTBN_ERR1P:
        MOV     K,1             ;OVERFLOW
        RET

FLTBN_ERR9:
        MOV     K,9             ;VALUE < 0
        ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
        RET

FLTBN_ERRE:
        MOV     K,0EH           ;VALUE = 0
        ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
        RET

FLTBN_ERR5:
        MOV     K,5             ;2^16 <= VALUE < 2^32
        ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
        RET

FLTBN_ERR5P:
        MOV     K,5             ;2^16 <= VALUE < 2^32
        RET

FLTBN:
        MOV     WORD PTR [R0],0
        MOV     WORD PTR [R2],0
        MOV     ESI,VSPTR
        MOV     CX,WORD PTR [ESI+6]
        MOV     DI,CX
        OR      DI,DI
        JS      FLTBN_ERR9      ;IF VALUE < 0
        MOV     EAX,DWORD PTR [ESI+2]
        MOV     EDI,EAX
        OR      EDI,EDI
        JNZ     FLTBN11
        MOV     DI,CX
        OR      DI,DI
        JZ      FLTBN_ERRE

FLTBN11:MOV     BX,WORD PTR [ESI]
        MOV     DI,BX
        OR      DI,DI
        JNZ     FLTBN_CHK
        MOV     DI,CX
        OR      DI,DI
        JNZ     FLTBN_ERR1
        MOV     DWORD PTR [R0],EAX
        TEST    EAX,0FFFF0000H
        JNZ     FLTBN_ERR5

FLTBN_ERR7:
        MOV     K,7             ;VALUE 0 < VALUE < 2^16
        ADD     VSPTR,8         ;DELETE LAST ENTRY IN VS
        RET

FLTBN_ERR7P:
        MOV     K,7             ;VALUE 0 < VALUE < 2^16
        RET

FLTBN_CHK:
        CALL    ALIGN_0         ;
        TEST    EAX,0FFFF0000H  ;BR, IF HIGH MANT <> 0
        JNZ     FLTBN_ERR1P     ;ERROR, overflow
        MOV     ECX,EAX
        SHL     ECX,16
        SHR     EBX,16
        OR      ECX,EBX
        MOV     DWORD PTR [R0],ECX
        TEST    EAX,0000FFFFH   ;BR, IF HIGH MANT <> 0
        JNZ     FLTBN_ERR5P     ;VALUE 0 < VALUE < 2^32
        JMP     FLTBN_ERR7P

FLTBN29:
        JMP     ERROR_34        ;ILLEGEAL VALUE

FLTBNC:
        CALL    FLTBN
        TEST    K,6         ;branch if error
        JZ      FLTBN29
        RET

fltbnl:
        mov     edx,vsptr
        call    newtoold
        mov     cx,word ptr [edx]
        xchg    ch,cl
        test    ch,10h
        jnz     fltbn_err9
        and     ch,0fh
        and     cl,0f0h
        or      ch,cl
        cmp     ch,12h
        ja      fltbn_err1
        call    fltbnccc
        mov     word ptr [r4],ax
        mov     word ptr [r2],bx
        mov     word ptr [r0],cx
        ret

FLTBNCCC:
        MOV     ESI,VSPTR
        MOV     CX,WORD PTR [ESI+6]
        OR      CX,CX
        JS      FLTBN_ERR9      ;IF VALUE < 0
        MOV     CX,WORD PTR [ESI]
        OR      CX,CX
        JNZ     FLTBNXX1
        MOV     AX,WORD PTR [ESI+6]
        MOV     BX,WORD PTR [ESI+4]
        MOV     CX,WORD PTR [ESI+2]
        mov     k,0
        ADD     VSPTR,8
        RET

FLTBNXX1:
        CALL    ALIGN_0
        SHR     EBX,16
        MOV     CX,BX
        MOV     BX,AX
        SHR     EAX,16
        mov     k,0
        RET

;* M10LONG: Multiply F3F2F1F0 by 10 and add in K.
;*
;* ENTRY: F3F2F1F0 should contain long binary number.
;*        K should contain byte to add in.
;*
;* EXIT: F3F2F1F0 * 10 + K ==> F3F2F1F0
;*
;* MODIFIED REGISTERS: F0-7
;*

M10LONG:
        MOV     EAX,DWORD PTR R0        ;GET LONG VALUE
        MOV     EBX,0
        MOV     BL,K                    ;GET TH EBYTE TO BE ADD IN
        SHL     EAX,1
        MOV     ECX,EAX                 ;VALUE * 2
        SHL     EAX,2                   ;VALUE * 8
        ADD     EAX,ECX                 ;VALUE * 10
        ADD     EAX,EBX                 ;VALUE * 10 + K
        MOV     DWORD PTR R0,EAX        ;PUT IN BACK
        RET

;----------------------------------------------------------------------------
;         FILE = BPMVP6D ,09/03/1986
;         TITLE     BINFLT
;*     BINFLT: CONVERT A 2-BYTE BINARY NUMBER TO INTERNAL
;*             FLOATING POINT FORMAT (8-BYTES).
;*
;*          ENTRY: F1,0 = BINARY NUMBER
;*                 PHASE = EXECUTION SINCE NUMBER IS
;*                         STORED IN THE VALUE STACK
;*
;*          RETURN: FLOATING POINT NUMBER --> VS
;*
;*          MODIFIED REGISTERS: PC'S,F0-5
;*
;*          ALGORITHM: 1. ZERO RESULT
;*                     2. DOUBLE BINARY NUMBER, CARRY OUT
;*                     3. DOUBLE DECIMAL NUMBER, CARRY IN
;*                     4. REPEAT 2,3 FOR ALL 16 BITS OF
;*                        THE BINARY NUMBER
;*                     5. NORMALIZE THE NUMBER, DETERMINE
;*                        EXPONENT, AND STORE FL. PT. NO.
;*
;*                      NOTE, IF NO. < 256, STEPS 2 AND 3
;*                      ARE ONLY PERFORMED ON LOWER 8-BITS
;*
;*     BINFLTA: SAME AS 'BINFLT' EXCEPT ONE BYTE IN F0 TO
;*              BE CONVERTED.
;*
BINFLTA:
        MOV     R1,0

BINFLT:
        mov     edi,vsptr
        sub     edi,8
        mov     eax,0
        stosw                   ;save exponent
        mov     ax,word ptr r0
        stosw                   ;save two byte binary value
        mov     eax,0           ;
        stosd                   ;save 4 byte zero
        sub     vsptr,8         ;vsptr pt to beg of this value
        ret

;         TITLE     BINDEC
;*     BINDEC: CONVERT A 2 BYTE BINARY VALUE TO DECIMAL
;*
;*          ENTRY: F1,0 = BINARY VALUE
;*
;*          RETURN: F4-F2 = DECIMAL VALUE (RIGHT JUSTIFIED
;*                          ,WITH LEADING ZEROES -- HIGH
;*                          DIGIT IS ALWAYS 0)
;*
;*          MODIFIED REGISTERS: F0-5
;*
;*          ALGORITHM: 1. ZERO RESULT
;*                     2. DOUBLE BINARY NUMBER, CARRY OUT
;*                     3. DOUBLE DECIMAL NUMBER, CARRY IN
;*                     4. REPEAT 2,3 FOR ALL 16 BITS OF
;*                        THE BINARY NUMBER
;*
;*
;*                    NOTE, IF NO. < 256, STEPS 2 AND 3
;*                    ARE ONLY PERFORMED ON LOWER 8-BITS.
;*
BINDEC:  push      edx
         mov       word ptr r2,0
         mov       byte ptr r4,0
         mov       ax,word ptr r0
         mov       dx,ax
         cmp       ax,10000
         jb        bindec1
         mov       edx,0
         mov       bx,10000
         div       bx
         mov       byte ptr r4,al
         mov       ax,dx
bindec1: cmp       ax,1000
         jb        bindec2
         mov       edx,0
         mov       bx,1000
         div       bx
         mov       byte ptr r3,al
         shl       byte ptr r3,4
         mov       ax,dx
bindec2: cmp       ax,100
         jb        bindec3
         mov       edx,0
         mov       bx,100
         div       bx
         or        byte ptr r3,al
         mov       ax,dx
bindec3: cmp       ax,10
         jb        bindec4
         mov       edx,0
         mov       bx,10
         div       bx
         mov       byte ptr r2,al
         shl       byte ptr r2,4
bindec4: or        byte ptr r2,dl
         pop       edx
         RET

;  BNFLT: Convert a two byte binary value into a floating point
;          number.
;
;  ENTRY: F1F0 should contain the number.
;
;  BNFLTA: Convert a one byte binary value into a floating point
;           number.
;
;  ENTRY: F0 should contain the number.
;
;  BNFLTX: Convert a four byte binary value into a floating point
;           number.
;
;  ENTRY: PHPLF1F0 should contain the number.
;
;  EXIT: Floating point value is pushed onto the VS.
;
;  BNFLTXXX: Convert a six byte binary value into a floating point
;           number.
;
;  ENTRY: F5F4F3F2F1F0 should contain the number.
;
;  EXIT: Floating point value is pushed onto the VS.
;
;  MODIFIED REGISTERS: PHPL, AUX0, all, K
; %################# NOTE #######################################################
;         This routine was lifted from BASIC-3.  It should replace the BINFLT
;         routine used throughout BASIC-2.  However, this was NOT done.
;         FLTBIN has many references, many of which would have to be modified
;         slightly since the new BINFLT uses more registers and has different
;         returns.  To reduce the chance of introducing bugs, I decided to only
;         use the new routine in VAL itself.  The old routine could be replaced
;         when the control memory space is needed.
;
;         Perhaps, should look at save/restore of registers for old entry points,
;         as opposed to modifying the callers.
;
;         Also, note that portions of the BASIC-3 routine not used by BIN have
;         been commented out.  These must be added back in if the old routine
;         is replaced.

BNFLTX:
        MOV     EDI,VSPTR
        SUB     EDI,8
        MOV     WORD PTR [EDI],0
        MOV     AX,WORD PTR [R0]
        MOV     WORD PTR [EDI+2],AX
        MOV     WORD PTR [EDI+4],DX
        MOV     WORD PTR [EDI+6],0
        MOV     VSPTR,EDI
        CMP     EDI,DWORD PTR [@@VSEND]
        JB      ERROR_02
        RET

BNFLTXXX:
        MOV     EDI,VSPTR
        SUB     EDI,8
        MOV     WORD PTR [EDI],0
        MOV     AX,WORD PTR [R0]
        MOV     WORD PTR [EDI+2],AX
        MOV     AX,WORD PTR [R2]
        MOV     WORD PTR [EDI+4],AX
        MOV     AX,WORD PTR [R4]
        MOV     WORD PTR [EDI+6],AX
        MOV     VSPTR,EDI
        CMP     EDI,DWORD PTR [@@VSEND]
        JB      ERROR_02
        RET

;      DVAR: SCAN AND RESOLVE A DIM OR COM VARIABLE. IN
;            RESOLUTION PHASE VARIABLE IS ADDED TO THE
;            SYMBOL TABLE.
;
;           ALPHA VARIABLE FORMAT:
;                letter [digit] $ [(dim [,dim] )] [length]
;
;           NUMERIC VARIABLE FORMAT:
;                letter [digit] [(dim [,dim] )]
;
;                WHERE: FOR VECTORS,
;                          0 < dim < 65536
;                       FOR 2-DIMENSIONAL ARRAYS,
;                          0 < dim < 256
;                       FOR ALPHA VARIABLES,
;                          0 < length <= 124
;                       'dim' AND 'length' MUST BE ASCII
;                          INTEGERS OR NUMERIC SCALARS
;
;           ENTRY: K = 0 IF NONCOMMON VARIABLE (DIM)
;                      1 IF COMMON VARIABLE (COM)
;                  PHASE = ENTRY OR RESOLUTION (NOT EXEC.)
;                  TEXTPTR POINTS AT NEXT TEXT CHARACTER.
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-7,AUX0,1
;

DVAR:
        CMP     BYTE PTR [TEXTPTR],7FH
        JE      DVARAA
        CMP     BYTE PTR [TEXTPTR],7DH
        JE      DVARAA
        CALL    VARNAME
        TEST    R0,0FH
        JZ      DVARX

ERROR_16:
        MOV     R0,16H          ;MISSING LETTER
        JMP     ERROR

DVARX:
        MOV     AX,WORD PTR [R2]
        JMP     DVARBB
DVARAA:
        MOV     AX,WORD PTR [TEXTPTR+1]
        MOV     WORD PTR [R2],AX
        ADD     TEXTPTR,7
        test    sl,3
        jnz     dvarbb
        test    mode,0800h      ;check list v
        jz      dvarbb
        call    listvar
DVARBB:
        MOV     AUX21,TEXTPTR
        MOV     AUX01,EAX
        MOV     AL,R2           ;SAVE NAME DIGIT & TYPE
        MOV     R4,AL
        TEST    AL,2            ;BARNCH IF SCALAR VARIABLE
        JZ      DVAR1
        CALL    DIMSUB          ;GET DIM1
        TEST    R0,0FH          ;ERROR IF NOT FOUND
        JNZ     ERROR_50
        MOV     AX,WORD PTR R1  ;F7,6 = DIM1 (BINARY)
        MOV     WORD PTR R6,AX
        CMP     BYTE PTR [TEXTPTR],','      ;LOOK FOR COMMA
        JNE     DVAR2
        INC     TEXTPTR
        TEST    SL,3            ;BRANCH IF ENTRY PHASE
        JZ      DVARY
        CMP     R7,0            ;ERROR IF 2-DIMENSIONAL & DIM1 > 255
        JNE     ERROR_50

DVARY:
        CALL    DIMSUB          ;GET DIM2
        TEST    R0,0FH          ;ERROR IF NOT FOUND
        JNZ     ERROR_50
        TEST    SL,3            ;BRANCH IF ENTRY PHASE
        JZ      DVAR2
        CMP     R2,0            ;ERROR IF DIM2 > 255
        JNE     ERROR_50
        MOV     AH,R6           ;F7 = DIM 1
        MOV     AL,R1           ;F6 = DIM 2
        MOV     WORD PTR R6,AX
        OR      R4,4            ;TYPE = 2-DIMENSIONAL
DVAR2:  CMP     BYTE PTR [TEXTPTR],')'       ;LOOK FOR ')'
        JNE     ERROR_11
        INC     TEXTPTR
DVAR1:  TEST    R4,1            ;BRANCH IF VARIABLE IS NUMERIC
        JZ      DVAR4
        MOV     R5,10H          ;F5 = DEFAULT LENGTH (16)
        CALL    DIMSUB          ;GET SPCIFIED LENGTH
        TEST    R0,0FH          ;BRANCH IF NO LENGTH SPECIFIED
        JNZ     DVAR4
        TEST    SL,3            ;BRANCH IF ENTRY PHASE
        JZ      DVAR5
        CMP     R2,0            ;ERROR IF LENGTH >255
        JNE     ERROR_50
        MOV     AL,R1           ;F5 = LENGTH, CARRY OFF
        MOV     R5,AL
        CMP     R1,124
        JA      ERROR_50        ;ERROR IF LENGTH > 124
DVAR4:  TEST    SL,3            ;EXIT IF ENTRY PHASE
        JZ      DVAR5
        MOV     EDX,AUX01
        MOV     WORD PTR R2,DX  ;RESTORE VARIABLE NAME
        MOV     AL,R4           ;R2 = VARIABLE TYPE
        AND     AL,0FBH
        MOV     R2,AL
        XCHG    TEXTPTR,AUX21
        CALL    FINDVARL    ;SEARCH FOR VARIABLE IN SYMBOL TABLE
        XCHG    TEXTPTR,AUX21
        TEST    R0,0FH
        JNZ     DVAR6
        TEST    CL,2        ;BRANCH IF SCALAR
        JZ      DVAR7
        CMP     CL,R4       ;ERROR IF DIMENSIONALITY DOESN'T AGREE
        JNE     ERROR_59
        MOV     CX,WORD PTR [EDX]    ;GET DIMENSIONS (CH,CL)
        XCHG    CH,CL
        XCHG    EDX,AUX00
        ADD     AUX00,2
        XCHG    EDX,AUX00
        CMP     CX,WORD PTR [R6]      ;ERROR IF DIMENSIONS NOT THE SAME
        JNE     ERROR_59
DVAR7:  TEST    R2,1        ;BRANCH IF NUMERIC
        JZ      DVAR9
        MOV     CH,BYTE PTR [EDX]    ;GET ALPHA LENGTH FROM SYMBOL TABLE
        CMP     CH,R5           ;ERROR IF LENGTH <> SPECIFIED LENGTH
        JNE     ERROR_59
DVAR9:  TEST    K,1         ;BRANCH IF DIM VARIABLE
        JZ      DVAR5
        MOV     DWORD PTR A0,EDX
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     ECX,DWORD PTR [EDX].@COMPTR
        CMP     ECX,0        ;BRANCH IF SOME COMMON VARIABLES EXIT
        JNE     DVARZ

ERROR_53:
        MOV     R0,53H       ;NONCOMMON DEFINED BEFORE COMMON VARIABLES
        JMP     ERROR

DVARZ:
        CMP     DWORD PTR A0,ECX  ;BRANCH IF FOUND VARIABLE NONCOMMON
        JB      ERROR_53
DVAR5:  RET

DVAR6:  TEST    K,1         ;BRANCH IF NOT COMMON
        JZ      DVAR10
        MOV     EDX,VARPTR
        MOV     DWORD PTR A0,EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@COMPTR
        MOV     ECX,DWORD PTR [EDX]
        CMP     ECX,DWORD PTR A0  ;ERROR IF NONCOMMON VARIABLES ALREADY  DEFIN
        JNE     ERROR_53
DVAR10: MOV     AL,R4       ;F2 = VARIABLE TYPE
        MOV     R2,AL
        XCHG    TEXTPTR,AUX21
        CALL    ADDVAR@     ;ADD VARIABLE TO SYMBOL TABLE
        XCHG    TEXTPTR,AUX21
        TEST    K,1         ;BRANCH IF NONCOMMON VARIABLE
        JZ      DVAR5
        MOV     EDX,VARPTR
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     DWORD PTR [EDX].@COMPTR,EAX  ;COMPTR = VARPTR
        RET

ERROR_59:
        MOV     R0,59H      ;ILLEGAL REDIMENSION
        JMP     ERROR

;      DIMSUB: SCAN & PROCESS A DIMENSION OR ALPHA LENGTH
;
;           FORMAT: INTEGER (NONZERO)
;                   NUMERIC SCALAR VARIABLE
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;           RETURN: TEXTPTR POINTS AFTER DIM OR LENGTH
;                   F0 = 0 IF FOUND
;                     ,BITS0F <> 0 IF NOT FOUND
;                   F2,1 = DIM OR LENGTH (IF FOUND)
;
;           ERROR#50 IF DIM OR LENGTH = 0 OR
;                    IF VARIABLE NOT NUMERIC SCALAR
;
;           MODIFIED REGISTERS: CH,CL,PC'S,F0-3,AUX0
;

DIMSUB: CALL    INTEGER     ;LOOK FOR INTEGER
        TEST    R0,0FH
        JZ      DIMSUB1
        CALL    VARNAME     ;LOOK FOR VARIABLE NAME
        TEST    R0,0FH
        JNZ     DIMSUB3
        TEST    R2,3        ;SKIP if numeric scalar
        JZ      DIMSUBX
        JMP     ERROR_50    ;ERROR IF VARIABLE NOT NUMERIC SCALAR

DIMSUBX:
        TEST    SL,3        ;BRANCH IF ENRTY PHASE
        JZ      DIMSUB2
        CALL    FINDVARL    ;FIND VARIABLE IN SYMBOL TABLE
        TEST    R0,0FH
        JNZ     ERROR_50
        MOV     EAX,VSPTR   ;VARIABLE VALUE ==> VS
        SUB     EAX,8
        MOV     ECX,DWORD PTR [EDX]
        MOV     DWORD PTR [EAX],ECX
        MOV     ECX,DWORD PTR [EDX+4]
        MOV     DWORD PTR [EAX+4],ECX
        MOV     VSPTR,EAX
        CMP     EAX,DWORD PTR [@@VSEND]
        JB      ERROR_02
        CALL    FLTBIN      ;CONVERT VALUE TO BINARY
        CMP     R2,2        ;ERROR IF < 1 OR > 65535
        JNE     ERROR_50
        MOV     AX,WORD PTR R0
        MOV     WORD PTR R1,AX  ;F2,1 = VALUE
DIMSUB1:CMP     WORD PTR R1,0   ;BRANCH IF VALUE > 0
        JA      DIMSUB2

ERROR_50:
        MOV     R0,50H      ;ILLEGAL DIMENSION OR LENGTH
        JMP     ERROR

DIMSUB2:MOV     R0,0        ;FLAG = FOUND
DIMSUB3:RET


;      FINDDEF: SAVE CURRENT TEXTPTR & TEXTLPTR;
;               SEARCH FOR THE SPECIFIED DEFFN' STATEMENT
;               IN PROGRAM.  DEFFN' MUST BE 1ST STATEMENT
;               ON A LINE. ERROR IF NOT FOUND.
;
;           ENTRY: K = BINARY VALUE OF DEFFN' LOOKING FOR
;                  PHASE = RESOLUTION OR EXECUTION
;
;           RETURN: F0 = 0 IF DEFFN' FOUND
;                   AUXA = TEXTPTR AT ENTRY TIME
;                   AUXB = TEXLPTR AT ENTRY TIME
;                   TEXTPTR POINTS AFTER "DEFFN' integer"
;                   TEXTLPTR POINTS TO THREAD OF DEFFN'
;                          LINE.
;                   F1 = K (DEFFN' INTEGER)
;                   TURN SP.FUNC. STATUS BIT OFF
;
;                   F0 = 1 IF DEFFN' NOT FOUND
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-2,AUXA,B
;
;      FINDDEFA: SAME AS 'FINDDEF' EXCEPT AUXA,B NOT
;           CHANGED (TEXTPTRS NOT SAVED)
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;

FINDDEF: CALL    SWITCH      ;SAVE CURRENT TEXT POINTERS
FINDDEFA:
         TEST    SL,2        ;BRANCH IF EXECUTION PHASE
         JNZ     FINDDEFX
FINDDEFB:
         MOV     EDX,DWORD PTR [CPBASE]
         MOV     EDX,DWORD PTR [EDX].@IBASE
         LEA     EDX,[EDX].@TEXTBEG         ;PC'S = ADDRESS OF THREAD TO LOWEST LINE
         JMP     FINDDEFD

FINDDEFC:
         MOV     EDX,TEXTLPTR
FINDDEFD:
         MOV     ECX,DWORD PTR [EDX]    ;CH,CL = THREAD TO NEXT LINE
         CMP     ECX,0        ;BRANCH IF NO MORE TEXT
         JE      FINDDEF2
         MOV     EDX,ECX       ;PC'S = ADDRESS TO NEXT LINE + 1
FINDDEF3:
         MOV     TEXTPTR,EDX  ;TEXTPTR POINT TO AFTER LINE NUMBER
         ADD     TEXTPTR,6
         MOV     TEXTLPTR,EDX ;TEXTLPTR POINT TO THREAD OF LINE
         CMP     BYTE PTR [TEXTPTR],@DEFFN ;LOOK FOR 'DEFFN' ATOM
         JNE     FINDDEFC     ;BR, NF
         INC     TEXTPTR
         CMP     BYTE PTR [TEXTPTR],27H    ;LOOK FOR SINGLE QUOTE
         JNE     FINDDEFC     ;BR, NF
         INC     TEXTPTR
         CALL    INTEGER      ;LOOK FOR INTEGER
         TEST    R0,0FH       ;NF, BRANCH
         JNZ     FINDDEFC
         MOV     AL,R1        ;BRANCH IF NOT SPECIFIED DEFFN'
         CMP     AL,K
         JNE     FINDDEFC
         CMP     R2,0
         JNE     FINDDEFC
         RET

FINDDEF2:
         MOV     AX,WORD PTR FS:[CPUST]  ;SPECIAL FUNCTION BIT OFF
         MOV     R0,1          ;FLAG = NOT FOUND
         RET

FINDDEFX:
         TEST    MODE,20H
         JZ      FINDDEFB    ;BRANCH IF PROGRAM NOT RESOLVED
         MOV     EDX,DWORD PTR [CPBASE]  ;GET ENTRY COUNT
         MOV     EDX,DWORD PTR [EDX].@IBASE
         LEA     EDX,[EDX].@DFN?QUTBL
         MOV     CH,BYTE PTR [EDX]
         CMP     CH,0        ;BRANCH IF NO ENTRIES
         JE      FINDDEFB
         MOV     AL,CH       ;AL = COUNT
         INC     EDX         ;PT TO FUNCTION #
FINDDEF4:
         MOV     CH,BYTE PTR [EDX]    ;GET FUNCTION #
         ADD     EDX,5       ;PT TO ADDR OF LINE
         CMP     CH,K        ;BRANCH IF IT'S THE ENTRY LOOKING FOR
         JE      FINDDEF5    ;
         DEC     AL          ;DECREMENT COUNT
         JNZ     FINDDEF4    ;BR, IF MORE ENTRIES

FINDDEF5:
         MOV     EDX,DWORD PTR [EDX-4] ;PC' ADDR OF DEFFN' LINE
         JMP     FINDDEF3


; FINDDEF@: SEARCH FOR DEFFN' IN THE PARTITION POINTED TO BY
;           @IBASE. IF NOT FOUND, SEARCH FOR DEFFN' IN THE
;           PARTITION POINTED TO BY @XBASE.
;
;      RETURN: F0 = 0 IF FOUND
;
;                F3 = @SUBR IF FOUND IN @IBASE PARTITION
;                     @XSUBR IF FOUND IN @XBASE PARTITION
;
;              F0 <>0 IF NOT FOUND
;

FINDDEF@:
         CALL      SWITCH      ;SAVE CURRENT TEXT POINTERS

FINDDFA@:
         MOV       R3,@SUBR    ;R3 = FOUND IN @IBASE PARTITION
         CALL      FINDDEFA    ;SEARCH FOR DEFFN' IN @IBASE PARTITION
         TEST      R0,0FH      ;F, BRANCH
         JZ        FINDDF@2
         MOV       EDX,DWORD PTR [CPBASE]    ;GET CURRENT BASE
         MOV       EDX,DWORD PTR [EDX].@XBASE;GET THE BASE OF GLOBAL PARTITION
         CMP       EDX,DWORD PTR [CPBASE]     ;BR, IF CPBASE = XBASE
         JE        FINDDF@1
         MOV       EBX,EDX              ;SAVE XBASE
         MOV       EDX,OFFSET BASE-4
FINDDF@3:
         ADD       EDX,4                ;INCREMENT COUNTER
         CMP       EBX,DWORD PTR [EDX]  ;FIND THE PART # FROM BASE TABLE
         JNE       FINDDF@3             ;BR, IF NOT THIS ONE
         SUB       EDX,OFFSET BASE
         SHR       EDX,2                ;GET THIS PARTITION #
         ADD       EDX,OFFSET PMODE     ;PT TO ENTRY IN PMODE TABLE
         TEST      BYTE PTR [EDX],PMODEG ;BR, IF THIS PART IS NOT A GLOBAL PART
         JZ        FINDDF@2
FINDDF@1:
         MOV       EDX,DWORD PTR [CPBASE]          ;GET CURRENT BASE
         MOV       EDX,DWORD PTR [EDX].@XBASE      ;GET GLOBAL PART BASE
         LEA       EDX,DWORD PTR [EDX].@TEXTBEG    ;GET TEXT BEG OF GLOBAL PART
         CALL      FINDDEFD    ;SEARCH FOR DEFFN' IN @XBASE PARTITION
         TEST      R0,0FH      ;NF, BRANCH
         JNZ       FINDDF@2
         MOV       R3,@XSUBR   ;R3 = FOUND IN @XBASE PARTITION
FINDDF@2:
         RET

;  ONBRANCH:  PERFORM A COMPUTED GOTO.
;    ENTRY:  F0 CONTAINS A COUNT: 00 TO FF
;
;    RETURN:  THIS SUBROUTINE SKIPS F0 INSTRUCTIONS OF
;       THE CALLING PROGRAM.
;
;    MODIFIED REGISTERS:  PC'S
;
;  SBPCS: Perform a subroutine branch to address specified by PC's
;
;  ENTRY: SB SBPCS with PC's containing address of routine to call
;
ONBRANCH:POP       EDX
         XOR       EAX,EAX
         MOV       AL,R0
         ADD       EDX,EAX
         SHL       EAX,2
         ADD       EDX,EAX

SBPCS:   PUSH      EDX
         RET


;      RELEXPR: PROCESS A RELATION EXPRESSION
;
;           DEFINITION:
;                RELEXPR ::=       REL AND RELTERM
;                                      OR
;                                      XOR
;
;                REL ::= EXPRESSION RELOP EXPRESSION
;                        ALPHA-ARG  RELOP ALPHA-ARG
;
;                RELOP ::= < / <= / = / >= / > / <>
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;           RETURN: F7 = 0 IF RELATION FALSE
;                   F7 = 1 IF RELATION TRUE
;
;           REGISTER USE:
;                F7 = CURRENT VALUE OF RELATIONS BEING
;                     PROCESSED. (1 = TRUE, 0 = FALSE)
;                F6 = OPERATOR ATOM
;                     (8A = AND, 8B = OR, 8C = XOR)
;                AUX3(HIGH BYTE) = RESULT (1=TRUE,0=FALSE)
;                     (LOW BYE)  = OPERATOR ATOM
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2,3

RELEXPR:

;2/22/89 ++
;       mov     word ptr r6,008bh       ;R7 (result) = 0, R6 (operator) = OR

         MOV     R7,0        ;RESULT = 0
         MOV     R6,8BH      ;OPERATOR = OR
;2/22/89 --

RELEXPR3:
        MOV     DX,WORD PTR R6
        MOV     AUX03,EDX    ;SAVE RESULT OF OPERATOR

RELEXPR5:
        CALL    REL         ;PROCESS RELATION
        TEST    SL,2        ;BRANCH IF NOT EXECUTION PHASE
        JZ      RELEXPR1
        CMP     R7,0
        JE      _M0608
        MOV     R7,1        ;R7 = 0 IF RELATION FALSE, 1 IF TRUE
_M0608:
        MOV     EDX,AUX03
        cmp     dl,8ah
        jne     _m0609
        AND     R7,DH       ;AND RESULT & RESULT OF REL
        JMP     RELEXPR4
_M0609:
        cmp     dl,8bh
        jne     _m0610
        OR      R7,DH       ;OR RESULT & RESULT OF REL
        JMP     RELEXPR4
_M0610:
        XOR     R7,DH       ;XOR RESULT & RESULT OF REL

RELEXPR4:
         MOV     CH,BYTE PTR [TEXTPTR]
         INC     TEXTPTR
         MOV     AL,CH
         AND     AL,0F0H
         CMP     AL,80H
         JNE     RELEXPR2

RELEXP11:
        MOV     R6,CH       ;R6 = OPERATOR ATOM
        CMP     CH,8AH
        JE      RELEXPR6
        CMP     CH,8BH
        JE      RELEXPR6
        CMP     CH,8CH
        JE      RELEXPR3


RELEXPR2:
        DEC     TEXTPTR      ;DECREMENT TEXTPTR IF NOT OPERATOR ATOM

relexpr2_0:
        RET                   ;EXIT

RELEXPR1:
        MOV     R0,@AND
        CALL    CCL         ;LOOK FOR 'AND'
        TEST    R0,0FH
        JZ      RELEXPR5
        MOV     R0,@OR
        CALL    CCL         ;LOOK FOR 'OR'
        TEST    R0,0FH
        JZ      RELEXPR5
        MOV     R0,@XOR
        CALL    CCL         ;LOOK FOR 'XOR'
        TEST    R0,0FH
        JZ      RELEXPR5
        RET

;      The following code speeds up multiple relation
;      processing. The next relation is skipped if:
;           1. The operator = OR and the current value of
;              the expression is 'true'.
;           2. The operator = AND and the current value of
;              the expression is 'false'.
;      Skipping is done by scanning for 'THEN','AND','OR',
;      or 'XOR'; literals must be bypassed.
;

RELEXPR6:
         MOV    AL,R7
         XOR    AL,CH
         MOV    R5,AL
         TEST   R5,1        ;BRANCH IFF NOT:  OR & TRUE, OR AND & FALSE
         JNZ    RELEXPR3
         MOV    EDX,TEXTPTR

;  SKIP PAST NEXT RELATION
;
RELEXPR8:
         MOV    CH,BYTE PTR [TEXTPTR] ;GET NEXT CHARACTER
         INC    TEXTPTR
         CMP    CH,7FH
         JE     RELEXPRA1
         CMP    CH,7DH
         JE     RELEXPRA1
         CMP    CH,7EH
         JE     RELEXPRA2
         TEST   CH,80H       ;BRANCH IF NOT ATOM
         JZ     RELEXPR8
         CMP    CH,0B1H
         JNE    RELEXPR9     ;BRANCH IF NOT 'THEN'
         DEC    TEXTPTR      ;POINT TO 'THEN'
         RET

RELEXPRA1:
         ADD    TEXTPTR,6
         JMP    RELEXPR8
RELEXPRA2:
         ADD    TEXTPTR,8
         JMP    RELEXPR8

RELEXPR9:
        CMP     CH,0FEH
        JE      RELEXPRA3
        CMP     CH,0FCH
        JNE     RELEXP10

RELEXPRA3:
        XOR     EAX,EAX
        MOV     AL,BYTE PTR [TEXTPTR]
        INC     TEXTPTR
        ADD     TEXTPTR,EAX
        JMP     RELEXPR8

RELEXP10:
        CMP     CH,8AH
        JE      RELEXPRA4
        CMP     CH,8BH
        JE      RELEXPRA4
        CMP     CH,8CH
        JNE     RELEXPR8

RELEXPRA4:
        JMP     RELEXP11
;
;2/21/89 ++ new routine for chk relational operators..
;
rel_x:
        cmp     word ptr [textptr],'><'
        je      rel_5           ;
        cmp     word ptr [textptr],'=<'
        je      rel_3           ;
        cmp     word ptr [textptr],'=>'
        je      rel_6           ;
        cmp     byte ptr [textptr],'<'
        je      rel_1           ;
        cmp     byte ptr [textptr],'='
        je      rel_2           ;
        cmp     byte ptr [textptr],'>'
        je      rel_4           ;
        mov     r1,18h          ;report error!
        jmp     error           ;
rel_1:
        inc     textptr         ;
        mov     al,1            ;
        ret                     ;
rel_2:
        inc     textptr
        mov     al,2            ;
        ret                     ;
rel_3:
        add     textptr,2
        mov     al,3            ;
        ret                     ;
rel_4:
        inc     textptr
        mov     al,4            ;
        ret                     ;
rel_5:
        add     textptr,2
        mov     al,5            ;
        ret                     ;
rel_6:
        add     textptr,2
        mov     al,6            ;
        ret                     ;


;      REL: SCAN AND EVALUATE A RELATION IN TEXT.
;           ERROR IF NOT FOUND.
;
;           RELATION FORMAT:
;                (1) EXPRESSION OPERATOR EXPRESSION
;                (2) ALPHA-ARGUMENT OPERATOR ALPHA-ARG.
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;           RETURN: F7 (LOW 3 BITS) <>0 IF RELATION TRUE
;                   F7= 0 IF RELATION FALSE
;
;           RELATION-OPERATOR-ATOMS     RELATION-VALUES
;                     < -- 1              X<Y -- 1
;                    <= -- 3              X=Y -- 2
;                     = -- 2              X>Y -- 4
;                    >= -- 6
;                     > -- 4
;                    <> -- 5
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2
;
;
;      RELALPHB:  COMPARE 2 ALPHA VALUES (LENGTHS OF
;                 VALUES NEED NOT BE THE SAME, SHORTER
;                 VALUE PADDED WITH SPACES).
;
;           ENTRY: F1,0 = LENGTH OF VALUE#1
;                  PC'S = ADDRESS OF VALUE#1
;                  F3,2 = LENGTH OF VALUE#2
;                  AUX0 = ADDRESS OF VALUE#2
;                  F7 = 0 OR RELATION-OPERATOR-ATOM AS
;                            DESCRIBED ABOVE
;
;           RETURN: F7 = F7 ANDED WITH 1 IF #1 < #2
;                                      2 IF #1 = #2
;                                      4 IF #1 > #2
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-5,F7,AUX0
;
;      RELALPHC: COMPARE 2 ALPHA VALUES OF EQUAL LENGTH
;
;           ENTRY: F1,0 = LENGTH OF VALUES
;                  PC'S = ADDRESS OF VALUE#1
;                  AUX0 = ADDRESS OF VALUE#2
;                  F7 = 0 OR RELATION-OPERATOR-ATOM AS
;                            DESCRIBED ABOVE
;                  F4 = 0
;
;           RETURN: F7 = F7 ANDED WITH 1 IF #1 < #2
;                                      2 IF #1 = #2
;                                      4 IF #1 > #2
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-1,F5,F7
;                               AUX0
;

REL:
        CALL    ALPHA       ;LOOK FOR ALPHA ARGUMENT
        TEST    R0,0FH
        JZ      RELALPHA

;      NUMERIC RELATION
;
        CALL    EXPR        ;SCAN AND EVALUATE AN EXPRESSION
;2/21/89 +++
        test    sl,2            ;br, if xphase
        jnz     _m0613          ;
        call    relop           ;
        jmp     expr            ;scan 2nd experssion
_m0613:
        call    rel_x           ;look for rel operator
        push    ax              ;save operator

;2/21/89 ---

        CALL    EXPR
        MOV     EDX,VSPTR    ;PC'S POINT TO VALUES
        CALL    MATHCMP     ;COMPARE VALUES

;2/21/89 +++
        pop     ax
        and     r7,al
;2/21/89 ---
        MOV     EDX,AUX01
;       JMP     DELETV8A    ;DELETE 1ST VALUE FROM VS AND RETURN
        ADD     EDX,8
        XCHG    EDX,VSPTR   ;VSPTR = PC'S + 8
        RET


;      ALPHA RELATION
;

RELALPHA:
;2/21/89 ++
        test    sl,2            ;br, if xphase
        jnz     relalph1        ;
        call    relop           ;get relation operator

;2/21/89 --
        CALL    ALPHA       ;SCAN 2ND ALPHA ARGUMENT
        TEST    R0,0FH
        JZ      SR@MD06     ;F, BRANCH

ERR_29S:
        JMP     ERROR_29    ;NF, ERROR

;2/21/89 ++
RELALPH1:
        call    rel_x           ;get relation operator
        push    ax

;2/21/89 --

        CALL    ALPHA       ;SCAN & PROCESS 2ND ALPHA ARGUMENT
        TEST    R0,0FH
        JNZ     ERR_29S

        pop     ax              ;restore operation operator
        mov     r7,al
        mov     esi,vsptr       ;
        lodsw                   ;get length of value #2
        mov     cx,ax           ;
        lodsd                   ;get address of value #2
        mov     edi,eax         ;
        lodsw                   ;get length of value #1
        mov     bx,ax           ;
        lodsd                   ;get address of value #1
        mov     vsptr,esi       ;update vsptr

        mov     esi,eax         ;ESI pt to value #1
                                ;EDI pt ot value #2
        mov     ax,cx           ;AX has length of value #2
        mov     cx,bx           ;CX has length of value #1

;
;      COMPARE 2 ALPHA VALUES
;
;           ENTRY: F1,0 = LENGTH OF VALUE#1
;                  PC'S = ADDRESS OF VALUE#1
;                  F3,2 = LENGTH OF VALUE#2
;                  AUX0 = ADDRESS OF VALUE#2
;
;           RETURN: F7 ANDED WITH 1 IF #1<#2
;                                 2 IF #1=#2
;                                 4 IF #1>#2
;
rela_b:
        and     ecx,0ffffh      ;make sure higher word = 0
        cmp     cx,ax           ;value #1 longer than value #2 ?
        je      rela_e          ;br if equal length
        jb      rela_l          ;br, if value #2 is longer

rela_g:                         ;value #1 is longer
        sub     cx,ax           ;get the length difference
        xchg    cx,ax           ;save difference if ax
        repe    cmpsb           ;chk two string
        ja      rela_4          ;br, if value #1 > value #2
        jb      rela_1          ;br, if vale #1 < value #2
rela_g1:
        movzx   ecx,ax          ;restore the length difference
rela_g2:
        cmp     byte ptr [esi],20h      ;chk with space char
        jb      rela_1          ;br, if < space
        ja      rela_4          ;br, if > space
        inc     esi             ;pt to next char
        loop    rela_g2         ;
rela_2:
        and     r7,02h          ;mark two values are equal
        ret

rela_1:
        and     r7,01h          ;mark value #1 < value #2
        ret


rela_e:
        and     ecx,0ffffh      ;make sure higher word = 0
        repe    cmpsb           ;chk chars
        jz      rela_2          ;they are equal
        jb      rela_1          ;value #1 < value #2
rela_4:
        and     r7,04h          ;mark value #1 > value #2

        ret
rela_l:
        sub     ax,cx           ;ax has the length difference
        repe    cmpsb           ;chk chars
        jb      rela_1          ;value #1 < value #2
        ja      rela_4          ;value #1 > value #2
rela_l1:
        mov     cx,ax           ;get the length difference
rela_l2:
        cmp     byte ptr [edi],20h      ;
        jb      rela_4          ;<
        ja      rela_1          ;>
        inc     edi             ;
        loop    rela_l2         ;
        jmp     rela_2          ;=

RELALPHB:
        MOV     AX,WORD PTR R0
        MOV     BX,WORD PTR R2
        CMP     AX,BX
        JB      RELALPH4                ;BR, IF LENGTH#1 < LENGTH#2
        MOV     R4,0                    ;FLAG: LENGTH#1 = LENGTH#2
        JBE     RELALPHC                ;BR, IF LENGTH#1 = LENGTH#2
        MOV     WORD PTR [R4],AX        ;F4,3 = LENGTH#1
        MOV     WORD PTR [R0],BX        ;F1,0 = LENGTH#2
        XOR     EAX,EAX
        MOV     AX,WORD PTR [R4]
        ADD     EAX,EDX
        MOV     DWORD PTR [A2],EAX      ;A3,2 = END#1 (ADDR OF END OF VALUE#1 +1
        MOV     R4,2                    ;FLAG: LENGTH#1 > LENGTH#2

RELALPHC:
        XOR     EAX,EAX
        MOV     AX,WORD PTR [R0]
        ADD     EAX,EDX
        MOV     DWORD PTR [A0],EAX      ;A1,0 = END#0 (MIN. OF END#1,#2)

RELALPH5:
        CMP     DWORD PTR [A0],EDX
        JBE     RELALPH6                ;BR, IF PAST END#0
        MOV     CH,BYTE PTR [EDX]       ;GET NEXT CHARACTER OF VALUE#1
        XCHG    EDX,AUX00
        INC     AUX00
        MOV     R5,CH                   ;F5 = NEXT CHARACTER OF VALUE#1 (CHARACTER#1)
        MOV     CH,BYTE PTR [EDX]       ;CH = NEXT CHARACTER OF VALUE#2 (CHARACTER#2)
        XCHG    EDX,AUX00
        INC     AUX00
        CMP     R5,CH
        JE      RELALPH5                ;BR, IF CHARACTER#1 = CHARACTER#2

RELALF11:
        CMP     R5,CH
        JB      RELALPH7                ;BR, IF VALUE#1 < VALUE#2

RELALF12:
        AND     R7,04H                  ;AND REL-OPERATOR & COMPARE RESULT

SR@MD06:
        RET

RELALPH6:
        TEST    R4,0FH
        JNZ     RELALPH8                ;BR, IF LENGTH#1 <> LENGTH#2
RELALF10:
        AND     R7,02H                  ;AND REL-OPERATOR & COMPARE RESULT
        RET

RELALPH8:
        MOV     R5,20H                  ;F5 = SPACE
        CMP     R4,2
        JE      RELALPH9                ;BR, IF LENGTH#1 > LENGTH#2
        XCHG    EDX,AUX00

RELALXXX:
        CMP     DWORD PTR [A2],EDX
        JBE     RELALF10                ;BR, IF PAST END OF VALUE#2
        MOV     CH,BYTE PTR [EDX]       ;GET NEXT CHARACTER OF VALUE#2
        INC     EDX
        CMP     R5,CH
        JE      RELALXXX                ;BR, IF CHARACTER = 'SPACE'
        JMP     RELALF11

RELALPH9:
        CMP     DWORD PTR [A2],EDX
        JBE     RELALF10                ;BR, IF PAST END OF VAL#1
        MOV     CH,BYTE PTR [EDX]       ;GET NEXT CHARACTER OF VALUE#1
        INC     EDX
        CMP     CH,R5
        JE      RELALPH9                ;BR, IF CHARACTER = 'SPACE'
        CMP     R5,CH
        JB      RELALF12                ;BR, IF VALUE#1 > VALUE#2

RELALPH7:
        AND     R7,01H                  ;AND REL-OPERATOR & COMPARE RESULT
        RET

RELALPH4:
        XCHG    EDX,AUX00               ;PC'S = ADDRESS OF VALUE#2
        XOR     EAX,EAX
        MOV     AX,WORD PTR [R2]
        ADD     EAX,EDX
        MOV     DWORD PTR [A2],EAX      ;A3,2 = END#2 (ADDR OF END OF VALUE#2 +1)
        XCHG    EDX,AUX00
        MOV     R4,1                    ;FLAG: LENGTH#1 < LENGTH#2
        JMP     RELALPHC


;      CONSOLEP: SET ALL DEVICE TABLE ENTRIES TO PRIMARY
;                DEVICE ADDRESSES. #1-15 ARE ZEROED OUT.
;
;           CI = 001     CO = 005(64)
;           PLOT = 413   TAPE = 10A  ?
;           DISK = 310   #1-15 = 0
;
;      CONSOLE: SET ALL DEVICE TABLE ENTRIES TO CURRENT
;               CONSOLE DEVICE ADDRESSES. #1-15 ARE
;               ZEROED OUT.
;
;           INPUT = CI
;           PRINT,LIST = CO
;           #1-15 = 0
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-2,AUX0
;
;      CONSOLEA: CO & CI = PRIMARY ADDRESSES
;
;           MODIFIED REGISTERS: PC'S,CH,CL,AUX0,F0-2
;

CONSOLEA:
        MOV     CH,BYTE PTR _DEVCI              ;GET PRIMARY CI DEVICE ADDR
        MOV     EDX,CPBASE                      ;GET CURRENT ADDR
        LEA     EAX,[EDX].@DEVCI                ;PT TO @DEVCI
        MOV     BYTE PTR [EAX],CH               ;PUT TYPE IN
        MOV     BYTE PTR [EAX+1],@MXDIADR       ;CI ADDR (01)
        MOV     CH,BYTE PTR _DEVCO              ;GET PRIMARY CO DEVICE ADDR
        LEA     EAX,[EDX].@DEVCO                ;PT TO @DEVCO
        MOV     BYTE PTR [EAX],CH               ;PUT TYPE IN
        MOV     BYTE PTR [EAX+1],@MXDOADR       ;CO ADDR (05)
        RET

CONSOLEP:
        CALL    CONSOLEA                        ;CI & CO = PRIMARY ADDRESSES
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     EAX,OFFSET _DEVCO
        MOV     CH,BYTE PTR [EAX+2]             ;GET LINE WIDTH
        LEA     EAX,[EDX].@DEVCO
        MOV     BYTE PTR [EAX+2],CH             ;STORE IT
        MOV     AX,WORD PTR [_DEVPLOT]          ;GET PRIMARY PLOT ADDR
        MOV     WORD PTR [EDX].@DEVPLOT,AX      ;PUT IN @DEVTBL
        MOV     AX,WORD PTR [_DEVTAPE]          ;GET PRIMARY TAPE ADDR
        MOV     WORD PTR [EDX].@DEVTAPE,AX      ;PUT IN @DEVTBL
        MOV     AX,WORD PTR [BOOTDEV]           ;GET PRIMARY DISK ADDR
        XCHG    AH,AL
        MOV     WORD PTR [EDX].@DEVDISK,AX      ;PUT IN @DEVTBL

CONSOLE:
        MOV     EDX,CPBASE                      ;GET CURRENT BASE
        MOV     AX,WORD PTR [EDX].@DEVCI        ;GET CONSOLE IN DEF
        MOV     WORD PTR [EDX].@DEVINPT,AX      ;MAKE INPUT = CI

        MOV     EAX,DWORD PTR [EDX].@DEVCO      ;GET CONSOLE OUT DEF (4 BYTES)
        MOV     DWORD PTR [EDX].@DEVPRNT,EAX    ;MAKE PRINT = CO
        MOV     DWORD PTR [EDX].@DEVLIST,EAX    ;MAKE LIST = CO

        LEA     EDI,[EDX].@DEVDISK              ;EDI PT TO DISK TABLE
        and     byte ptr [edi],0fh
        ADD     EDI,2                           ;SKIP PRIMARY TYPE & ADDR
        LEA     EBX,[EDX].@NAME                 ;EBX HAS THE ENDING OFFSET
        XOR     EAX,EAX                         ;ZERO CONTENT
        STOSW                                   ;CLEAR PRIMARY ST-ADR
        STOSD                                   ;CLEAR PRIMARY CURR,END-ADR

CONSOLE1:
        STOSD                                   ;ZERO DISK ENTRY
        STOSD                                   ;
        CMP     EDI,EBX                         ;MORE ENTRY ?
        JB      CONSOLE1                        ;ZERO NEXT ENTRY
        RET


;      FINDVAR: FIND SPECIFIED VARIABLE IN SYMBOL TABLE.
;               IF LOOKING FOR AN ARRAY, FINDVAR LOOKS FOR
;               EITHER A 1-DIM OR 2-DIM ARRAY AND RETURNS
;               A FLAG INDICATING WHICH WAS FOUND.
;               LOOK IN CURRENT PARTITION IF NOT GLOBAL VAR.
;               LOOK IN GLOBAL PARTITION IF GLOBAL VARIABLE;
;               IGNORE GLOBAL VARIABLE IF NOT EXECUTION PHASE.
;
;      FINDVARL: LOOK ONLY IN CURRENT PARTITION.
;
;
;               SYMBOL TABLE ENDS WHEN SYMBOL NAME LETTER
;                    IS HEX(00).
;
;           ENTRY: F3 = NAME LETTER OF VARIABLE
;                  F2 (HIGH 4 BITS) = NAME DIGIT OF VAR.
;                                     (F IF NO DIGIT)
;                     (LOW 4 BITS)  = TYPE OF VARIABLE
;                                     0 IF NUMERIC SCALAR
;                                     1 IF ALPHA SCALAR
;                                     2 IF NUMERIC ARRAY
;                                     3 IF ALPHA ARRAY
;
;           RETURN: F0 = 0 IF FOUND, PC'S POINT AFTER THE
;                          THREAD TO NEXT VARIABLE.  FOR
;                          NUMERIC SCALARS, PC'S POINT TO
;                          VALUE OF VARIABLE. FOR ALPHA
;                          SCALARS, PC'S POINT TO DEFINED
;                          LENGTH OF VARIABLE. FOR ARRAYS,
;                          PC'S POINT TO DIMENSIONS.
;
;                          CH,CL = NAME & ATOM OF VARIABLE
;                                  THAT WAS FOUND
;
;                   F0 = 1 IF NOT FOUND.
;
;           MODIFIED REGISTERS: PC'S,F0,F1,CH,CL
;
;           NOTE: ASSUMES EACH SYMBOL IN SYMBOL TABLE
;                 STARTS ON EVEN ADDRESS


FINDVAR:TEST    R2,8
        JZ      FINDVARL        ;BRANCH IF NOT GLOBAL VARIABLE
        TEST    SL,2            ;BRANCH IF EXECUTION PHASE
        JNZ     FINDVARA
        MOV     R0,0            ;FLAG = 'VARIABLE FOUND' (PRETEND)
        RET

FINDVARA:
        MOV     EDX,DWORD PTR [CPBASE]      ;POINT TO CURRENT PARTITION
        MOV     EDX,DWORD PTR [EDX].@XBASE  ;POINT TO GLOBAL PARTITION
        JMP     FINDVARB

FINDVARL:
        MOV     EDX,DWORD PTR [CPBASE]      ;POINT TO CURRENT PARTITION
        cmp     edx,dword ptr [edx].@xbase
        jne     findvarb
        TEST    SL,2
        JNZ     FINDOK

FINDVARB:
        LEA     EDX,[EDX].@VARTHRD   ;EDX = OFFSET OF VAR THREAD BEG
        XOR     EBX,EBX              ;CLEAR REG
        MOV     BL,R3                ;GET THE CHARACTER
        SUB     EBX,41H
        SHL     EBX,2                ;CAL THE OFFSET FROM BEG BY CHARACTER CODE
        ADD     EDX,EBX              ;EDX PT TO THREAD OF CHAR
        MOV     EDX,DWORD PTR [EDX]  ;GET THE THREAD

FINDVAR1:
        TEST    R2,6                 ;br if variable = scalar
        JNZ     FINDVAR4

;       search for scalar variable
;

FINDVAR2:
        MOV     CX,WORD PTR [EDX]    ;get name & atom
        XCHG    CH,CL
        CMP     CL,R2                ;= variable search?
        JE      FINDVAR3
        CMP     CH,0
        JE      FINDVAR5
        ADD     EDX,2
        MOV     EDX,DWORD PTR [EDX]  ;get the thread to next symbol with same letter
        JMP     FINDVAR2

;     search for array varibale
;

FINDVAR4:
        MOV     CX,WORD PTR [EDX]    ;get name & atom
        XCHG    CH,CL
        CMP     CH,0
        JE      FINDVAR5
        MOV     AL,R2
        XOR     AL,CL
        AND     AL,0FBH              ;don't care the reserved bit!
        CMP     AL,0
        JE      FINDVAR3
        ADD     EDX,2
        MOV     EDX,DWORD PTR [EDX]  ;get the thread to next symbol with same letter
        JMP     FINDVAR4

FINDVAR5:
        MOV     R0,1                 ;FLAG NOT FOUND
        RET

FINDVAR3:
        ADD     EDX,6                ;set pc pt to value (or dim)
        MOV     DWORD PTR [TEXTPTR-4],EDX
        TEST    SL,2
        JNZ     FINDOK1

        MOV     R0,0                 ;FLAG FOUND
        RET

FINDOK: CMP     DWORD PTR [TEXTPTR-4],0
        JE      FINDVARB
        MOV     EDX,DWORD PTR [TEXTPTR-4]
FINDOK1:
        MOV     CX,WORD PTR [EDX-6]
        XCHG    CH,CL
        MOV     R0,0
        RET


;      ADDVAR: ADD A VARIABLE TO THE SYMBOL TABLE.
;
;           ENTRY: F3 = NAME LETTER OF VARIABLE
;                  F2 (HIGH 4 BITS) = NAME DIGIT OF VAR.
;                                     ('F' IF NOT DIGIT)
;                     (LOW 4 BITS ) = SYMBOL TABLE ATOM
;                                     OF VARIABLE
;
;                                     0 = NUMERIC SCALAR
;                                     2 = NUMERIC VECTOR
;                                     6 = NUMERIC ARRAY
;                                     1 = ALPHA SCALAR
;                                     3 = ALPHA VECTOR
;                                     7 = ALPHA ARRAY
;
;                          F7,6 = DIMENSION(S) FOR ARRAYS
;
;                          F5 = LENGTH OF VARIABLE (ALPHA
;                               ONLY) (UP TO 124 ONLY)
;                          PHASE = RESOLUTION
;
;           RETURN: AUX0 POINT TO VALUE OF VARIABLE ADDED
;                   TO SYMBOL TABLE IF NUMERIC VARIABLE.
;                   POINTS TO DEFINED LENGTH OF ALPHA
;                   VARIABLES.
;
;           NOTE: ASSUMES EACH SYMBOL IN SYMBOL TABLE IS
;                 ALIGNED ON AN EVEN ADDRESS.
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,F4,AUX0
;

ADDVAR:
        TEST    SL,2            ;ERROR IF EXECUTION PHASE
        JNZ     ERROR_55
        TEST    R2,8            ;IGNORE GLOBAL VARIABLES
        JNZ     ADDVAR3
        MOV     EDX,DWORD PTR [CPBASE]     ;GET CURRENT BASE
        MOV     CH,BYTE PTR [EDX].@RESFLG  ;GET RESOLTION FLAG
        TEST    CH,1            ;IGNORE LOCAL VARIABLES AFTER DEFFN@ (R-PHASE)
        JZ      ADDVAR2
        TEST    MODE,02H
        JNZ     ADDVAR2

ADDVAR3:
        RET

ADDVAR@:
        TEST    SL,2            ;BRANCH IF NOT EXECUTION PHASE
        JZ      ADDVAR2

ERROR_55:
        MOV     R0,55H          ;UNDEFINED VARIABLE
        JMP     ERROR

ADDVAR2:
        TEST    R2,2            ;BRANCH IF NOT SCALAR VARIABLE
        JNZ     ADDVAR1

;   SCALAR VARIABLE
;

        MOV     EBX,8           ;IF NUMERIC THEN VALUE LENGTH = 8
        TEST    R2,1            ;IF ALPHA VARIABLE ?
        JZ      ADDVAR6         ;NO,
        MOV     BL,R5           ;GET LENGTH
        TEST    BL,1            ;IF ODD LENGTH THEN LENGTH + 1
        JZ      ADDVAR9         ;EVEN,
        INC     EBX             ;+1
ADDVAR9:
        INC     EBX

ADDVAR6:
        MOV     EDX,VARPTR      ;GET CURRENT PTR (STACK ON TABLE!!)
        MOV     DWORD PTR [A0],EDX
        MOV     EAX,6           ;EAX = SIZE USED BY VARIABLE INFORMATION
                                ;      2 BYTES NAME, DIGIT AND TYPE
                                ;      4 BYTES THREAD TO NEXT SYM WITH SAME LETTER
                                ;      2 BYTES DIM SPEC (IF VECTOR BIT ON)
                                ;      1 BYTE MAX LENGTH FOR ALPHA VARIABLE
        ADD     EAX,EBX         ;GET THE LENGTH
        SUB     EDX,EAX         ;EDX = NEW VARPTR POSTION
        CMP     EDX,DWORD PTR [@@VSEND]   ;ENOUGH FOR VS ?
        JB      ERROR_02        ;NO, ERROR

;  NOTE, THIS IS WHERE VS SHOULD BE MOVED & ERR02 CHECKED
;

        MOV     DWORD PTR [TEXTPTR-4],EDX
        ADD     DWORD PTR [TEXTPTR-4],6

ADDVARYYY:
        MOV     EAX,DWORD PTR [CPBASE]  ;GET CURRENT BASE
        LEA     EAX,[EAX].@VARTHRD      ;EDX = OFFSET OF VARTHRD BEG
        XOR     EBX,EBX         ;CLEAR REG
        MOV     BL,R3           ;GET THE CHARACTER
        SUB     EBX,41H         ;
        SHL     EBX,2           ;CAL THE OFFSET FROM BEG BY CHARACTER CODE
        ADD     EAX,EBX         ;EDX PT TO THREAD OF CHAR
        MOV     ECX,DWORD PTR [EAX]     ;GET ORI THREAD
        MOV     VARPTR,EDX              ;NEW TOP OF SYMBOL TABLE
        MOV     DWORD PTR [EAX],EDX     ;SAVE NEW THREAD

        MOV     AX,WORD PTR [R2]        ;ax = name ,digit & type
        XCHG    AH,AL
        MOV     WORD PTR [EDX],AX       ;save in st
        ADD     EDX,2                   ;edx pt to thread to next sam letter sym
        MOV     DWORD PTR [EDX],ECX     ;save ori thread
        ADD     EDX,4                   ;pt to option filed (dim,alpha leng ...)
        TEST    R2,2                    ;vector ?
        JZ      ADDVARB                 ;no
        MOV     AL,R7                   ;get dim
        MOV     BYTE PTR [EDX],AL       ;save it
        INC     EDX                     ;pt to next byte
        MOV     AL,R6                   ;WRITE ARRAY DIMENSION(S)
        MOV     BYTE PTR [EDX],AL       ;
        INC     EDX                     ;pt to option field -- max length

ADDVARB:
        MOV     AUX00,EDX               ;AUX0 = PTR
        MOV     R4,0                    ;R4 = 00 IF NUMERIC
        TEST    R2,1                    ;if numeric
        JZ      ADDVARC                 ;yes
        MOV     AL,R5                   ;WRITE ELEMENT LENGTH IF ALPHA
        MOV     BYTE PTR [EDX],AL
        INC     EDX                     ;pt to value
        MOV     R4,20H                  ;R4 = 20 IF ALPHA

ADDVARC:
        MOV     AL,R4                   ;INITIALIZE VALUE TO BLANKS OR ZEROES
        MOV     BYTE PTR [EDX],AL
        INC     EDX                     ;byte by byte
        CMP     DWORD PTR [A0],EDX      ;init to last varptr pos?
        JNE     ADDVARC                 ;no

        TEST    MODE,02H                ;execution phase
        JNZ     ADDVARD                 ;BRANCH IF IMMEDIATE EXECUTION
        MOV     EDX,DWORD PTR [CPBASE]  ;INITIALIZE STACKS
        LEA     EAX,[EDX].@DVTBL
        MOV     DWORD PTR [EDX].@DVTPTR,EAX
        LEA     EBX,[EDX].@OSBEG
        MOV     OSPTR,EBX
        MOV     EAX,VARPTR
        MOV     VSPTR,EAX
        MOV     DWORD PTR [EDX].@SAVEVS,EAX
        MOV     DWORD PTR [EDX].@SAVEOS,EBX
        RET

ADDVARD:
        MOV     EDX,DWORD PTR [CPBASE]  ;INITIALIZE STACKS, CONTINUE/HALT ILLEGAL
        LEA     EAX,[EDX].@DVTBL
        MOV     DWORD PTR [EDX].@DVTPTR,EAX
        LEA     EBX,[EDX].@OSBEG
        MOV     OSPTR,EBX
        MOV     EAX,VARPTR
        MOV     VSPTR,EAX
        MOV     DWORD PTR [EDX].@SAVEVS,EAX
        MOV     DWORD PTR [EDX].@SAVEOS,EBX
        MOV     DH,0FFH
        MOV     CONTLN_,EDX
        RET

;      ARRAYS
;

ADDVAR1:XOR     EBX,EBX
        MOV     BX,WORD PTR [R6]        ;R1,0 = DIMENSION(S)
        MOV     DX,WORD PTR [R2]        ;PH,PL = NAME & TYPE (SAVE)
        TEST    R2,4                    ;BRANCH IF VECTOR
        JZ      ADDVARA
        MOV     AL,BL
        MUL     BH
        MOV     BX,AX                   ;R1,0 = NUMBER OF ELEMENTS (DIM1 * DIM2)

ADDVARA:
        TEST    DL,1                    ;BRANCH IF ALPHA
        JNZ     ADDVAR5

;      NUMERIC ARRAY
;

        SHL     EBX,3

ADDVAR4:MOV     WORD PTR [R2],DX    ;RESTORE NAME & TYPE TO F3,2
        ADD     EBX,2
        JC      ERROR_01

        MOV     EDX,VARPTR      ;GET CURRENT PTR (STACK ON TABLE!!)
        MOV     DWORD PTR [A0],EDX
        MOV     EAX,6           ;EAX = SIZE USED BY VARIABLE INFORMATION
                                ;      2 BYTES NAME, DIGIT AND TYPE
                                ;      4 BYTES THREAD TO NEXT SYM WITH SAME LETTER
                                ;      2 BYTES DIM SPEC (IF VECTOR BIT ON)
                                ;      1 BYTE MAX LENGTH FOR ALPHA VARIABLE
        ADD     EAX,EBX         ;GET THE LENGTH
        CMP     EDX,EAX
        JB      ERROR_01
        SUB     EDX,EAX         ;EDX = NEW VARPTR POSTION
        CMP     EDX,DWORD PTR [@@VSEND]   ;ENOUGH FOR VS ?
        JB      ERROR_02        ;NO, ERROR
        JMP     ADDVARYYY

ERROR_01:
        JMP     ERR_01             ;EXCEED MEMORY SIZE

;      ALPHA ARRAY
;

ADDVAR5:MOV     AUX00,EDX   ;SAVE NAME AND TYPE
        XOR     EAX,EAX
        MOV     AL,R5
        MUL     BX
        JC      ERROR_50
        MOV     BX,AX
        MOV     EDX,AUX00          ;PC'S = NAME & TYPE
        TEST    EBX,1
        JNZ     ADDVAR5X
        INC     EBX                ;ADD 1 TO NO. OF BYTES IF EVEN
        JC      ERROR_01
ADDVAR5X:
        INC     EBX
        JC      ERROR_01
        JMP     ADDVAR4


;      INITVAR: INITIALIZE SYMBOL TABLE POINTERS
;               (CLEAR ALL VARIABLES)
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;

INITVAR:
        MOV     EBX,DWORD PTR [CPBASE]            ;GET CURRENT BASE
        MOV     EAX,DWORD PTR [EBX].@VAREND       ;GET @VAREND
        MOV     EDX,EAX
        MOV     VARPTR,EDX
        MOV     BYTE PTR [EDX],0    ;INITIALIZE SYMBOL TABLE PTRS (CLEAR ALL VAR.)
        MOV     BYTE PTR [EDX+1],0EFH
        LEA     EDX,[EBX].@COMPTR
        MOV     DWORD PTR [EDX],EAX
        LEA     EDX,[EBX].@VARTHRD
        MOV     ECX,26

INITVAR1:
        MOV     DWORD PTR [EDX],EAX
        ADD     EDX,4
        LOOP    INITVAR1

        RET

;      CLEARN: CLEAR ALL NONCOMMON VARIABLES
;
;           MODIFIED REGISTERS: PC'S,CHCL,F0-2,AUX0
;

CLEARN:
        MOV     EDX,CPBASE
        MOV     ECX,DWORD PTR [EDX].@COMPTR
        MOV     VARPTR,ECX                   ;VARPTR = COMPTR
        LEA     EAX,[EDX].@VARTHRD           ;BEG OF TABLE
        LEA     EBX,[EDX].@VARTHRE           ;END OF TABLE

CLEARN3:MOV     EDI,EAX
        MOV     ESI,DWORD PTR [EAX]        ;GET NEXT START-OF-CHAIN PTR
        ADD     EAX,4
        CMP     ECX,ESI                    ;BRANCH IF START-OF-CHAIN >= COMPTR
        JBE     CLEARN1

CLEARN2:MOV     EDX,ESI
        CMP     BYTE PTR [EDX],0           ;END OF CHAIN
        JE      CLEARN1
        ADD     EDX,2
        MOV     ESI,DWORD PTR [EDX]        ;GET NEXT THREAD IN CHAIN
        CMP     ESI,ECX                    ;BRANCH IF THREAD < COMPTR
        JB      CLEARN2
        MOV     DWORD PTR [EDI],ESI

CLEARN1:CMP     EAX,EBX                    ;BRANCH IF MORE START-OF-CHAIN PTRS
        JB      CLEARN3
        RET


;      NEXTVAR: FIND NEXT (PHYSICAL LOCATION) VARIABLE
;               IN SYMBOL TABLE
;
;           ENTRY: PC'S = ADDRESS OF CURRENT VARIABLE
;
;           RETURN: F3F2 = ADDRESS OF THE NEXT VARIABLE
;                          IN SYMBOL TABLE (VAREND IF
;                          NO MORE)
;
;           MODIFIED REG: PC'S,CH,CL,F3F2
;

NEXTVAR:
        MOV     DWORD PTR [A0],EDX      ;R1,0 = ADDRESS OF CURRENT VARIABLE
        DEC     EDX
        MOV     CH,BYTE PTR [EDX]       ;GET DIGIT & TYPE DEF
        TEST    CH,8                    ;branch if not global variable
        JZ      NEXTVAR4
        MOV     EDX,CPBASE
        MOV     EDX,DWORD PTR [EDX].@XBASE
        MOV     ECX,DWORD PTR [EDX].@VAREND
        MOV     DWORD PTR [A2],ECX      ;save ptr
        LEA     EDX,[EDX].@VARTHRD
        MOV     EBX,EDX
        ADD     EBX,124
        JMP     NEXTVAR2

; End of added logic
;

nextvarl:
        mov     dword ptr [a0],edx
NEXTVAR4:
        MOV     EDX,CPBASE
        MOV     ECX,DWORD PTR [EDX].@VAREND
        MOV     DWORD PTR [A2],ECX  ;R3,2 = END OF SYMBOL TABLE PTR
        LEA     EDX,[EDX].@VARTHRD
        MOV     EBX,EDX
        ADD     EBX,124

NEXTVAR2:
        MOV     ECX,DWORD PTR [EDX]    ;GET NEXT START-OF-CHAIN PTR
        MOV     AUX00,EDX
        ADD     AUX00,4
        JMP     NEXTVAR3

NEXTVAR1:
        MOV     EDX,ECX
        ADD     EDX,2
        MOV     ECX,DWORD PTR [EDX]    ;GET NEXT THREAD IN CHAIN

NEXTVAR3:
        CMP     ECX,DWORD PTR [A0]     ;BRANCH IF THREAD < SPECIFIED
        JB      NEXTVAR1

        CMP     DWORD PTR [A2],ECX     ;BRANCH IF THREAD >= (SMALLEST THREAD
        JBE     NEXTVAR9

;       FOUND > SPECIFIED ADDRESS)
;

        MOV     DWORD PTR [A2],ECX  ;F3,2 = THREAD

NEXTVAR9:
        MOV     EDX,AUX00
        CMP     EDX,EBX
        JNE     NEXTVAR2
        RET

        EVEN
ALIGN_0:
        PUSH    ECX
        PUSH    EDX
        PUSH    ESI
        PUSH    EDI
        XOR     ECX,ECX                 ;
        MOV     EBX,VSPTR               ;GET VSPTR
        MOV     CX,WORD PTR [EBX]       ;GET EXPONENT PART
        MOV     EDI,DWORD PTR [EBX+2]   ;GET LOWER DWORD
        MOV     SI,WORD PTR [EBX+6]     ;GET MANTISSA
        MOV     BYTE PTR [POS],0                   ;FLAG MANTISSA > 0
        OR      SI,SI                   ;CHECK SIGN OF MANTISSA
        JNS     SGN_EXP                 ;BR, IF POSITIVE
        MOV     BYTE PTR [POS],-1                  ;FLAG MANTISSA < 0
        NOT     SI                      ;2' COMP
        NEG     EDI                     ;
        JNZ     SGN_EXP                 ;BR, IF NO CARRY IN
        INC     SI                      ;CARRY IN
SGN_EXP:
        OR      CX,CX                   ;CHECK EXP SIGN
        JNS     TIMEBY10                ;MANTISSA * 10 LOOP CX TIME
        NEG     CX                      ;
DIVBY10:
        MOV     EBX,10                  ;PREPARE DIVISOR (10/100/1000/10000)
        DEC     CX                      ;
        JZ      DIV10_0                 ;
        MOV     EBX,100                 ;
        DEC     CX                      ;
        JZ      DIV10_0                 ;
        MOV     EBX,1000                ;
        DEC     CX                      ;
        JZ      DIV10_0                 ;
        MOV     EBX,10000               ;
        DEC     CX                      ;
DIV10_0:
        MOV     EDX,0                   ;
        MOV     EAX,0                   ;
        MOV     AX,SI                   ;START FROM M3
        DIV     BX                      ; M3/10
        MOV     SI,AX                   ;SAVE NEW M3
        MOV     EAX,EDI                 ; M2/10
        DIV     EBX                     ;
        MOV     EDI,EAX                 ;SAVE NEW M2

        OR      CX,CX                   ;MORE DIVIDE TO DO?
        JNZ     DIVBY10                 ;YES
        JMP     ALIGN_SGN               ;

TIMEBY10:
        MOV     DX,SI                   ;DUPLICATE ORI MANTISSA
        MOV     EAX,EDI                 ;
        SHL     EDI,1                   ;MANTISSA * 10
        RCL     SI,1                    ;
        SHL     EDI,1                   ;
        RCL     SI,1                    ;
        ADD     EDI,EAX                 ;
        ADC     SI,DX                   ;
        SHL     EDI,1                   ;
        RCL     SI,1                    ;
        LOOP    TIMEBY10                ;

ALIGN_SGN:
        CMP     BYTE PTR [POS],0                   ;MANTISSA NEED 2'COM ?
        JE      ALGN0_RET               ;NO
        NOT     SI                      ;2' COMP
        NEG     EDI                     ;
        JNZ     ALGN0_RET               ;BR, IF NO CARRY IN
        INC     SI                      ;CARRY IN

ALGN0_RET:

MOVE_RES:
        CLC
        MOV     EBX,EDI                 ;
        SHL     EBX,16                  ;TAKES LOWER WORD
        MOV     EAX,EDI                 ;
        SHR     EAX,16                  ;TAKES HIGHER WORD
        CLC                             ;
        SHL     ESI,16                  ;TAKES LOWER WORD OF ESI
        OR      EAX,ESI                 ;

        ADD     VSPTR,8                 ;POP UP VALUE IN VS
        POP     EDI
        POP     ESI
        POP     EDX
        POP     ECX
        RET

POS     DB      0                       ;FLAG USED BY ALIGN_0, NUMBER POS OR NEG

CODE    ENDS
        END
