          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    ERR_29C
PUBLIC    ERR_34G
PUBLIC    ERROR_41
PUBLIC    GETINPT2
PUBLIC    GETINPUT
PUBLIC    ILLSTMT
PUBLIC    INPER_75
PUBLIC    INPUT
PUBLIC    INPUT1
PUBLIC    INPUT6
PUBLIC    INPUTA
PUBLIC    INPUTSUB
PUBLIC    NXTINPT
PUBLIC    PRINT
PUBLIC    PRINTBEG
PUBLIC    PRINTEND
PUBLIC    PRNTHEX
PUBLIC    RETURN
PUBLIC    RETURNP
PUBLIC    TRACE
PUBLIC    TRACDSBL
PUBLIC    TRACENBL
PUBLIC    VVFMT
PUBLIC    VVFMTA
PUBLIC    VVFMTB
PUBLIC    WORK_BUFFER

EXTRN     _ABCOV  :NEAR
EXTRN     ALPHA   :NEAR
EXTRN     ALPHA1  :NEAR
EXTRN     ARECEV  :NEAR
EXTRN     AVARR   :NEAR
EXTRN     CCJB    :NEAR
EXTRN     CCL     :NEAR
EXTRN     CNSLMSG :NEAR
EXTRN     CPRNTCR :NEAR
EXTRN     CPRNTCRZ:NEAR
EXTRN     ENBLCO  :NEAR
EXTRN     ENBLDEVO:NEAR
EXTRN     ENBLNULL:NEAR
EXTRN     ENBLSCO :NEAR
EXTRN     ENDSTIOZ:NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTA:NEAR
EXTRN     ENDSTMTS:NEAR
EXTRN     ENTERA  :NEAR
EXTRN     ENTERF  :NEAR
EXTRN     ENTER_  :NEAR
EXTRN     ERR_02  :NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_07:NEAR
EXTRN     ERROR_08:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     ERROR_48:NEAR
EXTRN     EXPR    :NEAR
EXTRN     FLTBIN  :NEAR
EXTRN     FLTBINA :NEAR
EXTRN     FLTBINSA:NEAR
EXTRN     LTRLQT  :NEAR
EXTRN     MVSCRTCH:NEAR
EXTRN     NXTCHEOS:NEAR
EXTRN     OBSCMPRS:NEAR
EXTRN     OBSCMPSP:NEAR
EXTRN     OBSTROBE:NEAR
EXTRN     PRINTV  :NEAR
EXTRN     PRINTVA :NEAR
EXTRN     PRNTCR  :NEAR
EXTRN     RECEV2  :NEAR
EXTRN     REM     :NEAR
EXTRN     REMCO   :NEAR
EXTRN     SCANCHA :NEAR
EXTRN     SCRATCH :NEAR
EXTRN     SNMBR   :NEAR
EXTRN     SWITCH  :NEAR
EXTRN     TRACELNA:NEAR
EXTRN     TRACELNB:NEAR
EXTRN     TWRITCOL:NEAR
EXTRN     TWRITE  :NEAR
EXTRN     TWRITESP:NEAR
EXTRN     VARR    :NEAR
EXTRN     WRT@    :NEAR
EXTRN     WRTHEX  :NEAR
EXTRN     WRTLINE_:NEAR
EXTRN     _PRNTLST:NEAR

EXTRN     CPBASE  :DWORD
EXTRN     @@VSEND :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;     ***********************************                                      ;
;     *                                 *                                      ;
;     *  MODULE-12: GENERAL STATEMENTS  *                                      ;
;     *                                 *                                      ;
;     ***********************************                                      ;
;                                                                              ;
;                                                                              ;
;     DESCRIPTION: GENERAL BASIC STATEMENTS                                    ;
;                    RETURN     PRINT     TRACE                                ;
;                    INPUT      LINPUT                                         ;
;                                                                              ;
;     ENTRY: BRANCH TO APPROPRIATE STATEMENT ROUTINE.                          ;
;            TEXTPTR POINTS AFTER VERB.                                        ;
;            TEXTLPTR POINTS TO CURRENT LINE.                                  ;
;                                                                              ;
;     EXIT: BRANCH TO 'ENDSTMT','ENDSTIO',OR 'ERROR'                           ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     TRACE: PROCESS A 'TRACE' STATEMENT
;
;          STMT FORMAT:  TRACE [OFF]
;
;          ENTRY: TEXTLPTR POINTS TO CURRENT LINE.
;                 TEXTPTR POINTS TO NEXT TEXT CHAR.
;

TRACE:    MOV       R0,@DISK            ;SEARCH FOR KEYWORD DISK
          CALL      CCL
          TEST      R0,0FH              ;
          JZ        TRACE2              ;BRANCH IF 'DISK' IS FOUND
          MOV       R0,@OFF
          CALL      CCL                 ;LOOK FOR 'OFF'
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        TRACE1
          AND       MODE,0FFF3H      ;TRACE OFF
          TEST      R0,0FH
          JZ        TRACE1
          OR        MODE,0008H      ;TRACE ON IF 'OFF' NOT FOUND
TRACE1:   JMP       ENDSTMT

TRACE2:   MOV       R0,@OFF
          CALL      CCL                       ;LOOK FOR 'OFF'
          TEST      R0,0FH
          JNZ       TRACE3                    ;'OFF' NOT FOUND, BR
          TEST      SL,2
          JZ        ENDSTMT
          MOV       EDX,DWORD PTR [CPBASE]    ;POINT TO CPBASE
          MOV       BYTE PTR [EDX].@TRDISK,0  ;TURN OFF DISK TRACE FLAG
          JMP       ENDSTMT                   ;EXIT

TRACE3:   TEST      SL,2
          JZ        ENDSTMT
          MOV       EDX,DWORD PTR [CPBASE]    ;POINT TO CPBASE
          MOV       BYTE PTR [EDX].@TRDISK,1  ;TURN ON DISK TRACE FLAG
          JMP       ENDSTMT                   ;EXIT



;     TRACENBL: ENABLE TRACE & PRINT 'CR' IF NOT AT BEGIN
;               OF LINE, IF TRACE IS ON & EXECUTION PHASE
;               & NOT IMMEDIATE EXECUTION
;
;          MODIFIED REGISTERS: PC'S,K,F1
;
;     TRACDSBL: DISABLE TRACE IF EXECUTION PHASE
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3,K
;

TRACENBL: TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        TRACDSB1
          TEST      MODE,00000008H      ;BRANCH IF TRACE OFF
          JZ        TRACDSB1
          TEST      MODE,00000002H      ;DON'T TRACE IF IMMEDIATE EXECUTION
          JNZ       TRACDSB1
          OR        MODE,00000004H      ;ENABLE TRACE
          CALL      ENBLSCO             ;ENABLE SELECTED  CONSOLE OUTPUT

;     **** line number logic added in rel 3.0 ****

;  Output line number and statement indicators at begin of trace line.
;
;        eg,   100 :::

          CALL      CPRNTCR              ;output CR if not at begin of line
          CALL      WRT@                 ;output '@' if global text
          MOV       EDX,TEXTLPTR
          ADD       EDX,4                ;PASS THREAD POINTER
          MOV       CX,WORD PTR [EDX]    ;get line#
          XCHG      CH,CL
          MOV       WORD PTR [R2],CX
          CALL      WRTLINE_             ;output line#

          MOV       EDX,STMTCNT
TRACENB2: CMP       DL,0                 ;branch if statement count 0
          JE        TRACENB1
          DEC       DL
          PUSH      EDX
          CALL      TWRITCOL             ;output ':'
          POP       EDX
          JMP       TRACENB2

TRACENB1: JMP       TWRITESP             ;output space

; ==============================================================================

TRACDSBL: TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        TRACDSB1
          TEST      MODE,0004H           ;BRANCH IF TRACE NOT ENABLED
          JZ        TRACDSB1
          AND       MODE,0FFFBH          ;DISABLE TRACE
          JMP       ENBLNULL             ;DISABLE CO (ENABLE NULL DEVICE)

TRACDSB1: RET


;     RETURN: PROCESS A 'RETURN' STATEMENT
;
;          STMT FORMAT:
;               (1) RETURN
;               (2) RETURN CLEAR
;               (3) RETURN CLEAR ALL
;
;          ENTRY: TEXTLPTR POINTS TO CURRENT TEXT LINE
;                 TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          DESCRIPTION: WHEN A RETURN STATEMENT IS
;               ENCOUNTERED, THE OPERATOR STACK IS
;               SCANNED FOR A @SUBR ATOM OR @SFKEY ATOM.
;               ANY INCOMPLETED FOR-GROUPS ARE FLUSHED
;               FROM THE STACKS.  IF A @SUBR ATOM IS
;               FOUND, A BRANCH IF MADE TO THE STATEMENT
;               FOLLOWING THE CORRESPONDING GOSUB STATE-
;               MENT AND THE RETURN-GROUP IS FLUSHED FROM
;               THE STACKS.  IF A @SFKEY ATOM IS FOUND,
;               A TRANSFER IS MADE BACK TO KEYBOARD ENTRY
;               IF NONE OF THE ABOVE ATOMS ARE FOUND,
;               ERR#25 RESULTS.
;

RETURN:   TEST      MODE,00000002H
          JZ        RETURNXX            ;BRANCH IF NOT IMMEDIATE MODE
          MOV       R0,07H              ;ILLEGAL IMMEDIATE MODE STATEMENT
          JMP       ERROR

RETURNXX: MOV       R0,@CLEAR
          CALL      CCL                 ;LOOK FOR 'CLEAR'
          TEST      R0,0FH              ;BRANCH IF NOT FOUND
          JNZ       RETURN7
          MOV       R0,@ALL
          CALL      CCL                 ;LOOK FOR 'ALL'
          TEST      R0,0FH              ;BRANCH IF FOUND (RETURN CLEAR ALL)
          JZ        RETURNCA
          MOV       R0,0                ;FLAG = RETURN CLEAR
RETURN7:  TEST      SL,02H              ;BRANCH IF NOT EXECUTION PHASE
          JZ        RETURN1
          PUSH      EAX
          MOVZX     EAX,R0
          PUSH      EAX
          CALL      TRACENBL            ;turn on TRACE if trace mode (rel 3.0)
          POP       EAX
          MOV       R0,AL
          POP       EAX

RETURN2:  MOV       EDX,OSPTR
          MOV       CH,BYTE PTR [EDX]   ;GET LAST OS ATOM
          DEC       OSPTR
                                        ;CARRY OFF
          MOV       AL,CH
          SHR       AL,4
          CMP       AL,@SUBRH
          JNE       RETURN5

;
;CHECK FOR GLOBAL SUBROUTINE RETURN
;
          MOV       R1,CH
          AND       R1,0F7H             ;F1 = SUBROUTINE ATOM - GLOBAL FLAG
          TEST      CH,08H              ;BRANCH IF NOT GLOBAL
          JZ        RETURN20
          MOV       EDX,VSPTR
          MOV       ECX,DWORD PTR [EDX]          ;GET IBASE FROM STACK
          MOV       EBX,DWORD PTR [EDX+4]        ;GET XBASE FROM STACK
          ADD       VSPTR,8
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       DWORD PTR [EDX].@IBASE,ECX  ;RESTORE IBASE
          MOV       DWORD PTR [EDX].@XBASE,EBX  ;RESTORE XBASE

RETURN20: MOV       AL,R1
          AND       AL,0FH
          CMP       AL,@SUBRL           ;BRANCH IF NOT @SUBR ATOM
          JNE       RETURN3
          TEST      R0,0FH              ;BRANCH IF RETURN CLEAR
          JZ        RETURN4
RETURN10:
          MOV       EDX,VSPTR           ;TEXTPTR,TEXTLPTR,STMTCNT = GOSUB-GROUP
          MOV       EAX,DWORD PTR [EDX]
          MOV       TEXTLPTR,EAX
          MOV       TEXTPTR,DWORD PTR [EDX+4]
          MOV       EAX,DWORD PTR [EDX+8]
          MOV       STMTCNT,EAX
          ADD       VSPTR,12            ;STATEMENT TO RETURN TO
          CALL      TRACELNB            ;IF TRACE, PRINT 'TRANSFER TO XXXX'
RETURN1:  JMP       ENDSTMTS            ;EXIT, SAVE STACK PTRS

RETURN4:  ADD       VSPTR,12            ;REMOVE GOSUB-GROUP FROM VS
          JMP       ENDSTMTS            ;EXIT, SAVE STACK PTRS

RETURN3:  MOV       AL,R1
          AND       AL,0FH
          CMP       AL,@INTRPTL         ;BRANCH IF INTERRUPT SUBR.
          JE        IRETURN1
          CMP       AL,@SFKEYL          ;BRANCH IF NOT @SFKEY ATOM
          JNE       RETURN6
          TEST      R0,0FH              ;BRANCH IF RETURN CLEAR
          JZ        RETURN4
          CALL      RETURNP             ;STACK CURRENT CONTINUE LINE & STMT COUNT
          JMP       ENTERA              ;RETURN TO KEYBOARD ENTRY

RETURN6:  MOV       AL,R1
          AND       AL,0FH
          CMP       AL,@SFINPTL         ;BRANCH IF NOT @SFINPT ATOM
          JNE       ERROR_41
          TEST      R0,0FH              ;BRANCH IF RETURN CLEAR
          JZ        RETURN4
          MOV       EDX,VSPTR           ;TEXTPTR,TEXTLPTR,STMTCNT = SP.FUNC./INPUT GROUP
          MOV       EAX,DWORD PTR [EDX]
          MOV       TEXTLPTR,EAX
          MOV       TEXTPTR,DWORD PTR [EDX+4]
          MOV       EAX,DWORD PTR [EDX+8]
          MOV       STMTCNT,EAX
          ADD       VSPTR,12            ;(POINTS TO INTERRUPTED INPUT STMT)
          CALL      TRACELNA            ;IF TRACE, PRINT 'TRANSFER TO XXXX'
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       EAX,VSPTR
          MOV       DWORD PTR [EDX].@SAVEVS,EAX  ;SAVE VSPTR
          MOV       EAX,OSPTR
          MOV       DWORD PTR [EDX].@SAVEOS,EAX  ;SAVE OSPTR
          JMP       INPUT               ;REPEAT INTERRUPTED INPUT STMT

ERROR_41: MOV       R0,41H              ;RETURN ENCOUNTERED BUT NO SUBROUTINE CALL
          JMP       ERROR

RETURN5:  CMP       CH,@FOR             ;BRANCH IF NOT @FOR ATOM
          JNE       ERROR_41
          ADD       VSPTR,32            ;REMOVE FOR-GROUP FROM VS
          JMP       RETURN2

IRETURN1: MOV       EDX,DWORD PTR [CPBASE]
          MOV       CH,BYTE PTR [EDX].@ISTATUS
          MOV       AL,CH
          AND       AL,0FDH             ;ENABLE ALL INTERRUPTS (NOT IN INTERRUPT SUBR.
          MOV       BYTE PTR [EDX].@ISTATUS,AL
          TEST      R0,0FH              ;BRANCH IF 'RETURN CLEAR'
          JZ        RETURN4
          MOV       EDX,VSPTR           ;TEXTLPTR,TEXTPTR,STMTCNT = RETURN INFO.
          MOV       EAX,DWORD PTR [EDX]
          MOV       TEXTLPTR,EAX
          MOV       TEXTPTR,DWORD PTR [EDX+4]
          MOV       EAX,DWORD PTR [EDX+8]
          MOV       STMTCNT,EAX
          ADD       VSPTR,12            ;REMOVE RETURN INFO. FROM VS
          CALL      TRACELNB            ;IF TRACE, PRINT 'TRANSFER TO xxxx'
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       EAX,VSPTR
          MOV       DWORD PTR [EDX].@SAVEVS,EAX  ;SAVE VSPTR
          MOV       EAX,OSPTR
          MOV       DWORD PTR [EDX].@SAVEOS,EAX  ;SAVE OSPTR
          JMP       ENDSTMTA

RETURNCA: TEST      SL,02H              ;BRANCH IF NOT EXECUTION PHASE
          JZ        ENDSTMT
          MOV       EDX,DWORD PTR [CPBASE]   ;INITIALIZE VS & OS
          LEA       EAX,[EDX].@OSBEG
          MOV       OSPTR,EAX                ;OSPTR = OSBEG
          MOV       BYTE PTR [EAX],0         ;BEGIN OF OS = 0
          MOV       EBX,VARPTR
          MOV       VSPTR,EBX                ;SET VSPTR = VARPTR
          MOV       DWORD PTR [EDX].@SAVEVS,EBX  ;SAVE VSPTR
          MOV       DWORD PTR [EDX].@SAVEOS,EAX  ;SAVE OSPTR
          JMP       ENDSTMT


;     PRINT: PROCESS A 'PRINT' STATEMENT
;
;          STMT FORMAT:
;               PRINT [T] PRINT-ELEMENT [T PRINT-ELEM...]
;
;               WHERE: PRINT-ELEMENT = EXPRESSION
;                                      ALPHA VARIABLE
;                                      LITERAL STRING
;                                      TAB(EXPRESSION)
;                                      AT(X,Y [,Z])
;                                      HEXOF(ALPHA-VAR.)
;                                      NULL
;
;          MODIFIED REGISTERS: ALL,AUX0-3
;

PRINT:    CALL      PRINTBEG            ;IF EXECUTION PHASE & NOT IMMED. EXECUTION,

;      ENABLE PRINT DEVICE; RESTORE PRINT LINE COUNT

PRINT13:  CALL      NXTCHEOS            ;LOOK FOR END-OF-STATEMTENT CHARACTER
          TEST      R0,0FH              ;NF, BRANCH
          JNZ       PRINT6
          TEST      SL,2
          JZ        PRINTEND
          CALL      PRNTCR              ;IF EXECUTION PHASE, PRINT CR
          JMP       PRINTEND            ;EXIT
PRINT6:   MOV       CH,BYTE PTR [TEXTPTR] ;GET NEXT TEXT CHARACTER
          INC       TEXTPTR
          CMP       CH,','              ;BRANCH IF NOT COMMA
          JNE       PRINT2
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRINT4
;
;     SKIP TO BEGIN OF ZONE
;

PRINT8:   CALL      TWRITESP            ;PRINT SPACE
PRINT5:   TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRINT4
          MOV       EDX,CHARCNT
          TEST      DL,0FH              ;BRANCH IF NOT AT BEGIN OF ZONE
          JNZ       PRINT8
PRINT4:   CALL      NXTCHEOS            ;LOOK FOR END-OF-STATEMENT CHARACTER
          TEST      R0,0FH              ;NF, BRANCH
          JNZ       PRINT6
          JMP       PRINTEND
;
;     PROCESS A PRINT ELEMENT
;

PRINT7:   MOV       EDX,OFFSET _PRNTLST
          CALL      CCJB                ;LOOK FOR PRINT 'KEYWORD'
          JMP       PRNTAT              ;PRINT 'AT('
          JMP       PRNTHEX             ;PRINT HEXOF(
          JMP       PRNTTAB             ;PRINT TAB(
          JMP       PRNTBOX             ;PRINT BOX(
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRINT1
          CMP       BYTE PTR [TEXTPTR],@HEXLIT  ;LOOK FOR 'HEX' LITERAL ATOM
          JNE       PRINT1              ;NF, BRANCH
          INC       TEXTPTR
          JMP       PRNTHX
PRINT1:   MOV       K,4                 ;FLAG = RETURN CURRENT LENGTH OF ALPHA VALUE
          CALL      ALPHA1              ;LOOK FOR ALPHA VARIABLE OR LITERAL
          TEST      R0,0FH              ;BRANCH IF ALPHA NOT FOUND
          JNZ       PRINT11
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRINT9
          MOV       EDX,VSPTR           ;GET LENGTH AND ADDRESS OF ALPHA VALUE
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX      ;LENGTH OF ALPHA VALUE
          MOV       EDX,DWORD PTR [EDX+2] ;ADDRESS OF ALPHA VALUE
          ADD       VSPTR,6
          CALL      PRINTV              ;PRINT VALUE
          JMP       PRINT9

PRINT11:  CALL      EXPR                ;LOOK FOR NUMERIC EXPRESSION
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRINT9
          CALL      VVFMT               ;FORMAT VALUE OF EXPRESSION
          ADD       VSPTR,8             ;REMOVE VALUE FROM VS
          CALL      MVSCRTCH            ;MOVE VALUE TO 'IOBUFFER'
PRINT10:  CALL      PRINTVA             ;PRINT VALUE

;
;     LOOK FOR PUNCTUATION
;

PRINT9:   MOV       EDX,TEXTPTR         ;GET NEXT NONBLANK TEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR
          CMP       CH,','              ;BRANCH IF ,
          JE        PRINT5
          CMP       CH,';'              ;BRANCH IF ;
          JE        PRINT4
          MOV       TEXTPTR,EDX         ;DECREMENT TEXTPTR
          JMP       PRINT12
PRINT2:   CMP       CH,';'
          JE        PRINT4              ;BRANCH IF ;
PRINT3:   MOV       TEXTPTR,EDX         ;DECREMENT TEXTPTR
          CALL      NXTCHEOS            ;LOOK FOR END-OF-STATEMENT CHARACTER
          TEST      R0,0FH              ;NF, BRANCH
          JNZ       PRINT7
PRINT12:  TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRNTEND1
          CALL      CPRNTCRZ            ;PRINT CR IF NOT AT BEGIN OF LINE
PRINTEND: TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRNTEND1
          TEST      MODE,00000002H      ;BRANCH IF IMMEDIATE EXECUTION
          JNZ       PRNTEND1
          MOV       ECX,CHARCNT
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EDX].@PRNTCNT,CL  ;PRINT CHARCNT = CHARCNT
PRNTEND1: JMP       ENDSTIOZ            ;DISABLE PRINT, EXIT


;     PRINTBEG: IF EXECUTION PHASE & NOT IMMEDIATE
;               EXECUTION MODE, ENABLE PRINT DEVICE &
;               RESTORE THE PRINT LINE COUNT.
;
;          ENTRY: ADDRESS OF PRINT DEVICE IN DEVICE TBL
;
;          MODIFIED REGISTERS: PC'S,K,CH,CL
;

PRINTBEG: TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRNTBEG2
          TEST      MODE,00000002H       ;BRANCH IF IMMEDIATE EXECUTION
          JNZ       PRNTBEG1
          MOV       ECX,CHARCNT
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       CL,BYTE PTR [EDX].@PRNTCNT
          MOV       CHARCNT,ECX          ;CHARCNT = PRINT CHARCNT
          LEA       EDX,DWORD PTR [EDX].@DEVPRNT ;POINT TO PRINT DEVICE TABLE ENTRY
PRNTBEG0: JMP       ENBLDEVO             ;ENABLE PRINT DEVICE (PROGRAM EXECUTION)
PRNTBEG1: JMP       ENBLCO               ;ENABLE CO DEVICE (IMMEDIATE EXECUTION)
PRNTBEG2: RET


;     PRNTTAB: PROCESS A PRINT TAB( FUNCTION
;
;          FUNTION FORMAT: TAB(EXPRESSION)
;
;          DESCRIPTION:
;               SPACES TO THE SPECIFIED COLUMN (INTEGER
;               PORTION OF VALUE OF EXPRESSION).  COLUMNS
;               ARE NUMBERED 0 - N.  IF PAST SPECIFIED
;               COLUMN, TAB IS IGNORED.  IF VALUE OF TAB
;               IS > WIDTH OF OUTPUT DEVICE, A CARRIAGE
;               RETURN IS ISSUED.
;
;          ENTRY: TEXTPTR POINTS TO EXPRESSION
;


PRNTTAB:  CALL      EXPR                ;SCAN AND EVALUATE EXPRESSION
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRNTTAB1
          CALL      FLTBIN              ;CONVERT VALUE TO BINARY
          TEST      R2,0EH              ;BRANCH IF VALUE <= 0
          JZ        PRNTTAB1
          MOV       EDX,ACTDEV
          AND       DH,0FH
          CMP       DH,4                ;IGNORE TAB IF DEVICE TYPE 4
          JE        PRNTTAB1
          TEST      CHARCNT,0000FF00H   ;IGNORE TABE IF LINE WIDTH = 0
          JZ        PRNTTAB1
          TEST      R2,4                ;BRANCH IF VALUE > 65535
          JNZ       PRNTTAB4
          CMP       R1,0                ;BRANCH IF 0 < VALUE < 256
          JE        PRNTTAB2
PRNTTAB4: CALL      PRNTCR              ;PRINT CR
PRNTTAB1:                               ;LOOK FOR ')'
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       ERROR_11            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          JMP       PRINT9              ;BRANCH BACK TO PRINT LOGIC
PRNTTAB3: CALL      TWRITESP            ;OUTPUT A SPACE
          TEST      CHARCNT,000000FFH   ;BRANCH IF PAST END OF LINE
          JZ        PRNTTAB1
PRNTTAB2: MOV       EDX,CHARCNT         ;BRANCH IF AT SPECIFIED COLUMN
          CMP       DL,R0               ;BRANCH IF AT SPECIFIED COLUMN
          JAE       PRNTTAB1
          JMP       PRNTTAB3

;     PRNTAT: PROCESS A PRINT 'AT' FUNCTION
;
;          FUNCTION FORMAT: AT(ROW,COLUMN [,[ERASE]])
;
;               WHERE: ROW = EXPRESSION (0<=ROW<256)
;                   COLUMN = EXPR. (0<=COLUMN<LINE WIDTH)
;                   ERASE = EXPR. (0<=ERASE<=65535)
;
;          ENTRY: TEXTPTR POINTS AFTER 'AT('
;
;          RETURN: TEXTPTR POINTS AFTER ')'
;
;          MODIFIED REGISTERS: ALL, AUX0-3
;
;          DESCRIPTION:
;               1. CRT CURSOR HOME (01)
;               2. POSITION TO ROW (LINE FEEDS)
;               3. POSITION TO COLUMN (CURSOR RIGHTS)
;               4A. ERASE CHARACTERS (SPACES, CR/LF AT
;                   APPROPRIATE PLACES)
;                B. REPOSITION TO ROW AND COLUMN (REPEAT
;                   STEPS 1 TO 3)

PRNTAT:   CALL      EXPR                ;SCAN & EVALUATE ROW POSITION
          TEST      SL,2                ;SKIP IF NOT X PHASE
          JZ        PRNTAT1
          CALL      FLTBINA             ;CONVERT TO 1 BYTE BINARY
          MOV       DH,R0
          MOV       AUX03,EDX           ;SAVE IN AUX 3 (HIGH)
PRNTAT1:                                ;LOOK FOR COMMA
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          CALL      EXPR                ;SCAN & EVALUATE COLUMN POSITION
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        PRNTAT2
          CALL      FLTBINA             ;CONVERT COLUMN POSITION TO BINARY
          MOV       EDX,CHARCNT
          CMP       DH,R0
          JAE       PRNTAT99
ERR_34G:  JMP       ERROR_34            ;ERROR IF COLUMN >= LINE WIDTH
PRNTAT99: MOV       EDX,AUX03
          MOV       DL,R0               ;SAVE THE NEW COLUMN POSITION IN AUX 3 (LOW)
          MOV       AUX03,EDX

;%   PROCESS CHARACTER ERASE

PRNTAT2:
          CMP       BYTE PTR [TEXTPTR],','
          JNE       PRNTAT9
          INC       TEXTPTR
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       PRNTAT4
;;;       INC       TEXTPTR

;  THIRD PARAMETER DEFAULTS TO REMAINDER OF SCREEN

;;;       MOV       TEXTPTR,EDX         ;RESTORE TEXTPTR TO JUST BEFORE RIGHT PAREN
          TEST      SL,2                ;DONE IF NOT X PHASE
          JZ        PRNTATA
          CALL      ROWCOL              ;POSITION CURSOR TO INITIAL POSITION
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@LINES
          MOV       CH,BYTE PTR [EDX]
          MOV       EDX,AUX03
          MOV       R0,CH
          SUB       R0,DH               ;F0 = REMAINING LINES (INCL CURRENT ONE)
          MOV       R7,DL               ;(F7 = CURRENT COLUMN)
          MOV       EDX,CHARCNT
          MOV       R1,DH               ;F1 = DEFINED CRT WIDTH (USU. 64 OR 80)
;         CALL      MPY8X8
          MOV       AL,R1
          MUL       R0
          MOV       WORD PTR [R0],AX
          MOV       DX,WORD PTR [R0]
          XOR       AX,AX
          MOV       AL,R7
          SUB       DX,AX               ;PHPL = REMAINDER OF SCREEN SIZE
          JS        PRNTATA             ;IF BEYOND END OF SCREEN, DON'T ERASE
          MOV       AUX02,EDX           ;COUNT OF REMAINDER OF SCREEN
          JMP       PRNTAT5             ;CONTINUE

PRNTAT4:  CALL      EXPR                ;SCAN & EVALUATE ERASE COUNT
          TEST      SL,2                ;DONE IF NOT X PHASE
          JZ        PRNTATA
          CALL      FLTBIN              ;CONVERT TO 2 BYTE BINARY
          MOV       DX,WORD PTR [R0]
          MOV       AUX02,EDX           ;AUX 2 = ERASE COUNT

PRNTAT5:  CALL      ROWCOL              ;POSITION CURSOR (FIRST OF TWO TIMES)
          MOV       EDX,AUX02
          CMP       DX,0
          JNE       PRNTAT8
          JMP       PRNTATA             ;IF ERASE COUNT = 00, EXIT
PRNTAT7:  CALL      TWRITESP            ;WRITE A SPACE CHARACTER

; PRINT AT() ERASE
;     REGISTER USE: F7,6 = ERASE COUNT
;                   F5 = 0 IF DEVICE TYPE 4 OR LINE WIDTH 0
;

PRNTAT8:  MOV       WORD PTR [R6],DX    ;F7F6 = ERASE COUNT
          MOV       R5,0                ;DEFAULT LINE WIDTH = INFINITE
          MOV       EDX,ACTDEV
          AND       DH,0FH
          CMP       DH,4                ;BRANCH IF DEVICE TYPE 4
          JE        PRNTATE5
          JMP       PRNTATE4
PRNTATE1: CMP       R5,0                ;BRANCH IF INFINITE LINE WIDTH
          JE        PRNTATE5
          CALL      PRNTCR              ;OUTPUT CR (END OF LINE)
PRNTATE4: MOV       EDX,CHARCNT
          MOV       R5,DH               ;LINE WIDTH
          CMP       R5,0                ;BRANCH IF INFINITE LINE WIDTH
          JE        PRNTATE5
          MOV       AL,R5
          SUB       AL,DL
          MOV       R0,AL               ;F5 = REMAINING CHARACTERS ON LINE
          JMP       PRNTATE2
PRNTATE5: MOV       R0,0FFH             ;F0 = 255 CHARACTERS TO BE OUTPUT
PRNTATE2: CMP       R7,0
          JNE       PRNTATE3
          MOV       AL,R0
          CMP       AL,R6               ;F0 = MIN( ERASE COUNT, F0)
          JBE       PRNTATE3
          MOV       AL,R6
          MOV       R0,AL
PRNTATE3: XOR       AX,AX               ;SUBTRACT NO. OF CHARACTERS TO OUTPUT
          MOV       AL,R0
          SUB       WORD PTR [R6],AX    ;FROM ERASE COUNT
          CALL      OBSCMPSP            ;OUTPUT F0 SPACES
          CMP       WORD PTR [R6],0     ;BRANCH IF MORE TO ERASE
          JNE       PRNTATE1
PRNTAT9:  TEST      SL,2                ;SKIP IF NOT X PHASE
          JZ        PRNTATA
          CALL      ROWCOL              ;(RE)POSITION CURSOR
PRNTATA:                                ;GET A RIGHT PARENTHESIS
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       ERROR_11            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          JMP       PRINT9


; ROWCOL:  POSITION TO ROW AND COLUMN SPECIFIED BY AUX 3
;
;   AUX 3 HIGH = ROW
;   AUX 3 LOW  = COLUMN
;                   BOTH BINARY, 0-255

ROWCOL:   MOV       K,1
          CALL      OBSTROBE            ;CURSOR HOME
          MOV       EDX,AUX03
          MOV       R0,DH               ;F0 = ROW POSITION
          MOV       R1,0AH              ;F1 = LF
          CALL      OBSCMPRS            ;POSITION TO SPECIFIED ROW
          MOV       EDX,AUX03
          MOV       R0,DL               ;F0 = COLUMN POSITION
          MOV       R1,09H              ;F1 = CURSOR RIGHT
          MOV       EDX,CHARCNT
          MOV       DL,R0
          MOV       CHARCNT,EDX
          JMP       OBSCMPRS            ;POSITION TO APPROPRIATE COLUMN

; PRNTBOX:  PROCESS A PRINT 'BOX' FUNCTION
;
;     FUNCTION FORMAT:  BOX( expression, expression)
;
;     ENTRY:  TEXTPTR POINTS AFTER 'BOX('
;

PRNTBOX:  CALL      EXPR                ;GET HEIGHT OF BOX
          TEST      SL,2
          JZ        PRNTBOX1
          CALL      FLTBINSA            ;CONVERT TO BINARY IF X-PHASE
          MOV       DH,R3               ;SIGN
          MOV       DL,R0               ;VALUE
          MOV       AUX03,EDX
PRNTBOX1: CMP       BYTE PTR [TEXTPTR],',' ;MUST FIND COMMA
          JNE       ERROR_13
          INC       TEXTPTR
          CALL      EXPR                ;GET LENGTH OF BOX
          TEST      SL,2
          JZ        PRNTBOX3
          CALL      FLTBINSA            ;CONVERT TO BINARY IF X-PHASE
          MOV       AL,R0               ;SAVE LENGTH
          MOV       R7,AL
          MOV       EDX,AUX03
          MOV       R6,DL               ;F6 = HEIGHT
          CMP       DH,R3               ;BRANCH IF HEIGHT & WIDTH HAVE SAME SIGN
          JE        PRNTBOX5
          CMP       R6,0                ;USE WIDTH SIGN IF HEIGHT = 0
          JE        PRNTBOX5
          CMP       R0,0                ;ERROR IF HEIGHT & WIDTH HAVE DIFFERENT SIGNS
          JNE       ERR_34G
          MOV       R3,DH               ;USE HEIGHT SIGN IF WIDTH = 0
PRNTBOX5: MOV       K,02H
          CALL      OBSTROBE            ;ESCAPE
          MOV       K,0BH
          CALL      OBSTROBE            ;BOX GRAPHICS
          TEST      R3,10H              ;BRANCH IF ERASE (K=0B ALREADY)
          JNZ       PRNTBOX9
          MOV       K,02H               ;DRAW
PRNTBOX9: CALL      OBSTROBE            ;UPPER PEN POSITION
          MOV       R1,09H
          CALL      OBSCMPRS            ;DROW UPPER HORIZONTAL LINE
          CMP       R6,0                ;BRANCH IF HEIGHT = 0
          JE        PRNTBOX2
          MOV       K,0BH
          CALL      OBSTROBE            ;SWITCH TO LOWER PEN POSITION
          MOV       AL,R6
          DEC       AL
          MOV       R0,AL
          MOV       R1,0AH
          CALL      OBSCMPRS            ;DRAW RIGHT VERTICAL
PRNTBOX2: MOV       AL,R7
          MOV       R0,AL
          MOV       R1,08H
          CALL      OBSCMPRS            ;DRAW LOWER HORIZONTAL LINE
          CMP       R6,0                ;BRANCH IF HEIGHT = 0
          JE        PRNTBOX4
          MOV       K,0BH
          CALL      OBSTROBE            ;SWITCH TO UPPER PEN POSITION
          MOV       AL,R6
          DEC       AL
          MOV       R0,AL
          MOV       R1,0CH
          CALL      OBSCMPRS            ;DRAW LEFT VERTICAL LINE
PRNTBOX4: MOV       K,0FH
          CALL      OBSTROBE            ;END OF SEQUENCE
PRNTBOX3:                               ;MUST FIND ')'
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       ERROR_11            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          JMP       PRINT9

;     PRNTHEX:  PROCESS A PRINT 'HEXOF' FUNCTION.
;
;          FUNCTION FORMAT:  HEXOF( alpha-variable )
;                                   literal
;
;          ENTRY: TEXTPTR POINTS AFTER 'HEXOF('
;
;          DESCRIPTION: THE VALUE OF THE ALPHA VARIABLE
;               INCLUDING TRAILING SPACES IS PRINTED IN
;               HEXADECIMAL NOTATION.  NO CHECK IS MADE
;               TO BE SURE THAT THE VALUE WILL FIT ON THE
;               CURRENT OUTPUT LINE.
;

PRNTHEX:  CALL      ALPHA               ;SCAN AND PROCESS ALPHA VARIABLE OR LITERAL
          TEST      R0,0FH
          JZ        PRNTHEX9
ERR_29C:  JMP       ERROR_29            ;ERROR IF NOT FOUND
PRNTHEX9: CMP       BYTE PTR [TEXTPTR],')' ;LOOK FOR ")"
          JNE       ERROR_11
          INC       TEXTPTR
          TEST      SL,2                ;DONE IF NOT EXECUTION PHASE
          JZ        PRNTHEX1
          MOV       EDX,VSPTR           ;F1,0 = LENGTH OF VALUE; PC'S = ADDRESS OF VALUE
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          CALL      WRTHEX              ;PRINT VALUE IN HEXADECIMAL NOTATION
PRNTHEX1: JMP       PRINT9              ;DONE

;     PRNTHX: PROCESS A 'PRINT HEX(' FUNCTION
;
;          FUNCTION FORMAT:  HEX(hh ...)
;                    where: h = hexdigit
;
;          ENTRY: TEXTPTR POINTS AFTER 'HEX('
;                 PHASE = EXECUTION
;
;          NOTES: HEX() REQUIRES SEPARATE LOGIC FROM
;                 NORMAL LITERAL PROCESSING SINCE:
;                    1. NO CHECK TO SEE IF ENTIRE LITERAL
;                       WILL FIT ON LINE.
;                    2. NO EXTRA CHARACTER PRINTED AFTER
;                       ANY CR's FOUND IN LITERAL.
;

PRNTHX:   MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]   ;GET LENGTH OF LITERAL
          INC       EDX
          MOV       R0,CH               ;F0 = LENGTH
;         MOV       R3,0DH              ;F3 = CR
PRNTHX2:  MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER OF LITERAL
          INC       EDX
          MOV       K,CH
          CMP       CH,0DH              ;BRANCH IF 'CR'
          JE        PRNTHX1
          CALL      TWRITE              ;PRINT CHARACTER
PRNTHX3:  DEC       R0                  ;DECEMENT COUNT
          CMP       R0,0                ;BRANCH IF MORE TO LITERAL
          JNE       PRNTHX2
          MOV       TEXTPTR,EDX          ;POINT AFTER LITERAL
          JMP       PRINT9
;
;     PROCESS 'CR'
;

PRNTHX1:  XCHG      EDX,ACTDEV
          MOV       R2,DH               ;SAVE PRINT DEVICE TYPE
          AND       DH,0F7H
          OR        DH,07H              ;DEVICE TYPE = 7
          XCHG      EDX,ACTDEV          ;(NOTHING AFTER CR)
          CALL      TWRITE              ;PRINT 'CR'
          XCHG      EDX,ACTDEV
          MOV       DH,R2               ;RESTORE PRINT DEVIVE TYPE
          XCHG      EDX,ACTDEV
          JMP       PRNTHX3

;     INPUT: PROCESS AN 'INPUT' STATEMENT
;
;          STMT FORMAT:
;               INPUT ["LITERAL" [,]] VAR [,VAR ...]
;                    WHERE: VAR = ALPHA OR NUMERIC
;                                 VARIABLE
;
;          DESCRIPTION: THE 'LITERAL' FOLLOWED BY '? '
;               IS OUTPUT TO THE CURRENTLY ENABLED DEVICE
;               THEN, VALUES ARE RECEIVED FROM THE INPUT
;               DEVICE AND ASSIGNED TO THE VARIABLES IN
;               THE VARIABLE LIST.
;
;               'INPUT' ROUTINE PROCESSED A RECEIVER AND
;               THEN BRANCHES TO 'ENTER' TO RECEIVE VALUE
;               FROM INPUT DEVICE.  CONTROL IS PASSED
;               BACK TO 'INPUT' VIA 'NXTINPT' ROUTINE.
;
;          ENTRY: OUTPUT DEVICE SELECTED
;                 TEXTPTR POINTS AFTER 'INPUT'
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE.
;
;          REGISTER USE: AUXA,B,F MUST NOT BE USED BY ANY
;               ROUTINES CALLED BY INPUT (INCLUDING 'VAR'
;               'EXPR','AVAR','ENTER')
;
;               AUXF = PTR TO AFTER 'INPUT' VERB. SO THAT
;                      A SPECIAL FUNCTION SUBROUTINE CALL
;                      DURING INPUT OPERATION CAN RETURN
;                      TO BEGIN OF INPUT STMT.
;
;          MODIFIED REG: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUX3,4,7,A,B,F

INPUT:    CALL      INPUTSUB               ;PROCESS CONSOLE INPUT MESSAGE
INPUT6:   CALL      AVARR                  ;LOOK FOR ALPHA RECEIVER VARIABLE
          TEST      R0,0FH                 ;F, BRANCH
          JZ        INPUT99
          CALL      VARR                   ;LOOK FOR NUMERIC RECEIVER VARIABLE
INPUT99:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        INPUT1
          MOV       EDX,OFFSET INPUT1      ;PC'S = RETURN ADDRESS FOR 'GETINPUT'
          JMP       GETINPUT               ;VARIABLE = DATA FROM KBD
INPUT1:
          CMP       BYTE PTR [TEXTPTR],','
          JNE       INPUT1X
          INC       TEXTPTR
          JMP       INPUT6
INPUT1X:
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        INPUT7
          CMP       BYTE PTR [TEXTPTR],')' ;SKIP OVER POSSIBLE RIGHT PAREN. (FROM DEFFN')
          JNE       INPUTA
          INC       TEXTPTR
INPUTA:   MOV       EDX,TEXTENDS
          MOV       TEXTEND,EDX            ;FLUSH INPUT DATA
          AND       MODE,0DFFFH         ;INPUT MODE OFF
INPUT7:   JMP       ENDSTMT                ;EXIT


;     GETINPUT: GET INPUT DATA FROM KBD & SET RECEIVER
;               VARIABLE = INPUT DATA
;
;          CALL:   LPI     return-address
;                  B       GETINPUT
;
;          CALLED BY: INPUT, MATINPUT
;
;          ENTRY: PHASE = EXECUTION
;               RECEIVER VARIABLE ATOM IN OS
;               RECEIVER ADDRESS IN VS
;               RECEIVER LENGTH (IF ALPHA) IN VS
;               AUXF POINTS AFTER 'INPUT'
;               PC'S = RETURN ADDRESS FOR GETINPUT
;
;          RETURN: RECEIVER INFO. REMOVED FROM OS & VS
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUX3,4,7,A,B
;
;     GETINPT2: ENTRY POINT FOR 'KEYFUNC'
;

GETINPUT: MOV       AUX07,EDX           ;SAVE RETURN ADDRESS
          CALL      SWITCH              ;SAVE PTRS TO INPUT STMT
          TEST      MODE,00002000H      ;BRANCH IF INPUT MODE
          JNZ       GETINPT2
          OR        MODE,00002000H      ;MODE = INPUT
          JMP       ENTER_              ;GET INPUT DATA
GETINPT2: CMP       BYTE PTR [TEXTPTR],0DH ;LOOK FOR CR (END OF INPUT DATA)
          JNE       GETINPT3
          INC       TEXTPTR
          JMP       ENTERF              ;GET MORE INPUT DATA
GETINPT3: MOV       EDX,OSPTR
          MOV       CH,BYTE PTR [EDX]   ;GET LAST OS ATOM
          MOV       AL,CH
          AND       AL,0FH
          CMP       AL,@ALPHRCL         ;BRANCH IF RECEIVER ALPHA
          JE        GETINPT4
          MOV       EDX,TEXTPTR
          CALL      SNMBR               ;SCAN AND EVALUATE ASCII NUMBER  (INPUT DATA)
          MOV       TEXTPTR,AUX00
          TEST      R0,0FH              ;BRANCH if not found; Error X75
          JNZ       INPER_75
          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       GETINPTX            ;NF, BRANCH
          INC       TEXTPTR
          JMP       GETINPT5
GETINPTX: CMP       BYTE PTR [TEXTPTR],0DH  ;BRANCH IF CR
          JE        GETINPT5
          ADD       VSPTR,8             ;REMOVE VALUE FROM VS
          JMP       INPER_75            ;Error X75, Illegal number

GETINPT5: CALL      RECEV2              ;RECEIVE VALUE
GETINPT9: CALL      SWITCH              ;POINT TO INPUT STATEMENT
          MOV       EDX,AUX07
          PUSH      EDX                 ;RETURN ADDRESS ==> STACK
PRNTBEGR: RET


;
;     NXTINPT: CHECK INPUT DATA FOR 'CR ONLY'
;

NXTINPT:  AND       SL,0FFH-PHASE       ;PHASE = EXECUTION
          OR        SL,XPHASE
          MOV       EDX,TEXTENDS
          MOV       TEXTPTR,EDX
          ADD       TEXTPTR,5
          MOV       TEXTLPTR,EDX        ;POINT TO INPUT DATA
          INC       TEXTLPTR
          CMP       BYTE PTR [TEXTPTR],0DH  ;LOOK FOR CR (NO DATA)
          JNE       GETINPT3            ;NF, BRANCH
          INC       TEXTPTR
;         CALL      POPRCVR             ;REMOVE RECEIVER VARIABLE INFO. FROM OS & VS
          MOV       EAX,OSPTR
          MOV       CH,BYTE PTR [EAX]
          DEC       OSPTR
          CMP       CH,@NUMREC
          JE        NXTINPT1
          ADD       VSPTR,6             ;REMOVE ALPHA LENGTH AND RECEIVER ADDRESS
          JMP       NXTINPT2
NXTINPT1:
          ADD       VSPTR,4             ;REMOVE NUMERIC RECEIVER ADDRESS
NXTINPT2:
          MOV       EDX,TEXTENDS        ;FLUSH INPUT DATA
          MOV       TEXTEND,EDX
          CALL      SWITCH              ;POINT TO INPUT STATEMENT
          AND       MODE,0000DFFFH      ;INPUT MODE OFF
          JMP       REMCO               ;SLIDE TO END OF STATEMENT

;
;     ALPHA LOGIC
;

GETINPT4: CALL      LTRLQT              ;SCAN  LITERAL IN QUOTES
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1                ;NF, BRANCH - look for literal without quotes
          JE        GETINP10
          CMP       AL,3                ;BRANCH - Missing trailing quote - ERROR
          JE        INPER_73
          MOV       EAX,VSPTR           ;ADDRESS OF LITERAL ==> VS
          SUB       EAX,4
          MOV       DWORD PTR [EAX],EDX
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERR_02

          MOV       AX,WORD PTR [R2]

          MOV       EDX,VSPTR           ;LENGTH OF LITERAL ==> VS
          SUB       EDX,2
          MOV       WORD PTR [EDX],AX
          MOV       VSPTR,EDX
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERR_02

          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       GETINPTY
          INC       TEXTPTR
          JMP       GETINPT8
GETINPTY: CMP       BYTE PTR [TEXTPTR],0DH  ;BRANCH IF CR
          JNE       GETINPTZ
          INC       TEXTPTR
          JMP       GETINPT8
GETINPTZ: MOV       EDX,VSPTR           ;REMOVE ALPHA INFO. FROM VALUE STACK
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6

;  INPUT Errors
;

INPER_73: MOV       R0,73H              ;ILLEGAL INPUT DATA
          JMP       INPUTERR
INPER_75: MOV       R0,75H              ;Illegal number
INPUTERR: MOV       EDX,TEXTENDS        ;Flush INPUT buffer
          MOV       TEXTEND,EDX
          JMP       ERROR

;
;               LITERAL WITHOUT QUOTES
;

GETINP10: MOV       DWORD PTR [A2],EDX  ;F3,2 = COMPLEMENT OF ADDR OF LITRL
          MOV       EAX,VSPTR           ;ADDRESS OF LITERAL --> VS
          SUB       EAX,4
          MOV       DWORD PTR [EAX],EDX
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERR_02

GETINP11: MOV       R0,2CH              ;F0 = COMMA
          CALL      SCANCHA             ;SCAN TEXT LINE FOR A COMMA OR CR
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,2                ;BRANCH IF X'FD' FOUND (IGNORE)
          JE        GETINP11

          MOV       EAX,EDX             ;F1,0 = LENGTH OF LITERAL
          SUB       EAX,DWORD PTR [A2]
          MOV       WORD PTR [R0],AX

          MOV       EDX,VSPTR           ;LENGTH OF LITERAL --> VS
          SUB       EDX,2
          MOV       WORD PTR [EDX],AX
          MOV       VSPTR,EDX
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERR_02

GETINPT8: CALL      ARECEV              ;RECEIVE VALUE
          JMP       GETINPT9


;     INPUTSUB: BEGINNING OF INPUT PROCESSING. PROCESS
;          CONSOLE INPUT MESSAGE; MAKE SURE NOT IMMEDIATE
;          EXECUTION; SAVE TEXTPTR
;
;          ENTRY: TEXTPTR POINTS AFTER VERB (EG, 'INPUT')
;
;          FORMAT (CONSOLE MESSAGE):  [literal [,]]
;
;          RETURN:
;               AUXF POINTS AFTER VERB
;               TEXTPTR POINTS AFTER CONSOLE MESSAGE
;               IN EXECUTION PHASE,
;                    CONSOLE MESSAGE ==> CO DEVICE
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3,AUX0,2
;               IN EXECUTION PHASE, K,AUXF
;

INPUTSUB: TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        INPUTS1
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       CX,WORD PTR [EDX].@DEVINPT  ;READ ADDRESS OF DEV INPUT
          CMP       CH,01H
          JNE       ERROR_48            ;ERROR IF NOT ADDRESS 01
          MOV       EDX,TEXTPTR
          MOV       AUX0F,EDX           ;SAVE PTR TO BEGIN OF INPUT STMT (AFTER 'INPUT' VERB)
          CALL      ENBLCO              ;ENABLE CONSOLE OUTPUT
INPUTS1:  TEST      MODE,00000002H      ;ERROR IF IMMEDIATE EXECUTION
          JNZ       ERROR_07
          CALL      CNSLMSG             ;PROCESS INPUT MESSAGE
          TEST      R0,0FH              ;BRANCH IF NO MESSAGE
          JNZ       PRNTBEGR
          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       INPUTS2
          INC       TEXTPTR
          MOV       R0,0                    ;FOUND
          RET
INPUTS2:  MOV       R0,1                    ;NOT FOUND
          RET


;     ILLSTMT: PROCESS ILLEGAL STATEMENT (NOT SUPPORTED
;              ON 2600)
;
;          STMT IGNORED IN ENTRY PHASE.
;          ERROR IN R,X PHASE
;

ILLSTMT:  TEST      SL,3             ;BRANCH IF ENTRY PHASE
          JZ        REM
          JMP       ERROR_08


;     RETURNP: POP CONTINUE LINE AND STMT COUNT FOR
;              FOR CI SF'KEY RETURNS
;

RETURNP:
          MOV       EDX,VSPTR
                                              ;POP DUMMY INFO. (FOR ALIGNMENT ONLY)
                                              ;4 BYTE ???
          MOV       ECX,DWORD PTR [EDX+4]     ;GET CONTLN_ IN VS
          MOV       CONTLN_,ECX
          MOV       ECX,DWORD PTR [EDX+8]     ;GET STMTCNT IN VS
          MOV       STMTCNT,ECX
          ADD       VSPTR,12
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       EAX,VSPTR
          MOV       DWORD PTR [EDX].@SAVEVS,EAX
          MOV       EAX,OSPTR
          MOV       DWORD PTR [EDX].@SAVEOS,EAX
          RET


;     VVFMT: FORMAT A NUMERIC VALUE (INTERNAL FORM) FOR
;            PRINTING (IE, PRODUCE A STRING OF ASCII
;            CHARACTERS REPRESENTING THE NUMBER).  A
;            SPACE IS ADDED AFTER THE VALUE.
;
;          FIXED POINT FORMAT:  SIII---I.FFF---F
;               WHERE: .1 <= ABS(VALUE) < 10E14
;                       S = '-' IF VALUE <0 OR ' ' IF >=0
;                       I = INTERGER DIGIT
;                       F = FRACTION DIGIT
;               IF NO FRACTION DIGITS, DECIMAL POINT IS
;               NOT INCLUDED. LEADING INTEGER DIGITS ARE
;               NOT INCLUDED.
;
;          FLOATING POINT FORMAT:  SM.MMMMMMMMETXX
;               WHERE: .1 > ABS(VALUE) >=10E14
;                       S = '-' IF VALUE <0 OR ' ' IF >=0
;                       T = '-' IF VALUE <0 OR '+' IF >=0
;                       M = MANTISSA DIGIT
;                       X = EXPONENT DIGIT
;               TRAILING ZEROES ARE INCLUDED. NUMBER IS
;               NORMALIZED SO THAT LEADING DIGIT IS NOT 0
;
;          ENTRY: VALUE IS LAST VALUE IN VALUE STACK (VS)
;
;          RETURN: ASCII NUMBER IS IN SCRATCH AREA
;                  F0 = NO. OF CHARACTERS IN FORMATTED
;                       NUMBER
;
;          NOTE: ASSUMES THAT SCRATCH AREA ORIGIN = XX00
;
;          REGISTER USE: F0 = 0 IF FIXED POINT FORMAT
;                             1 IF FLOATING POINT FORMAT
;                        F1 = POSITION OF DECIMAL POINT
;                             (NO. OF INTEGER DIGITS)
;                        F2 = '.' (CONSTANT)
;                        F3,HIGH 4-BITS = 3 (CONSTANT)
;                           LOW 4-BITS = READ COUNT
;
;          SCRATCH AREA USED: 1ST 30 BYTES
;
;          MODIFIED REGISTERS: F0-3,CH,CL,PC'S,AUX0,2
;
;     VVFMTA: SAME AS VVFMT EXCEPT FOR ENTRY
;
;          ENTRY: PC'S = ADDRESS OF VALUE
;

vvfmtb:   push      textptr
          push      esi
          mov       sflag,1
          jmp       vvfmts
vvfmt:    mov       edx,vsptr
vvfmta:   push      textptr
          push      esi
          mov       sflag,0
vvfmts:   mov       edi,offset scratch
          mov       ax,word ptr [edx]
          mov       word ptr [a8],ax
          mov       ebp,dword ptr [edx+2]
          mov       bx,word ptr [edx+6]
          or        bx,bx
          jnz       vvfmt1
          or        ebp,ebp
          jz        vvfmt0
vvfmt1:   mov       al,20h
          or        bx,bx
          jns       vvfmt2
          mov       al,'-'
          not       bx
          neg       ebp
          jnz       vvfmt2
          inc       bx
vvfmt2:   stosb
          mov       esi,offset _abcov
          xor       dx,dx
vvfmt5:   lodsd
          mov       ecx,eax
          lodsw
          mov       r2,2fh
vvfmt3:   inc       r2
          sub       ebp,ecx
          sbb       bx,ax
          jnb       vvfmt3
          add       ebp,ecx
          adc       bx,ax
          cmp       r2,30h
          je        vvfmt4
          add       word ptr [a8],15
          cmp       word ptr [a8],0
          jge       vvfmt6
          mov       cx,15
          sub       cx,dx
          sub       cx,word ptr [a8]
          cmp       cx,14
          jl        fix_fmt
          jmp       float_fmt
vvfmt6:   cmp       word ptr [a8],14
          jl        fix_fmt
          jmp       float_fmt

vvfmt4:   dec       word ptr [a8]
          inc       dx
          jmp       vvfmt5

fix_fmt:  mov       temp,0
          mov       r8,13
          cmp       word ptr [a8],0
          jge       fix1
          mov       temp,edi
          mov       al,'.'
          stosb
          mov       cx,word ptr [a8]
          neg       cx
          and       ecx,0000ffffh
          sub       r8,cl
          mov       al,30h
          rep       stosb
fix1:     xor       cx,cx
fix4:     cmp       cx,word ptr [a8]
          jne       fix2
          mov       temp,edi
          mov       al,'.'
          stosb

fix2:     mov       al,r2
          stosb
          inc       cx
          lodsd
          or        eax,eax
          jz        fix5
          mov       edx,eax
          lodsw
          mov       r2,2fh
fix3:     inc       r2
          sub       ebp,edx
          sbb       bx,ax
          jnb       fix3
          add       ebp,edx
          adc       bx,ax

          cmp       cl,r8
          jne       fix4

fix5:     cmp       cx,word ptr [a8]
          jge       fixend
          sub       cx,word ptr [a8]
          neg       cx
          and       ecx,0000ffffh
          mov       al,30h
          rep       stosb

fixend:   cmp       temp,0
          je        fix_1
          dec       edi
fix_3:    cmp       edi,temp
          je        fix_1
          cmp       byte ptr [edi],30h
          jne       fix_2
          dec       edi
          jmp       fix_3
fix_2:    inc       edi
fix_1:    mov       al,20h
          stosb
          sub       edi,offset scratch
          mov       eax,edi
          mov       r0,al
          pop       esi
          pop       textptr
          ret

float_fmt:dec       word ptr [a8]
          mov       al,r2
          stosb
          mov       al,'.'
          stosb
          mov       cx,8
          test      sflag,1
          jz        float2
          mov       cx,12

float2:   lodsd
          or        eax,eax
          jz        float3
          mov       edx,eax
          lodsw
          mov       r2,2fh
float1:   inc       r2
          sub       ebp,edx
          sbb       bx,ax
          jnb       float1
          add       ebp,edx
          adc       bx,ax
          mov       al,r2
          stosb
          dec       cx
          jnz       float2
float3:   cmp       cx,0
          je        float4
          and       ecx,0000ffffh
          mov       al,30h
          rep       stosb
float4:   mov       al,'E'
          stosb
          mov       al,'+'
          mov       bx,word ptr [a8]
          or        bx,bx
          jns       float5
          mov       al,'-'
          neg       bx
float5:   stosb
          cmp       bx,10
          jge       float6
          mov       al,30h
          stosb
          mov       al,bl
          or        al,30h
          stosb
          jmp       floatend

float6:   xor       edx,edx
          mov       ax,bx
          mov       bx,10
          div       bx
          or        al,30h
          stosb
          mov       al,dl
          or        al,30h
          stosb

floatend:
          mov       al,20h
          stosb
          sub       edi,offset scratch
          mov       eax,edi
          mov       r0,al
          pop       esi
          pop       textptr
          ret

vvfmt0:   mov       byte ptr [edi],20h
          mov       byte ptr [edi+1],30h
          mov       byte ptr [edi+2],20h
          mov       r0,3
          pop       esi
          pop       textptr
          ret

work_buffer db      20 dup(20h)
temp        dd      0
sflag       db      0

CODE      ENDS
          END
