          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    ADJEXP
PUBLIC    CONVERT
PUBLIC    CPIMAGE
PUBLIC    ERR_29D
PUBLIC    ERR_75B
PUBLIC    ERROR_42
PUBLIC    ERROR_71
PUBLIC    ERROR_76
PUBLIC    IMAGE
PUBLIC    IMAGE_
PUBLIC    PACK
PUBLIC    PRNTUSNG
PUBLIC    UNPACK

EXTRN     _ABCOV  :NEAR
EXTRN     ALPHA   :NEAR
EXTRN     ALPHA1  :NEAR
EXTRN     ARECEV  :NEAR
EXTRN     ARRAYN  :NEAR
EXTRN     AVAR    :NEAR
EXTRN     AVARB   :NEAR
EXTRN     AVARD   :NEAR
EXTRN     AVARR   :NEAR
EXTRN     BREAKPTQ:NEAR
EXTRN     BREAKPTT:NEAR
EXTRN     CCL     :NEAR
EXTRN     CCLFROM :NEAR
EXTRN     CCLTO   :NEAR
EXTRN     CPRNTCR :NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTC:NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_10:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_52:NEAR
EXTRN     ERROR_75:NEAR
EXTRN     EXPR    :NEAR
EXTRN     NEWTOOLD:NEAR
EXTRN     NXTCHEOS:NEAR
EXTRN     PRINTBEG:NEAR
EXTRN     PRINTEND:NEAR
EXTRN     RECEV   :NEAR
EXTRN     SCRATCH :NEAR
EXTRN     SNMBR   :NEAR
EXTRN     TRLINE_ :NEAR
EXTRN     TWRITESP:NEAR
EXTRN     VARR    :NEAR
EXTRN     WORK_BUFFER:NEAR
EXTRN     WRTBLKB :NEAR

EXTRN     @@VSEND :DWORD
EXTRN     CPBASE  :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;     **********************************                                       ;
;     *                                *                                       ;
;     *     MODULE-15:  STATEMENTS     *                                       ;
;     *                                *                                       ;
;     **********************************                                       ;
;                                                                              ;
;     DESCRIPTION:                                                             ;
;          CONVERT     PRINTUSING     PACK     UNPACK                          ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     CONVERT: SCAN & PROCESS A CONVERT STATEMENT
;
;          FORMAT 1: (ALPHA TO NUMERIC)
;
;               CONVERT alpha-var TO numeric-variable
;
;          FORMAT 2: (NUMERIC TO ALPHA)
;
;               CONVERT num-var TO alpha-var,(format)
;
;         format = [+][$][#[,]...][.][#...][^^^^][+ ]
;                  [-]                           [- ]
;                                                [++]
;                                                [--]
;
;               or = alpha-variable containing format
;
;               where: no. of #'s > 0
;                      spaces in image ignored
;                      leading & trailing signs may not
;                         both occur
;
;          ENTRY: TEXTPTR POINTS AFTER 'CONVERT'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUX3,4,5
;
;          MODIFIED RAM: I/O BUFFER
;                        SCRATCH -- SCRATCH+14
;

CONVERT:  CALL      AVARD               ;SCAN & PROCESS ALPHA VARIABLE
          TEST      R0,0FH
          JNZ       CONVERT1            ;BRANCH IF NF

;     ALPHA (ASCII) TO NUMERIC (FL.PT.) CONVERSION
;

          TEST      SL,2
          JZ        CONVERT2            ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF ALPHA VALUE
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       AUX03,EDX           ;SAVE ADDRESS OF ALPHA VALUE
          MOV       AUX04,EAX           ;SAVE LENGTH OF ALPHA VALUE

CONVERT2: CALL      CCLTO               ;LOOK FOR 'TO'
          CALL      VARR                ;SCAN & PROCESS NUMERIC VARIABLE
          TEST      SL,2
          JZ        CONVERT3            ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,AUX04
          MOV       WORD PTR [R6],DX    ;F7,F6 = LENGTH OF VALUE
          MOV       EDX,AUX03           ;PC'S = ADDRESS OF ALPHA VALUE
          CALL      SNMBR               ;CONVERT ASCII NO. TO FL. PT.
          TEST      R0,0FH
          JNZ       ERROR_75            ;ERROR IF NOT FOUND
          CMP       WORD PTR [R6],0
          JNE       ERROR_75            ;BRANCH IF ILLEGAL CHARACTER IN STRING
          CALL      RECEV               ;NO. ==> NUMERIC VARIABLE

CONVERT3: JMP       ENDSTMTZ            ;EXIT

;     NUMERIC (FL.PT.) TO ALPHA (ASCII) CONVERSION
;

CONVERT1: CALL      EXPR                ;SCAN & EVALUATE EXPRESSION
          TEST      SL,2
          JZ        CONVERTX            ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR
          MOV       AUX03,EDX           ;SAVE PTR TO FL.PT. VALUE IN VS

CONVERTX: CALL      CCLTO               ;LOOK FOR 'TO'
          CALL      AVARR               ;SCAN & PROCESS ALPHA VARIABLE
          TEST      R0,0FH
          JNZ       ERROR_29                ;ERROR IF NOT FOUND
          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       ERROR_13
          INC       TEXTPTR

          MOV       DL,0
          MOV       AUX04,EDX           ;FLAG = CONVERT IMAGE
          CALL      CPIMAGE             ;SCAN & PROCESS IMAGE
          TEST      SL,2
          JZ        CONVERT3            ;BRANCH IF NOT EXECUTION PHASE
          CALL      CVTALPHA            ;CONVERT FL.PT. NO. TO ASCII
          TEST      R7,1
          JNZ       ERROR_71            ;BRANCH IF NUMBER UNDERFORMATTED (# FILLED)
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          INC       EDX
          TEST      R7,80H
          JZ        CONVERTY            ;BRANCH IF NO LEADING SIGN
          TEST      R7,40H
          JNZ       CONVERTY
          DEC       EDX

CONVERTY: MOV       EAX,VSPTR           ;ADDRESS OF ASCII VALUE ==> VS
          SUB       EAX,4
          MOV       DWORD PTR [EAX],EDX
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERROR_02

          MOV       EAX,AUX02
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          SUB       EAX,EDX
          MOV       WORD PTR [R0],AX
          TEST      R7,80H
          JZ        CONVERTZ
          TEST      R7,40H
          JZ        CONVERTQ            ;BRANCH IF LEADING SIGN

CONVERTZ: DEC       WORD PTR [R0]       ;DECREMENT LENGTH
CONVERTQ: MOV       AX,WORD PTR [R0]    ;LENGTH OF VALUE ==> VS
          MOV       EDX,VSPTR
          SUB       EDX,2
          MOV       WORD PTR [EDX],AX
          MOV       VSPTR,EDX
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERROR_02

          CALL      ARECEV              ;VALUE ==> ALPHA VARIABLE
          ADD       VSPTR,8             ;REMOVE VALUE FROM VS
          JMP       ENDSTMTZ

ERROR_71: MOV       R0,71H              ;NUMBER EXCEEDS IMAGE
          JMP       ERROR


;     IMAGE: PROCESS AN IMAGE STATEMENT
;
;          ENTRY: TEXTPTR POINTS AFTER '%"
;
;          FORMAT:   % character-string 'CR'
;


IMAGE:    TEST      SL,2
          JNZ       ENDSTMTC          ;BRANCH, IF EXECUTION

IMAGEX:   MOV       CH,BYTE PTR [TEXTPTR] ;CH = NEXT TEXT CHARACTER
          INC       TEXTPTR
          CMP       CH,0DH            ;BRANCH IF CHARACTER NOT CR
          JNE       IMAGEX

          DEC       TEXTPTR           ;POINT TO CR
          JMP       ENDSTMT


;     PRNTUSNG: PROCESS A PRINT-USING STATEMENT
;
;          FORMAT:
;
;              line-no.    expression
;  PRINTUSING [TO a,]alpha-var [,alpha-variable]...  [;]
;                     literal    ;literal
;
;          IMAGE FORMAT FOR VARIABLE:
;
;                [+][$][#[,]...][.][#...][^^^^][+ ]
;                 -                             -
;                                               ++
;                                               --
;
;              WHERE: NO. OF #'S > 0
;                     SPACES NOT ALLOWED
;
;          ENTRY: TEXTPTR POINTS AFTER 'PRINTUSING'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,3,6
;               IN EXECUTION PHASE, AUXD-F,4,5
;

PRNTUSNG: XOR       EDX,EDX
          MOV       AUX06,EDX           ;FLAG = NOT 'PRINTUSING TO'
          MOV       R0,@TO
          CALL      CCL                 ;LOOK FOR 'TO'
          TEST      R0,0FH
          JNZ       PRINTU5             ;NF, BRANCH
          CALL      AVARD               ;LOOK FOR ALPHA-VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29D             ;NF, ERROR
          TEST      SL,2
          JZ        PRINTU7             ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF 'TO-VARIABLE'
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       AUX04,EDX           ;SAVE ADDRESS OF VARIABLE
          XOR       EAX,EAX
          MOV       AX,WORD PTR [EDX]   ;F3,2 = COUNT (1ST 2 BYTES OF VARIABLE)
          XCHG      AH,AL
          MOV       WORD PTR [R2],AX
          ADD       EDX,2
          ADD       EDX,EAX
          MOV       AUX05,EDX           ;AUX5 = CURRENT LOCATION (BEGIN+COUNT+2)
          MOV       EDX,AUX04
          XOR       EAX,EAX
          MOV       AX,WORD PTR [R0]
          ADD       EDX,EAX
          MOV       AUX06,EDX              ;AUX6 = ADDRESS OF END OF TO-VARIABLE +1
PRINTU7:  CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       ERROR_13
          INC       TEXTPTR
          JMP       PRINTUX

PRINTU5:  CALL      PRINTBEG            ;IF EXECUTION PHASE & NOT IMMED. EXEC.,

;      ENABLE PRINT DEVICE

;     PROCESS IMAGE SPECIFICATION (ALPHA)
;

PRINTUX:  MOV       K,4                 ;RETURN CURRENT LENGTH OF ALPHA VARIABLE
          CALL      ALPHA1              ;SCAN & PROCESS ALPHA VARIABLE OR LITERAL
          TEST      R0,0FH
          JNZ       PRINTU1             ;BRANCH IF NOT FOUND
          TEST      SL,2
          JZ        PRINTU3             ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF ALPHA VALUE
          XOR       EAX,EAX
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       AUX0F,EDX           ;AUXF = ADDRESS OF BEGIN OF IMAGE
          ADD       EDX,EAX             ;PC'S = ADDRESS +1 OF END OF IMAGE
          JMP       PRINTU2

;     PROCESS IMAGE SPECIFICATION (LINE-NUMBER)
;

PRINTU1:  CALL      TRLINE_             ;PROCESS IMAGE LINE NUMBER
          TEST      SL,3
          JZ        PRINTU3             ;BRANCH IF ENTRY PHASE
          MOV       AUX00,EDX
          ADD       AUX00,6
          MOV       EDX,AUX00
PRINTUY:  MOV       CH,BYTE PTR [EDX]   ;GET STMT VERB
          INC       EDX
          CMP       CH,20H              ;BRANCH IF CHARACTER = SPACE
          JE        PRINTUY
          CMP       CH,@?PE             ;ERROR IF NOT IMAGE STATEMENT
          JNE       ERROR_42
          TEST      SL,2
          JZ        PRINTU3             ;BRANCH IF NOT EXECUTION PHASE
          MOV       AUX0F,EDX           ;AUXF POINT TO BEGIN OF IMAGE
          MOV       EDX,0FFFFFFFFH      ;IMAGE TERMINATES BY CR

PRINTU2:  MOV       AUX0E,EDX           ;AUXE = 'LENGTH' OF IMAGE (OR FFFF IF ENDS BY CR

;     PROCESS LEADING LITERAL IN IMAGE
;
          CALL      PULTRLB              ;PROCESS LEADING LITERAL IN IMAGE

;     PROCESS PUNCTUATION AFTER IMAGE SPECIFICATION
;

PRINTU3:  CALL      PUPUNCT              ;SCAN & PROCESS PUNCTUATION BEFORE NEXT ARG.
          TEST      SL,2
          JZ        PRINTU32             ;BRANCH IF NOT EXECUTION PHASE
          CMP       R4,0
          JNE       ERROR_42             ;ERROR IF NO '#' IN IMAGE

;     PROCESS ALPHA VALUE
;

PRINTU32: CALL      ALPHA               ;SCAN & PROCESS ALPHA VARIABLE OR LITERAL
          TEST      R0,0FH
          JNZ       PRINTU4             ;NF, BRANCH
          TEST      SL,2
          JZ        PRINTU31            ;BRANCH IF NOT EXECUTION PHASE
          CALL      PUFORMAT            ;SCAN VALUE FORMAT IN IMAGE
          MOV       EDX,AUX02           ;PC'S = LENGTH OF IMAGE
          MOV       EAX,DWORD PTR [CPBASE]
          LEA       EAX,[EAX].@IOBUFFR
          SUB       EDX,EAX
          TEST      R7,80H
          JZ        PRINTUZ             ;BRANCH IF NO SIGN IN IMAGE
          TEST      R7,40H
          JZ        PRINTUQ             ;BRANCH IF LEADING SIGN IN IMAGE
PRINTUZ:  DEC       EDX
PRINTUQ:  MOV       R4,DL               ;F5,F4 = LENGTH OF VALUE FORMAT
          MOV       R5,0
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF ALPHA VALUE
          XOR       EAX,EAX
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       DWORD PTR [A2],EDX
          ADD       DWORD PTR [A2],EAX  ;F3,2 POINT TO END OF VALUE +1
          CMP       AX,WORD PTR [R4]
          JBE       PRINTUW             ;BRANCH IF LENGTH OF VALUE <= LENGTH FORMA
          MOV       AX,WORD PTR [R4]
          MOV       DWORD PTR [A2],EDX
          ADD       DWORD PTR [A2],EAX  ;F3,2 = TRUNCATED END OF VALUE
PRINTUW:  MOV       AX,WORD PTR [R0]    ;F5,4 = LENGTH OF FORMAT - LENGTH OF VALU
          SUB       WORD PTR [R4],AX
          JNS       PRINTUS
          MOV       WORD PTR [R4],0     ;F5,4 = 0 IF RESULT WAS < 0
PRINTUS:  CALL      PUBLOCK             ;OUTPUT VALUE
          MOV       EDX,AUX06
          CMP       EDX,0
          JNE       PUSPACE             ;BRANCH IF PRINTUSING TO
          JMP       PRINTU6
PRINTUD:  CALL      TWRITESP            ;OUTPUT SPACE (PAD WITH TRAILING SPACES)
          DEC       R4                  ;DECREMENT COUNT
PRINTU6:  CMP       R4,0
          JNE       PRINTUD             ;BRANCH IF COUNT > 0
          JMP       PRINTU30

;     PROCESS NUMERIC VALUE
;

PRINTU4:  CALL      EXPR                ;SCAN & EVALUATE EXPRESSION
          TEST      SL,2
          JZ        PRINTU31            ;BRANCH IF NOT EXECUTION PHASE
          CALL      PUFORMAT            ;SCAN VALUE FORMAT IN IMAGE
          MOV       EDX,VSPTR
          MOV       AUX03,EDX           ;AUX3 = ADDRESS OF FL.PT. VALUE
          ADD       EDX,8               ;REMOVE VALUE FROM VS
          XCHG      EDX,VSPTR
          CALL      CVTALPHA            ;FORMAT NUMBER
          TEST      R7,1
          JNZ       PRINTU8             ;BRANCH IF NUMBER UNDERFORMATTED (# FILLED)

;
;     FLOAT LEADING SIGN & '$' IF ANY AND REMOVE
;          LEADING ZEROES
;

          CMP       R4,0
          JE        PRINTU8             ;BRANCH IF NO INTEGER DIGITS
          MOV       EDX,DWORD PTR [CPBASE]      ;POINT AT IOBUFFER
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CH,BYTE PTR [EDX]
          MOV       R0,CH               ;SAVE LEADING SIGN

PRINTU9:  MOV       BYTE PTR [EDX],20H  ;REPLACE CHARACTER WITH SPACE
          INC       EDX
          MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER OF FORMAT VALUE
          CMP       CH,30H
          JB        PRINTU9             ;BRANCH IF NOT DIGIT
          JNE       PRINTU10            ;BRANCH IF DIGIT <> 0
          DEC       R4                  ;DECREMENT INTEGER COUNT
          CMP       R4,0
          JNE       PRINTU9             ;BRANCH IF MORE INTEGER DIGITS

PRINTU10: DEC       EDX
          TEST      R7,08H
          JZ        PRINTUV             ;BRANCH IF NO '$'
          MOV       BYTE PTR [EDX],'$'  ;'$' ==> BUFFER
          DEC       EDX
PRINTUV:  MOV       AL,R0               ;SIGN ==> BUFFER
          MOV       BYTE PTR [EDX],AL

PRINTU8:  MOV       EDX,AUX02
          MOV       DWORD PTR [A2],EDX  ;F3,2 = ADDRESS OF END OF FORMATTED VALUE +1
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          INC       EDX                 ;POINT AT IOBUFFER+1
          TEST      R7,80H
          JZ        PRINTUU             ;BRANCH IF NO SIGN IN FORMAT
          TEST      R7,40H
          JNZ       PRINTUU             ;BRANCH IF TRAILING SIGN
          DEC       EDX
PRINTUU:  CALL      PUBLOCK             ;OUTPUT FORMATTED VALUE

;     POST VARIABLE PROCESSING
;

PRINTU30: CALL      PULTRL              ;OUTPUT LITERAL AFTER FORMAT
PRINTU31: CALL      PUPUNCT             ;SCAN & PROCESS PUNCTUATATION BEFORE ARG.
          TEST      SL,2
          JZ        PRINTU32            ;BRANCH IF NOT EXECUTION PHASE
          CMP       R4,0
          JE        PRINTU32            ;BRANCH IF '#' FOUND
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1
          JE        PRINTUK             ;BRANCH IF SEMICOLON FOUND
          CALL      PUCCR               ;PRINT CR IF NOT AT BEGIN OF LINE (, FOUND)
PRINTUK:  CALL      PULTRLB             ;OUTPUT LEADING LITRL IN IMAGE (REUSE IMAGE
          JMP       PRINTU32
ERR_29D:  JMP       ERROR_29            ;MISSING ALPHA VARIABLE

;     PUPUNCT: SCAN & PROCESS PRINTUSING PUNCTUATION
;
;          FORMAT:  ,
;                   ; [CR]
;                   CR
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 IF COMMA FOUND
;                  F0 = 1 IF SEMICOLON (NOT FOLLOWED BY
;                            CR) FOUND
;                  TEXTPTR POINTS AFTER , OR ;
;
;          EXIT: IF NEITHER COMMA NOR SEMICOLON FOUND,
;                    A CR IS OUTPUT IF EXECUTION PHASE &
;                    NOT AT BEGIN OF LINE.
;                    THEN, 'B PRINTEND'
;                IF SEMICOLON FOLLOWED BY CR IS FOUND,
;                    'B PRINTEND'
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0
;

PUPUNCT:  CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       PUPUNCTX
          MOV       R0,0
          INC       TEXTPTR
          JMP       PUPUNCT1                ;BRANCH IF FOUND
PUPUNCTX: CMP       BYTE PTR [TEXTPTR],';'  ;LOOK FOR ;
          JNE       PUPUNCT2                ;NF, BRANCH
          INC       TEXTPTR
          CALL      NXTCHEOS            ;LOOK FOR END-OF-STATEMENT CHARACTER
          TEST      R0,0FH
          JZ        PUPUNCT3            ;FOUND, BRANCH
PUPUNCT1: RET

PUPUNCT2: TEST      SL,2
          JZ        PUPUNCT3            ;BRANCH IF NOT EXECUTION PHASE
          CALL      PUCCR               ;OUTPUT CR IF NOT ALREADY AT BEGIN OF LINE
PUPUNCT3: MOV       EDX,AUX06
          POP       EAX
          CMP       EDX,0
          JNE       PUEND               ;BRANCH IF 'PRINTUSING TO'
          JMP       PRINTEND            ;EXIT FROM PRINTUSING

;     PUEND: UPDATE COUNT AT BEGIN OF 'TO-VARIABLE'
;

PUEND:    TEST      SL,2
          JZ        PUEND1             ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,AUX05
          MOV       EAX,EDX
          MOV       EDX,AUX04
          INC       EDX
          SUB       EAX,EDX             ;F1,0 = COUNT
          DEC       EAX
          MOV       WORD PTR [R0],AX
          DEC       EDX
          XCHG      AH,AL
          MOV       WORD PTR [EDX],AX   ;COUNT ==> BEGIN OF 'TO-VARIABLE'
PUEND1:
          JMP       ENDSTMTZ

;     PULTRL: PROCESS NEXT LITERAL IN IMAGE. SCAN IMAGE
;             FROM CURRENT LOCATION TO 1ST # OR END OF
;             IMAGE (CR OR END-ADDRESS). THEN, BACK SCAN
;             PAST ANY + OR -,$, AND . THAT IS PART OF
;             THE FORMAT.  OUTPUT LITERAL.
;
;          ENTRY: PHASE = EXECUTION
;               AUXD = CURRENT PTR TO IMAGE
;               AUXE = END ADDRESS +1 OF IMAGE (OR FFFF
;                      IF IMAGE ENDS WITH CR)
;
;          RETURN:
;               AUXD POINT PAST LITERAL IN IMAGE
;               LITERAL OUTPUT (TWRITE LOGIC)
;               F4 = 0 IF '#' FOUND
;                  <> 0 IF '#" NOT FOUND
;               F3,2 POINTS AFTER LITERAL
;
;          MODIFIED REGISTERS: PC'S,CH,CL,K,F1-4,AUXD
;
;     PULTRLB: SAME AS 'PULTRL' EXCEPT AUXD INITIALIZED
;              TO BEGIN OF LITERAL
;
;          ENTRY: AUXF = ADDRESS OF BEGIN OF LITERAL
;                 AUXE = ADDRESS OF END OF IMAGE +1
;

PULTRLB:  MOV       EDX,AUX0F
          MOV       AUX0D,EDX           ;AUXD POINTS TO BEGIN OF IMAGE
PULTRL:   MOV       EDX,AUX0E
          MOV       DWORD PTR [A2],EDX  ;F3,2 = ADDRESS OF END OF IMAGE +1
          MOV       EDX,AUX0D           ;PC'S = ADDRESS OF IMAGE
          MOV       R4,'#'              ;FLAG = '#' NOT FOUND

;     SCAN FOR '#'
;

PULTRL1:  CMP       DWORD PTR [A2],EDX
          JBE       PULTRL2              ;BRANCH IF END OF LITERAL (ADDR
          MOV       CH,BYTE PTR [EDX]
          MOV       R1,0DH               ;GET NEXT CHARACTER OF LITERAL; F1 = CR
          CMP       CH,R1
          JE        PULTRL2              ;BRANCH IF END OF LITERAL (CR)
          INC       EDX
          CMP       CH,R4
          JNE       PULTRL1              ;BRANCH IF NOT '#'

;     BACKSCAN OVER FORMAT PREFIX (+$.)
;
          MOV       R4,0                 ;FLAG = '#' FOUND
          SUB       EDX,2
          MOV       CH,BYTE PTR [EDX]
          CMP       CH,'.'               ;GET PREVIOUS CHARACTER
          JNE       PULTRLX              ;BRANCH IF NOT '.'
          DEC       EDX
PULTRLX:  MOV       CH,BYTE PTR [EDX]    ;GET PREVIOUS CHARACTER
          CMP       CH,'$'
          JNE       PULTRLY              ;BRANCH IF NOT '$'
          DEC       EDX
PULTRLY:  MOV       CH,BYTE PTR [EDX]    ;GET PREVIOUS CHARACTER
          CMP       CH,'+'
          JE        PULTRL2              ;BRANCH IF '+'
          CMP       CH,'-'
          JE        PULTRL2              ;BRANCH IF '-'
          INC       EDX

PULTRL2:  MOV       DWORD PTR [A2],EDX   ;F3,2 = PC'S
          XCHG      EDX,AUX0D            ;AUXD POINT AFTER LITERAL
          CMP       DWORD PTR [A2],EDX
          JB        PULTRL3              ;BRANCH IF BACKSCANNED TOO FAR
          JMP       PUBLOCK              ;OUTPUT LITERAL

PULTRL3:  MOV       DWORD PTR [A2],EDX   ;F3,2 = START OF LITERAL
          MOV       AUX0D,EDX            ;RESTORE AUXD
          RET

;     PUFORMAT: SCAN & PROCESS VALUE FORMAT IN IMAGE
;
;          ENTRY: PHASE = EXECUTION
;               AUXD = ADDRESS OF FORMAT IN IMAGE
;               AUXE = ADDRESS OF END OF IMAGE+1
;
;          RETURN (SEE 'IMAGE#'):
;               ALSO, AUXD = ADDRESS OF END OF FORMAT+1
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F2-7,AUX0,1,2,D
;

PUFORMAT: MOV       EDX,AUX0E
          MOV       DWORD PTR [A4],EDX  ;F5,4 = MAX. ADDRESS OF END OF FORMAT +1
          MOV       EDX,AUX0D
          SUB       DWORD PTR [A4],EDX  ;F5,4 = MAXIMUM LENGTH OF FORMAT
          MOV       EAX,DWORD PTR [A4]
          MOV       WORD PTR [R4],AX
          CMP       WORD PTR [R4],254
          JBE       PUFORMATX
          MOV       WORD PTR [R4],0FEH  ;IF LENGTH > 254, LENGTH = 254
PUFORMATX:CALL      IMAGE_PU            ;SCAN & PROCESS FORMAT IN  IMAGE
          MOV       AUX0D,EDX           ;AUXD POINT TO END OF FORMAT +1
          RET

;     PUBLOCK: OUTPUT A BLOCK OF CHARACTERS TO PRINT
;              DEVICE OR 'TO-VARIABLE'
;
;          ENTRY: PHASE = EXECUTION
;               PC'S = ADDRESS OF BLOCK OF CHARACTERS
;               F3,2 = ADDRESS OF END OF BLOCK +1
;               AUX6 = 0000 IF NOT PRINTUSING 'TO'
;
;               IF PRINTUSING TO A VARIABLE,
;                    AUX5 = NEXT AVAILABLE LOCATION IN
;                           TO-VARIABLE
;                    AUX6 = ADDRESS OF END OF 'TO-VAR' +1
;
;          RETURN:
;               PC'S = ADDRESS OF LAST CHAR. IN BLOCK +1
;               CH = LAST CHARACTER IN BLOCK
;               AUX5 UPDATED IF 'PRINTUSING TO'
;
;          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-1
;

PUBLOCK:  XCHG      EDX,AUX06
          CMP       DX,0
          JNE       PUBLK1              ;BRANCH IF 'PRINTUSING TO'
          XCHG      EDX,AUX06
          JMP       WRTBLKB             ;OUTPUT VALUE TO PRINT DEVICE

PUBLK1:   MOV       DWORD PTR [A0],EDX  ;F1,0 = ADDR OF END OF TO-VARIABLE +1
          XCHG      EDX,AUX06
          JMP       PUBLK2

PUBLK3:   XCHG      EDX,AUX05
PUBLK2:   CMP       DWORD PTR [A2],EDX  ;BRANCH IF END OF BLOCK
          JBE       PUBLK4              ;BRANCH IF END OF BLOCK
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX05           ;GET NEXT CHARACTER OF BLOCK
          INC       AUX05
          CMP       DWORD PTR [A0],EDX
          JBE       PUBLK3              ;BRANCH IF 'TO-VARIABLE' FULL
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX05           ;CHARACTER ==> 'TO-VARIABLE'
          INC       AUX05
          JMP       PUBLK2
PUBLK4:   RET

;     PUSPACE: PUT N SPACES INTO 'TO-VARIABLE'
;
;          ENTRY: PHASE = EXECUTION
;               F4 = NO. OF SPACES
;               AUX5 = NEXT AVAILABLE LOCATION IN 'TO-VAR
;               AUX6 = ADDR OF END OF TO-VAR +1
;
;          RETURN:
;               AUX5 UPDATED
;               F2 = SPACE
;
;          EXIT: B    PRINTU30
;
;          MODIFIED REGISTERS: PC'S,F0-2,4,AUX5
;

PUSPACE:  MOV       DWORD PTR [A0],EDX  ;F1,0 = END ADDRESS +1 OF 'TO-VARIABLE'
          MOV       EDX,AUX05
          MOV       R2,20H
          JMP       PUSPACE3

PUSPACE2: CMP       DWORD PTR [A0],EDX
          JBE       PUSPACE1            ;BRANCH IF 'TO-VARIABLE' FULL
          MOV       AL,R2               ;SPACE ==> 'TO-VARIABLE'
          MOV       BYTE PTR [EDX],AL
          INC       EDX
          DEC       R4                  ;DECREMENT SPACE COUNT
PUSPACE3: CMP       R4,0
          JNE       PUSPACE2            ;BRANCH IF MORE SPACES
PUSPACE1: MOV       AUX05,EDX           ;SAVE CURRENT 'TO-VARIABLE' ADDRESS
          JMP       PRINTU30

;     PUCCR: OUTPUT CR TO PRINT DEVICE IF NOT AT BEGIN
;            OF LINE; OR IF 'PRINTUSING TO' PUT CR IN
;            'TO-VARIABLE'
;
;
;          MODIFIED REGISTERS: PC'S,K,F0-1,AUX5
;

PUCCR:    MOV       EDX,AUX06
          CMP       DX,0
          JNE       PUCCR1              ;BRANCH IF 'PRINTUSING TO'
          JMP       CPRNTCR             ;OUTPUT CR IF NOT ALREADY AT BEGIN OF LINE

PUCCR1:   MOV       DWORD PTR [A0],EDX  ;F1,0 = ADDRESS OF END OF 'TO-VAR' +1
          MOV       EDX,AUX05
          CMP       DWORD PTR [A0],EDX
          JBE       PUCCR2              ;BRANCH IF 'TO-VAR' FULL
          MOV       BYTE PTR [EDX],0DH  ;CR ==> 'TO-VARIABLE'
          MOV       AUX05,EDX
          INC       AUX05
PUCCR2:   RET

;     IMAGE#: SCAN A NUMERIC IMAGE & CREATE DEFAULT VALUE
;
;          FORMAT:
;
;               [+][$][#[,]...][.][#...][^^^^][+ ]
;               [-]   [,      ]               [- ]
;                                             [++]
;                                             [--]
;
;               WHERE: NO. OF #'S > 0
;                      LEADING & TRAILING SIGNS MAY NOT
;                         BOTH OCCUR
;
;          ENTRY: PC'S = ADDRESS OF IMAGE
;                 F4 = MAXIMUM NO. OF CHARACTERS IN IMAGE
;                 F3,BIT01 = 0 IF SPACE IGNORED
;                            1 IF SPACE ENDS IMAGE
;                   ,BIT02 = 0 IF '$' & TRAILING SIGNS
;                                 LEGAL IN IMAGE
;                            1 IF '$' & TRAILING SIGNS
;                                 END IMAGE
;                   ,BIT04 = 0 IF COMMAS LEGAL IN IMAGE
;                            1 IF COMMAS END IMAGE
;
;          RETURN (EXECUTION PHASE EXCEPT AS NOTED):
;               F6 = NO. OF INTEGER #'S (ALL PHASES)
;               F5 = NO. OF FRACTION #'S (ALL PHASES)
;               ILLEGAL IMAGE IF F6,5 = 0
;               F7,BIT80 = 1 IF SIGN FOUND (ALL PHASES)
;                 ,BIT40 = 0 IF LEADING SIGN (ALL PHASES)
;                          1 IF TRAILING SIGN
;                 ,BITS30= 00 IF SIGN = '+'
;                          01 IF SIGN = '-'
;                          10 IF SIGN = '++'
;                          11 IF SIGN = '--'
;                 ,BIT08 = 1 IF '$' FOUND
;                 ,BIT04 = 1 IF '.' FOUND
;                 ,BIT02 = 1 IF '^^^^' FOUND
;               PC'S POINT TO END OF IMAGE +1 (ALL PHASES
;               AUX1 POINTS TO BEGIN OF IMAGE (ALL PHASES
;               AUX2 POINTS TO TRAILING HEX(00) IN BUFFER
;
;          I/O BUFFER CONTAINS NUMBER ZERO FORMATTED
;          ACCORDING TO IMAGE AS FOLLOWS:
;
;               [+][$][0[,]...][.][0...][E+00][DB]
;               [ ]                           [  ]
;                                             [+]
;             IE, THE IMAGE CHARACTERS ARE REPLACED BY:
;               +:     '+' ==> BUFFER
;               -:     ' ' ==> BUFFER
;               $:     '$' ==> BUFFER
;               #:     '0' ==> BUFFER
;               ,:     ',' ==> BUFFER
;               .:     '.' ==> BUFFER
;               ^^^^:  'E+00' ==> BUFFER
;               ++:    '  ' ==> BUFFER
;               --:    '  ' ==> BUFFER
;
;             ALSO, HEX(00) PUT IN BUFFER AFTER VALUE
;                   FOR TERMINATOR
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,2-7,AUX0,1,2
;
;     IMAGEPU: ENTRY FOR 'PRINTUSING'
;              (SPACES TERMINATE IMAGE,
;               COMMAS & '$' LEGAL)
;
;          ENTRY: PC'S = ADDRESS OF IMAGE
;                 F4 = MAXIMUM NO. OF CHARACTERS IN IMAGE
;
;     IMAGEC: ENTRY FOR 'CONVERT'
;             (IGNORE SPACES,
;              COMMAS & '$' LEGAL)
;
;          ENTRY: PC'S = ADDRESS OF IMAGE
;
;     IMAGEP: ENTRY FOR 'PACK'
;             (IGNORE SPACES,
;              COMMAS & '$' TERMINATE IMAGE)
;
;          ENTRY: PC'S = ADDRESS OF IMAGE
;

IMAGE_P:  MOV       R3,6           ;IGNORE SPACES; ',' & '$' & TRAILING SIGN END
          JMP       IMAGE_C1       ;IMAGE

IMAGE_C:  MOV       R3,0           ;IGNORE SPACES; ',' & '$' & TRAILING SIGN LEGL
IMAGE_C1: MOV       R4,0FEH        ;MAXIMUM NO. OF CHARACTERS IN IMAGE = 254
          JMP       IMAGE_

IMAGE_PU: MOV       R3,1           ;SPACES END IMAGE; ',' & '$' & TRAILING SIGNS

;      LEGAL
;

IMAGE_:   MOV       AUX01,EDX      ;SAVE PTR TO BEGIN OF IMAGE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       AUX02,EDX      ;AUX2 = ADDRESS OF BUFFER
          MOV       EDX,AUX01      ;PC'S POINT TO IMAGE
          MOV       R0,30H         ;F0 = '0'
          MOV       WORD PTR [R5],0 ;INTEGER & FRACTION # COUNTS = 0
          MOV       R7,0           ;FOUND FLAG = 0 (NOTHING FOUND YET)
          CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGE_1        ;BRANCH IF NOT '2X'

;     LOOK FOR LEADING + OR -
;
          CMP       CH,2BH
          JNE       IMAGE_2        ;BRANCH IF NOT '+'
          OR        R7,80H         ;LEADING '+' FOUND
          TEST      SL,2
          JZ        IMAGE_3        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX02      ;'+' ==> BUFFER
          INC       AUX02
          JMP       IMAGE_3

IMAGE_2:  TEST      SL,2
          JZ        IMAGE_X
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],20H  ;SPACE ==> BUFFER
          XCHG      EDX,AUX02
          INC       AUX02
IMAGE_X:  CMP       CH,2DH
          JNE       IMAGE_4        ;BRANCH IF NOT '-'
          OR        R7,90H         ;LEADING '-' FOUND

;     LOOK FOR '$'
;

IMAGE_3:  CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGE_1        ;BRANCH IF NOT '2X'
IMAGE_4:  CMP       CH,24H
          JNE       IMAGE_5        ;BRANCH IF NOT '$'
          OR        R7,08H         ;'$' FOUND
IMAGE_17: TEST      SL,2
          JZ        IMAGE_6        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX02      ;'$' ==> BUFFER
          INC       AUX02

;     LOOK FOR INTEGER #'S
;

IMAGE_6:  CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGE_7        ;BRANCH IF NOT '2X'
IMAGE_5:  CMP       CH,23H
          JNE       IMAGE_8        ;BRANCH IF NOT '#'
          TEST      SL,2
          JZ        IMAGE_Y        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       AL,R0
          MOV       BYTE PTR [EDX],AL
          XCHG      EDX,AUX02      ;'0' ==> BUFFER
          INC       AUX02
IMAGE_Y:  INC       R6             ;INCREMENT INTEGER # COUNT
          JMP       IMAGE_6

;     LOOK FOR ','
;

IMAGE_8:  CMP       CH,2CH
          JNE       IMAGE_16       ;BRANCH IF NOT ','
          TEST      R3,4
          JNZ       IMAGE_1        ;BRANCH IF COMMA NOT LEGAL IN IMAGE
          JMP       IMAGE_17       ;COMMA ==> BUFFER; LOOK FOR MORE INTEGER #'S

;     LOOK FOR '.'
;

IMAGE_16: CMP       CH,2EH
          JNE       IMAGE_9        ;BRANCH IF NOT '.'
          TEST      SL,2
          JZ        IMAGE_10       ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX02      ;'.' ==> BUFFER
          INC       AUX02
          OR        R7,04H         ;'.' FOUND

;     LOOK FOR FRACTION #'S
;

IMAGE_10: CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGE_7        ;BRANCH IF NOT '2X'
IMAGE_9:  CMP       CH,23H
          JNE       IMAGE_21       ;BRANCH IF NOT '#'
          TEST      SL,2
          JZ        IMAGE_Z        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],30H
          XCHG      EDX,AUX02      ;'0' ==> BUFFER
          INC       AUX02
IMAGE_Z:  INC       R5             ;INCREMENT FRACTION COUNT
          JMP       IMAGE_10

;     LOOK FOR EXPONENT (^^^^)
;

IMAGE_7:  MOV       AUX00,EDX      ;SAVE CURRENT PTR TO IMAGE
          DEC       AUX00
          MOV       R2,0           ;^ COUNT = 0
IMAGE_13: CMP       CH,5EH
          JNE       IMAGE_14       ;BRANCH IF NOT '^'
          INC       R2             ;INCREMENT ^ COUNT
          MOV       AL,R2
          AND       AL,0FH
          CMP       AL,4
          JE        IMAGE_25       ;BRANCH IF 4 ^'s FOUND
          CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          JMP       IMAGE_13

IMAGE_25: TEST      SL,2
          JZ        IMAGE_24       ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],'E'
          INC       EDX
          MOV       BYTE PTR [EDX],'+'   ;'E+00' ==> BUFFER
          INC       EDX
          MOV       BYTE PTR [EDX],30H
          INC       EDX
          MOV       BYTE PTR [EDX],30H
          XCHG      EDX,AUX02
          INC       AUX02
          OR        R7,2           ;'^^^^' FOUND

IMAGE_24: CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE

;     PROCESS TRAILING SIGN (+,-,++,--)
;

IMAGE_21: MOV       AUX00,EDX      ;SAVE PTR TO CURRENT CHARACTER OF IMAGE
          DEC       AUX00
          TEST      R3,2
          JNZ       IMAGE_14       ;BRANCH IF TRAILING SIGN ILLEGAL
          TEST      R7,80H
          JNZ       IMAGE_14       ;BRANCH IF LEADING SIGN ALREADY FOUND
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGE_14       ;BRANCH IF NOT '2X'
          CMP       CH,2BH
          JNE       IMAGE_15       ;BRANCH IF NOT '+'
          OR        R7,0C0H        ;TRAILING '+' FOUND
          TEST      SL,2
          JZ        IMAGE_W
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],'+'
          XCHG      EDX,AUX02      ;'+' ==> BUFFER
          INC       AUX02
IMAGE_W:  MOV       AUX00,EDX      ;SAVE CURRENT PTR TO IMAGE
          CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          CMP       CH,2BH
          JNE       IMAGE_14       ;BRANCH IF NOT '+'
          OR        R7,0E0H        ;TRAILING '++' FOUND
          TEST      SL,2
          JZ        IMAGE_1        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],20H   ;' ' ==> BUFFER
          DEC       EDX
          MOV       BYTE PTR [EDX],20H
IMAGE_18: XCHG      EDX,AUX02
          ADD       AUX02,2
          JMP       IMAGE_1

IMAGE_15: CMP       CH,2DH
          JNE       IMAGE_14       ;BRANCH IF NOT '-'
          OR        R7,0D0H        ;TRAILING '-' FOUND
          TEST      SL,2
          JZ        IMAGE_U
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],20H  ;SPACE ==> BUFFER
          XCHG      EDX,AUX02
          INC       AUX02
IMAGE_U:  MOV       AUX00,EDX      ;SAVE CURRENT PTR TO IMGE
          CALL      IMAGECH        ;GET NEXT CHARACTER OF IMAGE
          CMP       CH,2DH
          JNE       IMAGE_14       ;BRANCH IF NOT '-'
          OR        R7,0F0H        ;TRAILING '--' FOUND
          TEST      SL,2
          JZ        IMAGE_1        ;BRANCH IF NOT EXECUTION PHASE
          XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],20H  ;C'  ' ==> BUFFER
          DEC       EDX
          JMP       IMAGE_18       ;DECREMENT PC'S & BRANCH
IMAGE_14: MOV       EDX,AUX00      ;RESTORE PTR TO IMAGE
IMAGE_1:  TEST      SL,2
          JZ        IMAGE_22       ;BRANCH IF NOT EXECUTION PHASE
IMAGE_23: XCHG      EDX,AUX02
          MOV       BYTE PTR [EDX],0 ;HEX(00) ==> BUFFER
          XCHG      EDX,AUX02
IMAGE_22: RET

;     IMAGECH: GET NEXT CHARACTER OF IMAGE
;
;          ENTRY: PC'S POINT TO NEXT CHARACTER OF IMAGE
;               F4 = MAX. LENGTH OF REMAINING PORTION OF
;                    IMAGE
;               F3,BIT01 = 0 IF SPACES ARE IGNORED
;                          1 IF SPACES END IMAGE
;
;          RETURN: CH = NEXT CHARACTER OF IMAGE
;                  PC'S POINT AFTER FOUND CHARACTER
;                  F4 DECREMENTED
;
;          EXIT ('B IMAGE#23' FORCED IF:)
;               1. NO MORE CHARACTERS IN IMAGE (F4=0)
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F4
;

IMAGECH:  CMP       R4,0
          JE        IMAGECH1            ;BRANCH IF END OF IMAGE
          DEC       R4                  ;DECREMENT MAX. LENGTH COUNT
          MOV       CH,BYTE PTR [EDX]
          INC       EDX                 ;GET NEXT CHARACTER
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JNE       IMAGECH2            ;BRANCH IF CHARACTER <> '2X'
          CMP       CH,20H
          JNE       IMAGECH2            ;BRANCH IF CHARACTER <> SPACE
          TEST      R3,1
          JZ        IMAGECH             ;BRANCH IF IGNORE SPACES
IMAGECH2: RET

IMAGECH1: MOV       AUX00,EDX           ;SAVE PC'S
          POP       EDX                 ;REMOVE 'IMAGECH' RETURN ADDRESS
          MOV       EDX,AUX00           ;RESTORE PC'S
          JMP       IMAGE_23

;     CVTALPHA: CONVERT A FL.PT. NO. TO AN ASCII VALUE
;               ACCORDING TO A PRESCRIBED IMAGE
;
;          ENTRY: PHASE = EXEUCTION
;               'IMAGE#' CALLED:
;                    F6 = NO. OF INTEGER #'S
;                    F5 = NO. OF DECIMAL #'S
;                    F7 = FOUND FLAG (SIGN,EXP,ETC)
;                    AUX2 POINTS TO HEX(00) AFTER VALUE
;                         IN BUFFER
;                    DEFAULT ASCII VALUE IN (I/O) BUFFER
;               AUX3 = ADDRESS OF FL.PT. VALUE
;
;          RETURN (SEE 'IMAGE#' FOR DETAILS):
;               BUFFER CONTAINS FORMATTED ASCII VALUE
;                    (IF NO. EXCEEDS IMAGE, #'S INSERTED
;                     FOR DIGITS)
;               F4 = NO. OF INTEGER DIGITS
;               F7,BITSFE=IMAGE# FOUND FLAG (NOT MODIFIED
;                 ,BITS01 = 1 IFF NUMBER UNDERFORMATTED
;                                 (IE, # FILLED)
;
;       MODIFIED REGISTERS: PC'S,CH,CL,F0-2,F4-6,AUX0,1,3
;

CVTALPHA: MOV       EDX,DWORD PTR [CPBASE]  ;POINT TO I/O BUFFER
          LEA       EDX,[EDX].@IOBUFFR
          XCHG      EDX,AUX03

          PUSH      EDX
          PUSH      EBP
          MOV       AX,WORD PTR [EDX]       ;EXPONENT
          MOV       WORD PTR [R0],AX
          MOV       BX,WORD PTR [EDX+2]     ;LOW  WORD
          MOV       CX,WORD PTR [EDX+4]     ;MED  WORD
          MOV       BP,WORD PTR [EDX+6]     ;HIGH WORD

          MOV       R3,0                    ;SET MANTISSA SIGN TO PLUS
          OR        BP,BP                   ;CHECK SIGN OF MANTISSA
          JNS       VVXX                    ;BRANCH WHEN PLUS
          MOV       R3,1                    ;MANTISSA SIGN FLAG MINUS
          NOT       BP                      ;COMPLEMENT MANTISSA
          NOT       CX
          NEG       BX
          JNZ       VVXX
          INC       CX
          JNZ       VVXX
          INC       BP
VVXX:     MOV       ESI,OFFSET _ABCOV       ;
          MOV       EDI,OFFSET WORK_BUFFER  ;
          MOV       AUX00,EDI
;         CLD
VVXA:     LODSW
          OR        AX,AX
          JZ        VVEND
          MOV       DI,AX
          LODSW
          MOV       DX,AX
          LODSW
          MOV       R2,2FH                  ;INIT DIGIT
VVXZ:     INC       R2
          SUB       BX,DI                   ;GET DIGIT
          SBB       CX,DX
          SBB       BP,AX
          JNB       VVXZ
          ADD       BX,DI
          ADC       CX,DX
          ADC       BP,AX
          MOV       AL,R2
          MOV       EDX,AUX00
          MOV       BYTE PTR [EDX],AL
          INC       AUX00
          JMP       VVXA


VVEND:    POP       EBP

          MOV       ESI,OFFSET WORK_BUFFER
          XOR       EDX,EDX
;         CLD
VV2:      LODSB
          CMP       AL,30H
          JNE       VV1
          INC       EDX
          JMP       VV2
VV1:      MOV       AX,15
          SUB       AX,DX
          DEC       AX
          ADD       WORD PTR [R0],AX

          MOV       EDI,OFFSET WORK_BUFFER
          MOV       ESI,EDI
          ADD       ESI,EDX
          MOV       ECX,15
          SUB       ECX,EDX
          MOV       EBX,ECX
          REP       MOVSB
          MOV       ECX,EDX
          MOV       AL,30H
          REP       STOSB

          POP       EDX

          MOV       AL,R6               ;GET SIGN,EXP,1ST DIGIT OF NO.; F4 = NO. INTGR DIGT
          MOV       R4,AL

          MOV       AX,WORD PTR [R0]
          MOV       WORD PTR [EDX],AX

          MOV       AX,WORD PTR [EDX+2]
          MOV       BX,WORD PTR [EDX+4]
          MOV       CX,WORD PTR [EDX+6]
          OR        CX,CX
          JS        CVTALPHX            ;BR, IF NO. < 0
          JNZ       CVTALP49            ;BR, IF NO. > 0
          OR        AX,BX
          JNZ       CVTALP49            ;BR, IF NO. > 0
          JMP       CVTALPH1            ;BR, IF NO. = 0

;     EDIT '-' SIGN INTO BUFFER
;

CVTALPHX: TEST      R7,80H
          JZ        CVTALP49            ;BRANCH IF NO SIGN IN IMAGE
          TEST      R7,40H
          JNZ       CVTALP29            ;BRANCH IF TRAILING SIGN
          XCHG      EDX,AUX03           ;POINT TO I/O BUFFER, RESTORE AUX3

CVTALPH4: MOV       BYTE PTR [EDX],'-'  ;'-' ==> BUFFER
          MOV       EDX,AUX03
          JMP       CVTALPH5

CVTALPH9: MOV       BYTE PTR [EDX],'B'
          DEC       EDX                 ;'DB' ==> BUFFER
          MOV       BYTE PTR [EDX],'D'
          MOV       EDX,AUX03
          JMP       CVTALPH5

CVTALP29: MOV       AUX03,EDX           ;RESTORE AUX3
CVTALPH3: MOV       EDX,AUX02
          DEC       EDX
          TEST      R7,20H
          JZ        CVTALPH4            ;BRANCH IF '-' OR '+'
          MOV       AL,R7
          AND       AL,30H
          CMP       AL,30H
          JE        CVTALPH9            ;BRANCH IF '--'
          MOV       BYTE PTR [EDX],'R'  ;IF IMAGE SIGN = '++', 'CR' ==> BUFFER
          DEC       EDX
          MOV       BYTE PTR [EDX],'C'
          MOV       EDX,AUX03
          JMP       CVTALPH5

;     FIXED POINT IMAGE
;

CVTALP49: MOV       AUX03,EDX           ;RESTORE AUX3
CVTALPH5: TEST      R7,2
          JNZ       CVTALPH2            ;BRANCH IF FL.PT. IMAGE

          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          OR        AX,AX
          JS        CVTALPH7                 ;BRANCH IF EXPONENT < 0
          MOV       EDX,DWORD PTR [CPBASE]   ;POINT TO 'IOBUFFER'
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CH,BYTE PTR [EDX]
          INC       EDX

CVTALPH6: CMP       R6,0
          JE        CVTFILL_            ;BRANCH IF NO. OF INTEGER #'S = 0
          DEC       R6                  ;DECREMENT INTEGER # COUNT
          XOR       AX,AX
          MOV       AL,R6
          CMP       AX,WORD PTR [R0]
          JE        CVTMVNO             ;BRANCH IF EXPONENT = INTEGER # COUNT
VVXD:     MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER FROM BUFFER
          INC       EDX
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,30H
          JE        CVTALPH6            ;BRANCH IF CHARACTER = 3X (DIGIT)
          JMP       VVXD

CVTALPH7: NEG       WORD PTR [R0]
          MOV       EDX,DWORD PTR [CPBASE]  ;POINT TO 'IOBUFFER'
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          TEST      R7,4
          JZ        CVTALPH1            ;BRANCH IF NO '.' IN IMAGE
          XOR       AX,AX
          MOV       AL,R5
          CMP       AX,WORD PTR [R0]
          JB        CVTALPH1            ;BRANCH IF EXPONENT <= NO. OF DECIMAL #'S
          MOV       R2,'.'

CVTALPH8: MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER FROM BUFFER
          INC       EDX
          CMP       CH,R2
          JNE       CVTALPH8            ;SCAN PAST '.' (OR DIGIT)
          MOV       R2,'0'              ;F1 = '0'
          DEC       WORD PTR [R0]       ;DECREMENT EXPONENT COUNT
          CMP       WORD PTR [R0],0
          JNE       CVTALPH8            ;BRANCH IF EXPONENT COUNT > 0
          JMP       CVTMVNO             ;MANTISSA DIGITS ==> BUFFER

;     FL. PT. IMAGE
;

CVTALPH2: MOV       EDX,AUX03           ;POINT TO FL.PT. NO.
          CALL      ADJEXP              ;ADJUST EXPONENT OF FL.PT. NO. TO CONFORM TO IMAGE
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,2
          JE        CVTFILL_            ;BRANCH IF EXPONENT OVERFLOW ( > +99)
          CMP       AL,1
          JE        CVTALPH1            ;BRANCH IF EXPONENT UNDERFLOW ( < -99)
          MOV       CX,WORD PTR [EDX]   ;GET ADJUSTED EXPONENT
          MOV       WORD PTR [R5],CX    ;SAVE EXPONENT
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CH,BYTE PTR [EDX]
          INC       EDX                 ;POINT AT IOBUFFER +1
          CALL      CVTMVNO             ;MANTISSA ==> BUFFER

VVXE:     MOV       CH,BYTE PTR [EDX]
          INC       EDX
          CMP       CH,45H
          JNE       VVXE                ;skip over 'E' in buffer
          MOV       AX,WORD PTR [R5]
          OR        AX,AX
          JNS       VVXF
          JZ        VVXF                ;BRANCH IF EXPONENT = 0
VVXG:     MOV       BYTE PTR [EDX],'-'  ;EXPONENT SIGN = '-' IF EXP < 0
          NEG       WORD PTR [R5]
VVXF:     INC       EDX
          MOV       EDI,EDX

          XOR       EAX,EAX
          XOR       EDX,EDX
          MOV       AX,WORD PTR [R5]
          MOV       EBX,10
          DIV       EBX
          ADD       AL,30H              ;HIGH EXPONENT DIGIT ==> BUFFER
          STOSB
          ADD       DL,30H
          MOV       AL,DL
          STOSB                         ;LOW EXPONENT DIGIT ==> BUFFER
          MOV       EDX,EDI
CVTALPH1: RET

;     CVTMVNO: MANTISSA DIGITS ==> VALUE BEING FORMATTED
;              IN BUFFER
;
;          ENTRY: PC'S POINT TO CURRENT POSITION IN BUFFR
;               AUX3 = ADDRESS OF FL.PT. NO.
;               VALUE IN BUFFER ENDS WITH HEX(00)
;
;          RETURN: CHARACTERS = 3X (BEFORE 'E') STARTING
;                       AT PC'S ARE REPLACED WITH
;                       MANTISSA DIGITS OF FL.PT. NO.
;                  AUX3 = AUX3 + 8
;                  IF 'E' FOUND, PC'S POINT AT 'E'
;                  F0,BITSF0 = 3
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,AUX0,1
;
CVTMVNO:  MOV       AUX01,EDX           ;SAVE PTR TO FORMATTED VALUE (BUFFER)
;         CLD
          MOV       ECX,15
          MOV       EDI,OFFSET SCRATCH
          MOV       AUX03,EDI
          MOV       ESI,OFFSET WORK_BUFFER
          REP       MOVSB               ;MOV FL.PT. NO TO SCRATCH AREA

          MOV       BYTE PTR [EDI],0
          MOV       EDX,AUX01           ;HEX(00) AFTER ASCII MANTISSA; POINT TO BUFFER
          JMP       CVTMVNO3

CVTMVNO2: MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,40H
          JE        CVTMVNO4            ;BRANCH IF 'E'
          CMP       AL,30H
          JNE       CVTMVNO5            ;BRANCH IF NOT 'DIGIT'

          XCHG      EDX,AUX03
          MOV       CH,BYTE PTR [EDX]   ;GET NEXT MANTISSA DIGIT (ASCII)
          XCHG      EDX,AUX03
          INC       AUX03
          CMP       CH,0
          JE        CVTMVNO4            ;BRANCH IF NO MORE MANTISSA DIGITS
          MOV       BYTE PTR [EDX],CH   ;REPLACE '0' WITH MANTISSA DIGIT
CVTMVNO5: INC       EDX                 ;POINT TO NEXT CHARACTER IN BUFFER
CVTMVNO3: MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER FROM BUFFER
          CMP       CH,0
          JNE       CVTMVNO2            ;BRANCH IF NOT END-OF-VALUE IN BUFFER
CVTMVNO4: RET

;     CVTFILL#: REPLACE DIGITS OF FORMATTED VALUE IN
;               BUFFER WITH #'S (UNDERFORMATTED)
;
;          ENTRY: FORMATTED VALUE IN BUFFER
;                 VALUE ENDS WITH 'SPACE'
;
;          RETURN: ALL CHARACTERS OF VALUE = 3X ARE
;                  REPLACED BY '#'S
;                  F7,BIT01 = 1 (NO. UNDERFORMATTED)
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0
;

CVTFILL_: MOV       EDX,DWORD PTR [CPBASE]   ;POINT AT LEADING SIGN
          LEA       EDX,[EDX].@IOBUFFR
          JMP       CVTFIL_2            ;INCREMENT AND READ

CVTFIL_1: MOV       AL,CH               ;BRANCH IF CHARACTER <> DIGIT
          AND       AL,0F0H
          CMP       AL,30H
          JNE       CVTFIL_2            ;BRANCH IF CHARACTER <> DIGIT
          MOV       BYTE PTR [EDX],'#'  ;REPLACE DIGIT BY #

CVTFIL_2: INC       EDX
          MOV       CH,BYTE PTR [EDX]
          OR        R7,1                ;GET NEXT CHARACTER FROM BUFFER;

;      FLAG = NO. UNDERFORMATTED
;
          CMP       CH,0
          JNE       CVTFIL_1            ;BRNCH IF NOT END-OF-VALUE
          RET

;     ADJEXP: ADJUST EXPONENT OF A FL.PT. NO.
;             (EXPONENT = EXPONENT - ADJUST + 1)
;
;          ENTRY: PC'S POINT TO FL.PT. NO.
;               NO. ON EVEN BOUNDARY
;               F6 = ADJUST (BINARY)
;
;          RETURN:
;               F0 = 0 IF -99 <= EXP <= +99
;                    EXPONENT ADJUSTED
;               F0 = 1 IF EXP < -99
;               F0 = 2 IF EXP > +99
;               CH,BITSF0 = SIGN AFTER ADJUSTMENT
;                 ,BITS0F;CL = OLD EXP & 1ST DIGIT
;
;          MODIFIED REGISTERS: CH,CL,F0-2,F6
;

ADJEXP:   MOV       CX,WORD PTR [EDX]

;-------------------------------------------------------------------------------

;        Correction of bug -- don't adjust exponent if number is zero.
;
          MOV       AX,WORD PTR [EDX+6]
          MOV       BX,WORD PTR [EDX+4]
          MOV       SI,WORD PTR [EDX+2]
          OR        AX,AX
          JNZ       ADJEXPX
          OR        BX,SI
          JNZ       ADJEXPX
          JMP       ADJEXP7             ;branch if number is zero
;-------------------------------------------------------------------------------

ADJEXPX:  CMP       R6,0
          JE        ADJEXP1             ;BRANCH IF ADJUST = 0

;     ADJUSTMENT <= 0
;

          DEC       R6                  ;ADJ = ADJUST -1
          MOV       AX,CX
          OR        AX,AX
          JS        ADJEXP2             ;BRANCH IF EXPONENT NEGATIVE

ADJEXP5:  XOR       AX,AX
          MOV       AL,R6               ;EXP = EXP - ADJ
          SUB       CX,AX
          JNS       ADJEXP3             ;BRANCH IF EXP >=0

          CMP       CX,-99
          JL        ADJEXPU             ;BRANCH IF EXP < -99

ADJEXP3:  MOV       WORD PTR [EDX],CX

ADJEXP7:  MOV       R0,0                ;EXPONENT IN RANGE
          RET

;     ADJUSTMENT = 1
;

ADJEXP1:  MOV       R6,1                ;ADJ = 1
          MOV       AX,CX
          OR        AX,AX
          JS        ADJEXP5             ;BRANCH IF EXPONENT NEGATIVE
          CMP       CX,99
          JE        ADJEXPO             ;BRANCH IF EXPONENT = 99

ADJEXP2:  XOR       AX,AX
          MOV       AL,R6
          SUB       CX,AX               ;EXP = EXP + ADJ
          CMP       CX,255
          JG        ADJEXPU             ;BRANCH IF EXP > 255
          CMP       CX,99
          JLE       ADJEXP3             ;BRANCH IF EXP <= 99

ADJEXPU:  MOV       R0,1                ;EXPONENT UNDERFLOW ( < -99)
          RET

ADJEXPO:  MOV       R0,2                ;EXPONENT OVERFLOW ( > +99)
          RET

;     PACK: PROCESS A PACK STATEMENT
;
;          FORMAT:
;
;               PACK(image) alpha-var FROM expr      [,...]
;                                          num-array
;
;               where: image = [+][#...][.][#...][^^^^]
;                               -
;
;                           (at least 1 # required)
;
;                   or image = alpha-var containing image
;
;          ENTRY: TEXTPTR POINTS AFTER 'PACK'
;
;          MODIFIED REGISTERS: ALL,AUX0-4
;               IN EXECUTION PHASE, AUX5-7,9-B,E,F
;

PACK:     CALL      PACKSUB             ;SCAN IMAGE & BUFFER-VARIABLE
          CALL      CCLFROM             ;LOOK FOR 'FROM'

; SCAN NEXT ARGUMENT
;

PACK1:    CALL      ARRAYN              ;LOOK FOR NUMERIC ARRAY NAME
          TEST      R0,0FH
          JNZ       PACK15              ;BRANCH IF NOT FOUND
          TEST      SL,2
          JZ        PACK3               ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,AUX03           ;MOVE TO DIFFERENT AUX'S CONVENIENT TO BREAKPT
          MOV       AUX06,EDX
          MOV       EDX,AUX04
          MOV       AUX07,EDX
PACK16:   MOV       EDX,AUX06
          MOV       AUX05,EDX           ;SAVE PTR TO NEXT ELEMENT OF ARRAY

          MOV       EAX,VSPTR           ;NEXT ELEMENT ==> VS
          SUB       EAX,8
          MOV       ECX,DWORD PTR [EDX]
          MOV       DWORD PTR [EAX],ECX
          MOV       ECX,DWORD PTR [EDX+4]
          MOV       DWORD PTR [EAX+4],ECX
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERROR_02
          JMP       PACK2

PACK15:   CALL      EXPR                ;SCAN & EVALUATE EXPRESSION
          TEST      SL,2
          JZ        PACK3               ;BRANCH IF NOT EXECUTION PHASE
;         XOR       EDX,EDX
          MOV       AUX07,0             ;NO. OF ELEMENTS -1 = 0
          MOV       EDX,VSPTR
          MOV       AUX05,EDX           ;SAVE PTR TO VALUE ( IN VS)

PACK2:    MOV       EDX,AUX09
          MOV       AUX02,EDX           ;AUX2 = PTR TO IMAGE
          MOV       EDX,VSPTR
          MOV       AUX06,EDX           ;POINT TO VALUE
          ADD       EDX,8               ;"REMOVE" VALUE FROM VS
          XCHG      EDX,VSPTR

; PACK NEXT VALUE
;
;     ENTRY: AUX5=PTR TO NEXT ELEMENT OF ARRAY
;          AUX6 = ADDRESS OF NEXT VALUE TO PACK
;          AUX7 = NO. OF ELEMENTS IN ARGUMENT -1
;          AUX9 = AUX2 IMAGE PTR
;          AUXA = F6,5 IMAGE COUNTS
;          AUXB,BITS00FF = F7 IMAGE FLAGS
;          AUXE = NO. OF BYTES IN BUFFER-VARIABLE
;          AUXF = ADDRESS OF BUFFER-VARIABLE
;

PACK13:   test      byte ptr fs:[cpust],10h
          jz        pack13a             ;BRANCH IF < 30MS. ELAPSED

; Correction for infamous French trucking problem -- now saves all registers.
; Perhaps, should eliminate illegal syntax by calling IMAGE#C1 rather than
; IMAGE#C from the routine CPIMAGE.

          CALL      BREAKPTT            ;GIVE NEXT USER A CHANCE

PACK13A:  MOV       EDX,AUX06
;         MOV       EAX,DWORD PTR [EDX]
;         MOV       AUX20,EAX
;         MOV       EAX,DWORD PTR [EDX+4]
;         MOV       AUX21,EAX
          MOV       AUX03,EDX           ;POINT TO FL.PT. VALUE
          MOV       EDX,AUX0B
          MOV       R7,DL               ;F7 = IMAGE FLAG
          MOV       EDX,AUX0A
          MOV       WORD PTR [R5],DX    ;F6,5 = IMAGE COUNTS
          CALL      CVTALPHA            ;CONVERT FL.PT. VALUE TO ASCII ACCORDING TO IMAGE
          TEST      R7,1
          JNZ       ERROR_71            ;ERROR IF NO. EXCEEDS IMAGE

;     PACK ASCII VALUE INTO BUFFER
;
          MOV       EDX,AUX0F
          MOV       WORD PTR [R0],0     ;F1,F0 = 0
          TEST      R7,80H
          JZ        PACK14              ;BRANCH IF NO SIGN IN IMAGE
          MOV       EDX,AUX06           ;POINT TO FL.PT. VALUE
;         MOV       EAX,AUX20
;         MOV       DWORD PTR [EDX],EAX
;         MOV       EAX,AUX21
;         MOV       DWORD PTR [EDX+4],EAX
;         CALL      NEWTOOLD
          MOV       R1,1
          MOV       R0,0
          mov       eax,dword ptr [edx+2]
          or        eax,eax
          jnz       packxx
          mov       ax,word ptr [edx+6]
          or        ax,ax
          jz        pack14
packxx:   MOV       CX,WORD PTR [EDX]   ;GET SIGN OF VALUE; FLAG = SIGN IN F0
          OR        CX,CX
          JNS       PACKSS
          OR        R0,08H
PACKSS:   MOV       CX,WORD PTR [EDX+6]
          OR        CX,CX
          JNS       PACK14
          OR        R0,01H              ;SIGN ==> F0
PACK14:   MOV       EDX,DWORD PTR [CPBASE]  ;POINT TO ASCII VALUE-1
          LEA       EDX,[EDX].@IOBUFFR
          INC       EDX                 ;POINT TO ASCII VALUE
          JMP       PACK7

PACK6:    CALL      PACKCH              ;PACK HALF-BYTE ==> BUFFER-VARIABLE
PACK7:    MOV       CH,BYTE PTR [EDX]   ;GET NEXT ASCII CHARACTER
          INC       EDX
PACK5:    MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,30H
          JE        PACK6               ;BRANCH IF DIGIT
          CMP       AL,20H
          JE        PACK7               ;IGNORE '2X'
          CMP       CH,0
          JE        PACK8               ;BRANCH IF END OF ASCII VALUE
          INC       EDX                 ;BYPASS SIGN OF EXPONENT
          JMP       PACK7

PACK8:    TEST      R1,1
          JZ        PACK9               ;BRANCH IF LAST HALF-BYTE PUT INTO BUF-VAR
          MOV       EDX,AUX0F
          MOV       CH,BYTE PTR [EDX]   ;CH = NEXT BYTE OF BUFFER-VARIABLE
          CALL      PACKCHA             ;PUT LAST HALF-BYTE ==> BUFFER-VARIABLE

; SET ASCII VALUE = 0 (FOR 'CVTALPHA')
;

PACK9:    MOV       EDX,DWORD PTR [CPBASE] ;POINT TO BEGIN OF ASCII VALUE
          LEA       EDX,[EDX].@IOBUFFR
          MOV       R0,30H
          MOV       R1,'-'
          MOV       R2,'+'
          JMP       PACK12

PACK11:   MOV       AL,R2
          MOV       BYTE PTR [EDX],AL   ;REPLACE '-' BY '+'
          INC       EDX
          JMP       PACK12
PACK10:   MOV       AL,R0               ;REPLACE DIGIT BY '0'
          MOV       BYTE PTR [EDX],AL   ;REPLACE DIGIT BY '0'
          INC       EDX
PACK12:   MOV       CH,BYTE PTR [EDX]   ;GET NEXT ASCII CHARACTER
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,30H
          JE        PACK10              ;BRANCH IF DIGIT
          CMP       CH,R1
          JE        PACK11              ;BRANCH IF '-'
          INC       EDX
          CMP       CH,0
          JNE       PACK12              ;BRANCH IF NOT END OF ASCII VALUE

; LOOK FOR NEXT ARGUMENT OR ELEMENT
;
          MOV       EDX,AUX05
          ADD       EDX,8               ;AUX3 = ADDRESS OF NEXT ELEMENT
          MOV       AUX06,EDX
          MOV       EDX,AUX07
;         MOV       AUX07,EDX           ;DECREMENT NO. OF ELEMENTS
          DEC       AUX07
          CMP       DX,0
          JNE       PACK16              ;BRANCH IF MORE ELEMENTS

PACK3:    CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR ,
          JNE       ENDSTMTZ
          INC       TEXTPTR
          JMP       PACK1                   ;F, BRANCH

;     PACKCH: PACK NEXT HALF-BYTE INTO BUFFER-VARIABLE.
;             ERROR IF BUFFER FULL.
;
;          ENTRY:
;               AUXE = NO. OF BYTES REMAINING IN BUF-VAR
;               AUXF = PTR TO NEXT BYTE OF BUFFER-VARIABL
;               F1 = 0 IF 1ST HALF-BYTE NOT RECEIVED YET
;                      (SAVES CURRENT HALF-BYTE IN F0)
;                    1 IF 1ST HALF-BYTE WAS RECEIVED.
;                      (PACKS 2ND HALF-BYTE INTO F0 AND
;                      PUTS F0 INTO BUFFER-VARIABLE)
;
;          RETURN:
;               F1,BIT01 COMPLEMENTED
;               IF F1,BIT01 = 1,
;                    F0 = 0X WHERE X = HALF-BYTE REC'D
;               IF F1,BIT01 = 0,
;                    PACKED BYTE ==> BUFFER-VARIABLE
;                    AUXE DECREMENTED
;                    AUXF INCREMENTED
;
;          MODIFIED REGISTERS: F0,1,AUXE,F
;
;     PACKCHA: SAME AS 'PACKCH' EXCEPT ENTRY
;
;          ENTRY: AUXE,F AS ABOVE
;                 F0 = 0X WHERE X = 1ST HALF-BYTE
;                 CH = YZ WHERE Z = 2ND HALF-BYTE
;

PACKCH:   TEST      R1,1                ;BRANCH IF 1ST HALF-BYTE ALREADY REC'D
          JNZ       PACKCHA             ;BRANCH IF 1ST HALF-BYTE ALREADY REC'D
          MOV       R0,CH
          AND       R0,0FH              ;F0 = 0X WHERE X = 1ST HALF-BYTE
          MOV       R1,1                ;FLAG = 1ST HALF-BYTE REC'D
          RET

PACKCHA:  XCHG      EDX,AUX0E
          CMP       DX,0
          JNE       PACKCHX
          JMP       ERROR_76            ;ERROR IF BUFFER EMPTY

PACKCHX:  XCHG      EDX,AUX0E           ;DECREMENT BUFFER-VARIABLE COUNT
          DEC       AUX0E
          XCHG      EDX,AUX0F
          MOV       AL,R0
          SHL       AL,4
          MOV       AH,CH
          AND       AH,0FH
          OR        AL,AH
          MOV       BYTE PTR [EDX],AL   ;PACKED BYTE ==> BUFFER-VARIABLE
          XCHG      EDX,AUX0F           ;INCREMENT BUFFER-VARIABLE PTR
          INC       AUX0F
          MOV       R1,0                ;FLAG = 1ST HALF-BYTE NOT REC'D
          RET

;     UNPACK: PROCESS AN UNPACK STATEMENT
;
;          FORMAT:
;
;               UNPACK(image) alpha-var TO num-var [,...]
;                                          num-array
;
;               where: image = [+][#...][.][#...][^^^^]
;                               -
;
;                           (at least 1 # required)
;
;                   or image = alpha-var containing image
;
;          ENTRY: TEXTPTR POINTS AFTER 'UNPACK'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUX A-F
;

UNPACK:   CALL      PACKSUB            ;SCAN & PROCESS IMAGE & BUFFER VARIABLE
          CALL      CCLTO              ;LOOK FOR 'TO'

; SCAN NEXT ARGUMENT
;

UNPACK1:  CALL      ARRAYN             ;LOOK FOR NUMERIC ARRAY
          TEST      R0,0FH
          JZ        UNPACK8            ;F, BRANCH
          CALL      VARR               ;LOOK FOR NUMERIC VARIABLE
          TEST      SL,2
          JZ        UNPACK3            ;BRANCH IF NOT EXECUTION PHASE
;         MOV       EDX,OSPTR
;         MOV       OSPTR,EDX          ;REMOVE RECEIVER VARIABLE ATOM
          DEC       OSPTR
          MOV       EDX,VSPTR
          MOV       ECX,DWORD PTR [EDX]
;         MOV       VSPTR,EDX          ;GET ADDRESS OF VARIABLE FROM VS
          ADD       VSPTR,4
;         MOV       EDX,ECX
          MOV       AUX0C,ECX          ;AUXC = ADDRESS OF VARIABLE
;         XOR       EDX,EDX
          MOV       AUX0D,0            ;AUXD = NO. OF ELEMENTS -1  (0000)
          JMP       UNPACK7A

; UNPACK NEXT ARGUMENT'S VALUE(S)
;     ENTRY:
;          AUXA = F6,5 IMAGE COUNTS
;          AUXB,BITS00FF = F7 IMAGE FLAG
;          AUXC = ADDRESS OF ARGUMENT
;          AUXD = NO. OF ELEMENTS - 1
;          AUXE = NO. OF BYTES IN BUFFER-VARIABLE
;          AUXF = ADDRESS OF BUFFER-VARIABLE
;

UNPACK7:  test      byte ptr fs:[cpust],10h
          jz        unpack7a            ;BRANCH IF < 30MS. ELAPSED
          MOV       R0,SAV0A            ;SET FLAG FOR SAVE AUX A-1F, SHSL
          CALL      BREAKPTQ            ;GIVE NEXT USER A CHANCE
UNPACK7A: MOV       R1,0                ;INITIALIZE 'UNPACKCH' FLAG
          MOV       EDX,AUX0A
          MOV       WORD PTR [R5],DX    ;RESTORE IMAGE COUNTS
          MOV       EDX,AUX0B
          MOV       R7,DL               ;RESTORE IMAGE FLAG
          MOV       EDX,DWORD PTR [CPBASE]      ;POINT TO BEGIN OF I/O BUFFER
          LEA       EDX,[EDX].@IOBUFFR
          MOV       BYTE PTR [EDX],20H  ;SPACE ==> BUFFER
          MOV       R2,0                ;SIGN = '+'
          TEST      R7,80H
          JZ        UNPACK4             ;BRANCH IF NO SIGN IN IMAGE
          CALL      UNPACKCH            ;GET NEXT HALF-BYTE FROM BUFFER-VARIABLE
          MOV       AL,R0               ;SAVE SIGN
          MOV       R2,AL
          TEST      R0,1
          JZ        UNPACK4             ;BRANCH IF MANTISSA SIGN = '+'
          MOV       BYTE PTR [EDX],'-'  ;'-' ==> I/O BUFFER
          JMP       UNPACK4
UNPACKY:  CALL      UNPACKCH            ;GET NEXT HALF-BYTE FROM BUFFER VARIABLE
          MOV       AL,R0
          OR        AL,30H
          MOV       BYTE PTR [EDX],AL   ;ASCII DIGIT ==> I/O BUFFER
          DEC       R6                  ;DECREMENT INTEGER COUNT
UNPACK4:  INC       EDX
          CMP       R6,0
          JNE       UNPACKY             ;BRANCH IF MORE INTEGER DIGITS
          MOV       BYTE PTR [EDX],'.'  ;DECIMAL POINT ==> I/O BUFFER
          JMP       UNPACK5
UNPACKV:  CALL      UNPACKCH            ;GET NEXT HALF-BYTE FROM BUFFER-VARIABLE
          MOV       AL,R0
          OR        AL,30H
          MOV       BYTE PTR [EDX],AL   ;ASCII DIGIT ==> I/O BUFFER
          DEC       R5                  ;DECREMENT DECIMAL COUNT

UNPACK5:  INC       EDX
          CMP       R5,0
          JNE       UNPACKV             ;BRANCH IF MORE DECIMAL DIGITS
          TEST      R7,2
          JZ        UNPACK6             ;BRANCH IF NOT FL.PT. IMAGE
          MOV       BYTE PTR [EDX],'E'  ;'E' ==> I/O BUFFER
          INC       EDX
          MOV       BYTE PTR [EDX],'+'  ;EXPONENT SIGN ==> BUFFER
          TEST      R2,8
          JZ        UNPACKG
          MOV       BYTE PTR [EDX],'-'
UNPACKG:  INC       EDX
          CALL      UNPACKCH            ;GET 1ST EXPONENT DIGIT
          MOV       AL,R0
          OR        AL,30H
          MOV       BYTE PTR [EDX],AL   ;EXP. DIGIT ==> I/O BUFFER
          INC       EDX
          CALL      UNPACKCH            ;GET 2ND EXPONENT DIGIT
          MOV       AL,R0
          OR        AL,30H
          MOV       BYTE PTR [EDX],AL   ;EXP. DIGIT ==> I/O BUFFER
          INC       EDX
UNPACK6:  MOV       BYTE PTR [EDX],0    ;HEX(00) ==> BUFFER (END OF ASCII VALUE)
          MOV       R7,1                ;MAX. LENGTH = 255
          MOV       EDX,DWORD PTR [CPBASE] ;POINT TO ASCII NUMBER (IN IOBUFFER)
          LEA       EDX,[EDX].@IOBUFFR
          CALL      SNMBR               ;CONVERT ASCII NUMBER TO FL.PT.
          TEST      R0,0FH
          JNZ       ERR_75B             ;BRANCH IF NO NUMBER FOUND
          MOV       EDX,AUX00
          MOV       CH,BYTE PTR [EDX]
          MOV       EDX,AUX0C           ;GET CHARACTER AFTER ASCII VALUE
          CMP       CH,0
          JE        UNPACKBB            ;BRANCH IF HEX(00) (NO ILLEGAL CHARACTERS UNPACKD)
ERR_75B:  JMP       ERROR_75            ;ILLEGAL CHARACTER UNPACKED
UNPACKBB: MOV       EBX,VSPTR           ;VALUE FROM VS ==> VARIABLE
          MOV       EAX,DWORD PTR [EBX]
          MOV       DWORD PTR [EDX],EAX
          MOV       EAX,DWORD PTR [EBX+4]
          MOV       DWORD PTR [EDX+4],EAX
          ADD       VSPTR,8
          ADD       EDX,8
          MOV       AUX0C,EDX           ;INCREMENT VARIABLE PTR TO NEXT ELEMENT
          MOV       EDX,AUX0D
          MOV       AUX0D,EDX           ;DECREMENT NO. OF ELEMENTS
          DEC       AUX0D
          CMP       DX,0
          JNE       UNPACK7             ;BRANCH IF MORE ELEMENTS IN ARGUMENT

; LOOK FOR MORE ARGUMENTS
;

UNPACK3:  CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       ENDSTMTZ                ;EXIT IF NOT FOUND
          INC       TEXTPTR
          JMP       UNPACK1

UNPACK8:  TEST      SL,2
          JZ        UNPACK3             ;BRANCH IF NOT X-PHASE
          MOV       EDX,AUX03           ;MOVE TO DIFFERENT AUX'S FOR FASTER BREAKPT
          MOV       AUX0C,EDX
          MOV       EDX,AUX04
          MOV       AUX0D,EDX
          JMP       UNPACK7A

;     UNPACKCH: GET NEXT CHARACTER (HALF-BYTE) FROM
;               BUFFER-VARIABLE. ERROR IF NO MORE.
;
;          ENTRY:
;               AUXE = NO. OF BYTES REMAINING IN BUFFER
;               AUXF = POINTER TO NEXT CHARACTER IN BUFFR
;               F1 = 0 IF NEXT BYTE MUST BE READ FROM BUF
;                    1 IF NEXT HALF-BYTE = LOW HALF OF CH
;
;          RETURN:
;               F0 = 0X WHERE X = NEXT HALF-BYTE
;               AUXE DECREMENTED & AUXF INCREMENTED IF
;                    BYTE WAS READ FROM BUFFER-VARIABLE
;               CH = NEXT BYTE
;               F1,BIT01 COMPLEMENTED
;
;          MODIFIED REGISTERS: CH,CL,F0,F1
;

UNPACKCH: TEST      R1,1
          JNZ       UNPAKCH1            ;BRANCH IF NEXT HALF-BYTE IN CH
          XCHG      EDX,AUX0E
          CMP       DX,0
          JNE       UNPAKCHX
ERROR_76: MOV       R0,76H              ;BUFFER EXCEEDED
          JMP       ERROR
UNPAKCHX: XCHG      EDX,AUX0E
          DEC       AUX0E
          XCHG      EDX,AUX0F
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX0F           ;GET NEXT CHARACTER FROM BUFFER-VARIABLE
          INC       AUX0F
          MOV       R0,CH
          SHR       R0,4                ;F0 = 0X WHERE X = NEXT HALF-BYTE
          MOV       R1,1
          RET

UNPAKCH1: MOV       R0,CH               ;F0 = 0X WHERE X = NEXT HALF-BYTE
          AND       R0,0FH
          MOV       R1,0
          RET

;     PACKSUB: SCAN & PROCESS 'PACK' OR 'UNPACK' IMAGE
;              AND BUFFER VARIABLE
;
;          FORMAT: (image) alpha-variable
;
;          ENTRY: TEXTPTR PIONTS AFTER 'PACK' OR 'UNPACK'
;
;          RETURN: TEXTPTR POINTS AFTER BUFFER-VARIABLE
;               IN EXECUTION PHASE,
;                    AUXF = ADDRESS OF BUFFER-VARIABLE
;                    AUXE = LENGTH OF BUFFER-VARIABLE
;                    AUXB,BITS00FF = F7 IMAGE FLAG
;                    AUXA = F6,5 IMAGE COUNTS
;                    AUX9 = AUX2 IMAGE POINTER
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUX9,A,B,E,F,4
;

PACKSUB:  MOV       DL,6           ;FLAG = ',' & '$' ILLEGAL IN IMAGE, IGNORE ' '
          MOV       AUX04,EDX
          CALL      CPIMAGE        ;SCAN PACK IMAGE
          TEST      SL,2
          JZ        PACKSUB1       ;BRANCH IF NOT EXECUTION PHASE
          MOV       DL,R7
          MOV       AUX0B,EDX      ;SAVE IMAGE FLAG & COUNTS
          MOV       DX,WORD PTR [R5]
          MOV       AUX0A,EDX
          MOV       EDX,AUX02
          MOV       AUX09,EDX
PACKSUB1: JMP       AVARB          ;LOOK FOR BUFFER VARIABLE


;     CPIMAGE: SCAN & PROCESS 'CONVERT' OR 'PACK' IMAGE
;
;          FORMAT: (image)
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 AUX4,BITS0FF = IMAGE TYPE
;                                6 IF PACK,UNPACK
;                                0 IF CONVERT
;
;          RETURN: TEXTPTR POINTS AFTER IMAGE
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,4
;               IN EXECUTION PHASE, AUX5
;

CPIMAGE:  CMP       BYTE PTR [TEXTPTR],'('  ;LOOK FOR '('
          JNE       ERROR_10
          INC       TEXTPTR
          MOV       K,4                 ;FLAG = GET CURRENT LENGTH
          CALL      AVAR                ;LOOK FOR ALPHA-VARIABLE FORMAT
          TEST      R0,0FH
          JNZ       CPIMAGE6            ;BRANCH IF NOT FOUND
          TEST      SL,2
          JZ        CPIMAGE4            ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF ALPHA VALUE
          XOR       EAX,EAX
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          CMP       AX,255              ;BRANCH IF LENGTH < 255
          JB        CPIMAGE1
CPIMAGE2: JMP       ERROR_52            ;VARIABLE TOO LONG
CPIMAGE1: MOV       AUX05,EDX
          ADD       EDX,EAX
          XCHG      EDX,AUX05           ;AUX5 = ADDRESS OF END OF VALUE +1
          XCHG      EDX,AUX04
          MOV       R3,DL               ;F3 = IMAGE TYPE
          XCHG      EDX,AUX04
          MOV       AL,R0
          MOV       R4,AL               ;F4 = LENGTH OF VARIABLE
          CALL      IMAGE_              ;SCAN IMAGE
          MOV       DWORD PTR [A0],EDX
          MOV       EDX,AUX05
          CMP       DWORD PTR [A0],EDX
          JB        ERROR_42            ;ERROR IF ILLEGAL CHARACTER IN IMAGE
          JMP       CPIMAGE5

CPIMAGE6: MOV       EDX,AUX04
          MOV       R3,DL               ;F3 = IMAGE TYPE
          MOV       EDX,TEXTPTR
          CALL      IMAGE_C             ;SCAN IMAGE & CREATE DEFAULT ASCII VALUE
          MOV       TEXTPTR,EDX         ;POINT AFTER IMAGE
CPIMAGE5: CMP       WORD PTR [R5],0
          JNE       CPIMAGE4            ;BRANCH IF AT LEAST 1 # FOUND
ERROR_42: MOV       R0,42H              ;ILLEGAL IMAGE
          JMP       ERROR
CPIMAGE4: CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          RET

CODE      ENDS
          END
