;===========================================================================
;
;
;
;
;
;===========================================================================
;           This module was originally M40
;===========================================================================
           .XLIST
           INCLUDE PREAMBLE
           .LIST
PUBLIC       AKN
PUBLIC       AKN1
PUBLIC       AKNBPT
PUBLIC       CMNDINIT
PUBLIC       CMNDPLAT
PUBLIC       DISKADRD
PUBLIC       DISKCMDA
PUBLIC       DISKCMDC
PUBLIC       DISKCMND
PUBLIC       DISKSEL
PUBLIC       DISKSELC
PUBLIC       DISKSELCC
PUBLIC       DISKSL_C
PUBLIC       DISKSL_P
PUBLIC       DREAD
PUBLIC       DREADS0
PUBLIC       DREADSF
PUBLIC       DTLDBA
PUBLIC       DTLDDA
PUBLIC       DTSVBA
PUBLIC       DTSVDA
PUBLIC       DWRITE
PUBLIC       DWRITE?DA
PUBLIC       DWRITE?DAF
PUBLIC       ERR_92
PUBLIC       ERROR_81
PUBLIC       ERROR_88
PUBLIC       ERROR_93
PUBLIC       ERROR_94
PUBLIC       FILE_E
PUBLIC       FRMTDRAM
PUBLIC       INITRAMD
PUBLIC       LOADBLK
PUBLIC       LOADDATA
PUBLIC       LOADDBLK
PUBLIC       LOADLBLK
PUBLIC       MSWRTBEG
PUBLIC       MSWRTEND
PUBLIC       OBSDISK
PUBLIC       OBSECHO
PUBLIC       PLATTER
PUBLIC       PLATTERA
PUBLIC       PLATTERX
PUBLIC       RAW
PUBLIC       RAWON
PUBLIC       RAWOFF
PUBLIC       RECSCTR
PUBLIC       SAVEDATA
PUBLIC       SECTOR

EXTRN  ALPHA      :NEAR
EXTRN  srchdev    :NEAR
EXTRN  ALPHARAY   :NEAR
EXTRN  ARECEVAL   :NEAR
EXTRN  ARECEVX    :NEAR
EXTRN  ARGUMENT   :NEAR
EXTRN  ARGUMNTR   :NEAR
EXTRN  AVARL2     :NEAR
EXTRN  BINFLT     :NEAR
EXTRN  BINVAL     :NEAR
EXTRN  BREAKPTA   :NEAR
EXTRN  BREAKPTG   :NEAR
EXTRN  BREAKPTT   :NEAR
EXTRN  CBSNR      :NEAR
EXTRN  CCL        :NEAR
EXTRN  CPBASE     :DWORD
EXTRN  CPUID      :BYTE
EXTRN  DELAY10    :NEAR
EXTRN  DELAY5     :NEAR
EXTRN  DEVADDRS   :NEAR
EXTRN  DISKERR    :NEAR
EXTRN  ENBLDEVD   :NEAR
EXTRN  ENBLNLLDH  :NEAR
EXTRN  ENDDISK    :NEAR
EXTRN  ENDMEMX    :DWORD
EXTRN  ENDPART    :DWORD
EXTRN  ENDSDISK   :NEAR
EXTRN  ERROR      :NEAR
EXTRN  ERROR_10   :NEAR
EXTRN  ERROR_11   :NEAR
EXTRN  ERROR_13   :NEAR
EXTRN  ERROR_16   :NEAR
EXTRN  ERROR_29   :NEAR
EXTRN  ERROR_48   :NEAR
EXTRN  ERROR_74   :NEAR
EXTRN  FILE_A     :NEAR
EXTRN  FILE_ADR   :NEAR
EXTRN  GETPLTTR   :NEAR
EXTRN  HPION      :NEAR
EXTRN  NEWTOOLD   :NEAR
EXTRN  OBSNR      :NEAR
EXTRN  OLDTONEW   :NEAR
EXTRN  RAMDSK_S   :WORD
EXTRN  RECEVX     :NEAR
EXTRN  REMCO      :NEAR
EXTRN  SCRATCH    :NEAR
EXTRN  TRACED     :NEAR
EXTRN  VARR       :NEAR
EXTRN  WAITIBS    :NEAR
EXTRN  WAITRDY    :NEAR
EXTRN  WAITRDYB   :NEAR
EXTRN  WAKEUPA    :NEAR
EXTRN  _50MS      :DWORD
EXTRN  BASE       :DWORD
EXTRN  PART_      :BYTE
EXTRN  PLAT       :NEAR

;         MODULE    MOD-40 DISK BA, DA
;         TITLE     DISK
;*          ************************
;*          *                      *
;*          *     MOD40:  DISK     *
;*          *                      *
;*          ************************
;*
;*     MOD40 CONTAINS DISK COMMUNICATION LOGIC:
;*          1. DREAD --    READ SECTOR
;*          2. DWRITE --   WRITE SECTOR
;*          3. DCOMPARE -- COMPARE SECTOR (READ-AFTER-WRT)
;*
;*     ALSO, THE FOLLOWING ABSOLUTE ADDRESSING LOGIC:
;*          DATALOAD BA          DATALOAD DA
;*          DATASAVE BA          DATASAVE DA
;*     I/O BUFFERING:
;*
;*          1. A FIXED I/O BUFFER (0800-08FF) IS PROVIDED
;*             FOR NORMAL SINGLE SECTOR BUFFERING.
;*
;*          2. IF ADDITONAL BUFFERING IS REQUIRED, THE
;*             AREA IMMEDIATELY FOLLOWING THE TEXT AREA IS
;*             USED.
;*
;*                  LISTS - REQUIRES 1 SECTOR AFTER TEXT
;*                  MOVE,COPY - 4 SECTORS AFTER TEXT
;*
;*     DISK CONTROL REGISTER (AUXE):
;*
;*          XXXX XXXX  XXXX XXXX
;*          --^^ ----  ^    ----
;*          ^ ^^  ^    ^     ^
;*          ^ ^^  ^    ^     ----- PLATTER (0-4)
;*          ^ ^^  ^    ----------- SAVE! (2600 PROTECT)
;*          ^ ^^  ---------------- Unused (formerly, FILE# (0-15) );*;*;*
;*          ^ ^------------------- 1 IFF SAVE protect 2200
;*          ^ -------------------- 1 IFF READ-AFTER-WRITE
;*          ---------------------- SAVE COMPRESSION FLAG
;*                                   00 = NO COMPRESSION
;*                                   01 = DELETE SPACES
;*                                   11 = DELETE BOTH
;*
;*          PLATTER SPECIFICATION:
;*               0 (T) = USE DEVICE TYPE (3=F,B=R,D=PLATTER
;*                       SPECIFIED BY LOW 4-BITS OF ADDRESS)
;*               1 (F) = FIXED
;*               2 (R) = REMOVABLE
;*               3     = FIXED (DEVICE ADDR OR'ED WITH 40)
;*               4     = REMOVABLE (DEVICE ADDR OR'ED WITH
;*                                  40)
;*
;*     NOTE, 1. disk controller may not take OBS data
;*              until 1.6 usec. after trailing edge
;*              of OBS!
;*
;*           2. multiplexor controllers have common
;*              input/output data lines -- thus cannot
;*              OBS until IBS is complete!
;*
;*  ***   Prior to Rel. 3.1, AUXE,bits8-11 contained the file#.  In Rel. 3.1
;*        the number of file#'s allowed was increased to 256.  The file# is
;*        now stored in @FILE#.
;         EJECT
; *DISK SEQUENCES:
;*2 separate types of disk sequences are provided:
;*
;*     Diablo/Floppy sequences --
;*          a. Commands: read, write, compare single sector.
;*          b. Sector address 15 bits (16th bit stripped off).
;*          c. Platters: F and R.
;*
;*     Phoenix sequences --
;*          a. Commands: read, write, compare single sectors;
;*             copy, verify, multi-sector write.
;*          b. Sector address 24 bits (although existing code
;*             always sets high 8-bits to 0).
;*          c. Platters: 16, specfied by low 4 bits of device
;*             address:
;*                         x0 -- platter 10 (removable)
;*                         x1 -- platter 00 (1st fixed)
;*                         x2 -- platter 01 (2nd fixed)
;*                            .
;*                            .
;*                            .
;*                         xF -- platter 0E (15th fixed)
;*
;*     The disks indicate their type to the OS by the value
;*     returned in response to a 'disk initialization' command:
;*
;*               Cx -- Diablo/Floppy
;*               Dx -- Phoenix
;*
;*     BASIC-2 indicates that the low 4-bits of the device
;*     address specify the disk platter by using device type
;*     'D'.  The OS translates ACTDEV (device type & address)
;*     so that device type is 'D' iff disk is a Phoenix type.
;*     Translation is as follows:
;*
;*          disk = Diablo or Floppy
;*               T/D10 ==> /B10
;*               T/D11 ==> /310
;*
;*          disk = Phoenix
;*               T/310, F/310, F/B10 ==> /D11
;*               T/B10, R/310, R/B10 ==> /D10
;*CONSIDERATIONS:
;*     1. Control write loop with RB for Phoenix.

;*COMMAND EQUATES:
?AMREAD    EQU       00H      ; READ SECTOR
?AMEXTEND  EQU       20H      ; EXTENDED COMMAND (NEXT BYTE HAS COMMAND CODE)
?AMEXTENDH EQU       2H       ; (HIGH 4BITS)
?AMWRITE   EQU       40H      ; WRITE SECTOR
?AMCOMPARE EQU       80H      ; COMPARE SECTOR

?AMCOPY    EQU       01H      ; COPY SECTORS
?AMVERIFY  EQU       12H      ; VERIFY SECTORS
?AMMSWRTB  EQU       10H      ; BEGIN OF MULTI-SECTOR WRITE
?AMMSWRTE  EQU       11H      ; END OF MULTI-SECTOR WRITE
?AMFORMAT  EQU       02H      ; FORMAT PLATTER
?AMSTATUS  EQU       16H      ; DEVICE STATUS

;**** THE TIMEOUT VALUE WILL ADJUST

_WAIT    EQU       00400H     ;  TIMEOUT VALUE (0.3 MS)

;*Disk drives that do not respond to all Phoenix extended com-
;*mands must respond to the command by echoing back the comple-
;*ment of the command.  The OS will then either report an error
;*or use an alternate sequence.  Example, DSDD uses Phoenix
;*sequences but cannot perform verify, copy, or format.

;         TITLE     RAW RAWOFF RAWON
;*     RAW: PROCESS READ-AFTER-WRITE ($) SPECIFICATION
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER '$' IF THERE IS
;*                     ONE; OTHERWISE, TO NEXT NON-BLANK
;*                     TEXT CHARACTER
;*                  IN EXECUTION PHASE,
;*                     AUXE,BIT13 = 0 IF NO '$'
;*                                  1 IF '$' FOUND
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL
;*                  AUXE,BITS 13 (EXECUTION PHASE ONLY)
;*
;*     RAWON: TURN ON READ-AFTER-WRITE IF EXECUTION PHASE
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXE,BIT13 = 1 (READ-AFTER-WRITE)
;*
;*          MODIFIED REGISTERS (EXECUTION PHASE):
;*               AUXE,BIT13
;*
;*     RAWOFF: TURN OFF READ-AFTER-WRITE IF EXECUTION PHAS
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXE,BIT13 = 0 (NO READ-AFTER-WRITE)
;*
;*          MODIFIED REGISTERS (EXECUTION PHASE):
;*               AUXE,BIT13
;*
RAW:
        CMP     BYTE PTR [TEXTPTR],'$'
        JNE     RAWOFF
        INC     TEXTPTR
RAWON:
        TEST    SL,2
        JZ      RAW1
        OR      AUX0E,02000H
RAW1:
        RET

RAWOFF:
        TEST    SL,2
        JZ      RAW1
        AND     AUX0E,0FFFFDFFFH
        RET

;         TITLE     DWRITE$ DWRITE DWRITEB
;*     DWRITE$: WRITE ONE SECTOR TO DISK AND PERFORM A
;*              READ AFTER WRITE CHECK IF SPECIFIED.
;*
;*          ENTRY: SAME AS 'DWRITE' EXCEPT--
;*                 AUXE,BIT13 = 1 IF READ AFTER WRITE
;*                              0 IF NO R/W
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR WRITTEN TO +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,AUX0,1,F
;*
;*     DWRITE$F: SAME AS 'DWRITE$' EXCEPT FOR ENTRY
;*
;*          ENTRY: SAME AS 'DWRITE EXCEPT--
;*                 AUXF = SECTOR ADDRESS
;*                 (DATA TO BE WRITTEN IN IOBUFFER)
;*
;*     DWRITE: WRITE ONE SECTOR TO DISK
;*             (WRITEB ON 2200T, 4652)
;*
;*          ENTRY: DISK ENABLED.
;*                 AUXF = ADDRESS DATA TO WRITE
;*                PC'S = SECTOR ADDRESS OF SECTOR TO WRITE
;*                 AUXE,LOW BYTE = PLATTER
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR WRITTEN TO +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;*     DWRITEB: WRITE 256 BYTES OF DATA & LRC TO DISK
;*            (DWRITE ON 2200T, 4190)
;*
;*          ENTRY: DISK READY (IE, ENABLED,
;*                      ADDRESS BYTES TRANSFERRED AND
;*                      ACKNOWLEDGED)
;*                 AUXF = ADDRESS OF DATA TO WRITE
;*
;*          RETURN: AUXF = PC'S +1
;*
;*          MODIFIED REGISTERS: F0,F1,PC'S,K,AUXF,CH,CL
;*
;*          I/O NOTE: DISK CAN RECEIVE CHARACTERS AT MAX.
;*                    RATE OF 1 CHAR. / 8USEC (?).  DATA
;*                    IS NOT SENT ON A READY/BUSY BASIS,
;*                    SO A DELAY BETWEEN CHARACTERS MUST
;*                    BE INCLUDED.  HOW LONG SHOULD THIS
;*                    BE?  DISK SHOULD OPERATE ON READY/
;*                    BUSY BASIS!
;         SPACE
;*          TRANSFER RATE:
;*
;*             DIABLO/FLOPPY TRANSFER RATE = 15.7 USEC/CHAR
;*                                   (4.3MS FOR 256 BYTES)
;*
;*             PHOENIX TRANSFER RATE = 5.4 USEC/CHAR
;*                              (1.4MS FOR 256 BYTES)
;*
;*                    (ACTUALLY SLOWER DUE TO DISK PROCESSOR)
;*
;*             2200 TRANSFER RATE = 18.2 USEC/ CHAR.
;*                              (4.6 MS FOR 256 BYTES)
;*
DWRITE?DAF:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        XCHG    EDX,AUX0F

DWRITE?DA:
        XCHG    EDX,AUX0F
        MOV     AUX01,EDX       ;AUX1 = ADDR OF DATA TO WRITE
        XCHG    EDX,AUX0F
        CALL    DWRITE          ;WRITE SECTOR
        test    aux0e,02000h
        JZ      DWRITE?DA1
        MOV     EDX,AUX01
        XCHG    EDX,AUX0F
        DEC     EDX
        JMP     DCOMPARE

DWRITE?DA1:
        RET

DWRITE:
        MOV     AUX00,EDX
@3?PD0DC:
        MOV     EDX,ACTDEV
        CMP     DL,40H
        JNZ     DWRITEP9
        JMP     DWRITRAM        ;BRANCH IF RAMDISK ADDR

DWRITEP9:
        MOV     DL,0            ;INIT RETRY COUNT
DWRITE2:
        INC     EDX
        PUSH    EDX
DWRITE1:
        CALL    CMNDINIT        ;INITIAL DISK CONTROLLER
        MOV     EDX,AUX00       ;GET SECTOR ADDR
        MOV     R0,?AMWRITE
        CALL    DISKCMND        ;SEND WRITE COMMAND WITH SECTOR ADDR TO DISK
        CMP     R0,0
        JZ      DWRITE4         ;BRANCH IF NO ECHO ERROR

        POP     EDX
        TEST    DL,0FH
        JNZ     DWRITE2         ;BRANCH IF < 16 RETRIES
        CALL    ERROR_94

DWRITE4:
        CALL    AKN
;
        test    k,08h           ; k =  echo character ( 0Ch indicates access is denied)
        jz      retry_3
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     writee1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     write1ef

writee1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
write1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     dwritep9

retry_3:
;
        TEST    K,04H
        JNZ     ERROR_94
        CALL    DWRITEB
        CALL    AKNBPT
        POP     EDX

        TEST    K,4
        JZ      DWRITE3
        CMP     DL,3
        JNE     DWRITE2

DWRITE3:
        MOV     EDX,AUX00
        MOV     AUX0F,EDX
        INC     AUX0F
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        JMP     AKN1E

;* DATA TRANSFER
DWRITEB:
        MOV     bx,0                    ;bh= crc check bl = count
        MOV     EDX,AUX0F
        mov     esi,edx
        xchg    edx,actdev
        mov     ah,dh
        and     ah,0fh
        xchg    edx,actdev
        cmp     ah,_phoenix
        JZ      DWRITEP         ;BRANCH IF PHOENIX TYPE DRIVE

;*DIABLO/FLOPPY WRITE SEQUENCE (DELAY CONTROLLED)
DWRITEB1:
        inc     bl
        lodsb

;*_     CHAR.COUNT(F0), INCREMENT PTR TO DATA
        add     bh,al           ;ADD CHARACTER TO LRC
        call    delay10         ;DELAY SINCE DISK ACCEPTS CHARACTERS AT MAX. RATE
;*_     OF 1 CHAR./8USEC. >>>LENGTH OF DELAY?<<<<
        MOV     BYTE PTR FS:[OBS],al
        CMP     bl,0
        JNE     DWRITEB1        ;BRANCH IF < 256 CHARACTERS SENT
        CALL    DELAY10         ;DELAY SINCE DISK ACCEPTS CHAR. AT RATE OF 1/8USEC
        MOV     BYTE PTR FS:[OBS],bh    ;STROBE LRC TO DISK
        JMP     DELAY10

;*PHOENIX WRITE SEQUENCE (READY/BUSY CONTROLLED)
DWRITEP:
DWRITEP1:
        lodsb
        add     bl,1
        add     bh,al

        PUSH    ECX
        MOV     ECX,01C00H
BP40A_01:
        TEST    BYTE PTR FS:[CPUST],8
        LOOPZ   BP40A_01
        CMP     ECX,0
        POP     ECX
        JZ      ERROR_92        ;BRANCH IF NOT READY WITHIN 3MS.

DWRITEP2:
        MOV     BYTE PTR FS:[OBS],al
        CMP     bl,0
        JNZ     DWRITEP1

        MOV     ECX,1C00H
BP40A_02:
        TEST    BYTE PTR FS:[CPUST],8H
        LOOPZ   BP40A_02
        CMP     ECX,0
        JZ      ERROR_92        ;BRANCH IF NOT READY WITHIN 3MS.

DWRITEP3:
        MOV     AL,bh
        JMP     OBSNR

;         TITLE     DCOMPARE
;*     DCOMPARE: PERFORM READ-AFTER-WRITE
;*
;*          ENTRY: DISK ENABLED.
;*                 AUXF = ADDRESS DATA TO COMPARE
;*                PC'S = SECTOR ADDRESS OF SECTOR TO CHECK
;*                 AUXE,LOW BYTE = PLATTER
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR CHECKED +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;DCOMPARE TPA       ,0        SAVE SECTOR ADDRESS
;
;@3.0DD   EQU       *         check for ramdisk added in rel 3.0
;         TAP       ,ACTDEV
;         BNEH      4,PL,DCOMPAR1
;         BNEL      0,PL,DCOMPAR1
;         B         DCOMPARM  branch if RAMdisk address

DCOMPARE:
        MOV     AUX00,EDX
@3?PD0DD:
        MOV     EDX,ACTDEV
        CMP     DL,40H
        JNZ     DCOMPAR1
        JMP     DCOMPARM

;DCOMPAR1 MVI       0,PL      INIT RETRY COUNT TO ZERO
;DCMPARE2 TPS+1     INCREMENT RETRY COUNT
;         SB        CMNDINIT  INITIALIZE DISK CONTROLLER

DCOMPAR1:
        MOV     DL,0
DCMPARE2:
        INC     EDX
        PUSH    EDX
        CALL    CMNDINIT

;         TAP       ,0        GET SECTOR ADDRESS
;         MVI       &COMPARE,F0
;         SB        DISKCMND  SEND COMPARE COMMAND WITH SECTOR ADDRESS TO DISK

        MOV     EDX,AUX00
        MOV     R0,?AMCOMPARE
        CALL    DISKCMND

;         BER       F0,,DCMPARE3        BRANCH IF NO ECHO ERROR
;         TSP
;         BNEL      0,PL,DCMPARE2       BRANCH IF < 16 RETRIES
;         B         ERROR#94  BRANCH - MUX ERROR

        CMP     R0,0
        JE      DCMPARE3
        POP     EDX
        TEST    DL,0FH
        JNZ     DCMPARE2
        JMP     ERROR_94

;DCMPARE3 SB        AKN       GET ACKNOWLEDGEMENT FOR VALID SECTOR ADDRESS
;         SB        OBSDISK   SIGNAL DISK TO CHECK IOB'S TO INSURE NOT TRYING
;*_     TO RESTART (2200 DOES NOT WAIT FOR READY BEFORE
;*_     STROBE OR DELAY 5 USEC. AFTER)
;         SB        AKNBPT    WAIT FOR ACKNOWLEDGEMENT FROM DISK
;         BFL       7,K,DCMPARE5        BRANCH IF NOT CRC, FORMAT, OR SEEK ERROR
;DCMPARE4 TSP
;         BNEL      0,PL,DCMPARE2       RETRY IF < 16 SCREW UPS

DCMPARE3:
        CALL    AKN
;
        test    k,08h           ; k =  echo character ( 0Ch indicates access is denied)
        jz      retry_2
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     dcompe1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     dcomp1ef

dcompe1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
dcomp1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     dcompar1
retry_2:
;
        TEST    K,04H
        JNZ     ERROR_94
        CALL    OBSDISK
        CALL    AKNBPT
        TEST    K,07H
        JZ      DCMPARE5
DCMPARE4:
        POP     EDX
        TEST    DL,0FH
        JNZ     DCMPARE2

;ERROR#99 MVI       99,F0     READ-AFTER-WRITE ERROR
;         B         DISKERR

ERROR_99:
        MOV     R0,99H
        JMP     DISKERR

;DCMPARE5 SB        DWRITEB   WRITE DATA AND LRC TO DISK
;         SB        AKNBPT    WAIT FOR RESPONSE FROM DISK (COMPARE RESULT)
;         BNR       +,K,DCMPARE4        BRANCH IF COMPARE ERROR
;         TSP       CLEAR UP STACK
;         B         DWRITE3   set the AUX's to the return values and return

DCMPARE5:
        CALL    DWRITEB
        CALL    AKNBPT
        CMP     K,0
        JNZ     DCMPARE4
        POP     EDX
        JMP     DWRITE3

;         TITLE     MULT-SECTOR WRITE
;*MSWRTBEG: BEGIN OF MULTI-SECTOR WRITE COMMAND ==> DISK
;*MSWRTEND: END OF MULTI-SECTOR WRITE COMMAND ==> DISK
;*
;*     OPERATIONS THAT WRITE SEQUENTIAL SECTORS (E.G. 'SAVE')
;*     CAN BE PRECEDED BY A 'BEGIN OF MULTI-SECTOR WRITE'
;*     COMMAND AND TERMINATED BY AN 'END OF MULTI-SECTOR
;*     WRITE' COMMAND.  THE DISK PROCESSOR (PHOENIX) WILL
;*     MULTI-BUFFER THE SECTORS TO BE WRITTEN, WRITING ONLY
;*     WHEN: (1) ALL BUFFERS ARE FULL OR
;*           (2) 'END M.S. WRITE' COMMAND IS RECEIVED OR
;*           (3) DISK IS RESET OR
;*           (4) A COMMAND THAT IS NOT A SEQUENTIAL WRITE
;*               IS RECEIVED.
;*
;*     ERRORS OCCURING DURING WRITING MUST EITHER RESET THE
;*     DISK OR SEND AN 'END' COMMAND SO THAT THE BUFFERED
;*     SECTORS WILL BE WRITTEN.
;*
;*     DISK ERRORS ARE ACKNOWLEDGED BY 'END MULTI-SECTOR
;*     WRITE' SEQUENCE.
;*
;*     MS WRITE COMMANDS NOT ISSUED IF READ/AFTER/WRITE
;*
;*     ENTRY: DISK ENABLED
;*
;*     MODIFIED REGISTERS: PC'S,CHCL,K,F0-2
;*
;MSWRTBEG TAP       ,E
;
;*Check for read-after-write eliminated in Rel 2.0
;*
;*        BTH       2,PH,MSWRT4                    RETURN IF READ-AFTER-WRITE
;         MVI       &MSWRTB,F2   COMMAND = BEGIN MULTI-SECTOR WRITE

MSWRTBEG:
        MOV     R2,?AMMSWRTB
;
;MSW1     MVI       00,PL
;MSWRT1   TPS+1
;         SB        CMNDINIT  DISK INITIALIZATION (START OF OPERATION)
;         TAP       ,ACTDEV
;         BNEH      #PHOENIX,K,MSWRT4   BRANCH IF NOT PHOENIX OR DDDD FLOPPY

MSW1:
        MOV     DL,0
MSWRT1:
        INC     EDX
        PUSH    EDX
        CALL    CMNDINIT
        MOV     EDX,ACTDEV
        CMP     K,0D0H
        JNZ     MSWRT4

;MSWRT2   MVI       40,K
;         CIO       IOBS      IOBS = OPERATION IN PROGRESS
;         MVI       30,F0
;         BEQL      0,PL,MSWRT3         BRANCH IF DEVICE Dx0

MSWRT2:
        MOV     BYTE PTR FS:[IOBS],40H
        MOV     R0,30H
        TEST    DL,0FH
        JZ      MSWRT3

;         ANDI      0F,PL,F0  CALCULATE PLATTER#
;         AI        0FF,F0,F0 D11==>00, D12==>01,...
;         ORI       &EXTEND,F0,F0

        AND     DL,0FH
        DEC     DL
        OR      DL,?AMEXTEND
        MOV     R0,DL

;MSWRT3   SB        OBSECHO   COMMAND/PLATTER ==> DISK
;         BER       F0,,MSWRT3A         BRANCH IF NO EHCO ERROR
;         TSP
;         BNEL      0,PL,MSWRT1
;         B         ERROR#94

MSWRT3:
        CALL    OBSECHO
        CMP     R0,0
        JE      MSWRT3A
        POP     EDX
        TEST    DL,0FH
        JNZ     MSWRT1
        JMP     ERROR_94

;MSWRT3A  MV        F2,F0
;         SB        OBSECHO   M.S. WRITE COMMAND ==> DISK
;         BER       F0,,MSWRT3B         BRANCH IF NO EHCO ERROR
;         TSP
;         BNEL      0,PL,MSWRT1
;         B         ERROR#94

MSWRT3A:
        MOV     AL,R2
        MOV     R0,AL
        CALL    OBSECHO
        CMP     R0,0
        JE      MSWRT3B
;                               ;make sure that  R2 doesn't alter !!!
        cmp     k,60h           ;ECHO = 60h indicates extended command reject
        jnz     retry_4
        push    ecx
        mov     ch,r2
        mov     eax,cpbase
        mov     byte ptr [eax].@r2,ch
        pop     ecx
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     mswe1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     msw1ef

mswe1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
msw1ef:
        mov     edx,actdev
        call    enbldevd
        push    ecx
        mov     eax,cpbase
        mov     ch,byte ptr [eax].@r2
        mov     r2,ch
        pop     ecx
        jmp     msw1
;
retry_4:
        POP     EDX
        TEST    DL,0FH
        JNZ     MSWRT1
        JMP     ERROR_94

;MSWRT3B  TSP       CLEAN STACK
;         MVI       0,K
;         B         OBSDISK   START OPERATION

MSWRT3B:
        POP     EDX
        MOV     K,0
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        JMP     OBSDISK

;MSWRT4   TSP       CLEAN STACK
;         SR

MSWRT4:
        POP     EDX
        RET

;***************************************************************************
;*  END MULTI-SECTOR WRITE ROUTINE
;
;MSWRTEND TAP       ,E
;         MVI       &MSWRTE,F2    COMMAND = END OF MULTI-SECTOR WRITE
;         SB        MSW1      DISK INITIALIZATION (START OF OPERATION)
;         TAP       ,ACTDEV
;         BEQL      #PHOENIX,PH,*+2     BRANCH IF PHOENIX OR DDDD FLOPPY
;         SR

MSWRTEND:
        MOV     R2,?AMMSWRTE
        CALL    MSW1
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        MOV     EDX,ACTDEV
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JZ      BP40A_03
        RET
;
;*Read-after-write error (ERR 99) logic added in Rel 2.0  (bit 08 ==> ERR 99)
;*
;         SB        AKNBPT    get ACKNOWLEDGEMENT
;         BTL       8,K,ERROR#99        branch if read-after-write error
;         B         AKN1E     check for other errors

BP40A_03:
        CALL    AKNBPT
        TEST    K,8
        JNZ     ERROR_99
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        JMP     AKN1E

;         TITLE     SECTOR
;*     SECTOR: SCAN & PROCESS AN ABSOLUTE SECTOR SPEC.
;*
;*          SECTOR SPECIFICATION FORMAT:
;*
;*               ( alpha-var [,[receiver-variable]] )
;*                 expression
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER ')'
;*                  IN EXECUTION PHASE,
;*                     AUXF = SECTOR ADDRESS TO READ/WRITE
;*                     RECEIVER-VARIABLE ADDRESS, LENGTH,
;*                         AND ATOM IN VS AND OS (IF THERE
;*                         WAS A RECEIVER SPECIFIED)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXF (EXECUTION PHASE ONLY)
;*
;         ORG       *
;SECTOR   SB        GETCHLP   LOOK FOR '('
;         SB        BINVAL    GET 16-BIT BINARY VALUE FROM EXPR. OR ALPHA VARIABL
;         BFL       2,SL,SECTOR2        BRANCH IF NOT EXECUTION PHASE
;         MVX       F1F0,PHPL
;         TPA       ,F        AUXF = SECTOR ADDRESS

SECTOR:
        CMP     BYTE PTR [TEXTPTR],'('
        JNZ     ERROR_10
        INC     TEXTPTR
        CALL    BINVAL
        TEST    SL,2
        JZ      SECTOR2
        MOV     DX,WORD PTR R0
        MOV     AUX0F,EDX

;SECTOR2  SB        NXTCHCOM  LOOK FOR COMMA
;         BNEL      0,F0,SECTOR3        NF, BRANCH
;         SB        NXTCHRP   LOOK FOR ')'
;         BNEL      0,F0,*+2  BRANCH IF NOT FOUND
;         SR

SECTOR2:
        CMP     BYTE PTR [TEXTPTR],','
        JNZ     SECTOR3
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR],')'
        JNZ     BP40A_04
        INC     TEXTPTR
        RET

;         MVI       2,K
;         SB        AVARL2    SCAN & PROCESS ALPHA-RECEIVER-VARIALBE
;         BEQL      0,F0,*+2  F, BRANCH
;         SB        VARR      SCAN & PROCESS NUMERIC-RECEIVER-VARIABLE
;SECTOR3  B         GETCHRP   LOOK FOR ')'

BP40A_04:
        MOV     K,2
        CALL    AVARL2
        TEST    R0,0FH
        JZ      SECTOR3
        CALL    VARR
SECTOR3:
        CMP     BYTE PTR [TEXTPTR],')'
        JNZ     ERROR_11
        INC     TEXTPTR
        RET

;         TITLE     RECSCTR
;*     RECSCTR: SET THE RECEIVER-VARIABLE = NEXT AVAILABLE
;*             SECTOR (ADDRESS OF LAST SECTOR ACCESSED +1)
;*             IF A RECEIVER IS SET UP IN THE STACKS.
;*
;*          ENTRY: RECEIVER INFORMATION IN OS AND VS--
;*                    IF NUMERIC, @NUMREC IN OS
;*                                ADDRESS OF VAR. IN VS
;*                    IF ALPHA, @ALPHREC IN OS
;*                                ADDRESS OF VAR. IN VS
;*                                LENGTH OF VAR. IN VS
;*               AUXF = ADDRESS OF SECTOR LAST ACCESSED+1
;*                 PHASE = EXECUTION
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-5,K,AUX0,1,2
;*
;         ORG       *
;RECSCTR  TAP       ,OSPTR
;         TAP,R     ,F        CH = LAST OS ATOM; PH,PL = ADDRESS OF LAST SECTOR +1
;         MVX       PHPL,F1F0 F1,0 = ADDRESS OF LAST SECTOR ACCESSED + 1
;         BNEH      @NUMRECH,CH,RECSCTR2BRANCH IF NOT RECEIVER ATOM
;         BNEL      @NUMRECL,CH,RECSCTR1BRANCH IF ALPHA RECEIVER

RECSCTR:
        MOV     EDX,OSPTR
        MOV     CH,[EDX]
        MOV     EDX,AUX0F
        MOV     WORD PTR R0,DX
        CMP     CH,@NUMREC
        JZ      BP40A_05
        CMP     CH,@ALPHREC
        JZ      RECSCTR1
        JMP     RECSCTR2

;*     NUMERIC RECEIVER
;*
;         SB        BINFLT    CONVERT SECTOR ADDRESS TO FL.PT.
;         B         RECEVX    RECEIVER VARIABLE = SECTOR ADDRESS

BP40A_05:
        CALL    BINFLT
        JMP     RECEVX

;*     ALPHA RECEIVER
;*
;RECSCTR1 BEQL      @ALPHRCL,CH,*+2
;RECSCTR2 SR        ,         EXIT IF NOT RECEIVER ATOM
;         LPI       SCRATCH
;         OR,W1     F1,,      SAVE SECTOR ADDRESS IN SCRATCH AREA (RAM)
;         OR,W2     F0,,

RECSCTR2:
        RET
RECSCTR1:
        MOV     EDX,OFFSET SCRATCH
        MOV     AL,R1
        MOV     [EDX],AL
        MOV     AL,R0
        MOV     [EDX+1],AL

;         SB        PUSHPV2   ADDRESS OF SCRATCH --> VS
;         LPI       2
;         SB        PUSHPV2   LENGTH (2) --> VS
;         B         ARECEVX   RECEIVER VARIABLE = SECTOR ADDRESS

        MOV     EAX,VSPTR
        MOV     DWORD PTR [EAX-4],EDX
        SUB     VSPTR,4
        MOV     EAX,VSPTR
        MOV     WORD PTR [EAX-2],02
        SUB     VSPTR,2
        JMP     ARECEVX

;         TITLE     PLATTER PLATTERA
;*     PLATTER: LOOK FOR PLATTER SPECIFICATION IN TEXT
;*              (F,R,T). ERROR IF NF.
;*
;*     PLATTERA: LOOK FOR PLATTER SPECIFICATION IN TEXT
;*              (F,R,T)
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER PLATTER SPEC.
;*                  F0 = FF IF PLATTER SPEC. NOT FOUND
;*                  F0 = PLATTER SPECIFICATION IF FOUND
;*                         0 = T
;*                         1 = F
;*                         2 = R
;*                 IN EXECUTION PHASE,
;*                    AUXE,LOW BYTE = PLATTER SPEC.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0
;*               AUXE,LOW BYTE (EXECUTION PHASE ONLY)
;*
;*     PLATTERD: AUXE = DEFAULT PLATTER (F)
;*
;         ORG       *
;PLATTER  SB        PLATTERA  LOOK FOR PLATTER SPEC.
;         BNEH      0F,F0,PLATTER5      BRANCH IF FOUND
;         B         ERROR#16  ERROR IF NF

PLATTER:
        CALL    PLATTERA
        CMP     R0,0FFH
        JNZ     PLATTER5
        JMP     ERROR_16

;PLATTERA SB        GETCH     GET NEXT TEXT CHARACTER
;PLATTER1 BNEH      4,CH,*+2
;         BEQL      6,CH,PLATTERD       BRANCH IF 'F'
;         BNEH      5,CH,PLATTER2       BRANCH IF NOT '5X'
;         MVI       2,F0
;         BEQL      2,CH,PLATTER4       BRANCH IF 'R'
;         MVI       0,F0
;         BEQL      4,CH,PLATTER4       BRANCH IF 'T'

PLATTERA:
        mov     edx,textptr
        mov     ch,[edx]
        inc     textptr
PLATTER1:
        CMP     CH,'F'          ;'F' ASCII = 46H
        JZ      PLATTERD
        MOV     R0,2
        CMP     CH,'R'          ;'R' ASCII = 52H
        JZ      PLATTER4
        MOV     R0,0
        CMP     CH,'T'          ;'T' ASCII = 54H
        JZ      PLATTER4

;PLATTER2 MVI       0FF,F0    FLAG = NF
;         TPA       ,TEXTPTR  DECREMENT TEXTPTR
;         SR

PLATTER2:
        MOV     R0,0FFH
        MOV     TEXTPTR,EDX
        RET

;PLATTERD MVI       1,F0
;PLATTERX EQU       *
;PLATTER4 BFL       2,SL,PLATTER5       BRANCH IF NOT EXECUTION PHASE
;         XPA       ,E
;         ANDI      0F0,PL,PL AUXE,LOW NIBBLE = PLATTER SPECIFICATION

PLATTERD:
        MOV     R0,1
PLATTERX:
PLATTER4:
        TEST    SL,2
        JZ      PLATTER5
        mov     al,r0
        and     byte ptr aux0e,0f0h
        or      byte ptr aux0e,al


;         OR        F0,PL,PL
;         XPA       ,E
;PLATTER5 SR

PLATTER5:
        RET

;         TITLE     DISKSEL
;*     DISKSEL: PROCESS THE DISK SELECTION PARAMETER
;*              (#n [,]   or   /xyy [,])
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER DISK SELECTION
;*                    PARAMETER
;*                  IN EXECUTION PHASE,
;*                     DISK ENABLED
;*                     AUXE,HIGH BYTE = FILE# (DEFAULT =0)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXE,HIGH BYTE (EXECUTION PHASE ONLY)
;*
;*     DISKSELC: SAME AS DISKSEL EXECPT COMMA REQUIRED
;*               AFTER #n OR /xyy
;*
;*   DISKSEL#: PROCSS THE DISK SELECTION PARAMETER (#n[,])
;*               (SAME AS 'DISKSEL' EXCEPT /xyy NOT LEGAL)
;*
;*     DISKSL#C: PROCESS THE DISK SELECTION PARAMETER
;*               (#n, ) (TRAILING COMMA REQUIRED)
;*
;*     DISKSL#P: SAME AS 'DISKSL#C' EXCEPT PLATTER SPEC.
;*               IS OBTAINED FROM #N SLOT OF DEVICE TABLE
;*
;         ORG       *
;DISKSEL  SB        FILE#     SCAN & PROCESS FILE NUMBER (#n)
;         BEQL      0,F0,DISKSEL1       BRANCH IF FOUND
;         B         DISKADR   SCAN & PROCESS DISK ADDRESS (/xyy)
;DISKSEL1 SR

DISKSEL:
        CALL    FILE_
        TEST    R0,0FH
        JZ      DISKSEL1
        JMP     DISKADR
DISKSEL1:
        RET

;DISKSEL# SB        FILE#     SCAN & PROCESS FILE NUMBER (#n)
;         B         *+2
;DISKSL#C SB        FILE#C    SCAN & PROCESS FILE NUMBER (#n,)
;         BEQL      0,F0,DISKSEL1       BRANCH IF FOUND
;DISKSEL2 B         DISKADRD  ENABLE DEFAULT DISK

DISKSEL_:
        CALL    FILE_
        JMP     BP40C_02
DISKSL_C:
        CALL    FILE_C
BP40C_02:
        TEST    R0,0FH
        JZ      DISKSEL1
DISKSEL2:
        JMP     DISKADRD

;DISKSELC SB        FILE#C    LOOK FOR #n,
;         BEQL      0,F0,DISKSEL1       BRANCH IF FOUND
;         SB        DISKADR   LOOK FOR /xyy
;         BEQL      0,F0,DISKSEL1       BRANCH IF COMMA AFTER /XYY
;         B         ERROR#13  ERROR IF NO COMMA


DISKSELC:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@enabflg,0
        jmp     diskselc_1
diskselcc:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@enabflg,1
diskselc_1:
        CALL    FILE_C
        TEST    R0,0FH
        JZ      DISKSEL1
        CALL    DISKADR
        TEST    R0,0FH
        JZ      DISKSEL1
        JMP     ERROR_13

;DISKSL#P SB        FILE#A    SCAN #N; AUXE = FILE#
;         BNEL      0,F0,*+2  NF, BRANCH
;         SB        GETCHCOM  LOOK FOR COMMA
;         SB        GETPLTTR  GET PLATTER SPEC. FROM #N SLOT OF DEVICE TABLE
;         B         FILE#1

DISKSL_P:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     BP40C_03
        CMP     BYTE PTR [TEXTPTR],','
        JNZ     ERROR_13
        INC     TEXTPTR
BP40C_03:
        CALL    GETPLTTR
        JMP     FILE_1

;         TITLE     FILE# FILE#C
;*     FILE#: SCAN & PROCESS A FILE NUMBER SPECIFICATION
;*            & ENABLE DISK (WHOSE ADDRESS IS IN #n DEVICE table slot)
;*
;*          FILE# FORMAT:  # integer [,]
;*                           numeric-var [,]
;*
;*               where:  0 <= file# <= 255
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: F0 = 0 IF FOUND
;*                    TEXTPTR POINTS AFTER FILE NO. SPEC.
;*                    IN EXECUTION PHASE,
;*                       CH,CL = DEV.TYPE & ADDRESS FROM
;*                               THE DEVICE TABLE
;*                       K = DEVICE ADDRESS
;*
;*                 F0 <> 0 IF NOT FOUND
;*                    TEXTPTR POINTS TO NEXT NONBLANK TEXT character
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*
;*     FILE#C: SAME AS 'FILE#' EXCEPT COMMA REQUIRED AFTER file#
;*
;*     FILE#E:  enable #n disk
;*
;*        Entry:    @FILE#, byte 2 = file#
;*
;*        Return:   CHCL = device type & address
;*                  K = device address
;*
;*        Modified registers:  PHPL,CHCL,K
;*
;*------- #n, ------------------------------------------------------------------
;FILE#C   SB        FILE#A    SCAN & PROCESS #n
;         BNEL      0,F0,FILE#3         NF, BRANCH
;         SB        GETCHCOM  LOOK FOR COMMA (REQUIRED)
;         B         FILE#1

FILE_C:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     FILE_3
        CMP     BYTE PTR [TEXTPTR],','
        JNZ     ERROR_13
        INC     TEXTPTR
        JMP     FILE_1

;*------- #n [,] ---------------------------------------------------------------
;FILE#    SB        FILE#A    SCAN & PROCESS #n
;         BNEL      0,F0,FILE#3         NF, BRANCH
;         SB        NXTCHCOM  LOOK FOR COMMA (OPTIONAL)
;
;FILE#1   BFL       2,SL,FILE#2         BRANCH IF NOT EXECUTION PHASE

FILE_:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     FILE_3
        CMP     BYTE PTR [TEXTPTR],','
        JNZ     FILE_1
        INC     TEXTPTR
FILE_1:
        TEST    SL,2
        JZ      FILE_2

;*%------- enable #n disk -------------------------------------------------------
;FILE#E   SB        FILE#ADR  CHCL = device address at #n
;         MVX       CHCL,F1F0 F1,0 = DEVICE TYPE & ADDRESS
;         B         DISKADRA  ENABLE DISK

FILE_E:
        CALL    FILE_ADR
        MOV     WORD PTR R0,CX
        JMP     DISKADRA

;         TITLE     DISKADR
;*     DISKADR: SCAN & PROCESS AN ABSOLUTE DISK ADDRESS
;*              SPECIFICATION.  THE SPECIFIED DEVICE IS
;*              ENABLED.  IF NO SPECIFICATION IS FOUND,
;*              THE DEFAULT DISK IS ENABLED (IN EXECUTION
;*              PHASE ONLY).
;*
;*          ADDRESS SPECIFICATION = /taa [,]
;*
;*               WHERE: t = device type (hexdigit)
;*                      aa = device address (2 hexdigits)
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE, LOW BYTE OF AUXE
;*                    = PLATTER SPECIFICATION (0-2).
;*
;*          RETURN: TEXTPTR POINTS AFTER ADDRESS SPEC.
;*                  IN EXECUTION PHASE,
;*                     DISK ENABLED
;*                     F0 = 0 IF COMMA FOUND, 1 IF NOT
;*                        (F0 = 0 IF DEFAULT DISK ADDRESS)
;*                     K = DISK ADDRESS
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;*                              K (EXECUTION PHASE ONLY)
;*
;*     DISKADRD: ENABLE DEFAULT DISK IN EXECUTION PHASE
;*               (DEVICE TYPE & ADDRESS IN 'DISK' SLOT OF
;*               DEVICE TABLE)
;*
;*          ENTRY: IN EXECUTION PHASE, LOW BYTE OF AUXE
;*                    = PLATTER SPECIFICATION (0-4)
;*
;*          RETURN: IN EXECUTION PHASE,
;*                     DISK ENABLED
;*                     K = DISK ADDRESS
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1
;*                              K (EXECUTION PHASE ONLY)
;*
;*     DISKADRA: ENABLE THE SPECIFIED DISK DEVICE
;*
;*          ENTRY: F1,0 = DEVICE TYPE & ADDRESS
;*                 AUXE,BITS000F = PLATTER SPEC.
;*
;*          RETURN: F0 = 0
;*                  IN EXECUTION PHASE,
;*                     DISK ENABLED
;*                     K = DISK ADDRESS
;*
;*          MODIFIED REGISTERS: PC'S, K (EXECUTION PHASE)
;*
;*     DISK ADDRESSING NOTES:
;*          1. THE DEVICE TYPE MUST BE 3 OR B FOR DISKS.
;*             IF NOT, AN ERROR WILL RESULT.
;*
;DISKADR  SB        DEVADDRS  SCAN /taa
;         BNEH      0,F1,DISKADRD       BRANCH IF NF
;         SB        DISKADRA  ENABLE DISK IF EXECUTION PHASE
;         B         NXTCHCOM  LOOK FOR COMMA (OPTIONAL)

DISKADR:
        CALL    DEVADDRS
        TEST    R1,0F0H
        JNZ     DISKADRD
        CALL    DISKADRA
        CMP     BYTE PTR [TEXTPTR],','
        JNZ     FILE_3
        INC     TEXTPTR
        JMP     FILE_3

;DISKADRD BFL       2,SL,FILE#2         BRANCH IF NOT EXECUTION PHASE
;         SB        RDEVDISK  CH,CL = DEFAULT DISK ADDRESS
;         MVX       CHCL,F1F0 F1,0 = DEFAULT DISK ADDRESS

DISKADRD:
        TEST    SL,2
        JZ      FILE_2
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVDISK
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     WORD PTR R0,CX

;DISKADRA BFL       2,SL,FILE#2         BRANCH IF NOT EXECUTION PHASE
;         BEQL      3,F1,DISKADR1
;         BEQL      B,F1,DISKADR1       BRANCH IF DEVICE TYPE = 3 OR B
;         BNEL      #PHOENIX,F1,ERR#48B ERROR IF NOT TYPE 'D'

DISKADRA:
        TEST    SL,2
        JZ      FILE_2
        MOV     AL,R1
        AND     AL,0FH
        CMP     AL,3
        JZ      DISKADR1
        CMP     AL,0BH
        JZ      DISKADR1
        CMP     AL,_PHOENIX
        JNZ     ERR_48B

;         TAP       ,E
;         BNEL      0,PL,ERR#48B        ERROR IF TYPE 'D' & PLATTER 'F' OR 'R'

        MOV     EDX,AUX0E
        TEST    DL,0FH
        JNZ     ERR_48B

;DISKADR1 EQU       *
;         BNEHH     40,F0,DISKADR2
;         BNELL     40,F0,DISKADR2
;         BEQL      3,F1,DISKADR2

DISKADR1:
        CMP     R0,40H
        JNZ     DISKADR2
        CMP     AL,3
        JZ      DISKADR2

;ERR#48B  B         ERROR#48  error if device type not 3 for ramdisk
;DISKADR2 MVX       F1F0,PHPL
;         SB        ENBLDEVD  ENABLE DISK
;FILE#2   MVI       0,F0
;FILE#3   SR

ERR_48B:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@enabflg,0
        JMP     ERROR_48
DISKADR2:
        MOV     DX,WORD PTR R0
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@enabflg,1
        jz      file_2
        CALL    ENBLDEVD
FILE_2:
        MOV     R0,0
FILE_3:
        RET

;         TITLE     DTLDBA (DATALOAD BA)
;*     DTLDBA: SCAN & PROCESS A 'DATALOAD BA' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            DATALOAD BA platter [ file#,     ]
;*                                [disk-addr,  ]
;*
;*               (sector-addr [,[variable]]) alpha-array
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'BA'
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*               AUXE (DISK CONTROL REG.) = PLATTER,FILE#
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXE,F IN EXECUTION PHASE ONLY
;*
;         ORG       *
;DTLDBA   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (#n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION
;         SB        ALPHARAY  PROCESS ALPHA ARRAY SPECIFICATION
;         BFL       2,SL,DTLDBA1        BRANCH IF NOT EXECUTION PHASE

DTLDBA:
        CALL    PLATTER
        CALL    DISKSELC
        CALL    SECTOR
        CALL    ALPHARAY
        TEST    SL,2
        JZ      DTLDBA1

;         XPA       ,F        PC'S = SECTOR ADDRESS TO READ; AUXF = ADDRESS TO STORE
;*_     DATA INTO
;         SB        DREAD     READ SECTOR
;         SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;DTLDBA1  B         ENDSDISK  DISABLE DISK, EXIT

        XCHG    EDX,AUX0F
        CALL    DREAD
        CALL    RECSCTR
DTLDBA1:
        JMP     ENDSDISK

;         TITLE     DTSVBA (DATASAVE BA)
;*     DTSVBA: SCAN & PROCESS A 'DATASAVE BA' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            DATASAVE BA  platter [$] [ file#,   ]
;*                                     [disk-addr,]
;*
;*               (sector-addr [,[variable]]) alpha-var.
;*                                           literal
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'BA'
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*               AUXE (DISK CNTRL REG) = PLATTER,FILE#,R/W
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXE,F IN EXECUTION PHASE ONLY
;*
;         ORG       ;*
;DTSVBA   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ-AFTER-WRITE SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (#n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION
;         SB        ALPHA     PROCESS ALPHA VARIABLE OR LITERAL
;         BEQL      0,F0,*+2
;         B         ERROR#29  ERROR IF NOT FOUND
;         BFL       2,SL,DTSVBA1        BRANCH IF NOT EXECUTION PHASE

DTSVBA:
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC
        CALL    SECTOR
        CALL    ALPHA
        TEST    R0,0FH
        JZ      BP40D_01
        JMP     ERROR_29
BP40D_01:
        TEST    SL,2
        JZ      DTSVBA1

;*     DTSVBAVL:  IF DATASAVE BA VALUE IS ON LAST PAGE
;*          OF MEMORY, TRANSFER VALUE TO I/O BUFFER
;*          BEFORE WRITE IN ORDER TO PREVENT PARITY
;*          ERRORS.
;*
;*        This patch causes the value to be padded with hex(00)s if the value is
;*        shorter than 256 bytes.  This is done by copying short values to
;*        the IOBUFFER and padding with zeroes.  The code assumes that IOBUFFER
;*        is on a page boundary -- this is the case.
;DTSVBAVL SB        RIOBUFFR  POINT TO 'IOBUFFER'
;         TPA       ,0        AUX0 = ADDRESS OF I/O BUFFER
;         SB        POPV4     GET LENGTH AND ADDRESS OF ALPHA VALUE
;         BNR       F1,,DTSVBA2         branch if value longer than 256 bytes

DTSVBAVL:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     AUX00,EDX
        MOV     EDI,EDX         ;EDI = I/O BUFFER ADDRESS
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX
        MOV     ESI,EDX         ;ESI = ALPHA VALUE ADDRESS
        CMP     R1,0            ;R0R1 PAIR = ALPHA LENGTH
        JNZ     DTSVBA2

;*----------------- value shorter than 256 bytes -------------------------------
;*        copy value to IOBUFFER
;DTSVBA3  XPA+1,R   ,0        MOVE VALUE TO I/O BUFFER
;         XPA+1,W1  CH,0
;         AI        0FF,F0,F0 decrement count
;         BNR       F0,,DTSVBA3         branch if more bytes in value
;*        fill rest of IOBUFFER with zeroes
;         TAP       ,0
;         OR,W1     +,,       write zero
;         BNR       F0,PL,*-1 branch if more to buffer
;         AI        0FF,PH,PH point to begin of buffer

DTSVBA3:
        MOV     CL,R0
        AND     ECX,0FFH
        MOV     EAX,ECX
        REP     MOVSB
        MOV     ECX,100H
        SUB     ECX,EAX
        MOV     AL,0
        REP     STOSB
        MOV     EDX,AUX00

;DTSVBA2  XPA       ,F        PC'S = SECTOR ADDRESS TO WRITE; AUXF = ADDRESS
;*_     OF DATA TO WRITE
;         SB        DWRITE$   WRITE SECTOR & READ-AFTER-WRITE IF SPECIFIED
;         SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;DTSVBA1  B         ENDSDISK  DISABLE DISK, EXIT

DTSVBA2:
        XCHG    EDX,AUX0F
        CALL    DWRITE?DA
        CALL    RECSCTR
DTSVBA1:
        JMP     ENDSDISK

;         TITLE     DTLDDA (DATALOAD DA)
;*     DTLDDA: PROCESS A 'DATALOAD DA' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               DATALOAD DA platter  [file#,    ]
;*                                    [disk-addr,]
;*
;*                    (sector-addr[,[variable]]) arg-list
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          NOTE: DEVICE TABLE IS NOT MODIFIED BY THIS
;*                STATEMENT (UNLIKE 2200)
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS
;*               AUXE = DISK CONTROL REGISTER
;*               AUXD = EOF ADDRESS (FFFF - DUMMY FOR DA)
;*               AUXC = BUFFER PTR
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXC,D,E,F (EXECUTION PHASE ONLY)
;*
;         ORG       *
;DTLDDA   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (#n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION
;         BFL       2,SL,*+3  BRANCH IF NOT EXECUTION PHASE

DTLDDA:
        CALL    PLATTER
        CALL    DISKSELC
        CALL    SECTOR
        TEST    SL,2
        JZ      BP40D_03

;         SCX,0     F1F0,F1F0,PHPL      PC'S = FFFF
;         TPA       ,D        AUXD = EOF ADDRESS (DUMMY FOR DA STMTS)
;         SB        LOADDATA  PROCESS ARGUMENT LIST
;         BFL       2,SL,DTLDDA1        EXIT IF NOT EXECUTION PHASE

        MOV     EDX,0FFFFH
        MOV     AUX0D,EDX
BP40D_03:
        CALL    LOADDATA
        TEST    SL,2
        JZ      DTLDDA1

;         SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;         SB        ENDDISK   RELEASE DISK
;         B         REMCO     SLIDE OVER REST OF STMT (MAY BE IN MIDDLE IF EOF FOUN
;DTLDDA1  B         ENDSDISK  DISABLE DISK, EXIT

        CALL    RECSCTR
        CALL    ENDDISK
        JMP     REMCO
DTLDDA1:
        JMP     ENDSDISK

;         TITLE     DTSVDA (DATASAVE DA)
;*     DTSVDA: PROCESS A 'DATASAVE DA' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               DATASAVE DA  platter [$] [file#,    ]
;*                                        [disk-addr,]
;*
;*                    (sector-addr[,[variable]]) arg-list
;*                                               END
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          NOTE: DEVICE TABLE IS NOT MODIFIED BY THIS
;*                STATEMENT (UNLIKE 2200)
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS
;*               AUXE = DISK CONTROL REGISTER
;*               AUXD = EOF ADDRESS (FFFF -- DUMMY FOR DA)
;*               AUXC = BUFFER PTR
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXB,C,D,E,F (EXECUTION PHASE ONLY)
;*
;         ORG       *
;DTSVDA   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ-AFTER-WRITE SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (#n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION

DTSVDA:
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC
        CALL    SECTOR

;         BFL       2,SL,*+3  BRANCH IF NOT EXECUTION PHASE
;         SCX,0     F1F0,F1F0,PHPL      PC'S = FFFF
;         TPA       ,D        AUXD = EOF ADDRESS (DUMMY FOR DA STMTS)
;         SB        SAVEDATA  PROCESS ARGUMENT LIST

        TEST    SL,2
        JZ      BP40D_04
        MOV     EDX,0FFFFH
        MOV     AUX0D,EDX
BP40D_04:
        CALL    SAVEDATA

;         BFL       2,SL,*+2  EXIT IF NOT EXECUTION PHASE
;         SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;         B         ENDSDISK  DISABLE DISK, EXIT

        TEST    SL,2
        JZ      BP40D_05
        CALL    RECSCTR
BP40D_05:
        JMP     ENDSDISK

;         TITLE     DREAD DREADB
;*     DREAD: READ ONE SECTOR FROM DISK
;*            (DLOAD1 ON 2200T, 41A4)
;*
;*          DREAD RETRIES (UP TO 16 TIMES) FOR LRC ERRORS.
;*               (IMPLEMENTED 4/12/77 - RELEASE 1.5 VP)
;*
;*          OPTIMIZED READ DATA TRANSFER IMPLEMENTED 12/12/78 -
;*               RELEASE 1.5 MVP
;*
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED.
;*                 AUXF = ADDRESS OF WHERE TO STORE DATA
;*                 PC'S = SECTOR ADDRESS OF SECTOR TO READ
;*                 AUXE,LOW BYTE = PLATTER
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR ACCESSED +1
;*
;*          TRANSFER RATE:
;*
;*               2600 MAX. TRANSFER RATE = 4.8 USEC./CHAR.
;*                                  (1.2MS FOR 256 BYTES)
;*
;*               TYPICAL TRANSFER RATE = 2MS FOR 256 BYTES
;*                    (SINCE IBS FROM DISK IS 8USEC.)
;*
;*               2200 MAX. TRANSFER RATE = 19.8 USEC./CHAR
;*                                   (5.1MS FOR 256 BYTES)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;*    DREADB: READ 256 BYTES OF DATA FROM DISK & CHECK LRC
;*            (DREAD ON 2200T, 41BD)
;*
;*          ENTRY: DISK READY TO SEND DATA (IE, ENABLED,
;*                      ADDRESS BYTES TRANSFERRED AND
;*                      ACKNOWLEDGED)
;*                 AUXF = ADDRESS OF WHERE TO STORE DATA
;*
;*          RETURN: AUXF = PC'S +1
;*
;*          MODIFIED REGISTERS: F0,F1,PC'S,K,AUXF
;*
;*     DREADS0: READ SECTOR 0 FROM DISK INTO I/O BUFFER
;*
;*          ENTRY: DISK ENABLED
;*                 PHASE = EXECUTION
;*                 AUXE,LOW BYTE = PLATTER (AS ABOVE)
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR ACCESSED +1
;*                  AUXC = ADDRESS OF I/O BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-1,K,AUX0,C,F
;*
;*     DREADSF: READ SPECIFIED SECTOR FROM DISK INTO THE
;*              I/O BUFFER
;*
;*          ENTRY: SAME AS 'DREADS0' EXCEPT--
;*                    AUXF = SECTOR ADDRESS OF SECTOR TO
;*                           READ
;*
;*          RETURN: SAME AS 'DREADS0'
;
;*      **** FOR SOLVE PLATTER HOG PROBLEM ****
;*      HOGFLG = 1  (IN CMNDINIT)
;       HOGFLG = 0  (REJECTION)          1 : MUST CHECK DEVICE & PARTITION #
;            .                           0 : CHOSE ANY ONE PARTITION
;            .
;       HOGFLG = 0  (END OF DISKCMND)    THE DISKCMND IS DIVIDED TO TWO PORTIONS
;                                        EACH PORTION IS UNBREAK !!!!
;                                        SO DURING THE SECTION , HOGFLG = 1 TO INSURE
;
;         ORG       *
;DREADS0  ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,F        AUXF = SECTOR ADDRESS (0)

DREADS0:
        MOV     AUX0F,0

;DREADSF  SB        RIOBUFFR  POINT TO I/O BUFFER
;         TPA       ,C        AUXC POINT TO I/O BUFFER
;         XPA       ,F        AUXF POINT TO I/O BUFFER

DREADSF:                     ;EDX  = SECTOR ADDRESS
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     AUX0C,EDX
        XCHG    EDX,AUX0F

;@3.0DA   EQU       *         check for RAMDISK added rel 3.0
;DREAD    TPA       ,0        save sector address
;         TAP       ,ACTDEV
;         BNEH      4,PL,DREADP1
;         BNEL      0,PL,DREADP1
;         B         DREADRAM  branch if RAMdisk address (/340)

@3?PD0DA:
DREAD:
          MOV     AUX00,EDX
          MOV     EDX,ACTDEV
          CMP     DL,40H
          JNZ     DREADP1
          JMP     DREADRAM

;DREADP1  MVI       0,PL
;DREADE   TPS+1     ,         LRC ERROR COUNT ==> STACK
;         SB        CMNDINIT  INITIALIZE DISK CONTROLLER
;         TAP       ,0        GET SECTOR ADDRESS
;         MVI       &READ,F0
;         SB        DISKCMND  SEND READ COMMAND WITH SECTOR ADDRESS TO DISK

DREADP1:
          MOV     DL,0          ;DL = RETRY COUNT
DREADE:
        INC     DX
        PUSH    DX
        CALL    CMNDINIT
        MOV     EDX,AUX00
        MOV     R0,?AMREAD
        CALL    DISKCMND

;         BER       F0,,DREADE1         BRANCH IF NO ECHO ERROR
;         TSP
;         BNEL      0,PL,DREADE         BRANCH IF < 16 RETRIES
;         B         ERROR#94

        CMP     R0,0
        JE      DREADE1
        POP     DX
        TEST    DL,0FH
        JNZ     DREADE
        JMP     ERROR_94

;DREADE1  SB        AKN       GET ACKNOWLEDGEMENT FOR VALID SECTOR ADDRESS
;         SB        OBSDISK   SIGNAL DISK TO CHECK IOB'S TO INSURE NOT TRYING
;*_     TO RESTART. (2200 DOES NOT WAIT FOR READY BEFORE
;*_     STROBE OR DELAY 5 USEC. AFTER)
;         SB        AKN1      WAIT FOR ACKNOWLEDGEMENT FROM DISK

DREADE1:
        CALL    AKN
        TEST    K,08H           ; k =  echo character ( 0Ch indicates access is denied)
        JZ      RETRY_1
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     dreade1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     ax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     dread1ef

dreade1e:
        and     byte ptr [edx],0ffh-devoip
        pop     ax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
dread1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     dreadp1
RETRY_1:
        TEST    K,04H
        JNZ     ERROR_94
        CALL    OBSDISK
        CALL    AKN1

;*      DATA TRANSFER
;DREADB   ANDI      FF-CPB,SH,SH        READY FOR IBS
;         XPA+1     ,F        POINT TO BUFFER
;         XORX      F1F0,F1F0,F1F0      COUNT (F0) & LRC (F1) = 0
;         TPS       ,         SAVE PC'S

DREADB:
        MOV     BYTE PTR FS:[CPURDY],AL
        XCHG    EDX,AUX0F  ;edx= address of i/o buffer
        INC     AUX0F      ;aux0f = sector address + 1
        mov     edi,edx
        MOV     BX,0       ;BH= COUNT , BL=LRC

;DREADB1  MVI       #WAIT,PL  WAIT COUNT
;         BTL       CPB,SH,DREADB2      BRANCH IF IBS REC'D
;         BNR       -,PL,*-1
;         SB        WAITIBSD  WAIT UP TO 15MS FOR IBS (THEN ERR 92)
;

DREADB1:

        MOV     ECX,_WAIT
BP40X_01:
        TEST    BYTE PTR FS:[CPUST],CPB
        JNZ     BP40X_XX
        LOOP    BP40X_01

        CALL    WAITIBSD
        jmp     dreadb2
bp40x_xx:
        mov     al,fs:[ibget]

;DREADB2  TSP       ,         RESTORE BUFFER PTR
;         TPS+1,W1  K         SAVE REC'D CHARACTER IN BUFFER
;         AC,0      F1,K,F1   ADD CHARACTER TO LRC
;         ANDI      FF-CPB,SH,SH        READY FOR IBS

DREADB2:
        stosb
        ADD     BL,AL
        nop     ;just delay for 2280 DISK DRIVE
        nop
        nop
        nop
        nop
        nop
                ;
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
                ;
        MOV     BYTE PTR FS:[CPURDY],AL

;         AC,1      F0,,F0    INCREMENT CHARACTER COUNT
;         BFL       CA,SH,DREADB1       BRANCH IF < 256 CHARACTERS
;         SPACE
;         MVI       #WAIT,PL
;         BTL       CPB,SH,DREADB3      BRANCH IF LRC REC'D
;         BNR       -,PL,*-1
;         SB        WAITIBSD  WAIT UP TO 15MS FOR IBS (THEN ERR 92)

        ADD     BH,1
        JNC     DREADB1

        MOV     ECX,_WAIT
BP40X_03:
        TEST    BYTE PTR FS:[CPUST],CPB
        JNZ     DREADB3_X
        LOOP    BP40X_03
        CALL    WAITIBSD
        jmp     dreadb3
dreadb3_x:
        mov     al,byte ptr fs:[ibget]

;DREADB3  TSP
;         BNR       F1,K,LRCERR         BRANCH IF LRC WRONG
;         TSP
;         SR

DREADB3:
        CMP     BL,al
        JNE     LRCERR
        POP     DX
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        RET

;LRCERR   AI        0FF,PH,PH
;         XPA       ,F        AUXF = ADDRESS TO STORE DATA
;         TPA-1     ,0        AUX0 = SECTOR ADDRESS

LRCERR:
        mov     edx,edi
        SUB     EDX,100H
        XCHG    EDX,AUX0F
        MOV     AUX00,EDX
        DEC     AUX00

;         TSP       ,         GET LRC ERROR COUNT
;         BEQH      0,PL,DREADE         BRANCH IF LRC ERROR COUNT < 16

        POP     DX
        TEST    DL,0F0H
        JZ      DREADE

;ERROR#97 MVI       97,F0     LRC ERROR
;         B         DISKERR

ERROR_97:
        MOV     R0,97H
        JMP     DISKERR

;         TITLE     CMNDINIT CMNDREAD
;*      INITIALIZE DISK CONTROLLER TO RECEIVE A
;*               COMMAND.  (CKENDV ON 2200T, 4600)
;*
;*          INITIALIZATION STROBE DATA INDICATES 2200 TYPE TO
;*          THE DISK (CURRENTLY, ONLY DDDD FLOPPY CARES):
;*               00 -- 2200T
;*               01 -- 2200VP
;*               02 -- 2200MVP
;*
;*        Disk acknowledgement of initialization indicates the
;*        type of drive:
;*               Cx -- Diablo/Floppy
;*               D0 -- Phoenix, DSDD
;*
;*        CMNDINIT translates ACTDEV specification as
;*        follows:
;*
;*          For Diablo/Floppy:
;*               T/D10 ==> /B10
;*               T/D11 ==> /310
;*
;*          For Phoenix:
;*               T/B10 ==> /D10
;*               R/B10,R/310 ==> /D10
;*               T/310 ==> /D11
;*               F/B10,F/310 ==> /D11
;*
;*          Thus, device type in ACTDEV is 'D' iff Phoenix disk
;*
;*          ENTRY: DISK ENABLED
;*
;*          RETURN: K = DISK INITIALIZATION RESPONSE
;*
;*          MODIFIED REGISTERS: PC'S,K,CH,CL,F0
;*
;         ORG       *
;@3.0DB   EQU       *         check for ramdisk added rel 3.0
;CMNDINIT TAP       ,ACTDEV
;         BNEH      4,PL,CMNDINP1
;         BNEL      0,PL,CMNDINP1       branch if not RAMdisk
;         MVI       0CF,K     disk type = CF
;         SR

@3?PD0DB:
CMNDINIT:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        MOV     EDX,ACTDEV
        mov     al,dl
        and     al,0f0h
        cmp     al,40h
        jnz     cmndinp1
        mov     al,dl
        and     al,0fh
        cmp     al,0
        jz      cmndinitx
        jmp     error_90        ;d41 d42 ...
cmndinitx:
        MOV     K,0CFH
        RET

;CMNDINP1 SB        BREAKPTG  PROGRAM LEVEL BREAKPOINT IF 30MS ELAPSED
;*_(2270,2280,2260 PROBABLY NEVER BREAK HERE; DUAL-SIDED DOUBLE
;*_ DENSITY FLOPPY MAY)   [ADDED REL. 1.7]
;         SPACE
;         SB        DELAY10   DELAY 20 USEC. (MUST NOT PERFORM NEXT
;         SB        DELAY10   OPERATION TOO SOON AFTER LAST)
;         B         *+2

CMNDINP1:
        CALL    BREAKPTG
        JMP     BP40Y_01

;CMNDINT3 SB        BREAKPTA  BREAKPOINT IF DISK NOT READY WITHIN 1MS.
;         SB        WAITRDY   WAIT FOR DISK READY (UP TO 1MS.)
;         BFL       8,SH,CMNDINT3       BRANCH IF NOT READY
;         ORI       CPB,SH,SH INHIBIT INPUT (CRB = 1) ??? SHOULD ALREADY BE 1

; Device already is hogged by proc. enbldevd
; when enter break point, must unhog device for other CS sequence to unhog platter
; leaving break point, the device is available so we must hog device
;

CMNDINT3:
        CALL    BREAKPTA
BP40Y_01:
        CALL    WAITRDY
        TEST    BYTE PTR FS:[CPUST],08H
        JZ      CMNDINT3


;         MVI       0A0,K
;         CIO       IOBS      SET IOB'S
;         MVI       02,K      2200 MVP
;         SB        OBSNR     STROBE COMMAND TO DISK
;         SB        WAIT50MS  WAIT UP TO 50MS FOR RESPONSE (IBS) FROM DISK

        MOV     BYTE PTR FS:[IOBS],0A0H
        MOV     AL,CPUID
        SHL     AL,3
        OR      AL,03H
        CALL    OBSNR
        CALL    WAIT50MS

;         BTL       1,SH,ERROR#90       BRANCH IF NO RESPONSE

        JC      ERROR_90
        nop
        nop
        nop
        nop
        MOV     AL,FS:[IBGET]
        MOV     K,AL

;         TAP       ,ACTDEV   PC'S = DEVICE TYPE & ADDRESS
;         BEQH      0C,K,CMNDINT4       BRANCH IF FLOPPY/DIABLO TYPE
;         BNEH      #PHOENIX,K,ERROR#90 ERROR IF NOT DX
;         BEQL      0,K,CMNDINT5        BRANCH IF PHOENIX TYPE

        MOV     EDX,ACTDEV
        CMP     AL,0C0H
        JE      CMNDINT4
        CMP     AL,0D0H
        JE      CMNDINT5
;ERROR#90 MVI       90,F0     DISK HARDWARE ERROR
;         B         DISKERR

ERROR_90:
        MOV     R0,90H
        JMP     DISKERR

;* DIABLO/FLOPPY TYPE DRIVE
;CMNDINT4 EQU       *
;         BEQL      3,PH,CMNDINT6       BRANCH IF DEVICE TYPE = 3 OR B
;         BEQL      0B,PH,CMNDINT6
;         ANDI      0F0,PH,PH
;         ORI       0B,PH,PH  CHANGE DEVICE TYPE FROM 'D' TO 'B' IF ADDR IS X0
;         BEQL      0,PL,CMNDINT2       BRANCH IF ADDRESS IS X0 (REMOVABLE PLATTER
;         ANDI      0F7,PH,PH DEVICE TYPE = '3' IF ADDRESS IS X1 (FIXED )
;         BNEL      1,PL,ERR#48F        DIABLO/FLOPPY HAS ONLY 2 PLATTERS (F,R)
;         ANDI      0FE,PL,PL STRIP PLATTER SPEC. OFF DISK ADDRESS
;CMNDINT2 TPA       ,ACTDEV   STORE TRANSLATED DEVICE TYPE & ADDRESS
;CMNDINT6 SR
;
CMNDINT4:
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,03
        JZ      CMNDINT6
        CMP     AH,0Bh
        JZ      CMNDINT6
        AND     DH,0F0H
        OR      DH,0BH
        TEST    DL,0FH
        JZ      CMNDINT2
        AND     DH,0F7H
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,1
        JNZ     ERR_48F
        AND     DL,0FEH
CMNDINT2:
        MOV     ACTDEV,EDX
CMNDINT6:
        RET

;* PHOENIX TYPE DRICE
;CMNDINT5 EQU       *
;         BEQL      #PHOENIX,PH,CMNDINT6BRANCH IF DEVICE TYPE IS 'D'
;         BNEL      0,PL,ERR#48F        ERROR IF LOW 4-BITS OF ADDRESS NOT 0
;         XPA       ,E
;         MV        PL,F0     F0= PLATTER SPEC. (0=T,1=F,2=R)

CMNDINT5:
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JE      CMNDINT6
        TEST    DL,0FH
        JNZ     ERR_48F

        xchg    edx,aux0e
        mov     r0,dl

;*    ANDI    0F0,PL,PL      PLATTER SPEC = T [DELETED REL 1.7]
;         XPA       ,E
;         BEQL      2,F0,CMNDINT7       BRANCH IF 'R'
;         BEQL      1,F0,CMNDINT8       BRANCH IF 'F'
;         BEQL      0B,PH,*+2 BRANCH IF DEVICE TYPE = 'B'

        xchg    edx,aux0e
        CMP     r0,2
        JZ      CMNDINT7
        CMP     r0,1
        JZ      CMNDINT8
        CMP     AH,0BH
        JZ      CMNDINT7

;CMNDINT8 ORI       1,PL,PL   PLATTER = FIXED
;CMNDINT7 ANDI      0F0,PH,PH
;         ORI       #PHOENIX,PH,PH      DEVICE TYPE = 'D'
;         TPA       ,ACTDEV   SAVE TRANSLATED DEVICE TYPE & ADDRESS
;         SR

CMNDINT8:
        OR      DL,1
CMNDINT7:
        AND     DH,0F0H
        OR      DH,_PHOENIX
        MOV     ACTDEV,EDX
        RET

;ERR#48F  B         ERROR#48  ILLEGAL DEVICE SPECIFICATION

ERR_48F:
        JMP     ERROR_48

CMNDPLAT_1:
        CALL    BREAKPTA
CMNDPLAT:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        MOV     BYTE PTR FS:[IOBS],0A0H
        MOV     AL,CPUID
        SHL     AL,3
        OR      AL,03H
        CALL    OBSNR
        CALL    WAIT50MS
        JC      ERROR_90
        MOV     AL,FS:[IBGET]
        CMP     AL,0D0H
        JE      CMNDPLAT_2
        JMP     ERROR_90
CMNDPLAT_2:
        RET

;
;         TITLE     DISKCMND
;*     DISKCMND: SEND COMMAND, PLATTER, AND SECTOR ADDRESS
;*               TO DISK (SKADR ON 2200T, 41D3)
;*
;*         COMMAND FORMAT (DIABLO/FLOPPY READ, WRITE, COMPARE):
;*                 BYTE1       BYTE2       BYTE3
;*               XX0X XXXX   XXXX XXXX   XXXX XXXX
;*               -- - ----------------------------
;*               !  !         !
;*               !  !         _____ SECTOR ADDRESS (2600
;*               !  !               USES LOW 15 BITS ONLY)
;*               !  !
;*               !  !_____ PLATTER (0 = FIXED, 1 = REMVBL)
;*               !
;*               !________ COMMAND: 00 = READ
;*                                  01 = WRITE
;*                                  10 = COMPARE
;*
;*         COMMAND FORMAT (PHOENIX READ, WRITE, COMPARE):
;*                 BYTE1       BYTE2       BYTE3       BYTE4
;*               XX0X XXXX   XXXX XXXX   XXXX XXXX   XXXX XXXX
;*               -- ------   ---------------------------------
;*               !  !         !
;*               !  !         _____ SECTOR ADDRESS (2600
;*               !  !               USES LOW 16 BITS ONLY)
;*               !  !
;*               !  !_____ PLATTER (10 = REMOVABLE)
;*               !                 (00 = 1ST FIXED)
;*               !                 (01 = 2ND FIXED)
;*               !                  .
;*               !                  .
;*               !                 (0E = 15TH FIXED)
;*               !
;*               !________ COMMAND: 00 = READ
;*                                  01 = WRITE
;*                                  10 = COMPARE
;*
;*         COMMAND FORMAT (PHOENIX EXTENDED COMMANDS):
;*     BYTE1       BYTE2       BYTE3       BYTE4       BYTE5
;*   001X XXXX   XXXX XXXX   XXXX XXXX   XXXX XXXX   XXXX XXXX
;*      ------   ---------   ---------------------------------
;*      !        !            !
;*      !        !            _____ SECTOR ADDRESS (2600
;*      !        !                  USES LOW 16 BITS ONLY)
;*      !        !
;*      !        !_____EXTENDED COMMAND CODE (E.G., COPY)
;*      !
;*      !_________________ PLATTER (10 = REMOVABLE)
;*                                 (00 = 1ST FIXED)
;*                                 (01 = 2ND FIXED)
;*                                  .
;*                                  .
;*                                 (0E = 15TH FIXED)
;*
;*          ENTRY: DISK ENABLED AND INITIALIZED
;*                 PC'S = SECTOR ADDRESS
;*                 F0 = COMMAND:  00 IF READ
;*                                40 IF WRITE
;*                                80 IF COMPARE
;*
;*                                20 IF EXTENDED COMMAND
;*                 F2 = EXTENDED COMMAND CODE (PHOENIX ONLY)
;*
;*                 ACTDEV = DEVICE TYPE & ADDRESS (DEVICE TYPE
;*                          IS 'D' IFF PHOENIX)
;*                 AUXE,LOW BYTE = PLATTER (MUST BE 'T' IF
;*                                 PHOENIX)
;*
;*          RETURN: F0 = 0 IF COMMAND REC'D OK
;*                     <>0 IF ECHO ERROR
;*
;*          NOTE: IF ECHO ERROR OCCURS ON LAST BYTE OF
;*                COMMAND, 2600 MUST WAIT FOR ACK TO BE
;*                RECEIVED FROM DISK PROCESSOR BEFORE
;*                RE-INITIALIZING DISK PROCESSOR.
;*                (THIS IS BUG ON 2200)
;*
;*          MODIFIED REGISTERS: K,F0
;*
;*    DISKCMDA: SEND 3 BYTE SECTOR ADDRESS (HIGH BYTE SET TO 0)
;*
;*          ENTRY: PC'S = LOW 16 BITS OF SECTOR ADDRESS
;*
;*          MODIFIED REGISTERS: F0,K
;*
;         ORG       *
;DISKCMND SB        TRACED    Do TRACE DISK
;         BNR       F0,,SR@5  RETURN IF ECHO ERROR
;         B         DISKCMDB  SEND SECTOR ADDRESS TO DISK

DISKCMND:
        CALL    TRACED
        CMP     R0,0
        JNZ     SR@5
        JMP     DISKCMDB

;* SEND COMMAND TO DISK
;DISKCMDC TPS       ,         SAVE PC'S
;         MVI       40,K
;         CIO       IOBS      SET IOBS

DISKCMDC:
        PUSH    EDX
        MOV     BYTE PTR FS:[IOBS],40H

;         TAP       ,E
;         BEQL      0,PL,DISKCMD3       BRANCH IF DEVICE TYPE 'T'
;         BTL       1,PL,*+2
;DISKCMD1 ORI       10,F0,F0  PLATTER = 0 (FIXED) OR 1 (REMOVABLE)

        MOV     EDX,AUX0E
        TEST    DL,0FH
        JZ      DISKCMD3
        TEST    DL,01
        JNZ     DISKCMD2
DISKCMD1:
        OR      R0,10H

;DISKCMD2 TSP       ,         RESTORE PC';S
;         SB        OBSECHO   SEND COMMAND/PLATTER
;         BNR       F0,,DISKCMD5        EXIT IF ECHO ERROR
;         BFH       &EXTENDH,K,DISKCMD5 BRANCH IF NOT EXTENDED COMMAND

DISKCMD2:
        POP     EDX
        CALL    OBSECHO
        CMP     R0,0
        JNZ     DISKCMD5
        TEST    K,?AMEXTEND
        JZ     DISKCMD5

;         MV        F2,F0
;         B         OBSECHO   SEND 2ND BYTE OF COMMAND

        MOV     AL,R2
        MOV     R0,AL
        JMP     OBSECHO

;DISKCMD3 TAP       ,ACTDEV
;         BEQL      #PHOENIX,PH,DISKCMD4BRANCH IF DEVICE TYPE 'D'
;         BEQL      3,PH,DISKCMD2       BRANCH IF DEVICE TYPE '3'
;         B         DISKCMD1

DISKCMD3:
        MOV     EDX,ACTDEV
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JZ      DISKCMD4
        CMP     AH,3
        JZ      DISKCMD2
        JMP     DISKCMD1

;DISKCMD4 BEQL      0,PL,DISKCMD1       BRANCH IF DEVICE DX0 (REMOVABLE)
;         ANDI      0F,PL,K
;         AI        0FF,K,K   CALCULATE PLATTER#
;         OR        F0,K,F0   D11 ==> 00, D12 ==> 01, ...
;         B         DISKCMD2

DISKCMD4:
        TEST    DL,0FH
        JZ      DISKCMD1
        AND     DL,0FH
        ADD     DL,0FFH
        OR      R0,DL
        JMP     DISKCMD2

;* SEND SECTOR ADDRESS TO DISK
;DISKCMDB XPA       ,ACTDEV
;         MV        PH,K
;         XPA       ,ACTDEV
;         BEQL      #PHOENIX,K,DISKCMDA BRANCH IF DEVICE TYPE 'D'
;         ANDI      7F,PH,F0  STRIP OFF 16TH BIT OF ADDRESS
;         B         DISKCMD6

DISKCMDB:
        mov     eax,actdev
        and     ah,0fh
        cmp     ah,_phoenix
        JZ      DISKCMDA
        MOV     AL,DH
        AND     AL,7FH
        MOV     R0,AL
        JMP     DISKCMD6

;DISKCMDA MVI       0,F0
;         SB        OBSECHO   HIGH BYTE OF ADDRESS = 0
;         BNR       F0,,DISKCMD5        EXIT IF ECHO ERROR
;         MV        PH,F0

DISKCMDA:
        MOV     R0,0
        CALL    OBSECHO
        CMP     R0,0
        JNZ     DISKCMD5
        MOV     R0,DH

;DISKCMD6 SB        OBSECHO   SEND ADDRESS BYTE TO DISK
;         BNR       F0,,DISKCMD5        EXIT IF ECHO ERROR
;         MV        PL,F0
;         SB        OBSECHO   SEND ADDRESS BYTE TO DISK
;         BER       F0,,SR@5  RETURN IF NO ECHO ERROR
;         SB        AKNBPT    WAIT FOR ACKNOWLEDGEMENT FROM DISK (MUST

DISKCMD6:
        CALL    OBSECHO
        CMP     R0,0
        JNZ     DISKCMD5
        MOV     R0,DL
        CALL    OBSECHO
        CMP     R0,0
        JZ      SR@5
        CALL    AKNBPT

;*_   GET BEFORE CAN RE-INITTIALIZE DISK)
;DISKCMD5 B         DELAY10
;         SPACE     3
;SR@5     SR

DISKCMD5:
SR@5:
        RET

;         TITLE     AKN AKN1
;*     AKN: GET ACKNOWLEDGEMENT (IBS) FROM DISK OF
;*          VALID SECTOR ADDRESS (2200T, 4184)
;*
;*          ACKNOWLEDGEMENT CODE:
;*             K      = 0 IF OK
;*             K,BIT0 = 1 IF ERROR#98 (ADDRESSING ERROR)
;*             K,BIT1 = 1 IF ERROR#91 (DISK HARDWARE ERROR
;*             K,BIT2 = 1 IF ERROR#94 (FORMAT KEY ENGAGED)
;*
;*          MODIFIED REGISTERS: K
;*
;*     AKN1: GET ACKNOWLEDGEMENT (IBS) FROM DISK. ON VP,
;*           ERROR IF  NOT RECEIVED WITHIN 5SEC.
;*           HANGS ON MVP.
;*
;*          ACKNOWLEDGEMENT CODE:
;*            K     = 0 IF OK
;*            K,BIT0 = 1 IF ERROR#95 (SEEK ERROR)
;*            K,BIT1 = 1 IF ERROR#93 (DISK FORMAT ERROR)
;*            K,BIT2 = 1 IF ERROR#96 (CRC ERROR)
;*
;*          MODIFIED REGISTERS: K,F0,CH,CL,AUX0
;*
;         ORG       *
;AKN      SB        AKNBPT    WAIT FOR IBS FROM DISK
;         BTL       1,K,ERROR#98
;         BTL       2,K,ERROR#91
;         BTL       4,K,ERROR#94
;         B         DELAY5    DELAY SINCE MUX. HAS COMMON I/O DATA LINES

AKN:
        CALL    AKNBPT
        TEST    K,1
        JNZ     ERROR_98
        TEST    K,2
        JNZ     ERROR_91
;       TEST    K,4
;       JNZ     ERROR_94
        RET

;ERROR#98 MVI       98,F0     SECTOR NOT ON DISK (ADDRESSING ERROR)
;         B         DISKERR
;ERROR#91 MVI       91,F0     DISK HARDWARE ERROR
;         B         DISKERR
;ERROR#94 MVI       94,F0     FORMAT KEY ENGAGED
;         B         DISKERR

ERROR_98:
        MOV     R0,98H
        JMP     DISKERR
ERROR_91:
        MOV     R0,91H
        JMP     DISKERR
ERROR_94:
        MOV     R0,94H
        JMP     DISKERR

;AKN1     SB        AKNBPT    WAIT FOR ACK FROM DISK
;AKN1E    BTL       1,K,ERROR#95
;         BTL       2,K,ERROR#93
;         BTL       4,K,ERROR#96
;         SR

AKN1:
        CALL    AKNBPT
AKN1E:
        TEST    K,1
        JNZ     ERROR_95
        TEST    K,2
        JNZ     ERROR_93
        TEST    K,4
        JNZ     ERROR_96
        RET

;ERROR#93 MVI       93,F0     DISK FORMAT ERROR
;         B         DISKERR
;ERROR#96 MVI       96,F0     CRC ERROR
;         B         DISKERR
;ERROR#95 MVI       95,F0     SEEK ERROR
;         B         DISKERR
;ERR#92   ORI       CPB,SH,SH INHIBIT INPUT
;ERROR#92 MVI       92,F0     DISK HARDWARE ERROR
;         B         DISKERR

ERROR_93:
        MOV     R0,93H
        JMP     DISKERR
ERROR_96:
        MOV     R0,96H
        JMP     DISKERR
ERROR_95:
        MOV     R0,95H
        JMP     DISKERR
ERR_92:
ERROR_92:
        MOV     R0,92H
        JMP     DISKERR

;         TITLE     AKNBPT
;*POTENTIAL PROBLEM:  **************************************
;*
;*     CANNOT CALL OBSTROBE FROM DISK LOGIC SINCE TIMEOUT
;*     (BREAKPOINT) MAY OCCUR.  BREAKPOINT RETURN DOES NOT
;*     RESTORE IOB'S.
;         SPACE     3
;*AKNBPT: GET ACKNOWLEDGEMENT (IBS) FROM DISK. IF AKN NOT
;*          RECEIVED WITHIN 250 USEC., BREAKPOINT; BREAKPOINT
;*          RETURN WHEN DISK IS READY.
;*
;*     NOTE: CURRENTLY, NO 5 SEC. TIMEOUT HAS BEEN IMPLEMENTED
;*          -- IE, HANG UNTIL AKN RECEIVED. CERTAIN AKN'S
;*          SHOULD GENERATE AN ERROR IF NOT RECEIVED WITHIN
;*          5 SECONDS.
;*
;*     MODIFIED REGISTERS: K
;*
;*     EQUATES:
;*
;#DISKTO  EQU       0078      DISK AKN TIMEOUT VALUE (250 USEC.)

_DISKTO         EQU    020000h      ;(250 USEC)

;AKNBPT   EQU       *
;* SWITCH DISK CONTROLLER TO BUFFERED MODE
;         SB        DELAY5    DELAY TO BE SURE DISK SETS RB PROPERLY. BLAH!
;*  CHANGED TO DELAY5 TO MAKE SURE DISK DOESN'T!!!!
;*         DOUBLE BLAH !!!!!!    FIX DISK GLITCH IS HITCH
;* WAIT FOR AKN FROM DISK, TIMEOUT AFTER 250 USEC.
;         TPS       ,         SAVE PC'S

AKNBPT:
        PUSH    ECX

;         LPI       #DISKTO   TIMEOUT VALUE
;AKNBPT1  BTL       8,SH,AKNBPT2        BRANCH IF DISK READY (AKN REC'D)
;         OR        -,,       DECREMENT TIMEOUT VALUE
;         BLRX      DD,PHPL,AKNBPT1     LOOP FOR 250 USEC.
;* BREAKPOINT -- AKN TIMEOUT
;         SB        BREAKPTA  BREAKPOINT, SAVE ALL REG'S & 10 STACK LEVELS

        MOV     ECX,0FFFFFH
AKNBPT1:
        TEST    BYTE PTR FS:[CPUST],8H
        JNZ     AKNBPT2
        LOOP    AKNBPT1

        CALL    BREAKPTA

;* RECEIVE AKN
;AKNBPT2  MVI       40,K
;         CIO       IOBS      RESET IOB'S

AKNBPT2:
        MOV     BYTE PTR FS:[IOBS],40H

;         ANDI      EF-CPB,SH,SH        ALLOW INPUT
;         MVI       #WAIT,PL
;         BTL       CPB,SH,AKNBPT3
;         BNR       -,PL,*-1  WAIT UP TO .3MS FOR IBS
;         SB        WAITIBSD  ERROR IF NOT REC'D AFTER 15MS.

        NOP
        NOP
        NOP
        NOP

        MOV     FS:[CPURDY],AL
        MOV     ECX,_WAIT

        NOP
        NOP

BP40Z_01:
        TEST    BYTE PTR FS:[CPUST],02H
        JNZ     AKNBPT3_X
        LOOP    BP40Z_01

        CALL    WAITIBSD
        jmp     aknbpt3
aknbpt3_x:
        nop
        nop
        mov     al,fs:[ibget]

;AKNBPT3  TSP       ,         RESTORE PC'S
;         SR

AKNBPT3:
;       nop     ;just for delay
;       nop
;       nop
;       MOV     AL,FS:[IBGET]
        MOV     K,AL
        POP     ECX
        RET

;         TITLE     WAIT50MS
;*     WAIT50MS: WAITS UP TO 50MS FOR AN IBS STROBE
;*               (CRB = 1).   (WAIT50 ON 2200T, 4100)
;*
;*          RETURN: CARRY 0FF IF IBS RECEIVED
;*                  CARRY ON IF IBS NOT RECEIVED
;*                  CRB = 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K
;*
;WAIT50MS LPI,R     #50MS     GET 50MS COUNT
;         MVX       CHCL,PHPL PC'S = 50MS COUNT
;         ANDI      EF-CPB-CA,SH,SH     ALLOW INPUT, CARRY OFF
;         SPACE
;         BTL       2,SH,WAIT50M1       BRANCH IF IBS RECEIVED
;         ACX,1     DD,PHPL,PHPL        INCREMENT COUNT
;         BFL       1,SH,*-2  BRANCH IF < 50MS ELAPSED
;         SPACE
;         ORI       CPB,SH,SH INHIBIT INPUT
;WAIT50M1 SR

WAIT50MS:
        MOV     EDX,_50MS
        MOV     FS:[CPURDY],AL
BP40Z_02:
        TEST    BYTE PTR FS:[CPUST],02H  ;cpu busy in d1 bit of cpust port
        JNZ     WAIT50M1
        DEC     EDX
        JNZ     BP40Z_02        ; carry off if ibs received
        STC
        RET
WAIT50M1:
        CLC
        RET

;         TITLE     OBSECHO
;*     OBSECHO: STROBES (OBS) THE CONTENTS OF F0
;*             AND CHECKS ECHO (IBS)  (STRC ON 2200T,41E8)
;*
;*          ENTRY: F0 = CHARACTER TO STROBE
;*
;*          RETURN: F0 = 0 IF ECHO = CHARACTER
;*                    <> 0 IF ECHO INCORRECT CHARACTER
;*                  K = CHARACTER ECHOED
;*
;*          MODIFIED REGISTERS: K,F0
;*
;OBSECHO  ORI       CPB,SH,SH INHIBIT INPUT ??? SHOULD ALREADY BE 1 ??
;         MV        F0,K      K = CHARACTER TO STROBE
;         SB        OBSDISK   STROBE CHARACTER (OBS)
;         SB        WAITIBS   WAIT FOR ECHO

OBSECHO:
        MOV     AL,R0
        MOV     K,AL
        CALL    OBSDISK
;       CALL    WAITIBS
;for not alter m05.asm

        PUSH    EDX
        MOV     BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
        MOV     EDX,07500H              ;03A98H = 15000 US. = 15 MS.
xWAITIBS1:
        TEST    BYTE PTR FS:[CPUST],2
        JNZ     xWAITIBS1A
        DEC     EDX
        JNZ     xWAITIBS1
        JMP     xWAITIBS2
xWAITIBS1A:
        MOV     AL,FS:[IBGET]
        MOV     K,AL
xWAITIBS2:
        POP     EDX


;         BFL       2,SH,ERR#92         ERROR IF ECHO NOT RECEIVED WITHIN 8MS. (15MS)
;         XOR       F0,K,F0   F0 = 0 IFF ECHO = CHARACTER STROBED
;         B         DELAY10   DELAY SINCE MUX. HAS COMMON I/O DATA LINES

        TEST    BYTE PTR FS:[CPUST],CPB
        JZ      ERR_92
        MOV     AL,K
        XOR     R0,AL
        nop
        RET

;         TITLE     OBSDISK
;*OBSDISK: SAME AS 'OBSTROBD' EXCEPT IOB'S RESTORED TO HEX(40)
;*         IF BREAKPOINT OCCURS.   OUTPUTS K WITH AN OBS.
;*
;*     MODIFIED REGISTERS: K
;*
;OBSDISK  BTL       8,SH,OBSDISK1       BRANCH IF READY
;         TPS       ,         SAVE PC'S
;         SB        WAITRDYB  WAIT UP TO 1MS FOR READY; IF NOT, BREAKPOINT
;         MV        K,PL      SAVE K
;         MVI       40,K
;         CIO       IOBS      RESET IOB'S TO HEX(40)
;         MV        PL,K      RESTORE K
;         TSP       ,         RESTORE PC'S

OBSDISK:
        TEST    BYTE PTR FS:[CPUST],08H
        JNZ     OBSDISK1
        PUSH    EDX
        CALL    WAITRDYB
        MOV     BYTE PTR FS:[IOBS],40H
        POP     EDX

;@3.0OBD  EQU       *
;OBSDISK1 SB        DELAY5    delay 5 usec.
;         SBR       OBSNR     strobe character

@3?PD0OBD:
OBSDISK1:
        MOV     AL,K
        call    delay5
        JMP     OBSNR
;         TITLE     WAITIBSD
;*WAITIBSD: WAIT UP TO 15MS FOR IBS -- ERROR 92 IF NOT REC'D
;*
;*     ENTRY: CPB = READY
;*
;*     RETURN: K = CHARACTER REC'D
;*
;*     MODIFIED REGISTERS: PC'S,K
;*
;WAITIBSD LPI       1CA8      15MS COUNT
;WAITIBD1 BTL       CPB,SH,WAITIBD2     BRANCH IF IBS REC'D
;         OR        -,,       DECREMENT COUNT
;         BLRX      DD,PHPL,WAITIBD1    BRANCH IF TIME NOT ELAPSED
;         B         ERR#92    ERROR IF NOT REC'D WITHIN 15MS
;WAITIBD2 SR

WAITIBSD:
        PUSH    EDX
        MOV     EDX,1000000H
WAITIBD1:
        TEST    BYTE PTR FS:[CPUST],02H ;6
        JNZ     WAITIBD2                ;7
        DEC     EDX                     ;2
        JNZ     WAITIBD1                ;7
        JMP     ERR_92                  ;
WAITIBD2:
        MOV     AL,FS:[IBGET]
        MOV     K,AL
        POP     EDX
        RET

;         TITLE     LOADDATA
;*     LOADDATA: PROCESS A DATALOAD ARGUMENT-LIST.
;*
;*               (PRESENT LOGIC HANDLES ONLY LOAD FROM
;*                DISK; FOR OTHER RECORD FORMATTED DEVICES
;*                WITH SAME FORMAT CONVENTIONS, PATCH INTO
;*                'LOADBLK' AT 'B ERROR#47')
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                    (BEGIN OF ARGUMENT LIST)
;*
;*          RETURN: TEXTPTR POINTS AFTER ARGUMENT-LIST.
;*                  IN EXECUTION PHASE,
;*                     AUXF = SECTOR ADDRESS OF LAST
;*                            SECTOR ACCESSED +1  (EXCEPT
;*                            IF EOF WAS ENCOUNTERED, =
;*                            ADDR OF EOF )
;*                     CH,CL = 1ST 2 BYTES OF LAST BLOCK
;*                             READ
;*                     IF EOF ENCOUNTERED, EOF FLAG SET
;*
;*          REGISTER USE:
;*               AUXF = CURRENT SECTOR ADDRESS
;*               AUXE (DISK CONTROL REG.) = PLATTER
;*               AUXD = EOF SECTOR ADDRESS
;*                      (FFFF FOR DA STATEMENTS)
;*               AUXC = PTR TO READ BUFFER
;*               AUX2,HIGH BYTE = LENGTH OF RECEIVER VAR.
;*                   ,LOW  BYTE = TYPE OF RECEIVER
;*                               (80 = ALPHA, 0 = NUMERIC)
;*               AUX1 = ADDRESS OF RECEIVER VARIABLE
;*               F7,6 = NO. OF ELEMENTS IN RECEIVER
;*                      (1 IF SCALAR VARIABLE)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXC,F (EXECUTION PHASE ONLY)
;*
;*          ARGUMENT-LIST:
;*               THE ARGUMENT-LIST CONSISTS OF ALPHA OR
;*               NUMERIC VARIABLES. ALPHA ARRAYS (EG A$())
;*               ARE LOADED ELEMENT BY ELEMENT (IE, THE
;*               ARRAY IS NOT TREATED AS A SINGLE CHARACTR
;*               STRING, BUT RATHER AS A SET OF SEPARATE
;*               ELEMENTS.  HOWEVER, THE STR(apha-array)
;*               IS TREATED AS A SINGLE CHARACTER STRING--
;*               IT RECEIVES ONLY 1 VALUE.
;*
;*               VALUES FOR ALPHA-VARIABLES ARE PADDED
;*               WITH SPACES (HEX20) OR TRUNCATED AS
;*               REQUIRED.
;*
;*               NUMERIC DATA CANNOT BE LOADED INTO ALPHA
;*               VARIABLES, & VICE-VERSA. IF ATTEMPTED,
;*               ERR 87 RESULTS.
;*
;        EJECT
;*          NOTE: NO VALIDITY CHECK IS MADE ON NUMERIC
;*                DATA. VALUE IS TRANSFERED BYTE BY BYTE.
;*
;*     DATA RECORD FORMATS:
;*
;*              DATA RECORD          TRAILER RECORD
;*          -------------------    -------------------
;*          !  SOB (X'8-')    !    !  SOB (X'A-')    !
;*          -------------------    -------------------
;*          !  PRN            !    !                 !
;*          -------------------    !   -not used-    !
;*          !  SOV            !    !                 !
;*          -------------------    !                 !
;*          !  1ST DATA VALUE !    -------------------
;*          -------------------
;*          !  SOV            !
;*          -------------------
;*          !  2ND DATA VALUE !
;*          -------------------
;*          !     .           !
;*          !     .           !
;*          !     .           !
;*          -------------------
;*          !  SOV            !
;*          -------------------
;*          ! LAST DATA VALUE !
;*          -------------------
;*          !  EOB (X'FD')    !
;*          -------------------
;*          !  -not used-     !
;*          -------------------
;*
;*     SOB (X'8-'): BIT0 = 1 IFF LAST BLOCK OF LOGICAL REC
;*                  BIT1 = 1 IFF INTERMEDIATE BLOCK OF
;*                         LOGICAL RECORD
;*
;*     PRN: BLOCK NO. WITHIN LOGICAL RECORD (1,2,...)
;*
;*     SOV: BIT0-7 = LENGTH OF DATA VALUE
;*                  (LENGTH OF NUMERIC == 8)
;*          BIT 8 = 0 IF NUMERIC, 1 IF ALPHA
;*
;         ORG       *
;LOADDATA BFL       2,SL,LOADDT1        BRANCH IF NOT EXECUTION PHASE
;         TAP       ,MODE
;         ANDI      7F,PL,PL  EOF OFF
;         TPA       ,MODE

;**** PRN MEANS # OF DATA RECORD IN LOGICAL RECORD
;**** ONE LOGIICAL RECORD = MANY DATA RECORDS
;**** ONE SECTOR = ONE DATA RECORD = ONE BLOCK (SOB ---- EOB)
LOADDATA:
        TEST    SL,2
        JZ      LOADDT1
        AND     MODE,0FFFFFF7FH

;LOADDT3  SB        LOADDBLK  READ DATA BLOCK FROM DISK
;         BTH       2,CH,LOADDT2        BRANCH IF EOF
;         BNEH      0,CL,LOADDT3        BRANCH IF NOT 1ST BLOCK OF LOGICAL RECORD
;         BNEL      1,CL,LOADDT3
;         SB        HPION     HIGH PRIORITY I/O ON

LOADDT3:
        CALL    LOADDBLK
        TEST    CH,20H
        JNZ     LOADDT2
        CMP     CL,01H
        JNZ     LOADDT3
        CALL    HPION

;LOADDT1  SB        ARGUMNTR  LOK FOR ARRAY OR VARIABLE
;         BFL       2,SL,LOADDT7        BRANCH IF NOT EXECUTION PHASE

LOADDT1:
        CALL    ARGUMNTR
        TEST    SL,2
        JZ      LOADDT7

;LOADDT9  TAP       ,C
;         TPA+1,R   ,C        GET NEXT CHARACTER FROM DATA BLOCK
;         BNEH      F,CH,LOADDT10
;         BNEL      D,CH,LOADDT10       BRANCH IF NOT EOB

LOADDT9:
        MOV     EDX,AUX0C
        MOV     CH,[EDX]
        INC     AUX0C
        CMP     CH,0FDH
        JNZ     LOADDT10

;         SB        LOADDBLK  READ NEXT BLOCK
;         BFH       2,CH,LOADDT9        BRANCH IF NOT EOF
;         B         LOADDT2

        CALL     LOADDBLK
        TEST    CH,20H
        JZ      LOADDT9
        JMP     LOADDT2

;LOADDT10 TAP       ,2        GET TYPE OF RECEIVER VARIABLE
;         XOR       CH,PL,F0
;         BTH       8,F0,ERR#74A        ERROR IF TYPE OF RECEIVER <> TYPE OF DATA
;         BTH       8,CH,*+2
;         BNR       CH,PH,ERR#74A       IF NUMERIC, LENGTH OF DATA MUST BE 8
;         ANDI      7F,CH,F0

LOADDT10:
        MOV     EDX,AUX02
        MOV     AL,DL
        XOR     AL,CH
        MOV     R0,AL
        TEST    R0,80H
        JNZ     ERR_74A
        TEST    CH,80H
        JNZ     BP40E_01
        CMP     CH,DH
        JNZ     ERR_74A
BP40E_01:
        MOV     AL,CH
        AND     AL,7FH
        MOV     R0,AL

;         MVI       0,F1      F1,0 = LENGTH OF VALUE
;         MVI       0,F3
;         MV        PH,F2     F3,2 = LENGTH OF RECEIVER VARIABLE
;         TAP       ,1

        MOV     R1,0
        MOV     R3,0
        MOV     R2,DH
        MOV     EDX,AUX01

;         ACX,0     F3F2,PHPL,PHPL
;         XPA       ,1        AUX1 = ADDRESS OF NEXT RECEIVER
;         TPA       ,0        AUX0 = ADDRESS OF RECEIVER VARIABLE
;         TAP       ,C        PC'S = ADDRESS OF VALUE

        MOV     AX,WORD PTR R2
        AND     EAX,0FFFFH
        ADD     EDX,EAX
        XCHG    EDX,AUX01
        MOV     AUX00,EDX
        MOV     EDX,AUX0C

;         ACX,0     F1F0,PHPL,PHPL
;         XPA       ,C        AUXC POINT AFTER VALUE
;         SB        ARECEVAL  RECEIVER = VALUE

        MOV     AX,WORD PTR R0
        AND     EAX,0FFFFH
        ADD     EDX,EAX
        XCHG    EDX,AUX0C

        CMP     BYTE PTR AUX02,0; AUX02 LOW BYTE = 0 ---> NUMERIC DATA
        JNZ     BP40E_50

        PUSH    AUX01           ; ADDRESS OF NEXT RECEIVER
        PUSH    EDX             ; ADDRESS OF VALUE

        MOV     EDI,OFFSET SCRATCH
        MOV     ESI,EDX
        MOV     ECX,8
;       CLD
        REP     MOVSB

        CALL    OLDTONEW

        MOV     ESI,EDX
        POP     EDX
        MOV     EDI,EDX
        MOV     ECX,8
;       CLD
        REP     MOVSB

        POP    AUX01           ; PLATTER

BP40E_50:
        CALL    ARECEVAL

;         SC,,0     F6,,F6
;         SC        F7,,F7    DECREMENT NO. OF ELEMENTS COUNT
;         BLRX      DD,F7F6,LOADDT9     BRANCH IF MORE ELEMENTS IN RECEIVER

        DEC     WORD PTR R6
        JNZ     LOADDT9

;LOADDT7  SB        NXTCHCOM  LOOK FOR COMMA
;         BEQL      0,F0,LOADDT1        F, BRANCH TO GET NEXT RECEIVER
;         BFL       2,SL,LOADDT11       BRANCH IF NOT EXECUTION PHASE
;         SB        RIOBUFFR  POINT TO BEGIN OF BLOCK READ; CH = CONTROL BYTE

LOADDT7:
        cmp     byte ptr [textptr],','
        jnz     bp40e_99
        inc     textptr
        jmp     loaddt1
bp40e_99:
        TEST    SL,2
        JZ      LOADDT11
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     cx,[edx]
        xchg    ch,cl

;         BTL       1,CH,LOADDT11       EXIT IF LAST BLOCK OF LOGICAL RECORD
;         SB        LOADDBLK  READ NEXT SECTOR
;         BFH       2,CH,*-2  BRANCH IF NOT EOF

BP40E_02:
        TEST    CH,1
        JNZ     LOADDT11
        CALL    LOADDBLK
        TEST    CH,20H
        JZ      BP40E_02

;LOADDT2  TAP       ,MODE
;         ORI       80,PL,PL  SET EOF FLAG
;         TPA       ,MODE
;         TAP       ,F
;         TPA-1     ,F        DECREMENT SECTOR ADDRESS (SO NEXT READ WILL AGAIN
;*_     READ EOF)
;LOADDT11 SR
;ERR#74A  B         ERROR#74  WRONG VARIABLE TYPE

LOADDT2:
        OR      MODE,080H
        MOV     EDX,AUX0F
        DEC     AUX0F
LOADDT11:
        RET
ERR_74A:
        JMP     ERROR_74


;         TITLE     LOADDBLK
;*     LOADDBLK: READ A DATA BLOCK OR DATA EOF BLOCK FROM
;*              DISK INTO THE I/O BUFFER.  IF A DATA
;*              BLOCK IS NOT FOUND, AN ERROR RESULTS.
;*
;*          ERROR CONDITIONS:
;*               47 = DEVICE NOT DISK
;*               88 = SECTOR NOT A DATA OR DATA EOF BLOCK
;*               89 = SECTOR ADDR > EOF ADDRESS
;*               90-99 = DISK I/O ERRORS
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED
;*                 DEVICE TYPE = 3 OR B
;*                               (IF NOT, ERROR#47. IF
;*                                LOGIC IS TO BE USED TO
;*                                CONTROL OTHER DEVICES,
;*                                PATCH IN AT 'B ERROR#47'
;*                 AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*                 AUXE (DISK CONTROL REGISTER) = PLATTER
;*                AUXD = EOF SECTOR ADDRESS (CANNOT READ
;*                       BEYOND EOF
;*
;*          RETURN: BLOCK READ IN I/O BUFFER
;*                  CH,CL = 1ST 2 BYTES OF BLOCK READ
;*                  AUXF = ADDRESS OF SECTOR ACCESSED
;*                  AUXC POINTS TO 3RD BYTE OF BLOCK READ
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,K
;*                              AUX0,C,F
;*
;         ORG       *
;LOADDBLK SB        LOADBLK   LOAD BLOCK FROM DISK
;         TPA+2     ,C        AUXC = ADDRESS OF 3RD BYTE OF BUFFER
;         BEQH      8,CH,*+2
;         BNEH      A,CH,ERROR#88       ERROR IF NOT DATA BLOCK OR DATA EOF BLOCK
;         SR

LOADDBLK:
        CALL    LOADBLK
        MOV     AUX0C,EDX
        ADD     AUX0C,2
        MOV     AL,CH           ;CH = 81 OR 82H   --- MEAN DATA RECORD
        AND     AL,0F0H         ;           A0H   --- MEAN TRAILER RECORD
        CMP     AL,80H
        JZ      BP40E_03
        CMP     AL,0A0H
        JNZ     ERROR_88
BP40E_03:
        RET

;ERROR#88 MVI       88,F0     WRONG RECORD TYPE
;         B         ERROR

ERROR_88:
        MOV     R0,88H
        JMP     ERROR

;         TITLE     LOADBLK LOADLBLK
;*     LOADBLK: READ A BLOCK FROM DISK INTO THE I/O BUFFER
;*
;*          ERROR CONDITIONS:
;*               47 = DEVICE TYPE NOT DISK (3 OR B)
;*               89 = SECTOR ADDRESS > EOF (AUXD)
;*               90-99 = DISK I/O ERROR
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED
;*                 ACTDEV = DEVICE TYPE & ADDRESS
;*                 DEVICE TYPE = 3 OR B
;*                               (IF NOT, ERROR#47. IF
;*                                LOGIC IS TO BE USED TO
;*                                CONTROL OTHER DEVICES,
;*                                PATCH IN AT 'B ERROR#47'
;*                 TEXTEND POINTS TO END OF TEXT
;*                 AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*                 AUXE (DISK CONTROL REG.) = PLATTER
;*                AUXD = EOF SECTOR ADDRESS (CANNOT READ
;*                       BEYOND EOF
;*
;*          RETURN: BLOCK READ IN READ-BUFFER
;*                  CH,CL = 1ST 2 BYTES OF BLOCK READ
;*                  AUXF = ADDRESS OF SECTOR ACCESSED +1
;*                  PC'S POINT TO I/O BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,K
;*                              AUX0,F
;*
;*     LOADLBLK: SAME AS 'LOADBLK' EXCEPT DEVICE TYPE &
;*               ADDRESS ARE IN 'DEVLOAD' RATHER THAN IN
;*               'ACTDEV' AT ENTRY
;*
;         ORG       *
;LOADLBLK SB        RDEVLOAD  GET LOAD DEVICE ADDRESS
;         MVX       CHCL,PHPL PC'S = DEVICE TYPE & ADDRESS
;         SB        ENBLDEVD  ENABLE LOAD DISK

LOADLBLK:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVLOAD
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     DX,CX
        CALL    ENBLDEVD

;LOADBLK  TAP       ,ACTDEV   GET DEVICE TYPE & ADDRESS
;         BEQL      #PHOENIX,PH,LOADBLK1
;         BEQL      3,PH,LOADBLK1
;         BNEL      0B,PH,ERR#48G       BRANCH IF NOT DISK (3 OR B OR D)

LOADBLK:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      LOADBLK1
        CMP     DH,3
        JZ      LOADBLK1
        CMP     DH,0BH
        JNZ     ERR_48G

;LOADBLK1 TAP       ,D
;         MVX       PHPL,F1F0 F1,0 = EOF SECTOR ADDRESS
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         XPA       ,F        AUXF = ADDRESS OF READ BUFFER; PC'S = READ SECTOR ADDR

LOADBLK1:
        MOV     EDX,AUX0D
        MOV     WORD PTR R0,DX
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        XCHG    EDX,AUX0F

;         BLRX      F1F0,PHPL,ERROR#89  ERROR IF SECTOR ADDRESS > EOF SECTOR
;         SB        DREAD     READ NEXT SECTOR FROM DISK
;         B         RIOBUFFR  GET CONTROL BYTE OF BLOCK READ

        CMP     WORD PTR R0,DX
        JB      ERROR_89
        CALL    DREAD
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        RET

;ERROR#89 MVI       89,F0     SECTOR ADDRESS > END ADDRESS
;         B         ERROR
;ERR#48G  B         ERROR#48  ILLEGAL DEVICE SPECIFICATION

ERROR_89:
        MOV     R0,89H
        JMP     ERROR
ERR_48G:
        JMP     ERROR_48

;         TITLE     SAVEDATA
;*     SAVEDATA: PROCESS A DATASAVE ARGUMENT-LIST.
;*
;*               (PRESENT LOGIC HANDLES ONLY SAVE TO
;*                DISK; FOR OTHER RECORD FORMATTED DEVICES
;*                WITH SAME FORMAT CONVENTIONS, PATCH INTO
;*                'SAVEDBLK' AT 'B ERROR#47')
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                    (BEGIN OF ARGUMENT LIST)
;*
;*          RETURN: TEXTPTR POINTS AFTER ARGUMENT-LIST.
;*                  IN EXECUTION PHASE,
;*                     AUXF = SECTOR ADDRESS OF LAST
;*                            SECTOR ACCESSED +1
;*                     AUXC = ADDRESS OF I/O BUFFER
;*                     I/O BUFFER CONTAINS THE LAST BLOCK
;*                         WRITTEN
;*
;*          REGISTER USE:
;*               AUXF = CURRENT SECTOR ADDRESS
;*               AUXE (DISK CNTRL REG)= PLATTER,R/W
;*               AUXD = EOF SECTOR ADDRESS
;*                      (FFFF FOR DA STATEMENTS)
;*               AUXC = PTR TO I/O BUFFER
;*               AUX2,HIGH BYTE = SOV (FOR ARRAYS)
;*                   ,LOW  BYTE = LENGTH (ARRAYS)
;*               AUX3 = ADDRESS OF VALUE
;*               F7,6 = NO. OF ELEMENTS IN ARRAY
;*                      (1 IF SCALAR VARIABLE)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUX3,B,C,F (EXECUTION PHASE ONLY)
;*
;*          ARGUMENT-LIST:
;*               THE ARGUMENT-LIST CONSISTS OF ALPHA
;*               VARIABLES, LITERALS, EXPRESSIONS
;*               AND ARRAYS.  ALPHA ARRAYS (EG A$())
;*               ARE SAVED ELEMENT BY ELEMENT (IE, THE
;*               ARRAY IS NOT TREATED AS A SINGLE CHARACTR
;*               STRING, BUT RATHER AS A SET OF SEPARATE
;*               ELEMENTS.  HOWEVER, THE STR(apha-array)
;*               IS TREATED AS A SINGLE CHARACTER STRING--
;*               IT SAVES ONLY 1 VALUE.
;*
;*               VALUES FOR ALPHA-VARIABLES ARE SAVED
;*               WITH TRAILING SPACES (THE DEFINED LENGTH
;*               IS USED).
;*
;         EJECT
;*     DATA RECORD FORMATS:
;*
;*              DATA RECORD          TRAILER RECORD
;*          -------------------    -------------------
;*          !  SOB (81 OR 82) !    !  SOB (X'A0')    !
;*          -------------------    -------------------
;*          !  PRN            !    !                 !
;*          -------------------    !   -not used-    !
;*          !  SOV            !    !                 !
;*          -------------------    !                 !
;*          !  1ST DATA VALUE !    -------------------
;*          -------------------
;*          !  SOV            !
;*          -------------------
;*          !  2ND DATA VALUE !
;*          -------------------
;*          !     .           !
;*          !     .           !
;*          !     .           !
;*          -------------------
;*          !  SOV            !
;*          -------------------
;*          ! LAST DATA VALUE !
;*          -------------------
;*          !  EOB (X'FD')    !
;*          -------------------
;*          !  -not used-     !
;*          -------------------
;*
;*     SOB = X'81' IFF LAST BLOCK OF LOGICAL RECORD
;*           X'82' IFF INTERMEDIATE BLOCK OF
;*                         LOGICAL RECORD
;*
;*     PRN: BLOCK NO. WITHIN LOGICAL RECORD (1,2,...)
;*
;*     SOV: BIT0-7 = LENGTH OF DATA VALUE
;*                   (LENGTH OF NUMERIC == 8)
;*          BIT 8 = 0 IF NUMERIC, 1 IF ALPHA
;*
;         EJECT
;         ORG       *
;SAVEDATA MVI       @END,F0
;         SB        CCL       LOOK FOR 'END'
;         BNEL      0,F0,SAVEDT1        BRANCH IF NF
;         SPACE

SAVEDATA:
        MOV     R0,@END
        CALL    CCL
        TEST    R0,0FH
        JNZ     SAVEDT1

;*     RECORD DATA TRAILER RECORD (E0F)
;*
;         BFL       2,SL,SAVEDT2        BRANCH IF NOT EXECUTION PHASE
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         ORI,W1    0A0,,     CONTROL BYTE (DATA,TRAILER) --> BUFFER
;         B         SAVEDBLK  WRITE DATA TRAILER BLOCK
;SAVEDT2  SR

        TEST    SL,2
        JZ      SAVEDT2
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        MOV     BYTE PTR [EDX],0A0H
        JMP     SAVEDBLK
SAVEDT2:
        RET

;SAVEDT1  BFL       2,SL,SAVEDT6        BRANCH IF NOT EXECUTION PHASE
;         SB        MSWRTBEG  BEGIN OF MULTI-SECTOR WRITE
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         ORI,W1    82,,      CONTROL BYTE (DATA,INTERMEDIATE) --> BUFFER
;         ORI,W2    1,,       PHYSICAL RECORD NO. (1) --> BUFFER

SAVEDT1:
        TEST    SL,2
        JZ      SAVEDT6
        CALL    MSWRTBEG
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        MOV     BYTE PTR [EDX],082H
        MOV     BYTE PTR [EDX+1],1

;         TPA+2     ,C        INCREMENT BUFFER PTR
;         LPI       2
;         TPA       ,B        BUFFER COUNT = 2

        MOV     AUX0C,EDX
        ADD     AUX0C,2
        MOV     AUX0B,2

;SAVEDT6  SB        ARGUMENT  LOOK FOR ARGUMENT (EXPR,VAR,LITERAL,ARRAY)
;         BFL       2,SL,SAVEDT4        BRANCH IF NOT EXECUTION PHASE

SAVEDT6:
        CALL    ARGUMENT

;      ARGUMENT: SCAN & PROCESS AN ARGUMENT (OF
;                DATALOAD TYPE). EACH ELEMENT OF ALPHA-
;                ARRAY IS A SEPARATE RECEIVER.
;
;           FORMAT:  array-name
;                    alpha-variable
;                    expression
;                    literal
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;=======>   RETURN: TEXTPTR POINTS AFTER ARGUMENT
;             IN EXECUTION PHASE,
;                F7,6 = NO. OF ELEMENTS (1 IF SCALAR)
;                AUX3 = ADDRESS OF VALUE
;                AUX2,BITSFF00 = SOV
;                    ,BITS8000 = TYPE (1 ALPHA, 0 IF NUM)
;                    ,BITS7F00 = LENGTH (<125)
;                    ,BITS00FF = LENGTH
;                PC'S = AUX2
;
        TEST    SL,2
        JZ      SAVEDT4

;SAVEDT5  TAP       ,2
;         MVX       PHPL,F3F2 F3 = S0V; F2 = LENGTH OF VALUE
;SAVEDT8  SB        SAVEDSOV  SOV --> BUFFER; MAKE SURE ENOUGH ROOM FOR
;*_     VALUE. IF NOT WRITE RECORD & SETUP FOR NEXT
;         TPA+1     ,0        AUX0 = ADDRESS OF WHERE TO PUT VALUE IN BUFFER

SAVEDT5:
        MOV     EDX,AUX02
        MOV     WORD PTR R2,DX
SAVEDT8:
        CALL    SAVEDSOV
        MOV     AUX00,EDX
        INC     AUX00

;         TAP       ,3        PC'S POINT TO VALUE
;         MVI       0,F3      F3,2 = LENGTH OF VALUE
;         MVX       F3F2,F1F0 F1,0 = LENGTH
;         ACX,0     F1F0,PHPL,PHPL

        MOV     EDX,AUX03
        MOV     R3,0
        MOV     AX,WORD PTR R2
        MOV     WORD PTR R0,AX
        AND     EAX,0FFFFH
        ADD     EDX,EAX

;         XPA       ,3        AUX3 POINT TO NEXT ELEMENT
;         SB        ARECEVAL  VALUE --> BUFFER
;         TAP       ,C
;         ACX,0     F1F0,PHPL,PHPL
;         TPA       ,C        AUXC POINT AFTER VALUE IN BUFFER
        XCHG    EDX,AUX03


        TEST    AUX02,8000H
        JNZ     M40E_50

        PUSH    AUX01
        CALL    NEWTOOLD
        POP     AUX01

M40E_50:
        CALL    ARECEVAL
        MOV     EDX,AUX0C
        MOV     AX,WORD PTR R0
        AND     EAX,0FFFFH
        ADD     EDX,EAX
        MOV     AUX0C,EDX

;         SC,0      F6,,F6    DECREMENT NO. OF ELEMENTS
;         SC        F7,,F7
;         BLRX      DD,F7F6,SAVEDT5     BRANCH IF MORE ELEMENTS IN ARRAY

        DEC     WORD PTR R6
        JNZ     SAVEDT5

;*     LOOK FOR MORE ARGUMENTS
;*
;SAVEDT4  SB        NXTCHCOM  LOOK FOR COMMA
;         BEQL      0,F0,SAVEDT6        BRANCH IF FOUND
;         BFL       2,SL,SAVEDT2        BRANCH IF NOT EXECUTION PHASE
;         TAP       ,C

SAVEDT4:
        cmp     byte ptr [textptr],','
        jnz     bp40e_98
        inc     textptr
        jmp     savedt6
bp40e_98:
        TEST    SL,2
        JZ      SAVEDT2
        MOV     EDX,AUX0C

;         ORI,W1    0FD,,     EOB --> BUFFER
;         SB        RIOBUFFR  POINT TO BEGIN OF BUFFER
;         ORI,W1    81,,      CONTROL BYTE (DATA,LAST) --> BUFFER
;         SB        SAVEDBLK  WRITE LAST DATA BLOCK OF LOGICAL RECORD
;         B         MSWRTEND  END OF MULTI-SECTOR WRITE

        MOV     BYTE PTR [EDX],0FDH
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        MOV     BYTE PTR [EDX],081H
        CALL    SAVEDBLK
        JMP     MSWRTEND

;         TITLE     SAVEDSOV
;*     SAVEDSOV: MAKE SURE ENOUGH ROOM IN BUFFER FOR NEXT
;*               VALUE. IF NOT, PUT 'EOB' INTO BUFFER AND
;*               WRITE RECORD; THEN SETUP BUFFER FOR NEXT
;*               BLOCK.  THEN, PUT SOV INTO BUFFER.
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED
;*                 DEVICE TYPE = 3 OR B OR D
;*                               (IF NOT, ERROR#47. IF
;*                                LOGIC IS TO BE USED TO
;*                                CONTROL OTHER DEVICES,
;*                                PATCH IN AT 'B ERROR#47'
;*                 TEXTEND POINTS TO END OF TEXT
;*                 AUXF = SECTOR ADDRESS OF SECTOR TO WRIT
;*                 AUXE,LOW BYTE = PLATTER
;*                    0 IF USE DEVICE TYPE (3=F,B=R)
;*                    1 IF FIXED
;*                    2 IF REMOVABLE
;*                    3 IF FIXED (DEVICE ADDR OR'ED W. 40)
;*                    4 IF REMOVABLE (DEVICE ADDR OR'ED
;*                                    WITH 40)
;*                 AUXE,HIGH 4-BITS = 1 IF READ-AFTER-WRIT
;*                                    0 IF NO R/W
;*                AUXD = EOF SECTOR ADDRESS (CANNOT WRITE
;*                       BEYOND EOF
;*                AUXC = CURRENT PTR TO IO BUFFER
;*                F3 = SOV (START OF VALUE CHARACTER)
;*                F2 = LENGTH OF VALUE
;*
;*          RETURN: IF NOT ENOUGH ROOM FOR VALUE IN BUFFER
;*                      EOB IS PUT IN BUFFER AND BLOCK IS
;*                      WRITTEN TO DISK & BUFFER SETUP FOR
;*                      NEXT BLOCK
;*                  SOV PUT INTO IO BUFFER
;*                  AUXC POINTS AFTER SOV
;*                  BUFFER COUNT INCREMENTED BY LENGTH OF
;*                      VALUE +1
;*                  PC'S POINT TO SOV IN BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,K
;*                              AUX0,1,B,C,F
;*
;         ORG       *
;SAVEDSOV TAP       ,B
;         AC,1      F2,PL,PL  INCREMENT BUFFER COUNT BY LENGTH OF VALUE + 1
;         TPA       ,B
;         BFL       1,SH,SAVEDSV1       BRANCH IF ROOM ENOUGH FOR VALUE IN BUFFER

SAVEDSOV:
        MOV     EDX,AUX0B
        STC
        ADC     DL,R2
        MOV     AUX0B,EDX
        JNC     SAVEDSV1

;         TAP       ,C
;         ORI,W1    0FD,,     EOB --> BUFFER
;         SB        SAVEDBLK  WRITE BLOCK TO DISK
;         SB        HPION     HIGH PRIORITY I/O ON

        MOV     EDX,AUX0C
        MOV     BYTE PTR [EDX],0FDH
        CALL    SAVEDBLK
        CALL    HPION

;         AI        3,F2,PL
;         TPA       ,B        BUFFER COUNT = 3 + LENGTH OF VALUE
;         SB        RIOBUFFR  GET 1ST 2 BYTES OF BUFFER

        MOV     AL,R2
        ADD     AL,3
        MOV     DL,AL
        MOV     AUX0B,EDX
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     cx,[edx]
        xchg    ch,cl

;         AI,W2     1,CL,     INCREMENT PHYSICAL RECORD NUMBER IN BUFFER
;         TPA+2     ,C        AUXC POINT TO 3RD BYTE OF BUFFER

        ADD     CL,1
        MOV     [EDX+1],CL
        MOV     AUX0C,EDX
        ADD     AUX0C,2

;SAVEDSV1 TAP       ,C
;         TPA+1,W1  F3,C      SOV --> BUFFER
;         SR

SAVEDSV1:
        MOV     EDX,AUX0C
        MOV     AL,R3
        MOV     [EDX],AL
        INC     AUX0C
        RET

;         TITLE     SAVEDBLK
;*     SAVEDBLK: SAVE A DATA BLOCK OR DATA EOF BLOCK TO
;*              DISK FROM THE I/O BUFFER
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED
;*                 DEVICE TYPE = 3 OR B OR D
;*                               (IF NOT, ERROR#51. IF
;*                                LOGIC IS TO BE USED TO
;*                                CONTROL OTHER DEVICES,
;*                                PATCH IN AT 'B ERROR#51'
;*                 AUXF = SECTOR ADDRESS OF SECTOR TO WRIT
;*                 AUXE (DISK CNTRL REG.) = PLATTER,R/W
;*                AUXD = EOF SECTOR ADDRESS (CANNOT WRITE
;*                       BEYOND OR ON EOF
;*
;*          RETURN: BLOCK WRITTEN TO DISK
;*                  AUXF = ADDRESS OF SECTOR ACCESSED +1
;*                  AUXC POINTS TO BEGIN OF I/O BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,K
;*                              AUX0,1,C,F
;*
;         ORG       *
;SAVEDBLK TAP       ,ACTDEV
;         BEQL      #PHOENIX,PH,*+3
;         BEQL      3,PH,*+2
;         BNEL      0B,PH,ERR#48H       ERROR IF DEVICE ADDRESS <> DISK (3,D,OR B)

SAVEDBLK:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      BP40F_01
        CMP     DH,3
        JZ      BP40F_01
        CMP     DH,0BH
        JNZ     ERR_48H

;         TAP       ,D
;         MVX       PHPL,F1F0 F1,0 = EOF SECTOR ADDRESS
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         TPA       ,C        AUXC = ADDRESS OF I/O BUFFER

BP40F_01:
        MOV     EDX,AUX0D
        MOV     WORD PTR R0,DX
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        MOV     AUX0C,EDX

;         XPA       ,F        AUXF = ADDR OF IO BUFFER; PC'S = WRITE SECTOR ADDRESS
;         BLERX     F1F0,PHPL,ERROR#81  ERROR IF SECTOR ADDRESS > EOF SECTOR
;         B         DWRITE$   WRITE TO DISK; READ-AFTER-WRITE IF SPECIFIED

        XCHG    EDX,AUX0F
        CMP     WORD PTR R0,DX
        JBE     ERROR_81
        JMP     DWRITE?DA

;ERROR#81 MVI       81,F0     FILE FULL
;         B         ERROR
;
;ERR#48H  B         ERROR#48  ILLEGAL DEVICE SPECIFICATION

ERROR_81:
        MOV     R0,81H
        JMP     ERROR
ERR_48H:
        JMP     ERROR_48

;         TITLE     RAMDISK
;RAMDISK  EQU       *
;
;*  RAMDISK:  unused data memory in the system is available as a RAMDISK accessible
;*        by using address /340.  All memory beyond the last partition is setup
;*        as RAMDISK when the system is Master Initialized ($INIT).
;*
;*  RAMDISK routines:
;*
;*        INITRAMD: setup the RAMDISK.  Stores the number of sectors in the
;*                  RAMDISK in RAMDSK#S.
;*        RAMSCTR:  find the memory address of a RAMDISK sector.
;*        DREADRAM: read sector from RAMDISK.
;*        DWRITRAM: write sector to RAMDISK.
;*        DCOMPARM: read-after-write on one sector of RAMDISK.
;*
;*  Modifications to existing routines:
;*
;*        All modifications are marked by symbols of the form:  RAMDSKxx.
;*        RAMDISK access is determined by explicitly checking if the device
;*        address is 40.  The following routines have been modified:
;*
;*        DREAD:    branch to DREADRAM if RAMDISK access
;*        DWRITE:   branch to DWITDRAM if RAMDISK access
;*        DCOMPARE: branch to DCOMPARM if RAMDISK access
;*         return disk type = CF if RAMDISK
;*                  Disk type C is used so that COPY, MOVE, etc will use only
;*                  DREAD and DWRITE routines.
;*        ENBLDEVD: don't actually enable device if RAMDISK
;*        FORMATD:  error#93 if RAMDISK
;*        $INIT:    call INITRAMD.
;*                  Also, don't strip 40-bit off RAMDISK address
;
;
;         TITLE     DREADRAM
;*  DREADRAM:  read one sector from RAMdisk
;*
;*          ENTRY: phase = execution
;*                 SL/AUXF = bank/address of where to store data
;*                 AUX0 = sector address of sector to read
;*
;*          RETURN: AUXF = sector address +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;*          NOTE:  BSR/SL not modified
;*
;*        Note:     sector is on even boundary, but location to read to may not be.
;
;         ORG       *
;DREADRAM EQU       *
;* ======= save registers =======================================================
;         MVX       F3F2,PHPL
;         TPS       ,         save file registers
;         MVX       F5F4,PHPL
;         TPS       ,
;         MVX       F7F6,PHPL
;         TPS       ,

DREADRAM:
        PUSH    ESI
        PUSH    EDI
        PUSH    ECX

;* ======= get address of sector in RAM =========================================
;         SB        RAMSCTR   F1/PHPL = bank/address of sector
;*                                                 SL/AUXF = bank/address to read into

        CALL    RAMSCTR         ;EDX =  ADDRESS OF SECTOR IN RAM

;* ======= read (ie, copy) sector =============================================
;*                  ..... point to sector .....
;DREADRM3 MV        SL,F0     save SL
;         SHLL      F1,F1,SL  set bank for pre-VLSI-2 CPU
;         BFHH      80,F1,DREADRM4      branch if pre-VLSI-2 CPU
;         SB        SETBSR    select bank for VLSI-2 CPU
;
;*                  ..... get next 8 bytes of sector .....
;DREADRM4 OR,R      +,,
;         OR,R      CH+,,F7
;         OR,R      CH+,,F6
;         OR,R      CH+,,F5   read next 8 bytes of sector
;         OR,R      CH+,,F4
;         OR,R      CH+,,F3
;         OR,R      CH+,,F2
;*                  ..... point to area to read into .....
;**** BANK IS UNUSED NOW !
;         MV        F0,SL     set bank to read to (pre-VLSI-2)
;         MV        F1,F0     save bank of sector
;         ANDI      0F0,SL,F1
;         SB        SLCTBANK  select bank to read into
;         MV        F0,F1     F1 = bank of sector
;*                  ..... write 8 bytes into read area .....
;         XPA+1     ,F
;         OR,W1     +,F7,
;         OR,W1     +,F6,
;         OR,W1     +,F5,
;         OR,W1     +,F4,     write next 8 bytes of sector
;         OR,W1     +,F3,
;         OR,W1     +,F2,
;         OR,W1     +,CH,
;         XPA+1,W1  CL,F
;*                  ..... check if more bytes in sector .....
;         BNEH      0,PL,DREADRM3       branch if more to sector
;         BNEL      0,PL,DREADRM3

        MOV     ESI,EDX
        MOV     EDI,AUX0F
        MOV     ECX,40H
        CLD
        REP     MOVSD

;* ======= restore registers ====================================================
;         TSP
;         MVX       PHPL,F7F6
;         TSP
;         MVX       PHPL,F5F4
;         TSP
;         MVX       PHPL,F3F2

        POP     ECX
        POP     EDI
        POP     ESI

;* ======= update sector address ================================================
;         TAP       ,0
;         TPA+1     ,F        sector address +1
;         SR
        MOV     EDX,AUX00
        MOV     AUX0F,EDX
        ADD     AUX0F,1
        RET

;         TITLE     DWRITRAM
;*  DWRITRAM:  write one sector to RAMdisk
;*
;*          ENTRY: phase = execution
;*                 SL/AUXF = bank/address of data to write
;*                 AUX0 = sector address of sector to write
;*
;*          RETURN: AUXF = sector address +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;*          NOTE:  BSR/SL not modified
;*
;*        Note:     sector is on even boundary, but data to write may not be.
;
;         ORG       *
;DWRITRAM EQU       *
;* ======= save registers =======================================================
;         MVX       F3F2,PHPL
;         TPS       ,         save file registers
;         MVX       F5F4,PHPL
;         TPS       ,
;         MVX       F7F6,PHPL
;         TPS       ,

DWRITRAM:
        PUSH    ESI
        PUSH    EDI
        PUSH    ECX

;* ======= get address of sector in RAM =========================================
;         SB        RAMSCTR   F1/PHPL = bank/address of sector
;*                                                 SL/AUXF = bank/address of data to write

        CALL    RAMSCTR

;* ======= write (ie, copy) sector ============================================
;*                  ..... get next 8 bytes of data .....
;DWRITRM2 XPA       ,F        point to data to write
;         OR,R      +,,       assume bank already set
;         OR,R      CH+,,F7
;         OR,R      CH+,,F6
;         OR,R      CH+,,F5   read next 8 bytes of sector
;         OR,R      CH+,,F4
;         OR,R      CH+,,F3
;         OR,R      CH+,,F2
;         OR,R      CH+,,F0
;*                  ..... point to the sector .....
;         BFHH      80,F1,DWRITRM3      branch if pre-VLSI-2 CPU
;         SB        SETBSR    select sector bank for VLSI-2 CPU
;         B         DWRITRM6
;DWRITRM3 MV        SL,K      save SL
;         SHLL      F1,F1,SL  select sector bank for pre-VLSI-2
;*                  ..... write 8 bytes into sector .....
;DWRITRM6 XPA       ,F
;         OR,W1     +,F7,
;         OR,W1     +,F6,
;         OR,W1     +,F5,
;         OR,W1     +,F4,     write next 8 bytes of sector
;         OR,W1     +,F3,
;         OR,W1     +,F2,
;         OR,W1     +,F0,
;         OR,W1     +,CH,
;*                  ..... point to bank writing from .....
;         BTHH      80,F1,;*+2 branch if VLSI-2 CPU
;         MV        K,SL      point to bank writing from
;         MV        F1,F0     save sector bank
;         ANDI      0F0,SL,F1
;         SB        SLCTBANK  select bank to write from
;         MV        F0,F1     F1 = sector bank
;*                  ..... check if more bytes in sector .....
;         BNEL      0,PL,DWRITRM2       branch if more to sector
;         BNEH      0,PL,DWRITRM2

        MOV     ESI,AUX0F
        MOV     EDI,EDX
        MOV     ECX,100H
;       CLD
        REP     MOVSB

;* ======= restore registers ====================================================
;         TSP
;         MVX       PHPL,F7F6
;         TSP
;         MVX       PHPL,F5F4
;         TSP
;         MVX       PHPL,F3F2

        POP     ECX
        POP     EDI
        POP     ESI

;* ======= update sector address ================================================
;         TAP       ,0
;         TPA+1     ,F        sector address +1
;       RET

        MOV     EDX,AUX00
        MOV     AUX0F,EDX
        ADD     AUX0F,1
        RET

;         TITLE     DCOMPARM
;*  DCOMPARM:  perform read-after-write on one sector on RAMdisk
;*
;*        This is actually a NOP -- nothing is actually done.
;*
;*          ENTRY: phase = execution
;*                 AUXF = address of data to compare
;*                 AUX0 = sector address of sector to write
;*
;*          RETURN: AUXF = sector address +1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,K,AUX0,F
;*
;
;         ORG       ;*
;DCOMPARM SB        RAMSCTR   point to sector in RAM

DCOMPARM:
        CALL    RAMSCTR

;* ======= update sector address ================================================
;         TAP       ,0
;         TPA+1     ,F        sector address +1
;         SR

        MOV     EDX,AUX00
        MOV     AUX0F,EDX
        ADD     AUX0F,1
        RET

;         TITLE     FRMTDRAM
;*  FRMTDRAM:  format RAMdisk
;*
;*          Entry: phase = execution
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,7,K,AUX0
;*
;*          Note:  BSR/SL not modified
;
;         ORG       *
;FRMTDRAM EQU       *
;* ======= initialization =======================================================
;         LPI       0
;         TPA       ,0        start with sector 0

FRMTDRAM:
        MOV     AUX00,0

;* ======= make sure sector is in RAMdisk =======================================
;FRMTDRM0 LPI,R     RAMDSK#S  get # sectors in RAMdisk
;         TAP       ,0        sector address
;         MVX       PHPL,F1F0
;         BLRX      F1F0,CHCL,FRMTDRM1  branch if valid sector
;         B         ENDSDISK  done, no more sectors

FRMTDRM0:
        MOV     CX,RAMDSK_S
        MOV     EDX,AUX00
        CMP     DX,CX
        JB      FRMTDRM1
        JMP     ENDSDISK

;* ======= point to sector in RAM =========================================
;FRMTDRM1 SB        RAMSCTR   F1/PHPL = bank/address of sector
;*                                                 SL/AUXF = bank/address to read into
;         MV        SL,F7     save SL
;         SHLL      F1,F1,SL  set bank for pre-VLSI-2 CPU
;         BFHH      80,F1,FRMTDRM2      branch if pre-VLSI-2 CPU
;         SB        SETBSR    select bank for VLSI-2 CPU

FRMTDRM1:
        CALL    RAMSCTR

;* ======= format (zero) sector =================================================
;FRMTDRM2 SB        ZERO256

        MOV     ECX,64          ;ECX = LOOP COUNT
        MOV     EDI,EDX
        MOV     EAX,0
        REPNZ   STOSD           ;SET DATA MEMORY TO ZERO
        ADD     EDX,256

;* ======= next sector ==========================================================
;         TAP       ,0
;         TPA+1     ,0        increment sector #
;         MV        F7,SL     set bank to user bank (pre-VLSI-2)
;         ANDI      0F0,SL,F1
;         SB        SLCTBANK  select user partition bank
;         B         FRMTDRM0

        ADD     AUX00,1
        JMP     FRMTDRM0

;         TITLE     RAMSCTR
;*  RAMSCTR:  point to specified RAMdisk sector
;*
;*        Entry:    AUX0 = sector address
;*
;*                  Assumes that RAMDSK#S (no. of sectors in RAMdisk) has been
;*                  setup (this is done by INITRAMD).
;*
;*        Return:   F1/PHPL = bank/address of sector
;*
;*                  where bank format is:  1xxx-xxxx if VLSI-2 CPU
;*                                         0000-yyy0 if pre-VLSI-2
;*
;*                             xxxxxxx = bank# (00-7F)
;*                                 yyy = bank# is SL format
;*
;*        Error:    ERROR 98 if sector not in RAMdisk range
;*
;*        Modified registers:  PC's,F1-0,CHCL
;*
;         ORG       *
;RAMSCTR  EQU       *
;* ======= breakpoint if 30ms. has elapsed ======================================
;*  It is necessary to breakpoint if 30ms. has elapsed in RAM Disk access since
;*  certain statements (eg, $FORMAT DISK, VERIFY, COPY, MOVE) can access many
;*  sectors.  The breakpoint has been put in the RAMSCTR routine since this is
;*  is a common subroutine used for all RAM Disk access.
;*
;         SB        BREAKPTG  breakpoint if 30ms. elapsed

RAMSCTR:
        CALL    BREAKPTG

;* ======= make sure sector is in RAMdisk =======================================
;         LPI,R     RAMDSK#S  get # sectors in RAMdisk
;         TAP       ,0        sector address
;         MVX       PHPL,F1F0
;         BLRX      F1F0,CHCL,RAMSCTR1  branch if valid sector
;         B         ERROR#98

        MOV     CX,RAMDSK_S
        MOV     EDX,AUX00
        CMP     DX,CX
        JB      RAMSCTR1
        JMP     ERROR_98
;
;RAMSCTR1 SCX,0     CHCL,F1F0,F1F0      offset from end of memory
;* ======= get end of memory ====================================================
;         LPI,R     ENDMEMX   get end of memory
;         BFHH      80,CH,RAMSCTR4      branch if pre-VLSI-2 CPU
;* ======= calculate sector address for VLSI-2 CPU ==============================
;         SCX,1     CHCL,F1F0,F1F0      end-of-memory - sector-offset
;         ANDI      7F,F1,F1  strip off CPU type bit
;         LPI,R     ENDPART   get address of end of partitions
;         BLRX      CHCL,F1F0,RAMSCTR5  branch if sector address > end of partitions
;*
;*        sector is in lower 8K section of a partition bank
;*
;         ANDI      1F,F0,PH  page address of sector in bank
;         MVI       0,PL
;
;         MIH       8,F0,F0
;         BFLL      01,F1,;*+2 branch if in 1st region
;         ORI       08,F0,F0
;
;         ORI       80,F0,F1  region/bank address
;         SR
;*
;*        sector is in memory beyond partitions
;*
;RAMSCTR5 MVX       F0D,PHPL  address of sector in bank
;         ORI       80,F1,F1  region/bank address
;         SR
;* ======= calculate sector address for pre-VLSI-2 CPU ==========================
;RAMSCTR4 MVX       F3F2,PHPL save F3F2
;         MVX       F1F0,F3F2 sector offset
;
;         MVX       CHCL,F1F0 F1 = bank address; F0 = last page
;         AI        0E1,F0,F0 # pages in last bank
;         B         RAMSCTR3
;
;RAMSCTR2 SC,1      F2,F0,F2  subtract # sectors in current
;         SC        F3,,F3       bank from sector address
;
;         AI        0FF,F1,F1 decrement bank#
;         MVI       0E0,F0    # pages in this bank
;RAMSCTR3 BNR       F3,,RAMSCTR2        branch if sector addr > # sectors in bank
;         BLER      F0,F2,RAMSCTR2
;
;         MIL       4,F1,F1
;         BFHH      10,F1,*+2 convert bank# to SL format
;         XORI      12,F1,F1
;         SC,1      F0,F2,F0
;         AI        1F,F0,F0  F0 = page containing sector
;         MVX       PHPL,F3F2 restore registers
;         MVX       F0D,PHPL  address of sector
;         SR

RAMSCTR1:
        MOV     EDX,ENDPART
        MOV     ECX,AUX00
        AND     ECX,0FFFFH
        SHL     ECX,8
        ADD     EDX,ECX
        RET

;         TITLE     INITRAMD
;*  INITRAMD:  initialize RAMdisk
;*
;*        Determines the size of RAMdisk storing the number of sectors available
;*        in RAMDSK#S.  RAMdisk uses all data memory not used by partitions and
;*        the operating system.
;*
;*        Pre-VLSI-2 CPUs cannot access the 1st 8K of each memory bank > 1.
;*        VLSI-2 CPUs can access all of memory.
;*
;*        Entry:    ENDPART = address of last page of last partition
;*                  ENDMEM  = address of last page of memory
;*
;*        Return:   RAMDSK#S = number of sectors in RAMdisk (0 if none)
;*
;*        Modified registers:  F0-2,CHCL,PHPL
;*
;         ORG       *
;INITRAMD EQU       *
;* ----------------- calculate # pages free -------------------------------------
;         LPI,R     ENDPART
;         MVX       CHCL,F1F0 address of last page of last partition
;         LPI,R     ENDMEMX   address of last page of memory
;         SCX,1     CHCL,F1F0,F1F0      number of free pages of memory
;         ANDI      7F,F1,F1  strip off CPU type bit

INITRAMD:
        MOV     EDX,DWORD PTR [BASE]
        MOV     EAX,1024*256
        SUB     EAX,EDX
        SUB     EAX,200H
        MOV     ECX,ENDPART
        MOV     EDX,ENDMEMX
        SUB     EDX,ECX
        SUB     EDX,EAX
        INC     EDX

;* ----------------- if pre-VLSI-2, subtract nonaddressable 8K sections ----------
;         BTHH      80,CH,INITRMD1      branch if VLSI-2 CPU
;         MIL       2,F1,F2
;         SHLH      F2,F2,F2  F2 = 32 ;* (# banks -1)
;         SC,1      F0,F2,F0
;         SC        F1,,F1    subtract 8K sections
;* ----------------- save # pages for sectors -----------------------------------
;INITRMD1 LPI       RAMDSK#S
;         OR,W1     F1,,      store actual # sectors
;         OR,W2     F0,,
;         SR

INITRMD1:
        SHR     EDX,8
        MOV     RAMDSK_S,DX
        RET

;         TITLE     DRAM256
;*   DRAM256:  read 256 bytes of data memory
;*
;*        This is a debug statement that will read an arbitrary 256 bytes of
;*        data memory into the specified alpha-array.  The statement currently
;*        has no entry point, but could be invoked by overwriting an infrequently
;*        used statement, such as PLOT.
;*
;*        Format:    PLOT bank, address, alpha-variable
;*
;*                  where: bank and address are numeric expressions
;*
;DRAM256  SB        EXPR      bank #
;         SB        GETCHCOM  comma
;         SB        EXPR      address within bank
;         SB        GETCHCOM  comma
;         SB        ALPHARAY  alpha array to read into
;         BFL       XPHASE,SL,DRAM256A  branch if not x-phase
;
;         TPA       ,F        address of alpha array
;
;         SB        FLTBINB
;         MVX       F1F0,PHPL
;         TPA       ,0        binary address
;
;         SB        FLTBINA
;         ORI       80,F0,F1  binary bank#
;
;         TAP       ,0        address
;
;         SB        DREADRMX  read 256 bytes into alpha variable
;
;DRAM256A B         ENDSTMT
;
;DREADRMX TPS
;         TPS
;         TPS
;         SBR       DREADRM3  read 256 bytes into alpha variable
;ENDMOD40 EQU       *
CODE    ENDS
        END
