;===========================================================================
;
;
;
;
;
;===========================================================================
;           This module was originally M43
;===========================================================================
	   .XLIST
	   INCLUDE PREAMBLE
	   .LIST


;*COMMAND EQUATES:
?AMREAD    EQU       00H      ; READ SECTOR
?AMEXTEND  EQU       20H      ; EXTENDED COMMAND (NEXT BYTE HAS COMMAND CODE)
?AMEXTENDH EQU       2H       ; (HIGH 4BITS)
?AMWRITE   EQU       40H      ; WRITE SECTOR
?AMCOMPARE EQU       80H      ; COMPARE SECTOR

?AMCOPY    EQU       01H      ; COPY SECTORS
?AMVERIFY  EQU       12H      ; VERIFY SECTORS
?AMMSWRTB  EQU       10H      ; BEGIN OF MULTI-SECTOR WRITE
?AMMSWRTE  EQU       11H      ; END OF MULTI-SECTOR WRITE
?AMFORMAT  EQU       02H      ; FORMAT PLATTER
?AMSTATUS  EQU       16H      ; DEVICE STATUS

PUBLIC       COPY
PUBLIC       FORMATD
PUBLIC       LIMITS
PUBLIC       MOVE
PUBLIC       SETDEVLD
PUBLIC       VERIFY
PUBLIC       VERIFYE

EXTRN  part_            :byte
EXTRN  plat             :byte
EXTRN  rqstdev          :byte
EXTRN  rqstplat         :byte
EXTRN  finddev          :NEAR
EXTRN  devspec          :NEAR
EXTRN  breakptw         :NEAR
EXTRN  wrthex           :NEAR
EXTRN  wakeupp          :NEAR

EXTRN  @@VSEND          :NEAR
EXTRN  ADDIFILE         :NEAR
EXTRN  AKN              :NEAR
EXTRN  AKN1             :NEAR
EXTRN  AKNBPT           :NEAR
EXTRN  BASE             :NEAR
EXTRN  CATEND           :NEAR
EXTRN  CCL              :NEAR
EXTRN  CCLTO            :NEAR
EXTRN  CMNDINIT         :NEAR
EXTRN  CPBASE           :DWORD
EXTRN  CUREND1          :NEAR
EXTRN  CURENDR          :NEAR
EXTRN  DELAY5           :NEAR
EXTRN  DISKADRD         :NEAR
EXTRN  DISKCMDA         :NEAR
EXTRN  DISKCMDC         :NEAR
EXTRN  DISKCMND         :NEAR
EXTRN  DISKSEL          :NEAR
EXTRN  DISKSELC         :NEAR
EXTRN  DISKSELCC        :NEAR
EXTRN  DREAD            :NEAR
EXTRN  DREADS0          :NEAR
EXTRN  DREADSF          :NEAR
EXTRN  DWRITE           :NEAR
EXTRN  DWRITE?DAF       :NEAR
EXTRN  ENBLCO           :NEAR
EXTRN  ENBLDEVD         :NEAR
EXTRN  ENDDISK          :NEAR
EXTRN  ENDSDISK         :NEAR
EXTRN  ENDSTMT          :NEAR
EXTRN  ERROR_02         :NEAR
EXTRN  ERROR_10         :NEAR
EXTRN  ERROR_11         :NEAR
EXTRN  ERROR_12         :NEAR
EXTRN  ERROR_13         :NEAR
EXTRN  ERROR_19         :NEAR
EXTRN  ERROR_32         :NEAR
EXTRN  ERROR_81         :NEAR
EXTRN  ERROR_82         :NEAR
EXTRN  ERROR_83         :NEAR
EXTRN  ERROR_85         :NEAR
EXTRN  ERROR_86         :NEAR
EXTRN  ERROR_93         :NEAR
EXTRN  ERROR_94         :NEAR
EXTRN  ERR_34B          :NEAR
EXTRN  ERR_92           :NEAR
EXTRN  EXPR             :NEAR
EXTRN  FILELOCS         :NEAR
EXTRN  FILENAME         :NEAR
EXTRN  FILE_A           :NEAR
EXTRN  FILE_E           :NEAR
EXTRN  FINDNAMH         :NEAR
EXTRN  FLTBINA          :NEAR
EXTRN  FLTBINB          :NEAR
EXTRN  FRMTDRAM         :NEAR
EXTRN  GETFLPTR         :NEAR
EXTRN  GTFLPTRS         :NEAR
EXTRN  HPION            :NEAR
EXTRN  INTINDX          :NEAR
EXTRN  IOBUFTXT         :NEAR
EXTRN  MSWRTBEG         :NEAR
EXTRN  MSWRTEND         :NEAR
EXTRN  NEWEOF           :NEAR
EXTRN  NEWNAMEF         :NEAR
EXTRN  NXTCHEOS         :NEAR
EXTRN  OBSDISK          :NEAR
EXTRN  PLATTER          :NEAR
EXTRN  PRNTCR           :NEAR
EXTRN  RAWOFF           :NEAR
EXTRN  RAWON            :NEAR
EXTRN  RECEV            :NEAR
EXTRN  RECEVPC          :NEAR
EXTRN  RHASHFLG         :NEAR
EXTRN  TWRITESP         :NEAR
EXTRN  VARR             :NEAR
EXTRN  VRFYMSG          :BYTE
EXTRN  WAITIBS          :NEAR
EXTRN  WRTSTRCM         :NEAR
EXTRN  WRTVALA          :NEAR
extrn  srchdev          :near
extrn  wakeupa          :near
extrn  enblnlldh        :near
extrn  breakptt         :near
extrn  cbsnr            :near
extrn  stack_buffer     :near


;         MODULE    MOD-43 DISK (MISC.STMTS.)
;         TITLE     DISK (MISC.STMT.)
;*     *****************************
;*     *                           *
;*     *  MOD43: MISC. DISK STMTS  *
;*     *                           *
;*     *****************************
;*
;*     LIMITS: PROCESS A 'LIMITS' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            1. LIMITS platter [file#,] s,e,c
;*
;*          2. LIMITS platter [file#,] filename, s,e,u[,t]
;*
;*               where: s,e,c,u,t = numeric variables
;*                      s = start address
;*                      e = end address
;*                      c = current address
;*                      u = no. of sectors used
;*                      t = file status
;*                          2 if data file
;*                          1 if program
;*                          0 if file not found
;*                         -1 if scratched program
;*                         -2 if scratched data file
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LIMITS'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXA-F
;*

LIMITS:
	CALL    PLATTER         ;PROCESS PLATTER SPEC.
	CALL    FILE_A          ;LOOK FOR FILE#
	TEST    R0,0FH
	JNZ     BP43_01         ;BRANCH IF NF
	CMP     BYTE PTR [TEXTPTR],','
	JNE     ERROR_13        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
BP43_01:
	CALL    FILENAME        ;LOOK FOR A FILENAME
	TEST    R0,0FH
	JZ      LIMITS1         ;BR IF FOUND

;*     LIMITS FROM DEVICE TABLE (FORM 1.)

	CALL    GETFLPTR        ;GET START,END AND CURRENT SECTOR ADDRESS FROM DEV. TABLE
	CALL    LMTSVLST        ;PROCESS VARIABLE LIST
	JMP     ENDSTMT

;*     LIMITS FROM DISK PLATTER (FORM 2.)

LIMITS1:
	CMP     BYTE PTR [TEXTPTR],','
	JNE     ERROR_13        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	TEST    SL,2
	JZ      LIMITS2         ;BR IF NOT EXECUTION PHASE
	CALL    FILE_E          ;ENABLE DISK
	CALL    FINDNAMH        ;FIND FILE NAME IN INDEX
	mov     al,r3
	and     al,0f0h
	cmp     al,10H          ;F3 = 00,01 ---- NF
	JNZ     LIMITS3         ;     10,11 ----  F     BR IF NOT FOUND
	MOV     EDX,AUX0C       ; AUX0C = ADDRESS OF I/O BUFFER OF ENTRY WITH FILENAME
	MOV     CL,[EDX+1]      ; READ FILE TYPE/STATUS
	ADD     AUX0C,2
	MOV     AH,R3           ; R3 = 11,FILE SCRATCH
	AND     AH,1            ; AH=0 IF NOT SCRATCH,1 IF SCRATCH
	MOV     AL,1
	mov     bl,cl
	and     bl,0f0h
	CMP     BL,80H          ; 80 -- PROGRAM, 10 -- DATA
	JZ      BP43_02
;
; cs-386 format
;
	cmp     bl,40h
	jz      bp43_02

	MOV     AL,2            ; AL=1 IF PROGRAM,2 IF DATA FILE
BP43_02:
	MOV     AUX0A,EAX       ;AUX0A ---- FILE TYPE/STATUS INFORMATION
	CALL    GTFLPTRS        ;AUXB=SOF ADDRESS; AUX0D =EOF ADDRESS
	MOV     EDX,AUX0D
	MOV     AUX0F,EDX       ;AUX0F =EOF ADDRESS
	CALL    DREADSF         ;READ EOF SECTOR
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	MOV     CX,[EDX+1]
	XCHG    CH,CL
	MOV     AUX0F,ECX       ;AUX0F --- NO. SECTOR USED
	ADD     EDX,2
LIMITS2:
	CALL    LMTSVLST        ;PROCESS VARIABLE LIST
	CMP     BYTE PTR [TEXTPTR],','
	JNE     LIMITS5         ;BRANCH IF COMMA NF
	INC     TEXTPTR
	CALL    VARR            ;LOOK FOR NUMERIC RECEIVER VARIABLE
	TEST    SL,2
	JZ      LIMITS4
;       CALL    PUSH0V8         ; FLOATING POINT ZERO ==> VS
	MOV     EAX,VSPTR
	MOV     DWORD PTR [EAX-8],0
	MOV     DWORD PTR [EAX-4],0
	SUB     VSPTR,8

	CMP     EAX,DWORD PTR [@@VSEND]
	JB      ERROR_02
					;****  SET FLOATING POINTS NUMBER ( SIGN & VALUE)
	MOV     EBX,AUX0A               ;--------------------------------------------
	MOV     EDX,VSPTR               ;| EXP      |   ML    |           |   MM    |
	CMP     BH,01H                  ;--------------------------------------------
	JNZ     BP43_03                 ;0        15 16     31 32       47 48      63
	NEG     BL                      ;  +1 = 0000 0000 0000 0000
	MOV     BYTE PTR [EDX+3],0FFH   ;  -1 = 0000 FFFF FFFF FFFF
	MOV     DWORD PTR [EDX+4],0FFFFFFFFH
BP43_03:
	MOV     [EDX+2],BL
	CALL    RECEV
LIMITS4:
	JMP     ENDSDISK
LIMITS3:
	MOV     EDX,0
	MOV     AUX0A,EDX       ; FLAG = FILE NOT FOUND
	MOV     AUX0B,EDX       ; SOF ADDRESS
	MOV     AUX0D,EDX       ; EOF ADDRESS
	MOV     AUX0F,EDX       ; NO. OF SECTOR USED =0
	JMP     LIMITS2
LIMITS5:
	TEST    SL,2
	JZ      LIMITS4
	MOV     EDX,AUX0A
	CMP     DX,0            ;BR IF FILE FOUND
	JA      LIMITS4
	JMP     ERROR_82

;         TITLE     LMTSVLST
;*     LMTSVLST: PROCESS LIMITS VARIABLE LIST (START, END,
;*               CURRENT OR USED RECEIVER VARIABLES)
;*
;*          LIST FORMAT: s,e,c (or u)
;*
;*               where: s,e,c,u = numeric variables
;*                      s = start address
;*                      e = end address
;*                      c = current address
;*                      u = no. of sectors used
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*             IN EXECUTION PHASE,
;*                 AUXB = SOF ADDRESS
;*                 AUXD = EOF ADDRESS
;*                 AUXF = CURRENT ADDRESS (OR NO. OF
;*                        SECTORS USED)
;*
;*          RETURN: TEXTPTR POINTS AFTER LIST
;*               IN EXECUTION PHASE,
;*                  s = AUXB (SOF ADDRESS)
;*                  e = AUXD (EOF ADDRESS)
;*                  c (or u) = AUXF
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*
LMTSVLST:
	CALL    VARR            ;LOOK FOR START ADDRESS VARIABLE
	MOV     EDX,AUX0B       ;EDX= SOF
	CALL    RECEVPC         ;SOF ==> VARIABLE
	CMP     BYTE PTR [TEXTPTR],','
	JNE     ERROR_13        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	CALL    VARR            ;LOOK FOR EOF ADDRESS VARIABLE
	MOV     EDX,AUX0D       ;EDX = EOF
	CALL    RECEVPC         ;EOF ==> VARIBALE
	CMP     BYTE PTR [TEXTPTR],','
	JNE     ERROR_13        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	CALL    VARR            ;LOOK FOR CURRENT ADDRESS VARIABLE
	MOV     EDX,AUX0F       ;EDX= COF
	JMP     RECEVPC

; END LIMIT COMMAND


;         TITLE     VERIFY
;*     VERIFY: PROCESS A 'VERIFY' STATEMENT
;*
;*          STMT FORMAT:
;*
;*       VERIFY platter [file#,][(expr,expr)][num-variabl]
;*                       disk-addr,
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'VERIFY'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXA-F,9
;*
;*     REL 1.7 MODIFIED 5/10/79 -- IF DRIVE DOES NOT SUPPORT
;*          PHOENIX TYPE VERIFY, USE DIABLO SEQUENCE
;*
VERIFY:
	CALL    PLATTER         ;PROCESS PLATTER SPEC.
	CALL    DISKSELC        ;PROCESS #N OR /XYY PARAMETER
	CALL    SCTRANGE        ;PROCESS SECTOR ADDRESS RANGE
	CALL    NXTCHEOS        ;LOOK FOR EOS CHAR(END OF STATEMENT)
	MOV     R7,0
	TEST    R0,0FH
	JZ      BP43_04
	CALL    VARR
	MOV     R7,1            ;R7 =0 IF NO RECEIVER , 1 RECEIVER SPEC.
BP43_04:
	TEST    SL,2
	JZ      VERIFY1
	OR      MODE,0100H      ;VERIFY MODE ON
	CALL    HPION           ;HIGH PRIORITY I/O ON
	MOV     EDX,AUX0F
	MOV     AUX09,EDX
	INC     AUX09           ;AUX09 -- LOOP COUNTER
VERIFY22:
	CALL    CMNDINIT
VERIFY2:
	MOV     EDX,ACTDEV
	AND     DH,0FH
	CMP     DH,_PHOENIX
	JZ      VERIFY30        ;BR IF  PHOENIX DISK

;* ------- old-type disk verify (actually read sectors) ------------

VERIFY21:
	CALL    DREADSF         ;VERIFY BY ACTUALLY READING THE SECTOR
;* ------- check if more sectors to be verified --------------------
	MOV     EDX,AUX09
	MOV     AUX0F,EDX       ;AUX0F = AUX0F+1
	MOV     BX,DX           ;BX = READING SECTOR +1
	INC     AUX09           ;AUX09= NEXT SECTOR TO VERIFY + 1
	MOV     EDX,AUX0D       ;EDX = END SECTOR RANGE
	CMP     BX,0            ;DONE IF NEXT SECTOR =0 (WRAP AROUND)
	JZ      VERIFY23
	CMP     BX,DX
	JBE     VERIFY21        ;BR IF MORE SECTORS TO VERIFY
;* ------- verify complete ----------------
VERIFY23:
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	TEST    R7,0FH          ;BR IF NO RECEIVER
	JZ      VERIFY5
	MOV     EDX,0
VERIFY3:
	CALL    RECEVPC         ;RECEIVER = EDX
VERIFY5:
	AND     MODE,0FFFFFEFFH         ;VERIFY MODE OFF
VERIFY1:
	JMP     ENDSDISK
;* ------- Phoenix-type verify ---------------

VERIFY30:
	MOV     EDX,0    ;RETRY COUNT = 16 MAX.
VERIFY25:
	INC     EDX
	PUSH    EDX
	CALL    CMNDINIT        ;INITIALIZE DISK
	MOV     EDX,AUX0F       ;STARTING SECTOR ADDRESS
	MOV     R0,?AMEXTEND    ;EXTENDED COMMAND
	MOV     R2,?AMVERIFY    ;COMMAND = VERIFY
	CALL    DISKCMND        ;/COMMAND/PLATTER/SECTOR ADDRESS ==> DISK
	CMP     R0,0
	JZ      VERIFY6         ;BR IF COMMAND OK
;
	cmp     k,60h           ;ECHO = 60h indicates extended command reject
	jnz     retry_6
	mov     eax,actdev
	and     al,0f0h
	mov     k,al
	call    srchdev

	test    cl,devopen
	jnz     verife1e

	and     byte ptr [edx],0ffh-devuse
	mov     eax,actdev
	and     al,030h
	mov     byte ptr fs:[_abs],al
	mov     al,0
	call    cbsnr                           ;unhog device
	call    enblnlldh                       ;disable disk
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	mov     eax,actdev
	and     al,030h
	mov     r0,al
	call    wakeupa
	jmp     verif1ef

verife1e:
	and     byte ptr [edx],0ffh-devoip
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,1
	call    breakptt
verif1ef:
	mov     edx,actdev
	call    enbldevd
	jmp     verify30
;
retry_6:
	POP     EDX
	CMP     EDX,10H
	JNZ     RETRYVRF        ;IF COMMAND ERROR & RETRY COUNT < 16 THEN BRANCH
	JMP     ERROR_94
RETRYVRF:
	TEST    R0,0F0H
	JZ      VERIFY25
	TEST    R0,0FH          ;BR IF ECHO ERROR
	JZ      VERIFY25
	JMP     VERIFY21        ;BR IF DPU VERIFY NOT SUPPORT
VERIFY6:
	POP     EDX             ;GET THE RETRY COUNT
	CALL    AKN             ;ACKNOWLEDGEMENT OF VALID(START) SECTOR ADDRESS
	MOV     EDX,AUX0D       ;END SECTOR ADDRESS
	CALL    DISKCMDA        ;END ADDRESS ==> DISK
	CALL    AKN             ;ACKNOWLEDGEMENT OF VALID(END)SECTOR ADDRESS
	MOV     K,0
	CALL    OBSDISK         ;START VERIFY
	CALL    AKNBPT          ;WAIT IBS --- BREAKPOINT IF NOT READY WITHIN 1/4 MS.
	CALL    WAITIBS         ;FOR SET RECEIVER,THE HIGH BYTE SECTOR ADDRESS IS IGNORED IN ANKBPT
	TEST    BYTE PTR FS:[CPUST],CPB
	JZ      ERR_92A
	MOV     DH,K            ;2ND ADDRESS
	CALL    WAITIBS
	TEST    BYTE PTR FS:[CPUST],CPB
	JZ      ERR_92A
	MOV     DL,K            ;3RD ADDRESS
	MOV     AUX09,EDX
	INC     AUX09           ;AUX09 = ADDRESS OF LAST SECTRO VERIFYED + 1
	CALL    AKN1            ;READ ACKNOWLEDGE
	JMP     VERIFY23        ;NO ERROR
ERR_92A:
	JMP     ERR_92

;*     VERIFY ERROR
;*
;*          ENTRY: FROM 'DISKERR'
;*                 F0 = ERROR CODE
;*                 AUX9 = SECTOR ADDRESS + 1 OF BAD SECTOR
;*                 F7 = 0 IF NO RECEIVER VARIABLE
;*                      1 IF RECEIVER VARIABLE
;*

VERIFYE:
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@ERRF
	MOV     AL,R0
	MOV     [EDX],AL        ;ERROR CODE ==> ERR
	MOV     EDX,AUX09       ;EDX = BAD SECTOR ADDRESS + 1
	CMP     R7,1
	JZ      VERIFY3         ;BR IF RECEIVER SPECIFIED
	MOV     EDX,ACTDEV
	MOV     AUX0A,EDX       ;SAVE DISK ADDRESS
	CALL    ENDDISK         ;CLOSE DISK IF NOT HOGGED
	CALL    ENBLCO          ; ENABLE CO DEVICE
@3?PD0MH:
	MOV     EDX,OFFSET VRFYMSG
	CALL    WRTSTRCM        ;OUTPUT "ERROR IN SECTOR"
	CALL    TWRITESP        ;OUTPUT SPACE
	MOV     EDX,AUX09
	DEC     EDX
	MOV     WORD PTR R0,DX  ;R1,0 = BAD SECTOR ADDRESS
	CALL    WRTVALA         ;WRITE R1,0
	CALL    PRNTCR          ;WRITE 'CR'
	TEST    SH,20H          ;BRANCH IF NOT HALT/STEPe
	JNZ     VERIFY5
	MOV     EDX,AUX0A       ;EDX=DISK TYPE & ADDRESS
	CALL    ENBLDEVD        ;ENABLE DISK
;* ------- check if more sectors to be verified ---------
	MOV     EDX,AUX09
	MOV     AUX0F,EDX
	MOV     EBX,EDX
	MOV     AUX09,EDX
	INC     AUX09
	MOV     EDX,AUX0D
	CMP     BX,0
	JZ      VERIFY23
	CMP     BX,DX
	JA      VERIFY23
	MOV     ESP,OFFSET STACK_BUFFER
	JMP     VERIFY2

;   END VERIFY COMMAND

;* -----------  testplat ---------------*
;The following changes are for platter hog
;Because copy from the same device but different platters
;e.g. copy t/d21 to t/d22
;OS allow platter p21 and mark the MDT table 20 devoip
;But platter p22 is hogged by another partition ,OS wait platter p22
;At this time , other partition can't unhog p22 due to MDT table 20 has been marked
;We must certify that device d20, platter p21 p22 are all available
;*

test_plat:
	test    sl,2
	jz      real_beg
	jmp     real_beg1
;make sure that device & platters are available

;* device not available
copyplat:
	mov     textptr,aux05
	mov     dl,part_           ;POINT TO REQUESTED DEVICE TABLE (SAME PAGE)
	and     edx,0ffh           ;DEVICE ADDRES ==> RQSTDEV
	add     edx,offset rqstdev ;WAIT UNTIL DEVICE AVAILABLE
	mov     [edx],ch
	jmp     copyplat_3

;* platter not available
copyplat_2:
	mov     textptr,aux05
	mov     dl,part_           ;POINT TO REQUESTED DEVICE TABLE (SAME PAGE)
	and     edx,0ffh           ;DEVICE ADDRES ==> RQSTDEV
	add     edx,offset rqstplat;WAIT UNTIL DEVICE AVAILABLE
	mov     al,r0
	mov     [edx],al
copyplat_3:
	call    breakptw

real_beg1:
	mov     aux05,textptr           ;save textptr (point to platter)
	call    platter                 ;skip   platter
	call    diskselcc               ;look for /taa,#n
	and     dx,0fffh
	cmp     dh,03h                  ;310 --> d11
	jnz     copyplat_4              ;d10 --> d10
	cmp     dl,40h                  ;b10 --> d10
	jnz     copyplat_5              ;340 --> x
	mov     ebx,cpbase
	mov     [ebx].@soudev,dx
	jmp     copyplat_1
copyplat_5:
	inc    dl
copyplat_4:
	mov     word ptr r0,dx
	mov     bx,word ptr r0
	mov     edx,cpbase
	mov     [edx].@soudev,bx
	push    word ptr r0
	and     r0,0f0h
	call    finddev                 ;look whether the device is used
	pop     word ptr r0
	test    r3,0fh                  ;br if device is used by other partitions
	jnz     copyplat
	mov     ebx,dword ptr cpbase
	mov     byte ptr [ebx].@soudev_f,0
	xor     ebx,ebx
	mov     bl,r0                   ;get the platter hog byte
	add     ebx,offset plat
	test    byte ptr [ebx],80h
	jz      copyplat_1              ;br if platter not hog
	mov     al,byte ptr [ebx]
	and     al,0fh
	cmp     al,part_
	jnz     copyplat_2              ;br if platter is used by other partition
	mov     ebx,dword ptr cpbase
	mov     byte ptr [ebx].@soudev_f,1
copyplat_1:

	mov     sl,01h
	call    filename
	call    sctrange        ;PROCESS START-END ADDR SPECIFICATION
	mov     sl,02h
	call    cclto
;
	call    platter                 ;skip   platter
	call    diskselcc               ;look for /taa,#n
	and     dx,0fffh
	cmp     dh,03h                  ;310 --> d11
	jnz     copyplat_4x             ;d10 --> d10
	cmp     dl,40h                  ;b10 --> d10
	jnz     copyplat_5x             ;340 --> x
	mov     ebx,cpbase
	mov     [ebx].@desdev,dx
	jmp     copyplat_6
copyplat_5x:
	inc    dl
copyplat_4x:
	mov     word ptr r0,dx
	mov     bx,word ptr r0
	mov     edx,cpbase
	mov     [edx].@desdev,bx
	push    word ptr r0
	and     r0,0f0h
	call    finddev                 ;look whether the device is used
	pop     word ptr r0
	test    r3,0fh                  ;br if device is used by other partitions
	jnz     copyplat
	mov     ebx,dword ptr cpbase
	mov     byte ptr [ebx].@desdev_f,0
	mov     ebx,0
	mov     bl,r0                   ;get the platter hog byte
	add     ebx,offset plat
	test    byte ptr [ebx],80h
	jz      copyplat_6              ;br if platter not hog
	mov     al,byte ptr [ebx]
	and     al,0fh
	cmp     al,part_
	jnz     copyplat_2              ;br if platter is used by other partition
	mov     ebx,dword ptr cpbase
	mov     byte ptr [ebx].@desdev_f,1
copyplat_6:
	mov     textptr,aux05           ;restore
	mov     ebx,cpbase
	mov     bx,[ebx].@soudev
	cmp     bx,340h
	jz      copyplat_10
	and     ebx,0ffh
	add     ebx,offset plat
	mov     al,part_
	or      al,80h
	mov     ah,[ebx]
	or      al,ah
	mov     [ebx],al
copyplat_10:
	mov     ebx,cpbase
	mov     bx,[ebx].@desdev
	cmp     bx,340h
	jz      real_beg
	and     ebx,0ffh
	add     ebx,offset plat
	mov     al,part_
	or      al,80h
	mov     ah,[ebx]
	or      al,ah
	mov     [ebx],al
real_beg:
	ret


;         TITLE     COPY
;*     COPY: PROCESS A 'COPY' STATEMENT
;*
;*          2600 FORMAT:
;*
;*             COPY platter [file#,] [(expr,expr)] TO
;*                           disk-addr,
;*
;*               platter [file#,] [(expression)]
;*                        disk-addr,
;*
;*          2200 FORMAT:
;*
;*             COPY [file#, ] FR [(expr,expr)]
;*                 disk-addr, RF
;*
;*          ENTRY: TEXTPTR POINTS TO AFTER 'COPY'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3,4,5,C-F
;*
;*          NOTE: READ AND WRITE TO DISK CURRENTLY HANG
;*                IF DISK DOESN'T RECOGNIZE READ/WRITE
;*                COMMAND -- 2200 ONLY PERMITS 2 RETRIES.
;*                ALSO, 2200 DOES NOT RETRY IF LRC ERROR!
;*                SHOULD RETRY (N TIMES) IN EITHER CASE
;*                ==> SINGLE READ/WRITE ROUTINE.
;*
;*               COPY COULD READ AS MANY SECTORS AS WOULD
;*               FIT IN MEMORY BEFORE WRITING. MIGHT
;*               IMPROVE MULTI-PLEXED COPYING OR MIGHT
;*               INCREASE TRACK MOVEMENT.
;*
;*               SHOULD END (SOURCE & DESTINATION) SECTORS
;*               BE READ BEFORE COPY TO ENSURE COPY WILL
;*               WORK? DOESN'T DO MUCH! SAVE CODE BY NOT
;*               DOING IT.
;
;* RELEASE 2.1:  both disks hogged for entire copy operation.
;
;* THERE ARE TWO COPY FORMAT --- 2200 & 2600

COPY:
	MOV     EAX,DWORD PTR [CPBASE]
	MOV     BYTE PTR [EAX].@MOVEFLAG,1
	CALL    RAWOFF          ;READ-AFTER-WRITE OFF
	CALL    FRRF            ;PROCESS 'RF' OR 'FR'
	TEST    R0,0FH
	JZ      COPY22F2
	CMP     BYTE PTR [TEXTPTR],'/'
	JE      M43_T1
	CMP     BYTE PTR [TEXTPTR],'#'
	JNE     M43_T2
M43_T1:
	INC     TEXTPTR
	JMP     COPY22F1
M43_T2:

;*-------- 2600 FORMAT ----------

	call    test_plat
	CALL    PLATTER         ;PROCESS 'FROM' PLATTER SPECIFICATION
	CALL    DISKSELC        ;PROCESS 'FROM' #n, OR /xyz, PLATTER
	TEST    SL,2
	JZ      COPY1
	CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX

	MOV     EDX,AUX0E
	MOV     AUX05,EDX       ;AUX05 ----  'FROM' PLATTER SPEC.
	MOV     EDX,ACTDEV
	MOV     AUX04,EDX       ;AUX04 ----  'FROM' DEVICE TYPE & ADDRESS

COPY1:
	CALL    SCTRANGE        ;PROCESS START-END ADDR SPECIFICATION
	CALL    CCLTO           ;LOOK FOR 'TO'
	CALL    PLATTER         ;AUX0E --- 'TO' PLATTER SPEC.
	CALL    DISKSELC        ;PROCESS 'TO' #n, OR /xyz, PLATTER
	CALL    SCTRTO          ;PROCESS 'TO' START ADDR
	TEST    SL,2
	JZ      MVCPYEND

COPY3:
	CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX
	CALL    HPION           ;HIGH PRIORITY I/O ON
	CALL    COPYS           ;COPY SECTOR
COPY2:
	JMP     MVCPYEND        ;DISABLE DISK, EXIT

;*--------   2200 FORMAT:  -------------
COPY22F1:
	MOV     TEXTPTR,EDX     ;DECREMENT TEXTPTR
	CALL    DISKSELC        ;PROCESS #n, OR /xyz, PLATTER
	CALL    FRRF            ;PROCESS 'FR' OR 'RF'
	CMP     R0,0
	JZ      COPY22F3
	JMP     ERROR_19
COPY22F3:
	TEST    SL,2
	JZ      COPY22F4
	MOV     EDX,ACTDEV
	MOV     AUX04,EDX
	CALL    COPYX           ;SETUP AUXS TO ACTIVATE FROM DISK
	CALL    CMNDINIT        ;TRANSFER FROM DISK ADDR

COPY22F4:
	CALL    SCTRANGE
	TEST    SL,2
	JZ      MVCPYEND_X
	MOV     EDX,AUX0F
	MOV     AUX03,EDX
	CALL    COPYX

	CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX
	CALL    HPION           ;HIGH PRIORITY I/O ON
	CALL    COPYS           ;COPY SECTOR
	TEST    SL,2
	JZ      MVCPYEND_X
	CALL    ENDDISK
	CALL    COPYXA
MVCPYEND_X:
	JMP     ENDSDISK

COPY22F2:
	CALL    DISKADRD        ;ENABLE DEFAULT DISK
	JMP     COPY22F3

;         TITLE     FRRF
;*     FRRF: SCAN & PROCESS 'FR' OR 'RF' PARAMETER
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN:
;*               F0 = 0 IF FOUND
;*                    TEXTPTR POINTS AFTER 'RF' OR 'FR'
;*                    IN EXECUTION PHASE,
;*                         AUX5 = FROM PLATTER
;*                         AUXE = TO PLATTER
;*               F0 <> 0 IF NOT FOUND
;*                    TEXTPTR POINTS AT NEXT NONBLANK
;*                         TEXT CHARACTER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,AUX0
;*               IN EXECUTION PHASE, AUX5,E
;*
FRRF:
	CMP     BYTE PTR [TEXTPTR],'F'
	MOV     AUX00,TEXTPTR
	JNE     FRRF1
	INC     TEXTPTR
	CMP     BYTE PTR [TEXTPTR],'R'
	JNE     FRRF2
	INC     TEXTPTR
	MOV     R0,0

	TEST    SL,2
	JZ      FRRF3
	MOV     AUX05,1         ;'FROM' PLATTER = FIXED (F)
	MOV     AUX0E,2         ;'TO' PLATTER = REMOVABLE (R)
FRRF3:
	RET

FRRF1:
	CMP     BYTE PTR [TEXTPTR],'R'
	MOV     AUX00,TEXTPTR
	JNE     FRRF2
	INC     TEXTPTR
	CMP     BYTE PTR [TEXTPTR],'F'
	JNE     FRRF2
	INC     TEXTPTR
	MOV     R0,0

	TEST    SL,2
	JZ      FRRF3
	MOV     AUX05,2         ;'FROM' PLATTER = REMOVABLE (R)
	MOV     AUX0E,1         ;'TO' PLATTER = FIXED (F)
	RET

FRRF2:
	MOV     R0,1
	MOV     EDX,AUX00
	MOV     TEXTPTR,EDX     ;RESTORE TEXTPTR
	RET

;         TITLE     COPYS
;*     COPYS: COPY A GROUP OF SEQUENTIAL SECTORS FROM
;*            ONE DISK PLATTER TO ANOTHER
;*
;*          ENTRY: PHASE = EXECUTION
;*               AUXF = 'FROM' START SECTOR ADDRESS
;*               AUXD = 'FROM' END SECTOR ADDRESS
;*               AUX5 = 'FROM' PLATTER SPECIFICATION
;*               AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*
;*               AUX3 = 'TO' START SECTOR ADDRESS
;*               AUXE = 'TO' PLATTER SPECIFICATION
;*               ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*
;*          RETURN:
;*               AUXF = 'FROM' END ADDRESS +1
;*               AUXD = 'FROM' END ADDRESS
;*               F7,6 = 'FROM' END ADDRESS
;*               AUXE = 'FROM' PLATTER SPEC.
;*               ACTDEV = 'FROM' DEVICE TYPE & ADDRESS
;*
;*               AUX3 = 'TO' SECTOR ADDRESS OF LAST
;*                      SECTOR COPIED +1
;*               AUX4 = 'TO' DEVICE TYPE & ADDRESS
;*               AUX5 = 'TO' PLATTER SPECIFICATION
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-3,6,7
;*                              AUX0,1,3,4,5,C,E,F
;*
COPYS:
	MOV     EDX,AUX0D
	MOV     WORD PTR R6,DX  ;F7,6 = END SECTOR ADDR FOR COPY
	MOV     EDX,AUX0F       ;AFTER EXCHANGE : AUX3 = 'FROM' START SECTOR ADDRESS
	XCHG    EDX,AUX03       ;                 AUXF = 'TO' START SECTOR ADDRESS
	MOV     AUX0F,EDX       ;SUBROUTINE COPYXB WILL EXCHANGE ALL INFORMATION BETWEEN 'FROM' AND 'TO'

	MOV     EDX,ACTDEV
	AND     DH,0FH
	CMP     DH,_PHOENIX
	JNZ     COPYS1          ;BRANCH IF 'TO' DISK NOT PHOENIX
	AND     DL,30H          ;F0 = PRIMARY ADDR OF 'TO' DISK

	MOV     EAX,AUX04
	AND     AH,0FH
	CMP     AH,_PHOENIX
	JNZ     COPYS1          ;BRANCH IF 'FROM' DISK NOT PHOENIX
	AND     AL,30H
	CMP     AL,DL
	JNZ     COPYS1          ;BRANCH IF DIFFERENT PHOENIX UNIT

;*PHOENIX COPY -- 'TO' & 'FROM' SAME DISK PROCESSOR
;
COPYSP:
	CALL    COPYXB          ;ENABLE 'FROM' DEVICE
copysp1x:
	MOV     EDX,0           ; EDX = RETRY COUNT --- 16 MAX.
COPYSP1:
	INC     EDX
	PUSH    EDX
BP43A_01:
	CALL    CMNDINIT
	MOV     EDX,AUX0F
	MOV     R0,?AMEXTEND    ;EXTENDED COMMAND
	MOV     R2,?AMCOPY      ;COMMAND = COPY
	CALL    DISKCMND        ;COMMAND/PLATTER/SECTOR ADDRESS ==> DISK
	CMP     R0,0
	JZ      COPYSP2
;
	cmp     k,60h           ;ECHO = 60h indicates extended command reject
	jnz     retry_7         ;
				;if denied , no partitions interfere this device
				;for example, copy t/d21,(xx,yy)tot/d22,(zz)
				;when d21 or d22 is denied,you can't delete the mark
				;in the MDT for another partition issue $open!/d21
;
	mov     eax,actdev
	and     al,0f0h
	mov     k,al
	call    srchdev

	test    cl,devopen
	jnz     copye1e

	and     byte ptr [edx],0ffh-devuse
	mov     eax,actdev
	and     al,030h
	mov     byte ptr fs:[_abs],al
	mov     al,0
	call    cbsnr                           ;unhog device
	call    enblnlldh                       ;disable disk
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	mov     eax,actdev
	and     al,030h
	mov     r0,al
	call    wakeupa
	jmp     copy1ef

copye1e:
	and     byte ptr [edx],0ffh-devoip
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,1
	call    breakptt
copy1ef:
	mov     edx,actdev
	call    enbldevd
	jmp     copysp1x
;
;
retry_7:
	POP     EDX
	CMP     EDX,10H
	JNZ     RETRYCPY
	JMP     ERROR_94

RETRYCPY:
	TEST    R0,0F0H
	JZ      COPYSP1         ;BRANCH IF ECHO ERROR
	TEST    R0,0FH
	JZ      COPYSP1
	MOV     R2,4
	CALL    IOBUFTXT        ;make sure at least a 1K buffer
	JMP     COPYS11         ;BRANCH IF DPU COPY NOT SUPPORTED
	CALL    IOBUFTXT
	JMP     COPYS11

COPYSP2:
	CALL    AKN             ;ACKNOWLEDGEMENT OF VALID SECTOR ADDRESS
	MOV     EDX,AUX0D
	CALL    DISKCMDA        ;'FROM' END ADDRESS ==> DISK
	CMP     R0,0
	JZ      COPYSP2A
	POP     EDX
	CMP     EDX,10H         ;BRANCH IF < 16 RETRIES
	JNZ     COPYSP1
	JMP     ERROR_94

COPYSP2A:
	CALL    AKN
	CALL    COPYXB          ;ENABLE 'TO' DEVICE
	MOV     R0,0
	MOV     EDX,AUX0F
	CALL    DISKCMND        ;'TO' PLATTER/SECTOR ADDRESS ==> DISK
	CMP     R0,0
	JZ      COPYSP2B        ;BRANCH IF NO ECHO ERROR
;
	cmp     k,60h           ;ECHO = 60h indicates extended command reject
	jnz     retry_8
;
	mov     eax,actdev
	and     al,0f0h
	mov     k,al
	call    srchdev

	test    cl,devopen
	jnz     copye2e

	and     byte ptr [edx],0ffh-devuse
	mov     eax,actdev
	and     al,030h
	mov     byte ptr fs:[_abs],al
	mov     al,0
	call    cbsnr                           ;unhog device
	call    enblnlldh                       ;disable disk
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	mov     eax,actdev
	and     al,030h
	mov     r0,al
	call    wakeupa
	jmp     copy2ef

copye2e:
	and     byte ptr [edx],0ffh-devoip
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,1
	call    breakptt
copy2ef:
	jmp     copysp
;
retry_8:
;
	POP     EDX
	CMP     EDX,10H
	JNZ     COPYSP2C
	JMP     ERROR_94

COPYSP2C:
	INC     EDX
	PUSH    EDX
	CALL    COPYXB
	JMP     BP43A_01

COPYSP2B:
	POP     EDX             ;CLEAN STACK
	CALL    AKN
	MOV     K,0
	CALL    OBSDISK         ;START COPYING
	CALL    AKN1            ;COPY ACKNOWLEDGEMENT
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	CALL    COPYXB          ;SWITCH PTRS

	MOV     BX,WORD PTR R6
	MOV     DX,BX
	ADD     DX,1
	XCHG    EDX,AUX0F       ;AUXF = END SECTOR ADDR +1
	MOV     EAX,EDX
	SUB     BX,AX
	MOV     EDX,AUX03       ;# SECTOR COPIED -1
	ADD     DX,BX
	ADD     DX,1
	MOV     AUX03,EDX       ;AUX4 = 'TO' ADDR OF LAST SECTOR COPIED +1
	RET
;
;*COPY -- NOT ON A SINGLE PHOENIX UNIT
;
COPYS1:
	CALL    COPYX           ;SETUP 'FROM' DEVICE INFORMATION
COPYS11:
	MOV     EDX,AUX0F       ;PC'S = 'FORM' SECTOR ADDR
	CMP     WORD PTR R6,DX
	JB      COPYS2
	CALL    DREAD4S         ;READ UP TO 4 SECTOR 'FROM' DEVICE
	CALL    COPYX           ;SETUP 'TO' DEVICE INFORMATION

	MOV     EDX,ACTDEV
	AND     DH,0FH
	CMP     DH,_PHOENIX
	JZ      COPYS3          ;BRANCH IF PHOENIX WRITING TO
	CALL    DWRITENS        ;WRITE SECTORS THAT WERE READ TO 'TO' DEVICE
	JMP     COPYS1

COPYS2:
	RET

;*WRITING TO PHOENIX
COPYS3:
	CALL    MSWRTBEG        ;BEGIN MULTI-SECTOR WRITE
	CALL    DWRITENS        ;WRITE SECTORS
	CALL    MSWRTEND        ;END MULTI-SECTOR WRITE
	JMP     COPYS1

;         TITLE     COPYX COPYXA
;*     COPYX: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*               AUXF,AUX3 = 'FROM' & 'TO' CURRENT SECTOR
;*                           ADDRESSES
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               AUXF,AUX3 EXCHANGED
;*               NEW ACTDEV ENABLED
;*               AUXC = ADDRESS OF I/O BUFFER (>=1K)
;*               F1 = # OF PAGES OF BUFFERING
;*
;*          MODIFIED REGISTERS: PC'S,K,F0-2,AUX3,4,5,C,E,F
;*
;*     COPYXA: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               NEW ACTDEV ENABLED
;*
;*          MODIFIED REGISTERS: PC'S,K,AUX4,5,E
;*
;*     COPYXB: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*               AUXF,AUX3 = 'FROM' & 'TO' CURRENT SECTOR
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               AUXF,AUX3 EXCHANGED
;*               NEW ACTDEV ENABLED
;*
;*          MODIFIED REGISTERS: F0,1,CH,CL,PC'S,K,
;*                              AUX0,3,4,5,E,F
;*
;
;*Release 2.1:  disk being disabled is not released.
;
COPYX:
	MOV     R2,4
	CALL    IOBUFTXT        ;MAKE SURE 1K BUFFER AVAIABLE; AUXC POINT TO BUFFR
COPYXB:
	MOV     EDX,AUX0F
	XCHG    EDX,AUX03       ;AUX3 = AUXF; AUXF = AUX3
	MOV     AUX0F,EDX
COPYXA:
	MOV     EDX,ACTDEV
	XCHG    EDX,AUX04       ;AUX4 = ACTDEV; ACTDEV = AUX4
COPYXA1:
	CALL    ENBLDEVD
	MOV     EDX,AUX05
	XCHG    EDX,AUX0E       ;AUX5 = AUXE; AUXE = AUX5
	MOV     AUX05,EDX
	RET

;         TITLE     MOVEEND
;*     MOVEEND: PROCESS A 'MOVEEND' STATEMENT
;*
;*          FORMAT:
;*
;*               MOVE END platter [ file#[,]] = expression
;*                                disk-addr[,]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'END'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,E,F
;*
MOVEEND:
	CALL    PLATTER
	CALL    DISKSEL         ;PROCESS #n[,] or /xyy[,] PARAMETER
	CMP     BYTE PTR [TEXTPTR],'='
	JNE     ERROR_12        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	CALL    EXPR
	TEST    SL,2
	JZ      MOVEEND1

	CALL    FLTBINB         ;CONVERT EXPR VALUE TO BINARY (NEW CAT. END)
	MOV     BX,WORD PTR R0
	MOV     AUX0F,EBX       ;AUX0F = NEW CAT. END
	INC     BX              ;BX = NEW CAT. END + 1
	PUSH    EBX             ;AVOID ALTERED BY CALLED SUBROUTINE

	CALL    DREADSF         ;READ NEW CAT. END (TO BE SURE LEGAL PLATTER ADDR)
	MOV     EDX,AUX0C       ;AUX0C = PTR TO DATA TO BE WRITTEN
	XCHG    EDX,AUX0F
	DEC     DX              ;PC'S SECTOR TO BE WRITTEN
	CALL    DWRITE          ;WRITE A SECTOR (VALID SECTOR ADDRESS CHECK)

	CALL    CURENDR         ;DX = CURRENT CAT. END
	POP     EBX             ;BX = NEW CAT. END
	CMP     BX,DX
	JBE     MOVEEND2
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR

	ADD     EDX,4
	MOV     [EDX],BH
	INC     EDX
	MOV     [EDX],BL        ;NEW END ==> I/O BUFFER

	CALL    RAWON           ;FLAG = READ-AFTER-WRITE
	MOV     AUX0F,0
	CALL    DWRITE?DAF

MOVEEND1:
	JMP     ENDSDISK
MOVEEND2:
	JMP     ERROR_86        ;CATALOG END ERROR

;         TITLE     NEXTFILE
;*     NEXTFILE: GET NEXT FILE ENTRY FROM DISK INDEX
;*               (SCRATCHED OR ACTIVE)
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER SPEC.
;*               AUX6 = SECTOR ADDRESS OF CURRENT INDEX
;*                      SECTOR
;*               AUX7,LOW BYTE = ENTRY NO. OF NEXT ENTRY
;*                               IN CURRENT INDEX SECTOR
;*                   ,HIGHBYTE = NO. OF INDEX SECTORS
;*
;*               THUS, WHEN ENTERING FOR 1ST TIME:
;*                    AUX6 = 0
;*                    AUX7 = nn01 (nn = NO. OF INDEX SCTR)
;*
;*          RETURN: F0 = 1 IF NO MORE FILENAMES IN INDEX
;*
;*               F0 = 0 IF FILENAME FOUND
;*                    AUXB = START ADDRESS OF FILE
;*                    AUXD = END ADDRESS OF FILE
;*                    F6 = FILE STATUS
;*                         10 IF ACTIVE
;*                         11 IF SCRATCHED
;*                    F7 = FILE TYPE
;*                         00 IF DATA FILE
;*                         80 IF PROGRAM
;*                    AUX6 INCREMENTED IF NECESSARY
;*                    AUX7,LOW BYTE = ENTRY NO. OF NEXT
;*                         ENTRY (OR 16 )
;*
;*                    WORKSPACE CONTAINS FILENAME.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,6,7
;*                              AUX0,B,C,D,F,6,7
;*
NEXTFIL3:
	MOV     EDX,AUX07
	TEST    DL,0F0H
	JZ      NEXTFIL4        ;BRANCH IF MORE ENTRIES IN CURRENT INDEX SECTOR

;   THE PARAMETER PASSING IS POOR :
;
;               AUX7,LOW   BYTE = ENTRY NO. OF NEXT ENTRY
;                                 IN CURRENT INDEX SECTOR
;                   ,HIGH  BYTE = NO. OF INDEX SECTORS
NEXTFILE:
	MOV     EDX,AUX07
	TEST    DL,0F0H
	JZ      NEXTFIL1        ;BRANCH IF MORE ENTRIES IN CURRENT INDEX SECTOR
	MOV     DL,0            ;RESET TNE ENTRY NO. = 0
	MOV     AUX07,EDX
	MOV     BL,DH           ;BL = NO. OF INDEX SECTOR

	MOV     EDX,AUX06
	INC     EDX
	CMP     BL,DL
	JBE     NEXTFIL2        ;BRANCH IF NO MORE INDEX SECTOR
	MOV     AUX06,EDX

NEXTFIL1:
	MOV     EDX,AUX06
	MOV     AUX0F,EDX
	CALL    DREADSF         ;READ INDEX SECTOR
	MOV     EDX,AUX07

NEXTFIL4:
	MOV     AUX07,EDX
	INC     AUX07
	MOV     AL,DL
	AND     EAX,0FH
	SHL     EAX,4           ;EAX = 16 * ENTRY NO.
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	ADD     EDX,EAX         ;THE ASSUMPTION THAT I/O BUFFER ORIGIN IS XX00 IS WRONG IN CS-386

	MOV     CX,[EDX]        ;  FILE STATUS (F6) = 10 IF ACTIVE, 11 IF SCRATCH
	XCHG    CH,CL
	MOV     AUX0C,EDX
	ADD     AUX0C,2
	MOV     AL,CH
	AND     AL,0F0H
	CMP     AL,10H
	JNZ     NEXTFIL3
	MOV     R6,CH
	MOV     R7,CL

	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDI,[EDX].@WORKSPC
	CALL    GTFLPTRS        ;GET START, END ADDR OF FILE
	ADD     EDX,4
	MOV     ESI,EDX
	MOV     ECX,8
	REP     MOVSB

	MOV     R0,0            ;FLAG = FOUND
	RET

NEXTFIL2:
	MOV     R0,1            ;FLAG = NO MORE IN INDEX
	RET

;         TITLE     SCTRANGE
;*     SCTRANGE: PROCESS SECTOR RANGE PARAMETER
;*
;*          FORMAT: [(start-addr-expr, end-addr-expr)]
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 DISK ENABLED
;*                 AUXE = PLATTER
;*
;*          RETURN: TEXTPTR POINTS AFTER SECTOR-RANGE SPEC
;*               IN EXECUTION PHASE,
;*                  AUXF = START-ADDRESS (DEFAULT = 0)
;*                  AUXD = END-ADDRESS (DEFAULT = CURRENT
;*                            END OF CATALOG AREA)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,D,F
;*
;*     SCTRANGA: GET DEFAULT SECTOR RANGE (0 TO CURRENT
;*               END OF CATALOG AREA)
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXF = 0 (START ADDRESS)
;*               AUXD = CURRENT END OF CATALOG AREA
;*                      (END ADDRESS)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1
;*                              AUX0,C,D,F
;*
SCTRANGE:
	CMP     BYTE PTR [TEXTPTR],'('
	JNE     SCTRANGA
	INC     TEXTPTR
	CALL    EXPR
	CMP     BYTE PTR [TEXTPTR],','
	JNE     ERROR_13        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	CALL    EXPR
	CMP     BYTE PTR [TEXTPTR],')'
	JNE     ERROR_11        ;BRANCH IF NOT MATCH
	INC     TEXTPTR

	TEST    SL,2
	JZ      SCTRANG2
	CALL    FLTBINB
	MOV     BX,WORD PTR R0
	MOV     AUX0D,EBX       ;AUX0D -- END ADDRESS

	CALL    FLTBINB
	MOV     DX,WORD PTR R0
	MOV     AUX0F,EDX       ;AUX0F -- START ADDRESS

	MOV     BX,WORD PTR AUX0D
	CMP     BX,DX
	JB      BP43C_01
SCTRANG2:
	RET

BP43C_01:
	JMP     ERROR_32

SCTRANGA:
	TEST    SL,2
	JZ      SCTRANG2
	CALL    CURENDR
	MOV     AUX0D,EDX
	MOV     AUX0F,0
	RET

;         TITLE     SCTRTO
;*     SCTRTO: PROCESS DESTINATION SECTOR ADDR PARAMETER
;*
;*          FORMAT: [(expression)]
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER SECTOR PARAMETER
;*               IN EXECUTION PHASE,
;*                  PC'S & AUX3 = SECTOR ADDRESS
;*                                (DEFAULT = AUXF)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3
;*
SCTRTO:
	CMP     BYTE PTR [TEXTPTR],'('
	JNE     SCTRTO1
	INC     TEXTPTR
	CALL    EXPR
	CMP     BYTE PTR [TEXTPTR],')'
	JNE     ERROR_11        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	TEST    SL,2
	JZ      SCTRTO2
	CALL    FLTBINB
	MOV     DX,WORD PTR R0

SCTRTO3:
	MOV     AUX03,EDX
SCTRTO2:
	RET
SCTRTO1:
	MOV     EDX,AUX0F
	TEST    SL,2
	JNZ     SCTRTO3
	RET

;         TITLE     SETDEVLD
;*     SETDEVLD: DEVLOAD = ACTDEV
;*
;*          MODIFIED REGISTERS: PC'S,F0,1,CH,CL
;*
SETDEVLD:
	MOV     EBX,ACTDEV      ;ACTDEV    |1 |2 |3 |4 |
;       CALL    RDEVLOAD        ;EBX       |4 |3 |2 |1 |
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@DEVLOAD
	MOV     [EDX],BH        ;R0R1      |1 |2 |
	MOV     [EDX+1],BL      ;MOV [EDX],BX <>  OR,W1 F1,, & OR,W2 F0,
	RET

;         TITLE     $FORMAT DISK
;*FORMATD:  FORMAT DISK STATEMENT
;*
;*     SYNTAX: $FORMAT DISK platter [/xyy]
;*                                  [#n  ]
;*
;*     THIS STATEMENT FORMATS A DISK PLATTER (CURRENTLY, ONLY
;*          2260C & 2280)
;*

FORMATD:
	CALL    PLATTER
	CALL    DISKSEL
	TEST    SL,2
	JZ      FORMATD2
formatd4:
	MOV     ECX,0           ;INITIALIZE RETRY COUNT
FORMATD3:
	INC     ECX
	PUSH    ECX

@3?PD0G:
	MOV     EDX,ACTDEV
	CMP     DL,40H
	JNZ     FORMATP1
	JMP     FRMTDRAM

FORMATP1:
	CALL    CMNDINIT
	MOV     R0,?AMEXTEND
	MOV     R2,?AMFORMAT
	CALL    DISKCMDC
	CMP     R0,0
	JZ      FORMATD1
;
	cmp     k,60h           ;ECHO = 60h indicates extended command reject
	jnz     retry_5

	mov     eax,actdev
	and     al,0f0h
	mov     k,al
	call    srchdev

	test    cl,devopen
	jnz     formte1e

	and     byte ptr [edx],0ffh-devuse
	mov     eax,actdev
	and     al,030h
	mov     byte ptr fs:[_abs],al
	mov     al,0
	call    cbsnr                           ;unhog device
	call    enblnlldh                       ;disable disk
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
	mov     eax,actdev
	and     al,030h
	mov     r0,al
	call    wakeupa
	jmp     formt1ef

formte1e:
	and     byte ptr [edx],0ffh-devoip
	pop     eax
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,1
	call    breakptt
formt1ef:
	mov     edx,actdev
	call    enbldevd
	jmp     formatd4
;
retry_5:
	TEST    R0,0F0H
	JZ      FORMAT3A
	TEST    R0,0FH
	JZ      FORMAT3A
	JMP     ERROR_93
FORMAT3A:
	POP     ECX
	CMP     ECX,10H
	JNZ     FORMATD3
	JMP     ERROR_94

FORMATD1:
	POP     ECX
	MOV     K,0
	CALL    OBSDISK
	CALL    AKN1
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@hogflg,0
FORMATD2:
	JMP     ENDSDISK

;         TITLE     DREAD4S
;*     DREAD4S: READ UP TO 64 SEQUENTIAL SECTORS FROM DISK.
;*              WILL READ 64 SECTORS EXCEPT WHEN END SECTOR
;*              IS ENCOUNTERED -- CANNOT READ BEYOND END
;*              SECTOR, OR NOT THAT MUCH MEMORY AVAILABLE.
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER SPEC.
;*               AUXC = ADDRESS OF I/O BUFFER (1K BYTES)
;*               AUXF = SECTOR ADDRESS OF 1ST SECTOR
;*                      TO READ
;*               F7,6 = END SECTOR ADDRESS (CANNOT READ
;*                      BEYOND THIS SECTOR)
;*               F1 = NO. OF PAGES OF MEMORY AVAILABLE FOR BUFS
;*
;*          RETURN: AUXF = SECTOR ADDRESS +1 OF LAST
;*                         SECTOR READ
;*                  F3 = NO. OF SECTORS READ
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,3,K
;*                              AUX0,C,F
;*
DREAD4S:
	MOV     BL,40H
	CMP     BL,R1
	JBE     BP43B_01
	MOV     BL,R1           ;BL = 64 IF #PAGES > 64
BP43B_01:                       ;     #PAGES IF #PAGES < 64
	MOV     R3,0            ; COUNT --- INCREASE ONE

DREAD4S1:
	MOV     EDX,AUX0C
	ADD     EDX,100H
	XCHG    EDX,AUX0C
	XCHG    EDX,AUX0F

	CMP     WORD PTR R6,DX
	JB      DREAD4S2
	PUSH    EBX
	CALL    DREAD
	POP     EBX
	ADD     R3,1
	CMP     R3,BL
	JB      DREAD4S1
	RET

DREAD4S2:
	MOV     AUX0F,EDX
	RET

;         TITLE     MOVE
;*     MOVE: PROCESS A 'MOVE' STATEMENT
;*
;*          2600 FORMAT:
;*
;*     1. MOVE platter [ file#,] TO platter [ file#, ]  [LS=expr,] [END=expr]]
;*                     [disk-addr,]         [disk-addr,] [END=expr]
;*
;*     2. MOVE platter [ file#, ] filename TO platter
;*                     [disk-addr,]
;*
;*               [ file#,] [(expression)]
;*               disk-addr,   filename
;*
;*          2200 FORMAT:
;*
;*               MOVE [ file#, ] FR
;*                    disk-addr, RF
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'MOVE'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3-F
;*
MOVE:
	MOV     EAX,DWORD PTR [CPBASE]
	MOV     BYTE PTR [EAX].@MOVEFLAG,1
	MOV     R0,@END
	CALL    CCL
	TEST    R0,0FH
	JNZ     BP43B_02
	JMP     MOVEEND

BP43B_02:
	CALL    HPION
	CALL    RAWOFF

	CALL    FRRF
	TEST    R0,0FH
	JZ      MOVE22F2
	CMP     BYTE PTR [TEXTPTR],'/'
	JE      M43_T3
	CMP     BYTE PTR [TEXTPTR],'#'
	JNE     M43_T4
M43_T3:
	INC     TEXTPTR
	JMP     COPY22F1
M43_T4:

;*     2600 FORMAT
;*
	call    test_plat

	CALL    PLATTER
	CALL    DISKSELC
	TEST    SL,2
	JZ      MOVE1

	CALL    CMNDINIT

	MOV     EDX,AUX0E
	MOV     AUX05,EDX       ;AUX05 -- 'FROM' PLATTER SPEC.
	MOV     EDX,ACTDEV
	MOV     AUX04,EDX       ;AUX04 -- 'FROM' DEVICE TYPE/ADDRESS
	MOV     AUX06,TEXTPTR   ;AUX06 -- TEXT PTR

	CALL    DREADS0
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	MOV     CX,[EDX]
	XCHG    CH,CL
	ADD     EDX,2
	PUSH    EDX
	MOV     DX,CX
	MOV     AUX07,EDX       ;AUX07(03) -- HASH FLAG & # INDEX SECTORS
	MOV     AUX03,EDX

	POP     EDX
	ADD     EDX,2
	CALL    CUREND1
	INC     DX
	MOV     AUX08,EDX       ;AUX08 -- CURRENT END + 1

MOVE1:
	CALL    FILENAME
	CMP     R0,0
	JZ      MOVEF
;
; IF FILE FOUND , FALL THROUGH FOLLOWING SUBROUTINE
;
;*     MOVE ENTIRE CATALOG AREA
;*
;*          PLATTER MOVE ALGORITHM:
;*               1. SET UP INDEX ON 'TO' PLATTER (SAME
;*                  SIZE AS 'FROM' PLATTER)
;*               2. FOR EACH ACTIVE FILE ON 'FROM' PLATTER
;*                 A. FIND LOCATION FOR ENTRY IN 'TO'
;*                    PLATTER INDEX.
;*                 B. ADD FILE ENTRY TO 'TO' INDEX
;*                 C. COPY FILE FROM 'FROM' TO 'TO' PLATTR
;*
	CALL    CCLTO
	CALL    PLATTER
	CALL    DISKSELC

;*        CHECK IF INDEX SIZE SPECIFIED OR TAKE OLD INDEX SIZE
	MOV     R0,@LS?EQ
	CALL    CCL
	TEST    R0,0FH
	JNZ     MOVE6
	CALL    EXPR

	TEST    SL,2
	JZ      MOVE8
	CALL    FLTBINA
	TEST    R2,0FH
	JZ      MERR_34B
	MOV     DH,1
	MOV     DL,R0
	MOV     AUX03,EDX       ; AUX03 -- HASH FALG & NO. OF INDEX

MOVE8:
	CMP     BYTE PTR [TEXTPTR],','
	JNE     MOVE5
	INC     TEXTPTR

MOVE6:
	MOV     R0,@END
	CALL    CCL
	TEST    R0,0FH
	JNZ     MOVE5
	CMP     BYTE PTR [TEXTPTR],'='
	JNE     ERROR_12        ;BRANCH IF NOT MATCH
	INC     TEXTPTR
	CALL    EXPR
	TEST    SL,2
	JZ      MVCPYEND

;*        CREATE SPECIFIED INDEX
	CALL    FLTBINB
	MOV     EDX,AUX03
	MOV     DH,1
	MOV     AUX03,EDX
	MOV     DH,0            ;MASK THE HASH FLAG OUT
	CMP     WORD PTR R0,DX  ;R1R0 PAIR -- RETURN BINARY VALUE OF SUBROUTINE FLTBINB
	JB      MOVE7
	MOV     DX,WORD PTR R0
	INC     DX
	MOV     AUX08,EDX       ;AUX08 -- END = ? CATALOG END
	JMP     MOVE5

;*        ERROR IF NO. OF INDEX SECTORS=0
;
MERR_34B:
	JMP     ERR_34B

;*        ERROR IF END<NO. OF INDEX SECTORS
;
MOVE7:
	JMP     ERROR_86

;*        USE OLD INDEX
;
MOVE5:
	TEST    SL,2
	JZ      MVCPYEND
MOVE2:
	CALL    CMNDINIT

;*
;*     THE FOLLOWING REGISTERS ARE NOW SET UP:
;*          AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*          AUX5 = 'FROM' PLATTER SPEC.
;*          ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*          AUXE = 'TO' PLATTER SPEC.
;*
	MOV     EDX,AUX03
	MOV     WORD PTR R2,DX
	MOV     R4,0
	CMP     R3,01
	JNZ     MOVE4
	INC     R4

MOVE4:
	CALL    RHASHFLG
	MOV     AL,R4
	MOV     [EDX],AL
	MOV     EDX,AUX07
	MOV     DH,DL
	MOV     DL,1
	MOV     AUX07,EDX       ; DH = # INDEX SECTOR; DL = RETRY COUNT --- SAVE IN AUX07 FOR LATER USE

	MOV     EDX,0
	MOV     AUX06,EDX
	MOV     AL,R2
	MOV     R4,AL

	MOV     EDX,AUX08
	MOV     WORD PTR R2,DX
	CALL    INTINDX
	MOV     EDX,AUX0F
	MOV     AUX03,EDX
	CALL    COPYXA

;*     THE FOLLOWING REGISTERS ARE NOW SET UP
;*          ACTDEV = 'FROM' DEVICE TYPE & ADDRESS
;*          AUXE = 'FROM' PLATTER SPEC.
;*          AUX6 = CURRENT INDEX SECTOR ADDRESS
;*          AUX7,HIGH BYTE = NO. OF INDEX SECTORS
;*              ,LOW BYTE = NEXT ENTRY NO. (0-15)
;*
;*          AUX4 = 'TO' DEVICE TYPE & ADDRESS
;*          AUX5 = 'TO' PLATTER SPECIFICATION
;*          AUX3 = 'TO' CURRENT SECTOR ADDRESS
;*
;
;*RELEASE 2.1:  both disks now hogged for the entire move operation.
;
MOVE3:
	CALL    NEXTFILE
	TEST    R0,0FH
	JNZ     MVCPYEND
	TEST    R6,0FH
	JNZ     MOVE3
	MOV     AL,R7
	AND     AL,0F0H
	CMP     AL,80H
	JZ      BP43B_03
;
; cs-386 format
;
	cmp     al,40h
	jz      bp43b_03
;
	test    r7,0f0h
	JNZ     move3

;*        CHECK THAT CATALOG END WILL NOT BE EXCEEDED
BP43B_03:                       ;SEE SUBROUTINE "NEXTFILE" IN BPMVP43C.ASM
	MOV     EBX,AUX0D
	SUB     BX,WORD PTR AUX0B
	SUB     BX,1
	ADD     BX,WORD PTR AUX03
	CMP     BX,WORD PTR AUX08
	JB      BP43B_04

	mov     edx,cpbase
	mov     ax,word ptr [edx].@soudev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need5
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need5:
	mov     ax,word ptr [edx].@desdev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need6
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need6:
	JMP     ERROR_81

BP43B_04:
	CALL    COPYXA
	MOV     DL,R7
	MOV     AUX0A,EDX       ;BYTE PTR AUX0A = FILE TYPE
	MOV     EDX,AUX0B
	MOV     AUX0F,EDX       ;AUX0F = 'FROM' START ADDRESS

	CALL    COPYS
	MOV     EBX,AUX0D               ;ORIGIN SECTOR 2 -- 4
	SUB     BX,WORD PTR AUX0B       ;BX=1
	SUB     BX,1                    ;DEST  SECTOR  5 -- 7


	MOV     EDX,AUX03       ;AFTER CALLING SUBROUITNE "COPYS", AUX03 = "TO" END SECTOR + 1
	MOV     AUX0D,EDX
	DEC     AUX0D           ;AUX0D = "TO" EOF
	SUB     DX,BX
	SUB     DX,1
	MOV     AUX0B,EDX
	DEC     AUX0B           ;AUX0B = "TO" SOF

	CALL    COPYXA
	CALL    FINDNAMH
	TEST    R3,0F0H
	JZ      BP43B_05
	JMP     ERROR_83
BP43B_05:
	test    r3,0fh
	jnz     error_85
	MOV     EDX,AUX0A
	MOV     AUX0A,3         ;FOR ADDIFILE -- CREATE A NEW FILE

	MOV     R7,DL
	CALL    ADDIFILE
	CALL    COPYXA
	JMP     MOVE3

;*     2200 FORMAT
;
;*
MOVE22F1:
	MOV     TEXTPTR,EDX
	CALL    DISKSELC
	CALL    FRRF
	CMP     R0,0
	JZ      MOVE22F3
	JMP     ERROR_19
MOVE22F3:
	TEST    SL,2
	JZ      MVCPYEND
	MOV     EDX,ACTDEV
	MOV     AUX04,EDX
	CALL    CMNDINIT

	CALL    COPYXA
	CALL    DREADS0
	MOV     EDX,DWORD PTR [CPBASE]
	LEA     EDX,[EDX].@IOBUFFR
	MOV     CX,[EDX]
	XCHG    CH,CL
	MOV     WORD PTR R2,CX

	MOV     BL,0
	CMP     R3,01
	JNZ     MOVE2A
	MOV     BL,01

MOVE2A:
	CALL    RHASHFLG
	MOV     [EDX],BL        ;SAVE HASH GLAG
	MOV     DL,1
	MOV     DH,R7
	MOV     AUX07,EDX       ;AUX07 -- SAME AS 2600 FORMAT

	MOV     EDX,0
	MOV     AUX06,EDX
	MOV     AL,R2
	MOV     R4,AL
	CALL    CATEND
	INC     DX
	MOV     AUX08,EDX
	MOV     WORD PTR R2,DX

	CALL    COPYXA
	CALL    INTINDX
	MOV     EDX,AUX0F
	MOV     AUX03,EDX
	CALL    COPYXA
	JMP     MOVE3

MOVE22F2:
	CALL    DISKADRD
	JMP     MOVE22F3
;
;
;*     MOVE (APPEND) ONE FILE
;*
;*          ENTRY (EXECUTION PHASE):
;*               AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*               AUX5 = 'FROM' PLATTER SPEC.
;*               AUX6 = ADDRESS OF FILENAME IN TEXT LINE
;*               FILENAME ==> SCRATCH AREA (1ST 8 BYTES)
;*
;*          ALGORITHM:
;*               1. GET NAME OF FILE TO MOVE ('FILENAME')
;*               2. GET LIMITS OF FILE TO MOVE ('FINDNAMH'
;*                  (ERROR IF NF OR SCRATCHED)
;*               3. GET LIMITS OF WHERE FILE IS TO BE
;*                  MOVED TO
;*               4. ERROR IF FILE TOO LARGE FOR DESTINATIO
;*               5. MOVE FILE ('COPYS')
;*               6. WRITE EOF BLOCK ('DWRITE$')
;*               7. ADD FILENAME TO INDEX ('ADDIFILE')
;*
MOVEF:
	mov     eax,dword ptr [cpbase]
	mov     byte ptr [eax].@moveflag,1
	CALL    CCLTO
	CALL    PLATTER
	CALL    DISKSELC
	CALL    FILELOCS
	TEST    SL,2
	JZ      MVCPYEND

	CALL    CMNDINIT
	MOV     EDX,AUX06       ;EXCHANGE  TEXTPTR,AUX06 ONLY
	XCHG    EDX,TEXTPTR
	MOV     AUX06,EDX
	CALL    NEWNAMEF
	MOV     EDX,AUX0B
	MOV     AUX03,EDX       ;AUX03 = 'TO' SOF
	MOV     EDX,AUX0D
	MOV     AUX02,EDX       ;AUX02 = 'TO' EOF

	CALL    COPYXA
	CALL    FINDNAMH
	CMP     R3,10H
	JZ      BP43B_06
;
	mov     edx,cpbase
	mov     ax,word ptr [edx].@soudev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need1
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need1:
	mov     ax,word ptr [edx].@desdev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need2
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need2:
;
	JMP     ERROR_82

BP43B_06:
	MOV     TEXTPTR,AUX06   ;RESTORE TEXTPTR
	MOV     EDX,AUX0C
	MOV     CX,[EDX]
	XCHG    CH,CL
	ADD     AUX0C,2
	MOV     AUX06,ECX       ;SAVE FILE TYPE & STATUS
	CALL    GTFLPTRS        ;AUXB = 'FROM' SOF
				;AUXD = 'FROM' EOF
	MOV     EBX,AUX0D
	SUB     BX,WORD PTR AUX0B
	SUB     BX,1
	ADD     BX,WORD PTR AUX03
	CMP     BX,WORD PTR AUX02
	JB      BP43B_11

	mov     edx,cpbase
	mov     ax,word ptr [edx].@soudev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need3
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need3:
	mov     ax,word ptr [edx].@desdev
	and     eax,0ffh
	cmp     ax,40h
	je      n_need4
	add     eax,offset plat
	mov     byte ptr [eax],00h              ;unhog plat
n_need4:
	JMP     ERROR_81

BP43B_11:
	CALL    COPYXA
	DEC     WORD PTR AUX0D

;*     THE FOLLOWING REGISTERS ARE NOW SET UP:
;*
;*          AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*          AUX5 = 'FROM' PLATTER
;*          AUXB = 'FROM' SOF ADDRESS
;*          AUXD = 'FROM' EOF ADDRESS -1
;*
;*          ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*          AUXE = 'TO' PLATTER
;*          AUX3 = 'TO' SOF ADDRESS
;*          AUX2 = 'TO' EOF ADDRESS (OLD)
;*
	MOV     EDX,AUX03
	XCHG    EDX,AUX0B
	MOV     AUX0F,EDX
	CALL    COPYS

	CALL    COPYXB
	MOV     EDX,AUX0F
	MOV     AUX0D,EDX
	MOV     EDX,AUX0A

;*_     FILE & CHECK EOF <= END CAT. AREA
	TEST    DL,2
	JNZ     BP43B_07
	MOV     EDX,AUX02
	MOV     AUX0D,EDX

BP43B_07:
	CALL    NEWEOF
	CALL    COPYXB
	CALL    DREADSF
	CALL    COPYXB
	MOV     EDX,AUX0D
	MOV     AUX0F,EDX

	CALL    DWRITE?DAF
	CALL    FINDNAMH
	MOV     EDX,AUX06
	MOV     R7,DL
	CALL    ADDIFILE

MVCPYEND:
	TEST    SL,2
	JZ      MVCPYEN1
	CALL    ENDDISK
	CALL    COPYXA

	mov     eax,cpbase
	mov     bx,[eax].@soudev        ;we make some
	cmp     bx,340h
	jz      mvcpyend_1
	cmp     byte ptr [eax].@soudev_f,1
	je      mvcpyend_1
	mov     r0,bl
	and     ebx,0ffh
	add     ebx,offset plat
	mov     byte ptr [ebx],0
	call    wakeupp
mvcpyend_1:
	mov     eax,cpbase
	mov     bx,[eax].@desdev        ;we make some
	cmp     bx,340h
	jz      mvcpyen1
	cmp     byte ptr [eax].@desdev_f,1
	je      mvcpyen1
	mov     r0,bl
	and     ebx,0ffh
	add     ebx,offset plat
	mov     byte ptr [ebx],0
	call    wakeupp

MVCPYEN1:
	JMP     ENDSDISK

;         TITLE     DWRITENS
;*     DWRITENS: WRITE N SEQUENTIAL SECTORS TO DISK WHERE
;*               DATA TO WRITE IS LOCATED SEQUENTIALLY IN
;*               I/O BUFFER. READ-AFTER-WRITE IS NOT
;*               PERFORMED.
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXC = ADDRESS OF I/O BUFFER
;*               AUXF = SECTOR ADDRESS OF 1ST SECTOR TO
;*                      WRITE
;*               AUXE = PLATTER SPECIFICATION
;*               F3 = NO. OF SECTORS TO WRITE
;*
;*          RETURN: AUXF = SECTOR ADDRESS +1 OF LAST
;*                         SECTOR WRITTEN
;*                  F3 = 0
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,3,K
;*                              AUX0,C,F
;*
DWRITENS:
	MOV     EDX,AUX0C
	ADD     EDX,100H
	XCHG    EDX,AUX0C
	XCHG    EDX,AUX0F
	CALL    DWRITE
	DEC     R3
	JNZ     DWRITENS
	RET
CODE    ENDS
	END
