;***************************************************************************        
;
;          P R E - A M B L E   F O R   C O D E   M O D U L E S
;
;****************************************************************************
          .386P
          PAGE 58,132

CGROUP    GROUP CODE
DGROUP    GROUP DATA,CONST,STACK

CODE      SEGMENT PUBLIC  DWORD  'CODE'
CODE      ENDS
DATA      SEGMENT PUBLIC  PARA   'DATA'
DATA      ENDS
CONST     SEGMENT PUBLIC  DWORD  'CONST'
CONST     ENDS
STACK     SEGMENT STACK   DWORD  'STACK'
STACK     ENDS

CODE      SEGMENT USE32
          ASSUME CS:CODE,DS:CODE,ES:CODE
;============================================================================
; The following was originally a separate include file - MPVEQU.ASI
;============================================================================
;------------------------------------------------------------------------------;
;        SYSTEM EQUATES OF MVP O.S.                                            ;
;------------------------------------------------------------------------------;


;    --- EQUATES FOR I/O STROBES, etc. ---
;

;FLAGS NEEDED FOR MXE TC OPERATION

TCINUSE   EQU       08H       ;PORT IS BEING USED FOR TC
TCWAIT    EQU       08H       ;partition waiting TC port to be released
TCPORT    EQU       80H       ;PORT IS USED AS TC PORT
TCPORTL   EQU       08H       ;
TCDEVW    EQU       10H       ;partition breakpointed because TC buffer full
TCDEVWL   EQU       01H       ;
NOTOPN    EQU       00H       ;PORT NOT $OPENED
OPNELSE   EQU       01H       ;PORT $OPENED BY ANOTHER PARTITION
OPNSELF   EQU       02H       ;PORT $OPENED BY SAME PARTITION
?amPRTYER EQU       14H       ;Parity error occurred signal

; we set (fs).base=0ffff8000h and the i/o port all relative to (fs)
TIMSET   EQU       000H            ;8 BIT VALUE EACH UNIT WITH 120 US
CPUST    EQU       002H            ;READ BACK CPU AND IO STATUS
                                         ;D0 = 5US PULSE
                                         ;D1 = CPU BUSY
                                         ;D2 = KEY BOARD FUNCTION
                                         ;D3 = I/O READY
                                         ;D4 = TIME OUT ( 30MS)
                                         ;D5 = CPU HALT
                                         ;D6 = SRAM PARITY ERROR
                                         ;D7 = DRAM PARITY ERROR

CPUFLG   EQU       004H            ;D0 = FGSER/ MEANS GENERATE PARITY BIT
                                         ;     FOR DIAG. TEST
                                         ;D1 = CLEAR PARITY ERROR
                                         ;D2 = RESERVE
                                         ;D3 = IN TESTING

CPURDY   EQU       006H  ;RELEASE CPU BUSY
RTCADDR  EQU       008H  ;REAL TIME CLOCK ADDRESS STROBE
RTCDATA  EQU       00AH  ;REAL TIME CLOCK DATA STROBE
IBGET    EQU       00CH  ;GET INPUT BUS DATA
IOBS     EQU       00EH  ;DISK LATCH
_ABS     EQU       012H  ;ADDRESS BUS STROBE
OBS      EQU       014H  ;OUTPUT DATA BUS STROBE
CBS      EQU       018H  ;COMMAND DATA BUS STROBE

;Register use
;Auxiliary registers 10-1F are reserved for system pointers and flags.  They are
;referenced by name only (eg, VSPTR) to improve code readability.  AUX registers
;00-0F are for general use.  By convention, subroutines should use the lowest
;numbered registers possible. Hopefully, this will conserve register use and
;minimize conflicts.  During entry and resolution phases, AUX registers 03-0F
;must not be modified.

;Lowest numbered file registers should be used whenever possible.  Typically,
;entry and return parameters are passed though low numbered file registers.
;When 16 bit values are stored in a file registers pair, the register with the
;higher address contains the high byte of the value.

;================ register SH =================================================;

;      80      40       20      10      08      04      02      01
;   -----------------------------------------------------------------
;   ! DPRTY ! PARITY ! HALT  ! CLK   ! DB    ! ENDI  ! CPB   ! CA   !
;   -----------------------------------------------------------------
;
CA       EQU       01H
;          CARRY (BIT 01) (H/M)
;               0 = NO CARRY
;               1 = CARRY
;
CPB      EQU       02H
;          CRB (BIT 02) (H/M) (ALIAS KBD)
;               0 = ALLOW INPUT FROM KBD OR SELECTED
;                   DEVICE (IE, CPU IS READY)
;               1 = INHIBIT ALL INPUT FROM DEVICES
;                   (IE, CPU BUSY)
;
ENDI     EQU       04H
;          ENDI (BIT 04) (H/M)  (ALIAS KFN)
;               SET TO 1 WHEN INPUT RECEIVED FROM KBD
;                    IS SPECIAL FUNCTION CODE.  IT IS
;                    A 9TH DATA BIT FOR INPUT.
;
RB       EQU       08H
;          RB (BIT 08) (H)
;               0 = DEVICE NOT ENABLED OR BUSY
;               1 = DEVICE ENABLED AND READY
;
CLK      EQU       10H
CLKH     EQU       01H
;          CLK (BIT 10) (H/M)
;               SETTING BIT TO 1 TRIGGERS CLOCK (1-SHOT).
;               CLOCK REMAINS AT 1 FOR 30MS. +- 20%, THEN 0.
;               CLOCK CAN BE RE-TRIGGERED 5MS. AFTER TRIGGER;
;               EARLIER RE-TRIGGERS ARE IGNORED.
;               'INSTR 17800C' TRIGGERS CLOCK.
;
;                    CLOCK SPECIFICATIONS:
;                         28.0 MS. MIN.,  30.9 MS. AVE.,  43.0 MS. MAX.
;
HALT     EQU       20H
;          HALT (BIT 20) (H/M)
;               SET TO 1 WHEN HALT/STEP PRESSED ON KBD
;
;          PARITY (BIT 40) (H/M)
;               SET TO 1 WHEN A PARITY ERROR OCCURS ON
;                    CONTROL OR DATA MEMORY
;
;          DPRTY (BIT 80) (M)
;               0 = TRAP IF PARITY ERROR
;               1 = DO NOT TRAP IF PARITY ERROR

;================ register SL =================================================;

;         80  40  20   10       08    04    02    01
;     -------------------------------------------------
;     !  memory bank #        !     !     !  phase    !
;     -------------------------------------------------

PHASE    EQU       03H

;               00 = ENTRY PHASE
;               01 = RESOLUTION PHASE
;               10 = EXECUTION PHASE

XPHASE   EQU       02H                 ;EXECUTION PHASE
RPHASE   EQU       01H                 ;RESOLUTION PHASE
EPHASE   EQU       0FFH-XPHASE-RPHASE  ;ENTRY PHASE

;          -SPARE- (BITS 0C)



;   ---- AUXILIARY REGISTER EQUATES ----
;

TEXTPTR  EQU       EBP       ;TEXT POINTER. POINTS TO NEXT CHARACTER TO BE
                             ;PROCESSED IN CURRENT LINE.
TEXTEND  EQU       AUX11     ;END OF TEXT POINTER. POINTS TO CR OF LAST TEXT
                             ;LINE.
TEXTLPTR EQU       AUX12     ;CURRENT STATEMENT LINE POINTER. POINTS TO
                             ;THREAD OF CURRENT LINE
VARPTR   EQU       AUX13     ;SYMBOL TABLE POINTER. POINTS TO END OF SYMBOL
                             ;TABLE.
MODE     EQU       AUX14     ;SYSTEM MODES

;
;      EXECUTION MODE (BITS 0003)
;           00 = RUN
;           01 = RUN AT LINE NO.
;           10 = IMMEDIATE EXECUTION
;
;      TRACE MODE (BITS 000C)
;           00 = TRACE OFF
;           11 = TRACE ON
;           10 = TRACE ON BUT DISABLED
;
;      RESOLUTION FLAG (BITS 0030)
;           00 = PROGRAM NOT RESOLVED
;           01 = RESOLUTION IN PROGRESS
;           10 = PROGRAM RESOLVED
;
;      I/O CLASS (BIT 0040)
;           0 = STANDARD
;           1 = FOR FUTURE EXPANSION
;
;      END OF FILE (BIT 0080)
;           0 = NOT EOF
;           1 = EOF
;
;      VERIFY MODE (BIT 0100)
;           0 = NOT VERIFYING DISK
;           1 = VERIFYING DISK (SURPRESS NORMAL DISK
;                               ERROR MESSAGES)
;
;      OVERLAY MODE (BIT 0200)
;           0 = NOT OVERLAYING
;           1 = OVERLAYING
;
;      Immed line valid (BIT 0400)

MODEIMM  EQU       04H       ;1 if Textend points to valid immed line

;
;      LISTV MODE (BIT 0800)
;           0 = NOT LISTV
;           1 = LISTV
;
;      LISTD MODE (BIT 1000)
;           0 = NOT LISTD
;           1 = LISTD

;      INPUT MODE (BIT 2000)
;           0 = NOT INPUT
;           1 = INPUT
;
;      LIST MODE (BIT 4000)
;           0 = NORMAL LIST
;           1 = LIST IN STEPS OF 15 LINES
;
;      LOAD MODE (BIT 8000)
;           0 = NOT LOADING
;           1 = LOADING
;

OSPTR    EQU       AUX15     ;OPERATOR STACK POINTER. POINTS TO LAST ENTRY IN
                             ;OPERATOR STACK (OS)
VSPTR    EQU       AUX16     ;VALUE STACK POINTER. POINTS TO LAST ENTRY IN
                             ;VALUE STACK (VS)
UNUSEDX  EQU       AUX17     ;THIS AUX NOT CURRENTLY USED

STMTCNT  EQU       AUX18     ;STATEMENT COUNTS

;      STATEMENT COUNT (BITS 00FF): POSITON OF THE
;           STATEMENT CURRENTLY BEING PROCESSED IN THE
;           STATEMENT LINE. (0,1,2,...)
;      CONTINUE STATEMENT COUNT (BITS FF00): POSITION OF
;           STATEMENT IN THE STATEMENT LINE TO CONTINUE
;           PROCESSING AT. (EG, AFTER HALT, STOP, ETC.)
;

CONTLN_  EQU       AUX19     ;LINE NUMBER TO CONTINUE PROCESSING AT DUE TO
                             ;CONTINUE, HALT/STEP, OR RUN AT.
ACTDEV   EQU       AUX1A     ;DEVICE ADDRESS (BITS 00FF) AND TYPE (BITS 0F00)
                             ;OF CURRENTLY ENABLED DEVICE
MATHMODE EQU       AUX1B     ;MATH MODES

;
;      ERROR MODE (BITS FF00)
;               NORMAL MATH ERROR (TERMINATE PROGRAM).
;               CONTINUE EXECUTION WITH DEFAULT VALUE
;               IF MATH ERROR OCCURS & ERROR <= PH
;
;      TRIG MODE (BITS 0030)
;           00 = RADIANS
;           01 = DEGREES
;           10 = GRADS
;
;      ROUND MODE (BITS 00C0)
;           00 = ROUND +,-,*,/
;           11 = TRUNCATE +,-,*,/
;

CHARCNT  EQU       AUX1D     ;CHARACTER COUNT (BITS 00FF). NUMBER OF

;      CHARACTERS OUTPUT ON CURRENT OUTPUT
;      LINE (CURSOR POSITION).
; MAXIMUM LINE LENGTH (BITS FF00). DEFAULT = 64.

TEXTENDS EQU       AUX1E     ;SAVED END OF TEXT POINTER (TEXTEND). POINTS TO

;      END OF TEXT BEFORE LAST LINE ENTERED.
;
;      END OF TEXT IS CR OF LAST LINE IF AT ODD ADDRESS
;      (OR +1 IF ADDRESS OF CR IS EVEN)
;

COUNTS   EQU       AUX1C     ;LINE COUNT (BITS 00FF). NUMBER OF LINES OUTPUT.

;      USED FOR LISTS, LINE ERASE, ETC.  SET TO ZERO
;      AT BEGIN OF LINE ENTRY (READCH).
;
; SELECT PAUSE (BITS 0F00). DELAY n * 1/6 SEC. AFTER EACH
;      CR OUTPUT.
;------------------ ACTIOBS (AUX 1F) ------------------------------------------;

ACTIOBS  EQU       AUX1F     ;bits 00FF

;        Bits 00FF = current value of the IOB's (ie, AB latches).  Normally,
;        this is the address of the enabled device (ACTDEV).  However, IOB's
;        are used in disk control sequences as a start of command flag.

;        ACTIOBS is set whenever a device is enabled (except in OS device
;        polling).  ACTIOBS was added in release 1.9.


;------------------------------------------------------------------------------;
;                    PRIME                                                     ;
;                      !                                                       ;
;          -------------------------                                           ;
;          ! system initialization !                                           ;
;          ! (set up 1 partition)  !                                           ;
;          -------------------------              for each partition           ;
;                      !<----------------------------------------------------- ;
;          -------------------------                                         ! ;
;          ! initialize partition  !                                         ! ;
;          -------------------------                                         ! ;
; CLEAR--------------->!                                                     ! ;
;          -------------------------                                         ! ;
;          !         START         !                                         ! ;
;          !-----------------------!                                         ! ;
;          ! clear partition       !                                         ! ;
;          -------------------------                                         ! ;
; RESET--------------->!                                                     ! ;
;          -------------------------                                         ! ;
;          !         RESET         !                                         ! ;
;          !-----------------------!                                         ! ;
;          ! reset partition       !                                         ! ;
;          -------------------------                                         ! ;
;  ------------------->!                                                     ! ;
;  !       -------------------------               --------------------      ! ;
;  !       !         ENTER         !  system not   !      BOOT        !      ! ;
;  !       !-----------------------!-------------->!------------------!------- ;
;  !       ! get next text line    !  configured   ! configure system !        ;
;  !       -------------------------               !    (@GENPART)    !        ;
;  !  ---------------->!                           --------------------        ;
;  !  !                !<------------------------------------------------      ;
;  !  !    -------------------------                                    !      ;
;  !  !    !        PROCST         !                                    !      ;
;  !  !    !-----------------------!                                    !      ;
;  !  !    ! jump to statement     !                                    !      ;
;  !  !    ! processing routine    !                                    !      ;
;  !  !    -------------------------                                    !      ;
;  !  !                !                                                !      ;
;  !  !    -------------------------    ----------------------          !      ;
;  !  !    !       xyzSTMT         !    !        ERROR       !          !      ;
;  !  !    !-----------------------!--->!--------------------!--------->!      ;
;  !  !    ! process statement     !    ! process error      ! :ERROR          ;
;  !  !    -------------------------    ----------------------                 ;
;  !  !                !                           !                           ;
;  !  !    -------------------------             ENTER                         ;
;  !  !  R !        ENDSTMT        !                                           ;
;  !  !<---!-----------------------!                                           ;
;  !     X ! point to next stmt    !                                           ;
;  !       -------------------------                                           ;
;  !                   ! E-phase                                               ;
;  !<-------------------                                                       ;
;                                                                              ;
;------------------------------------------------------------------------------;

; Breakpoints in partition execution normally occur in ENDSTMT or during state-
; ment execution while waiting for I/O, although lengthy statements may break
; during their execution.  Task switching is performed by the routine BREAKPT.


;       ------- TEXT ATOM EQUATES --------
;

;       REFERENCED TEXT ATOMS
;

@DEFFN   EQU       0CEH      ;'DEFFN' TEXT ATOM
@LINE_   EQU       0FFH      ;'LINE NUMBER REFERENCE' TEXT ATOM
@LINE_H  EQU        0FH
@LINE_L  EQU        0FH
@?PE     EQU       0D8H      ;'%'
@?PEH    EQU        0DH      ;'%' TEXT ATOM
@?PEL    EQU        08H
@STMTSEP EQU       0FDH      ;'STATEMENT SEPARATOR' TEXT ATOM
@STMTSPH EQU        0FH
@STMTSPL EQU        0DH
@DC      EQU       0BFH      ;'DC'
@DA      EQU       0BDH      ;'DA'
@BA      EQU       0BEH      ;'BA'
@END     EQU        96H      ;'END'
@THEN    EQU       0B1H      ;'THEN'
@STEP    EQU       0B0H      ;'STEP'
@OFF     EQU       0BAH      ;'OFF'
@CLEAR   EQU        81H      ;'CLEAR'
@TAB     EQU       0CDH      ;'TAB('
@AT      EQU       0F5H      ;'AT('
@HEXOF   EQU       0F6H      ;'HEXOF('
@TO      EQU       0B2H      ;'TO'
@LOAD    EQU       0A1H      ;'LOAD'
@SAVE    EQU       085H      ;'SAVE'
@RE      EQU       0D6H      ;'RE'
@DATA    EQU        97H      ;'DATA'
@AND     EQU        8AH      ;'AND'
@OR      EQU        8BH      ;'OR'
@XOR     EQU        8CH      ;'XOR'
@BOOL    EQU       0E7H      ;'BOOL'
@ADD$    EQU       0E8H      ;'ADD'
@SUB$    EQU       0EFH      ;'SUB'
@DAC     EQU       0EDH      ;'DAC'
@DSC     EQU       0EEH      ;'DSC'
@BIN?LP  EQU       0DEH      ;'BIN('
@STR     EQU       0D3H      ;'STR('
@STRH    EQU        0DH
@STRL    EQU        03H
@HEX?LP  EQU       0D2H      ;'HEX('
@DIM     EQU        93H      ;'DIM'
@ALL     EQU       0E1H      ;'ALL'
@LTRL    EQU       0FEH      ;PACKED LITERAL
@LTRLH   EQU        0FH      ;PACKED LITERAL ATOM
@LTRLL   EQU        0EH
@HEXLIT  EQU       0FCH      ;PACKED HEX-LITERAL ATOM
@HEXLITH EQU        0FH
@HEXLITL EQU        0CH
@LIST    EQU        80H      ;'LIST'
@LISTH   EQU        08H
@LISTL   EQU        00H
@PRINT   EQU       0A0H      ;'PRINT'
@PRINTH  EQU        0AH
@PRINTL  EQU        00H
@ROUND   EQU       0F4H      ;'ROUND'
@ERROR   EQU       0EBH      ;'ERROR'
@GOTO    EQU        9CH      ;'GOTO'
@GOSUB   EQU        9AH      ;'GOSUB'
@OPEN    EQU       0B4H      ;'OPEN'
@TEMP    EQU        8DH      ;'TEMP'
@CLOSE   EQU       0E3H      ;'CLOSE'
@LS?EQ   EQU       0E0H      ;'LS='
@DISK    EQU        8EH      ;'DISK'
@BEG     EQU       0B3H      ;'BEG'
@REM     EQU       0A2H      ;'REM'
@REMH    EQU        0AH      ;'REM'
@REML    EQU        02H
@NEXT    EQU        9DH      ;'NEXT'
@GIO     EQU       0F0H      ;'GIO'
@TRAN    EQU       0F1H      ;'TRAN'
@PACK    EQU       0E2H      ;'PACK'
@UNPACK  EQU       0E6H      ;'UNPACK
@IF      EQU        9FH      ;'IF'
@ON      EQU        94H      ;'ON'
@SELECT  EQU       0A5H      ;'SELECT'
@ELSE    EQU       0F2H      ;'ELSE'
@SKIP    EQU       0AAH      ;'SKIP'
@RUN     EQU        82H      ;'RUN'
@STOP    EQU        95H      ;'STOP'
@INIT    EQU       0E4H      ;'INIT'
@FORT    EQU        9EH      ;'FOR'
@$       EQU       0EAH      ;'$'
@CONT    EQU        84H      ;'CONTINUE'
@CI      EQU       0B5H      ;'CI'
@CO      EQU       0B8H      ;'CO'
@INPUT   EQU        99H      ;'INPUT'
@PLOT    EQU       0A4H      ;'PLOT'
@TAPE    EQU        8FH      ;'TAPE'
@COM     EQU       0A6H      ;COM atom

;     OPERATOR STACK (OS) ATOMS
;

@UPLUS   EQU       0A0H      ;UNARY (LEADING) +   (EXPRESSION ANALYSIS)
@UPLUSL  EQU        00H
@UMINUS  EQU       0B3H      ;UNARY -
@ADD     EQU       0B0H      ;+
@SUB     EQU       0B2H      ;-
@MUL     EQU       0C0H      ;*
@DIV     EQU       0C5H      ;/
@XEY     EQU       0D0H      ;^
@NUMREC  EQU        30H      ;NUMERIC RECEIVER VARIABLE ATOM
@NUMRECH EQU        03H
@NUMRECL EQU        00H
@ALPHREC EQU        38H      ;ALPHA RECEIVER VARIABLE ATOM
@ALPHRCH EQU        03H
@ALPHRCL EQU        08H
@FOR     EQU        20H      ;FOR ATOM (FOR/NEXT LOOP)
@FORH    EQU        02H
@FORL    EQU        00H
@SUBR    EQU        10H      ;GOSUB ATOM (SUBROUTINE CALL)
@SUBRH   EQU        01H
@SUBRL   EQU        00H
@SFKEY   EQU        11H      ;SPECIAL FUNCTION KEY ATOM (SUBROUTINE CALL
@SFKEYH  EQU        01H      ;     DURING CONSOLE INPUT)
@SFKEYL  EQU        01H      ;(HIGH 4-BITS OF @SUBR & @SFKEY MUST BE SAME)
@SFINPT  EQU        12H      ;SPECIAL FUNCTION KEY ATOM (SUBROUTINE CALL
@SFINPTL EQU        02H      ;     DURING INPUT MODE)
@SFLINPT EQU        13H      ;SPECIAL FUNCTION KEY ATOM (SUBROUTINE CALL
@SFLNPTL EQU        03H      ;     DURING LINPUT MODE)
@INTRPT  EQU        14H      ;INTERRUPT SUBROUTINE ATOM
@INTRPTL EQU        04H      ;
@XSUBR   EQU        18H      ;GLOBAL SUBROUTINE OS ATOM
@XSUBRL  EQU        08H      ;
@RELEXPR EQU        42H      ;BEGIN OF RELATION EXPRESSION
@RELAND  EQU        44H      ;(OR 45) RELATION AND OPERATOR
@RELOR   EQU        48H      ;(OR 49) RELATION OR OPERATOR


; MXD DEVICE ADDRESS EQUATES
;

@MXD1CAD EQU        06H      ;1ST MXD CONTROL ADDRESS
@MXD2CAD EQU        46H      ;2ND MXD CONTROL ADDRESS
@MXD3CAD EQU        86H      ;3RD MXD CONTROL ADDRESS
@MXD4CAD EQU       0C6H      ;4TH MXD CONTROL ADDRESS

@MXDIADR EQU        01H      ;MXD KEYBOARD DEVICE ADDRESS
@MXDSADR EQU        02H      ;MXD STATUS DEVICE ADDRESS
@MXDDADR EQU        03H      ;MXE screen input address
@MXDPADR EQU        04H      ;MXD PRINTER DEVICE ADDRESS
@MXDOADR EQU        05H      ;MXD CRT ADDRESS (ACTUALLY, TRANSLATED TO 07)
@MXDCADR EQU        06H      ;MXD CONTROL ADDRESS

; MXD COMMAND EQUATES
;

?AMSELECTP EQU       0C0H      ;SELECT P COMMAND
?AMSELTERM EQU       0FFH      ;SELECT TERMINAL (WAS 0F4)

?AMDISCNON EQU        24H      ;disconnect detection on
?AMDISCNOF EQU        25H      ;disconnect detection off
?AMSCRNIN  EQU        29H      ;Initiate program initiated screen input
?AMSCRNINT EQU        2AH      ;Abort screen input
?AMSCRNINR EQU        2BH      ;Initiate screen input in response
?AMDISACK  EQU        2CH      ;Acknowledge completion of disconnect processing
                               ;                      to a keyboard request
?AMSELCOMM EQU        2DH      ;.SELECT MXE PORT
?AMTCPSW   EQU        2EH      ;.LOAD PASSWORD

?AMLOADED  EQU        14H      ;DOWNLOADING COMPLETE
?AMDWNLOAD EQU        13H      ;DOWNLOADING BEGINNING
?AMTICK    EQU        12H      ;DISABLE/ENABLE CLOCK
?AMTYPE    EQU        11H      ;REQUEST FOR MXD TYPE
?AMTERMLR  EQU        10H      ;TERMINATE LR (CR IN DEFFN' QUOTES)
?AMCONTLR  EQU        0FH      ;CONTINUE LR (RECALL ILLEGAL OR SF UNDEFINED)
?AMPRTREQ  EQU        0EH      ;REQUEST FOR PRINT BUFFER EMPTY
?AMCRTREQ  EQU        0DH      ;REQUEST FOR CRT BUFFER EMPTY
?AMRECDATA EQU        0CH      ;RECEIVE LR DATA
?AMQUERYLR EQU        0BH      ;QUERY LINE REQUEST
?AMENDLRT  EQU        0AH      ;END OF LINE REQUEST (WAS 0F5)
?AMREFILL  EQU        09H      ;RECALL, DEFFN'
?AMPREFILL EQU        08H      ;PREFILL LINE REQUEST
?AMLR      EQU        07H      ;LINE REQUEST (WAS 03)
?AMKEYINVP EQU        06H      ;KEYIN LINE REQUEST (WAS 0FC)
?AMKEYINT  EQU        05H      ;2200T FORM OF KEYIN (WAS 0FB)
?AMIFONKBD EQU        04H      ;$IF ON AT ADDRESS 01 (HALF OF KEYIN)
?AMDELLR   EQU        03H      ;DELETE LINE REQUEST (WAS 0FA)
?AMINITTRM EQU        02H      ;INITIALIZE CURRENT TERMINAL (WAS 0F9)
?AMPOWER   EQU        01H      ;POWER ON INITIALIZE
?AMNULL    EQU        00H      ;NULL OPERATION, DUMMY BYTES
?AMSLCTTC  EQU        02H      ;.SELECT TC
?AMSLCTTRM EQU        01H      ;.SELECT TERMINAL

?AMRESETC  EQU        01H      ;RESET CRT ONLY
?AMRESETCP EQU        00H      ;RESET CRT & TERMINAL PRINTER

NULL     EQU        00H      ;NULL DATA BYTE

LRLEN    EQU      01E0H
LRLENH   EQU        01H      ;MAXIMUM LINE REQUEST LENGTH (480 BYTES)
LRLENL   EQU       0E0H


;OUTDATED COMMANDS (USED FOR JERRY'S VERSION):
;

@CMDSIZE EQU       01H       ;CRT SIZE
@CMDCOL  EQU       02H       ;COLUMN POSITION
@CMDLRU  EQU       04H       ;LINE REQUEST WITH UNDERLINE
                             ; ADDED ON VERSION 2.5

TCDEV    EQU       0AH       ;.TC DEVICE TYPE BYTE

TCDEVH   EQU       00H       ;.HIGH NIBBLE OF TC DEVICE TYPE BYTE
TCDEVL   EQU       0AH       ;.LOW NIBBLE OF TC DEVICE TYPE


; DISK EQUATES:
;

_DISKHOG EQU       80H       ;SWITCH DISK CONTROLLER TO HOG MODE
_DISKRST EQU       01H       ;RESET DISK
_PHOENIX EQU       0DH       ;PHOENIX TYPE DISK DEVICE TYPE


;------------------------------------------------------------------------------;
;      -------- RAM MAP ---------                                              ;
;------------------------------------------------------------------------------;


;------------------------------------------------------------------------------;
;               --------------------------------
;               !                              !
;               !     GLOBAL INFORMATION       !
;               !                              !
;               --------------------------------
;               !                              !
;               !     PARTITION #0             !
;               !                              !
;               --------------------------------
;               !                              !
;               !     PARTITION #1             !
;               !                              !
;               --------------------------------
;               !                              !
;               !          .                   !
;               !          .                   !
;               !          .                   !
;               !                              !
;               --------------------------------
;               !                              !
;               !     PARTITION #N             !
;               !                              !
;               --------------------------------
;------------------------------------------------------------------------------;

EXTRN    GIEND:NEAR

BASEP    EQU       OFFSET GIEND     ;ADDRESS OF PARTITION AREAS
PARTMAX  EQU       20H              ;MAXIMUM # OF PARTITIONS = 32
MINPART  EQU       5                ;MINUMUM PARTITION SIZE (# PAGES)  (1.25K)
MAXTERM_ EQU       10H              ;MAXIMUM TERMINAL NUMBER



;================== PSTAT: partition status table =============================;
;  PSTAT contains 1 status byte / partition indicating the current status of the
;  corresponding partition.  The table is terminated by a 17th byte.

;     STATUS BYTE BIT DEFINITIONS
;

PSTATETB EQU       80H       ;BIT 80 -- END OF TABLE.
PSTATET  EQU       08H       ;          LAST BYTE OF PSTAT TABLE = 80;

;       --- INDICATES THERE ARE NO MORE PARTITIONS. ---

PSTATPBT EQU       40H       ;BIT40 -- PROGRAM BREAKPOINT.
PSTATPB  EQU       04H       ;          END OF STATEMENT OR STMT SEGMENT;

;       --- BREAKPOINT RETURN CAN BE DONE. ---

PSTATIBT EQU       20H       ;BIT20 -- NON-MXD I/O BREAKPOINT.
PSTATIOB EQU       02H       ;BREAKPOINT RETURN ONLY IF DEVICE READY.

PSTATICT EQU       10H       ;BIT10 -- MXD I/O COMPLETION OR WAKE UP PART.
PSTATIOC EQU       01H       ;          BREAKPOINT RETURN CAN BE PERFORMED.

;         BIT SET WHEN:
;         1.OPERATION IS COMPLETE (PSTATLR, PSTATCOT, PSTATPT)
;         2. TERMINAL IS ATTACHED TO A WAITING PARTITION.
;         3. RESET, M.I., ETC.
;         4. REQUESTED DEVICE OPENED.

PSTATLR  EQU       04H       ;BIT 04 -- MXD I/O BREAKPOINT FOR LINE REQUEST

PSTATCOT EQU       02H       ;BIT 02 -- MXD I/O BREAKPOINT FOR CONSOLE
                             ;          OUTPUT TIMEOUT (CO BUFFER FULL).
PSTATPT  EQU       01H       ;BIT 01 -- MXD I/O BREAKPOINT FOR PRINT TIMEOUT
                             ;          (PRINT BUFFER FULL).

PSTATIOX EQU       PSTATIOB+PSTATIOC


;VALID STATUS BYTE VALUES:
;
;     00 = INACTIVE PARTITION (UNDEFINED OR ASLEEP).
;          MAY BE WAITING FOR TERMINAL TO BE ATTACHED OR
;          DEVICE TO BECOME AVAILABLE. PARTITION IS
;          AWAKENED BY SETTING STATUS TO I/O COMPLETE.
;     01 = MXD PRINT BUFFER FULL.
;     02 = MXD CRT BUFFER FULL.
;     04 = MXD LINE REQUEST.
;     10 = MXD I/O COMPLETE OR REQUEST OS ATTN (RESET, MASTER
;          INITIALIZATION, TERMINAL ATTACHED).
;     20 = NON-MXD BREAKPOINT.
;     40 = PROGRAM BREAKPOINT.
;     80 = END OF TABLE.

;================== PTERM:  partition terminal table ==========================;
;PTERM TABLE CONTAINS THE TERMINAL ADDRESS AND STATUS OF THE
;TERMINAL ASSIGNED TO EACH PARTITION. IF THERE IS NO TERMINAL
;ASSIGNED TO A PARTITION, THE ENTRY IS HEX(FF).

;     PTERM ENTRY BIT-DEFINITIONS:
;

PTERMADR EQU       0C7H      ;TERMINAL ADDRESS

;      BITS C0 = MXD BOARD ADDRESS
;      BITS 07 = IN-BOARD TERMINAL NUMBER

PTERMD   EQU        20H      ;1 IFF TERMINAL DETACHED FROM THIS PARTITION
PTERMDH  EQU        02H      ;(HIGH 4-BITS)

PTERMW   EQU        10H      ;1 IFF PARTITION IS WAITING FOR TERMINAL TO BE
                             ;     ATTACHED
PTERMWH  EQU        01H      ;(HIGH 4-BITS)

;
;     NOTE: CANNOT BE WAITING FOR TERMINAL UNLESS
;           TERMINAL IS DETACHED.
;

PTERMRLS EQU        08H      ;PARTITION RELEASED (NO TERMINAL), PTERMD &
                             ;     PERHAPS PTERMW WILL ALSO BE SET

;================== PMODE:  partition mode table ==============================;

;PMODE CONTAINS ONE BYTE / PARTITION INDICATING THE PARTITION
;OPERATING MODE.

;     PMODE ENTRY BIT-DEFINITIONS
;

PMODEP   EQU       01H       ;1 IFF PARTITION IS NON-PROGRAMMABLE
PMODEB   EQU       02H       ;1 IFF PROGRAM BOOTSTRAPPING TO BE PERFORMED
PMODEG   EQU       04H       ;1 IFF PARTITION DEFINED TO BE GLOBAL
PMODER   EQU       08H       ;1 IFF RND NO.S TO BE GENERATED (RANDOMIZATION)
PMODEI   EQU       10H       ;1 IFF HIGH PRIORITY I/O IN PROGRESS FOR THIS
PMODEIL  EQU       01H       ;     PARTITION
PMODED   EQU       20H       ;1 iff terminal just disconnected
PMODESI  EQU       40H       ;1 iff partition available for screen input

;================== global ptrs, flags, etc. ==================================;

MIBOOT   EQU       02H       ;SYSGENFG BIT -- 1 IFF M.I. PROGRAM BOOTSTRAPPING

IOXMAX_  EQU       04H       ;I/O LEVEL EXECUTION LIMIT

;     BIT VALUES
;
;     /0FD DEVELOPMENT CLOCK (8080 MICROPROGRAMMED TIMER,
;     RESIDENT ON TC CONTROLLER). BITS 30 OF BYTE 1 SPECIFY:
;
;          00 -- DON'T ACCESS CLOCK
;          10 -- KEEP TRACK OF TOTAL SYSTEM EXECUTION TIME
;                (IE, ALL TIME EXECPT THAT SPENT IN BREAKPOINT
;                POLLING)
;          11 -- KEEP TRACK OF PARTITION #1 EXECUTION TIME.
;

OSMODCLK EQU       02H       ;ACCESS /0FD CLOCK
OSMODCL1 EQU       01H       ;TURN CLOCK ON FOR PARTITION #N ONLY

                             ;  Bits 0F of byte 1 specify the
                             ;  partition to be timed (part#-1)


;================== SCRNIN:  screen input table ===============================;
;     The screen input table, SCRNIN, has one entry per terminal in terminal
;     order.  The table keeps track of which partitions are doing screen dumps
;     and which terminals have requested screen dumps.

;     Terminal entry (1 byte):
;        bits 0F = partition number of partition doing screen dump
;        bit 10 = 1 if screen input is in progress
;        bit 20 = 1 if terminal has requested a screen input partition

SCRNINP  EQU       10H       ;screen input in progress
SCRNINR  EQU       20H       ;request for screen input


;================== MDEVTBL:  master device table =============================;
;THE MASTER DEVICE TABLE CONTAINS A 2 BYTE ENTRY FOR EACH
;DEVICE ADDRESS ALLOWED IN THE CURRENT CONFIGURATION.
;
;     BYTE 1 = DEVICE-ADDRESS (00 IF END OF TABLE)
;     BYTE 2 = DEVICE STATUS
;          ,BIT 80 = 1 IFF DEVICE IS A DISK
;          ,BIT 30 = 11 IFF DEVICE RESERVED EXCLUSIVELY FOR A
;                           SPECIFIED PARTITION
;          ,BIT 10 = 1 IFF DEVICE OPEN
;          ,BIT 0F = PARTITION # OF PARTITION FOR WHICH THE
;                    DEVICE IS CURRENTLY OPEN
;
;IN ADDITION TO THE ABOVE, A MASTER DEVICE TABLE EXTENSION
;PROVIDES 2 MORE BYTES / ENTRY.
;
;     BYTE 2, BIT 01 = 1 IFF DISK DEVICE HAS BEEN HOGGED WITH
;                            THE 80-BIT OF ADDRESS. NOTE, THE
;                            DEVOPEN BIT IS ALSO SET.

;    ----  STATUS BIT EQUATES:  -----
;

EXTRN    MDEVTBL:NEAR        ;STARTING ADDRESS OF MASTER DEVICE TABLE
EXTRN    MDEVTBX:NEAR        ;STARTING ADDRESS OF MASTER DEVICE TABLE EXTENSION

DHOGADR  EQU       01H                 ;01 IFF DISK HOGGED BY 80-BIT OF ADDRESS

MDEVTBLE EQU       OFFSET MDEVTBL+40H  ;END OF DEVICE TABLE

;MDEVDISP EQU       OFFSET MDEVTBL-OFFSET MDEVTBX  ;DISPLACEMENT VALUE


;  ---- STATUS BIT EQUATES ----
;

DEVOPEN  EQU       10H       ;DEVICE OPEN
DEVOPENH EQU       01H

DEVEXCL  EQU       20H       ;EXCLUSIVE DEVICE
DEVEXCLH EQU       02H

DEVOIP   EQU       40H       ;OPERATION IN PROGRESS (TEMP. OPEN FOR DURATION
DEVOIPH  EQU       04H       ;     OF STATEMENT)

DEVUSE   EQU       DEVOPEN+DEVOIP      ;DEVICE IN USE
DEVUSEH  EQU       DEVOPENH+DEVOIPH

DEVTDISK EQU       80H       ;DEVICE TYPE = DISK
DEVTDSKH EQU       08H

;================== TIME:  date & time ========================================;
; When the clock is set, these counts are updated once
; every second.
;

;------------------------------------------------------------------------------;
;       Time Form Structure                                                    ;
;------------------------------------------------------------------------------;

TIME_FORM STRUC
@YEARS           DB     ?
@MONTHS          DB     ?
@DAYS            DW     ?
@HOURS           DB     ?
@MINUTES         DB     ?
@SECONDS         DB     ?
@CENTISECONDS    DB     ?
TIME_FORM ENDS


;------------------------------------------------------------------------------;
;       The Paritition RAM Structure                                           ;
;------------------------------------------------------------------------------;

PAR_INF    STRUC

@savereg   DB      232     DUP(0)  ;Regs save area

@TRDSKW    DB      16      DUP(0)  ;Work area for disk trace

@workspc   DB      8       DUP(0)  ;8 byte general scratch area

@file_     DB      2       DUP(0)  ;2 byte area containing the current file
                                   ;number and maximum file#
                                   ;byte 1: maximum file#  byte 2: current file#

@rsave     DB      4       DUP(0)  ;Work area for any individual statement

@stop_     DB      2       DUP(0)  ;2 byte value that contains the line# to stop at

@dvtbl     DB      50      DUP(0)  ;Table for handling dummy variables during
                                   ;FN processing

@dataptr   DB      4       DUP(0)  ;Current data pointer. Point to current data value

@datalpt   DB      4       DUP(0)  ;Current data line pointer. Points to thread
                                   ;of the current data line

@devload   DB      2       DUP(0)  ;Device address of load device

@dvtptr    DB      4       DUP(0)  ;Dummy variable table pointer. (FN processing
                                   ;points to next available position.)

@errf      DB      1       DUP(0)  ;Error function value (packed decimal)

@lines     DB      1       DUP(0)  ;Select line value (default = 24)

@varend    DB      4       DUP(0)  ;End of data memory - 1 (eg, xxxxxffe)

@savevs    DB      4       DUP(0)  ;Save location for vsptr

@saveos    DB      4       DUP(0)  ;Save location for osptr

@prntcnt   DB      1       DUP(0)  ;Print charcnt position

@listflg   DB      1       DUP(0)  ;List save location

@defnadr   DB      4       DUP(0)  ;Points to 1st user defined function in prgm

@onerrpt   DB      4       DUP(0)  ;Points to 1st on_error_goto stmt in prgm

@doflag    DB      1       DUP(0)  ;Do flag ( 1 if Do found & not matched)

@resflg    DB      1       DUP(0)  ;Global resolution flag
                                   ;bit 01 = 1 iff deffn@ encountered during res.

@xbase     DB      4       DUP(0)  ;Base address of global partition

@ibase     DB      4       DUP(0)  ;Indirect base address (either global or
                                   ; current (calling) partition)

@dbase     DB      4       DUP(0)  ;Base address of partition currently refers to

@comptr    DB      4       DUP(0)  ;Common variable pointer. points to end of
                                   ;variable in symbol table

@partend   DB      4       DUP(0)  ;Pointer of partition end

@istatus   DB      1       DUP(0)  ;Interrupt handing status byte

@itable    DB      96      DUP(0)  ;Interrupt table

@iobuffr   DB      512     DUP(0)  ;Disk sector buffer, also can be used for
                                   ;other purposes if not performing a disk opration

@devtbl    DB      148+1920 DUP(0) ;Device table

@name      DB      8       DUP(0)  ;Global name (8 byte of partition)

@named     DB      4       DUP(0)  ;'Global For' flag (4 bytes)
                                   ;    bit 80000000 = 1 iff global for term# 32
                                   ;    bit 40000000 = 1 iff global for term# 31
                                   ;         .
                                   ;         .
                                   ;    bit 00000001 = 1 iff global for term# 1

@hashfl    DB      1       DUP(0)  ;Hash algorithm flag

@trdisk    DB      1       DUP(0)  ;Hash algorithm trace disk work area

@grpthrd   DB      68      DUP(0)  ;Threads to text-line groups

@mthseed   DB      14      DUP(0)  ;Random number seed

@dfn?qutbl DB      48      DUP(0)  ;Deffn' location table

@varthrd   DB     128      DUP(0)  ;Symbol table (start-of-chain pointer)

@osbeg     DB      64      DUP(0)  ;Operation Stack

@sysptr    dd      6       DUP(0)  ;save @@osend, @@vsend, @@varthd

@spreg     dd      1       DUP(0)  ;special register (temp. save )

@spreg1    dd      1       DUP(0)  ;special register1 (temp. save )

@spreg2    db      1       DUP(0)  ;special register2 (TC status byte)

@spreg3    db      1       DUP(0)  ;special register3 (GOTO, GOSUB status)

@spreg4    db      1       DUP(0)  ;special register4 (RESAVE status)

@spreg5    db      1       DUP(0)  ;special register5

@spreg6    db      1       DUP(0)  ;special register6

@spreg7    db      1       DUP(0)  ;special register7

@spreg8    db      1       DUP(0)  ;special register8 (INPUT CURSOR Flag)

@spreg9    db      1       DUP(0)  ;special register9

@r2        db      1       DUP(0)  ;save r2 for mswrt begin and end

@rst_flag  db      1       DUP(0)  ;reset flag for disk close

@hhh       db      1       DUP(0)  ;Platter open and close flag

@ok        db      1       DUP(0)  ;flag for multi open statement

@retry     db      1       DUP(0)  ;retry count of platter hog

@flg_a     db      1       DUP(0)  ;flg_a

@hogflg    db      1       DUP(0)  ;hog flag

@enabflg   db      1       DUP(0)  ;device enable flag

@arrayflag db      1       DUP(0)  ;array flag

@moveflag  db      1       DUP(0)  ;move flag

@escflag   db      1       DUP(0)  ;esc flag

@dir_ptr   db      64      DUP(0)  ;MS-DOS file directory pointer buffer

@toptr     dd      ?               ;especially for copy & move use
@soudev    dw      ?               ;this is for platter hog
@soudev_f  db      ?               ;this is for platter hog
@desdev    dw      ?
@desdev_f  db      ?

@textbeg   dd      1       DUP(0)  ;Pointer of text begin

PAR_INF    ENDS

@VARTHRE   EQU    @VARTHRD+80H
@OSEND     EQU    @OSBEG+40H


;================ Register Save Area ==========================================;
;     The Register Save Area is used by the operating system to store the
;     current register values of the partition when control is passed from
;     this partition to a different partition.
;
;       --- register save map ---
;      0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F
;     !================================================!
;  0x ! f !0 !f2!f3!f4!f5!f6!f7!  aux00    !k !0 ! ecx-!
;  1x ! (ecx)!f1!f0!   pc      ! breakpt   ! stack save!
;  2x !   (2)      !     (3)   !    (4)    !    (5)    !
;  3x !   (6)      !     (7)   !    (8)    !    (9)    !
;  4x !   (10)     !     (11)  !    (12)   !    (13)   !
;  5x !  aux01     !   aux02   !   aux03   !   aux04   !
;  6x !  aux05     !   aux06   !   aux07   !   aux08   !
;  7x !  aux09     !   aux0a   !   aux0b   !   aux0c   !
;  8x !  aux0d     !   aux0e   !   aux0f   !   aux10   !
;  9x !  aux11     !   aux12   !   aux13   !   aux14   !
;  ax !  aux15     !   aux16   !   aux17   !   aux18   !
;  bx !  aux19     !   aux1a   !   aux1b   !   aux1c   !
;  cx !  aux1d     !   aux1e   !   aux1f   !sh!sl!rt!0 !
;  dx !   a0 !  a1 !  a2 !  a3 !  a4 !  a5 !  a6 !  a7 !
;     !================================================!
;
;     The registers saved are dependent upon the value of F0 set on entry to
;     SAVEREGS. LOADREGS restores register values at breakpoint return time.
;     SAVEREGS. LOADREGS restores register values at breakpoint return time.

;                  F0=0  -  SAVES FLAG, F2-7, TOP 13 LEVELS OF STACK, AUX 0-1F.
;                           (BASIC-2 saves only 10 stack levels)
;                  F0=1  -  SAVES FLAG, AUX 10-1F, SH,SL.
;                  F0=2  -  SAVES FLAG, AUX 0A-1F, SH,SL.
;                  F0=3  -  SAVES FLAG, AUX 06-1F, SH,SL.
;                  F0=4  -  SAVES FLAG, AUX 03-1F, SH,SL.

;       SAVE REGISTER FLAG VALUES (BREAKPOINT LOGIC)

SAVALL   EQU       00H       ;SAVE ALL REGISTERS & 10 STACK LEVELS
SAV10    EQU       01H       ;SAVE SH,SL & AUX10-1F
SAV0A    EQU       02H       ;SAVE SH,SL & AUX0A-1F
SAV0C    EQU       SAV0A     ;SAVE SH,SL & AUX0C-1F (AT LEAST)
SAV06    EQU       03H       ;SAVE SH,SL & AUX06-1F
SAV03    EQU       04H       ;SAVE SH,SL & AUX03-1F

_STKLVLS EQU       0DH       ;no. of stack levels to save (13)

@REG3    EQU       @SAVEREG+58H
@REG6    EQU       @SAVEREG+64H
@REGA    EQU       @SAVEREG+74H
@REG10   EQU       @SAVEREG+8CH
@REGMODE EQU       @SAVEREG+9CH          ;AUX 14
@REG1A   EQU       @SAVEREG+0B4H

@BREAKPT EQU       @SAVEREG+18H          ;BREAKPOINT RETURN ADDRESS

@SAVESH  EQU       @SAVEREG+0CCH         ;DISPLACEMENT TO SH IN SAVE REG. AREA


;================ DEVTBL:  device table =======================================;

;                              ---------------
@DEVCI   EQU       @DEVTBL     ; TYPE ! ADDR !  (CONSOLE INPUT)
;                              ---------------
@DEVINPT EQU       @DEVTBL+2   ; TYPE ! ADDR !  (INPUT)
;                              ---------------
@DEVPLOT EQU       @DEVTBL+4   ; TYPE ! ADDR !  (PLOT)
;                              ---------------
@DEVTAPE EQU       @DEVTBL+6   ; TYPE ! ADDR !   (TAPE)
;                              -----------------------------
@DEVCO   EQU       @DEVTBL+8   ; TYPE ! ADDR ! WIDTH! SPARE! (CO)
;                              -----------------------------
@DEVPRNT EQU       @DEVCO+4    ; TYPE ! ADDR ! WIDTH! SPARE!  (PRINT)
;                              -----------------------------
@DEVLIST EQU       @DEVPRNT+4  ; TYPE ! ADDR ! WIDTH! SPARE!  (LIST)
;                              -----------------------------

@DEVDISK EQU       @DEVLIST+4  ;DISK (#0 - #15)
;
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------
;                   ! TYPE ! ADDR ! START-ADDR ! CURR-ADDR ! END-ADDR  !
;                   ----------------------------------------------------


;     OTHER SYSTEM POINTERS:
;

IBUFBEG  EQU       AUX03     ;START OF FREE SPACE FOLLOWING TEXT AREA
                             ;     (USED BY 'ENTER')
IBUFEND  EQU       AUX04     ;END OF AVAILABLE FREE SPACE FOLLOWING TEXT AREA
                             ;     (VSPTR - 32)   (USED BY 'ENTER','LOAD')

;     SYSTEM MINIMUM BUFFER LENGTHS
;

MINBUF   EQU       40H       ;64 BYTES FOR TEXT ENTRY
MINVS    EQU       80H       ;128 BYTES FOR VALUE STACK

ISTACT    EQU       01
ISTSUB    EQU       02
ISTGINH   EQU       04
ISTCHK    EQU       08
ISTALRT   EQU       10H
ISTALRTH  EQU       1

;============================================================================
; The following was originally a separate include file - MPVREGS.ASI
;============================================================================
EXTRN    AUX00     :DWORD
EXTRN    AUX01     :DWORD
EXTRN    AUX02     :DWORD
EXTRN    AUX03     :DWORD
EXTRN    AUX04     :DWORD
EXTRN    AUX05     :DWORD
EXTRN    AUX06     :DWORD
EXTRN    AUX07     :DWORD
EXTRN    AUX08     :DWORD
EXTRN    AUX09     :DWORD
EXTRN    AUX0A     :DWORD
EXTRN    AUX0B     :DWORD
EXTRN    AUX0C     :DWORD
EXTRN    AUX0D     :DWORD
EXTRN    AUX0E     :DWORD
EXTRN    AUX0F     :DWORD
EXTRN    AUX10     :DWORD
EXTRN    AUX11     :DWORD
EXTRN    AUX12     :DWORD
EXTRN    AUX13     :DWORD
EXTRN    AUX14     :DWORD
EXTRN    AUX15     :DWORD
EXTRN    AUX16     :DWORD
EXTRN    AUX17     :DWORD
EXTRN    AUX18     :DWORD
EXTRN    AUX19     :DWORD
EXTRN    AUX1A     :DWORD
EXTRN    AUX1B     :DWORD
EXTRN    AUX1C     :DWORD
EXTRN    AUX1D     :DWORD
EXTRN    AUX1E     :DWORD
EXTRN    AUX1F     :DWORD
EXTRN    AUX20     :DWORD
EXTRN    AUX21     :DWORD
EXTRN    AUX22     :DWORD
EXTRN    AUX23     :DWORD

EXTRN    R0        :BYTE
EXTRN    R1        :BYTE
EXTRN    R2        :BYTE
EXTRN    R3        :BYTE
EXTRN    R4        :BYTE
EXTRN    R5        :BYTE
EXTRN    R6        :BYTE
EXTRN    R7        :BYTE
EXTRN    R8        :BYTE

EXTRN    A0        :WORD
EXTRN    A1        :WORD
EXTRN    A2        :WORD
EXTRN    A3        :WORD
EXTRN    A4        :WORD
EXTRN    A5        :WORD
EXTRN    A6        :WORD
EXTRN    A7        :WORD
EXTRN    A8        :WORD

EXTRN    SH        :BYTE
EXTRN    SL        :BYTE

EXTRN    K         :BYTE

