;============================================================================          
;
;         R  E  N  U  M  B  E  R 
;
;============================================================================          
;       This module was originally M23
;============================================================================          
          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    RENUMBER

EXTRN     BREAKPTG:NEAR
EXTRN     BUMPREAD:NEAR
EXTRN     CCL     :NEAR
EXTRN     CPBASE  :DWORD
EXTRN     ENTERF  :NEAR
EXTRN     ERRC_20 :NEAR
EXTRN     ERRORC  :NEAR
EXTRN     FINDST  :NEAR
EXTRN     LINE_REF:NEAR
EXTRN     NEXTREF :NEAR
EXTRN     NEXTREFS:NEAR
EXTRN     NXTLOW  :NEAR
EXTRN     UNRESLVS:NEAR

; PREDCT:  CALCULATE NEW LINE NUMBER THAT ANY GIVEN
;    NUMBER SHOULD BE CHANGED TO.
;
;  ENTRY:  F1F0 ARE THE LINE NUMBER TO BE CHECKED.
;
;  RETURN:  F3F2 IS THE RESULTANT LINE NUMBER
;
;  MODIFIED REGISTERS:  PC'S, CHCL, F3F2, AUX 1
;

PREDCT:   MOV       AX,WORD PTR [R6]
          CMP       AX,WORD PTR [R0]
          JB        PREDCT9             ;EXIT IF BEYOND RANGE
          MOV       EDX,AUX05
          MOV       WORD PTR [R2],DX
          MOV       EDX,AUX0A
          JMP       PREDCT3

PREDCT2:  MOV       AL,K                ;PREDICT NEXT LINE #
          ADD       AL,R2
          DAA
          MOV       R2,AL
          JNC       PREDCT3
          MOV       AL,R3
          ADD       AL,1
          DAA
          MOV       R3,AL               ;CALCULATE NEXT STMT#
          JC        RENUM97             ;ERROR IF >9999
PREDCT3:  MOV       EAX,DWORD PTR [EDX]
          MOV       AUX01,EDX
          ADD       AUX01,4
          MOV       EDX,AUX01
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       EDX,EAX             ;CHCL = LINE #
          CMP       WORD PTR [R6],CX
          JB        PREDCT9
          CMP       CX,WORD PTR [R0]
          JB        PREDCT2             ;LOOP IF LESS
          JE        PREDCTR             ;EXIT IF EQUAL
PREDCT9:  MOV       AX,WORD PTR [R0]
          MOV       WORD PTR [R2],AX    ;NOT FOUND EXIT
PREDCTR:  RET                           ;RETURN


; NEW SYNTAX:
;
;     RENUMBER [a][-b]   [TO c] [STEP d]
;                         ,[c]  [,[d]]
;
;  REGISTER USAGE:
;        F7F6 = b       default = 9999
;        K    = d       default = 10
;       AUX 4 = a       default = lowest line #
;       AUX 5 = c       default = d
;       AUX 6 =
;       AUX 7  points at thread of highest statement < c
;              which is not between a and b inclusive.
;       AUX 8  points at thread of highest statement < a
;       AUX 9  points at thread of highest statement <=b
;       AUX A  points at thread of first statement >=a

RENUMBER: CALL      LINE_REF            ;GET a
          TEST      R0,0FH
          JZ        RENUM11             ;F, SKIP
          MOV       WORD PTR [R2],0
RENUM11:  MOV       DX,WORD PTR [R2]
          MOV       AUX04,EDX           ;SAVE START LINE NUMBER IN AUX 4
          MOV       WORD PTR [R6],9999H ;(F7F6 = 9999)
          CMP       BYTE PTR [TEXTPTR],'-' ;CHECK NEXT CHARACTER FOR -
          JNE       RENUM13             ;SKIP IF NOT FOUND (DEFAULT = 9999)
          INC       TEXTPTR
          CALL      LINE_REF            ;GET b
          TEST      R0,0FH
          JNZ       RENUM91             ;ERROR IF NOT FOUND
          MOV       AX,WORD PTR [R2]
          MOV       WORD PTR [R6],AX    ;F7F6 = b
          MOV       EDX,AUX04           ;GET START LINE NUMBER (a)
          CMP       WORD PTR [R6],DX
          JB        RENUM95             ;ERROR IF b < a

RENUM13:  MOV       R5,0                ;FLAG: c NOT FOUND (so far)
          CMP       BYTE PTR [TEXTPTR],',' ;CHECK FOR COMMA
          JNE       RENUM20             ;SKIP IF NOT FOUND
          INC       TEXTPTR
          CALL      LINE_REF            ;CHECK c
          TEST      R0,0FH
          JNZ       RENUM15             ;SKIP IF NOT FOUND
          MOV       R5,1                ;FLAG = DEST LINE IS FOUND
          MOV       DX,WORD PTR [R2]
          MOV       AUX05,EDX           ;SAVE DESTINATION LINE NUMBER
RENUM15:  CMP       BYTE PTR [TEXTPTR],',' ;CHECK FOR COMMA
          JNE       RENUM25             ;DONE IF NOT FOUND
          INC       TEXTPTR
          CALL      LINE_REF            ;LOOK FOR d, increment
          TEST      R0,0FH
          JNZ       RENUM25             ;DONE IF NOT FOUND
          JMP       RENUM24

RENUM20:  MOV       R0,@TO
          CALL      CCL                 ;LOOK FOR 'TO'
          TEST      R0,0FH
          JNZ       RENUM22             ;NF, SKIP AHEAD
          CALL      LINE_REF            ;LOOK FOR c
          TEST      R0,0FH
          JNZ       RENUM91             ;ERROR IF NF
          MOV       R5,1
          MOV       DX,WORD PTR [R2]
          MOV       AUX05,EDX           ;SAVE c
RENUM22:  MOV       R0,@STEP
          CALL      CCL                 ;LOOK FOR 'STEP'
          TEST      R0,0FH
          JNZ       RENUM25             ;NF, SKIP AHEAD
          CALL      LINE_REF            ;LOOK FOR d
          TEST      R0,0FH
          JNZ       RENUM99             ;ERROR IF NF
RENUM24:  CMP       WORD PTR [R2],0099H ;ERROR IF >99
          JA        RENUM99
          CMP       WORD PTR [R2],0
          JE        RENUM99             ;ERROR IF =0
          MOV       AL,R2
          MOV       K,AL
          JMP       RENUM27
RENUM25:  MOV       K,10H               ;DEFAULT INCREMENT (d) = 10
RENUM27:  TEST      R5,0FH
          JNZ       RENUM29             ;SKIP IF c WAS SPECIFIED EXPLICITLY
          XOR       EDX,EDX
          MOV       DL,K
          MOV       AUX05,EDX           ;c=d; DESTINATION LINE NUMBER = INCREMENT
RENUM29:  MOV       EDX,TEXTENDS
          MOV       TEXTEND,EDX         ;FLUSH THE STATEMENT
          CMP       BYTE PTR [TEXTPTR],0DH  ;GET A CARRIAGE RETURN
          JNE       ERRC_20
          INC       TEXTPTR
          CALL      UNRESLVS            ;NOT RESOLVED, NO INTERRUPTS, FLUSH STACKS

;  SET UP IMPORTANT POINTERS FOR RENUMBERING
;
          MOV       EDX,AUX04
          MOV       WORD PTR [R2],DX    ;F3F2 = a
          CALL      FINDST
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1
          JE        RENUM80             ;SKIP, IF NO STMT >= a
          CMP       WORD PTR [R6],CX
          JB        RENUM80             ;SKIP IF b< new a
          MOV       AUX0A,EDX           ;SAVE ADDRESS OF new a
          MOV       DX,CX
          MOV       AUX04,EDX           ;SAVE LINE NUMBER OF new a
          CALL      NXTLOW
          MOV       AUX08,EDX           ;SAVE THREAD OF HIGHEST STMT < a
          MOV       EDX,AUX05
          MOV       WORD PTR [R2],DX
RENUM31:  CALL      NXTLOW
          MOV       AUX07,EDX           ;AUX 7 POINTS AT LINE BEFORE HOLE
          MOV       DWORD PTR [A0],EDX  ;SAVE THE POINTER
          ADD       EDX,4
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       EDX,AUX04           ;READ THE LINE NUMBER
          CMP       WORD PTR [R6],CX
          JB        RENUM32             ;OKAY IF BEYOND RENUM RANGE
          CMP       CX,DX
          JB        RENUM32             ;OKAY IF BEFORE RENUM RANGE
          MOV       WORD PTR [R2],CX    ;(SAVE CHCL, LINE #)
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TEXTBEG
          CMP       DWORD PTR [A0],EDX
          JBE       RENUM32             ;OKAY IF BEGINNING OF TEXT
          JMP       RENUM31             ;LINE # F3F2 WILL BE MOVED, TRY AGAIN

RENUM32:  MOV       AX,WORD PTR [R6]
          MOV       WORD PTR [R2],AX
          INC       WORD PTR [R2]
          CALL      NXTLOW              ;FIND THE HIGHEST LINE THAT WILL BE MOVED
          MOV       AUX09,EDX           ;AUX 9 POINTS AT LAST LINE TO BE MOVED
          CALL      BUMPREAD            ;READ THE HIGHEST STATEMENT # IN RANGE TO BE MOVED
          MOV       WORD PTR [R6],CX
          MOV       WORD PTR [R0],CX
          CALL      PREDCT              ;PREDICT NEW LINE # FOR END OF RANGE (F3F2)

;  CHECK IF HOLE IS BIG ENOUGH FOR MOVED TEXT
;
          MOV       EDX,AUX07
          MOV       ECX,DWORD PTR [EDX]
          MOV       EDX,ECX             ;PHPL = THREAD
          JMP       RENUM38
RENUM35:  MOV       EAX,DWORD PTR [EDX]
          ADD       EDX,4
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          MOV       EDX,EAX             ;PHPL = THREAD,  CHCL= STMT #
          CMP       WORD PTR [R2],CX
          JB        RENUM48             ;OKAY IF MOVED TEXT FITS ENTIRELY
          CMP       WORD PTR [R6],CX
          JB        RENUM97             ;ERROR, SKIP
          XCHG      EDX,AUX04
          CMP       CX,DX
          JB        RENUM97             ;ERROR, SKIP
          XCHG      EDX,AUX04

;  CURRENT LINE IS GOING TO MOVE ANYWAY;  CHECK NEXT
;

RENUM38:  CMP       EDX,0
          JNE       RENUM35             ;LOOP BACK IF ANY MORE TEXT

;   (OKAY IF END OF TEXT)
;  RENUMBER LINE # REFERENCES
;

RENUM48:  CALL      NEXTREFS            ;FIND FIRST REFERENCE
          JMP       RENUM55
RENUM53:  CALL      NEXTREF             ;FIND NEXT REFERENCE
RENUM55:  MOV       AL,R1
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        RENUM60             ;SKIP IF END OF TEXT
          CALL      PREDCT              ;PREDICT THIS LINE #
          MOV       EDX,TEXTPTR
          MOV       AX,WORD PTR [R2]
          XCHG      AH,AL
          MOV       WORD PTR [EDX-6],AX
;         ADD       EDX,2
;         MOV       TEXTPTR,EDX         ;CHANGE TO NEW LINE #
;         ADD       TEXTPTR,4
          CALL      BREAKPTG            ;BREAKPOINT IF 30MS. ELAPSED
          JMP       RENUM53             ;LOOP BACK TILL END OF STMT

;   RE-THREAD TEXT LINES
;

RENUM60:  MOV       EDX,AUX08
          MOV       ECX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EDX
          MOV       EDX,AUX07
          CMP       EDX,DWORD PTR [A0]
          JE        RENUM70             ;OK IF IN-PLACE RENUMBER
;         CALL      EXTHR               ;ATTACH TEXT AT NEW PLACE
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [EDX],ECX
          MOV       ECX,EAX
          MOV       EDX,AUX09
;         CALL      EXTHR               ;CHANGE LAST MOVED LINE, TOO
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [EDX],ECX
          MOV       ECX,EAX
          MOV       EDX,AUX08
;         CALL      EXTHR               ;UNTHREAD THE TEXT FROM THE ORIGINAL PLACE
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [EDX],ECX
          MOV       ECX,EAX

;   RENUMBER THE MOVED STATEMENTS THEMSELVES
;

RENUM70:  MOV       EDX,AUX05
          MOV       WORD PTR [R2],DX
          MOV       EDX,AUX04
          MOV       WORD PTR [R4],DX    ;F5,4 = LOWEST LINE# OF RANGE TO RENUMBER
          MOV       EDX,AUX0A
          JMP       RENUM73

RENUM72:  MOV       AL,K
          ADD       AL,R2
          DAA
          MOV       R2,AL
          JNC       RENUM73
          MOV       AL,R3
          ADD       AL,1
          DAA
          MOV       R3,AL               ;CALCULATE NEXT STMT#
RENUM73:  MOV       ECX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],ECX
          ADD       EDX,4
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CMP       CX,WORD PTR [R4]
          JB        RENUM80             ;BRANCH IF NOT IN RANGE
          CMP       WORD PTR [R6],CX
          JB        RENUM80             ;JUMP IF BEYOND RANGE
          MOV       AX,WORD PTR [R2]
          XCHG      AH,AL
          MOV       WORD PTR [EDX],AX   ;CHANGE STMT NUMBER
          MOV       EDX,DWORD PTR [A0]
          CMP       EDX,0
          JNE       RENUM72             ;LOOP IF NON-ZERO THREAD

RENUM80:  JMP       ENTERF              ;FLUSH STATEMENT AND GO TO ENTER
RENUM91:  MOV       R0,21H
          JMP       ERRORC              ;MISSING LINE # (SYNTAX)
RENUM95:  MOV       R0,32H
          JMP       ERRORC              ;START > END
RENUM97:  MOV       R0,33H
          JMP       ERRORC              ;CONFLICT OF LINE #'S ERROR
RENUM99:  MOV       R0,34H
          JMP       ERRORC              ;ILLEGAL VALUE (>99)

CODE      ENDS
          END
