;===========================================================================          
;
;          S Y N T A X   C H E C K I N G
;
;===========================================================================          
;       This Module was originally M02
;===========================================================================          

          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    @LETTER
PUBLIC    CCJ
PUBLIC    CCJB
PUBLIC    CCJE
PUBLIC    CCL
PUBLIC    CCLFROM
PUBLIC    CCLTO
PUBLIC    CCNL
PUBLIC    DEVADDR
PUBLIC    DEVADDRS
PUBLIC    DIGIT
PUBLIC    ERRC_20
PUBLIC    ERROR_08
PUBLIC    ERROR_10
PUBLIC    ERROR_11
PUBLIC    ERROR_12
PUBLIC    ERROR_13
PUBLIC    ERROR_17
PUBLIC    ERROR_18
PUBLIC    ERROR_19
PUBLIC    ERROR_34
PUBLIC    HEXDIGIT
PUBLIC    HEXDIGTA
PUBLIC    HEXPAIR
PUBLIC    INTEGER
PUBLIC    LETRDIGT
PUBLIC    LETTER
PUBLIC    LETTERA
PUBLIC    LINE_
PUBLIC    LINE_REF
PUBLIC    LN_RANGA
PUBLIC    LN_RANGE
PUBLIC    NXTCHEOS
PUBLIC    RELOP
PUBLIC    SCANCHA
PUBLIC    SCNCHSS
PUBLIC    SQZTEXT
PUBLIC    SQZTEXTL
PUBLIC    SWITCH
PUBLIC    SWITCHA
PUBLIC    VARNAME
PUBLIC    VARNAMEA
PUBLIC    VARNAMEB
PUBLIC    VERBCHK

EXTRN     ERROR   :NEAR
EXTRN     ERRORC  :NEAR
EXTRN     ERROR_16:NEAR
EXTRN     ERROR_20:NEAR
EXTRN     ERR_02  :NEAR
EXTRN     ERR_01  :NEAR
EXTRN     LISTVAR :NEAR
EXTRN     ONBRANCH:NEAR
EXTRN     ORG0000 :NEAR
EXTRN     ORG0100 :NEAR
EXTRN     _FROM   :NEAR
EXTRN     BASE    :NEAR

EXTRN     PART_     :BYTE
EXTRN     cpbase   :dword

;------------------------------------------------------------------------------;
;                                                                              ;
;          *******************************                                     ;
;          *                             *                                     ;
;          *  MODULE#2: SYNTAX CHECKING  *                                     ;
;          *                             *                                     ;
;          *******************************                                     ;
;                                                                              ;
;                                                                              ;
;     DESCRIPTION: SUBROUTINES FOR SCANNING TEXT                               ;
;                                                                              ;
;     ENTRY: TEXTPTR POINTS TO NEXT CHARACTER IN TEXT                          ;
;               TO BE PROCESSED.                                               ;
;            TEXTLPTR POINTS TO CURRENT TEXT LINE.                             ;
;                                                                              ;
;------------------------------------------------------------------------------;

;     LETRDIGT: GET NEXT TEXT CHARACTER IF ITS A
;               LETTER OR DIGIT
;     DIGIT:    GET NEXT TEXT CHARACTER IF ITS A DIGIT
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 IF FOUND, CH = FOUND CHARACTER
;                         PC'S POINT TO FOUND CHARACTER
;                  F0 =1 IF NOT FOUND, PC'S POINT TO
;                        NEXT NONBLANK CHARACTER
;                        CH = NEXT NONBLANK CHARACTER
;
;                  IF FOUND, TEXTPTR POINTS TO CHARACTER
;                  AFTER FOUND CHARACTER. OTHERWISE,
;                  TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;

LETRDIGT: CALL      LETTER              ;LOOK FOR A LETTER
          TEST      R0,0FH
          JZ        DIGIT2              ;BRANCH IF FOUND
DIGIT:    MOV       EDX,TEXTPTR         ;PC'S POINT TO NEXT TEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]   ;READ CHARACTER AND INC. TEXTPTR
          INC       TEXTPTR
          CMP       CH,30H
          JB        DIGIT1
          CMP       CH,39H
          JA        DIGIT1
          MOV       R0,0
          RET
DIGIT1:   MOV       TEXTPTR,EDX
          MOV       R0,1
DIGIT2:   RET



;     LETTER: GET NEXT TEXT CHARACTER IF ITS A LETTER
;             (A-Z)
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 IF FOUND, CH = LETTER
;                         PC'S POINT TO FOUND CHARACTER
;                  F0 = 1 IF NOT FOUND, PC'S POINT TO
;                         NEXT NONBLANK CHARACTER
;                         CH = NEXT NONBLANK CHARACTER
;
;                  TEXTPTR POINTS TO NEXT CHARACTER AFTER
;                  LETTER IF FOUND. OTHERWISE, TO THE
;                  NONBLANK CHARACTER.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;
;          NOTE: 'LETTER' MUST BE LOCAL TO 'CHARNF'
;
;     LETTERA: SAME  AS 'LETTER' EXCEPT FOR ENTRY
;
;          ENTRY: PC'S = TEXTPTR
;

LETTER:   MOV       EDX,TEXTPTR          ;PC'S POINT TO NEXT TEXT CHARACTER
LETTERA:  MOV       CH,BYTE PTR [EDX]    ;READ CHARACTER AND INC. TEXTPTR
          INC       TEXTPTR
          CMP       CH,41H
          JB        LETTER1
          CMP       CH,5AH
          JA        LETTER1
          MOV       R0,0
          RET
LETTER1:  MOV       TEXTPTR,EDX
          MOV       R0,1
          RET


;     @LETTER: LOOK FOR [@] LETTER
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 BIT08 OF F2 = 0
;
;          RETURN: F0 = 0 IF FOUND, CH = LETTER
;                         PC'S POINT TO FOUND CHARACTER
;                         F2 = F2 OR 08 IF @ LETTER
;                         AUX0 POINTS AT 1ST CHAR. OF NAME
;                  F0 = 1 IF NOT FOUND, PC'S POINT TO
;                         NEXT NONBLANK CHARACTER
;                         CH = NEXT NONBLANK CHARACTER
;
;                  ERR#16 IF @ FOUND BUT NO LETTER
;
;                  TEXTPTR POINTS TO NEXT CHARACTER AFTER
;                  LETTER IF FOUND. OTHERWISE, TO THE NEXT
;                  NONBLANK CHARACTER.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0,F2,AUX0
;

@LETTER:  MOV       EDX,TEXTPTR         ;PC'S POINT TO NEXT TEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]   ;READ CHARACTER AND INC. TEXTPTR
          INC       TEXTPTR
          CMP       CH,40H
          JE        @LETTER1            ;BRANCH IF CHARACTER '@'
          JB        @LETTER2            ;NOT FOUND
          CMP       CH,5AH
          JA        @LETTER2            ;NOT FOUND
          MOV       AUX00,EDX           ;AUX0 POINT AT LETTER (NO '@' FOUND)
          MOV       R0,0
          RET

@LETTER1: OR        R2,08H              ;FLAG = '@' FOUND
          MOV       AUX00,EDX           ;AUX00 POINT AT '@'
          CALL      LETTER              ;FOUND SECOND CHARACTER
          TEST      R0,0FH
          JNZ       ERROR_16            ;ERROR IF @ FOUND BUT NO LETTER
          RET

@LETTER2: MOV       TEXTPTR,EDX
          MOV       R0,1
          RET


;     NXTCH: GET NEXT NONBLANK TEXT CHARACTER IF =
;            CHARACTER IN F0
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 F0 = CHARACTER LOOKING FOR
;
;          RETURN: F0 = 0 IF FOUND, PC'S POINTS TO
;                         FOUND CHARACTER
;                  F0 =1 IF NOT FOUND, PC'S POINT TO
;                        NEXT NONBLANK CHARACTER
;                        CH = NEXT NONBLANK CHARACTER
;
;                  IF FOUND, TEXTPTR POINTS TO CHARACTER
;                  AFTER THE FOUND CHARACTER. OTHERWISE,
;                  TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;
;          NOTE: 'NXTCH' MUST BE LOCAL TO 'CHARNF','CHARF
;
;     NXTCHCR: GET NEXT TEXT CHARACTER IF = CR
;     NXTCHCOM: ... IF = COMMA
;     NXTCHLP:  ... IF = '('
;     NXTCHRP:  ... IF = ')'
;     NXTCHEQL: ... IF = '='
;     NXTCHSQT: ... IF = SINGLE QUOTE
;     NXTCHDEF: ... IF = 'DEFFN' TEXT ATOM
;     NXTCHP:   ... IF = 'P'
;     NXTCH$:   ... IF = '$"
;     NXTCHQT:  ... IF = '"'
;     NXTCHF:   ... IF = 'F'
;     NXTCHR:   ... IF = 'R'
;     NXTCHS:   ... IF = 'S'
;     NXTCHT:   ... IF = 'T'
;     NXTCH/:   ... IF = '/'
;     NXTCH#:   ... IF = '#'
;     NXTCHMNS: ... IF = '-'
;     NXTCH;:   ... IF = ';'
;     NXTCH>:   ... IF = '>'
;     NXTCH<:   ... IF = '<'
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;


NXTCHCOM: MOV       AL,2CH             ;AL = COMMA
NXTCH:    MOV       EDX,TEXTPTR        ;PC'S POINT TO NEXT TEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]  ;READ CHARACTER AND INC. TEXTPTR
          INC       TEXTPTR
          CMP       CH,AL              ;BRANCH IF CORRECT CHARACTER
          JNE       NXTCH1
          MOV       R0,0
          RET
NXTCH1:   MOV       TEXTPTR,EDX
          MOV       R0,1
          RET

;     HEXDIGIT: GET NEXT TEXT CHARACTER IF ITS A HEX
;               DIGIT (IE, 0-9 OR A-F)
;
;     HEXDIGTA: same as 'HEXDIGIT' except Not Found return if space encountered.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0X IF FOUND WHERE X = DIGIT
;                          PC'S POINT TO FOUND CHARACTER
;                  F0 = 10 IF NOT FOUND, PC'S POINT TO
;                          NEXT NONBLANK CHARACTER
;
;                  TEXTPTR POINTS TO CHARACTER AFTER HEX
;                  DIGIT IF FOUND. OTHERWISE, TO THE NEXT
;                  NONBLANK TEXT CHARACTER.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;

HEXDIGTA:
HEXDIGIT: MOV       EDX,TEXTPTR            ;PC'S POINT TO NEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]      ;READ CHARACTER AND INC TEXTPTR
          INC       TEXTPTR
          CMP       CH,39H                 ;CHECK DIGIT
          JA        HEXDIGIT1
          CMP       CH,30H
          JB        HEXDIGIT2
          MOV       R0,CH
          AND       R0,0FH
          RET

HEXDIGIT1:CMP       CH,'A'                 ;CHECK 'A' TO 'F'
          JB        HEXDIGIT2
          CMP       CH,'F'                 ;CHECK 'A' TO 'F'
          JA        HEXDIGIT2
          MOV       R0,CH                  ;FOUND AND SET RETURN VALUE
          ADD       R0,0C9H
          RET

HEXDIGIT2:MOV       TEXTPTR,EDX            ;NOT FOUND AND RESET TEXTPTR ,RETURN VAL
          MOV       R0,10H
          RET



;     SCANCHA: SCAN CURRENT TEXT LINE FOR A SPECIFIED
;             CHARACTER. SCAN TERMINATES IF 'CR' OR
;             STATEMENT SEPARATOR IS FOUND.
;
;          ENTRY: TEXTPTR POINTS TO CHARACTER IN TEXT
;                    LINE TO BEGIN SCAN AT.
;                 F0 = CHARACTER TO SCAN FOR
;
;          RETURN: F0 = 0 IF FOUND, TEXTPTR POINTS TO
;                         CHARACTER AFTER FOUND CHAR.
;                         PC'S POINT TO FOUND CHARACTER.
;                  F0 = 1 IF NOT FOUND, TEXTPTR & PC,S
;                         POINT TO 'CR' OF LINE.
;                  F0 = 2 IF STATEMENT SEPARATOR FOUND
;                         BEFORE SPECIFIED CHARACTER.
;                         TEXTPTR & PC'S POINT AFTER
;                         STATEMENT SEPARATOR.
;          MODIFIED REGISTERS: CH,CL,PC'S,F0
;
;          NOTE, 'SCANCH' MUST BE LOCAL TO 'CHARF' &
;                'CHARNF'
;          NOTE: SCANCH MAY NOT SAFELY BE USED IN AN
;                IMAGE STATEMENT, EXCEPT TO FIND THE CR.
;                NO CHARACTER IN A REM MAY BE SAFELY
;                SEARCHED FOR, EXCEPT THE STATEMENT
;                SEPARATOR.
;     SCNCHSS: SCAN FOR 'STATEMENT SEPARATOR' (FD)
;
;          ENTRY: TEXTPTR POINTS TO CHARACTER IN TEXT
;                 LINE TO BEGIN SCAN AT.
;
;

SCNCHSS:  MOV       R0,@STMTSEP          ;SCAN FOR 'STATEMENT SEPARATOR'

;   NEW SCANCH ROUTINE - SCANCHA

SCANCHA:  MOV       R8,0
          test      mode,2000h
          jnz       scanchbx
          MOV       EDX,TEXTPTR
SCANCHAP:
          CMP       BYTE PTR [EDX-1],@REM
          JE        SCANCHBX
          cmp       byte ptr [edx-1],@?PE
          je        scanchbx
          CMP       BYTE PTR [EDX-1],20H
          JNE       SCANCHB
          DEC       EDX
          JMP       SCANCHAP
scanchbx:
          MOV       R8,1
SCANCHB:  MOV       EDX,TEXTPTR
SCANCHA6: MOV       CH,BYTE PTR [EDX]    ;GET NEXT TEXT CHARACTER
          INC       TEXTPTR
SCANCHA7: CMP       R8,1
          JE        SCANCHAX
          CMP       CH,7FH
          JE        SCANCHX
          CMP       CH,7DH
          JE        SCANCHX
          CMP       CH,7EH
          JE        SCANCHY
          CMP       CH,@REM
          JE        SCANCHA8
SCANCHAX: CMP       CH,R0
          JE        SCANCHA1             ;BRANCH IF CHAR. = CHAR. LOOKING FOR
          CMP       CH,0DH
          JE        SCANCHA2             ;BRANCH IF CHAR. = 'CR'
;         CMP       CH,@REM
;         JNE       SCANCHA3             ;BRANCH IF NOT 'REM' ATOM
          JMP       SCANCHA3

;  WE'RE IN A REM;  SKIP TO STATEMENT SEPARATOR OR CR

SCANCHA8: MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR
          CMP       CH,0DH               ;BRANCH IF CHAR = 'CR'
          JE        SCANCHA7
          CMP       CH,@STMTSEP
          JNE       SCANCHA8             ;LOOP IF NOT STATEMENT SEPARATOR
          JMP       SCANCHA7             ;BRANCH IF CHAR = STATEMENT SEPARATOR

SCANCHA3: CMP       CH,@STMTSEP
          JE        SCANCHA4             ;EXIT IF STATEMENT SEPARATOR (FD)
          CMP       CH,@LTRL
          JE        SCANCHA5             ;BRANCH IF LITERAL ATOM (FE)
          CMP       CH,@HEXLIT
          JE        SCANCHA5             ;BRANCH IF @HEXLIT ATOM (FC)
          CMP       CH,@LINE_
          JNE       SCANCHB              ;BRANCH IF NOT LINE_ ATOM (FF)
          MOV       TEXTPTR,EDX          ;IF CHAR. = LINE# ATOM, BYPASS LINE NO.
          ADD       TEXTPTR,7
          JMP       SCANCHB

SCANCHA5: MOV       EDX,TEXTPTR
          MOV       ECX,0                ;INIT CHAR LENGTH
          MOV       CL,BYTE PTR [EDX]    ;CH = LENGTH OF PACKED HEX-LITERAL'
          INC       EDX
          ADD       EDX,ECX              ;PC'S POINT AFTER HEX-LITERAL
          MOV       TEXTPTR,EDX
          JMP       SCANCHA6

SCANCHA1: MOV       R0,0
          RET

SCANCHA2: MOV       TEXTPTR,EDX
          MOV       R0,1
          RET

SCANCHA4: MOV       R0,2                 ;FLAG THE STATEMENT SEPARATOR FOUND
          RET

SCANCHX:  ADD       TEXTPTR,6
          JMP       SCANCHB

SCANCHY:  ADD       TEXTPTR,8
          JMP       SCANCHB



;     CCL: LOOK FOR A SPECIFIED WORD (OR ATOM) IN TEXT.
;          IF ENTRY PHASE AND AN UNATOMIZED WORD IS FOUND
;          THE WORD IS REPLACED BY ITS TEXT ATOM. IF WORD
;          INCLUDES A TRAILING SPACE AND THERE IS A SPACE
;          FOLLOWING WORD IN TEXT, THAT SPACE WILL BE
;          DELETED; SUCCESSIVE SPACES WILL NOT BE
;          DELETED. IF RESOLUTION OR EXECUTION PHASE,
;          ONLY ATOMS ARE LOOKED FOR.
;
;          ENTRY: TEXTPTR POINTS TO THE NEXT CHARACTER
;                      IN TEXT.
;                 F0 = TEXT ATOM OF WORD (OR ATOM)
;                      LOOKING FOR.
;
;          RETURN: F0,BITS0F= 0 IF FOUND, TEXTPTR POINTS
;                         TO CHARACTER AFTER ATOM.
;                  F0,BITS0F= 1 IF NF, TEXTPTR POINTS TO
;                         NEXT NONBLANK TEXT CHARACTER.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;               F1,AUX0,1 (ENTRY PHASE ONLY)
;
;          NOTE, ASSUMES ATOM TABLE ORIGIN IS: 0100
;

CCL:      TEST      SL,3
          JZ        CCL1                ;BRANCH IF ENTRY PHASE
          MOV       EDX,TEXTPTR         ;PC'S POINT TO NEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]   ;READ CHARACTER AND INC TEXTPTR
          INC       TEXTPTR
          CMP       CH,R0
          JNE       CCL2                ;NOT FOUND AND RETURN
          MOV       R0,0                ;FOUND
          RET

CCL2:     MOV       TEXTPTR,EDX
          MOV       R0,1
          RET

CCL1:     MOV       AL,R0
          MOV       R1,AL               ;SAVE TEXT ATOM
          CALL      NXTCH               ;SEE IF NEXT TEXT CHARACTER = ATOM
          TEST      R0,0FH
          JNZ       CCL3
          RET

CCL3:     MOV       EAX,0
          MOV       AL,R1
          SUB       EAX,00000080H
          SHL       EAX,3

;      (ASSUMES ATOM TABLE ORIGIN IS: 0100)

          MOV       EDX,OFFSET ORG0100
          ADD       EDX,EAX             ;PC'S = ADDRESS OF ATOM ENTRY IN ATOM TABLE
          MOV       ECX,DWORD PTR [EDX] ;ECX = ADDRESS OF UNATOMIZED WORD
          MOV       EDX,ECX
          AND       EDX,0FFFFFFFH


;     CCNL: COMPARE THE NEXT TEXT CHARACTERS WITH THE
;           SPECIFIED WORD. SPACES ARE IGNORED IN BOTH
;           THE SPECIFIED WORD AND TEXT.  IF THE WORD IS
;           FOUND, IT IS REPLACED BY ITS TEXT ATOM.
;           IF THE WORD INCLUDES A TRAILING SPACE AND
;           THERE IS A SPACE FOLLOWING WORD IN TEXT, THAT
;           SPACE WILL BE DELETED; SUCCESSIVE SPACES WILL
;           NOT BE DELETED.
;
;          ENTRY: TEXTPTR POINTS TO THE NEXT TEXT CHAR.
;                 PC'S = ADDRESS OF THE SPECIFIED WORD.
;                 PHASE = EXECUTION (UNLESS WORD NOT TO
;                         BE ATOMIZED, ATOM = 00)
;
;          RETURN: F0,BITS0F = 0 IF FOUND, TEXT WORD IS
;                    REPLACED BY ATOM. TEXTPTR & PC'S
;                    POINT TO CHARACTER AFTER ATOM.
;                  F0 = 1 IF NF, TEXTPTR POINTS TO NEXT
;                         NEXT NONBLANK CHAR. IN TEXT.
;                         AUX1 POINTS TO NEXT CHAR. TO BE
;                         CHECKED IN THE SPECIFIED WORD.
;                         F1 = NO. OF CHAR. LEFT TO BE
;                         CHECKED.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0,F1,AUX0,1
;
;          WORD FORMAT: COUNT (NO. OF CHARACTERS IN WORD)
;                       1ST CHARACTER OF WORD
;                       2ND CHARACTER OF WORD
;                        .
;                        .
;                        .
;                       LAST CHARACTER OF WORD
;                       TEXT ATOM FOR WORD
;

CCNL:     MOV       CH,BYTE PTR [EDX]  ;SAVE PTR TO SPECIFIED WORD AND GET LENGTH OF
          MOV       AUX01,EDX
          INC       AUX01
          MOV       EDX,TEXTPTR        ;OF THE WORD
          MOV       AUX00,EDX          ;SAVE TEXT PTR
          MOV       R1,CH              ;F1 = LENGTH OF WORD
CCNL2:    MOV       EDX,AUX01
          MOV       CH,BYTE PTR [EDX]
          INC       AUX01              ;GET NEXT CHAR. OF SPECIFIED WORD
          MOV       AL,CH              ;F0 = CHARACTER
          MOV       R0,CH
          CMP       CH,20H
          JE        CCNL3              ;BRANCH IF CHAR. = SPACE
          CALL      NXTCH              ;IS NEXT CHAR. IN TEXT = CHAR. OF WORD?
          TEST      R0,0FH
          JZ        CCNL1              ;YES, BRANCH
          MOV       EDX,AUX00
          MOV       TEXTPTR,EDX        ;NO, RESTORE TEXTPTR
CCLNR:    RET
CCNL3:    MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR            ;GET NEXT TEXT CHARACTER
          CMP       CH,R0
          JE        CCNL1              ;BRANCH IF CHARACTER = 'SPACE'
          MOV       TEXTPTR,EDX        ;DECREMENT TEXTPTR
CCNL1:    DEC       R1                 ;DECREMENT COUNT
          CMP       R1,0
          JNE       CCNL2              ;BRANCH IF MORE TO CHARACTERS IN WORD
;
;     REPLACE TEXT WORD BY TEXT ATOM FOR WORD
;
          MOV       EDX,AUX01
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX01,EDX
          INC       AUX01              ;GET TEXT ATOM
          CMP       CH,0
          JE        CCLNR              ;EXIT IF "TEXT ATOM" = 0
          TEST      SL,03H
          JZ        CCNL4              ;DON'T ATOMIZE IF NOT ENTRY PHASE
CCNL5:    RET
CCNL4:    TEST      MODE,0800H
          JNZ       CCNL5              ;BRANCH IF LISTV MODE (DON'T ATOMIZE)
          MOV       EDX,AUX00
          MOV       BYTE PTR [EDX],CH
          MOV       AUX00,EDX
          INC       AUX00              ;PUT TEXT ATOM IN TEXT LINE
          JMP       SQZTEXTL



;     SQZTEXT: DELETE A SECTION OF A TEXT LINE. ASSUMES
;              REST OF LINE NOT ATOMIZED.
;
;          ENTRY: AUX0 = ADDRESS TO MOVE 'TO'
;                 TEXTPTR = ADDRESS TO MOVE 'FROM'
;                 LINE MUST END WITH A CR.
;
;                 ALL CHARACTERS FROM THE 'TO' ADDRESS
;                 UP TO BUT NOT INCLUDING THE 'FROM'
;                 ADDRESS ARE DELETED. THE TEXT LINE IS
;                 IN EFFECT SHIFTED TO THE LEFT.
;
;          RETURN: PC'S, TEXTPTR = ADDRESS OF CR + 1
;
;          MODIFIED REGISTERS: PH,PL,CH,CL
;
;          NOTE: THIS ROUTINE SHOULD ONLY BE ENTERED
;                IN ENTRY PHASE SINCE TEXT IS MOVED.
;
;     SQZTEXTL: DELETE A SECTION OF A TEXT LINE. ASSUMES
;               REST OF LINE IS UNATOMIZED.
;
;          RETURN: PC'S = ADDRESS OF CR + 1
;                  TEXTEND = ADDRESS OF CR
;                  TEXTPTR = 'TO' ADDRESS
;

SQZTEXTL: CALL      SQZTEXT            ;DELETE TEXT WORD FROM TEXT LINE
          MOV       TEXTEND,EDX        ;RESET TEXTEND TO NEW VALUE
          DEC       TEXTEND
          MOV       EDX,AUX00
          MOV       TEXTPTR,EDX        ;RESET TEXTPTR TO CHARACTER AFTER ATOM
          RET

SQZTEXT:  MOV       ESI,TEXTPTR        ;ESI  = 'FROM' ADDRESS
          MOV       EDI,AUX00          ;EDI  = 'TO' ADDRESS
;         CLD
SQZTEXT1: LODSB
          STOSB
          CMP       AL,0DH             ;EXIT IF CHAR. = 'CR'
          JNE       SQZTEXT1
          MOV       EDX,EDI            ;RESET PC'S AND TEXTPTR
          MOV       TEXTPTR,EDI
          RET



;     CCJ: LOOK FOR A SPECIFIED TYPE OF WORD (OR ATOM) IN
;          TEXT. IN ENTRY PHASE AND AN UNATOMIZED WORD IS
;          FOUND, THE WORD IS REPLACED BY ITS TEXT ATOM.
;          IF THE WORD INCLUDES A TRAILING SPACE AND
;          THERE IS A SPACE FOLLOWING WORD IN TEXT, THAT
;          SPACE WILL BE DELETED; SUCCESSIVE SPACES WILL
;          NOT BE DELETED.
;
;          ENTRY: TEXTPTR POINTS TO THE NEXT TEXT CHAR.
;                 F2 (HIGH 4-BITS) = LIST OF WORDS TO
;                                    BE CHECKED.
;                             (0 = VERB LIST)
;                             (2 = COMMAND LIST)
;                             (4 = FUNCTION LIST)
;                             (6 = ----)
;                             (8 = ARC FUNCTION LIST)
;                             (A = FUNCTION LIST #2)
;                             (C = ----)
;                             (E = ----)
;
;          RETURN: F0 = 0X IF FOUND, TEXTPTR POINTS TO
;                          CHARACTER AFTER TEXT ATOM.
;                          PC'S = ADDRESS OF FOUND WORD'S
;                          ROUTINE.
;                  F0 <> 0X IF NOT FOUND, TEXTPTR POINTS
;                          TO NEXT NONBLANK TEXT CHAR.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0
;                  F1,F3,AUX0,1 (ENTRY PHASE ONLY)
;
;          LIST STRUCTURE: COUNT (NO. OF WORDS IN LIST)
;
;                          NO. OF CHARACTERS IN 1ST WORD
;                          1ST CHARACTER OF 1ST WORD
;                          2ND CHARACTER OF 1ST WORD
;                          .
;                          .
;                          .
;                          LAST CHARACTER OF 1ST WORD
;                          TEXT ATOM OF 1ST WORD
;
;                          NO. OF CHARACTERS IN 2ND WORD
;                          1ST CHARACTER OF 2ND WORD
;                          2ND CHARACTER OF 2ND WORD
;                          .
;                          .
;                          .
;                          LAST CHARACTER OF 2ND WORD
;                          TEXT ATOM OF 2ND WORD
;
;                          .
;                          .
;                          .
;
;          NOTE, ASSUMES ATOM TABLE ORIGIN IS: 0100
;                & ADDRESSES OF LISTS ARE AT: 0000
;

CCJ6:     MOV       TEXTPTR,EDX
          DEC       TEXTPTR

CCJ:      MOV       EDX,TEXTPTR        ;PC'S POINT TO NEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]  ;READ CHARACTER AND INC TEXTPTR
          INC       TEXTPTR
          TEST      CH,80H
          JZ        CCJ1               ;BRANCH IF NOT ATOM
          MOV       EAX,0
          MOV       AL,CH
          SUB       EAX,00000080H
          SHL       EAX,3              ;ATOM ENTRY ADDRESS OF ATOM TABLE
          MOV       EDX,OFFSET ORG0100
          ADD       EDX,EAX
          MOV       ECX,DWORD PTR [EDX];ECX = ATOM TEXT ADDRESS
          MOV       AL,R2
          SHR       ECX,24
          XOR       AL,CL
          MOV       R0,AL
          TEST      AL,0F0H            ;CHECK FUNCTION TYPE
          JNZ       CCJ7
          ADD       EDX,4
          MOV       ECX,DWORD PTR [EDX];ECX = ATOM ACTION ROUTINE ADDRESS
          MOV       EDX,ECX
          RET

CCJ1:     TEST      SL,3               ;BRANCH IF ENTRY PHASE
          JZ        CCJ2
CCJ7:     MOV       EDX,TEXTPTR
          DEC       TEXTPTR            ;DECREMENT TEXTPTR
CCJ4:     MOV       R0,0FFH            ;FLAG = NOT FOUND
CCJ3:     RET

CCJ2:     CALL      CCJE               ;LOOK FOR UNATOMIZED TEXT WORD IN LIST
          TEST      R0,0FH             ;F, BRANCH
          JZ        CCJ6
          MOV       R0,0FFH            ;NF, EXIT
          RET


;     CCJE: SCAN SPECIFIED LIST FOR MATCH WITH UNATOMIZED
;          TEXT WORD. THE WORD IS REPLACED BY ITS TEXT
;          ATOM. IF THE WORD INCLUDES A TRAILING SPACE
;          AND THERE IS A SPACE FOLLOWING THE WORD IN
;          TEXT, THAT SPACE WILL BE DELETED; SUCCESIVE
;          SPACES WILL NOT BE DELETED.
;          ENTRY: PHASE = ENTRY
;                 PC'S POINT TO NEXT TEXT CHARACTER
;                 F2(HIGH 4-BITS) = LIST TO CHECK
;                                   (SEE CCJ ENTRY)
;
;          RETURN: F0 = X0 IF FOUND. PC'S, TEXTPTR POINT
;                          AFTER WORD IN TEXT.
;                  F0 <>X0 IF NOT FOUND.  TEXTPTR POINTS
;                          TO NEXT NONBLANK TEXT CHARACTR
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,3,AUX0,1
;

CCJE:     MOV       TEXTPTR,EDX        ;DECREMENT TEXTPTR
          MOV       EAX,0
          MOV       AL,R2
          SHR       EAX,4
          SHL       EAX,1
          MOV       EDX,OFFSET ORG0000
          ADD       EDX,EAX            ;PC'S = ADDRESS OF TABLE POINTER
          ADD       EDX,4
          MOV       ECX,DWORD PTR [EDX]
          MOV       EDX,ECX            ;PC'S = TABLE POINTER
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX
          INC       AUX00              ;CH = NO. OF ENTRIES IN TABLE
          MOV       R3,CH              ;F3 = NO. OF ENTRIES IN TABLE
          MOV       EDX,AUX00
CCJ5:     CALL      CCNL               ;COMPARE NEXT WORD IN TABLE WITH TEXT
          TEST      R0,0FH
          JZ        CCJ3               ;MATCH, BRANCH
          DEC       R3                 ;DECREMENT COUNT
          CMP       R3,0
          JE        CCJ4               ;BRANCH IF COUNT = 0
          MOV       EDX,AUX01
          MOV       EAX,0
          MOV       AL,R1
          ADD       EDX,EAX            ;PC'S = ADDRESS OF NEXT WORD IN TABLE
          JMP       CCJ5



;     LINE#REF: GET LINE NUMBER REFERENCE FROM TEXT. IN
;               RESOLUTION OR EXECUTION PHASE, LINE NO.
;               MUST BE IN
;               PACKED FORM (FFDDDD). IN ENTRY PHASE,
;               NO. CAN BE EITHER PACKED OR UNPACKED
;            (ASCII). IF UNPACKED, NO. WILL BE REPLACED
;            BY PACKED FORM. NOTE, THIS INVOLVES TEXT
;            MOVEMENT (LINE MAY EXPAND UP TO 2 BYTES OR
;            SHRINK BY 1 BYTE); TEXT LINE MUST BE LAST
;            LINE IN TEXT AREA SINCE SQZTEXT KEYS ON 'CR'
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 TEXTEND POINT TO LAST CHAR. IN LINE
;
;          RETURN: F0 = 0 IF FOUND, F3-2 = LINE NO.,
;                         TEXTPTR POINTS TO CHARACTR
;                         AFTER THE LINE NO.
;                  F0 (LOW 4 BITS) NOT = 0 IF NOT FOUND,
;                         TEXTPTR POINTS TO NEXT NONBLANK
;                         CHARACTER.
;
;          MODIFIED REGISTERS: PH,PL,CH,CL,F0,F2,F3
;                         F1,F4,AUX0,1 (ENTRY PHASE ONLY)
;
;     LINE#: GET AN UNPACKED (ASCII) LINE NO. FROM TEXT.
;            LINE MUST BE LAST LINE IN TEXT AREA AND
;            PHASE MUST BE ENTRY.  UNPACKED NO. WILL BE
;            REPLACED BY PACKED DECIMAL FORM (2 BYTES:
;            DDDD).  NOTE, PACKED NO. WILL ALWAYS BE ON
;            EVEN BOUNDARY, IMMEDIATELY FOLLOWING THREAD.
;
;          NOTE, LINE NUMBERS ARE 1 - 4 DIGITS (LEADING
;                ZEROES ARE IGNORED).
;
;          MODIFIED REG'S: PC'S,CH,CL,F0-4,AUX0,1
;

LINE_REF: MOV       EDX,TEXTPTR
          MOV       R0,1
          MOV       CH,BYTE PTR [EDX]
          CMP       CH,@LINE_
          JNE       LINE_1

LINE_REF1:MOV       AX,WORD PTR [EDX+1]
          XCHG      AH,AL
          MOV       WORD PTR [R2],AX
          ADD       TEXTPTR,7
          MOV       R0,0
          RET

LINE_4:   RET
LINE_:    MOV       R4,0               ;FLAG = LINE NO. RATHER THAN REFERENCE
          MOV       EDX,TEXTPTR        ;PC'S = TEXTPTR   (POINT TO LINE NO.)
          JMP       LINE_6
LINE_1:   TEST      SL,03H
          JZ        LINE_10            ;BRANCH IF ENTRY PHASE
          RET
LINE_10:  MOV       R4,0FFH            ;FLAG = LINE NO. REFERENCE
LINE_6:   MOV       AUX00,EDX          ;SAVE TEXTPTR
          MOV       AX,0
          MOV       WORD PTR [R2],0    ;F3-2 = 0 (RESULT)

;;;;;
          TEST      MODE,08000H
          JZ        LINE_P
          MOV       AH,BYTE PTR [TEXTPTR]
          cmp       ah,0dh
          je        line_q
;         cmp       ah,00h
;         jb        line_q
          cmp       ah,0fh
          ja        line_q
          SHL       AH,4
          MOV       CH,BYTE PTR [TEXTPTR+1]
          AND       CH,0FH
          OR        AH,CH
          MOV       AL,BYTE PTR [TEXTPTR+2]
          SHL       AL,4
          MOV       CH,BYTE PTR [TEXTPTR+3]
          AND       CH,0FH
          OR        AL,CH
          MOV       WORD PTR [R2],AX
          ADD       TEXTPTR,4
          MOV       AUX01,TEXTPTR
          JMP       LINE_3
;;;;;

LINE_P:   CALL      DIGIT              ;LOOK FOR A 'DIGIT'
          TEST      R0,0FH
          JZ        LINE_5             ;BRANCH IF FOUND
          RET

line_q:   mov       r0,1
          ret

LINE_2:   CALL      DIGIT              ;LOOK FOR 'DIGIT'
          TEST      R0,0FH
          JNZ       LINE_3             ;NF, BRANCH
LINE_5:   MOV       AUX01,EDX          ;SAVE PTR TO CHAR. AFTER DIGIT
          INC       AUX01
          SHL       AX,4               ;shift result left 1 digit and
          AND       CH,0FH
          OR        AL,CH              ;insert low digit
          MOV       R3,AH
          MOV       R2,AL
          TEST      AH,0F0H
          JZ        LINE_2             ;BRANCH IF < 4 DIGITS FOUND
;
;     SQUEEZE UNPACKED LINE NO. OUT OF TEXT LINE
;

LINE_3:   MOV       EDX,AUX01
          MOV       CH,BYTE PTR [EDX]
          MOV       TEXTPTR,EDX        ;GET CHARACTER AFTER LAST DIGIT
          TEST      R4,0FH
          JNZ       LINE_7             ;BRANCH IF LINE NO. REFERENCE
          CMP       CH,20H
          JNE       LINE_7
          MOV       TEXTPTR,EDX
          INC       TEXTPTR            ;BYPASS SPACE (SQUEEZE OUT OF TEXT)
LINE_7:   CALL      SQZTEXT            ;SQUEEZE UNPACKED LINE NO. OUT OF TEXT LINE
          MOV       TEXTEND,EDX
          ADD       TEXTEND,6          ;SET TEXTEND TO NEW END OF TEXT
          TEST      R4,0FH
          JNZ       LINE_8             ;BRANCH IF LINE NO. REFERENCE
          MOV       TEXTEND,EDX
          INC       TEXTEND            ;ONE LESS IF LINE NO. RATHER THAN REFERENCE

;
;     MAKE SURE AT LEAST 10 BYTES BETWEEN TEXTEND & VS
;

LINE_8:   MOV       EBX,VSPTR
          SUB       EBX,10
          MOV       EAX,TEXTEND
          MOV       EDX,TEXTEND
          CMP       EBX,EAX
          JB        LINE_9             ;ERROR IF NOT AT LEAST 10 BYTES
;
;     IF LINE NO. REFERENCE (F1=FF), EXPAND LINE BY 5
;          BYTES AND INSERT ATOM AND PACKED NO. (FFDDDD).
;     IF LINE NO. (F1=00), EXPAND LINE BY 2 BYTES AND
;          INSERT PACKED NO. (DDDD)
;
          MOV       TEXTPTR,EDX        ;SAVE 'FROM' ADDRESS
          SUB       TEXTPTR,2
          MOV       EDX,AUX00
          MOV       DWORD PTR [A0],EDX ;F1-0 = PTR TO WHERE LINE NO. WAS
          MOV       EDX,TEXTPTR
                                       ;PC'S = 'FROM' ADDRESS
          ADD       TEXTPTR,7          ;TEXTPTR = 'TO' ADDRESS ('FROM' + 7 IF REF.)
          TEST      R4,0FH
          JNZ       LINE_11
          MOV       TEXTPTR,EDX
          ADD       TEXTPTR,2          ;= 'TO' ADDRESS ('FROM' + 2 IF LINE NO)
LINE_11:  MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,TEXTPTR
          DEC       TEXTPTR            ;MOVE NEXT BYTE OF TEXT LINE 3 BYTES
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,TEXTPTR
          DEC       TEXTPTR            ;TO THE RIGHT
          CMP       DWORD PTR [A0],EDX
          JBE       LINE_11            ;BRANCH IF MORE TO MOVE
          MOV       EDX,AUX00
          TEST      R4,0FH
          JZ        LINE_12               ;BRANCH IF LINE NO. RATHER THAN REFERENCE
          MOV       BYTE PTR [EDX],@LINE_ ;INSERT LINE NO REF. 0FFH
          INC       EDX                   ;INCREMENT PC'S BY 1
LINE_12:  MOV       AL,R3
          MOV       BYTE PTR [EDX],AL     ;INSERT PACKED LINE NO. TO TEXT LINE
          INC       EDX
          MOV       AL,R2
          MOV       BYTE PTR [EDX],AL     ;INSERT PACKED LINE NO. TO TEXT LINE
          TEST      R4,0FH
          JZ        LINE_99
          INC       EDX
          MOV       DWORD PTR [EDX],0     ;INSERT LINE NO ADDRESS
          ADD       EDX,3
LINE_99:  MOV       TEXTPTR,EDX
          INC       TEXTPTR               ;TEXTPTR POINT TO CHAR. AFTER LINE NO.
CHARFA:   MOV       R0,0
          RET
LINE_9:   JMP       ERR_02                ;NOT ENOUGH MEMORY


ERROR_11: MOV       R0,11H                ;EXPECTED ')'
          JMP       ERROR

ERROR_10: MOV       R0,10H                ;EXPECTED '('
          JMP       ERROR

ERROR_12: MOV       R0,12H                ;EXPECTED '='
          JMP       ERROR

ERROR_13: MOV       R0,13H                ;MISSING COMMA
          JMP       ERROR

ERRC_20:  MOV       R0,20H                ;EXPECTED END OF STATEMENT
          JMP       ERRORC


;     NXTCHEOS: LOOK FOR END-OF-STATEMENT (EOS) CHARACTER
;               CR OR :  OR STATEMENT-SEPARATOR
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 IF EOS FOUND. TEXTPTR & PC'S
;                         POINTS TO EOS CHARACTER.
;                  F0 = 1 IF NOT FOUND. TEXTPTR & PC'S
;                         POINT TO NEXT NONBLANK TEXT
;                         CHARACTER. CH = NEXT NONBLANK
;                         TEXT CHARACTER
;
;          MODIFIED REGISTERS: CH,CL,PC'S,F0

NXTCHEOS: MOV       EDX,TEXTPTR           ;PC'S POINT TO NEXT CHARACTER
          MOV       CH,BYTE PTR [EDX]     ;READ NEXT CHARACTER
          CMP       CH,0FDH
          JE        NXTCHEOS1             ;BRANCH IF STATEMENT SEPARATOR
          CMP       CH,0DH
          JE        NXTCHEOS1             ;BRANCH IF CR
          CMP       CH,':'
          JE        NXTCHEOS1             ;BRANCH IF COLON
          MOV       R0,1                  ;FLAG = NF
          RET

NXTCHEOS1:MOV       R0,0                  ;FLAG = F
          RET


;     CCLTO: LOOK FOR 'TO' IN TEXT.  ERROR IF NOT FOUND.
;     CCLFROM: LOOK FOR 'FROM' IN TEXT. ERROR IF NF.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER.
;
;          MODIFIED REGISTERS: CL,CL,PC'S,F0
;                    F1,AUX0,1 (ENTRY PHASE ONLY)
;
;
;CCLCOPYTO:
;CCLMOVETO:
;          MOV       R0,@TO
;          CALL      CCL                   ;LOOK FOR 'TO'
;          TEST      R0,0FH
;          JNZ       ERROR_19              ;BRANCH IF NOT FOUND
;          TEST      SL,02H
;          JZ        SR@MD02               ;BR, IF NOT RESLOUTION PHASE
;CK2:
;          MOV       EDX,DWORD PTR [CPBASE]
;          MOV       [EDX].@TOPTR,TEXTPTR
;          JMP       SR@MD02

CCLTO:    MOV       R0,@TO
          CALL      CCL                   ;LOOK FOR 'TO'
          TEST      R0,0FH
          JZ        SR@MD02               ;BRANCH IF FOUND

ERROR_19: MOV       R0,19H                ;MISSING REQUIRED STATEMENT TEXT
          JMP       ERROR

CCLFROM:  MOV       EDX,OFFSET _FROM
          CALL      CCNL                  ;LOOK FOR 'FROM'
          TEST      R0,0FH
          JNZ       ERROR_19              ;ERROR IF NOT FOUND
SR@MD02:  RET

TOPTR     DD        ?


;     INTEGER: GET INTEGER (ASCII DIGITS, 0 TO 65535)
;              FROM TEXT AND CONVERT INTEGER TO BINARY.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 IF INTEGER FOUND.
;                         TEXTPTR POINTS AFTER INTEGER
;                         F2,1 = BINARY VALUE OF INTEGER
;                         CH = LAST DIGIT (ASCII) OF
;                              INTEGER
;                  F0 = 1 IF INTEGER NOT FOUND (IE, NO
;                              DIGITS FOUND)
;                         PC'S & TEXTPTR POINTS TO NEXT
;                              NONBLANK TEXT CHARACTER
;
;             ERROR#34 (ILLEGAL VALUE) IF INTEGER > 65535
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;
;          NOTE: THIS CODE IS NOT OPTIMIZED FOR SPEED,
;                BUT RATHER FOR MINIMUM AMOUNT OF CODE.
;

INTEGER:  MOV       EDX,TEXTPTR           ;PC'S POINT TO NEXT CHARACTER
          CMP       BYTE PTR [EDX],30H
          JB        INT_NF
          CMP       BYTE PTR [EDX],39H
          JA        INT_NF
          XOR       AX,AX
          MOV       AL,BYTE PTR [EDX]
          AND       AL,0FH                ;AX = FIRST DIGIT
          INC       TEXTPTR
          MOV       BX,0

INTEGER2: MOV       EDX,TEXTPTR
          CMP       BYTE PTR [EDX],30H
          JB        INTEGER1
          CMP       BYTE PTR [EDX],39H
          JA        INTEGER1
          MOV       CX,AX
          SHL       AX,1
          JC        ERROR_34
          SHL       AX,1
          JC        ERROR_34
          SHL       AX,1
          JC        ERROR_34
          SHL       CX,1
          JC        ERROR_34
          ADD       AX,CX                 ;AX = DIGIT * 10
          JC        ERROR_34
          MOV       BL,BYTE PTR [EDX]
          AND       BL,0FH
          MOV       BH,0
          ADD       AX,BX                 ;AX = AX + DIGIT
          JC        ERROR_34
          INC       TEXTPTR
          JMP       INTEGER2

INTEGER1: MOV       WORD PTR [R1],AX      ;SET RESULT TO R1 R2
          MOV       R0,0
          RET

INT_NF:   MOV       R0,1
          RET

ERROR_34: MOV       R0,34H                ;ILLEGAL VALUE
          JMP       ERROR


;     SWITCH: EXCHANGE TEXTPTR AND TEXTLPTR WITH
;             AUXA AND AUXB.
;
;          MODIFIED REGISTERS: NONE
;
;SWITCHA: save/restore textptrs
;
;     STMTCNTS <--> AUX9
;     TEXTPTR  <--> AUXA
;     TEXTLPTR <--> AUXB
;

SWITCHA: MOV       EDX,STMTCNT
         XCHG      EDX,AUX09
         MOV       STMTCNT,EDX

SWITCH:  XCHG      TEXTPTR,AUX0A          ;EXCHANGE TEXTPTR AND AUXA
         MOV       EDX,TEXTLPTR
         XCHG      EDX,AUX0B              ;EXCHANGE TEXTLPTR AND AUXB
         MOV       TEXTLPTR,EDX
         RET


;     DEVADDRS: LOOK FOR DEVICE ADDRESS SPECIFICATION
;               (/taa) IN TEXT.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F1,HIGH 4-BITS = 0 IF FOUND
;                     F1,0 = 0taa
;                     TEXTPTR POINTS AFTER /taa
;
;                 F1,HIGH 4-BTS <>0 IF NF
;                     TEXTPTR POINTS TO NEXT NONBLANK
;                         TEXT CHARACTER
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;
;     DEVADDR: GET DEVICE TYPE AND ADDRESS (3 HEX DIGITS)
;              FROM TEXT. ERROR IF NOT FOUND.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F1,0 = 0taa WHERE t = DEVICE TYPE
;                                   aa = DEVICE ADDRESS
;                  TEXTPTR POINTS AFTER DEVICE ADDRESS
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;
;     HEXPAIR: GET A PAIR OF HEX DIGITS FROM TEXT. ERROR
;              IF NOT FOUND.
;
;          RETURN: F0 = XY WHERE X = 1ST HEX DIGIT,
;                                Y = 2ND HEX DIGIT
;                  TEXTPTR POINTS AFTER 2ND HEX DIGIT
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,F2
;

DEVADDRS: MOV       AL,'/'              ;LOOK FOR '/'
          CALL      NXTCH
          MOV       R1,0FFH
          TEST      R0,0FH
          JNZ       DEVADDR1            ;BRANCH IF NF
DEVADDR:  CALL      HEXDIGIT            ;LOOK FOR DEVICE TYPE
          TEST      R0,0F0H
          JNZ       ERROR_17            ;NF, ERROR
          MOV       AL,R0               ;SAVE TYPE
          MOV       R1,AL
HEXPAIR:  CALL      HEXDIGIT            ;LOOK FOR 1ST DIGIT OF DEVICE ADDRESS
          TEST      R0,0F0H
          JNZ       ERROR_17            ;NF, ERROR
          MOV       AL,R0
          SHL       AL,4
          MOV       R2,AL               ;SAVE ADDRESS DIGIT
          CALL      HEXDIGIT            ;LOOK FOR 2ND DIGIT OF DEVICE ADDRESS
          TEST      R0,0F0H
          JNZ       ERROR_17            ;NF, ERROR
          MOV       AL,R2               ;F0 = DEVICE ADDRESS
          OR        R0,AL
DEVADDR1: RET
ERROR_17: MOV       R0,17H              ;EXPECTED HEX DIGIT
          JMP       ERROR

;     LN#RANGE: SCAN TEXT FOR START AND END LINE NUMBERS.
;               IF NO STARTING NO., START = 0000.
;               IF NO ENDING NO., END = 9999.
;
;          FORMAT:  [ start-line-number][,[end-line-no.]]
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F7,6 = START #  (DEFAULT=0000)
;                  F5,4 & F3,2 = END# (DEFAULT=9999)
;                  F0,BITS 0F <>0 IFF A SINGLE LINE NUMBR
;                         WITH NO COMMA WAS FOUND
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,F2-7
;                              F1,AUX0,1 (ENTRY PHASE)
;
;     LN#RANGA: SAME AS 'LNRANGE' EXECPT F3,2 = 1ST LINE
;               NUMBER AT TIME OF ENTRY.
;

LN_RANGE: CALL      LINE_REF                     ;LOOK FOR START LINE NUMBER
          TEST      R0,0FH
          JZ        LN_RANGA                     ;BRANCH IF FOUND
          MOV       WORD PTR [R6],0              ;DEFAULT START = 0
          CALL      NXTCHCOM                     ;LOOK FOR COMMA
          TEST      R0,0FH
          JNZ       LN_RANG2                     ;BRANCH IF NOT FOUND (NO PARAMETERS)
          JMP       LN_RANG1

LN_RANGA: MOV       AX,WORD PTR [R2]             ;F7,6 = START LINE NUMBER
          MOV       WORD PTR [R6],AX
          CALL      NXTCHCOM                     ;LOOK FOR COMMA
          TEST      R0,0FH
          JNZ       LN_RANG3                     ;BRANCH IF NF
LN_RANG1: CALL      LINE_REF                     ;LOOK FOR END NUMBER
          TEST      R0,0FH
          JZ        LN_RANG4                     ;BRANCH IF FOUND
LN_RANG2: MOV       R0,0                         ;FLAG = COMMA FOUND
LN_RANG3: MOV       WORD PTR [R2],9999H          ;DEFAULT END = 9999
          MOV       AX,WORD PTR [R2]             ;F5,4 = END NUMBER
          MOV       WORD PTR [R4],AX
          RET

LN_RANG4:
          MOV       AX,WORD PTR [R2]             ;F5,4 = END NUMBER
          MOV       WORD PTR [R4],AX
          RET

;  CCJB:  IDENTIFY A TEXT WORD FROM A LIST OF POSSIBLE
;     TEXT WORDS, POSSIBLY INCLUDING WORDS WHICH WON'T
;     ATOMIZE.
;
;  ENTRY:  PC'S POINT AT A 2 BYTE ADDRESS IN 8 BIT, WHICH
;     POINTS AT THE FIRST ELEMENT IN A LIST OF ADDRESSES.
;     THESE ADDRESSES POINT AT TEXT WORD ENTRIES OF THE
;     FOLLOWING FORMAT:
;         1 BYTE COUNT, TEXT WORD, ATOM
;     IF THE ATOM ENTRY IS 00, THEN THE TEXT WORD IS NOT
;     TO BE ATOMIZED.  TEXTPTR POINTS AT THE FIRST
;     CHARACTER  OF THE TEXT WORD TO BE MATCHED.
;
;  RETURN:  THE RETURN POINT IS DETERMINED BY WHICH WORD
;     WAS RECOGNIZED.  IF THE FIRST WORD IN THE LIST IS
;     FOUND, A NORMAL RETURN IS PERFORMED.  THE SECOND
;     WILL CAUSE ONE INSTRUCTION TO BE SKIPPED UPON
;     RETURNING, ETC.  A NOT FOUND RETURN WILL RETURN TO
;     ONE MORE THAN THE LAST ENTRY OF THE LIST.  F0 WILL
;     CONTAIN THE BINARY VALUE OF WHICH ENTRY (0 - N) OF
;     THE LIST WAS FOUND.
;
;  MODIFIED REGISTERS:  F2F1F0, PC'S, CHCL, AUX 0,1,2
;
;  REGISTER USAGE:  F2 IS A COUNT OF TABLE ENTRIES.  F1F0
;     ARE USED BY CCNL, AND F0(=F2) IS PASSED TO ONBRANCH
;

CCJB:    MOV       R2,0FFH           ;COUNT = -1
         MOV       ECX,DWORD PTR [EDX]
         MOV       EDX,ECX
         MOV       AUX02,EDX         ;AUX 2 POINTS AT NEXT TABLE ENTRY
         MOV       EDX,TEXTPTR
         MOV       CH,BYTE PTR [EDX]
         INC       TEXTPTR
         MOV       TEXTPTR,EDX        ;SPACE PAST ALL LEADING BLANKS
CCJB1:   INC       R2
         MOV       EDX,TEXTPTR
         MOV       CH,BYTE PTR [EDX]
         MOV       EDX,AUX02
         MOV       R0,CH             ;F0 = FIRST CHARACTER FROM TEXT
         MOV       ECX,DWORD PTR [EDX]
         ADD       AUX02,4           ;READ NEXT TABLE ADDRESS ENTRY
         CMP       ECX,0
         JE        CCJB7             ;EXIT IF END OF LIST (0000 ADDRESS)
         MOV       EDX,ECX
         TEST      R0,80H
         JNZ       CCJB5             ;SKIP IF ALREADY TEXT ATOM
         CALL      CCNL              ;TRY TO MATCH IT AGAINST TEXT WORD
         TEST      R0,0FH
         JNE       CCJB1             ;NF, LOOP BACK
         JMP       CCJB7             ;FOUND, BRANCH
CCJB5:   MOV       CH,BYTE PTR [EDX]
         INC       EDX
         MOV       EAX,0
         MOV       AL,CH
         ADD       EDX,EAX           ;SKIP PAST TEXT WORD SPELLED OUT
         MOV       CH,BYTE PTR [EDX] ;
         CMP       CH,R0
         JNE       CCJB1
         MOV       EDX,TEXTPTR
         MOV       CH,BYTE PTR [EDX]
         INC       TEXTPTR
CCJB7:   MOV       AL,R2
         MOV       R0,AL
         JMP       ONBRANCH          ;SKIP F0 INSTRUCTIONS UPON RETURNING

;     VARNAME: SCAN VARIABLE NAME IN TEXT
;
;          VARIABLE NAME = LETTER [DIGIT] [$] [(]
;
;          ENTRY: TEXTPTR POINTS TO NEXT NONBLANK TEXT
;                 CHARACTER
;
;          RETURN: F0 = 0 IF NAME FOUND
;                         TEXTPTR POINTS AFTER NAME
;                         F3 = NAME LETTER
;                         F2,HIGH 4-BITS = NAME DIGIT OR
;                                          X'F' IF NONE
;                           ,BIT0 = 1 IFF '$' FOUND
;                           ,BIT1 = 1 IFF '(' FOUND
;                           ,BIT2 = 0
;                           ,BIT3 = 1 IFF '@' FOUND
;                         AUX0 = ADDRESS OF NAME LETTER
;
;                  F0 = 1 IF NAME NOT FOUND (NO LETTER)
;                         TEXTPTR POINTS TO NEXT NONBLANK
;                         TEXT CHARACTER
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,F2,F3,AUX0
;
;  ALTERNATE ENTRY, VARNAMEA -
;      F2 MUST CONTAIN 'F1' TO INDICATE THAT ONLY ALPHA
;      VARIABLES ARE CONSIDERED ACCEPTABLE.


VARNAME:  MOV       R2,0F0H                  ;FLAG THAT NUMERIC IS ACCEPTABLE
          CMP       BYTE PTR [TEXTPTR],7FH
          JE        VARNAMEOK1
          CMP       BYTE PTR [TEXTPTR],7DH
          JE        VARNAMEOK1
          JMP       VARNAMET

VARNAMEA: CMP       BYTE PTR [TEXTPTR],7FH
          JE        VARNAMEOK2
          CMP       BYTE PTR [TEXTPTR],7DH
          JE        VARNAMEOK2

VARNAMET: CALL      @LETTER                  ;LOOK FOR [@] NAME-LETTER
          TEST      R0,0FH
          JNZ       VARNR                    ;NF EXIT
          MOV       R3,CH                    ;F3 = NAME LETTER
VARN08:   MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR

;      CHECK DIGIT

          CMP       CH,30H
          JB        VARN51
          CMP       CH,3FH
          JA        VARN51
          CMP       CH,39H
          JA        VARN75
VARN10:   MOV       AL,CH                    ;HIGH PART OF F2 = DIGIT
          SHL       AL,4
          AND       R2,0FH
          OR        R2,AL
VARN15:   MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR
;      CHECK FOR A $ (ALPHA VARIABLE)
          CMP       CH,20H
          JB        VARN75                   ;B, NOT 2X
          CMP       CH,2FH
          JA        VARN75
VARN20:   CMP       CH,24H                   ;B, NOT 24
          JNE       VARN61
          OR        R2,1                     ;FLAG ALPHA VARIABLE
VARN25:   MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       TEXTPTR
;     CHECK FOR A LEFT PAREN (ARRAY)
          CMP       CH,20H                   ;B, NOT 2X
          JB        VARN40
          CMP       CH,2FH
          JA        VARN40
VARN30:   CMP       CH,28H
          JNE       VARN71
          OR        R2,2                     ;FLAG ARRAY VARIABLE
          INC       EDX
VARN40:   mov       eax,dword ptr [cpbase]
          TEST      BYTE PTR [EAX].@ARRAYFLAG,1
          JZ        VARNXXX
          MOV       BYTE PTR [EAX].@ARRAYFLAG,0
          TEST      R2,2
          JZ        VARN80
VARNXXX:  MOV       TEXTPTR,EDX
          TEST      SL,3                     ;SKIP IF ENTRY PHASE (POSSIBLE LIST V)
          JZ        VARNAMEB
VARN42:
          CALL      SQZTEXT            ;SQUEEZE UNPACKED LINE NO. OUT OF TEXT LINE
          MOV       TEXTEND,EDX
          ADD       TEXTEND,6          ;SET TEXTEND TO NEW END OF TEXT

;
;     MAKE SURE AT LEAST 10 BYTES BETWEEN TEXTEND & SYMBOL TABLE
;

          mov       eax,textend
          MOV       EBX,VSPTR
          SUB       EBX,10
          MOV       EDX,TEXTEND
          CMP       EBX,EAX
          JB        ERR_02             ;ERROR IF NOT AT LEAST 10 BYTES
;
;     EXPAND LINE BY 7 BYTES AND INSET VAR ATOM, NAME, TYPE AND ADDRESS DWORD
;
          MOV       TEXTPTR,EDX        ;SAVE 'FROM' ADDRESS
          MOV       EDX,AUX00
          MOV       DWORD PTR [A0],EDX ;F1-0 = PTR TO WHERE LINE NO. WAS
          MOV       EDX,TEXTPTR
                                       ;PC'S = 'FROM' ADDRESS
          ADD       TEXTPTR,7          ;TEXTPTR = 'TO' ADDRESS ('FROM' + 7 IF REF.)
VARN99:   MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,TEXTPTR
          DEC       TEXTPTR            ;MOVE NEXT BYTE OF TEXT LINE 3 BYTES
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,TEXTPTR
          DEC       TEXTPTR            ;TO THE RIGHT
          CMP       DWORD PTR [A0],EDX
          JBE       VARN99             ;BRANCH IF MORE TO MOVE
          MOV       EDX,AUX00
          MOV       BYTE PTR [EDX],7FH ;INSERT VAR ATOM 7FH
          INC       EDX                ;INCREMENT PC'S BY 1
          MOV       AL,R2
          MOV       BYTE PTR [EDX],AL  ;INSERT TYPE AND DIGIT
          INC       EDX
          MOV       AL,R3
          MOV       BYTE PTR [EDX],AL  ;INSERT LETTER
          INC       EDX
          MOV       DWORD PTR [EDX],0
          ADD       EDX,4
          MOV       AUX00,EDX
          MOV       TEXTPTR,EDX
          MOV       R0,0
          RET

;  NOT A DIGIT

VARN51:   CMP       CH,20H             ;IF NOT 2X, END OF VARIABLE
          JB        VARN75
          CMP       CH,2FH
          JA        VARN75
          JMP       VARN20             ;CHECK $
;  NOT  $  24
VARN61:
;  MUST BE NUMERIC
          TEST      R2,1               ;BRANCH IF NUMERIC IS OKAY (VARNAME ENTRY)
          JZ        VARN30
          JMP       VARN80             ;NOT FOUND EXIT (AVAR ENTRY)
;  NOT   (  28
VARN71:   JMP       VARN40             ;SKIP FORWARD
;   NOT  2X
VARN75:   TEST      R2,1               ;BRANCH IF NUMERIC IS OKAY
          JZ        VARN40
;   NUMERIC VARIABLE FOUND, WHEN ALPHA WAS SPECIFIED
VARN80:   MOV       R0,1
          MOV       EDX,AUX00
          MOV       TEXTPTR,EDX        ;RESTORE TEXTPOINTER TO THE NAME LETTER

VARNR:    RET                          ;EXIT
VARNAMEB: TEST      MODE,0800H         ;CHECK IF THIS IS REALLY WITHIN A LIST V
          JZ        VARN42             ;IF NOT, F0=0 AND RETURN
          JMP       LISTVAR            ;GO TO LISTVAR TO PRINT OUT THE VARIABLE

VARNAMEOK1:
          MOV       AX,WORD PTR [TEXTPTR+1]
          MOV       WORD PTR [R2],AX
;         TEST      AL,1
;         JNZ       VARNAMEERR
          MOV       EDX,TEXTPTR
          ADD       TEXTPTR,7
          TEST      SL,3
          JZ        VARNAMEXXX
          MOV       R0,0
          RET

VARNAMEOK2:
          MOV       AX,WORD PTR [TEXTPTR+1]
          MOV       WORD PTR [R2],AX
          TEST      AL,1
          JZ        VARNAMEERR
          MOV       EDX,TEXTPTR
          ADD       TEXTPTR,7
          TEST      SL,3
          JZ        VARNAMEXXX
          MOV       R0,0
          RET

VARNAMEERR:
          MOV       R0,1
          RET

VARNAMEXXX:
          TEST      MODE,0800H         ;CHECK IF THIS IS REALLY WITHIN A LIST V
          JNZ       LISTVAR            ;GO TO LISTVAR TO PRINT OUT THE VARIABLE
          MOV       R0,0
          RET


;     VERBCHK: ERROR IF STATMENT VERB IS 'DATA', '%', OR
;              'DEFFN'.  CALLED BY IF, ELSE, ERROR.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          MODIFIED REG: PC'S,CH,CL,F0,AUX0,1,2
;

VERBCHK:
          MOV       AUX02,TEXTPTR      ;SAVE TEXTPTR
          MOV       R0,@DATA
          CALL      CCL                ;LOOK FOR 'DATA'
          TEST      R0,0FH
          JNZ       VERBCHK1           ;NF, BRANCH
          MOV       R0,@LOAD
          CALL      CCL                ;LOOK FOR 'LOAD' (DATALOAD)
          TEST      R0,0FH
          JZ        VERBCHK2           ;BRANCH IF 'DATALOAD'
          MOV       R0,@SAVE
          CALL      CCL                ;LOOK FOR 'SAVE'
          TEST      R0,0FH
          JNZ       ERROR_08           ;BRANCH IF NOT 'DATASAVE'
VERBCHK2:
          MOV       TEXTPTR,AUX02      ;RESTORE TEXTPTR
VERBCHK3: RET
VERBCHK1: MOV       R0,@?PE
          CALL      CCL                ;LOOK FOR '%'
          TEST      R0,0FH
          JZ        ERROR_08           ;ERROR IF FOUND
          MOV       R0,@DEFFN
          CALL      CCL                ;LOOK FOR 'DEFFN'
          TEST      R0,0FH
          JNZ       VERBCHK3           ;NF, BRANCH
ERROR_08: MOV       R0,08H             ;STMT NOT LEGAL HERE
          JMP       ERROR


;     RELOP: GET A RELATION OPERATOR FROM TEXT
;            (<,<=,=,>=,>, OR <>)
;            ERROR IF NOT FOUND.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER.
;                 TEXLPTR POINTS TO CURRENT TEXT LINE.
;
;          RETURN: F1 = 1 IF <
;                       3 IF <=
;                       2 IF =
;                       6 IF >=
;                       4 IF >
;                       5 IF <>
;
;          MODIFIED REGISTERS: F0,F1,CH,CL,PC'S
;
;          Codes:  < -- 3C
;                  = -- 3D
;                  > -- 3E
;

RELOP1:   CMP       CH,20H              ;BRANCH IF NOT SPACE
          JNE       ERROR_18
          JMP       RELOP8
RELOP:    MOV       EDX,TEXTPTR
RELOP8:   MOV       CH,BYTE PTR [EDX]   ;CH = NEXT TEXT CHARACTER
          MOV       R1,0                ;F1 = 0
          INC       EDX
          CMP       CH,3CH              ;BRANCH IF NOT '<'
          JNE       RELOP4
          OR        R1,01H              ;SET '<' FOUND BIT
RELOP5:   MOV       CH,BYTE PTR [EDX]   ;GET NEXT TEXT CHARACTER
          INC       EDX
          CMP       CH,20H
          JE        RELOP5              ;BRANCH IF 'SPACE'
          JMP       RELOP4
RELOP3:   MOV       TEXTPTR,EDX
          DEC       TEXTPTR             ;POINT AFTER RELATION OPERATOR
          RET
RELOP4:   CMP       CH,3EH
          JNE       RELOP7              ;BRANCH IF NOT '>'
          OR        R1,04H              ;SET '>' FOUND BIT
RELOP2:   MOV       CH,BYTE PTR [EDX]
          INC       EDX
          CMP       CH,20H
          JE        RELOP2              ;BRANCH IF SPACE
RELOP7:   CMP       CH,3DH              ;BRANCH IF NOT '='
          JNE       RELOP6
          CMP       R1,5                ;IF <> RECEIVED?
          JE        ERROR_18            ;
          OR        R1,02H              ;SET '=' FOUND BIT
          MOV       TEXTPTR,EDX         ;POINT AFTER RELATION OPERATOR
          RET
RELOP6:   CMP       R1,0
          JNE       RELOP3              ;BRANCH IF RELATION OPERATOR FOUND
ERROR_18: MOV       R0,18H              ;MISSING RELATION OPERATOR
          JMP       ERROR

CODE      ENDS
          END
