;============================================================================          
;
;       A R R A Y   H A N D L I N G
;
;============================================================================
;       This modulule was originally M09
;============================================================================
	  .XLIST
	  INCLUDE PREAMBLE
	  .LIST

PUBLIC    ARAYEL
PUBLIC    ARAYELA
PUBLIC    ARAYELB
PUBLIC    ARAYELP
PUBLIC    ARRAY
PUBLIC    ARRAY2
PUBLIC    ARRAYA
PUBLIC    ERR_55A
PUBLIC    ERROR_56

EXTRN     ERROR   :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_04:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_55:NEAR
EXTRN     EXPR    :NEAR
EXTRN     FINDVAR :NEAR
EXTRN     FLTBIN :NEAR
EXTRN     VARNAME :NEAR

EXTRN     @@OSEND :DWORD
EXTRN     @@VSEND :DWORD
EXTRN     CPBASE  :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;      *****************************                                           ;
;      *                           *                                           ;
;      *    MODULE-09: ARRAYS      *                                           ;
;      *                           *                                           ;
;      *****************************                                           ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     ARAYEL: SCAN ARRAY ELEMENT SUBSCRIPTS, FIND ARRAY
;             IN SYMBOL TABLE IF RESOLUTION AND EXECTION
;             PHASES, AND CALCULATE ADDRESS OF THE ARRAY
;             ELEMENT IN EXECUTION PHASE.
;
;          ENTRY: F3 = NAME LETTER OF ARRAY
;                 F2,HIGH 4 BITS = NAME DIGIT OF ARRAY
;                                  X'F' IF NO DIGIT
;                   ,LOW 4 BITS = TYPE OF VARIABLE
;                                 2 IF NUMERIC ARRAY
;                                 3 IF ALPHA ARRAY
;                 TEXTPTR POINTS AFTER '(' FOLLOWING THE
;                    VARIABLE NAME.
;
;          RETURN: TEXTPTR POINTS AFTER ')' FOLLOWING
;                     THE SUBSCRIPTS
;
;               IN EXECUTION PHASE ONLY:
;                  PC'S = ADDRESS OF ARRAY ELEMENT
;                  CH = ELEMENT LENGTH (FOR ALPHA ONLY)
;                  F7,6 = DIMENSION(S)
;                  AUX0 POINTS AFTER DIM(S) IN SYMBOL TBL
;                  K,HIGH 4-BITS = ARRAY TYPE
;                                  2 IF NUMERIC VECTOR
;                                  3 IF ALPHA VECTOR
;                                  6 IF NUMERIC 2-DIM.
;                                  7 IF ALPHA 2-DIM.
;                  AUX2 = ELEMENT POSITION (EL. NO. -1)
;
;          MODIFIED REGISTERS: ALL, AUX0,1,2
;               K,LOW 4-BITS PRESERVED IN EXECUTION PHASE
;
;     ARAYELA: PC'S = PC'S + (F1,0) * CH
;
;              USUALLY, (F1,0) = NO. OF ELEMENTS, CH =
;              ELEMENT LENGTH, PC'S = 0 OR START ADDRESS
;              OF ARRAY. USED TO CALCULATE NO. OF BYTES
;              IN AN ARRAY (PC'S = 0) OR POSITION OF AN
;              ARRAY ELEMENT (PC'S = START ADDRESS OF
;              ARRAY).  ASSUMES RESULT < 65536.
;
;          ENTRY: PC'S = DESIRED VALUE
;                 F1,0 = NO. OF ELEMENTS
;                 CH = ELEMENT LENGTH
;
;          RETURN: PC'S = PC'S + (F1,0) * CH
;
;          MODIFIED REGISTERS: PC'S,F0-5
;
;     ARAYELB & ARAYELC ARE ENTRY POINTS FOR 'ARAYELP'.
;

ARAYEL:   TEST      SL,02H              ;BRANCH IF EXECUTION PHASE
	  JNZ       ARAYELX1
	  TEST      SL,03H              ;BRANCH IF ENTRY PHASE
	  JZ        ARAYEL0
	  TEST      R2,08H              ;BRANCH IF GLOBAL VARIABLE
	  JNZ       ARAYEL0
	  CALL      FINDVAR             ;SEARCH SYMBOL TABLE FOR SPECIFIED ARRAY
	  TEST      R0,0FH              ;NF, BRANCH
	  JNZ       ARAYEL14
	  JMP       ARAYEL2             ;BRANCH RESOLUTION PHASE

ARAYEL0:  CALL      EXPR                ;PROCESS 1ST SUBCRIPT
	  CMP       BYTE PTR [TEXTPTR],','   ;LOOK FOR COMMA
	  JNE       ARAYELX2
	  INC       TEXTPTR
	  CALL      EXPR                ;PROCESS 2ND SUBSCRIPT
ARAYELX2: CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')' AND EXIT
	  JNE       ERROR_11
	  INC       TEXTPTR
	  MOV       R0,0
	  RET

ARAYELX1:
	  CALL      FINDVAR             ;SEARCH SYMBOL TABLE FOR SPECIFIED ARRAY
	  TEST      R0,0FH              ;NF, BRANCH
	  JNZ       ARAYEL14
	  MOV       EAX,VSPTR
	  SUB       EAX,4
	  MOV       DWORD PTR [EAX],EDX
	  MOV       VSPTR,EAX
	  CMP       EAX,DWORD PTR [@@VSEND]
	  JB        ERROR_02
	  MOV       AH,CL
	  AND       AH,0FH
	  MOV       AL,K
	  SHL       AL,4
	  OR        AL,AH
	  MOV       EDX,OSPTR
	  INC       EDX
	  CMP       EDX,DWORD PTR [@@OSEND]
	  JE        ERROR_04
	  MOV       BYTE PTR [EDX],AL
	  MOV       OSPTR,EDX
ARAYEL2:  TEST      CL,04H              ;BRANCH IF ARRAY IS 1-DIMENSIONAL
	  JZ        ARAYEL4
ARAYEL1:  CALL      EXPR                ;SCAN & EVALUATE 1ST SUBSCRIPT
ARAYEL23: CMP       BYTE PTR [TEXTPTR],','
	  JNE       ARAYEL3
	  INC       TEXTPTR
ARAYEL4:  CALL      EXPR                ;SCAN & EVALUATE 2ND SUBSCRIPT
ARAYEL5:  CMP       BYTE PTR [TEXTPTR],')'   ;LOOK FOR ')'
	  JNE       ERROR_11
	  INC       TEXTPTR
	  MOV       R0,0
	  TEST      SL,02H              ;EXIT IF NOT EXECUTION PHASE
	  JZ        ARAYEL6
	  MOV       EDX,OSPTR
	  MOV       CH,BYTE PTR [EDX]   ;GET VARIABLE ATOM & LOW 4-BITS OF K
	  DEC       OSPTR
	  MOV       K,CH
	  SHL       K,4
	  MOV       AL,CH
	  SHR       AL,4
	  OR        K,AL                ;RESTORE K (MAY HAVE BEEN CLOBBERED BY 'EXPR')
	  TEST      K,40H
	  JNZ       ARAYEL9
;
;     VECTOR (1-DIMENSIONAL)
;
	  CALL      FLTBIN             ;CONVERT SUBSCRIPT TO BINARY (F1,0)
	  TEST      R2,2                ;BRANCH IF NOT 0 < SUBSCRIPT < 2^32
	  JZ        ERROR_56
	  MOV       EDX,VSPTR
	  MOV       ECX,DWORD PTR [EDX] ;GET ARRAY ADDRESS (POINTS TO DIMS) FROM VS
	  ADD       VSPTR,4
	  MOV       EDX,ECX             ;PC'S POINT TO DIMENSIONS
ARAYELB:  MOV       CX,WORD PTR [EDX]
	  SHL       ECX,16
	  MOV       CX,WORD PTR [EDX+2]
	  MOV       AUX00,EDX
	  ADD       AUX00,4
	  MOV       DWORD PTR [A6],ECX  ;F7,6 = DIMENSIONS OF ARRAY
ARAYEL12: MOV       EAX,DWORD PTR [A6]
	  CMP       EAX,DWORD PTR [A0]  ;ERROR IF DIMENSION < SUBSCRPT
	  JB        ERROR_56
	  DEC       DWORD PTR [A0]      ;F1,0 = SUBSCRIPT - 1
ARAYEL10: MOV       EDX,DWORD PTR [A0]
	  MOV       AUX02,EDX           ;SAVE ELEMENT POSITION (ELEMENT NO. -1)
	  MOV       EDX,AUX00
	  TEST      K,10H               ;BRANCH IF ALPHA VARIABLE
	  JNZ       ARAYEL8
	  mov       eax,dword ptr [a0]
	  shl       eax,3               ;F1,0 = 8 (SUBSCRIPT - 1)
	  ADD       EDX,EAX             ;PH,PL = ADDRESS OF SPECIFIED ARRAY ELEMENT
ARAYEL6:  RET

;     MATRIX (2-DIMENSIONAL)
;

ARAYEL9:  CALL      FLTBIN             ;CONVERT 2ND SUBSCRIPT TO BINARY (F1,0)
	  TEST      R2,2                ;ERROR IF SUBSCRIPT < 0
	  JZ        ERROR_56
	  CMP       A1,0                ;                   > 65535
	  JNE       ERROR_56
	  MOV       AX,A0               ;F5 = SUBSCRIPT2
	  MOV       A5,AX
	  CALL      FLTBIN             ;CONVERT 1ST SUBSCRIPT TO BINARY (F1,0)
	  TEST      R2,2                ;ERROR IF SUBSCRIPT < 0
	  JZ        ERROR_56
	  CMP       A1,0                ;                   > 65535
	  JNE       ERROR_56
	  MOV       EDX,VSPTR
	  MOV       ECX,DWORD PTR [EDX] ;GET ARRAY ADDRESS (POINTS TO DIMS) FROM VS
	  ADD       VSPTR,4
	  MOV       EDX,ECX             ;PC'S POINT TO DIMENSIONS
ARAYELC:  MOV       CX,WORD PTR [EDX]
	  SHL       ECX,16
	  MOV       CX,WORD PTR [EDX+2]
	  MOV       AUX00,EDX
	  ADD       AUX00,4
	  MOV       DWORD PTR [A6],ECX  ;F7,6 = DIMENSIONS OF ARRAY
ARAYEL13: MOV       AX,A7
	  CMP       AX,A0               ;ERROR IF DIM1 < SUBSCRIPT1
	  JB        ERROR_56
	  MOV       AX,A6
	  CMP       AX,A5               ;ERROR IF DIM2 < SUSCRIPT2
	  JB        ERROR_56
	  DEC       A0                  ;F0 = SUBSCRIPT1 - 1
	  DEC       A5                  ;F5 = SUBSCRIPT2 - 1
	  MOVZX     EAX,A6
	  MOVZX     EBX,A0
	  PUSH      EDX
	  MUL       EBX
	  POP       EDX
	  MOV       DWORD PTR [A0],EAX
	  MOVZX     EAX,A5
	  ADD       DWORD PTR [A0],EAX  ;F1,0 = (F1,0) + (SUBSCRIPT2-1)
	  JMP       ARAYEL10

;     ALPHA
;

ARAYEL8:  MOV       CH,BYTE PTR [EDX]   ;CH = DEFINED LENGTH OF VARIABLE; PC'S POINT T
	  INC       EDX

;      START OF ARRAY VALUE

ARAYELA:  MOVZX     EAX,CH              ;BRANCH IF ELEMENT POSITION < 256
	  MOV       EBX,DWORD PTR [A0]
	  PUSH      EDX
	  MUL       EBX
	  POP       EDX
	  ADD       EDX,EAX             ;PC'S = ADDRESS OF SPECIFIED ARRAY ELEM.
	  RET

ARAYEL3:  TEST      SL,3                ;BRANCH IF ENTRY PHASE
	  JZ        ARAYEL5

ERROR_56: MOV       R0,56H              ;ILLEGAL SUBSCRIPT
	  JMP       ERROR

ARAYEL14: TEST      SL,2                ;BRANCH IF EXECTION PHASE
	  JNZ       ERR_55A
	  MOV       EDX,DWORD PTR [CPBASE]
	  LEA       EDX,[EDX].@RESFLG
	  MOV       CH,BYTE PTR [EDX]
	  TEST      CH,1                ;IGNORE NONGLOBAL VARIABLES IF DEFFN@ FOUND
	  JNZ       ARAYEL0
ERR_55A:  JMP       ERROR_55            ;UNDEFINED ARRAY VARIABLE


;     ARAYELP: DETERMINE THE ADDRESS OF A SPECIFIED ARRAY
;              ELEMENT.  ERROR IF SUBSCRIPT(S) > DIM(S).
;
;          ENTRY: PC'S POINT TO DIMENSION(S) OF ARRAY IN
;                    SYMBOL TABLE
;                 F1,0 = SUBSCRIPT(S) OF ELEMENT
;                 K,BIT4 = 0 IF NUMERIC
;                          1 IF ALPHA
;                   BIT6 = 0 IF VECTOR (1-DIMENSIONAL)
;                          1 IF MATRIX (2-DIMENSIONAL)
;
;          RETURN: PC'S = ADDRESS OF SPEC. ARRAY ELEMENT
;                  F7,6 = DIMENSION(S)
;                  CH = ELEMENT LENGTH (ALPHA ONLY)
;                  AUX0 POINTS AFTER DIM(S) IN SYMBOL TBL
;                  AUX2 = ELEMENT POSITION (EL. NO. -1)
;
;          MODIFIED REGISTERS: PC'S,F0-7,CH,CL,AUX0,2
;
;          NOTE: THIS ROUTINE MUST BE LOCAL TO 'ARAYEL'
;

ARAYELP:  TEST      K,40H               ;BRANCH IF 1-DIMENSIONAL (VECTOR)
	  JZ        ARAYELB
	  CMP       DWORD PTR [A0],0    ;ERR 56 (ILLEGAL SUBSCRIPTS) IF =0
	  JE        ERROR_56
	  MOV       AX,A0               ;F5 = SUBSCRIPT2
	  MOV       A5,AX
	  MOV       AX,A1               ;F0 = SUBSCRIPT1
	  MOV       A0,AX
	  JMP       ARAYELC


;     ARRAY: SCAN & PROCESS AN ARRAY SPECIFICATION
;
;          ARRAY SPECIFICATION FORMAT:
;               letter [digit] [$] ()
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN (FOUND): F0 = 0
;                  AUX0 = ADDRESS OF NAME LETTER OF ARRAY
;                         IN TEXT
;                  TEXTPTR POINTS AFTER ')'
;                  F5, LOW BIT = 0 IF NUMERIC
;                                1 IF ALPHA
;
;               IN EXECUTION PHASE ONLY:
;                  F7,6 = DIMENSION(S)
;                  F3,2 = NO. OF ELEMENTS
;                  CH = ELEMENT LENGTH (ALPHA ONLY)
;                  F5,LOW 4-BITS = ARRAY TYPE
;                                  2 IF NUMERIC VECTOR
;                                  3 IF ALPHA VECTOR
;                                  6 IF NUMERIC 2-DIM.
;                                  7 IF ALPHA 2-DIM.
;                  PC'S = START ADDRESS OF ARRAY
;
;          RETURN (NOT FOUND): F0 = 1
;                  TEXTPTR POINTS TO NEXT NONBLANK TEXT
;                      CHARACTER
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-7,AUX0
;
;     ARRAYA: PROCESS AN ARRAY SPECIFICATION.
;             ARRAY SPECIFICATION ALREADY SCANNED.
;
;          ENTRY: F3 = NAME LETTER OF ARRAY
;                 F2,HIGH 4-BITS = NAME DIGIT OF ARRAY
;                                  OR X'F' IF NONE
;                    LOW 4-BITS = ARRAY TYPE
;                                 2 IF NUMERIC ARRAY
;                                 3 IF ALPHA ARRAY
;
;          RETURN: SEE 'FOUND RETURN' ABOVE.
;
;     ARRAY2: RESTORE TEXTPTR, FLAG = NF
;
;          ENTRY: AUX0 = SAVED TEXTPTR
;
;          RETURN: TEXTPTR = AUX0
;                  F0 = 1
;
;          MODIFIED REGISTERS: PC'S,F0
;

ARRAY:    MOV       EAX,DWORD PTR [CPBASE]
	  MOV       BYTE PTR [EAX].@ARRAYFLAG,1        ;FLAG FOR ARRAY NAME ONLY
	  CALL      VARNAME             ;SCAN ARRAY NAME IN TEXT
	  MOV       EAX,DWORD PTR [CPBASE]
	  MOV       BYTE PTR [EAX].@ARRAYFLAG,0
	  TEST      R0,0FH              ;NF, BRANCH
	  JNZ       ARRAY3
	  TEST      R2,02H              ;BRANCH IF NOT AN ARRAY NAME
	  JZ        ARRAY2
	  CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
	  JNE       ARRAY2
	  INC       TEXTPTR
ARRAYA:   TEST      SL,3                ;BRANCH IF ENTRY PHASE
	  JZ        ARRAY1
	  DEC       TEXTPTR
	  CALL      FINDVAR             ;SEARCH SYMBOL TABLE FOR SPECIFIED ARRAY
	  INC       TEXTPTR
	  TEST      R0,0FH              ;BRANCH IF NOT FOUND
	  JNZ       ARRAY5
	  TEST      SL,02H              ;BRANCH IF NOT EXECUTION PHASE
	  JZ        ARRAY1
	  MOV       R5,CL               ;F5 = VARIABLE TYPE; CH,CL = DIMENSION(S)
	  MOV       CX,WORD PTR [EDX]
	  SHL       ECX,16
	  MOV       CX,WORD PTR [EDX+2]
	  ADD       EDX,2
	  MOV       DWORD PTR [A6],ECX  ;F7,6 = DIM(S)
	  MOV       DWORD PTR [A2],ECX  ;F3,2 = DIM(S)
	  TEST      R5,04H              ;BRANCH IF VECTOR
	  JZ        ARRAY4
	  MOV       DWORD PTR [A0],ECX  ;F1,0 = DIMENSIONS

	  MOVZX     EAX,A1
	  MOVZX     EBX,A0

	  PUSH      EDX
	  MUL       EBX
	  POP       EDX

	  MOV       DWORD PTR [A2],EAX  ;F3,2 = NUMBER OF ELEMENT
ARRAY4:   MOV       R0,0                ;F0 = 0; INCREMENT PC'S
	  ADD       EDX,2
	  TEST      R5,01H              ;BRANCH IF NUMERIC
	  JZ        ARRAY6
	  MOV       CH,BYTE PTR [EDX]   ;CH = ELEMENT LENGTH (ALPHA)
	  INC       EDX
ARRAY6:   RET

ARRAY2:   MOV       R0,1                ;FLAG = NOT FOUND
	  SUB       TEXTPTR,7
	  RET

ARRAY5:   TEST      SL,2                ;ERROR IF X-PHASE
	  JNZ       ERR_55A
	  MOV       EDX,DWORD PTR [CPBASE]
	  LEA       EDX,[EDX].@RESFLG
	  MOV       CH,BYTE PTR [EDX]
	  TEST      CH,01H              ;ERROR IF DEFFN@ NOT ENCOUNTERED
	  JZ        ERR_55A
	  MOV       R0,0                ;FLAG = FOUND

ARRAY1:   MOV       AL,R2
	  MOV       R5,AL
ARRAY3:   RET

CODE      ENDS
	  END
