;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M08
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    COM
PUBLIC    DIM
PUBLIC    ERR_17C
PUBLIC    ERROR_48
PUBLIC    SELECT
PUBLIC    SELECTA
PUBLIC    SELECTB
PUBLIC    SLCTCI
PUBLIC    SLCTCO
PUBLIC    SLCTD
PUBLIC    SLCTDISK
PUBLIC    SLCTG
PUBLIC    SLCTP
PUBLIC    SLCTPLOT
PUBLIC    SLCTR
PUBLIC    SLCTTAPE
PUBLIC    SLCTLEN
PUBLIC    SLCTADRA
PUBLIC    SLCTADRO
PUBLIC    SLCTADR1
PUBLIC    SLCTADR5
PUBLIC    SLCTADDR
PUBLIC    SLCTDRVR
PUBLIC    SLCTMORE
PUBLIC    STOP
PUBLIC    STOP_

EXTRN     AVARB     :NEAR
EXTRN     BADDRESS  :NEAR
EXTRN     CCJB      :NEAR
EXTRN     CCL       :NEAR
EXTRN     CNSLMSG   :NEAR
EXTRN     DEVADDR   :NEAR
EXTRN     DEV?AMTERM:NEAR
EXTRN     DIGIT     :NEAR
EXTRN     DVAR      :NEAR
EXTRN     ENBLCO    :NEAR
EXTRN     ENDSTHLT  :NEAR
EXTRN     ENDSTMT   :NEAR
EXTRN     ERROR     :NEAR
EXTRN     ERROR_11  :NEAR
EXTRN     ERROR_16  :NEAR
EXTRN     ERROR_17  :NEAR
EXTRN     ERROR_19  :NEAR
EXTRN     ERROR_34  :NEAR
EXTRN     ERROR_51  :NEAR
EXTRN     ERROR_55  :NEAR
EXTRN     EXPR      :NEAR
EXTRN     FILE_B    :NEAR
EXTRN     FILE_PTR  :NEAR
EXTRN     FINDVARL  :NEAR
EXTRN     FLTBINA   :NEAR
EXTRN     GETDRDEV  :NEAR
EXTRN     HEXDIGIT  :NEAR
EXTRN     HEXDIGTA  :NEAR
EXTRN     HEXPAIR   :NEAR
EXTRN     LINE_REF  :NEAR
EXTRN     NEXTVAR   :NEAR
EXTRN     NEXTVARL  :NEAR
EXTRN     PRNTCR    :NEAR
EXTRN     REM       :NEAR
EXTRN     RSTOP_    :NEAR
EXTRN     SLCT@     :NEAR
EXTRN     SLCTERM   :NEAR
EXTRN     SLCTOFF   :NEAR
EXTRN     SLCTON    :NEAR
EXTRN     SLCTTC    :NEAR
EXTRN     SLTADRT   :NEAR
EXTRN     VARNAME   :NEAR
EXTRN     WRTLINE_  :NEAR
EXTRN     WRTWORD   :NEAR
EXTRN     _SLCTLST  :NEAR
EXTRN     _STOP     :NEAR

EXTRN     CPBASE    :DWORD
EXTRN     PART_     :BYTE

EXTRN     CMDBUADR  :DWORD
EXTRN     WAITCMD   :NEAR

;------------------------------------------------------------------------------;
;                                                                              ;
;     ***********************************                                      ;
;     *                                 *                                      ;
;     *  MODULE#08: GENERAL STATEMENTS  *                                      ;
;     *                                 *                                      ;
;     ***********************************                                      ;
;                                                                              ;
;                                                                              ;
;     DESCRIPTION: GENERAL BASIC STATEMENTS                                    ;
;                                                                              ;
;                    COM      DIM      SELECT     LIST                         ;
;                    STOP                                                      ;
;                                                                              ;
;     ENTRY: BRANCH TO APPROPRIATE STATEMENT ROUTINE.                          ;
;            TEXTPTR POINTS AFTER VERB.                                        ;
;            TEXTLPTR POINTS TO CURRENT LINE.                                  ;
;                                                                              ;
;     EXIT: BRANCH TO 'ENDSTMT','ENDSTIO',OR 'ERROR'                           ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     STOP: PROCESS A 'STOP' STATEMENT
;
;          STMT FORMAT:  STOP [literal] [#]       (Program mode)
;                        STOP [line#]             (Immediate mode)
;
;          ENTRY: TEXTPTR POINTS AFTER 'STOP'
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          DESCRIPTION: For program mode, stops program execution and sets
;               CONTLN# & CONTINUE STMTCNT to the next statement.  Note, if
;               there is no next statement, CONTLN# = FFFF which forces an
;               error if CONTINUE or HALT/STEP is performed.
;
;               For Immediate mode, the specified line# is saved in RSTOP#.
;               ENDSTMT checks this number when transfer is made to the next
;               line.  If next line matches, then the logic described above is
;               performed (by STOP# routine).
;

STOP:
STOPSTMT: TEST      MODE,0002H
          JNZ       STOPI                   ;branch if Immediate mode

; ----------------- Program mode -----------------------------------------------

          TEST      SL,2                    ;BRANCH IF NOT EXECUTION PHASE
          JZ        STOP1
          CALL      PRNTSTOP                ;print CR 'STOP '
STOP1:    CALL      CNSLMSG                 ;PROCESS STOP MESSAGE
          MOV       R0,1
          CMP       BYTE PTR [TEXTPTR],'#'  ;LOOK FOR '#'
          JNE       STOPAA
          INC       TEXTPTR
          MOV       R0,0
STOPAA:   TEST      SL,2                    ;BRANCH IF NOT EXECUTION PHASE
          JZ        STOPE
          TEST      R0,0FH                  ;BRANCH IF # NOT FOUND
          JNZ       STOP3
          MOV       EDX,TEXTLPTR
          ADD       EDX,4
          MOV       CX,WORD PTR [EDX]       ;GET LINE NUMBER
          XCHG      CH,CL
          MOV       WORD PTR [R2],CX        ;F3,2 = LINE #
          CALL      WRTLINE_                ;DISPLAY LINE #
STOP3:    OR        SH,HALT                 ;SET HALT/STEP STATUS BIT
STOPE:    JMP       ENDSTMT                 ;EXIT

; ----------------- Immediate mode----------------------------------------------

STOPI:    CALL      LINE_REF                ;look for line#
          TEST      R0,0FH
          JZ        STOP4
          MOV       WORD PTR [R2],0FFFFH    ;if not found, FFFF

STOP4:
          TEST      SL,XPHASE               ;branch if not execution phase
          JZ        STOPI1
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       AX,WORD PTR [R2]
          MOV       WORD PTR [EDX].@STOP_,AX      ;save stop#
STOPI1:   JMP       ENDSTMT

; ================= output CR 'STOP ' ==========================================

PRNTSTOP: CALL      ENBLCO                  ;ENABLE CONSOLE OUTPUT
          CALL      PRNTCR                  ;PRINT CR
          MOV       EDX,OFFSET _STOP+6
          MOV       CH,BYTE PTR [EDX]
          CALL      WRTWORD                 ;PRINT 'STOP '
          RET

; ==============================================================================
;  STOP#:  check if next line to be executed matches the stop#.  If so, force a prgram
;          halt.  This routine is called from ENDSTMT.
;
;        Entry:    TEXTLPTR points to thread of current line
;

STOP_:     MOV      EDX,DWORD PTR [CPBASE]  ;get stop#
           MOV      CX,WORD PTR [EDX].@STOP_
           MOV      EDX,TEXTLPTR
           ADD      EDX,4
           MOV      WORD PTR [R2],CX        ;F3F2 = stop#; CLCH = line#
           MOV      CX,WORD PTR [EDX]
           XCHG     CH,CL
           CMP      CX,WORD PTR [R2]        ;check if line# = stop#
           JE       STOP_1
STOP_9:    RET                               ;not equal

; ----------------- stop -------------------------------------------------------

STOP_1:    CALL     PRNTSTOP                ;output CR 'STOP '
           CALL     WRTLINE_                ;output line#
           OR       SH,HALT                 ;set HALT/STEP status bit
           JMP      ENDSTHLT


;     DIM: PROCESS A DIM STATEMENT.  ALLOCATE SPACE FOR
;          THE SPECIFIED VARIABLES IN THE SYMBOL TABLE.
;
;          STMT FORMAT:  DIM variable [,variable ...]
;
;               where: variable =
;                    letter [digit] [(dim [,dim] )]
;
;          ENTRY: TEXTPTR POINTS AFTER 'DIM'
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;     COM: PROCESS A COM STATEMENT.  ALLOCATE SPACE FOR
;          THE SPECIFIED VARIABLES IN THE SYMBOL TABLE
;          AND SET COMPTR; OR IF 'COM CLEAR', CHANGE COM-
;          MON VARIABLE POINTER (COMPTR).
;
;       MODIFIED REGS:   ALL, AUX 0-2
;
;          STMT FORMAT:  COM variable [,variable...]
;                        COM CLEAR [variable name]
;
;               where: variable =
;                    letter [digit]$[(dim[,dim])][length]
;
;

COM:      MOV       K,1                            ;FLAG = COMMON
          MOV       R0,@CLEAR
          CALL      CCL                            ;LOOK FOR 'CLEAR'
          TEST      R0,0FH                         ;NF, BRANCH
          JNZ       DIM1

COMCLEAR: CALL      VARNAME                        ;LOOK FOR VARIABLE NAME
          MOV       AUX21,TEXTPTR
          TEST      R0,0FH                         ;NF, SKIP
          JNZ       COMCLR2
          TEST      R2,2                           ;SKIP IF NOT ARRAY
          JZ        COMCLR5
          CMP       BYTE PTR [TEXTPTR],')'         ;GET RIGHT PAREN
          JNE       ERROR_11
          INC       TEXTPTR
COMCLR5:  TEST      SL,3                           ;DONE IF NOT X PHASE
          JZ        COMCLR1
          XCHG      TEXTPTR,AUX21
          CALL      FINDVARL
          XCHG      TEXTPTR,AUX21
          TEST      SL,1
          JNZ       COMCLR1
          SUB       EDX,4
          CMP       R0,0
          JE        COMCLR3
          JMP       ERROR_55
COMCLR2:  TEST      SL,2                           ;DONE IF NOT X PHASE
          JZ        COMCLR1
          MOV       EDX,DWORD PTR [CPBASE]         ;POINT AT END OF SYMBOL TABLE
          MOV       ECX,DWORD PTR [EDX].@VAREND
          MOV       DWORD PTR [A2],ECX             ;(MAKE ALL SYMBOLS NON-COMMON)
COMCLR4:  MOV       EDX,DWORD PTR [CPBASE]         ;MOVE COMMON POINTER
          MOV       EAX,DWORD PTR [A2]
          MOV       DWORD PTR [EDX].@COMPTR,EAX
COMCLR1:  JMP       ENDSTMT                        ;EXIT
COMCLR3:  CALL      NEXTVARL                       ;FIND THE NEXT VARIABLE IN THE SYMBOL TABLE
          JMP       COMCLR4

DIM:      MOV       K,0                            ;FLAG = NONCOMMON
DIM1:     TEST      SL,2
          JZ        DIM2
          JMP       REM                            ;IF EXECUTION PHASE, SKIP OVER STATEMENT
DIM2:     CALL      DVAR                           ;PROCESS NEXT VARIABLE
          CMP       BYTE PTR [TEXTPTR],','         ;LOOK FOR COMMA
          JNE       ENDSTMT                        ;NF, BRANCH
          INC       TEXTPTR
          JMP       DIM2


;     SELECT: PROCESS A 'SELECT' STATEMENT
;
;          ENTRY: TEXTPTR POINTS AFTER 'SELECT'
;
;          AUX0-4 MODIFIED IN ENTRY PHASE
;

SLCTPRNT: TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTPRT2
          MOV       EDX,DWORD PTR [CPBASE] ;PRINT CHARCNT = 0
          MOV       BYTE PTR [EDX].@PRNTCNT,0

SLCTPRT2: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO 'PRINT' DEVICE TABLE ENTRY
          LEA       EDX,[EDX].@DEVPRNT

SLCTPRT1: CALL      SLCTADRO               ;GET & STORE DEVICE TYPE AND ADDRESS
          CALL      SLCTLEN                ;GET & STORE LINE WIDTH

SLCTMORE: CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       SELECTXX               ;SKIP IF NOT FOUND
          INC       TEXTPTR
          JMP       SELECTB
SELECTXX: MOV       EDX,AUX03
          TEST      DH,0F0H                ;REGULAR SELECT STATEMENT
          JZ        SELECTE
          TEST      SL,2                   ;SKIP IF NOT X PHASE
          JZ        SELECT30
          JMP       REM                    ;X PHASE EXIT
SELECT30: CMP       BYTE PTR [TEXTPTR],';' ;CHECK FOR ;
          JNE       SELECTE                ;BRANCH IF NOT FOUND
          INC       TEXTPTR
SELECTA:  CMP       BYTE PTR [TEXTPTR],';' ;LOOK FOR ';'
          JNE       SELECTB                ;BRANCH IF NOT FOUND
          INC       TEXTPTR
          JMP       SELECTA

SELECTE:  JMP       ENDSTMT

SELECT:   MOV       AUX03,0                ;FLAG NO 'ON' & SAVE 'ON' FLAG
SELECTB:  MOV       EDX,OFFSET _SLCTLST
          CALL      CCJB                   ;LOOK FOR SELECT KEYWORD & RETURN TO PROPER BRANCH
          JMP       SLCTPRNT               ;SELECT PRINT
          JMP       SLCTCO                 ;SELECT CO
          JMP       SLCTTAPE               ;SELECT TAPE
          JMP       SLCTCI                 ;SELECT CI
          JMP       SLCTDISK               ;SELECT DISK
          JMP       SLCTDRVR               ;SELECT DRIVER
          JMP       SLCTD                  ;SELECT D
          JMP       SLCTRND                ;SELECT ROUND
          JMP       SLCTNO                 ;SELECT NO
          JMP       SLCTERR                ;SELECT ERROR
          JMP       SLCTLIST               ;SELECT LIST
          JMP       SLCTR                  ;SELECT R
          JMP       SLCT_                  ;SELECT #
          JMP       SLCTG                  ;SELECT G
          JMP       SLCTPLOT               ;SELECT PLOT
          JMP       SLCTP                  ;SELECT P
          JMP       SLCTLIN                ;SELECT LINES
          JMP       SLCTINPT               ;SELECT INPUT
          JMP       SLCTON                 ;SELECT ON
          JMP       SLCTOFF                ;SELECT OFF
          JMP       SLCT@                  ;SELECT @
          JMP       SLCTTC                 ;SELECT TC
          JMP       SLCTERM                ;SELECT TERMINAL
          JMP       SLCTNEW                ;SELECT NEW
          JMP       SLCTOLD                ;SELECT OLD
          JMP       SLCTTIME               ;SELECT TON
          JMP       SLCTNOTIME             ;SELECT TOFF
          JMP       SLCTHOG                ;SELECT HON
          JMP       SLCTNOHOG              ;SELECT HOFF
          JMP       SLCT3ON                ;SELECT 3ON
          JMP       SLCT3OFF               ;SELECT 3OFF
          JMP       SLCTWIDTH              ;SELECT WIDTH

SELECT5:  JMP       ERROR_19               ;ILLEGAL KEYWORD

SLCTNO:   MOV       R7,8                   ;FLAG = 'NO' FOUND
          MOV       R0,@ROUND
          CALL      CCL                    ;LOOK FOR 'ROUND'
          TEST      R0,0FH                 ;NF, ERROR
          JNZ       SELECT5
          JMP       SELECT31

SLCTRND:  MOV       R7,0                   ;FLAG = 'NO' NOT FOUND
SELECT31: TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          AND       MATHMODE,0FF3FH
          TEST      R7,8
          JZ        SELECT6
          OR        MATHMODE,00C0H         ;SET ROUND MODE BIT (0 = ROUND, 1 = NO ROUND)
          JMP       SELECT6

SLCTLIN:  CALL      EXPR
          TEST      SL,2                   ;SKIP IF NOT X PHASE
          JZ        SLCTMORE
          CALL      FLTBINA                ;CONVERT TO BINARY
          CMP       DWORD PTR [A0],0       ;ERROR IF ZERO
          JE        SLCT_2
          MOV       EAX,DWORD PTR [A0]     ;WRITE LINES COUNT INTO 8 BIT
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EDX].@LINES,AL
          JMP       SLCTMORE

SLCTERR:  CMP       BYTE PTR [TEXTPTR],'>' ;LOOK FOR '>'
          JE        SELECT32               ;BRANCH IF FOUND
          MOV       R0,0
          JMP       SELECT33

SELECT32: INC       TEXTPTR
          CALL      HEXPAIR                ;GET PAIR OF HEX DIGITS

SELECT33: TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          MOV       EDX,MATHMODE
          MOV       DH,R0                  ;SET MATH MODE TO SPECIFIED ERROR CODE (OR 00)
          MOV       MATHMODE,EDX
          JMP       SELECT6

SLCTCO:   MOV       EDX,DWORD PTR [CPBASE] ;PC'S POINT TO CONSOLE OUTPUT IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVCO

          CALL      SLCTADRO               ;GET & STORE DEVICE TYPE AND ADDRESS
          CALL      SLCTLEN                ;GET & STORE LINE WIDTH
          JMP       SLCTMORE

SLCTLIST: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO LIST ENTRY IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVLIST
          JMP       SLCTPRT1

SLCTCI:   MOV       EDX,DWORD PTR [CPBASE] ;POINT TO CONSOLE INPUT IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVCI

          CALL      SLCTADDR               ;GET DEVICE TYPE & ADDRESSS & PUT INTO DEVICE TBL
          TEST      SL,2                   ;BRANCH IF NOT X-PHASE
          JZ        SLCTMORE
          CMP       R0,01H                 ;ONLY ADDRESS 01 LEGAL
          JE        SLCTMORE

JUMPERRA: JMP       SLCTERRA

SLCTINPT: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO INPUT IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVINPT
          JMP       SELECT2

SLCTPLOT: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO PLOT IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVPLOT
          CALL      SLCTADRO               ;GET & STORE DEVICE TYPE & ADDRESS
          JMP       SLCTMORE

SLCTTAPE: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO TAPE IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVTAPE
          JMP       SELECT2

SLCTDISK: MOV       EDX,DWORD PTR [CPBASE] ;POINT TO DISK IN DEVICE TABLE
          LEA       EDX,[EDX].@DEVDISK

SELECT2:  CALL      SLCTADDR               ;GET & STORE DEVICE ADDRESS
          JMP       SLCTMORE

SLCTD:    MOV       R0,10H                 ;FLAG = DEGREES
          JMP       SELECT3

SLCTG:    MOV       R0,20H                 ;FLAG = GRADS
          JMP       SELECT3

SLCTR:    MOV       R0,0                   ;FLAG = RADIANS

SELECT3:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          MOV       EDX,MATHMODE
          AND       DL,0CFH
          OR        DL,R0
          MOV       MATHMODE,EDX           ;SET TRIG MODE FLAG

SELECT6:  JMP       SLCTMORE

SLCTP:    CALL      DIGIT                  ;LOOK FOR DIGIT
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          MOV       EDX,COUNTS
          AND       DH,0F0H                ;PAUSE = 0
          TEST      R0,0FH                 ;BRANCH IF DIGIT NOT FOUND
          JNZ       SELECTYY
          AND       DH,0F0H
          MOV       AL,CH
          AND       AL,0FH
          OR        DH,AL                  ;PAUSE = DIGIT

SELECTYY: MOV       COUNTS,EDX
          JMP       SLCTMORE

SLCTNEW:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          MOV       EDX,COUNTS
          AND       DH,0FH
          OR        DH,10H                 ;SAVE PROGRAM USE NEW FORMAT
          MOV       COUNTS,EDX
          JMP       SLCTMORE

SLCTOLD:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          MOV       EDX,COUNTS
          AND       DH,0FH                 ;SAVE PROGRAM USE OLD FORMAT
          MOV       COUNTS,EDX
          JMP       SLCTMORE

SLCTTIME: TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg6,1  ;SELECT TIME/RECORD ON
          pop       eax
          JMP       SLCTMORE

SLCTNOTIME:
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg6,0  ;SELECT TIME/RECORD OFF
          pop       eax
          JMP       SLCTMORE

SLCTHOG:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg5,1  ;SELECT TIME/RECORD ON
          pop       eax
          JMP       SLCTMORE

SLCTNOHOG:
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg5,0  ;SELECT TIME/RECORD OFF
          pop       eax
          JMP       SLCTMORE

SLCT3ON:  TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg9,1  ;SELECT TIME/RECORD ON
          pop       eax
          JMP       SLCTMORE

SLCT3OFF:
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          push      eax
          mov       eax,dword ptr [cpbase]
          MOV       byte ptr [eax].@spreg9,0  ;SELECT TIME/RECORD OFF
          pop       eax
          JMP       SLCTMORE

SLCTWIDTH:
          call      expr
          TEST      SL,2                   ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORE
          CALL      FLTBINA                ;CONVERT TO BINARY
          CMP       DWORD PTR [A0],0       ;ERROR IF ZERO
          JE        SLCT_2
          CMP       DWORD PTR [A0],80      ;ERROR IF greater than 80
          JA        SLCT_2

          CMP       CMDBUADR,0
          JE        SLCTMORE

          MOV       EAX,DWORD PTR [A0]     ;WRITE LINES COUNT INTO 8 BIT
          mov       ebx,dword ptr [cpbase]
          mov       byte ptr [ebx].@width,al

          PUSH      EAX
          CALL      WAITCMD
          POP       EAX
          MOV       GS:[EBX].cmd_cbs,18H
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_parm,al
          MOV       GS:[EBX].cmd_sts,0FH

          JMP       SLCTMORE

SLCT_:    MOV       AUX00,TEXTPTR          ;SAVE TEXTPTR
          CALL      DIGIT                  ;LOOK FOR DIGIT
          TEST      R0,0FH                 ;BRANCH IF NOT FOUND; MUST BE 2600 FORMAT
          JNZ       SLCT_1
SELECT36: CALL      HEXDIGIT               ;SCAN UNTIL HEXDIGIT NOT FOUND
          TEST      R0,0F0H
          JZ        SELECT36
          MOV       TEXTPTR,AUX00          ;RESTORE TEXTPTR
          CMP       CH,'/'                 ;BRANCH IF '/' (BASIC-2 FORMAT)
          JE        SLCT_1
          CMP       CH,'<'                 ;BRANCH IF NOT '<' (BASIC FORMAT)
          JNE       SLCT_22

;     2600 FORMAT
;

SLCT_1:   CALL      FILE_B                  ;PROCESS FILE NUMBER
          TEST      SL,2                    ;BRANCH IF NOT EXECUTION PHASE
          JZ        SELECT2
          CALL      FILE_PTR
          MOV       AUX0D,EDX               ;SAVE PTR TO #n DEVICE TABLE SLOT
          SUB       AUX0D,2
          MOV       EDX,AUX0D               ;SAVE PTR TO #n SLOT OF DEVICE TABLE
          JMP       SELECT2


;     2200 FORMAT
;

SLCT_22:  CALL      DIGIT                   ;LOOK FOR DIGIT
          TEST      R0,0FH                  ;BRANCH IF FOUND
          JZ        SELECT35
SLCT_2:   JMP       ERROR_34                ;ERROR IF NOT FOUND
SELECT35: MOV       R0,CH
          AND       R0,0FH
          MOVZX     AX,R0
          MOV       BX,14
          PUSH      EDX
          MUL       BX
          POP       EDX
          AND       EAX,0FFFFH
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEVDISK
          ADD       EDX,EAX                 ;PC'S = ADDRESS OF #n DEVICE TABLE SLOT
          JMP       SELECT2

ERROR_48: MOV       R0,48H                  ;ILLEGAL DEVICE SPECIFICATION
          JMP       ERROR


;        SLCTDRVR: ENABLE/DISABLE PRINTER DRIVER FOR THE SPECIFIED ADDRESS
;
;           FORMAT:  SELECT DRIVER  /TAA  [OFF]
;                    SELECT DRIVER <ALPHA-VARIABLE> [OFF]
;
;           ENTRY: TEXTPTR POINTS AFTER 'DRIVER'
;
;           EXIT: DRIVER ENABLED IF IT EXISTS FOR THE SPECIFIED ADDRESS
;                 UNLESS THE 'OFF' PARAMETER IS SPECIFIED, THEN ITS TURNED OFF
;
;           MODIFIED REGISTERS: PHPL, CHCL, F0, F1, F2, AUX0
;  PROCESS ALPHA VARIABLE SPECIFICATION

SLCTDRVR: CMP       BYTE PTR [TEXTPTR],'<' ;LOOK FOR '<'
          JNE       SDRVRTAA               ;BRANCH IF NOT FOUND
          INC       TEXTPTR
          CALL      AVARB                  ;GET ALPHA VARIABLE
          TEST      SL,2                   ;BRANCH IF NOT X-PHASE
          JZ        SDAVAR1
          CMP       DWORD PTR [A0],3
          JAE       SDAVAR1
          JMP       ERROR_51               ;ERROR IF VARIABLE LENGTH < 3

SDAVAR1:  CMP       BYTE PTR [TEXTPTR],'>' ;LOOK FOR '>'
          JNE       ERROR_16               ;ERROR IF NOT FOUND
          INC       TEXTPTR

SDAVAR2:  TEST      SL,2                   ;BRANCH IF NOT X-PHASE
          JZ        SDRVOFF?
          MOV       EDX,AUX00
          XCHG      EDX,TEXTPTR            ;POINT TO VAULE OF VARIABLE
          MOV       AUX00,EDX              ;SAVE TEXTPTR
          CALL      HEXDIGTA               ;GET DEVICE TYPE
          TEST      R0,0F0H
          JNZ       SDERR_17
          CALL      HEXDIGTA               ;GET 1ST DIGIT OF ADDRESS
          TEST      R0,0F0H
          JNZ       SDERR_17
          MOV       AL,R0
          MOV       R1,AL                  ;SAVE 1ST DIGIT
          CALL      HEXDIGTA               ;GET 2ND DIGIT OF ADDRESS
          TEST      R0,0F0H
          JNZ       SDERR_17
          AND       R0,0FH
          MOV       AL,R1
          SHL       AL,4
          OR        R0,AL                  ;F0 = DEVICE ADDRESS
          MOV       TEXTPTR,AUX00          ;RESTORE TEXTPTR
          JMP       SDLOOKUP

;  PROCESS /TAA SPECIFICATION

SDRVRTAA: CMP       BYTE PTR [TEXTPTR],'/' ;LOOK FOR '/' (OPTIONAL)
          JNE       SELECTZZ
          INC       TEXTPTR
SELECTZZ: CALL      DEVADDR                ;PUT DEVICE ADDRESS IN F0
          TEST      SL,2                   ;BRANCH IF NOT X-PHASE
          JZ        SDRVOFF?

;  LOOK UP DEVICE ADDRESS IN DRIVER LIST AND GET BIT MAP

SDLOOKUP: CALL      GETDRDEV               ;LOOK UP DEVICE ADDRESS
          CMP       DWORD PTR [A1],0       ;F2F1 = POINTER TO BIT MAP
          JNE       SDLUKUP1
          JMP       ERROR_48               ;ERROR IF NOT FOUND

SDLUKUP1: MOV       EDX,DWORD PTR [A1]
          PUSH      EDX                    ;SAVE POINTER TO BIT MAP
;         CALL      RCM                    ;GET BIT MAP
;         MOV       AL,[EDX+2]             ;+- RCM
          MOV       AL,[EDX+8]             ;u64
          MOV       K,AL
;-------- u64 ---------
          MOV       EBX,0                   ;divide  PART# by
          MOV       BL,PART_               ;get the byte offset of bit map
          SHR       BX,4                   ;which set of 16 partition ?
          SHL       BX,1                   ;byte offset
;         MOV       AX,WORD PTR [EDX]
          MOV       AX,WORD PTR [EDX+EBX]  ;
;-------- u64e --------
          MOV       DX,AX                  ;+- RCM
          PUSH      EDX                    ;SAVE IT

;  CREATE A 2 BYTE MASK W/ BIT FOR CURRENT PARTITION TURNED ON

          MOV       DL,BYTE PTR [PART_]    ;PARTITION NUMBER USED FOR LOOP CONTROL
          AND       DL,0FH                 ;u64
          MOV       WORD PTR [R1],0        ;F2F1 = 0000, CARRY SET
          STC
SDRVMASK: RCL       WORD PTR [R1],1        ;MASK = MASK * 2
          MOV       AL,DL
          DEC       EDX
          CMP       AL,0
          JNE       SDRVMASK               ;BRANCH IF NOT DONE

;  IF ITS A TERMINAL PRINTER USE A SPECIAL MASK

          CMP       R0,03H                 ;TERMINAL PRINTERS ARE 'TIED'
                                           ;TO THE TERMINAL ADDRESS AND NOT
          JNE       SDRVOFF?

          MOV       WORD PTR [R1],0FFFFH   ;THE PARTITION #, SO THEY ARE
                                           ;PARTITION INDEPENDENT

;  PROCESS THE 'OFF' PARAMETER

SDRVOFF?: MOV       R0,@OFF
          CALL      CCL                    ;LOOK FOR 'OFF'
          TEST      SL,2                   ;BRANCH IF NOT X-PHASE
          JZ        SDRVROUT
          POP       EDX                    ;RECALL BIT MAP
          TEST      R0,0FH                 ;BRANCH IF 'OFF' NOT FOUND
          JNZ       SDRVRON

          XOR       R1,0FFH                ;USE COMPLEMENT OF MASK TO...
          XOR       R2,0FFH                ;TO TURN DRIVER OFF
          AND       DX,WORD PTR [R1]       ;TURN DRIVER OFF

          JMP       SDRVRSET

;  TURN DRIVER ON AND SAVE NEW BIT MAP

SDRVRON:  OR        DX,WORD PTR [R1]       ;TURN DRIVER ON
SDRVRSET: MOV       AUX00,EDX
          POP       EDX                    ;RECALL POINTER TO BIT MAP
;         CALL      WCM                    ;SAVE NEW BIT MAP
          MOV       AL,K                   ;bit map byte 2
;         MOV       [EDX+2],AL
          MOV       [EDX+8],AL             ;u64
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX+EBX],AX  ;u64,EBX is byte offset

;  TRASH THE LAST DRIVER ADDRESS USED FLAG SO 'SDRVDEV' KNOWS THINGS HAVE CHANGED

          MOV       AUX00,0
          MOV       EDX,OFFSET DEV?AMTERM  ;POINT TO FLAG
;         CALL      WCM                    ;SET FLAG TO 0000
          MOV       AL,K                   ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX

;  EXIT FROM THIS MESS

SDRVROUT: JMP       SLCTMORE               ;SEE IF THERE MORE TO SELECT
SDERR_17: JMP       ERR_17C                ;KILL


;     SLCTADDR: GET DEVICE TYPE AND ADDRESS & STORE IN
;               DEVICE TABLE.
;
;          ILLEGAL ADDRESSES: 02,03,06,07,41-47,81-87,C1-C7
;
;     SLCTADRO: SAME AS 'SLCTADDR' EXCEPT 01 ALSO ILLEGAL
;
;          FORMAT: [/] taa   or   <alpha-var>
;               WHERE: t = DEVICE TYPE
;                     aa = DEVICE ADDRESS
;
;         ENTRY: P 'S POINT TO DEVICE TABLE LOCAT ON TO
;                      STORE TYPE AND ADDRESS
;                 CH,CL = OLD ENTRY IN DEVICE TABLE
;                 TEXTPTR POINTS TO DEVICE TYPE
;
;          RETURN: PC'S POINT TO DEVICE ADDRESS IN DEVICE
;                     TABLE.
;                  TEXTPTR POINT AFTER DEVICE ADDRESS
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-2,AUX0-2
;                    AUXD-F (IN X-PHASE)
;
;     SLCTADRA: PUT DEVICE TYPE & ADDRESS IN DEVICE TABLE
;               IF EXECUTION PHASE
;
;          ENTRY (EXECUTION PHASE):
;               AUXD = ADDRESS OF #n DEV.TBL. SLOT
;               F1,0 = DEVICE TYPE & ADDRESS
;
;          RETURN: PC'S POINT TO DEV. ADDRS. IN DEV.TBL.
;
;          MODIFIED REGISTERS: PC'S
;

SLCTADDR: TEST      SL,2                    ;BRANCH IF NOT X-PHASE
          JZ        SLCTADR9
          MOV       AUX0D,EDX               ;SAVE PTR TO DEVICE TABLE
SLCTADR9: CMP       BYTE PTR [TEXTPTR],'<'  ;LOOK FOR '<'
          JNE       SLCTADRX                ;BRANCH IF NOT FOUND
          INC       TEXTPTR
          JMP       SLCTADR1

; /taa device address specification

SLCTADRX: CMP       BYTE PTR [TEXTPTR],'/'  ;LOOK FOR '/' (OPTIONAL)
          JNE       SLCTADRY
          INC       TEXTPTR
SLCTADRY: CALL      DEVADDR                 ;GET DEVICE ADDRESS
SLCTADRA: TEST      SL,2                    ;RETURN IF NOT EXECUTION PHASE
          JZ        SR@4
SLCTADR2: CMP       R1,TCDEV                ;B if not TC
          JNE       SLCTADR5
          JMP       SLCTADR7                ;

SLCTADR5: CALL      BADDRESS                ;CHECK FOR ILLEGAL ADDRESSES
SLCTADR7: MOV       EDX,AUX0D               ;POINT TO DEVICE TABLE
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          MOV       AL,R1                   ;DEVICE TYPE ==> TABLE
          AND       AL,0FH
          MOV       AH,CH
          AND       AH,0F0H
          OR        AL,AH
          MOV       BYTE PTR [EDX-1],AL
          MOV       AL,R0
          MOV       BYTE PTR [EDX],AL
          RET                               ;STORE DEVICE ADDRESS IN DEVICE TABLE

; <alpha-var> device address specification

SLCTADR1: CALL      AVARB                   ;GET ALPHA VARIABLE
          TEST      SL,2                    ;BRANCH IF NOT X-PHASE
          JZ        SLCTADR3
          CMP       DWORD PTR [A0],3
          JAE       SLCTADR3
          JMP       ERROR_51                ;ERROR IF LENGTH OF VARIABLE < 3

SLCTADR3: CMP       BYTE PTR [TEXTPTR],'>'  ;LOOK FOR '>'
          JNE       ERROR_16                ;NF, ERROR
          INC       TEXTPTR

SLCTADR8: TEST      SL,2                    ;RETURN IF NOT X-PHASE
          JZ        SR@4
          MOV       EDX,AUX0F
          XCHG      EDX,TEXTPTR             ;POINT TO VALUE OF VARIABLE
          MOV       AUX0F,EDX               ;SAVE TEXTPTR
          CALL      HEXDIGTA                ;GET DEVICE TYPE
          TEST      R0,0F0H                 ;ERROR IF NF
          JNZ       ERR_17C
          MOV       AL,R0
          MOV       R1,AL
          CALL      HEXDIGTA                ;GET 1ST DIGIT OF ADDRESS
          TEST      R0,0F0H                 ;ERROR IF NF
          JNZ       ERR_17C
          MOV       AL,R0
          MOV       R2,AL
          CALL      HEXDIGTA                ;GET 2ND DIGIT OF ADDRESS
          TEST      R0,0F0H                 ;ERROR IF NF
          JNZ       ERR_17C
          AND       R0,0FH                  ;F1,0 = DEVICE TYPE & ADDRESS
          MOV       AL,R2
          SHL       AL,4
          OR        R0,AL
          MOV       EDX,AUX0F
          MOV       TEXTPTR,EDX             ;RESTORE TEXTPTR
          JMP       SLCTADR2

ERR_17C:  MOV       EDX,AUX0F
          MOV       TEXTPTR,EDX             ;RESTORE TEXTPTR
          JMP       ERROR_17
SR@4:     RET

; SLCTADRO

SLCTADRO: CALL      SLTADRT                  ;GET DEVICE TYPE & ADDRESS, PUT INTO TABLE
          TEST      SL,2                     ;RETURN IF NOT X-PHASE
          JZ        SR@4
          CMP       R0,01H                   ;BRANCH IF NOT DEVICE ADDRESS 01
          JNE       SR@4

SLCTERRA: MOV       BYTE PTR [EDX+1],CH
          MOV       BYTE PTR [EDX],CL        ;RESTORE OLD DEVICE TABLE ENTRY
          JMP       ERROR_48                 ;ILLEGAL DEVICE ADDRESS

;     SLCTLEN: GET LINE WIDTH SPECIFICATION & STORE WIDTH
;              IN DEVICE TABLE
;
;          ENTRY: PC'S POINT TO ADDRESS TO STORE WIDTH -1
;                 TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: PC'S POINT TO DEVICE TABLE AFTER WIDTH
;                  TEXTPTR POINTS AFTER WIDTH
;
;          MODIFIED REGISTERS: ALL,AUX0-2,4
;

SLCTLEN:  MOV       AUX04,EDX             ;SAVE PTR TO DEVICE TABLE
          INC       AUX04
          CMP       BYTE PTR [TEXTPTR],'(';LOOK FOR '('
          JNE       SR@4                  ;NF, RETURN
          INC       TEXTPTR
          CALL      EXPR                  ;PROCESS LENGTH EXPRESSION
          TEST      SL,2                  ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTLEN1
          CALL      FLTBINA               ;CONVERT TO BINARY
          MOV       EDX,AUX04
          MOV       EAX,DWORD PTR [A0]
          MOV       BYTE PTR [EDX],AL     ;STORE LENGTH IN DEVICE TABLE
          INC       EDX
SLCTLEN1: CMP       BYTE PTR [TEXTPTR],')';LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          RET

CODE      ENDS
          END
