;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M10
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    ALPHA
PUBLIC    ALPHA1
PUBLIC    ANVARR
PUBLIC    ARECEV
PUBLIC    ARECEVX
PUBLIC    ARECEVAL
PUBLIC    AVAR
PUBLIC    AVAR1
PUBLIC    AVARD
PUBLIC    AVARL2
PUBLIC    AVARL2A
PUBLIC    AVARR
PUBLIC    AVARV
PUBLIC    CHARCTR
PUBLIC    CURLEN
PUBLIC    CURLENA
PUBLIC    ERR_17A
PUBLIC    ERR_17D
PUBLIC    ERROR_23
PUBLIC    ERROR_29
PUBLIC    ERROR_57
PUBLIC    LITERAL
PUBLIC    LTRLQT
PUBLIC    STRFNC

EXTRN     ADDVAR  :NEAR
EXTRN     ARAYEL  :NEAR
EXTRN     ARAYELA :NEAR
EXTRN     ARRAYA  :NEAR
EXTRN     CCL     :NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_04:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_17:NEAR
EXTRN     ERROR_24:NEAR
EXTRN     ERROR_51:NEAR
EXTRN     EXPR    :NEAR
EXTRN     FINDVAR :NEAR
EXTRN     FLTBIN  :NEAR
EXTRN     HEXDIGIT:NEAR
EXTRN     HEXPAIR :NEAR
EXTRN     LISTVAR :NEAR
EXTRN     SQZTEXTL:NEAR
EXTRN     TRACEVRA:NEAR
EXTRN     VARA    :NEAR
EXTRN     VARNAME :NEAR
EXTRN     VARNAMEA:NEAR
EXTRN     WRTWORD :NEAR
EXTRN     _STR    :NEAR

EXTRN     @@VSEND :DWORD
EXTRN     @@OSEND :DWORD
EXTRN     CPBASE  :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;         *******************************                                      ;
;         *                             *                                      ;
;         *  MODULE#10: ALPHANUMERICS   *                                      ;
;         *                             *                                      ;
;         *******************************                                      ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     ANVARR: SCAN & PROCESS AN ALPHA OR NUMERIC
;             RECEIVER VARIABLE.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 PHASE = EXECUTION
;
;          RETURN:
;                  ERROR#24 IF NOT FOUND
;
;                  TEXTPTR POINTS AFTER FOUND VARIABLE.
;                  ADDRESS OF VARIABLE ==> VS
;                  IF ALPHA, LENGTH ==> VS
;                  @ALPHREC OR @NUMREC ==> OS
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;-----------------------------------------------------------------------------;

ANVARR:   MOV       K,2                 ;FLAG = RECEIVE VAR.
          CMP       BYTE PTR [TEXTPTR],7FH
          JE        ANVARRX
          CMP       BYTE PTR [TEXTPTR],7DH
          JE        ANVARRX
          CALL      VARNAME             ;LOOK FOR VAR. NAME
          TEST      R0,0FH              ;BRANCH IF NF
          JNZ       ANVARR1
          TEST      R2,1                ;BRANCH IF ALPHA VAR.
          JNZ       AVAR1
          JMP       VARA                ;PROCESS NUMERIC RECEIVER
ANVARRX:
          MOV       AX,WORD PTR [TEXTPTR+1]
          MOV       WORD PTR [R2],AX
          ADD       TEXTPTR,7
          test      sl,3
          jnz       anvarrxy
          test      mode,0800h
          jz        anvarrxy
          call      listvar
anvarrxy:
          TEST      R2,1                ;BRANCH IF ALPHA VAR.
          JNZ       AVAR1
          JMP       VARA                ;PROCESS NUMERIC RECEIVER


ANVARR1:  CALL      AVAR                ;LOOK FOR 'STR('
          TEST      R0,0FH              ;RETURN IF FOUND
          JZ        ALPHASR
          JMP       ERROR_24


;     ALPHA: SCAN AND PROCESS AN ALPHA VARIABLE OR
;            LITERAL STRING OR STR FUNCTION.
;            ASSUMES DEFINED LENGTH OF VARIABLE IS TO
;            BE RETURNED.
;
;          VARIABLE FORMAT:
;               SCALAR = letter [digit] $
;               VECTOR-ELEMENT = letter [digit] $ (expr)
;               ARRAY-ELEM.= letter [digit] $ (expr,expr)
;               ARRAY = letter [digit] $ ()
;
;          STR FUNCTION FORMAT:
;               STR( alpha-var [,[expr] [,expr] ] )
;
;          VALID FORMS OF LITERAL STRINGS:
;               1. "character-string"
;               2. HEX( hexdigit hexdigit ...)
;
;%MAY WANT K-ENTRY-BIT FOR 'ERROR IF NOT FOUND'
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          RETURN (FOUND): F0 = 0
;                 TEXTPTR POINTS AFTER LITERAL OR VAR.
;                 ADDRESS AND LENGTH OF VALUE IN VS
;                    (LENGTH IN LAST)
;
;          RETURN (NOT FOUND): F0 = 1
;                 TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;     ALPHA1:  SAME AS 'ALPHA' EXCEPT WHETHER TO RETURN
;              'CURRENT LENGTH' OF VALUE OR 'DEFINED
;              LENGTH' OF THE VARIABLE MUST BE SPECIFIED.
;
;          ENTRY: K,BIT04 = 0 IF DEFINED-LENGTH OF VARIAB
;                            IS TO BE RETURNED
;                        = 1 IF CURRENT LENGTH OF VALUE
;                            IS TO BE RETURNED
;
;          NOTE: CURRENT LENGTH OF STR(...)
;                INCLUDES TRAILING SPACES.  IF A LITERAL
;                IS FOUND, ITS ACTUAL LENGTH IS RETURNED.
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;-----------------------------------------------------------------------------;

ALPHA:    MOV       K,0                     ;FLAG = RETURN DEFINED-LENGTH OF VAR.

;     Code to optimize literal, alpha-variable, or STR()
;     decoding.
;
;          CODES:  FC -- LITERAL ATOM
;                  FE -- HEX LITERAL ATOM
;                  D3 -- STR( ATOM
;

ALPHA1:   TEST      SL,2                    ;BRANCH IF EXECUTION PHASE
          JNZ       ALPHA2
          CALL      LITERAL                 ;LOOK FOR LITERAL
          TEST      R0,0FH                  ;NF, BRANCH
          JNZ       AVAR
          RET
;+++
alpha2:
        mov     ch,byte ptr [textptr]   ;get character
        inc     textptr                 ;update ptr
        test    ch,80h                  ;br, if atom
        jnz     alpha3                  ;
        cmp     ch,20h                  ;br, if not space
        ja      alpha5
alphanf:
        dec     textptr                 ;something else
        mov     r0,1
alphasr:
        ret
alpha3:
        cmp     ch,0feh                 ;br, if literal atom
        je      literalq                ;
        cmp     ch,0fch                 ;br, if hex literal atom
        je      literalq                ;
        cmp     ch,0d3h                 ;br, if str( atom
        je      strfnc                  ;
alpha5:
        dec     textptr                 ;pt back
;       cmp     ch,7fh                  ;
;       je      avarx1_2                ;
;       cmp     ch,7dh                  ;
;       je      avarx1_2                ;
        jmp     avarv                   ;


;     AVAR: SCAN AND PROCESS AN ALPHA VARIABLE
;           OR STR FUNCTION
;
;          VARIABLE FORMAT:
;               SCALAR = letter [digit] $
;               VECTOR-ELEMENT = letter [digit] $ (expr)
;               ARRAY-ELEM.= letter [digit] $ (expr,expr)
;               ARRAY = letter [digit] $ ()
;
;          STR FUNCTION FORMAT:
;               STR( alpha-var [,[expr] [,expr] ] )
;
;%MAY WANT K-ENTRY-BIT FOR 'ERROR IF NOT FOUND'
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 K, BIT02 = 1 IFF RECEIVER VARIABLE
;                    BIT04 = 0 IFF DEFINED LENGTH OF VAR.
;                              IS TO BE RETURNED.
;                            1 IFF CURRENT LENGTH OF
;                              VALUE IS TO BE RETURNED.
;
;                    ?? MIGHT MAKE RECEIVER/TRACE BIT
;                       INDEPENDENT BITS ??
;
;          RETURN (NF): F0 = 1
;
;          RETURN (FOUND): F0 = 0
;               ADDRESS OF VALUE OF VAR. --> VS (IN 1ST)
;               IF K,BIT04=0, DEFINED LENGTH-->VS (IN 2ND
;                   ,BIT04=1, CURRENT LENGTH OF VAR.-->VS
;
;               IF VARIABLE IS A RECEIVER (BIT02 OF K =1)
;                    @ALPHREC ATOM --> OS
;
;                   NOTE, FOR STR FUNCTION THE CURRENT
;                   LENGTH IS THE SPECIFIED NUMBER OF
;                   CHARACTERS (INCLUDING TRAILING SPACES
;                   IF ANY). FOR ALPHA VARIABLES, THE
;                   CURRENT LENGTH DOES NOT INCLUDE
;                   TRAILING SPACES (EXCEPT FOR
;                   STR() FUNCTION).
;
;          MODIFIED REGISTERS: ALL, AUX0,1,2
;
;     AVARR: SCAN AND PROCESS AN ALPHA RECEIVER VARIABLE
;            OR STR FUNCTION.
;
;     AVARV: SCAN AND PROCESS AN ALPHA VARIABLE
;            (STR FUNCTION NOT ALLOWED)
;
;     AVARD: SAME AS 'AVAR' EXCEPT K SET = 0  (RETURN
;            DEFINED LENGTH OF VARIABLE)

AVARD:    MOV       K,0                      ;RETURN DEFINED LENGTH OF VAR.
          JMP       AVAR
AVARR:    MOV       K,2                      ;FLAG = RECEIVER
AVAR:     TEST      SL,2                     ;BRANCH IF EXECUTION PHASE
          JNZ       AVARXX
          MOV       R0,@STR
          CALL      CCL                      ;LOOK FOR 'STR('
          TEST      R0,0FH                   ;F, BRANCH
          JZ        STRFNC
          JMP       AVARV                    ;NF, BRANCH
;+++
avarx0_0:
        inc     textptr
avarx:
        mov     ch,byte ptr [textptr]
        cmp     ch,@str
        je      strfnc_0
        cmp     ch,20h
        ja      avarx1_0
        je      avarx0_0
        dec     textptr
        mov     r0,1
        ret

avarx1_0:
;       cmp     byte ptr [textptr],7fh
;       je      avarx1_2

avarx1_1:
;       cmp     byte ptr [textptr],7dh
;       je      avarx1_2
        jmp     avarv

avarx1_2:
        mov     ax,word ptr [textptr+1]
        mov     word ptr [r2],ax
        test    al,1
        jz      avarx1_3
        mov     edx,textptr
        add     textptr,7
        mov     r0,0
        test    r2,2
        jnz     avar2
        call    findvar
        mov     ch,byte ptr [edx]
        mov     aux00,edx
        inc     aux00
        call    tracevra
        mov     edx,aux00
        jmp     avar8

avarx1_3:
        mov     r0,1
        ret

AVARXX:   MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR
          CMP       CH,@STR
          JE        STRFNC
          CMP       CH,20H
          JA        AVARX1
          JE        AVARXX
          DEC       TEXTPTR
          MOV       R0,1
          RET

AVARX1:   DEC       TEXTPTR                  ;DECREMENT TEXTPTR
AVARV:    MOV       R2,0F1H                  ;FLAG = ALPHA VAR. WANTED
          CALL      VARNAMEA                 ;LOOK FOR NAME OF VAR.
          TEST      R0,0FH                   ;NF, EXIT
          JNZ       AVAR9
AVAR1:    TEST      R2,2                     ;BRANCH IF ARRAY VAR.
          JNZ       AVAR2
          TEST      SL,3                     ;EXIT IF ENTRY PHASE
          JZ        AVAR3
          CALL      FINDVAR                  ;LOOK FOR VAR. IN SYMBOL TABLE
          TEST      R0,0FH                   ;F, BRANCH
          JZ        AVAR4
          MOV       R5,10H                   ;LENGTH OF VAR. = 16
          CALL      ADDVAR                   ;ADDR VAR. TO SYMBOL TABLE
          MOV       EDX,AUX00                ;PC'S = ADDR. OF VAR.
AVAR4:    TEST      SL,2                     ;EXIT IF NOT EXECUTION PHASE
          JZ        AVAR3
          MOV       CH,BYTE PTR [EDX]        ;CH = DEFINED LENGTH OF VAR.
          MOV       AUX00,EDX
          INC       AUX00
          CALL      TRACEVRA                 ;IF TRACE MODE, PRINT VAR. NAME
          MOV       EDX,AUX00                ;PC'S POINT TO VALUE OF VAR.
AVAR8:    MOV       EAX,VSPTR                ;ADDR OF VAR. VALUE --> VS
          SUB       EAX,4
          MOV       DWORD PTR [EAX],EDX
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERROR_02
          MOVZX     EAX,CH
          mov       dword ptr [a0],eax       ;R1,0 = define length of VAR
AVAR12:   TEST      K,4
          JNZ       AVAR5
AVAR7:    MOV       EAX,DWORD PTR [A0]
          MOV       EDX,VSPTR
          SUB       EDX,4
          MOV       DWORD PTR [EDX],EAX
          MOV       VSPTR,EDX
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERROR_02

AVAR11:   TEST      K,2                      ;BRANCH IF NOT RECEIVER VAR.
          JZ        AVAR3
          MOV       EDX,OSPTR                ;(ALPHA RECEIVER ATOM) --> OS
          INC       EDX
          CMP       EDX,DWORD PTR [@@OSEND]
          JE        ERROR_04
          MOV       BYTE PTR [EDX],@ALPHREC
          MOV       OSPTR,EDX

AVAR3:    MOV       R0,0                     ;FLAG = FOUND
AVAR9:    RET

AVAR5:    CALL      CURLENA                  ;DETERMINE CURRENT LENGTH OF VALUE
          JMP       AVAR7

;     ARRAY LOGIC
;

AVAR2:    CALL      TRACEVRA                 ;IF TRACE MODE, PRINT VAR. NAME
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       AVAR2X
          INC       TEXTPTR
          JMP       AVAR10
AVAR2X:
          CALL      ARAYEL                   ;SCAN & PROCESS SUBSCRIPT; PC'S = ADDR OF ARRAY EL.
                                             ;CH = DEFINED LENGTH OF ELEMENT
          MOV       AUX00,EDX                ;AUX0 = PTR TO ARRAY ELEMENT
          TEST      SL,2                     ;BRANCH IF EXECUTION PHASE
          JNZ       AVAR8
          JMP       AVAR3

;     ARRAY SPECIFICATION LOGIC   (EG, A$() )
;

AVAR10:   CALL      ARRAYA                   ;FIND ARRAY IN SYMBOL TABLE, GET START ADDR.
                                             ;OF THE ARRAY (PC'S), NO. OF ELEMENTS (F3,2), &
                                             ;ELEMENT LENGTH (CH)
          TEST      SL,2                     ;EXIT IF NOT EXECUTION PHASE
          JZ        AVAR3
          MOV       AUX00,EDX                ;SAVE PC'S
;         CALL      PUSHPV2                  ;ADDR OF ARRAY --> VS
          MOV       EAX,VSPTR                ;PC'S = VSPTR
          MOV       DWORD PTR [EAX-4],EDX
          SUB       VSPTR,4
          CMP       EAX,DWORD PTR [@@VSEND]  ;PC'S < VSEND ?
          JB        ERROR_02
          MOV       EDX,0                    ;PC'S = 0
          MOV       EAX,DWORD PTR [A2]         ;R1,0 = NO. OF ELEMENTS IN ARRAY
          MOV       DWORD PTR [A0],EAX
          CALL      ARAYELA                  ;PC'S = NO. OF BYTES IN ARRAY
          MOV       DWORD PTR [A0],EDX
          MOV       EDX,AUX00
          JMP       AVAR12


;     STRFNC:  SCAN AND PROCESS A STR FUNCTION
;
;          STR FUNCTION FORMAT:
;               STR( ALPHA-VAR [,[EXPR] [,EXPR] ] )
;
;               DEFAULT STARTING POSTION (1ST EXPRESSION)
;               OF SUBSTRING = 1.
;               IF 2ND EXPRESSION (LENGTH OF SUBSTRING)
;               IS OMITTED, THE SUBSTRING FROM THE START
;               TO THE END OF THE VARIABLE IS SPECIFIED.
;
;          ENTRY: TEXTPTR POINTS AFTER 'STR('
;                 K,BIT02= 1 IFF ALPHA RECEIVER
;
;          RETURN: F0 = 0 (FOUND FLAG)
;                  TEXTPTR POINTS AFTER 'STR(...)'
;
;                  IN EXECUTION PHASE,
;                  ADDRESS OF SUBSTRING --> VS (IN 1ST)
;                  LENGTH OF SUBSTRING --> VS (IN 2ND)
;
;                  IF RECEIVER AND EXECUTION PHASE,
;                  @ALPHAREC ATOM --> OS
;
;                  NOTE, LENGTH OF SUBSTRING INCLUDES ANY
;                  TRAILING SPACES.
;
;          MODIFIED REGISTERS: ALL, AUX0,1,2
strfnc_0:
        inc     textptr
STRFNC:   MOV       AL,K                 ;SAVE ENTRY FLAG
          MOV       R7,AL
          TEST      K,2                  ;BRANCH IF NOT RECEIVER VAR.
          JZ        STRFNC1
          TEST      MODE,0004H           ;BRANCH IF NOT TRACE
          JZ        STRFNC1
          TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        STRFNC1
          MOV       EDX,OFFSET _STR+5
          MOV       CH,BYTE PTR [EDX]
          CALL      WRTWORD              ;PRINT 'STR('

STRFNC1:  MOV       AL,R7                ;AVAR FLAG = RETURN DEFINED LENGTH OF VAR
          AND       AL,0FBH
          MOV       K,AL
          CALL      AVARV                ;SCAN AND PROCESS AN ALPHA VARIABLE
          TEST      R0,0FH               ;F, BRANCH
          JZ        STRFNC9
ERROR_29: MOV       R0,29H               ;MISSING ALPHA VAR.
          JMP       ERROR
STRFNC9:  CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       STRFNC2              ;NF, BRANCH
          INC       TEXTPTR
          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR 2ND COMMA
          JNE       STRFNCV              ;F, BRANCH
          INC       TEXTPTR
          JMP       STRFNC3
STRFNCV:  CALL      EXPR                 ;SCAN AND EVALUATE STARTING POSITION EXPRESSION
          CMP       BYTE PTR [TEXTPTR],','   ;LOOK FOR 2ND COMMA
          JNE       STRFNC4              ;NF,BRANCH
          INC       TEXTPTR
STRFNC8:  CALL      EXPR                 ;SCAN AND EVALUATE LENGTH EXPRESSION
          TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        STRFNC2
;2/23/89 ++
        mov     k,0                     ;flag = length specified
        call    fltbin                 ;convert length
        cmp     r2,2                    ;chk if length between 0 - 2^32
        jne     error_57                ;br, if no
        mov     ebx,dword ptr a0        ;get length
        mov     dword ptr a6,ebx        ;save it for a while
strfnc5:
        call    fltbin                  ;convert starting pt
        cmp     r2,2                    ;chk if valid #
        jne     error_57                ;
        mov     eax,dword ptr a0          ;get the starting pt
strfnc10:
        dec     eax                     ;starting pt - 1
        mov     edx,vsptr               ;
        mov     ecx,dword ptr [edx]       ;get the variable defined length
        test    k,1                     ;if length specified?
        jnz     strfnc6                 ;br, if not
        mov     ebx,dword ptr a6          ;get length
        mov     esi,eax                   ;
        add     esi,ebx                   ;cal the ending pt
        jc      error_57                ;br, if over 65536
        cmp     ecx,esi                   ;br, if defined length < ending pt
        jb      error_57                ;
strfnc7:
        add     dword ptr [edx+4],eax   ;update starting pt
        mov     dword ptr [edx],ebx       ;put new length
        cmp     byte ptr [textptr],')'  ;chk next char
        jne     error_11                ;
        inc     textptr                 ;update textptr
        mov     r0,0                    ;
        ret
strfnc6:
        cmp     ecx,eax                 ;chk if defined length < ending pt
        jbe     error_57                ;
        sub     ecx,eax                 ;cal the length needed
        mov     ebx,ecx                 ;
        jmp     strfnc7                 ;
strfnc3:
        test    sl,2                    ;br, if not xphase
        jz      strfnc8                 ;
        mov     edx,vsptr               ;
        sub     edx,8                   ;put default value 1 into VS
        mov     word ptr [edx],0        ;
        mov     word ptr [edx+2],1      ;
        mov     dword ptr [edx+4],0     ;
        mov     vsptr,edx               ;
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERROR_02
          JMP       STRFNC8

STRFNC4:
          MOV       k,1                  ;FLAG = LENGTH NOT SPECIFIED
          TEST      SL,2                 ;BRANCH IF EXECUTION PHASE
          JNZ       STRFNC5
STRFNC2:  CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          MOV       R0,0
          RET
ERROR_57: MOV       R0,57H               ;ILLEGAL STR ARGUMENTSA
          JMP       ERROR

;     LITERAL: SCAN AND PROCESS A LITERAL STRING IN TEXT
;
;          VALID FORMS OF LITERAL STRINGS:
;               1. "character-string"
;                    (any characters except quote or CR)
;               2. HEX( hexdigit hexdigit ...)
;
;          ATOMIZATION: IN ENTRY PHASE, LITERAL STRINGS
;               ARE REPLACED BY ATOMIZED FORMS OF THE
;               LITERALS.
;
;               LITERAL IN QUOTES:
;
;                    LITERAL ATOM (FE)
;                    COUNT (LENGTH OF LITERAL)
;                    1ST CHARACTER
;                    2ND CHARACTER
;                         .
;                         .
;                         .
;                    LAST CHARACTER
;
;                    FOR EXAMPLE,  "ABCD" IS ATOMIZED AS:
;                                 'FE' '04' ABCD
;
;               HEX LITERALS:
;
;                    HEXLIT ATOM (FC)
;                    COUNT (LENGTH OF LITERAL)
;                    1ST CHARACTER (2 PACKED HEX DIGITS)
;                    2ND CHARACTER
;                        .
;                        .
;                        .
;                    LAST CHARACTER
;
;                    FOR EXAMPLE, HEX(41424344) IS:
;                                 'FC' '04' ABCD
;
;               THE LITERAL REMAINS IN PACKED FORM IN
;               TEXT. SPECIAL LOGIC IS REQUIRED IN 'EDIT'
;               'LISTLINE','SCANCH','SAVE', AND 'LOAD'
;               ROUTINES TO PROCESS THE PACKED LITERALS.
;
;     THE PACKED FORM HAS THE FOLLOWING ADVANTAGES:
;          1. SPEED (DON'T HAVE TO SCAN ENTIRE LITERAL
;             IN RESOLUTION & EXECUTION PHASES)
;          2. LESS MEMORY (PACKED FORM REQUIRES HALF THE
;             STORAGE FOR HEX LITERALS)
;          3. NO SPECIAL LOGIC REQUIRED IN STATEMENTS
;             THAT ALLOW HEX(...).  THE 'COUNT AND
;             AND ADDRESS' LOGIC OF NORMAL LITERALS AND
;             ALPHA VARIABLES SUFFICES.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          RETURN (FOUND): F0 = 0
;                 TEXTPTR POINTS AFTER LITERAL
;                 ADDRESS AND LENGTH OF LITERAL IN VS
;                    (LENGTH IN LAST) (EXECUTION PHASE)
;
;          RETURN (NOT FOUND): F0 = 1
;                 TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3,AUX0

LITERAL:  MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]   ;GET NEXT TEXT CHAR
          INC       TEXTPTR
          CMP       CH,0FEH             ;BRANCH IF NOT LITERAL OF HEXLITERAL ATOM
          JE        LITERALQ
          CMP       CH,0FCH
          JE        LITERALQ
          JMP       LITERAL3
LITERALQ: MOV       EDX,TEXTPTR
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          MOVZX     EAX,CH              ;R3,2 = LENGTH OF LITERAL
          MOV       DWORD PTR [A2],EAX
          MOV       EBX,EDX             ;EBX = ADDR OF LITERAL
          ADD       EDX,EAX
          MOV       TEXTPTR,EDX         ;TEXTPTR POINTS AFTER LITERAL

          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        LITERAL4
          MOV       EDX,VSPTR
          MOV       DWORD PTR [EDX-4],EBX  ;ADDR OF LITERAL --> VS
          MOV       DWORD PTR [EDX-8],EAX    ;LENGTH OF LITERAL --> VS
          SUB       EDX,8
          MOV       VSPTR,EDX
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERROR_02

LITERAL4: MOV       R0,0                ;FLAG = LITERAL FOUND
          RET

LITERAL3: MOV       TEXTPTR,EDX         ;DECREMENT TEXTPTR
          TEST      SL,3                ;BRANCH IF ENTRY PHASE
          JZ        LITERAL2
LITERAL8: MOV       R0,1                ;FLAG = LITERAL NOT FOUND
          RET

;  ENTRY PHASE
;     LITERAL ASSUMED TO BE UNATOMIZED
;

LITERAL2: TEST      MODE,0800H          ;BRANCH IF LISTV
          JNZ       LITERAL8
          CALL      LTRLQT              ;SCAN LITERAL IN QUOTES
          TEST      R0,0FH              ;BRANCH IF QUOTE LITERAL FOUND
          JZ        LITERAL5
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1                ;BRANCH IF QUOTE LITERAL NOT FOUND
          JE        LITERAL9

ERROR_23: MOV       R0,23H              ;ILLEGAL LITERAL ERROR
          JMP       ERROR

;     ATOMIZE LITERAL IN QUOTES
;

LITERAL5: MOV       BYTE PTR [EDX-1],@LTRL  ;REPLACE QUOTE BY LITERAL ATOM


LITERAL1: MOV       CH,BYTE PTR [EDX]   ;CH = NEXT CHAR OF LITERAL
          MOV       R0,'"'              ;R0 = QUOTE
          MOV       AL,BYTE PTR A2      ;REPLACE LITERAL CHAR WITH R2
          MOV       BYTE PTR [EDX],AL
          INC       EDX
          MOV       BYTE PTR A2,CH      ;R2 = CHAR THAT WAS REPLACED
          CMP       CH,R0               ;BRANCH IF R2 <> QUOTE (END OF LITERAL)
          JNE       LITERAL1
          JMP       LITERAL4

;     UNPACKED HEX LITERAL
;
LITERAL9: MOV       R0,@HEX?LP
          CALL      CCL                 ;LOOK FOR 'HEX('
          TEST      R0,0FH              ;BRANCH IF FOUND
          JZ        LITHEXU
          JMP       LITERAL8

LITHEXU:  MOV       EDX,TEXTPTR         ;PC'S = TEXTPTR
          MOV       AUX00,EDX           ;SAVE PTR TO 'HEX(' ATOM
          DEC       AUX00
          MOV       R1,0                ;NO. OF CHARACTERS = 0
LITHEXU2: CALL      HEXDIGIT            ;LOOK FOR HEXDIGIT
          TEST      R0,0F0H             ;NF, BRANCH
          JNZ       LITHEXU1
          CALL      HEXDIGIT            ;LOOK FOR 2ND HEXDIGIT OF PAIR
          TEST      R0,0F0H             ;NF, BRANCH
          JNZ       ERR_17D
          INC       R1                  ;INCREMENT NO. OF CHARACTERS
          CMP       R1,0                ;BRANCH IF < 256
          JNE       LITHEXU2
LITHEXU1: CMP       R1,0                ;ERROR IF NO HEXDIGITS FOUND
          JE        ERROR_23
          CMP       BYTE PTR [TEXTPTR],')'     ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          MOV       EDX,AUX00
          MOV       AL,@HEXLIT          ;CHANGE 'HEX(' ATOM TO 'HEXLIT' ATOM
          MOV       BYTE PTR [EDX],AL
          INC       EDX
          MOV       TEXTPTR,EDX         ;TEXTPTR POINT AFTER ATOM
          MOV       AUX00,EDX
          DEC       EDX
          CALL      HEXDIGIT            ;GET NEXT HEXDIGIT
          MOV       EDX,AUX00
          MOV       AL,R1               ;PUT LENGTH OF LITERAL IN TEXT AFTER HEXLIT ATOM
          MOV       BYTE PTR [EDX],AL
          INC       AUX00
LITHEXU3: MOV       AL,R0               ;R2 = 0X WHERE X = HEXDIGIT
          MOV       R2,AL
          CALL      HEXDIGIT            ;GET 2ND HEXDIGIT OF PAIR
          MOV       EDX,AUX00           ;GET POINTER TO PACKED-LITERAL
          MOV       AL,R2               ;PACK 2 HEXDIGITS AND STORE CHAR IN TEXT
          SHL       AL,4
          MOV       AH,R0
          AND       AH,0FH
          OR        AL,AH
          MOV       BYTE PTR [EDX],AL
          INC       AUX00              ;INCREMENT POINTER TO PACKED LITERAL
          CALL      HEXDIGIT           ;GET 1ST HEXDIGIT OF NEXT PAIR
          TEST      R0,0F0H            ;F, BRANCH
          JZ        LITHEXU3
          CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          MOV       R0,0
          JMP       SQZTEXTL           ;DELETE REMAINDER OF UNPACKED LITERAL FROM TEXT

ERR_17D:  JMP       ERROR_17


;    ARECEV: SET THE SPECIFIED ALPHA RECEIVER VARIABLES
;            = SPECIFIED ALPHA VALUE.
;
;          ENTRY: VALUE STACK (VS) CONTAINS--
;                  -------------------------------------
;                  ! LENGTH OF VALUE (2 BYTES)         !
;                  ! ADDRESS OF VALUE (2 BYTES)        !
;                  ! LENGTH OF     RECEIVER (2 BYTES)  !
;                  ! ADDRESS OF     RECEIVER (2 BYTES) !
;                  -------------------------------------
;
;                 OPERATOR STACK (OS) CONTAINS--
;                  -------------------------------------
;                  ! @ALPHREC FOR     RECEIVER         !
;                  -------------------------------------
;
;                      WHERE: @ALPHREC = ALPHA RECEIVER
;                                        ATOM
;
;          RETURN: VS CLEARED OF VALUE AND RECEIVER
;                       ADDRESSES.
;                  OS CLEARED OF @ALPHREC ATOMS
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-5,AUX0,1

;+++
arecev2:
        mov     edx,vsptr
        mov     eax,dword ptr [edx]
        mov     dword ptr [a0],eax        ;R0,1 = length of value
        mov     edx,dword ptr [edx+4]   ;PC's = addr of value
        add     vsptr,8                 ;clear VS entry
        mov     aux01,edx               ;
arecev1_0:
        ret
arecev:
        test    sl,2                    ;br, if not xphase
        jz      arecev1_0               ;
arecevx:
        mov     edx,osptr               ;
        cmp     byte ptr [edx],@alphrec ;br, if not alpha recever
        jne     arecev2                 ;
        dec     osptr                   ;clear OS entry
        mov     edx,vsptr               ;

        mov     eax,dword ptr [edx]       ;get length of value
        mov     esi,dword ptr [edx+4]   ;    addr of value

        mov     ebx,dword ptr [edx+8]     ;get length of receiver
        mov     edi,dword ptr [edx+12]   ;    addr of receiver

        add     vsptr,16                ;clear VS entries

areceval_0:
        cmp     eax,ebx                   ;br, if receiver length > value length
        jb      ar_4                    ;
        mov     ecx,ebx                   ;make the length = receiver length
        rep movsb                       ;
ar_0:
        ret
ar_4:
        or      eax,eax                   ;chk if value length = 0
        jz      ar_0                    ;
        mov     ecx,eax                   ;make the length = value length
        rep movsb
        mov     ecx,ebx                   ;fill the padded space
        sub     ecx,eax                   ;
        mov     al,20h
        rep stosb
        ret


;;   FALL THOUGH TO 'ARECEVAL'
;
;
;;     ARECEVAL:  MOVE ALPHA VALUE (CHARACTER STRING) TO
;;                AN ALPHA RECEIVER VARIABLE. THE RECEIVER
;;                IS PADDED WITH TRAILING SPACES IF THE
;;                LENGTH OF THE VALUE IS SHORTER THAN THE
;;                LENGTH OF THE RECEIVER.
;;
;;          ENTRY: F1,0 = LENGTH OF VALUE
;;                 F3,2 = LENGTH OF RECEIVER
;;                 PC'S = ADDRESS OF VALUE
;;                 AUX0 = ADDRESS OF RECEIVER
;;
;;          MODIFIED REGISTERS: CH,CL,PC'S,F2-5,AUX0
;
;
ARECEVAL: MOV       EAX,DWORD PTR [A0]      ;B, IF VALUE SHORTER THAN RCVR
          CMP       EAX,DWORD PTR [A2]
          JB        ARECEV4
;
;          RECEIVER LENGTH <= VALUE LENGTH
;
          MOV       CH,BYTE PTR [EDX]     ;GET 1ST BYTE OF VALUE
          INC       EDX
          XCHG      EDX,AUX00
          MOV       EAX,DWORD PTR [A2]
          ADD       EAX,EDX
          MOV       DWORD PTR [A2],EAX    ;R3,2 = ADDR OF END OF RECEIVER + 1
          JMP       ARECEV6

ARECEV7:  MOV       BYTE PTR [EDX],CH     ;PUT NEXT BYTE OF VALUE INTO RECEIVER
          INC       EDX
          XCHG      EDX,AUX00
          MOV       CH,BYTE PTR [EDX]     ;GET NEXT BYTE OF VALUE
          INC       EDX
          XCHG      EDX,AUX00
ARECEV6:  CMP       EDX,DWORD PTR [A2]    ;BRANCH IF MORE TO RECEIVER
          JNE       ARECEV7
          RET

;          RECEIVER LENGTH > VALUE LENGTH
;

ARECEV4:  MOV       EAX,0
          CMP       EAX,DWORD PTR [A0]      ;BRANCH IF VALUE LENGTH > 0
          JB        ARECEV8
          RET

ARECEV8:  MOV       EAX,DWORD PTR [A0]
          ADD       EAX,EDX
          MOV       DWORD PTR [A4],EAX    ;R5,4 = ADDR OF END OF VALUE + 1
          XCHG      EDX,AUX00
          MOV       EAX,DWORD PTR [A2]
          ADD       EAX,EDX
          MOV       DWORD PTR [A2],EAX    ;R3,2 = ADDR OF END RECEIVER + 1
          XCHG      EDX,AUX00
ARECEV5:  MOV       CH,BYTE PTR [EDX]     ;GET NEXT BYTE OF VALUE
          INC       EDX
          XCHG      EDX,AUX00
          MOV       BYTE PTR [EDX],CH     ;STORE BYTE IN RECEIVER
          INC       EDX
          XCHG      EDX,AUX00
          CMP       EDX,DWORD PTR [A4]    ;BRANCH IF MORE TO VALUE
          JNE       ARECEV5

;          FILL REST OF RECEIVER WITH SPACES
;

          MOV       EDX,AUX00             ;PC'S POINT TO RECEIVER
ARECEV9:  MOV       BYTE PTR [EDX],20H    ;PUT SPACE INTO RECEIVER
          INC       EDX
          CMP       DWORD PTR [A2],EDX    ;BRANCH IF MORE TO RECEIVER
          JNE       ARECEV9
ARECEV1:  RET


;     LTRLQT: SCAN A LITERAL IN QUOTES
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN (LEADING QUOTE NOT FOUND): F0 = 1
;               TEXTPTR POINTS AT NEXT NONBLANK TEXT CHAR
;
;          RETURN (TRAILING QUOTE NOT FOUND): F0 = 3
;               TEXTPTR POINTS AT LEADING QUOTE
;
;          RETURN (FOUND): F0 = 0
;               TEXTPR POINTS AFTER LITERAL
;               PC'S POINT TO 1ST CHARACTER OF LITERAL
;                         (AFTER LEADING QUOTE)
;               F3,2 = LENGTH OF LITERAL
;
;          MODIFIED REGISTERS: F0,2,3,PC'S,CH,CL

LTRLQT:   MOV       EDX,TEXTPTR
          MOV       R0,1
          CMP       BYTE PTR [EDX],'"'
          JNE       LTRLQT1
          INC       TEXTPTR

;     LITERAL IN QUOTES
;
          MOV       R0,'"'               ;R0 = QUOTE
          INC       EDX
LTRLQT5:  MOV       CH,BYTE PTR [EDX]    ;GET NEXT CHAR
          INC       EDX                  ;INCREMENT PC'S
          CMP       CH,R0                ;BRANCH IF END OF LITERAL
          JE        LTRLQT3
          CMP       CH,0DH               ;BRANCH IF NOT CR
          JNE       LTRLQT5
LTRLQT4:  MOV       R0,3                 ;SIGNAL TRAILING QUOTE NOT FOUND
          RET

LTRLQT3:  MOV       DWORD PTR [A2],EDX   ;R3,2 = PTR AFTER END OF LITERAL
          XCHG      EDX,TEXTPTR          ;TEXTPTR POINTS TO AFTER END OF LITERAL
          MOV       EAX,EDX
          SUB       DWORD PTR [A2],EAX
          DEC       DWORD PTR [A2]
          CMP       DWORD PTR [A2],255
          JA        LTRLQT4              ;ERROR IF LENGTH > 255
          CMP       DWORD PTR [A2],0
          JE        LTRLQT4              ;ERROR IF LENGTH = 0
          MOV       R0,0
LTRLQT1:  RET


;     CURLEN: DETERMINE THE CURRENT LENGTH OF AN ALPHA
;             STRING (DEFINED LENGTH - TRAILING SPACES).
;             IF STRING IS ALL SPACES, LENGTH = 1.
;
;          ENTRY: PC'S = ADDRESS OF VALUE
;                 F1,0 = DEFINED LENGTH OF VALUE
;
;          RETURN: F1,0 = CURRENT LENGTH OF VALUE
;                  F3,2 = ADDRESS OF VALUE
;                  PC'S POINTS AFTER CURRENT VALUE (ADDR
;                        OF VALUE + CURRENT LENGTH)
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3
;
;     CURLENA: SAME AS 'CURLEN' EXCEPT FOR ENTRY
;
;          ENTRY: AUX0 = ADDRESS OF VALUE
;                 F1,0 = DEFINED LENGTH OF VALUE

;2/22/89 ++
curlena:
        mov     edx,aux00               ;
curlen:
        mov     dword ptr [a2],edx      ;return value start addr
        mov     edi,edx                 ;setup for scan string
        mov     ecx,dword ptr a0          ;get the defined length
        add     edi,ecx                 ;
        dec     edi                     ;edi pt to the ending char
        mov     al,20h                  ;compare with space
        pushf
        std                             ;from tail to head
        repe    scasb                   ;
        je      curl_1                  ;all space
        inc     ecx                     ;final length
        mov     dword ptr a0,ecx        ;save new length
curl_2:
        add     edi,2                   ;pt after legal char
        mov     edx,edi                 ;return parameter
        cld
        popf
        ret
curl_1:
        mov     dword ptr a0,1          ;as definition
        jmp     curl_2                  ;


;     AVARL2: SCAN & PROCESS AN ALPHA VARIABLE OR
;             STR FUNCTION.  SAME AS 'AVAR' EXCEPT
;             AN ERROR RESULTS IF LENGTH OF VARIABLE
;             IS NOT AT LEAST 2.
;
;          ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;               K,BIT02 = 1 IFF RECEIVER VARIABLE
;                ,BIT04 = 0 IF DEFINED LENGTH OF VARIABLE
;                              IS TO BE RETURNED
;                         1 IF CURRENT LENGTH OF VARIABLE
;                              IS TO BE RETURNED
;
;          RETURN (NOT FOUND): F0 = 1
;               TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;          RETURN (FOUND): F0 = 0
;               TEXTPTR POINTS AFTER VARIABLE
;            IN EXECUTION PHASE,
;               ADDRESS OF VARIABLE ==> VS (1ST IN)
;               IF K,BIT04=0, DEFINED LENGTH ==> VS (2ND)
;                         =1, CURRENT LENGTH ==> VS
;               IF K,BIT02=1, @ALPHREC ==> OS
;               CH,CL = LENGTH (CURRENT OR DEFINED) OF
;                       VARIABLE VALUE (>1)
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;
;     AVARL2A: SAME AS AVARL2 EXCEPT ENTRY FLAG (K) IS
;             SET TO 0. THUS, ADDRESS OF VARIABLE &
;             DEFINED LENGTH ARE PUT INTO VS; NOTHING IS
;             PUT INTO OS.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER

AVARL2A:  MOV       K,0

AVARL2:   CALL      AVAR                 ;SCAN & PROCESS ALPHA VAR.
          TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        AVARL21
          TEST      R0,0FH               ;BRANCH IF NOT FOUND
          JNZ       AVARL21
          MOV       EDX,VSPTR
          MOV       ECX,DWORD PTR [EDX]    ;GET LENGTH OF VAR.
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@spreg9,1
          jne       avarl2_x
          CMP       ECX,3
          JAE       AVARL21              ;BRANCH IF LENGTH >= 3
          JMP       ERROR_51             ;VAR. TOO SHORT
avarl2_x:
          CMP       ECX,2
          JAE       AVARL21              ;BRANCH IF LENGTH >= 2
          JMP       ERROR_51             ;VAR. TOO SHORT

AVARL21:  RET


;     CHARCTR: SCAN ALPHA VARIABLE OR LITERAL & GET 1ST
;              CHARACTER OF VALUE, OR GET CHARACTER
;              REPRESENTED BY 2 HEX DIGITS. ERROR IF NOT
;              FOUND.
;
;          FORMAT:   alpha-variable
;                    literal
;                    hh           (h = hexdigit)
;
;          ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;
;          RETURN: TEXTPTR POINTS AFTER 'CHARACTER'
;                      PARAMETER
;                  F0 = CHARACTER IN EXECUTION PHASE
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2

CHARCTR:  CALL      ALPHA                ;LOOK FOR ALPHA VAR OF LITERAL
          TEST      R0,0FH               ;NF, BRANCH
          JNZ       CHARCTR1
          TEST      SL,2                 ;BRANCH IF NOT EXECUTION PHASE
          JZ        CHARCTR2
          MOV       EDX,VSPTR            ;GET ADDR OF VALUE
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       CH,BYTE PTR [EDX]    ;GET 1ST CHAR OF VALUE
          MOV       R0,CH                ;R0 = CHAR
CHARCTR2: RET

CHARCTR1: JMP       HEXPAIR              ;LOOK FOR PAIR OF HEX DIGITS

ERR_17A:  JMP       ERROR_17             ;MISSING HEXDIGIT

CODE      ENDS
          END
