;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M11
;===========================================================================
	    .XLIST
	    INCLUDE PREAMBLE
	    .LIST

PUBLIC    ERR_75C
PUBLIC    ERROR_70
PUBLIC    DATA_
PUBLIC    GETDATA
PUBLIC    NXTDVL
PUBLIC    NXTDVLA
PUBLIC    ON
PUBLIC    ONSCAN
PUBLIC    READ
PUBLIC    RESTORE
PUBLIC    ROTATE

EXTRN     ANVARR  :NEAR
EXTRN     ARECEV  :NEAR
EXTRN     AVARD   :NEAR
EXTRN     AVARR   :NEAR
EXTRN     BREAKPTG:NEAR
EXTRN     CCL     :NEAR
EXTRN     CCNL    :NEAR
EXTRN     CPBASE  :DWORD
EXTRN     DATALOAD:NEAR
EXTRN     DATASAVE:NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_10:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_19:NEAR
EXTRN     ERROR_21:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     ERROR_74:NEAR
EXTRN     ERROR_75:NEAR
EXTRN     EXPR    :NEAR
EXTRN     FLTBIN  :NEAR
EXTRN     FLTBINA :NEAR
EXTRN     FLTBINB :NEAR
EXTRN     GOSUBA  :NEAR
EXTRN     GOTO    :NEAR
EXTRN     IFB_    :NEAR
EXTRN     IMMEDERR:NEAR
EXTRN     LINE_REF:NEAR
EXTRN     LITERAL :NEAR
EXTRN     NXTCHEOS:NEAR
EXTRN     ONERROR :NEAR
EXTRN     RECEV   :NEAR
EXTRN     REM     :NEAR
EXTRN     SCNCHSS :NEAR
EXTRN     SELECTA :NEAR
EXTRN     SELECTB :NEAR
EXTRN     SNUMBER :NEAR
EXTRN     SWITCH  :NEAR
EXTRN     TRLINE_ :NEAR
EXTRN     TRLINE_A:NEAR
EXTRN     TRLINE_B:NEAR
EXTRN     VARR    :NEAR
EXTRN     _ERRORU :NEAR
EXTRN     _LINES  :NEAR

;------------------------------------------------------------------------------;
;                                                                              ;
;      ***********************************                                     ;
;      *                                 *                                     ;
;      *  MODULE#11: GENERAL STATEMENTS  *                                     ;
;      *                                 *                                     ;
;      ***********************************                                     ;
;                                                                              ;
;                                                                              ;
;      DESCRIPTION: GENERAL BASIC STATEMENTS                                   ;
;                                                                              ;
;                ON          KEYIN        BIN     ROTATE                       ;
;                DATA        READ         RESTORE                              ;
;                                                                              ;
;      ENTRY: BRANCH TO APPROPRIATE STATEMENT ROUTINE.                         ;
;             TEXTPTR POINTS AFTER VERB.                                       ;
;             TEXTLPTR POINTS TO CURRENT LINE.                                 ;
;                                                                              ;
;      EXIT: BRANCH TO 'ENDSTMT','ENDSTIO',OR 'ERROR'                          ;
;                                                                              ;
;------------------------------------------------------------------------------;



;      ON: PROCESS AN 'ON' STATEMENT
;
;           GENERAL FORM:
;
;           ON expression GOSUB
;              alpha-var  GOTO   [line#][,[line#]...]
;                        SELECT [slct-lst][;[slct-lst]...]
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;

ON:       MOV       EDX,OFFSET _ERRORU
	  CALL      CCNL                  ;LOOK FOR 'ERROR', DON'T ATOMIZE IT
	  TEST      R0,0FH                ;NF, BRANCH
	  JNZ       ON50
	  JMP       ONERROR
ON50:     CALL      AVARD                 ;LOOK FOR ALPHA-VARIABLE
	  TEST      R0,0FH                ;NF, BRANCH
	  JNZ       ON1
	  TEST      SL,2                  ;BRANCH IF NOT EXECUTION PHASE
	  JZ        ON2
	  mov       edx,vsptr             ;PC'S = ADDRESS OF ALPHA-VARIABLE
	  mov       eax,dword ptr [edx]
	  mov       dword ptr [a0],eax
	  mov       edx,dword ptr [edx+4]
	  add       vsptr,8
	  MOV       CH,BYTE PTR [EDX]     ;GET 1ST BYTE OF ALPHA-VARIALBE; FLAG = GOTO
	  MOV       R7,0
	  MOV       R6,CH                 ;SAVE BYTE (BRANCH VALUE)
	  CMP       CH,0                  ;EXIT IF VALUE = 0
	  JE        ON8
ON2:      MOV       R0,@GOTO
	  CALL      CCL                   ;LOOK FOR 'GOTO'
	  TEST      R0,0FH                ;BRANCH IF FOUND
	  JZ        ON3
	  MOV       R0,@GOSUB
	  CALL      CCL                   ;LOOK FOR 'GOSUB'
	  TEST      R0,0FH
	  JZ        ON25
	  MOV       R0,@SELECT
	  CALL      CCL                   ;CHECK FOR SELECT ATOM
	  TEST      R0,0FH                ;ERROR IF NOT FOUND
	  JNZ       ON24

;   ON x SELECT ...

	  MOV       EDX,00008000H         ;FLAG = ON SELECT
	  MOV       AUX03,EDX
	  TEST      SL,2                  ;SKIP IF EXECUTION PHASE
	  JNZ       ON52
	  JMP       SELECTA
ON52:     MOV       R0,';'
	  CALL      ONSCAN                ;SCAN TO ARGUMENT TO EXECUTE
	  JMP       SELECTB               ;EXIT TO SELECT

ON24:     JMP       ERROR_19              ;NF, ERROR


;   ON x GOTO/GOSUB ...

ON25:     MOV       R7,1                  ;FLAG = GOSUB

ON3:      TEST      SL,2                  ;BRANCH IF EXECUTION PHASE
	  JNZ       ON4
ON5:
	  CMP       BYTE PTR [TEXTPTR],','
	  JNE       ON5X
	  INC       TEXTPTR
	  JMP       ON5                   ;F, BRANCH
ON5X:
	  CALL      LINE_REF              ;LOOK FOR LINE NUMBER REFERENCE
	  TEST      R0,0FH                ;NF, BRANCH
	  JNZ       ON6
	  CALL      TRLINE_B              ;SEARCH FOR REFERENCED LINE IF RESOLUTION PHASE
	  CMP       BYTE PTR [TEXTPTR],','
	  JNE       ON7
	  INC       TEXTPTR
	  JMP       ON5                   ;F, BRANCH
ON7:      JMP       ENDSTMT               ;EXIT

ON4:      MOV       R0,','
	  CALL      ONSCAN                ;SCAN FOR ARGUMENT TO EXECUTE
	  CMP       R7,0                  ;BRANCH IF NOT 'GOTO'
	  JNE       ON51
	  JMP       GOTO
ON51:     CALL      TRLINE_A              ;GET LINE TO TRANSFER TO
	  MOV       AUX00,EDX             ;SAVE PTR TO REFERENCED LINE
	  ADD       AUX00,4
	  CALL      SCNCHSS               ;SCAN FOR STMT SEPARATOR
	  MOV       TEXTPTR,EDX           ;POINT TO STMT SEPARATOR OR CR
	  JMP       GOSUBA
ON1:      CALL      EXPR                  ;SCAN & PROCESS EXPRESSION
	  TEST      SL,2                  ;BRANCH IF NOT EXECUTION PHASE
	  JZ        ON2
	  CALL      FLTBIN               ;CONVERT VALUE TO BINARY
	  CMP       R2,2                  ;BRANCH IF VALUE < 1 OR > 2^32
	  JNE       ON8
	  CMP       DWORD PTR [A0],255
	  JA        ON8
	  MOV       EAX,DWORD PTR [A0]
	  MOV       WORD PTR [R6],AX      ;F6 = BRANCH VALUE; FLAG (F7) = GOTO
	  JMP       ON2

ON6:      JMP       ERROR_21


;      ONSCAN: SCAN 'ON' STATEMENT FOR ARGUMENT TO EXECUTE
;
;           ENTRY: PHASE = EXECUTION
;                  F0 = SEPARATOR CHARACTER (, OR ; ETC)
;                  TEXTPTR POINTS AFTER 'GOTO','GOSUB', OR
;                     'SELECT'
;                  F6 = ON VALUE
;
;           RETURN: TEXTPTR POINTS TO ARGUMENT TO EXECUTE
;
;           EXITS: 'ENDSTMT' IF ON VALUE > NO. OF ARGUMNTS
;                  'REM' IF NULL ARGUMENT
;
;           MODIFIED REGISTERS: F6,CH,CL,PC'S
;

ONSCAN:   MOV       EDX,TEXTPTR
ONSCAN1:  DEC       R6                    ;DECREMENT ON VALUE
	  CMP       R6,0                  ;BRANCH IF VALUE = 0
	  JE        ONSCAN3
ONSCAN2:  MOV       CH,BYTE PTR [EDX]     ;GET NEXT CHARACTER
	  INC       EDX
	  CMP       CH,R0                 ;BRANCH IF SEPARATOR
	  JE        ONSCAN1
	  CMP       CH,0FFH               ;BRANCH IF LINE REFERENCE
	  JNE       ONSCANXX
	  ADD       EDX,6
	  JMP       ONSCAN2

ONSCANXX:
	  CMP       CH,0DH                ;BRANCH IF 'CR'
	  JE        ONSCAN4
	  CMP       CH,0FDH               ;BRANCH IF NOT STATEMENT SEPARATOR
	  JNE       ONSCAN2


;     END OF STATEMENT
;

ONSCAN4:  MOV       TEXTPTR,EDX           ;POINT TO END OF STATEMENT CHARACTER
	  DEC       TEXTPTR
ON8:      JMP       IFB_                  ;EXIT, CHECK FOR COLON, ELSE STATEMENT

;     CHECK FOR NULL ARGUMENT
;
ONSCAN3:  MOV       TEXTPTR,EDX
	  MOV       CH,BYTE PTR [EDX]     ;GET 1ST CHARACTER OF ARGUMENT
	  INC       TEXTPTR
	  CMP       CH,R0                 ;BRANCH IF NULL ARGUMENT
	  JE        ON8
	  MOV       TEXTPTR,EDX           ;POINT TO 1ST CHARACTER OF ARGUMENT
	  RET


;      ROTATE: PROCESS A 'ROTATE' STATEMENT
;
;           ENTRY: TEXTPTR POINTS AFTER 'ROTATE'
;
;           FORMAT:   ROTATE [C] (alpha-var, expression)
;
;           MODIFIED REGISTERS: ALL,AUX0-4
;

ROTATE:   MOV       R0,1
	  CMP       BYTE PTR [TEXTPTR],'C';LOOK FOR 'C'
	  JNE       ROTATEXX
	  INC       TEXTPTR
	  MOV       R0,0

ROTATEXX:
	  MOV       DL,R0
	  MOV       AUX04,EDX             ;SAVE FOUND/NOT FOUND FLAG
	  CMP       BYTE PTR [TEXTPTR],'(';LOOK FOR '('
	  JNE       ERROR_10
	  INC       TEXTPTR
	  CALL      AVARD                 ;LOOK FOR ALPHA-VARIABLE
	  TEST      R0,0FH                ;BRANCH IF FOUND
	  JZ        ROTATE10
	  JMP       ERROR_29              ;ERROR IF NOT FOUND
ROTATE10: CMP       BYTE PTR [TEXTPTR],',';LOOK FOR COMMA
	  JNE       ERROR_13
	  INC       TEXTPTR
	  CALL      EXPR                  ;SCAN & EVALUATE EXPRESSION
	  CMP       BYTE PTR [TEXTPTR],')';LOOK FOR ')'
	  JNE       ERROR_11
	  INC       TEXTPTR
	  TEST      SL,2                  ;BRANCH IF NOT EXECUTION PHASE
	  JZ        ROTATE1
	  MOV       R6,0                  ;SIGN OF EXPRESSION (ASSUME IS POSITIVE)
	  MOV       EDX,VSPTR
	  MOV       AX,WORD PTR [EDX+2]   ;GET 1ST WORD
	  MOV       BX,WORD PTR [EDX+4]   ;GET 2ND WORD
	  MOV       CX,WORD PTR [EDX+6]   ;GET 3RD WORD
	  OR        CX,CX
	  JNS       ROTATEYY
	  MOV       R6,1
	  NOT       CX                    ;COMPLEMENT MANTISSA
	  NOT       BX
	  NEG       AX
	  JNZ       ROTATEYY
	  INC       BX
	  JNZ       ROTATEYY
	  INC       CX
ROTATEYY:
	  MOV       WORD PTR [EDX+2],AX
	  MOV       WORD PTR [EDX+4],BX
	  MOV       WORD PTR [EDX+6],CX
	  CALL      FLTBINA
	  CMP       DWORD PTR [A0],8
	  JA        ERROR_34              ;ERROR IF VALUE > 8

ROTATE11: MOV       EAX,DWORD PTR [A0]    ;SAVE ROTATE VALUE
	  MOV       R7,AL
	  CMP       R6,0                  ;BRANCH IF ROTATE VALUE >=0
	  JE        ROTATE13
	  MOV       AL,8
	  SUB       AL,R7                 ;ROTATE VALUE = 8 - (ROTATE VALUE)
	  MOV       R7,AL

ROTATE13: MOV       EDX,AUX04
	  MOV       R5,DL                 ;F5 = 0 IF 'C' FOUND; ELSE 1
	  MOV       EBX,VSPTR             ;GET LENGTH & ADDRESS OF VARIABLE VALUE
	  MOV       EAX,DWORD PTR [EBX]
	  MOV       DWORD PTR [A0],EAX
	  MOV       EDX,DWORD PTR [EBX+4]
	  ADD       VSPTR,8
	  MOV       CH,BYTE PTR [EDX]     ;F3,2 = ADDRESS OF VARIABLE; CH = 1ST CHARACTR
	  MOV       DWORD PTR [A2],EDX
	  ADD       EDX,EAX               ;PC'S POINT TO END OF VARIABLE
	  TEST      R5,0FH                ;BRANCH IF ROTATE C
	  JZ        ROTATE5
	  CMP       R7,0                  ;BRANCH IF ROTATE COUNT = 0
	  JE        ROTATE1
	  DEC       EDX


; ROTATE EACH CHARACTER INDEPENDENTLY
;

ROTATE4:  MOV       CH,BYTE PTR [EDX]     ;GET NEXT CHARACTER TO ROTATE
	  MOV       CL,R7                 ;CL = ROTATE COUNT
ROTATE14: ROL       CH,CL                 ;ROTATE CH
	  MOV       BYTE PTR [EDX],CH
	  DEC       EDX                   ;DECREMENT POINTER
	  CMP       DWORD PTR [A2],EDX    ;BRANCH IF MORE CHARACTERS TO ROTATE
	  JBE       ROTATE4

ROTATE1:  JMP       ENDSTMTZ              ;EXIT

; ROTATE ENTIRE STRING
;

ROTATE5:  DEC       EDX
	  CMP       R7,0                  ;BRANCH IF ROTATE VALUE = 0 (OR -8)
	  JE        ROTATE9
	  MOV       AUX00,EDX             ;SAVE PTR TO END OF STRING
	  MOV       R5,0
ROTATE6:
	  CLC
	  CMP       R5,0
	  JE        ROTATEAA
	  STC
ROTATEAA:
	  MOV       CH,BYTE PTR [EDX]     ;GET NEXT CHARACTER
	  RCL       CH,1                  ;SHIFT LEFT 1 BIT
	  MOV       R5,0
	  JNC       ROTATEZZ
	  MOV       R5,1

ROTATEZZ:
	  MOV       BYTE PTR [EDX],CH
	  DEC       EDX
	  CMP       DWORD PTR [A2],EDX    ;BRANCH IF MORE CHARACTERS IN STRING
	  JBE       ROTATE6
	  MOV       EDX,AUX00             ;POINT TO END OF STRING
	  MOV       CH,BYTE PTR [EDX]     ;GET LAST CHARACTER OF STRING
	  OR        CH,R5                 ;PUT SHIFTED OUT BIT INTO END OF STRING
	  MOV       R5,0
	  MOV       BYTE PTR [EDX],CH
	  DEC       R7                    ;DECREMENT ROTATE COUNT
	  CMP       R7,0                  ;BRANCH IF MORE BITS TO ROTATE
	  JNE       ROTATE6

ROTATE9:  CMP       R6,0                  ;BRANCH IF ROTATE VALUE >= 0
	  JZ        ROTATE1

;     ROTATE STRING RIGHT 1 BYTE (ROTATE VALUE < 0)
;

ROTATE8:  MOV       CH,BYTE PTR [EDX]     ;F1,0 = ADDRESS OF END OF STRING;
	  MOV       DWORD PTR [A0],EDX

;      CH = LAST CHARACTER OF STRING

	  MOV       EDX,DWORD PTR [A2]    ;PC'S = ADDRESS OF BEGIN OF STRING
ROTATE7:  MOV       R2,CH                 ;F2 = CHARACTRR READ, CH = NEXT CHARACTER
	  MOV       CH,BYTE PTR [EDX]
	  MOV       AL,R2                 ;REPLACE CHARACTER BY PREVIOUS CHARACTER
	  MOV       BYTE PTR [EDX],AL
	  INC       EDX
	  CMP       DWORD PTR [A0],EDX
	  JB        ROTATE1
	  JMP       ROTATE7               ;BRANCH IF MORE CHARACTERS IN STRING


;      READ: PROCESS A 'READ' STATEMENT
;
;           STMT FORMAT:  READ variable [,variable...]
;
;           ENTRY: TEXTPTR POINTS AFTER 'READ'
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;

READ:
	  TEST    SL,2                    ;BR IF XPHASE
	  JNZ     READ3
	  CALL    IMMEDERR                ;ERROR, IF IMMEDIATE
READ2:
	  TEST    SL,2                    ;BR, IF XPHASE
	  JNZ     READ3                   ;
	  CALL    AVARR                   ;LOOK FOR ALPHA RECEIVER
	  TEST    R0,0FH                  ;BR, IF F
	  JZ      READ4                   ;
	  CALL    VARR                    ;LOOK FOR NUMERIC RECEIVER VARIABLE
READ4:
	  JMP     READ1
READ3:
	  CALL    ANVARR                  ;PROCESS ALPHA OR NUMERIC RECEIVER VARA
	  CALL    GETDATA                 ;VARIABLE = NEXT DATA VALUE
READ1:
	  CMP     BYTE PTR [TEXTPTR],','  ;LOOK FOR ','
	  JNE     ENDSTMTZ                ;BR, IF NF
	  INC     TEXTPTR
	  JMP     READ2                   ;


;      RESTORE: PROCESS A 'RESTORE' STATEMENT
;
;           STMT FORMAT:  RESTORE expression
;                                 [line# [,expression]]
;
;           ENTRY: TEXTPTR POINTS AFTER 'RESTORE'
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;      MOD REG: ALL,AUX0-2; IN EXEC., AUXA-C

RESTORE:
	  TEST    SL,2                    ;BR, IF NOT XPHASE
	  JZ      RESTORE9
	  MOV     EDX,DWORD PTR [CPBASE]
	  MOV     ECX,DWORD PTR [EDX].@IBASE   ;@DBASE = @IBASE
	  MOV     DWORD PTR [EDX].@DBASE,ECX
	  LEA     EBX,[ECX].@TEXTBEG           ;GET TEXTBEG POINTED TO BY @IBASE
	  MOV     ECX,DWORD PTR [EBX]
	  MOV     DWORD PTR [EDX].@DATAPTR,0   ;DATAPTR = 0
	  MOV     DWORD PTR [EDX].@DATALPT,ECX ;DATALPT = TEXTBEG
RESTORE9:
	  CALL    NXTCHEOS                ;LOOK FOR END-OF STATEMENT CHARACTER
	  TEST    R0,0FH                  ;BR, IF F
	  JZ      RESTORE5

	  MOV     EDX,OFFSET _LINES               ;
	  CALL    CCNL                    ;LOOK FOR 'LINE'
	  TEST    R0,0FH                  ;BR, IF NF
	  JNZ     RESTORE1
	  CALL    TRLINE_                 ;LLOK FOR LINE NUMBER
	  TEST    SL,2                    ;BR, IF NOT XPHASE
	  JZ      RESTORE2                ;
	  MOV     DWORD PTR [A0],EDX      ;SAVE ADDRESS OF REFERENCE LINE
	  CALL    SWITCH                  ;SAVE TEXT PTR TO RESTORE
	  MOV     EDX,DWORD PTR [A0]      ;
	  MOV     TEXTLPTR,EDX            ;POINT TO THREAD OF REFERENCED LINE
	  MOV     TEXTPTR,EDX             ;
	  ADD     TEXTPTR,6               ;POINT AFTER LINE NUMBER OF REF. LINE
	  CALL    NXTDVLA                 ;DATA PTRS POINT TO REF. LINE
	  CALL    SWITCH                  ;RESTORE TEXTPTRS TO RESTORE

RESTORE2:
	  CMP     BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE     RESTORE5                ;BR, IF NF
	  INC     TEXTPTR
RESTORE1:
	  CALL    EXPR                    ;PROCESS EXPRESSION
	  TEST    SL,2                    ;BR, IF NOT XPHASE
	  JZ      RESTORE5                ;
	  CALL    FLTBINB                 ;CONVERT VALUE TO BINARY

	  CMP     DWORD PTR [A0],0
	  JE      RESTORE5                ;
	  CMP     DWORD PTR [A0],1
	  JE      RESTORE5                ;BR, IF VALUE = 0 OR 1

RESTORE10:
	  CALL    SWITCH                  ;
	  MOV     EDX,DWORD PTR [A0]
	  DEC     EDX                     ;DECREMENT RESTORE VALUE

RESTORE6:
	  MOV     AUX0C,EDX               ;
	  DEC     AUX0C                   ;DECREMENT RESTORE VALUE
	  CALL    BREAKPTG                ;BREAK IF 30ms UP
	  CALL    NXTDVL                  ;POINT TO NEXT DATA VALUE
	  XOR     SL,PHASE                ;PHASE = RESOLUTION
	  CALL    LITERAL                 ;LOOK FOR LITERAL IN DATA STATEMENT
	  TEST    R0,0FH                  ;
	  JZ      RESTORE11               ;
	  CALL    SNUMBER                 ;LOOK FOR NUMBER IN DATA STATEMENT
	  TEST    R0,0FH                  ;
	  JZ      RESTORE11               ;
ERR_75C:  JMP     ERROR_75                ;ERROR IF NF

RESTORE11:
	  XOR     SL,PHASE                ;RESTORE PHASE TO EXECUTION
	  MOV     EDX,TEXTPTR             ;PC'S = TEXTPTR
	  MOV     DWORD PTR [A0],EDX      ;
	  MOV     EDX,DWORD PTR [CPBASE]
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     ECX,DWORD PTR [A0]      ;
	  MOV     DWORD PTR [EDX],ECX     ;SET DATAPTR
	  MOV     EDX,AUX0C               ;GET RESTORE VALUE
	  CMP     EDX,0                   ;
	  JNE     RESTORE6                ;BR, IF RESTORE VALUE > 0
	  CALL    SWITCH                  ;POINT TO RESTORE STATEMENT
RESTORE5:
	  JMP     ENDSTMTZ                ;EXIT



;      NXTDVL: POINT TO NEXT DATA VALUE
;
;           ENTRY: DATAPTR = 0 IF NOT POINTING AT A DATA
;                              VALUE NOW.
;                          = PTR TO PREVIOUS DATA VALUE
;                  DATALPTR POINTS TO LINE WHICH DATAPTR
;                          POINTS TO
;                  AUXA = TEXTPTR TO CURRENT TEXT LINE
;                  AUXB = TEXTLPTR TO CURRENT TEXT LINE
;                  PHASE = EXECUTION
;
;           RETURN: DATAPTR & TEXTPTR POINT TO NEXT DATA
;                       VALUE.
;                   DATALPTR & TEXTLPTR POINT TO LINE WITH
;                       WITH NEXT DATA VALUE.
;
;                   ERROR#70 IF NO MORE DATA  (TEXTPTR =
;                       AUXA, TEXTLPTR = AUXB)
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0,F1,AUXA,B
;
;      NXTDVLA: SET DATAPTRS = TEXTPTRS
;

NXTDVL:
	  MOV     EDX,DWORD PTR [CPBASE]  ;CH,CL = DATAPTR
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     ECX,DWORD PTR [EDX]
	  CMP     ECX,0                   ;BR, IF DATAPTR > 0
	  JNE     NXTDVL1                 ;
	  MOV     EDX,DWORD PTR [CPBASE]  ;point to starting text thread
	  LEA     EDX,[EDX].@DATALPT
NXTDVL4:
	  MOV     ECX,DWORD PTR [EDX]     ;GET THREAD TO NEXT LINE
	  CMP     ECX,0                   ;BR, IF NO MORE TEXT (F0 MUST = 0)
	  JE      NXTDVL7                 ;
	  MOV     EDX,ECX                 ;
	  MOV     TEXTLPTR,EDX            ;
	  ADD     TEXTLPTR,4              ;
	  XCHG    EDX,TEXTLPTR            ;TEXTLPTR POINT TO NEXT LINE
	  MOV     TEXTPTR,EDX             ;
	  ADD     TEXTPTR,2               ;TEXTPTR POINT AFTER LINE NUMBER

NXTDVL3:
	  CMP     BYTE PTR [TEXTPTR],@DATA ;LOOK FOR 'DATA'
	  JNE     NXTDVL6
	  INC     TEXTPTR
	  JMP     NXTDVL2
NXTDVL6:
	  CALL    SCNCHSS                  ;SCAN FOR STATEMENT SEPARATOR
	  TEST    R0,0FH                   ;BR, IF F
	  JZ      NXTDVL3
	  MOV     EDX,TEXTLPTR
	  JMP     NXTDVL4

NXTDVL2:
	  MOV     CH,BYTE PTR [TEXTPTR]   ;GET NEXT TEXT CHARACTER
	  TEST    CH,80H                  ;
	  JZ      NXTDVLA                 ;
	  CMP     CH,@LTRL                ;BR, IF LITERAL ATOM
	  JE      NXTDVLA
	  CMP     CH,@HEXLIT              ;BR, IF NOT HEX LITERAL ATOM (MUST
	  JNE     NXTDVL6
NXTDVLA:
	  MOV     EDX,TEXTLPTR            ;

	  MOV     DWORD PTR [A0],EDX      ;
	  MOV     EDX,DWORD PTR [CPBASE]  ;point to 'DATALPTR'
	  LEA     EDX,[EDX].@DATALPT
	  MOV     EAX,DWORD PTR [A0]
	  MOV     DWORD PTR [EDX],EAX     ;DATALPTR = TEXTLPTR
	  JMP     NXTDVL5                 ;

NXTDVL1:
	  MOV     EDX,DWORD PTR [CPBASE]  ;ch,cl = DATALPTR
	  LEA     EDX,[EDX].@DATALPT
	  MOV     ECX,DWORD PTR [EDX]
	  MOV     EDX,ECX                 ;
	  MOV     TEXTLPTR,EDX            ;TEXTLPTR = DATALPTR
	  MOV     EDX,DWORD PTR [CPBASE]
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     ECX,DWORD PTR [EDX]
	  MOV     EDX,ECX                 ;
	  MOV     TEXTPTR,EDX             ;TEXTPTR = DATAPTR
	  CMP     BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE     NXTDVL3                 ;BR, IF NF
	  INC     TEXTPTR

NXTDVL5:
	  MOV     EDX,TEXTPTR             ;
	  MOV     DWORD PTR [A0],EDX      ;
	  MOV     EDX,DWORD PTR [CPBASE]
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     EAX,DWORD PTR [A0]      ;
	  MOV     DWORD PTR [EDX],EAX     ;DATAPTR = TEXTPTR
	  RET
NXTDVL7:
	  CALL    SWITCH                  ;POINT TO STMT THAT CALLED NXTDVL (AUXA,B)

ERROR_70:
	  MOV     R0,70H                  ;INSUFFICIENT DATA
	  JMP     ERROR


;      GETDATA: GET NEXT DATA VALUE & SET RECEIVER = DATA
;
;           ENTRY: PHASE = EXECUTION
;                RECEIVER VARIABLE ATOM IN OS
;                ADDRESS OF RECEIVER IN VS
;                LENGTH OF RECEIVER IN VS (IF ALPHA)
;
;           RETURN: RECEIVER INFO. FLUSHED FROM OS & VS
;                RECEIVER = DATA
;                DATA PTRS UPDATED
;
;         ERRORS:  now switches back to READ statement before branching to error.
;                  This allows ERROR to work after READ.  Error now never displays
;                  DATA statement when READing.  It would be better to display
;                  both the DATA and READ statements (future?).  It would also be
;                  handy to have LIST RESTORE to display the current data ptr.
;
;           MODIFIED REG: ALL,AUX0,1,A,B
;

GETDATA:
	  CALL    SWITCH                  ;SAVE POINTER TO READ STATEMENT
	  CALL    NXTDVL                  ;POINT TO NEXT DATA VALUE
	  MOV     EDX,OSPTR
	  MOV     CH,BYTE PTR [EDX]       ;GET LAST OS ATOM
	  CMP     CH,@ALPHREC             ;BR, IF ALPHA
	  JE      GETDATA3
	  CALL    SNUMBER                 ;GET NUMBER FORM DATA STMT
	  TEST    R0,0FH                  ;BR, IF F
	  JZ      GETDATA1                ;
	  CALL    SWITCH                  ;POINT BACK TO READ STMT
	  JMP     ERROR_75                ;ILLEGAL NUMBER

GETDATA1:
	  MOV     EDX,TEXTPTR             ;
	  MOV     DWORD PTR [A0],EDX
	  MOV     EDX,DWORD PTR [CPBASE]
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     EAX,DWORD PTR [A0]
	  MOV     DWORD PTR [EDX],EAX     ;DATAPTR = TEXTPTR
	  CALL    SWITCH                  ;POINT TO READ STMT
	  JMP     RECEV                   ;RECEIVE VALUE

GETDATA3:
	  CALL    LITERAL                 ;LOOK FOR LITERAL IN DATA STMT
	  TEST    R0,0FH                  ;BR, IF F
	  JZ      GETDATA2
	  CALL    SWITCH                  ;POINT BACK TO READ STMT
	  JMP     ERROR_74                ;ERROR IF NF

GETDATA2:
	  MOV     EDX,TEXTPTR             ;
	  MOV     DWORD PTR [A0],EDX      ;
	  MOV     EDX,DWORD PTR [CPBASE]
	  LEA     EDX,[EDX].@DATAPTR
	  MOV     EAX,DWORD PTR [A0]
	  MOV     DWORD PTR [EDX],EAX     ;DATAPTR = TEXTPTR
	  CALL    SWITCH                  ;POINT TO READ STMT
	  JMP     ARECEV                  ;ALPHA-VARIABLE = VALUE OF LITERAL



;      DATA: PROCESS A 'DATA' STATEMENT
;
;           ENTRY: TEXTPTR POINTS TO NEXT TEXT CHAR.
;                  TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;

DATA_:
	  MOV     R0,@LOAD
	  CALL    CCL                     ;LOOK FOR 'LOAD'
	  TEST    R0,0FH                  ;BR, IF NF
	  JNZ     DATA3                   ;
	  JMP     DATALOAD                ;BR, F
DATA3:
	  MOV     R0,@SAVE                ;
	  CALL    CCL                     ;LOOK FOR 'SAVE'
	  TEST    R0,0FH                  ;BR, IF NF
	  JNZ     DATA4                   ;
	  JMP     DATASAVE                ;BR, F
DATA4:
	  TEST    SL,2                    ;
	  JZ      DATA5                   ;
	  JMP     REM                     ;SLIDE OVER STMT IF XPHASE
DATA5:
	  CALL    IMMEDERR                ;ERROR IF IMMEDIATE EXECUTION
DATA1:
	  CALL    LITERAL                 ;LOOK FOR LITERAL
	  TEST    R0,0FH                  ;BR, IF F
	  JZ      DATA2
	  CALL    SNUMBER                 ;LOOK FOR NUMBER
	  TEST    R0,0FH                  ;ERROR IF NF
	  JNZ     ERR_75C                 ;
DATA2:
	  CMP     BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE     ENDSTMT                 ;EXIT, IF NF
	  INC     TEXTPTR
	  JMP     DATA1

CODE      ENDS
	  END
