;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M14
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    ADD_
PUBLIC    AND_
PUBLIC    BIN
PUBLIC    BOOL
PUBLIC    DMFARG
PUBLIC    ERR_19E
PUBLIC    ERR_29E
PUBLIC    ERROR08C
PUBLIC    HEXPRINT
PUBLIC    INIT
PUBLIC    ONERR
PUBLIC    ONERROR
PUBLIC    OR_
PUBLIC    XOR_

EXTRN     ARECEV  :NEAR
EXTRN     AVARD   :NEAR
EXTRN     AVARR   :NEAR
EXTRN     CBSNR   :NEAR
EXTRN     CCL     :NEAR
EXTRN     CHARCTR :NEAR
EXTRN     DELAY10 :NEAR
EXTRN     ENBLDEVB:NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ERRORC  :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_10:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_17:NEAR
EXTRN     ERROR_19:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERRTYPE :NEAR
EXTRN     EXPR    :NEAR
EXTRN     FLTBINA :NEAR
EXTRN     GOTO    :NEAR
EXTRN     HEXDIGIT:NEAR
EXTRN     HEXPAIR :NEAR
EXTRN     INITSTKA:NEAR
EXTRN     NXTCHEOS:NEAR
EXTRN     OPARITH :NEAR
EXTRN     OPLGCL  :NEAR
EXTRN     PRINTBEG:NEAR
EXTRN     PRINTEND:NEAR
EXTRN     PRNTCR  :NEAR
EXTRN     REM     :NEAR
EXTRN     RUNB    :NEAR
EXTRN     SCRATCH :NEAR
EXTRN     TRLINE_ :NEAR
EXTRN     WRTHEX  :NEAR

EXTRN     @@VSEND :DWORD
EXTRN     CPBASE  :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;     *****************************                                            ;
;     *                           *                                            ;
;     *  MODULE-14:  2200 SYNTAX  *                                            ;
;     *                           *                                            ;
;     *****************************                                            ;
;                                                                              ;
;------------------------------------------------------------------------------;


;     AND: PROCESS AN 'AND' STATEMENT
;     OR: PROCESS AN 'OR' STATEMENT
;     XOR: PROCESS AN 'XOR' STATEMENT
;     BOOL: PROCESS A 'BOOL' STATEMENT
;
;          STMT FORMAT:
;
;               AND
;               OR    (alpha-variable, alpha-variable)
;               XOR                   hexdigit hexdigit
;               BOOLx
;
;                    where: x = hexdigit (BOOL func code)
;
;          ENTRY: TEXTPTR POINTS AFTER STMT VERB
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          MODIFIED REGISTERS: ALL,AUX0-3
;

AND_:     CALL      DMFARG            ;SCAN & PROCESS ARGUMENTS
AND1:     CALL      OPLGCL            ;PERFORM THE SPECIFIED LOGICAL OPERATION
          JMP       ENDSTMTZ          ;EXIT

OR_:      CALL      DMFARG            ;SCAN & PROCESS ARGUMENTS
          OR        R7,10H            ;FLAG = OR
          JMP       AND1

XOR_:     CALL      DMFARG            ;SCAN & PROCESS ARGUMENTS
          OR        R7,20H            ;FLAG = XOR
          JMP       AND1

BOOL:     CALL      HEXDIGIT          ;LOOK FOR BOOL FUNCTION CODE
          TEST      R0,0F0H
          JNZ       ERROR_17          ;ERROR IF NOT FOUND
          MOV       DL,R0
          OR        DL,40H            ;SAVE BOOL FUNCTION CODE
          MOV       AUX03,EDX
          CALL      DMFARG            ;SCAN & PROCESS ARGUMENTS
          XCHG      EDX,AUX03
          OR        R7,DL             ;SET BOOL FUNCTION CODE BITS IF F7
          XCHG      EDX,AUX03
          JMP       AND1

;     ADD: PROCESS AN 'ADD' STATEMENT
;
;          STMT FORMAT:
;
;               ADD[C] (alpha-variable,   alpha-variable)
;                                       hexdigit hexdigit
;
;          ENTRY: TEXTPTR POINTS AFTER 'ADD'
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          MODIFIED REGISTERS: ALL,AUX0-2
;

ADD_:     CMP       BYTE PTR [TEXTPTR],'C'  ;LOOK FOR 'C'
          JNE       ADD1                    ;BRANCH IF NF
          INC       TEXTPTR
          CALL      DMFARG                  ;SCAN & PROCESS ARGUMENTS
          OR        R7,40H                  ;FLAG = ADD WITH CARRY

ADD2:     CALL      OPARITH                 ;PERFORM OPERATION
          JMP       ENDSTMTZ                ;EXIT

ADD1:     CALL      DMFARG                  ;SCAN & PROCESS ARGUMENTS
          JMP       ADD2


;     DMFARG: SCAN & PROCESS A DATA MANIPULATION STMT
;             ARGUMENTS.
;
;          ARGUMENT FORMAT:
;               (alpha-var, alpha-var)   STRING-TO-STRING
;                    -OR-
;               (alpha-var, hexdigit hexdigit)  IMMEDIATE
;
;          ENTRY: TEXTPTR POINTS TO '('
;
;          RETURN: PC'S = ADDRESS OF 1ST OPERAND
;                  F1,0 = LENGTH OF 1ST OPERAND
;
;                  F7 = 0  IF STRING-TO-STRING FORM
;                         AUX0 = ADDRESS OF 2ND OPERAND
;                         F3,2 = LENGTH OF 2ND OPERAND
;
;                 F7 = 80 IF IMMEDIATE FORM
;                         F4 = IMMEDIATE OPERAND
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;

DMFARG:   CMP       BYTE PTR [TEXTPTR],'(' ;LOOK FOR '('
          JNE       ERROR_10
          INC       TEXTPTR
          CALL      AVARD                  ;PROCESS ALPHA RECEIVER (1ST OPERAND)
          TEST      R0,0FH
          JZ        DMFARGXX

ERR_29E:  JMP       ERROR_29               ;NF, ERROR
DMFARGXX: CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       ERROR_13
          INC       TEXTPTR
          CALL      AVARD                  ;LOOK FOR ALPHA-VARIABLE (2ND OPERAND)
          TEST      R0,0FH
          JNZ       DMFARG3                ;BRANCH IF NF
          TEST      SL,2
          JZ        DMFARG2                ;BRANCH IF NOT EXECUTION PHASE
          MOV       R7,0                   ;FLAG = STRING-TO-STRING FORM
          MOV       EDX,VSPTR              ;GET LENGTH & ADDRESS OF 2ND OPERAND
          MOV       EAX,DWORD PTR [EDX]
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       DWORD PTR [A2],EAX       ;F3,2 = LENGTH OF OPERAND2
          MOV       AUX00,EDX              ;AUX0 = ADDRESS OF OPERAND2

DMFARG1:  CMP       BYTE PTR [TEXTPTR],')' ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          MOV       EDX,VSPTR              ;F1,0 = LENGTH OF OPERAND1; PC'S = ADDRESS OF OP1
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          RET

DMFARG2:  CMP       BYTE PTR [TEXTPTR],')' ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          RET

DMFARG3:  CALL      HEXPAIR                ;LOOK FOR PAIR OF HEX DIGITS (IMMED. OPERAND
          TEST      SL,2
          JZ        DMFARG2                ;BRANCH IF NOT EXECUTION PHASE
          MOV       R7,80H                 ;FLAG = IMMEDIATE OPERATION
          MOV       AL,R0
          MOV       R4,AL                  ;F4 = IMMEDIATE OPERAND
          MOV       A3,0FFH                ;FLAG = NOT ALL FUNCTION
          JMP       DMFARG1

;     INIT: PROCESS AN 'INIT' STATEMENT
;
;          STMT FORMAT:
;
;               INIT(alpha) alpha-var [,alpha-var]...
;                   ( hh  )
;
;                    WHERE: h = hexdigit
;
;          ENTRY: TEXTPTR POINTS AFTER 'INIT'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,F
;

INIT:     CMP       BYTE PTR [TEXTPTR],'('  ;LOOK FOR '('
          JNE       ERROR_10
          INC       TEXTPTR
          CALL      CHARCTR                 ;LOOK FOR ALPHA VAR., LITERAL, OR HEXPAIR
          TEST      SL,2
          JZ        INIT2                   ;BRANCH IF NOT EXECUTION PHASE
          MOV       DL,R0
          MOV       AUX0F,EDX               ;AUXF = INIT. CHARACTER

INIT2:    CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR

INIT4:    CALL      AVARD                   ;LOOK FOR ALPHA VARIABLE TO INITIALIZE
          TEST      R0,0FH
          JNZ       ERR_29E                 ;ERROR IF NOT FOUND
          TEST      SL,2
          JZ        INIT3                   ;BRANCH IF NOT EXECUTION PHASE
          MOV       EAX,AUX0F               ;AL = INIT CHARACTER
          MOV       EDI,VSPTR               ;GET ADDRESS AND LENGTH OF VARIABLE
          MOV       ECX,DWORD PTR [EDI]
          MOV       EDI,DWORD PTR [EDI+4]
          ADD       VSPTR,8
          REP       STOSB                   ;INIT. CHARACTER --> VARIABLE

INIT3:    CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       ENDSTMTZ                ;NF, EXIT
          INC       TEXTPTR
          JMP       INIT4                   ;F, BRANCH

;     HEXPRINT: PROCESS A 'HEXPRINT' STATEMENT
;
;          STMT FORMAT:
;
;               HEXPRINT alpha-var [, alpha-var] ... [,]
;                                  [; alpha-var]
;
;          ENTRY: TEXTPTR POINTS AFTER 'HEXPRINT'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;

HEXPRINT: CALL      PRINTBEG            ;ENABLE PRINT DEVICE IF EXECUTION PHASE &

;     NOT   IMMEDIATE EXECUTION MODE
;

HEXPRNT3: CALL      AVARD               ;LOOK FOR ALPHA VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29E             ;ERROR IF NOT FOUND
          TEST      SL,2
          JZ        HEXPRNTX            ;BRANCH IF NOT EXECUTION PHASE
          MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF VARIABLE
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          CALL      WRTHEX                  ;PRINT VALUE OF VARIABLE IN HEX
HEXPRNTX: CMP       BYTE PTR [TEXTPTR],';'  ;LOOK FOR ;
          JNZ       HEXPRNTY
          INC       TEXTPTR
          JMP       HEXPRNT1            ;F, BRANCH

HEXPRNTY: TEST      SL,2
          JZ        HEXPRNTZ
          CALL      PRNTCR                 ;PRINT CR IF EXECUTION PHASE

HEXPRNTZ: CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       HEXPRNT2               ;NF, BRANCH
          INC       TEXTPTR
HEXPRNT1: CALL      NXTCHEOS               ;LOOK FOR END-OF-STMT CHARACTER
          TEST      R0,0FH
          JNZ       HEXPRNT3               ;F, BRANCH
HEXPRNT2: JMP       PRINTEND


;     BIN: PROCESS A 'BIN' STATEMENT (2200 SYNTAX)
;
;          FORMAT: BIN( alpha-variable ) = expression
;
;          ENTRY: TEXTPTR POINTS AFTER '('
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;

BIN:      CALL      AVARR                  ;SCAN & PROCESS ALPHA VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29E                ;ERROR IF NOT FOUND
          CMP       BYTE PTR [TEXTPTR],')' ;LOOK FOR ')'
          JNE       ERROR_11
          INC       TEXTPTR
          CMP       BYTE PTR [TEXTPTR],'=' ;LOOK FOR '='
          JNE       ERROR_12
          INC       TEXTPTR
          CALL      EXPR                   ;SCAN & PROCESS EXPRESSION
          TEST      SL,2
          JZ        BIN1                   ;BRANCH IF NOT EXECUTION PHASE

          CALL      FLTBINA                ;CONVERT VALUE TO BINARY
          DEC       OSPTR
          MOV       AL,BYTE PTR [A0]
          MOV       EDX,VSPTR              ;GET ADDRESS OF ALPHA-VAR, REMOVE LAST OS ATOM
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       BYTE PTR [EDX],AL      ;PUT VALUE INTO ALPHA VARIABLE
BIN1:     JMP       ENDSTMTZ               ;EXIT

;     ONERROR: PROCESS AN 'ON ERROR GOTO' STATEMENT
;              IN EXECUTION PHASE, STMT IS IGNORED.
;
;          ENTRY: TEXTPTR POINTS AFTER 'ERROR'
;
;          FORMAT:  ON ERROR E$,L$ GOTO xxxx
;
;          ONERRPTR:  ONERRPTR POINTS AFTER 'ON ERROR' IN
;                     THE 1ST 'ON ERROR GOTO' STATEMENT
;                     IN THE PROGRAM.  THIS PTR IS SET UP
;                     DURING RESOLUTION PHASE BY 'ONERROR
;

ONERROR:  TEST      SL,2
          JNZ       REM                 ;IGNORE STATEMENT IF EXECUTION PHASEE
          TEST      SL,3
          JZ        ONERROR1            ;BRANCH IF ENTRY PHASE
          MOV       EDX,TEXTPTR
          MOV       DWORD PTR [A0],EDX
          MOV       EDX,DWORD PTR [CPBASE] ;SET ON ERROR PTR
          LEA       EDX,[EDX].@ONERRPT
          MOV       ECX,DWORD PTR [EDX]
          CMP       ECX,0
          JNE       ONERROR1            ;BRANCH, ALREADY POINTS TO  'ON ERR STMT
          MOV       EAX,DWORD PTR [A0]
          MOV       DWORD PTR [EDX],EAX ;ONERRPTR POINT TO CURRENT ON ERR STMT

ONERROR1: CALL      AVARD               ;LOOK FOR ALPHA-VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29E                 ;ERROR IF NOT FOUND
          CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
          JNE       ERROR_13
          INC       TEXTPTR
          CALL      AVARD               ;LOOK FOR ALPHA-VARIABLE (2ND)
          TEST      R0,0FH
          JNZ       ERR_29E             ;NF, ERROR
          MOV       R0,@GOTO
          CALL      CCL                 ;LOOK FOR GOTO
          TEST      R0,0FH
          JNZ       ERR_19E             ;ERROR IF NOT FOUND
          CALL      TRLINE_             ;LOOK FOR LINE-NUMBER REFERENCE
          JMP       ENDSTMT

ERR_19E:  JMP       ERROR_19            ;MISSING BASIC WORD

;     ONERR: ON-ERROR-GOTO PROCESSING FOR EXECUTION PHASE
;            PROGRAM ERRORS.
;
;          ENTRY: ERRF = ERROR CODE
;                 PHASE = EXECUTION
;                 TEXTLPTR POINTS TO LINE IN ERROR
;                 CHCL = ADDRESS OF ON-ERROR-GOTO STMT
;                        (POINTS AFTER 'ERROR')
;

ONERR:    MOV       EDX,ECX
          MOV       TEXTPTR,EDX          ;POINT TO 'ON ERROR GOTO' STATEMENT
          CALL      INITSTKA             ;INITIALIZE STACKS
          AND       MODE,0FFFH           ;LIST, INPUT MODES OFF
          CALL      AVARR                ;LOOK FOR ALPHA-VARIABLE (ERR CODE RECEIVER)
          TEST      R0,0FH
          JNZ       ERR_29E                 ;ERROR IF NOT FOUND
          MOV       EDX,DWORD PTR [CPBASE]  ;GET ERROR CODE
          MOV       CH,BYTE PTR [EDX].@ERRF
          MOV       R7,CH                   ;F7 = ERROR CODE
          CALL      ERRTYPE              ;DETERMINE ERROR TYPE (SAVE IT IN K)
          MOV       EDX,OFFSET SCRATCH
          MOV       AL,K
          MOV       BYTE PTR [EDX],AL    ;ERROR TYPE ==> SCRATCH AREA
          MOV       AL,CH                ;ERROR CODE ==> SCRATCH AREA
          SHR       AL,4
          ADD       AL,30H
          MOV       BYTE PTR [EDX+1],AL
          MOV       AL,CH
          AND       AL,0FH
          ADD       AL,30H
          MOV       BYTE PTR [EDX+2],AL
          MOV       EAX,VSPTR
          MOV       DWORD PTR [EAX-4],EDX  ;ADDRESS OF ASCII ERROR CODE ==> STACK
          MOV       DWORD PTR [EAX-8],3     ;LENGTH OF ERROR CODE ==> STACK
          SUB       EAX,8
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERROR_02               ;BR, IF STACK FULL

          CALL      ARECEV                 ;ASCII ERROR CODE ==> RECEIVER VARIABLE
          CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       ERROR_13
          INC       TEXTPTR
          CALL      AVARR                ;LOOK FOR LINE-NUMBER RECEIVER
          TEST      R0,0FH
          JNZ       ERR_29E              ;NF, ERROR
          MOV       EDX,TEXTLPTR
          ADD       EDX,4
          MOV       CX,WORD PTR [EDX]    ;GET LINE NUMBER OF LINE IN ERROR
          XCHG      CH,CL
          MOV       EDX,OFFSET SCRATCH   ;ASCII LINE NUMBER ==> SCRATCH AREA
          MOV       AL,CH
          SHR       AL,4
          ADD       AL,30H
          MOV       BYTE PTR [EDX],AL
          MOV       AL,CH
          AND       AL,0FH
          ADD       AL,30H
          MOV       BYTE PTR [EDX+1],AL
          MOV       AL,CL
          SHR       AL,4
          ADD       AL,30H
          MOV       BYTE PTR [EDX+2],AL
          MOV       AL,CL
          AND       AL,0FH
          ADD       AL,30H
          MOV       BYTE PTR [EDX+3],AL
          MOV       EAX,VSPTR
          MOV       DWORD PTR [EAX-4],EDX ;ADDRESS OF ASCII LINE NUMBER ==> STACK
          MOV       DWORD PTR [EAX-8],4    ;LENGTH OF LINE NUMBER ==> STACK
          SUB       EAX,8
          MOV       VSPTR,EAX
          CMP       EAX,DWORD PTR [@@VSEND]
          JB        ERROR_02             ;ERR, IF STACK FULL

          CALL      ARECEV               ;ASCII LINE NUMBER ==> RECEIVER VARIABLE
          MOV       R0,@GOTO
          CALL      CCL                  ;LOOK FOR 'GOTO'
          TEST      R0,0FH
          JNZ       ERR_19E              ;ERROR IF NOT FOUND
          TEST      MODE,0200H           ;BRANCH IF NOT OVERLAYING
          JZ        GOTO

          CALL      TRLINE_              ;GET ON-ERROR-GOTO LINE-NUMBER
          MOV       DX,WORD PTR [R2]
          MOV       CONTLN_,EDX          ;CONTLN# = ON-ERROR-GOTO LINE-NUMBER
          MOV       STMTCNT,0            ;STMTCNT = 0
          OR        MODE,0001H           ;MODE = 'RUN AT SPECIFIED LINE'
          JMP       RUNB

ERROR08C: MOV       R0,08H               ;ERROR A08
          JMP       ERRORC               ;(PROGRAM LINE MUST BE FLUSHED)

; TESTCLKN: TEST CLOCK N TIMES.
;
; TESTCLK: CHECK ACCURACY OF 30MS. CLOCK. DISPLAY 'XXMS TICK'
;          IF CLOCK DOES NOT FALL WITHIN LIMITS.
;
;      CLOCK SPECIFICATIONS:
;           20 MS. MIN.
;           27 MS. AVE.
;           35 MS. MAX.
;
;      MODIFIED REGISTERS: PC'S,F0-F5,K,CH,CL
;
;
;TESTCLK:
;TESTCLKN:
;         RET

; CLKON: TURN ON "2227B" CLOCK (/0FD)
; CLKOFF: TURN OFF "2227B" CLOCK
;
;       TEMPORARY R & D TOOL!!!!
;
;      MODIFIED REGISTERS: K
;
;
;CLKON:
;        MOV     K,0FDH
;        CALL    ENBLDEVB
;        CALL    DELAY10
;        MOV     AL,1
;        MOV     K,1
;        CALL    CBSNR
;        CALL    DELAY10
;        RET
;CLKOFF:
;        MOV     K,0FDH
;        CALL    ENBLDEVB
;        CALL    DELAY10
;        MOV     AL,2
;        MOV     K,2
;        CALL    CBSNR
;        CALL    DELAY10
;        RET


CODE      ENDS
          END
