;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M44
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC       TRACED
PUBLIC       DTRACE


EXTRN  CCL        :NEAR
EXTRN  CPBASE     :DWORD
EXTRN  CPRNTCR    :NEAR
EXTRN  DISKCMDC   :NEAR
EXTRN  ENDSTMT    :NEAR
EXTRN  ENBLSCO    :NEAR
EXTRN  ENBLDEVD   :NEAR
EXTRN  PART_      :BYTE
EXTRN  PRNTCR     :NEAR
EXTRN  TWRITE     :NEAR
EXTRN  TWRITESP   :NEAR
EXTRN  TWRIT2SP   :NEAR
EXTRN  WRTHEXCH   :NEAR
EXTRN  $DWRTVAL32 :NEAR
EXTRN  WRTLIN_2   :NEAR


;         FILE = BPMVP44 ,09/09/1986
;         MODULE    MOD-44    DISK TRACING
;         SYMBL     BPMVP00
;         SYMBL     BPMVP01
;         SYMBL     BPMVP02
;         SYMBL     BPMVP05
;         SYMBL     BPMVP40
;         SYMBL     MLMVP90
;         SYMBL     BPMVP43
;         SYMBL     DAMVP20
;         SYMBL     JLMVP32
;*
;*    Disk tracing...
;*
;*      Syntax:
;*        TRACE DISK - Outputs trace information to current CO device
;*
;*                                   /taa hhhh ddddd hh
;*                                     ^   ^     ^    ^
;*                                     !   !     !    !-Partition
;*                                     !   !     !------Sector address
;*                                     !   !------------Disk command
;*                                     !----------------Disk address
;*
;*        TRACE DISK OFF - Turns off the outputting of trace information
;*
;*        The memory location TRDISK is a flag indicating disk trace (1) or
;*        not (0).
DTRACE:
        MOV     R0,@DISK        ;SEARCH FOR KEYWORD DISK
        CALL    CCL
        TEST    R0,0FH
        JZ      DTRACE1         ;BR IF FOUND
        MOV     R0,@OFF
        RET
DTRACE1:
        MOV     R0,@OFF                 ;SEARCH FOR KEYWORD OFF
        CALL    CCL
        TEST    R0,0FH
        JNZ     DTRACE3                 ;BR IF NOT FOUND
        TEST    SL,2
        JZ      DTRACE2
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDISK       ;POINT TO TRACE DISK FLAG
        MOV     BYTE PTR [EDX],0        ;TURN OFF TRACE DISK FLAG
DTRACE2:
        JMP     ENDSTMT                 ;EXIT
DTRACE3:
        TEST    SL,2                    ;BR IF NOT EXECUTION PHASE
        JZ      DTRACE5
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDISK       ;POINT TO TRACE DISK FLAG
        MOV     BYTE PTR [EDX],1        ;TURN ON TRACE DISK FLAG
DTRACE5:
        JMP     ENDSTMT

;*===============================================================================
;*
;*    Patch to DISKCMND to perform disk trace.
;*
;*        Disk tracing is inhibited during LIST S to avoid a disk hog problem.
;*        If trace is to CRT and LIST S stops just after trace disk output, the
;*        disk is hogged (until the operator continues the LIST S).  This is
;*        unacceptible; thus, the disk trace is inhibited.
;*====>   BPMVP40Y "DISKCMND" CALL  TRACED SUBROUITNE, THE ENTRY PARAMETERS ARE:
;          ENTRY: DISK ENABLED AND INITIALIZED
;                 PC'S = SECTOR ADDRESS
;                 F0 = COMMAND:  00 IF READ
;                                40 IF WRITE
;                                80 IF COMPARE
;
;                                20 IF EXTENDED COMMAND
;                 F2 = EXTENDED COMMAND CODE (PHOENIX ONLY)
;
;                ACTDEV = DEVICE TYPE & ADDRESS (DEVICE TYPE
;                          IS 'D' IFF PHOENIX)
;                 AUXE,LOW BYTE = PLATTER (MUST BE 'T' IF
;                                 PHOENIX)
TRACED:
        PUSH    EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDISK       ;POINT TO TRACE DISK FLAG
        MOV     CH,[EDX]        ;GET TRACE DISK FLAG
        CMP     CH,1            ;CH  -- 0 OFF   BR IF TRACE DISK IS OFF
        JNZ     TRACED4         ;       1 ON
        TEST    MODE,4000H      ;BR IF NOT LIST S
        JZ      TRACED1
TRACED4:
        POP     EDX
        CALL    DISKCMDC        ;PROCESS DISK COMMAND
        RET

;* ------- disk trace -----------
;*    Save registers used
TRACED1:
;       CALL    R@TEMP           ;EACH PARTITION HAS ONE TEMPORARY STORAGE AREA
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
;       CALL    WRTF5            ;SAVE F5-0
        MOV     AL,R5
        MOV     AH,R4
        MOV     [EDX],AX
        MOV     AL,R3
        MOV     AH,R2
        MOV     [EDX+2],AX
        MOV     AL,R1
        MOV     AH,R0
        MOV     [EDX+4],AX
        ADD     EDX,6
        MOV     EAX,AUX00        ;    TEMPORARAY AREA -----> 0  | F5             1
        MOV     [EDX],EAX        ;                           1  | F4             1
        ADD     EDX,4            ;                           2  | F3             1
        MOV     EAX,ACTDEV       ;                           3  | F2             1
        MOV     [EDX],EAX        ;                           4  | F1             1
        MOV     WORD PTR R4,AX   ;                           5  | F0             1
        ADD     EDX,4            ;                           6  | AUX00          4
        POP     EAX              ;                           10 | ACTDEV         4
        MOV     [EDX],EAX        ;                           14 | SECTOR ADDRESS 2
        MOV     EBX,DWORD PTR [A0]
        MOV     DWORD PTR [EDX+4],EBX ;                      18 | A0 A1
        MOV     AUX00,EAX
;       CALL    R@TEMP3          ;RESTORE R2 & R0
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        mov     cl,byte ptr [edx+3]
        mov     ch,byte ptr [edx+5]
;       ADD     EDX,3
;       MOV     CX,WORD PTR [EDX]
        MOV     R2,CL           ;R2 = EXTENDED COMMAND
        MOV     R0,CH           ;R0 = PRIMARY COMMAND
; OUTPUT FORMAT:
;                                   /taa hhhh ddddd hh
;                                     ^   ^     ^    ^
;                                     !   !     !    !-Partition
;                                     !   !     !------Sector address
;                                     !   !------------Disk command
;                                     !----------------Disk address

;*    Output disk address
        CALL    ENBLSCO         ;ENABLE SELECTED CO DEVICE
        CALL    CPRNTCR         ;OUTPUT CR IF NOT AT BEGIN OF LINE
        MOV     K,'/'
        CALL    TWRITE
        MOV     AL,R5           ;OUTPUT DISK ADDRESS IN R5 & R4
        AND     AL,0FH
        CALL    WRTHEXCH
        MOV     AL,R4
        SHR     AL,4
        CALL    WRTHEXCH
        MOV     AL,R4
        AND     AL,0FH
        CALL    WRTHEXCH
        CALL    TWRITESP
;*    Output disk command
        MOV     AL,R0
        SHR     AL,4        ;OUTPUT DISK COMMAND IN R0
        CALL    WRTHEXCH
        MOV     AL,R0
        AND     AL,0FH
        CALL    WRTHEXCH
        CMP     R0,20H
        JNZ     TRACED2
;*    Output extended command
        MOV     AL,R2           ;OUTPUT EXTENDED COMMAND IN R2
        SHR     AL,4
        CALL    WRTHEXCH
        MOV     AL,R2
        AND     AL,0FH
        CALL    WRTHEXCH
        JMP     TRACED3
;*    Output spaces
TRACED2:
        CALL    TWRIT2SP
TRACED3:
        CALL    TWRITESP
;*    Output sector address
        MOV     EDX,AUX00       ;GET SECTOR ADDRESS
        MOV     DWORD PTR A0,EDX
        CALL    $DWRTVAL32
;*    Output partition number
        CALL    TWRITESP
        MOV     CH,PART_
        ADD     CH,1            ;PART # FROM 1 TO 16
        CMP     CH,10           ;CONVERT TO DECIMAL IF > 9
        JB      BP44_01
        ADD     CH,6
BP44_01:
        MOV     R2,CH
        CALL    WRTLIN_2
        CALL    PRNTCR
;*    Re-enable disk device
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        ADD     EDX,10
        MOV     ECX,[EDX]
        MOV     ACTDEV,ECX
        MOV     EDX,ECX
        CALL    ENBLDEVD
;*    Restore registers
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        MOV     CX,[EDX]
        MOV     R5,CL
        MOV     R4,CH
        ADD     EDX,2
        MOV     CX,[EDX]
        MOV     R3,CL
        MOV     R2,CH
        ADD     EDX,2
        MOV     CX,[EDX]
        MOV     R1,CL
        MOV     R0,CH
        ADD     EDX,2
        MOV     ECX,[EDX]
        ADD     EDX,8
        MOV     AUX00,ECX         ;RESTORE AUX00
        MOV     ECX,[EDX]
        MOV     EDX,ECX           ;(E)DX = SECTOR ADDRESS
        MOV     EBX,DWORD PTR [EDX+4]
        MOV     DWORD PTR [A0],EBX
        CALL    DISKCMDC
        RET

; ---------------- 22c11-2 -------------------
PUBLIC  TRACED_NEW
TRACED_NEW:
        PUSH    EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDISK       ;POINT TO TRACE DISK FLAG
        MOV     CH,[EDX]        ;GET TRACE DISK FLAG
        CMP     CH,1            ;CH  -- 0 OFF   BR IF TRACE DISK IS OFF
        JNZ     $TRACED4         ;       1 ON
        TEST    MODE,4000H      ;BR IF NOT LIST S
        JZ      $TRACED1
$TRACED4:
        POP     EDX
        RET

;* ------- disk trace -----------
;*    Save registers used
$TRACED1:
;       CALL    R@TEMP           ;EACH PARTITION HAS ONE TEMPORARY STORAGE AREA
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
;       CALL    WRTF5            ;SAVE F5-0
        MOV     AL,R5
        MOV     AH,R4
        MOV     [EDX],AX
        MOV     AL,R3
        MOV     AH,R2
        MOV     [EDX+2],AX
        MOV     AL,R1
        MOV     AH,R0
        MOV     [EDX+4],AX
        ADD     EDX,6
        MOV     EAX,AUX00        ;    TEMPORARAY AREA -----> 0  | F5             1
        MOV     [EDX],EAX        ;                           1  | F4             1
        ADD     EDX,4            ;                           2  | F3             1
        MOV     EAX,ACTDEV       ;                           3  | F2             1
        MOV     [EDX],EAX        ;                           4  | F1             1
        MOV     WORD PTR R4,AX   ;                           5  | F0             1
        ADD     EDX,4            ;                           6  | AUX00          4
        POP     EAX              ;                           10 | ACTDEV         4
        MOV     [EDX],EAX        ;                           14 | SECTOR ADDRESS 2
        MOV     EBX,DWORD PTR [A0]
        MOV     DWORD PTR [EDX+4],EBX ;                      18 | A0 A1
        MOV     AUX00,EAX
;       CALL    R@TEMP3          ;RESTORE R2 & R0
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        mov     cl,byte ptr [edx+3]
        mov     ch,byte ptr [edx+5]
;       ADD     EDX,3
;       MOV     CX,WORD PTR [EDX]
        MOV     R2,CL           ;R2 = EXTENDED COMMAND
        MOV     R0,CH           ;R0 = PRIMARY COMMAND
; OUTPUT FORMAT:
;                                   /taa hhhh ddddd hh
;                                     ^   ^     ^    ^
;                                     !   !     !    !-Partition
;                                     !   !     !------Sector address
;                                     !   !------------Disk command
;                                     !----------------Disk address

;*    Output disk address
        CALL    ENBLSCO         ;ENABLE SELECTED CO DEVICE
        CALL    CPRNTCR         ;OUTPUT CR IF NOT AT BEGIN OF LINE
        MOV     K,'/'
        CALL    TWRITE
        MOV     AL,R5           ;OUTPUT DISK ADDRESS IN R5 & R4
        AND     AL,0FH
        CALL    WRTHEXCH
        MOV     AL,R4
        SHR     AL,4
        CALL    WRTHEXCH
        MOV     AL,R4
        AND     AL,0FH
        CALL    WRTHEXCH
        CALL    TWRITESP
;*    Output disk command
        MOV     AL,R0
        SHR     AL,4        ;OUTPUT DISK COMMAND IN R0
        CALL    WRTHEXCH
        MOV     AL,R0
        AND     AL,0FH
        CALL    WRTHEXCH
        CMP     R0,20H
        JNZ     $TRACED2
;*    Output extended command
        MOV     AL,R2           ;OUTPUT EXTENDED COMMAND IN R2
        SHR     AL,4
        CALL    WRTHEXCH
        MOV     AL,R2
        AND     AL,0FH
        CALL    WRTHEXCH
        JMP     $TRACED3
;*    Output spaces
$TRACED2:
        CALL    TWRIT2SP
$TRACED3:
        CALL    TWRITESP
;*    Output sector address
        MOV     EDX,AUX00       ;GET SECTOR ADDRESS
        MOV     DWORD PTR A0,EDX
        CALL    $DWRTVAL32
;*    Output partition number
        CALL    TWRITESP
        MOV     CH,PART_
        ADD     CH,1            ;PART # FROM 1 TO 16
        CMP     CH,10           ;CONVERT TO DECIMAL IF > 9
        JB      $BP44_01
        ADD     CH,6
$BP44_01:
        MOV     R2,CH
        CALL    WRTLIN_2
        CALL    PRNTCR
;*    Re-enable disk device
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        ADD     EDX,10
        MOV     ECX,[EDX]
        MOV     ACTDEV,ECX
        MOV     EDX,ECX
        CALL    ENBLDEVD
;*    Restore registers
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@TRDSKW
        MOV     CX,[EDX]
        MOV     R5,CL
        MOV     R4,CH
        ADD     EDX,2
        MOV     CX,[EDX]
        MOV     R3,CL
        MOV     R2,CH
        ADD     EDX,2
        MOV     CX,[EDX]
        MOV     R1,CL
        MOV     R0,CH
        ADD     EDX,2
        MOV     ECX,[EDX]
        ADD     EDX,8
        MOV     AUX00,ECX         ;RESTORE AUX00
        MOV     ECX,[EDX]
        MOV     EDX,ECX           ;(E)DX = SECTOR ADDRESS
        MOV     EBX,DWORD PTR [EDX+4]
        MOV     DWORD PTR [A0],EBX
        RET
; ----------------- 22c11-2 ------------------


CODE    ENDS
        END
