;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M49
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    ICHECK
PUBLIC    ICLEAR
PUBLIC    IPOLL
PUBLIC    SLCTOFF
PUBLIC    SLCTON

EXTRN     CCL:NEAR
EXTRN     CCNL:NEAR
EXTRN     CPBASE:DWORD
EXTRN     DELAY10:NEAR
EXTRN     DEVSPEC:NEAR
EXTRN     ERROR:NEAR
EXTRN     ERROR_48:NEAR
EXTRN     ENBLNLLD:NEAR
EXTRN     GOSUBPI:NEAR
EXTRN     SLCTMORE:NEAR
EXTRN     TRLINE_:NEAR
EXTRN     VJUMP:NEAR

EXTRN     _ALERT:BYTE
extrn     B_ABS:BYTE

;         FILE = BPMVP49 ,12/08/1986
;         MODULE    MOD-49 SOFT INTERRUPT
;         TITLE     MODULE-49 SOFT INTERRUPT
;
;*     ***********************************
;*     *                                 *
;*     *  MODULE-49: SOFT INTERRUPT      *
;*     *                                 *
;*     ***********************************
;*
;*
;*     REFERENCED MODULES:
;         SYMBL     BPMVP00   SYSTEM EQUATES
;         SYMBL     BPMVP06   SUBROUTINES
;         SYMBL     BPMVP02   SYNTAX CHECKING
;         SYMBL     BPMVP04
;         SYMBL     BPMVP05   I/O SUBROUTINES
;         SYMBL     BPMVP01   PROGRAM CONTROL
;         SYMBL     BPMVP08
;         SYMBL     JLMVP32   MVP routines
;         SYMBL     BPMVP8D   Data Memory constants
;         SYMBL     BPMVP60
;         TITLE     INDEX
;*SLCTON   -- process SELECT ON statement
;*SLCTOFF  -- process SELECT OFF statement
;*IFIND    -- find specified device in interrupt table
;*ICLEAR   -- clear interrupt table
;*ICHECK   -- branch to interrupt routine if interrupt pending
;*IPOLL    -- poll for interrupts
;         TITLE     INTERRUPT SELECT ON/OFF
;
;*     SLCTON: PROCESS A 'SELECT' STATEMENT 'ON' PARAMETER
;*     SLCTOFF: PROCESS A 'SELECT' STATEMENT 'OFF' PARAMTR
;*
;*          FORMAT:  ON CLEAR
;*                   ON [/xyy [GOSUB line-number]]
;*                   OFF [/xyy [GOSUB line-number]]
;*
;*                       ALERT can be used instead of /xyy for signaling.
;*
;@3.0SLON EQU       *         file# added in Rel 3.0
;*                       Device address can also be specified by file#.
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'ON' OR 'OFF'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2 (AUXE in X-phase only)
;@3.0SLON: EQU       *         file# added in Rel 3.0
;*
;*          CS386      INTERRUPT TABLE :
;*
;*          STATUS     DEVICE ADDR      SUBROUTINE ADDR
;*          1 BYTE     1 BYTE           4 BYTE
;*
;*%----------------- SELECT ON CLEAR --------------------------------------------
SLCTON:   MOV       R0,@CLEAR
          CALL      CCL         ;LOOK FOR 'CLEAR'
          TEST      R0,0FH      ;BRANCH IF NOT FOUND
          JNZ       SLCTON1

;*     ON CLEAR  (REMOVE ALL INTERRUPTS)
;*
          TEST      SL,2        ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORX
          CALL      ICLEAR      ;CLEAR INTERRUPT TABLE
          JMP       SLCTMORE    ;RETURN TO SELECT STATEMENT PROCESSING

;*%----------------- SELECT ON/OFF device or alert ------------------------------
;*     ON [/xyy [GOSUB line-number]]
;*     OFF [/xyy [GOSUB line-number]]
;*
SLCTOFF:  CALL      DEVSPEC     ;look for /xyy or #n
          MOV       R5,1        ;FLAG = OFF
          JMP       SLCTON11

SLCTON1:  CALL      DEVSPEC     ;look for /xyy or #n
          MOV       R5,2        ;FLAG = ON

SLCTON11: TEST      R1,0F0H     ;branch if /xyy or #n not found
          JNZ       SLCTON12
          TEST      SL,XPHASE   ;branch if not execution phase
          JZ        SLCTON5
          MOV       AL,R0
          MOV       K,AL        ;SAVE DEVICE ADDRESS
          CMP       R0,0        ;error if address 00
          JE        ERR_48A

;*       Insert future check to allow MXD devices here.
          AND       R0,38H
          JNZ       SLCTON5
          TEST      K,0FH       ;ERROR IF MXD ADDRESS
          JNZ       ERR_48A
          JMP       SLCTON5

SLCTON12: MOV       EDX,OFFSET _ALERT
          CALL      CCNL        ;look for 'ALERT'
          MOV       K,0         ;ALERT value
          TEST      R0,0FH      ;branch if not found
          JNZ       SLCTON2

SLCTON5:  MOV       R0,@GOSUB
          CALL      CCL         ;LOOK FOR 'GOSUB'
          TEST      R0,0FH      ;NF, BRANCH
          JNZ       SLCTON3
          CALL      TRLINE_     ;LOOK FOR LINE NUMBER REFERENCE

          TEST      SL,2        ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORX
          MOV       DWORD PTR [A6],EDX  ;SAVE ADDRESS OF LINE TO TRANSFER TO IF INTERRPT
          CALL      IFIND       ;FIND PROPER POSITIONO IN INTERRUPT TABLE
          MOV       AL,R0
          AND       AL,0F0H
          CMP       AL,0F0H
          JNE       M49_01      ;BRANCH IF TABLE NOT FULL

ERROR_49: MOV       R0,49H      ;INTERRUPT TABLE FULL
          JMP       ERROR
M49_01:
          MOV       AL,R5       ;STATUS = ON OR OFF
          MOV       AH,K
          MOV       [EDX-1],AX  ;DEVICE ADDRESS ==> INTERRUPT TABLE
          MOV       EAX,DWORD PTR [A6]  ;SUBROUTINE ADDRESS ==> INTERRUPT TABLE
          MOV       DWORD PTR [EDX+1],EAX
          ADD       EDX,4

SLCTON4:  MOV       AL,R5
          AND       AL,0FH
          CMP       AL,2
          JNE       SLCTMORX    ;BRANCH IF NOT 'ON /xyy'
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH       ;READ STATUS BYTE
          OR        AL,ISTACT   ;FLAG = INTERRUPT ENABLED
          MOV       [EDX],AL
SLCTMORX: JMP       SLCTMORE

;*     ON /xyy   or   OFF /xyy
;*
SLCTON3:  TEST      SL,2        ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORX
          CALL      IFIND       ;FIND ENTRY IN INTERRUPT TABLE
          CMP       R0,0FFH     ;BRANCH IF TABLE FULL
          JE        ERR_48A
          TEST      R0,0FH
          JZ        ERR_48A     ;BRANCH IF ENTRY NOT FOUND
          MOV       AL,R5       ;STATUS = ON OR OFF
          MOV       [EDX-1],AL  ;STATUS = ON OR OFF
          JMP       SLCTON4
ERR_48A:  JMP       ERROR_48    ;ILLEGAL OR UNDEFINED DEVICE SPEC.

;*     GENERAL ON OR OFF
;*
SLCTON2:  TEST      SL,2        ;BRANCH IF NOT EXECUTION PHASE
          JZ        SLCTMORX
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH       ;READ STATUS BYTE
          AND       AL,0FBH
          MOV       R0,AL
          MOV       [EDX],AL    ;ACTIVATE ALL INTERRUPTS IF 'ON'
          MOV       AL,R5
          AND       AL,0FH
          CMP       AL,2
          JE        SLCTMORE
          MOV       AL,R0
          OR        AL,4        ;INHIBIT ALL INTERRUPTS IF 'OFF'
          MOV       [EDX],AL
          JMP       SLCTMORE

;         TITLE     INTERRUPT (IFIND)
;*     IFIND: FIND SPECIFIED DEVICE ENTRY IN INTERRUPT
;*            TABLE.
;*
;*          ENTRY: K = DEVICE ADDRESS
;*
;*          RETURN: F0 = FF IF NOT FOUND & TABLE FULL
;*                  F0 = 00 IF NOT FOUND & TABLE NOT FULL
;*                     PC'S POINT TO 2ND BYTE OF 1ST
;*                          UNUSED ENTRY.
;*                  F0 = ENTRY STATUS IF FOUND.
;*                     PC'S POINT TO 2ND BYTE OF ENTRY.
;*
;*          MODIFIED REGISTERS: PC'S,F0,CH,CL
;*
IFIND:                          ;PC'S = ADDRESS OF INTERRUPT TABLE
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ITABLE
          MOV       EBX,EDX
          ADD       EBX,96
IFIND2:   MOV       CX,[EDX]    ;GET STATUS / DEVICE-ADDRESS OF NEXT ENTRY
          XCHG      CH,CL
          INC       EDX
          MOV       R0,CH       ;F0 = ENTRY STATUS
          CMP       CH,0        ;BRANCH IF ENTRY NOT USED
          JE        IFIND1
          CMP       CL,K        ;BRANCH IF SPECIFIED DEVICE
          JE        IFIND1

          ADD       EDX,5       ;POINT TO NEXT ENTRY
          CMP       EDX,EBX     ;BRANCH IF MORE ENTRIES IN TABLE
          JB        IFIND2
          MOV       R0,0FFH     ;F0 = TABLE FULL
IFIND1:   RET

;         TITLE     INTERRUPT PROCESSING
;*%INTERRUPT TABLE
;*     ISTATUS (INTERRUPT STATUS REGISTER):
;*
;ISTACT   EQU       01
;*         BIT01 = 1 IFF at least 1 SELECT ON /xyy has been executed
;ISTSUB   EQU       02
;*         BIT02 = 1 IFF executing an interrupt subroutine
;ISTGINH  EQU       04
;*         BIT04 = 1 IFF general interrupt inhibit (SELECT OFF)
;ISTCHK   EQU       08
;*         BIT08 = 1 IFF interrupts already checked in this timeslice
;*                       (Interrupts are checked only once per timeslice)
;*
;ISTALRT  EQU       10
;ISTACT    EQU       01
;ISTSUB    EQU       02
;ISTGINH   EQU       04
;ISTCHK    EQU       08
;ISTALRT   EQU       10H
;ISTALRTH  EQU       1

;*         BIT10 = 1 IFF $ALERT condition has been raised by a $ALERT statement
;ISTALRTH EQU       1
;*
;*                   (Interrupt polling only done if BITS0F = 1)
;*
;*     ITABLE (INTERRUPT TABLE):
;*
;*          ENTRY1:  status  device-addr  transfer-address
;*          ENTRY2:  status  device-addr  transfer-address
;*            .
;*            .
;*            .
;*          ENTRY8:  status  device-addr  transfer-address
;*
;*          where: status (1 byte) = 00 if no entry
;*                                   01 if disabled (OFF)
;*                                   02 if enabled (ON)
;*                 device-addr (1byte)
;*                         00 reserved for ALERT interrupt
;*                 transfer-addr (2 bytes) = address of
;*                         line to transfer to when
;*                         interrupt processed.
;*
;*     NOTE: Coding depends upon interrupt table ending at the end of a 256 page.
;*
;*     NOTE: Coding depends upon interrupt status register (ISTATUS) immediately preceeding
;*           interrupt table (ITABLE) in memory.
;*
;         TITLE     INTERRUPT (ICLEAR)
;*     ICLEAR: CLEAR ALL INTERRUPT ENTRIES FROM INTERRUPT
;*             TABLE.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL
;*
ICLEAR:
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          PUSH      ECX
          MOV       ECX,96/4    ;ZERO INTERRUPT TABLE
ICLEARA:
          MOV       DWORD PTR [EDX],0
          ADD       EDX,4
          LOOP      ICLEARA
          POP       ECX
          RET                   ;we don't have any interrupt

;         TITLE     INTERRUPT (ICHECK)
;*     ICHECK: CHECK FOR INTERRUPTS (IF PROGRAM EXCUTION).
;*             TRANSFER TO INTERRUPT SUBROUTINE IF
;*                  DEVICE IS READY.
;*
;*          ENTRY:  (EXECUTION PHASE)
;*
;*          EXIT: (INTERRUPT FOUND, EXECUTION PHASE)
;*               @INTRPT OR @XSUBR ==> OS
;*               STMTCNT           ==> VS
;*               TEXTPTR           ==> VS
;*               TEXTLPTR          ==> VS
;*               XBASE,IBASE       ==> VS
;*               XBASE = CPBASE
;*               TRANSFER MADE TO INTERRUPT SUBROUTINE
;*
;*          MODIFIED REGISTERS: CH,CL,PH,PL,K,F1,F0
;*
ICHECK:                         ;GET INTERRUPT STATUS
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH
          AND       AL,0FH
          CMP       AL,ISTACT   ;BRANCH IF NO 'ON/xyy', GENERAL INHIBIT, OR
          JNZ       ICHECK1

;*_     IN INTERRUPT SUBROUTINE
;
          CALL      IPOLLx      ;interrupt pollinig
          TEST      R1,1        ;branch if pending interrupt
          JNZ       ICHECK3

;*      No interrupts pending
;
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH       ;Flag interrupts checked this timeslice
          OR        AL,ISTCHK
          MOV       [EDX],AL
          CALL      ENBLNLLD    ;disable all devices (ie, enable null)

ICHECK1:  JMP       VJUMP

;
;*     BRANCH TO INTERRUPT SUBROUTINE
;*
ICHECK3:  MOV       R0,CH       ;F0=Interrupting device; Form addr(adr(line to transfer to))
          INC       EDX
          MOV       ECX,[EDX]   ;GET ADDRESS OF LINE TO TRANSFER TO
          MOV       EDX,ECX
          MOV       AUX00,EDX   ;SAVE PTR TO LINE
          ADD       AUX00,4

          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@ISTATUS
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH
          OR        AL,ISTSUB+ISTCHK
          MOV       R1,AL       ;Flag: In interrupt subroutine, INTERRUPT SUBR.)
          MOV       [EDX],AL
          CMP       R0,0        ;Branch if not acknowledging $ALERT
          JNE       M49_03
          MOV       AL,R1
          AND       AL,0FFH-ISTALRT ;Turn off $ALERT
          MOV       R1,AL
          MOV       [EDX],AL
M49_03:
          CALL      ENBLNLLD    ;DISABLE ALL DEVICES (IE, ENABLE NULL)
          MOV       R0,@INTRPT+@XSUBRL    ;Value stack atom
          JMP       GOSUBPI     ;STACK RETURN INFO. & TRANSFER TO INT. SUBR.

;         TITLE     IPOLL
;*     IPOLL: poll for interrupts
;*
;*          ENTRY:
;*            PC's point to Interrupt Status Register
;*            CH = interrupt status, bits 0F = 1 (ie, interrupt processing active)
;*                                 , bit  10 = 1 iff ALERT interrupt pending
;*            Calling routine is responsible for checking bits ISTACT and ISTCHK
;*            before calling this routine.
;*
;*          RETURN:
;*               F1,bit 01 = 1 if interrupt pending & interrupt processing active
;*                   PC's point at 2nd byte of interrupt table entry
;*                   CH = Interrupting device
;*               F1,bit 01 = 0 if no interrupt pending or all interrupts disabled
;*
;*
;*          MODIFIED REGISTERS: CH,CL,PH,PL,K,F1
;*
IPOLL:
          MOV       R1,CH       ;F1 = interrupt status; Point to interrupt table
        lea     ebx,[edx].@iobuffr      ;The ending address of @ITABLE
        lea     edx,[edx].@itable
        jmp     ipoll5

IPOLLx:
          MOV       R1,CH       ;F1 = interrupt status; Point to interrupt table
          INC       EDX
          MOV       EBX,EDX
          ADD       EBX,96

;*%=============== check status of next entry in interrupt table ================
IPOLL5:   MOV       CX,[EDX]    ;GET STATUS OF NEXT ENTRY
          XCHG      CH,CL
          INC       EDX
          TEST      CH,2        ;BRANCH IF NOT ENABLED
          JZ        IPOLL2

;*%=============== check for ALERT (task interrupt) =============================
          CMP       CL,0        ;branch if device
          JNE       IPOLL6
          TEST      R1,10H      ;branch if no ALERT  ISTALRTH = 01H
          JZ        IPOLL2

;*%=============== interrupt pending return =====================================
IPOLL3:   MOV       CX,[EDX]
          XCHG      CH,CL
          RET

;*%=============== check for device READY (interrupt) ===========================
IPOLL6:   MOV       K,CL                    ;K = DEVICE ADDRESS
          MOV       BYTE PTR FS:[_ABS],CL   ;ENABLE DEVICE
          mov       B_ABS,cl

          CALL      DELAY10                 ;DELAY 5 USEC.
          TEST      BYTE PTR FS:[CPUST],8   ;BRANCH IF DEVICE READY (INTERRUPT)
          JNZ       IPOLL3

;*%=============== check for more interrupt table entries =======================
IPOLL2:   TEST      CH,3        ;BRANCH IF ENTRY NOT DEFINED
          JZ        IPOLL4
          ADD       EDX,5       ;POINT TO NEXT ENTRY
          CMP       EDX,EBX     ;BRANCH IF MORE ENTRIES
          JB        IPOLL5

;*%=============== no interrupts return =========================================
IPOLL4:   MOV       R1,0        ;no interrupts
          RET

CODE      ENDS
          END

