;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M50
;===========================================================================
	    .XLIST
	    INCLUDE PREAMBLE
	    .LIST

PUBLIC    GETDIM
PUBLIC    GETDIMA
PUBLIC    MAT
PUBLIC    MATADD
PUBLIC    MATCON
PUBLIC    MATDIM
PUBLIC    MATEQU
PUBLIC    MATEQUAL
PUBLIC    MATLET
PUBLIC    MATMPY
PUBLIC    MATIDN
PUBLIC    MATINPUT
PUBLIC    MATINV
PUBLIC    MATINV30
PUBLIC    MATINV61
PUBLIC    MATINV81
PUBLIC    MATPRINT
PUBLIC    MATREAD
PUBLIC    MATREDIM
PUBLIC    MATSMPY
PUBLIC    MATSUB
PUBLIC    MATTRN
PUBLIC    MATVAR
PUBLIC    MATVAR$
PUBLIC    MATZER
PUBLIC    NAMECHK
PUBLIC    REDIM
PUBLIC    REDIM$
PUBLIC    SWTCHCOL
PUBLIC    SWTCHROW

EXTRN     @LETTER :NEAR
EXTRN     ADDVAR  :NEAR
EXTRN     BREAKPTQ:NEAR
EXTRN     CCJB    :NEAR
EXTRN     CCL     :NEAR
EXTRN     CPRNTCR :NEAR
EXTRN     CURLEN  :NEAR
EXTRN     DIGIT   :NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_04:NEAR
EXTRN     ERROR_10:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     ERROR_26:NEAR
EXTRN     ERROR_27:NEAR
EXTRN     ERROR_50:NEAR
EXTRN     ERROR_59:NEAR
EXTRN     ERROR_99:NEAR
EXTRN     ERR_02  :NEAR
EXTRN     ERR_01  :NEAR
EXTRN     EXPR    :NEAR
EXTRN     FINDVAR :NEAR
EXTRN     FLTBIN  :NEAR
EXTRN     GETDATA :NEAR
EXTRN     GETINPUT:NEAR
EXTRN     IMMEDERR:NEAR
EXTRN     INPUTA  :NEAR
EXTRN     LISTVAR :NEAR
EXTRN     MATCOPY :NEAR
EXTRN     MATHADD1:NEAR
EXTRN     MATHADD2:NEAR
EXTRN     MATHCMP1:NEAR
EXTRN     MATHDIV1:NEAR
EXTRN     MATHDIV2:NEAR
EXTRN     MATHERR :NEAR
EXTRN     MATHMUL1:NEAR
EXTRN     MATHMUL2:NEAR
EXTRN     MATHSQR :NEAR
EXTRN     MATHSUB2:NEAR
EXTRN     MATMOVE :NEAR
EXTRN     MERGE   :NEAR
EXTRN     MVSCRTCH:NEAR
EXTRN     NEXTVAR :NEAR
EXTRN     NXTCHEOS:NEAR
EXTRN     PRINTBEG:NEAR
EXTRN     PRINTEND:NEAR
EXTRN     PRINTVA :NEAR
EXTRN     PRNTCR  :NEAR
EXTRN     SCRATCH :NEAR
EXTRN     SEARCH  :NEAR
EXTRN     SORT    :NEAR
EXTRN     SQZTEXT :NEAR
EXTRN     TWRITESP:NEAR
EXTRN     VARNAMEB:NEAR
EXTRN     VARR    :NEAR
EXTRN     VVFMTA  :NEAR
EXTRN     _MATFLST:NEAR
EXTRN     _MATLST :NEAR

EXTRN     @@VSEND :DWORD
EXTRN     @@OSEND :DWORD
EXTRN     CPBASE  :DWORD


;------------------------------------------------------------------------------;
;                                                                              ;
;      ************************************                                    ;
;      *                                  *                                    ;
;      *     MOD50: SCIENTIFIC MATRIX     *                                    ;
;      *                                  *                                    ;
;      ************************************                                    ;
;                                                                              ;
;      DESCRIPTION:                                                            ;
;           DECODES A MAT STATEMENT AND                                        ;
;                1. PROCESSES MAT STATEMENT                                    ;
;                     MAT c = ...                                              ;
;                     MAT PRINT           MAT READ                             ;
;                     MAT INPUT           MAT REDIM                            ;
;                                                                              ;
;           OR   2. BRANCH TO SORT PACKAGE                                     ;
;                     MAT SEARCH          MAT COPY                             ;
;                     MAT SORT            MAT MERGE                            ;
;                     MAT CONVERT         MAT MOVE                             ;
;                                                                              ;
;------------------------------------------------------------------------------;



;      MAT: DECODE A MAT STATEMENT & BRANCH TO THE
;           APPROPRIATE ROUTINE.  ASSUMES KEYWORDS
;           ARE ALL ATOMIZED IN ENTRY PHASE.
;
;

MAT:     MOV       EDX,OFFSET _MATLST   ;GET ADDRESS OF MAT KEYWORD LIST
	 CALL      CCJB                 ;LOOK FOR MAT KEYWORD
	 JMP       MATCOPY              ;MAT COPY
	 JMP       SEARCH               ;MAT SEARCH
	 JMP       SORT                 ;MAT SORT
	 JMP       MERGE                ;MAT MERGE
	 JMP       MATMOVE              ;MAT MOVE
	 JMP       MATMOVE              ;MAT CONVERT
	 JMP       MATPRINT             ;MAT PRINT
	 JMP       MATREAD              ;MAT READ
	 JMP       MATREDIM             ;MAT REDIM
	 JMP       MATINPUT             ;MAT INPUT

;      MATLET: DECODE A MAT LET STATEMENT
;
;           FORMATS:
;
;                MAT c = CON...          MATCON
;                MAT c = IDN...          MATIDN
;                MAT c = ZER...          MATZER
;                MAT c = INV...          MATINV
;                MAT c = TRN...          MATTRN
;                MAT c = (...            MATSMPY
;                MAT c = a +...          MATADD
;                MAT c = a -...          MATSUB
;                MAT c = a *...          MATMPY
;                MAT c = a               MATEQU
;
;           ENTRY: TEXTPTR POINTS AFTER 'MAT'
;
;           EXIT: BRANCH TO ROUTINE SPECIFIED ABOVE.
;                TEXTPTR POINTS AFTER POINT SHOWN ABOVE.
;                AUX3 = ADDRESS OF DIMS OF ARRAY c IN
;                       SYMBOL TABLE (R & X PHASES ONLY)
;                AUX4 = NAME & TYPE OF ARRAY c
;                AUX5 = ADDRESS OF DIMS OF ARRAY a
;                       (R & X PHASES ONLY)
;                AUX6 = NAME & TYPE OF ARRAY a
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-7,AUX0,3-6


MATLET:  CALL      MATVAR               ;SCAN & PROCESS MATRIX c
	 MOV       AUX03,EDX            ;AUX3 = ADDR OF DIMS OF MAT C
	 MOV       AX,WORD PTR [R2]     ;
	 MOV       AUX04,EAX            ;AUX04 = NAME & TYPE OF MAT C
	 CMP       BYTE PTR [TEXTPTR],'='   ;LOOK FOR '='
	 JNE       ERROR_12
	 INC       TEXTPTR
	 CMP       BYTE PTR [TEXTPTR],'('   ;LOOK FOR '('
	 JNE       MATSMPZ
	 INC       TEXTPTR
	 JMP       MATSMPY              ;BR, IF F
MATSMPZ: MOV       EDX,OFFSET _MATFLST  ;GET ADDRS OF MAT LET KEYWORD LIST
	 CALL      CCJB                 ;LOOK FOR MATLET KEYWORD
	 JMP       MATZER               ;MAT c = ZER
	 JMP       MATCON               ;MAT c = CON
	 JMP       MATIDN               ;MAT c = IDN
	 JMP       MATINV               ;MAT c = INV
	 JMP       MATTRN               ;MAT c = TRN

;  DECODE MAT ADD,SUB,MPY, & EQU
;

MATLET4: CALL      MATVAR               ;SCAN & PROCESS MAT a
	 MOV       AUX05,EDX            ;AUX05 = ADDR OF DIMS OF MAT A
	 MOV       AX,WORD PTR [R2]     ;
	 MOV       AUX06,EAX            ;AUX06 = NAME & TYPE OF MAT A
	 MOV       CH,BYTE PTR [TEXTPTR];GET NEXT CHAR
	 INC       TEXTPTR
	 TEST      CH,20H               ;BR, IF NOT *, -, +
	 JZ        MATLET8
	 CMP       CH,2AH               ;BR, IF '*'
	 JE        MATMPY
	 CMP       CH,2BH               ;BR, IF '+'
	 JE        MATADD
	 CMP       CH,2DH               ;BR, IF '-'
	 JE        MATSUB
MATLET8: DEC       TEXTPTR              ;DECREMENT TEXTPTR
	 JMP       MATEQU

;      MATCON: PROCESS A MAT CON STATEMENT
;      MATIDN: PROCESS A MAT IDN STATEMENT
;      MATZER: PROCESS A MAT ZER STATEMENT
;
;           FORMAT:
;                        CON
;                MAT c = IDN [(expression [,expression)]]
;                        ZER
;
;                IF IDN, MATRIX MUST BE SQUARE.
;
;         ENTRY: TEXTPTR POINTS AFTER 'CON','IDN',OR 'ZER'
;
;           REGISTER USE:
;                AUX3 = POINTER TO ARRAY c
;                AUX4,BITS FFF0 = NAME OF ARRAY c
;                    ,BITS 0006 = TYPE OF ARRAY c
;                                 01 IF 1-DIMENSIONAL
;                                 11 IF 2-DIMENSIONAL
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2,3,4
;

MATCON:  CALL      MATDIM               ;PROCESS REDIMENSION EXPRESSION
	 MOV       R7,1                 ;FLAG = CON
	 JMP       MATZER1              ;

MATIDN:  CALL      MATDIM               ;PROCESS REDIMENSION EXPRESSION
	 MOV       R7,2                 ;FLAG = IDN
	 JMP       MATZER1              ;

MATZER:  CALL      MATDIM               ;PROCESS REDIMENSION EXPRESSION
	 MOV       R7,0                 ;FLAG = ZER

MATZER1: TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATZER5              ;
	 MOV       EDX,AUX04            ;GET TYPE OF ARRAY
	 CMP       R7,2                 ;BR, IF NOT IDN
	 JNE       MATZER2              ;
	 TEST      DL,4                 ;BR, IF 1-DIMENSINAL
	 JZ        MATZER3              ;
	 MOV       EAX,ECX
	 SHR       EAX,16
	 CMP       AX,CX                ;ERROR, IF MATRIX NOT SQUARE
	 JNE       ERROR_44             ;

MATZER6: MOV       A6,CX                ;SAVE DIM

MATZER2: MOV       EAX,ECX
	 MOV       DWORD PTR [A0],ECX   ;F1,0 = DIM(S)
	 TEST      DL,4                 ;BR, IF 1-DIMENSIONAL
	 JZ        MATZERX
	 SHR       EAX,16
	 MOV       EBX,ECX
	 AND       EBX,0FFFFH
	 PUSH      EDX
	 MUL       EBX                  ;AX = DIM1 * DIM2 (NO. OF ELEMENTS)
	 POP       EDX
	 MOV       DWORD PTR [A0],EAX   ;F1,0 = NO. OF ELEMENTS

MATZERX: MOV       EDX,AUX03            ;POINT TO ARRAY
	 MOVZX     AX,R7                ;F2 = 0 IF IDN OR ZER, = 1 IF CON
	 AND       AX,1
	 MOV       A2,AX

MATZER4: MOV       WORD PTR [EDX],0     ;EXPONENT
	 MOV       WORD PTR [EDX+2],AX  ;LOWER MANTISSA
	 MOV       DWORD PTR [EDX+4],0  ;HIGH MANTISSA
	 ADD       EDX,8                ;ADVANCE TO NEXT ELEMENT OF MAT

	 DEC       DWORD PTR [A0]       ;DECREMENT ELEMENT COUNT
	 JNZ       MATZER4              ;BR, IF MORE ELEMENTS IN ARRAY
	 CMP       R7,2                 ;BR, IF NOT IDN
	 JNE       MATZER5

;      IDN: SET ELEMENTS ON MAIN DIAGONAL = 1
;
	 MOV       EDX,AUX03            ;PT TO BEG OF ARRAY
	 MOVZX     ECX,A6               ;GET DIM
	 MOV       EAX,ECX              ;
	 INC       EAX                  ;AL = DIM +1
	 SHL       EAX,3                ;EAX = 8 * (DIM+1)

MATIDN1: MOV       WORD PTR [EDX+2],1   ;ELEMENT ON MAIN DIAGONAL = 1
	 ADD       EDX,EAX              ;EDX PT TO NEXT ELEMENT ON DIAGONAL
	 DEC       CX                   ;DECREMENT COUNT (ROW NO.)
	 JNZ       MATIDN1              ;BR, IF COUNT > 0

MATZER5: JMP       ENDSTMTZ             ;EXIT

MATZER3: CMP       ECX,1                ;BR, IF DIM = 1
	 JE        MATZER6

ERROR_44:MOV       R0,44H               ;MATRIX NOT SQUARE
	 JMP       ERROR


;      MATEQU: PROCESS MAT EQUAL STATEMENT
;
;           FORMAT: MAT c = a
;
;           ENTRY: TEXTPTR POINTS AFTER 'a'
;             IN EXECUTION PHASE,
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;                AUX4 = NAME & TYPE OF MAT c
;                AUX5 = ADDRESS OF DIM(S) OF MAT a
;                AUX6 = NAME & TYPE OF MAT a
;
;           MODIFIED REGISTERS: ALL,AUX0,3-6
;

MATEQU:  TEST      SL,2                ;BR, IF NOT XPHASE
	 JZ        MATEQU1             ;
	 CALL      GETDIM              ;F2,1 = DIM1 OF MAT a; F0 = DIM2 OF MAT a
	 CALL      MATEQUAL            ;MAT c = MAT a
MATEQU1: JMP       ENDSTMTZ


;      MATEQUAL: MAT c = MAT a
;
;           ENTRY: EXECUTION PHASE
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;                AUX4 = NAME & TYPE OF MAT c
;                AUX5 = ADDRESS OF DIM(S) OF MAT a
;                AUX6 = NAME & TYPE OF MAT a
;
;           MODIFIED REGISTERS: ALL,AUX3
;

MATEQUAL:MOV       EDX,AUX04            ;GET NAME & TYPE OF MAT C
	 MOV       WORD PTR [R6],DX
	 MOV       EDX,AUX06            ;GET NAME & TYPE OF MAT A
	 CMP       DX,WORD PTR [R6]     ;BR, IF MAT A, C HAS SAME NAMES
	 JE        MATEQUL1

MATEQX1: CALL      REDIM                ;REDIMENSION MAT c TO DIM(S) OF MAT a
	 MOV       ECX,DWORD PTR [A6]   ;CX = DIM(S)
	 MOV       DWORD PTR [A0],ECX
	 MOV       EAX,ECX
	 TEST      K,4                  ;BR, IF MAT C IS 1-DIMENSIONAL
	 JZ        MATEQUX              ;
	 SHR       EAX,16
	 MOV       EBX,ECX
	 AND       EBX,0FFFFH
	 PUSH      EDX
	 MUL       EBX                  ;AX = DIM1 * DIM2 (NO. OF ELEMENTS)
	 POP       EDX
	 MOV       DWORD PTR [A0],EAX
MATEQUX: MOV       EDX,AUX05            ;EDX PT TO MAT A
					;AUX05 PT AFETR DIM OF MAT A (GETDIM)
	 MOV       EBX,AUX03            ;EBX PT TO MAT C
MATEQU2: MOV       ECX,DWORD PTR [EDX]  ;
	 MOV       DWORD PTR [EBX],ECX  ;
	 MOV       ECX,DWORD PTR [EDX+4];
	 MOV       DWORD PTR [EBX+4],ECX;
	 ADD       EBX,8                ;PT TO NEXT ELEMENT OF C
	 ADD       EDX,8                ;PT TO NEXT ELEMENT OF A
	 DEC       DWORD PTR [A0]       ;DECREMENT COUNTER
	 JNZ       MATEQU2              ;BR, IF MORE ELEMENT

MATEQUL1:RET


;      MATSMPY: PROCESS A MAT SCALAR MULTIPLY STATEMENT
;
;           FORMAT: MAT c = (expression) * a
;
;           ENTRY: TEXTPTR POINTS AFTER '('
;             IN EXECUTION PHASE,
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;                AUX4 = NAME & TYPE OF MAT c
;
;           MODIFIED REGISTERS: ALL,AUX0,3-5
;                IN RESOLUTION & EXECUTION, AUX1,2,8,9,B
;

MATSMPY: CALL      EXPR                 ;SCAN & EVALUATE EXPRESSION
	 CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
	 JNE       ERROR_10                ;ERROR, IF NF
	 INC       TEXTPTR
	 CMP       BYTE PTR [TEXTPTR],'*'  ;LOOK FOR '*'
	 JNE       ERROR_14                ;ERROR, IF NF
	 INC       TEXTPTR
	 CALL      MATVAR               ;SCAN & PROCESS MAT a
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATADD1              ;
	 MOV       CX,WORD PTR [EDX]    ;GET DIM OF MAT A
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 MOV       AUX0A,EDX
	 ADD       AUX0A,4              ;AUX0A = ADDRESS OF MAT a
	 CALL      GETDIMA              ;F2,1 = DIM1, F0 = DIM2
	 MOV       K,2                  ;FLAG = SCALAR MULTIPLY
	 MOV       EDX,VSPTR            ;
	 MOV       AUX0B,EDX            ;AUXB PT AT SCALAR MULTIPLIER
	 ADD       EDX,8
	 XCHG      EDX,VSPTR
	 JMP       MATADDA              ;

ERROR_14:MOV       R0,14H               ;MISSING '*'
	 JMP       ERROR

;      MATADD: PROCESS A MAT ADDITION STATEMENT
;      MATSUB: PROCESS A MAT SUBTRACTION STATEMENT
;
;           FORMAT: MAT c = a + b
;                   MAT c = a - b
;
;           ENTRY: TEXTPTR POINTS AFTER '+' OR '-'
;             IN EXECUTION PHASE,
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;                AUX4 = NAME & TYPE OF MAT c
;                AUX5 = ADDRESS OF DIM(S) OF MAT a
;                AUX6 = NAME & TYPE OF MAT a
;
;           REGISTER USE:
;                AUX5 = BREAKPT COUNT
;                AUXA = PTR OT MAT a
;                AUXB = PTR TO MAT b (OR TO SCALAR FOR
;                       MAT SCALAR MULTIPLY)
;                AUXC = PTR TO MAT c
;                AUXD,BITS000F = 0 IF ADD
;                                1 IF SUBTRACT
;                                2 IF SCALAR MULITPLY
;                AUXE = ELEMENT COUNT
;
;           MODIFIED REGISTERS: ALL,AUX0,3-6
;                IN EXECUTION, AUX1,2,A-E
;

MATSUB:  MOV       K,1                  ;FLAG = SUBTRACT
	 JMP       MATADDX              ;

MATADD:  MOV       K,0                  ;FLAG = ADD

MATADDX: CALL      MATVAR               ;SCAN & PROCESS MAT B
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATADD1              ;
	 MOV       CX,WORD PTR [EDX]    ;CH,CL = DIM(S)
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 MOV       AUX0B,EDX
	 ADD       AUX0B,4              ;AUX0B = ADDRESS OF MAT b
	 CALL      GETDIMA              ;F2,1 = DIM1, F0 = DIM2 OF MAT b
	 MOV       EDX,AUX05
	 MOV       CX,WORD PTR [EDX]    ;CH,CL = DIM(S)
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 MOV       AUX0A,EDX
	 ADD       AUX0A,4              ;AUX0A = ADDRESS OF MAT a
	 MOV       EDX,AUX06
	 TEST      DL,4
	 JZ        MATADD2              ;BR, IF MAT a IS 1-DIMENSIONAL
	 CMP       A2,0
	 JNE       ERROR_45             ;ERROR, IF MAT b DIM1 > 65535
	 CMP       DWORD PTR [A0],ECX
	 JNE       ERROR_45             ;ERROR, IF MAT a DIM <> MAT b DIM

MATADDA: MOV       DL,K
	 MOV       AUX0D,EDX            ;SAVE OPERATION FLAG
	 CALL      REDIM                ;REDIMENSION MAT C = DIM(S) OF MAT A
					;(AUX 3,4 SET UP ON ENTRY)
	 MOV       AUX0C,EDX            ;
	 ADD       AUX0C,4              ;AUXC = 1ST ELEMENT OF MAT C
	 MOV       EAX,DWORD PTR [A6]   ;F7,6 = DIM(S)
	 MOV       DWORD PTR [A0],EAX

	 TEST      K,4                  ;BR, IF MAT C IS 1-DIMENSIONAL
	 JZ        MATADDY
	 MOVZX     EBX,AX
	 SHR       EAX,16
	 PUSH      EDX
	 MUL       EBX
	 POP       EDX
	 MOV       DWORD PTR [A0],EAX
MATADDY: MOV       EDX,DWORD PTR [A0]     ;DX = NO. OF ELEMENTS

;  PERFORM OPERATION
;

MATADD6: MOV       AUX0E,EDX
	 DEC       AUX0E                ;DECREMENT ELEMENT COUNT
	 MOV       EDX,AUX0A
	 MOV       AUX01,EDX            ;AUX01 POINTS TO ELEMENT OF MAT a
	 MOV       EDX,AUX0D
	 MOV       K,DL                 ;K = OPERATION FLAG
	 MOV       EDX,AUX0B            ;PC'S POINT TO ELEMENT OF MAT b
	 TEST      K,0FH                ;BR, IF OPERATION NOT ADD
	 JNZ       MATADD3              ;
	 CALL      MATHADD2             ;ELEMENT A + ELEMENT B -> ELEMENT C
MATADD4: CALL      MATHERR              ;CHK FOR MATH ERRORS
	 MOV       DWORD PTR [A0],8     ;ELEMENT LENGTH = 8
	 ADD       AUX0B,8              ;EDX PT TO NEXT ELEMENT OF B
	 MOV       EDX,AUX0B

MATADD5: TEST      BYTE PTR FS:[CPUST],10H  ;BR, IF < 30 MS ELAPSED
	 JZ        MATADD5A             ;< 30 MS
	 MOV       R0,SAV0A             ;FLAG TO SAVE AUX A-F, & SHSL
	 CALL      BREAKPTQ             ;GIVE NEXT USER A CHANCE
	 MOV       DWORD PTR [A0],8     ;RESTORE ELEMENT LENGTH

MATADD5A:ADD       AUX0A,8              ;PT TO NEXT ELEMENT OF A
	 ADD       AUX0C,8              ;PT TO NEXT ELEMENT OF C
	 MOV       EDX,AUX0C
	 MOV       AUX03,EDX            ;SAVE ALSO IN AUX 3 FOR CALLS TO MATH ROUTINE
	 MOV       EDX,AUX0E
	 CMP       EDX,0
	 JNE       MATADD6              ;BR, IF MORE ELEMENTS

MATADD1: JMP       ENDSTMTZ

MATADD3: CMP       K,1                  ;BR, IF NOT SUBTRACT
	 JNE       MATADD7              ;
	 CALL      MATHSUB2             ;ELEMENT A - ELEMENT B -> ELEMENT C
	 JMP       MATADD4              ;

MATADD7: CALL      MATHMUL2             ;(SCALAR) * ELEMENT a ==> ELEMENT c
	 CALL      MATHERR              ;CHECK FOR MATH ERRORS
	 MOV       DWORD PTR [A0],8     ;ELEMENT LENGTH = 8
	 JMP       MATADD5

;  END OF OPERATION
;

MATADD2: CMP       ECX,DWORD PTR [A1]   ;BR, IF DIM OF MAT A <> DIM MAT B
	 JNE       ERROR_45             ;
	 CMP       A0,1                 ;ERROR IF DIM2 OF MAT B <> 1
	 JE        MATADDA              ;

ERROR_45:MOV       R0,45H               ;MATRIX OPERANDS NOT COMPATIBLE
	 JMP       ERROR


;      MATTRN: PROCESS A MAT TRN STATEMENT
;
;           FORMAT:  MAT c = TRN(a)
;
;                WHERE: NAME OF MAT c <> NAME OF MAT a
;
;           DESCRIPTION:
;                FOR I=1 TO N: FOR J=1 TO M
;                     C(I,J)=A(J,I)
;                NEXT J: NEXT I
;
;           ENTRY: TEXTPTR POINTS AFTER 'TRN'
;                  AUX4,BITS FFF0 = NAME OF MAT c
;               IN EXECUTION PHASE,
;                  AUX4,BITS 000F = TYPE OF ARRAY c
;                  AUX3 = ADDRESS OF DIM(S) OF MAT c
;
;           REGISTER USE:
;                F2,1 = 0008 (ELEMENT LENGTH)
;                F4,3 = DISPLACEMENT IN MAT a TO NEXT
;                       ELEMENT IN CURRENT COLUMN OF a
;                       ( 8 * DIM2 -1 OF MAT a )
;                F5 = COLUMN COUNT
;                F6 = DIM2 OF MAT c
;                F7 = ROW COUNT (INITIALLY DIM1 OF MAT c)
;                AUX3 = PTR TO MAT c
;                AUX4 = NAME & TYPE OF MAT c
;                AUX5 = PTR TO CURRENT COLUMN OF MAT a
;                AUX6 = NAME & TYPE OF MAT a
;
;           MODIFIED REGISTERS: ALL,AUX0,3-6
;

MATTRN:  CALL      MATVAR               ;SCAN & PROCESS MAT a
	 MOV       AUX05,EDX            ;AUX5 = ADDRESS OF DIM(S) OF MAT A
	 MOV       DX,WORD PTR [R2]
	 MOV       AUX06,EDX            ;AUX6 = NAME & TYPE OF MAT A
	 MOV       EDX,AUX04

	 CALL      NAMECHK              ;ERROR, IF NAME OF A AND C ARE SAME

	 CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
	 JNE       ERROR_11
	 INC       TEXTPTR
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATTRN2              ;
	 CALL      GETDIM
	 CMP       A2,0                 ;ERROR IF DIM1 > 65535
	 JNE       ERR_50A              ;
	 MOV       AX,A0                ;
	 MOV       A2,AX
	 MOV       EAX,DWORD PTR [A1]
	 MOV       DWORD PTR [A0],EAX     ;EXCHANGE DIM1 & DIM2
	 MOV       A2,0                 ;

	 CALL      REDIM                ;REDIMEN MAT c (DIM1 = DIM2 OF MAT a)
					; (DIM2 = DIM1 OF MAT a)
	 TEST      K,4                  ;BR, IF MAT C IS 2-DIMENSIONAL
	 JNZ       MATTRNX              ;
	 MOV       AX,A6                ;GET DIM1
	 MOV       A7,AX                ;F7 = DIM1
	 MOV       A6,1                 ;F6 (DIM2) 1
MATTRNX: MOVZX     EAX,A7
	 SUB       EAX,1
	 SHL       EAX,3                ;EAX = 8 * (DIM2-1  OF MAT A)
	 MOV       DWORD PTR [A3],EAX
	 MOV       DWORD PTR [A1],8     ;ELEMENT LENGTH = 8

;  PERFORM TRANSPOSE
;

MATTRN3: MOV       AX,A6                ;COLUMN COUNT = DIM2 OF MAT C
	 MOV       A5,AX                ;
	 MOV       EDX,AUX05            ;PC PT TO CURRENT COLUMN OF MAT A
	 ADD       EDX,8                ;AUX5 PT TO NEXT COLUMN OF MAT A
	 XCHG      EDX,AUX05

;      CURRENT ROW OF MAT c = CURRENT COLUMN OF MAT a
;

MATTRN4: MOV       EBX,AUX03
	 MOV       ECX,DWORD PTR [EDX]
	 MOV       DWORD PTR [EBX],ECX
	 MOV       ECX,DWORD PTR [EDX+4]
	 MOV       DWORD PTR [EBX+4],ECX
	 ADD       EDX,8                ;PT TO NEXT ELEMENT OF C
	 ADD       AUX03,8              ;PT TO NEXT ELEMENT OF A
	 ADD       EDX,DWORD PTR [A3]
	 DEC       A5                   ;DECREMENT COUNTER
	 JNZ       MATTRN4              ;BR, IF COUNT > 0

;      ROW COMPLETE
;

	 DEC       A7                   ;DECREMENT ROWS COUNT
	 CMP       A7,0                 ;BR, IF MORE ROWS IN MAT C
	 JNE       MATTRN3

MATTRN2: JMP       ENDSTMTZ


;      MATMPY: PROCESS A MAT MULTIPLY STATEMENT
;
;           FORMAT: MAT c = a * b
;
;                WHERE: NAME OF MAT c <> NAME OF MAT a
;                       NAME OF MAT c <> NAME OF MAT b
;
;           DESCRIPTION:
;                 C(I,J)=A(I,1)*B(1,J)+...+A(I,N)*B(N,J)
;             THAT IS,
;                A1 = DIM1 OF MAT a
;                A2 = DIM2 OF MAT a
;                B2 = DIM2 OF MAT b
;                FOR I = 1 TO A1
;                     FOR J = 1 TO B2
;                          C(I,J) = 0
;                          FOR K = 1 TO A2
;                              C(I,J)=C(I,J)+A(I,K)*B(K,J)
;                          NEXT K
;                     NEXT J
;                NEXT I
;
;           ENTRY: TEXPTR POINTS AFTER '*'
;                AUX4,BITS FFF0 = NAME OF MAT c
;                AUX6,BITS FFF0 = NAME OF MAT a
;             IN EXECUTION PHASE,
;                AUX4,BITS 000F = TYPE OF ARRAY c
;                AUX6,BITS 000F = TYPE OF ARRAY a
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;                AUX5 = ADDRESS OF DIM(S) OF MAT a
;
;           REGISTER USE:
;                F7,F6 = CONSTANT 0008 (ELEMENT LENGTH)
;                AUXE = PTR TO MAT c
;                AUXF = PTR TO BEGIN OF CURRENT ROW OF a
;                AUX6 = PTR TO CURRENT ELEMENT OF MAT a
;
;                AUX7 = PTR TO BEGIN OF MAT b
;                AUX8 =PTR TO BEGIN OF CURRENT COLUMN OF b
;                AUX9 = PTR TO CURRENT ELEMENT OF MAT b
;                AUXD = DISPLACEMENT TO NEXT ELEMENT IN
;                       CURRENT COLUMN OF MAT b
;                       ( 8 * (DIM2 OF MAT b) )
;
;                AUXA,BITS FF00 = DIM2 OF MAT a (=DIM1 b)
;                    ,BITS 00FF = SUM COUNT (=DIM2 OF a)
;                AUXB,BITS FF00 = DIM2 OF MAT c
;                    ,BITS 00FF = COLUMN COUNT (=DIM2 c)
;                AUXC,BITS 00FF = ROW COUNT (=DIM1 OF c)
;
;           MODIFIED REGISTERS: ALL,AUX0,3-7
;                IN EXECUTION PHASE, AUX1,2,6-F
;

MATMPY:  CALL      MATVAR               ;SCAN & PROCESS MAT B
	 MOV       AUX07,EDX            ;SAVE PTR TO DIM(S) OF MAT B
	 MOV       Al,R2
	 MOV       R5,AL                ;F5 = TYPE OF MAT B
	 MOV       EDX,AUX04
	 CALL      NAMECHK              ;ERROR, IF TWO MAT HAS SAME NAME
	 MOV       EDX,AUX06
	 MOV       WORD PTR [R2],DX
	 MOV       EDX,AUX04
	 CALL      NAMECHK              ;ERROR, IF TWO MAT HAS SAME NAME
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATMPY1
	 CALL      GETDIM               ;GET DIM(S) OF MAT a (AUX 5,6 SET UP ON ENTRY)
	 MOV       EAX,DWORD PTR [A0]     ;SAVE DIM(S) OF MAT A
	 MOV       DWORD PTR [A6],EAX     ;F7,6 = DIM(S) OF MAT A
	 MOVZX     EAX,A0
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX
	 MOV       AUX0A,EDX            ;SAVE DIM2 OF MAT a
	 MOV       EDX,AUX05            ;PTR OF 1ST ROW OF MAT A
	 MOV       AUX0F,EDX            ;SAVE IT
	 MOV       EDX,AUX07            ;AUX7 = PTR TO MAT B
	 MOV       CX,WORD PTR [EDX]    ;CX = DIM(S) OF MAT B
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 MOV       AUX07,EDX            ;AUX7 PT TO ELEMENT OF MAT B
	 ADD       AUX07,4

	 MOV       AL,R5                ;F2 = TYPE OF ARRAY
	 MOV       R2,AL
	 CALL      GETDIMA              ;F2,1 = DIM1 OF MAT b; F0 = DIM2

	 CMP       A2,0                 ;ERROR, IF DIM1 OF MAT B > 255
	 JNE       ERROR_45
	 MOV       AX,A6
	 CMP       A1,AX                ;ERROR IF DIM2 OF MAT A <> DIM1 OF MAT B
	 JNE       ERROR_45
	 MOV       AX,A7
	 MOV       A1,AX                ;F2,1 = DIM1 OF MAT A
	 CALL      REDIM                ;REDIMENSION MAT C (DIM1 = DIM1 OF A)
					;(DIM2 = DIM2 OF b)
					;( AUX 3,4 SET UP ON ENTRY )
	 TEST      K,4                  ;BR, IF MAT C IS 2-DIMENSIONAL
	 JNZ       MATMPYX
	 MOV       AX,A6
	 MOV       A7,AX                ;F7 = DIM1
	 MOV       A6,1                 ;F6 = DIM2 = 1

MATMPYX: MOV       CX,WORD PTR [EDX]
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 MOV       AUX0E,EDX            ;AUXE PT TO ELEMENT OF MAT C
	 ADD       AUX0E,4
	 MOVZX     EAX,A6               ;GET DIM2 OF MAT B
	 SHL       EAX,3                ;EAX = 8 * DIM2 OF B
	 MOV       AUX0D,EAX            ;SAVE IN AUXD
	 MOVZX     EAX,A6
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX
	 MOV       AUX0B,EDX            ;SAVE DIM2 OF MAT c
	 MOV       DX,A7               ;ROW COUNT = DIM1 OF MAT c
	 MOV       DWORD PTR [A6],8     ;ELEMENT LENGTH

;  PERFORM MULTIPLICATION
;

MATMPY3: MOV       AUX0C,EDX            ;DECREMENT ROW COUNT
	 DEC       AUX0C
	 MOV       EDX,AUX07
	 MOV       AUX08,EDX            ;PT TO BEG OF MAT B
	 MOV       EDX,AUX0B
	 MOV       EAX,EDX
	 SHR       EAX,16
	 MOV       DX,AX

;      PROCESS ROW OF MAT c
;
;           C(I,J) = 0 + A(I,1)*B(1,J) +...+ A(I,N)*B(N,J)
;

MATMPY4: MOV       AUX0B,EDX            ;DECREMENT CLOUMN COUNT (# OF ELE IN ROW)
	 DEC       AUX0B
	 MOV       EDX,AUX08
	 MOV       AUX09,EDX            ;PT TO BEG OF CURRENT COLUMN OF MAT B
	 ADD       EDX,8                ;PT TO BEGIN OF NEXT COLUMN OF MAT B
	 MOV       AUX08,EDX
	 MOV       EDX,AUX0F
	 MOV       AUX06,EDX            ;PT TO BEG OF CURRENT ROW OF MAT A
	 MOV       EDX,AUX0E            ;INIT ELEMENT OF MAT C
	 MOV       DWORD PTR [EDX],0
	 MOV       DWORD PTR [EDX+4],0
	 MOV       EDX,AUX0A
	 MOV       EAX,EDX
	 SHR       EAX,16
	 MOV       DX,AX               ;SUM COUNT = DIM2 OF MAT A

;      C(I,J) = C(I,J) + A(I,K)*B(K,J)
;
;           A(I,K)*B(K,J) ==> SCRATCH
;           C(I,J) + SCRATCH ==> C(I,J)
;

MATMPY5: MOV       AUX0A,EDX            ;DECREMENT SUM COUNT
	 DEC       AUX0A
	 TEST      BYTE PTR FS:[CPUST],10H
	 JZ        MATMPY6              ;BR, IF < 30 MS ELAPSED
	 MOV       R0,SAV06
	 CALL      BREAKPTQ             ;GIVE NEXT USER A CHANCE
	 MOV       DWORD PTR [A6],8     ;ELEMENT LENGTH

MATMPY6: MOV       EDX,OFFSET SCRATCH+20H
	 MOV       AUX03,EDX
	 MOV       EDX,AUX06            ;EDX PT TO CURRENT ELEMENT OF MAT A
	 ADD       EDX,8
	 XCHG      AUX06,EDX            ;AUX6 PT TO NEXT ELEMENT OF MAT A
	 MOV       AUX01,EDX            ;AUX1 PT TO CURRENT ELEMENT OF MAT A
	 MOV       EAX,AUX0D            ;GET 8 * DIM2 OF MAT B

	 MOV       EDX,AUX09            ;EDX PT TO CURRNET ELEMENT OF MAT B
	 ADD       EDX,EAX
	 XCHG      AUX09,EDX            ;AUX9 PT TO NEXT ELE IN CURRENT COLUMN
					;OF MAT B

	 CALL      MATHMUL2             ;A(I,K) * B(K,J) ==> SCRATCH
	 CALL      MATHERR              ;CHECK FOR MATH ERRORS
	 MOV       EDX,AUX0E            ;AUXE HAS PTR TO CURRENT ELE OF C
	 MOV       AUX01,EDX            ;AUX1 PT AT C(I,J)
	 MOV       EDX,OFFSET SCRATCH+20H
					;EDX PT TO PRODUCT OF A(I,K)*B(I,J)

	 CALL      MATHADD1             ;C(I,J) = C(I,J) + ( A(I,K)*B(I,J) )
	 CALL      MATHERR              ;CHECK FOR MATH ERRORS
	 MOV       DWORD PTR [A6],8
	 MOV       EDX,AUX0A            ;GET SUM COUNT
	 CMP       DX,0                ;BR, IF SUM COUNT >0
	 JNE       MATMPY5

;       DONE WITH C(I,J)
;

	 MOV       EDX,AUX0E            ;AUXE PT TO NEXT ELEMENT OF MAT C
	 ADD       EDX,8
	 MOV       AUX0E,EDX
	 MOV       EDX,AUX0B
	 CMP       DX,0                ;BR, IF MORE ELE IN CURRENT ROW OF C
	 JNE       MATMPY4

;      CURRENT ROW OF MAT c COMPLETE
;

	 MOV       EDX,AUX06
	 MOV       AUX0F,EDX            ;AUXF PT TO BEG OF NEXT ROW OF MAT A
	 MOV       EDX,AUX0C
	 CMP       DX,0                ;BR, IF MORE ROWS IN MAT C
	 JNE       MATMPY3

MATMPY1: JMP       ENDSTMTZ


;      MATINV: PROCESS A MAT INVERSE STATEMENT
;
;          FORMAT: MAT c = INV(a) [, [variable,] variable]
;
;                where: 1st variable = determinant
;                       2nd variable = norm
;
;                norm (normalized determinant) =
;                     det / PRODUCT(Euclidean length of
;                                   each row)
;
;                Euclidean length = SQR( SUM(each element
;                                   in the row squared) )
;
;      DESCRIPTION: INVERSION IS PERFORMED BY THE GAUSS-
;           JORDAN ELIMINATION METHOD DONE IN PLACE WITH
;           MAXIMUM PIVOT STRATEGY.  THE DETERMINANT IS
;           CALCULATED DURING THE INVERSION.  IF A NORM
;           VARIABLE IS SPECIFIED, THE NORM IS CALCULATED.
;
;           METHOD:
;
;                A. MAT c = MAT a
;
;                B. IF NORM VARIABLE SPECIFIED, CALCULATE
;                   DETERMINANT NORMALIZER.
;
;                C. DETERMINANT = 1
;
;                D. N PASSES ARE MADE THROUGH THE MATRIX.
;                   ON THE ITH PASS, THE FOLLOWING IS DONE
;
;                     1. FIND MAXIMUM PIVOT ELEMENT (MAX.
;                        ELEMENT IN LOWER RIGHT SUBARRAY
;                        WHOSE ELEMENT(1,1) IS ELEMENT(I,I
;                        OF ENTIRE ARRAY.
;
;                     2. MOVE PIVOT ELEMENT TO PIVOT
;                        POSITION:
;                          a. IF PIVOT ELEMENT IS IN ROW J
;                             SWITCH ROWS I & J.
;                          b. IF PIVOT ELEMENT IS IN
;                             COLUMN K, SWITCH COL I & K.
;
;                     3. NORMALIZATION: DIVIDE EACH
;                        ELEMENT OF PIVOT ROW BY PIVOT
;                        ELEMENT EXCEPT ELEMENT IN PIVOT
;                        POSITION = 1 / PIVOT ELEMENT.
;                        MULTIPLY DETERMINANT BY PIVOT
;                        ELEMENT.  MATRIX IS SINGULAR IF
;
;                     4. ELIMINATION: ELIMINATE ALL
;                        ELEMENTS IN PIVOT COLUMN EXCEPT
;                        PIVOT ELEMENT BY MULTIPLYING THE
;                        PIVOT ROW BY THE ELEMENT IN THE
;                        PIVOT COLUMN TO BE ELIMINATED
;                        AND SUBTRACTING THE RESULT FROM
;                        THE ROW CONTAINING THE ELEMENT TO
;                        BE ELIMINATED.  BUT LET ELEMENT
;                        TO BE ELIMINATED = - ( THAT
;                        ELEMENT ) * (PIVOT ELEMENT)
;
;                E. UNSCRAMBLE INVERSE: SWITCH COLUMNS AND
;                   ROWS OF MATRIX IN REVERSE ORDER THAT
;                   THEY WERE SWITCHED BY STEP D2.
;
;                F. NORM = DETERMINANT / NORMALIZER
;
;      REFERENCES (INVERSION METHOD):
;           1. Kuo,Shan S.,"COMPUTER APPLICATIONS OF
;              NUMERICAL METHODS", Addison-Wesley, 1972,
;              p. 176-203.
;           2. Carnahan, Luther, Wilkes, "APPLIED
;              NUMERICAL METHODS", Wiley, 1969, p.269-296.
;           3. Conte,S.D.,"ELEMENTARY NUMERICAL ANALYSIS",
;              McGraw-Hill, 1965, p.156-177.
;
;      REFERENCES (ILL-CONDITIONED MATRICES, ROUND-OFF
;                  ERRORS, OTHER TECHNIQUES):
;           1. Forsythe,Moler,"COMPUTER SOLUTION OF LINEAR
;              ALGEBRAIC SYSTEMS", Prentice-Hall, 1967.
;
;      REGISTER USE (GLOBAL):
;           AUXC,BITS FF00 = DIM
;               ,BITS 00FF = PASS#
;           AUXD = PIVOT POSITION (ADDRESS)
;           AUXE = ADDRESS (EVEN) OF NORM VARIABLE
;                  (ODD IF NO NORM VARIABLE SPECIFIED)
;           AUXF = ADDRESS OF BEGIN OF ARRAY
;
;      ENTRY: TEXTPTR POINTS AFTER 'INV'
;             AUX4 = NAME & TYPE OF MAT c
;             IN RESOLUTION & EXECUTION PHASE,
;                AUX3 = ADDRESS OF DIM(S) OF MAT c
;
;      MODIFIED REGISTERS: ALL,AUX0-6
;           IN EXECUTION PHASE, AUX7-F
;


MATINV:  CALL      MATVAR               ;SCAN & PROCESS MAT A
	 MOV       AUX05,EDX            ;SAVE PTR TO MAT A
	 MOVZX     EDX,WORD PTR [R2]    ;GET NAME LETTER AND DIGIT OF MAT A
	 MOV       AUX06,EDX
	 CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
	 JNE       ERROR_11
	 INC       TEXTPTR
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATINVX
	 MOV       AUX0E,0              ;FLAG = NO NORM VARIABLE SPECIFIED (0001)
MATINVX: CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	 JNE       MATINV1              ;BR, IF NF
	 INC       TEXTPTR
	 CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	 JNE       MATINVY
	 INC       TEXTPTR
	 JMP       MATINV2              ;BR, IF F (NO DET VARIABLE SPECIFIED)
MATINVY: CALL      VARR                 ;SCAN DETERMINANT VARIABLE
	 CMP       BYTE PTR [TEXTPTR],','   ;LOOK FOR COMMA
	 JNE       MATINV1              ;BR, IF NF
	 INC       TEXTPTR

MATINV2: CALL      VARR                 ;SCAN NORM VARIABLE
	 TEST      SL,2                 ;BR, IF NOT X PHASE
	 JZ        MATINV80             ;
	 DEC       OSPTR                ;REMOVE OS RECEIVER ATOM
	 MOV       EDX,VSPTR            ;GET ADDR OF NORM VARIABLE
	 MOV       EDX,DWORD PTR [EDX]  ;
	 ADD       VSPTR,4              ;
	 MOV       AUX0E,EDX            ;AUXE = ADDR OF NORM VARIABLE

MATINV1: TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATINV80             ;
	 MOV       EDX,AUX03            ;PTR TO MAT C
	 MOV       AUX0F,EDX            ;AUXF = PTR TO BEG OF MAT C
	 ADD       AUX0F,4
	 MOV       AUX0D,EDX            ;AUXD (PIVOT POSITION)=PTR TO BEG OF C
	 ADD       AUX0D,4
	 CALL      GETDIM               ;GET DIMENSIONS OF MAT a (AUX 5,6 SET UP ON ENTRY)
	 CMP       A2,0                 ;BR, IF NOT 0
	 JNE       ERROR_44             ;
	 MOV       AX,A0
	 CMP       AX,A1                ;BR, IF MAT A IS NOT SQUARE
	 JNE       ERROR_44             ;
	 movzx     edx,a0
	 SHL       EDX,16
					;AH = DIM2
	 MOV       DX,1                 ;PASS# = 1
	 MOV       AUX0C,EDX
	 CALL      MATEQUAL             ;MAT C= MAT A (AUX 3-6 SET UP ON ENTRY)
	 MOV       EDX,OFFSET SCRATCH+30H
	 MOV       WORD PTR [EDX],0     ;EXP = 0
	 MOV       WORD PTR [EDX+2],1   ;MAN LOW = 1
	 MOV       DWORD PTR [EDX+4],0  ;MAN HIGH = 0


;  CALCULATE DETERMINANT NORMALIZER
;      DESCRIPTION: (ONLY CALCULATED IF NORM VAR. SPEC.)
;
;           10 M = 1: REM M = NORM VARIABLE
;           20 FOR R= 1 TO N: X = 0
;           30 FOR C= 1 TO N: X=X+A(R,C)*A(R,C): NEXT C
;           40 M = M + SQR(X): NEXT R
;
;      ENTRY: AUXC,BITS FF00 = DIM
;             AUXE = ADDRESS (EVEN) OF NORM VARIABLE
;                    (ODD IF NO NORM VARIABLE)
;             AUXF = ADDRESS OF START OF MAT c
;
;      EXIT: NORM VARIABLE = DETERMINANT NORMALIZER
;
;      MODIFIED REGISTERS: ALL,AUX0-3,8,B
;

	 MOV       EDX,AUX0E            ;GET NORM VARIABLE ADDR
	 cmp       edx,0                ;BR, IF NO NORM VARIABLE
	 je        MATINV20             ;
					;SET NORM VARIABLE = 1
	 MOV       WORD PTR [EDX],0     ;EXP = 0
	 MOV       WORD PTR [EDX+2],1   ;MAN LOW = 1
	 MOV       DWORD PTR [EDX+4],0  ;MAN HIGH = 0

	 MOV       EDX,AUX0C            ;
	 MOV       AUX0B,EDX            ;ROW COUNT = DIM
	 MOV       EDX,AUX0F            ;
	 MOV       AUX08,EDX            ;AUX8 PT TO BEG OF ARRAY

MATINV11:MOV       EDX,OFFSET SCRATCH+20H
					;SET [SCRATCH+20]= 0
	 MOV       DWORD PTR [EDX],0    ;
	 MOV       DWORD PTR [EDX+4],0  ;
	 MOV       EDX,AUX0C            ;
	 SHR       EDX,16
	 MOV       A0,DX                ;
	 MOV       EDX,AUX0B            ;
	 MOV       DX,A0                ;COLUMN COUNT = DIM

MATINV10:MOV       AUX0B,EDX            ;DECREMENT COLUMN COUNT
	 DEC       AUX0B                ;
	 MOV       EDX,OFFSET SCRATCH+28H
	 MOV       AUX03,EDX
	 MOV       EDX,AUX08            ;EDX = ADDR OF CURRENT ELEMENT OF ROW
	 ADD       EDX,8
	 XCHG      EDX,AUX08            ;AUX8 = ADDR OF NEXT ELEMENT OF ROW

	 MOV       AUX01,EDX            ;AUX1 = ADDR CURRENT ELEMENT OF ROW
	 CALL      MATHMUL2             ;CURRENT ELEMENT * CURRENT ELEMENT
					; ---> [SCRATCH+28H]
	 CALL      MATHERR              ;CHECK FOR MATH ERRORS

	 MOV       EDX,OFFSET SCRATCH+20H
	 XCHG      EDX,AUX01
	 CALL      MATHADD1             ;[SCRATCH+20] + [SCRATCH+28]
					; ---> [SCRATCH+20]
	 CALL      MATHERR              ;CHECK FOR MATH ERRORS
	 MOV       EDX,AUX0B            ;
	 CMP       DX,0                 ;BR, IF MORE ELEMENT IN CURRENT ROW
	 JNE       MATINV10             ;
	 MOV       EDX,OFFSET SCRATCH+20H
	 CALL      MATHSQR              ;SQR([SCRATCH+20]) -> [SCRATCH+20]
	 CALL      MATHERR              ;CHK FOR MAT ERRORS
	 MOV       EDX,AUX0E            ;NORM VARIABLE ADDR
	 MOV       AUX01,EDX            ;
	 MOV       EDX,OFFSET SCRATCH+20H
	 CALL      MATHMUL1             ;NORM = NORM * [SCRATCH+20]
	 CALL      MATHERR              ;CHK FOR MATH ERRORS
	 TEST      BYTE PTR FS:[CPUST],10H  ;BR, IF <30MS ELAPSED
	 JZ        MATINV12             ;

	 MOV       EDX,DWORD PTR [CPBASE]    ;GET CURRENT BASE
	 LEA       EBX,[EDX].@IOBUFFR   ;GET ADDR OF IOBUFFR

	 MOV       AUX03,EBX            ;SAVE IT FOR AS PTR TO SAVE ELEMENT
	 MOV       EDX,OFFSET SCRATCH+30H

	 MOV       EAX,DWORD PTR [EDX]  ;SAVE DET
	 MOV       DWORD PTR [EBX],EAX  ;
	 MOV       EAX,DWORD PTR [EDX+4];
	 MOV       DWORD PTR [EBX+4],EAX;

	 MOV       R0,SAV06             ;
	 CALL      BREAKPTQ             ;BREAKPT

	 MOV       EDX,OFFSET SCRATCH+30H
	 MOV       AUX03,EDX

	 MOV       EBX,DWORD PTR [CPBASE]    ;GET CURRENT BASE
	 LEA       EBX,[EBX].@IOBUFFR        ;GET ADDR OF IOBUFFR

	 MOV       EAX,DWORD PTR [EBX]  ;
	 MOV       DWORD PTR [EDX],EAX  ;RESTORE DET
	 MOV       EAX,DWORD PTR [EBX+4];
	 MOV       DWORD PTR [EDX+4],EAX;

MATINV12:MOV       EDX,AUX0B            ;DECREMENT ROW COUNT
	 MOV       EAX,EDX
	 SHR       EAX,16
	 DEC       EAX
	 MOV       EBX,EAX
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX
	 MOV       AUX0B,EDX
	 CMP       BX,0
	 JNE       MATINV11             ;BR, IF MORE ROWS IN ARRAY


;  FIND MAXIMUM PIVOT ELEMENT IN REMAINING SUBARRAY
;


;      ELEMENTS ARE COMPARED BY MATH PACKAGE SUBROUTINE
;      'MATHCMP1'. BEFORE CALLING, THE SIGNS OF THE
;      ELEMENTS TO BE COMPARED ARE SAVED AND THEN CHANGED
;      TO '+'.  AFTER RETURN, SIGNS ARE RESTORED.
;
;      SUBARRAY:    A(P,P)    A(P,P+1)    ...  A(P,DIM)
;                   A(P+1,P)  A(P+1,P+1)  ...  A(P+1,DIM)
;                     .          .               .
;                     .          .               .
;                     .          .               .
;                   A(DIM,P)  A(DIM,P+1)       A(DIM,DIM)
;
;      ENTRY: AUXD = PIVOT POSITION (ADDRESS)
;             AUXC,BITS 00FF = PASS#
;                 ,BITS FF00 = DIM
;
;      EXIT: AUX1 = ADDRESS OF MAXIMUM ELEMENT
;            AUX5 = MAXIMUM ELEMENT SUBSCRIPTS (ROW,COL)
;            K = DIM
;
;      REGISTER USE:
;           AUX1 = PTR TO LARGEST ELEMENT FOUND
;           AUX5 = SUBSCRIPTS OF LARGEST ELEMENT FOUND
;                  (ROW,COLUMN)
;           AUX9 = ROW POINTER (POINTS TO BEGIN OF NEXT
;                  ROW OF SUBARRAY)
;           AUX8 = CURRENT ELEMENT POINTER
;           AUXB,BITS FF00 = ROW COUNT (ROW SUBSCRIPT OF
;                            CURRENT ELEMENT)
;           F6 = 1ST BYTE OF LARGEST ELEMENT FOUND
;           F5 = 1ST BYTE OF CURRENT ELEMENT
;           F4 = COLUMN COUNT (COLUMN SUBSCRIPT OF CURRENT
;                ELEMENT)
;           K = DIM
;
;      MODIFIED REGISTERS: ALL,AUX0,1,2,6,8,9,B
;


MATINV20:MOV       EDX,AUX0D            ;
	 MOV       AUX09,EDX            ;ROW PTR = PIVOT POSITION
	 MOV       AUX01,EDX            ;AUX1 = MAXIMUM ELEMENT ADDR
	 MOV       AX,WORD PTR [EDX+6]  ;GET HIGHEST MANTISSA
	 MOV       R6,0                 ;FLAG SIGN OF ELEMENT = '+'
	 OR        AX,AX                ;
	 JNS       MATINVXX             ;BR, IF POSITIVE
	 MOV       R6,1                 ;FLAG SIGN = '-'
	 MOV       EBX,DWORD PTR [EDX+2];GET THE OTHER PART OF MANTISSA
	 NOT       AX                   ;2'S COMPLEMENT MANTISSA
	 NEG       EBX                  ;
	 JNZ       MATINVYY             ;
	 INC       AX                   ;

MATINVYY:MOV       WORD PTR [EDX+6],AX  ;WRITE BACK THE MANTISSA OF '+'
	 MOV       DWORD PTR [EDX+2],EBX

MATINVXX:MOV       EDX,AUX0C            ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 MOV       A8,AX                ;K = DIM
	 MOV       EAX,EDX
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX              ;
	 MOV       AUX06,EDX            ;MAX ELEMENT SUBSCRIPTS = PASS#, PASS#

MATINV21:MOV       AUX0B,EDX            ;ROW COUNT = PH
	 MOV       EDX,AUX0C            ;
	 MOV       A4,DX                ;COLUMN COUNT = PASS#
	 MOV       EDX,AUX09            ;
	 MOVZX     EAX,A8                ;

;------- Routine  MATDSPLA ----------------------;
;        This routine has entry value in F0
;        calculats 8*F0 --> F1F0

	 SHL       EAX,3
	 MOV       DWORD PTR [A0],EAX

	 ADD       EDX,EAX              ;PC'S PT TO CURRENT ROW OF SUBARRAY
	 xchg      AUX09,EDX            ;AUX9 PT TO NEXT ROW OF SUBARRAY

;      PROCESS NEXT ROW OF SUBARRAY
;

MATINV22:MOV       AUX08,EDX            ;
	 MOV       AX,WORD PTR [EDX+6]  ;GET HIGH MANTISSA OF CURRENT ELEMENT
	 MOV       R5,0                 ;FLAG SIGN OF ELEMENT = '+'
	 OR        AX,AX                ;
	 JNS       MATINVAA             ;BR, IF POSITIVE
	 MOV       R5,1                 ;FLAG SIGN = '-'
	 MOV       EBX,DWORD PTR [EDX+2];GET THE OTHER PART OF MANTISSA
	 NOT       AX                   ;2'S COMPLEMENT MANTISSA
	 NEG       EBX                  ;
	 JNZ       MATINVZZ             ;
	 INC       AX                   ;

MATINVZZ:MOV       WORD PTR [EDX+6],AX  ;WRITE BACK THE MANTISSA OF '+'
	 MOV       DWORD PTR [EDX+2],EBX

MATINVAA:CALL      MATHCMP1             ;COMPARE CURRENT ELEMENT TO MAX ELEMENT
	 MOV       EDX,AUX08            ;GET ADDR OF CURRENT ELEMENT
	 TEST      R7,1                 ;BR, IF ABS(CUR ELEMT) > ABS(MAX ELEMT)
	 JNZ       MATINV23             ;
	 CMP       R5,0                 ;BR, IF ORI MANTISSA = '+'
	 JE        MATINV24             ;
	 MOV       AX,WORD PTR [EDX+6]  ;START TO CONVERT BACK (FROM '+' TO '-')
	 MOV       EBX,DWORD PTR [EDX+2];
	 NOT       AX                   ;
	 NEG       EBX                  ;
	 JNZ       MATINVBB             ;Note: may be we can save ori mantissa
	 INC       AX                   ;      in some save area then use copy
					;      to restore!
MATINVBB:MOV       WORD PTR [EDX+6],AX  ;RESTORE MANTISSA
	 MOV       DWORD PTR [EDX+2],EBX;

MATINV24:ADD       EDX,8                ;PT TO NEXT ELEMENT OF SUBARRAY
	 INC       A4                   ;INCREMENT COLUMN COUNT
	 MOV       AX,A4                ;
	 CMP       AX,A8                ;BR, IF MORE ELEMENTS IN CURRENT ROW
	 JBE       MATINV22             ;

;      ROW COMPLETE
;
	 MOV       EDX,AUX0B            ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 INC       EAX                   ;INCREMENT ROW COUNT
	 MOV       EBX,EAX
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX
	 MOV       A0,BX                ;
	 CMP       BX,A8                ;BR, IF MORE ROW IN SUBARRAY
	 JBE       MATINV21             ;

	 MOV       EDX,AUX01            ;
	 CMP       R6,0                 ;BR, IF ORI MANTISSA = '+'
	 JE        MATINV30             ;
	 MOV       AX,WORD PTR [EDX+6]  ;START TO CONVERT BACK (FROM '+' TO '-')
	 MOV       EBX,DWORD PTR [EDX+2];
	 NOT       AX                   ;
	 NEG       EBX                  ;
	 JNZ       MATINVCC             ;Note: may be we can save ori mantissa
	 INC       AX                   ;      in some save area then use copy
					;      to restore!
MATINVCC:MOV       WORD PTR [EDX+6],AX  ;RESTORE MANTISSA
	 MOV       DWORD PTR [EDX+2],EBX;

	 JMP       MATINV30

;      CURRENT ELEMENT > LARGEST ELEMENT FOUND
;

MATINV23:XCHG      AUX01,EDX            ;MAX ELEMT ADDR = ADDR OF CURNT ELEMT
	 CMP       R6,0                 ;BR, IF ORI MANTISSA = '+'
	 JE        MATINVEE             ;
	 MOV       AX,WORD PTR [EDX+6]  ;START TO CONVERT BACK (FROM '+' TO '-')
	 MOV       EBX,DWORD PTR [EDX+2];
	 NOT       AX                   ;
	 NEG       EBX                  ;
	 JNZ       MATINVDD             ;Note: may be we can save ori mantissa
	 INC       AX                   ;      in some save area then use copy
					;      to restore!
MATINVDD:MOV       WORD PTR [EDX+6],AX  ;RESTORE MANTISSA
	 MOV       DWORD PTR [EDX+2],EBX;

MATINVEE:MOV       AL,R5                ;
	 MOV       R6,AL                ;F6 = FLAG OF SIGN OF NEW MAX. ELEMT
	 MOV       EDX,AUX0B            ;
	 MOV       DX,A4                ;
	 MOV       AUX06,EDX            ;MAX ELEMT POS= ROW/COLUMN OF CURNT ELMT
	 MOV       EDX,AUX01            ;PC'S = ADDR OF CURRNET ELEMT
	 JMP       MATINV24             ;

;  MOVE PIVOT ELEMENT TO PIVOT POSITION
;      DESCRIPTION: SWITCH ROWS THEN COLUMNS
;
;      ENTRY: AUX5 = SUBSCRIPTS OF PIVOT ELEMENT (ROW,COL)
;             AUXC,BITS00FF = PASS#
;                 ,BITSFF00 = DIM
;             AUXF = PTR TO BEGIN OF ARRAY
;
;      EXIT: SUBSCRIPTS OF PIVOT ELEMENT ==> VS
;             AUX7 = ADDRESS OF PIVOT ROW
;
;      MODIFIED REGISTERS: PC'S,CH,CL,F0-5,7,AUX0,7
;

MATINV30:MOV       EDX,AUX06            ;ONLY LOWER 2 BYTE HAS MEANING TO SAVE!
	 MOV       EAX,VSPTR            ;SUBCRIPTS OF PIVOT ELEMT
	 SUB       EAX,4
	 MOV       DWORD PTR [EAX],EDX
	 MOV       VSPTR,EAX
	 CMP       EAX,DWORD PTR [@@VSEND]
	 JB        ERR_02

	 MOV       EDX,AUX06            ;
	 SHR       EDX,16
	 MOV       A6,DX                ;F6 = ROW SUBSCRIPT OF PIVOT ELEMT
	 MOV       EDX,AUX0C            ;
	 MOV       A5,DX                ;F5 = PASS# (PIVOT ROW)
	 CMP       DX,A6                ;BR, IF PIVOT ELEMT ROW = PIVOT ROW
	 JE        MATINV31             ;
					;CHANGING SIGN OF DETERMINANT (ASSUME
					;   DET <> 0 )
	 MOV       EDX,OFFSET SCRATCH+30H
	 MOV       AX,WORD PTR [EDX+6]  ;START TO CANGE SIGN
	 MOV       EBX,DWORD PTR [EDX+2];
	 NOT       AX                   ;
	 NEG       EBX                  ;
	 JNZ       MATINVFF             ;Note: may be we can save ori mantissa
	 INC       AX                   ;      in some save area then use copy
					;      to restore!
MATINVFF:MOV       WORD PTR [EDX+6],AX  ;RESTORE MANTISSA
	 MOV       DWORD PTR [EDX+2],EBX;

MATINV31:CALL      SWTCHROW             ;EXCHANGE ROW WITH PIVOT ELMT & PIVOT ROW
	 MOV       EDX,AUX06            ;
	 MOV       A3,DX                ;F3 = COLUMN SUBSCRIPT OF PIVOT ELEMT
	 MOV       EDX,AUX0C            ;
	 MOV       A2,DX                ;F2 = PASS# (PIVOT COLUMN)
	 CMP       DX,A3                ;BR, IF PIVOT ELEMT COLUMN = PIVOT COL
	 JE        MATINV41             ;
	 MOV       EDX,OFFSET SCRATCH+30H
	 MOV       AX,WORD PTR [EDX+6]  ;START TO CANGE SIGN
	 MOV       EBX,DWORD PTR [EDX+2];
	 NOT       AX                   ;
	 NEG       EBX                  ;
	 JNZ       MATINVGG             ;Note: may be we can save ori mantissa
	 INC       AX                   ;      in some save area then use copy
					;      to restore!
MATINVGG:MOV       WORD PTR [EDX+6],AX  ;RESTORE MANTISSA
	 MOV       DWORD PTR [EDX+2],EBX;
	 CALL      SWTCHCOL             ;EXCHG COLMN WITH PIVOT ELMT & PIVOT COL

;      PIVOT ELEMENT IS NOW IN PIVOT POSITION
;

;  NORMALIZE PIVOT ROW
;      DESCRIPTION:
;
;           10 X=A(P,P): REM P = PASS#
;           20 D=D*X: REM D = DETERMINANT
;           30 A(P,P)=1
;           40 FOR I=1 TO N: A(P,I)=A(P,I)/X: NEXT I
;
;      ENTRY: AUX7 = ADDRESS OF PIVOT ROW
;             AUXD = ADDRESS OF PIVOT ELEMENT
;
;      MODIFIED REGISTERS: ALL,AUX0-3,9,B
;

MATINV41:MOV       EDX,AUX07            ;
	 MOV       AUX09,EDX            ;AUX9 = ADDR OF PIVOT ROW
	 MOV       EBX,OFFSET SCRATCH+28H
	 MOV       AUX03,EBX
	 MOV       EDX,AUX0D            ;

;------------ Routine MOVEELMT ------------------;
;The routine move 8 byte data pt to PC to an
;space pt by AUX03

	 MOV       EAX,DWORD PTR [EDX]
	 MOV       DWORD PTR [EBX],EAX
	 MOV       EAX,DWORD PTR [EDX+4]
	 MOV       DWORD PTR [EBX+4],EAX

;-----------------------------------------------

	 MOV       AUX01,OFFSET SCRATCH+30H
	 MOV       EDX,OFFSET SCRATCH+28H
	 CALL      MATHMUL1             ;DET = DEL * PIVOT ELEMT
	 CALL      MATHERR              ;CHK FOR MATH ERRORS
	 MOV       EDX,OFFSET SCRATCH+30H
	 XOR       EAX,EAX              ;
	 MOV       AX,WORD PTR [EDX+6]  ;GET MANTISSA OF DET
	 MOV       EBX,DWORD PTR [EDX+2];
	 OR        EAX,EBX              ;BR, IF DET = 0 (MATRIX SINGULAR)
	 JZ        MATINV81             ;
	 MOV       EDX,AUX0D            ;

;----------- Routine INITELM1 -------------------;
	 MOV       WORD PTR [EDX],0     ;
	 MOV       WORD PTR [EDX+2],1   ;
	 MOV       DWORD PTR [EDX+4],0  ;
;------------------------------------------------;
	 MOV       EDX,AUX0C            ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 MOV       DX,AX                ;COLUMN COUNT = DIM

MATINV40:MOV       AUX0B,EDX            ;
	 DEC       AUX0B                ;DECREMENT COLUMN COUNT
	 MOV       EDX,AUX09            ;PC'S PT TO CURNT ELEMT OF PIVOT ROW
	 ADD       EDX,8
	 XCHG      EDX,AUX09            ;AUX9 PT TO NEXT ELEMT OF PIVOT ROW
	 MOV       AUX01,EDX            ;
	 MOV       EDX,OFFSET SCRATCH+28H
	 CALL      MATHDIV1             ;DIV NXT ELEMT OF PIVOT ROW BY PIVOT ELEMT
	 CALL      MATHERR              ;CHK FOR MATH ERRORS
	 MOV       EDX,AUX0B            ;
	 CMP       DX,0                 ;BR, IF MORE ELEMTS IN PIVOT ROW
	 JNE       MATINV40             ;

;      DESCRIPTION:
;
;           10 FOR R=1 TO M: IF R=P THEN 40: REM P=PASS#
;           20 X=A(R,P): A(R,P) = 0: REM X = [SCRATCH+20]
;           30 FOR C=1 TO M: A(R,C)=A(R,C)-X*A(P,C): NEXTC
;           40 NEXT R
;
;           WHERE LINE 40 IS PROCESSED AS FOLLOWS:
;                [SCRATCH+20] * A(P,C) ==> [SCRATCH+28]
;                A(R,C) - [SCRATCH+28] ==> A(R,C)
;
;      ENTRY: AUXF = BEGIN OF ARRAY
;             AUX7 = PTR TO PIVOT ROW
;             AUXC,BITSFF00 = DIM
;                 ,BITS00FF = PASS#
;
;      REGISTER USE:
;           AUX0,1,2 = MATH PACKAGE USE
;           AUXF = PTR TO BEGIN OF ARRAY
;           AUX9 = PTR TO CURRENT ELEMENT
;           AUX7 = PTR TO BEGIN OF PIVOT ROW
;           AUX5 = PTR TO PIVOT ROW
;           AUXA = DISPLACEMENT TO PIVOT COLUMN
;                  ( 8 * (PASS# -1) )
;           AUXB,BITS FF00 = ROW COUNT
;               ,BITS 00FF = COLUMN COUNT
;           AUXC,BITS FF00 = DIM
;               ,BITS 00FF = PASS#
;
;      MODIFIED REGISTERS: ALL,AUX0-3,5,6,A,B
;
	 AND       EDX,0FFFFH
	 MOV       AUX0B,EDX            ;ROW COUNT = 0
	 MOV       EDX,AUX0C
	 MOVZX     EAX,DX
	 DEC       EAX                  ;PASS# - 1
	 SHL       EAX,3                ;
	 MOV       DWORD PTR [A0],EAX   ;F1,0 = 8 * (PASS# -1)  !!! CAN BE DELD!
	 MOV       AUX0A,EAX            ;AUXA = DISPLACEMENT TO PIVOT COLUMN
	 MOV       EDX,AUX0F            ;
MATINV50:MOV       AUX09,EDX            ;PT TO BEG OF ARRAY

MATINV51:MOV       EAX,AUX0C            ;F1 = AH = DIM, F0 = AL = PASS#
	 MOV       DWORD PTR [A0],EAX
	 MOV       EDX,AUX0B            ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 CMP       A1,AX                ;BR, IF NO MORE ROWS IN ARRAY
	 JE        MATINV55             ;
	 INC       AX                   ;INCREMENT ROW COUNT
	 MOV       BX,AX
	 SHL       EAX,16
	 AND       EDX,0FFFFH
	 OR        EDX,EAX
	 CMP       A0,BX                ;BR, IF ROW IS PIVOT ROW
	 JE        MATINV52             ;
	 MOV       DX,A1                ;DIM - 1
	 DEC       DX                   ;COLUMN = DIM -1
	 MOV       AUX0B,EDX            ;
	 MOV       AUX03,OFFSET SCRATCH+20H     ;CAN BE DELD!!!!
	 MOV       EDX,AUX0A
	 MOV       EAX,EDX              ;
	 MOV       DWORD PTR [A0],EDX   ;F1,0 = DISPLACEMENT TO PIVOT COLUMN
	 MOV       EDX,AUX09            ;
	 ADD       EDX,EAX              ;PT TO PIVOT COLUMN OF CURNT ROW
	 MOV       EBX,AUX03
	 MOV       EAX,DWORD PTR [EDX]
	 MOV       DWORD PTR [EBX],EAX
	 MOV       EAX,DWORD PTR [EDX+4]
	 MOV       DWORD PTR [EBX+4],EAX

	 MOV       DWORD PTR [EDX],0
	 MOV       DWORD PTR [EDX+4],0

	 MOV       EDX,AUX07            ;
	 MOV       AUX06,EDX            ;PT TO BEG OF PIVOT ROW

;      ELIMINATE CURRENT ROW
;

MATINV53: TEST     BYTE PTR FS:[CPUST],10H ;BR, IF < 30 MS ELAPSED
	  JZ       MATINV54             ;


;         THIS SECTION SAVES SCRATCH AREA SCRATCH+20 TO
;            SCRATCH+37 IN IOBUFFR OF THE CURRENT PARTITION.
;         THEN SAVES AUX 06-1F,SHSL AND CALLS BREAKPT.
;         FINALLY, THE SCRATCH AREA IS RESTORED FOLLOWING
;            RETURN FROM BREAKPT AND THE BREAKPT COUNT IS
;            RESET.
;

	 MOV       ESI,OFFSET SCRATCH+20H
	 MOV       ECX,6
	 MOV       EDX,CPBASE           ;
	 LEA       EDI,[EDX].@IOBUFFR   ;
	 REP       MOVSD

XSCRAT2: MOV       R0,SAV06             ;SAVE AUX 06-1F, SHSL
	 CALL      BREAKPTQ             ;GIVE NEXT USER A CHANCE

	 MOV       EDI,OFFSET SCRATCH+20H
	 MOV       ECX,6
	 MOV       EDX,CPBASE           ;
	 LEA       ESI,[EDX].@IOBUFFR   ;
	 REP       MOVSD

MATINV54:MOV       AUX03,OFFSET SCRATCH+28H
	 MOV       EDX,AUX06            ;
	 MOV       AUX01,EDX            ;PT TO PIVOT ROW ELEMT
	 MOV       EDX,OFFSET SCRATCH+20H
	 CALL      MATHMUL2             ;X * PIVOT ROW ELEMT -> [SCRATCH+28H]
	 CALL      MATHERR              ;CHK MATH ERRORS
	 MOV       EDX,AUX09            ;AUX1 PT TO CURRENT ROW ELEMT
	 MOV       AUX03,EDX            ;
	 XCHG      AUX01,EDX            ;PC'S PT TO [SCRATCH+28]
	 CALL      MATHSUB2             ;CURNT ELEMT - [SCRATCH+28]-> CURNT ELEMT
	 CALL      MATHERR              ;CHK FOR MATH ERROR
	 MOV       EAX,8                ;
	 MOV       DWORD PTR [A0],EAX   ;F1,0 = 8
	 ADD       AUX09,8              ;PT TO NEXT ELEMT OF CURNT ROW
	 ADD       AUX06,8              ;PT TO NEXT ELEMT OF PIVOT ROW

	 MOV       EDX,AUX0B            ;
	 DEC       DX
	 XCHG      EDX,AUX0B            ;DECREMENT COLUMN COUNT
	 CMP       A1,DX                ;BR, IF MORE LEEMTS IN CURNT ROW
	 JB        MATINV53             ;
	 JMP       MATINV51             ;

MATINV52:MOV       AUX0B,EDX            ;
	 MOVZX     EAX,A1               ;
	 SHL       EAX,3                ;
	 MOV       DWORD PTR [A0],EAX
	 MOV       EDX,AUX09            ;
	 ADD       EDX,EAX              ;PT TO NEXT ROW
	 JMP       MATINV50             ;

;  END OF PASS
;

MATINV55:MOV       EDX,AUX0C            ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 INC       EAX                  ;DIM + 1
	 SHL       EAX,3                ;
	 mov       dword ptr [a0],eax
	 MOV       EDX,AUX0D
	 ADD       EDX,EAX              ;PT TO NEXT PIVOT POSITION
	 MOV       AUX0D,EDX
	 MOV       EDX,AUX0C            ;
	 XCHG      EDX,AUX0C
	 INC       AUX0C                ;INCREMENT PASS#
	 MOV       A0,DX                ;
	 MOV       EAX,EDX
	 SHR       EAX,16
	 CMP       A0,AX                ;BR, IF PASS# <= DIM
	 JB        MATINV20             ;

;  UNSCRAMBLE INVERSE
;      DESCRIPTION: SWITCH COLUMNS & THEN ROWS
;
;      ENTRY: AUXC,BITS FF00 = DIM
;           VS CONTAINS:
;                SUBSCRIPT OF LAST PIVOT ELEMENT (1ST OUT)
;                SUBSCRIPT OF NEXT TO LAST PIVOT ELEMENT
;                     .
;                     .
;                     .
;                SUBSCRIPT OF 1ST PIVOT ELEMENT (LAST OUT)
;
;      MODIFIED REGISTERS: PC'S,K,CH,CL,F0-5,F7,AUX0,7
;
	 MOV       A8,AX                ;COUNT = DIM

MATINV61:MOV       EDX,VSPTR            ;
	 MOV       ECX,DWORD PTR [EDX]    ;GET SUBSCRIPTS OF PIVOT ELEMT
	 MOV       A6,CX
	 shr       ecx,16
	 MOV       A3,CX
	 ADD       VSPTR,4              ;
	 MOV       AX,A8                ;
	 MOV       A2,AX                ;F2 = COUNT (PIVOT POSITION)
	 CALL      SWTCHCOL             ;EXCHANGE COLUMNS
	 MOV       AX,A8                ;
	 MOV       A5,AX                ;F5 = COUNT (PIVOT POSITION)
	 CALL      SWTCHROW             ;EXCHANGE ROWS
	 INC       EDX
	 DEC       A8                   ;DECREMENT COUNT
	 JNZ       MATINV61             ;

;  COMPLETE DET AND NORM PROCESSING
;      ENTRY:
;           AUXE = ADDRESS (EVEN) OF NORM VARIABLE
;                  (ODD IF NO NORM VARIABLE)
;           [SCRATCH+30] = DETERMINANT
;           NORM VARIABLE = DETERMINANT NORMALIZER
;           LAST OS ATOM = @NUMREC IF THERE IS A
;                          DETERMINANT VARIABLE
;           ADDRESS OF DET VARIABLE IN VS
;
;      EXIT: DET VARIABLE = DETERMINANT
;            NORM VARIABLE = DETERMINANT / NORMALIZER
;
	 MOV       EDX,OFFSET SCRATCH+30H
	 MOV       AUX01,EDX            ;AUX1 = ADDR OF DETERMINANT
	 MOV       EDX,AUX0E
	 cmp       edx,0                ;BR, IF NO NORM VARIABLE
	 je        MATINV71             ;
	 MOV       AUX03,EDX            ;GET ADDR OF NORM VARIABLE
	 CALL      MATHDIV2             ;NORM = DETERMINANT / NORMALIZER
	 CALL      MATHERR              ;CHK FOR MATH ERROR

MATINV71:MOV       EAX,AUX0E            ;GET ADDRS OF NORM VARIBALE
	 MOV       DWORD PTR [A6],EAX
	 MOV       EDX,OSPTR            ;
	 MOV       CH,BYTE PTR [EDX]    ;GET LAST OS ATOM
	 CMP       CH,@NUMREC           ;BR, IF NO DET VARIABLE
	 JNE       MATINV80             ;

MATINV72:DEC       OSPTR                ;REMOVE OS ATOM

	 MOV       EDX,VSPTR            ;
	 MOV       EDX,DWORD PTR [EDX]  ;GET ADDRS OF DET VARIABLE
	 ADD       VSPTR,4              ;
	 CMP       EDX,DWORD PTR [A6]   ;BR, IF DET & NORM ARE SAME VARIABLES
	 JE        MATINV80             ;
	 MOV       AUX03,EDX            ;
	 MOV       EBX,OFFSET SCRATCH+30H

;------------ Routine MOVEELMT ------------------;
;The routine move 8 byte data pt to PC to an
;space pt by AUX03
;
;   DET VARIABLE = DETERMINANT

	 MOV       EAX,DWORD PTR [EBX]
	 MOV       DWORD PTR [EDX],EAX
	 MOV       EAX,DWORD PTR [EBX+4]
	 MOV       DWORD PTR [EDX+4],EAX

;-------------------------------------------------;

MATINV80:JMP       ENDSTMTZ


;  MATRIX SINGULAR
;      DESCRIPTION:
;           DET & NORM VARIABLES SET = 0
;           IF NO DET OR NORM VARIABLE, ERR93 IS DISPLAYED
;                OTHERWISE, NO ERROR MESSAGE.
;
;      ENTRY: DETERMINANT [SCRATCH+30] = 0
;             AUXE = ADDRESS (EVEN) OF NORM VARIABLE
;                    (ODD IF NO NORM VARIABLE)
;                    AUXC,BITS 00FF = PASS#
;

MATINV81:MOV       EDX,AUX0C            ;
	 MOVZX     EAX,DX
	 SHL       EAX,2                ;4 * PASS#
	 MOV       DWORD PTR [A0],EAX
	 ADD       VSPTR,EAX            ;REMOVE PIVOT ELEMT SUBSCRIPTS FROM VS
	 MOV       A2,0
	 MOV       EDX,AUX0E            ;GET ADDR OF NORM VARIBALE
	 MOV       DWORD PTR [A6],EDX
	 cmp       edx,0                ;BR, IF NO NORM VARIABLE
	 je        MATINVSS

	 MOV       DWORD PTR [EDX],0     ;NORM VARIABLE = 0
	 MOV       DWORD PTR [EDX+4],0  ;

	 ADD       EDX,8                ;
	 JMP       MATINV71

MATINVSS:MOV       EDX,OSPTR            ;
	 MOV       CH,BYTE PTR [EDX]    ;GET LAST OS ATOM
	 CMP       CH,@NUMREC           ;
	 JE        MATINV72             ;BR, IF DET VARIABLE SPECIFIED

ERROR_72:MOV       R0,72H               ;SINGULAR MATRIX (NO NORM OR DET VAR SPEC)
	 JMP       ERROR                ;

;      MATREDIM: PROCESS A MAT REDIM STATEMENT
;
;           FORMAT:
;
;     MAT REDIM a[(dim1-expr[,dim2-expr])][length][,b...]
;
;           ENTRY: TEXTPTR POINTS AFTER 'MAT RE'
;
;           MODIFIED REGISTERS: ALL,AUX0-4
;

MATREDIM:MOV       R0,@DIM              ;
	 CALL      CCL                  ;LOOK FOR 'DIM'
	 TEST      R0,0FH               ;BR, IF NOT FOUND
	 JNZ       ERROR_12             ;

MATREDM1:CALL      MATVAR$              ;SCAN & PROCESS ARRAY NAME
	 MOV       AUX03,EDX            ;AUX3 = ADDR OF SIM(S) OF ARRAY
	 MOV       DX,WORD PTR [R2]
	 MOV       AUX04,EDX            ;AUX4 = NAME & TYPE OF ARRAY
	 CALL      MATDIM               ;SCAN & PROCESS REDIMENSION EXPRESSION
	 CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	 JNE       ENDSTMTZ
	 INC       TEXTPTR
	 JMP       MATREDM1             ;


;      MATPRINT: PROCESS A MAT PRINT STATEMENT
;
;           FORMAT:  MAT PRINT a [, b ...] [,]
;                                 ;         ;
;
;           ENTRY: TEXTPTR POINTS AFTER 'PRINT'
;
;           REGISTER USE:
;                F7 = CHARACTER AFTER ARRAY (, ; : CR)
;                F6 = DIM2
;                F5 = COLUMN COUNT
;                F4 = TYPE OF ARRAY
;                   ,BIT0001 = 0 IF NUMERIC
;                              1 IF ALPHA
;                AUX3 = ROW COUNT
;                AUX5 = PTR TO ARRAY
;                AUX6 = NAME & TYPE OF ARRAY
;                AUX4 = ELEMENT LENGTH (8 IF NUMERIC)
;
;           MODIFIED REGISTERS: ALL,AUX0,5,6
;                IN EXECUTION PHASE, AUX3,4
;

MATPRINT:CALL      PRINTBEG             ;IF XPHASE & NOT IMMED EXEC., ENABLE DEVICE

MATPRNT1:CALL      MATVAR$              ;SCAN & PROCESS ARRAY NAME
	 MOV       AUX05,EDX            ;AUX5 = ADDR OF DIM(S) OF ARRAY
	 MOV       DX,WORD PTR [R2]
	 MOV       AUX06,EDX            ;AUX6 = NAME & TYPE OF ARRAY
	 MOV       R4,DL                ;F4 = TYPE OF ARRAY
	 MOV       CH,BYTE PTR [TEXTPTR];GET NEXT TEXT CHARACTER
	 INC       TEXTPTR
	 MOV       R7,CH                ;F7 = TEXT CHAR AFTER ARRAY
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATPRNT2
	 CALL      PRNTCR               ;OUTPUT CR
	 CALL      GETDIM               ;F2,1 = DIM1; F0 = DIM2
	 MOV       AX,A0
	 MOV       A6,AX                ;F6 = DIM2
	 MOV       EDX,DWORD PTR [A1]
	 MOV       AUX03,EDX
	 DEC       AUX03                ;AUX03 = NO. OF ROWS - 1
	 MOV       EDX,8
	 TEST      R4,1                 ;BR, IF ARRAY IS NUMERIC
	 JZ        MATPRNT3
	 MOV       EDX,AUX05
	 MOVZX     EDX,BYTE PTR [EDX]    ;GET ELEMENT LENGTH
	 INC       AUX05                ;AUX5 PT TO BEG OF ELEMT

MATPRNT3:MOV       AUX04,EDX            ;AUX4 = ELEMTNT LENGTH

MATPRNT4:MOV       AX,A6
	 MOV       A5,AX                ;F5 (COLUMN COUNT) = DIM2

MATPRNT8:MOV       EAX,AUX04             ;GET ELEMT LENGTH
	 MOV       DWORD PTR A0,EAX
	 MOV       EDX,AUX05            ;EDX TO TO ELEMT
	 ADD       AUX05,EAX            ;AUX5 PT TO NEXT ELEMT
	 TEST      R4,1                 ;BR, IF ALPHA ARRAY
	 JNZ       MATPRNT5             ;
	 CALL      VVFMTA               ;FORMAT VALUE FOR PRINTING
					;NEEDS EDX PT TO VALUE
	 CALL      MVSCRTCH             ;MOVE VALUE TO 'IOBUFFER'

MATPRNT6:CALL      PRINTVA              ;OUTPUT VALUE
	 DEC       A5                   ;DECREMENT COLUMN COUNT
	 JZ        MATPRNT7             ;BR, IF NO MORE COLUMN
	 TEST      R4,1                 ;BR, IF ALPHA ARRAY
	 JNZ       MATPRNT8             ;
	 CMP       R7,';'               ;BR, IF CHARACTER AFETR ARRAY = ';'
	 JE        MATPRNT8
	 JMP       MATPRN11             ;

MATPRNTY:CALL      TWRITESP             ;OUTPUT SPACE

MATPRN11:MOV       EDX,CHARCNT          ;
	 TEST      DL,0FH               ;BR, IF NOT AT BEGIN OF ZONE (16 CHAR)
	 JNZ       MATPRNTY             ;
	 JMP       MATPRNT8

MATPRNT5:CMP       R7,';'               ;BR, IF CHAR AFTER ARRAY <> ';'
	 JNE       MATPRNT6X            ;
	 CALL      CURLEN               ;DETERMINE CURRENT LENGTH OF ELEMENT
	 MOV       EDX,DWORD PTR [A2]
	 MOV       EAX,DWORD PTR [A0]
	 MOV       WORD PTR [R0],AX
	 JMP       MATPRNT6
MATPRNT6X:
	 MOV       EAX,DWORD PTR [A0]
	 MOV       WORD PTR [R0],AX
	 JMP       MATPRNT6

MATPRNT7:CALL      CPRNTCR              ;PRINT CR IF NOT AT BEGIN OF LINE
	 MOV       EDX,AUX03
	 DEC       AUX03                ;DECREMENT ROW COUNT
	 CMP       EDX,0
	 JNZ       MATPRNT4             ;BR, IF MORE ROWS IN ARRAY

MATPRNT2:CMP       R7,','
	 JE        MATPRNT9             ;BR, IF CHAR AFTER ARRAY = ','
	 CMP       R7,';'
	 JNE       MATPRN10             ;BR, IF CHAR AFTER ARRAY <> ';'

MATPRNT9:CALL      NXTCHEOS             ;LOOK FOR END-OF-STMT CHAR
	 TEST      R0,0FH               ;BR, IF NF
	 JNZ       MATPRNT1             ;
	 JMP       PRINTEND

MATPRN10:DEC       TEXTPTR              ;DECRMENT TEXTPTR
	 JMP       PRINTEND             ;

;      MATREAD: PROCESS A MAT READ STATEMENT
;      MATINPUT: PROCESS A MAT INPUT STATEMENT
;
;           STMT FORMAT:
;
;      MAT READ a[(dim1-expr[,dim2-expr])][length] [,b...]
;          INPUT
;
;           ENTRY: TEXTPTR POINTS AFTER 'READ' OR 'INPUT'
;
;           REGISTER USE:
;                AUXD = PTR TO ARRAY
;                AUX9 = ELEMENT LENGTH
;                AUX8,BITS 000F = ARRAY TYPE
;                AUXC = ELEMENT COUNT
;                AUXE,BIT 0001 = OPERATION: 0 IF INPUT
;                                           1 IF READ
;                AUXF = PTR TO MAT INPUT STATEMENT FOR
;                       SPECIAL FUNCTION SUBROUTINE RETURN
;                       TO MAT INPUT
;                AUXA,B = SAVE AREA FOR TEXTPTRS
;
;           MODIFIED REGISTERS: ALL,AUX0-4
;                IN EXECUTION PHASE, AUX7-F
;

MATINPUT:TEST      SL,2                 ;BR, IF XPHASE
	 JZ        MATREAD1             ;
	 MOV       EDX,TEXTPTR          ;
	 MOV       AUX0F,EDX            ;SAVE PTR TO MAT INPUT(FOR SP. FUN. RET)
	 MOV       EDX,0                ;FLAG = INPUT
	 JMP       MATREAD0             ;

MATREAD: TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATREAD1             ;
	 MOV       EDX,1                ;FLAG = READ

MATREAD0:MOV       AUX0E,EDX            ;

MATREAD1:CALL      IMMEDERR             ;ERROR IF IMMEDIATE EXECUTION

MATREAD2:CALL      MATVAR$              ;SCAN & PROCESS ARRAY NAME
	 MOV       AUX03,EDX            ;SAVE ADDR OF DIM(S) OF ARRAY
	 MOV       DX,WORD PTR [R2]     ;GET NAME & TYPE OF ARRAY
	 MOV       AUX04,EDX
	 CALL      MATDIM               ;SCAN & PROCESS REDIMENSION EXPRESSION
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATREAD5
	 MOV       DWORD PTR [A0],ECX   ;F1,0 = DIM(S)
	 MOV       AUX0D,EDX            ;AUXD = ADDRESS OF ARRAY
	 ADD       AUX0D,4
	 MOV       EDX,AUX04
	 MOV       K,DL                 ;K = ARRAY TYPE
	 MOV       AUX08,EDX            ;SAVE ARRAY TYPE
	 MOV       EDX,8                ;ELEMT LENGTH
	 TEST      K,1                  ;BR, IF ARRAY IS NUMERIC
	 JZ        MATREAD9             ;
	 XCHG      EDX,AUX0D
	 MOV       CH,BYTE PTR [EDX]    ;GET ELEMENT LENGTH
	 XCHG      EDX,AUX0D
	 INC       AUX0D
	 MOVZX     EDX,CH

MATREAD9:MOV       AUX09,EDX            ;SAVE ELEMT LENGTH
	 TEST      K,4                  ;BR, IF ARRAY 1-DIMENSIONAL
	 JZ        MATREADX             ;
	 MOVZX     EAX,A0               ;
	 MOVZX     EBX,A1               ;
	 PUSH      EDX
	 MUL       EBX                  ;AX = F0 * F1
	 POP       EDX
	 MOV       DWORD PTR [A0],EAX
MATREADX:MOV       EDX,DWORD PTR [A0]     ;PC'S = NO. OF ELEMTS IN ARRAY

MATREAD3:MOV       AUX0C,EDX            ;DECREMANE ELEMTS COUNT
	 DEC       AUX0C
	 MOV       EDX,AUX09            ;GET ELEMENT LENGTH
	 MOV       DWORD PTR [A6],EDX   ;F7,6 = ELEMT LENGTH
	 MOV       EDX,AUX0D            ;PC'S PT TO CURRENT ELEMT
	 MOV       EAX,DWORD PTR [A6]
	 ADD       EDX,EAX
	 XCHG      EDX,AUX0D             ;AUX09 PT TO NEXT ELEMT
	 MOV       EAX,VSPTR
	 SUB       EAX,4
	 MOV       DWORD PTR [EAX],EDX
	 MOV       VSPTR,EAX
	 CMP       EAX,DWORD PTR [@@VSEND]
	 JB        ERR_02

	 MOV       R0,@NUMREC
	 MOV       EDX,AUX08
	 TEST      DL,1                 ;BR, IF NUMERIC ARRAY
	 JZ        MATREAD4

	 MOV       EAX,DWORD PTR [A6]
	 MOV       EDX,VSPTR
	 SUB       EDX,4
	 MOV       DWORD PTR [EDX],EAX
	 MOV       VSPTR,EDX
	 CMP       EDX,DWORD PTR [@@VSEND]
	 JB        ERR_02
	 MOV       R0,@ALPHREC

MATREAD4:MOV       EDX,OSPTR
	 INC       EDX
	 CMP       EDX,DWORD PTR [@@OSEND]
	 JE        ERROR_04
	 MOV       AL,R0
	 MOV       BYTE PTR [EDX],AL
	 MOV       OSPTR,EDX

	 MOV       EDX,AUX0E
	 TEST      DL,1                 ;BR, IF OPERATION = INPUT
	 JZ        MATREAD8
	 CALL      GETDATA              ;ELEMT = NEXT DATA VALUE

	 TEST      BYTE PTR FS:[CPUST],10H  ;BR, IF < 30 MS ELAPSED
	 JZ        MATREAD7             ;
	 MOV       R0,SAV06             ;SAVE AUX6 - 1F
	 CALL      BREAKPTQ             ;BREAKPT

MATREAD7:MOV       EDX,AUX0C            ;GET ELEMT COUNT
	 CMP       EDX,0                ;BR, IF MORE ELEMTS IN ARRAY
	 JNE       MATREAD3             ;

MATREAD5:CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	 JNE       MATREADO
	 INC       TEXTPTR
	 JMP       MATREAD2             ;BR, IF F

MATREADO:TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATREAD6             ;
	 MOV       EDX,AUX0E
	 TEST      DL,1                 ;BR, IF OPERATION NOT INPUT
	 JNZ       MATREAD6             ;
	 JMP       INPUTA               ;FLUSH INPUT DATA, INPUT MODE OFF, EXIT

MATREAD6:JMP       ENDSTMTZ

MATREAD8:MOV       EDX,AUX0C            ;GET ELEMTS COUNT

;----------------------------------------------;
;
;The @WORKSPC needs to be changed from 8 bytes
;to 12 bytes for temparily save purpose
;

MATINPT1:MOV       EBX,AUX0D
	 MOV       ECX,AUX0E

	 MOV       EAX,CPBASE
	 LEA       EAX,[EAX].@WORKSPC

	 MOV       DWORD PTR [EAX],EDX    ;SAVE ELEMTS COUNT
	 MOV       DWORD PTR [EAX+4],EBX
	 MOV       DWORD PTR [EAX+8],ECX

	 MOV       EDX,OFFSET MATINPT2
	 JMP       GETINPUT             ;GET NEXT INPUT VALUE

MATINPT2:MOV       EDX,CPBASE
	 LEA       EDX,[EDX].@WORKSPC
	 MOV       EAX,DWORD PTR [EDX]    ;GET ELEMT COUNT
	 MOV       AUX0C,EAX            ;RESTORE
	 MOV       EAX,DWORD PTR [EDX+4];GET ELEMT ADDR
	 MOV       AUX0D,EAX
	 MOV       EAX,DWORD PTR [EDX+8]  ;GET OPERAION FLAG
	 MOV       AUX0E,EAX
	 JMP       MATREAD7

;      MATVAR: SCAN & PROCESS MAT VARIABLE (NUMERIC)
;      MATVAR$: SCAN & PROCESS MAT VARIABLE (ALPHA OR
;               NUMERIC)
;
;           ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;
;           RETURN: F3 = NAME LETTER OF ARRAY
;                   F2,BITS F0 = NAME DIGIT (DEFAULT = F)
;                     ,BITS 01 = 0 IF NUMERIC, 1 IF ALPHA
;                IN RESOLUTION & EXECUTION PHASE,
;                     ,BITS 06 = 01 IF VECTOR, 11 IF 2-DIM
;
;                IN RESOLUTION & EXECUTION PHASE,
;                     PC'S = ADDRESS OF DIMS OF ARRAY IN
;                            SYMBOL TABLE
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-7,AUX0
;

MATVAR$: MOV       R7,0                 ;FLAG = ALPHA OR NUMERIC
	 JMP       MATVARX

MATVAR:  MOV       R7,1                 ;FLAG = NUMERIC ONLY

MATVARX: MOV       R2,0F2H              ;
	 TEST      SL,3
	 JNZ       MATVARA
	 CMP       BYTE PTR [TEXTPTR],7DH
	 JE        MATVARA
	 CALL      @LETTER              ;LOOK FOR [@] NAME_LETTER
	 TEST      R0,0FH               ;
	 JNZ       ERROR_26             ;BR, IF NF (MISSING ARRAY)
	 MOV       R3,CH                ;F3 = NAME LETTER
	 CALL      DIGIT                ;LOOK FOR NAME DIGIT
	 TEST      R0,0FH               ;BR, IF NF
	 JNZ       MATVARY              ;
	 AND       CH,0FH               ;TAKE DIGIT NIBBLE
	 SHL       CH,4
	 AND       R2,0FH               ;
	 OR        R2,CH                ;F2, BIT F0 = NAME DIGIT

MATVARY: CMP       BYTE PTR [TEXTPTR],'$'  ;LOOK FOR '$'
	 JNE       MATVAR1              ;BR, IF NF
	 INC       TEXTPTR
	 CMP       R7,1                 ;BR, IF NUMERIC ONLY
	 JE        ERR_27M              ;
	 OR        R2,1                 ;FLAG = ALPHA VARIABLE
	 JMP       MATVAR1

MATVARA: MOV       AX,WORD PTR [TEXTPTR+1]
	 MOV       WORD PTR [R2],AX
	 MOV       EDX,TEXTPTR
	 ADD       TEXTPTR,7

MATVAR1: TEST      SL,3                 ;BR, IF ENTRY PHASE
	 JZ        MATVAR3              ;
	 CALL      FINDVAR              ;LOOK FOR ARRAY IN SYMBOL TABLE
	 TEST      R0,0FH               ;BR, IF NF
	 JNZ       MATVAR2              ;
	 TEST      R2,08H               ;BR, IF NOT GLOBAL VARIABLE
	 JZ        MATVARZ              ;
	 TEST      SL,2                 ;BRM IF NOT XPHASE
	 JZ        MATVARW              ;
MATVARZ: MOV       R2,CL                ;F2 = NAME DIGIT & VARIABLE ATOM

MATVARW: RET

MATVAR3: TEST      MODE,0800H           ;CHECK IF THIS IS REALLY WITHIN A LIST V
	 JZ        MATVAR4              ;IF NOT, F0=0 AND RETURN
	 JMP       LISTVAR              ;GO TO LISTVAR TO PRINT OUT THE VARIABLE

MATVAR4:
	 CALL      SQZTEXT              ;SQUEEZE UNPACKED LINE NO. OUT OF TEXT LINE
	 MOV       TEXTEND,EDX
	 ADD       TEXTEND,6            ;SET TEXTEND TO NEW END OF TEXT

;
;     MAKE SURE AT LEAST 10 BYTES BETWEEN TEXTEND & VS
;

	 mov       eax,textend
	 mov       edx,textend
	 MOV       EBX,VSPTR
	 SUB       EBX,10
	 CMP       EBX,EAX
	 JB        ERR_02               ;ERROR IF NOT AT LEAST 10 BYTES
;
;     EXPAND LINE BY 7 BYTES AND INSET VAR ATOM, NAME, TYPE AND ADDRESS DWORD
;
	 MOV       TEXTPTR,EDX          ;SAVE 'FROM' ADDRESS
	 MOV       EDX,AUX00
	 MOV       DWORD PTR [A0],EDX   ;F1-0 = PTR TO WHERE LINE NO. WAS
	 MOV       EDX,TEXTPTR
					;PC'S = 'FROM' ADDRESS
	 ADD       TEXTPTR,7            ;TEXTPTR = 'TO' ADDRESS ('FROM' + 7 IF REF.)
MATVAR5: MOV       CH,BYTE PTR [EDX]
	 XCHG      EDX,TEXTPTR
	 DEC       TEXTPTR              ;MOVE NEXT BYTE OF TEXT LINE 3 BYTES
	 MOV       BYTE PTR [EDX],CH
	 XCHG      EDX,TEXTPTR
	 DEC       TEXTPTR              ;TO THE RIGHT
	 CMP       DWORD PTR [A0],EDX
	 JBE       MATVAR5              ;BRANCH IF MORE TO MOVE
	 MOV       EDX,AUX00
	 MOV       BYTE PTR [EDX],7DH   ;INSERT VAR ATOM 7DH
	 INC       EDX                  ;INCREMENT PC'S BY 1
	 MOV       AL,R2
	 MOV       BYTE PTR [EDX],AL    ;INSERT TYPE AND DIGIT
	 INC       EDX
	 MOV       AL,R3
	 MOV       BYTE PTR [EDX],AL    ;INSERT LETTER
	 INC       EDX
	 MOV       DWORD PTR [EDX],0
	 ADD       EDX,4
	 MOV       AUX00,EDX
	 MOV       TEXTPTR,EDX
	 MOV       R0,0
	 RET

;      ADD 10 X 10 ARRAY TO SYMBOL TABLE
;

MATVAR2: OR        R2,4                 ;FLAG = 2-DIMENSIONAL
	 MOV       DWORD PTR [A6],0A000AH  ;DIM1 = DIM2 = 10
	 MOV       R5,10H               ;ELEMT LENGTH = 16 (FOR ALPHA ARRAY)
	 CALL      ADDVAR               ;ADD ARRAY TO SYMBOL TABLE
	 MOV       EDX,AUX00            ;AUX0 PT TO VALUE OF ELEMT OR LENGTH IF
					;ALPHA ARRAY.
	 SUB       EDX,4                ;PC'S = ADDR OF DIMS OF ARRAY IN SYM TABL
	 MOV       DWORD PTR [TEXTPTR-4],EDX
	 RET

ERR_27M: JMP       ERROR_27             ;EXPECTED NUMERIC ARRAY


;      MATDIM: SCAN & PROCESS MAT REDIMENSIN EXPRESSION
;
;           FORMAT:
;
;                [(dim1-expr [,dim2-expr])] [length-expr]
;
;                DIMENSIONALITY MUST AGREE WITH ARRAY (IN
;                RESOLUTION AND EXECUTION PHASES). TYPE
;                (ALPHA,NUMERIC) MUST AGREE WITH ARRAY.
;                LENGTH-EXPR ONLY LEGAL FOR ALPHA ARRAYS.
;
;           ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;                 AUX4,BITS 0006 = 01 IF 1-DIM (R,X PHASE)
;                                  11 IF 2-DIM
;                     ,BIT 0001 = 0 IF NUMERIC (ALL PHASES
;                                 1 IF ALPHA
;                AUX3 = ADDRESS OF DIM(S) (EXECUTION PHASE
;
;           RETURN: TEXTPTR POINTS AFTER REDIM EXPRESSION
;                IN EXECUTION PHASE & IF REDIM EXPR FOUND,
;                     F7,6 = NEW DIM(S)
;                     F5 = NEW LENGTH (ALPHA ONLY)
;                     DIM(S) & [LENGTH] ==> SYMBOL TABLE
;                     K = VARIABLE TYPE (AUX4,BITS 00FF)
;                IN EXECUTION PHASE (FOUND OR NOT FOUND),
;                     PC'S = ADDRESS OF DIM(S)
;                     AUX3 = AUX3 + 2 (POINTS AFTER DIMS)
;                     CH,CL = DIM(S)
;
;           MODIFIED REGISTERS: ALL,AUX0,1,2,3
;

MATDIM:  CMP       BYTE PTR [TEXTPTR],'('  ;LOOK FOR '('
	 JNE       MATDIM1              ;BR, IF NF
	 INC       TEXTPTR
	 TEST      SL,2                 ;BR, IF XPHASE
	 JNZ       MATDIMX1
	 TEST      SL,3                 ;BR, IF ENTRY PHASE
	 JZ        MATDIMX2
	 TEST      AUX04,8              ;BR, IF VARIABLE GLOBAL
	 JNZ       MATDIMX2
	 MOV       EDX,DWORD PTR [CPBASE]
	 TEST      BYTE PTR [EDX].@RESFLG,1 ;BR, IF NOT LOCAL VAR, AFTER DEFFN @PART
	 JZ        MATDIMX1

MATDIMX2:CALL      EXPR                 ;PROCESS 1ST DIMENSION
	 CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	 JNE       MATDIM3              ;BR, IF NF
	 INC       TEXTPTR
	 JMP       MATDIM7

MATDIMX1:CALL      EXPR
	 TEST      SL,3                 ;BR, IF ENTRY PHASE
	 JZ        MATDIM2
	 TEST      AUX04,4              ;BR, IF 1-DIMENSIONAL ARRAY
	 JZ        MATDIM3
	 CMP       BYTE PTR [TEXTPTR],','   ;LOOK FOR COMMA
	 JNE       ERROR_13
	 INC       TEXTPTR
MATDIM7: CALL      EXPR                 ;SCAN & PROCESS DIM2-EXPRESSION

MATDIM3: CMP       BYTE PTR [TEXTPTR],')'   ;LOOK FOR ')'
	 JNE       ERROR_11
	 INC       TEXTPTR

MATDIM9: TEST      AUX04,1              ;BR, IF NUMERIC ARRAY
	 JZ        MATDIM4
	 CALL      NXTCHEOS             ;LOOK FOR END-OF-STMT CHAR
	 MOV       R3,10H               ;DEFAULT ELEMT LENGTH = 16
	 TEST      R0,0FH               ;BR, IF NO LENGTH-EXPRESSION
	 JZ        MATDIM4
	 CMP       CH,','               ;BR, IF COMMA
	 JE        MATDIM4
	 CALL      EXPR                 ;SCAN & PROCESS LENGTH-EXPRESSION
	 TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATDIM8
	 CALL      FLTBIN               ;CONVERT LENGTH TO BINARY
	 CMP       R2,2                 ;BR, IF LENGTH < 1 OR > 2^32
	 JNE       ERR_50A
	 CMP       DWORD PTR [A0],124   ;BR, IF < 124
	 JBE       MATDIMX
ERR_50A: JMP       ERROR_50             ;ILLEGAL DIMENSION OR LENGTH

MATDIMX: MOV       AL,BYTE PTR [A0]     ;GET LENGTH
	 MOV       R3,AL                ;F3 = LENGTH

MATDIM4: TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATDIM8
	 CALL      FLTBIN               ;CONVERT DIM TO BINARY
	 CMP       R2,2                 ;ERROR, IF DIM < 1 OR > 2^32
	 JNE       ERR_50A
	 TEST      AUX04,4              ;BR, IF 1-DIMENSIONAL ARRAY
	 JZ        MATDIM6
	 CMP       DWORD PTR [A0],0FFFFH;ERROR, IF DIM2 >65535
	 JA        ERR_50A
	 MOV       AX,A0
	 MOV       A4,AX                ;F4 = DIM2
	 CALL      FLTBIN               ;CONVERT DIM1 TO BINARY
	 CMP       R2,2                 ;ERROR IF DIM1 < 1 OR > 65535
	 JNE       ERR_50A
	 CMP       DWORD PTR [A0],0FFFFH ;ERROR, IF DIM1 > 65535
	 JA        ERR_50A
	 MOV       AX,A0                ;GET DIM1
	 MOV       A1,AX                ;F1 = DIM1
	 MOV       AX,A4                ;GET DIM2
	 MOV       A0,AX                ;F0= DIM2

MATDIM6: JMP       REDIM$

MATDIM2: CMP       BYTE PTR [TEXTPTR],')'  ;LOOK FOR ')'
	 JNE       MATDIMY              ;BR, IF NF
	 INC       TEXTPTR
	 JMP       MATDIM9

MATDIMY: CMP       BYTE PTR [TEXTPTR],','   ;LOOK FOR COMMA
	 JNE       MATDIM3              ;BR, IF NF
	 INC       TEXTPTR
	 JMP       MATDIM7              ;BR, F

MATDIM1: TEST      SL,2                 ;BR, IF NOT XPHASE
	 JZ        MATDIM8
	 MOV       EDX,AUX03            ;PC PT TO DIM(S)
	 MOV       CX,WORD PTR [EDX]    ;CH,CL = DIM(S)
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 ADD       AUX03,4              ;AUX3 PT AFTER DIM(S)

MATDIM8: RET


;      REDIM$: REDIMENSION AN ARRAY. AMOUNT OF SPACE
;              REQUIRED FOR REDIMENSIONED ARRAY MUST BE
;              <= AMOUNT OF SPACE ORIGINALLY RESERVED
;              FOR THE ARRAY.
;
;           ENTRY: F1,0 = DIM IF 1-DIMENSIONAL
;                  F1 = DIM 1, F0 = DIM2 IF 2-DIMENSIONAL
;                  F3 = LENGTH (ALPHA ONLY)
;                  AUX3 = ADDRESS OF DIM(S) OR ARRAY IN
;                         SYMBOL TABLE
;                AUX4,BIT  0001 = 0 IF NUMERIC, 1 IF ALPHA
;                    ,BITS 0006 = 01 IF 1-DIMENSIONAL
;                                 11 IF 2-DIMENSIONAL
;                PHASE = EXECUTION
;
;           RETURN: NEW DIM(S) & [LENGTH] ==> SYMBOL TBL
;                F7,6 = DIM(S)
;                F5 = LENGTH (ALPHA)
;                K = VARIABLE TYPE (AUX4,BITS 00FF)
;                PC'S = ADDRESS OF DIM(S)
;                AUX3 = AUX3 + 2 (POINTS AFTER DIMS)
;                CH,CL = DIM(S)
;
;           MODIFIED REGISTERS: ALL
;
;      REDIM: SAME AS 'REDIM$' EXCEPT DIMENSIONALITY IS
;             CHECKED. IF MAT c  IS 2-DIMENSIONAL, DIM1
;             MUST BE < 256. IF MAT c IS 1-DIMENSIONAL,
;             DIM2 MUST = 1.
;
;           ENTRY: F2,1 = DIM1
;                  F0 = DIM2
;                  F3 = LENGTH (ALPHA ONLY)
;                  AUX3 = ADDRESS OF DIM(S) OF MAT c
;                  AUX4 = NAME & TYPE OF MAT c
;                  PHASE = EXECUTION
;
;           RETURN: SAME AS 'REDIM$'
;
;           MODIFIED REGISTERS: SAME AS 'REDIM$'
;

REDIM:   TEST      AUX04,4              ;BR, IF MAT C IS 1-DIMENSIONAL
	 JZ        REDIM1
	 CMP       A2,0                 ;ERROR, IF DIM1 > 65535
	 JNE       ERR_59A
	 JMP       REDIM$

REDIM1:  CMP       A0,1                 ;ERROR IF DIM2 <> 1
	 JNE       ERR_59A
	 MOV       EAX,DWORD PTR [A1]
	 MOV       DWORD PTR [A0],EAX     ;F1,0 = DIM

;      CALCULATE ADDRESS OF END OF REDIMENSIONED ARRAY
;

REDIM$:  MOV       EDX,AUX03
	 XCHG      EDX,AUX04
	 INC       AUX04
	 MOV       K,DL                 ;K = TYPE OF ARRAY
	 XCHG      EDX,AUX04            ;PC'S = ADDRESS OF ARRAY -1
	 MOV       R5,8                 ;LENGTH = 8 ( IF NUMERIC)
	 TEST      K,1                  ;BR, IF NUMERIC
	 JZ        REDIM$1
	 INC       EDX
	 MOV       AL,R3
	 MOV       R5,AL                ;F5 = LENGTH (ALPHA)

REDIM$1: MOV       EAX,DWORD PTR [A0]
	 MOV       DWORD PTR [A6],EAX   ;F7,6 = DIM(S)
	 TEST      K,4                  ;BR, IF 1-DIMENSIONAL
	 JZ        REDIM$Y
	 MOVZX     EBX,A1
	 AND       EAX,0FFFFH
	 PUSH      EDX
	 MUL       EBX                  ;AX = # OF ELEMTS
	 POP       EDX
	 MOV       DWORD PTR [A0],EAX   ;F1,0 = # OF ELEMTS

REDIM$Y: MOV       EAX,DWORD PTR [A0]
	 MOVZX     EBX,R5
	 PUSH      EDX
	 MUL       EBX
	 POP       EDX
	 JC        ERR_59A
	 MOV       DWORD PTR [A0],EAX   ;TOTAL LENGTH REQUIRED BY ARRAY
	 ADD       EDX,EAX              ;PC = ADDR OF LAST BYTE OF REDIM. ARRAY
	 JC        ERR_59A

	 MOV       AUX01,EDX            ;SAVE ADDR OF END OF REDIM. ARRAY

;      GET ADDRESS OF END OF AREA ALLOCATED FOR ARRAY
;
	 MOV       EDX,AUX03            ;
	 SUB       EDX,4                ;
	 CALL      NEXTVAR              ;F3,2 = ADDR OF END OF ARRAY
	 MOV       EDX,AUX01
	 CMP       DWORD PTR [A2],EDX   ;BR, IF REDIM. ARRAT <= AVAIL SPACE
	 JBE       ERR_59A              ;
	 MOV       EDX,AUX04            ;
	 MOV       K,DL                 ;K = ARRAY TYPE
	 MOV       EDX,AUX03            ;
	 MOV       AX,WORD PTR [A7]     ;GET DIMS
	 MOV       WORD PTR [EDX],AX
	 MOV       AX,WORD PTR [A6]     ;GET DIMS
	 MOV       WORD PTR [EDX+2],AX
	 ADD       EDX,4                ;NEW DIM(3) --> SYMBOL TABLE
	 TEST      K,1                  ;BR, IF ARRAY NOT ALPHA
	 JZ        REDIM$X              ;
	 MOV       AL,R5                ;NEW LENGTH --> SYMBOL TABLE
	 MOV       BYTE PTR [EDX],AL    ;
	 INC       EDX

REDIM$X: MOV       EDX,AUX03            ;
	 MOV       CX,WORD PTR [EDX]    ;CH,CL = DIM(S)
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 ADD       AUX03,4              ;AUX3 PT AFTER DIM(S)
	 RET

ERR_59A: JMP       ERROR_59             ;ILLEGAL REDIMENSIONING


;      GETDIM: F2,1 = DIM1, F0 = DIM2
;
;           ENTRY: AUX5 = ADDRESS OF DIM(S)
;                  AUX6,BITS0006 = 01 IF 1-DIMENSIONAL
;                                  11 IF 2-DIMENSIONAL
;
;           RETURN: F2,1 = DIM1
;                   F0 = DIM2
;                   F3 = AUX6,BITS 00FF
;                   CH,CL = DIM(S)
;                   AUX5 = AUX5+2
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-3,AUX5
;
;      GETDIMA: F2,1 = DIM1, F0 = DIM2
;
;           ENTRY: CH,CL = DIM(S)
;                  F2,BITS 06 = 01 IF 1-DIMENSIONAL
;                               11 IF 2-DIMENSIONAL
;
;           RETURN: F2,1 = DIM1
;                   F0 = DIM2
;                   F3 = F2
;
;           MODIFIED REGISTERS: F0-3
;

GETDIM:  MOV       EDX,AUX05
	 MOV       CX,WORD PTR [EDX]    ;CH,CL = DIM(S)
	 SHL       ECX,16
	 MOV       CX,WORD PTR [EDX+2]
	 ADD       AUX05,4
	 MOV       EDX,AUX06
	 MOV       R2,DL

GETDIMA: MOV       AL,R2
	 MOV       R3,AL                ;F3 = TYPE OF ARRAY
	 MOV       A2,0
	 MOV       DWORD PTR [A0],ECX   ;F2,1 = DIM1, F0 = DIM2
	 TEST      R3,4                 ;BR, IF ARRAY IS 2-DIMENSIONAL
	 JNZ       GETDIMX
	 MOV       DWORD PTR [A1],ECX   ;F2,1 = DIM1
	 MOV       A0,1                 ;F0 = DIM2(1)

GETDIMX: RET

;      NAMECHK: COMPARE 2 MATRIX NAMES. ERROR IF SAME.
;
;           ENTRY: F3 = NAME1 LETTER
;                  F2,BITS F0 = NAME1 DIGIT (F IF NONE)
;                  PH = NAME2 LETTER
;                  PL,BITS F0 = NAME2 DIGIT (F IF NONE)
;
;           MODIFIED REGISTERS: PL
;

NAMECHK: CMP       DX,WORD PTR [R2]      ;BR, IF MATRIX NAMES ARE DIFFERENT
	 JE        ERROR_43

NAMECHK1:RET

ERROR_43:MOV       R0,43H               ;ERROR NAMES ARE SAME
	 JMP       ERROR


;      SWTCHROW: EXCHANGE 2 ROWS OF ARRAY
;
;           ENTRY: F6 = SUBSCRIPT OF ROW 1
;                  F5 = SUBSCRIPT OF ROW 2
;                  AUXF = ADDRESS OF BEGIN OF ARRAY
;                  AUXC,BITS FF00 = DIM2 OF ARRAY
;
;           RETURN: AUX7 = ADDRESS OF ROW 2
;
;           MODIFIED REGISTERS: PC'S,CH,CL,F0-5,7,AUX0,7
;

SWTCHROW:MOV       EDX,AUX0C
	 SHR       EDX,16
	 MOV       A7,DX
	 MOV       A0,DX
	 MOVZX     EAX,A6
	 DEC       EAX
	 MOVZX     EBX,A0
	 MUL       EBX
	 SHL       EAX,3
	 MOV       DWORD PTR [A0],EAX
	 MOV       EDX,AUX0F
	 ADD       EDX,EAX
	 MOV       AUX00,EDX

	 MOV       AX,A7
	 MOV       A0,AX
	 MOVZX     EAX,A5
	 DEC       EAX
	 MOVZX     EBX,A0
	 MUL       EBX
	 SHL       EAX,3
	 MOV       DWORD PTR [A0],EAX
	 MOV       EDX,AUX0F
	 ADD       EDX,EAX
	 MOV       AUX07,EDX
	 MOV       AX,A5
	 CMP       AX,A6
	 JE        SWTCHRW1

SWTCHRW2:MOV       EBX,AUX00
	 MOV       EAX,DWORD PTR [EBX]
	 MOV       EDI,DWORD PTR [EDX]
	 MOV       DWORD PTR [EDX],EAX
	 MOV       DWORD PTR [EBX],EDI

	 MOV       EAX,DWORD PTR [EBX+4]
	 MOV       EDI,DWORD PTR [EDX+4]
	 MOV       DWORD PTR [EDX+4],EAX
	 MOV       DWORD PTR [EBX+4],EDI

	 ADD       AUX00,8
	 ADD       EDX,8
	 DEC       A7
	 JNZ       SWTCHRW2

SWTCHRW1:RET

;      SWTCHCOL: EXCHANGE 2 COLUMNS OF ARRAY
;
;           ENTRY: F3 = SUBSCRIPT OF COLUMN 1
;                  F2 = SUBSCRIPT OF COLUMN 2
;                  AUXF = ADDRESS OF BEGIN OF ARRAY
;                  AUXC,BITS FF00 = DIM1 OF ARRAY
;
;           MODIFIED REGISTERS: F0-5,PH,PL,CH,CL,AUX0
;

SWTCHCOL:MOVZX     EAX,A3               ;COL 1
	 CMP       AX,A2                ;BR, IF COL1 & COL2 ARE SAME
	 JE        SWTCHRW1             ;
	 DEC       EAX                  ;COL 1 - 1
	 SHL       EAX,3                ;EAX = 8 * COL1
	 MOV       EDX,AUX0F            ;GET ADDR OF ARRAY
	 ADD       EDX,EAX              ;EBX PT TO BEG OF COL1
	 MOV       AUX00,EDX
	 MOVZX     EAX,A2                ;AL = COL2
	 DEC       EAX                  ;COL2 -1
	 SHL       EAX,3                ;
	 MOV       EDX,AUX0F
	 ADD       EDX,EAX              ;EDI PT TO BEG OF COL2
	 XCHG      EDX,AUX0C
	 MOV       EAX,EDX
	 SHR       EAX,16
	 MOV       A2,AX
	 MOV       A0,AX
	 DEC       A0
	 XCHG      EDX,AUX0C
	 MOVZX     EAX,A0
	 SHL       EAX,3                ;EAX = 8 * (DIM1 -1)
	 MOV       DWORD PTR [A0],EAX

SWTCHCL2:MOV       EBX,AUX00
	 MOV       ECX,DWORD PTR [EBX]   ;EXCHANGE ELEMTS BETWEEN COLUMNS
	 MOV       EDI,DWORD PTR [EDX]
	 MOV       DWORD PTR [EBX],EDI
	 MOV       DWORD PTR [EDX],ECX
	 MOV       ECX,DWORD PTR [EBX+4]
	 MOV       EDI,DWORD PTR [EDX+4]
	 MOV       DWORD PTR [EBX+4],EDI
	 MOV       DWORD PTR [EDX+4],ECX
	 ADD       AUX00,8
	 ADD       EDX,8

	 ADD       EDX,EAX              ;PT TO NEXT ELEMT IN COL1
	 XCHG      EDX,AUX00
	 ADD       EDX,EAX              ;PT TO NEXT ELEMT IN COL2

	 DEC       A2                   ;BR, IF MORE ELEMTS IN COLUMN
	 JNZ       SWTCHCL2             ;

SWTCHCL1:RET

CODE     ENDS
	 END
