;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M55
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    CHARTABL
PUBLIC    DEV?AMTERM
PUBLIC    DREGSTOR
PUBLIC    DRVRDEV
PUBLIC    DRVRSTAT
PUBLIC    DRVRMAIN
PUBLIC    ESCTABL
PUBLIC    GETDRDEV
PUBLIC    MSTRTABL
PUBLIC    TABLNAME
PUBLIC    TABLSTRT
PUBLIC    ESCRTNS
PUBLIC    ESCAPE
PUBLIC    OUTCODE

EXTRN     DELAY5:NEAR
EXTRN     ERROR:NEAR
EXTRN     PART_:BYTE
EXTRN     PTERM:BYTE
EXTRN     TEMPSAVE:BYTE
EXTRN     WAITRDYB:NEAR
EXTRN     CPBASE:DWORD
;-------- TSAI --------
EXTRN     CMDBUADR:DWORD
EXTRN     TEMADRTBL:DWORD
EXTRN     TOMXF   :BYTE
EXTRN     WAITCMD :NEAR
;-------- TSAII -------
extrn     print_addr:near
extrn     print_flag:near
extrn     PRT_BUFFER_START_X:DWORD
extrn     PRT_BUFFER_END_X  :DWORD
;
;         TITLE     GENERALIZED PRINTER DRIVER
;*******************************************************************************
;         MODULE    MOD-55 PRINTER DRIVER
;*
;*
;*   DBMVP55 :  GENERALIZED PRINTER DRIVER
;*
;*        THIS MODULE IS THE GENERALIZED, TABLE DRIVEN, PRINTER DRIVER FOR THE
;*        MVP BASIC-2 OPERATING SYSTEM.  FOR COMPLETE DOCUMENTATION SEE THE
;*        FOLLOWING DOCUMENTS, ALL WRITEN BY DAVID M. BARRETT.
;*
;*        #MVP03    2200 GENERALIZED PRINTER DRIVER FUNCTIONAL SPECIFICATION
;*        #MVP04    2200 GENERALIZED PRINTER DRIVER STANDARD CHARACTER SET,
;*                           CONTROL SEQUENCES AND ESCAPE SEQUENCES
;*        #MVP05    2200 GENERALIZED PRINTER DRIVER DESIGN SPECIFICATION
;*
;*
;*% REFERENCED MODULES:
;         SYMBL     BPMVP00   SYSTEM EQUATES
;         SYMBL     BPMVP01   CONTROL
;         SYMBL     BPMVP05   I/O SUBROUTINES
;         SYMBL     BPMVP19   VERIFY MEMORY
;         SYMBL     22MVP
;*
;*% EDIT FILE LIST
;*                  DBMVP55   MAIN ROUTINE
;         CONT      DBMVP55A  REGISTER SAVE AND RESTORE,
;*                            STATUS WORD ACCESS ROUTINES
;         CONT      DBMVP55B  ESCAPE SEQUENCE DECODER
;         CONT      DBMVP55C  ESCAPE SEQUENCE ROUTINES
;         CONT      DBMVP55D  MORE ESCAPE SEQUENCE ROUTINES
;         CONT      DBMVP55E  ESCAPE SEQUENCE TRANSLATOR
;         CONT      DBMVP55F  CHARACTER AND CONTROL CODE ROUTINES
;         CONT      DBMVP55H  ESCAPE SEQUENCE DECODING TABLE DEFINITION
;*
;*
;*
;*        SET LOCATION COUNTER
;*
;*
;*% DRIVER EQUATES
;*
; ***** BYTE ORIENTED  TYPE *****

MSTRTABL  DD      2*16 dup(?)           ;ALL PRINTER DRIVERS' ESCTABL & CHARTABL BEGIN ADDRESS IN  TABLSTRT ARE KEPT HERE
                                        ;EACH DRIVER HAS ONE PAIR (DD)

; ------------------------------------------------------------------
;| char1  |  esc1  |  char2 |   esc2  |      ................       |
; -------------------------------------------------------------------
;

ESCTABL   DD      ?                     ;current ESCTABLE BEGIN ADDRESS  IN TABLSTRT

CHARTABL  DD      ?                     ; curent  CHARTABLE BEGIN ADDRESS IN TABLSTRT

DREGSTOR  DB      64*64 dup(?)          ; THE SPACE FOR TEMPARY STORAGE REGS
                                        ; EACH PARTITION HAS 64 BYTES TO KEEP
                                        ; INFORMATION,u64
TABLNAME  DB      8*16 dup(?)           ;EVERY DRIVER HAS 8 BYTES TO KEEP DRIVER NAME

; **** CONTROL MEMORY TYPE ( 1 WORD = 3 BYTES) *****


;DRVRDEV   DB      3*2*16 dup(?)        ; ALL PRINTER DRIVERS' (DRIVER ADDRESS
DRVRDEV    DB      12*16  DUP(?)        ; & TABLE #) & (BIT MAP) ARE KEPT here

                                        ; BIT MAP ---- WHICH PARTITION CAN USE THIS PRINTER DRIVER
                                        ; EACH DRIVER HAS ONE PAIR (CM WORD)

; --------------------------------------------------------------------------
;| ADDRESS & TABLE #1 |  BIT MAP  1    |  ADDRESS & TBALE #2 |   BIT MAP 2  | ............       ................       |
; --------------------------------------------------------------------------

DEV?amTERM DB     3*1 dup(?)            ;previously used DRIVER'S DRIVER # & TERMINAL ADDRESS


DRVRSTAT  DB      3*3*64 dup(?)         ;u64
                                        ;EVERY PARTITION HAS THREE(3) STATUS WORDS



TABLSTRT  DB      3*2048 DUP(?)
                                        ; THE SPACE ARE FOR ALL ESCTABLE & CHARTABLE DOWNLOAD


;* THIS ROUTINE IS THE MAIN MODULE OF THE GENERALIZED PRINTER DRIVER.
;* THE STATUS BITS AND THE INPUT ARE CHECKED AND THE APPROPRIATE ROUTINE IS
;* CALLED DEPENDING UPON THEIR SETTINGS.  CHECKS FOR WHICH ROUTINE TO CALL ARE
;* MADE IN ORDER OF IMPORTANCE AND HIERARCHY.
;*
;* ENTRY: K = CODE TO BE SENT TO THE DRIVER OR THE PRINTER; PC'S SAVED ON TOP
;*             OF STACK
;* EXIT: NO CHANGES ARE MADE
;* MODIFIED REGISTERS: NONE, ALL ARE RESTORED BEFORE EXIT, INCLUDING PC'S
;*
;
DRVRMAIN: CALL      REGHOLD     ;SAVE REGISTERS
          CALL      GETSTAT1    ;READ STATUS WORD 1
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       R0,AL       ;F0 = BITS 16 - 23 OF WORD 1
          MOV       AX,WORD PTR [EDX]
          MOV       R1,AH       ;F1 = BITS 8 - 15 OF WORD 1
          MOV       R2,AL       ;F2 = BITS 0 - 7 OF WORD 1
          TEST      R0,40H      ;BRANCH IF POWER ON INIT HAS BEEN DONE
          JZ        SIT1
          MOV       EDX,AUX01
          PUSH      EDX         ;SAVE INPUT
          MOV       R5,23H      ;SET F5 = ESCAPE NUMBER
          CALL      RSTDEF      ;DO A POWER-ON RESET
          POP       EDX
          MOV       AUX01,EDX   ;RECALL INPUT
SIT1:     TEST      R0,30H      ;BRANCH IF NOT TEMP TRANSPARENCY OR ESC INPUT
          JZ        SIT4
          TEST      R0,20H      ;BRANCH IF BIT 6 IS NOT ON
          JZ        SIT3
          CALL      TEMPTRAN    ;CALL TEMPORARY TRANSPARENCY ROUTINE
          JMP       MAINOUT     ;EXIT
SIT3:     CALL      ESCAPE      ;CALL ESCAPE DECODER ROUTINE
          JMP       MAINOUT     ;EXIT
SIT4:     MOV       EDX,AUX01
          CMP       DL,02H
          JNE       SIT5        ;BRANCH IF PL NOT = HEX(02)
          CALL      ESCIN       ;CALL START ESCAPE SEQUENCE ROUTINE
          JMP       MAINOUT     ;EXIT
SIT5:     CALL      CHARCTRL    ;CALL CONTROL CODE CHARACTER DECODER
MAINOUT:  MOV       AL,R0
          MOV       K,AL
          MOV       DX,WORD PTR R1
          XCHG      DH,DL
          MOV       AUX00,EDX   ;SAVE PHPL IN AUX 0
          CALL      GETSTAT1    ;SAVE STATUS WORD 1
;         CALL      WCM
          MOV       AL,K        ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX
          JMP       REGRSTR     ;RESTORE REGISTERS

;         TITLE     TEMPORARY TRANSPARNECY
;*******************************************************************************
;*   THIS ROUTINE HANDLES THE TEMPORARY TRANSPARENCY MODE OF THE DRIVER.  THE
;*   CODE IS SENT TO THE PRINTER, THEN THE COUNT OF THE NUMBER OF CODES REMAINING
;*   TO BE SENT IS DECREMENTED BY 1.  IF THE COUNT BECOMES 0, THEN THE TEMPORARY
;*   TRANSPARENCY BIT FLAG IN STATUS WORD 1 IS TURNED OFF.
;*
;* ENTRY: THE CODE TO OUTPUT IS IN AUX1, COUNT OF NUMBER TO SEND IN F1
;* EXIT: F1 IS UPDATED TO REFLECT THE NEW COUNT
;* MODIFIED REGISTERS: F2 (BIT 6 OF STATUS WORD 1), PHPL, K
;*                     BITS 8 - 15 OF STATUS WORD 3 (TEMPORARY TRANSPARENCY COUNT)
;*                     F1 (NUMBER TO SEND)
;*
TEMPTRAN: MOV       EDX,AUX01
          MOV       K,DL        ;K = OUTPUT CODE
          CALL      OUTCODE     ;SEND CODE TO PRINTER
          DEC       R1          ;TRANSPARENCY COUNT = TRANS. COUNT -1
          JZ        TEMPOUT
          RET
TEMPOUT:  AND       R0,0DFH     ;TURN OFF TEMPORARY TRANSPARENCY MODE
          RET

;         TITLE     ESCAPE SEQUENCE ERROR HANDLER
;*******************************************************************************
;* THIS ROUTINE HANDLES ESCAPE SEQUENCE ERRORS. AS SOON AS AN ESCAPE SEQUENCE ERROR
;* IS DETECTED, IT IS FLAGGED AS AN 'ILLEGAL MICROCOMMAND' ERROR (P46).
;*
;* ENTRY: ERROR DETECTED
;* EXIT: REGISTERS RESTORED, CONTROL TRANSFERRED TO 'ERROR'
;* MODIFIED REGISTERS: ALL
;*
ESCERROR: AND       R0,0CFH     ;CLEAR ESCAPE SEQ. IN PROGRESS FLAG
          CALL      MAINOUT     ;SAVE STATUS & RESTORE ALL
          MOV       R0,46H      ;ERROR = P46 ILLEGAL MICROCOMMAND
          JMP       ERROR       ;TELL THEM

;********************************************************************************
;* THIS ROUTINE SETS THE ESCAPE SEQUENCE FLAG WHEN EVER A HEX(02) IS DETECTED IN
;* THE INPUT AND THE FLAG IS NOT ALL READY SET.
;*
;* ENTRY: INPUT CODE IS IN AUX1
;* EXIT: STATUS WORD 1 UPDATED
;* MODIFIED REGISTERS: BIT 20 IN STATUS WORD 1
;*
;*******************************************************************************
ESCIN:    OR        R0,10H      ;TURN ON ESCAPE MODE FLAG
          MOV       R1,00       ;SET ESCAPE SEQUENCE POINTER TO 0
          push      eax
          mov       eax,dword ptr [cpbase]
          mov       byte ptr [eax].@escflag,1
          pop       eax
          RET

;         TITLE     REGHOLD
;*******************************************************************************
;* THIS ROUTINE SAVES THE REGISTERS CHCL, K, AUX0 - AUX3, PHPL AND F0 - F7 IN
;* CONTROL MEMORY FOR LATER RECOVERY.  THIS ROUTINE IS USED BY THE GENERALIZED PRINTER DRIVER.
;*
;* ENTRY:  NOTHING SPECIAL
;* EXIT:    ORIGINAL CHCL, F0 - F7, AUX0 - AUX3, PHPL AND K  A1 A2 SAVED
;*           (BYTE)   2     8*1        4*4        4       2   2  2   (  TOTAL = 36 )
;* WE GIVE EACH PARTITION STORAGE 64 BYTES FOR SIMPLE !!!!
;* MODIFIED REGISTERS: CHCL, PHPL, F0 - F7, K, AUX0 - AUX3
;*
REGHOLD:
        MOV     EBX,OFFSET DREGSTOR
        XOR     EAX,EAX
        MOV     AL,PART_
        SHL     EAX,6           ; 64 BYTES PER PARTITION
        ADD     EBX,EAX         ;ADDRESS OF START OF STORE FOR THIS PARTITION
        MOV     EAX,DWORD PTR R0
        MOV     [EBX],EAX
        MOV     EAX,DWORD PTR R4
        MOV     [EBX+4],EAX
        MOV     EAX,AUX00
        MOV     [EBX+8],EAX
        MOV     EAX,AUX01
        MOV     [EBX+12],EAX
        MOV     EAX,AUX02
        MOV     [EBX+16],EAX
        MOV     EAX,AUX03
        MOV     [EBX+20],EAX
        MOV     [EBX+24],EDX
        MOV     [EBX+28],CX
        MOV     AL,K
        MOV     [EBX+30],AL
        MOV     EAX,DWORD PTR A1
        MOV     [EBX+32],EAX
        MOV     AL,K
        AND     EAX,0FFH
        MOV     AUX01,EAX
        RET

;         TITLE     REGRSTR
;******************************************************************************
;* THIS ROUTINE RESTORES THE CHCL, PHPL, AUX0 -  AUX3, AND F0 - F7 REGISTERS TO
;* THIER ORIGINAL STATE BEFORE THE PRINTER DRIVER WAS CALLED.
;*
;* ENTRY:  NOTHING SPECIAL
;* EXIT:     CHCL, PHPL, F0 - F1, AUX0 - AUX3 ARE RESTORED TO THEIR ORIGINAL STATES
;* MODIFIED REGISTERS:  CHCL, PHPL, F0 - F7, AUX0 - AUX3
;*
REGRSTR:
        MOV     EBX,OFFSET DREGSTOR
        XOR     EAX,EAX
        MOV     AL,PART_
        SHL     EAX,6           ; 64 BYTES PER PARTITION
        ADD     EBX,EAX         ;ADDRESS OF START OF STORE FOR THIS PARTITION
        MOV     EAX,[EBX]
        MOV     DWORD PTR R0,EAX
        MOV     EAX,[EBX+4]
        MOV     DWORD PTR R4,EAX
        MOV     EAX,[EBX+8]
        MOV     AUX00,EAX
        MOV     EAX,[EBX+12]
        MOV     AUX01,EAX
        MOV     EAX,[EBX+16]
        MOV     AUX02,EAX
        MOV     EAX,[EBX+20]
        MOV     AUX03,EAX
        MOV     EDX,[EBX+24]
        MOV     CX,[EBX+28]
        MOV     AL,[EBX+30]
        MOV     K,AL
        MOV     EAX,[EBX+32]
        MOV     DWORD PTR A1,EAX
        RET

;         TITLE     GETSTAT
;*******************************************************************************
;* THIS ROUTINE POINTS THE PC'S TO STATUS WORD 1 OF A PARTITION'S ENTRY IN THE
;* DRIVER STATUS TABLE.
;*
;* ENTRY: PHPL AND CHCL ARE FREE TO BE USED
;* EXIT:  CH = PARTITION NUMBER, PHPL = CONTROL MEMORY ADDRESS OF FIRST STATUS WORD
;* MODIFIED REGISTERS: CHCL, PHPL
;*
GETSTAT1: MOV       CH,PART_    ;GET PARTITION NUMBER
          MOV       EDX,OFFSET DRVRSTAT ;POINT PC'S AT STATUS TABLE
GETSTATX: MOV       EAX,0       ;CH*3 = DISPLACEMENT INTO TABLE
          MOV       AL,CH
          PUSH      EAX         ;ADDRESS = START + PART # * 9
;****************************************************************
;       EACH PARTITION HAS THREE STATUS WORDS
;       EACH STATUS WORD HAS THREE BYTES
;       ADDRESS INCREASE ONE IN CONTROL MEMORY (WORD ORIENTED)
;   =   ADDRESS INCREASE THREE IN CS-386 MEMORY ( BYTE ORIENTED)
;****************************************************************
          SHL    EAX,3          ;PART# x 8
          ADD    EDX,EAX        ;START + PART#X8
          POP    EAX
          ADD    EDX,EAX        ;EDX= ADDRESS OF STATUS WORD 1
          RET

;         TITLE     READ AND WRITE STATUS
;*******************************************************************************
;* THESE ROUTINES POINT TO THE REQUESTED STATUS WORD OF A PARTITION'S ENTRY IN THE
;* DRIVER STATUS TABLE AND READ IT INTO K, PH, & PL
;*
;* ENTRY: NONE
;* EXIT: CH = PARTITION NUMBER, K,PH,PL = DRIVER STATUS WORD
;* TRASHED REGISTERS: CHCL, PHPL, K
;*
RDSTAT2:  MOV       CH,PART_    ;POINT TO STATUS WORD 2
          MOV       EDX,OFFSET DRVRSTAT
          ADD       EDX,3
          CALL      GETSTATX
;         JMP       RCM         ;READ IT AND RETURN
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          RET
;*
RDSTAT3:  MOV       CH,PART_    ;POINT TO STATUS WORD 3
          MOV       EDX,OFFSET DRVRSTAT
          ADD       EDX,6
          CALL      GETSTATX
;         JMP       RCM         ;READ IT AND RETURN
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          RET

;*******************************************************************************
;* THESE ROUTINES POINT TO THE REQUESTED STATUS WORD OF A PARTITION'S ENTRY IN THE
;* DRIVER STATUS TABLE AND UPDATE IT USING K, PH, & PL
;*
;* ENTRY: K,PH,PL = DRIVER STATUS WORD
;* EXIT: STATUS WORD SAVED
;* TRASHED REGISTERS: CHCL, PHPL, K
;*
WRTSTAT2: MOV       AUX00,EDX
          MOV       CH,PART_    ;POINT TO STATUS WORD 3
          MOV       EDX,OFFSET DRVRSTAT
          ADD       EDX,3
          CALL      GETSTATX    ;POINT TO STATUS WORD 2
;         JMP       WCM         ;WRITE IT AND RETURN
          MOV       AL,K        ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX
          RET

WRTSTAT3: MOV       AUX00,EDX
          MOV       CH,PART_    ;POINT TO STATUS WORD 3
          MOV       EDX,OFFSET DRVRSTAT
          ADD       EDX,6
          CALL      GETSTATX
;         JMP       WCM         ;WRITE IT AND RETURN
          MOV       AL,K        ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX
          RET


;         TITLE     ESCADDR
;*******************************************************************************
;*  THIS ROUTINE IS USED TO FIND THE ADDRESS OF THE START OF THE ESCAPE SEQUENCE
;*  TRANSLATION TABLE FOR THE ACTIVE DRIVER.
;*
;* ENTRY: NONE (ESCAPE TABLE ADDRESS SET UP BY ENABLE DEVICE)
;* EXIT: PHPL = 16 BIT ADDRESS OF TRANSLATION TABLE
;* REGISTERS TRASHED: PHPL
;*
;ESCADDR  LPI       ESCTABL   POINT TO ESCAPE TABLE ADDRESS
;         SBR       RCM       READ IT AND RETURN

;
; WE HAVE ALTERED ECSTABLE =====> DEFINE DWORD
;

ESCADDR:  MOV       EDX,ESCTABL
          RET

;         TITLE     GETDRDEV
;*******************************************************************************
;*  THIS ROUTINE LOOKS UP THE ENTRY IN THE DRIVER DEVICE LIST THAT HAS THE
;*  ADDRESS FOUND IN F0.
;*
;*  ENTRY: F0 HOLDS ADDRESS TO FIND
;*  EXIT: IF FOUND  -  F2F1 POINT TO BIT MAP FOR THE ADDRESS
;*                     PL = DRIVER #, PH = TERMINAL ADDRESS
;*        IF NOT FOUND  -  F2F1 = 0000, PHPL INVALID

;
; TWO WORDS PER UNIT
;
; WE HAVE ALTERED F2F1 =====> A2A1 FOR ADDRESS TO BIT MAP
; IN REGHOLD WE NEED TO HOLD A2A1 OR NOT ?
;

;*  REGISTERS MODIFIED: PHPL, F1-F3, K, CHCL
;*
GETDRDEV: MOV       R3,0
          MOV       EDX,OFFSET DRVRDEV  ;PHPL = BASE ADDRESS OF DRIVER DEVICE LIST
          MOV       DWORD PTR A1,EDX    ;SAVE ADDRESS IN F2F1
DRDEV1:                                 ;READ NEXT ENTRY
          MOV       AL,[EDX+2]          ;+- RCM
          MOV       K,AL                ;term# assigned to this driver
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX               ;+- RCM
          CMP       R3,DH               ;BRANCH IF NO DRIVER THIS ADDRESS
          JE        NOGOTCHA
          CMP       R0,DH               ;BRANCH IF FOUND,type match
          JE        GOTCHA
DRDEV1A:  ADD       DWORD PTR A1,12     ;STEP TO NEXT ENTRY
          MOV       EDX,DWORD PTR A1    ;SET PHPL TO NEXT ENTRY
          JMP       DRDEV1              ;GO AND PLAY WITH IT
GOTCHA:   PUSH      EDX                 ;TEMP. SAVE DRIVER NUMBER
          MOV       R3,4
          CMP       R3,DH               ;BRANCH IF NOT TERM. PRINTER
          JNE       GOTCHA1
          MOV       EDX,OFFSET PTERM    ;SEE IF ITS OUR TERMINAL PRINTER
          MOV       EAX,0
          MOV       AL,PART_
          ADD       EDX,EAX
;         MOV       CH,[EDX]            ;GET TERMINAL ADDRESS
;         AND       CH,0DFH             ;MASK DETACH
          MOV       CH,[EDX+PARTMAX]    ;XPTERM ENTRY,TERM#
          MOV       AL,K                ;term# assigned to this driver
;-------- u64 ---------------
          AND       AL,3FH
          DEC       AL                  ;change K(TERM#) to xx00yyyy

          PUSH      EBX                 ;--TSAI,03-18-92 ----
          MOVZX     EBX,AL
          MOV       AL,[EBX+OFFSET TEMADRTBL]
          POP       EBX                 ;--TSAI,03-18-92 ----

          MOV       AH,AL               ;and xx000yyy format
          MOV       R3,AH
;         AND       AH,0C3H
;         MOV       R4,AH
          CMP       R3,CH               ;BRANCH IF TERMINAL NUMBERS MATCH
;         CMP       WORD PTR R3,CX
;-------- u64e ---------------
          JE        GOTCHA1
          MOV       R3,0
          POP       EDX                 ;CLEAN STACK FOR NEXT TRY
          JMP       DRDEV1A             ;BRANCH TO CHECK NEXT
GOTCHA1:  ADD       DWORD PTR A1,3      ;POINT F2F1 TO BIT MAP FOR THIS ADDRESS
          POP       EDX                 ;RECALL DRIVER NUMBER
;         MOV       DH,CH               ;PH = TERMINAL ADDRESS
          MOV       DH,CL               ;u64
          RET
NOGOTCHA: MOV       DWORD PTR A1,0      ;IF NOT FOUND F2F1 = 0000
          RET

;         TITLE     ESCAPE
;*******************************************************************************
;*******************************************************************************
;*  THIS FILE CONTAINS THE ESCAPE SEQUENCE ROUTINES, THE ESCAPE SEQUENCE DECODER,
;*  AND THE ESCAPE SEQUENCE TRANSLATION TABLE MANAGER.  THIS IS FILE #3 OF THE
;*  2200 GENERALIZED PRINTER DRIVER MODULE.
;*******************************************************************************
;*******************************************************************************
;*
;*
;*
;* THIS PROGRAM IS THE ESCAPE SEQUENCE DECODER FOR THE GENERALIZED PRINTER
;* DRIVER. IT IS CALLED BY THE MAIN PROGRAM AND CALLS THE ESCAPE SEQUENCE ROUTINES
;* WHEN A TERMINATED SEQUENCE IS FOUND
;*
;*
;* ENTRY: F0 - F2 CONTAIN DRIVER STATUS WORD 1, AUX1 = THE INPUT,
;*
;* EXIT:  WHEN SEQUENCE FOUND INVALID:  ESCAPE SEQUENCE POINTER = 0, ESCAPE MODE FLAG
;*                         OFF, ESCAPE MODE ERROR FLAG ON, F0 - F2 = STATUS WORD 1
;*        WHEN SEQUENCE FOUND TO CONTINUE: F0 - F2 = UPDATED DRIVER STATUS WORD 1
;*        WHEN SEQUENCE FOUND TO TERMINATE: F0 - F2 = UPDATED DRIVER STATUS WORD 1
;*
;* MODIFIED REGISTERS: F0 - F7, PHPL, K, AUX0, AUX2
;*
;*
ESCAPE:   MOV       EDX,OFFSET ESCDECOD    ;POINT PC'S AT ESCAPE DECODING TABLE
          MOV       EAX,0
          MOV       AL,R1
          MOV       BL,3
          MUL       BL
          ADD       EDX,EAX     ;ADD IN DISPLACEMENT INTO SEQUENCE
          MOV       AUX00,EDX   ;SAVE PHPL
;         CALL      RCM         ;READ NEXT WORD OF DECODING SEQUENCE
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       AL,K
          AND       AL,07FH
          MOV       R3,AL       ;F3 = 1ST BYTE OF DECODING WORD
          MOV       R4,DH       ;F4 = 2ND BYTE OF DECODING WORD
          MOV       R5,DL       ;F5 = 3RD BYTE OF DECODING WORD
          MOV       EDX,AUX01
          MOV       R6,DL       ;F6 = INPUT CODE
          TEST      R3,0F0H     ;IF F3 <> 0X THEN BRANCH
          JNZ       SITT5
          TEST      R3,0FH      ;BRANCH IF F3 NOT = 00
          JNZ       SITT1
          MOV       AL,R6
          CMP       AL,R4       ;BRANCH IF INPUT NOT = F4
          JNE       DIEQUIK
          MOV       AL,R5
          MOV       R1,AL       ;UPDATE ESCAPE SEQUENCE POINTER
          RET
SITT1:    MOV       AL,R3
          AND       AL,0FH
          CMP       AL,1
          JNE       SITT2       ;BRANCH IF F3 NOT = 01
          MOV       AL,R5
          MOV       R1,AL       ;UPDATE ESCAPE SEQUENCE POINTER
          CALL      RDSTAT2     ;READ WORD 2
          MOV       DL,R6       ;PLACE INPUT INTO WORD 2
          JMP       SITT31
SITT2:    CMP       AL,2
          JNE       SITT3       ;BRANCH IF F3 NOT = 02
          MOV       AL,R5
          MOV       R1,AL       ;UPDATE ESCAPE SEQUENCE POINTER
          CALL      RDSTAT2     ;READ WORD 2
          MOV       DH,R6       ;PLACE INPUT INTO WORD 2
          JMP       SITT31      ;RETURN
SITT3:    CMP       AL,3        ;BRANCH IF F3 NOT = 03
          JNE       SITT4
          MOV       AL,R5
          MOV       R1,AL       ;UPDATE ESCAPE SEQUENCE POINTER
          CALL      RDSTAT2     ;READ WORD 2
          MOV       AL,R6
          MOV       K,AL        ;PLACE INPUT INTO WORD 2
SITT31:   CALL      WRTSTAT2    ;SAVE STATUS WORD 2
          RET
SITT4:    CMP       AL,0FH      ;BRANCH IF F3 NOT = 0F
          JNE       SITT6
          MOV       AL,R6
          CMP       AL,R4       ;BRANCH IF INPUT NOT = F4
          JNE       DIEQUIK
          JMP       SITT51
SITT5:
          CMP       R3,1FH
          JNE       DIEQUIK     ;BRANCH IF F3 NOT = 1F
          MOV       AL,R6
          MOV       R1,AL       ;PLACE INPUT INTO WORD 1
SITT51:   CALL      ESCRTNS     ;CALL ESCAPE SEQUENCE ROUTINES
          AND       R0,0EFH     ;TURN OFF ESCAPE MODE FLAG
          push      eax
          mov       eax,dword ptr [cpbase]
          mov       byte ptr [eax].@escflag,0
          pop       eax
          RET
SITT6:    CMP       AL,0EH      ;BRANCH IF F3 NOT = 0E
          JNE       DIEQUIK
          MOV       R7,0        ;SET UP LOOP COUNTER
          MOV       DL,R5
          MOV       AUX02,EDX   ;SAVE NUMBER OF POSSIBILITIES
NEXTPOS:  INC       R1          ;INCREMENT ESCAPE SEQUENCE POINTER
          MOV       EDX,OFFSET ESCDECOD
          MOV       EAX,0
          MOV       AL,R1       ;ADD IN DISPLACEMENT
          MOV       BL,3
          MUL       BL
          ADD       EDX,EAX     ;READ IN NEXT DECODING WORD
;         CALL      RCM         ;DO THE READ
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       AL,K
          AND       AL,07FH
          MOV       R3,AL       ;F3 = 1ST BYTE OF NEW DECODING WORD
          MOV       R4,DH       ;F4 = 2ND BYTE OF NEW DECODING WORD
          MOV       R5,DL       ;F5 = 3RD BYTE OF NEW DECODING WORD
          MOV       AL,R6
          CMP       AL,R4       ;BRANCH IF F4 NOT = INPUT
          JNE       LOOPEND
          TEST      R3,0F0H     ;ERROR IF F3 NOT = 0X
          JNZ       DIEQUIK
          TEST      R3,0FH      ;BRANCH IF F3 NOT = 00
          JNZ       CHECK0F
          MOV       AL,R5
          MOV       R1,AL       ;UPDATE ESCAPE SEQUENCE POINTER
          RET
CHECK0F:  MOV       AL,R3
          AND       AL,0FH
          CMP       AL,0FH
          JNE       DIEQUIK     ;ERROR IF F3 NOT = 0F OR 00
          CALL      ESCRTNS     ;CALL ESCAPE SEQUENCE ROUTINES
          JMP       DIEQUIK1    ;BRANCH
LOOPEND:  INC       R7          ;INCREMENT LOOP COUNTER
          MOV       EDX,AUX02   ;RECALL NUMBER OF POSSIBILITIES
          CMP       R7,DL       ;BRANCH IF MORE POSSIBILITIES
          JNE       NEXTPOS

DIEQUIK:  JMP       ESCERROR    ;GO FLAG THE ERROR
DIEQUIK1: AND       R0,0EFH     ;TURN OFF ESCAPE MODE FLAG
          MOV       R1,0        ;SET ESCAPE SEQUENCE POINTER TO 0
          push      eax
          mov       eax,dword ptr [cpbase]
          mov       byte ptr [eax].@escflag,0
          pop       eax
          RET

;         TITLE     ESCJUMP
;*******************************************************************************
;* THIS ROUTINE CALLS THE ESCAPE SEQUENCE ROUTINE THAT CORRESPONDS TO THE NUMBER
;* IN THE F5 REGISTER.
;*
;* ENTRY: F0 - F2 = STATUS WORD 1, F5 = NUMBER ID OF ESCAPE SEQUENCE
;* EXIT: CONTROL TRANSFERRED TO THE APPROPRIATE ROUTINE
;* MODIFIED REGISTERS: F3, F6, F7, PHPL
;*
ESCRTNS:  MOV       R3,27H      ;SEE IF ESCAPE SEQUENCE NUMBER GOOD
          CMP       R5,27H      ;BRANCH IF OUT OF RANGE
          JA        ESCJUMP_1
          MOV       EDX,OFFSET ESCJUMP ;COMPUTE ADDRESS INTO JUMP TABLE
          MOV       EAX,0
          MOV       AL,R5
          MOV       BL,5        ; OCCUPY  5  BYTES PER JMP NEAR INSTRUCTION
          MUL       BL
          ADD       EDX,EAX
          PUSH      EDX         ;SET UP FOR JUMP
ESCJUMP_1:
          RET
ESCJUMP:
          JMP       ESCRET      ;JUST RETURN
          JMP       DIAGNOST    ;CALL START DIAGNOSTICS ROUTINE
          JMP       SELFONT0    ;CALL SELECT FONT 0 ROUTINE
          JMP       SELFONT1    ;CALL SELECT FONT 1 ROUTINE
          JMP       SELFONT2    ;CALL SELECT FONT 2 ROUTINE
          JMP       CLRPLATN    ;CALL CLEAR PLATTEN ROUTINE
          JMP       OEOE        ;CALL 0E W/ 0E ENDING DEFINITION ROUTINE
          JMP       OEOF        ;CALL 0E W/ 0F ENDING DEFINTION ROUTINE
          JMP       HORZTABC    ;CALL HORIZONTAL TAB ROUTINE
          JMP       HORZTABI    ;CALL HORIZONTAL TAB BY INCHES ROUTINE
          JMP       PAPRTRY1    ;CALL SELECT PAPER TRAY 1 ROUTINE
          JMP       PAPRTRY2    ;CALL SELECT PAPER TRAY 2 ROUTINE
          JMP       DESELECT    ;CALL DESELECT PRINTER ROUTINE
          JMP       SUPERON     ;CALL ENABLE SUPERSCRIPT ROUTINE
          JMP       SUPEROFF    ;CALL DISABLE SUPERSCRIPT ROUTINE
          JMP       SUBON       ;CALL ENABLE SUBSCRIPT ROUTINE
          JMP       SUBOFF      ;CALL DISABLE SUBSCRIPT ROUTINE
          JMP       UNDERON     ;CALL ENABLE UNDERSCORE ROUTINE
          JMP       UNDEROFF    ;CALL DISABLE UNDERSCORE ROUTINE
          JMP       OVERON      ;CALL ENABLE OVERSTRIKE ROUTINE
          JMP       OVEROFF     ;CALL DISABLE OVERSTRIKE ROUTINE
          JMP       PITCH       ;CALL SELECT PITCH ROUTINE
          JMP       LFSEALF     ;CALL LINE FEED SPACING + AUTO LF ROUTINE
          JMP       LFSDALF     ;CALL LINE FEED SPACING - AUTO LF ROUTINE
          JMP       ENABLLF     ;CALL ENABLE AUTO LINE FEED ROUTINE
          JMP       DISABLF     ;CALL DISABLE AUTO LINE FEED ROUTINE
          JMP       PLINEF14    ;CALL 1/4 LINE FEED ROUTINE
          JMP       PLINEF12    ;CALL 1/2 LINE FEED ROUTINE
          JMP       PLINEF34    ;CALL 3/4 LINE FEED ROUTINE
          JMP       LMARGIN     ;CALL SET LEFT MARGIN ROUTINE
          JMP       PROPRON     ;CALL ENABLE PROPORTITIONAL SPACING ROUTINE
          JMP       PROPOFF     ;CALL DISABLE PROPORTITIONAL SPACING ROUTINE
          JMP       FLENGTH     ;CALL SET FORM LENGTH ROUTINE
          JMP       LNGHINCH    ;CALL SET FORM LENGTH IN INCHES ROUTINE
          JMP       TTRANS      ;CALL ENTER TEMP. TRANSPARENCY ROUTINE
          JMP       RSTDEF      ;CALL RESTORE DEFAULTS ROUTINE
          JMP       PAPRTRY3    ;CALL SELECT PAPER TRAY 3 ROUTINE
          JMP       REVRSELF    ;CALL REVERSE LINE FEED ROUTINE
          JMP       SLCTPNTR    ;CALL SELECT PRINTER ROUTINE
          JMP       COLOR       ;CALL SELECT COLOR ROUTINE

;         TITLE     ESCAPE SEQUENCE ROUTINES
;********************************************************************************
;*
;* THIS FILE CONTAINS THE ESCAPE SEQUENCE ROUTINES USED BY THE 2200 GENERALIZED
;* PRINTER DRIVER.
;*
;*******************************************************************************
ESCRET:
        RET

;*******************************************************************************
;*
;*  THIS ROUTINE STARTS THE ON BOARD DIAGNOSTICS FOR THE PRINTER.  A CARRIAGE
;*  RETURN, A LINE FEED AND A FORM FEED ARE ISSUED BEFORE STARTING THE DIAGNOSTICS.
;*  THIS WILL CAUSE THE CONTENTS OF THE PRINTER'S BUFFER TO BE PRINTED AND WILL
;*  GET A NEW PAGE TO KEEP DIAGNOSTIC OUTPUT FROM MESSING UP THE LAST PAGE THAT
;*  WAS PRINTED.
;*
;*  ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID
;*  EXIT:
;*  REGISTERS MODIFIED: F3, PH, PL, AUX3, AUX1
;*
DIAGNOST: CALL      ESCCHECK    ;SEE IF SEQUENCE IS SUPPORTED FOR THIS PRINTER
          MOV       EDX,0DH     ;PHPL = CARRIAGE RETURN CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      CARRTN      ;PRINT IT
          MOV       EDX,0AH     ;PHPL = LINE FEED CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      LINEFEED    ;PRINT IT
          MOV       EDX,0CH     ;PHPL = FORM FEED CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      FORMFEED    ;PRINT IT
          JMP       TRANESC     ;SEND TRANSLATION STRING TO PRINTER

;*******************************************************************************
;*
;* THIS ROUTINE IS USED BY THOSE ESCAPE SEQUENCES THAT NEED A CARRIAGE RETURN ISSUED
;* BEFORE THEY PREFORM THIER ACTIONS.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID
;* EXIT:
;* REGISTERS MODIFIED: AUX3, PH, PL, F3, AUX1
;*
;* THE FOLLOWING ESCAPE SEQUENCE ROUTINE LABLES ALL POINT TO THIS ROUTINE:
;*      DESELECT, SELFONT0, SELFONT1, SELFONT2, PAPRTRY1, PAPRTRY2
;*
DESELECT:                       ;EQUATE THE ABOVE LABLES TO
SLCTPNTR  EQU       DESELECT
SELFONT0  EQU       DESELECT    ;THIS ADDRESS
SELFONT1  EQU       DESELECT
SELFONT2  EQU       DESELECT
PAPRTRY1  EQU       DESELECT
PAPRTRY2  EQU       DESELECT
PAPRTRY3  EQU       DESELECT
COLOR     EQU       DESELECT
          CALL      ESCCHECK    ;SEE IF SEQUENCE IS SUPPORTED FOR THIS PRINTER

          MOV       EDX,0DH     ;PHPL = CARRIAGE RETURN CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      TRANCHAR    ;PRINT IT WITHOUT AN AUTOMATIC LINE FEED
          JMP       TRANESC     ;SEND TRANSLATION STRING TO THE PRINTER

;         TITLE     CLEAR PLATTEN
;***********************************************************************************
;* THIS ROUTINE HANDLES THE CLEAR PLATTEN ESCAPE SEQUENCE.  A CARRIAGE RETURN AND
;* A LINE FEED ARE ISSUED BEFORE THE TRANSLATION STRING TO PRINT THE CONTENTS OF
;* THE BUFFER.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID
;* EXIT:
;* REGISTERS MODIFIED: F3, AUX3, AUX1, PHPL
;*
CLRPLATN: CALL      ESCCHECK    ;SEE IF SEQUENCE IS SUPPORTED
          MOV       EDX,0DH     ;PHPL = CARRIAGE RETURN CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      CARRTN      ;PRINT IT
          MOV       EDX,0AH     ;PHPL = LINE FEED CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      LINEFEED    ;PRINT IT
          CALL      RDSTAT3     ;GET LINE COUNT, ZERO IT OUT AND...
          MOV       DL,0
          CALL      WRTSTAT3    ;SAVE UPDATED COUNT
          JMP       TRANESC     ;SEND TRANSLATION STRING TO THE PRINTER

;         TITLE     DEFINE 0E
;********************************************************************************
;*
;* THIS ROUTINE IS THE CODE THAT HANDLES THE HEX (0E) DEFINITION ESCAPE SEQUENCE...
;* FOR DEFINITIONS THAT END WITH A HEX(0E). AFTER CLEARING AND RESETTING THE
;* SWITCHES, CALL OESTART TO TURN ON THE SET OPTIONS.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PHPL, F0 - F3, AUX1
;*
OEOE:     MOV       EDX,AUX01
          PUSH      EDX         ;SAVE INPUT CODE
          MOV       EDX,0FH
          MOV       AUX01,EDX   ;SET UP TO......
          CALL      OFEND       ;AND TURN OFF OLD 0E SETTINGS
          POP       EDX
          MOV       AUX01,EDX   ;RESTORE INPUT CODE
          AND       R0,0F0H     ;TURN OFF 0E SWITCHES
          MOV       R3,0        ;FOR COMPARISIONS
          CALL      RDSTAT2     ;GET STAUS WORD 2
          CMP       R3,DL       ;BRANCH IF NO OVERSTRIKE
          JE        OEOE1
          OR        R0,08H      ;TURN ON OVERSTRIKE

OEOE1:    CMP       R3,DH       ;BRANCH IF NO UNDERSCORE
          JE        OEOE2
          OR        R0,04H      ;TURN ON UNDERSCORE
OEOE2:    AND       K,07FH      ;STRIP OFF PARITY BIT
          MOV       AL,R3
          CMP       AL,K        ;BRANCH IF NO EMPHASIZED PRINT
          JE        OEOE3
          OR        R0,02H      ;TURN ON EMPHASIZED PRINT
OEOE3:    MOV       EDX,0EH     ;PHPL = HEX(0E)
          MOV       AUX01,EDX   ;SAVE IT
          JMP       OESTART1    ;TURN ON NEW 0E SETTINGS

;********************************************************************************
;*
;* THIS ROUTINE IS THE CODE THAT HANDLES THE HEX (0E) DEFINITION ESCAPE SEQUENCE...
;* FOR DEFINITIONS THAT END WITH A HEX(0F). AFTER CLEARING AND RESETTING THE
;* SWITCHES, RETURN TO CALLING PROGRAM.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PHPL, F0 - F3, AUX1
;*
OEOF:     CALL      OFEND       ;TURN OFF OLD 0E SETTINGS
          AND       R0,0F0H     ;TURN OFF 0E SWITCHES
          MOV       R3,0        ;FOR COMPARISIONS
          CALL      RDSTAT2     ;GET STAUS WORD 2
          CMP       R3,DL       ;BRANCH IF NO OVERSTRIKE
          JE        OEOF1
          OR        R0,08H      ;TURN ON OVERSTRIKE
OEOF1:    CMP       R3,DH       ;BRANCH IF NO UNDERSCORE
          JE        OEOF2
          OR        R0,04H      ;TURN ON UNDERSCORE
OEOF2:    OR        R0,01H      ;TURN ON '0F ENDING' BIT
          AND       K,07FH      ;STRIP OFF PARITY BIT
          MOV       AL,R3
          CMP       AL,K
          JE        OEOF3       ;BRANCH IF NO EMPHASIZED PRINT
          OR        R0,02H      ;TURN ON EMPHASIZED PRINT
OEOF3:    RET                   ;YANKEE GO HOME

;         TITLE     HORIZONTAL TAB
;**********************************************************************************
;*
;* THIS ROUTINE CONTROLS THE HORIZONTAL TAB ESCAPE SEQUENCE ACTIONS.  THE CARRIAGE
;* IS MOVED TO THE GIVEN COLUMN UNLESS THAT COLUMN IS BEYOND THE DEFINED LINE LENGTH.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE NUMBER ID, CHARCNT = SYSTEM CHARACTER COUNT
;*        BYTES 0 - 7 OF STATUS WORD 2 = DESTINATION COLUMN NUMBER
;* EXIT: CHARCNT UPDATED TO REFLECT NEW VALUE
;* REGISTERS MODIFIED: PH, PL, AUX1, AUX3, F3
;*
HORZTABC: CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       R3,DL       ;SAVE DESTINATION IN F3
          CMP       R3,0        ;COLUMN 0 = COLUMN 1 SO...
          JNE       HORZTABA
          MOV       R3,01H      ;CHANGE 0 TO 1 IF THATS WHAT THEY WANT
HORZTABA: MOV       EDX,CHARCNT ;GET SYSTEM CHAR. COUNT AND LINE LENGTH
          CMP       R3,DH       ;IF DESTINATION IS BEYOND DEFINED
          JBE       HORZTABB
HORTBOUT: RET                   ;LINE LENGTH, BRANCH TO EXIT

HORZTABB: MOV       DL,R3       ;UPDATE SYSTEM CHARACTER COUNT
          MOV       CHARCNT,EDX ;AND SAVE IT
          MOV       AUX03,EDX   ;ALSO SAVE IT IN AUX3
          MOV       EDX,0DH     ;RETURN TO BEGINNING OF LINE
          MOV       AUX01,EDX   ;SAVE CARRIAGE RETURN CODE IN AUX1
          CALL      TRANCHAR    ;PRINT IT WITHOUT ANY LINE FEEDS

TABMORE:  MOV       EDX,AUX03   ;RECALL DISTANCE TO DESTINATION
          DEC       EDX         ;DISTANCE = DISTANCE - 1
          CMP       DL,0
          JE        HORTBOUT    ;EXIT IF AT DESTINATION
          MOV       AUX03,EDX   ;SAVE DISTANCE
          MOV       EDX,20H     ;PHPL = SPACE CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      TRANCHAR    ;PRINT IT
          JMP       TABMORE     ;PLAY IT AGAIN SAM........

;*********************************************************************************
;*  THIS ROUTINE HANDLES TAB BY INCHES AND QUARTER INCHES.  IF THE TAB WILL EXTEND
;*  BEYOND THE END OF LINE, THE TAB IS NOT DONE.
;*
;* ENTRY: STATUS WORD 2 = NUMBER OF INCHES AND QUARTER INCHES TO TAB
;*        STATUS WORD 3 = PITCH NUMBER
;* EXIT:  TAB DONE AND CHARATER COUNT UPDATED
;* REGISTERS MODIFIED: PHPL, AUX0, AUX3, F3 - F7
;*
HORZTABI: CALL      RDSTAT3     ;READ STATUS WORD 3
          MOV       AL,K
          SHR       AL,4
          MOV       R4,AL       ;F4 = PITCH NUMBER
          MOV       R5,0        ;F5 = 00
          AND       AL,0FH
          CMP       AL,1        ;BRANCH IF NOT 5 PITCH
          JNE       HORZTAB1
          MOV       R4,05       ;F4 = # OF PRINT POSITIONS PER INCH
          JMP       GETINCH

HORZTAB1: CMP       AL,2        ;BRANCH IF NOT 10 PITCH
          JNE       HORZTAB2
          MOV       R4,0AH      ;F4 = # PRINT POSITIONS PER INCH
          JMP       GETINCH

HORZTAB2: CMP       AL,3        ;BRANCH IF NOT 12 PITCH
          JNE       HORZTAB3
          MOV       R4,0CH      ;F4 = # PRINT POSITIONS PER INCH
          JMP       GETINCH
HORZTAB3: CMP       AL,4        ;BRANCH IF NOT 15 PITCH
          JNE       HORZTAB4
          MOV       R4,0FH      ;F4 = # PRINT POSITIONS PER INCH
          JMP       GETINCH

HORZTAB4: MOV       R4,10H      ;F4 = # PRINT POSITIONS FOR 16.5 PITCH
GETINCH:  CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       R3,DL       ;F3 = NUMBER OF INCHES TO TAB
          PUSH      EDX
          MOV       WORD PTR R6,0
INCHES:   TEST      R3,0FH      ;BRANCH IF NO WHOLE INCHES
          JZ        GETQRTRS
          DEC       R3          ;DECREMENT # OF INCHES
          MOV       AX,WORD PTR R4
          ADD       WORD PTR R6,AX  ;ADD IN # OF POSITIONS THIS INCH
          JMP       INCHES      ;DO NEXT INCH
GETQRTRS: MOV       DX,WORD PTR R6
          MOV       AUX03,EDX   ;SAVE NUMBER OF POSITIONS TO TAB IN AUX3
          POP       EDX
          MOV       R3,DH       ;F3 = # OF 1/4 INCHES
          MOV       R6,03H      ;INSURE NO MORE THAN 3 1/4 INCHES
          CMP       R3,03H
          JA        HOZTOUT     ;IF MORE THAN 3 "1/4'S" ....
          TEST      R3,0FH      ;BRANCH IF NO QUARTER INCHES
          JZ        HRZTAB6A
          MOV       R6,0
          MOV       R7,04H
          MOV       R5,03H
HORZTAB5: INC       R6          ;FIND # OF POSITIONS PER 1/4 INCH
          MOV       AL,R7
          SUB       R4,AL       ;# POSITIONS/INCH = # POSITIONS/INCH - 4
          MOV       AL,R4
          CMP       AL,R5       ;BRANCH IF < 4 POSITIONS LEFT
          JBE       HORZTAB6
          JMP       HORZTAB5
HORZTAB6: MOV       AL,R6       ;F4 = # POSITIONS PER 1/4 INCH
          MOV       R4,AL
HRZTAB6A: MOV       R5,0
          MOV       EDX,AUX03
          MOV       WORD PTR R6,DX   ;RECALL # OF POSITIONS TO TAB
HORZTAB7: TEST      R3,0FH      ;BRANCH IF NO 1/4 INCHES LEFT
          JZ        TABCHECK
          DEC       R3          ;DECREMENT NUMBER OF 1/4 INCHES
          MOV       AX,WORD PTR R4
          ADD       WORD PTR R6,AX    ;ADD IN # POSITIONS THIS 1/4 INCH
          JMP       HORZTAB7    ;DO NEXT QUARTER INCH
TABCHECK: MOV       EDX,CHARCNT ;GET LINE LENGTH AND CHARACTER COUNT
          MOV       AL,R6
          MOV       R5,DL
          ADD       R5,AL       ;F5 = FINAL CHARACTER COUNT
          CMP       R5,DH       ;IF FINAL CHARACTER COUNT > THAN....
          JBE       HORZTAB8
HOZTOUT:  RET                   ;LINE LENGTH, THEN RETURN
HORZTAB8: MOV       DL,R5       ;ELSE SAVE NEW CHARACTER COUNT
          MOV       CHARCNT,EDX
DOTAB:    CMP       R6,0
          JNE       DOTAB1      ;EXIT IF TAB FINISHED
          CMP       R7,0
          JE        HOZTOUT
DOTAB1:   MOV       R4,01
          MOV       R5,0        ;F5F4 = 0001
          MOV       AX,WORD PTR R4
          SUB       WORD PTR R6,AX  ;DECREMENT # POSITIONS TO TAB
          MOV       DX,WORD PTR R6
          MOV       AUX03,EDX   ;SAVE # POSITIONS TO TAB IN AUX3
          MOV       EDX,20H     ;PHPL = SPACE CODE
          MOV       AUX01,EDX   ;SAVE IN AUX1
          CALL      TRANCHAR    ;PRINT A SPACE
          MOV       EDX,AUX03
          MOV       WORD PTR R6,DX   ;RECALL # POSITIONS TO TAB
          JMP       DOTAB       ;DO NEXT SPACE

;         TITLE     SUPERSCRIPT
;*******************************************************************************
;*
;*  THIS ROUTINE IS WHAT TURNS ON SUPERSCRIPT MODE FOR THE SUPERSCRIPT ON ESCAPE
;*  SEQUENCE.  ISSUE NO CARRIAGE RETURNS, SPACES, LINE FEEDS OR FORM FEEDS.
;*
;* ENTRY: F5 = SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1,
;* EXIT: SUPERSCRIPT ON, STAUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PH, PL, F0 - F2, F3, AUX3
;*
SUPERON:  TEST      R2,1        ;BRANCH IF SUPERSCRIPT IS ALREADY ON
          JNZ       SUPEROUT
          CALL      ESCCHECK    ;SEE IF IT IS SUPPORTED
          OR        R2,1        ;TURN ON SUPERSCRIPT FLAG
          CALL      TRANESC     ;SEND TRANSLATION TO THE PRINTER
SUPEROUT: RET

;*******************************************************************************
;*
;*  THIS ROUTINE IS WHAT TURNS OFF SUPERSCRIPT MODE FOR THE SUPERSCRIPT OFF ESCAPE
;*  SEQUENCE.  ISSUE NO CARRIAGE RETURNS, SPACES, LINE FEEDS OR FORM FEEDS.
;*
;* ENTRY: F5 = SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1,
;* EXIT: SUPERSCRIPT OFF, STAUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PH, PL, F0 - F2, F3, AUX3
;*
SUPEROFF: TEST      R2,1        ;BRANCH IF SUPERSCRIPT IS ALREADY OFF
          JZ        SUPEROUT
          CALL      ESCCHECK    ;SEE IF IT IS SUPPORTED
          AND       R2,0FEH     ;TURN OFF SUPERSCRIPT FLAG
          CALL      TRANESC     ;SEND TRANSLATION TO THE PRINTER
          RET

;         TITLE     SUBSCRIPT
;*******************************************************************************
;*
;*  THIS ROUTINE IS WHAT TURNS ON SUBSCRIPT MODE FOR THE SUBSCRIPT ON ESCAPE
;*  SEQUENCE.  ISSUE NO CARRIAGE RETURNS, SPACES, LINE FEEDS OR FORM FEEDS.
;*
;* ENTRY: F5 = SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1,
;* EXIT: SUBSCRIPT ON, STATUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PH, PL, F0 - F2, F3, AUX3
;*
SUBON:    TEST      R2,02H      ;BRANCH IF SUBSCRIPT IS ALREADY ON
          JNZ       SUPEROUT
          CALL      ESCCHECK    ;SEE IF IT IS SUPPORTED
          OR        R2,02H      ;TURN ON SUBSCRIPT FLAG
          JMP       TRANESC     ;SEND TRANSLATION TO THE PRINTER

;*******************************************************************************
;*
;*  THIS ROUTINE IS WHAT TURNS OFF SUBSCRIPT MODE FOR THE SUBSCRIPT OFF ESCAPE
;*  SEQUENCE.  ISSUE NO CARRIAGE RETURNS, SPACES, LINE FEEDS OR FORM FEEDS.
;*
;* ENTRY: F5 = SEQUENCE NUMBER ID, F0 - F2 = STATUS WORD 1,
;* EXIT: SUBSCRIPT OFF, STAUS WORD 1 MODIFIED
;* REGISTERS MODIFIED: PH, PL, F0 - F2, F3, AUX3
;*
SUBOFF:   TEST      R2,02H      ;BRANCH IF SUBSCRIPT IS ALREADY OFF
          JZ        SUPEROUT
          CALL      ESCCHECK    ;SEE IF IT IS SUPPORTED
          AND       R2,0FDH     ;TURN OFF SUPERSCRIPT FLAG
          JMP       TRANESC     ;SEND TRANSLATION TO THE PRINTER

;         TITLE     UNDERSCORE/OVERSTRIKE
;*******************************************************************************
;*
;*   THIS FILE IS THE SECOND FILE OF ESCAPE SEQUENCE ROUTINES
;*
;********************************************************************************
;*******************************************************************************
;*
;*
;*
;* THIS ROUTINE TURNS ON UNDERSCORE MODE
;*
;* ENTRY: F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 IS UPDATED
;* REGISTERS MODIFIED: NONE
;*
UNDERON:  OR        R2,04H      ;TURN ON UNDERSCORE FLAG
          RET

;******************************************************************************
;*
;* THIS ROUTINE TURN OFF UNDERSCORE MODE
;*
;* ENTRY: F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 IS UPDATED
;* REGISTERS MODIFIED: NONE
;*
UNDEROFF: AND       R2,0FBH     ;TUN OFF UNDERSCORE FLAG
          RET

;******************************************************************************
;*
;* THIS ROUTINE TURNS ON OVERSTRIKE MODE
;*
;* ENTRY: F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 IS UPDATED
;* REGISTERS MODIFIED: NONE
;*
OVERON:   OR        R2,08H      ;TURN ON OVERSTRIKE FLAG
          RET

;******************************************************************************
;*
;* THIS ROUTINE TURNS OFF OVERSTRIKE MODE
;*
;* ENTRY: F0 - F2 = STATUS WORD 1
;* EXIT: STATUS WORD 1 IS UPDATED
;* REGISTERS MODIFIED: NONE
;*
OVEROFF:  AND       R2,0F7H     ;TURN OFF OVERSTRIKE FLAG
          RET

;         TITLE     SET LINE FEED SPACING
;*******************************************************************************
;*
;* THIS ROUTINE HANDLES THE "SET LINE FEED SPACING AND ENABLE AUTO LINE FEED AFTER
;* CARRIAGE RETURN" ESCAPE SEQUENCE.
;*
;* ENTRY: ESCAPE VARIABLE 1 = LINES PER INCH
;* EXIT:
;* REGISTERS MODIFIED: MOST
;*
LFSEALF:  CALL      SETLINEF    ;SET LINE FEED SPACING
          OR        R2,20H      ;TURN ON AUTO LINE FEED FLAG
          JMP       TRANESC     ;SEND TRANSLATION TO THE PRINTER

;*******************************************************************************
;*
;* THIS ROUTINE HANDLES THE "SET LINE FEED SPACING AND DISABLE AUTO LINE FEED AFTER
;* CARRIAGE RETURN" ESCAPE SEQUENCE.
;*
;* ENTRY: ESCAPE VARIABLE 1 = LINES PER INCH
;* EXIT:
;* REGISTERS MODIFIED: MOST
;*
LFSDALF:  CALL      SETLINEF    ;SET LINE FEED SPACING
          AND       R2,0DFH     ;TURN OFF AUTO LINE FEED FLAG
          JMP       TRANESC     ;SEND TRANSLATION TO THE PRINTER

;*******************************************************************************
;*
SETLINEF: CALL      ESCCHECK    ;SEE IF SEQUENCE IS SUPPORTED
          CALL      ESCADDR     ;GET ESCAPE TABLE BASE ADDRESS
;         CALL      RCM         ;READ # OF PRINTER INCREMENTS PER INCH
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       R6,DL       ;F6 = PRINTER INCREMENTS PER INCH
          CALL      RDSTAT2     ;GET ESCAPE VARIABLE 1
          MOV       R7,DL       ;F7 = LINES PER INCH
          TEST      R7,0FH      ;IF NOT (0 < LINES/INCH <= 15)...
          JE        NOREMAN1
          TEST      R7,0F0H     ;ERROR SO RETURN
          JNE       NOREMAN1
          CALL      RDSTAT3     ;GET STATUS WORD 3
          AND       K,70H
          AND       R7,0FH
          MOV       AL,R7
          OR        K,AL        ;K = LINES PER INCH
          CALL      WRTSTAT3    ;SAVE IT
          MOV       R3,0        ;COUNTER = 0
STLINEF1: MOV       AL,R7       ;SUBTRACT LINE/INCH FROM INCREMENTS/INCH
          SUB       R6,AL
          INC       R3          ;INCREAMENT COUNTER
          MOV       AL,R7
          CMP       AL,R6       ;BRANCH IF F7 < F6
          JBE       STLINEF1
          CMP       R6,0        ;IF NO REMAINDER THEN BRANCH  ...
          JE        NOREMAIN
          MOV       AL,R6
          SUB       R7,AL       ;IF REMAINDER => 1/2(LINES PER INCH) THEN, ....
          CMP       AL,R7       ;ROUND OFF BY ADDING 1 TO COUNT
          JB        NOREMAIN
          INC       R3
NOREMAIN: CALL      RDSTAT2     ;GET ESCAPE VAIABLE 1 (STAT WORD 2)
          MOV       DL,R3       ;PUT COUNT INTO ESCAPE VARIABLE 1
          CALL      WRTSTAT2    ;WRITE IT OUT
NOREMAN1: RET

;         TITLE     SET LEFT MARGIN
;*********************************************************************************
;*
;* THIS ROUTINE HANDLES THE SET LEFT MARGIN ESCAPE SEQUENCE.  FIRST IT ISSUES
;* A CARRIAGE RETURN, THEN WALKS THE CARRIAGE TO THE LEFT MARGIN AND SETS IT.
;*
;* ENTRY: F5 = SEQUENCE ID, ESCAPE VARIABLE 1 = COLUMN NUMBER OF LEFT MARGIN
;* EXIT: CARRIAGE AT LEFT MARGIN OF CURRENT LINE, AND MARGIN SET
;* REGISTERS MODIFIED: F5, PH, PL
;*
;
LMARGIN:  CALL      ESCCHECK    ;SEE IF SEQUENCE IS SUPPORTED
          CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       R5,0
          CMP       R5,DL       ;COLUMN 0 = COLUMN 1 SO....
          JNE       LMARGIN1
          MOV       DL,01H      ;CHANGE COLUMN 0 TO COLUMN 1
LMARGIN1: MOV       R5,DL       ;F5 = COLUMN NUMBER OF LEFT MARGIN
          MOV       EDX,0DH     ;PHPL = CARRIAGE RETURN CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      TRANCHAR    ;TRANSLATE IT AND SEND IT

MARGSTEP: DEC       R5          ;F5 = NUMBER OF SPACES TO MARGIN
          CMP       R5,0        ;BRANCH IF AT MARGIN
          JE        MARGSEND
          MOV       EDX,20H     ;PHPL = SPACE CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      TRANCHAR    ;SEND IT
          JMP       MARGSTEP    ;BRANCH TO DO NEXT ONE
MARGSEND: JMP       TRANESC     ;SEND ESCAPE SEQUENCE TRANSLATION

;         TITLE     AUTO LINEFEED
;*******************************************************************************
;*
;* THIS ROUTINE HANDLES THE "ENABLE AUTO LINE FEED AFTER CARRIAGE RETURN" ESCAPE
;* SEQUENCE.
;*
;* ENTRY: F5 = SEQUENCE ID
;* EXIT: AUTO LINE FEED ENABLED
;* REGISTERS MODIFIED: F3, F2, STATUS WORD 1, PH, PL
;*
ENABLLF:  MOV       R3,0
          CMP       R3,DH       ;BRANCH IF UNSUPPORTED...
          JNE       ENABLLF1
          CMP       R3,DL       ;PHPL = 0000
          JE        ENABLLF2
ENABLLF1: OR        R2,20H      ;TURN ON AUTO LINE FEED
ENABLLF2: RET

;*******************************************************************************
;*
;* THIS ROUTINE HANDLES THE "DISABLE AUTO LINE FEED AFTER CARRIAGE RETURN" ESCAPE
;* SEQUENCE.
;*
;* ENTRY: F5 = SEQUENCE ID
;* EXIT: AUTO LINE FEED DISABLED
;* REGISTERS MODIFIED: F3, F2, STATUS WORD 1, PH, PL
;*
DISABLF:  MOV       R3,0
          CMP       R3,DH       ;BRANCH IF UNSUPPORTED...
          JNE       DISABLF1
          CMP       DL,0        ;PHPL = 0000
          JE        DISABLF2
DISABLF1: AND       R2,0DFH     ;TURN OFF AUTO LINE FEED
DISABLF2: RET

;         TITLE     SELECT PITCH
;********************************************************************************
;*
;* THIS ROUTINE HANDLES THE SELECT PITCH SEQUENCES.
;*
;* ENTRY: F5 = SEQUENCE ID , ESCAPE VARIABLES 1 & 2 = PITCH SETTING
;* EXIT:
;* REGISTERS MODIFIED: PH,PL,F3,AUX0,AUX1,AUX3
;*
PITCH:    CALL      ESCADDR     ;GET ESCAPE TABLE BASE ADDRESS INTO PHPL
          MOV       R3,1
          MOV       R4,0        ;F4F3 = 0001
          ADD       EDX,3       ;SKIP OVER PRINTER INCREMENT ENTRY
          MOV       AUX01,EDX   ;SAVE ADDRESS OF PITCH SETTINGS IN AUX1
          CALL      RDSTAT2     ;READ STATUS WORD 2
          MOV       R3,05H      ;FOR COMPARISION
          CMP       R3,DH       ;BRANCH IF FRACTIONAL PITCH NOT = 0.5
          JNE       PITCHJMP
          MOV       R3,10H      ;FOR COMPARISION
          CMP       R3,DL       ;ERROR IF NOT 16.5 PITCH
          JNE       PITCHOUT
          JMP       PITCH165    ;...IT MUST BE UNSUPPORTED
PITCHJMP: CMP       R4,DH       ;IF FRACTIONAL PITCH NOT = 0 ERROR
          JNE       PITCHOUT
          MOV       AH,DL
          TEST      AH,0F0H
          JNZ       PITCHOUT
          CMP       DL,0FH
          JE        PITCH15     ;BRANCH IF 15 PITCH
          CMP       DL,0CH
          JE        PITCH12     ;BRANCH IF 12 PITCH
          CMP       DL,0AH
          JE        PITCH10     ;BRANCH IF 10 PITCH
          CMP       DL,05H
          JNE       PITCH5      ;BRANCH IF 5 PITCH
PITCHOUT: RET                   ;ERROR, UNSUPPORTED PITCH, RETURN
PITCH5:   CALL      RDSTAT3     ;GET STATUS WORD 3
          OR        K,10H
          AND       K,1FH       ;SET PITCH
          CALL      WRTSTAT3    ;SAVE IT IN CONTROL MEMORY
          MOV       EDX,AUX01
          JMP       PITCHALL    ;BRANCH
PITCH10:  CALL      RDSTAT3     ;GET STATUS WORD 3
          OR        K,20H
          AND       K,2FH       ;SET PITCH
          CALL      WRTSTAT3    ;SAVE WORD 3
          MOV       EDX,AUX01
          MOV       R3,1
          JMP       PITCHAL1
PITCH12:  CALL      RDSTAT3     ;GET STATUS WORD 3
          OR        K,30H
          AND       K,3FH       ;SET PITCH
          CALL      WRTSTAT3    ;SAVE WORD 3
          MOV       EDX,AUX01
          MOV       R3,2
          JMP       PITCHAL1
PITCH15:  CALL      RDSTAT3     ;GET STATUS WORD 3
          OR        K,40H
          AND       K,4FH       ;SET PITCH
          CALL      WRTSTAT3    ;SAVE WORD 3
          MOV       EDX,AUX01
          MOV       R3,03
          JMP       PITCHAL1
PITCH165: CALL      RDSTAT3     ;GET STATUS WORD 3
          OR        K,50H
          AND       K,5FH       ;SET PITCH
          CALL      WRTSTAT3    ;SAVE WORD 3
          MOV       EDX,AUX01
          MOV       R3,4
PITCHAL1: MOV       EAX,0       ;PHPL = ADDRESS OF PITCH SETTING
          MOV       AL,R3
          MOV       BL,3
          MUL       BL
          ADD       EDX,EAX
PITCHALL:                       ;READ TRANSLATION
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          CMP       R4,DL       ;EXIT IF ITS NOT SUPPORTED
          JE        PITCHOUT
          MOV       AUX01,EDX   ;PLACE PITCH SETTING TRANSLATION INTO ...
          CALL      RDSTAT2     ;GET ESCAPE VARIABLE 1 (STATUS WORD 2)
          XCHG      EDX,AUX01   ;VARABLE 1 = PITCH SETTING
          CALL      WRTSTAT2    ;SAVE STATUS WORD 2
          CALL      ESCCHECK
          JMP       TRANESC     ;SEND TRANSLATION TO PRINTER

;         TITLE     PROPORTIONAL SPACING
;********************************************************************************
;*
;* THIS ROUTINE ENABLES PROPORTIONAL SPACING FOR THOSE PRINTERS THAT SUPPORT IT.
;*
;* ENTRY: F5 = SEQUENCE ID, F0 - F2 = STATUS WORD 1
;* EXIT: PROPORTIONAL SPACING ENABLED
;* REGISTERS MODIFIED: F2, F3, PL, PH
;*
PROPRON:  TEST      R2,10H      ;BRANCH IF ALREADY ON
          JNZ       PROFOUT
          CALL      ESCCHECK    ;SEE IF SUPPORTED
          OR        R2,10H      ;TURN ON PROPORTIONAL SPACING FLAG
          JMP       TRANESC     ;SEND IT

;********************************************************************************
;*
;* THIS ROUTINE DISABLES PROPORTIONAL SPACING FOR THOSE PRINTERS THAT SUPPORT IT.
;*
;* ENTRY: F5 = SEQUENCE ID, F0 - F2 = STATUS WORD 1
;* EXIT: PROPORTIONAL SPACING DISABLED
;* REGISTERS MODIFIED: F2, F3, PL, PH
;*
PROPOFF:  TEST      R2,10H      ;BRANCH IF ALREADY OFF
          JZ        PROFOUT
          CALL      ESCCHECK    ;SEE IF SUPPORTED
          AND       R2,0EFH     ;TURN OFF PROPORTIONAL SPACING FLAG
          JMP       TRANESC     ;SEND IT
PROFOUT:  RET                   ;EXIT

;         TITLE     PARTIAL LINEFEED
;***********************************************************************************
;*
;* THE FOLLOWING SECTION OF CODE IS USED BY THE PARTITAL LINE FEED ESCAPE SEQUENCES.
;*
;* ENTRY: F5 = SEQUENCE ID
;* EXIT:
;* REGISTERS MODIFIED: F3, PH, PL
;*
PLINEF14:                       ;1/4 LINE FEED
PLINEF12  EQU       PLINEF14    ;1/2 LINE FEED
PLINEF34  EQU       PLINEF14    ;3/4 LINE FEED
RSTPRNTR  EQU       PLINEF14    ;RESET PRINTER
          CALL      ESCCHECK    ;SEE IF SUPPORTED
          CALL      TRANESC     ;SEND IT
          RET
;*******************************************************************************
;*
;*  THIS SEQUENCE IS USED TO ENTER TEMPORARY TRANSPARENCY MODE.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE ID, ESCAPE VARIABLE 1 = NUMBER OF BYTE TO SEND TRANSPARENTLY
;* EXIT: TEMP. TRANPARENCY MODE ON
;* REGISTERS MODIFIED: STATUS WORD 1
;*
TTRANS:   OR        R0,20H      ;TURN ON TEMPORARY TRANSPARENCY MODE
TTRANS1:  RET

;         TITLE     SET FORM LENGTH
;***********************************************************************************
;*
;* THE FOLLOWING SECTION OF CODE IS USED BY THE SET FORM LENGTH ESCAPE SEQUENCE.
;*
;* ENTRY: F5 = SEQUENCE ID, ESCAPE VARIABLE 1 = FORM LENGTH
;* EXIT:
;* REGISTERS MODIFIED: F3, PH, PL
;*
FLENGTH:  CALL      ESCCHECK    ;SEE IF SUPPORTED
          CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       R3,DL       ;F3 = FORM LENGTH
          CALL      RDSTAT3     ;GET STATUS WORD 3
          MOV       DH,R3       ;PH = FORM LENGTH
          CALL      WRTSTAT3    ;WRITE IT OUT
          JMP       TRANESC     ;SEND IT

;***********************************************************************************
;*
;* THE FOLLOWING SECTION OF CODE IS USED BY THE REVERSE LINE FEED ESCAPE SEQUENCE.
;*        THE REVERSE LINE FEED IS NOT DONE IF IT WILL CROSS A PAGE BOUNDARY!!!
;*
;* ENTRY: F5 = SEQUENCE ID
;* EXIT: PLATTEN MOVED, LINE COUNT UPDATED, CHARACTER COUNT SET TO 0
;* REGISTERS MODIFIED: F3, PH, PL
;*
REVRSELF: CALL      ESCCHECK    ;MAKE SURE ITS FOR REAL
          CALL      RDSTAT3
          CMP       DL,0
          JE        TTRANS1     ;BRANCH IF GOING OFF CURRENT PAGE
          MOV       R3,DL
          DEC       R3          ;DECREMENT LINE COUNT
          JMP       LFEED1      ;REUSE SOME LOGIC

;*******************************************************************************
;* THIS ROUTINE HANDLE THE SET FORM LENGTH BY INCHES ESCAPE SEQUENCE
;*
;* ENTRY: F5 = ESCAPE SEQUENCE ID, STATUS WORD 2 = LENGTH OF FORM IN INCHES
;* EXIT:  NEW PAGE LENGTH CALCULATED, LENGTH OF FORM SET
;* REGISTERS MODIFIED: PHPL, AUX0, AUX3, F3 - F5
;*
LNGHINCH: CALL      ESCCHECK    ;SEE IF SUPPORTED
          MOV       R4,0
          CALL      RDSTAT3     ;GET STATUS WORD 3
          MOV       AL,K
          AND       AL,0FH
          MOV       R3,AL       ;F3 = LINE FEED SPACING
          CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       R5,DL       ;F5 = LENGTH OF FORM IN INCHES
          CMP       R5,0        ;BRANCH IF NO INCHES AT ALL
          JE        LNGHOUT
LNINCH1:  CMP       R5,0        ;BRANCH IF NONE LEFT
          JE        LNGHSEND
          DEC       R5          ;DECREMENT # OF INCHES
          MOV       AL,R3
          ADD       R4,AL       ;ADD IN # LINES THIS INCH
          JMP       LNINCH1     ;F6 = LINES PER FORM
LNGHSEND: CALL      RDSTAT3     ;GET STATUS WORD 3
          MOV       DH,R4       ;PH = LINES PER FORM
          CALL      WRTSTAT3    ;WRITE IT BACK OUT TO SAVE IT
          MOV       DL,R4
          CALL      WRTSTAT2    ;SET UP FOR ESC. TRANSLATION
          CALL      TRANESC     ;SEND SEQUENCE TO PRINTER
LNGHOUT:  RET

;         TITLE     RESTORE DEFAULTS
;********************************************************************************
;*
;* THIS ROUTINE IS THE RESTORE DEFAULTS SEQUENCE.  BOTH THE PRINTER AND THE STATUS
;* WORD MODE BITS ARE RESET.
;*
;* ENTRY: F5 = SEQUENCE ID
;* EXIT: PRINTER AND DRIVER DEFAULTS RESET
;* REGISTERS MODIFIED: F3, PH, PL, ALL STATUS WORDS
;*
RSTDEF:   MOV       DL,R5
          PUSH      EDX         ;SAVE F5
          MOV       EDX,0DH     ;PHPL = CARRIAGE RETURN CODE
          MOV       AUX01,EDX   ;SAVE IT
          CALL      TRANCHAR    ;SEND IT
          MOV       R2,0        ;CLEAR PREVIOUS ATTRIBUTES
          AND       R0,02       ;0E = EMPHASIZED PRINT ONLY
          CALL      RDSTAT3
          MOV       DL,0        ;SET DRIVER'S LINE COUNT TO 0
          CALL      WRTSTAT3
          POP       EDX
          MOV       R5,DL       ;RESTORE F5
          CALL      RSTPRNTR    ;RESET PRINTER
          CALL      RDSTAT2
          MOV       EDX,0AH     ;SET PITCH TO 10
          CALL      WRTSTAT2
          MOV       R5,15H
          CALL      PITCH
          CALL      RDSTAT2
          MOV       DL,06       ;SET LINEFEED SPACING AND ENABLE
          CALL      WRTSTAT2    ;AUTO LINEFEED
          MOV       R5,16H
          CALL      LFSEALF
          CALL      RDSTAT2
          MOV       DL,42H
          CALL      WRTSTAT2    ;SET PAGE LENGTH
          MOV       R5,20H
          JMP       FLENGTH

;         TITLE     ESCCHECK
;*******************************************************************************
;*
;* THIS FILE IS THE TABLE MANAGER OF THE ESCAPE SEQUENCE TRANSLATION SUB-MODULE.
;*  IT IS COMPRISED OF TWO ROUTINES ESCCHECK AND TRANESC.
;*
;*******************************************************************************
;*******************************************************************************
;*
;*
;* THIS ROUTINE CHECKS TO SEE IF A GIVEN ESCAPE SEQUENCE IS SUPPORTED BY THE
;* PRINTER IN QUESTION.  IF THE SEQUENCE IS SUPPORTED, THEN THE ADDRESS OF THE
;* START OF ITS TRANSLATION STRING IS RETURNED IN THE PC'S AND AUX 3.  IF THE
;* SEQUENCE IS NOT SUPPORTED, THEN THE RETURN ADDRESS OF THIS ROUTINE'S PARENT
;* IS REMOVED FROM THE STACK AND CONTROL IS RETURNED TO THIS ROUTINE'S GRANDPARENT.
;*
;* ENTRY: F5 = ESCAPE SEQUENCE ID NUMBER
;* SUPPORTED EXIT: PC'S & AUX 3 = ADDRESS OF START OF TRANSLATION STRING
;* UNSUPPORTED EXIT: CONTROL RETURNED TO THIS ROUTINE'S GRANDPARENT
;* REGISTERS MODIFIED: F3,F4,F6,PHPL , AUX 3
;*
ESCCHECK: CALL      ESCADDR     ;GET ESCAPE TABLE BASE ADDRESS
          MOV       R3,05       ;SKIP OVER PRINTER INCREMENT AND...
          MOV       R4,0        ;PITCH TRANSLATIONS
          ADD       EDX,15      ;PHPL = START OF TABLE
          MOV       EAX,0
          MOV       AL,R5
          MOV       BL,3
          MUL       BL
          ADD       EDX,EAX     ;PHPL = ADDRESS OF ESCAPE SEQUENCE ENTRY
;         CALL      RCM
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       WORD PTR R5,DX  ;F6F5 = TRANS. STRING OFFSET
          CMP       R4,DH       ;BRANCH IF TRANSALTION EXISTS
          JNE       GOTADDR
          CMP       R4,DL
          JNE       GOTADDR
          POP       EDX         ;IF UNSUPPORTED GO TO GRANDPARENT
          RET                   ;INSTEAD OF PARENT

GOTADDR:  CALL      ESCADDR
          MOV       EAX,0
          MOV       AX,WORD PTR R5
          MOV       BX,3
          PUSH      EDX
          MUL       BX
          POP       EDX
          ADD       EDX,EAX     ;RETURN ADDRESS OF TRANSLATION STRING
          MOV       AUX03,EDX   ;IN BOTH PC'S AND AUX 3
          RET

;         TITLE     TRANSESC
;*******************************************************************************
;*
;* THIS ROUTINE TAKES THE ESCAPE TRANSLATION STRINGS OUT OF THE TABLE AND SENDS
;* THEM TO THE PRINTER.  ESCAPE VARIABLE VALUES ARE INSERTED WHERE NEEDED FROM
;* ESCAPE VARIABLE 1.
;*
;* ENTRY: AUX3 = ADDRESS OF STRING, ESCAPE VARIABLE 1 = ESCAPE VARIABLE VALUE
;* EXIT: SEQUENCE TRANSLATION SENT TO PRINTER
;* REGISTERS MODIFIED: PHPL,F3F4,K,AUX2,AUX3
;*
TRANESC:  CALL      RDSTAT2     ;GET STATUS WORD 2
          MOV       AUX02,EDX   ;SAVE ESCAPE VARIABLE IN AUX2 FOR LATER
          MOV       R4,0
          MOV       EDX,AUX03   ;PHPL = ADDRESS OF TRANSLATION STRING
          ADD       AUX03,3
;         CALL      RCM         ;READ 1ST WORD OF STRING
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       AL,K
          AND       AL,07FH
          MOV       R3,AL       ;F3 = # OF BYTES IN STRING
TRANLOOP: MOV       K,DH
          CALL      TRLOOPA     ;SEND BYTE 1 OF THIS WORD
          MOV       K,DL
          CALL      TRLOOPA     ;SEND BYTE 2 OF THIS WORD
          MOV       EDX,AUX03
          ADD       AUX03,3
;         CALL      RCM
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          JMP       TRANLOOP    ;PLAY IT AGAIN SAM!!!
TRLOOPA:  MOV       AL,K        ;BRANCH IF K NOT = 8X
          MOV       R7,AL
          CMP       AL,98H
          JE        TRLOOP1
          CMP       AL,97H
          JE        TRLOOP2
          CMP       AL,99H
          JE        TRLOOP3

          CMP       AL,88H
          JE        TRLOOP1
          CMP       AL,87H
          JE        TRLOOP2
          CMP       AL,89H
          JE        TRLOOP3

          JMP       TRLOOP0

TRLOOP1:  XCHG      EDX,AUX02   ;RECALL ESCAPE VARIABLE 1
          MOV       K,DL        ;K = CODE TO SEND TO THE PRINTER
          XCHG      EDX,AUX02   ;RECALL PC'S
          JMP       TRLOOP0
TRLOOP2:  XCHG      EDX,AUX02   ;OUTPUT CODE "ESCAPE VARIABLE 1" - 1
          MOV       K,DL        ;BUT DON'T DECREMENT IF ZERO
          XCHG      EDX,AUX02
          MOV       AL,R4
          CMP       AL,K
          JE        TRLOOP0
          DEC       K
          JMP       TRLOOP0
TRLOOP3:  XCHG      EDX,AUX02   ;OUTPUT CODE "ESCAPE VARIABLE 1" + 1
          MOV       K,DL
          INC       K
          XCHG      EDX,AUX02
TRLOOP0:  MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,90H
          JNE       TRLOOPB2

TRLOOPB3: MOV       AUX02,EDX          ;SAVE CURRENT PC
          PUSH      WORD PTR [R4]      ;SAVE F5F4
          MOV       DX,WORD PTR [R2]   ;SAVE F3F2
          MOV       AL,K               ;SET UP FOR ASCII CONVERSION
          MOV       R5,AL
          MOV       R4,AL
          MOV       WORD PTR [R6],0
          MOV       R3,8               ;LOOP CONTROL

TRLOOPB6: MOV       AX,WORD PTR [R4]
          ADD       WORD PTR [R4],AX
          MOV       AL,R6
          ADC       AL,R6
          DAA
          MOV       R6,AL
          MOV       AL,R7
          ADC       AL,R7
          DAA
          MOV       R7,AL

          INC       R3
          TEST      R3,0F0H
          JZ        TRLOOPB6
          MOV       WORD PTR [R2],DX   ;RESTORE F3F2
          POP       WORD PTR [R4]      ;RESTORE F5F4
          MOV       EDX,AUX02          ;RESTORE PC
          CMP       R7,0
          JZ        TRLOOPB4           ;BRANCH IF VALUE < 100
          TEST      R7,0F0H
          JZ        TRLOOPB5           ;BRANCH IF VALUE < 1000
          MOV       AL,R7              ;SET LOW NIBBLE OF K TO 1ST ASCII
          AND       AL,0F0H
          SHR       AL,4
          MOV       K,AL
          ADD       K,30H              ;CONVERT TO ASCII
          CALL      OUTCODE            ;OUTPUT 1ST ASCII CHARACTER
TRLOOPB5: MOV       AL,R7              ;SET LOW NIBBLE OF K TO 2ND ASCII
          AND       AL,4
          MOV       K,AL
          ADD       K,30H              ;CONVERT TO ASCII
          CALL      OUTCODE            ;OUTPUT 2ND ASCII CHARACTER
TRLOOPB4: MOV       AL,R6              ;SET LOW NIBBLE OF K TO 3RD ASCII
          AND       AL,0F0H
          SHR       AL,4
          MOV       K,AL
          ADD       K,30H              ;CONVERT TO ASCII
          CALL      OUTCODE            ;OUTPUT 3RD ASCII CHARACTER
          MOV       AL,R6              ;SET LOW NIBBLE OF K TO 4TH ASCII
          AND       AL,0FH
          MOV       K,AL
          ADD       K,30H              ;CONVERT 4TH NIBBLE TO ASCII
TRLOOPB2: CALL      OUTCODE            ;SEND BYTE TO PRINTER
          ADD       R3,0FFH            ;DECREMENT NUMBER OF BYTES SENT
          CMP       R3,0
          JNZ       TRANEOUT           ;BRANCH IF NOT DONE
          POP       EDX
TRANEOUT: RET

;         TITLE     CHARCTRL
;*******************************************************************************
;* THIS FILE IS THE CHARACTER AND CONTROL CODE DECODER. IT TRANSLATES AND PRINTS
;* ALL CHARACTERS AND CONTROL SEQUENCES.  IT ALSO UPDATES THE PARTITION'S STATUS
;* WORDS AS IS APPROPRIATE.
;*******************************************************************************

;*******************************************************************************
;* THIS ROUTINE IS THE TOP LEVEL OF THE CHARACTER AND CONTROL CODE DECODER. AFTER
;* THE CONTROL CODES ARE FILTERED OUT AND THE STATUS WORDS UPDATED, THEY ARE
;* SENT TO THE TRANSLATION ROUTINE TO BE TRANSLATED AND SENT TO THE PRINTER.
;* NON-CONTROL CODES ARE SENT STRAIGHT TO THE TRANSLATION ROUTINE.
;*
;*
;* ENTRY: PL = INPUT CODE, F0 - F2 = STATUS WORD 1
;* EXIT: PROCESSING COMPLETE
;* REGISTERS MODIFIED: F3 - F5, AUX0 - 2, PHPL, K
;*
;*
CHARCTRL: TEST      DL,0FH
          JZ        M55_11
          MOV       AH,DL
          AND       AH,0F0H
          CMP       AH,80H
          JE        NULLCODE    ;BRANCH IF PL = 8X, BUT NOT = 80
M55_11:
          TEST      DL,0F0H     ;BRANCH IF PL NOT = 0X
          JNZ       GETCHAR
          MOV       AL,DL
          AND       AL,0FH
          CMP       AL,0DH
          JE        CARRTN      ;BRANCH TO CARRIAGE RETURN ROUTINE IF F5 = 0D
          CMP       AL,0
          JE        NULLCODE    ;BRANCH IF PL = 00
          CMP       AL,0AH
          JE        LINEFEED    ;BRANCH TO LINEFEED ROUTINE IF F5 = 0A
          CMP       AL,0CH
          JE        FORMFEED    ;BRANCH TO FORM FEED ROUTINE IF F5 = 0C
          CMP       AL,0EH
          JE        OESTART     ;BRANCH TO 0E ROUTINE IF F5 = 0E
          CMP       AL,0FH
          JE        OFEND       ;BRANCH TO 0F ROUTINE IF F5 = 0F
          CMP       AL,08H
          JE        GETCHAR     ;BRANCH IF ITS A BACKSPACE
          CMP       AL,09H
          JE        HORIZTAB    ;BRANCH TO HORIZONTAL TAB ROUTINE IF F5 = 09
          CMP       AL,0BH
          JE        VERTTAB     ;BRANCH TO VERTICAL TAB ROUTINE IF F5 = 0B
          CMP       AL,07H
          JE        GETCHAR     ;BRANCH TO RING THE BELL
          JMP       NULLCODE    ;BRANCH IF 00 >= PL <= 06
GETCHAR:  MOV       DH,0
          MOV       AUX01,EDX
          CALL      TRANCHAR    ;PRINT CHARACTER
          TEST      R2,4        ;BRANCH IF AUTO UNDERSCORE IS OFF
          JZ        GETCHAR1
          MOV       EDX,08
          MOV       AUX01,EDX
          CALL      TRANCHAR    ;BACKSPACE
          MOV       EDX,0100H
          MOV       AUX01,EDX
          CALL      TRANCHAR    ;UNDERSCORE
GETCHAR1: TEST      R2,8        ;BR IF OVERSTRIKE IS OFF
          JZ        NULLCODE
          MOV       EDX,08
          MOV       AUX01,EDX
          CALL      TRANCHAR    ;BACKSPACE
          MOV       EDX,0101H
          MOV       AUX01,EDX
          CALL      TRANCHAR    ;OVERSTRIKE
NULLCODE: RET

;         TITLE     CONTROL CODES
;********************                 THIS SECTION OF CODE HANDLES HORIZONTAL TABS
HORIZTAB: XCHG      EDX,CHARCNT
          MOV       R5,DL       ;F3 = CHARACTER COUNT
          MOV       R4,05H      ;F4 = TAB EVERY 5TH COLUMN
HTAB:     MOV       AL,R5
          CMP       AL,R4       ;BRANCH IF F5 < 5
          JB        HTAB1
          MOV       AL,R4
          SUB       R5,AL       ;F5 = F5 - 5
          JMP       HTAB        ;ON EXIT F5 = # OF SPACES PAST LAST TAB STOP
HTAB1:    MOV       AL,R4
          SUB       AL,R5
          MOV       R5,AL       ;F5 = NUMBER OF SPACES TO NEXT TAB STOP
          ADD       DL,R5       ;PL = CHARACTER COUNT AFTER TAB
          MOV       R4,DL       ;F4 = CHARACTER COUNT IN PL
          CMP       R4,DH       ;BRANCH IF TAB IS ON THIS LINE
          JBE       HTAB2
HTABOUT:  RET                   ;EXIT IF TAB STOP IS PAST DEFINED LINE LENGTH
HTAB2:    XCHG      EDX,CHARCNT ;SAVE CHARACTER COUNT
          MOV       EDX,20H     ;PHPL = CODE FOR A SPACE
          MOV       AUX01,EDX   ;SAVE IT
          JMP       VTAB        ;GO PRINT SPACES TO TAB

;********************          THIS SECTION OF CODE HANDLES LINE FEEDS
LINEFEED: CALL      RDSTAT3     ;GET STATUS WORD 3
          MOV       R3,DL
          INC       R3          ;INCREMENT LINE COUNT AND STORE IN F3
          CMP       R3,DH       ;BRANCH IF NOT GOING OFF PAGE
          JB        LFEED1
          MOV       DL,0
LFEED1:   XCHG      EDX,COUNTS
          MOV       DL,R3       ;PL=UPDATED LINE COUNT
          XCHG      EDX,COUNTS
          MOV       DL,R3
          CALL      WRTSTAT3    ;SAVE STATUS WORD 3
          XCHG      EDX,AUX1D
          MOV       DL,0
          XCHG      EDX,AUX1D
          JMP       TRANCHAR    ;SEND LINE FEED TO PRINTER

;********************           THIS SECTION OF CODE HANDLES FORM FEEDS
FORMFEED: CALL      RDSTAT3     ;GET STATUS WORD 3
          MOV       DL,0        ;ZERO OUT LINE COUNT
          CALL      WRTSTAT3    ;SAVE UPDATED STATUS WORD 3
          XCHG      EDX,AUX1D
          MOV       DL,0
          XCHG      EDX,AUX1D
          MOV       EDX,COUNTS  ;RESET SYSTEM LINE COUNT
          MOV       DL,0        ;TO ZERO
          MOV       COUNTS,EDX  ;AND SAVE IT
FORMFED1: JMP       TRANCHAR    ;SEND LINE FEED TO PRINTER


;********************            THIS SECTION OF CODE HANDLES CARRIAGE RETURNS
CARRTN:   TEST      R0,1        ;BRANCH IF HEX 0E ON UNTIL HEX 0F
          JZ        CARRTN1
          MOV       EDX,0FH
          MOV       AUX01,EDX   ;PRETEND WE GOT A 0F CUZ 'CR'
          CALL      OFEND       ;IS SUPPOSED TO TURN THIS SHIT
          MOV       EDX,0DH     ;OFF...THEN SET UP FOR THE 'CR'
          MOV       AUX01,EDX
CARRTN1:  TEST      R2,20H      ;BRANCH IF AUTO LINE FEED IS OFF
          JZ        FORMFED1
          CALL      TRANCHAR    ;OUTPUT THE CARRIAGE RETURN
          MOV       EDX,0AH     ;PL = LINE FEED CODE
          MOV       AUX01,EDX   ;SAVE LINE FEED CODE IN AUX1
          JMP       LINEFEED    ;OUTPUT THE LINE FEED

;********************              THIS SECTION OF CODE HANDLES HEX 0E'S
OESTART:  OR        R0,1
OESTART1: TEST      R0,4        ;BRANCH IF 0E HAS NO UNDERSCORE
          JZ        OESTART2
          OR        R2,04       ;TURN ON UNDERSCORE MODE
OESTART2: TEST      R0,8        ;BRANCH IF 0E HAS NO OVERSTRIKE
          JZ        OESTART3
          OR        R2,08H      ;TURN ON OVERSTRIKE MODE
OESTART3: OR        R2,80H      ;TURN 0E ON
          TEST      R0,2        ;SEND 0E TO PRINTER IF EMPHASIZED PRINT
          JNZ       TRANCHAR
          RET

;********************              THIS SECTION OF CODE HANDLES HEX 0F'S
OFEND:    TEST      R0,4        ;BRANCH IF 0E HAS NO UNDERSCORE
          JZ        OFEND1
          AND       R2,0FBH     ;TURN OFF UNDERSCORE MODE
OFEND1:   TEST      R0,8        ;BRANCH IF 0E HAS NO OVERSTRIKE
          JZ        OFEND2
          AND       R2,0F7H     ;TURN OFF OVERSTRIKE MODE
OFEND2:   AND       R2,07FH     ;TURN 0E OFF
          and       r0,0feh     ;turn off 0e active
          TEST      R0,2        ;SEND 0F TO PRINTER IF EMPHASIZED PRINT
          JNZ       TRANCHAR
          RET

;********************              THIS SECTION OF CODE HANDLES NEGATIVE LINE FEEDS
NEGLF:    CALL      TRANCHAR    ;DO NEGATIVE LINE FFED
          MOV       EDX,AUX01   ;RECALL OUTPUT CODE
          TEST      DL,0FH      ;BRANCH IF -LF IS UNSUPPORTED
          JZ        NEGOUT
          CALL      RDSTAT3     ;GET STATUS WORD 3
          DEC       DL          ;LINECOUNT = LINECOUNT - 1
          CALL      WRTSTAT3    ;SAVE STATUS WORD 3
          XCHG      EDX,COUNTS  ;GET SYSTEM LINE COUNT
          DEC       DL          ;DECREMENT IT
          XCHG      EDX,COUNTS     ;AND SAVE IT
NEGOUT:   RET

;********************                   THIS SECTION OF CODE HANDLES VERTICAL TABS
VERTTAB:  CALL      RDSTAT3     ;GET STAUS WORD 3
          MOV       R4,06
          MOV       R5,DL       ;SAVE COPY OF LINE COUNT IN F6
SIXMORE:  MOV       AL,R5
          CMP       AL,R4       ;BRANCH IF F5 < 6
          JB        VERTTAB1
          MOV       AL,R4
          SUB       R5,AL       ;F5 = F5 - 6
          JMP       SIXMORE     ;ON EXIT F5 = # OF LINES TO VERT. TAB STOP
VERTTAB1: MOV       AL,R4
          SUB       AL,R5       ;F5 = NUMBER OF LINES TO TAB STOP
          DEC       AL
          MOV       R5,AL
          MOV       R4,DL
          ADD       R4,AL       ;F4 = LINE COUNT AFTER DOING VERTICAL TAB
          CMP       R4,DH       ;BRANCH IF TAB STOP IS ON THIS PAGE
          JB        SAMEPAGE
          MOV       EDX,0CH     ;PHPL = FORM FEED CODE
          MOV       AUX01,EDX   ;SAVE IT
          JMP       FORMFEED    ;ISSUE FORM FEED IF GOING OFF PAGE
SAMEPAGE: MOV       DL,R4       ;PL = LINE COUNT AFTER DOING TAB
          CALL      WRTSTAT3    ;SAVE STATUS WORD 3
          XCHG      EDX,COUNTS  ;UPDATE SYSTEM LINE COUNT
          MOV       DL,R4
          XCHG      EDX,COUNTS  ;SAVE IT
          XCHG      EDX,AUX1D
          MOV       DL,0
          XCHG      EDX,AUX1D
          MOV       EDX,0AH     ;PHPL = LINE FEED CODE
          MOV       AUX01,EDX   ;SAVE IT
VTAB:     TEST      R5,0FH      ;BRANCH IF AT TAB STOP
          JZ        NEGOUT
          CALL      TRANCHAR    ;ISSUE LINE FEED
          DEC       R5          ;DECREMENT NUMBER OF LINES UNTIL TAB STOP
          JMP       VTAB        ;BRANCH BACK TO DO NEXT ONE

;         TITLE     TRANCHAR
;*******************************************************************************
;* THIS ROUTINE LOCATES TRANSLATION STRINGS IN THE CHARACTER TRANSLATION TABLE
;* AND SENDS THEM TO THE PRINTER.  IF CODE IS NOT SUPPORTED AN ASCII SPACE (HEX 20)
;* IS OUTPUT IF IT IS A PRINTABLE CHARACTER, OTHERWISE IF THE CODE IS UNSUPPORTED,
;* NOTHING IS SENT TO THE PRINTER AND 0000 IS RETURNED IN AUX1.
;*
;* ENTRY: AUX1 = INPUT; F0 - F2 = STATUS WORD 1; ACTDEV = DRIVER #, DEVICE TYPE
;*                      AND DEVICE ADDRESS
;* EXIT: AUX1 = 0000 IF INPUT CODE WAS UNSUPPORTED AND/OR NON-PRINTABLE
;* MODIFIED REGISTERS: F3F4, AUX1, AUX2, PHPL, K
;*
;*
TRANCHAR: MOV       EDX,CHARTABL
          MOV       AUX02,EDX   ;SAVE IT
          MOV       EDX,AUX01   ;RECALL CODE TO OUTPUT
          MOV       WORD PTR R3,DX  ;F4F3 = OUTPUT CODE
          MOV       EDX,AUX02   ;RECALL TABLE ADDRESS
          MOV       EAX,0
          MOV       AX,WORD PTR R3
          AND       AX,1FFH
          MOV       BX,3
          PUSH      EDX
          MUL       BX
          POP       EDX
          ADD       EDX,EAX  ;PHPL = ADDRES OF CHAR/CTRL CODE ENTRY
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       R4,0FFH     ;FOR LOOP CONTROL
          CMP       R4,DH       ;BRANCH IF PL = CODE TO SENT TO PRINTER
          JE        DUMPCODE
          MOV       AL,DH
          AND       AL,0FH
          CMP       AL,0FH
          JE        NOGOOD      ;BRANCH IF NOT PRINTABLE UNSUPPORTED
          MOV       WORD PTR R3,DX  ;SAVE DISPLACEMENT TO TRANSLATION STRING
          MOV       EDX,AUX02   ;RECALL TABLE ADDRESS
          MOV       EAX,0
          MOV       AX,WORD PTR R3
          MOV       BX,3
          PUSH      EDX
          MUL       BX
          POP       EDX
          ADD       EDX,EAX
          MOV       AUX02,EDX   ;SAVE ADDRESS OF TRANSLATION STRING
          ADD       AUX02,3
;         CALL      RCM         ;READ 1ST WORD OF STRING
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          MOV       AL,K
          MOV       R3,AL       ;F3 = # OF BYTES IN STRING
DUMPMORE: MOV       K,DH        ;K = CODE TO OUTPUT
          CALL      OUTCODE     ;SEND IT
          DEC       R3          ;DECREMENT NUMBER OF BYTES SENT
          JZ        TRANCOUT
          MOV       K,DL        ;K = CODE TO OUTPUT
          CALL      OUTCODE     ;SEND IT
          DEC       R3          ;DECREMENT NUMBER OF BYTES SENT
          JZ        TRANCOUT
          MOV       EDX,AUX02   ;RECALL ADDRESS OF LAST WORD IN TRAN. STRING
          MOV       AUX02,EDX   ;SAVE NEW ADDRESS
          ADD       AUX02,3
;         CALL      RCM         ;READ NEXT WORD
          MOV       AL,[EDX+2]  ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          MOV       DX,AX       ;+- RCM
          JMP       DUMPMORE    ;LOOP BACK TO USE IT
DUMPCODE: MOV       K,DL        ;K = CODE TO OUTPUT
          JMP       OUTCODE     ;PRINT IT
NOGOOD:   MOV       EDX,0       ;CODE IS AN UNSUPPORTABLE CONTROL CODE
          MOV       AUX01,EDX   ;RETURN 0000 IN PC'S AND AUX1
TRANCOUT: RET

;         TITLE     OUTCODE
;*******************************************************************************
;* THIS ROUTINE ISSUES THE OBS STROBE TO THE PRINTER. THE CHARACTER IS STROBED
;* FROM THE K REGISTER.
;*
;* ENTRY: K = HEX CODE TO OUTPUT
;* MODIFIED REGISTERS: K
;
;----- TSAI -------
OUTCODE:
          CMP       TOMXF,0
          JE        OUTCODE1                   ;BR,IF NOT MXF
          CALL      WAITCMD
OUTCODE5:
          MOV       GS:[EBX].cmd_cbs,0FFH      ;
          MOV       GS:[EBX].cmd_abs,04        ;printer adr
          MOV       BYTE PTR GS:[EBX].cmd_parm,01    ;1 char
          MOV       AL,K
          MOV       BYTE PTR GS:[EBX+1].cmd_parm,AL  ;the char to be write
          MOV       GS:[EBX].cmd_sts,0FH       ;start this command
          RET
OUTCODE1:
;------- TSAII -----
;         TEST      BYTE PTR FS:[CPUST],8  ;BRANCH IF PRINTER READY
;         JNZ       OUTCODE2
          PUSH      EDX         ;SAVE PC'S ON STACK
          CALL      WAITRDYB    ;WAIT UP TO 1MS. FOR DEVICE READY
          POP       EDX         ;RESTORE PC'S
OUTCODE2: CALL      DELAY5      ;DELAY 5 USEC. FOR PRINTER
OUTCODE3:
          MOV       AL,K        ;STROBE CHARACTER
          push      eax
          movzx     eax,byte ptr part_
          add       eax,offset print_flag
          cmp       byte ptr [eax],0ffh
          pop       eax
          jne       outcode_x
          MOV       BYTE PTR FS:[OBS],AL
          JMP       DELAY5      ;DELAY 5 USEC. (RETURN FROM THERE TOO)
outcode_x:
          call      out_printer
          jmp       delay5

public    chk_printer
public    chk_printer_x
public    out_printer

chk_printer:
          push      eax
          push      ebx
          push      ecx
          movzx     eax,byte ptr part_
          add       eax,offset print_flag
          movzx     eax,byte ptr [eax]
          shl       eax,2
          add       eax,offset print_addr
          mov       ebx,dword ptr [eax+10h]
          mov       ecx,dword ptr [eax]
          mov       ebx,dword ptr gs:[ebx]
          push      ecx
          mov       ecx,dword ptr gs:[ecx]
          and       dword ptr [eax+20h],0f00000h
          add       dword ptr [eax+20h],ecx
          pop       ecx
          and       dword ptr [eax+30h],0f00000h
          add       dword ptr [eax+30h],ebx
          cmp       ebx,dword ptr [PRT_BUFFER_END_X]
          je        chk_printer1
          inc       ebx
          cmp       ebx,dword ptr gs:[ecx]
          jne       printer_rdy
          clc
          pop       ecx
          pop       ebx
          pop       eax
          ret
chk_printer1:
          push      eax
          mov       eax,dword ptr [PRT_BUFFER_START_X]
          cmp       dword ptr gs:[ecx],eax
          pop       eax
          jne       printer_rdy
          clc
          pop       ecx
          pop       ebx
          pop       eax
          ret
printer_rdy:
          stc
          pop       ecx
          pop       ebx
          pop       eax
          ret

chk_printer_x:
          push      eax
          push      ebx
          push      ecx
          movzx     eax,k
          sub       eax,15h
          shl       eax,2
          add       eax,offset print_addr
          mov       ebx,dword ptr [eax+10h]
          mov       ecx,dword ptr [eax]
          mov       ebx,dword ptr gs:[ebx]
          push      ecx
          mov       ecx,dword ptr gs:[ecx]
          and       dword ptr [eax+20h],0f00000h
          add       dword ptr [eax+20h],ecx
          pop       ecx
          and       dword ptr [eax+30h],0f00000h
          add       dword ptr [eax+30h],ebx
          cmp       ebx,dword ptr [PRT_BUFFER_END_X]
          je        chk_printer1_x
          inc       ebx
          cmp       ebx,dword ptr gs:[ecx]
          jne       printer_rdy_x
          clc
          pop       ecx
          pop       ebx
          pop       eax
          ret
chk_printer1_x:
          push      eax
          mov       eax,dword ptr [PRT_BUFFER_START_X]
          cmp       dword ptr gs:[ecx],eax
          pop       eax
          jne       printer_rdy_x
          clc
          pop       ecx
          pop       ebx
          pop       eax
          ret
printer_rdy_x:
          stc
          pop       ecx
          pop       ebx
          pop       eax
          ret


out_printer:
          push      ebx
          push      ecx
          push      edx
          movzx     ebx,byte ptr part_
          add       ebx,offset print_flag
          movzx     ebx,byte ptr [ebx]
          shl       ebx,2
          add       ebx,offset print_addr
          mov       ecx,dword ptr [ebx+10h]
          push      eax
          mov       eax,dword ptr [PRT_BUFFER_END_X]
          cmp       dword ptr gs:[ecx],eax
          pop       eax
          je        out_printer1
          mov       edx,dword ptr [ebx+30h]
          mov       byte ptr gs:[edx],al
          inc       dword ptr [ebx+30h]
          inc       dword ptr gs:[ecx]
          pop       edx
          pop       ecx
          pop       ebx
          ret

out_printer1:
          mov       edx,dword ptr [ebx+30h]
          mov       byte ptr gs:[edx],al
          mov       edx,dword ptr [ebx+20h]
          mov       dword ptr [ebx+30h],edx
          mov       edx,dword ptr [PRT_BUFFER_START_X]
          mov       dword ptr gs:[ecx],edx
          pop       edx
          pop       ecx
          pop       ebx
          ret

;         FILE = DBMVP55H,12/03/1986
;*  THIS FILE DEFINES THE ESCAPE SEQUENCE DECODING TABLE.  FOR COMPLETE DOCUMENTATION
;*******************************************************************************
;*  ON HOW THIS TABLE IS STRUCTURED AND USED SEE THE DOCUMENT 2200 GENERALIZED
;*  PRINTER DRIVER DESIGN SPECIFICATION BY DAVID BARRETT.
;*
;*% DEFINE THE MAIN JUMP TABLE
ESCDECOD  DB        0dH,00H,0eH ;NUMBER OF POSSIBILITIES
          DB        0eH,01H,00H ;AND THE OFFSETS INTO THE
          DB        12H,02H,00H ;TABLE FOR EACH OF THEM
          DB        19H,03H,00H
          DB        1cH,04H,00H
          DB        22H,05H,00H
          DB        2aH,06H,00H
          DB        31H,07H,00H
          DB        34H,08H,00H
          DB        45H,09H,00H
          DB        4eH,0AH,00H
          DB        5dH,0BH,00H
          DB        65H,0CH,00H
          DB        6eH,0DH,00H
;*% DEFINE 0201 SEQUENCES
          DB        0fH,02H,00H
          DB        10H,01H,00H
          DB        11H,00H,00H
          DB        01H,0FH,0fH ;02 01 02 01 00 0F
;*% DEFINE 0202 SEQUENECES
          DB        03H,00H,0eH
          DB        16H,00H,00H
          DB        17H,02H,00H
          DB        18H,04H,00H
          DB        02H,0FH,0fH ;02 02 00 0F
          DB        03H,0FH,0fH ;02 02 02 0F
          DB        04H,0FH,0fH ;02 02 04 0F
;*% DEFINE 0203 SEQUENCES
          DB        02H,00H,0eH
          DB        25H,0EH,0fH ;02 03 0E
          DB        05H,0FH,0fH ;02 03 0F
;*% DEFINE 0204 SEQUENCES
          DB        1dH,00H,01H
          DB        1eH,00H,02H
          DB        1fH,00H,03H
          DB        02H,00H,0eH
          DB        06H,0EH,0fH ;02 04 dd ee ff 0E
          DB        07H,0FH,0fH ;02 04 dd ee ff 0F
;*% DEFINE 0205 SEQUENECES
          DB        02H,00H,0eH
          DB        25H,01H,00H
          DB        27H,02H,00H
          DB        26H,00H,01H
          DB        08H,0FH,0fH ;02 05 01 dd 0F
          DB        28H,00H,01H
          DB        29H,00H,02H
          DB        09H,0FH,0fH ;02 05 02 dd ee 0F
;*% DEFINE 0206 SEQUENCES
          DB        03H,00H,0eH
          DB        2eH,01H,00H
          DB        2fH,02H,00H
          DB        30H,03H,00H
          DB        0aH,0FH,0fH ;02 06 01 0F
          DB        0bH,0FH,0fH ;02 06 02 0F
          DB        24H,0FH,0fH ;02 06 03 0F
;*% DEFINE 0207 SEQUENCES
          DB        02H,00H,0eH
          DB        26H,0EH,0fH ;02 07 0E
          DB        0cH,0FH,0fH ;02 07 0F
;*% DEFINE 0208 SEQUENCES
          DB        04H,00H,0eH
          DB        39H,01H,00H
          DB        3cH,02H,00H
          DB        3fH,03H,00H
          DB        42H,04H,00H
          DB        02H,00H,0eH
          DB        0dH,0EH,0fH ;02 08 01 0E
          DB        0eH,0FH,0fH ;02 08 01 0F
          DB        02H,00H,0eH
          DB        0FH,0EH,0FH ;02 08 02 0E
          DB        10H,0FH,0fH ;02 08 02 0F
          DB        02H,00H,0eH
          DB        11H,0EH,0fH ;02 08 03 0E
          DB        12H,0FH,0fH ;02 08 03 0F
          DB        02H,00H,0eH
          DB        13H,0EH,0fH ;02 08 04 0E
          DB        14H,0FH,0fH ;02 08 04 0F
;*% DEFINE 0209 SEQUENCES
          DB        02H,00H,0eH
          DB        48H,01H,00H
          DB        4cH,02H,00H
          DB        49H,02H,00H
          DB        4aH,00H,01H
          DB        4bH,00H,02H
          DB        15H,0FH,0fH ;02 09 01 02 dd ee 0F
          DB        4dH,00H,01H
          DB        27H,0FH,0fH ;02 09 02 dd 0F
;*% DEFINE 020A SEQUENCES
          DB        06H,00H,0eH
          DB        55H,00H,00H
          DB        56H,01H,00H
          DB        5bH,02H,00H
          DB        5cH,04H,00H
          DB        18H,0EH,0fH ;02 0A 0E
          DB        19H,0FH,0fH ;02 0A 0F
          DB        1aH,0FH,0fH ;02 0A 00 0F
          DB        57H,01H,00H
          DB        58H,00H,01H
          DB        02H,00H,0eH
          DB        16H,0EH,0fH ;02 0A 01 01 dd 0E
          DB        17H,0FH,0fH ;02 0A 01 01 dd 0F
          DB        1bH,0FH,0fH ;02 0A 02 0F
          DB        1cH,0FH,0fH ;02 0A 04 0F
;*% DEFINE 020B SEQUENCES
          DB        02H,00H,0eH
          DB        60H,01H,00H
          DB        62H,02H,00H
          DB        61H,00H,01H
          DB        1dH,0FH,0fH ;02 0B 01 dd 0F
          DB        02H,00H,0eH
          DB        1eH,0EH,0fH ;02 0B 02 0E
          DB        1FH,0FH,0FH ;02 0B 02 0F
;*% DEFINE 020C SEQUENCES
          DB        02H,00H,0eH
          DB        68H,01H,00H
          DB        6cH,02H,00H
          DB        69H,02H,00H
          DB        6aH,00H,00H
          DB        6bH,00H,01H
          DB        20H,0FH,0fH ;02 0C 01 02 00 dd 0F
          DB        6dH,00H,01H
          DB        21H,0FH,0fH ;02 0C 02 dd 0F
;*% DEFINE 020D SEQUENCES
          DB        02H,00H,0eH
          DB        71H,01H,00H
          DB        72H,0CH,00H
          DB        22H,00H,1fH ;02 0D 01 dd.....
          DB        73H,03H,00H
          DB        23H,0FH,0fH ;02 0D 0C 03 0F

CODE      ENDS
          END
