;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M90
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    DATE
PUBLIC    ERROR_79
PUBLIC    GETTIME
PUBLIC    INITCK
PUBLIC    RTC_34
PUBLIC    PSWRD
PUBLIC    SETCLK
PUBLIC    VERSION_X
PUBLIC    TIME
PUBLIC    TIMEUP
;PUBLIC    UPCLK
PUBLIC    VDATE
PUBLIC    VTIME

EXTRN     ENBLDEVB:NEAR
EXTRN     RELA_B:NEAR
EXTRN     ERROR_08:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_19:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     WAITIBS:NEAR
EXTRN     ENDSTMT:NEAR
EXTRN     ALPHA1:NEAR
EXTRN     ERROR:NEAR
EXTRN     OBSNT:NEAR
EXTRN     CBSNT:NEAR
EXTRN     CCNL:NEAR

EXTRN     _INITPSW:WORD
EXTRN     _PSWRD:WORD
EXTRN     TIMED:BYTE
EXTRN     CLKADR:BYTE
EXTRN     SCRATCH:BYTE
EXTRN     MXDADR:BYTE
EXTRN     CSVER:NEAR

extrn     delay5:near

;-----------------------------------------------------------------------------;
;        FILE = MLMVP90 ,09/09/1986
;        MODULE    MOD-90 TIME VERBS AND ROUTINES
;              ************************************
;              *                                  *
;              *  MOD-90 TIME VERBS AND ROUTINES  *
;              *                                  *
;              ************************************
;
; Referenced modules:
;
;        SYMBL     BPMVP00   system equates
;        SYMBL     BPMVP05   I/O subroutines
;        SYMBL     DAMVP35   terminal I/O
;        SYMBL     BPMVP02   text scanning
;        SYMBL     BPMVP06   subroutines
;        SYMBL     BPMVP10   alphanumerics
;        SYMBL     BPMVP01   end statement
;        SYMBL     BPMVP8D   ram constants
;        SYMBL     BPMVP9D
;        SYMBL     BPMVP19
;-----------------------------------------------------------------------------;
;        TITLE     TIME AND DATE VERBS
; VDATE: Process a DATE verb.
;
; FORMAT: DATE = alpha-arg PASSWORD alpha-arg
;
; VTIME: Process a TIME verb.
;
; FORMAT: TIME = alpha-arg PASSWORD alpha-arg
;
; ENTRY: Text pointer should point at proposed receiver.
;
; EXIT: Special receiver statment is processed.
;-----------------------------------------------------------------------------;
;%====== process a set date ===================================================
vdate:  mov     edx,offset timed        ;pt to year
        mov     cl,0                    ;flag don't care if clock or not
        jmp     setclk                  ;

;%===== process a set time ===================================================
vtime:
        mov     edx,offset timed+3      ;pt to hour
        mov     cl,0ffh                 ;flag chk clock exist

;%===== process a time set statement =========================================
setclk:
        mov     aux06,edx               ;save timed ptr
        push    cx                      ;save flag
        cmp     byte ptr [textptr],'='
        jne     error_12                ;branch if not match
        inc     textptr

;%===== find and process an alpha variable ===================================
        mov     k,4                     ;
        call    alpha1                  ;get current length of alpha argument
        test    r0,0fh                  ;br, if not found
        jnz     setclk8                 ;
        mov     aux07,textptr           ;save ptr of alpha
        call    pswrd                   ;chk password
        pop     cx                      ;restore flag
        mov     r4,cl                   ;
        test    sl,xphase               ;br, if not execution phase
        jz      setclk4                 ;

        mov     edx,vsptr               ;
        mov     eax,dword ptr [edx]       ;get length
        mov     dword ptr a0,eax          ;
        mov     edx,dword ptr [edx+4]   ;get addr
        add     vsptr,8                 ;
        cmp     eax,6                    ;br, if length <> 6
        jne     setclk9                 ;

;%===== check format =========================================================
;
;        check current length
;
        mov     aux00,edx               ;save addr
        mov     ecx,6                   ;
setclk1:
        mov     al,byte ptr [edx]       ;get the character
        cmp     al,30h                  ;br, if char < 30h
        jb      setclk9
        cmp     al,39h                  ;br, if char > 39h
        ja      setclk9
        inc     edx                     ;
        loop    setclk1

        CMP       R4,0          ;SKIP IF DON'T CARE
        JE        SETCLK5
;@      MOV       EDX,OFFSET CLKADR    ;GET CLOCK ADDR
;@      MOV       CH,[EDX]
;@      CMP       CH,R4         ;ERROR IF NO CLOCK
;@      JE        SETCLK7
;%===== set the time =========================================================
;
SETCLK5: MOV    EDX,AUX00       ;POINT AT STRING
        mov     ebx,aux06       ;pt to timed buffer
        mov     ecx,3           ;set loop = 3
SETCLK3:
        mov     ah,byte ptr [edx]       ;get high digit
        and     ah,0fh                  ;
        shl     ah,4                    ;
        mov     al,byte ptr [edx+1]     ;get low digit
        and     al,0fh                  ;
        or      al,ah
        mov     byte ptr [ebx],al       ;save it in timed
        inc     ebx
        add     edx,2
        loop    setclk3

;******* to put in new code for RTC     !!
;(1)    check UIP till ready
;(2)    set the time
;
        mov     ecx,3000h
        mov     al,0ah                  ;RTC register A
rtc_0:
        call    delay5
        mov     fs:[rtcaddr],al         ;select RTC register
        nop
        call    delay5
        mov     ah,fs:[rtcdata]
        test    ah,80h                  ;chk if update in progress
        jz      rtc_1                   ;br, if no
        loop    rtc_0
        jmp     setclk9                 ;br, if error
rtc_1:
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        or      al,20h
        call    delay5
        mov     byte ptr fs:[rtcdata],al        ;make 32.768KHz ..
        call    delay5
        nop
        mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        or      al,82h
        mov     byte ptr fs:[rtcdata],al        ;make 24 hours, BCD, ....

        mov     ebx,aux06
        cmp     ebx,offset timed                ;chk date or time
        je      rtc_2                           ;br, if it's date
        call    delay5
        mov     byte ptr fs:[rtcaddr],0         ;select RTC register - second
        aad
        mov     ah,byte ptr [ebx+2]             ;get sec
        call    delay5
        mov     byte ptr fs:[rtcdata],ah
        aad
        call    delay5
        mov     byte ptr fs:[rtcaddr],2         ;select RTC register - minute
        aad
        call    delay5
        mov     ah,byte ptr [ebx+1]             ;get minute
        mov     byte ptr fs:[rtcdata],ah
        aad
        call    delay5
        mov     byte ptr fs:[rtcaddr],4         ;select RTC register - hour
        aad
        mov     ah,byte ptr [ebx]               ;get hour
        call    delay5
        mov     byte ptr fs:[rtcdata],ah
        aad
        jmp     rtc_29                          ;exit done
rtc_2:
        call    delay5
        mov     byte ptr fs:[rtcaddr],7         ;select RTC register - day
        aad                                     ;Anita
        mov     ah,byte ptr [ebx+2]             ;get day
        call    delay5
        mov     byte ptr fs:[rtcdata],ah        ;
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],8         ;select RTC register - month
        aad                                     ;Anita
        mov     ah,byte ptr [ebx+1]             ;get month
        call    delay5
        mov     byte ptr fs:[rtcdata],ah        ;
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],9         ;select RTC register - year
        aad                                     ;Anita
        mov     ah,byte ptr [ebx]               ;get year
        call    delay5
        mov     byte ptr fs:[rtcdata],ah        ;
rtc_29:
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
        nop
        call    delay5
        mov     byte ptr fs:[rtcdata],20h       ;make 32.768KHz ..
        nop
        call    delay5
        mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
        nop
        call    delay5
        mov     byte ptr fs:[rtcdata],02        ;make 24 hours, BCD, ....
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ch       ;select RTC register B
        nop
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        call    delay5
        mov     byte ptr fs:[rtcaddr],0dh       ;select RTC register B
        nop
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;

SETCLK4:  JMP       ENDSTMT     ;EXIT DONE

;%==== errors ===============================================================
;
SETCLK7:  JMP       ERROR_08    ;ERROR

SETCLK8:  JMP       ERROR_29    ;MISSING ALPHA-EXPRESSION

SETCLK9:  MOV       EDX,AUX07
          MOV       TEXTPTR,EDX ;POINT AT VAR.
          JMP       ERROR_34    ;ILLEGAL VALUE
;-----------------------------------------------------------------------------;
;         TITLE     PASSWORD                                                  ;
;                                                                             ;
; PSWRD: Process a password clause.                                           ;
;                                                                             ;
; FORMAT: PASSWORD alpha-variable or literal                                  ;
;                                                                             ;
; ENTRY: TEXTPTR should point at the PASSWORD atom.                           ;
;                                                                             ;
; EXIT: If given password matches system password,                            ;
;            then return,                                                     ;
;       else give an error.                                                   ;
;-----------------------------------------------------------------------------;
;%====== look for the PASSWORD atom ===========================================
PSWRD:    MOV       EDX,OFFSET _PSWRD
          CALL      CCNL        ;FIND PASSWORD
          TEST      R0,0FH      ;BR IF FOUND
          JZ        PSWRD2
          JMP       ERROR_19    ;MISSING WORD

;%====== get and check the password ===========================================
PSWRD2:   MOV       K,4
          CALL      ALPHA1      ;GET THE PASSWORD
          TEST      R0,0FH      ;ERROR MISSING ALPHA
          JNZ       PSWRD7
          TEST      SL,XPHASE   ;CHECK PHASE
          JZ        PSWRD1
          MOV       DX,WORD PTR R4
          PUSH      EDX         ;SAVE R5R4
          MOV       EDX,OFFSET _INITPSW  ;POINT TO SYSTEM PASSWORD
          MOV       AUX00,EDX
          MOV       DWORD PTR A2,8
;         CALL      POPV4       ;LEN ==. R1R0, ADDR ==> CHCL
          MOV       EDX,VSPTR
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       ECX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       EDX,ECX
          MOV       R7,2
;2/21/89 ++
          mov       ecx,dword ptr a0
          mov       eax,dword ptr a2
          mov       esi,edx
          mov       edi,aux00
          call      rela_b
;         CALL      RELALPHB    ;COMPARE TO PASSWORD
;2/21/89 --
          CMP       R7,2        ;BR IF NO MATCH
          JNE       ERR_126
          POP       EDX
          MOV       WORD PTR R4,DX  ;RESTORE R5R4
PSWRD1:   RET

PSWRD7:   JMP       ERROR_29    ;MISSING ALPHA-VAR.

ERR_126:  JMP       ERROR_79    ;INVALID PASSWORD (ERR_126 IN BASIC-3)
;-----------------------------------------------------------------------------;
;         TITLE     UPDATE CLOCK                                              ;
;                                                                             ;
; UPCLK: Advance the time by one second.                                      ;
;                                                                             ;
; ENTRY: This routine should be called once a second.                         ;
;                                                                             ;
; EXIT: Time updated by one second.                                           ;
;                                                                             ;
; MODIFIED: F1, PHPL.                                                         ;
;-----------------------------------------------------------------------------;
;*********************************************************
;       On entry AL has the second count report from MXD..
;
;upclk:
;        xor     ah,ah           ;use as minutes count
;
;upclk_1:
;        cmp     al,3ch          ;over 60 secs
;        jl      upclk_0         ;br, if less than 60 secs
;        sub     al,3ch          ;translate into minute
;        inc     ah              ;increment minute count
;        jmp     upclk_1         ;chk again
;
;upclk_0:
;        add     timed+5,al      ;add secs
;        cmp     timed+5,3ch     ;is it over 60
;        jge     upclk_m         ;br, if over 60 secs goto update minute
;        or      ah,ah           ;have we done the update?
;        jz      upclkr          ;br, yes
;        jmp     upclk_m0        ;just update minute
;upclk_m:
;        sub     timed+5,3ch     ;update correct sec
;        inc     ah              ;
;
;upclk_m0:
;        add     timed+4,ah      ;
;        cmp     timed+4,3ch     ;is it over 60
;        jge     upclk_h         ;br, if over 60 minutes
;        jmp     upclkr          ;all set
;
;upclk_h:
;        sub     timed+4,3ch     ;update correct minutes
;
;        inc     timed+3         ;
;        cmp     timed+3,18h     ;is it over 24
;        jge     upclk_d         ;br, if over 24 hours
;        jmp     upclkr          ;all set
;
;upclk_d:
;        mov     ah,30           ;day of month
;        sub     timed+3,18h     ;update correct hours
;        cmp     timed+1,2       ;chk if Febuary
;        jne     upclk_d0        ;br, if not
;        mov     ah,29           ;
;        test    timed,03h       ;chk if leap year
;        jz      upclk_d1        ;br, if yes
;        mov     ah,28           ;
;
;upclk_d1:
;        inc     timed+2         ;update date
;        cmp     timed+2,ah      ;over day of Feb
;        jge     upclk_mn        ;br, if yes
;        jmp     upclkr          ;
;
;upclk_d0:
;        mov     ch,timed+1
;        cmp     ch,8            ;month larger than Aug
;        jge     upclk_d2        ;
;        test    ch,1            ;
;        jz      upclk_d3        ;30 days for Apr,June
;        inc     ah              ;31 days for Jan,Mar,May,Jul
;        jmp     upclk_d3        ;
;
;upclk_d2:
;        test    ch,1            ;
;        jnz     upclk_d3        ;30 days for Sep, Nov
;        inc     ah              ;31 days for Aug,Oct,Dec
;
;upclk_d3:                       ;
;        inc     timed+2         ;update date
;        cmp     timed+2,ah      ;over day of the month
;        jge     upclk_mn        ;br, if yes
;        jmp     upclkr          ;
;
;upclk_mn:
;        inc     timed+1         ;update month
;        cmp     timed+1,12      ;over months of the year
;        jge     upclk_y         ;br, if yes
;        jmp     upclkr          ;
;
;upclk_y:
;        sub     timed+1,12      ;
;        inc     timed           ;
;        cmp     timed,63h       ;less than 99
;        jle     upclkr          ;br, if yes
;        mov     timed,0
;
;upclkr:
;        ret
;-----------------------------------------------------------------------------;
;         TITLE     DAY OF YEAR
;
; DAYS: Return year and day of year. (NOT IMPLEMENTED)
;
; ENTRY: The time counts should be valid.
;
; EXIT: The first five bytes of scratch area will look as follows:
;
;                  year (00 - 99)
;                  day of year (000 - 365)
;
; MODIFIED: F1F0 F3F2 PHPL K AUX0.
;
; RAM: First five bytes of scratch area.
;
;
;*DAYS     MVI       01,F2                          years only
;*        SB        GETTIMEA                       get year
;
;*        LPI,R     TIMED+1                        read month
;*        AI        FF,CH,F0                       month - 1 ==> F0
;*        MVI       00,F1                          00 ==> F1
;
;*DAYS0    MIL       0F,F0,F0
;*        ACX,0     F1F0,F1F0,F1F0                 30 * (month - 1) ==> F1F0
;
;*        OR        CH+,,F4                        month ==> F4
;
;*        OR,R      -,,                            read day
;*        ANDX      DCH,SLCH,F3F2                  day ==> F3F2
;
;*        handle January and Febuary
;
;*        BEQLL     1,F4,DAYS1                     skip if January
;*        BNELL     2,F4,DAYS2                     skip if not Febuary
;
;*DAYS1    AI        4,F4,F4                        displace by four
;*        B         DAYS2A
;
;*        handle leap years
;
;*DAYS2    LPI,R     TIMED                          read years
;*        BTLL      01,CH,DAYS2A
;*        BTLL      02,CH,DAYS2A                   skip if not leap year
;
;*        AI        1,F2,F2                        add in an extra day
;
;*        handle March through December
;
;*DAYS2A   BFL       08,F4,DAYS3                    skip if month < 8
;*        AI        1,F4,F4                        displace by one
;
;*DAYS3    MIL       8,F4,F4
;*        SHLH      F4,,F4                         divide by two
;*        AI        100-2,F0,F0                    subtract two
;*        AC,0      F4,F0,F0                       add to total, ignore carry
;
;*        ACX,0     F3F2,F1F0,F1F0                 day of year ==> F1F0
;
;*        convert to ASCII
;
;*DAYS5    SB        BINDEC                         F1F0 ==> F4F3F2 (decimal)
;
;*        LPI       SCRATCH+2
;*        ORI       30,F3,F3                       high digit ==> F3
;*        OR,W1     +,F3,                          write high digit
;
;*        SHHH      F2,F3,F3                       middle digit ==> F3
;*        OR,W1     +,F3,                          write middle digit
;
;*        SHHL      F2,F3,F3                       low digit ==> F3
;*        SR,W1     F3                             write low digit and exit
;
;*DAYSR    SR                                       exit
;-----------------------------------------------------------------------------;
;         TITLE     GETTIME
;
; GETTIME: Get the time.
;
; ENTRY: The contents of CLKADR must be valid.
;
; EXIT: Fourteen unpacked digits representing the time (two bytes
;       for each unit of time) are stored in the first fourteen
;       bytes of the scratch area in the following manner:
;
;                 years (00 - 99)
;                 months (01 - 12)
;                 days (01 - 31)
;                 hours (00 - 23)
;                 minutes (00 - 59)
;                 seconds (00 - 59)
;                 centiseconds (00)
;
; MODIFIED REGISTERS: F1F0, F3F2, PHPL, AUX0
;
; MODIFIED RAM: The first fourteen bytes of the scratch are modified.
;
;
; GETTIMEA: Get some time.
;
; ENTRY: F2 should contain the number of time units to convert.
;
; EXIT: Same as GETTIME except only specified times are converted.
;-----------------------------------------------------------------------------;
gettimea:
        movzx   ecx,r2
        jmp     gettimex

gettime:

;**** process RTC data reading ...
;(1)    check UIP bit
;(2)    get the time
;
                                                ;Anita for new cpu board
;       mov     ecx,1000
        mov     ecx,3000h
                                                ;Anita
        mov     al,0ah                          ;RTC register A
rtc_10:
        call    delay5
        mov     byte ptr fs:[rtcaddr],al        ;select RTC register
        nop
        call    delay5
        mov     ah,byte ptr fs:[rtcdata]
        test    ah,80h                          ;chk if update in progress
        jz      rtc_20                          ;br, if no
        loop    rtc_10
        jmp     setclk9                         ;br, if error

rtc_20:
        mov     ebx,offset timed

        call    delay5
        mov     byte ptr fs:[rtcaddr],0         ;second
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx+5],al

        call    delay5
        mov     byte ptr fs:[rtcaddr],2         ;minute
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx+4],al

        call    delay5
        mov     byte ptr fs:[rtcaddr],4         ;hour
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx+3],al

        call    delay5
        mov     byte ptr fs:[rtcaddr],7         ;day
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx+2],al

        call    delay5
        mov     byte ptr fs:[rtcaddr],8         ;month
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx+1],al

        call    delay5
        mov     byte ptr fs:[rtcaddr],9         ;year
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     byte ptr [ebx],al

        mov     ecx,7
gettimex:
        mov     edx,offset scratch              ;pt to work buffer
        mov     ebx,offset timed
gettime1:
        xor     ax,ax
        mov     al,byte ptr [ebx]               ;get the years
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h                        ;make it ascii
        xchg    al,ah                           ;swap
        mov     word ptr [edx],ax               ;save it
        inc     ebx
        add     edx,2
        loop    gettime1
        ret
;----

;-----------------------------------------------------------------------------;
;         TITLE     FIND A CLOCK
;
; INITCK: Do all clock initialization.
;
; ENTRY: MXD address table must contain all active MXD addresses.
;
; EXIT: CLKADR will contain the command address of an MXD with a clock
;       of 'FF' if no clock exists.  The time counts are initialized
;       and the clock is started
;
; MODIFIED REGISTERS: F1F0 F3F2 AUX0 PHPL
;
; SEQUENCES:
;
;      Type request sequence:
;
;           CBS     &TYPE
;           OBS     NULL
;           WR
;           IBS     type
;                .
;                .        IGNORED
;                .
;           IBS     ENDI
;
;      Start timer sequence:
;
;           CBS     &TICK
;           CBS     count
;
;
; ALGORITHM:
;
;      This routine sends a GET TYPE command to an MXD and waits
;      up to 15ms for a response.  If the MXD responds with TYPE = '02',
;      the MXD command address is stored in CLKADR.  Otherwise the next
;      MXD is scanned.  If no MXD has a clock, CLKADR is set to 'FF'.
;
;-----------------------------------------------------------------------------;
;%===== initialize counts ====================================================
INITCK:
        mov     timed,0
        mov     timed+1,1
        mov     timed+2,1
        mov     timed+3,0
        mov     timed+4,0
        mov     timed+5,0
        mov     timed+6,0
        mov     timed+7,0

        mov     ecx,3000h
        mov     al,0ah                  ;RTC register A
rtc_30:
        call    delay5
        mov     fs:[rtcaddr],al         ;select RTC register
        nop
        aad                             ;Anita
        call    delay5
        mov     ah,fs:[rtcdata]
        test    ah,80h                  ;chk if update in progress
        jz      rtc_31                  ;br, if no
        loop    rtc_30
rtc_31:

        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     al,21h                          ;make 32.768KHz
        call    delay5
        mov     byte ptr fs:[rtcdata],al        ;make 32.768KHz ..
        aad                             ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     al,02h                          ;make 24 hours
        call    delay5
        mov     byte ptr fs:[rtcdata],al        ;make 24 hours, BCD, ....

        aad                             ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ch       ;select RTC register C
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;read in
        aad                             ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0dh       ;select RTC register D
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;read in

        mov     ecx,3000h
rtc_32:
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register
        nop
        aad                             ;Anita
        call    delay5
        mov     ah,byte ptr fs:[rtcdata]
        test    ah,80h                          ;chk if update in progress
        jz      rtc_34                          ;br, if no
        loop    rtc_32
rtc_34:
        call    delay5
        mov     byte ptr fs:[rtcaddr],09        ;select register - year
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;read year (00 - 99)
        cmp     al,99h                          ;chk if in bianry data mode
        ja      rtc_40                          ;br, if in BCD mode

        call    delay5
        mov     byte ptr fs:[rtcaddr],8         ;month (01 - 12)
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]
        cmp     al,12h
        ja      rtc_40

        call    delay5
        mov     byte ptr fs:[rtcaddr],7         ;day (01 - 31)
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]
        cmp     al,31h
        ja      rtc_40

        call    delay5
        mov     byte ptr fs:[rtcaddr],4         ;hour (01 - 24)
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]
        cmp     al,24h
        ja      rtc_40

        call    delay5
        mov     byte ptr fs:[rtcaddr],2         ;minute (01 - 60)
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]
        cmp     al,60h
        ja      rtc_40

        call    delay5
        mov     byte ptr fs:[rtcaddr],0         ;second (01 - 60)
        nop
        aad                             ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]
        cmp     al,60h
        jbe     rtc_99

rtc_40:
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
        nop
        aad                                     ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;make 32.768KHz ..

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
        aad                                     ;Anita
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;
        mov     al,82h                          ;
        call    delay5
        mov     byte ptr fs:[rtcdata],al        ;make set bit on

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],0         ;second
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],1         ;second alarm
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],2         ;minute
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],3         ;minute alarm
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],4         ;hour
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],5         ;hour alarm
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],0         ;0

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],6         ;day of week
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],1         ;sunday

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],7         ;day
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],01h       ;01

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],8         ;month
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],01h       ;01

        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcaddr],9         ;year
        nop
        aad                                     ;Anita
        call    delay5
        mov     byte ptr fs:[rtcdata],89h       ;89
;        mov     ecx,600
;rtc_33:
;        mov     byte ptr fs:[rtcaddr],0ah      ;select RTC register
;        nop
;        mov     ah,byte ptr fs:[rtcdata]
;        test    ah,80h                         ;chk if update in progress
;        jz      rtc_35                         ;br, if no
;        loop    rtc_33                         ;
;rtc_35:
                                                ;Anita for 33M cpu board
;       mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
;       mov     al,byte ptr fs:[rtcdata]        ;
;       mov     al,21h                          ;make 32.768KHz
;       mov     byte ptr fs:[rtcdata],al        ;make 32.768KHz ..
;       mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
;       mov     al,byte ptr fs:[rtcdata]        ;
;       mov     al,02h                          ;make 24 hours
;       mov     byte ptr fs:[rtcdata],al        ;make 24 hours, BCD, ....
        aad                                     ;delay for a wile
rtc_99:
        call    delay5
        mov     byte ptr fs:[rtcaddr],0ah       ;select RTC register A
        nop
        aad                                     ;delay for a wile
        call    delay5
        mov     byte ptr fs:[rtcdata],20h       ;make 32.768KHz ..
        nop
        aad                                     ;delay for a wile
        call    delay5
        mov     byte ptr fs:[rtcaddr],0bh       ;select RTC register B
        nop
        aad                                     ;delay for a wile
        call    delay5
        mov     byte ptr fs:[rtcdata],02        ;make 24 hours, BCD, ....
        aad                                     ;delay for a wile
                                                ;Anita

        call    delay5
        mov     byte ptr fs:[rtcaddr],0ch       ;select RTC register C
        nop
        aad                                     ;delay for a wile
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;read in
        aad                                     ;delay for a wile
        call    delay5
        mov     byte ptr fs:[rtcaddr],0dh       ;select RTC register D
        nop
        aad                                     ;delay for a wile
        call    delay5
        mov     al,byte ptr fs:[rtcdata]        ;read in

        ret

;%===== search for a clock ===================================================

          MOV       R0,0        ;R0 = 0, INITIAL COUNT
          MOV       EDX,OFFSET MXDADR    ;POINT TO MXD ADDR TABLE

INITCK1:  MOV       CH,[EDX]    ;READ ADDR AND UPDATE PC
          INC       EDX
          XCHG      EDX,AUX00
          CMP       CH,0FFH
          JE        INITCK4     ;BR, IF NO MXD

          MOV       AL,CH
          AND       AL,0C0H
          OR        AL,6
          MOV       R3,AL       ;STORE COMMAND ADDR IN R3
          MOV       K,AL
          CALL      ENBLDEVB    ;ENABLE THE MXD

          MOV       AL,?amTYPE
          CALL      CBSNT       ;SEND GET TYPE COMMAND
          MOV       AL,NULL
          CALL      OBSNT       ;SEND NULL TO MAKE BUSY
_M9001A:  TEST      BYTE PTR FS:[CPUST],08H
          JZ        _M9001A     ;WAIT UNTIL MXD OR TIME OUT
          CALL      WAITIBS     ;WAIT FOR BYTE OR TIME OUT
          TEST      BYTE PTR FS:[CPUST],CPB  ;BR IF NO ANSWER
          JZ        INITCK4
          MOV       AL,K
          MOV       R2,AL       ;SAVE MXD TYPE

INITCK3:  MOV       AX,WORD PTR FS:[CPUST]  ;CPB AND ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],AL
_M9002:   TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR ANSWER
          JZ        _M9002
          TEST      BYTE PTR FS:[CPUST],4   ;BR NOT ENDI
          JZ        INITCK3
          TEST      R2,2        ;CHECK FOR CLOCK (TYPE 02)
          JZ        INITCK4
;%===== clock found ==========================================================
;
          MOV       EDX,OFFSET CLKADR
          MOV       AL,R3       ;WRITE CLOCK ADDR
          MOV       K,AL
          MOV       [EDX],AL
          CALL      ENBLDEVB    ;ENABLE MXD

          MOV       AL,?amTICK
          CALL      CBSNT       ;SEND COMMAND CODE
          MOV       AL,1
          CALL      OBSNT       ;INTERRUPT AFTER ONE SECOND
          JMP       INITCKR     ;DISABLE AND EXIT
;%===== search for next MXD ==================================================
;
INITCK4:                        ;CPU IS BUSY
          MOV       EDX,AUX00   ;POINT TO NEXT MXD ADDR
          INC       R0
          MOV       AL,R0       ;UPDATE COUNT
          AND       AL,0FH
          CMP       AL,4
          JNE       INITCK1     ;LOOP
;%===== no clock found =======================================================
;
          MOV       EDX,OFFSET CLKADR
          MOV       BYTE PTR [EDX],0FFH ;INDICATE NO CLOCK
;        set counts to 99
;
          MOV       EDX,OFFSET TIMED+3
          MOV       EAX,63636363H
          MOV       R0,AL
          MOV       [EDX],EAX   ;99 ==> HOURS, MINUTES
                                ;99 ==> SECONDS, CENTISECONDS
          ADD       EDX,4
INITCKR:  MOV       K,0
          JMP       ENBLDEVB    ;DISABLE MXD AND EXIT
;-----------------------------------------------------------------------------;
;         TITLE     TIME FUNCTIONS
;
; DATE: Scan and evaluate a DATE function.
;
; FORMAT: DATE
;
; ENTRY: TEXTPTR points at next text character.
;
; EXIT: F0 = 0 and TEXTPTR points after DATE.
;
;          In execution phase,
;               string is put in start of scratch area
;               F3F2 = length of value
;               AUX0 = address of DATE string.
;
; MODIFIED REGISTERS: all, AUX0
;-----------------------------------------------------------------------------;
DATE:     TEST      SL,XPHASE   ;EXIT IF NOT X-PHASE
          JZ        TIMEUP2
          CALL      GETTIME     ;GET THE DATE
          MOV       EDX,OFFSET SCRATCH   ;START AT SCRATCH AREA
          MOV       A2,6        ;LENGTH EQUALS SIX
          JMP       TIMEUP
;-----------------------------------------------------------------------------;
; TIME: Scan and evaluate a TIME function.
;
; FORMAT: TIME
;
; ENTRY: TEXTPTR points at next text character.
;
; EXIT: F0 = 0 and TEXTPTR points after TIME.
;
;          In execution phase,
;               string is put in start of scratch area
;               F3F2 = length of value
;               AUX0 = address of TIME string.
;
; MODIFIED REGISTERS: all, AUX0
;-----------------------------------------------------------------------------;
TIME:     TEST      SL,XPHASE   ;EXIT IF NOT X-PHASE
          JZ        TIMEUP2
          CALL      GETTIME     ;GET TIME
          MOV       EDX,OFFSET SCRATCH+6
          MOV       A2,8        ;LENGTH EQUALS EIGHT
          JMP       TIMEUP

;-----------------------------------------------------------------------------;
; VERSION: Get Release Version function.
;
; FORMAT: VERSION
;
; ENTRY: TEXTPTR points at next text character.
;
; EXIT: F0 = 0 and TEXTPTR points after VERSION.
;
;          In execution phase,
;               string is put in start of scratch area
;               F3F2 = length of value
;               AUX0 = address of VERSION string.
;
; MODIFIED REGISTERS: all, AUX0
;-----------------------------------------------------------------------------;
VERSION_X:TEST      SL,XPHASE   ;EXIT IF NOT X-PHASE
          JZ        VERSIONUP2
          MOV       EDX,OFFSET CSVER
          MOV       A2,32       ;LENGTH EQUALS EIGHT

          MOV       A3,0        ;length ==> F3F2
          MOV       AUX00,EDX   ;address ==> AUX0

VERSIONUP2:MOV       R0,0        ;flag as found
          RET

;-----------------------------------------------------------------------------;
; DAY: Scan and evaluate a DAY function.   (NOT IMPLEMENTED)
;
; FORMAT: DAY
;
; ENTRY: TEXTPTR points at next text character.
;
; EXIT: F0 = 0 and TEXTPTR points after DAY.
;
;          In execution phase,
;               string is put in start of scratch area
;               F3F2 = length of value
;               AUX0 = address of DAY string.
;
; MODIFIED REGISTERS: all, AUX0
;-----------------------------------------------------------------------------;
;*DAY     BFLL      XPHASE,SL,TIMEUP2              exit if not execution phase
;*        SB        DAYS                           get day
;*        LPI       SCRATCH
;*        MVI       5,F2                           length equals five
;
;%==== fall through to TIMEUP ===============================================
;         EJECT
;-----------------------------------------------------------------------------;
; TIMEUP: Finish up a time function
;
; EXIT: Zero out upper byte of length, transfer address to AUX0, flag
;       as found, and exit.
;-----------------------------------------------------------------------------;
TIMEUP:   MOV       A3,0        ;length ==> F3F2
          MOV       AUX00,EDX   ;address ==> AUX0

TIMEUP2:  MOV       R0,0        ;flag as found
          RET

;==============================================================================

ERROR_79: MOV       R0,79H      ;ILLEGAL PASSWORD
          JMP       ERROR
ENDMOD90:

CODE      ENDS
          END
