;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M98
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    $CLOSTC
PUBLIC    $CLSTCA
PUBLIC    $OPENTC
PUBLIC    $OPENDTC
PUBLIC    ENBLTC
PUBLIC    MXESTA
PUBLIC    MXESTA6
PUBLIC    MXEPSW
PUBLIC    PERRMXE
PUBLIC    SLCTERM
PUBLIC    SLCTTC
PUBLIC    SLTADRT
PUBLIC    TCGIO
PUBLIC    WAITRDB6

EXTRN     MXD2SADR:BYTE
EXTRN     MXD3SADR:BYTE
EXTRN     MXD4SADR:BYTE
EXTRN     PART_:BYTE
EXTRN     PSTAT:DWORD
EXTRN     PTC:DWORD
EXTRN     PTERM:DWORD
EXTRN     TEMADRTBL:DWORD
EXTRN     TPDEVTBL:DWORD
EXTRN     _INITPSW:DWORD

EXTRN     $CLOSE4:NEAR
EXTRN     $OPEN1:NEAR
EXTRN     $OPEN91:NEAR
EXTRN     $OPENDB:NEAR
EXTRN     AVARB:NEAR
EXTRN     BREAKPTB:NEAR
EXTRN     BREAKPTT:NEAR
EXTRN     BREAKPTW:NEAR
EXTRN     CBSNT:NEAR
EXTRN     DEVADDR:NEAR
EXTRN     ENBLDEVB:NEAR
EXTRN     ERROR_16:NEAR
EXTRN     ERROR_17:NEAR
EXTRN     ERROR_48:NEAR
EXTRN     ERROR_51:NEAR
EXTRN     HEXDIGTA:NEAR
EXTRN     OBSNT:NEAR
EXTRN     SLCTADR1:NEAR
EXTRN     SLCTADR5:NEAR
EXTRN     SLCTMORE:NEAR
EXTRN     WAITIBS:NEAR
EXTRN     WAITIBSE:NEAR
EXTRN     WAITRDYB:NEAR
EXTRN     TEN:BYTE
;------- TSAI -----
EXTRN     MXF:WORD
EXTRN     MXFTBL:DWORD
EXTRN     ERROR:NEAR
;------- TSAII -----
;-----------------------------------------------------------------------------;
; READLINE: Get an input line from keyboard or other device.                  ;
;                                                                             ;
; ENTRY: I/O buffer is located from XXXX to YYYY.                             ;
;        Address XXXX is in AUX IBUFBEG, TEXTEND and F7F6.                    ;
;        Address YYYY is in AUX IBUFEND.                                      ;
;        YYYY is at least 20 larger than XXXX.                                ;
;                                                                             ;
; The high order 4 bits of F5 are set as specified below.                     ;
;                                                                             ;
;        F4=00, except when entered from LIST S, when F4 is the keystroke     ;
;               already entered.                                              ;
;                                                                             ;
;-----------------------------------------------------------------------------;
;        FILE = SSMVP98 ,09/11/1986
;        MODULE    MOD-98    MXE TC
;
;      MODULE 98 : MXE TC ROUTINES
;
;    REFERENCED MODULES
;
;        SYMBL     BPMVP00   System equates
;        SYMBL     BPMVP02   Syntax checking
;        SYMBL     BPMVP08   MVP statements
;        SYMBL     JLMVP32   MVP subroutines
;        SYMBL     BPMVP05   I/O subroutines
;        SYMBL     DAMVP26   $GIO
;        SYMBL     BPMVP01   Control
;        SYMBL     BPMVP33   MVP statements
;        SYMBL     BPMVP36   SYSTEM Initialization
;        SYMBL     BPMVP8D   RAM constants
;        SYMBL     BPMVP12   MVP STATEMENTS
;        SYMBL     BPMVP06   SUBROUTINES
;        SYMBL     BPMVP07   EXPRESSION PROCESSING
;        SYMBL     BPMVP16   SUBROUITNES
;-----------------------------------------------------------------------------;
;   SLCTTC : SELECT TC PORT                                                   ;
;                                                                             ;
;   General form :                                                            ;
;                SELECT TC port number                                        ;
;   Where:                                                                    ;
;     port number = /Add, where dd is a integer decimal value from 02 to 16   ;
;                              = <alpha-var>                                  ;
;                                                                             ;
; This statement is used when a port is to be selected as a TC port as opposed;
; to as a terminal port.  No partition including the partition issuing this   ;
; statement should be assigned or attached to atht port hwen SELECT TC        ;
; statement is executed, otherwise an illegal device error will be generated. ;
;                                                                             ;
; When converting a terminal port to TC port is desired, a user should        ;
; release all partitions assigned to that particular terminal by $RELEASE PART;
; statement.                                                                  ;
;                                                                             ;
; Device address /Add or <alpha-var> indicates which port is being selected.  ;
; The first port 01 is not allowed to be selected as TC port becuase          ;
; this port is permanently selected as terminal tport for system console      ;
; purpose.  If the specified porty has been seleected as a TC port already, no;
; error will be generated.                                                    ;
;                                                                             ;
; ENTRY : TEXTPTR POINTS AFTER "SELECT"                                       ;
;-----------------------------------------------------------------------------;
SLCTTC:   CALL      _TCDEV          ;GET USER SPECIFIED TC PORT ADDR
          TEST      SL,02H          ;BRANCH IF NOT EXEC. PHASE
          JZ        SLCTTC9
          MOV       AX,WORD PTR R0  ;MOVE FOR INPUT TO RDDEVEX ROUTINE
          MOV       WORD PTR R4,AX
          CALL      RDDEVEX         ;GET PORT STATUS BYTE

          TEST      CH,TCPORT       ;RETURN IF TC PORT ALREADY
          JNZ       SLCTTC9
          CALL      TCTRANF         ;TRANSLATE USER SPECIFIED ADDR INTO MXE+PORT#
          MOV       WORD PTR R0,DX  ;R1,0 = MXE PORT #(EX. 40, C2, 81)
          CALL      CHKATTN         ;CHECK IF THE PORT IS ASSIGNED TO A TERMINAL
;
;========== Enable control addr of MXE and Select a TC port ==================
;
;-------- TSAI --------
          MOVZX     AX,R0
          SHR       AL,06
          BT        MXF,AX
          JNC       SLCTTC10         ;BR,if MXD
          MOVZX     EBX,R0
          AND       BL,0FH
          SHL       AL,04              ;xx__xxxx-->__xxxxxx
          OR        BL,AL              ;dword offset
          SHL       EBX,02
          MOV       EBX,[EBX+OFFSET MXFTBL]
SLCTTC11:
          CMP       GS:[EBX].cmd_sts,0FH
          JE        SLCTTC11                  ;wait till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amSELCOMM
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,?amSLCTTC ;sele a port as a TC
          MOV       GS:[EBX].cmd_sts,0FH      ;start command
          MOV       ECX,03A98H                ;about 15ms
SLCTTC12:
          CMP       GS:[EBX].cmd_sts,0f0H     ;if returned with value
          JZ        SLCTTC13
          LOOP      SLCTTC12
          JMP       SLCTTC8                   ;time out error
SLCTTC13:
          CMP       BYTE PTR GS:[EBX].cmd_parm,0H
          JNZ       SLCTTC8                   ;error if ret value <> 0
          INC       EDX
          CALL      TCSET
          JMP       SLCTMORE
SLCTTC10:
;--------- TSAII ------
          MOV       AL,R0
          AND       AL,PTERMXF      ;u64
          OR        AL,@MXDCADR
          MOV       K,AL            ;K = CONTROL ADDR OF MXE (06,46,86,C6)
          CALL      ENBLDEVB        ;ENABLE CONTROL ADDR OF MXE

          MOV       AL,?amSELTERM
          CALL      CBSNT           ;SELECT PORT COMMAND
          MOV       AL,R0
          AND       AL,PTERMNO      ;u64
          CALL      OBSNT           ;SELECT PORT
          MOV       AL,NULL
          CALL      OBSNT           ;INDICATION OF COMPLETION

          MOV       AL,?amSELCOMM   ;CONTROL COMMAND
          CALL      CBSNT
          MOV       AL,?amSLCTTC    ;SELECT A PORT AS A TC
SLCTTC7:  CALL      OBSNT

;========== Wait 15 ms, if no response time out error for MXD ================
          CALL      WAITIBS     ;wait 15 ms to find if it's MXE

; IF TC IS SUPPORTED THEN K = HEX(00) W/ENDI
          TEST      BYTE PTR FS:[CPUST],CPB  ;BR IF TIME OUT
          JZ        SLCTTC8
          CMP       K,0             ;BR IF NOT 00
          JNZ       SLCTTC8
          INC       EDX
          TEST      BYTE PTR FS:[CPUST],ENDI ;BR IF NOT ENDI
          JZ        SLCTTC8
          CALL      TCSET           ;SET A TC PORT INDICATION BIT IN DEV EXT TABLE

SLCTTC9:  JMP       SLCTMORE        ;SELECT NEXT DEVICE
SLCTTC8:                            ;SET CPB TO READY
          JMP       ERROR_48

;-----------------------------------------------------------------------------;
;   TCDEV : Get user specified TC port addr                                   ;
;                                                                             ;
;      Format : [/] Add   or <alpha-var>                                      ;
;               where dd is from 02 to 16                                     ;
;      Entry : ,TEXTPTR points to device type                                 ;
;      Return : User specified TC port addr is F1F0 in hex mode (A01 to A0F)  ;
;      Modified registers : CHCL,PHPL,F0,F1,F2                                ;
;-----------------------------------------------------------------------------;
_TCDEV:   CMP       BYTE PTR [TEXTPTR],'<'
          JNE       TCDEVS1
          INC       TEXTPTR         ;BR IF FOUND
          JMP       TCDEV3

;===== /Add Tc port specification ===============
TCDEVS1:
          CMP       BYTE PTR [TEXTPTR],'/'
          JNE       TCDEVS2
          INC       TEXTPTR         ;BR IF FOUND
          MOV       R0,0
TCDEVS2:
          CALL      DEVADDR         ;USER SPECIFIED TC PORT ADDR(DECIMAL)
          TEST      SL,2            ;BR IF NOT X-PHASE
          JZ        TCDEVSR
          CALL      DEVADTC1        ;USER SPECIFIED TC PORT ADDR(HEX)
TCDEVSR:  RET

;===== <alpha-var> TC port specification =========
TCDEV3:   CALL      AVARB           ;GET ALPHA VAR.
          TEST      SL,2            ;BR IF NOT X-PHASE
          JZ        TCDEV5
          CMP       DWORD PTR [A0],3
          JB        ERROR_51        ;ERROR IF LENGTH OF VAR. < 3

TCDEV5:                             ;LOOK FOR '>'
          CMP       BYTE PTR [TEXTPTR],'>'
          JNE       ERROR_16        ;NF, ERROR
          INC       TEXTPTR
          TEST      SL,2            ;RETURN IF NOT X-PHASE
          JZ        TCDEVSR

          MOV       EDX,AUX0F
          XCHG      EDX,TEXTPTR     ;POINT TO VALUE OF VAR.
          MOV       AUX0F,EDX       ;SAVE TEXTPTR
          CALL      HEXDIGTA        ;GET DEVICE TYPE
          TEST      R0,0F0H         ;BRANCH TO ERROR IF NF
          JNZ       TCDEVERR

          MOV       AL,R0
          MOV       R1,AL
          CALL      HEXDIGTA        ;GET 1ST DIGIT ADDR
          TEST      R0,0F0H         ;BRANCH TO ERROR IF NF
          JNZ       TCDEVERR
          MOV       AL,R0
          MOV       R2,AL
          CALL      HEXDIGTA        ;GET 2ND DIGIT OF ADDR
          TEST      R0,0F0H         ;BRANCH TO ERROR IF NF
          JNZ       TCDEVERR

          MOV       AL,R0           ;SHLL        F0,F2,F0
          AND       AL,0FH          ;R1,0 = TC PORT ADDR READ IN DECIMAL
          MOV       AH,R2
          SHL       AH,4
          OR        AH,AL
          MOV       R0,AH
          MOV       EDX,AUX0F
          MOV       TEXTPTR,EDX     ;RESTORE TEXTPTR
          JMP       DEVADTC1        ;TRANSLATE INTO HEX TC PORT ADDR

TCDEVERR: JMP       ERROR_17

;         TITLE     SLCTERM
;-----------------------------------------------------------------------------;
;   SLCTERM : Select a port as a regular terminal (15.02.44)                  ;
;                                                                             ;
;   General form :                                                            ;
;        SELECT TERMINAL port number                                          ;
;   Where :                                                                   ;
;        port number = /Add, where dd is a integer decimal value from 02 to 16;
;                    = <alpha-var>                                            ;
;                                                                             ;
;As opposed to SELECT TC statement, SELECT TERMINAL statement is used to select
;a port as a terminal port.  In another words, to convert a TC port to terminal
;port.  The port should not be opened as a TC port by another partition when  ;
;this SELECT TERMINAL statement is executed, otherwise an illegal device error;
;will be generated.  If the specified port has been seleected as a terminal port
;already, no error will be generated.  When system is powered on, all ports are
;selected as terminal ports.                                                  ;
;                                                                             ;
;     Entry : TEXTPTR POINTS AFTER "SELECT"                                   ;
;-----------------------------------------------------------------------------;
SLCTERM:  CALL      _TCDEV          ;GET USER SPECIFIED TC PORT ADDR
          TEST      SL,02H          ;BR IF NOT X-PHASE
          JZ        SETTERM9
          MOV       AX,WORD PTR R0
          MOV       WORD PTR R4,AX
          CALL      CHKOPN          ;CHECK IF THE PORT HAS BEEN OPENED ALREADY

          MOV       AL,R2
          AND       AL,0FH
          CMP       AL,NOTOPN       ;BR IF NOT OPENED YET
          JE        SETTERM2
          CMP       AL,OPNSELF      ;BR IF OPENED BY SOME PARTITION
          JE        SETTERM3
          JMP       ERROR_48        ;ERROR OPENED BY SOMEONE ELSE

;  I am not that quite sure whether this should be an error or Breakpointed.
;  I think it should get Brakpointed because it shouldn't get penalized for what
;  he didn't do.
;
SETTERM2: CALL      TCRESET         ;RESET A BIT INDICATING TERMINAL PORT
          CALL      TCTRANF         ;GET MXE PORT #
;-------- TSAI --------
          MOVZX     AX,DL
          SHR       AL,06
          BT        MXF,AX
          JNC       SETTERM4           ;BR,if MXD
          XOR       EBX,EBX
          MOV       BL,DL
          AND       BL,0FH
          SHL       AL,04              ;PORT NO xx__xxxx-->__xxxxxx
          OR        BL,AL              ;dword offset
          SHL       EBX,02
          MOV       EBX,[EBX+OFFSET MXFTBL]
SETTERM5:
          CMP       GS:[EBX].cmd_sts,0FH
          JE        SETTERM5             ;wait till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amSELCOMM
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,?amSLCTTRM;sele a port as a TC
          MOV       GS:[EBX].cmd_sts,0FH      ;start command
          MOV       ECX,03A98H
SETTERM14:
          CMP       GS:[EBX].cmd_sts,0f0H     ;if returned with value
          JZ        SETTERM13
          LOOP      SETTERM14
          MOV       R0,92H                    ;time out
          AND       MODE,07FFFH
          JMP       ERROR                     ;ERROR 92
SETTERM13:
          JMP       SLCTMORE
SETTERM4:
;--------- TSAII ------
          MOV       AL,DL
          AND       AL,PTERMXF      ;u64
          OR        AL,@MXDCADR     ;GET CONTROL ADDR OF MXE
          MOV       K,AL
          CALL      ENBLDEVB        ;ENABLE CONTROL ADDR OF MXE

          MOV       AL,?amSELTERM
          CALL      CBSNT           ;SELECT PORT COMMAND
          MOV       AL,DL
          AND       AL,PTERMNO      ;u64
          CALL      OBSNT           ;SELECT PORT
          MOV       AL,NULL
          CALL      OBSNT           ;INDICATION OF COMPLETION

          MOV       AL,?amSELCOMM   ;SELECT CONTROL COMMAND
          CALL      CBSNT
          MOV       AL,?amSLCTTRM   ;SELECT A PORT AS TERMINAL
          CALL      OBSNT
          CALL      WAITIBSE        ;WAIT 15 MS TO CHECK IF IT'S MXE
          JMP       SLCTMORE        ;CHOSE NEXT DEVICE

SETTERM3: CALL      RDDEVEX         ;GET PORT STATUS BYTE
          AND       CH,0F0H-TCPORT-DEVOPEN  ;RESET TO TERMINAL PORT ALSO CLOSE
          MOV       [EDX],CH

SETTERM9: JMP       SLCTMORE

;         TITLE     DEVADTC
;-----------------------------------------------------------------------------;
;   DEVADTC : Get user specified TC device addr in decimal and change it to hex
;         ENTRY :  ,TEXTPTR = Points to device type
;         Return : F1F0 = User specified device addr by HEX, A0F
;   DEVADTC1 : Same as DEVADTC except it gets input F1F0 as user specified device addr
;                   by decimal value
;
;-----------------------------------------------------------------------------;
DEVADTC1: TEST      SL,2            ;BR IF NOT X-PHASE
          JZ        DEVADTCA
          CMP       R0,0            ;BR IF NOT ILLEGAL DEVICE ADDR
          JNE       DEVADTCB
DEVADTC9: JMP       ERROR_48

DEVADTCB:
          CMP       R4,0FH
          JNE       DEVADTC2
DEVADTC2: ;CMP       R0,10H          ;BR IF < 10
          ;JB        DEVADTC3
          ;ADD       R0,0FAH         ;GET HEX VALUE BY ADDING HEX 0A
          MOV       AL,R0
          SHR       AL,4             ;
          MUL       TEN              ;*10
          AND       R0,0FH
          ADD       R0,AL
          DEC       R0
;-------- tsai,12-09-91 -----
          MOVZX     EDX,R0
          MOV       CH,[EDX+OFFSET TEMADRTBL] ;check terminal adr table
          CMP       CH,0FFH         ;ERROR IF NOT EXISTENT
          JE        DEVADTC9
          JMP       DEVADTCA

;DEVADTC3: DEC       R0              ;DECREMENT BY 1, SYSTEM START FROM 0 NOT 1
;         JZ        DEVADTC9        ;ERROR IF ATTEMPT OF 1ST PORT AS TC

;DEVADTC4: CMP       R0,0FH          ;u64
;         JBE       DEVADTCA        ;IF 1ST MXE, RETURN
;         CMP       R0,0FH          ;u64
;         JBE       MXE2EX          ;BR TO CHECK EXISTENCE OF 2ND MXE BOARD
;         CMP       R0,1FH          ;u64
;         JBE       MXE3EX          ;BR TO CHECK EXISTENCE OF 3RD MXE BOARD
;         JMP       MXE4EX          ;BR TO CHECK EXISTENCE OF 4RD MXE BOARD
;
;MXE2EX:   MOV       EDX,OFFSET MXD2SADR ;READ 2ND MXD STATUS, FF IF NONE
;         JMP       _M9802

;MXE3EX:   MOV       EDX,OFFSET MXD3SADR ;READ 3RD MXD STATUS, FF IF NONE
;         JMP       _M9802

;MXE4EX:   MOV       EDX,OFFSET MXD4SADR ;READ 1ST MXD STATUS, FF IF NONE
;_M9802:   MOV       CH,[EDX]        ;May be changed to CH only.
;         CMP       CH,0FFH         ;ERROR IF NOT EXISTENT
;         JE        DEVADTC9

;DEVADTC8: TEST      R0,0F0H         ;ERROR IF NOT PROPER DEVICE ADDR
;         JNZ       DEVADTC9

DEVADTCA: RET
;-------- tsai,12-09-91 -----

;-----------------------------------------------------------------------------;
;   CHKASSN: Check if any partition is assigned to specified port
;
;       Entry : F0 = MXE addr(bit C0) + Port # (bit 03)
;       Return : Error if a port is attached to a partition as a terminal
;       Modified registers : CHCL, PHPL, F3
;       Data structure used : PTERM table
;-----------------------------------------------------------------------------;
CHKATTN:  MOV       EDX,OFFSET PTERM    ;GET PTERM TABLE ADDR

CHKATTN2: MOV       CH,[EDX]            ;GET PTERM ENTRY
          INC       EDX
          TEST      CH,PTERMRLS         ;BR IF PARTITION IS ASSIGNED TO THIS PORT
          JZ        CHKATTN7
CHKATTN4: CMP       EDX,OFFSET PTERM+PARTMAX;BR IF NOT END OF TABLE, AND
          JNE       CHKATTN2                ;u64,CHECK NEXT PART
CHKATTN9:
          RET

CHKATTN7:;MOV       AL,CH           ;MASK OUT MXE ADDR + PORT#
          MOV       AL,[EDX-1+PARTMAX];u64
          AND       AL,PTERMADR
          MOV       R3,AL
          CMP       AL,R0           ;BR IF NOT SAME DEVICE ADDR
          JNE       CHKATTN4
          JMP       ERROR_48        ;ERROR IF PORT IS ATTACHED TO DIFFERENT PART.

;-----------------------------------------------------------------------------;
;  TCSET : Set a bit in extention table indicating TC port                    ;
;      Entry : F5F4 = Device addr inputted from user                          ;
;      Return : Bit 80 in extention table is set to 1                         ;
;      Modified registers : PHPL,CHCL,F5F4                                    ;
;-----------------------------------------------------------------------------;
TCSET:    CALL      RDDEVEX         ;READ DEVICE EXTENTION TABLE ENTRY
;         MOV       [EDX],CH        ;OR BIT INDICATE TC PORT
          OR        BYTE PTR [EDX],TCPORT
          RET

;-----------------------------------------------------------------------------;
;TCRESET : Reset a bit in device extention table indicating back to Termianal ;
;     Entry : F5F4 + Device addr inputted from user                           ;
;     Return : bit 80 in device extention table is reset to 0                 ;
;     Modified registers : PHPL,CHCL, F5F4                                    ;
;-----------------------------------------------------------------------------;
TCRESET:  CALL      RDDEVEX         ;READ DEVICE EXTENTION TABLE ENTRY
;         MOV       [EDX],CH        ;RESET TO TERMINAL INDICATION BIT
          AND       BYTE PTR [EDX],0FFH-TCPORT
          RET

;-----------------------------------------------------------------------------;
;   RDDEVEX : Read device status byte from device extention table             ;
;      Entry : F5F4 = User specified device addr for TC 0taa                  ;
;      Return : CH (bit 80) = TC port or not                                  ;
;                  (bit 30) = Exclusive use for particular partition          ;
;                  (bit 10) = Device open                                     ;
;                  (bit 0F) = Part# that opened the device                    ;
;      Mofidified registers :PHPL,CHCL,F3F2                                   ;
;-----------------------------------------------------------------------------;
RDDEVEX:  MOV       EDX,0           ;GET DEVICE EXTENTION TABLE ADDR
          MOV       DL,R4           ;COUNT 2 BYTES AS ONE ENTRY
          ADD       DL,DL
          ADD       EDX,OFFSET TPDEVTBL
          INC       EDX
          MOV       CH,[EDX]        ;READ STATUS BYTE FOR THAT PORT
          RET

;-----------------------------------------------------------------------------;
; $OPENTC : Open a TC port                                                    ;
;                                                                             ;
; General form :                                                              ;
;       $OPEN [line-number,]  port number  [,  port number  ]                 ;
;                             file number      file number                    ;
; Where:                                                                      ;
;       port number = /Add, where dd is a integer decimal value from 02 to 16 ;
;       file number = #n, where n is integer or numeric variable with a value ;
;                     between 02 to 15                                        ;
;                                                                             ;
; A program may request exclusive use of a TC port for current partition by   ;
; pecifying port number in $OPEN statement.  The specified port must be select;
; as TC port before this statement is executed, otherwise an illegal device   ;
; error will be generated.  Once OPEN, the port remains "hogged" by the curren;
; partition until one of the following conditions occurs:                     ;
;                                                                             ;
;  * A $CLOSE or END statement is executed(END must be within a program)      ;
;  * Program execution terminates with the last line of program text          ;
;  * A clear(with no parameters), RESET, or LOAD RUN command is executed      ;
;                                                                             ;
;  If the specified TC port has already been OPENed by another partition, a   ;
;  branch is made to the line number specified in $OPEN statement.  If no     ;
;  e-number is specified, the $OPEN statement will wait until the specified TC;
;  port becomes available for this partition.                                 ;
;                                                                             ;
; If multiple devices(including TC ports) are specified IN $OPEN statement and;
; one of the devices cannot openned, then none of the devices is opened.      ;
;                                                                             ;
;========== for $OPEN TC statement ===========================================;
$OPENTC:  CALL      DEVADTC1        ;GET USER SPECIFIED DEVICE ADDR
          MOV       AX,WORD PTR R0
          MOV       WORD PTR R4,AX

$OPENTC1: CALL      RDDEVEX         ;GET PORT STATUS BYTE
          TEST      CH,TCPORT       ;BR IF IT'S TC PORT
          JZ        ERROR_48

$OPENTC2: CALL      CHKOPN          ;CHECK IF IT'S OPENED
          MOV       AL,R2
          AND       AL,0FH
          CMP       R2,NOTOPN       ;BR IF NOT OPENED YET
          JE        $OPEN1
          CMP       R2,OPNSELF      ;BR IF OPENED BY ITSELF
          JE        $OPEN1

;========== If TC port was opened by somebody else already, Breakpoint ====
          MOV       EDX,AUX0F
          MOV       AL,DL           ;BR IF LINE# SPECIFIED
          AND       AL,0FH          ;ORTHERWISE PAGING ERROR CRAP
          CMP       AL,0FH
          JNE       $OPENTC6

          MOV       EDX,0
          MOV       DL,PART_        ;PTC TABLE ADDR
          MOV       CH,DL
          ADD       EDX,OFFSET PTC  ;GET PTC TABLE ENTRY(TC PORT BEING WAITED)
          MOV       BYTE PTR [EDX],CH
          MOV       BYTE PTR [EDX+PARTMAX],CH;u64
          MOV       AUX00,EDX       ;SAVE CURRENT PARTITION'S ENTRY ADDR

          CALL      TCTRANF         ;GET MXE ADDR AND PORT#
          MOV       WORD PTR R0,DX
          MOV       EDX,AUX00       ;RESTORE CURRENT PART'S PTC TABLE ENTRY
          MOV       AL,R0           ;WRITE TC PORT REQUESTED FLAG
          MOV       [EDX+PARTMAX],AL;u64,fill TC # into XPTC table
          AND       AL,0C7H         ;u64,mask to match PTC format
          OR        AL,TCWAIT
          MOV       [EDX],AL
          MOV       EDX,AUX0D
          MOV       TEXTPTR,EDX     ;RESTORE TEXTPTR TO DEVICE LIST
          JMP       $OPEN91

$OPENTC6: JMP       $OPENDB

$OPENTC8: JMP       $OPEN1

;-----------------------------------------------------------------------------;
;   $OPENDTC : Set a open device flag and part# in device extention table     ;
;       Entry : F5F4 = User specified device addr A0F                         ;
;-----------------------------------------------------------------------------;
$OPENDTC: CALL      RDDEVEX         ;GET PORT STATUS
          AND       CH,0F0H         ;CLEAR PART#
          OR        CH,DEVOPEN      ;SET DEVICE OPEN FLAG
          MOV       R3,CH           ;SAVE PORT STATUS
          MOV       CH,PART_        ;GET CURRENT PART#
          MOV       [EDX-1-TPDSIZE],CH ;u64
          OR        CH,R3
          MOV       [EDX],CH
          RET

;-----------------------------------------------------------------------------;
;   $CLOSTC : Close a TC port                                                 ;
;                                                                             ;
;     General form:                                                           ;
;             $CLOSE [  port-number  [,  port-number   ]...]                  ;
;                       file-number      file-number                          ;
;     Where:                                                                  ;
;             port-number = /Add, where dd is a integer decimal from 02 to 16 ;
;             file-number = #n                                                ;
;                                                                             ;
;  The specified port must be selected as TC port previously, otherwise an    ;
;  illegal device error will be generated.                                    ;
;                                                                             ;
;  If the TC port was not opened previously, no error will be generated.      ;
;                                                                             ;
; The $CLOSE statement releases the specified devices in this case TC port whi;
; were previouly hogged via the $OPEN statement.  If no device addresses are  ;
; specified, the $CLOSE statement releases all devices including TC ports     ;
; currently OPENed for the current partition.                                 ;
;%========== for $CLOSE for TC port ==========================================;
$CLOSTC:  CALL      DEVADTC1        ;GET USER SPECIFIED DEVICE ADDR
          MOV       AX,WORD PTR R0
          MOV       WORD PTR R4,AX
          CALL      RDDEVEX         ;GET PORT STATUS BYTE
          INC       EDX
          TEST      CH,TCPORT       ;BR IF THE PORT IS A TC PORT
          JZ        ERROR_48        ;ERROR IF NOT TC PORT

          TEST      CH,DEVOPEN      ;BR IF NOT OPENED
          JZ        $CLOSE4

;%============= TC port and  opened ==========================================
;         MOV       AL,CH           ;PART# THAT OPENED TC PORT
          MOV       AL,BYTE PTR [EDX-2-TPDSIZE];u32
          AND       AL,PARTBIT      ;u32
          MOV       R1,AL
          CMP       AL,BYTE PTR PART_   ;BR IF NOT OPENED BY CURRENT PART
          JNE       $CLOSE4
          DEC       EDX

$CLOSTC2: CALL      $CLSTC          ;CLOSE TC PORT
          JMP       $CLOSE4         ;BR USER SPECIFIED DEVICE ADDR

;-----------------------------------------------------------------------------;
;   $CLSTC : Close TC port rotine                                             ;
;       Entry:    F1F0 = User specified Tc port # in decimal                  ;
;                 PHPL = Device extention table entry addr                    ;
;                 CH = Port status                                            ;
;                                                                             ;
;       Note :  PTC table contains 16 bytes(1 byte per partition) indicating  ;
;               what TC port a partition has been waiting for.                ;
;                                                                             ;
;       Modifified registers : CHCL, PHPL,F2, F3                              ;
;       Data structure used : PTC, PSTAT, TPDEVTBL                            ;
;                                                                             ;
;-----------------------------------------------------------------------------;
$CLSTC:   MOV       AL,CH           ;RESET OPENED DEVICE FLAG
          AND       AL,0F0H-DEVOPEN
          MOV       [EDX],AL
          CALL      TCTRANF         ;GET PHYSICAL PORT DEVICE ADDR
          MOV       R2,DL           ;R2 = PHYSICAL PORT#

$CLSTC10: MOV       EDX,0
          MOV       DL,PART_        ;GET CURRENT PARTITION
          ADD       EDX,OFFSET PTC  ;GET PTC TABLE ADDR
          MOV       EBX,EDX
;         INC       EDX
          JMP       $CLSTC30

$CLSTC20: MOV       CH,[EDX+PARTMAX]        ;GET NEXT ENTRY
          INC       EDX
          MOV       AL,CH
          AND       AL,PTERMADR     ;u64
          MOV       K,AL
          CMP       AL,R2           ;BR IF REQUEST FOR THIS PORT
          JE        $CLSTC40

$CLSTC30: CMP       EDX,OFFSET PTC+PARTMAX ;BR IF NOT END OF TABLE,u64
          JNE       _M9805
          MOV       EDX,OFFSET PTC      ;POINT TO BEGINNING OF TABLE
_M9805:   CMP       EDX,EBX             ;BR IF MORE ENTRIES TO CHECK
          JNE       $CLSTC20
          RET

$CLSTC40: DEC       EDX
          MOV       EAX,EDX
          SUB       EAX,OFFSET PTC
          MOV       R3,AL               ;SAVE CURRENT PARTITION#
          MOV       BYTE PTR [EDX],0    ;REQYEST FOR DEVICE OFF IN PTC TABLE
          MOV       BYTE PTR [EDX+PARTMAX],0;u64
          MOV       EDX,OFFSET PSTAT    ;GET PSTAT TABLE ADDR
          ADD       EDX,EAX             ;CURRENT PARTITION'S ENTRY
          MOV       BYTE PTR [EDX],PSTATICT ;SET I/O COMPLETE (CAUSE BRK PT RET)
          JMP       BREAKPTT

;-----------------------------------------------------------------------------;
;   $CLSTCA : Close all TC ports opened by current partition                  ;
;                                                                             ;
;      Note : Search in Device extention table and PTC table to find          ;
;              if there is any TC ports that are opened by current partition  ;
;-----------------------------------------------------------------------------;
$CLSTCA:
          PUSH      WORD PTR R4     ;SVAE THESE FOR CONSISTENCY (IN $CLOSEA ONLY
                                    ;R0-R3 ARE MODIFIED
          MOV       R0,0            ;COUNTER FOR ENTRIES
          MOV       CH,PART_        ;GET CURRENT PARTITION#
          MOV       R4,CH           ;USE R4 AS CURRENT PART# IN THIS ROUTINE
          MOV       EDX,OFFSET TPDEVTBL   ;DEVICE EXTENTION TABLE

$CLSTCA2:                           ;2 BYTES FOR ENTRY
          MOV       CH,[EDX+1]        ;Only CH is concerned. GET PORT STATUS BYTE
          ADD       EDX,2
          TEST      CH,TCPORT       ;BR IF NOT TC PORT
          JZ        $CLSTCA4
          TEST      CH,DEVOPEN      ;BR IF NOT OPENED
          JZ        $CLSTCA4

;%============= TC port and  opened ==========================================
;         MOV       AL,CH           ;PART# THAT OPENED TC PORT
          MOV       AL,BYTE PTR [EDX-2-TPDSIZE];u32
          AND       AL,PARTBIT      ;u32
          MOV       R1,AL
          CMP       AL,R4           ;BR IF NOT OPENED BY CURRENT PART
          JNE       $CLSTCA4

;============= TC port has been opened by current partition ==================
          PUSH      EDX             ;SAVE NEXT TC PORT ENTRY
          DEC       EDX             ;GO BACK TO CURRENT STATUS BYTE
          CALL      $CLSTC          ;CLOSE TC PORT (WAKE UP NEXT PART)

;%============= Try next TC port =============================================
          POP       EDX             ;RESTORE NEXT TC PORT ENTRY ADDR
$CLSTCA4: INC       R0              ;INCREMENT # OF TC PORTS TESTED
          CMP       R0,40H          ;BR IF NOT END OF TABLE, TRY NEXT ENTRY
          JNE       $CLSTCA2        ;u64
$CLSTCA6:
          POP       WORD PTR R4
          RET
;-----------------------------------------------------------------------------;
;  CHKOPN : Check if the specified port is opened by somebody else as TC port ;
;      Entry : F5F4 = Device addr read from the user                          ;
;              F1F0 = Real device addr                                        ;
;      Return : F2 = 00 if not opened yet                                     ;
;                    01 if opened by somebody else                            ;
;                    02 if opned by same current partition                    ;
;      Modified registers : PHPL,CHCL,F2,F3,F4,F5                             ;
;-----------------------------------------------------------------------------;
CHKOPN:   CALL      RDDEVEX         ;GET PORT STATUS BYTE
CHKOPN1:  TEST      CH,DEVOPEN      ;BR IF IT'S OPENED ALREADY
          JNZ       CHKOPN2
          MOV       R2,NOTOPN       ;NOT OPENED YET FLAG
          RET

CHKOPN2: ;MOV       AL,CH           ;GET PARTITION # THAT OPENED THE PORT
          MOV       AL,[EDX-1-TPDSIZE];u64,GET TBDEVTBL EXTENSION
          AND       AL,PARTBIT        ;u64
          MOV       R3,AL
          MOV       CH,PART_        ;GET CURRENT PARTITION #
          CMP       CH,R3
          JE        CHKOPN3         ;BR IF OPENED BY ITSELF
          MOV       R2,OPNELSE      ;OPENED BY SOMEONE ELSE
          RET

CHKOPN3:  MOV       R2,OPNSELF      ;OPENED BY SAME PARTITION FLAG
          RET
;-----------------------------------------------------------------------------;
;   Notes : In $GIO Enabling a Device routine, if a user specifies a Tc port, ;
;                then  (1). Check if that port is a TC port.  Error if not.   ;
;                      (2). Check if somebody already opened that TC port.    ;
;                             Breakpoint if opened by someone else .          ;
;                      (3). Enable control addr of proper MXE                 ;
;                      (4). Select port                                       ;
;                      (5). Enable device                                     ;
;     Note2 : For TC $GIO, aux ACTDEV high byte = hex (0A)                    ;
;                                     low byte = MXE addr + port #            ;
;========== TC code, assuming user want TC $GIO ==============================;
TCGIO:    MOV       WORD PTR R0,DX
          CALL      DEVADTC1        ;CHANGE USER SPECIFIED DEV ADDR INTO HEX
                                    ;ENTRY:          F1F0 =  A16
                                    ;RETURN:         F1F0 =  A0F
TCGIO4:   MOV       AX,WORD PTR R0
          MOV       WORD PTR R4,AX

TCGIO6:   CALL      RDDEVEX         ;READ DEVICE STSTUS BYTE
                                    ;entry :         F5F4 = A0F
                                    ;return :        CH = port status byte
          TEST      CH,TCPORT       ;BR IF TC PORT
          JZ        ERROR_48        ;ERROR IF TC PORT

;%========== Check if that TC port is opened by somebody else already =======
TCGIO7:   CALL      CHKOPN1
          MOV       AL,R2
          AND       AL,0FH
          CMP       AL,NOTOPN       ;BR IF NOT OPENED YET
          JE        TCGIO9
          CMP       AL,OPNSELF      ;BR IF OPENED BY SELF
          JE        TCGIO9

;%========== Breakpoint if opened by another partition =====================
          MOV       EDX,0
          MOV       DL,PART_            ;GET PTC ADDR
          MOV       CH,DL
          ADD       EDX,OFFSET PTC      ;GET CURRENT PARTITION'S PTC ENTRY
          MOV       BYTE PTR [EDX],CH   ;CLEAR LEFT OVER
          MOV       BYTE PTR [EDX+PARTMAX],CH   ;CLEAR LEFT OVER,u64
          MOV       AUX00,EDX
          CALL      TCTRANF             ;GET MXE ADDR AND PORT #
                                        ;    entry F1F0 = A0F
                                        ;    return PHPL = MXE addr port #
          MOV       WORD PTR R0,DX
          MOV       EDX,AUX00       ;RESTORE PTC ENTRY ADDR FOR CURRENT PARTITION
          MOV       AL,R0           ;SET A FLAG FOR TC PORT WAITING FLAG
          MOV       [EDX+PARTMAX],AL    ;u64,fill TC# into XPTC
          AND       AL,0C7H             ;u64,mask to match PTC FORMAT
          OR        AL,TCWAIT
          MOV       [EDX],AL
          CALL      BREAKPTW        ;BREAKPOINT IF OPENED BY SOMEONE ELSE
          JMP       TCGIO6          ;TRY AGAIN

;%========== Enable the specified TC port ====================================
TCGIO9:   CALL      TCTRANF
          MOV       ACTDEV,EDX      ;SAVE ACTIVE DEVICE ADDR
          JMP       ENBLTC          ;ENABLE TC DEVICE

;-----------------------------------------------------------------------------;
; TCTRAN : Translate user psecified device addr into MXE addr + port #        ;
;        Entry : PHPL = User specified device addr                            ;
;        Return : PL(bit C0) = MXE board addr                                 ;
;                 PL(bit 0F) = port #                                         ;
;        Modified registers : CHCL,PHPL                                       ;
; TCTRANF : same as TCTRAN except it gets user specified device addr from F1F0;
;-----------------------------------------------------------------------------;
TCTRANF:  MOV       DX,WORD PTR R0  ;GET USER SPECIFIED DEVICE ADDR
TCTRAN:  ;TEST      DL,0F0H
         ;JNZ       TCTRANE
          CMP       DL,64
          JAE       TCTRANE
          PUSH      EBX
;         DEC       DL
          MOVZX     EBX,DL
          MOV       DL,[EBX+OFFSET TEMADRTBL]
          POP       EBX
          RET

;         MOV       AL,DL
;         AND       DL,0FH
;         AND       AL,30H
;         SHL       AL,02H
;         OR        DL,AL
          RET

;          CMP       DL,0FH          ;u64
;          JA        MXE2
;          AND       DL,0Fh          ;(1ST) DL = MXE BOARD # + PORT #
;          RET                       ;u64
;
;MXE2:     CMP       DL,1FH          ;2ND OR 3RD OR 4TH MXE BOARD,u64
;          JA        MXE3
;          OR        DL,40H          ;DL = MXE BOARD #
;          JMP       MXE6
;
;MXE3:     CMP       DL,2FH          ;3RD OR 4TH MXE BOARD,u64
;          JA        MXE4
;          OR        DL,80H          ;DL = MXE BOARD #
;          JMP       MXE6
;
;MXE4:     OR        DL,0C0H         ;DL = MXE BOARD #
;
;MXE6:   ; AND       DL,0F3H         ;DL = MXE BOARD # + PORT #
;          AND       DL,PTERMADR     ;u64
;          RET                       ;????

TCTRANE:  JMP       ERROR_48        ;GOTO ILLEGAL DEVICE ERROR ROUTINE

;-----------------------------------------------------------------------------;
;   ENBLTC : Enable specified TC device and select TC port                    ;
;            TC operation is assumed at this point.                           ;
;        Entry : ACTDEV = high byte(0A) + low byte(MXE addr + port#)          ;
;        Return : Device enabled                                              ;
;                 Port selected                                               ;
;                                                                             ;
;     Notes: This routine is similar to ENBLCNT3 06.08.50                     ;
;                                                                             ;
;%========== Enable control addr of MXE board ================================;
ENBLTC:   MOV       EDX,ACTDEV
          AND       DL,PTERMXF      ;GET MXE BOARD ADDR,u64
          OR        DL,@MXDCADR     ;MXE COMMAND ADDR
          MOV       K,DL            ;K = DEVICE ADDR
          CALL      ENBLDEVB        ;ENABLE DEVICE 06.09.133

;%========== Select port ======================================================
          MOV       AL,0FFH
          CALL      CBSNT           ;SELECT PORT COMMAND
          MOV       EDX,ACTDEV
          MOV       AL,DL
          AND       AL,PTERMNO      ;AL = PORT #,u64
          CALL      OBSNT           ;SEND PORT # TOBE SELECTED
          MOV       AL,NULL         ;SEND NULL AS COMPLETION OF TERMINAL SELECTION
          CALL      OBSNT

;%========== Enable $GIO addr (04) ==========================================
;  The following code is for enabling device addr 04
;  This code is similar to ENBLDVG2 06.09.80
;
          MOV       EDX,ACTDEV      ;DL = MXE BOARD ADDR + PORT #
          AND       DL,PTERMXF      ;GET MXE BOARD ADDR,u64
          OR        DL,04H
          MOV       K,DL
          JMP       ENBLDEVB        ;ENABLE ADDR 04

;-----------------------------------------------------------------------------;
;   MXEPSW : Load system password to MXE                                      ;
;-----------------------------------------------------------------------------;
MXEPSW:   MOV       K,@MXD1CAD
          CALL      LDMXEPW         ;LOAD PASSWORD FOR 1ST MXE BOARD
          CMP       MXD2SADR,0FFH
          JE        MXEPSW9         ;BR IF NO 2ND MXE

          MOV       K,@MXD2CAD
          CALL      LDMXEPW         ;LOAD PASSWORD FOR 2ND BOARD
          CMP       MXD3SADR,0FFH
          JE        MXEPSW9         ;BR IF NO 3RD MXE

          MOV       K,@MXD3CAD
          CALL      LDMXEPW         ;LOAD PASSWORD FOR 3RD BOARD
          CMP       MXD4SADR,0FFH
          JE        MXEPSW9         ;BR IF NO 4TH MXE

          MOV       K,@MXD4CAD
          JMP       LDMXEPW         ;LOAD PASSWORD FOR 4TH MXE BOARD

MXEPSW9:  RET

;-----------------------------------------------------------------------------;
;   LDMXEPW : Download System password into a MXE board                       ;
;                                                                             ;
;             The password will be ignored if it's MXD board                  ;
;                                                                             ;
;      Entry : K = MXE control addr(06, 46, 86, C6)                           ;
;      Return : System password will be loaded into MXE                       ;
;      Modified registers :CHCL, PHPL, F0, F1                                 ;
;      Data structure : #INITPSW = System password                            ;
;-----------------------------------------------------------------------------;
;-------- TSAI --------
LDMXEPW:
          MOVZX     AX,K
          SHR       AL,06
          BT        MXF,AX
          JNC       LDMXEPW1           ;BR,if MXD
          XOR       EBX,EBX
          MOV       BL,AL
          SHL       EBX,6              ;point to 1'st port of this MXF
          MOV       EBX,[EBX+OFFSET MXFTBL]
LDMXEPW3:
          CMP       GS:[EBX].cmd_sts,0FH
          JE        LDMXEPW3             ;wait till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amTCPSW
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,6
          MOV       EAX,DWORD PTR [_INITPSW]
          MOV       DWORD PTR GS:[EBX+1].cmd_parm,EAX
          MOV       AX,WORD PTR [_INITPSW+4]
          MOV       WORD PTR GS:[EBX+5].cmd_parm,AX
          MOV       GS:[EBX].cmd_sts,0FH      ;start command
          RET
;--------- TSAII --------
LDMXEPW1: CALL      ENBLDEVB        ;ENABLE CONTROL ADDR OF MXE
          MOV       AL,?amTCPSW     ;LOAD PASSWORD COMMAND
          CALL      CBSNT           ;SEND A COMMAND
          MOV       R0,8            ;8 CHAR FOR PASSWORD
          MOV       R1,0            ;counter
          MOV       EDX,OFFSET _INITPSW  ;SYSTEM PASSWORD ADDR

LDMXEPW2: MOV       AL,[EDX]        ;READ A CHAR
          INC       EDX
          CALL      OBSNT           ;SEND CHAR READ TO MXE
          INC       R1              ;INCREASE COUNTER BY 1
          CMP       R1,8            ;BR IF NOT DONE ALL
          JNZ       LDMXEPW2
          MOV       AL,NULL         ;SEND NULL AS COMPLETION OF PASSWORD LOADING
          JMP       OBSNT

;-----------------------------------------------------------------------------;
; MXESTA : Check if port is a TC port or Terminal port                        ;
; Entry : F1 = MXE + port(00, 01,02,03,40,41,42,43,80,81,82,83,C0,C1,C2,C3)   ;
;      Return : CH = port status byte                                         ;
;      Modified Registers : PHPL, CHCL                                        ;
;-----------------------------------------------------------------------------;
MXESTA:
          PUSH      WORD PTR R0     ;SAVE R1R0
          AND       R1,PTERMADR     ;GET MXE PORT ADDR,u64
          MOV       AL,R1
          AND       AL,0F0H         ;BR IF 3RD OR 4TH MXE BOARD
          JNZ       MXESTA2

          MOV       AL,R1           ;FOR 1ST MXE BOARD
          JMP       _M9806

MXESTA2:  CMP       AL,040H
          JNE       MXESTA3
          MOV       AL,R1           ;FOR 2ND MXE BOARD
          AND       AL,0FH
          MOV       R1,AL
          ADD       AL,16           ;u64
          JMP       _M9806

MXESTA3:  CMP       AL,080H
          JNE       MXESTA4         ;BR IF 4TH MXE
          MOV       AL,R1           ;FOR 3RD MXE BOARD
          AND       AL,0FH
          MOV       R1,AL
          ADD       AL,32           ;u64
          JMP       _M9806

MXESTA4:  MOV       AL,R1           ;FOR 4TH MXE
          AND       AL,0FH
          MOV       R1,AL
          ADD       AL,48           ;u64
_M9806:   MOV       R0,AL

MXESTA5:  MOV       R1,0            ;R1R0 CONTAINS OFFSET TO TPDEVTBL
          MOV       EDX,0
          MOV       DX,WORD PTR R0  ;2 BYTE PER ENTRY
          ADD       EDX,EDX
          INC       EDX
          ADD       EDX,OFFSET TPDEVTBL  ;TERMINAL PRINTER DEVICE EXTENTION TABLE
          MOV       CH,[EDX]        ;READ STATUS BYTE
          POP       WORD PTR R0     ;RESTORE
          RET

;-----------------------------------------------------------------------------;
;   MXESTA6 : Wake up the partition if TC buffer empty flag is on             ;
;      Entry : F1 = MXE + port# (i.e. 80, C2, 42)                             ;
;      Modified reg's: CHCL, PHPL                                             ;
;-----------------------------------------------------------------------------;
MXESTA6:
          PUSH      WORD PTR R0
          AND       R1,PTERMADR     ;GET MXE PORT ADDR,u64
          MOV       EDX,OFFSET PTC

MXESTA61: MOV       CH,[EDX]
          MOV       CL,[EDX+PARTMAX];u64
          INC       EDX
          TEST      CH,TCDEVW       ;BR IF NOT TC PORT
          JZ        MXESTA7
;         MOV       AL,CH
          MOV       AL,CL          ;u64
          AND       AL,PTERMADR    ;u64
          MOV       R0,AL
          CMP       AL,R1           ;BR IF NOT SAME PORT
          JNE       MXESTA7

          DEC       EDX
          MOV       BYTE PTR [EDX],0    ;ERASE PRINT BUFFERWAIT FLAG
          MOV       BYTE PTR [EDX+PARTMAX],0 ;u64
          MOV       EAX,EDX
          SUB       EAX,OFFSET PTC      ;RETAIN PARTITION # OFFSET
          MOV       EDX,OFFSET PSTAT    ;GET PSTAT TABLE
          ADD       EDX,EAX             ;GOTO CURRENT PARTITION'S ENTRY
          OR        BYTE PTR [EDX],PSTATICT ;IO COMPLETION

          MOV       EDX,OFFSET PTC
          ADD       EDX,EAX
          INC       EDX

MXESTA7:  CMP       EDX,OFFSET PTC+PARTMAX      ;u64
          JNE       MXESTA61
          POP       WORD PTR R0
          RET

;-----------------------------------------------------------------------------;
;   WAITRDB6 : If partition wait TC buffer empty flag, breakpoint             ;
;     Modified reg's: PHPL                                                    ;
;-----------------------------------------------------------------------------;
WAITRDB6:
          MOV       EBX,0
          MOV       BL,PART_        ;GET PART#
          ADD       EBX,OFFSET PTC  ;GET PTC TABLE ADDR
                                    ;GET TO RIGHT PARTITION'S ENTRY
          MOV       EAX,ACTDEV
          MOV       [EBX+PARTMAX],AL;u64,fill TC# into XPTC table
          AND       AL,0C7H         ;u64,mask to match PTC format
          OR        AL,TCDEVW       ;K will eventually be destroyed.
          MOV       [EBX],AL        ;fill TC status into PTC table
          CALL      BREAKPTB
          JMP       WAITRDYB

;-----------------------------------------------------------------------------;
;   PERRMXE : Send "Parity error signal" to MXE board                         ;
;-----------------------------------------------------------------------------;
PERRMXE:  MOV       K,@MXD1CAD      ;1ST MXE CONTROL ADDR
          CALL      PRTYER          ;PARITY ERROR & S.F. 15 IS PRESSED

          CMP       MXD2SADR,0FFH   ;READ 2ND MXD ADDR
          JE        PERRMXER        ;BR IF NOT EXIST
          MOV       K,@MXD2CAD      ;2ND MXE CONTROL ADDR
          CALL      PRTYER          ;PARITY ERROR & S.F. 15 IS PRESSED

          CMP       MXD3SADR,0FFH   ;READ 3RD MXD ADDR
          JE        PERRMXER        ;BR IF NOT EXIST
          MOV       K,@MXD3CAD      ;3RD MXE CONTROL ADDR
          CALL      PRTYER          ;PARITY ERROR & S.F. 15 IS PRESSED

          CMP       MXD4SADR,0FFH   ;READ 4TH MXD ADDR
          JE        PERRMXER        ;BR IF NOT EXIST
          MOV       K,@MXD4CAD
          JMP       PRTYER

PERRMXER: RET

;-----------------------------------------------------------------------------;
; PRTYER : Send MXE that parity error occured and special fucntion key 15 is  ;
;          pressed.                                                           ;
;        Entry : K = MXE addr (06, 46, 86, c6)                                ;
;        Return : Command is send to all MXE's                                ;
;-----------------------------------------------------------------------------;
PRTYER:   CALL      ENBLDEVB        ;ENABLE DEVICE
          MOV       AL,?amPRTYER    ;SEND SIGNAL
          JMP       CBSNT

;-----------------------------------------------------------------------------;
; SLTADRT : Select addr without checking TC device addr. I.e. If device       ;
;           addr /add, is encountered, it will result in illegal device error ;
;-----------------------------------------------------------------------------;

SLTADRT:  TEST      SL,2            ;BR IF NOT X-PHASE
          JZ        SLTADRTX
          MOV       AUX0D,EDX       ;SAVE PTR TO DEVICE TABLE
SLTADRTX: CMP       BYTE PTR [TEXTPTR],'<'    ;LOOK FOR '<'
          JNE       SLTADRT2        ;BR IF NOT FOUND
          INC       TEXTPTR
          JMP       SLCTADR1

; /taa device address specification
;

SLTADRT2: CMP       BYTE PTR [TEXTPTR],'/'   ;LOOK FOR '/' (OPTIONAL)
          JNE       SLTADRTY
          INC       TEXTPTR
SLTADRTY: CALL      DEVADDR         ;GET DEVICE ADDR
          TEST      SL,2            ;RETURN IF NOT X-PHASE
          JZ        SLTADRT4
          JMP       SLCTADR5        ;CHECK FOR ILLEGAL ADDR
SLTADRT4: RET

CODE      ENDS

          END
