;===========================================================================
;
;
;
;
;
;===========================================================================
;           This module was originally MATH
;===========================================================================
	    .XLIST
	    INCLUDE PREAMBLE
	    .LIST
; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; ::                                                                          ::
; ::                    m a t h p a k 1                                       ::
; ::                                                                          ::
; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; .......... procedures callable from outside mathpack programs ..............................

PUBLIC    MATHADD
PUBLIC    MATHADD1
PUBLIC    MATHADD2
PUBLIC    MATHSUB
PUBLIC    MATHSUB1
PUBLIC    MATHSUB2
PUBLIC    MATHMUL
PUBLIC    MATHMUL1
PUBLIC    MATHMUL2
PUBLIC    MATHDIV
PUBLIC    MATHDIV1
PUBLIC    MATHDIV2
PUBLIC    MATHCMP
PUBLIC    MATHCMP1
PUBLIC    MATHINT
PUBLIC    MATHFIX
PUBLIC    MATHABS
PUBLIC    MATHSGN
PUBLIC    MATHMOD
PUBLIC    MATHRD
PUBLIC    MATHRND0
PUBLIC    MATHRNDX
PUBLIC    MATHNRND
PUBLIC    MATHSQR
PUBLIC    MATHLGT
PUBLIC    MATHSIN
PUBLIC    MATHCOS
PUBLIC    MATHATAN
PUBLIC    MATHASIN
PUBLIC    MATHACOS
PUBLIC    MATHEXP
PUBLIC    MATHLOG
PUBLIC    MATHX2Y
PUBLIC    MATHTAN
PUBLIC    MATHMAX
PUBLIC    MATHMIN
PUBLIC    maxvalue
PUBLIC    maxnvalue
PUBLIC    chk_max
PUBLIC    chk_maxn
PUBLIC    temp_ptr
PUBLIC    MANREG
PUBLIC    MAlg
PUBLIC    PRE_FLG

EXTRN     CPBASE  :DWORD
EXTRN     PART_   :BYTE
EXTRN     PMODE   :NEAR
EXTRN     SAVESEED:BYTE
EXTRN     TIMED   :BYTE

PUSHREGS        MACRO
	.xlist
		PUSH    EBX
		PUSH    ECX
		PUSH    EDX
		PUSH    ESI
		PUSH    EDI
		PUSH    EBP
	.list
ENDM

POPREGS         MACRO
	.xlist
		POP     EBP
		POP     EDI
		POP     ESI
		POP     EDX
		POP     ECX
		POP     EBX
	.list
ENDM

;****************************************************************************
;
;   .\MATH\M1DATA.ASM
;
;****************************************************************************
PUBLIC  _MPI
align 4
_MPI            DW      0FFF5H, 0F64FH, 02559H, 00049H  ;PI

ARG_2           DW      00000H, 00002H, 00000H, 00000H  ;2
ARG_0           DW      4 DUP(0)                        ;0
ARG_1           DW      00000H, 00001H, 00000H, 00000H  ;1
ARG_5           DW      0FFFFH, 00005H, 00000H, 00000H  ;5
ARG_10          DW      0FFF5H, 01000H, 0D4A5H, 000E8H  ;10
MAXVALUE        DW      00057H, 09FFFH, 04E72H, 00918H  ;9.999999999999E99
MAXNVALUE       DW      00057H, 06002H, 0B18DH, 0F6E7H  ;-9.999999999999E99
CON_8F          DW      00000H, 0FFFFH, 0FFFFH, 00000H  ;4294967295
CON_SQR2        DW      0FFF4H, 07005H, 045B2H, 00149H  ;SQR(2) 1.414213562373

CON_P25         DW      0FFF3H, 0A800H, 0139CH, 00246H  ;0.25
CON_P5          DW      0FFF2H, 02000H, 0883DH, 02D79H  ;0.5
CON_P75         DW      0FFF3H, 0F800H, 03AD5H, 006D2H  ;0.75
CON_M1          DW      0FFF3H, 06000H, 0B18DH, 0F6E7H  ;-1
;CON_P5          DW      0FFF3H, 05000H, 02739H, 0048CH  ;0.5
;CON_M1          DW      0FFF4H, 0F000H, 02B5AH, 0FF17H  ;-1
CON_1           DW      0FFF4H, 01000H, 0D4A5H, 000E8H  ;1
CON_2           DW      0FFF4H, 02000H, 0A94AH, 001D1H  ;2
CON_10          DW      00000H, 0000AH, 00000H, 00000H  ;10
CON_100         DW      00000H, 00064H, 00000H, 00000H  ;100
CON_1000        DW      00000H, 003E8H, 00000H, 00000H  ;1000
CON_10000       DW      00000H, 02710H, 00000H, 00000H  ;10000
		DW      00000H, 086A0H, 00001H, 00000H  ;100000
		DW      00000H, 04240H, 0000FH, 00000H  ;1000000
		DW      00000H, 09680H, 00098H, 00000H  ;10000000
		DW      00000H, 0E100H, 005F5H, 00000H  ;100000000
		DW      00000H, 0CA00H, 03B9AH, 00000H  ;1000000000
		DW      00000H, 0E400H, 0540BH, 00002H  ;10000000000
		DW      00000H, 0E800H, 04876H, 00017H  ;100000000000
		DW      00000H, 01000H, 0D4A5H, 000E8H  ;1000000000000
		DW      00000H, 0A000H, 04E72H, 00918H  ;10000000000000
		DW      00000H, 04000H, 0107AH, 05AF3H  ;100000000000000 (10^14)
CON_10N:  ;THE ENDING MARK OF 10 ** N CONSTANTS .


PI_2            DW      0FFF4H, 0CF8BH, 0BAC1H, 0016DH  ;PI/2

	EVEN
CON_1778        DW      0FFF4H, 06977H, 009B6H, 0019EH  ;1.778279410039 (10^.25)
CON_5623        DW      0FFF4H, 09F40H, 04D8CH, 0051DH  ;5.6234132519035(10^.75)
CON_3162        DW      0FFF3H, 0C608H, 0466FH, 002E0H  ;.31622776601684(10^(-.5))


OPR_L   LABEL WORD
EXP_L   DW      0
M1_L    DW      0
M2_L    DW      0
M3_L    DW      0

OPR_S   LABEL WORD
EXP_S   DW      0
M1_S    DW      0
M2_S    DW      0
M3_S    DW      0

M3_SAV  DW      0
	DW      0
PTR_A   DD      0
PTR_B   DD      0

MATHAREA DW     12 DUP(0)
align 4
;****************************************************************************
;
;   .\MATH\M2DATA.ASM
;
;****************************************************************************
align 4
ODD_COE         DW      00000H, 0BC54H, 0C05DH, 01CC2H  ;.31622776601684
EVEN_COE        DW      00000H, 0A000H, 04E72H, 00918H  ; 10
EVEN_MCOE       DW      00000H, 00001H, 00000H, 00000H  ; 1

EXP_T           DB      000H
		DB      0F2H, 0FFH, 0F1H, 0FEH          ;1
		DB      0F0H, 0FDH, 0EFH, 0FCH          ;5
		DB      0EEH, 0FBH, 0EDH, 0FAH          ;9
		DB      0ECH, 0F9H, 0EBH, 0F8H          ;13
		DB      0EAH, 0F7H, 0E9H, 0F6H          ;17
		DB      0E8H, 0F5H, 0E7H, 0F4H          ;21
		DB      0E6H, 0F3H, 0E5H, 0F2H          ;25
		DB      0E4H, 0F1H, 0E3H, 0F0H          ;29
		DB      0E2H, 0EFH, 0E1H, 0EEH          ;33
		DB      0E0H, 0EDH, 0DFH, 0ECH          ;37
		DB      0DEH, 0EBH, 0DDH, 0EAH          ;41
		DB      0DCH, 0E9H, 0DBH, 0E8H          ;45
		DB      0DAH, 0E7H, 0D9H, 0E6H          ;49
		DB      0D8H, 0E5H, 0D7H, 0E4H          ;53
		DB      0D6H, 0E3H, 0D5H, 0E2H          ;57
		DB      0D4H, 0E1H, 0D3H, 0E0H          ;61
		DB      0D2H, 0DFH, 0D1H, 0DEH          ;65
		DB      0D0H, 0DDH, 0CFH, 0DCH          ;69
		DB      0CEH, 0DBH, 0CDH, 0DAH          ;73
		DB      0CCH, 0D9H, 0CBH, 0D8H          ;77
		DB      0CAH, 0D7H, 0C9H, 0D6H          ;81
		DB      0C8H, 0D5H, 0C7H, 0D4H          ;85
		DB      0C6H, 0D3H, 0C5H, 0D2H          ;89
		DB      0C4H, 0D1H, 0C3H, 0D0H          ;93
		DB      0C2H, 0CFH, 0C1H                ;97

align 4

OPR_B           LABEL WORD
M1_B            DW      0
M2_B            DW      0
M3_B            DW      0

OPR_A           LABEL WORD
M1_RES          LABEL WORD
M1_A            DW      0
M2_RES          LABEL WORD
M2_A            DW      0
M3_RES          LABEL WORD
M3_A            DW      0
M4_RES          LABEL WORD
M1_T            DW      0
M5_RES          LABEL WORD
M2_T            DW      0
M6_RES          LABEL WORD
M3_T            DW      0

EXP_B           DW      0
EXP_A           DW      0
align 4
;****************************************************************************
;
;   .\MATH\M3DATA.ASM
;
;****************************************************************************
align 4
TRI_CONV:
	DW      0FFF4H, 03E2CH, 0EB07H, 005B6H  ;2 * #PI
	DW      00000H, 00168H, 00000H, 00000H  ;360
	DW      00000H, 00190H, 00000H, 00000H  ;400
atri_conv:
	dw      0fff5h, 0604ch, 00575h, 00536h  ;360/2*#pi
	dw      0fff5h, 0321bh, 03ef4h, 005cah  ;400/2*#pi
COE_ATAN:
	DW      0FFF3H, 04FFDH, 02739H, 0048CH  ; .499999999999713
	DW      0FFF2H, 04275H, 0DF50H, 0FC35H  ;-.416666666535507 E-1
	DW      0FFF1H, 0DB4CH, 03104H, 005AFH  ; .624999981754762 E-2
	DW      0FFF1H, 0C141H, 02507H, 0FEFCH  ;-.111607023174289 E-2
	DW      0FFF0H, 0042DH, 043ACH, 001F9H  ; .217009383121276 E-3
	DW      0FFEFH, 02DFFH, 0BC6AH, 0FBF6H  ;-.443783510886539 E-4
	DW      0FFEEH, 05959H, 01DE0H, 00886H  ; .937211988207343 E-5
	DW      0FFEEH, 02C3AH, 03C2DH, 0FE2BH  ;-.201333006842204 E-5
	DW      0FFEDH, 04C3CH, 0B857H, 003E9H  ; .430235499218835 E-6
	DW      0FFECH, 08B2EH, 026E2H, 0F7FEH  ;-.880403057582556 E-7
	DW      0FFECH, 05FA4H, 0396EH, 0017CH  ; .163305110723608 E-7
	DW      0FFEBH, 0978DH, 062ABH, 0FDA9H  ;-.257102999768294 E-8
	DW      0FFEAH, 04283H, 0C28DH, 002E7H  ; .319442473843478 E-9
	DW      0FFE9H, 06411H, 0A7CFH, 0FD63H  ;-.287051773438321 E-10
	DW      0FFE8H, 0BFA9H, 0A747H, 0017CH  ; .163489406967311 E-11
	DW      0FFE6H, 023DAH, 092C1H, 0FC01H  ;-.439128941264570 E-13
;!COE_EXP:
;!        DW      00018H
COE_EXP DW      0FFDCH, 09F18H, 0430BH, 00177H  ; 1.611737571 E-24
	DW      0FFDDH, 0B106H, 0A0E8H, 00384H  ; 3.868170170 E-23
	DW      0FFDEH, 030C3H, 07217H, 00817H  ; 8.896791392 E-22
	DW      0FFE0H, 0E6E3H, 0B7D1H, 001C7H  ; 1.957294106 E-20
	DW      0FFE1H, 09810H, 00205H, 003BDH  ; 4.110317623 E-19
	DW      0FFE2H, 03020H, 0040BH, 0077AH  ; 8.220635246 E-18
	DW      0FFE4H, 0721BH, 0A9BAH, 0016BH  ; 1.561920696 E-16
	DW      0FFE5H, 033CAH, 097E9H, 0028EH  ; 2.811457254 E-15
	DW      0FFE6H, 071A3H, 0CF0CH, 00458H  ; 4.779477332 E-14
	DW      0FFE7H, 04F6CH, 07E7AH, 006F4H  ; 7.647163731 E-13
	DW      0FFE9H, 0BF1DH, 012F8H, 0010BH  ; 1.147074559 E-11
	DW      0FFEAH, 03EC2H, 0E75CH, 00175H  ; 1.605904383 E-10
	DW      0FFEBH, 01E63H, 0132BH, 001E6H  ; 2.087675698 E-9
	DW      0FFECH, 0BE10H, 04A33H, 00247H  ; 2.505210838 E-8
	DW      0FFEDH, 01DDFH, 09E6CH, 00281H  ; 2.755731922 E-7
	DW      0FFEEH, 01DDFH, 09E6CH, 00281H  ; 2.755731922 E-6
	DW      0FFEFH, 0E7AFH, 074FAH, 00241H  ; 2.480158730 E-5
	DW      0FFF0H, 01FBFH, 0F72FH, 001CDH  ; 1.984126984 E-4
	DW      0FFF1H, 09639H, 0603AH, 00143H  ; 1.388888888 E-3
	DW      0FFF1H, 08555H, 0415FH, 00794H  ; 8.333333333 E-3
	DW      0FFF2H, 0C2ABH, 020AFH, 003CAH  ; 4.166666666 E-2
	DW      0FFF3H, 01AABH, 00D13H, 00184H  ; .16666666666667
	DW      0FFF3H, 05000H, 02739H, 0048CH  ; .5
	DW      0FFF3H, 0A000H, 04E72H, 00918H  ; 1
	DW      0FFF3H, 0A000H, 04E72H, 00918H  ; 1
LGT_E:
	DW      0FFF3H, 0E758H, 02BAEH, 003F3H  ; LGT (e)
LN_10:
	DW      0FFF4H, 03B82H, 01CC4H, 00218H  ; LN (10)
chk_max:
	DW      00056H, 03FFFH, 0107AH, 05AF3H
	DW      00057H, 09FFFH, 04E72H, 00918H
	DW      00058H, 01000H, 0D4A5H, 000E8H
	DW      00059H, 0E800H, 04876H, 00017H
	DW      0005AH, 0E400H, 0540BH, 00002H
	DW      0005BH, 0CA00H, 03B9AH, 00000H
	DW      0005CH, 0E100H, 005F5H, 00000H
	DW      0005DH, 09680H, 00098H, 00000H
	DW      0005EH, 04240H, 0000FH, 00000H
	DW      0005FH, 086A0H, 00001H, 00000H
	DW      00060H, 02710H, 00000H, 00000H
	DW      00061H, 003E8H, 00000H, 00000H
	DW      00062H, 00064H, 00000H, 00000H
	DW      00063H, 0000AH, 00000H, 00000H
chk_maxn:
	DW      00056H, 0C001H, 0EF83H, 0A50CH
	DW      00057H, 06001H, 0B18DH, 0F6E7H
	DW      00058H, 0E0FFH, 02B5AH, 0FF17H  ;
	DW      00059H, 017FFH, 0B789H, 0FFE8H  ;
	DW      0005AH, 01BFFH, 0ABF4H, 0FFFDH  ;
	DW      0005BH, 035FFH, 0C465H, 0FFFFH  ;
	DW      0005CH, 01EFFH, 0FA0AH, 0FFFFH  ;
	DW      0005DH, 0697FH, 0FF67H, 0FFFFH  ;
	DW      0005EH, 0BDBFH, 0FFF0H, 0FFFFH  ;
	DW      0005FH, 0795FH, 0FFFEH, 0FFFFH  ;
	DW      00060H, 0D8EFH, 0FFFFH, 0FFFFH  ;
	DW      00061H, 0FC17H, 0FFFFH, 0FFFFH  ;
	DW      00062H, 0FF9BH, 0FFFFH, 0FFFFH  ;
	DW      00063H, 0FFF5H, 0FFFFH, 0FFFFH  ;
align 4
;****************************************************************************
;
;   .\MATH\M4DATA.ASM
;
;****************************************************************************
even
MANREG_F        DB      0               ;FLAG FOR SKIP MANTISSA REGRESSION
ESC_FLAG        DB      0               ;FLAG FOR PRIMARY (+,-,*,/, ETC) ROUTINES
ESC_FLAG1       DB      0               ;FLAG FOR HIGHER ROUTINE ENTRY
ESC_FLAG2       DB      0               ;FLAG FOR ARCTAN FUNCTIONS TRI_CONV
ESC_FLAG3       DB      0               ;FLAG FOR ARCSIN FUNCTIONS TRI_CONV
ESC_FLAG4       DB      0               ;FLAG FOR ARCCOS FUNCTIONS TRI_CONV

even
PTR_FLP         DB      0
SQR_FLG         DB      0               ;FLAG TO INDICATES X' = X/2 FOR SQR ROUTINE
PRE_FLG         DB      0               ;FLAG FOR MANTAIN PRECISION AS MUCH AS POSSIBLE

EVEN
M1_X            DW      0
M2_X            DW      0
M3_X            DW      0

M1_QUO  LABEL   WORD
M4_X            DW      0
M2_QUO          DW      0
M3_QUO          DW      0

M1_Y            DW      0
M2_Y            DW      0
M3_Y            DW      0

E_CUNT          DW      0

RS_PTR          DD      0
CO_PTR          DD      0

TEMP_Y          DW      4 DUP(0)
TEMP_X          DW      4 DUP(0)
TEMP_Y1         DW      4 DUP(0)
TEMP_X1         DW      4 DUP(0)
TEMP_Y2         DW      4 DUP(0)
TEMP_X2         DW      4 DUP(0)
TEMP_Z          DW      4 DUP(0)                ;USED BY ARCSIN, ^
TEMP_Z1         DW      4 DUP(0)                ;USED BY ARCCOS, ^
TEMP_Z2         DW      4 DUP(0)                ;USED BY LGT, ^
TEMP_N          DW      4 DUP(0)                ;USED BY ^
TEMP_ZZ1        DW      4 DUP(0)                ;USED BY ^ (error 65)
TEMP_PTR        DD      0
TEMP_PTR1       DD      0
TEMP_PTR2       DD      0
TEMP_PTR3       DD      0
eexm            dd      0
edxm            dd      0
ebxm            dd      0
even
;! COE_LGT DW      0000CH
COE_LGT DW      0FFF1H, 00842H, 054F4H, 03AADH  ;.064516129032258  2/31
	DW      0FFF1H, 02C23H, 04928H, 03EB9H  ;.068965517241339  2/29
	DW      0FFF1H, 04BDAH, 0B6DFH, 0435EH  ;.07407407407407   2/27
	DW      0FFF2H, 08000H, 0A528H, 00746H  ;.08000000000000   2/25
	DW      0FFF2H, 04859H, 09D42H, 007E8H  ;.08695652173913
	DW      0FFF2H, 09862H, 06F48H, 008A9H  ;.095238095238095
	DW      0FFF3H, 03943H, 015BBH, 000F5H  ;.10526315789474
	DW      0FFF3H, 08B48H, 0EB1CH, 00111H  ;.11764705882353
	DW      0FFF3H, 01555H, 070DCH, 00136H  ;.13333333333333
	DW      0FFF3H, 0189DH, 03374H, 00166H  ;.15384615384615
	DW      0FFF3H, 0D746H, 05414H, 001A7H  ;.18181818181818
	DW      0FFF3H, 0238EH, 066C4H, 00205H  ;.22222222222222
	DW      0FFF3H, 02DB7H, 03AFCH, 00299H  ;.28571428571429
	DW      0FFF3H, 04000H, 05294H, 003A3H  ;.40000000000000
	DW      0FFF3H, 06AABH, 0344CH, 00610H  ;.66666666666667
	DW      0FFF4H, 02000H, 0A94AH, 001D1H  ;2.0000000000000

;LGT_CO  DW      0ffffH, 0000fH, 00000H, 00000H  ;1.5000000000000
;        DW      0FFFfH, 00005H, 00000H, 00000H  ;0.5000000000000
;        DW      0FFF3H, 0B000H, 02317H, 00A01H  ;1.1000000000000
;        DW      0FFF3H, 0B800H, 005FBH, 00901H  ;0.9900000000000
;        DW      0FFF3H, 08400H, 0A27EH, 0091AH  ;1.0010000000000
;        DW      0FFF3H, 0D600H, 012D7H, 00918H  ;0.9999000000000
;        DW      0FFF3H, 08100H, 05468H, 00918H  ;1.0000100000000
;        DW      0FFF3H, 00980H, 04DDAH, 00918H  ;0.9999990000000
;        DW      0FFF3H, 0E240H, 04E81H, 00918H  ;1.0000001000000
;        DW      0FFF3H, 01960H, 04E71H, 00918H  ;0.9999999900000
;        DW      0FFF3H, 0C710H, 04E72H, 00918H  ;1.0000000010000
;        DW      0FFF3H, 09C18H, 04E72H, 00918H  ;0.9999999999000
;        DW      0FFF3H, 0A064H, 04E72H, 00918H  ;1.0000000000100
;        DW      0FFF3H, 09FF6H, 04E72H, 00918H  ;0.9999999999990
;        DW      0FFF3H, 0A001H, 04E72H, 00918H  ;1.0000000000001
;
;LGT_VAL DW      0FFF3H, 0C6DEH, 0FE91H, 00199H  ;1.5000000000000
;        DW      0FFF3H, 0F26BH, 01C23H, 0FD43H  ;0.5000000000000
;        DW      0FFF1H, 08F51H, 07C4BH, 025A5H  ;1.1000000000000
;        DW      0FFF1H, 010AEH, 0BD53H, 0FC07H  ;0.9900000000000
;        DW      0FFF1H, 0B196H, 01108H, 00065H  ;1.0010000000000
;        DW      0FFF1H, 01321H, 0E346H, 0FFF5H  ;0.9999000000000
;        DW      0FFF1H, 0BF60H, 002DBH, 00001H  ;1.0000100000000
;        DW      0FFF1H, 03055H, 0E61DH, 0FFFFH  ;0.9999990000000
;        DW      0FFF1H, 0AE46H, 00296H, 00000H  ;1.0000001000000
;        DW      0FFF1H, 0BB60H, 0FFBDH, 0FFFFH  ;0.9999999900000
;        DW      0FFF1H, 0A076H, 00006H, 00000H  ;1.0000000010000
;        DW      0FFF1H, 0565BH, 0FFFFH, 0FFFFH  ;0.9999999999000
;        DW      0FFF1H, 010F6H, 00000H, 00000H  ;1.0000000000100
;        DW      0FFF1H, 0FE4EH, 0FFFFH, 0FFFFH  ;0.9999999999990
;        DW      0FFF1H, 0002BH, 00000H, 00000H  ;1.0000000000001

;! SIN_CO  DW      0000AH                          ;COEFICIENTS COUNT
SIN_CO  DW      0FFF1H, 0EB9DH, 0504EH, 00107H  ;1.13092374E-03
	DW      0FFF2H, 0CD5AH, 0DE28H, 0FEE7H  ;-.01203158594214
	DW      0FFF3H, 000C3H, 0AD6CH, 000F2H  ;.1042291622083
	DW      0FFF3H, 0C2BFH, 0FDC0H, 0F977H  ;-.7181223017793
	DW      0FFF4H, 0B894H, 066EAH, 00379H  ;3.819952584852
	DW      0FFF5H, 04B6CH, 08CEBH, 0FEA0H  ;-15.09464257684
	DW      0FFF5H, 0EA3DH, 04159H, 003D3H  ;42.05869394493
	DW      0FFF5H, 09DF2H, 00D72H, 0F906H  ;-76.70585975310
	DW      0FFF5H, 0827BH, 00530H, 0076CH  ;81.60524927611
	DW      0FFF5H, 09A57H, 07040H, 0FC3DH  ;-41.34170224041
	DW      0FFF4H, 03E2CH, 0EB07H, 005B6H  ;6.283185307180
align 4



MATHCMP1:
		EVEN
		PUSHREGS
		MOV     EDI,EDX                 ;GET OPR_Y
		MOV     ESI,AUX01               ;    OPR_X
		JMP     mcmp_6

MATHCMP:
		EVEN
		PUSHREGS
		MOV     AUX02,EDX               ;
		MOV     EDI,EDX                 ;GET OPR_Y
		ADD     EDX,8                   ;PT TO OPR_X
		MOV     AUX01,EDX
		MOV     ESI,EDX                 ;    OPR_X
MCMP_6:
		MOV     EBX,[ESI+4]
		MOV     EAX,[ESI]               ;EXP_X IN AX
		MOV     EBP,[EDI+4]             ;
		MOV     ECX,[EDI]               ;EXP_Y IN CX
		CMP     AX,CX                   ;CMP EXPONENTS
		JNE     MCMP1                   ;NEEDS ALIGNMENT

		AND     EAX,0FFFF0000H          ;MASK OFF EXP_X
		AND     ECX,0FFFF0000H          ;MASK OFF EXP_Y
		SUB     EAX,ECX                 ;
		SBB     EBX,EBP
		JL      MCMPL
		JG      MCMPG
		OR      EAX,EBX                 ;IS X = Y ?
		JZ      MCMPE                   ;BR, YES
		JNZ     MCMPG

MCMP1:
		XOR     EBX,EBP                 ;CHK SIGN OF THESE TWO VALUE
		JNS     MCMP2                   ;BOTH HAVE SAME SIGN
		OR      EBP,EBP                 ;
		JNS     MCMPL                   ;X IS NEGATIVE VALUE
		JMP     MCMPG                   ;Y IS NEGATIVE VALUE
MCMP2:
		MOV     EBX,EDI                 ;
		CALL    MALG                    ;ALIGNMENT
		MOV     EDI,EBX                 ;
		JMP     MCMP_6                  ;

MCMPL:          MOV     R7,1                    ;A < B
		POPREGS
		RET

MCMPG:          MOV     R7,4                    ;A > B
		POPREGS
		RET
MCMPE:          MOV     R7,2                    ;A = B
		POPREGS
		RET

;****************************************************************************
;
;   .\MATH\M1ADD.ASM
;
;****************************************************************************
;-----------------------------------------------------------------------
; M1ADD.ASM

MADD_1:         SUB     ESI,2               ;PT BACK TO EXP_B
		CALL    MALG                ;CALL ADDALIGN
		JMP     MADD_2              ;CONTINUE ADD WITH ALIGNED EXP

SUBRET:
ADDRET:
		MOV     ESI,OFFSET MATHAREA
		CMP     R0,0            ;BR, IF DEFAULT ERROR VALUE
		JNE     ADDRET0
		CALL    MANREG
ADDRET0:
		POP     EDI
		MOVSD
		MOVSD
ret_0:
		CMP     ESC_FLAG,-1             ;CALLING FROM MATH INTERNAL
		JE      ADDRET1

		AND     EAX,0FFFFH
		POPREGS
ADDRET1:
		RET
ovr_0:
chk_ov_0:
ovr_1:
ovr_2:

MATHADD1:
		EVEN
		PUSHREGS

		MOV     R0,0                ;NORMAL RETURN FLAG
		MOV     ESI,EDX             ;GET OPERAND B PTR
		MOV     EBX,AUX01           ;GET OPERAND A PTR
		PUSH    EBX                 ;RETURN VALUE LOC
		JMP     ADD_MATH

MATHADD2:
		EVEN
		PUSHREGS

		MOV     R0,0                ;NORMAL RETURN FLAG
		MOV     ESI,EDX             ;GET OPERAND B PTR
		MOV     EBX,AUX01           ;GET OPERAND A PTR
		PUSH    AUX03               ;RETURN VALUE LOC
		POP     AUX01               ;RETURN VALUE LOC
		PUSH    AUX03               ;RETURN VALUE LOC
		JMP     ADD_MATH

		EVEN
ADD_MATH1:
		PUSH    EDI             ;RETURN VALUE BFR
		JMP     ADD_MATH        ;
MATHADD:
		EVEN
		MOV     R0,0                ;NORMAL RETURN FLAG
		ADD     EDX,8               ;DX RETURN PTR
		PUSHREGS
		MOV     EBX,EDX             ;GET OPERAND A PTR
		SUB     EDX,8
		MOV     ESI,EDX             ;GET OPERAND B PTR
ADD_MATH0:
		PUSH    EBX                 ;RETURN VALUE LOC

ADD_MATH:
		MOV     EDI,OFFSET MATHAREA
		PUSH    EDI                 ;SAVE MATHAREA PTR

MADD_2:
		LODSW                       ;EXP_B
		CMP     AX,[EBX]            ;EXP_B = EXP_A ?
		JNZ     MADD_1              ;NO
		STOSW                       ;YES, SAVE IN MATHAREA

		LODSD
		ADD     EAX,DWORD PTR [EBX+2]
		STOSD

		LODSW                       ;GET M3_B
		ADC     AX,[EBX+6]          ;ADD M3_B, M3_A WITH CARRY

		STOSW                       ;SAVE M3 IN MATHAREA
		JO      MADD_3              ;IF OVERFLOW ?
MADD_31:
		POP     EDI                 ;**** CHECK
		JMP     ADDRET              ;NO, RETURN

MADD_30:                                ;CHK FOR NEG LIMIT
;** IF RESULT OVERFLOW JMP HERE !!

MADD_3:
		POP     EAX                 ;FOR STACK BALANCE
		SUB     EDI,8               ;DI PT BACK TO BEG OF MATHAREA
		CALL    MANADJ              ;CALL MANTISSA NORMALIZE
		ADD     EDI,8               ;DI PT TO END OF MATHAREA
		JMP     ADDRET              ;RETURN

;---------------------------------------------------------------------------
;MATHSUB ROUTINE
;

MSUB_1:
		SUB     ESI,2               ;
		CALL    MALG                ;CALL ALIGNMENT FOR OPERATION
		JMP     MSUB_2              ;CONTINUE SUB WITH ALIGNED EXP

MATHSUB1:
		PUSHREGS

		MOV     R0,0
		MOV     EBX,EDX             ;GET OPR_B
		MOV     ESI,AUX01           ;GET OPR_A
		PUSH    ESI                 ;RETURN VALUE LOC
		JMP     SUB_MATH

MATHSUB2:
		PUSHREGS

		MOV     R0,0
		MOV     EBX,EDX             ;GET OPR_B
		MOV     ESI,AUX01           ;GET OPR_A
		PUSH    AUX03               ;RETURN VALUE LOC
		POP     AUX01               ;RETURN VALUE LOC
		PUSH    AUX03               ;RETURN VALUE LOC
		JMP     SUB_MATH
		EVEN
SUB_MATH1:
		PUSH    EDI     ;RETURN VALUE BFR
		JMP     SUB_MATH
MATHSUB:
		ADD     EDX,8               ;**
		PUSHREGS

		MOV     R0,0
		MOV     EBX,EDX             ;GET OPR_B
		SUB     EBX,8               ;
		MOV     ESI,EDX             ;GET OPR_A
SUB_MATH0:
		PUSH    ESI                 ;RETURN VALUE LOC
SUB_MATH:
		MOV     EDI,OFFSET MATHAREA ;
		PUSH    EDI                 ;SAVE MATHAREA PTR

msub_2:         LODSW                       ;GET EXP_A
		CMP     AX,[EBX]            ;EXP_A = EXP_B ?
		JNZ     msub_1              ;NO
		STOSW                       ;SAVE EXP_RES
		LODSD
		SUB     EAX,DWORD PTR [EBX+2]
		STOSD

		LODSW                       ;GET M3_A
		SBB     AX,[EBX+6]          ;M3_A - M3_B WITH BORROW
		STOSW                       ;SAVE M3_RES
		JO      MADD_3              ;IF MANTISSA OVERFLOW ?
MSUB_31:
		POP     EDI                 ;
		JMP     SUBRET              ;NO, RETURN

;---------------------------------------------------------------------------
;ROUTINE FOR ADJUST MANTISSA TO MAKE SURE WITHIN PROPER LIMITS
;
MANADJ:
		EVEN
		MOV     SI,[EDI+6]          ;SI = M3
		MOV     EBP,DWORD PTR [EDI+2] ;EBP = M1,M2

		PUSH    ESI                 ;SAVE M3
		OR      SI,SI               ;NEG ?
		JS      MOV_2               ;YES,
		NOT     SI                  ;NO, 2' COMPL M3M2M1
		NEG     EBP                     ;
		JNZ     MOV_2               ;
		INC     SI                  ;
MOV_2:
		PUSH    EDI                 ;SAVE MATHAREA PTR

		MOV     EDX,0               ;SETUP FOR DIVIDE
		MOV     EDI,10              ;DIVISOR = 10

		MOV     AX,SI               ;START FROM M3
		DIV     DI                  ;
		MOV     SI,AX               ;SAVE NEW M3

		MOV     EAX,EBP             ;REMAINDER,M2 / 10
		DIV     EDI                 ;
		MOV     EBP,EAX             ;SAVE NEW M2

		TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
		JNZ     MOV_3               ;NO,
		CMP     EDX,5               ;YES, REMAINDER < 5?
		JB      MOV_3               ;YES,

		INC     EBP                 ;ADD 1 TO M1
		JNZ     MOV_3               ;CARRY IN?
		INC     SI                  ;YES, ADD 1 TO M3

MOV_3:
		POP     EDI                 ;RESTORE MATHAREA PTR
		POP     EAX                 ;RESTORE ORIGINAL M3
		OR      AX,AX               ;NEG?
		JS      MOV_4               ;YES,
		NOT     SI                  ;NO, 2' COMPL BACK
		NEG     EBP                 ;
		JNZ     MOV_4               ;
		INC     SI                  ;

MOV_4:
		MOV     DWORD PTR [EDI+2],EBP  ;PUT NEW M1 IN MATHAREA
		MOV     [EDI+6],SI         ;    NEW M3

		ADD     WORD PTR [EDI],1    ;ADD 1 IN EXP
		JO      MADJ                ;JMP IF OVERFLOW
		RET                         ;

;
;ROUTINE TO ADJUEST MANTISSA AND EXPONENT, ENTRY HERE EITHER EXP OR MANTISSA
;IS OVER THE LEGAL BOUND....
;
MADJ:
		PUSH    ECX                 ;SAVE REGS
		PUSH    ESI                 ;
		PUSH    EBX                 ;
		PUSH    EBP                 ;
		MOV     CX,[EDI]            ;CX = EXP
		MOV     EBP,DWORD PTR [EDI+2]  ;EBP = M1,M2
		MOV     SI,[EDI+6]          ;SI = M3
		PUSH    ESI                 ;SAVE M3

		OR      SI,SI               ;MANTISSA NEG?
		JNS     MOV_6               ;NO, JMP
		NOT     SI                  ;2' COMPL
		NEG     EBP                 ;
		JNZ     MOV_6               ;
		INC     SI                  ;

MOV_6:
		PUSH    EDX                 ;SAVE REGS
		PUSH    EAX                 ;
		PUSH    EDI                 ;
		OR      CX,CX               ;EXP NEG?
		JNS     MOV_E               ;NO, JMP
MOV_7:
;               CMP     SI,0918H            ;MAX VALUE BEFORE * 10
		CMP     SI,0CCCH            ;MAX VALUE BEFORE * 10
		JNB     MOV_C               ;JMP, IF >= 0918H

MOV_8:          MOV     EDI,EBP             ;MANTISSA * 10
		MOV     DX,SI               ;
		SHL     EBP,1               ;
		RCL     SI,1                ;
		SHL     EBP,1               ;
		RCL     SI,1                ;
		ADD     EBP,EDI             ;
		ADC     SI,DX               ;
		SHL     EBP,1               ;
		RCL     SI,1                ;
		DEC     CX                  ;EXP - 1
		JS      MOV_7               ;JMP, IF EXP NEG

MOV_9:          POP     EDI                 ;RESTORE REGS
		POP     EAX                 ;
		POP     EDX                 ;
		MOV     [EDI],CX            ;SAVE NEW EXP IN MATHAREA
		POP     ECX                 ;RESTORE ORIGINAL EXP
		OR      CX,CX               ;JMP, IF ORI M3 POS
		JNS     MOV_A               ;
		NOT     SI                  ;2' COMPL MANTISSA
		NEG     EBP                 ;
		JNZ     MOV_A               ;
		INC     SI                  ;

MOV_A:          MOV     DWORD PTR [EDI+2],EBP  ;PUT NEW M1 IN MATHAREA
		MOV     [EDI+6],SI          ;        M3
MOV_B:
		POP     EBP                 ;RESTORE REGS
		POP     EBX                 ;
		POP     ESI                 ;
		POP     ECX                 ;
		RET                         ;

;** IF M3 >= 0918H .........  ( COULDN'T * 10 WITH VALUE 9999 9999 9999 9)

MOV_C:          JNZ     MOV_D               ;JMP, IF > 0918H
;               CMP     EBP,04E729FFFH      ;JMP, IF OVER MAX VALUE COULD REP
		CMP     EBP,0CCCCCCCCH      ;JMP, IF OVER MAX VALUE COULD REP
		JBE     MOV_8               ;
public          qqq1
qqq1:
MOV_D:
		MOV     R0,61H
		POP     EDI             ;RETURN BUFFER PTR
		POP     EAX
		POP     EAX
		POP     EAX             ;ORI M3
		MOV     ESI,OFFSET MAXVALUE
		OR      AX,AX           ;
		JNS     MO37X_2         ;BR, IF POS
		MOV     ESI,OFFSET MAXNVALUE
MO37X_2:
		MOVSD                   ;
		MOVSD                   ;
		JMP     MOV_B

MOV_E:          MOV     EDI,10

MOV_F:          XOR     EDX,EDX
		MOV     AX,SI
		DIV     DI
		MOV     SI,AX
		MOV     EAX,EBP
		DIV     EDI
		MOV     EBP,EAX
		OR      EAX,EAX
		OR      SI,SI
		JZ      MOV_H
		INC     CX
		JNS     MOV_F
		TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
		JNZ     MOV_G
		CMP     EDX,5
		JB      MOV_G
		INC     EBP
		JNZ     MOV_G
		INC     SI
MOV_G:          JMP     MOV_9

MOV_H:
		MOV     R0,60H
		POP     EDI             ;GET RETURN BUFFER PTR
		POP     EAX
		POP     EAX
		POP     EAX
		MOV     ESI,OFFSET ARG_0
		MOVSD
		MOVSD
		JMP     MOV_B

;---------------------------------------------------------------------------
;ROUTINE FOR ADJUST MANTISSA TO MAKE SURE WITHIN PROPER BOUNDARY
;     ENTRY -- ESI PT TO VALUE TO BE REGRESSED..
;
EVEN
MANREG:
	CMP     PRE_FLG,-1
	JE      MANREG_X
	MOV     AX,WORD PTR [ESI+6]     ;GET M3
	MOV     EBP,DWORD PTR [ESI+2]   ;GET M1, M2
	PUSH    AX                      ;SAVE M3
	OR      AX,AX                   ;
	JNS     MANREG_3                ;BR, IF POS
	NOT     AX                      ;NO, 2' COMPL M3M2M1
	NEG     EBP                     ;
	JNZ     MANREG_3
	INC     AX

MANREG_3:
	MOV     E_CUNT,1                ;EXP = 1 (DEFAULT)
	MOV     EDI,10                  ;
	CMP     AX,0918H                ;13 DIGITS?
	JB      MANREG_0
	JA      MANREG_2
	CMP     EBP,04E729FFFH
	JBE     MANREG_0
MANREG_2:
	CMP     AX,05AF3H               ;14 DIGITS ?
	JB      MANREG_20
;       JA      MANREG_21               ;BR, IF 15 DIGITS
	CMP     EBP,0107A3FF6H          ;
	JBE     MANREG_20
	MOV     E_CUNT,2
	MOV     EDI,100                 ;
;MANREG_21:
;        MOV     E_CUNT,3
;        MOV     EDI,1000                ;
MANREG_20:
	XOR     EDX,EDX                 ;
	DIV     DI                      ;
	MOV     BX,AX                   ;
	MOV     EAX,EBP                 ;
	DIV     EDI                     ;
	MOV     EBP,EAX                 ;

	TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING ?
	JNZ     MANREG_1

	SHR     EDI,1
	CMP     EDX,EDI                 ;YES, REMAINDER < 1/2 DIVISOR
	JB      MANREG_1                ;YES,

	INC     EBP                     ;ADD 1 TO M1
	JNZ     MANREG_1                ;CARRY IN?
	INC     BX                      ;YES, ADD 1 TO M3
MANREG_1:
	POP     AX                      ;GET OLD M3
	OR      AX,AX                   ;
	JNS     MANREG_5                ;BR, IF POS
	NOT     BX                      ;NO, 2' COMPL M3M2M1
	NEG     EBP                     ;
	JNZ     MANREG_5
	INC     BX

MANREG_5:
	MOV     WORD PTR [ESI+6],BX     ;
	MOV     DWORD PTR [ESI+2],EBP   ;
	MOV     BX,E_CUNT               ;GET EXP
	ADD     WORD PTR [ESI],BX       ;
	RET
MANREG_0:
	POP     AX
MANREG_X:
	RET
;****************************************************************************
;
;   .\MATH\M1MUL.ASM
;
;****************************************************************************
;-------------------------------------------------------------
;M1MUL.ASM
;

;-------------------------------------------------------------
;MANTISSA MUL ROUTINE
;

		 EVEN

;-------------------------------------------------------------
;MATHMUL ROUTINE
;
MULRET:
		MOV     ESI,OFFSET MATHAREA     ;PREPARE FOR TRANSFER FINAL VAL
		CMP     R0,0                    ;BR, IF DEFAULT ERROR VALUE
		JNE     MULRET0
		CALL    MANREG
MULRET0:
		POP     EDI
		movsd
		movsd
mulret_0:
		CMP     ESC_FLAG,-1             ;BR, IF CALLING FROM MATH INTERNAL
		JE      MULRET1
		POPREGS
MULRET1:
		RET

mulovr_0:
		jmp     mulret_0                ;
chk_mulov_0:

mulovr_1:

mulovr_2:

MATHMUL1:
		EVEN
		PUSHREGS
		MOV     R0,0
						;DX PT TO OPR_B
		MOV     EBX,AUX01               ;BX PT TO OPR_A
		PUSH    EBX                     ;RETURN VALUE LOC
		JMP     MUL_MATH

MATHMUL2:
		EVEN
		PUSHREGS
		MOV     R0,0
						;DX PT TO OPR_B
		MOV     EBX,AUX01               ;BX PT TO OPR_A
		PUSH    AUX03                   ;RETURN VALUE LOC
		POP     AUX01                   ;RETURN VALUE LOC
		PUSH    AUX03                   ;RETURN VALUE LOC
		JMP     MUL_MATH

MUL_MATH1:
		PUSH    EDI                     ;RETURN VALUE BFR
		JMP     MUL_MATH                ;

MATHMUL:
		EVEN
		MOV     R0,0
		ADD     EDX,8                   ;**
		PUSHREGS
		MOV     EBX,EDX                 ;DX PT TO OPR_B
		SUB     EDX,8                   ;BX PT TO OPR_A
MUL_MATH0:
		PUSH    EBX                     ;RETURN VALUE LOC
MUL_MATH:
		MOV     EDI,OFFSET MATHAREA

		CALL    mmul                    ;CALL MATH ROUTINE
		JMP     MULRET                  ;

mmul:
	mov     esi,0                   ;init
	mov     ebp,0                   ;
	mov     ax,[ebx]                ;get exp_a
	mov     exp_a,ax                ;save exp_a
	mov     si,word ptr [ebx+6]     ;get m3_a
	mov     ebx,dword ptr [ebx+2]   ;get m1,m2_a
	mov     ax,[edx]                ;get exp_b
	mov     exp_b,ax                ;save exp_b
	mov     bp,word ptr [edx+6]     ;get m3_b
	mov     ecx,dword ptr [edx+2]   ;get m1,m2_b
	mov     ptr_flp,0               ;assume same opr_a, opr_b both positive
	or      si,si                   ;opr_a neg?
	jns     mmul_1                  ;br, if positive
	not     ptr_flp                 ;flag different sign
	not     si                      ;2's complement opr_a
	neg     ebx                     ;
	jnz     mmul_1                  ;
	inc     si                      ;
mmul_1:
	or      bp,bp                   ;opr_b neg?
	jns     mmul_2                  ;br, if positive
	not     ptr_flp                 ;flag sign different
	not     bp                      ;2's complement opr_b
	neg     ecx                     ;
	jnz     mmul_2                  ;
	inc     bp
mmul_2:
	xor     edx,edx                 ;init
	mov     dword ptr m1_res,0      ;
	mov     dword ptr m3_res,0      ;
	mov     dword ptr m5_res,0      ;

	or      ecx,ecx                 ;m1,m2_b = 0 ?
	jz      mmul_4                  ;br, yes

	or      ebx,ebx                 ;m1,m2_a = 0 ?
	jz      mmul_3                  ;br, yes

	mov     eax,ebx                 ;
	mul     ecx                     ;m1,m2_a * m1,m2_b
	mov     dword ptr m3_res,edx    ;
	mov     dword ptr m1_res,eax    ;

mmul_3:
	or      esi,esi                 ;m3_a = 0 ?
	jz      mmul_5                  ;br, yes
	mov     eax,esi                 ;
	mul     ecx                     ;m3_a * m1,m2_b
	add     dword ptr m3_res,eax    ;
	mov     dword ptr m5_res,edx    ;
	jnc     mmul_5                  ;
	inc     dword ptr m5_res        ;
mmul_5:

mmul_4:
	or      ebx,ebx                 ;m1,m2_a = 0 ?
	jz      mmul_6                  ;br, yes
	mov     eax,ebp                 ;
	mul     ebx                     ;m3_b * m1,m2_a
	add     dword ptr m3_res,eax    ;
	adc     dword ptr m5_res,edx    ;
mmul_6:
	or      esi,esi                 ;m3_a = 0 ?
	jz      mmul_7                  ;br, yes
	mov     eax,esi                 ;
	mul     ebp                     ;m3_a * m3_b
	add     dword ptr m5_res,eax    ;
mmul_7:
	mov     ebx,dword ptr m4_res    ;check high order mantissa = 0 ?
	or      ebx,ebx                 ;
	jnz     mmul_9                  ;br, if not 0
	or      bx,word ptr m6_res      ;
	jnz     mmul_9                  ;br, if not 0

	mov     bp,0                    ;for test
	MOV     DX,M3_RES               ;GET M3_RES
	CMP     DX,07FFFH               ;OVER MAX LIMIT ?
	JBE     MMUL_A                  ;NO,

MMUL_9: CALL    PMUL_F                  ;CALL ADJ MANTISSA
	MOV     DX,M3_RES               ;GET M3_RES
	JMP     MMUL_B
MMUL_A: MOV     BP,0000
;
MMUL_B:

	mov     ecx,dword ptr m1_res    ;get m1,m2 reslut
	cmp     ptr_flp,0               ;same sign or not ?
	je      MMUL_C
	mov     ptr_flp,0               ;reset
	NOT     DX                      ;2' COMPL
	neg     ecx
	JNZ     MMUL_C                  ;
	INC     DX                      ;

MMUL_C:
	mov     dword ptr [edi+2],ecx   ;put m1,m2,m3_res to matharea
	MOV     [EDI+6],DX              ;
	MOV     BX,BP                   ;BP = COUNTER OF ( *10 )
	ADD     BX,EXP_B                ;ADD EXP_B
	JNO     MMUL_D                  ;OVERFLOW ?

	MOV     [EDI],BX                ;YES, SAVE CURRENT EXP_RES
	CALL    MADJ                    ;ADJUST VALUE
	MOV     BX,[EDI]                ;GET ADJUSTED EXP_RES

MMUL_D: ADD     BX,EXP_A                ;ADD EXP_A TO EXP_RES
	MOV     [EDI],BX                ;PUT IN MATHAREA
	JNO     MMUL_E                  ;OVERFLOW ?
	CALL    MADJ                    ;YES, ADJUST VALUE
MMUL_E: RET                             ;


PMUL_F:
	MOV     EBP,0           ;COUNT OF EXP CHANGED
PMUL_G:
	MOV     EDX,0           ;INIT FOR DIV
	MOV     ECX,1000000     ;DIVISOR

	MOV     EAX,DWORD PTR M5_RES
	OR      EAX,EAX         ;IS M5,M6_RES = 0 ?
	JZ      PMUL_GA         ;BR, IF YES
	MOV     EBP,6;6         ;STARTING FROM MIDDLE

	CMP     EAX,100000      ;
	JB      PMUL_G5         ;BR, IF LESS

	CMP     EAX,1000000     ;
	JB      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR, EBP = 6
	INC     EBP
	MOV     ECX,10000000
	CMP     EAX,10000000    ;
	JB      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR , EBP = 7
	INC     EBP             ;
	MOV     ECX,100000000   ;DIVISOR
	CMP     EAX,100000000   ;
	JB      PMUL_G9         ;BR, EBP = 8
	INC     EBP             ;
	MOV     ECX,1000000000  ;DIVISOR
	JMP     PMUL_G9         ;

PMUL_G5:
	MOV     ECX,100000      ;
	MOV     EBP,5;5         ;
	CMP     EAX,10000       ;
	JA      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR, EBP = 5
	DEC     EBP
	MOV     ECX,10000
	CMP     EAX,1000        ;
	JA      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR , EBP = 4
	DEC     EBP
	MOV     ECX,1000
	CMP     EAX,100         ;
	JA      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR , EBP = 3
	DEC     EBP
	MOV     ECX,100
	CMP     EAX,10          ;
	JA      PMUL_G9         ;BR, IF FIND THE RIGHT DIVISOR , EBP = 2
	DEC     EBP
	MOV     ECX,10          ;EBP = 1

PMUL_G9:
	DIV     ECX
	MOV     DWORD PTR M5_RES,EAX    ;PUT QUOTIENT (0) BACK
	MOV     EAX,DWORD PTR M3_RES    ;
	DIV     ECX                     ;
	MOV     DWORD PTR M3_RES,EAX    ;PUT QUOTIENT BACK
	MOV     EAX,DWORD PTR M1_RES    ;
	DIV     ECX                     ;
	MOV     DWORD PTR M1_RES,EAX    ;PUT QUOTIENT BACK

	TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ     PMUL_GA                 ;NO
	SHL     EDX,1                   ;REMAINDER * 2
	CMP     EDX,ECX                 ;= DIVISOR ?
	JB      PMUL_GA                 ;NO
	INC     DWORD PTR M1_RES        ;YES, INC
	JNC     PMUL_GA                 ;CARRY ?
	INC     DWORD PTR M3_RES        ;
	JNC     PMUL_GA                 ;
	INC     DWORD PTR M5_RES        ;

;CHECK IF M5,M6 ARE REALLY = 0 HERE !!
;
PMUL_GA:
	XOR     EDX,EDX
	MOV     DX,WORD PTR M5_RES      ;
	OR      EDX,EDX                 ;
	JZ      PMUL_H                  ;BR, IF ZERO
	MOV     ECX,10                  ;
	MOV     AX,DX                   ;
	XOR     EDX,EDX                 ;
	DIV     CX                      ;DIVIDE BY 10
	MOV     WORD PTR M5_RES,AX      ;
	MOV     EAX,DWORD PTR M3_RES    ;
	DIV     ECX                     ;
	MOV     DWORD PTR M3_RES,EAX    ;
	MOV     EAX,DWORD PTR M1_RES    ;
	DIV     ECX                     ;
	MOV     DWORD PTR M1_RES,EAX    ;
	INC     EBP
	TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ     PMUL_GA                 ;NO
	SHL     EDX,1                   ;REMAINDER * 2
	CMP     EDX,ECX                 ;= DIVISOR ?
	JB      PMUL_H                  ;NO
	INC     DWORD PTR M1_RES        ;YES, INC
	JNC     PMUL_H                  ;CARRY ?
	INC     DWORD PTR M3_RES        ;
	JNC     PMUL_H                  ;
	INC     DWORD PTR M5_RES        ;

PMUL_H:
	MOV     EDX,0           ;INIT FOR DIV

	MOV     EAX,DWORD PTR M3_RES
	OR      EAX,EAX         ;IS M3,M4_RES = 0 ?
	JZ      PMUL_I          ;BR, IF YES

	MOV     ECX,100;        ;DIVISOR
	CMP     EAX,100000      ;
	JB      PMUL_H5         ;BR, IF LESS
	ADD     EBP,2;3  ;      ;

	CMP     EAX,1000000     ;
	JB      PMUL_H9         ;BR, IF FIND THE RIGHT DIVISOR, EBP +3
				;    LEAVE  |EAX| < 999
	INC     EBP             ;
	MOV     ECX,1000;       ;
	CMP     EAX,10000000    ;
	JB      PMUL_H9         ;BR, IF FIND THE RIGHT DIVISOR , EBP + 4
	INC     EBP             ;
	MOV     ECX,10000;      ;DIVISOR
	CMP     EAX,100000000   ;
	JB      PMUL_H9         ;BR, EBP + 5
	INC     EBP             ;
	MOV     ECX,100000;     ;DIVISOR
	CMP     EAX,1000000000  ;
	JB      PMUL_H9         ;BR, EBP + 6
	INC     EBP             ;
	MOV     ECX,1000000;    ;DIVISOR
	JMP     PMUL_H9         ;EBP + 7

PMUL_H5:
	MOV     ECX,10;         ;
	ADD     EBP,1;2         ;EBP + 2
	CMP     EAX,10000       ;
	JA      PMUL_H9         ;BR, IF FIND THE RIGHT DIVISOR, EBP + 2

	DEC     EBP             ;NO NEED TO ADJUST
	RET
PMUL_H9:
	DIV     ECX
	MOV     DWORD PTR M3_RES,EAX    ;PUT QUOTIENT (0) BACK
	MOV     EAX,DWORD PTR M1_RES    ;
	DIV     ECX                     ;
	MOV     DWORD PTR M1_RES,EAX    ;PUT QUOTIENT BACK

	TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ     PMUL_I                  ;NO
	SHL     EDX,1                   ;REMAINDER * 2
	CMP     EDX,ECX                 ;= DIVISOR ?
	JB      PMUL_I                  ;NO
	INC     DWORD PTR M1_RES        ;YES, INC
	JNC     PMUL_I                  ;CARRY ?
	INC     DWORD PTR M3_RES        ;
	JNC     PMUL_I                  ;
	INC     DWORD PTR M5_RES        ;
PMUL_I:
	RET
;****************************************************************************
;
;   .\MATH\M1DIV.ASM
;
;****************************************************************************
;-----------------------------------------------------------------------
;M1DIV.ASM
;

DIVRET:
	MOV     ESI,OFFSET MATHAREA

			;Could be a bug here to generate 14 digits result
			;4/24/89

	CMP     MANREG_F,-1             ;IF COMING FROM TRI_CONV
	JE      DIVRET0                 ;BR, IF YES
	CMP     R0,0                    ;BR, IF DEFAULT ERROR VALUE
	JNE     DIVRET0                 ;
	CALL    MANREG
DIVRET0:
	POP     EDI
	MOVSD
	MOVSD
	CMP     ESC_FLAG,-1          ;
	JE      DIVRET1
	POPREGS
DIVRET1:
	RET

MATHDIV1:
	PUSHREGS
	MOV     R0,0                    ;DX PT TO OPR_Y ( DIVISOR )
	MOV     EBX,AUX01               ;BX PT TO OPR_X ( DIVIDEND )
	PUSH    EBX                     ;RETURN VALUE LOC
	JMP     DIV_MATH

MATHDIV2:
	PUSHREGS
	MOV     R0,0                    ;DX PT TO OPR_Y ( DIVISOR )
	MOV     EBX,AUX01               ;BX PT TO OPR_X ( DIVIDEND )
	PUSH    AUX03                   ;RETURN VALUE LOC
	POP     AUX01                   ;RETURN VALUE LOC
	PUSH    AUX03                   ;RETURN VALUE LOC
	JMP     DIV_MATH

DIV_MATH0:      ;The entry pt used by any other MATH routine.....
		;Input : EBX - ptr of X, EDX - ptr of Y, EDI - ptr of return
		;        buffer

	PUSH    EDI                     ;SAVE RET VALUE BUFFER
	JMP     DIV_MATH                ;

MATHDIV:
	ADD     EDX,8                   ;**
	PUSHREGS
	MOV     R0,0                    ;
	MOV     EBX,EDX                 ;DX PT TO OPR_Y ( DIVISOR )
	SUB     EDX,8                   ;BX PT TO OPR_X ( DIVIDEND )
	PUSH    EBX                     ;RETURN VALUE LOC
DIV_MATH:
	MOV     EDI,OFFSET MATHAREA     ;
;!      PUSH    EDI                     ;SAVE MATHAREA PTR
	CALL    MDIV                    ;CALL MATH ROUTINE
;!      POP     EDI                     ;**** CHECK
	JMP     DIVRET                  ;RETURN

MDIV:
	MOV     ESI,EDX                 ;SI PT TO OPR_Y
	MOV     AX,[EBX]                ;GET EXP_X
	MOV     EXP_A ,AX               ;SAVE IT
	MOV     AX,[ESI]                ;GET EXP_Y
	MOV     EXP_B ,AX               ;SAVE IT

	MOV     WORD PTR E_CUNT,0       ;COUNTER OF EXP_ADJ  ( 10**X )

	mov     cx,[ebx+6]              ;get mantissa of opr_x
	mov     ebx,[ebx+2]             ;
	mov     ptr_flp,0               ;assume x, y both positive
	or      cx,cx                   ;x < 0 ?
	jns     MDIV_1                  ;br, if > 0
	not     ptr_flp                 ;
	not     cx                      ;2's complement
	neg     ebx                     ;
	jnz     MDIV_1                  ;
	inc     cx                      ;


MDIV_1:
	mov     dword ptr m1_x,ebx      ;save mantissa of x
	mov     m3_x,cx                 ;


	mov     dx,[esi+6]              ;get mantissa of y
	mov     ebp,[esi+2]             ;
	or      dx,dx                   ;y < 0 ?
	jns     MDIV_2                  ;
	not     ptr_flp                 ;flag y has different sign
	not     dx                      ;2's complement
	neg     ebp                     ;
	jnz     MDIV_2                  ;
	inc     dx                      ;

MDIV_2:

	mov     dword ptr m1_y,ebp      ;save mantissa of y
	mov     m3_y,dx                 ;
	or      dx,dx                   ;m3_y = 0 ?
	jnz     MDIV_3                  ;
	test    ebp,0ffff0000h          ;m2_y = 0 ?
	jnz     MDIV_3                  ;
	test    ebp,0ffffh              ;m1_y = 0 ?
	jnz     MDIV_A                  ;br to special rotine for simple divisor

	jmp     MDIV_G                  ;mantissa_y = 0

MDIV_3:
	or      ebx,ebx                 ;m1,m2_x = 0 ?
	jnz     MDIV_4                  ;
	or      cx,cx                   ;m3_x = 0 ?
	jz      MDIV_9                  ;mantissa_x = 0


MDIV_4: CALL    MDIV_K                  ;CALL CON_SUB ROUTINE

MDIV_5:
	test    ptr_flp,1               ;oprnds has same sign?
	jz      MDIV_6                  ;br, if no
	not     dx                      ;2's complement
	neg     ebp                     ;
	jnz     MDIV_6                  ;
	inc     dx                      ;

MDIV_6:
	mov     [edi+2],ebp             ;save m1,m2_quo back
	mov     [edi+6],dx              ;     m3_quo

	MOV     AX,EXP_A                ;GET EXP_X
	SUB     AX,EXP_B                ;SUB BY EXP_Y
	MOV     [EDI],AX                ;SAVE EXP_RES BACK

	JNO     MDIV_7                  ;EXP_RES OVERFLOW ?
	CALL    MADJ                    ;ADJUST EXP - MANTISSA

MDIV_7: MOV     AX,E_CUNT               ;GET COUNTER OF ADJU EXP DIFF
	ADD     [EDI],AX                ;ADD TO EXP_RES
	JNO     MDIV_8                  ;EXP_RES OVERFLOW ?
	CALL    MADJ                    ;ADJUST EXP - MANTISSA
MDIV_8: RET

MDIV_9:
	MOV     DX,0                    ;zero result or underflow
	mov     EBP,0                   ;
	jmp     MDIV_5

;---------------------------------------------------------------------------
;     ( SIMPLE DIVIDE ROUTINE )
;
;IF DIVISOR IS A SINGLE WORD MANTISSA, PROCESS CAN BE SIMPLIFIED AS FOLLOWS
;

MDIV_A: MOV     DX,0                    ;
	MOV     AX,M3_X                 ;GET M3_X
	OR      AX,AX                   ;= 0 ?
	JNZ     MDIV_B                  ;NO
	MOV     M3_QUO,AX               ;M3_QUO = 0

	MOV     AX,M2_X                 ;GET M2_X
	OR      AX,AX                   ;= 0 ?
	JNZ     MDIV_C                  ;NO
	MOV     M2_QUO,AX               ;M2_QUO = 0

	MOV     AX,M1_X                 ;GET M1_X
	OR      AX,AX                   ;= 0 ?
	JNZ     MDIV_D                  ;NO
	JMP     MDIV_9                  ;YES, RESULT = 0

MDIV_B: DIV     BP                      ;DIVIDED BY SINGLE WORD DIVISOR
	MOV     M3_QUO,AX               ;SAVE M3_QUO
	MOV     AX,M2_X                 ;GET M2_X
MDIV_C: DIV     BP                      ;
	MOV     M2_QUO,AX               ;SAVE M2_QUO
	MOV     AX,M1_X                 ;GET M1_X
MDIV_D: DIV     BP                      ;
	MOV     M1_QUO,AX               ;SAVE M1_QUO
	OR      DX,DX                   ;REMAINDER = 0 ?
	JZ      MDIV_F                  ;YES

	CMP     WORD PTR M3_QUO,0CCCH   ;M3 OVER MAX LIMIT BEFORE *10 ?
	JAE     MDIV_E                  ;YES
	JMP     MDIV_3                  ;NO,  MAKE SURE PRECISION IS ENOUGH

MDIV_E: TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING ?
	JNZ     MDIV_F                  ;NO
	SHL     DX,1                    ;
	CMP     DX,BP                   ;
	JB      MDIV_F                  ;
	INC     WORD PTR M1_QUO         ;
	JNZ     MDIV_F                  ;
	INC     WORD PTR M2_QUO         ;
	JNZ     MDIV_F                  ;
	INC     WORD PTR M3_QUO         ;

MDIV_F:
	mov     ebp,dword ptr m1_quo    ;get m1,m2_quo
	MOV     DX,M3_QUO               ;    M3_QUO
	JMP     MDIV_5

;-------------------------------------------------------------------------
;THE ABNORMAL CONDITION -- DIVIDED BY ZERO ..................
;
MDIV_G:
	MOV     AX,M1_X
	OR      AX,M2_X
	JNZ     MDIV_I
	OR      AX,M3_X
	JNZ     MDIV_I

	mov     r0,63h                  ;math error 63

MDIV_H:
	mov     dx,0                    ;result = 0
	mov     ebp,0                   ;
	mov     exp_A,0                 ;
	mov     exp_b,0                 ;
	jmp     MDIV_5                  ;


;-------------------------------------------------------------------------
;THE ABNORMAL CONDITION -- OVERFLOW .................
;
MDIV_I:
	mov     r0,62h                  ;math error 62

	mov     ax,m3_x
	or      ax,ax                   ;
	js      MDIV_I1                 ;br, if neg
	mov     exp_a,0057h             ;
	mov     exp_b,0                 ;
	mov     ebp,04e729fffh          ;set default value 9.999999999999e99
	mov     dx,00918h               ;
	jmp     MDIV_5                  ;

MDIV_I1:
	mov     exp_a,0057h             ;
	mov     exp_b,0                 ;
	mov     ebp,0b18d6001h          ;set default value -9.999999999999e99
	mov     dx,0f6e7h               ;
	jmp     MDIV_5                  ;



MDIV_J:
	mov     ebp,1                   ;
	mov     dx,0                    ;
	jmp     MDIV_X                  ;


MDIV_K:
	MOV     WORD PTR E_CUNT,0000    ;INIT COUNTER OF EXP ADJU DIFF
	PUSH    EDI                     ;SAVE MATHAREA PTR

	mov     ebp,dword ptr m1_x      ;get m1,m2_x
	mov     dx,m3_x                 ;    m3_x

	CMP     DX,M3_Y                 ;M3_X > M3_Y ?
	JA      MDIV_M                  ;YES
	JB      MDIV_Q                  ;M3_X < M3_Y

	cmp     ebp,dword ptr m1_y      ;m1,m2_x > m1,m2_y ?
	jb      MDIV_Q                  ;br, x < y
	je      MDIV_J                  ;br, if x = y


MDIV_M:
	mov     ebp,dword ptr m1_y      ;get m1,m2_y
	mov     dx,m3_y                 ;    m3_y


	MOV     DI,0                    ;M4_Y = 0
	MOV     M4_X  ,DI               ;M4_X = 0
	JMP     MDIV_O

MDIV_N:
	mov     dword ptr m1_y,ebp      ;save new m1,m2_y
	mov     m3_y,dx                 ;         m3_y


;---------------------------------------------------------------------------
;IF MANTISSA_A > MANTISSA_B ................
;MANTISSA_B WILL KEEP * 10 UNTIL ( M4_B > 0 ) OR ( > MANTISSA_A )
;
;note: When terminate loop, the last iteration result has not been saved back
;      and the counter of ( * 10 ) will be decrement by 1.
;      The purpose of this loop is make divisor as large as possible.
;

MDIV_O: INC     WORD PTR E_CUNT         ;INC COUNTER OF ( *10 )

	SHL     EBP,1                   ;MANTISSA_Y * 10
	RCL     DX,1                    ;
	RCL     DI,1                    ;
	SHL     EBP,1
	RCL     DX,1                    ;
	RCL     DI,1                    ;
	ADD     EBP,DWORD PTR M1_Y
	ADC     DX,M3_Y                 ;
	ADC     DI,0                    ;
	SHL     EBP,1
	RCL     DX,1                    ;
	ADC     DI,DI                   ;M4_B = 0 ?
	JNZ     MDIV_P                  ;NO

	CMP     DX,M3_X                 ;M3_Y > M3_X ?
	JA      MDIV_P                  ;YES
	JB      MDIV_N                  ;NO, MANTISSA_B * 10 AGAIN



	CMP     EBP,DWORD PTR M1_X      ;M1,M2_Y > M1,M2_X ?
	JB      MDIV_N                  ;Y < X
	JE      MDIV_J                  ;Y = X

;---------------------------------------------------------------------------
;MANTISSA_Y * 10 UNTIL ( M4_Y NOT EQUAL 0 ) OR ( MAN_Y > MAN_X )
;

MDIV_P: DEC     WORD PTR E_CUNT         ;DEC COUNTER OF ( *10 )
	JMP     MDIV_S                  ;TO START CON_SUB

;---------------------------------------------------------------------------
;IF MANTISSA_X < MANTISSA_Y WILL COME HERE
;MANTISSA_X WILL KEEP * 10 UNTIL ( M4_X > 0 ) OR ( > MANTISSA_Y )
;

MDIV_Q: MOV     DI,0                    ;INIT M4_X = 0
MDIV_R: DEC     WORD PTR E_CUNT         ;DEC COUNTER OF ( *10 )

	SHL     EBP,1                   ;MANTISSA_X * 10
	RCL     DX,1                    ;
	RCL     DI,1                    ;
	SHL     EBP,1
	RCL     DX,1                    ;
	RCL     DI,1                    ;
	ADD     EBP,DWORD PTR M1_X
	ADC     DX,M3_X                 ;
	ADC     DI,0                    ;
	SHL     EBP,1
	RCL     DX,1                    ;
	ADC     DI,DI                   ;
	MOV     DWORD PTR M1_X,EBP
	MOV     M3_X,DX                 ;
	MOV     M4_X,DI                 ;
	JNZ     MDIV_S                  ;M4_X = 0 ?

	CMP     DX,M3_Y                 ;YES, M3_X < M3_Y ?
	JB      MDIV_R                  ;YES, AGAIN
	JA      MDIV_S                  ;NO

	CMP     EBP,DWORD PTR M1_Y      ;M1,M2_X > M1,M2_Y ?
	JB      MDIV_R                  ;X < Y
	JE      MDIV_J                  ;X = Y

;------------------------------------------------------------------------
;Note: The mantissa of dividend will be expanded from 3 words to 6 words,
;      mantissa = mantissa * 10 **13 and exp = exp -13.
;

MDIV_S: SUB     WORD PTR E_CUNT,13      ;EXP_X - 13


	MOV     EBP,DWORD PTR M1_X      ;GET M1,M2_X
	MOV     DX,M3_X                 ;    M3_X
	MOV     DI,M4_X                 ;    M4_X

	MOV     ESI,0                   ;INIT M5,M6_X

	MOV     ECX,0033H               ;MAKE MANTISSA_X * 2*10**13
	CLC                             ;
MDIV_T:
	RCR     ESI,1
	RCR     DI,1                    ;
	RCR     DX,1                    ;
	RCR     EBP,1
	JNB     MDIV_U                  ;
	ADD     ESI,48C27395H
MDIV_U: LOOP    MDIV_T                  ;

	MOV     ECX,0030H               ;DOES 48 TIMES BINARY SUB

MDIV_V:
	SUB     DI,M1_Y                 ;M4_X - M1_Y
	SBB     ESI,DWORD PTR M2_Y      ;M5,M6_Y - M2,M3_Y
	JNB     MDIV_W                  ;JMP, IF NOT BORROW
	ADD     DI,M1_Y                 ;RESTORE M4_X
	ADC     ESI,DWORD PTR M2_Y      ;RESTOER M5,M6_X

MDIV_W:
	RCL     EBP,1                   ;ROTATE FOR NEXT BIT SUB
	RCL     DX,1                    ;
	RCL     DI,1                    ;
	RCL     ESI,1                   ;
	LOOP    MDIV_V                  ;

	NOT     EBP                     ;GET M1,M2_QUO
	NOT     DX                      ;    M3_QUO

	TEST    DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ     MDIV_X                  ;NO
	SUB     DI,M1_Y                 ;DO MORE BINARY SUB ON M4,M5,M6
	SBB     ESI,DWORD PTR M2_Y
	JB      MDIV_X                  ;
	INC     EBP
	JNZ     MDIV_X                  ;
	INC     DX                      ;
MDIV_X: POP     EDI                     ;RESTORE MATHAREA PTR
	RET

;****************************************************************************
;
;   .\MATH\LGT.ASM
;
;****************************************************************************
;******************************************************************
;MATHLGT - Find the logorithm (base 10) of X
;       Input:  EDX pt to value of X
;       Ouput:  X is replace by logorithm of X
;       possible error : X = 0,  ERROR 67 ( LGT(X) = 9.999999999 E99)
;                        X < 0,  ERROR 68 ( LGT(X) = LOG(ABS(X))
;
MATHLGT:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     PRE_FLG,-1
	MOV     EBX,EDX                 ;
	MOV     EDI,EDX                 ;

LGT_MATH1:
	MOV     TEMP_PTR,EDI            ;RESULT PTR
	CALL    MLGT_3                  ;ROUTINE TO PROCESS LGT
	OR      AL,AL
	JNZ     MLGT_1                  ;RETURN FLAG

	MOV     EBX,OFFSET LGT_E        ;VALUE OF LGT (E)
	MOV     EDX,OFFSET TEMP_Y       ;
	MOV     EDI,TEMP_PTR
	CALL    MUL_MATH1               ;
	MOV     ESI,TEMP_PTR            ;
	MOV     EBX,OFFSET TEMP_Z1
	MOV     EDI,ESI
	CALL    ADD_MATH1               ;
MLGT_1:
	CMP     ESC_FLAG1,-1            ;
	JE      MLGT_2                  ;
	MOV     PRE_FLG,0               ;
	MOV     ESI,TEMP_PTR            ;
	CALL    MANREG                  ;TO 12 DIGIT ACCRACY
	MOV     ESC_FLAG,0              ;
	POPREGS                         ;
MLGT_2:
	RET
MLGT_3:
	MOV     AX,WORD PTR [EBX+6]     ;GET M3_X
	OR      AX,AX                   ;CHECK SIGN
	JS      MLGT_4                  ;BR, IF NEGATIVE
	OR      AX,WORD PTR [EBX+4]     ;IF X = 0 ?
	OR      AX,WORD PTR [EBX+2]     ;
	JNZ     MLGT_6                  ;BR, IF NOT ZERO

;** X = 0  --> ERROR 67 LGT(X) = -9.9999999..E99
;
	MOV     R0,67H                  ;
	MOV     ESI,OFFSET MAXNVALUE    ;
	MOV     EDI,TEMP_PTR            ;
	MOVSD
	MOVSD
	MOV     AL,1
	RET

;** X < 0 --> ERROR 68, LGT(X) = LGT(ABS(X))
;
MLGT_4:
	MOV     R0,68H                  ;
	MOV     ESI,EBX                 ;
	MOV     EDI,OFFSET TEMP_Z2      ;

	MOV     AX,[ESI]                ;GET EXP_X
	MOV     [EDI],AX                ;
	MOV     EAX,[ESI+2]             ;GET M1,M2
	MOV     CX,[ESI+6]              ;M3
	NEG     EAX
	JNZ     MLGT_41
	INC     CX
MLGT_41:
	MOV     [EDI+2],EAX             ;
	MOV     [EDI+6],CX              ;
	JNO     MLGT_5                  ;BR, IF MANTISSA STILL WITHIN LIMIT
	CALL    MANADJ                  ;
MLGT_5:
	MOV     EBX,OFFSET TEMP_Z2      ;
;
;TEMP_Z  -- the power of mantissa (in radix 10), mantissa
;TEMP_Z1 -- the exponent of old X
;
MLGT_6:
	XOR     EAX,EAX
	MOV     ESI,EBX                 ;
	MOV     AX,[ESI]                ;GET EXP_X

	MOV     WORD PTR TEMP_Z,0       ;
	MOV     WORD PTR TEMP_Z1,0      ;
	MOV     WORD PTR TEMP_Z1+2,AX   ;
	MOV     DWORD PTR TEMP_Z1+4,0   ;
	OR      AX,AX                   ;EXP_X IS NEG ?
	JNS     MLGT_61                 ;BR, IF POS
	MOV     DWORD PTR TEMP_Z1+4,-1  ;MAKE SIGN EXTEND
MLGT_61:
	MOV     ECX,[ESI+2]             ;GET M1,M2 OF X
	MOV     DWORD PTR TEMP_Z+2,ECX  ;
	MOV     AX,[ESI+6]              ;GET M3
	MOV     WORD PTR TEMP_Z+6,AX

	MOV     EDI,OFFSET CON_10+2     ;START TO CHECK THE POWER OF MANTISSA
MLGT_8:
	CMP     AX,[EDI+4]              ;COMPARE WITH 10^N CONSTANT MANTISSA
	JB      MLGT_9                  ;BR, WE KNOW WHAT WE ARE
	JA      MLGT_7                  ;GET 10^(N+1) TO COMPARE
	CMP     ECX,[EDI]               ;
	JBE     MLGT_9
MLGT_7:
	ADD     EDI,8                   ;PT TO NEXT 10^N CONSTANT MANTISSA
	DEC     WORD PTR TEMP_Z         ;
	INC     DWORD PTR TEMP_Z1+2     ;
	JNZ     MLGT_8                  ;
	INC     WORD PTR TEMP_Z1+6      ;
	JMP     MLGT_8

MLGT_9:
	MOV     ESI,OFFSET TEMP_Z       ;
	MOV     EDI,OFFSET CON_1778     ;
	CALL    PCMP                    ;
	CMP     AL,1                    ;
	JE      MLGT_C                  ;

	MOV     ESI,OFFSET TEMP_Z
	MOV     EDI,OFFSET CON_5623
	CALL    PCMP
	CMP     AL,1
	JE      MLGT_A

	DEC     WORD PTR TEMP_Z         ;
	MOV     EBX,OFFSET CON_1        ;
	JMP     MLGT_B                  ;

MLGT_A:
	MOV     EBX,OFFSET CON_3162     ;
	MOV     EDX,OFFSET TEMP_Z       ;
	MOV     EDI,EDX
	CALL    MUL_MATH1               ;

	MOV     EBX,OFFSET ARG_5        ;
MLGT_B:
	MOV     ESI,OFFSET TEMP_Z1      ;
	MOV     EDI,ESI                 ;
	CALL    ADD_MATH1               ;
MLGT_C:
	MOV     ESI,OFFSET TEMP_Z       ;
	MOV     EBX,OFFSET CON_1        ;
	MOV     EDI,ESI                 ;
	CALL    ADD_MATH1               ;
	MOV     EBX,OFFSET CON_2        ;
	MOV     EDX,OFFSET TEMP_Z       ;
	MOV     EDI,EDX                 ;
	CALL    DIV_MATH0               ;

	MOV     ESI,OFFSET CON_1        ;
	MOV     EBX,OFFSET TEMP_Z       ;
	MOV     EDI,EBX                 ;
	CALL    SUB_MATH1               ;

	MOV     EDX,OFFSET TEMP_Z       ;
	MOV     EBX,EDX                 ;
	MOV     EDI,OFFSET TEMP_Y1      ;
	CALL    MUL_MATH1               ;CALL MUL FUNCTION
	MOV     ESI,OFFSET COE_LGT      ;
	MOV     ECX,15                  ;
	MOV     EDI,OFFSET TEMP_Y1      ;
	MOV     EBX,EDI                 ;
	CALL    PLYEV                   ;EVAL POLYNOMIAL WITH CORR COE TAB PTR
	MOV     EDI,OFFSET TEMP_Y       ;
	MOV     EBX,OFFSET TEMP_Z       ;
	MOV     EDX,OFFSET TEMP_Y1      ;
	CALL    MUL_MATH1               ;CALL MUL FUNCTION
	MOV     AL,0
	RET

;******************************************************************
;MATHLOG - Find the natural logorithm (base e) of X
;       Input:  EDX pt to value of X
;       Ouput:  X is replace by logorithm of X
;       possible error : X = 0,  ERROR 67 ( LOG(X) = 9.999999999 E99)
;                        X < 0,  ERROR 68 ( LOG(X) = LOG(ABS(X))
;
MATHLOG:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     PRE_FLG,-1
	MOV     EBX,EDX                 ;
	MOV     EDI,EDX                 ;
LOG_MATH1:
	MOV     TEMP_PTR,EDI            ;RESULT PTR
	CALL    MLGT_3                  ;ROUTINE TO PROCESS LGT
	JB      MLOG_1                  ;RETURN FLAG

	MOV     EBX,OFFSET TEMP_Z1      ;
	MOV     EDX,OFFSET LN_10        ;
	MOV     EDI,OFFSET TEMP_Z2
	CALL    MUL_MATH1               ;
	MOV     ESI,OFFSET TEMP_Y       ;
	MOV     EBX,OFFSET TEMP_Z2
	MOV     EDI,TEMP_PTR
	CALL    ADD_MATH1               ;
MLOG_1:
	CMP     ESC_FLAG1,-1            ;
	JE      MLOG_2
	MOV     PRE_FLG,0
	MOV     ESI,TEMP_PTR
	CALL    MANREG
	MOV     ESC_FLAG,0              ;
	POPREGS                         ;
MLOG_2:
	RET

;******************************************************************
;MATHX2Y - Raise X to the Y power
;       Input:  EDX pt to value of Y, EDX+8 pt to value X
;       Ouput:  X is replace by logorithm of X
;
;       possible error : IF Y = 0 - IF X =  0 THEN ERROR 63, R = 0
;                                   IF X <> 0 THEN R = 1.0000
;                        IF X = 0 - IF Y < 0  THEN ERROR 64, R = 9.9999...E99
;                                   IF Y > 0  THEN R = 0
;                        IF Y = NONZERO INTEGER -
;

MATHX2Y:
	MOV     R0,0                    ;
	ADD     EDX,8                   ;
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     PRE_FLG,-1
	MOV     ESI,EDX                 ;
	SUB     ESI,8                   ;ESI - PTR OF Y

	PUSH    EDX                     ;SAVE RESULT PTR

	MOV     TEMP_PTR,EDX            ;TEMP_PTR =  X PTR
	MOV     TEMP_PTR1,ESI           ;TEMP_PTR1 = Y PTR
	MOV     EAX,DWORD PTR [EDX+2]   ;GET M1,M2_X
	OR      EAX,EAX                 ;M1,M2_X = 0 ?
	JNZ     MXY_1
	OR      AX,WORD PTR [EDX+6]     ;M3_X = 0 ?
	JNZ     MXY_1
	JMP     MXY_B
MXY_1:
	XOR     ECX,ECX                 ;
	MOV     AX,WORD PTR [ESI]       ;GET EXP_Y
	MOV     CX,WORD PTR [ESI+6]     ;M3_Y
	MOV     EBX,DWORD PTR [ESI+2]   ;M1,M2_Y
	OR      AX,AX                   ;
	JZ      MXY_3                   ;BR, IF EXP_Y = 0
	OR      EBX,EBX                 ;
	JNZ     MXY_11                  ;BR, IF M1,M2_Y <> 0
	OR      ECX,ECX                 ;
	JZ      MXY_3                   ;BR, IF MANTISSA_Y = 0
MXY_11:
	MOV     ESI,TEMP_PTR1           ;GET Y PTR
	MOV     EDI,OFFSET TEMP_Z2      ;
	CALL    MREG                    ;REGRESSION
	MOV     ESI,OFFSET TEMP_Z2      ;COMPARE Y AND REG(Y)
	MOV     EDI,TEMP_PTR1           ;
	CALL    PCMP                    ;

	CMP     AL,2                    ;Y = INTEGER ?
	JNE     MXY_E                   ;BR, IF NOT

MXY_2:
	XOR     ECX,ECX
	MOV     CX,WORD PTR [TEMP_Z2+6]
	MOV     EBX,DWORD PTR [TEMP_Z2+2]

	MOV     AX,TEMP_Z2              ;AX = EXP
	OR      AX,AX                   ;= 0 ?
	JZ      MXY_3                   ;BR, YES

	CALL    ALIGN_0

	MOV     CX,AX
	MOV     EBX,EBX
MXY_3:
	MOV     TEMP_Z2,CX              ;
	OR      CX,CX                   ;NEEDS COMPLEMENT ?
	JNS     MXY_4                   ;BR, NO
	NOT     CX
	NEG     EBX
	JNZ     MXY_4
	INC     CX

MXY_4:

	MOV     DWORD PTR TEMP_Z2+2,EBX
	MOV     WORD PTR TEMP_Z2+6,CX

	MOV     ESI,OFFSET ARG_1        ;GET VALUE 1
	MOV     EDI,OFFSET TEMP_Z       ;SET RESULT BUFFER PTR
	MOVSD
	MOVSD

	MOV     ESI,TEMP_PTR            ;GET X PTR
	MOV     EDI,OFFSET TEMP_Z1      ;WORK BUFFER PTR
	MOVSD
	MOVSD
MXY_5:
	SHR     WORD PTR TEMP_Z2+6,1    ;CHECK BIT BY BIT
	RCR     DWORD PTR TEMP_Z2+2,1   ;
	JNB     MXY_6                   ;BR, IF BIT IS ZERO

	MOV     EBX,OFFSET TEMP_Z1      ;DO THE MULTIPLICATION OF X
	MOV     EDX,OFFSET TEMP_Z       ;
	MOV     EDI,EDX                 ;
	CALL    MUL_MATH1               ;
MXY_6:
	MOV     EAX,DWORD PTR TEMP_Z2+2 ;CHK Y = 0 ?
	OR      EAX,EAX                 ;
	JNZ     MXY_61                  ;
	OR      AX,WORD PTR TEMP_Z2+6   ;
	JZ      MXY_7                   ;

MXY_61:
	MOV     EBX,OFFSET TEMP_Z1      ;MULTIPLY CURRENT BY ITSELF
	MOV     EDX,EBX                 ;(BASED ON THE ALGORITHM CHECKING Y BIT
	MOV     EDI,EBX                 ; BY BIT FROM LEFT TO RIGHT!)
	CALL    MUL_MATH1               ;
	JMP     MXY_5
MXY_7:
	MOV     AX,TEMP_Z2              ;GET SIGN
	OR      AX,AX                   ;
	JNS     MXY_9                   ;BR, IF POSITIVE
	MOV     EBX,OFFSET ARG_1        ;
	MOV     EDX,OFFSET TEMP_Z
	POP     EDI                     ;GET RETURN BUFFER PTR
	PUSH    EDI
	CALL    DIV_MATH0               ;
	POP     EDI
MXY_8:
	MOV     PRE_FLG,0
	MOV     ESI,EDI
	CALL    MANREG
	MOV     ESC_FLAG,0              ;
	POPREGS
	RET
MXY_9:
	MOV     ESI,OFFSET TEMP_Z       ;
MXY_A:
	POP     EDI                     ;GET RETURN BUFFER PTR
	PUSH    EDI
	MOVSD                           ;
	MOVSD                           ;
	POP     EDI
	JMP     MXY_8                   ;

;** X = 0 ...
;
MXY_B:
	MOV     ESI,TEMP_PTR1           ;GET Y PTR
	CMP     WORD PTR [ESI+6],0      ;
	JS      MXY_D                   ;BR, IF Y < 0
	JNZ     MXY_C                   ;BR, IF Y > 0
	MOV     EAX,DWORD PTR [ESI+2]   ;
	OR      EAX,EAX                 ;
	JNZ     MXY_C                   ;
	MOV     R0,63H                  ;ERROR 63
MXY_C:
	MOV     ESI,OFFSET ARG_0        ;CONSTANT 0 PTR
	JMP     MXY_A
MXY_D:
	MOV     R0,64H                  ;ERROR 64
	MOV     ESI,OFFSET MAXVALUE      ;MAX VALUE PTR
	JMP     MXY_A

;** X <> 0 AND Y = NON-INTEGER ..
;
MXY_E:
	MOV     EDI,TEMP_PTR            ;GET X PTR
	MOV     CX,WORD PTR [EDI+6]     ;CHECK X < 0 ?
	OR      CX,CX                   ;
	JNS     MXY_F0                  ;BR, IF NOT

	MOV     R0,65H                  ;ERROR 65

	MOV     ESI,TEMP_PTR            ;MAKE RESULT = 10 ** (Y*LGT(|X|))
	MOV     EBX,DWORD PTR [ESI+2]   ;
	MOV     CX,WORD PTR [ESI+6]     ;
	NOT     CX                      ; -> |X|
	NEG     EBX                     ;
	JNZ     MXY_F
	INC     CX
MXY_F:
	MOV     DWORD PTR TEMP_ZZ1+2,EBX;SAVE |X| IN TEMP_ZZ1
	MOV     WORD PTR TEMP_ZZ1+6,CX  ;
	MOV     EDI,TEMP_PTR            ;
	MOV     AX,WORD PTR [EDI]       ;GET EXP_X
	MOV     WORD PTR TEMP_ZZ1,AX    ;
	MOV     EDI,OFFSET TEMP_ZZ1     ;
MXY_F0:
	MOV     ESC_FLAG1,-1            ;
	MOV     EBX,EDI                 ;
	MOV     EDI,OFFSET TEMP_N       ;
	PUSH    DWORD PTR TEMP_PTR1
	CALL    LOG_MATH1               ;
	POP     DWORD PTR TEMP_PTR1
	MOV     EBX,OFFSET TEMP_N       ;
	MOV     EDX,TEMP_PTR1           ;
	MOV     EDI,OFFSET TEMP_N       ;
	CALL    MUL_MATH1               ;Y * LGT(|X|)
	MOV     EBX,OFFSET TEMP_N       ;
	POP     EDI                     ;RESTORE RETURN BUFFER PTR
	MOV     EDX,EDI                 ;
	MOV     EAX,DWORD PTR [EBX]     ;
	STOSD
	MOV     EAX,DWORD PTR [EBX+4]   ;
	STOSD
	CALL    EXP_MATH1               ;
	MOV     ESC_FLAG1,0             ;
	JMP     MXY_8

ALIGN_0:
	PUSH    ECX
	PUSH    EDX
	PUSH    ESI
	PUSH    EDI
	XOR     ECX,ECX                 ;
	MOV     EBX,OFFSET TEMP_Z2
	MOV     CX,WORD PTR [EBX]       ;GET EXPONENT PART
	MOV     EDI,DWORD PTR [EBX+2]   ;GET LOWER DWORD
	MOV     SI,WORD PTR [EBX+6]     ;GET MANTISSA
	MOV     BYTE PTR [POS],0                   ;FLAG MANTISSA > 0
	OR      SI,SI                   ;CHECK SIGN OF MANTISSA
	JNS     SGN_EXP                 ;BR, IF POSITIVE
	MOV     BYTE PTR [POS],-1                  ;FLAG MANTISSA < 0
	NOT     SI                      ;2' COMP
	NEG     EDI                     ;
	JNZ     SGN_EXP                 ;BR, IF NO CARRY IN
	INC     SI                      ;CARRY IN
SGN_EXP:
	OR      CX,CX                   ;CHECK EXP SIGN
	JNS     TIMEBY10                ;MANTISSA * 10 LOOP CX TIME
	NEG     CX                      ;
DIVBY10:
	MOV     EBX,10                  ;PREPARE DIVISOR (10/100/1000/10000)
	DEC     CX                      ;
	JZ      DIV10_0                 ;
	MOV     EBX,100                 ;
	DEC     CX                      ;
	JZ      DIV10_0                 ;
	MOV     EBX,1000                ;
	DEC     CX                      ;
	JZ      DIV10_0                 ;
	MOV     EBX,10000               ;
	DEC     CX                      ;
DIV10_0:
	MOV     EDX,0                   ;
	MOV     EAX,0                   ;
	MOV     AX,SI                   ;START FROM M3
	DIV     BX                      ; M3/10
	MOV     SI,AX                   ;SAVE NEW M3
	MOV     EAX,EDI                 ; M2/10
	DIV     EBX                     ;
	MOV     EDI,EAX                 ;SAVE NEW M2

	OR      CX,CX                   ;MORE DIVIDE TO DO?
	JNZ     DIVBY10                 ;YES
	JMP     ALIGN_SGN               ;

TIMEBY10:
	MOV     DX,SI                   ;DUPLICATE ORI MANTISSA
	MOV     EAX,EDI                 ;
	SHL     EDI,1                   ;MANTISSA * 10
	RCL     SI,1                    ;
	SHL     EDI,1                   ;
	RCL     SI,1                    ;
	ADD     EDI,EAX                 ;
	ADC     SI,DX                   ;
	SHL     EDI,1                   ;
	RCL     SI,1                    ;
	LOOP    TIMEBY10                ;

ALIGN_SGN:
	CMP     BYTE PTR [POS],0                   ;MANTISSA NEED 2'COM ?
	JE      ALGN0_RET               ;NO
	NOT     SI                      ;2' COMP
	NEG     EDI                     ;
	JNZ     ALGN0_RET               ;BR, IF NO CARRY IN
	INC     SI                      ;CARRY IN

ALGN0_RET:

MOVE_RES:
	MOV     AX,SI
	MOV     EBX,EDI

	POP     EDI
	POP     ESI
	POP     EDX
	POP     ECX
	RET

POS     DB      0                       ;FLAG USED BY ALIGN_0, NUMBER POS OR NEG
;****************************************************************************
;
;   .\MATH\SQR.ASM
;
;****************************************************************************
;*******************************************************
;MATHSQR - Find the square root of X
;       Input:  EDX pt to value of X
;       Ouput:  X is replace by square root of X
;
EXTRN   MATHPAGE:BYTE
msqr_0:
;         If X = 0 then square root = 0
	XOR     EAX,EAX
	STOSD
	STOSD
	cmp     esc_flag1,-1            ;calling from higher math routine?
	je      msqr_d
	mov     esc_flag,0
	MOV     PRE_FLG,0
	POPREGS
	RET

MATHSQR:
	MOV     R0,0
	PUSHREGS
	mov     esc_flag,-1
	MOV     PRE_FLG,-1              ;FLAG WE NEED HIGHER PRECISION
sqr_math1:
	MOV     EDI,EDX                 ;EDI PT TO X
	MOV     EBX,EDX                 ;EBX PT TO X
	MOV     TEMP_PTR,EDI            ;SAVE OUTPUT PTR
	MOV     AX,[EDX+6]              ;GET M3_X
	OR      AX,AX                   ;ERROR, IF X < 0
	JS      msqr_b                  ;
msqr_2:
	OR      AX,[EDX+4]              ;BR, IF X <> 0
	OR      AX,[EDX+2]              ;
	JNZ     msqr_3                  ;
	JMP     msqr_0

msqr_3:
	MOV     ESI,EDX                 ;ESI PT TO X (THE GIVEN VALUE)
	MOV     AX,WORD PTR [ESI]       ;GET EXP

	PUSH    AX                      ;save exp

	xor     edx,edx                 ;
	mov     dx,[esi+6]              ;get m3_x
	mov     ebx,dword ptr [esi+2]   ;    m1,m2_x

	mov     eexm,0                  ;prepare 96 bits buffer for operation
	mov     edxm,edx                ;
	mov     ebxm,ebx                ;

	mov     ecx,5fh                 ;loop counter  (95 times)
	xor     ebp,ebp                 ;Initial value
	mov     esi,0                   ;EBX:EAX:ESI = Xold
	mov     edi,0                   ;EDX:EBP:EDI = Xnew
	mov     eax,0                   ;
	mov     ebx,0                   ;
	mov     edx,0                   ;

sqr_loop:

	shl     ebxm,1                  ;
	rcl     edxm,1                  ;
	rcl     eexm,1                  ;
	rcl     edi,1                   ;
	rcl     ebp,1                   ;
	rcl     ebx,1                   ;
					;
	shl     ebxm,1                  ;
	rcl     edxm,1                  ;
	rcl     eexm,1                  ;
	rcl     edi,1                   ;
	rcl     ebp,1                   ;
	rcl     ebx,1                   ;
					;
	stc                             ;
	rcl     esi,1                   ;
	rcl     eax,1                   ;
	rcl     edx,1                   ;
					;
	sub     edi,esi                 ;
	sbb     ebp,eax                 ;
	sbb     ebx,edx                 ;
					;
	jnc     sqr_100                 ;
					;
	add     edi,esi                 ;
	adc     ebp,eax                 ;
	adc     ebx,edx                 ;
					;
	dec     esi                     ;
					;
	dec     ecx                     ;
	jnz     sqr_loop

sqr_200:


	mov     ebx,offset mathpage+8   ;only the integer part been process
	mov     word ptr [ebx],0        ;exp should be 0

	mov     edi,1                   ;scaling factor
	xor     ebp,ebp                 ;

sqr_122:
	bsr     ecx,edx                 ;make sure we has enough precision
	cmp     ecx,0EH                 ;check where the first bit in proper pos?
	je      sqr_123                 ;br, if yes
	shl     edi,1                   ;shift scaling factor
	shl     esi,1                   ;shift result into proper position
	rcl     eax,1                   ;
	rcl     edx,1                   ;
	jmp     sqr_122                 ;again

sqr_100:
	inc     esi                     ;
	dec     ecx                     ;
	jnz     sqr_loop                ;
	jmp     sqr_200                 ;

sqr_123:
	mov     word ptr [ebx+6],dx     ;put the result into temp buffer
	mov     dword ptr [ebx+2],eax   ;

	mov     word ptr con_8f+2,0     ;save scaling factor
	mov     dword ptr con_8f+4,edi  ;

	POP     AX                      ;RESTORE EXP
	OR      AX,AX                   ;
	JZ      msqr_a                  ;BR, IF EXP = 0
	JS      msqr_8                  ;BR, IF EXP < 0

	MOV     EBX,OFFSET ODD_COE      ;54BC5DC0C21C
	MOV     CX,0FFF3H               ;
	TEST    AX,1                    ;CHECK IF ODD NUMBER
	JNZ     msqr_4                  ;BR, IF YES
	MOV     EBX,OFFSET EVEN_COE     ;00A0724E1809
msqr_4:
	SHR     AX,1                    ;
	ADD     AX,CX                   ;
	MOV     WORD PTR [EBX],AX       ;
msqr_5:
	MOV     EDX,OFFSET MATHPAGE+8
	MOV     EDI,offset mathpage
	CALL    MUL_MATH1

	MOV     EBX,offset mathpage     ;XNEW
	MOV     EDX,OFFSET CON_8F       ;scaling factor
	MOV     EDI,temp_ptr            ;RESULT BUFFER
	CALL    DIV_MATH0               ;
msqr_6:
	cmp     esc_flag1,-1            ;calling from higher order math routine?
	je      msqr_7                  ;br, yes

	MOV     PRE_FLG,0               ;
	MOV     ESI,TEMP_PTR            ;
	CALL    MANREG                  ;
	mov     esc_flag,0              ;
	POPREGS
	RET
msqr_7:
	ret

msqr_8:
	MOV     EDI,OFFSET ODD_COE      ;54BC5DC0C21C
	TEST    AX,1                    ;CHECK IF ODD NUMBER
	JNZ     msqr_9                  ;BR, IF YES
	MOV     EDI,OFFSET EVEN_MCOE    ;010000000000
msqr_9:
	NEG     AX                      ;
	MOV     EBX,OFFSET EXP_T        ;
	XLAT
	MOV     AH,0FFH                 ;
	MOV     EBX,EDI                 ;
	MOV     WORD PTR [EBX],AX       ;
	JMP     msqr_5                  ;

msqr_a:
	MOV     EBX,OFFSET MATHPAGE+8   ;XNEW
	MOV     EDX,OFFSET CON_8F       ;4294967295
	MOV     EDI,TEMP_PTR            ;RESULT BUFFER
	CALL    DIV_MATH0               ;XNEW = N/XOLD
	JMP     msqr_6
	MOV     EDI,TEMP_PTR
	MOVSD
	MOVSD
	JMP     msqr_6

;         If parameter < 0 then report error-66 !
msqr_b:
	PUSH    EDI             ;SAVE A BIT
	PUSH    EBX
	ADD     EDX,2           ;SKIP EXP PORTION
	MOV     EDI,EDX         ;EDI PT TO ?????????DR TO OPERATE
	MOV     ESI,EDX         ;EBX PT TO SOURCE VALUE

	LODSW                   ;GET M1
	NOT     AX              ;COMPLEMENT
	INC     AX              ;
	STOSW                   ;SAVE IN BUFFER
	LODSW                   ;GET M2
	NOT     AX              ;
	ADC     AX,0            ;
	STOSW                   ;
	LODSW                   ;GET M3
	NOT     AX              ;
	ADC     AX,0            ;
	STOSW                   ;
	JNO     msqr_c          ;IF VALUE STILL WITHIN THE LIMITS
	SUB     EDI,8           ;PT TO THE BEG OF VALUE
	CALL    MANADJ          ;NORMALIZATION ROUTINE
msqr_c:
	MOV     R0,66H
	POP     EBX
	POP     EDI
	JMP     msqr_2

msqr_d:
	ret

;****************************************************************************
;
;   .\MATH\EXP.ASM
;
;****************************************************************************

;**********************************************************************
;MATHMAX -- Finds the max. value of X or Y
;       Input :         EDX + 8 - X ptr
;                       EDX     - Y ptr
;
MATHMAX:
	ADD     EDX,8                   ;EDX PT TO X
	PUSHREGS
	MOV     ESI,EDX                 ;ESI PT TO X
	SUB     EDX,8                   ;
	MOV     EDI,EDX                 ;EDI PT TO Y
	PUSH    EDX                     ;
	CALL    PCMP                    ;COMPARE X AND Y
	POP     EDX                     ;
	TEST    AL,1                    ;X < Y ?
	JNZ     MAX_Y                   ;
MAX_RET:
	POPREGS
	RET
MAX_Y:
	MOV     ESI,EDX                 ;PT TO Y
	ADD     EDX,8                   ;PT TO X
	MOV     EDI,EDX                 ;
	MOVSD
	MOVSD
	JMP     MAX_RET

;**********************************************************************
;MATHMIN -- Finds the min. value of X or Y
;       Input :         EDX + 8 - X ptr
;                       EDX     - Y ptr
;
MATHMIN:
	ADD     EDX,8                   ;EDX PT TO X
	PUSHREGS
	MOV     ESI,EDX                 ;ESI PT TO X
	SUB     EDX,8                   ;
	MOV     EDI,EDX                 ;EDI PT TO Y
	PUSH    EDX                     ;
	CALL    PCMP                    ;COMPARE X AND Y
	POP     EDX                     ;
	TEST    AL,4                    ;X > Y ?
	JNZ     MIN_Y                   ;BR, IF YES
MIN_RET:
	POPREGS
	RET
MIN_Y:
	MOV     ESI,EDX                 ;PT TO Y
	ADD     EDX,8                   ;PT TO X
	MOV     EDI,EDX                 ;
	MOVSD
	MOVSD
	JMP     MIN_RET

;**********************************************************************
;MATHEXP -- RAISES e TO THE POWER X, I.E. FIND THE NATUAL ANTILOG OF X
;               e**X = 10 ** (X* LGT e)
;
MATHEXP:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
EXP_MATH1:

	MOV     RS_PTR,EDX              ;SAVE RESULT BUFFER PTR
	MOV     EBX,EDX                 ;SET UP FOR MATHMUL
	MOV     EDX,OFFSET LGT_E        ;
	MOV     EDI,OFFSET TEMP_Z       ;
	CALL    MUL_MATH1               ;TEMP_Z = X * LGT e
	MOV     ESI,OFFSET TEMP_Z       ;
	MOV     EDI,ESI
	CALL    MREG                    ;TAKE INTEGER PART OF TEMP_Z

	MOV     AX,TEMP_Z               ;GET EXPONENT
	OR      AX,AX                   ;
	JNZ     MEXP_1                  ;

	MOV     AX,TEMP_Z+6             ;GET M3
	OR      AX,AX                   ;
	JS      MEXP_10                 ;BR, IF NEG
	CMP     DWORD PTR TEMP_Z+4,0    ;MAKE SURE ONE WORD VALUE
	JNE     MEXP_1                  ;BR, IF NOT
MEXP_3:
	MOV     EBX,OFFSET TEMP_Z       ;SET UP FOR MATHMUL
	MOV     EDX,OFFSET LN_10        ;CONSTANT LN10 = 2.3025850929941
	MOV     EDI,OFFSET TEMP_Z1      ;
	CALL    MUL_MATH1               ;

	MOV     ESI,RS_PTR              ;GET X PTR
	MOV     EBX,OFFSET TEMP_Z1      ;
	MOV     EDI,EBX                 ;
	CALL    SUB_MATH1               ;

;!      MOV     EDX,OFFSET COE_EXP      ;COEFICIENTS OF EXP
	MOV     EBX,OFFSET TEMP_Z1      ;
	MOV     EDI,RS_PTR              ;
	MOV     ESI,OFFSET COE_EXP      ;
	MOV     ECX,24                  ;
	CALL    PLYEV                   ;EVALUATE POLYNOMIAL
	MOV     AX,TEMP_Z+2             ;
	MOV     EDI,RS_PTR              ;
	ADD     WORD PTR [EDI],AX       ;
	JNO     MEXP_4
	CALL    MADJ
MEXP_4:
	CMP     ESC_FLAG1,-1            ;
	JE      MEXP_5                  ;

	MOV     ESC_FLAG,0
	POPREGS
MEXP_5:
	RET

MEXP_10:
	CMP     DWORD PTR TEMP_Z+4,-1   ;MAKE SURE ONE WORD VALUE
	JE      MEXP_3                  ;BR, IF NOT

MEXP_1:
	MOV     AX,TEMP_Z+6             ;CHECK SIGN
	OR      AX,AX                   ;
	JS      MEXP_2                  ;

public  qqq2
qqq2:
; ERROR PROCESSING ....
	MOV     R0,61H                  ;OVERFLOW
	MOV     ESI,OFFSET MAXVALUE     ;GET VALUE PTR OF 9.999999999999E99
	MOV     EDI,RS_PTR              ;RETURN VALUE ADDRESS
	MOVSD
	MOVSD
	JMP     MEXP_4                  ;EXIT
MEXP_2:
	MOV     R0,60H                  ;UNDERFLOW
	MOV     ESI,OFFSET MAXNVALUE    ;GET VALUE PTR OF -9.999999999999E99
	MOV     EDI,RS_PTR              ;RETURN VALUE ADDRESS
	MOVSD
	MOVSD
	JMP     MEXP_4                  ;EXIT
;****************************************************************************
;
;   .\MATH\SIN.ASM
;
;****************************************************************************
;------------------------------------------------------
;Routine for evaluate N1*X^m+N2*X^(m-1)+N3*X^(m-2)......
;
;       Upon entry: ESI pt to table of coeficients
;                   ECX has # of coeficient in table
;                   EBX pt to the value X
;                   EDI pt to the result parameter
;
PLYEV:
	PUSH    EDI                     ;SAVE RETURN ADDRESS
	MOV     EDX,ESI                 ;EDX - TABLE PTR
	MOV     EAX,DWORD PTR [ESI]     ;GET 1ST ENTRY IN TABLE
	MOV     DWORD PTR TEMP_X1,EAX   ;
	MOV     EAX,DWORD PTR [ESI+4]   ;GET 1ST ENTRY IN TABLE
	MOV     DWORD PTR TEMP_X1+4,EAX ;
PLYEV_1:
	PUSH    ECX                     ;SAVE COUNT
	PUSH    EBX                     ;SAVE X PTR
	PUSH    EDX                     ;SAVE CURRENT TABLE PTR
	MOV     EDI,OFFSET TEMP_X1      ;TEMPORY BUFFER
	MOV     EDX,EDI                 ;
	CALL    MUL_MATH1               ;X * COEFICIENT
	POP     EDX                     ;RESTORE TABLE PTR
	ADD     EDX,8                   ;PT TO NEXT ENTRY OF TABLE
	PUSH    EDX                     ;
	MOV     ESI,OFFSET TEMP_X1      ;RESULT OF MUL
	MOV     EBX,EDX                 ;TEMPORY BUFFER FOR ADD
	MOV     EDI,ESI                 ;
	CALL    ADD_MATH1               ;
	POP     EDX                     ;RESTORE CURRENT TABLE PTR
	POP     EBX                     ;RESTORE X PTR
	POP     ECX                     ;RESTORE COUNT
	LOOP    PLYEV_1                 ;LOOP AGAIN
	POP     EDI                     ;RESTORE RETURN LOC
	MOV     ESI,OFFSET TEMP_X1      ;
	MOVSD                           ;
	MOVSD                           ;
	RET                             ;

MPLY:
	PUSH    EDI                     ;
	PUSH    EBX                     ;
	MOV     EDX,EBX                 ;
	MOV     EDI,OFFSET TEMP_Y1      ;
	CALL    MUL_MATH1               ;CALL MUL FUNCTION
	MOV     EBX,OFFSET TEMP_Y1      ;
	MOV     ESI,OFFSET SIN_CO       ;
	MOV     ECX,10
	MOV     EDI,EBX                 ;
	CALL    PLYEV                   ;EVAL POLYNOMIAL WITH CORR COE TAB PTR
	MOV     EDX,OFFSET TEMP_Y1      ;
	POP     EBX                     ;
	POP     EDI                     ;
	PUSH    EDI
	CALL    MUL_MATH1               ;CALL MUL FUNCTION
	POP     ESI
	CMP     ESC_FLAG1,-1            ;
	JE      MSIN_A                  ;
	MOV     ESC_FLAG,0
	MOV     PRE_FLG,0
	CALL    MANREG
	POPREGS
	RET

;****************************************************************
;MATHTAN - Find the tangent of value x
;
MATHTAN:
	MOV     R0,0
	MOV     PRE_FLG,-1
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     ESC_FLAG1,-1
	PUSH    EDX                     ;SAVE X PTR
	MOV     ESI,EDX                 ;X PTR
	MOV     EDI,OFFSET TEMP_Z2      ;
	MOVSD
	MOVSD
	MOV     EDX,OFFSET TEMP_Z2      ;
	CALL    SIN_MATH1
	POP     ESI                     ;GET X PTR
	PUSH    ESI                     ;
	MOV     EDI,OFFSET TEMP_N       ;
	MOVSD
	MOVSD
	MOV     EDX,OFFSET TEMP_N       ;
	CALL    COS_MATH1               ;
	MOV     EDX,OFFSET TEMP_N       ;GET COS(X)
	MOV     EBX,OFFSET TEMP_Z2      ;    SIN(X)
	POP     EDI                     ;RETURN BUFFER PTR
	MOV     EAX,DWORD PTR [EDX+2]   ;
	OR      EAX,EAX                 ;
	JZ      MTAN_1                  ;BR, COULD BE ZERO,
MTAN_0:
	PUSH    EDI
	CALL    DIV_MATH0
	POP     ESI
	MOV     ESC_FLAG1,0             ;
	MOV     ESC_FLAG,0              ;
	MOV     PRE_FLG,0
	CALL    MANREG
	POPREGS
	RET
MTAN_1:
	OR      AX,WORD PTR [EDX+6]     ;MAKE SURE ZERO
	JNZ     MTAN_0                  ;BR, IF NOT
	MOV     ESI,OFFSET MAXVALUE     ;GET MAX VALUE
;doesn't make sense!
;       MOV     AX,WORD PTR [EBX+6]     ;GET SIN(X) SIGN
;       OR      AX,AX                   ;
;       JNS     MTAN_2                  ;BR, IF POS
;       MOV     ESI,OFFSET MAXNVALUE    ;GET NEG MAX VALUE
MTAN_2:
	CLD
	MOVSD
	MOVSD
	MOV     R0,62H                  ;ERROR CODE
	MOV     ESC_FLAG1,0             ;
	MOV     ESC_FLAG,0              ;
	MOV     PRE_FLG,0
	POPREGS
	RET


;****************************************************************
;MATHSIN - Find the sine of value x
;
MATHSIN:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     PRE_FLG,-1

SIN_MATH1:

	MOV     AL,0                    ;FLAG SOMETHING
	JMP     MSIN_1                  ;

;****************************************************************
;MATHCOS - Find the cosine of value x
;
MATHCOS:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
	MOV     PRE_FLG,-1
COS_MATH1:
	MOV     AL,1                    ;
MSIN_1:
	PUSH    EAX                     ;SAVE OPERATION FLAG
	MOV     TEMP_PTR,EDX            ;SAVE RESULT BUFR PTR
	MOV     EDI,EDX                 ;
	MOV     EBX,EDX                 ;
	CALL    TMOD                    ;CONVERT X TO QUADS

;4/24/89 could be a bug here!
;       MOV     MANREG_F,0              ;RESET MANREG FLAG
;
	MOV     ESI,OFFSET TEMP_X       ;
	MOV     EDI,OFFSET TEMP_Y       ;
	CALL    MREG                    ;REGRESSION
	MOV     ESI,OFFSET TEMP_X       ;
	MOV     EBX,OFFSET TEMP_Y       ;
	MOV     EDI,ESI                 ;
	CALL    SUB_MATH1               ;
	POP     EAX                     ;RESTORE OPERATION FLAG
	OR      AL,AL                   ;
	JZ      MSIN_2                  ;BR, IF SIN
	MOV     ESI,OFFSET TEMP_X       ;
	MOV     EBX,OFFSET CON_P25      ;
	MOV     EDI,ESI                 ;
	CALL    ADD_MATH1               ;CALL ADD FUNCTION

;3/22/89 ++
MSIN_2:
	MOV     ESI,OFFSET TEMP_X       ;COMPARE X WITH .25
	MOV     EDI,OFFSET CON_P25      ;
	CALL    PCMP                    ;
	CMP     AL,1                    ;BR, IF X < .25
	JE      MSIN_6                  ;
	CMP     AL,2                    ;
	JE      MSIN_7                  ;BR, IF X = .25
MSIN_3:
	MOV     ESI,OFFSET TEMP_X       ;COMPARE X WITH .75
	MOV     EDI,OFFSET CON_P75      ;
	CALL    PCMP                    ;
	CMP     AL,1                    ;x < .75 ?
	JE      MSIN_5                  ;
	CMP     AL,2                    ;X = .75
	JE      MSIN_8                  ;

MSIN_4:
	MOV     ESI,OFFSET TEMP_X       ;
	MOV     EBX,OFFSET CON_M1       ;
	MOV     EDI,ESI                 ;
	CALL    ADD_MATH1               ;CALL ADD FUNCTION
	JMP     MSIN_6                  ;
MSIN_5:
	MOV     ESI,OFFSET CON_P5       ;
	MOV     EBX,OFFSET TEMP_X       ;
	MOV     EDI,EBX                 ;
	CALL    SUB_MATH1               ;CALL SUB FUNCTION
MSIN_6:
	MOV     EBX,OFFSET TEMP_X       ;
	MOV     EDI,TEMP_PTR            ;
	JMP     MPLY                    ;TO EVAL POLYNORMIAL
MSIN_7:
	MOV     ESI,OFFSET CON_1        ;
	JMP     MSIN_9                  ;
MSIN_8:
	MOV     ESI,OFFSET CON_M1       ;
MSIN_9:
	MOV     EDI,TEMP_PTR            ;
	MOVSD                           ;
	MOVSD                           ;
	CMP     ESC_FLAG1,-1            ;
	JE      MSIN_A

	MOV     PRE_FLG,0
	MOV     ESI,TEMP_PTR
	CALL    MANREG                  ;
	MOV     ESC_FLAG,0
	POPREGS
MSIN_A:
	RET

TMOD:
	MOV     EDX,030H                ;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	AND     EDX,MATHMODE            ;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	SHR     EDX,1                   ;
;Could be a bug here !
	MOV     MANREG_F,-1             ;TURN FLAG ON TO HAVE MORE PRECISION
;4/24/89
					;FROM CONVERSION
	ADD     EDX,OFFSET TRI_CONV     ;
	MOV     EDI,OFFSET TEMP_X       ;
	JMP     DIV_MATH0               ;JMP TO DIV_MATH0 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF RES BUFFR
					;WHEN RETURN FROM DIV, DIRECTLY TO THE
					;CALLER


;**********************************************
;For some value regression ......
;
MREG:
	LODSW                           ;
	OR      AX,AX                   ;
	JS      MREG_1                  ;
	STOSW                           ;
	MOVSW                           ;
	MOVSW                           ;
	MOVSW                           ;
	RET
MREG_1:
	MOV     EBX,ESI                 ;
	SUB     EBX,2                   ;
	MOV     AX,1                    ;
	JMP     mint_2                  ;CALL INT FUNCTION
	RET

;**********************************************
;MATHATAN - Find the arctangent of X
;
;The algorithm:
;
;       If |x| >= 1, let x' = 1/x, else , x'=x
;       Let z = (2*x')**2
;       Let f(z) = sum ( cn * z**n) where n=0 to 14
;           arctan(x') = (2*x') * f(z)
;       If x' = 1/x then |arctan(x)| = pi/2 - |arctan(x')|
;       else arctan(x) = arctan(x')
EVEN
MATHATAN:
	MOV     R0,0
	PUSHREGS
	MOV     ESC_FLAG,-1
	mov     esc_flag2,-1
	MOV     PRE_FLG,-1
EVEN
ATAN_MATH:

	PUSH    EDX                     ;SAVE X PTR
	MOV     AX,WORD PTR [EDX+6]     ;CHECK SIGN OF X
	PUSH    EAX                     ;SAVE SIGN
	OR      AX,AX                   ;
	JNS     MATAN_1                 ;BR, IF POSITIVE

;** ABS(X) ..                   IN TEMP_Y1

	NOT     WORD PTR [EDX+6]        ;2' COMPLEMENT
	NOT     WORD PTR [EDX+4]        ;
	NEG     WORD PTR [EDX+2]        ;
	JNZ     MATAN_1                 ;
	INC     WORD PTR [EDX+4]        ;
	JNZ     MATAN_1                 ;
	INC     WORD PTR [EDX+6]        ;

MATAN_1:
	MOV     ESI,EDX                 ;SET UP FOR COMPARE X AND 1
	PUSH    ESI                     ;
	MOV     EDI,OFFSET CON_1        ;
	CALL    PCMP                    ;
	POP     ESI                     ;

	POP     EBX                     ;RESTORE SIGN OF X
	OR      BX,BX                   ;
	JNS     MATAN_2                 ;BR, IF POSITIVE


	NOT     WORD PTR [ESI+6]        ;2' COMPLEMENT
	NOT     WORD PTR [ESI+4]        ;
	NEG     WORD PTR [ESI+2]        ;
	JNZ     MATAN_2                 ;
	INC     WORD PTR [ESI+4]        ;
	JNZ     MATAN_2                 ;
	INC     WORD PTR [ESI+6]        ;
MATAN_2:
	PUSH    EAX                     ;SAVE COMPARE RESULT
	TEST    AL,1                    ;X < 1 ?
	JNZ     MATAN_3                 ;BR, IF X < 1

;** X'= 1/X .....

	MOV     EBX,OFFSET CON_1        ;SET UP CALLING PARAMETERS
	MOV     EDX,ESI                 ;
	MOV     EDI,OFFSET TEMP_Y       ;TEMP_Y CONTAINS X'
	push    edi
	CALL    DIV_MATH0               ;
	pop     esi

;** NOW X' PT BY ESI ....       IN TEMP_X

MATAN_3:
	MOV     EDI,OFFSET TEMP_X       ;PUT X' INTO TEMP_X
	MOVSD                           ;
	MOVSD                           ;

;** ( 2 * X' ) ......           IN TEMP_Y

	MOV     EBX,OFFSET TEMP_X       ;SET UP FOR CALLING MUL
	MOV     EDX,OFFSET CON_2        ;
	MOV     EDI,OFFSET TEMP_Y       ;
	CALL    MUL_MATH1               ;

;** Z = ( 2 * X' ) ** 2 ...         IN TEMP_X1

	MOV     EBX,OFFSET TEMP_Y       ;
	mov     esi,ebx
	mov     edi,offset temp_y2
	movsd
	movsd
	mov     edx,offset temp_y2

	MOV     EDI,OFFSET TEMP_X1      ;
	CALL    MUL_MATH1               ;

;** EVALUATE F(Z) = SUM ( Cn * ( Z**n ) ..  IN TEMP_Y1
;                                              TEMP_X1 -- CURRNET POWER OF Z
;                                              TEMP_X2 -- TEMPORY STORAGE
;                                              TEMP_Y2 -- VALUE OF Z

	MOV     ESI,OFFSET TEMP_X1      ;VALUE OF Z
	MOV     EDI,OFFSET TEMP_Y2      ;
	MOVSD
	MOVSD

	MOV     ESI,OFFSET COE_ATAN     ;C0
	MOV     EDI,OFFSET TEMP_Y1      ;
	MOVSD
	MOVSD
	MOV     EBX,ESI                 ;EBX PT TO CURRENT COEFFICIENT
MATAN_4:
	PUSH    EBX                     ;SAVE COE LIST PTR
	MOV     EDX,OFFSET TEMP_X1      ;EDX PT TO CURRENT Z
	MOV     EDI,OFFSET TEMP_X2      ;TEMP BUFFER
	CALL    MUL_MATH1               ;

	MOV     EBX,OFFSET TEMP_Y1      ;
	MOV     EDI,EBX                 ;
	MOV     ESI,OFFSET TEMP_X2      ;
	CALL    ADD_MATH1               ;ADD TO LAST ITEM

	MOV     EBX,OFFSET TEMP_Y2      ;ONE MORE POWER
	MOV     EDX,OFFSET TEMP_X1      ;EDX PT TO CURRENT Z
	MOV     EDI,OFFSET TEMP_X1      ;UPDATE CURRENT Z
	CALL    MUL_MATH1               ;
	POP     EBX                     ;
	ADD     EBX,8                   ;PT TO NEXT COE
	CMP     EBX,OFFSET COE_ATAN+8*16;
	JNE     MATAN_4

;** ARCTAN(X') = (2*X') * F(Z)
;   WHERE                        (2*X') IN TEMP_Y
;                                F(Z)   IN TEMP_Y1

	MOV     EBX,OFFSET TEMP_Y1
	MOV     EDX,OFFSET TEMP_Y
	MOV     EDI,OFFSET TEMP_Y1
	CALL    MUL_MATH1
	POP     EAX                     ;RESTORE X|1 COMPARE RESULT
	TEST    AL,1                    ;X < 1 ?
	JNZ     MATAN_9                 ;EXIT
	MOV     EDI,OFFSET TEMP_Y1      ;
	MOV     AX,WORD PTR [EDI+6]     ;GET MSW OF ARCATAN(X')
	OR      AX,AX                   ;
	JS      MATAN_5                 ;BR, IF NEG

;** ARCATAN (X) = PI/2 - ARCATAN(X') ..

	MOV     ESI,OFFSET PI_2         ;
	MOV     EBX,OFFSET TEMP_Y1      ;
	POP     EDI                     ;GET OLD X PTR
	CALL    SUB_MATH1               ;
	SUB     EDI,8                   ;PT BACK TO X PTR
	JMP     MATAN_7                 ;

;** IF ARCATAN(X') IS NEG ..
MATAN_5:
	MOV     ESI,OFFSET PI_2         ;
	MOV     EBX,OFFSET TEMP_Y1      ;
	NOT     WORD PTR [EBX+6]        ;2' COMPLEMENT
	NOT     WORD PTR [EBX+4]        ;
	NEG     WORD PTR [EBX+2]        ;
	JNZ     MATAN_6                 ;
	INC     WORD PTR [EBX+4]        ;
	JNZ     MATAN_6                 ;
	INC     WORD PTR [EBX+6]        ;
MATAN_6:
	POP     EDI                     ;RESTORE OLD X PTR
	PUSH    EDI                     ;
	CALL    SUB_MATH1               ;
	POP     EDI                     ;

	NOT     WORD PTR [EDI+6]        ;2' COMPLEMENT
	NOT     WORD PTR [EDI+4]        ;
	NEG     WORD PTR [EDI+2]        ;
	JNZ     MATAN_7                 ;
	INC     WORD PTR [EDI+4]        ;
	JNZ     MATAN_7                 ;
	INC     WORD PTR [EDI+6]        ;
MATAN_7:
	cmp     esc_flag2,0             ;needs tri_conv now
	je      atan_x0                 ;br, if no

	mov     edx,030H                ;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and     edx,mathmode            ;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr     edx,1                   ;
	jz      atan_x0                 ;if it's radian then return

	push    edi
	mov     ebx,edi                 ;get the result ptr
	add     edx,offset atri_conv-8  ;
	call    mul_math1               ;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop     edi
atan_x0:
	mov     esc_flag2,0             ;reset the flag
	CMP     ESC_FLAG1,-1            ;CALLING FROM OTHER MATH
	JE      MATAN_8                 ;BR, YES
	MOV     ESC_FLAG,0              ;

	MOV     PRE_FLG,0
	POPREGS
MATAN_8:
	RET


MATAN_9:
	POP     EDI
	MOV     ESI,OFFSET TEMP_Y1
	MOVSD
	MOVSD
	SUB     EDI,8                   ;PREPARE FOR ADJUSTMENT
	JMP     MATAN_7

;**********************************************
;MATHASIN - Find the arcsine of X
;
;The algorithm:
;
;       If |x| > 1, error 69 (argument too large)
;       If |x| = 1, arcsin(x) = sgn(x) * pi/2
;       If |x| < 1, arcsin(x) = arctan(x/sqr(1-x*x))
;
EVEN
MATHASIN:
	MOV     ESC_FLAG3,-1            ;
	MOV     PRE_FLG,-1
ASINMATH:
	PUSHREGS
	MOV     R0,0                    ;
	MOV     ESC_FLAG,-1
	MOV     ESC_FLAG1,-1
	PUSH    EDX                     ;SAVE X PTR
	MOV     AX,WORD PTR [EDX+6]     ;CHECK SIGN OF X
	PUSH    EAX                     ;SAVE SIGN
	OR      AX,AX                   ;
	JNS     MASIN_1                 ;BR, IF POSITIVE

;** ABS(X) ..                   IN TEMP_Y1

	NOT     WORD PTR [EDX+6]        ;2' COMPLEMENT
	NOT     WORD PTR [EDX+4]        ;
	NEG     WORD PTR [EDX+2]        ;
	JNZ     MASIN_1                 ;
	INC     WORD PTR [EDX+4]        ;
	JNZ     MASIN_1                 ;
	INC     WORD PTR [EDX+6]        ;

MASIN_1:
	MOV     ESI,EDX                 ;SET UP FOR COMPARE X AND 1
	PUSH    ESI                     ;
	MOV     EDI,OFFSET CON_1        ;
	CALL    PCMP                    ;
	POP     ESI                     ;

	POP     EBX                     ;RESTORE SIGN OF X
	OR      BX,BX                   ;
	JNS     MASIN_2                 ;BR, IF POSITIVE


	NOT     WORD PTR [ESI+6]        ;2' COMPLEMENT
	NOT     WORD PTR [ESI+4]        ;
	NEG     WORD PTR [ESI+2]        ;
	JNZ     MASIN_2                 ;
	INC     WORD PTR [ESI+4]        ;
	JNZ     MASIN_2                 ;
	INC     WORD PTR [ESI+6]        ;
MASIN_2:
	TEST    AL,1                    ;X < 1 ?
	JNZ     MASIN_5                 ;BR, IF X < 1
	TEST    AL,4                    ;X > 1 ?
	JNZ     MASIN_4                 ;BR, IF X > 1 (ERROR 69)

;** |X| = 1 --> ARCSIN(X) = SGN(X) * PI/2 ..
;
	POP     EDI                     ;GET THE PTR OF X
	MOV     ESI,OFFSET PI_2         ;ESI PT TO CONSTANT PI/2
	MOVSD                           ;
	MOVSD                           ;
	SUB     EDI,8                   ;
	OR      BX,BX                   ;X < 0 ?
	JNS     MASIN_3                 ;BR, IF POSITIVE
	NOT     WORD PTR [EDI+6]        ;2' COMPLEMENT
	NOT     WORD PTR [EDI+4]        ;
	NEG     WORD PTR [EDI+2]        ;
	JNZ     MASIN_3                 ;
	INC     WORD PTR [EDI+4]        ;
	JNZ     MASIN_3                 ;
	INC     WORD PTR [EDI+6]        ;
MASIN_3:
	CMP     ESC_FLAG3,-1
	JNE     ASIN_X0                 ;BR, IF NOT FROM BEGINING
	mov     edx,030H                ;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and     edx,mathmode            ;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr     edx,1                   ;
	jz      asin_xx                 ;if it's radian then return

	push    edi
	mov     ebx,edi                 ;get the result ptr
	add     edx,offset atri_conv-8  ;
	call    mul_math1               ;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop     edi
asin_xx:
	MOV     ESC_FLAG3,0             ;RESET
asin_x0:
	MOV     ESC_FLAG,0              ;
	MOV     ESC_FLAG1,0             ;
	MOV     PRE_FLG,0               ;
	POPREGS
	RET

;** |X| > 1 --> ERROR 69 ....
;
MASIN_4:
	POP     EDX                     ;RESTORE X PTR
	MOV     R0,69H                  ;FLAG ERROR
	MOV     DWORD PTR [ESI],0       ;PUT VALUE = 0
	MOV     DWORD PTR [ESI+4],0     ;
	JMP     ASIN_XX                 ;EXIT

;** |X| < 1 --> ARCSIN(X) = ARCTAN(X/SQR(1-X*X)) ..
;
MASIN_5:
	PUSH    ESI                     ;SAVE X PTR
	MOV     EDI,OFFSET TEMP_X       ;
	MOVSD                           ;
	MOVSD                           ;TEMP_X = X
	MOV     EBX,ESI                 ;SET UP FOR MUL_MATH1
	sub     ebx,8                   ;
	MOV     EDX,OFFSET TEMP_X       ;
	MOV     EDI,EDX                 ;
	CALL    MUL_MATH1               ;TEMP_X = X*X
	MOV     ESI,OFFSET CON_1        ;ESI PT TO VALUE 1
	MOV     EBX,OFFSET TEMP_X       ;
	MOV     EDI,EBX                 ;
	CALL    SUB_MATH1               ;TEMP_X = 1 - X*X
	MOV     EDX,OFFSET TEMP_X       ;
	CALL    SQR_MATH1               ;TEMP_X = SQR(1-X*X)
	POP     EBX                     ;RESTORE X PTR
	PUSH    EBX                     ;SAVE X PTR
	MOV     EDX,OFFSET TEMP_X       ;
	MOV     EDI,OFFSET TEMP_Z       ;
	CALL    DIV_MATH0               ;TEMP_Z = X/SQR(1-X*X)
	MOV     EDX,OFFSET TEMP_Z       ;

	CALL    ATAN_MATH               ;TEMP_Z = ARCTAN(X/SQR(1-X*X))

	POP     EDI                     ;RESTORE X PTR
	POP     EDI                     ;RESTORE X PTR
	MOV     ESI,OFFSET TEMP_Z       ;
	MOVSD
	MOVSD

	SUB     EDI,8
	CMP     ESC_FLAG3,-1
	JNE     ASIN_X1                 ;BR, IF NOT FROM BEGINING
	mov     edx,030H                ;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and     edx,mathmode            ;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr     edx,1                   ;
	jz      asin_xx1                ;if it's radian then return
	push    edi
	mov     ebx,edi                 ;get the result ptr
	add     edx,offset atri_conv-8  ;
	call    mul_math1               ;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop     edi
asin_xx1:
	MOV     ESC_FLAG3,0             ;RESET
ASIN_X1:
	MOV     ESC_FLAG,0
	MOV     ESC_FLAG1,0
	MOV     PRE_FLG,0
	POPREGS
	RET

;**********************************************
;MATHACOS - Find the arccosine of X
;
;The algorithm:
;
;       If |x| > 1, error 69 (argument too large)
;       else arccos(x) = pi/2 - arcsin(x), in radians

EVEN
MATHACOS:
	PUSH    EDX                     ;SAVE X PTR
	MOV     ESI,EDX                 ;
	MOV     EDI,OFFSET TEMP_Z1      ;DUPLICATE X
	MOVSD
	MOVSD
	MOV     EDX,OFFSET TEMP_Z1      ;
	CALL    ASINMATH                ;
	POP     EDX                     ;RESTORE X PTR
	CMP     R0,0                    ;BR, IF ERROR
	JNE     MACOS_1                 ;ERROR EXIT
	PUSHREGS
	MOV     ESC_FLAG,-1             ;
	MOV     EBX,OFFSET TEMP_Z1      ;TEMP_Z1 = ARCSIN(X)
	MOV     ESI,OFFSET PI_2         ;PT TO VALUE OF PI_2
	MOV     EDI,EDX                 ;RETURN BUFFER
	CALL    SUB_MATH1               ;ARCCOS(X) =PI/2 - ARCSIN(X)

	mov     edx,030H                ;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and     edx,mathmode            ;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr     edx,1                   ;
	jz      asin_xx1                ;if it's radian then return
	SUB     EDI,8
	push    edi
	mov     ebx,edi                 ;get the result ptr
	add     edx,offset atri_conv-8  ;
	call    mul_math1               ;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop     edi
	MOV     ESC_FLAG,0              ;
	POPREGS
MACOS_1:
	RET
;****************************************************************************
;
;   .\MATH\M1INT.ASM
;
;****************************************************************************
m_flag  dd      0
MATHRNDX:
	PUSHREGS                        ;On entry EDX pt to parameter X
	MOV     AX,WORD PTR [EDX+2]     ;CHECK IF X = 0 ?
	OR      AX,WORD PTR [EDX+4]     ;
	OR      AX,WORD PTR [EDX+6]     ;
	JNZ     mrd_3                   ;BR, IF <> 0
	MOV     EDI,CPBASE              ;GET CURRENT BASE
	LEA     EDI,[EDI].@MTHSEED      ;PT TO PARTITION RANDOM# SEED
	MOV     EAX,52ACFFF3H           ;PUT THE DEFAULT VALUE IN
	STOSD                           ;
	MOV     EAX,0170F30EH           ;
	STOSD                           ;
	MOV     EDI,EDX                 ;GET PTR OF X
	MOV     EAX,52ACFFF3H           ;PUT THE DEFAULT VALUE IN
	STOSD                           ;
	MOV     EAX,0170F30EH           ;
	STOSD                           ;
	XOR     EDX,EDX                     ;GET PARTITION MODE
	MOV     DL,BYTE PTR [PART_]
	ADD     EDX,OFFSET PMODE
	AND     BYTE PTR [EDX],0FFH-PMODER  ;TURN OFF RANDOMIZATION
	POPREGS
	RET
MRD_3:
	mov     dword ptr [m_flag],0
	PUSH    EDX                     ;SAVE X PTR FOR A BIT
	MOV     ESI,CPBASE              ;
	LEA     ESI,[ESI].@MTHSEED      ;GET PTR OF PARTITION RANDOM# SEED
	XOR     EDX,EDX                 ;
	MOV     EAX,DWORD PTR [ESI+2]   ;GET M1, M2
	MOV     EBX,EAX                 ;
;@@     MOV     EBX,DWORD PTR SAVESEED+4
	MOV     DX,WORD PTR [ESI+6]     ;GET M3
	OR      EAX,EDX                 ;LAST RANDOM# = 0 ?
	JZ      mrd_8
	SHL     EDX,16
	MOV     DX,WORD PTR SAVESEED+6  ;
MRD_4:                                  ;EBX = M1, M2 CX = M3 OF LAST SYS MANT
	MUL     EBX                     ;
	XCHG    AH,AL
	MOV     EBX,EAX                 ;
	MOV     EAX,DWORD PTR SAVESEED+2
	XOR     EAX,DWORD PTR [ESI+4]
;;      XCHG    DH,DL                   ;@@
	MUL     EDX                     ;
	ROL     AX,3                    ;
	MOV     DX,AX                   ;
MRD_5:
	CMP     DX,0918H                ;IF OVER MAX VALUE
	JA      MRD_6                   ;
	JB      MRD_53
	CMP     EBX,4E729FFFH
	JBE     MRD_53
MRD_59:
	MOV     EDX,DWORD PTR [ESI+2]   ;
;       MOV     EDX,DWORD PTR timed     ;
	MOV     EAX,EDX                 ;
MRD_6:
	MOV     EBX,DWORD PTR SAVESEED+2
;       MOV     EBX,DWORD PTR timed+2
	MOV     CX,AX
	AND     CX,07H
	INC     CL
	ROL     EAX,CL
	MOV     ECX,EAX
	inc     dword ptr [m_flag]
	cmp     dword ptr [m_flag],2000
	ja      mrd_6x
	JMP     mrd_4
mrd_6x:
	inc     word ptr [esi+6]
	mov     dword ptr [m_flag],0
	jmp     mrd_4

MRD_53:
	MOV     AX,0FFF3H
MRD_7:
	MOV     CX,DX                   ;
	MOV     WORD PTR [ESI+6],CX     ;NEW SEED M3
	MOV     DWORD PTR [ESI+2],EBX   ;NEW SEED M1,M2
	MOV     WORD PTR [ESI],AX       ;
	POP     EDX                     ;RESTORE X PTR
	MOV     WORD PTR [EDX+6],CX     ;NEW SEED M3
	MOV     DWORD PTR [EDX+2],EBX   ;NEW SEED M1,M2
	MOV     WORD PTR [EDX],AX       ;EXP
	POPREGS
	RET
MRD_8:
	MOV     EAX,DWORD PTR [ESI+4]   ;
;       MOV     EAX,dword ptr timed+4
	XOR     EAX,0170F30EH
	MOV     EBX,DWORD PTR SAVESEED+4
;       MOV     EBX,dword ptr timed+4
	XOR     EBX,52AC2B14H
;@@     MOV     DX,word ptr timed+5
	MOV     DX,WORD PTR [ESI+2]
	XOR     DX,3B65H
	JMP     mrd_4

;***********************************************************************
;Following sections are the routine of MATHNRND
;       To calculate next random number and save new seed back.
MATHNRND:

	push    edx
	mov     edx,dword ptr saveseed+2
	xor     ebx,ebx
	mov     bx,word ptr saveseed+6
	mov     eax,ebx
	add     eax,edx
	mov     ecx,edx
	add     edx,edx
	adc     ebx,ebx
	add     edx,edx
	adc     ebx,ebx
	add     edx,ecx
	adc     ebx,eax
	mov     word ptr saveseed+6,bx
	pop     edx
	RET


;MATHINT: Retrun greatest integer which is less then the value.
;
;The routine check numeric value first, to decide whether the value is an
;INTEGER already; if it is then the result is the value itself.  If the value
;is not a INTEGER then take following step to do the function:
;       (1)Change representation into positive if necessary
;       (2)Divide mantissa portion by 10, until exponent = 0
;       (3)Check original value is positive of negative, remainder = 0 or not.
;          If remainder <> 0 then result - 1 if value is negative, result + 1
;          if value if positive.
;
;
MATHINT:
	EVEN
	MOV     AX,WORD PTR [EDX]       ;GET THE EXP OF X
	OR      AX,AX           ;>= 0 ?
	JNS     MINT_1          ;NO NEED FOR INT FUNCTION
	MOV     EDI,EDX         ;EDI PT TO RETURN BUFFER
	MOV     EBX,EDX         ;EBX PT TO SOURCE VALUE
	MOV     AX,1            ;FLAG ENTRY FROM MATHINT
	JMP     MINT            ;PERFORM INT FUNTION
MINT_1:
	RET

MINT:
	PUSHREGS                ;
MINT_2:
	PUSH    EDI             ;EDI PT TO THE RETURN BUFFER
	PUSH    AX              ;
	MOV     ESI,EBX         ;EBX PT TO OPERAND X
	MOV     AX,WORD PTR [ESI]
	MOV     EXP_S,AX        ;SAVE EXP
	MOV     EDX,0           ;
	MOV     DX,WORD PTR [ESI+6]
	MOV     EDI,DWORD PTR [ESI+2]
	PUSH    DX              ;SAVE M3
	OR      DX,DX           ;NEGATIVE?
	JNS     MINT_3          ;NO,

	NOT     DX              ;2'S COMPLEMENT
	NEG     EDI             ;
	JNZ     MINT_3          ;
	INC     DX              ;

MINT_3:
	MOV     ECX,EDI         ;ECX = M1, M2
	MOV     ESI,EDX         ; SI = M3
MINT_39:
	MOV     EBP,-1          ;INIT EXP COUNT
	MOV     BP,EXP_S        ;GET EXP
	CMP     EBP,-9          ;ARE WE OVER DWORD INTEGER BOUND?
	JL      MINT_41         ;BR, IF YES
	NEG     EBP             ;
	SHL     EBP,3           ;
	ADD     EBP,OFFSET CON_2+2
	MOV     EDI,DWORD PTR [EBP]
	MOV     EXP_S,0         ;CLEAR EXP COUNT
MINT_5:
	XOR     EDX,EDX         ;INIT DIVISION BUFFERS
	MOV     AX,SI           ;
	CWDE                    ;
	DIV     EDI             ;
	MOV     ESI,EAX         ;SAVE NEW M3
	MOV     EAX,ECX         ;
	DIV     EDI             ;
	MOV     ECX,EAX         ;SAVE NEW M1, M2

	CMP     EXP_S,0         ;HAVE WE DONE?
	JNE     MINT_39         ;BR, IF NOT

	POP     AX              ;RESTORE ORIGINAL M3
	OR      AX,AX           ;CHK SIGN
	JNS     MINT_8          ;BR, IF POSITIVE
	NOT     SI              ;2'S COMPLEMENT
	NEG     ECX             ;
	JNZ     MINT_6          ;
	INC     SI              ;
;****************************************************************************
;Following sections is used to handle special consideration for routine ROUND
;If restored AX = 0 then means called from ROUND routine, otherwise skip this
;section.
;
MINT_6:
	POP     AX              ;RESTORE OPERATION FLAG
	OR      AX,AX           ;CHK SIGN
	JS      MINT_9          ;BR, IF NEGATIVE
	JNZ     MINT_7          ;BR, IF NOT ZERO
	SHL     EDX,1           ;
	CMP     EDX,EDI         ;
	JB      MINT_9          ;

MINT_7:
	OR      EDX,EDX         ;REMAINDER = 0 ?
	JZ      MINT_9          ;BR, IF 0

	SUB     ECX,1           ;RESULT = RESULT - 1
	SBB     SI,0            ;
	JMP     MINT_9          ;

MINT_8:
	POP     AX              ;RESTORE OPERATION FLAG
	OR      AX,AX           ;
	JNZ     MINT_9          ;
	SHL     EDX,1           ;
	CMP     EDX,EDI         ;
	JB      MINT_9          ;
	INC     ECX             ;
	JNZ     MINT_9          ;
	INC     SI              ;

;******************************
;Store the result value back ..
;
MINT_9:
	POP     EDI             ;GET THE PTR OF RETURN BUFFER
	MOV     WORD PTR [EDI+6],SI
	MOV     DWORD PTR [EDI+2],ECX
	MOV     WORD PTR [EDI],0
	CMP     ESC_FLAG,-1     ;
	JE      MINT_A
	POPREGS
MINT_A:
	RET

MINT_41:
	MOV     EDX,0           ;
	MOV     EAX,EBP         ;GET EXP
	MOV     EDI,9           ;
	DIV     EDI             ;

	OR      EDX,EDX         ;REMAINDER = 0 ?
	JZ      MINT_42         ;BR, IF YES

	ADD     EXP_S,DX        ;UPDATE EXP
	SHL     EDX,3           ;
	ADD     EDX,OFFSET CON_2+2
	MOV     EDI,DWORD PTR [EDX]
	JMP     MINT_5          ;
MINT_42:
	ADD     EXP_S,9         ;
	MOV     EDI,1000000000  ;
	JMP     MINT_5          ;

;MATHFIX: Retrun integer portion of value.
;
;The routine check numeric value first, to decide whether the value is an
;INTEGER already; if it is then the result is the value itself.  If the value
;is not a INTEGER then take following step to do the function:
;       (1)Make use of same processing routine of MATHINT with different flag.
;          The flag disable carry in while negative value is processed for
;          MATHINT.
MATHFIX:
	EVEN
	MOV     AX,WORD PTR [EDX]       ;GET THE EXP OF X
	OR      AX,AX           ;>= 0 ?
	JNS     MFIX_1          ;NO NEED FOR FIX FUNCTION
	MOV     EDI,EDX         ;EDI PT TO RETURN BUFFER
	MOV     EBX,EDX         ;EBX PT TO SOURCE VALUE
	MOV     AX,-1           ;FLAG ENTRY FROM MATHFIX
	JMP     MINT            ;PERFORM INT FUNTION
MFIX_1:
	RET

;MATHABS: Return the absolute value
;
MATHABS:
	EVEN
	mov     r0,0
	MOV     AX,WORD PTR [EDX+6]     ;GET THE M3 OF X
	OR      AX,AX           ;>= 0 ?
	JNS     MABS_2          ;NO NEED TO COMPLEMENT
	PUSHREGS

	MOV     ECX,DWORD PTR [EDX+2]
	NOT     ECX
	ADD     ECX,1
	MOV     DWORD PTR [EDX+2],ECX
	MOV     AX,WORD PTR [EDX+6]
	NOT     AX
	ADC     AX,0
	MOV     WORD PTR [EDX+6],AX
	JNO     MABS_1
	MOV     EDI,EDX
	CALL    MANADJ          ;NORMALIZATION ROUTINE

MABS_1:
	POPREGS
MABS_2:
	RET

;*******************************************************
;MATHMOD: MOD(X/Y)  Finds the remainder of X/Y.
;       Upon entry: EDX - ptr of Y, EDX+8 - ptr of X
;
MATHMOD:

	EVEN
	ADD     EDX,8                   ;WHEN RETURN EDX SHOULD PT TO X
	PUSHREGS
	PUSH    EDX                     ;SAVE PTR OF X
	MOV     ESI,EDX                 ;ESI - PTR OF X
	SUB     EDX,8                   ;PTR TO Y
	MOV     EBX,EDX                 ;EBX - PTR OF Y
	MOV     EAX,DWORD PTR [EBX+2]   ;GET M1,M2_Y
	OR      EAX,EAX                 ; = 0 ?
	JNZ     MMOD_05                 ;BR, IF NOT
	OR      AX,WORD PTR [EBX+6]     ; = 0 ?
	JZ      MMOD_2                  ;BR IF = 0

MMOD_05:
	MOV     AX,WORD PTR [EBX]       ;GET EXP_Y
	CMP     AX,WORD PTR [ESI]       ;IF EXP_X = EXP_Y ?
	JE      MMOD_3                  ;BR, IF YES

	MOV     PTR_A,ESI               ;SAVE X PTR
	MOV     PTR_B,EBX               ;SAVE Y PTR

	MOV     EDX,EBX                 ;PREPARE PARAMTERS FOR DIVIDE
	MOV     EBX,ESI                 ;
	MOV     EDI,OFFSET OPR_S        ;EDI PT TO BUFFER ADDRESS
	CALL    MDIV                    ;CALL MATHDIV
	MOV     EDX,OFFSET OPR_S        ;EDX PT TO RESULT OF (X/Y)
	MOV     AX,WORD PTR [EDX]       ;GET EXP
	OR      AX,AX                   ;BR, IF VALUE IS AN INTEGER
	JNS     MMOD_1                  ;
	MOV     EDI,EDX                 ;PREPARE FOR MATHINT ROUTINE
	MOV     EBX,EDX                 ;
	MOV     AX,0001                 ;
	CALL    MINT                    ;CALL MATHINT
MMOD_1:
	MOV     EBX,OFFSET OPR_S        ;
	MOV     EDX,PTR_B               ;GET PTR TO Y
	MOV     EDI,EBX                 ;EBX PT TO RESULT INT (X/Y)
	CALL    MMUL                    ;CALL MATHMUL
	MOV     ESI,OFFSET OPR_S        ;ESI PT TO RESULT OF Y*INT(X/Y)
	MOV     EDI,OFFSET TEMP_Y
	MOVSD                           ;MOVE TO RESULT INTO OPERAND Y
	MOVSD                           ;
	MOV     EBX,OFFSET TEMP_Y       ;EBX PT TO RESULT OF Y*INT(X/Y)
	MOV     ESI,PTR_A               ;GET PTR TO X
	POP     EDI                     ;RESTORE RETURN BUFFER ADDR
	PUSH    EDI                     ;SAVE

	MOV     EDI,OFFSET MATHAREA     ;WORKING AREA PTR FOR MATHSUB
	PUSH    EDI                     ;

	JMP     msub_2                  ;JMP TO MATHSUB
;

MMOD_2:
	POP     EAX                     ;FOR STACK BALENCE
	POPREGS                         ;
	RET                             ;IF Y=0 THEN MOD(X,0) = X

;----------------------------------------
;CASE : EXP_X = EXP_Y
;       ESI PT TO X, EBX PT TO Y
;
MMOD_3:
	MOV     EXP_S,AX                ;SAVE EXP FOR A WHILE
	MOV     DI,WORD PTR [ESI+6]     ;GET M3_X
	MOV     EBP,DWORD PTR [ESI+2]   ;    M1,M2_X
	MOV     AX,WORD PTR [EBX+6]     ;    M3_Y
	MOV     EDX,DWORD PTR [EBX+2]   ;    M1,M2_Y
	MOV     M3_X,DI                 ;SAVE OLD M3_X
	MOV     M3_SAV,AX               ;     OLD M3_Y
	OR      DI,DI                   ;X < 0 ?
	JNS     MMOD_4                  ;BR, IF NOT
	NOT     DI                      ;
	NEG     EBP                     ;
	JNZ     MMOD_4                  ;
	INC     DI                      ;
MMOD_4:
	OR      AX,AX                   ;Y < 0 ?
	JNS     MMOD_5                  ;BR, IF NOT
	NOT     AX                      ;
	NEG     EDX                     ;
	JNZ     MMOD_5                  ;
	INC     AX
MMOD_5:
	MOV     SI,AX                   ;SAVE Y IN SI_EBX
	MOV     EBX,EDX                 ;

	OR      AX,AX                   ;M3_X = 0
	JNZ     MMOD_6                  ;BR, IF <> 0

	MOV     AX,DI                   ;GET M3_X
	CWDE                            ;
	XOR     EDX,EDX                 ;PREPARE FOR DIVIDE
	DIV     EBX                     ;
	MOV     EAX,EBP                 ;GET M1,M2_X
	DIV     EBX                     ;
	XOR     AX,AX                   ;
MMOD_9:
	OR      EDX,EDX                 ;IF REMAINDER = 0 ?
	JZ      MMOD_D                  ;BR, IF = 0
MMOD_A:
	TEST    M3_X,8000H              ;IF OLD X < 0 ?
	JZ      MMOD_C                  ;BR, IF NOT
	TEST    M3_SAV,8000H            ;IF OLD Y < 0 ?
	JNZ     MMOD_B                  ;BR, IF YES
	SUB     EDX,EBX                 ;
	SBB     AX,SI                   ;
MMOD_B:
	NOT     AX                      ;
	NEG     EDX                     ;
	JNZ     MMOD_D                  ;
	INC     AX                      ;
MMOD_D:
	POP     EDI                     ;RESTORE RESULT PTR
	MOV     WORD PTR [EDI+6],AX     ;
	MOV     DWORD PTR [EDI+2],EDX   ;
	MOV     AX,EXP_S                ;
	MOV     WORD PTR [EDI],AX       ;
	POPREGS
	RET
MMOD_C:
	TEST    M3_SAV,8000H            ;
	JZ      MMOD_D                  ;
	SUB     EDX,EBX                 ;
	SBB     AX,SI                   ;
	JMP     MMOD_D                  ;
MMOD_6:
	XOR     EAX,EAX                 ;INIT TEMP RESULT
	XOR     EDX,EDX                 ;
	MOV     ECX,48                  ;LOOP COUNT
MMOD_7:
	SHL     EBP,1                   ;
	RCL     DI,1                    ;
	RCL     EDX,1                   ;
	RCL     AX,1                    ;
	SUB     EDX,EBX                 ;
	SBB     AX,SI                   ;
	JNB     MMOD_8                  ;
	ADD     EDX,EBX                 ;
	ADC     AX,SI                   ;
MMOD_8:
	LOOP    MMOD_7                  ;
	OR      AX,AX                   ;
	JNZ     MMOD_A                  ;
	OR      EDX,EDX                 ;
	JNZ     MMOD_A                  ;
	JMP     MMOD_D                  ;

;***********************************************************************
;Following sections are the routine of MATHRD
;
;         IF EXP_N <> 0 ...............
MRND_2:
	MOV     PTR_B,EBX               ;SAVE PTR OF N
	JNS     MRND_3                  ;BR, IF EXP_N > 0

	PUSH    EDI                     ;
	MOV     EDI,OFFSET TEMP_Y       ;FIND A WORK AREA FOR INT(N)
	MOV     AX,1                    ;FLAG FOR MATHINT
	CALL    mint                    ;CALL MATHINT
	MOV     EBX,OFFSET TEMP_Y       ;GET INT(N) RESULT OUT
	POP     EDI                     ;
	MOV     AX,[EBX+2]              ;GET M1_N'
	MOV     DX,[EBX+4]              ;    M2
	OR      DX,[EBX+6]              ;EXIT, IF M2,M3 = 0
	JNZ     MRND_6                  ;BR, IF <> 0
	MOV     EBX,PTR_B               ;RESTORE N PTR
	RET

;         IF EXP_N > 0 .............     AX HAS EXP_N
MRND_3:
	CMP     DWORD PTR [EBX+4],0     ;CHK IF M2,M3_N <> 0
	JNE     MRND_7                  ;BR,

	MOV     DX,[EBX+2]              ;GET M1_N (SINCE M2,M3 = 0)
	OR      DX,DX                   ;BR, IF M1 = 0
	JZ      MRND_5                  ;

MRND_4:
	CMP     DX,6554                 ;MAX. VALUE IN A WORD BEFORE (* 10)
	JA      MRND_6                  ;BR, IF ABOVE MAX VALUE
	MOV     BX,DX                   ;M1_N * 10
	SHL     DX,2                    ;
	ADD     DX,BX                   ;
	SHL     DX,1                    ;
	DEC     AX                      ;EXP_N - 1
	JNZ     MRND_4                  ;BR, IF EXP_N <> 0
MRND_5:
	MOV     AX,DX                   ;AX = FINAL M1_N' OR 0
	MOV     EBX,PTR_B               ;RESTORE PTR OF N
	RET

MRND_6:
	MOV     EBX,PTR_B               ;RESTORE PTR OF N
MRND_7:
	MOV     AX,-1                   ;FLAG RESULT = X
	RET

MRND_80:
	TEST    EAX,0FFFF0000H
	JNZ     MRND_B
	OR      CX,CX
	JNZ     MRND_B
	JMP     MRND_81

MATHRD:
	;ON ENTRY EDX PT TO Y, EDX+8 PT TO X
	;
MRND_0:
	PUSHREGS
	MOV     ESI,EDX                 ;ESI - PTR OF N
	ADD     EDX,8                   ;EDX - PTR OF X
	PUSH    EDX                     ;SAVE PTR OF X
	MOV     EDI,OFFSET MATHAREA     ;
	PUSH    EDI                     ;EDI PT TO WORK AREA
	MOV     EBX,EDI                 ;

	MOV     DX,WORD PTR [ESI]       ;DX = EXP_X
	MOVSW                           ;SAVE EXP_X
	MOV     EAX,DWORD PTR [ESI]     ;EAX = M1,2_X
	MOV     CX,WORD PTR [ESI+4]     ;CX = M3_X
	PUSH    CX                      ;SAVE M3_X
	OR      CX,CX                   ;IF NEG?
	JNS     MRND_8                  ;BR, IF POS
	NOT     CX
	NEG     EAX
	JNZ     MRND_8
	INC     CX
MRND_8:
	MOV     DWORD PTR [EDI],EAX
	MOV     WORD PTR [EDI+4],CX
	OR      DX,DX                   ;CHK EXP_X
	JZ      MRND_80                 ;BR, IF ZERO
	CALL    MRND_2                  ;
	CMP     AX,-1                   ;
	JE      MRND_B

MRND_81:
	MOV     DX,AX                   ;DX = N' (N TRANCATES TO AN INTEGER)
	POP     AX                      ;RESTORE M3_N
	POP     EDI                     ;RESTORE WORK AREA PTR
	OR      AX,AX                   ;BR, IF N >= 0
	JNS     MRND_9                  ;
	NEG     DX                      ;COMPLEMENT N'

MRND_9:
	POP     ESI                     ;GET PTR OF X
	PUSH    ESI                     ;
	MOV     EBX,EDI                 ;
	LODSW                           ;GET EXP_X
	ADD     AX,DX                   ;ADD N' TO EXP_X
	STOSW                           ;SAVE BACK
	MOVSW                           ;MOVE MANTISSA
	MOVSW                           ;
	MOVSW                           ;
	MOV     EDI,EBX                 ;
	JGE     MRND_A                  ;BR, IF EXP_X' >= 0  (ALREADY AN INTEGER)

	PUSH    DX                      ;SAVE N'
	MOV     AX,0000                 ;FLAG CALLING FROM ROUND ROUTINE
	CALL    mint                    ;CALL MATHINT
	POP     DX                      ;RESTORE N'
MRND_A:
	SUB     [EDI],DX                ;UPDATE EXP_X'
	MOV     ESI,EDI                 ;
	POP     EDI                     ;RESTORE X PTR
	MOVSD
	MOVSD
	POPREGS
	ADD     EDX,8                   ;PT TO X WHEN RETURN
	RET
MRND_B:
	POP     AX                      ;
	POP     EAX                     ;
	POP     EAX                     ;STACK BALANCE
	POPREGS
	ADD     EDX,8
	RET
;
;***********************************************************************
;Following sections are the routine of MATHRND0
;       To initialize random number seed to .1584625767084
;
MATHRND0:
	PUSH    EDI                     ;
	PUSHF                           ;
	MOV     EDI,OFFSET SAVESEED     ;PT TO SYSTEM RANDOM# SEED
	MOV     EAX,52ACFFF3H           ;PUT THE DEFAULT VALUE IN
	STOSD                           ;
	MOV     EAX,0170F30EH           ;
	STOSD                           ;
	POPF                            ;
	POP     EDI                     ;
	RET


;***************************************************************************
PCMP:   ;This routine to compare two value pt by ESI (A) and EDI (B),
	;when return AL has glag to indicates compare result
	;MODIFIED FOR SPEED UP BY USING REGS AS MUCH AS POSSIBLE 3/22/89
	;EBX-EAX FOR X VALUE, EBP-ECX FRO Y VALUE...

	MOV     EBX,[ESI+4]
	MOV     EAX,[ESI]               ;EXP_X IN AX
	MOV     EBP,[EDI+4]             ;
	MOV     ECX,[EDI]               ;EXP_Y IN CX
	CMP     AX,CX                   ;CMP EXPONENTS
	JNE     PCMP1                   ;NEEDS ALIGNMENT

	AND     EAX,0FFFF0000H          ;MASK OFF EXP_X
	AND     ECX,0FFFF0000H          ;MASK OFF EXP_Y
	SUB     EAX,ECX                 ;
	SBB     EBX,EBP
	JL      PCMPL
	JG      PCMPG
	OR      EAX,EBX                 ;IS X = Y ?
	JZ      PCMPE                   ;BR, YES
	JNZ     PCMPG

PCMP1:
	XOR     EBX,EBP                 ;CHK SIGN OF THESE TWO VALUE
	JNS     PCMP2                   ;BOTH HAVE SAME SIGN
	OR      EBP,EBP                 ;
	JNS     PCMPL                   ;X IS NEGATIVE VALUE
	JMP     PCMPG                   ;Y IS NEGATIVE VALUE
PCMP2:
	MOV     EBX,EDI                 ;
	CALL    MALG                    ;ALIGNMENT
	MOV     EDI,EBX                 ;
	JMP     PCMP                    ;

PCMPL:  MOV     AL,1                    ;A < B
	RET
PCMPG:  MOV     AL,4                    ;A > B
	RET
PCMPE:  MOV     AL,2                    ;A = B
	RET


;MATHSGN: Return the value 1 if the expression is positive, -1 if negative
;         and 0 if zero.
MATHSGN:
	EVEN
	MOV     WORD PTR [EDX],0        ;PUT EXP = 0
	MOV     AX,WORD PTR [EDX+6]     ;GET THE M3 OF X
	OR      AX,AX                   ;NEGATIVE ?
	JS      MSGN_2                  ;PUT VALUE -1
	JNZ     MSGN_1                  ;PUT VALUE 1
	OR      AX,WORD PTR [EDX+4]     ;CHK M2
	JNZ     MSGN_1                  ;
	OR      AX,WORD PTR [EDX+2]     ;CHK M1
	JNZ     MSGN_1                  ;
	MOV     DWORD PTR [EDX+4],0     ;PUT VALUE 0
	MOV     WORD PTR [EDX+2],0      ;
	RET
MSGN_1:
	MOV     DWORD PTR [EDX+4],0     ;
	MOV     WORD PTR [EDX+2],1      ;
	RET
MSGN_2:
	MOV     DWORD PTR [EDX+4],-1    ;
	MOV     WORD PTR [EDX+2],-1     ;
	RET
;****************************************************************************
;
;   .\MATH\ALG.ASM
;
;****************************************************************************
ADDALIGN PROC
even
;ON ENTRY -- EBX PT TO VALUE X,  ESI PT TO VALUE Y
;
;REGISTER USAGE
;
;       AX - EXP_X          DX - EXP_Y
;      EDI - M12_X         EBX - M12_Y
;       SI -  M3_X          BP -  M3_Y
;

MALG:
	MOV     EAX,DWORD PTR [EBX+2]   ;
	OR      EAX,EAX                 ;
	JNZ     MALG_0                  ;
	OR      AX,WORD PTR [EBX+6]     ;
	JNZ     MALG_0                  ;
	MOV     AX,WORD PTR [ESI]       ;
	MOV     WORD PTR [EBX],AX       ;
	RET
MALG_0:
	MOV     EAX,DWORD PTR [ESI+2]   ;
	OR      EAX,EAX                 ;
	JNZ     MALG_4                  ;
	OR      AX,WORD PTR [ESI+6]     ;
	JNZ     MALG_4                  ;
	MOV     AX,WORD PTR [EBX]       ;
	MOV     WORD PTR [ESI],AX       ;
	RET
MALG_4:

	PUSH    EAX                     ;SAVE REGS
	PUSH    ECX
	PUSH    EDX
	PUSH    EDI
	PUSH    EBP


	MOV     PTR_FLP,0               ;INIT FLAG
	XOR     EAX,EAX                 ;
	MOV     EDX,0                   ;
	MOV     ECX,0                   ;
	MOV     EBP,0                   ;
	MOV     AX,[EBX]                ;EXP_X
	MOV     EDI,[EBX+2]             ;M12_X
	MOV     CX,[EBX+6]              ;
	MOV     DX,[ESI]                ;EXP_Y
	MOV     EBX,[ESI+2]             ;M12_Y
	MOV     BP,[ESI+6]              ;M3_Y
	XOR     ESI,ESI
	MOV     SI,CX                   ;M3_X

MALG_5:
	MOV     ECX,EAX                 ;
	SUB     CX,DX                   ;ECX HAS EXPONENT DIFFERENCE
	JNS     MALG_2                  ;

	NEG     CX                      ;MAKE POSITIVE DIFFERENCE
	MOV     PTR_FLP,-1              ;FLAG WE HAD CHANGED

	XCHG    EAX,EDX                 ;SWAP TWO VALUES
	XCHG    EDI,EBX                 ;
	XCHG    ESI,EBP                 ;
MALG_2:

	MOV     WORD PTR [OPR_S],DX     ;SAVE VALUE Y FOR A BIT
	MOV     DWORD PTR [OPR_S+2],EBX ;
	MOV     WORD PTR [OPR_S+6],BP   ;

	MOV     M3_SAV,0                ;INIT FLAG
	OR      SI,SI                   ;CHK SIGN
	JNS     MALG_3                  ;BR, IF POS
	MOV     M3_SAV,-1
	NOT     SI                      ;
	NEG     EDI                     ;
	JNZ     MALG_3                  ;
	INC     SI                      ;
MALG_3:
	CMP     SI,0CCCH                ;OVER THE MAX VALUE?(as big as possible)
;       CMP     SI,0918H                ;OVER THE MAX VALUE?(as big as possible)
	JAE     MALG_6                  ;BR, IF YES

	MOV     BP,SI                   ;VALUE X * 10
	MOV     EBX,EDI                 ;
	SHL     EDI,1                   ;
	RCL     SI, 1                   ;
	SHL     EDI,1                   ;
	RCL     SI, 1                   ;
	ADD     EDI,EBX                 ;
	ADC     SI,BP                   ;
	SHL     EDI,1                   ;
	RCL     SI, 1                   ;
	LOOP    MALG_3                  ;

	MOV     DX,WORD PTR [OPR_S]     ;RESTORE Y VALUE
	MOV     EBX,DWORD PTR [OPR_S+2] ;
	MOV     BP,WORD PTR [OPR_S+6]   ;

					;AT THIS POINT,
	MOV     AX,DX                   ;EXP_X SHOULD EQUAL EXP_Y
	CMP     M3_SAV,-1               ;HAVE WE NEG THE VALUE?
	JNE     MALG_K                  ;BR, IF NO
	MOV     M3_SAV,0                ;RESET
	NOT     SI                      ;
	NEG     EDI                     ;
	JNZ     MALG_K                  ;
	INC     SI                      ;
	JMP     MALG_K                  ;TO THE RETURN PT

MALG_6:

	MOV     DX,WORD PTR [OPR_S]     ;RESTORE Y VALUE
	MOV     EBX,DWORD PTR [OPR_S+2] ;
	MOV     BP,WORD PTR [OPR_S+6]   ;
	MOV     AX,DX                   ;AT THIS POINT NEW EXP_X SHOULD BE
	ADD     AX,CX                   ;EXP_Y + N ( NO. OF * 10)
	CMP     M3_SAV,-1               ;HAVE WE NEG BEFORE?
	JNE     MALG_7                  ;BR, IF NO
	MOV     M3_SAV,0
	NOT     SI                      ;
	NEG     EDI                     ;
	JNZ     MALG_7                  ;
	INC     SI                      ;
MALG_7:
	MOV     WORD PTR [OPR_S],AX     ;SAVE THE ALIGNED X VALUE
	MOV     DWORD PTR [OPR_S+2],EDI ;
	MOV     WORD PTR [OPR_S+6],SI   ;
	CMP     CX,14                   ;CHK IF THE DIFFERENCE IS TOO BIG
	JAE     MALG_1                  ;BR, THAT CAN'T BE HANDLE HERE

	ADD     DX,CX                   ;CAL THE FINAL EXP_Y
	MOV     WORD PTR [OPR_L],DX     ;

	MOV     M3_SAV,0                ;INIT FLAG
	OR      BP,BP                   ;IF THE VALUE Y BE NEG?
	JNS     MALG_9                  ;BR, IF POS
	MOV     M3_SAV,-1               ;
	NOT     BP
	NEG     EBX
	JNZ     MALG_9
	INC     BP
MALG_9:
	AND     ECX,0FFFFH
;       xor     edx,edx
	PUSH    ECX                     ;SAVE THE DIFFERENCE FOR A BIT
	CMP     ECX,7                   ;7 IS THE NO THAT CAN HANDLE IN 32 BIT
	JLE     MALG_A                  ;
	SUB     ECX,7                   ;
MALG_A:
	XOR     EDX,EDX                 ;
	AND     EBP,0FFFFH
	SHL     ECX,3                   ;
	ADD     ECX,OFFSET CON_2        ;CAL THE ADDRESS OF DIVISOR
	MOV     ECX,[ECX+2]             ;
	MOV     EAX,EBP                 ;DIVIDE Y BY (10 * N)
	DIV     ECX                     ;
	MOV     EBP,EAX                 ;
	MOV     EAX,EBX                 ;
	DIV     ECX                     ;
	MOV     EBX,EAX                 ;EBP,EBX HAS THE NEW Y VALUE
	MOV     EAX,ECX                 ;TO KEEP THE DIVISOR
MALG_B:
	POP     ECX                     ;RESTORE THE OLD DIFFERENCE OF EXP
	CMP     ECX,7                   ;
	JBE     MALG_C

	MOV     ECX,7                   ;
	PUSH    ECX                     ;
	JMP     MALG_A                  ;DO IT AGAIN
MALG_C:
	SHR     EDX,1                   ;
	CMP     EDX,EAX                 ;
	JB      MALG_F                  ;
	INC     EBX                     ;
	JNZ     MALG_F                  ;
	INC     EBP
MALG_F:
	CMP     M3_SAV,-1               ;HAVE WE NEG THE VALUE ?
	JNE     MALG_D                  ;BR, IF NO
	MOV     M3_SAV,0
	NOT     BP
	NEG     EBX
	JNZ     MALG_D
	INC     BP
MALG_D:
	MOV     DX,WORD PTR [OPR_L]     ;GET THE EXP_Y

	MOV     AX,WORD PTR [OPR_S]     ;GET THE ALIGNED X VALUE
	MOV     EDI,DWORD PTR [OPR_S+2] ;
	MOV     SI,WORD PTR [OPR_S+6]   ;
MALG_K:
	CMP     PTR_FLP,-1              ;HAVE WE SWAP BEFORE?
	JNE     MALG_E                  ;BR, IF NO
	MOV     PTR_FLP,0               ;RESET
	XCHG    EAX,EDX
	XCHG    EDI,EBX
	XCHG    ESI,EBP

MALG_E:
	MOV     ECX,ESI

	MOV     ESI,OFFSET OPR_S        ;
	MOV     [ESI],DX                ;SAVE THE NEW Y VALUE
	MOV     [ESI+2],EBX             ;
	MOV     [ESI+6],BP              ;

	MOV     EBX,OFFSET OPR_L        ;
	MOV     [EBX],AX                ;SAVE THE NEW X VALUE
	MOV     [EBX+2],EDI             ;
	MOV     [EBX+6],CX              ;
MALG_L:
	POP     EBP
	POP     EDI
	POP     EDX
	POP     ECX
	POP     EAX
	RET

MALG_1:
	ADD     DX,CX                   ;UPDATE EXP_Y
	MOV     EBX,0                   ;M123_Y = 0
	MOV     EBP,0                   ;
	JMP     MALG_K                  ;
ADDALIGN    ENDP

CODE            ENDS
		END
