;===========================================================================
;
;           P A C K  /  U N P A C K  
;
;===========================================================================
;           This module was originally M17
;===========================================================================
	    .XLIST
	    INCLUDE PREAMBLE
	    .LIST

PUBLIC    $PACKFB
PUBLIC    $PACK
PUBLIC    $PACKD
PUBLIC    $PACKF
PUBLIC    $UNPACK
PUBLIC    $UNPAKD
PUBLIC    $UNPAKF
PUBLIC    $UNPAKF3
PUBLIC    $UNPAKF8
PUBLIC    FORMAT
PUBLIC    HEXSTMT
PUBLIC    HEXPACK
PUBLIC    HEXUNPAK
PUBLIC    ERR_17B
PUBLIC    ERR_19Q
PUBLIC    ERR_29F
PUBLIC    ERR_29Q
PUBLIC    ERR_34Q
PUBLIC    ERR_51B
PUBLIC    ERR_51Q
PUBLIC    ERR_74
PUBLIC    ERR_75A
PUBLIC    ERROR_58

EXTRN     ALIGN_0 :NEAR
EXTRN     ADJEXP  :NEAR
EXTRN     ALPHIN  :NEAR
EXTRN     ALPHINL :NEAR
EXTRN     ARECEVAL:NEAR
EXTRN     ARGUMENT:NEAR
EXTRN     ARGUMNTR:NEAR
EXTRN     AVAR    :NEAR
EXTRN     AVARB   :NEAR
EXTRN     AVARD   :NEAR
EXTRN     BINEXP  :NEAR
EXTRN     BNFLTXXX:NEAR
EXTRN     BREAKPTG:NEAR
EXTRN     CCL     :NEAR
EXTRN     CCLFROM :NEAR
EXTRN     CCLTO   :NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ENDSTMTZ:NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_11:NEAR
EXTRN     ERROR_12:NEAR
EXTRN     ERROR_16:NEAR
EXTRN     ERROR_17:NEAR
EXTRN     ERROR_19:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_34:NEAR
EXTRN     ERROR_51:NEAR
EXTRN     ERROR_71:NEAR
EXTRN     ERROR_75:NEAR
EXTRN     ERROR_76:NEAR
EXTRN     FORMATD :NEAR
EXTRN     HEXPRINT:NEAR
EXTRN     INTEGER :NEAR
EXTRN     MATHPAGE:NEAR
EXTRN     MOVEVALF:NEAR
EXTRN     MOVEVALU:NEAR
EXTRN     NEWTOOLD:NEAR
EXTRN     OLDTONEW:NEAR
EXTRN     RCVASCII:NEAR
EXTRN     REM     :NEAR
EXTRN     SCRATCH :NEAR
EXTRN     SNMBR   :NEAR
EXTRN     VVFMT   :NEAR
EXTRN     MATHABS :NEAR
EXTRN     FLTBNL  :NEAR

EXTRN     @@VSEND :DWORD

;------------------------------------------------------------------------------;
;                                                                              ;
;     **********************************                                       ;
;     *                                *                                       ;
;     *     MODULE-17:  STATEMENTS     *                                       ;
;     *                                *                                       ;
;     **********************************                                       ;
;                                                                              ;
;     DESCRIPTION:                                                             ;
;          $PACK       $UNPACK                                                 ;
;          HEXPACK     HEXUNPACK                                               ;
;                                                                              ;
;------------------------------------------------------------------------------;

;     $PACK: PROCESS A '$PACK' STATEMENT
;
;          FORMAT:
;
;               $PACK (D=delim) alpha FROM argument-list
;                     (F=field)
;
;               where: alpha = alpha-variable [<s,n>]
;                              alpha-array [<s,n>]
;
;                      delim,field = alpha
;                                    literal
;
;                      arg-list = variable
;                                 expression
;                                 literal
;
;          ENTRY: TEXTPTR POINTS AFTER '$PACK'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,4
;               IN EXECUTION PHASE, AUX3,C-F
;

$PACK:    CALL      $PACKSUB            ;SCAN & PROCESS FIELD/DELIMITER SPECIFICATION

;      AND BUFFER VARIABLE
;
	  CALL      CCLFROM             ;LOOK FOR 'FROM'
	  TEST      SL,2
	  JNZ       $PACK1              ;BRANCH IF EXECUTION PHASE

;     ENTRY, RESOLUTION PHASE
;

$PACKX:   CALL      ARGUMENT                ;SCAN NEXT ARGUMENT
	  CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE       ENDSTMT                 ;EXIT IF NOT FOUND
	  INC       TEXTPTR
	  JMP       $PACKX                  ;BRANCH IF FOUND

;     EXECUTION PHASE
;

$PACK1:   MOV       EDX,AUX04
	  MOV       AL,DL
	  AND       AL,0FH
	  CMP       AL,0
	  JE        $PACKF                  ;BRANCH IF FIELD FORM OF PACK
	  CMP       AL,1
	  JE        $PACKD                  ;BRANCH IF DELIMITER FORM OF PACK

;     FALL THROUGH TO INTERNAL FORM OF PACK
;

;     FORMAT:  $PACK buffer FROM argument-list
;
;     ENTRY: TEXTPTR POINTS AFTER 'FROM'
;          PHASE = EXECUTION
;          AUXF = ADDRESS OF BUFFER
;          AUXE = LENGTH OF BUFFER
;

$PACKI:   MOV       K,3
	  CALL      BUFCOUNT           ;DECREMENT BUFFER COUNT BY 3
	  MOV       EDX,AUX0F
	  MOV       BYTE PTR [EDX],80H ;PUT X'8001' INTO BUFFER
	  INC       EDX
	  MOV       BYTE PTR [EDX],01H
	  MOV       AUX0F,EDX
	  INC       AUX0F

$PACKI1:  CALL      ARGUMENT           ;SCAN NEXT ARGUMENT
	  MOV       EDX,AUX02
	  MOV       R5,DH              ;F5 = SOV CHARACTER
	  MOV       K,DL               ;K = LENGTH OF ARGUMENT + 1
	  INC       K
$PACKI2:  CALL      BUFCOUNT           ;MAKE SURE ROOM FOR VALUE IN BUFFER
	  MOV       EDX,AUX0F
	  MOV       AL,R5
	  MOV       BYTE PTR [EDX],AL
	  MOV       AUX0F,EDX          ;SOV ==> BUFFER
	  INC       AUX0F
	  TEST      R5,80H             ;CHECK NUMERIC TYPE
	  JNZ       $PACKI3
	  PUSH      AUX03
	  MOV       EDX,AUX03
	  CALL      NEWTOOLD
	  MOV       AUX03,EDX
	  CALL      MOVEVALU           ;VALUE ==> BUFFER
	  POP       AUX03
	  ADD       AUX03,8
	  JMP       $PACKI4
$PACKI3:  CALL      MOVEVALU
$PACKI4:  MOV       EDX,AUX0F
	  MOV       BYTE PTR [EDX],0FDH;X'FD' ==> BUFFER  (END OF RECORD)
	  MOV       EAX,OFFSET $CA
	  CALL      MOREARG            ;CHECK FOR MORE ARGUMENT
	  JMP       $PACKI2            ;BRANCH IF MORE ELEMENTS
$CA:      JMP       $PACKI1            ;BRANCH IF COMMA FOUND (MORE ARGUMENTS)

;     $UNPACK: PROCESS A '$UNPACK' STATEMENT
;
;          FORMAT:
;
;             $UNPACK (D=delim) alpha TO argument-list
;                     (F=field)
;
;               where: alpha = alpha-variable [<s,n>]
;                              alpha-array [<s,n>]
;
;                      delim,field = alpha
;                                    literal
;
;                      arg-list = variable
;
;          ENTRY: TEXTPTR POINTS AFTER '$UNPACK'
;
;          MODIFIED REGISTERS:
;

$UNPACK:  CALL      $PACKSUB            ;SCAN & PROCESS FIELD/DELIMITER SPEC.

;      AND BUFFER VARIABLE
;

	  CALL      CCLTO               ;LOOK FOR 'TO'
	  TEST      SL,2
	  JNZ       $UNPACK1            ;BRANCH IF EXECUTION PHASE

;     ENTRY, RESOLUTION PHASE
;

$UNPAKY:  CALL      ARGUMNTR               ;SCAN NEXT ARGUMENT
	  CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
	  JNE       ENDSTMT                ;EXIT IF NOT FOUND
	  INC       TEXTPTR
	  JMP       $UNPAKY                ;BRANCH IF FOUND

;     EXECUTION PHASE
;

QUNPAKFX: JMP       $UNPAKF
$UNPACK1: MOV       EDX,AUX04
	  MOV       AL,DL
	  AND       AL,0FH
	  CMP       AL,0
	  JE        QUNPAKFX       ;BRANCH IF FIELD FORM OF UNPACK
	  CMP       AL,1
	  JE        $UNPAKD        ;BRANCH IF DELIMITER FORM OF UNPACK

;     FALL THROUGH TO INTERNAL FORM OF UNPACK
;


;     FORMAT:  $UNPACK buffer TO argument-list
;
;     ENTRY: TEXTPTR POINTS AFTER 'TO'
;          AUXF = ADDRESS OF BUFFER
;          AUXE = LENGTH OF BUFFER
;

$UNPAKI:  MOV       EDX,AUX0F
	  MOV       AUX0F,EDX           ;POINT AFTER CONTROL INFO. (8001) IN BUFFER
	  ADD       AUX0F,2
	  MOV       K,2
	  CALL      BUFCOUNT            ;DECREMENT BUFFER COUNT BY 2
$UNPAKI1: CALL      ARGUMNTR            ;SCAN NEXT ARGUMENT
$UNPAKI2: MOV       EDX,AUX0F
	  MOV       CH,BYTE PTR [EDX]
	  MOV       AUX0F,EDX           ;GET SOV CHARACTER
	  INC       AUX0F

	  CMP       CH,0FDH
	  JE        REM                 ;BRANCH IF EOB
	  MOV       EDX,AUX02
	  MOV       R2,DH               ;F2 = RECEIVER LENGTH
	  MOV       R0,DL
	  XOR       R0,CH
	  TEST      R0,80H
	  JZ        $UNPAKZ             ;BRANCH IF DATA TYPE = VARIABLE TYPE
	  JMP       ERR_74              ;ERROR IF TYPE INCORRECT
$UNPAKZ:  MOV       K,CH
	  AND       K,7FH
	  INC       K                   ;K = LENGTH OF VALUE +1
	  CALL      BUFCOUNT            ;DECREMENT BUFFER COUNT BY LENGTH +1
	  MOVZX     EAX,K
	  MOV       DWORD PTR [A0],EAX
	  DEC       DWORD PTR [A0]
	  MOVZX     EAX,R2              ;F1,0 = LENGTH OF VALUE
	  MOV       DWORD PTR [A2],EAX  ;F3,2 = LENGTH OF RECEIVER VARIABLE
	  MOV       EDX,AUX01
	  MOV       EAX,DWORD PTR [A2]
	  ADD       EDX,EAX             ;AUX1 POINT TO NEXT RECEIVER
	  XCHG      EDX,AUX01
	  MOV       AUX00,EDX           ;AUX0 = ADDRESS OF RECEIVER
	  MOV       EDX,AUX0F
	  MOV       EAX,DWORD PTR [A0]
	  ADD       EDX,EAX             ;AUXF POINT AFTER VALUE IN BUFFER
	  XCHG      EDX,AUX0F           ;PC'S = ADDRESS OF VALUE
	  TEST      CH,80H
	  JNZ       $UNPAKI3
	  MOV       EBX,OFFSET MATHPAGE
	  MOV       EAX,DWORD PTR [EDX]
	  MOV       DWORD PTR [EBX],EAX
	  MOV       EAX,DWORD PTR [EDX+4]
	  MOV       DWORD PTR [EBX+4],EAX
	  CALL      OLDTONEW
$UNPAKI3: CALL      ARECEVAL            ;VALUE ==> VARIABLE
	  MOV       EAX,OFFSET $CB
	  CALL      MOREARG             ;LOOK FOR MORE ARGUMENT
	  JMP       $UNPAKI2            ;BRANCH IF MORE ELEMENTS
$CB:      JMP       $UNPAKI1            ;BRANCH IF COMMA FOUND (MORE ARGUMENTS)

;     $PACKD: PROCESS DELIMITER FORM OF $PACK
;
;          FORMAT:
;
;               $PACK(D=delim) alpha FROM arg-list
;
;          ENTRY: TEXTPTR POINTS AFTER 'FROM'
;               IN EXECUTION PHASE,
;                    AUXF = ADDRESS OF BUFFER
;                    AUXE = LENGTH OF BUFFER
;                    AUXD = ADDRESS OF DELIMITER SPEC.
;                    AUXC = LENGTH OF DELIMITER SPEC.
;

$PACKD:   CALL      DELIMTR             ;GET DELIMITER SPECIFICATION
	  JMP       $PACKD1

$PACKD5:  CALL      PAKDLMTR            ;DELIMITER ==> BUFFER
$PACKD1:  CALL      ARGUMENT            ;SCAN NEXT ARGUMENT
	  MOV       EDX,AUX03
	  MOV       AUX0A,EDX           ;AUXA = ADDRESS OF ARGUMENT
	  MOV       EDX,AUX02
	  MOV       WORD PTR [R4],DX    ;F5 = VARIABLE TYPE; F4 = LENGTH
	  MOV       K,DL                ;K = LENGTH OF ARGUMENT VALUE
$PACKD2:  TEST      R5,80H
	  JNZ       $PACKD3             ;BRANCH IF ALPHA VALUE

;     NUMERIC VALUE
;

	  CALL      CVTASCII            ;CONVERT FL.PT. VALUE TO ASCII (PRINT FORMAT)
	  MOV       AL,R0
	  MOV       K,AL                ;K = LENGTH OF VALUE
	  DEC       K

;     ALPHA VALUE (OR CONVERTED NUMERIC VALUE)
;

$PACKD3:  CALL      BUFCOUNT            ;MAKE SURE ROOM IN BUFFER FOR VALUE
	  MOV       AL,K                ;F0 = LENGTH OF VALUE
	  MOV       R0,AL
	  CALL      MOVEVALF            ;VALUE ==> BUFFER

;     CHECK FOR MORE ARGUMENT
;

	  MOV       EAX,OFFSET $CC
	  CALL      MOREARG             ;CHECK FOR MORE ARGUMENT
	  JMP       $UNPAKW             ;BRANCH IF MORE ELEMENTS IN CURRENT ARGUMENT
$CC:      JMP       $PACKD5             ;BRANCH IF COMMA FOUND (MORE ARGUMENTS)
$UNPAKW:  CALL      PAKDLMTR            ;DELIMITER ==> BUFFER
	  JMP       $PACKD2

;     PAKDLMTR: DELIMITER CHARACTER ==> BUFFER
;
;          ENTRY: PHASE = EXECUTION
;               AUXD,BITS00FF = DELIMITER CHARACTER
;               AUXF = ADDRESS OF NEXT LOCATION IN BUFFER
;
;          RETURN: F0 = DELIMITER CHARACTER
;
;          MODIFIED REGISTERS: PC'S,F0-2,AUXE
;

PAKDLMTR: MOV       AL,K               ;SAVE ELEMENT LENGTH
	  MOV       R2,AL
	  MOV       K,1
	  CALL      BUFCOUNT           ;MAKE SURE ROOM IN BUFFER FOR DELIMITER
	  MOV       EDX,AUX0D
	  MOV       R0,DL              ;F0 = DELIMITER CHARACTER
	  MOV       EDX,AUX0F
	  MOV       AL,R0
	  MOV       BYTE PTR [EDX],AL
	  MOV       AUX0F,EDX          ;DELIMITER CHARACTER ==> BUFFER
	  INC       AUX0F
	  MOV       AL,R2              ;RESTORE K
	  MOV       K,AL
	  RET

;     $UNPACKD: PROCESS DELIMITER FORM OF $UNPACK
;
;          FORMAT:
;
;               $UNPACK(D=delim) alpha TO arg-list
;
;          ENTRY: TEXTPTR POINTS AFTER 'TO'
;               IN EXECUTION PHASE,
;                    AUXF = ADDRESS OF BUFFER
;                    AUXE = LENGTH OF BUFFER
;                    AUXD = ADDRESS OF DELIMITER SPEC.
;                    AUXC = LENGTH OF DELIMITER SPEC.
;

$UNPAKD:  CALL      DELIMTR             ;GET DELIMITER SPECIFICATION
$UNPAKD1: CALL      ARGUMNTR            ;SCAN NEXT ARGUMENT

;     DETERMINE LENGTH OF NEXT VALUE IN BUFFER
;

$UNPAKD2: MOV       EDX,AUX0D           ;F3 = DELIMITER TYPE
	  MOV       WORD PTR [R2],DX    ;F2 = DELIMITER CHARACTER
$UNPAKD7: MOV       EDX,AUX0F           ;PC'S = BUFFER PTR
	  MOV       DWORD PTR [A0],0     ;VALUE LENGTH = 0
	  JMP       $UNPAKD4

$UNPAKD3: XCHG      EDX,AUX0E           ;DECREMENT BUFFER COUNT
	  DEC       AUX0E
	  MOV       CH,BYTE PTR [EDX]
	  INC       EDX                 ;GET NEXT CHARACTER FROM BUFFER
	  CMP       CH,R2
	  JE        $UNPAKD5            ;BRANCH IF CHARACTER = DELIMITER
	  INC       DWORD PTR [A0]       ;INCREMENT VALUE LENGTH
$UNPAKD4: XCHG      EDX,AUX0E           ;GET BUFFER LENGTH
	  CMP       EDX,0
	  JNE       $UNPAKD3            ;BRANCH IF BUFFER NOT EMPTY

;     BUFFER EMPTY
;

	  XCHG      EDX,AUX0E
	  XCHG      EDX,AUX0F
	  MOV       AUX0B,EDX           ;AUXB = ADDRESS OF VALUE
	  CMP       DWORD PTR [A0],0
	  JNE       $UNPAKD6            ;BRANCH IF LENGTH > 0
	  TEST      R3,1
	  JNZ       REM                 ;BRANCH IF "IGNORE REMAINING ARGUMENTS"
					;SLIDE TO END OF STMT
	  JMP       ERROR_76            ;ERROR IF NOT ENOUGH DATA

;     DELIMITER FOUND
;

$UNPAKD5: XCHG      EDX,AUX0F           ;AUXF POINT AFTER DELIMITER
	  MOV       AUX0B,EDX           ;AUXB = ADDRESS OF VALUE
	  CMP       DWORD PTR [A0],0
	  JNE       $UNPAKD6            ;BRANCH IF LENGTH > 0
	  TEST      R3,2
	  JNZ       $UNPAKD7            ;BRACNH IF "IGNORE SUCCESSIVE DELIMITERS"
	  MOV       EDX,AUX02
	  MOVZX     EAX,DH               ;F0 = LENGTH OF RECEIVER
	  MOV       DWORD PTR [A0],EAX
	  MOV       EDX,AUX01
	  ADD       EDX,EAX
	  MOV       AUX01,EDX           ;INCREMENT PTR PAST RECEIVER
	  JMP       $UNPAKD8

;     UNPACK NEXT VALUE
;

$UNPAKD6: CALL      RCVASCII            ;CONVERT ASCII TO FL.PT. & PUT ==> RECEIVR

;     CHECK FOR MORE ARGUMENT
;

$UNPAKD8: MOV       EAX,OFFSET $CD
	  CALL      MOREARG             ;CHECK FOR MORE ARGUMENTS
	  JMP       $UNPAKD2            ;BRANCH IF MORE ELEMENTS IN CURRENT ARGUMENT
$CD:      JMP       $UNPAKD1            ;BRANCH IF COMMA FOUND (MORE ARGUMENTS)

;     DELIMTR: GET DELIMITER SPECIFICATION
;
;          ENTRY: PHASE = EXECUTION
;               AUXD = ADDRESS OF DELIMITER SPEC.
;               AUXC = LENGTH OF DELIMITER SPEC.
;
;          RETURN:
;               CH = DELIMITER TYPE (00-03)
;               CL = DELIMITER CHARACTER
;               AUXD = CHCL (DELIMITER SPEC)
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0,AUXD
;

DELIMTR:  MOV       EDX,AUX0D
	  MOV       CH,BYTE PTR [EDX]   ;GET DELIMITER TYPE
	  INC       EDX
	  MOV       R0,CH
	  MOV       CH,BYTE PTR [EDX]   ;GET DELIMITER CHARACTER
	  MOV       EDX,AUX0C
	  DEC       EDX
	  CMP       EDX,0
	  JNE       $UNPAKV             ;BRANCH IF DELIMITER LENGTH >=0

ERROR_58: MOV       R0,58H              ;ILLEGAL DELIMITER SPEC.
	  JMP       ERROR

$UNPAKV:  MOV       DH,R0
	  MOV       R0,4
	  CMP       R0,DH
	  JBE       ERROR_58            ;ERROR IF DELIMITER TYPE > 03
	  MOV       DL,CH
	  MOV       AUX0D,EDX           ;AUXD = DELIMITER SPECIFICTION
	  RET

; cgetbyte:  get next byte from string. if no more, get hex(20).
;            convert values hex(20-5f) to hex(00-3f). error for other values.
;
;       entry:  r0=length of string (0-255)
;               phpl=address of string
;
;       return: r1=next byte (converted to hex(00-3f)
;               r0 decremented (until 0)
;               phpl incremented

cgetbyte:
	mov     ch,byte ptr [edx]               ;get next byte (or hex(20))
	inc     edx
	mov     r1,0
	cmp     a0,0
	je      cgetbyte1                       ;br, if no more in string
	dec     word ptr a0                     ;decrement count
	cmp     ch,20h
	jb      error_71                        ;br, illegal value
	cmp     ch,5fh
	ja      error_71                        ;br, illegal value
	mov     r1,ch
	sub     byte ptr r1,20h                 ;r1=next byte - hex(20)
cgetbyte1:
	ret


; ugetbyte:  get next byte from string. if no more, get hex(00).
;
;       entry:  r0=length of string (0-255)
;               phpl=address of string
;
;       return: r1=next byte (00 in no more)
;               r0 decremented (until 0)
;               phpl incremented

ugetbyte:
	mov     ch,byte ptr [edx]       ;get next byte (or hex(00))
	inc     edx
	mov     r1,0
	cmp     a0,0
	je      ugetbyte1               ;br, if no more in string

	dec     word ptr a0             ;decrement count
	mov     r1,ch                   ;r1=next byte
ugetbyte1:
	ret

; putbyte:   put next byte from string.
;
;       entry:  r2=length of string (1-255)
;               aux0=address of string
;               r3=next byte
;
;       return: r2 decremented
;               aux0 incremented

putbyte:
	xchg    edx,aux00
	mov     ch,r3
	mov     byte ptr [edx],ch
	inc     edx
	xchg    edx,aux00               ;put byte into string, inc. address

	dec     word ptr a2             ;decrement length
	ret


;     $PACKF: PROCESS FIELD FORM OF $PACK
;
;          FORMAT:
;
;               $PACK(F=field) buffer FROM arg-list
;
;               field = 00xx     skip field
;                       10xx     ASCII free field
;                       2dxx     ASCII integer
;                       3dxx     IBM display format
;                       4dxx     IBM USASCII-8
;                       5dxx     IBM pack decimal
;                       6dxx     unsigned pack decimal
;                       A0xx     alphanumeric
;
;               where: xx = field length (>0)
;                       d = decimal point position (from
;                           right end of field)
;
;          ENTRY: TEXTPTR POINTS AFTER 'FROM'
;
;          MODIFIED REGISTERS:
;

$PACKF:   CALL      ARGUMENT            ;SCAN NEXT ARGUMENT
	  MOV       EDX,AUX03
	  MOV       AUX0A,EDX           ;AUXA = ADDRESS OF VALUE
	  MOV       EDX,AUX02
	  MOV       R5,DH               ;F5 = VALUE TYPE
	  CALL      FLDSPEC             ;GET NEXT FIELD SPECIFICATION

$PACKF1:  MOV       AL,R2
;@@ 3.4 ++
	  MOV       R4,AL
;@@ 3.4 --
	  AND       AL,0F0H
	  CMP       AL,0A0H
	  JNE       $PACKF2             ;BRANCH IF NOT ALPHA FIELD

; PROCESS ALPHA FIELD (A0xx)
;

	  MOV       EDX,AUX02
	  MOVZX     AX,DL               ;F1,0 = LENGTH OF VALUE
	  MOV       A0,AX
$PACKF4:  MOV       A1,0
	  MOVZX     EAX,K
	  MOV       DWORD PTR [A2],EAX  ;F3,2 = LENGTH OF FIELD
	  MOV       EDX,AUX0F
	  ADD       EDX,EAX             ;AUXF POINT AFTER FIELD
	  XCHG      EDX,AUX0F
	  MOV       AUX00,EDX           ;AUX0 POINT TO FIELD
	  MOV       EDX,AUX03
	  MOV       EAX,DWORD PTR [A0]
	  ADD       EDX,EAX             ;AUX3 POINT AFTER VALUE
	  XCHG      EDX,AUX03           ;PC'S POINT TO VALUE
;@@ 3.4 ++

	  CMP       R4,0A1H
	  JE        $PACKF32            ;br, if compressed alpha
	  call      areceval            ;value ==> field
	  jmp       $packf7

;PROCESS COMPRESSED ALPHA FILED (A1 XX) ..
;       ENTRY   R0  = LENGTH OF VALUE TO PACK
;               EDX = ADDRESS OF VALUE TO PACK
;               R2  = LENGTH OF FILED
;               AUX0= ADDRESS OF FILED
;       REGISTER USED -
;               R1  = NEXT BYTE OF VALUE (STRING)
;               R3  = NEXT BYTE TO BE WRITTEN (COMPRESS DATA)
;
$PACKF32:
	call    cgetbyte                ;r1 = 1st byte of set of 4
	mov     al,r1
	shl     al,2
	mov     r3,al                   ;6 bit value into result

	call    cgetbyte                ;r1 = 2nd byte of set of 4
	mov     al,r1
	shr     al,4
	mov     r4,al
	or      r3,al                   ;or high 2 bits into result

	call    putbyte                 ;store resultant byte in field
	cmp     a2,0
	je      $packf33                ;branch if field full

	mov     al,r4
	shr     al,4
	mov     ah,r1
	shl     ah,4
	or      al,ah
	mov     r3,al                   ;store low 4 bits of 2nd byte

	call    cgetbyte                ;r1 = 3rd byte of set of 4
	shl     byte ptr r1,2

	mov     al,r1
	shr     al,4
	and     byte ptr r3,0f0h
	or      r3,al                   ;store high 4-bits of 3rd byte

	call    putbyte                 ;store resultant byte in field
	cmp     a2,0
	je      $packf33                ;br, if field full

	mov     al,r1
	and     al,0fh
	mov     r3,al
	shl     al,4
	or      r3,al
	and     r3,0c0h                 ;store low 2 bits of 3rd byte

	call    cgetbyte                ;f1 = 4th byte of set of 4
	mov     al,r1
	or      r3,al                   ;store 6 bits of byte 4

	call    putbyte                 ;store resultant byte in field
	cmp     a2,0
	jne     $packf32                ;br, if more bytes in field

$packf33:
	jmp     $packf7

;@@ 3.4 --

; CHECK FOR MORE ARGUMENT
;

$PACKF7:  MOV       EAX,OFFSET $CE
	  CALL      MOREARG             ;CHECK FOR MORE ARGUMENT
	  JMP       $PACKXX             ;MORE ELEMENTS IN CURRENT ARGUMENT
$CE:      JMP       $PACKF              ;COMMA FOUND (MORE ARGUMENTS)
$PACKXX:  MOV       EDX,AUX02
	  MOV       R5,DH               ;F5 = TYPE OF VALUE
	  CALL      FLDSPECA            ;RE-USE CURRENT FIELD SPECIFICATION
	  JMP       $PACKF1

; PROCESS ASCII FREE FIELD (10xx)
;

$PACKF2:  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,10H
	  JNE       $PACKF3             ;BRANCH IF NOT ASCII FREE
	  CALL      CVTASCII            ;CONVERT FL.PT. VALUE TO ASCII (PRINT FORMAT)
	  MOV       EDX,0808H
	  MOV       AUX02,EDX           ;RESTORE AUX2 INFO
	  movzx     ax,r0
	  dec       ax
	  mov       a0,ax               ;DECREMENT ASCII LENGTH
	  JMP       $PACKF4

; PROCESS FIELD TYPES 2dxx - 5dxx
;

$PACKF3:  MOV       EDX,AUX0A
	  MOV       AUX03,EDX
	  ADD       AUX0A,8             ;AUXA = ADDRESS OF NEXT FL.PT. VALUE
;@@ 3.4 ++
	  MOV       AL,R2               ;
	  AND       AL,0F0H             ;
	  CMP       AL,80H              ;BR, IF SIGNED BINARY
	  JE        $PACKFB             ;
	  CMP       AL,90H              ;BR, IF UNSIGNED BINARY
	  JE        $PACKFB             ;
	  CMP       AL,70H              ;BR, IF NOT REDSHAW FORMAT
	  JNE       $PKF3_1
	  AND       R2,5FH              ;IF REDSHAW FORMAT (TYPE 7, CHANGE TO
					;TYPE 5 AND TRY THAT FIRST)
$PKF3_1:
;@@ 3.4 --
	  CALL      NEWTOOLD
	  MOV       AUX03,EDX           ;AUX3 = ADDRESS OF CURRENT FL.PT. VALUE
	  CALL      BINEXP              ;GET EXPONENT (BINARY) OF VALUE
	  TEST      R2,0FH
	  JZ        $PACKF5             ;BRANCH IF DECIMAL POSITION = 0
	  TEST      CL,0FH
	  JZ        $PACKF5             ;BRANCH IF VALUE = 0
	  MOV       AL,R2
	  AND       AL,0FH
	  MOV       R1,AL
;         MOV       AL,R1
	  ADD       R0,AL               ;INCREMENT EXPONENT BY DEC. POSITION

; NOTE, SINCE DECIMAL POSITION < 16, RESULTANT EXPONENT
; IS <= X'73' WHICH IS STILL POSITIVE!  SO DON'T NEED TO
; CHECK FOR OVERFLOW.

; INITIALIZE FIELD TO ZERO WITH TRUE SIGN
;
;     ASCII INTEGER FIELD (2dxx)
;

$PACKF5:  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,20H
	  JNE       $PACKF6             ;BRANCH IF NOT ASCII INTEGER
	  MOV       AL,30H              ;FILL CHARACTER = ASCII ZERO
	  CALL      FILLFLD             ;FILL FIELD WITH ZEROES
	  MOV       EDX,AUX00           ;POINT TO FIELD
	  MOV       BYTE PTR [EDX],'+'  ;PLUS SIGN ==> FIELD
	  TEST      R0,80H
	  JNZ       $PACKF7             ;BRANCH IF EXPONENT < 0
	  TEST      CH,10H
	  JZ        $PACKXY             ;BRANCH IF VALUE >=0
	  MOV       BYTE PTR [EDX],'-'  ;MINUS SIGN ==> FIELD
$PACKXY:  MOV       AUX00,EDX           ;POINT AFTER SIGN
	  INC       AUX00
	  DEC       K                   ;DECREMENT FIELD LENGTH
	  MOV       EDX,AUX0F
	  DEC       EDX
	  JMP       $PACKF8             ;PC'S POINT TO END OF FIELD, BRANCH

;     IBM DISPLAY FORMAT (3dxx)
;

$PACKF6:  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,30H
	  JNE       $PACKF9             ;BRANCH IF NOT IBM DISPLAY FORMAT
	  MOV       AL,0F0H
	  CALL      FILLFLD             ;FILL FIELD WITH ZERO (F0)
	  MOV       R5,0C0H             ;SIGN = '+' (C)
$PACKF11: MOV       EDX,AUX0F
	  DEC       EDX                 ;POINT TO END OF FIELD
	  MOV       AL,R5
	  MOV       BYTE PTR [EDX],AL   ;PLUS SIGN ==> FIELD
	  TEST      R0,80H
	  JNZ       $PACKF7             ;BRANCH IF EXPONENT < 0
	  TEST      CH,10H
	  JZ        $PACKXZ             ;BRANCH IF VALUE >= 0
	  MOV       AL,R5
	  ADD       AL,10H
	  MOV       BYTE PTR [EDX],AL   ;CHANGE SIGN TO '-'
$PACKXZ:  JMP       $PACKF8

;     USASCII-8 (4dxx)
;

$PACKF9:  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,40H
	  JNE       $PACKF10            ;BRANCH IF NOT USASCII-8
	  MOV       AL,50H
	  CALL      FILLFLD             ;FILL FIELD WITH ZERO (50)
	  MOV       R5,0A0H             ;SIGN = '+' (A)
	  JMP       $PACKF11

;     PACK DECIMAL
;

$PACKF10: MOV       AL,0
	  CALL      FILLFLD             ;FILL FIELD WITH ZERO (00)
	  MOV       EDX,AUX0F
	  DEC       EDX                 ;POINT TO END OF FIELD
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,50H
	  JE        $PACKF20            ;BRANCH IF IBM PACK DECIMAL

;     UNSIGNED PACK DECIMAL (6dxx)
;

	  TEST      R0,80H
	  JNZ       $PACKF7             ;BRANCH IF EXP < 0
	  MOV       AL,K
	  MOV       R1,AL
	  JMP       $PACKF22

;     IBM PACK DECIMAL (5dxx)
;

$PACKF20: MOV       BYTE PTR [EDX],0CH  ;SIGN = '+' (C)
	  TEST      R0,80H
	  JNZ       $PACKF7             ;BRANCH IF EXPONENT < 0
	  TEST      CH,10H
	  JZ        $PACKWW             ;BRANCH IF VALUE >= 0
	  MOV       BYTE PTR [EDX],0DH  ;SIGN = '-'
$PACKWW:  MOV       AL,K
	  DEC       AL
	  MOV       R1,AL
$PACKF22: MOV       AL,R1               ;K = NO. OF DIGITS THAT CAN BE PACKED
	  ADD       K,AL
	  JNC       $PACKF8
	  MOV       K,0FFH              ;K = 255 IF MORE THAN 255

; VALUE ==> FIELD

;     ENTRY: K = NO. OF DIGITS THAT CAN BE PACKED
;            F0 = EXPONENT (NO. OF DIGITS TO PACK -1)
;            PC'S POINT TO END OF FIELD
;            F2 = FIELD TYPE
;

$PACKF8:  MOV       AL,R0               ;SAVE 'EXPONENT'
	  MOV       R5,AL
	  INC       R0                  ;F0 = NO. OF DIGITS TO PACK
	  MOV       AL,K
	  CMP       R0,AL
	  JBE       $PACKQQ

;@@ 3.4 ++
	  MOV       EDX,AUX0B           ;
	  MOV       R2,DH               ;GET ACTUAL FIELD TYPE
	  MOV       K,DL                ;FIELD LENGTH
	  MOV       EDX,AUX00           ;
	  MOV       AUX0F,EDX           ;
	  MOV       AL,R2               ;
	  AND       AL,0F0H             ;
	  CMP       AL,70H              ;BR, IF REDSHAW FORMAT
	  JE        $PACKFB             ;
	  JMP       ERROR_71            ;ERROR IF TOO MANY DIGITS TO PACK
;@@ 3.4 --

$PACKQQ:  MOV       AL,R0
	  MOV       K,AL
	  MOV       R1,0DH
	  CMP       AL,R1
	  JBE       $PACKSS             ;BRANCH IF NO. OF DIGITS TO PACK <= 13
	  MOV       K,0DH               ;NO. OF DIGITS TO PACK = 13
$PACKSS:  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,60H
	  JNE       $PACKF23            ;BRANCH IF NOT UNSIGNED PACK DECIMAL
	  DEC       R0
	  JMP       $PACKRR
QPACKF12: JMP       $PACKF12
$PACKF23: MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,50H
	  JNE       QPACKF12            ;BRANCH IF NOT PACK DECIMAL FORM

$PACKRR:  MOV       R1,0
	  SHL       WORD PTR [R0],3
	  SHR       R0,4
	  MOV       AL,R1
	  SHL       AL,4
	  OR        R0,AL               ;F0 = F0 / 2
	  INC       R0                  ;F0 = NO. OF BYTES REQUIRED TO STORE PACKED DIGITS
$PACKF12: INC       EDX
	  MOVZX     EAX,R0
	  MOV       DWORD PTR [A0],EAX
	  MOV       DWORD PTR [A3],EDX
	  SUB       EDX,EAX             ;PC'S = ADDR IN FIELD TO STORE 1ST DIGIT

;     MOVE VALUE
;
;          ENTRY: PC'S = ADDR IN FIELD TO STORE 1ST DIGIT
;                 K = NO. OF DIGITS TO STORE
;                 F2 = FIELD TYPE
;                 AUX3 = ADDRESS OF VALUE
;

	  XCHG      EDX,AUX03           ;SAVE PTR TO FIELD
	  MOV       CH,BYTE PTR [EDX]
	  INC       EDX
	  MOV       R1,0                ;POINT TO 2ND BYTE OF VALUE
	  MOV       CL,BYTE PTR [EDX]
	  INC       EDX
	  MOV       R3,CL               ;F3,BITS0F = 1ST DIGIT
	  XCHG      EDX,AUX03
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,60H
	  JE        $PACKJJ             ;BRANCH IF UNSIGNED PACK DECIMAL
	  CMP       AL,50H
	  JNE       $PACKF15            ;BRANCH IF NOT IBM PACK DECIMAL
	  INC       R5                  ;INCREMENT EXPONENT
$PACKJJ:  TEST      R5,1                ;BRANCH IF "EXPONENT" EVEN
	  JNZ       $PACKF15            ;BRANCH IF "EXPONENT" EVEN
	  OR        R1,02H              ;FLAG = STORE DIGIT IN LOW-ORDER OF BYTE
$PACKF15: MOV       AL,R3               ;F0 = LOW DIGIT OF PAIR
	  AND       AL,0FH
	  MOV       R0,AL               ;F0 = LOW DIGIT OF PAIR
	  TEST      R1,1
	  JZ        $PACKF13            ;BRANCH IF LOW ORDER DIGIT IS NEXT
	  XCHG      EDX,AUX03
	  MOV       CH,BYTE PTR [EDX]
	  XCHG      EDX,AUX03           ;GET NEXT PAIR OF DIGITS
	  INC       AUX03
	  MOV       R3,CH               ;SAVE DIGITS
	  MOV       R0,CH               ;F0 = HIGH ORDER DIGIT
	  SHR       R0,4
$PACKF13: MOV       CH,BYTE PTR [EDX]   ;COMPLEMENT READ FLAG
	  XOR       R1,03H              ;COMPLEMENT READ FLAG
	  MOV       AL,CH
	  OR        AL,R0
	  MOV       BYTE PTR [EDX],AL   ;DIGIT ==> FIELD
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,60H
	  JE        $PACKGG             ;BRANCH IF UNSIGNED PACK DECIMAL
	  CMP       AL,50H
	  JNE       $PACKF16            ;BRANCH IF NOT PACK DECIMAL
$PACKGG:  TEST      R1,2
	  JZ        $PACKF16            ;BRANCH IF STORE IN LOW ORDER OF BYTE
	  MOV       AL,CH
	  AND       AL,0FH
	  MOV       AH,R0
	  SHL       AH,4
	  OR        AL,AH
	  MOV       BYTE PTR [EDX],AL   ;HIGH ORDER DIGIT ==> BUFFFER
	  DEC       EDX
$PACKF16: DEC       K                   ;DECREMENT DIGIT COUNT
	  INC       EDX
	  CMP       K,0
	  JNE       $PACKF15            ;BRANCH IF MORE DIGITS TO PACK
	  JMP       $PACKF7

$UNPAKFX: JMP       $UNPAKF

;@@ 3.4 ++
;
;BINARY $PACK FORMATS .....
;

;       TYPE 9: UNSIGN BINARY
;
;               BN   BN-1   BN-2   BN-3 ..... B1
;                 WHERE BN = HIGH ORDER BIT
;                       N1 = LOW ORDER BIT
;
;       THE ABSOLUTE VALUE OF THE NUMERIC VALUE IS CONVERTED TO BINARY.  THE
;       BIT LENGTH OF THE BINARY VALUE IS THE LENGTH OF THE FIELD x 8
;
;       TYPE 8: SIGNED BINARY
;
;               S   BN   BN-1   BN-2   BN-3 ..... B1
;                 WHERE S = SIGN ( 0 IF POSITIVE, 1 IF NEGATIVE)
;
;       SIGN IF THE HIGHEST BIT.  THUS, RANGE IS 1/2 OF UNSIGNED BINARY.
;       IF NEGATIVE, BINARY NUMBER IS STORED AS 2'S COMPLEMENT.
;
;       TYPE 7: REDSHAW SIGNED BINARY (AKA, REDSHAW BINARY OR REDSHAW FORMAT)
;
;               BN-4..... B1   BN-1   BN-2   BN-3   S
;
;                 ERROR IF (BN-1 BN-2 BN-3) > 5
;
;       NOTE, IF VALUE IS NEGATIVE, NUMBER IS NOT COMPLEMENTED.
;       REDSHAW FORMAT USES THE LOW NIBBLE TO IDENTIFY THE PACK TYPE AND
;       THE SIGN OF THE VALUE:
;
;               0CH (E OR F) --> + PACKED DECIMAL VALUE (SAME AS $PACK TYPE 5)
;               0DH          --> - PACKED DECIMAL VALUE (SAME AS $PACK TYPE 5)
;               0 - 0BH      --> REDSHAW BINARY (LOW BIT IS SIGN)


;ROUTINE FOR BINARY FORMATS --
;
;       ENTRY:  X-PHASE
;               AUX03 = ADDRESS OF FLOATING POINT VALUE
;               AUX0F = ADDRESS OF FIELD
;               AUX0B = FIELD SPECIFICATION
;               R2    = FIELD TYPE AND DECIMAL POSITION
;               K     = FIELD LENGTH
;               R7R6  = ELEMENT COUNT

$PACKFB:
	MOV     EDX,AUX03
	MOV     AL,R2
	AND     AL,0F0H
	CMP     AL,70H
	JE      $PACKFBXXX
	CALL    NEWTOOLD
	MOV     AUX03,EDX
$PACKFBXXX:
	CALL    FLDLEN6                 ;ERROR IF FIELD LENGTH > 6

;ADJUST EXPONENT OF FL PT VALUE TO DECIMAL POSITION
;

	MOV     EDX,AUX03

	MOV     EBX,VSPTR
	MOV     CX,WORD PTR [EDX]
	XCHG    CH,CL
	MOV     EAX,DWORD PTR [EDX]
	MOV     DWORD PTR [EBX-8],EAX
	MOV     EAX,DWORD PTR [EDX+4]
	MOV     DWORD PTR [EBX-4],EAX
	SUB     VSPTR,8                 ;VALUE INTO VS (FOR FLTBN)

	CMP     EBX,DWORD PTR [@@VSEND]
	JB      ERROR_02

	TEST    CL,0FH
	JZ      $PACKFB6                ;DONE IF VALUE = 0
	TEST    R2,0FH
	JZ      $PACKFB6                ;BR, IF DEC. POS. = 0

	MOV     EDX,VSPTR               ;POINT TO VALUE

	MOV     AL,R2
	AND     AL,0FH
	MOV     R3,AL                   ;DECIMAL POSITION (BINARY)

	CMP     R3,0AH
	JB      $PACKFB1
	ADD     R3,6                    ;DECIMAL POSITION (PACKED DECIMAL)
$PACKFB1:
	MOV     R0,CH
	AND     R0,0FH
	MOV     AL,CL
	AND     AL,0F0H
	OR      R0,AL                   ;R0=EXPONENT (PACKED DECIMAL)

	TEST    CH,80H
	JNZ     $PACKFB7                ;BR, IF NEGATIVE EXPONENT

	MOV     AL,R3
	ADD     AL,R0
	DAA                             ;EXP = EXP + DEC. POS.
	MOV     R0,AL
	JNC     $PACKFB8
	JMP     ERROR_34                ;ERROR IF EXPONENT OVERFLOWS

$PACKFB7:
	MOV     R1,0
	MOV     AL,R1
	SUB     AL,R0
	DAS
	MOV     R0,AL                   ;COMPLEMENT EXP SINCE NEGATIVE

	MOV     AL,R3
	ADD     AL,R0
	DAA                             ;ADD DEC. POS. TO COMPLEMENTED EXP
	MOV     R0,AL
	JC      $PACKFB9                ;BR, IF EXP NOT NEGATIVE
	MOV     AL,R1
	SUB     AL,R0
	DAS
	MOV     R0,AL                   ;COMPLEMENTED EXPONENT
	JMP     $PACKFB8

$PACKFB9:
	AND     CH,7FH
	MOV     BYTE PTR [EDX],CH       ;CHENGE SIGN OF EXP TO +

$PACKFB8:
	MOV     AL,R0
	AND     AL,0FH
	MOV     AH,CH
	AND     AH,0F0H
	OR      AL,AH
	MOV     BYTE PTR [EDX],AL

	MOV     AL,CL
	AND     AL,0FH
	MOV     AH,R0
	AND     AH,0F0H
	OR      AL,AH
	MOV     BYTE PTR [EDX+1],AL               ;INCREMENTED EXP ==> FL. PT. VALUE

;---- CONVERT ADJUSTED FL. PT. VALUE TO BINARY ------
;

$PACKFB6:
	MOV     EDX,DWORD PTR [A6]                ;SAVE ELEMENT COUNT
	PUSH    EDX

	MOV     EDX,VSPTR
	MOV     CX,WORD PTR [EDX]
	XCHG    CH,CL
	PUSH    ECX                             ;SAVE ORIGINAL SIGN OF NUMBER

	MOV     EBX,OFFSET MATHPAGE
	MOV     EAX,DWORD PTR [EDX]
	MOV     DWORD PTR [EBX],EAX
	MOV     EAX,DWORD PTR [EDX+4]
	MOV     DWORD PTR [EBX+4],EAX
	CALL    OLDTONEW
	MOV     EBX,VSPTR
	MOV     EAX,DWORD PTR [EDX]
	MOV     DWORD PTR [EBX],EAX
	MOV     EAX,DWORD PTR [EDX+4]
	MOV     DWORD PTR [EBX+4],EAX
	mov     edx,vsptr

	CALL    MATHABS                         ;TAKE ABSOLUTION VALUE OF NUMBER
	CALL    FLTBNL                          ;CONVERT ABS. VALUE TO BINARY

; CHECK MAGNITUDE OF NUMBER
;

	mov     al,k
	and     al,0fh
	cmp     al,01h
	je      err_71                          ;ERROR IF OVERFLOW
	MOV     EDX,AUX0B
	MOV     WORD PTR [R6],DX                ;FIELD SPECIFICATION (TYPE/LENGTH)

	MOV     AL,R7
	AND     AL,0F0H
	CMP     AL,90H
	JE      $PACKFB2
	TEST    R5,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY
$PACKFB2:
	MOV     AH,R6
	AND     AH,0FH
	CMP     AH,06H
	JE      $PAKFB10                        ;BR, IF FIELD LENGTH = 6

	CMP     R5,0
	JNE     ERR_71                          ;BYTE MUST BE 0 IF LENGTH < 6
	CMP     AL,90H
	JE      $PACKFB3
	TEST    R4,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY
$PACKFB3:
	CMP     AH,05H
	JE      $PAKFB10                        ;BR, IF FIELD LENGTH = 5

	CMP     R4,0
	JNE     ERR_71                          ;BYTE MUST BE 0 IF LENGTH < 5
	CMP     AL,90H
	JE      $PACKFB4
	TEST    R3,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY
$PACKFB4:
	CMP     AH,04H
	JE      $PAKFB10                        ;BR, IF FIELD LENGTH = 4

	CMP     R3,0
	JNE     ERR_71                          ;BYTE MUST BE 0 IF LENGTH < 4
	CMP     AL,90H
	JE      $PACKFB5X
	TEST    R2,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY
$PACKFB5X:
	CMP     AH,03H
	JE      $PAKFB10                        ;BR, IF FIELD LENGTH = 3

	CMP     R2,0
	JNE     ERR_71                          ;BYTE MUST BE 0 IF LENGTH < 3
	CMP     AL,90H
	JE      $PACKFB6X
	TEST    R1,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY
$PACKFB6X:
	CMP     AH,02H
	JE      $PAKFB10                        ;BR, IF FIELD LENGTH = 2

	CMP     R1,0
	JNE     ERR_71                          ;BYTE MUST BE 0 IF LENGTH < 2
	CMP     AL,90H
	JE      $PAKFB10
	TEST    R0,80H
	JNZ     ERR_71                          ;HIGH BIT MUST BE 0 IF SIGNED BINARY

; INSERT SIGN IF SIGNED BINARY TYPE
;
$PAKFB10:
	POP     EDX                             ;GET ORIGINAL SIGN OF NUMBER
	MOV     AL,R7
	AND     AL,0F0H
	CMP     AL,80H
	JNE     $PAKFB12                        ;BR, IF UNSIGNED BINARY
	TEST    DH,10H
	JZ      $PAKFB12                        ;BR, IF NUMBER NOT NEGATIVE

	MOV     BX,WORD PTR [R4]
	MOV     EAX,DWORD PTR [R0]
	NOT     BX
	NEG     EAX
	JNZ     $PX1
	INC     BX
$PX1:
	MOV     WORD PTR [R4],BX
	MOV     DWORD PTR [R0],EAX              ;TAKE 2'S COMPLEMENT IF NEGATIVE

;CONVERT BINARY NUMBER TO REDSHAW FORMAT
;

;       1.SHIFT BINARY NUMBER LEFT 4 - BITS
;       2.INSERT HIGHEST 3-BITS OF VALUE INTO HIGH 3-BITS OF LOWEST NIBBLE
;       3.INSERT SIGN INTO LOWEST BIT OF VALUE
;

$PAKFB12:
	MOV     AL,R7
	AND     AL,0F0H
	CMP     AL,70H
	JNE     $PACKFB5

	MOV     AL,R5
	SHR     AL,4
	MOV     K,AL
	SHL     WORD PTR [R4],4
	MOV     AL,R3
	SHR     AL,4
	OR      R4,AL
	mov     al,r0
	SHL     DWORD PTR [R0],4        ;SHIFT VALUE LEFT 4-BITS
	mov     r0,al

;SET F4,L=HIGHEST NIBBLE OF ACTUAL VALUE (AS PER FIELD LENGTH)
;

	MOV     AL,R6
	AND     AL,0FH
	CMP     AL,06H
	JE      $PAKFB11                ;BR, IF LENGTH = 6
	MOV     AH,R5
	MOV     K,AH
	CMP     AL,05H
	JE      $PAKFB11                ;BR, IF LENGTH = 5
	MOV     AH,R4
	MOV     K,AH
	CMP     AL,04H
	JE      $PAKFB11                ;BR, IF LENGTH = 4
	MOV     AH,R3
	MOV     K,AH
	CMP     AL,03H
	JE      $PAKFB11                ;BR, IF LENGTH = 3
	MOV     AH,R2
	MOV     K,AH
	CMP     AL,02H
	JE      $PAKFB11                ;BR, IF LENGTH = 2
	MOV     AH,R1
	MOV     K,AH

$PAKFB11:
	MOV     AL,K
	AND     AL,06H
	CMP     AL,06H
	JE      ERR_71                 ;ERROR, IF HIGH 3-BITS > 5
	and     k,0fh
	SHL     BYTE PTR K,1           ;SHIFT HIGH 3-BITS

	mov     al,k
	and     al,0fh
	shl     byte ptr r0,4
	or      r0,al                   ;insert high 3-bits into r0

	TEST    DH,10H
	JZ      $PACKFB5
	OR      R0,01H                  ;SIGN INTO LOW BIT OF R0
$PACKFB5:
	MOV     EDX,AUX0F               ;POINT TO FIELD
	MOV     AL,R6
	AND     AL,0FH
	CMP     AL,1
	JE      $PAKFB21                ;BR, IF FIELD LENGTH = 1
	CMP     AL,2
	JE      $PAKFB22                ;BR, IF FIELD LENGTH = 2
	CMP     AL,3
	JE      $PAKFB23                ;BR, IF FIELD LENGTH = 3
	CMP     AL,4
	JE      $PAKFB24                ;BR, IF FIELD LENGTH = 4
	CMP     AL,5
	JE      $PAKFB25                ;BR, IF FIELD LENGTH = 5
	MOV     AL,R5
	MOV     BYTE PTR [EDX],AL       ;WRITE 1ST BYTE
	INC     EDX
$PAKFB25:
	MOV     AL,R4
	MOV     BYTE PTR [EDX],AL       ;WRITE 2ND BYTE
	INC     EDX
$PAKFB24:
	MOV     AL,R3
	MOV     BYTE PTR [EDX],AL       ;WRITE 3RD BYTE
	INC     EDX
$PAKFB23:
	MOV     AL,R2
	MOV     BYTE PTR [EDX],AL       ;WRITE 4TH BYTE
	INC     EDX
$PAKFB22:
	MOV     AL,R1
	MOV     BYTE PTR [EDX],AL       ;WRITE 5TH BYTE
	INC     EDX
$PAKFB21:
	MOV     AL,R0
	MOV     BYTE PTR [EDX],AL       ;WRITE 6TH BYTE
	INC     EDX
	MOV     AUX0F,EDX

; EXIT
;
	POP     EDX
	MOV     DWORD PTR [A6],EDX        ;RESTORE ELEMENT COUNT
	JMP     $PACKF7

ERR_71:
	JMP     ERROR_71                ;VALUE EXCEEDS FORMAT

;@@ 3.4 --

;@@@ 3.4 ++
patchub:
	xchg    edx,aux0f               ;auxf point after field
	mov     al,r2
	and     al,0f0h
	cmp     al,80h
	je      $unpkfb                 ;br, if signed binary
	cmp     al,90h
	je      $unpkfb                 ;br, if unsigned binary
	cmp     al,70h
	jne     patchub1                ;br, if not redshaw format

	xchg    edx,aux0f
	dec     edx
	mov     ch,byte ptr [edx]
	xchg    edx,aux0f
	inc     aux0f                   ;get last byte of value
	mov     al,ch
	and     al,0ch
	cmp     al,0ch
	jne     $unpkfb                 ;if sign nibble is c,d,e or f then use type 5 logic
	and     r2,5fh
patchub1:
	jmp     $unpakf2x
$unpkfb:

;
;       entry:    x-phase
;                 auxf = address of end of field + 1
;                 phpl = address of field
;                 auxb = field specification
;                   f2 = field type / decimal position
;                    k = field length
;                 aux3 = element count
;

	call    fldlen6                 ;error if field length > 4

; -------------- initialize value ------------
;
	mov     al,r2
	mov     r7,al                   ;field type /dec. pos.
	mov     ch,byte ptr [edx]
	mov     edx,aux0f               ;ch = 1st byte; point to end of field
	mov     word ptr [r4],0
	mov     word ptr [r2],0
	mov     word ptr [r0],0         ;initialize to 0
	test    ch,80h
	jz      $unpkfb2                ;br, if value >= 0
	mov     al,r7
	and     al,0f0h
	cmp     al,80h
	jne     $unpkfb2                ;br, if not signed binary value
	mov     word ptr [r4],-1
	mov     word ptr [r2],-1
	mov     word ptr [r0],-1        ;initialize to -1

; ----------- get binary value from field ----------
;

$unpkfb2:
	dec     edx                     ;point to last byte in field
	mov     ch,byte ptr [edx]       ;get low order byte
	dec     edx
	mov     r0,ch                   ;r0 = low byte
	mov     ch,byte ptr [edx]
	dec     edx
	mov     al,k
	and     al,0fh
	cmp     al,1
	je      $unpkfb5                ;br, if field length = 1
	mov     r1,ch                   ;r1 = 2nd byte
	mov     ch,byte ptr [edx]
	dec     edx
	cmp     al,2
	je      $unpkfb5                ;br, if field length = 2
	mov     r2,ch                   ;r2 = 3rd byte
	mov     ch,byte ptr [edx]
	dec     edx
	cmp     al,3
	je      $unpkfb5                ;br, if field length = 3
	mov     r3,ch                   ;r3 = 4th byte
	mov     ch,byte ptr [edx]
	dec     edx
	cmp     al,4
	je      $unpkfb5                ;br, if field length = 4
	mov     r4,ch                   ;r4 = 5th byte
	mov     ch,byte ptr [edx]
	dec     edx
	cmp     al,5
	je      $unpkfb5                ;br, if field length = 5
	mov     r5,ch                   ;r5 = 6th byte

; ------------ convert redshaw format to signed binary --------
;

$unpkfb5:
	mov     al,r7
	and     al,0f0h
	cmp     al,70h
	jne     $unpkfb1                ;br, if mot redshaw format

	mov     al,r0
	and     al,0fh
	shl     al,3
	mov     r6,al                   ;save low nibble (shifted)

	mov     al,r4
	shr     dword ptr [r0],4
	shr     word ptr [r4],4
	shl     al,4
	or      r3,al

;
;       put high 3-bits of value into highest nibble, according to
;       field length
;

	mov     al,k
	and     al,0fh
	cmp     al,6
	jne     $unpkfbx                ;br, if length not 6
	and     r5,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r5,bl
	jmp     $unpkfb6
$unpkfbx:
	cmp     al,5
	jne     $unpkfby                ;br, if length not 5
	and     r4,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r4,bl
	jmp     $unpkfb6
$unpkfby:
	cmp     al,4
	jne     $unpkfbz                ;br, if length not 4
	and     r3,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r3,bl
	jmp     $unpkfb6
$unpkfbz:
	cmp     al,3
	jne     $unpkfbx1               ;br, if length not 3
	and     r2,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r2,bl
	jmp     $unpkfb6
$unpkfbx1:
	cmp     al,2
	jne     $unpkfby1               ;br, if length not 2
	and     r1,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r1,bl
	jmp     $unpkfb6
$unpkfby1:
	and     r0,0fh
	mov     bl,r6
	and     bl,0f0h
	or      r0,bl

$unpkfb6:
	test    r6,08h
	jz      $unpkfb1

	mov     bx,word ptr [r4]
	mov     eax,dword ptr [r0]
	not     bx
	neg     eax
	jnz     $unpx2
	inc     bx
$unpx2:
	mov     word ptr [r4],bx
	mov     dword ptr [r0],eax      ;complement value if negative

; ------------ convert value to floationg point
;

$unpkfb1:
	mov     al,r7
	and     al,0f0h
	cmp     al,90h
	je      $unpkfb3                ;br, if unsigned binary
	call    binflts                 ;convert signed binary to fl. pt.
	jmp     $unpakf3x

$unpkfb3:
	mov     dx,word ptr [r2]
	call    bnfltxxx                ;convert unsigned binary to fl. pt.
	jmp     $unpakf3x

; binflts:    convert 6-byte signed binary number to floating point
;
;        entry:  r5r4r3r2r1r0 = signed number
;                           (2's complement if negative)
;
;        return:  floating point value in vs
;
;        modified registers: all, aux0
;
binflts:
	mov     dh,r5
	and     dh,80h
	push    edx                     ;save sign of value
	test    r5,80h
	jz      binflts1                ;br, if not negative
	mov     bx,word ptr [r4]
	mov     eax,dword ptr [r0]
	not     bx
	neg     eax
	jnz     binfltsx
	inc     bx
binfltsx:
	mov     dword ptr [r0],eax
	mov     word ptr [r4],bx        ;take absolute value

binflts1:
	call    bnfltxxx                ;convert abs. value to binary
	pop     edx
	test    dh,80h                  ;br, if not negative
	jz      binflts2
	mov     edx,vsptr
	mov     eax,dword ptr [edx+2]
	mov     bx,word ptr [edx+6]
	or      bx,bx
	jnz     binflts3
	or      eax,eax
	jnz     binflts3
	jmp     binflts2                ;don't negate 0
binflts3:
	not     bx
	neg     eax
	jnz     binflts4
	inc     bx
binflts4:
	mov     dword ptr [edx+2],eax
	mov     word ptr [edx+6],bx
binflts2:
	ret

; fldlen6:  check $pack/$unpack length for maximum of 6
;
;           entry:   k = length
;
;           return: err p58 if length > 6
;
;           modified registers: r0
;
fldlen6:
	mov     r0,6
	mov     al,6
	cmp     al,k
	jb      error_58                ;error if length > 4
	ret

;@@@ 3.4 --

;     $PACKSUB: SCAN & PROCESS '$PACK' OR '$UNPACK' FIELD
;               OR DELIMITER SPECIFICATION & BUFFER VAR.
;
;          FORMAT:
;             1. (F=field) buffer            (field form)
;             2. (D=delimiter) buffer    (delimiter form)
;             3. buffer                   (internal form)
;
;               where: buffer = alpha-var [<s,n>]
;                               alpha-array [<s,n>]
;
;             field,delimiter = alpha-var [<s,n>]
;                               alpha-array [<s,n>]
;                               literal
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: TEXTPTR POINTS AFTER 'buffer'
;            IN EXECUTION PHASE,
;               AUXF = ADDRESS OF BUFFER
;               AUXE = LENGTH OF BUFFER
;               AUXD = ADDRESS OF FIELD/DELIMITER SPEC.
;               AUXC = LENGTH OF FIELD/DELIMITER SPEC.
;               AUX4 = PACK/UNPACK TYPE
;                      0 IF FIELD FORM
;                      1 IF DELIMITER FORM
;                      2 IF INTERNAL FORM
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,4
;               IN EXECUTION PHASE, AUXC-F
;

$PACKSUB: MOV       EDX,2
	  MOV       AUX04,EDX               ;TYPE = INTERNAL
	  CMP       BYTE PTR [TEXTPTR],'('  ;LOOK FOR '('
	  JNE       $PACKSB1                ;BRANCH IF NF (INTERNAL FORM)
	  INC       TEXTPTR
	  CMP       BYTE PTR [TEXTPTR],'F'  ;LOOK FOR 'F'
	  JNE       $PACKSUBX
	  INC       TEXTPTR
	  MOV       R0,0
	  JMP       $PACKSB2            ;BRANCH IF FOUND

$PACKSUBX:CMP       BYTE PTR [TEXTPTR],'D'
	  JNE       ERROR_16            ;ERROR IF NOT 'F' OR 'D'
	  INC       TEXTPTR             ;INCREMENT TEXTPTR
	  MOV       R0,1
$PACKSB2: MOV       DL,R0
	  MOV       AUX04,EDX               ;AUXF = TYPE (0 IF FIELD, 1 IF DELIMITER)
	  CMP       BYTE PTR [TEXTPTR],'='  ;LOOK FOR '='
	  JNE       ERROR_12
	  INC       TEXTPTR
	  CALL      ALPHINL             ;LOOK FOR ALPHA VARIABLE OR LITERAL
	  TEST      R0,0FH
	  JZ        $PACKSBY
$PACKSB4: JMP       ERROR_29            ;ERROR IF NOT FOUND
$PACKSBY: TEST      SL,2
	  JZ        $PACKSB3            ;BRANCH IF NOT EXECUTION PHASE
	  MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF VALUE
	  MOV       EAX,DWORD PTR [EDX]
	  MOV       DWORD PTR [A0],EAX
	  MOV       EDX,DWORD PTR [EDX+4]
	  ADD       VSPTR,8
	  MOV       AUX0D,EDX           ;AUXD = ADDRESS OF TYPE VARIABLE
	  MOV       EDX,DWORD PTR [A0]
	  MOV       AUX0C,EDX           ;AUXC = LENGTH OF TYPE VALUE

$PACKSB3: CMP       BYTE PTR [TEXTPTR],')' ;LOOK FOR ')'
	  JNE       ERROR_11
	  INC       TEXTPTR
$PACKSB1: CALL      ALPHIN              ;LOOK FOR ALPHA VARIABLE (BUFFER)
	  TEST      R0,0FH
	  JNZ       $PACKSB4            ;NF, ERROR
	  TEST      SL,2
	  JZ        $PACKSB5            ;BRANCH IF NOT EXECUTION PHASE
	  MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF BUFFER
	  MOV       EAX,DWORD PTR [EDX]
	  MOV       DWORD PTR [A0],EAX
	  MOV       EDX,DWORD PTR [EDX+4]
	  ADD       VSPTR,8
	  MOV       AUX0F,EDX           ;SAVE ADDRESS OF BUFFER
	  MOV       EDX,DWORD PTR [A0]
	  MOV       AUX0E,EDX           ;AUXE = LENGTH OF BUFFER
$PACKSB5: RET

;     MOREARG: CHECK FOR MORE ARGUMENTS. DECREMENT
;              ELEMENT COUNT. IF MORE ELEMENTS, NORMAL
;              RETURN.  IF NO MORE ELEMENTS, LOOK FOR
;              COMMA. IF COMMA FOUND, RETURN + 1. IF NO
;              COMMA, BRANCH TO 'ENDSTMT'.
;
;          ENTRY: F7,6 = ELEMENT COUNT
;                 TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: NORMAL RETURN IF ELEMENT COUNT > 0.
;                  RETURN + 1  IF COMMA FOUND.
;                  BRANCH TO 'ENDSTMT IF ELEMENT COUNT >0
;                    & NO COMMA FOUND.
;
;          MODIFIED REGISTERS: F7,6
;               PC'S,CH,CL,F0 IFF COMMA FOUND
;

MOREARG:  DEC       DWORD PTR [A6]       ;DECREMENT ELEMENT COUNT
	  CMP       BYTE PTR [A6],0
	  JNE       MOREARG1             ;BRANCH IF MORE ELEMENTS (NOT N*256)
	  CMP       DWORD PTR [A6],0
	  JNE       MOREARG2                ;BRANCH IF MORE ELEMENTS (N*256)
	  CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE       ENDSTMTZ                ;NF, EXIT
	  INC       TEXTPTR
	  POP       EDX
	  JMP       EAX
MOREARG2: CALL      BREAKPTG            ;IF 30MS. ELAPSED, BREAKPOINT
MOREARG1: RET


;     FORMAT: PROCESS A '$FORMAT' STATEMENT
;
;          STMT FORMAT:
;
;    $FORMAT alpha-var = field-spec [,field-spec] ...
;
;          field-spec = SKIPxxx     skip field
;                       Fxxx        ASCII free format
;                       Ixxx[.dd]   ASCII integer format
;                       Dxxx[.dd]   IBM display format
;                       Uxxx[.dd]   USASCII-8 format
;                       P+xxx[.dd]  IBM pack decimal
;                       Pxxx[.dd]   unsigned pack decimal
;                       Axxx        alphanumeric
;
;          where:  xxx = field width (0 < xxx < 256)
;                   dd = implied decimal position (<16)
;
;     ENTRY: TEXTPTR POINTS AFTER 'FORMAT'
;
;     MODIFIED REGISTERS: ALL,AUX0,1,2
;

FORMAT:   MOV       R0,@DISK
	  CALL      CCL                 ;LOOK FOR 'DISK'
	  TEST      R0,0FH
	  JZ        FORMATD             ;BRANCH IF '$FORMAT DISK'
	  CALL      AVARD               ;LOOK FOR ALPHA-VARIABLE
	  TEST      R0,0FH
	  JNZ       ERR_29Q             ;NF, ERROR
	  TEST      SL,2
	  JZ        FORMAT1             ;BRANCH IF NOT EXECUTION PHASE
	  MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF VARIABLE
	  MOV       EAX,DWORD PTR [EDX]
	  MOV       DWORD PTR [A0],EAX
	  MOV       EDX,DWORD PTR [EDX+4]
	  ADD       VSPTR,8
	  MOV       AUX02,EDX               ;SAVE LENGTH OF VARIABLE
	  MOV       DWORD PTR [A6],EAX        ;SAVE LENGTH OF ALPHA-VARIABLE
FORMAT1:  CMP       BYTE PTR [TEXTPTR],'='  ;LOOK FOR '='
	  JNE       ERROR_12
	  INC       TEXTPTR
FORMAT4:  MOV       R0,@SKIP
	  CALL      CCL                 ;LOOK FOR 'SKIP'
	  MOV       WORD PTR [R4],0     ;INITIALIZE FIELD SPECIFICATION (SKIP)
	  TEST      R0,0FH
	  JZ        FORMAT5                ;BRANCH IF 'SKIP' FOUND
	  MOV       CH,BYTE PTR [TEXTPTR]  ;GET FIELD TYPE CHARACTER
	  INC       TEXTPTR
	  MOV       R5,10H              ;FIELD TYPE = ASCII FREE
	  CMP       CH,'F'
	  JE        FORMAT5             ;BRANCH IF 'F'
	  MOV       R5,0A0H             ;FIELD TYPE = ALPHA
	  CMP       CH,'A'
	  JE        FORMAT5             ;BRANCH IF 'A'
;@@ 3.4 ++
	MOV     R5,0A1H                 ;FIELD TYPE = COMPRESSED ALPHA
	CMP     CH,'C'                  ;
	JE      FORMAT5                 ;
	MOV     R5,80H                  ;FIELD TYPE = SIGNED BINARY
	CMP     CH,'B'                  ;
	JNE     FORMAT8                 ;BR, IF NOT
	MOV     CH,BYTE PTR [TEXTPTR]   ;GET FIELD TYPE CHARACTER
	INC     TEXTPTR
	CMP     CH,'+'                  ;
	JE      FORMAT6                 ;BR, IF FOUND '+'
	DEC     TEXTPTR                 ;
	MOV     R5,90H                  ;FIELD TYPE = BINARY
	JMP     FORMAT6
FORMAT8:
	MOV     R5,70H                  ;FIELD TYPE = PACK DEC WITH OVERFLOW
	CMP     CH,'O'                  ;
	JNE     FORMAT9                 ;BR, IF NOT
	MOV     CH,BYTE PTR [TEXTPTR]   ;GET FIELD TYPE CHARACTER
	INC     TEXTPTR
	CMP     CH,'+'                  ;
	JE      FORMAT6                 ;BR, IF FOUND '+'
	DEC     TEXTPTR                 ;
	JMP     ERR_19Q                 ;ERROR IF NOT 'O+'
FORMAT9:
;@@ 3.4 --
	  MOV       R5,20H              ;FIELD TYPE = ASCII INTEGER
	  CMP       CH,'I'
	  JE        FORMAT6             ;BRANCH IF 'I'
	  MOV       R5,30H              ;FIELD TYPE = IBM DISPLAY FORMAT
	  CMP       CH,'D'
	  JE        FORMAT6             ;BRANCH IF 'D'
	  MOV       R5,40H              ;FIELD TYPE = USASCII-8
	  CMP       CH,'U'
	  JE        FORMAT6             ;BRANCH IF 'U'
	  MOV       R5,50H              ;FIELD TYPE = IBM PACK DECIMAL
	  CMP       CH,'P'
	  JNE       ERR_19Q                 ;ERROR IF NOT 'P'
	  CMP       BYTE PTR [TEXTPTR],'+'  ;LOOK FOR '+'
	  JNE       FORMATX                 ;BRANCH IF FOUND
	  INC       TEXTPTR
	  JMP       FORMAT6
FORMATX:  MOV       R5,60H                  ;FIELD TYPE = UNSIGNED PACK DECIMAL
FORMAT6:  CALL      FORMTFLD                ;PROCESS FIELD LENGTH SPECIFICATION
	  CMP       BYTE PTR [TEXTPTR],'.'  ;LOOK FOR '.'
	  JNE       FORMAT7                 ;NF, BRANCH
	  INC       TEXTPTR
	  CALL      INTEGER             ;LOOK FOR INTEGER
	  TEST      R0,0FH
	  JNZ       FORMAT7             ;NF, LENGTH
	  CMP       R2,0
	  JNE       ERR_34Q             ;ERROR IF INTEGER > 15
	  TEST      R1,0F0H
	  JNZ       ERR_34Q
	  MOV       AL,R5
	  OR        AL,R1
	  MOV       R5,AL               ;DECIMAL POSITON ==> FIELD SPECIFICATION
	  JMP       FORMAT7

FORMAT5:  CALL      FORMTFLD            ;PROCESS FIELD LENGTH SPECIFICATION
FORMAT7:  TEST      SL,2
	  JZ        FORMAT3             ;BRANCH IF NOT EXECUTION
	  CMP       DWORD PTR [A6],2
	  JB        ERR_51Q             ;ERROR IF VARIABLE TOO SHORT
	  SUB       DWORD PTR [A6],2     ;DECREMENT LENGTH OF VARIABLE
	  MOV       EDX,AUX02
	  MOV       AL,R5
	  MOV       BYTE PTR [EDX],AL   ;FIELD SPECIFICATION ==> VARIABLE
	  INC       EDX
	  MOV       AL,R4
	  MOV       BYTE PTR [EDX],AL
	  MOV       AUX02,EDX
	  INC       AUX02

FORMAT3:  CMP       BYTE PTR [TEXTPTR],','  ;LOOK FOR COMMA
	  JNE       ENDSTMTZ            ;EXIT IF NOT FOUND
	  INC       TEXTPTR
	  JMP       FORMAT4             ;BRANCH IF FOUND
FORMTFLD: CALL      INTEGER             ;LOOK FOR INTEGER (FIELD LENGTH)
	  TEST      R0,0FH
	  JNZ       ERR_34Q             ;NF, ERROR
	  CMP       R2,0
	  JNE       ERR_34Q             ;ERROR IF > 255
	  CMP       R1,0
	  JE        ERR_34Q             ;ERROR IF = 0
	  MOV       AL,R1
	  MOV       R4,AL               ;FIELD LENGTH ==> FIELD SPECIFICATION
	  RET

ERR_34Q:  JMP       ERROR_34            ;ILLEGAL VALUE
ERR_51Q:  JMP       ERROR_51            ;VARIABLE TOO SHORT
ERR_29Q:  JMP       ERROR_29            ;MISSING ALPHA VARIABLE
ERR_19Q:  JMP       ERROR_19            ;MISSING REQUIRED BASIC WORD

;     $UNPAKF: PROCESS FIELD FORM OF $UNPACK
;
;          FORMAT:
;
;               $UNPACK(F=field) buffer TO arg-list
;
;               field = 00xx     skip field
;                       10xx     ASCII free field
;                       2dxx     ASCII integer
;                       3dxx     IBM display format
;                       4dxx     IBM USASCII-8
;                       5dxx     IBM pack decimal
;                       6dxx     unsigned pack decimal
;                       A0xx     alphanumeric
;
;               where: xx = field length (>0)
;                       d = decimal point position (from
;                           right end of field)
;
;          RAM: SCRATCH - (SCRATCH+24)
;
;          ENTRY: TEXTPTR POINTS AFTER 'TO'
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2,4
;               IN EXECUTION PHASE, AUXB-F
;

$UNPAKF:  CALL      ARGUMNTR            ;SCAN NEXT ARGUMENT
	  MOV       EDX,AUX02
	  MOV       R5,DL               ;F5 = VALUE TYPE
	  CALL      FLDSPEC             ;GET NEXT FIELD SPECIFICATION

$UNPAKF1: MOV       AL,R2
;@@ 3.4 ++
	  MOV       R4,AL
;@@ 3.4 --
	  AND       AL,0F0H
	  CMP       AL,0A0H
	  JNE       $UNPAKF2            ;BRANCH IF NOT ALPHA FIELD

; PROCESS ALPHA FIELD (A0xx)
;

	  MOV       EDX,AUX02
	  MOVZX     EAX,DH               ;F3,2 = LENGTH OF RECEIVER
	  MOV       DWORD PTR [A2],EAX
	  MOVZX     EAX,K
	  MOV       DWORD PTR [A0],EAX  ;F1,0 = LENGTH OF FIELD
	  MOV       EDX,AUX01
	  MOV       EAX,DWORD PTR [A2]
	  ADD       EDX,EAX             ;AUX1 POINT AFTER RECEIVER
	  XCHG      EDX,AUX01
	  MOV       AUX00,EDX           ;AUX0 POINT TO RECEIVER
	  MOV       EDX,AUX0F
	  MOV       EAX,DWORD PTR [A0]
	  ADD       EDX,EAX             ;AUXF POINT AFTER FIELD
	  XCHG      EDX,AUX0F           ;PC'S POINT TO FIELD
;@@ 3.4 ++
	  CMP       R4,0A1H
	  JE        $UNPKF32            ;br, if compressed alpha
	  call      areceval            ;value from field ==> receiver
	  jmp       $unpkf10

;PROCESS COMPRESSED ALPHA FILED (A1 XX) ..
;
;       ENTRY   R0  = LENGTH OF FIELD
;               EDX = ADDRESS OF FIELD
;               R2  = LENGTH OF RECEIVER VARIABLE
;               AUX0= ADDRESS OF RECEIVER VARIABLE
;       REGISTER USED -
;               R1  = NEXT BYTE OF FIELD
;               R3  = NEXT BYTE TO BE WRITTEN (UNCOMPRESS DATA)
;
$UNPKF32:
	call    ugetbyte                ;r1=1st byte of set of 3
	mov     r4,0
	mov     al,r1
	mov     r3,al
	shl     word ptr [r3],2

	shr     byte ptr r3,4
	mov     al,r4
	shl     al,4
	or      r3,al
	add     r3,20h
	call    putbyte                 ;store 1st byte of result
	cmp     a2,0
	je      $unpkf33                ;br, if receiver full

	mov     al,r1
	and     al,03h
	mov     r3,al

	call    ugetbyte                ;r1=2rd byte of set of 3
	shl     byte ptr r3,4
	mov     al,r1
	shr     al,4
	or      r3,al
	add     r3,20h
	call    putbyte                 ;store 2nd byte of result
	cmp     a2,0
	je      $unpkf33                ;br, if receiver full

	mov     al,r1
	mov     r4,al
	call    ugetbyte                ;r1=3rd byte of set of 3
	mov     al,r1
	mov     r3,al
	shl     word ptr [r3],2
	mov     al,r4
	and     al,3fh
	mov     r3,al
	add     r3,20h
	call    putbyte                 ;store 3rd byte of result
	cmp     a2,0
	je      $unpkf33                ;br, if reciever full

	mov     al,r1
	and     al,3fh
	mov     r3,al
	add     r3,20h
	call    putbyte                 ;store 4th byte of result
	cmp     a2,0
	jne     $unpkf32                ;br, if more bytes in reciever

$unpkf33:
	jmp     $unpkf10

; CHECK FOR MORE ARGUMENT
;

$UNPKF10: MOV       EAX,OFFSET $CF
	  CALL      MOREARG             ;CHECK FOR MORE ARGUMENT
	  JMP       $UNPKFX             ;MORE ELEMENTS IN CURRENT ARGUMENT
$CF:      JMP       $UNPAKF             ;COMMA FOUND (MORE ARGUMENTS)
$UNPKFX:  MOV       EDX,AUX02
	  MOV       R5,DL               ;F5 = TYPE OF VALUE
	  CALL      FLDSPECA            ;RE-USE CURRENT FIELD SPECIFICATION
	  JMP       $UNPAKF1

; PROCESS NUMERIC FIELDS (10xx - 5dxx)
;     CONVERT VALUE TO ASCII & THEN TO FL.PT. VIA SNMBR
;               (ASCII VALUE BUILT AT SCRATCH+8)
;

$UNPAKF2: MOV       EDX,DWORD PTR [A6]
	  MOV       AUX03,EDX           ;SAVE ELEMENT COUNT
	  MOV       EDX,AUX0F
	  MOVZX     EAX,K
	  MOV       DWORD PTR [A0],EAX
	  MOV       WORD PTR [R0],AX
	  ADD       EDX,EAX
;@@@ 3.4 ++ <----
	  jmp       patchub
$unpakf2x:
;@@@ 3.4 -- <----
;         XCHG      EDX,AUX0F           ;POINT AFTER FIELD
	  MOV       AUX09,EDX           ;AUX9 = ADDRESS OF FIELD
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,10H
	  JE        $UNPAKF3            ;BRANCH IF ASCII FREE
	  MOV       WORD PTR [R4],0     ;DIGIT COUNT, EXPONENT = 0
	  MOV       EDX,OFFSET SCRATCH+8
	  MOV       BYTE PTR [EDX],'+'  ;PLUS SIGN ==> SCRATCH
	  CMP       AL,20H
	  JNE       $UNPAKF4            ;BRANCH IF NOT ASCII INTEGER
	  CALL      UNPKFGD             ;GET SIGN FROM FIELD
	  MOV       AL,R0
	  AND       AL,2FH
	  MOV       BYTE PTR [EDX],AL   ;SIGN ==> SCRATCH
$UNPAKF4: INC       EDX                 ;POINT AFTER SIGN IN SCRATCH AREA

;     BYPASS LEADING ZEROES
;
$UNPAKFY: CALL      UNPKFGD             ;GET NEXT DIGIT
	  CMP       R0,0
	  JE        $UNPAKF5            ;BRANCH IF END OF FIELD
	  TEST      R0,0FH
	  JZ        $UNPAKFY           ;BRANCH IF DIGIT = 0

;     TRANSFER INTEGER DIGITS TO SCRATCH AREA
;

$UNPAKF7: MOV       AL,R0               ;DIGIT (ASCII) ==> SCRATCH
	  MOV       BYTE PTR [EDX],AL
	  INC       EDX
	  INC       R5                  ;INCREMENT DIGIT COUNT
	  CMP       R5,0DH
	  JE        $UNPAKF6            ;BRANCH IF 13 SIGNIFICANT DIGITS PROCESSED
	  CALL      UNPKFGD             ;GET NEXT DIGIT
	  MOV       AL,R0
	  AND       AL,0F0H
	  CMP       AL,30H
	  JE        $UNPAKF7            ;BRANCH IF FOUND
	  JMP       $UNPAKF8

;     BYPASS DIGITS BEYOND 1ST 13 SIGNIFICANT DIGITS
;

$UNPAKF9: MOV       AL,R4               ;INCREMENT EXPONENT
	  INC       AL
	  DAA
	  MOV       R4,AL
	  JNC       $UNPAKF6            ;BRANCH IF EXPONENT <= 99

ERR_75A:  JMP       ERROR_75            ;ERROR IF ILLEGAL NUMBER

$UNPAKF6: CALL      UNPKFGD             ;GET NEXT DIGIT
	  MOV       AL,R0
	  AND       AL,0F0H
	  CMP       AL,30H
	  JE        $UNPAKF9            ;BRANCH IF FOUND

;     PUT EXPONENT (ASCII) ==> SCRATCH
;

	  MOV       BYTE PTR [EDX],'E'  ;'E' ==> SCRATCH
	  INC       EDX
	  MOV       AL,R4               ;EXPONENT ==> SCRATCH
	  SHR       AL,4
	  ADD       AL,30H
	  MOV       BYTE PTR [EDX],AL
	  INC       EDX
	  MOV       AL,R4
	  AND       AL,0FH
	  ADD       AL,30H
	  MOV       BYTE PTR [EDX],AL
	  INC       EDX
	  JMP       $UNPAKF8           ;INCREMENT PC'S, BRANCH

;     PUT ZERO ==> SCRATCH IF VALUE = 0
;

$UNPAKF5: MOV       BYTE PTR [EDX],30H  ;ZERO ==> SCRATCH
	  INC       EDX

;   SIGN ==> SCRATCH (IF NOT ASCII INTEGER OR ASCII FREE)
;

$UNPAKF8: MOV       EAX,EDX                 ;K = LENGTH OF ASCII VALUE
	  MOV       EDX,OFFSET SCRATCH+8    ;POINT TO ASCII VALUE
	  SUB       EAX,EDX
	  MOV       K,AL
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,20H
	  JE        $UNPAKF3                ;BRANCH IF ASCII INTEGER
	  CMP       AL,60H
	  JE        $UNPAKF3                ;BRANCH IF UNSIGNED PACK DECIMAL
	  MOV       R1,CH
	  CMP       AL,50H
	  JNE       $UNPAKFZ                ;F1,BITSF0 = SIGN
	  MOV       R1,CH
	  SHR       R1,4
	  MOV       AL,CH
	  SHL       AL,4
	  OR        R1,AL
$UNPAKFZ: MOV       AL,R1
	  AND       AL,0F0H
	  CMP       AL,0B0H
	  JE        $UNPAKFA
	  CMP       AL,0D0H
	  JNE       $UNPAKF3                ;BRANCH IF SIGN PLUS (NOT B OR D)
$UNPAKFA: MOV       BYTE PTR [EDX],'-'      ;MINUS SIGN ==> SCRATCH

;     CONVERT ASCII VALUE TO FL.PT.
;
;          ENTRY: PC'S = ADDRESS OF ASCII VALUE
;                 K = LENGTH OF ASCII VALUE
;

$UNPAKF3: MOVZX     EAX,K               ;F7,F6 = LENGTH OF ASCII VALUE
	  MOV       DWORD PTR [A6],EAX
	  CALL      SNMBR               ;CONVERT ASCII VALUE TO FL.PT.
	  TEST      R0,0FH
	  JNZ       ERR_75A             ;BRANCH IF NF
	  CMP       DWORD PTR [A6],0
	  JNE       ERR_75A             ;ERROR IF ILLEGAL CHAR. IN ASCII STRING

;@@@ 3.4 +++

$unpakf3x:

;@@@ 3.4 ---

;     ADJUST EXPONENT BY IMPLIED DECIMAL POSITION
;
	  MOV       EDX,AUX0B
	  MOV       R6,DH
	  AND       R6,0FH
	  INC       R6                  ;F6 = ADJUST FACTOR (IMPLIED DEC. POS. +1)
	  MOV       EDX,VSPTR           ;POINT TO VALUE
	  CALL      ADJEXP              ;EXPONENT = EXP - F6 + 1

;     FL.PT. VALUE ==> RECEIVER
;

	  MOV       EDX,AUX01
	  MOV       EAX,VSPTR           ;VALUE ==> RECEIVER
	  MOV       EBX,DWORD PTR [EAX]
	  MOV       DWORD PTR [EDX],EBX
	  MOV       EBX,DWORD PTR [EAX+4]
	  MOV       DWORD PTR [EDX+4],EBX
	  ADD       VSPTR,8
	  ADD       EDX,8
	  MOV       AUX01,EDX           ;POINT TO NEXT RECEIVER
	  MOV       EDX,AUX03
	  MOV       DWORD PTR [A6],EDX    ;RESTORE ELEMENT COUNT
	  JMP       $UNPKF10

;     UNPKFGD: GET NEXT DIGIT FROM FIELD DURING UNPACK
;
;          ENTRY: PHASE = EXECUTION
;               AUX9 = ADDRESS OF NEXT CHARACTER IN FIELD
;               K = FIELD LENGTH
;               F2 = FIELD TYPE
;
;               FOR PACK DECIMAL,
;                    F1,BIT01 = 0 IF NEED TO READ NEXT
;                               PAIR OF DIGITS
;                             = 1 IF USE LOW DIGIT IN CH
;
;          RETURN: F0 = NEXT DIGIT (ASCII)
;                  K DECREMENTED IF NEXT CHAR. READ
;                  AUX9 INCREMENTED IF NEXT CHAR. READ
;                  F1,BIT01 COMPLEMENTED
;
;          MODIFIED REGISTERS: F0,1,K,CH,CL,AUX9
;

UNPKFGD:  MOV       R0,0                ;FLAG = NF
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,60H
	  JNE       UNPKFGDX            ;BRANCH IF NOT UNSIGNED PACK DECIMAL
	  TEST      R1,1
	  JNZ       UNPKFGD3            ;BRANCH IF LOW DIGIT OF PAIR
UNPKFGDX: MOV       AL,R0
	  CMP       AL,K
	  JE        UNPKFGD2            ;BRANCH IF END OF FIELD
	  MOV       AL,R2
	  AND       AL,0F0H
	  CMP       AL,50H
	  JE        UNPKFGD1            ;BRANCH IF PACK DECIMAL
	  CMP       AL,60H
	  JE        UNPKFGD1            ;BRANCH IF UNSIGNED PACK DECIMAL

;     NOT PACK DECIMAL
;

	  XCHG      EDX,AUX09
	  MOV       CH,BYTE PTR [EDX]   ;GET NEXT CHARACTER FROM FIELD
	  XCHG      EDX,AUX09
	  INC       AUX09
	  MOV       R0,CH
	  AND       R0,0FH
UNPKFGD4: DEC       K                   ;DECREMENT FIELD LENGTH
UNPKFGD5: OR        R0,30H              ;F0 = ASCII DIGIT
	  XOR       R1,1                ;COMPLEMENT HIGH/LOW PACK FLAG
UNPKFGD2: RET

;     PACK DECIMAL
;

UNPKFGD1: TEST      R1,1
	  JNZ       UNPKFGD3            ;BRANCH IF LOW DIGIT OF PAIR NEEDED
	  XCHG      EDX,AUX09
	  MOV       CH,BYTE PTR [EDX]   ;GET NEXT PAIR OF DIGITS
	  XCHG      EDX,AUX09
	  INC       AUX09
	  MOV       R0,CH
	  SHR       R0,4                ;F0 = HIGH DIGIT OF PAIR
	  JMP       UNPKFGD4

UNPKFGD3: MOV       R0,CH
	  AND       R0,0FH
	  JMP       UNPKFGD5

;    BUFCOUNT: DECREMENT BUFFER COUNT BY SPECIFIED AMOUNT
;              ERROR IF COUNT < 0.
;
;          ENTRY: AUXE = BUFFER COUNT
;                 PHASE = EXECUTION
;                 K = DECREMENT VALUE
;
;          RETURN: AUXE = AUXE - K
;                  F1,0 = OLD BUFFER COUNT
;
;          MODIFIED REGISTERSL F1,0,AUXE
;

BUFCOUNT: XCHG      EDX,AUX0E
	  MOV       DWORD PTR [A0],EDX
	  MOVZX     EBX,K
	  SUB       EDX,EBX             ;DECREMENT BUFFER COUNT
	  JS        BUFCNT1             ;BRANCH IF COUNT < 0
	  XCHG      EDX,AUX0E
	  RET

BUFCNT1:  JMP       ERROR_76            ;ERROR IF BUFFER TOO SMALL


;     CVTASCII: CONVERT FL.PT. VALUE TO ASCII
;               (PRINT FORMAT)
;
;          ENTRY: PHASE = EXECUTION
;               AUXC = ADDRESS OF FL.PT. VALUE
;
;          RETURN: ASCII VALUE ==> SCRATCH AREA
;               AUX3 = ADDRESS OF VALUE
;               F0 = LENGTH OF ASCII VALUE (INCLUDING
;                    TRAILING SPACE)
;               AUXA = AUXA + 8 (POINTS AFTER FL.PT VALU)
;
;          MODIFIED RAM: SCRATCH - SCRATCH+15
;
;          MODIFIED REGISTERS: PC'S,CH,CL,F0-3,AUX0,2,3,A
;

CVTASCII: MOV       EDX,AUX0A
	  ADD       EDX,8              ;PC'S POINT TO CURRENT ELEMENT OF ARGUMENT
	  XCHG      EDX,AUX0A          ;AUXA = ADDRESS OF NEXT ELEMENT
	  MOV       EAX,VSPTR          ;CURRENT VALUE ==> VS
	  SUB       EAX,8
	  MOV       ECX,DWORD PTR [EDX]
	  MOV       DWORD PTR [EAX],ECX
	  MOV       ECX,DWORD PTR [EDX+4]
	  MOV       DWORD PTR [EAX+4],ECX
	  MOV       VSPTR,EAX
	  CMP       EAX,DWORD PTR [@@VSEND]
	  JB        ERROR_02

	  CALL      VVFMT              ;CONVERT VALUE TO ASCII
	  ADD       VSPTR,8            ;REMOVE VALUE FROM VS
	  MOV       EDX,OFFSET SCRATCH
	  MOV       AUX03,EDX          ;AUX3 = ADDRESS OF ASCII VALUE
	  RET

;     FLDSPEC: GET NEXT FIELD SPECIFICATION
;
;             MAKE SURE LEGAL & FIELD WILL FIT IN BUFFER.
;             CHECK FIELD TYPE, AND PROCESS IF SKIP FIELD
;
;          ENTRY: PHASE = EXECUTION
;               AUXC = FIELD SPECIFICATION LENGTH
;               AUXD = PTR TO NEXT FIELD SPEC.
;               AUXE = BUFFER COUNT
;               AUXF = PTR TO NEXT LOCATION IN BUFFER
;               F5,BIT80 = VARIABLE/VALUE TYPE
;                   (1 IF ALPHA, 0 IF NUMERIC)
;
;          RETURN:
;               AUXC DECREMENTED
;               AUXD POINTS TO NEXT FIELD SPEC.
;               AUXE,F UPDATED IF SKIP FIELD
;               AUXB = FIELD SPEC.
;               F2 = FIELD TYPE
;               K = FIELD LENGTH
;
;          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-2,AUXB-F
;
;     FLDSPECA: GET CURRENT FIELD SPECIFICATION
;
;               MAKE SURE FIELD FITS IN BUFFER.
;
;          ENTRY: PHASE = EXECUTION
;               AUXB = FIELD SPECIFICAION
;               AUX5,BIT80 = VARIABLE/VALUE TYPE
;
;          RETURN:
;               AUXB = FIELD SPECIFICATION
;               F2 = FIELD TYPE
;               K = FIELD LENGTH
;
;          MODIFIED REGISTERS: PC,S,K,F0-2
;

;     PROCESS SKIP FIELD
;

FLDSPEC2: MOV       EDX,AUX0F
	  MOV       DWORD PTR [A0],EDX
	  MOVZX     EDX,K
	  ADD       EDX,DWORD PTR [A0]
	  MOV       AUX0F,EDX           ;INCREMENT BUFFER PTR PAST FIELD

;     GET NEXT FIELD SPECIFICATION
;

FLDSPEC:  MOV       EDX,AUX0C
	  MOV       AUX0C,EDX           ;DECREMENT FIELD SPEC. LENGTH
	  SUB       AUX0C,2
	  CMP       EDX,1
	  JA        FLDSPECX            ;BRANCH IF FIELD SPEC. LENGTH > 1
FLDSPEC1: JMP       ERROR_58            ;ILLEGAL FIELD SPEC.
FLDSPECX: MOV       EDX,AUX0D
	  MOV       CH,BYTE PTR [EDX]
	  INC       EDX
	  MOV       R0,CH               ;F0 = FIELD TYPE
	  MOV       CH,BYTE PTR [EDX]
	  MOV       AUX0D,EDX
	  INC       AUX0D
	  MOV       DH,R0               ;PH,PL = FIELD SPECIFICATION
	  MOV       DL,CH
	  MOV       AUX0B,EDX           ;AUXB = FIELD SPECIFICATION

;     MAKE SURE LEGAL FIELD SPECIFICATION
;
;          00xx     skip field
;          10xx     ASCII free
;          2dxx     ASCII integer
;          3dxx     IBM display format
;          4dxx     IBM USASCII-8
;          5dxx     IBM pack decimal
;          6dxx     unsigned pack decimal
;          A0xx     alphanumeric
;

	  CMP       CH,0
	  JE        FLDSPEC1            ;BRANCH IF FIELD LENGTH = 0
;@@ 3.4 ++
	  CMP       DH,0A1H             ;BR, IF FIELD TYPE = A1
	  JE        FLDSPECA            ;
;@@ 3.4 --
	  CMP       DH,0A0H
	  JNE       FLDSPEC3            ;BRANCH IF NOT 'A-'
FLDSPEC5: TEST      DH,0FH
	  JZ        FLDSPECA            ;BRANCH IF DECIMAL POSITION = 0
FLDSPEC4: JMP       ERROR_58            ;ILLEGAL FIELD SPEC.
FLDSPEC3: MOV       R0,0A0H
	  CMP       R0,DH
	  JBE       FLDSPEC4            ;BRANCH IF FIELD TYPE >5F
	  TEST      DH,0E0H
	  JZ        FLDSPEC5            ;BRANCH IF SKIP OR ASCII FREE FIELD

;     MAKE SURE BUFFER LARGE ENOUGH FOR FIELD
;

FLDSPECA: MOV       EDX,AUX0B           ;GET FIELD SPECIFICATION
	  MOV       R2,DH               ;F2 = FIELD TYPE
	  MOV       K,DL                ;K = FIELD LENGTH
	  CALL      BUFCOUNT            ;DECREMENT BUFFER COUNT BY FIELD LENGTH

;     CHECK FIELD TYPE
;
	  CMP       R2,0
	  JE        FLDSPEC2            ;BRANCH IF SKIP FIELD
;@@ 3.4 ++
	  MOV     AL,R5
	  AND     AL,80H
	  MOV     R0,AL
	  MOV     AL,R2
	  AND     AL,0F0H
	  CMP     AL,0A0H               ;BR, IF NOT ALPHA
	  JNE     FLDS_0
	  XOR     R0,80H                ;COMPLEMENT
FLDS_0:
;@@ 3.4 --
	  TEST      R0,80H
	  JNZ       ERR_74              ;BRANCH IF FIELD TYPE <> VALUE/VARIABLE TYPE
	  RET

; ERR#74 SHOULD BE BRANCH TO ERROR#74 (MOD07)
;

ERR_74:   MOV       R0,74H              ;WRONG VARIABLE TYPE
	  JMP       ERROR

;     FILLFLD: FILL FIELD WITH SPECIFIED CHARACTER
;
;          ENTRY: AL = FILL CHARACTER
;               AUXF POINTS TO FIELD
;               K = LENGTH OF FIELD
;
;          RETURN: PC'S = ADDRESS OF FIELD - 1
;               AUX0 = ADDRESS OF FIELD
;               AUXF = ADDRESS OF END OF FIELD +1
;
;          MODIFIED REGISTERS: PC'S,F3,4,AUX0,F
;

FILLFLD:  MOV       AH,CH
	  MOVZX     ECX,K                ;FILL LENGTH
	  MOV       EDI,AUX0F           ;POINT TO BEGIN OF FIELF
	  MOV       AUX00,EDI
	  REP       STOSB
	  MOV       AUX0F,EDI
	  MOV       CH,AH
	  RET

;     HEXPACK: PROCESS A 'HEXPACK' STATEMENT
;
;          FORMAT: HEXPACK alpha-var FROM alpha-var
;
;          ENTRY: TEXTPTR POINTS AFTER 'FROM'
;               IN EXECUTION PHASE,
;                    AUXE = LENGTH OF 1ST ALPHA-VARIABLE
;                    AUXF = ADDRESS OF 1ST ALPHA-VARIABLE
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXECUTION PHASE, AUXE,F

HEXPACK:  CALL      AVARB               ;SCAN & PROCESS BUFFER VARIALBE
	  CALL      CCLFROM             ;LOOK FOR 'FROM'
	  MOV       K,4                 ;FLAG = CURRENT LENGTH
	  CALL      AVAR                ;LOOK FOR ALPHA-VARIABLE (VALUE)
	  TEST      R0,0FH
	  JZ        HEXPACKX
ERR_29F:  JMP       ERROR_29            ;ERROR IF ALPHA-VARIABLE NOT FOUND
HEXPACKX: TEST      SL,2
	  JZ        ENDSTMTZ            ;BRANCH IF NOT EXECUTION PHASE
	  MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF VALUE
	  MOV       ECX,DWORD PTR [EDX]
	  MOV       ESI,DWORD PTR [EDX+4]
	  ADD       VSPTR,8

;     REGISTERS:
;          ESI  = ADDRESS OF VALUE TO PACK
;          ECX  = LENGTH OF VALUE TO PACK
;          EDI  = ADDRESS OF BUFFER-VARIABLE
;          EBX  = LENGTH OF BUFFER-VARIABLE
;

	  MOV       EDI,AUX0F
	  MOV       EBX,AUX0E
	  SHL       EBX,1
	  CMP       EBX,ECX
	  JB        ERR_51B             ;ERROR IF BUFFER TOO SMALL

	  MOV       DL,0                ;HIGH/LOW DIGIT FLAG = HIGH
;         AND       ECX,0000FFFFH
HEXPACKC: LODSB
	  MOV       BL,AL
	  AND       BL,0F0H
	  CMP       BL,30H
	  JE        HEXPACKA
	  CMP       AL,'A'
	  JB        ERR_17B
	  CMP       AL,'F'
	  JA        ERR_17B
	  ADD       AL,9
HEXPACKA: AND       AL,0FH
	  CMP       DL,0
	  JNE       HEXPACKB
	  MOV       AH,BYTE PTR [EDI]
	  AND       AH,0FH
	  SHL       AL,4
	  OR        AH,AL
	  MOV       DL,1
	  LOOP      HEXPACKC
	  JMP       HEXPACKD
HEXPACKB: AND       AH,0F0H
	  OR        AH,AL
	  MOV       BYTE PTR [EDI],AH
	  INC       EDI
	  XOR       DL,DL
	  LOOP      HEXPACKC
HEXPACKD: CMP       DL,0
	  JZ        ENDSTMTZ
	  MOV       BYTE PTR [EDI],AH
	  JMP       ENDSTMTZ

ERR_51B:  JMP       ERROR_51            ;VARIABLE TOO SMALL
ERR_17B:  JMP       ERROR_17            ;ILLEGAL HEX CHARACTER


;     HEXUNPAK: PROCESS A 'HEXUNPACK' STATEMENT
;
;          FORMAT: HEXUNPACK alpha-var TO alpha-var
;
;          ENTRY: TEXTPTR POINTS AFTER 'TO'
;               IN EXECUTION PHASE,
;                    AUXE = LENGTH OF 1ST ALPHA-VARIABLE
;                    AUXF = ADDRESS OF 1ST ALPHA-VARIABLE
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;               IN EXEUCUTION PHASE, AUXE,F
;

HEXUNPAK: CALL      AVARB               ;SCAN & PROCESS BUFFER VARIABLE
	  CALL      CCLTO               ;LOOK FOR 'TO'
	  CALL      AVARD               ;LOOK FOR ALPHA-VARIABLE (RECEIVER)
	  TEST      R0,0FH
	  JNZ       ERR_29F             ;NF, ERROR
	  TEST      SL,2
	  JZ        ENDSTMTZ            ;BRANCH IF NOT EXECUTION PHASE
	  MOV       EDX,VSPTR           ;GET LENGTH & ADDRESS OF RECEIVER
	  MOV       EBX,DWORD PTR [EDX]
	  MOV       EDI,DWORD PTR [EDX+4]
	  ADD       VSPTR,8

;     REGISTERS:
;          EDI  = ADDRESS OF RECEIVER VARIABLE
;          EBX  = LENGTH OF RECEIVER VARIABLE
;          ESI  = ADDRESS OF BUFFER-VARIABLE
;          ECX  = LENGTH OF BUFFER-VARIABLE
;

	  MOV       ESI,AUX0F
	  MOV       ECX,AUX0E          ;LENGTH OF BUFFER

	  SHR       EBX,1
	  CMP       EBX,ECX
	  JB        ERR_51B             ;ERROR IF RECEIVER TOO SMALL
;         AND       ECX,0000FFFFH

HEXUNPAKC:LODSB
	  MOV       AH,AL
	  SHR       AH,4
	  OR        AH,30H
	  CMP       AH,39H
	  JBE       HEXUNPAKA
	  ADD       AH,7
HEXUNPAKA:MOV       BYTE PTR [EDI],AH
	  INC       EDI
	  AND       AL,0FH
	  OR        AL,30H
	  CMP       AL,39H
	  JBE       HEXUNPAKB
	  ADD       AL,7
HEXUNPAKB:STOSB
	  LOOP      HEXUNPAKC

	  JMP       ENDSTMTZ            ;EXIT


;     HEXSTMT: PROCESS A 'HEX' STATEMENT
;
;          FORMAT:  HEXPACK ...
;                   HEXUNPACK ...
;                   HEXPRINT ...
;
;          ENTRY: TEXTPTR POINTS AFTER 'HEX''
;
;

HEXSTMT:  MOV       R0,@PACK
	  CALL      CCL                 ;LOOK FOR 'PACK'
	  TEST      R0,0FH
	  JZ        HEXPACK             ;BRANCH IF 'HEXPACK'
	  MOV       R0,@UNPACK
	  CALL      CCL                 ;LOOK FOR 'UNPACK'
	  TEST      R0,0FH
	  JZ        HEXUNPAK            ;BRANCH IF 'HEXUNPACK'
	  MOV       R0,@PRINT
	  CALL      CCL                 ;LOOK FOR 'PRINT'
	  TEST      R0,0FH
	  JZ        HEXPRINT            ;BRANCH IF 'HEXPRINT'
	  JMP       ERROR_19            ;NF, ERROR

CODE      ENDS
	  END
